/* Server version: WI-V6.3.7.18553 Firebird 2.1 
   SQLDialect: 3. ODS: 11.1. Forced writes: On. Sweep inteval: 20000.
   Page size: 8192. Cache pages: 75 (600 Kb). Read-only: False. */
SET NAMES NONE;

SET SQL DIALECT 3;

ALTER TABLE RIGHTS_CLOCK_IN DROP CONSTRAINT PKLCLOCKIN;

ALTER TABLE ACCOUNT_POST DROP CONSTRAINT FK_AP_ACCOUNT;

/* Alter Procedure (Before Drop)... */
SET TERM ^ ;

ALTER PROCEDURE ACCOUNT_POSTING_DEL$INT(AP_DBKEY CHAR(8),
REASON VARCHAR(50))
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE DOC_CHECK_FISCAL$INT(DH_DBKEY CHAR(8))
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE DOCUMENT_DELETE$DOC(ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE DOCUMENT_PRENUMERATE$DOC(SELECTION_ID INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE GUEST_DEL_POSTINGS$INT(ID_GUEST INTEGER)
 RETURNS(EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE LOG_LOGONOFF(IN_ID_CLOCK_IN INTEGER,
IN_COMP_NAME VARCHAR(20))
 RETURNS(OUT_ID_CLOCK_IN INTEGER,
OUT_NOW TIMESTAMP,
OUT_NOW_NOTIFY_MIN INTEGER,
OUT_PATCH_VERSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE PAYMENT_DOC_DELETE$DOC(ID_PAYMENT_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^


/* Drop Procedure... */
SET TERM ; ^

DROP PROCEDURE ACCOUNT_POSTING_DEL$INT;

SET TERM ^ ;

ALTER PROCEDURE DOCUMENT_ADD_PAYMENT$DOC(ID_DOC_HEAD INTEGER,
ID_PAY_DOC_TYPE INTEGER,
PAY_VALUE NUMERIC(15,4),
PAY_CURRENCY VARCHAR(3),
DESCRIPTION VARCHAR(100))
 RETURNS(ID_PAYMENT_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DOCUMENT_VALIDATE$DOC(ID_DOC_HEAD /* TYPE OF ID_REF */ INTEGER)
 RETURNS(FIRM_DATA /* TYPE OF TNOTE_BLOB */ BLOB SUB_TYPE 1,
WARN_CODE /* TYPE OF TRANGE */ INTEGER,
NEW_DOC_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP PROCEDURE DOC_CHECK_FISCAL$INT;

DROP PROCEDURE DOCUMENT_DELETE$DOC;

DROP PROCEDURE DOCUMENT_PRENUMERATE$DOC;

SET TERM ^ ;

ALTER PROCEDURE RES_ANUL_DETAIL$INT(RD_DBKEY CHAR(8),
REASON VARCHAR(50),
CANCELATION_NUMBER /* TYPE OF NAME_20 */ VARCHAR(20) = null)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE RES_GUEST_DEL$INT(ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50) = null)
 RETURNS(EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP PROCEDURE GUEST_DEL_POSTINGS$INT;

DROP PROCEDURE LOG_LOGONOFF;

DROP PROCEDURE PAYMENT_DOC_DELETE$DOC;


/* Drop Index... */
RECONNECT;

/* Drop: SERVICES_IDX1 (TIdxData) */
DROP INDEX SERVICES_IDX1;


/* Create Table... */
CREATE TABLE ACCOUNT_POST_POS_TRANSFER(ID_ACCOUNT_POST ID,
UNIQUE_SALES_NUMBER TNAME_SHORT NOT NULL,
POS_ID_SMETKA ID_REF,
POS_SMETKA_NUM TNAME_SHORT,
POS_SMETKA_DATE TDATE,
POS_OBJECT_NAME TOBJECT_NAME,
TAG_VALUE TNAME_SHORT NOT NULL,
TAG_NAME TNAME_SHORT NOT NULL,
TRANSFER_VALUE TPRICE NOT NULL);


CREATE TABLE DOC_FISCAL_DATA(ID_DOC_HEAD ID_TYPE NOT NULL,
UNIQUE_SALES_NUMBER TENUM_STRING,
DETAIL_LEVEL NAME_20,
ADDITIONAL_PAYMENT_TEXT TNAME_SHORT,
FISCAL_LINES TNOTE_BLOB,
FISCAL_PAYMENTS TNOTE_BLOB,
FISCAL_DEVICE_ID TSHORT_CODE,
FISCALIZATION_DETAILS TDESCRIPTION_LONG,
STORNO_FISCAL_DEVICE_ID TSHORT_CODE,
STORNO_FISCALIZATION_DETAILS TDESCRIPTION_LONG);


CREATE TABLE SALE_NUM(ID_SALE_NUM ID NOT NULL,
UNIQUE_SALES_NUMBER TENUM_STRING NOT NULL,
CREATED_AT TCURRENT_DT NOT NULL,
USER_CREATED TCURRENT_USER);


ALTER TABLE SALE_NUM ADD SALE_DATE COMPUTED BY (cast(CREATED_AT as date));


ALTER TABLE ACCOUNT ADD ID_SALE_NUM ID_REF;

ALTER TABLE DOC_COMPLETION ADD ID_SALE_NUM ID_REF;

ALTER TABLE DOC_SUPPLIER ADD COMPANY_NAME TDESCRIPTION_LONG;

ALTER TABLE DOC_SUPPLIER ADD COMPANY_ADDRESS TDESCRIPTION_LONG;

ALTER TABLE DOC_SUPPLIER ADD COMPANY_IDENT_NUM TTEXT_SHORT;

ALTER TABLE DOC_SUPPLIER ADD COMPANY_VAT_REG_NUM TTEXT_SHORT;

ALTER TABLE DOC_SUPPLIER ADD COMPANY_MOL TPERSON_NAME;

ALTER TABLE DOC_TYPE ADD CREATED_AT TCURRENT_DT;

ALTER TABLE DOC_TYPE ADD UPDATED_AT TDATETIME;

ALTER TABLE DOC_TYPE ADD ARCHIVED_AT TDATETIME;

ALTER TABLE HOTEL ADD CREATED_AT TCURRENT_DT;

ALTER TABLE HOTEL ADD UPDATED_AT TDATETIME;

ALTER TABLE HOTEL ADD ARCHIVED_AT TDATETIME;

ALTER TABLE HOTEL ADD COMPANY_NAME TDESCRIPTION_LONG;

ALTER TABLE HOTEL ADD COMPANY_ADDRESS TDESCRIPTION_LONG;

ALTER TABLE HOTEL ADD COMPANY_IDENT_NUM TTEXT_SHORT;

ALTER TABLE HOTEL ADD COMPANY_VAT_REG_NUM TTEXT_SHORT;

ALTER TABLE HOTEL ADD COMPANY_MOL TPERSON_NAME;

ALTER TABLE HOTEL ADD ACCOMODATION_PLACE_UIN TDESCRIPTION_LONG;

ALTER TABLE PAYMENT_TYPE ADD CREATED_AT TCURRENT_DT;

ALTER TABLE PAYMENT_TYPE ADD UPDATED_AT TDATETIME;

ALTER TABLE PAYMENT_TYPE ADD ARCHIVED_AT TDATETIME;

ALTER TABLE PROFILE ADD CREATED_AT TCURRENT_DT;

ALTER TABLE PROFILE ADD UPDATED_AT TDATETIME;

ALTER TABLE PROFILE ADD ARCHIVED_AT TDATETIME;

ALTER TABLE RIGHTS_GROUPS ADD CREATED_AT TCURRENT_DT;

ALTER TABLE RIGHTS_GROUPS ADD UPDATED_AT TDATETIME;

ALTER TABLE RIGHTS_GROUPS ADD ARCHIVED_AT TDATETIME;

ALTER TABLE RIGHTS_GROUPS_LINES ADD GRANTED_AT TCURRENT_DT;

ALTER TABLE RIGHTS_GROUPS_REPORTS ADD GRANTED_AT TCURRENT_DT;

ALTER TABLE RIGHTS_USERS ADD USER_POSITION TDESCRIPTION_SHORT;

ALTER TABLE RIGHTS_USERS ADD CREATED_AT TCURRENT_DT;

ALTER TABLE RIGHTS_USERS ADD UPDATED_AT TDATETIME;

ALTER TABLE RIGHTS_USERS ADD ARCHIVED_AT TDATETIME;

ALTER TABLE ROOMS ADD ACCOMODATION_PLACE_UIN TDESCRIPTION_LONG;

ALTER TABLE SERVICES ADD CREATED_AT TCURRENT_DT;

ALTER TABLE SERVICES ADD UPDATED_AT TDATETIME;

ALTER TABLE SERVICES ADD ARCHIVED_AT TDATETIME;

UPDATE RDB$RELATION_FIELDS SET RDB$Collation_ID =
(Select C.Rdb$Collation_ID from Rdb$Collations C
where C.Rdb$Collation_Name='NONE'
 and C.Rdb$Character_Set_ID = (select Rdb$Character_Set_ID from Rdb$character_Sets where Rdb$character_set_name = 'NONE'))
  WHERE RDB$FIELD_NAME='PERSON_NAME' AND RDB$RELATION_NAME='PERSON_DATA';

/* Alter Field (Null / Not Null)... */
UPDATE RDB$RELATION_FIELDS SET RDB$NULL_FLAG = NULL WHERE RDB$FIELD_NAME='SESSION_VALUE' AND RDB$RELATION_NAME='SYSTEM_SESSION';


/* Drop table-fields... */
ALTER TABLE ACC_TEMPLATE DROP TMP$ORIG_ID;

ALTER TABLE BONUSPOINT_SCHEME DROP TMP$ORIG_ID;

ALTER TABLE CONTRACT_AGENT_COMMISSION$PMS DROP TMP$ORIG_CONTRACT;

ALTER TABLE CONTRACT_EXPENSE$PMS DROP TMP$ORIG_CONTRACT;

ALTER TABLE CONTRACT_MANAGEMENT$PMS DROP TMP$ORIG_CONTRACT;

DROP VIEW ENA_DEPOSIT;

DROP VIEW ENA_DOC_DEPOSIT_CONSUMPTION;

DROP VIEW ENA_DOC_HEAD_ADVANCE;

DROP VIEW ENA_DOC_HEAD_SERVICE;

DROP VIEW ENA_DOC_PAYMENT;

SET TERM ^ ;

ALTER PROCEDURE ACC_STATEMENT_GET_INFO$PMS(FROM_DATE DATE,
TO_DATE DATE,
ID_SERVICE_HL_LIST VARCHAR(255))
 RETURNS(ID_BILL INTEGER,
ID_DOC INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
POST_DATE DATE,
ID_ROOM INTEGER,
ID_OWNER INTEGER,
ROOM_INFO VARCHAR(30),
OWNER_NAME VARCHAR(100),
BILLING_INFO VARCHAR(100),
ID_SERVICE INTEGER,
SERVICE_DESC VARCHAR(100),
DESCRIPTION VARCHAR(300),
REF_DOC_INFO VARCHAR(300),
DEVICE_READING_INFO VARCHAR(300),
INCOME_VALUE NUMERIC(15,4),
INCOME_CURR VARCHAR(3),
OUTGO_VALUE NUMERIC(15,4),
OUTGO_CURR VARCHAR(3),
IS_ANUL SMALLINT,
IS_INVOICED SMALLINT,
ID_EXPORT_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW OWNER_POST_INVOICED;

SET TERM ^ ;

ALTER PROCEDURE DOCUMENT_ADD_DEF_PAYMENT$DOC(ID_DOC_HEAD INTEGER,
ID_PAY_DOC_TYPE INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE FISCAL_VALUE_GET$INT(ID_DOC_HEAD INTEGER)
 RETURNS(FISCAL_VALUE NUMERIC(15,2),
FISCAL_PAYMENT_CNT INTEGER,
FISCAL_PAYMENT_VALUE NUMERIC(15,2),
SALE_REDUCTION_COEF DOUBLE PRECISION)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE FISCALIZE_PAYMENT$FISC(ID_DOC_HEAD INTEGER)
 RETURNS(FISC_SUM NUMERIC(15,4),
FISC_TEXT VARCHAR(30),
FISC_GRP VARCHAR(10))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE PAYMENT_GET_DEFAULT$INT(ID_ACCOUNT INTEGER)
 RETURNS(ID_PAY_DOC_TYPE INTEGER,
PAY_CURR VARCHAR(3))
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW ACCOUNT_PAY_DOCS;

DROP VIEW DEPOSIT_SECURE;

DROP VIEW PAY_DOC_TYPE_S;

ALTER TABLE DOC_TYPE DROP TMP$ORIG_ID;

ALTER TABLE GUARANTEE_POLICY DROP TMP$ORIG_ID;

DROP VIEW FB_GUESTS;

ALTER TABLE GUEST_STAY DROP TMP$ORIG_BOARD;

ALTER TABLE PAYMENT_TAX DROP TMP$ORIG_ID;

DROP VIEW PAYMENT_TYPE_S;

ALTER TABLE PAYMENT_TYPE DROP TMP$ORIG_ID;

DROP VIEW ACCOUNT_PREVIEW;

DROP VIEW ACTIVITY_DATES;

DROP VIEW ENA_RESERV_DETAIL;

DROP VIEW HK_GUEST;

SET TERM ^ ;

ALTER PROCEDURE HK_PLAN_LINES_FINALIZE$HK(ID_PLAN_PERIOD INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE HK_PLAN_PERIOD_MODIFY$HK(ID_PLAN_PERIOD INTEGER,
ID_PLAN INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
OPERATION VARCHAR(10))
 RETURNS(NEW_ID_PLAN_PERIOD INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW HK_RESERVATION;

SET TERM ^ ;

ALTER PROCEDURE AVAILABILITY_OCCUPANCY$INT(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE EAI_EXT_ROOM_STATUS(ROOMS_FILTER VARCHAR(512) = '',
ID_HOTEL INTEGER = null)
 RETURNS(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
GUEST_NAME2 VARCHAR(50),
ROOM_NAME VARCHAR(10),
FROM_DATE DATE,
TO_DATE DATE,
COUNTRY VARCHAR(30),
AGE INTEGER,
ID_AGENT INTEGER,
ID_GROUP INTEGER,
SEX CHAR,
GUEST_CODE VARCHAR(50),
GUESTS_IN_ROOM INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE SUMMARY_OCCUPANCY_STATISTIC$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
 BEGIN EXIT; END
^

SET TERM ; ^

DROP VIEW HOTEL_ROOM_OCCUPANCY;

DROP VIEW RES_ROOM_TYPES;

ALTER TABLE RESERV_DETAIL DROP TMP$ORIG_BOARD;

DROP VIEW ENA_DOC_PAYMENT_DISCOUNT;

ALTER TABLE SALE_DISCOUNT DROP TMP$ORIG_ID;

DROP VIEW ENA_ACCOUNT_POST_HISTORY;

DROP VIEW ENA_DOC_LINE_ADVANCE;

DROP VIEW ENA_DOC_LINE_AGENT_DISCOUNT;

DROP VIEW ENA_DOC_LINE_SERVICE;

DROP VIEW ENA_DOC_LINE_SURGARGE;

ALTER TABLE SALE_TAXATION DROP TMP$ORIG_ID;

DROP VIEW ENA_DOC_TAX;

ALTER TABLE SALE_TAXES DROP TMP$ORIG_ID;

DROP VIEW ENA_SERVICES;

ALTER TABLE SERVICE_GROUPS DROP TMP$ORIG_ID;

SET TERM ^ ;

ALTER PROCEDURE AVAILABILITY_RATE_SMALL$WBE(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER,
ROOMS INTEGER,
ADULTS INTEGER,
CHILDREN INTEGER,
QUERY_ID INTEGER,
PROFILE_ID INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE AVAILABILITY_RATING_LOOP$INT(ID_SESSION INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ROOMS_COUNT INTEGER,
ADULTS_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ROOMTYPE_LIST VARCHAR(2000),
RATE_LIST VARCHAR(2000),
BOARD_LIST VARCHAR(2000),
HOTELS VARCHAR(255) = '')
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE BASE_SERVICES_GEN$INT(ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE BOARD_TO_FOODS(ID_BOARD /* TYPE OF ID */ INTEGER)
 RETURNS(ID_SERVICE /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE EAI_POS_CHECK_CARD$P2E(IN_CARD_NUMBER VARCHAR(50),
ID_HOTEL INTEGER)
 RETURNS(ID_GUEST INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100),
GUEST_NAME VARCHAR(100),
ROOM_NAME VARCHAR(20),
BOARD_NAME VARCHAR(30))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE EAI_POS_GET_GUESTS$P2E(IN_ROOM_NAME VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(OUT_ID_GUEST INTEGER,
OUT_GUEST_NAME VARCHAR(100),
OUT_FROM_DATE DATE,
OUT_TO_DATE DATE,
OUT_OK_FOR_POST INTEGER,
OUT_COUNTRY VARCHAR(30),
OUT_TEXT VARCHAR(100),
OUT_BOARD_NAME VARCHAR(30),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE EXPORT_BOOKING$EXC(BOOKING_ID INTEGER)
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20),
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_ID INTEGER,
IS_GUEST_ARRANGER INTEGER,
POSTING_ROUTING VARCHAR(20),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IS_DIFFERENT_TARIFF SMALLINT,
IS_DIFFERENT_BOARD SMALLINT,
IS_CUSTOM_PRICE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
EXC_LOCAL_VERSION BIGINT,
EXC_REMOTE_VERSION BIGINT,
CREATE_DATETIME TIMESTAMP,
EATING_OBJECT VARCHAR(50),
CHECK_OUT_KIND SMALLINT,
EARLYCHECKOUT_DATE DATE)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE LOOKUP_BOARD$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30),
ONLY_BOARDS SMALLINT)
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE RES_CREATE_GET$RSV(ID_HOTEL INTEGER)
 RETURNS(ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIMESTAMP,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIMESTAMP,
TRANSFER_OUT_NOTE VARCHAR(30),
IS_LATE_DEPARTURE INTEGER,
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
COUNTRY_CODE VARCHAR(20),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
CHECK_STATUS INTEGER,
ID_HK_PLAN INTEGER,
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER,
DEFAULT_GUEST_MASK VARCHAR(10))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE RES_CREATE_LOG$INT(RD_DBKEY CHAR(8))
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE RES_GET_GUEST_BOARDS$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(BOARD_NAMES VARCHAR(255),
ID_BOARD INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE RES_GET_GUEST_DATA$INT(RESERV_DATA VARCHAR(20),
ID_RESERV_DATA /* TYPE OF ID */ INTEGER)
 RETURNS(BOARD_NAMES /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
TARIFF_NAMES /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
PACKET_NAMES /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
VOUCHERS_RENDER /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE RES_GUEST_SAVE_BOARD$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_BOARD INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE RES_SAVE_BOARD$INT(RD_DBKEY CHAR(8),
ID_BOARD INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE TAR_BOARD_DECOMPOSE$INT(ID_BOARD /* TYPE OF ID */ INTEGER,
ID_TAR_HEAD /* TYPE OF ID */ INTEGER)
 RETURNS(ID_SERVICE /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE TAR_CALC_EVAL_COMPLEX_RATE$INT(INPUT_DETAIL_DBKEY CHAR(8),
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
BEDS SMALLINT,
ID_TYPE_STAY INTEGER,
IS_MANUAL_TYPE_STAY SMALLINT,
ID_BOARD INTEGER,
ID_ROOM_TYPE INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
CHECKIN_DATE DATE,
DAY_OF_STAY INTEGER,
PAYORS INTEGER,
MINORS INTEGER,
PERIOD_DEPEND_ON_CHECKIN SMALLINT,
CNT_DAYS_BP INTEGER,
CNT_DAYS_BOARD INTEGER,
BOARD_TYPE_FIND VARCHAR(10),
TOTAL_GUESTS INTEGER,
SEQ_NUM INTEGER,
TARIFF_CURR CHAR(3),
REAL_RECALC SMALLINT)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_PAYORS INTEGER,
OUT_MINORS INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE TAR_CALC_EVAL_SIMPLE_RATE$INT(ID_TAR_INPUT_DETAIL INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
ID_TAR_HEAD INTEGER,
BEDS SMALLINT,
GUEST_AGE INTEGER,
ID_TYPE_STAY INTEGER,
IS_MANUAL_TYPE_STAY INTEGER,
ID_BOARD INTEGER,
ID_ROOM_TYPE INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
TOTAL_GUESTS INTEGER,
CURRENT_ADULT_NUM INTEGER,
CURRENT_CHILD_NUM INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
NEW_CURRENT_ADULT_NUM INTEGER,
NEW_CURRENT_CHILD_NUM INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE TAR_GET_BASE_SERVICE$INT(ID_TYPE_STAY INTEGER,
ID_ROOM_TYPE INTEGER,
ID_BOARD INTEGER,
ID_HOTEL INTEGER)
 RETURNS(ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE TAR_MATCH_BOARD(TID_DBKEY CHAR(8),
ID_TAR_BP INTEGER,
BOARD_TYPE_FIND VARCHAR(10),
ID_BOARD INTEGER,
ID_BOARD_INCLUDE INTEGER,
MATCH_DATE DATE,
BASE_PER_DAY NUMERIC(15,4),
DAY_OF_STAY INTEGER,
CNT_DAYS_BOARD INTEGER,
CNT_DAYS_BP INTEGER,
CUSTOM_PRICE NUMERIC(15,4))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SEPARATE_BOARD INTEGER,
SERVICE_TYPE VARCHAR(20),
BOARD_PRICE NUMERIC(15,4),
PTEXT VARCHAR(20),
ID_SERVICE INTEGER,
FOOD_PER_DAY NUMERIC(15,4),
PACKET_ITEM INTEGER,
DISC_TAG VARCHAR(50))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE TAR_OUTPUT_BASE(ID_TAR_CALC INTEGER)
 RETURNS(ID_GUEST INTEGER,
ID_RESERV INTEGER,
ID_SERVICE INTEGER,
ID_TARIFF INTEGER,
DATE_POST DATE,
QTY_POST INTEGER,
PRICE_ORIG NUMERIC(15,4),
CURR_ORIG CHAR(3),
SHORT_CODE VARCHAR(255),
ID_ROOM INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE TAR_SAVE_BO_BOARD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE TAR_SAVE_BO_BP(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE TARIFA_BOARDS_SUPPORTED(ID_TAR_HEAD INTEGER)
 RETURNS(ID_BOARD INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE TARIFA_GET_PARAM(ID_PARAM INTEGER,
FOR_DATE DATE,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER)
 RETURNS(OUT_VALUE VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW MEALS;

DROP VIEW PACKETS_VOUCHERS;

ALTER TABLE SERVICES DROP TMP$ORIG_ID;

ALTER TABLE SERVICES DROP TMP$ORIG_TYPE_HRANA;

ALTER TABLE SERVICES DROP TMP$ORIG_TYPE_STAY;

ALTER TABLE SERVICES DROP TMP$ORIG_ROOM_TYPE;

ALTER TABLE TAR_BO_BASE_POSITION DROP TMP$ORIG_BOARD;

ALTER TABLE TAR_BO_BOARD DROP TMP$ORIG_BOARD;

ALTER TABLE TAR_BO_BOARD DROP TMP$ORIG_SERVICE;

ALTER TABLE TAR_BO_DISCOUNT DROP TMP$ORIG_SERVICE;

ALTER TABLE TAR_BO_DISCOUNT_STAY DROP TMP$ORIG_SERVICE;

ALTER TABLE TAR_BO_PACK DROP TMP$ORIG_SERVICE;

ALTER TABLE TAR_SIMPLE_BOARDS DROP TMP$ORIG_BOARD;

ALTER TABLE TAR_SIMPLE_PRICE DROP TMP$ORIG_BOARD;

ALTER TABLE TAX_POLICY DROP TMP$ORIG_ID;


RECONNECT;

/* Drop tables... */
DROP TABLE RIGHTS_CLOCK_IN;


/* Create Procedure... */
SET TERM ^ ;

CREATE PROCEDURE ACCOUNT_SALE_NUMBER_SET(ID_ACCOUNT TYPE OF ID,
OVERRIDE_EXISTING TYPE OF TLOGICAL = 0)
 RETURNS(ID_SALE_NUM TYPE OF ID)
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE DOC_INIT_FISCAL_STATUS$INT(ID_DOC_HEAD TYPE OF ID)
 AS
 BEGIN EXIT; END
^

CREATE PROCEDURE DOCUMENT_SALE_NUMBER_SET(ID_DOC_HEAD TYPE OF ID,
CREATED_AT TYPE OF TDATETIME = current_timestamp)
 RETURNS(ID_SALE_NUM TYPE OF ID)
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE FISCAL_DEVICE_STATUS_CHECK RETURNS(FISCAL_DEVICE_ID TYPE OF TSHORT_CODE)
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE FISCAL_SESSION_UPDATE$FISC(FISCAL_SESSION_ID INTEGER,
FISCAL_DEVICE_ID TYPE OF TSHORT_CODE)
 AS
 BEGIN EXIT; END
^

CREATE PROCEDURE FISCALIZE_PREPARE$FISC(ID_DOC_HEAD INTEGER,
DETAIL_LEVEL VARCHAR(20),
ADDITIONAL_PAYMENT_TEXT VARCHAR(30) = null)
 RETURNS(UNIQUE_SALES_NUMBER VARCHAR(50),
FISCALIZATION_DETAILS VARCHAR(255),
VOID_REASON VARCHAR(30),
IS_VOID TYPE OF TLOGICAL)
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE FISCALIZE_PREPARE_DATA$INT(ID_DOC_HEAD INTEGER,
UNIQUE_SALES_NUMBER VARCHAR(50),
DETAIL_LEVEL VARCHAR(20),
ADDITIONAL_PAYMENT_TEXT VARCHAR(30) = null)
 AS
 BEGIN EXIT; END
^

CREATE PROCEDURE FISCALIZE_PREPARE_LINES$INT(ID_DOC_HEAD INTEGER,
DETAIL_LEVEL VARCHAR(20),
ADDITIONAL_PAYMENT_TEXT VARCHAR(30) = null)
 RETURNS(FISC_PRICE NUMERIC(15,4),
FISC_QTY NUMERIC(15,4),
FISC_TEXT VARCHAR(30),
FISC_GRP VARCHAR(10),
TRANSACTION_VALUE NUMERIC(15,4))
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE FISCALIZE_PREPARE_PAYMENT$INT(ID_DOC_HEAD INTEGER)
 RETURNS(FISC_SUM NUMERIC(15,4),
FISC_TEXT VARCHAR(30),
FISC_GRP VARCHAR(10))
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE FISCALIZE_SET_DETAILS$FISC(ID_DOC_HEAD INTEGER,
FISCALIZATION_DETAILS VARCHAR(255))
 AS
 BEGIN EXIT; END
^

CREATE PROCEDURE FISCALIZE_VOID_PREPARE$FISC(ID_DOC_HEAD INTEGER)
 RETURNS(UNIQUE_SALES_NUMBER VARCHAR(50),
FISCALIZATION_DETAILS VARCHAR(255),
VOID_REASON VARCHAR(30))
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE GUEST_ANUL_POSTINGS$INT(ID_GUEST INTEGER)
 RETURNS(EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE HOTEL_COMPANY_DATA(ID_HOTEL TYPE OF ID,
LANGUAGE_CODE TYPE OF TLANGUAGE,
ID_DOC_SUPPLIER TYPE OF ID,
LC_IDENT_NUM TYPE OF TDESCRIPTION_SHORT,
LC_VAT_REG_NUM TYPE OF TDESCRIPTION_SHORT,
LC_MOL TYPE OF TDESCRIPTION_SHORT,
LC_ADDRESS TYPE OF TDESCRIPTION_SHORT)
 RETURNS(COMPANY_DATA TYPE OF TNOTE_BLOB)
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE RIGHTS_MODIFY_AUDIT_USER(USER_PASSWORD VARCHAR(50),
OPERATION VARCHAR(10))
 RETURNS(USER_NAME VARCHAR(30))
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE UNIQUE_SALES_NUMBER_GEN RETURNS(UNIQUE_SALES_NUMBER TYPE OF TNAME_SHORT)
 AS
 BEGIN SUSPEND; END
^


SET TERM ; ^

DROP VIEW ENA_GUEST;

/* Create view: ENA_GUEST */
CREATE VIEW ENA_GUEST(
ID_GUEST,
ID_RESERV_DETAIL,
PERSON_NAME,
PERSON_NAME2,
IS_CHILD,
VAUCHER_DATE,
VAUCHER_NUM,
VAUCHER_TEXT,
VAUCHER_NUM2,
VAUCHER_DATE2,
RATING_AGE,
AGE,
COUNTRY_CODE,
MASK)
 AS 
select
G.ID_GUEST,
G.ID_RESERV_DETAIL,
PD.PERSON_NAME,
PD.PERSON_NAME2,
G.IS_CHILD,
G.VAUCHER_DATE,
G.VAUCHER_NUM,
G.VAUCHER_TEXT,
G.VAUCHER_NUM2,
G.VAUCHER_DATE2,
GD.RATING_AGE,
(select ga.AGE_INYEARS from SYSTEM_CALC_AGE_INYEARS(pd.BIRTH_DAY, g.FROM_DATE) ga) as AGE,
PD.COUNTRY_CODE,
PD.MASK
from GUEST g
    join GUEST_DATA gd on gd.ID_GUEST = g.ID_GUEST
    join PERSON_DATA pd on pd.ID_PERSON_DATA = gd.ID_PERSON_DATA
;

COMMENT ON VIEW ENA_GUEST IS
'!!! .    (    )';

COMMENT ON COLUMN ENA_GUEST.ID_GUEST IS
'   ( )   . .';

COMMENT ON COLUMN ENA_GUEST.ID_RESERV_DETAIL IS
'        ( ENA_RESERV_DETAIL.ID_RESERV_DETAIL). .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME2 IS
'      . .';

COMMENT ON COLUMN ENA_GUEST.IS_CHILD IS
'   . 0 - ; 1 - . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE IS
'    . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_TEXT IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.RATING_AGE IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.COUNTRY_CODE IS
'    .        ISO. .';

COMMENT ON COLUMN ENA_GUEST.MASK IS
'  .         . .';

/* Create view: MEALS */
CREATE VIEW MEALS(
ID_SERVICE,
NAME,
IS_BREAKFAST,
IS_LUNCH,
IS_DINNER,
IS_EXTRAFOOD1,
IS_EXTRAFOOD2,
WEIGHT_TAG,
ID_BOARD,
IS_BOARD,
ID_HOTEL,
IS_ARCHIVE,
CHKSUM)
 AS 
select s.ID_SERVICE,
       s.SERVICE_NAME,
       sm.IS_BREAKFAST,
       sm.IS_LUNCH,
       sm.IS_DINNER,
       sm.IS_EXTRAFOOD1,
       sm.IS_EXTRAFOOD2,
       sm.WEIGHT_TAG,
       sm.ID_BOARD,
       sm.IS_BOARD,
       s.ID_HOTEL,
       s.IS_DELETED as is_archive,
       sm.IS_BREAKFAST*1+sm.IS_EXTRAFOOD1*2+sm.IS_LUNCH*4+sm.IS_EXTRAFOOD2*8+sm.IS_DINNER*16+100*s.id_hotel
from   SERVICE_MEALS sm
       join SERVICES s on s.ID_SERVICE = sm.ID_SERVICE
;

/* Create view: ENA_RESERV_DETAIL */
CREATE VIEW ENA_RESERV_DETAIL(
ID_HOTEL,
ID_RESERV_DETAIL,
NUMBER,
ID_GUEST_MAIN,
GUEST_MAIN_NAME,
GUEST_MAIN_NAME2,
TITLE,
FROM_DATE,
TO_DATE,
NIGHTS,
ADULT_COUNT,
CHILD_COUNT,
ID_EATING_OBJECT,
CHECK_STATUS,
IS_ANUL,
ARRANGER_PROFILE_ID,
ARRANGER_PROFILE_NAME,
ARRANGER_PROFILE_TYPE,
ARRANGER_PROFILE_ACCOUNT_NO,
MARKET_SEGMENT_CODE,
MARKET_SOURCE_CODE,
MARKET_CHANNEL_CODE,
MARKET_HEAR_CODE,
MARKET_COME_CODE,
ROOM_TYPE,
ROOM_NAME,
RATE_NAME,
RESERV_PRICE,
PRICE_CURRENCY,
BOARD,
EMAIL,
NATIONALITY,
NOTE)
 AS 
select
rd.ID_HOTEL,
rd.ID_RESERV_DETAIL,
rd.NUMBER,
rd.ID_TITULAR,
pd.PERSON_NAME,
pd.PERSON_NAME2,
pd.TITLE,
rd.FROM_DATE,
rd.TO_DATE,
rd.TO_DATE - rd.FROM_DATE,
rd.ADULT_COUNT,
rd.CHILD_COUNT,
rd.ID_EATING_OBJECT,
rd.CHECK_STATUS,
rd.IS_ANUL,
rd.ID_AGENT_PROFILE,
(select p1.PROFILE_NAME from PROFILE p1 where p1.ID_PROFILE = rd.ID_AGENT_PROFILE),
(select p2.PROFILE_TYPE from PROFILE p2 where p2.ID_PROFILE = rd.ID_AGENT_PROFILE),
(select p3.ACCOUNT_NO from PROFILE p3 where p3.ID_PROFILE = rd.ID_AGENT_PROFILE),
(select M1.MARKET_CODE from NOM_MARKET_SEGMENTS M1 where m1.ID_NOM_MARKET_SEGMENT = rd.ID_NOM_MARKET_SEGMENT),
(select M2.SOURCE_CODE from NOM_SOURCE_CODES M2 where m2.ID_NOM_SOURCE_CODE = rd.ID_NOM_SOURCE_CODE),
(select M3.CHANNEL_CODE from NOM_CHANNEL_CODES M3 where m3.ID_NOM_CHANNEL_CODE = rd.ID_NOM_CHANNEL_CODE),
(select M4.HEAR_REASON_CODE from NOM_HEAR_REASONS M4 where m4.ID_NOM_HEAR_REASON = rd.ID_NOM_HEAR_REASON),
(select M5.COME_REASON_CODE from NOM_COME_REASONS M5 where m5.ID_NOM_COME_REASON = rd.ID_NOM_COME_REASON),
coalesce((select rrt.TYPE_ROOM from ROOM_TYPES rrt join ROOMS r on r.ID_ROOM_TYPE = rrt.ID_ROOM_TYPE where r.ID_ROOM = rd.ID_ROOM),
         (select rrt.TYPE_ROOM from ROOM_TYPES rrt join ROOM_MAP$EXC rmp on rmp.ID_ROOM_TYPE = rrt.ID_ROOM_TYPE where rmp.ID_ROOM = rd.ID_ROOM),
         (select rrt.TYPE_ROOM from ROOM_TYPES rrt where rrt.ID_ROOM_TYPE = rd.ID_ROOM_TYPE)),
(select r.room_name from rooms r where r.ID_ROOM = rd.ID_ROOM),
t.TARIFA_NAME,
rd.ROOM_PRICE,
rd.ROOM_CURRENCY,
M.NAME,
(select p.EMAIL
 from   PROFILE P
 where  p.ID_PROFILE = rd.ID_PERSON_PROFILE) as EMAIL,
rd.COUNTRY,
rd.NOTE
from RESERV_DETAIL rd
    join GUEST g on g.ID_GUEST = rd.ID_TITULAR
    join GUEST_DATA gd on gd.ID_GUEST = g.ID_GUEST
    join PERSON_DATA pd on pd.ID_PERSON_DATA = gd.ID_PERSON_DATA
    join TARIFA T on t.ID_TARIFA = rd.ID_RATE
    join MEALS M on M.ID_BOARD = rd.ID_BOARD
;

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_RESERV_DETAIL IS
'   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NUMBER IS
'  .    (   ). .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_GUEST_MAIN IS
'      .      .  -     .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME IS
'    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME2 IS
'       . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.FROM_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.TO_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NIGHTS IS
'. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ADULT_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHILD_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_EATING_OBJECT IS
'          . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHECK_STATUS IS
'  . -3 =  ; -2 =   ; -1 =  ; 0 =  ; 1 =  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.IS_ANUL IS
'   . 0 - , 1 - .  -       0  1.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ID IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_NAME IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_TYPE IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ACCOUNT_NO IS
'             .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SEGMENT_CODE IS
'   ''segment''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SOURCE_CODE IS
'   ''source''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_CHANNEL_CODE IS
'   ''channel''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_HEAR_CODE IS
'   ''hear reason''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_COME_CODE IS
'   ''come reason''.   . .';

SET TERM ^ ;

ALTER PROCEDURE ACCOUNT_MANIP_VIEW(IN_IS_CLOSED SMALLINT,
IN_ID_ACCOUNTS VARCHAR(5000),
IN_IS_ANUL SMALLINT,
IN_INCLUDE SMALLINT,
IN_ID_DOC_HEAD INTEGER)
 RETURNS(OUT_ID_SERVICE INTEGER,
OUT_SERVICE_NAME VARCHAR(100),
OUT_IS_BASE INTEGER,
OUT_ID_ACCOUNT_POST INTEGER,
OUT_ID_CORRECT_POST INTEGER,
OUT_ID_ACCOUNT INTEGER,
OUT_ROOM_NAME VARCHAR(10),
OUT_GUEST_NAME VARCHAR(50),
OUT_QTY_POST NUMERIC(15,4),
OUT_QTY_FREE NUMERIC(15,4),
OUT_PRICE_POST NUMERIC(15,4),
OUT_SUM_PRICE NUMERIC(15,4),
OUT_QTY_POST_ORIG NUMERIC(15,4),
OUT_QTY_FREE_ORIG NUMERIC(15,4),
OUT_PRICE_POST_ORIG NUMERIC(15,4),
OUT_SUM_PRICE_ORIG NUMERIC(15,4),
OUT_DATE_POST DATE,
OUT_CURR_POST VARCHAR(3),
OUT_IS_ANUL INTEGER,
OUT_IS_CORRECT SMALLINT,
OUT_ID_SERVICE_GROUP INTEGER,
OUT_SRV_GROUP_NAME VARCHAR(100),
OUT_ID_ROOM INTEGER,
OUT_ID_GUEST INTEGER,
OUT_USER_CHANGED VARCHAR(30),
OUT_DATETIME_CHANGED TIMESTAMP,
OUT_CHANGE_TEXT VARCHAR(20),
OUT_PREV_POST VARCHAR(30),
OUT_DATE_CAME DATE)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE AGENT_AGES_MODIFY$PROFILE(ID_AGENT_AGES INTEGER,
ID_AGENT INTEGER,
AGE_START INTEGER,
AGE_END INTEGER,
AGES_NAME VARCHAR(50),
IS_CHILD SMALLINT,
OPERATION VARCHAR(10))
 RETURNS(NEW_ID_AGENT_AGES INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DOC_LINES_SUSPEND_INVOICE(ID_DOC_HEAD INTEGER,
CORRECTION_INDEX INTEGER,
RPT_TYPE VARCHAR(20),
RPT_CURR VARCHAR(10),
RPT_VAT VARCHAR(20),
IN_VAUCHER_NUM VARCHAR(20))
 RETURNS(TAX_STATUS INTEGER,
ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
VAUCHER_NUM VARCHAR(20),
GUEST_NAME VARCHAR(100),
IS_CHILD INTEGER,
AGES_NAME VARCHAR(50),
GFROM_DATE DATE,
GTO_DATE DATE,
PACKET_NAME VARCHAR(50),
LINE_NAME VARCHAR(100),
ID_SERVICE INTEGER,
DATE_POST DATE,
QTY_POST NUMERIC(15,2),
SINGLE_PRICE NUMERIC(15,4),
LINE_VALUE NUMERIC(15,4),
PACKET_PRICE NUMERIC(15,4),
PACKET_PRICE_WOT_DIFF DOUBLE PRECISION,
ID_TARIFA INTEGER,
BIRTH_DATE DATE,
NIGHTS INTEGER,
IS_BASE INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE EAI_EXT_ROOM_GUESTS(IN_ROOM_NAME VARCHAR(10),
ID_HOTEL INTEGER = null)
 RETURNS(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ROOM_NAME VARCHAR(10),
FROM_DATE DATE,
TO_DATE DATE,
COUNTRY VARCHAR(30),
AGE INTEGER,
ID_AGENT INTEGER,
ID_GROUP INTEGER,
SEX CHAR,
GUEST_CODE VARCHAR(50))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE GUEST_AGENT_SET$INT(G_DBKEY CHAR(8),
NEW_ID_AGENT_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE RES_GUEST_LOAD(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_GUEST INTEGER,
STATUS INTEGER,
GUEST_NAME1 VARCHAR(255),
GUEST_NAME2 VARCHAR(255),
IS_CHILD INTEGER,
AGE INTEGER,
BIRTH_DAY DATE,
BIRTHDAY_INTERNAL DATE,
COUNTRY_CODE VARCHAR(10),
FROM_DATE DATE,
TO_DATE DATE)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE RES_GUEST_SAVE_RATE$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TARIFF INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE RES_GUEST_SAVE_ROOMTYPE$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TAR_ROOM_TYPE INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE RES_GUEST_SAVE_TYPESTAY$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TYPE_STAY INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE RESERV_STATISTIC_SLICE$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_PROFILE_AGENT INTEGER,
COUNTRY_CODE VARCHAR(20),
MARKET_SEGMENT_CODE VARCHAR(3),
SOURCE_CODE VARCHAR(3),
CHANNEL_CODE VARCHAR(3),
HEAR_REASON_CODE VARCHAR(3),
COME_REASON_CODE VARCHAR(3))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE SPR_HOTEL_REGISTER(IN_FROM DATE,
IN_TO DATE,
IN_FROM_GUEST INTEGER,
IN_TO_GUEST INTEGER,
IN_MASK VARCHAR(10),
ID_HOTEL INTEGER = null)
 RETURNS(ID_GUEST INTEGER,
GUEST_NAME VARCHAR(50),
ROOM_NAME VARCHAR(10),
CITIZENSHIP_EGN VARCHAR(65),
PERIOD_FROM DATE,
PERIOD_TO DATE,
NIGHTS INTEGER,
RESERVATION VARCHAR(100),
ID_ACCOUNT_NIGHTS VARCHAR(30),
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
ADDRESS_BULGARIAN VARCHAR(100),
PASSPORT VARCHAR(40),
NOTE VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE TAR_CALC_EVAL_DATE$INT(ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
FOR_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW GUEST_CARD;

/* Create view: GUEST_CARD */
CREATE VIEW GUEST_CARD(
ID_GUEST,
GUEST_CODE,
GUEST_NAME1,
GUEST_NAME2,
EGN,
PASS_NUM,
PASS_DATE,
PASS_PLACE,
PASS_EXP_DATE,
COUNTRY,
SITY,
ADDRESS,
BIRTH_DAY,
BIRTH_PLACE,
SEX,
MASK,
STAY_NOTE,
ID_STAY_REASON,
STAY_REASON,
KPP_DATE,
IS_REGISTRED,
USER_REGISTRED,
USER_CHANGE_REGISTRED,
CAR,
KPP,
ID_NOM_MARKET_SEGMENT,
ID_NOM_SOURCE_CODE,
ID_NOM_CHANNEL_CODE,
ID_NOM_HEAR_REASON,
ID_NOM_COME_REASON,
EXTERNAL_DATA_LINK,
BIRTHDAY_INTERNAL)
 AS 
select
    GD.ID_GUEST,
    GD.GUEST_CODE,
    PD.PERSON_NAME,
    PD.PERSON_NAME2,
    PD.EGN,
    PD.PASS_NUM,
    PD.PASS_DATE,
    PD.PASS_PLACE,
    PD.PASS_EXP_DATE,
    PD.COUNTRY_CODE,
    PD.CITY,
    PD.ADDRESS,
    PD.BIRTH_DAY,
    PD.BIRTH_PLACE,
    PD.SEX,
    PD.MASK,
    GD.STAY_NOTE,
    GD.ID_STAY_REASON,
    SR.NAME as STAY_REASON,
    GD.KPP_DATE,
    GD.IS_REGISTRED,
    GD.USER_REGISTRED,
    GD.USER_CHANGE_REGISTRED,
    GD.CAR,
    GD.KPP,
    GD.ID_NOM_MARKET_SEGMENT,
    GD.ID_NOM_SOURCE_CODE,
    GD.ID_NOM_CHANNEL_CODE,
    GD.ID_NOM_HEAR_REASON,
    GD.ID_NOM_COME_REASON,
    GD.EXTERNAL_DATA_LINK,
    PD.BIRTHDAY_INTERNAL
from GUEST_DATA GD
     join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
     left outer join STAY_REASON SR on SR.ID_STAY_REASON = GD.ID_STAY_REASON
;

/* Create Views... */
/* Alter view (drop/create): USER_RIGHTS for view: PAY_DOC_TYPE_S */
/* Alter view (drop): USER_RIGHTS for view: PAY_DOC_TYPE_S */
SET TERM ^ ;

ALTER PROCEDURE RES_GET_PRICE$INT(RD_DBKEY CHAR(8),
OPTIONS VARCHAR(255))
 RETURNS(ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
REQUIRED_DEPOSIT_VALUE NUMERIC(15,4),
REQUIRED_DEPOSIT_CURRENCY CHAR(3))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE SYSTEM_GET_RIGHTS(USER_NAME VARCHAR(30))
 RETURNS(RIGHT_ITEM VARCHAR(100),
RIGHT_KIND VARCHAR(10))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE ACCOUNT_POST_TRANSFER_ACC$ACC(ID_SELECTED INTEGER)
 RETURNS(ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DEPOSIT_TRANSFER_ACCOUNTS$ACC(ID_DEPOSIT INTEGER)
 RETURNS(ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE GUEST_GET_POSTING_ACCOUNT$INT(ID_GUEST INTEGER,
ACCOUNT_ROUTING VARCHAR(10))
 RETURNS(ID_ACCOUNT INTEGER,
ID_ROOM INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE PROFILE_GET_ACCOUNT$PROFILE(ID_PROFILE INTEGER,
SHOW_ARCHIVE SMALLINT)
 RETURNS(ID_ACCOUNT INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
DEPOSIT_VALUE NUMERIC(15,4),
BALANCE_VALUE NUMERIC(15,4),
IS_DEFAULT SMALLINT,
IS_CREDIT SMALLINT,
CREDIT_LIMIT NUMERIC(15,4),
ID_TYPE_PAYMENT INTEGER,
IS_LEVEL_1 INTEGER,
IS_ARCHIVE INTEGER,
HOTEL_NAME VARCHAR(50))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE RES_ACCOUNTS_UNUSED_CLEAR$INT(ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE RES_GET_ACCOUNTS(ID_RESERV_DETAIL INTEGER,
OPERATION VARCHAR(50))
 RETURNS(ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE RES_GET_BALLANCE$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(RESERVATION_BALLANCE VARCHAR(255),
RECIEVED_DEPOSITS VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE RES_SAVE_ACCOUNTS_FINALIZE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

SET TERM ; ^

DROP VIEW ACCOUNTS_OPEN;

DROP VIEW ACCOUNT_S;

DROP VIEW CHECK_STATUS_GRANTED;

SET TERM ^ ;

ALTER PROCEDURE SERVICE_PAYMENT_ANALYSIS$RPT(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER)
 RETURNS(ID_SERVICE INTEGER,
ID_PAYMENT_TYPE INTEGER,
SALE_AMOUNT NUMERIC(15,4))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE SPR_DOC_MATRIX(FROM_DATE DATE,
TO_DATE DATE,
ID_CONTRAGENT INTEGER,
ID_TYPE_PAYMENT INTEGER,
ID_BASE_DOC_TYPE INTEGER,
SRV_GROUP_TAG VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(DOC_DATA VARCHAR(30),
IS_ANUL SMALLINT,
CONTRAGENT_NAME VARCHAR(100),
USER_NAME VARCHAR(50),
COL_NAME VARCHAR(30),
COL_VALUE NUMERIC(15,4),
COL_ORIG_VALUE NUMERIC(15,4),
SORT_ORDER SMALLINT)
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW DOCUMENT_RELEASE_S;

DROP VIEW DOCUMENT_S;

DROP VIEW PAY_DOC_TYPE_NA;

DROP VIEW VIEW_PHONECALLS;

DROP VIEW USER_RIGHTS;

/* Alter view (create): USER_RIGHTS for view: PAY_DOC_TYPE_S */
/* Create view: USER_RIGHTS */
CREATE VIEW USER_RIGHTS(
RIGHT_CODE,
RIGHT_GROUP,
DEF_DESCRIPTION)
 AS 
select distinct
       r.RIGHT_CODE,
       r.RIGHT_GROUP,
       r.DEF_DESCRIPTION
from   RIGHTS r
       join RIGHTS_GROUPS_LINES rgl on rgl.RIGHT_CODE = r.RIGHT_CODE
       join RIGHTS_USER_GROUPS rug on rug.ID_RIGHT_GROUP = rgl.ID_RIGHT_GROUP
where  rug.USER_NAME = current_user
union
select r.RIGHT_CODE,
       r.RIGHT_GROUP,
       r.DEF_DESCRIPTION
from   RIGHTS r
where  current_user in ('SYSDBA')
;

/* Create view: PAY_DOC_TYPE_S */
CREATE VIEW PAY_DOC_TYPE_S(
ID_DOC_TYPE,
DOC_TYPE_NAME,
STORNO_DOC_NAME,
ID_PAYMENT_TYPE,
ID_HOTEL,
ID_DOC_NUM,
DEF_CURRENCY,
IS_TAXED,
IS_ARCHIVE,
DOC_DIRECTION,
IS_CASH,
IS_CC,
IS_CHECK,
IS_BANK_TRANSFER,
IS_AR_DEBT,
IS_FISCALIZE,
PRINT_COPYIES,
EXPORT_TAG,
DESCRIPTION,
RAPORT_NAME,
CURRENCY_LIST)
 AS 
select DT.ID_DOC_TYPE,
       DT.DOC_TYPE_NAME,
       DTP.STORNO_DOC_NAME,
       DTP.ID_PAYMENT_TYPE,
       DT.ID_HOTEL,
       DT.ID_DOC_NUM,
       DT.DOC_CURR,
       DT.IS_TAXED,
       DT.IS_ARCHIVE,
       DTP.DOC_DIRECTION,
       DTP.IS_CASH,
       DTP.IS_CC,
       DTP.IS_CHECK,
       DTP.IS_BANK_TRANSFER,
       DTP.IS_AR_DEBT,
       DTP.IS_FISC,
       DT.PRINT_COPYIES,
       DT.EXPORT_TAG,
       DT.DESCRIPTION,
       DT.RAPORT_NAME,
       DT.CURRENCY_LIST
from   DOC_TYPE DT
       join DOC_TYPE_PAY DTP on DT.ID_DOC_TYPE = DTP.ID_DOC_TYPE
where  (DTP.RIGHT_CODE is null)
       or (DTP.RIGHT_CODE in (select distinct R.RIGHT_CODE
                              from   USER_RIGHTS R
                              where  R.RIGHT_CODE starting with 'DOC_PAY_GROUP_'))
;

/* Alter view (drop/create): DOC_HEAD for view: ACCOUNT_PAY_DOCS */
/* Alter view (drop): DOC_HEAD for view: ACCOUNT_PAY_DOCS */
SET TERM ^ ;

ALTER PROCEDURE ACC_STATEMENT_INVOICES_GET$PMS(ID_BILL INTEGER)
 RETURNS(ID_DOC INTEGER,
ID_SERVICE INTEGER,
DATE_POST DATE,
ROOM_NAME VARCHAR(100),
LINE_DESC VARCHAR(100),
OUTGO_VALUE NUMERIC(15,4),
CURR_POST VARCHAR(3),
IS_ANUL SMALLINT,
INV_DESCRIPTION VARCHAR(100))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE ACCOUNT_GET_CONTRAGENT_DATA$INT(ID_ACCOUNT INTEGER)
 RETURNS(ID_CONTRAGENT INTEGER,
IS_JURIDICAL_PERSON SMALLINT,
CONTRAGENT_NAME VARCHAR(100),
VAT_REG_NUM VARCHAR(30),
IDENT_NO VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(100),
RECIPIENT_NAME VARCHAR(100),
RECIPIENT_PAS_NUM VARCHAR(20),
RECIPIENT_PAS_DATE DATE,
RECIPIENT_PAS_FROM VARCHAR(30),
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE ACCOUNT_POSTING_DOC_UPDATE$INT(DH_DBKEY /* TYPE OF TDB_KEY */ CHAR(8))
 RETURNS(WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE ACCOUNT_POSTS_EW_MARK$INT(ID_END_WORK INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE BP_SCHEME_CALC_TURNOVER_POINTS(ID_BONUSPOINT_SCHEME INTEGER,
ID_DOC_HEAD INTEGER,
ID_RESERV_DETAIL INTEGER,
POSTING_TYPES VARCHAR(20))
 RETURNS(POINTS INTEGER,
TURNOVER NUMERIC(15,4),
TURNOVER_CURR CHAR(3),
POINTS_REASON VARCHAR(50))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DEPOSIT_REFUND$DOC(ID_DEPOSIT INTEGER,
REFUND_AMOUNT NUMERIC(15,4),
REFUND_CURRENCY VARCHAR(3),
ID_PAY_DOC_TYPE INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_REFUND_PAYMENT INTEGER,
ID_STORNO_DOC INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DOCUMENT_ADVANCE_STORNO$INT(ID_DEPOSIT INTEGER,
PAY_AMOUNT NUMERIC(15,2),
DESCRIPTION VARCHAR(100))
 RETURNS(ID_STORNO_DOC INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DOCUMENT_ANUL$DOC(ID_DOC_HEAD INTEGER,
ANUL_REASON VARCHAR(100),
MAKE_ANNUL_REPORT SMALLINT)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE DOCUMENT_ATTACH_PAYMENT$INT(ID_DOC_HEAD INTEGER,
ID_ACCOUNT_PAYMENT INTEGER,
PAY_CURR_RATE NUMERIC(15,6),
PAY_VALUE NUMERIC(15,4))
 RETURNS(DOC_VALUE NUMERIC(15,4))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DOCUMENT_BONUSPOINTS_APPLY$CL(ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE DOCUMENT_BONUSPOINTS_SPEND(ID_DOC_HEAD INTEGER,
BONUSPOINT_CNT INTEGER)
 RETURNS(DOC_REST_AMOUNT NUMERIC(15,4))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DOCUMENT_DETACH_DEPOSIT$INT(ID_DOC_HEAD INTEGER,
ID_DEPOSIT INTEGER,
ID_STORNO_DOC INTEGER = null)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE DOCUMENT_PAYMENTS_CLEAR$DOC(ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE DOCUMENT_REMOVE_PAYMENT$DOC(ID_PAYMENT_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE DOCUMENT_STORNO$DOC(ID_DOC_HEAD INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_STORNO_DOC INTEGER,
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DOCUMENT_STORNO$INT(ID_DOC_HEAD INTEGER,
DESCRIPTION VARCHAR(100),
STORNO_PAYMENTS SMALLINT)
 RETURNS(ID_STORNO_DOC INTEGER,
ID_HOTEL INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DOCUMENT_STORNO_PAYS_SET$DOC(ID_STORNO_DOC INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE DOCUMENT_USE_DEPOSIT$DOC(ID_DOC_HEAD INTEGER,
ID_DEPOSIT INTEGER,
DEPOSIT_AMOUNT NUMERIC(15,4))
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE EXPORT_DOCS$PMS(START_DATE /* TYPE OF TDATE */ DATE,
END_DATE /* TYPE OF TDATE */ DATE,
ID_HOTEL /* TYPE OF ID_REF */ INTEGER)
 RETURNS(ID_ROOM /* ID_REF */ INTEGER,
ID_RESERV_DETAIL /* ID_REF */ INTEGER,
ID_CONTRACT /* ID_REF */ INTEGER,
FROM_DATE /* TDATE */ DATE,
TO_DATE /* TDATE */ DATE,
PRICE_WITH_VAT /* TPRICE */ NUMERIC(15,4),
PRICE_WO_VAT /* TPRICE */ NUMERIC(15,4),
BEDNIGHTS /* TCOUNT */ INTEGER,
STAY /* TCOUNT */ INTEGER,
RESERVS /* TCOUNT */ INTEGER,
LAST_ID_DOC_HEAD /* ID_REF */ INTEGER,
DOC_DESCRIPTION /* TDESCRIPTION_LONG */ VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE EXPORT_DOCUMENT(FROM_DATE DATE,
TO_DATE DATE,
DOC_TAG VARCHAR(20),
PAY_TAG VARCHAR(20),
NO_PAY_DOCS VARCHAR(20),
GROUP_TAG VARCHAR(20),
ID_HOTEL INTEGER = null,
RETURN_CLIENT_PERSON_ID SMALLINT = 0)
 RETURNS(DOC_TYPE_ID INTEGER,
DOC_SUB_TYPE SMALLINT,
DOC_TYPE_NAME VARCHAR(50),
DOC_DATE DATE,
DOC_FOR_DEPOSIT SMALLINT,
TAX_EVENT_DATE DATE,
DIFF_VAT_REASON VARCHAR(254),
DOC_NUM VARCHAR(20),
DOC_CURRENCY CHAR(3),
DOC_RATE NUMERIC(15,4),
DOC_IS_STORNED SMALLINT,
DOC_IS_STORNO SMALLINT,
DOC_ID_BASE_DOC INTEGER,
DOC_EXPORT_TAG VARCHAR(20),
DOC_SEND_NAME VARCHAR(100),
DOC_DOGOVOR_NUM VARCHAR(30),
DOC_NOTE VARCHAR(100),
DOC_SUPPLIER_ID INTEGER,
CLT_ID INTEGER,
CLT_NAME VARCHAR(100),
CLT_VAT_REG_NUM VARCHAR(30),
CLT_IDENT_NO VARCHAR(30),
CLT_MOL VARCHAR(100),
CLT_ADDRESS VARCHAR(100),
CLT_COUNTRY_CODE VARCHAR(10),
CLT_ZIP_CODE VARCHAR(10),
CLT_RECIEVE_NAME VARCHAR(100),
PAY_TYPE_ID INTEGER,
PAY_TYPE VARCHAR(20),
PAY_CURRENCY CHAR(3),
PAY_VALUE NUMERIC(15,4),
PAY_RATE NUMERIC(15,6),
PAY_CC_NAME VARCHAR(50),
PAY_CC_NUM VARCHAR(50),
PAY_CC_BANK VARCHAR(50),
PAY_EXPORT_TAG VARCHAR(20),
LINE_ID INTEGER,
LINE_NAME VARCHAR(50),
LINE_WOT_VAT NUMERIC(15,4),
LINE_VAT_FREE NUMERIC(15,4),
LINE_VAT_BASE NUMERIC(15,4),
LINE_VAT NUMERIC(15,4),
VAT_VALUE NUMERIC(15,4),
ID_VAT_GROUP INTEGER,
ID_SALE_TAXATION INTEGER,
LINE_QTY NUMERIC(15,4),
ACC_NO VARCHAR(30),
POSITION_NO INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE EXPORT_DOCUMENT_LINES(ID_DOC_HEAD INTEGER,
GROUP_TAG VARCHAR(20),
PAY_COEFICIENT DOUBLE PRECISION,
DOC_RATE NUMERIC(15,4))
 RETURNS(LINE_ID INTEGER,
LINE_NAME VARCHAR(50),
LINE_WOT_TAX NUMERIC(15,4),
LINE_TAX NUMERIC(15,4),
LINE_QTY NUMERIC(15,4),
ACC_NO VARCHAR(30),
TAX_PERCENT NUMERIC(15,4),
ID_SALE_TAXATION INTEGER,
POSITION_NO INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE FISCALIZE_LINE$FISC(ID_DOC_HEAD INTEGER,
DETAIL_LEVEL VARCHAR(20),
ADDITIONAL_PAYMENT_TEXT VARCHAR(30) = null)
 RETURNS(FISC_PRICE NUMERIC(15,4),
FISC_QTY NUMERIC(15,4),
FISC_TEXT VARCHAR(30),
FISC_GRP VARCHAR(10),
TRANSACTION_VALUE NUMERIC(15,4))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE FISCALIZE_MARK_DOC$FISC(ID_DOC_HEAD INTEGER,
IS_MANUAL INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE PAYMENT_STORNO$INT(ID_PAYMENT_HEAD INTEGER,
ID_ACCOUNT INTEGER,
NEW_ID_DOC_HEAD INTEGER,
STORNO_AMOUNT NUMERIC(15,4),
DESCRIPTION VARCHAR(100),
TARGET_DOC_AMOUNT NUMERIC(15,4))
 RETURNS(ID_STORNO_PAYMENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE PAYMENT_VOID_CHECK$INT(ID_PAYMENT_HEAD /* TYPE OF ID */ INTEGER,
VOID_REASON /* TYPE OF TREASON */ VARCHAR(50))
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE SERVICE_POSTING_REVENUE$INT(ID_END_WORK INTEGER)
 RETURNS(SEQUENCE_ID INTEGER,
POST_DBKEY CHAR(8),
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT INTEGER,
ID_SERVICE INTEGER,
ID_SALE_TAXATION INTEGER,
ID_GUEST INTEGER,
ROOM_NAME VARCHAR(10),
ARISE_DATE DATE,
DATE_POST DATE,
IS_PRIMARY_POST SMALLINT,
POST_TYPE VARCHAR(10),
QTY_POST NUMERIC(15,4),
PRICE_POST NUMERIC(15,4),
RATE_POST NUMERIC(15,6),
CURR_POST VARCHAR(3),
POST_NET_VALUE NUMERIC(15,4),
POST_GROSS_VALUE NUMERIC(15,4),
DATETIME_POST TIMESTAMP,
USER_NAME VARCHAR(30),
POST_REASON VARCHAR(30))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE SYSTEM_EVENT_LOG$INT(OBJECT_CLASS VARCHAR(30),
OBJECT_ID INTEGER,
EVENT_CODE VARCHAR(50),
EVENT_TEXT VARCHAR(255),
EXTRA_DATA VARCHAR(255) = null)
 RETURNS(NEW_ID_SYSTEM_LOG INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE SYSTEM_LOG_OBJECT_INFO_GET(OBJECT_CLASS VARCHAR(30),
OBJECT_ID INTEGER)
 RETURNS(OBJECT_DESCRIPTION VARCHAR(100),
HOTEL_CODE VARCHAR(10))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE SYSTEM_NUM_GETINFO$CFG(ID_NUMERATOR INTEGER)
 RETURNS(IN_USE INTEGER,
NEXT_NUM_VALUE INTEGER,
NEXT_NUM_TEXT VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW ACCOUNT_POST_ACCUMULATION;

SET TERM ^ ;

ALTER PROCEDURE ACCOUNTS_BALANCE_TO_DATE$RPT(ID_HOTEL INTEGER,
TO_DATE DATE)
 RETURNS(ID_ACCOUNT INTEGER,
ACCOUNT_CURR CHAR(3),
CURR_RATE NUMERIC(15,6),
POSTING_AMOUNT NUMERIC(15,4),
PAYMENT_AMOUNT NUMERIC(15,4),
OPEN_DEP_AMOUNT NUMERIC(15,4),
OPEN_CHARGES INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DOCUMENT_PAY_TYPES(ID_DOC_HEAD INTEGER)
 RETURNS(PAY_TYPE_LIST VARCHAR(255),
PAY_TYPE_IDS VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE PAYMENTS_EW_SUMMARIZE$INT(ID_END_WORK INTEGER)
 AS
 BEGIN EXIT; END
^

SET TERM ; ^

DROP VIEW DOCUMENT_PAYMENT;

SET TERM ^ ;

ALTER PROCEDURE PMS_ROOM_DOCS_PREPARE$RPT(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER)
 RETURNS(REC_COUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW DOCUMENT_RELEASE;

SET TERM ^ ;

ALTER PROCEDURE ACCOUNT_DEBT_FILL$INT(ID_END_WORK INTEGER)
 AS
 BEGIN EXIT; END
^

SET TERM ; ^

DROP VIEW DOCUMENT_REVENUE;

DROP VIEW DOC_HEAD;

/* Alter view (create): DOC_HEAD for view: ACCOUNT_PAY_DOCS */
/* Create view: DOC_HEAD */
CREATE VIEW DOC_HEAD(
ID_DOC,
ID_BASE_DOC,
ID_DOC_TYPE,
DOC_SUB_TYPE,
DOC_TYPE_NAME,
ID_DOC_NUM,
NUM,
DOC_NUM,
ID_ACCOUNT,
ID_DOC_CONTRAGENT,
ID_DOC_SUPPLIER,
DOC_DATE,
FOR_DEPOSIT,
IS_STORNED,
IS_ANUL,
IS_STORNO,
FISC_STATUS,
DOC_CURRENCY,
DOC_VALUE,
DOC_VALUE_A,
DOC_NET_VALUE,
DOC_RATE,
DOC_ACC_RATE,
TAX_EVENT_DATE,
DESCRIPTION,
USER_CREATED,
DATETIME_CREATED,
SELECTION_ID,
ONE_LINE_TEXT,
DIFF_VAT_REASON,
TAXABLE_VALUE,
IS_EFAKTURA_EXPORTED,
SECOND_CURRENCY,
SECOND_CURR_RATE,
SECOND_CURR_NET_VALUE,
SECOND_CURR_GROSS_VALUE,
PROFORMA_EXP_DATE,
ID_SALE_NUM)
 AS 
select dh.ID_DOC_HEAD,
       dh.ID_BASE_DOC,
       dh.ID_DOC_TYPE,
       dh.DOC_SUB_TYPE,
       dh.DOC_TYPE_NAME,
       dh.ID_DOC_NUM,
       dh.NUM,
       dh.DOC_NUM,
       dh.ID_ACCOUNT,
       dh.ID_DOC_CONTRAGENT,
       dh.ID_DOC_SUPPLIER,
       dh.DOC_DATE,
       dh.FOR_DEPOSIT,
       dh.IS_STORNED,
       dh.IS_ANUL,
       dh.IS_STORNO,
       dc.FISC_STATUS,
       dh.DOC_CURRENCY,
       dh.DOC_VALUE,
       dh.DOC_VALUE_A,
       dh.DOC_NET_VALUE,
       dh.DOC_RATE,
       dh.DOC_ACC_RATE,
       dc.TAX_EVENT_DATE,
       dh.DESCRIPTION,
       dh.USER_CREATED,
       dh.DATETIME_CREATED,
       dh.SELECTION_ID,
       dh.ONE_LINE_TEXT,
       dh.DIFF_VAT_REASON,
       dh.TAXABLE_VALUE,
       dc.IS_EFAKTURA_EXPORTED,
       dh.SECOND_CURRENCY,
       dh.SECOND_CURR_RATE,
       dh.SECOND_CURR_NET_VALUE,
       dh.SECOND_CURR_GROSS_VALUE,
       dh.PROFORMA_EXP_DATE,
       dc.ID_SALE_NUM
from DOC_HEAD$INT dh
     join DOC_COMPLETION dc on dc.ID_DOC_HEAD = dh.ID_DOC_HEAD
;

/* Create view: ACCOUNT_PAY_DOCS */
CREATE VIEW ACCOUNT_PAY_DOCS(
ID_PAYMENT_HEAD,
ID_DOC_TYPE,
DOC_TYPE_NAME,
NUM,
PAYMENT_NUM,
PAYMENT_DATE,
ID_ACCOUNT,
PAY_CURRENCY,
PAY_RATE,
PAY_VALUE,
IS_ANUL,
IS_STORNO,
IS_STORNED,
IS_DEPOSIT,
PAY_REASON,
ID_DOC_HEAD,
ID_DOC_CONTRAGENT,
DATETIME_CREATED,
USER_CREATED)
 AS 
select   P.ID_PAYMENT_HEAD,
         P.ID_DOC_TYPE,
         P.DOC_TYPE_NAME,
         P.NUM,
         P.PAYMENT_NUM,
         P.PAYMENT_DATE,
         P.ID_ACCOUNT,
         P.PAY_CURRENCY,
         P.PAY_RATE,
         P.PAY_VALUE_A,
         P.IS_ANUL,
         P.IS_STORNO,
         P.IS_STORNED,
         cast(0 as integer),
         cast(DH.DOC_TYPE_NAME || ' ' || DH.DOC_NUM || '/' || formatdate(DH.DOC_DATE, 'D;dd.mm.yyyy') as varchar(100)),
         P.ID_DOC_HEAD,
         P.ID_DOC_CONTRAGENT,
         P.DATETIME_CREATED,
         P.USER_CREATED
from     PAYMENT_HEAD P
         join PAY_DOC_TYPE_S PD on PD.ID_DOC_TYPE = P.ID_DOC_TYPE
         join DOC_HEAD DH on DH.ID_DOC = P.ID_DOC_HEAD --and DH.FOR_DEPOSIT = 0
union all
select   P.ID_PAYMENT_HEAD,
         P.ID_DOC_TYPE,
         P.DOC_TYPE_NAME,
         P.NUM,
         P.PAYMENT_NUM,
         P.PAYMENT_DATE,
         P.ID_ACCOUNT,
         P.PAY_CURRENCY,
         P.PAY_RATE,
         P.PAY_VALUE_A,
         P.IS_ANUL,
         P.IS_STORNO,
         P.IS_STORNED,
         cast(1 as integer),
         coalesce(d.DESCRIPTION, p.DESCRIPTION) as pay_reason,
         P.ID_DOC_HEAD,
         P.ID_DOC_CONTRAGENT,
         P.DATETIME_CREATED,
         P.USER_CREATED
from     PAYMENT_HEAD P
         join PAY_DOC_TYPE_S PD on PD.ID_DOC_TYPE = P.ID_DOC_TYPE
         left outer join DEPOSIT D on d.ID_DEPOSIT = p.ID_DEPOSIT
where    P.ID_DOC_HEAD is null
;

/* Create view: ACCOUNT_POST_ACCUMULATION */
CREATE VIEW ACCOUNT_POST_ACCUMULATION(
ID_ACCUMULATION_POST,
ID_ACCOUNT_POST,
IS_PRIMARY_POST,
ID_SERVICE,
ID_ACCOUNT,
DATE_POST,
SYS_DATE,
QTY_POST,
PRICE_POST,
POST_NET_VALUE,
POST_GROSS_VALUE,
CURR_POST,
ID_DOC_HEAD)
 AS 
select AP.ID_ACCOUNT_POST,
       AP.ID_ACCOUNT_POST,
       cast(1 as smallint),
       AP.ID_SERVICE,
       AP.ID_ACCOUNT,
       AP.DATE_POST,
       EW1.PREV_DATE,
       AP.QTY_POST,
       AP.PRICE_POST,
       AP.POST_NET_VALUE,
       AP.POST_GROSS_VALUE,
       AP.CURR_POST,
       AP.ID_BASE_DOC
from   ACCOUNT_POST AP
       join END_WORKS EW1 on EW1.ID_END_WORK = AP.ID_END_WORK
where not exists (select ac.ID_ACC_POST_CORRECT
                  from   ACCOUNT_POST_CORRECTION ac
                  where  ac.ID_ACCOUNT_POST = ap.ID_ACCOUNT_POST)
union all
select AP.ID_ACCOUNT_POST,
       AP.ID_ACCOUNT_POST,
       cast(1 as smallint),
       APC.ID_SERVICE,
       APC.ID_ACCOUNT,
       AP.DATE_POST,
       EW2.PREV_DATE,
       apc.OLD_QTY,
       apc.OLD_PRICE,
       apc.OLD_POST_NET_VALUE,
       apc.OLD_POST_GROSS_VALUE,
       apc.OLD_CURR_POST,
       coalesce((select   first 1 DH.ID_DOC
                 from     DOC_LINE_POST_VALUES PV
                          join DOC_LINE DL on DL.ID_DOC_LINE = PV.ID_DOC_LINE
                          join DOC_HEAD DH on DH.ID_DOC = DL.ID_DOC_HEAD
                 where    PV.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
                          and DH.IS_ANUL = 0
                          and DH.DATETIME_CREATED < apc.DATETIME_CREATED
                 order by DH.DATETIME_CREATED desc), nullif(apc.ID_DOC_HEAD, -1), AP.ID_BASE_DOC)
from   ACCOUNT_POST AP
       join END_WORKS EW2 on EW2.ID_END_WORK = AP.ID_END_WORK
       left outer join (select   APC1.ID_ACCOUNT_POST,
                                 min(APC1.ID_ACC_POST_CORRECT) as ID_ACC_POST_CORRECT
                        from     ACCOUNT_POST_CORRECTION APC1
                        group by APC1.ID_ACCOUNT_POST) T on T.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
       left outer join  ACCOUNT_POST_CORRECTION APC on APC.ID_ACC_POST_CORRECT = T.ID_ACC_POST_CORRECT
where  APC.ID_ACC_POST_CORRECT is not null
union all
select APC.ID_ACC_POST_CORRECT,
       APC.ID_ACCOUNT_POST,
       cast(0 as smallint),
       APC.ID_SERVICE,
       APC.ID_ACCOUNT,
       APC.DATE_POST_ORIG,
       EW3.PREV_DATE,
       iif(APC.IS_QTY_CORRECT = 0, APC.NEW_QTY, APC.NEW_QTY - APC.OLD_QTY),
       iif(APC.IS_QTY_CORRECT = 1, APC.NEW_PRICE, APC.NEW_PRICE - APC.OLD_PRICE),
       APC.NEW_POST_NET_VALUE - APC.OLD_POST_NET_VALUE,
       APC.NEW_POST_GROSS_VALUE - APC.OLD_POST_GROSS_VALUE,
       APC.NEW_CURR_POST,
       APC.ID_DOC_HEAD
from   ACCOUNT_POST_CORRECTION APC
       join ACCOUNT_POST ap on ap.ID_ACCOUNT_POST = apc.ID_ACCOUNT_POST
       join END_WORKS ew3 on ew3.ID_END_WORK = apc.ID_END_WORK
union all
select APC.ID_ACC_POST_CORRECT,
       APC.ID_ACCOUNT_POST,
       cast(0 as smallint),
       APC.ID_SERVICE,
       APC.ID_ACCOUNT,
       APC.DATE_POST_ORIG,
       EW7.PREV_DATE,
       iif(APC.IS_QTY_CORRECT = 0, APC.NEW_QTY, APC.NEW_QTY - APC.OLD_QTY),
       iif(APC.IS_QTY_CORRECT = 1, APC.NEW_PRICE, APC.NEW_PRICE - APC.OLD_PRICE),
       APC.NEW_POST_NET_VALUE - APC.OLD_POST_NET_VALUE,
       APC.NEW_POST_GROSS_VALUE - APC.OLD_POST_GROSS_VALUE,
       APC.NEW_CURR_POST,
       APC.ID_DOC_HEAD
from   END_WORKS EW7
       left outer join ACCOUNT_POST AP on AP.ID_END_WORK = EW7.ID_END_WORK
       left outer join ACCOUNT_POST_CORRECTION APC on APC.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
where  AP.ID_ACCOUNT_POST is not null
       and APC.ID_ACC_POST_CORRECT is not null
       and APC.ID_END_WORK is null
union all
select PV.ID_ACCOUNT_POST,
       PV.ID_ACCOUNT_POST,
       cast(0 as smallint),
       DL.ID_SERVICE,
       A.ID_ACCOUNT,
       DL.DATE_POST,
       DRD.RELEASE_DATE,
       DL.QTY_POST,
       PV.ACCOUNT_PRICE * DRD.VALUE_CORR_INDEX,
       (PV.NET_RATE_DIFF + PV.NET_ROUND_DIFF) * DRD.VALUE_CORR_INDEX,
       (PV.GROSS_RATE_DIFF + PV.GROSS_ROUND_DIFF) * Drd.VALUE_CORR_INDEX,
       DH.DOC_CURRENCY,
       DH.ID_DOC
from   DOC_HEAD DH
       join DOC_RELEASE_DATE drd on drd.ID_DOC_HEAD = dh.ID_DOC and drd.VALUE_CORR_INDEX <> 0
       join ACCOUNT A on A.ID_ACCOUNT = DH.ID_ACCOUNT
       join DOC_LINE DL on DL.ID_DOC_HEAD = DH.ID_DOC
       join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
                                       and ((PV.NET_RATE_DIFF <> 0)
                                              or (PV.NET_ROUND_DIFF) <> 0
                                              or (PV.GROSS_RATE_DIFF <> 0)
                                              or (PV.GROSS_ROUND_DIFF <> 0))
       left join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = PV.ID_ACCOUNT_POST
       join END_WORKS EW4 on EW4.ID_END_WORK = AP.ID_END_WORK
union all
select null,
       null,
       cast(1 as smallint),
       DL.ID_SERVICE,
       A.ID_ACCOUNT,
       DL.DATE_POST,
       DRD.RELEASE_DATE,
       DL.QTY_POST,
       DL.WOT_DIFF * DH.DOC_ACC_RATE * DRD.VALUE_CORR_INDEX,
       DL.NAT_NET_VALUE * DRD.VALUE_CORR_INDEX,
       DL.NAT_GROSS_VALUE * DRD.VALUE_CORR_INDEX,
       DH.DOC_CURRENCY,
       DH.ID_DOC
from   DOC_HEAD DH
       join DOC_RELEASE_DATE drd on drd.ID_DOC_HEAD = dh.ID_DOC and drd.VALUE_CORR_INDEX <> 0
       join ACCOUNT A on A.ID_ACCOUNT = DH.ID_ACCOUNT
       join DOC_LINE DL on DL.ID_DOC_HEAD = DH.ID_DOC
       join DOC_FOOTER DF on DF.ID_DOC_LINE = DL.ID_DOC_LINE
;

/* Create view: ACCOUNT_S */
CREATE VIEW ACCOUNT_S(
ID_ACCOUNT,
ACCOUNT_CURR,
ACCOUNT_NAME,
IS_CREDIT_ACCOUNT,
CREDIT_LIMIT,
ID_TYPE_PAYMENT,
NOTE,
MASK,
IS_BLOCKED,
BLOCK_TEXT,
SECURITY_LEVEL,
IS_ARCHIVE,
IS_BASE,
IS_EXTRA,
IS_ALOWED_POS_INTERFACE,
POS_INTERFACE_NOTE,
ID_RESERV_DETAIL,
ID_PROFILE,
ID_HOTEL,
IS_DEFAULT,
ID_SALE_NUM)
 AS 
select
    ID_ACCOUNT,
    ACCOUNT_CURR,
    ACCOUNT_NAME,
    IS_CREDIT_ACCOUNT,
    CREDIT_LIMIT,
    ID_TYPE_PAYMENT,
    NOTE,
    MASK,
    IS_BLOCKED,
    BLOCK_TEXT,
    SECURITY_LEVEL,
    IS_ARCHIVE,
    IS_BASE,
    IS_EXTRA,
    IS_ALOWED_POS_INTERFACE,
    POS_INTERFACE_NOTE,
    ID_RESERV_DETAIL,
    ID_PROFILE,
    ID_HOTEL,
    IS_DEFAULT,
    ID_SALE_NUM
from
  ACCOUNT A
  join (select max(cast(iif(R.RIGHT_CODE is not null, 1, 0) as integer)) as GRANTED_LEVEL
        from   RIGHTS_USERS RU
               left outer join USER_RIGHTS R on R.RIGHT_CODE  = 'ACCSECURLEVEL1'
        where  RU.USER_NAME = current_user
        union
        select cast(1 as integer)
        from   RDB$DATABASE
        where  not exists (select *
                           from   RIGHTS_USERS RU
                           where  RU.USER_NAME = current_user)) UR on UR.GRANTED_LEVEL >= A.SECURITY_LEVEL
;

/* Alter view (drop/create): ACCOUNT_S for view: ACCOUNT_PREVIEW */
/* Alter view (drop): ACCOUNT_S for view: ACCOUNT_PREVIEW */
DROP VIEW ACCOUNT_S;

/* Alter view (create): ACCOUNT_S for view: ACCOUNT_PREVIEW */
/* Create view: ACCOUNT_S */
CREATE VIEW ACCOUNT_S(
ID_ACCOUNT,
ACCOUNT_CURR,
ACCOUNT_NAME,
IS_CREDIT_ACCOUNT,
CREDIT_LIMIT,
ID_TYPE_PAYMENT,
NOTE,
MASK,
IS_BLOCKED,
BLOCK_TEXT,
SECURITY_LEVEL,
IS_ARCHIVE,
IS_BASE,
IS_EXTRA,
IS_ALOWED_POS_INTERFACE,
POS_INTERFACE_NOTE,
ID_RESERV_DETAIL,
ID_PROFILE,
ID_HOTEL,
IS_DEFAULT,
ID_SALE_NUM)
 AS 
select
    ID_ACCOUNT,
    ACCOUNT_CURR,
    ACCOUNT_NAME,
    IS_CREDIT_ACCOUNT,
    CREDIT_LIMIT,
    ID_TYPE_PAYMENT,
    NOTE,
    MASK,
    IS_BLOCKED,
    BLOCK_TEXT,
    SECURITY_LEVEL,
    IS_ARCHIVE,
    IS_BASE,
    IS_EXTRA,
    IS_ALOWED_POS_INTERFACE,
    POS_INTERFACE_NOTE,
    ID_RESERV_DETAIL,
    ID_PROFILE,
    ID_HOTEL,
    IS_DEFAULT,
    ID_SALE_NUM
from
  ACCOUNT A
  join (select max(cast(iif(R.RIGHT_CODE is not null, 1, 0) as integer)) as GRANTED_LEVEL
        from   RIGHTS_USERS RU
               left outer join USER_RIGHTS R on R.RIGHT_CODE  = 'ACCSECURLEVEL1'
        where  RU.USER_NAME = current_user
        union
        select cast(1 as integer)
        from   RDB$DATABASE
        where  not exists (select *
                           from   RIGHTS_USERS RU
                           where  RU.USER_NAME = current_user)) UR on UR.GRANTED_LEVEL >= A.SECURITY_LEVEL
;

/* Create view: ACCOUNT_PREVIEW */
CREATE VIEW ACCOUNT_PREVIEW(
ID_ACCOUNT,
ACCOUNT_NAME,
ID_PROFILE,
PROFILE_NAME,
PROFILE_TYPE,
ROOM_NAME,
ACCOUNT_CURR,
IS_CREDIT_ACCOUNT,
IS_BLOCKED,
IS_ARCHIVE,
ID_HOTEL,
NOTE)
 AS 
select A.ID_ACCOUNT,
       A.ACCOUNT_NAME,
       P.ID_PROFILE,
       P.PROFILE_NAME,
       P.PROFILE_TYPE,
       R.ROOM_NAME,
       A.ACCOUNT_CURR,
       A.IS_CREDIT_ACCOUNT,
       A.IS_BLOCKED,
       A.IS_ARCHIVE,
       A.ID_HOTEL,
       A.NOTE
from   ACCOUNT_S A
       join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
       left outer join RESERV_DETAIL RD ON RD.ID_RESERV_DETAIL = A.ID_RESERV_DETAIL
       left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
;

/* Create view: ACCOUNTS_OPEN */
CREATE VIEW ACCOUNTS_OPEN(
ID_ACCOUNT,
ACCOUNT_CURR,
ACCOUNT_NAME,
IS_CREDIT_ACCOUNT,
CREDIT_LIMIT,
ID_TYPE_PAYMENT,
NOTE,
MASK,
IS_BLOCKED,
BLOCK_TEXT,
SECURITY_LEVEL,
IS_ARCHIVE,
IS_BASE,
IS_EXTRA,
IS_ALOWED_POS_INTERFACE,
POS_INTERFACE_NOTE,
ID_RESERV_DETAIL,
ID_PROFILE,
ID_HOTEL)
 AS 
select
    A.ID_ACCOUNT,
    A.ACCOUNT_CURR,
    A.ACCOUNT_NAME,
    A.IS_CREDIT_ACCOUNT,
    A.CREDIT_LIMIT,
    A.ID_TYPE_PAYMENT,
    A.NOTE,
    A.MASK,
    A.IS_BLOCKED,
    A.BLOCK_TEXT,
    A.SECURITY_LEVEL,
    A.IS_ARCHIVE,
    A.IS_BASE,
    A.IS_EXTRA,
    A.IS_ALOWED_POS_INTERFACE,
    A.POS_INTERFACE_NOTE,
    A.ID_RESERV_DETAIL,
    A.ID_PROFILE,
    A.ID_HOTEL
from ACCOUNT_S A
where A.IS_ARCHIVE = 0
      and (exists (select AP.ID_ACCOUNT_POST
                   from   ACCOUNT_POST AP
                   where  AP.AC = '00'
                          and AP.ID_ACCOUNT = A.ID_ACCOUNT)
           or
           exists (select  DA.ID_DEPOSIT
                   from    DEPOSIT_AVAILABLE DA
                   where   DA.ID_ACCOUNT = A.ID_ACCOUNT))
;

/* Create view: ACTIVITY_DATES */
CREATE VIEW ACTIVITY_DATES(
ID_ACTIVITY_OFFER,
ID_ACTIVITY,
ACTIVITY_TYPE,
FROM_DATE,
TO_DATE)
 AS 
select ae.ID_ACTIVITY_OFFER,
       ae.ID_ACTIVITY_EVENT,
       cast('EVENT' as varchar(30)),
       cast(od.FROM_DATETIME as date),
       cast(od.TO_DATETIME as date)
from   ACTIVITY_EVENT ae
       join RESOURCE_RESERVATION rr on rr.ID_RESOURCE_RESERVATION = ae.ID_ACTIVITY_EVENT
       join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
union all
select fb.ID_ACTIVITY_OFFER,
       fb.ID_ACTIVITY_FB,
       cast('MEAL' as varchar(30)),
       fb.CONSUME_DATE,
       fb.CONSUME_DATE
from   ACTIVITY_FB fb
union all
select ad.ID_ACTIVITY_OFFER,
       ad.ID_ACTIVITY_ADDITION,
       cast('ADDITION' as varchar(30)),
       ad.ADDITION_DATE,
       ad.ADDITION_DATE
from   ACTIVITY_ADDITION ad
union all
select o.ID_ACTIVITY_OFFER,
       rd.ID_RESERV_DETAIL,
       cast('BOOKING' as varchar(30)),
       rd.FROM_DATE,
       rd.TO_DATE
from   RESERV_DETAIL rd
       join ACTIVITY_OFFER o on o.ID_RESERV_GROUP = rd.ID_GROUP
where  rd.IS_ANUL = 0
;

/* Create view: CHECK_STATUS_GRANTED */
CREATE VIEW CHECK_STATUS_GRANTED(
CHECK_STATUS)
 AS 
select first 1 cast(-3 as smallint) as granted_status
from   USER_RIGHTS ur
where  ur.RIGHT_CODE = 'WAITING_RESERV_PREVIEW'
union
select -2 from RDB$DATABASE
union
select -1 from RDB$DATABASE
union
select 0 from RDB$DATABASE
union
select first 1 cast(1 as smallint)
from   USER_RIGHTS ur
where  ur.RIGHT_CODE = 'CHECKEDOUT_RESERV_PREVIEW'
;

/* Create view: DEPOSIT_SECURE */
CREATE VIEW DEPOSIT_SECURE(
ID_DEPOSIT,
DESCRIPTION,
ID_PROFILE,
ID_ACCOUNT,
ID_RESERV_DETAIL,
ID_PAYMENT_HEAD,
ID_PAYMENT_TYPE,
ID_DOC_TYPE,
DOC_TYPE_NAME,
PAYMENT_NUM,
PAYMENT_DATE,
PAY_CURRENCY,
PAY_RATE,
ID_DOC_HEAD,
USER_CREATED,
DATETIME_CREATED,
DOC_SELECTED,
DEP_VALUE,
AVAIL_VALUE)
 AS 
select D.ID_DEPOSIT,
       D.DESCRIPTION,
       D.ID_PROFILE,
       D.ID_ACCOUNT,
       D.ID_RESERV_DETAIL,
       D.ID_PAYMENT_HEAD,
       D.ID_PAYMENT_TYPE,
       D.ID_DOC_TYPE,
       D.DOC_TYPE_NAME,
       D.PAYMENT_NUM,
       D.PAYMENT_DATE,
       D.PAY_CURRENCY,
       D.PAY_RATE,
       D.ID_DOC_HEAD,
       D.USER_CREATED,
       D.DATETIME_CREATED,
       D.DOC_SELECTED,
       D.RECEIVED_AMOUNT,
       d.RECEIVED_AMOUNT - d.DEDUCTED_AMOUNT
from   DEPOSITS D
       join ACCOUNT_S A on A.ID_ACCOUNT = D.ID_ACCOUNT
       join PAY_DOC_TYPE_S PDT on PDT.ID_DOC_TYPE = D.ID_DOC_TYPE
where  d.IS_ANUL = 0
       and d.RECEIVED_AMOUNT > 0
;

/* Create view: DOCUMENT_PAYMENT */
CREATE VIEW DOCUMENT_PAYMENT(
ID_HOTEL,
REALIZE_DATE,
ID_PAYMENT_HEAD,
ID_ACCOUNT,
ID_DOC_TYPE,
DOC_TYPE_NAME,
ID_DOC_NUM,
NUM,
PAYMENT_NUM,
ID_PAYMENT_TYPE,
PAYMENT_DATE,
PAY_CURRENCY,
IS_ANUL,
IS_STORNED,
IS_STORNO,
DESCRIPTION,
ID_DOC_HEAD,
ID_DOC_CONTRAGENT,
USER_CREATED,
DATETIME_CREATED,
ID_AR_PAYMENT,
DUE_DATE,
INIT_PAY_VALUE,
INIT_PAY_RATE,
INIT_PAY_DOC_RATE,
REALIZED_VALUE,
EQUAL_PAY_DOC_RATE,
EQUAL_DOC_VALUE,
NAT_VALUE,
FISC_STATUS,
ID_SALE_NUM)
 AS 
select   A.ID_HOTEL,
         DRD.RELEASE_DATE as REALIZE_DATE,
         P.ID_PAYMENT_HEAD,
         P.ID_ACCOUNT,
         P.ID_DOC_TYPE,
         P.DOC_TYPE_NAME,
         P.ID_DOC_NUM,
         P.NUM,
         P.PAYMENT_NUM,
         P.ID_PAYMENT_TYPE,
         P.PAYMENT_DATE,
         P.PAY_CURRENCY,
         iif(p.IS_ANUL = 1 and P.ANNUL_DATE = drd.RELEASE_DATE, 1, 0) as is_anul,
         P.IS_STORNED,
         P.IS_STORNO,
         P.DESCRIPTION,
         DP.ID_DOC_HEAD,
         P.ID_DOC_CONTRAGENT,
         coalesce(sl.ACTION_USER, P.USER_CREATED),
         coalesce(sl.ACTION_DATETIME, P.DATETIME_CREATED),
         P.ID_AR_PAYMENT,
         P.DUE_DATE,
         DP.PAY_AMOUNT as INIT_PAY_VALUE,
         DP.PAY_RATE as INIT_PAY_RATE,
         cast(DP.PAY_RATE / dp.DOC_RATE as double precision) as INIT_PAY_DOC_RATE,
         cast(DP.PAY_AMOUNT * drd.VALUE_CORR_INDEX as numeric(15,4)) as REALIZED_VALUE,
         DP.EQUAL_PAY_DOC_RATE,
         cast(DP.DOC_AMOUNT * drd.VALUE_CORR_INDEX as numeric(15,4)) as EQUAL_DOC_VALUE,
         cast(DP.DOC_AMOUNT * Dh.DOC_RATE * drd.VALUE_CORR_INDEX as numeric(15,4)) as NAT_VALUE,
         Dh.FISC_STATUS,
         dh.ID_SALE_NUM
  from   DOC_PAY_USAGE DP
         join DOC_HEAD dh on dh.ID_DOC = dp.ID_DOC_HEAD
         join ACCOUNT A on A.ID_ACCOUNT = dh.ID_ACCOUNT
         join ACCOUNT_PAYMENTS AP on AP.ID_ACCOUNT_PAYMENT = DP.ID_ACCOUNT_PAYMENT
         join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = ap.ID_PAYMENT_HEAD
         join DOC_RELEASE_DATE DRD on DRD.ID_DOC_HEAD = DP.ID_DOC_HEAD
         left outer join DOC_ANNULMENT DA on DA.ID_DOC_HEAD = DH.ID_DOC and da.ANNULMENT_DATE = drd.RELEASE_DATE and da.ANNULMENT_DATE > dh.DOC_DATE
         left outer join SYSTEM_LOG_EVENT SL on SL.ID_SYSTEM_LOG = DA.ID_LOG_EVENT
  where  ((P.ID_DOC_HEAD is null) or (p.ID_DOC_HEAD = dp.ID_DOC_HEAD) or (Dh.FOR_DEPOSIT = 1))
;

/* Create view: DOCUMENT_RELEASE */
CREATE VIEW DOCUMENT_RELEASE(
ID_DOC,
ID_DOC_TYPE,
ID_DOC_NUM,
ID_ACCOUNT,
ID_DOC_CONTRAGENT,
ID_DOC_SUPPLIER,
DOC_CURRENCY,
DOC_TYPE_NAME,
NUM,
DOC_NUM,
REAL_DOC_DATE,
RPT_DOC_DATE,
DOC_RATE,
DOC_VALUE,
DOC_VALUE_A,
IS_ANNUL_FLAG,
IS_ANNUL_ON_DATE,
VALUE_CORR_IDX,
IS_STORNO,
IS_STORNED,
DESCRIPTION,
USER_CREATED,
DATETIME_CREATED,
DOC_ACC_RATE,
ID_BASE_DOC,
FOR_DEPOSIT,
TAX_EVENT_DATE,
DIFF_VAT_REASON,
FISC_STATUS,
ANNULMENT_DATE,
ANNUL_PROT_NUM,
ANNUL_PROT_DOC_NUM,
ANNUL_USER,
ANNUL_DATETIME)
 AS 
select DH.ID_DOC,
       DH.ID_DOC_TYPE,
       DH.ID_DOC_NUM,
       DH.ID_ACCOUNT,
       DH.ID_DOC_CONTRAGENT,
       DH.ID_DOC_SUPPLIER,
       DH.DOC_CURRENCY,
       DH.DOC_TYPE_NAME,
       DH.NUM,
       DH.DOC_NUM,
       DH.DOC_DATE as REAL_DOC_DATE,
       RD.RELEASE_DATE as RPT_DOC_DATE,
       DH.DOC_RATE,
       DH.DOC_VALUE,
       DH.DOC_VALUE_A,
       DH.IS_ANUL as IS_ANNUL_FLAG,
       iif(DA.ANNULMENT_DATE is not distinct from DH.DOC_DATE, DH.IS_ANUL, 0) as IS_ANNUL_ON_DATE,
       RD.VALUE_CORR_INDEX as VALUE_CORR_IDX,
       DH.IS_STORNO,
       DH.IS_STORNED,
       DH.DESCRIPTION,
       DH.USER_CREATED,
       DH.DATETIME_CREATED,
       DH.DOC_ACC_RATE,
       DH.ID_BASE_DOC,
       DH.FOR_DEPOSIT,
       DH.TAX_EVENT_DATE,
       DH.DIFF_VAT_REASON,
       DH.FISC_STATUS,
       DA.ANNULMENT_DATE,
       DA.PROT_NUM as ANNUL_PROT_NUM,
       DA.PROT_DOC_NUM as ANNUL_PROT_DOC_NUM,
       SL.ACTION_USER as ANNUL_USER,
       SL.ACTION_DATETIME as ANNUL_DATETIME
from DOC_HEAD DH
     join DOC_RELEASE_DATE RD on rd.ID_DOC_HEAD = dh.ID_DOC
     left outer join DOC_ANNULMENT DA on DA.ID_DOC_HEAD = DH.ID_DOC
     left outer join SYSTEM_LOG_EVENT SL on SL.ID_SYSTEM_LOG = DA.ID_LOG_EVENT
;

/* Create view: PAY_DOC_TYPE_NA */
CREATE VIEW PAY_DOC_TYPE_NA(
ID_DOC_TYPE)
 AS 
select DTP.ID_DOC_TYPE
from   DOC_TYPE_PAY DTP
where  DTP.RIGHT_CODE is not null
       and DTP.RIGHT_CODE not in
           (select distinct R.RIGHT_CODE
            from   USER_RIGHTS R
            where  R.RIGHT_CODE starting with 'DOC_PAY_GROUP_')
;

/* Create view: DOCUMENT_S */
CREATE VIEW DOCUMENT_S(
ID_DOC,
ID_BASE_DOC,
ID_DOC_TYPE,
DOC_SUB_TYPE,
DOC_TYPE_NAME,
ID_DOC_NUM,
NUM,
DOC_NUM,
ID_ACCOUNT,
ID_DOC_CONTRAGENT,
ID_DOC_SUPPLIER,
DOC_DATE,
FOR_DEPOSIT,
IS_STORNED,
IS_ANUL,
IS_STORNO,
FISC_STATUS,
DOC_CURRENCY,
DOC_VALUE,
DOC_VALUE_A,
DOC_RATE,
DOC_ACC_RATE,
TAX_EVENT_DATE,
DESCRIPTION,
USER_CREATED,
DATETIME_CREATED,
SELECTION_ID,
ONE_LINE_TEXT,
DIFF_VAT_REASON,
TAXABLE_VALUE,
IS_EFAKTURA_EXPORTED)
 AS 
select ID_DOC,
       ID_BASE_DOC,
       ID_DOC_TYPE,
       DOC_SUB_TYPE,
       DOC_TYPE_NAME,
       ID_DOC_NUM,
       NUM,
       DOC_NUM,
       ID_ACCOUNT,
       ID_DOC_CONTRAGENT,
       ID_DOC_SUPPLIER,
       DOC_DATE,
       FOR_DEPOSIT,
       IS_STORNED,
       IS_ANUL,
       IS_STORNO,
       FISC_STATUS,
       DOC_CURRENCY,
       DOC_VALUE,
       DOC_VALUE_A,
       DOC_RATE,
       DOC_ACC_RATE,
       TAX_EVENT_DATE,
       DESCRIPTION,
       USER_CREATED,
       DATETIME_CREATED,
       SELECTION_ID,
       ONE_LINE_TEXT,
       DIFF_VAT_REASON,
       TAXABLE_VALUE,
       IS_EFAKTURA_EXPORTED
from   DOC_HEAD D
where  not exists (select AP.ID_PAYMENT_HEAD
                   from   DOC_PAY_USAGE DP
                          join ACCOUNT_PAYMENTS AP on AP.ID_ACCOUNT_PAYMENT = dp.ID_ACCOUNT_PAYMENT
                          join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = ap.ID_PAYMENT_HEAD
                          join PAY_DOC_TYPE_NA DNA on DNA.ID_DOC_TYPE = P.ID_DOC_TYPE
                   where  DP.ID_DOC_HEAD = D.ID_DOC)
;

/* Create view: DOCUMENT_RELEASE_S */
CREATE VIEW DOCUMENT_RELEASE_S(
ID_DOC,
ID_DOC_TYPE,
ID_DOC_NUM,
ID_ACCOUNT,
ID_DOC_CONTRAGENT,
ID_DOC_SUPPLIER,
DOC_CURRENCY,
DOC_TYPE_NAME,
NUM,
DOC_NUM,
REAL_DOC_DATE,
RPT_DOC_DATE,
DOC_RATE,
DOC_VALUE,
DOC_VALUE_A,
IS_ANNUL_FLAG,
IS_ANNUL_ON_DATE,
VALUE_CORR_IDX,
IS_STORNO,
IS_STORNED,
DESCRIPTION,
USER_CREATED,
DATETIME_CREATED,
DOC_ACC_RATE,
ID_BASE_DOC,
FOR_DEPOSIT,
TAX_EVENT_DATE,
DIFF_VAT_REASON,
FISC_STATUS,
ANNULMENT_DATE,
ANNUL_PROT_NUM,
ANNUL_PROT_DOC_NUM,
ANNUL_USER,
ANNUL_DATETIME)
 AS 
select DH.ID_DOC,
       DH.ID_DOC_TYPE,
       DH.ID_DOC_NUM,
       DH.ID_ACCOUNT,
       DH.ID_DOC_CONTRAGENT,
       DH.ID_DOC_SUPPLIER,
       DH.DOC_CURRENCY,
       DH.DOC_TYPE_NAME,
       DH.NUM,
       DH.DOC_NUM,
       DH.DOC_DATE as REAL_DOC_DATE,
       RD.RELEASE_DATE as RPT_DOC_DATE,
       DH.DOC_RATE,
       DH.DOC_VALUE,
       DH.DOC_VALUE_A,
       DH.IS_ANUL as IS_ANNUL_FLAG,
       iif(DA.ANNULMENT_DATE is not distinct from DH.DOC_DATE, DH.IS_ANUL, 0) as IS_ANNUL_ON_DATE,
       RD.VALUE_CORR_INDEX as VALUE_CORR_IDX,
       DH.IS_STORNO,
       DH.IS_STORNED,
       DH.DESCRIPTION,
       DH.USER_CREATED,
       DH.DATETIME_CREATED,
       DH.DOC_ACC_RATE,
       DH.ID_BASE_DOC,
       DH.FOR_DEPOSIT,
       DH.TAX_EVENT_DATE,
       DH.DIFF_VAT_REASON,
       DH.FISC_STATUS,
       DA.ANNULMENT_DATE,
       DA.PROT_NUM as ANNUL_PROT_NUM,
       DA.PROT_DOC_NUM as ANNUL_PROT_DOC_NUM,
       SL.ACTION_USER as ANNUL_USER,
       SL.ACTION_DATETIME as ANNUL_DATETIME
from DOCUMENT_S DH
     join DOC_RELEASE_DATE RD on rd.ID_DOC_HEAD = dh.ID_DOC
     left outer join DOC_ANNULMENT DA on DA.ID_DOC_HEAD = DH.ID_DOC
     left outer join SYSTEM_LOG_EVENT SL on SL.ID_SYSTEM_LOG = DA.ID_LOG_EVENT
;

/* Create view: DOCUMENT_REVENUE */
CREATE VIEW DOCUMENT_REVENUE(
ID_ACCOUNT_POST,
ID_ACCOUNT,
ID_SERVICE,
ID_GUEST,
ID_HOTEL,
ID_SALE_TAXATION,
DATE_POST,
DOC_DATE,
ACC_CURR,
POST_TYPE,
QTY_POST,
ACC_POST_AMOUNT,
NET_VALUE,
GROSS_VALUE)
 AS 
select   PV.ID_ACCOUNT_POST, A.ID_ACCOUNT, DL.ID_SERVICE, DL.ID_GUEST, A.ID_HOTEL,
         DL.ID_SALE_TAXATION, DL.DATE_POST, Drd.RELEASE_DATE, A.ACCOUNT_CURR,
         cast(case when PV.IS_BASE = 1 then 'BASE'
                   when PV.IS_BASE = 0 and PV.ID_MASTER_ADDINS > 0 then 'ADD_INS'
                   else 'EXTRA'
              end as varchar(10)) as POST_TYPE,
         cast(sum(DL.QTY_POST) as numeric(15,2)),
         cast(0 as double precision),
         cast(sum((PV.NET_RATE_DIFF + PV.NET_ROUND_DIFF) * Drd.VALUE_CORR_INDEX) as numeric(15,4)),
         cast(sum((PV.GROSS_RATE_DIFF + PV.GROSS_ROUND_DIFF) * Drd.VALUE_CORR_INDEX) as numeric(15,4))
  from   DOC_HEAD DH
         join DOC_RELEASE_DATE drd on drd.ID_DOC_HEAD = dh.ID_DOC and drd.VALUE_CORR_INDEX <> 0
         join ACCOUNT A on A.ID_ACCOUNT = DH.ID_ACCOUNT
         join DOC_LINE DL on DL.ID_DOC_HEAD = DH.ID_DOC
         join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
                                         and ((PV.NET_RATE_DIFF <> 0)
                                              or (PV.NET_ROUND_DIFF) <> 0
                                              or (PV.GROSS_RATE_DIFF <> 0)
                                              or (PV.GROSS_ROUND_DIFF <> 0))
         left join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = PV.ID_ACCOUNT_POST
         join END_WORKS EW on EW.ID_END_WORK = AP.ID_END_WORK and EW.PREV_DATE <= Drd.RELEASE_DATE
  group by 1, 2, 3, 4, 5, 6, 7, 8, 9, 10
  union all
  /* taxes */
  select cast(null as integer), A.ID_ACCOUNT, DL.ID_SERVICE, DL.ID_GUEST, A.ID_HOTEL,
         DL.ID_SALE_TAXATION, DL.DATE_POST, Drd.RELEASE_DATE, A.ACCOUNT_CURR, cast('TAX' as varchar(10)),
         cast(sum(DL.QTY_POST) as numeric(15,2)),
         cast(sum(DL.SINGLE_VALUE * DL.QTY_POST * DH.DOC_ACC_RATE * Drd.VALUE_CORR_INDEX) as double precision),
         sum(DL.NAT_NET_VALUE * Drd.VALUE_CORR_INDEX),
         sum(DL.NAT_GROSS_VALUE * Drd.VALUE_CORR_INDEX)
  from   DOC_HEAD DH
         join ACCOUNT A on A.ID_ACCOUNT = DH.ID_ACCOUNT
         join DOC_RELEASE_DATE drd on drd.ID_DOC_HEAD = dh.ID_DOC and drd.VALUE_CORR_INDEX <> 0
         join DOC_FOOTER DF on DF.ID_DOC_HEAD = DH.ID_DOC
         join DOC_LINE DL on DL.ID_DOC_LINE = DF.ID_DOC_LINE
  group by 1, 2, 3, 4, 5, 6, 7, 8, 9, 10
;

/* Create view: ENA_ACCOUNT_POST_HISTORY */
CREATE VIEW ENA_ACCOUNT_POST_HISTORY(
ID_HOTEL,
ID_ACCOUNT_POST_HISTORY,
ID_ACCOUNT,
ID_SERVICE,
ID_SALE_TAXATION,
SYSTEM_DATE,
POST_DATE,
POST_CURR,
POST_AMOUNT,
NAT_NET_VALUE,
NAT_GROSS_VALUE,
POST_TYPE,
ID_GUEST,
REVENUE_GROUP,
REVENUE_ACCOUNT,
REVENUE_SUB_ACCOUNT,
TAXATION_NAME,
TAXATION_ACCOUNT_NAME)
 AS 
select AD.ID_HOTEL,
       AD.ID_ACCOUNT_DEBT,
       AD.ID_ACCOUNT,
       AD.ID_SERVICE,
       AD.ID_SALE_TAXATION,
       AD.DEBT_DATE,
       AD.POST_DATE,
       AD.POST_CURR,
       AD.POST_AMOUNT,
       AD.NAT_NET_VALUE,
       AD.NAT_GROSS_VALUE,
       AD.POST_TYPE,
       AD.ID_GUEST,
       AD.REVENUE_GROUP,
       AD.REVENUE_ACCOUNT,
       AD.REVENUE_SUB_ACCOUNT,
       ST.NAME,
       ST.ACCOUNT_NAME
from   ACCOUNT_DEBT ad
       join SALE_TAXATION st on st.ID_SALE_TAXATION = ad.ID_SALE_TAXATION
;

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_HOTEL IS
'       .  ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT_POST_HISTORY IS
'   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT IS
'      .  ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.SYSTEM_DATE IS
'    / . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_DATE IS
'        (). .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_CURR IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_AMOUNT IS
'    (   )    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_NET_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_GROSS_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_TYPE IS
'  . BASE -  ; ADD_INS -  - ,    ; EXTRA -     ,     ; TAX -            ,     .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_GUEST IS
'       .  ENA_GUEST.ID_GUEST.        : 1.    "  "; 2.           ; 3.        ,      . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_GROUP IS
'       .    : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_ACCOUNT IS
' -      .    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_SUB_ACCOUNT IS
' --      . ,     -. .';

/* Create view: ENA_DEPOSIT */
CREATE VIEW ENA_DEPOSIT(
ID_HOTEL,
ID_DEPOSIT_PAYMENT,
PAYMENT_DATE,
SYSTEM_DATE,
PAYMENT_NUM,
DOC_DIRECTION,
DOC_TYPE_NAME,
DESCRIPTION,
ID_ACCOUNT,
PAY_AMOUNT,
PAY_CURRENCY,
IS_ANUL,
USER_CREATED,
DATETIME_CREATED,
USER_ANNUL,
DATETIME_ANNUL,
EXPORT_TAG)
 AS 
select a.ID_HOTEL,
       p.ID_PAYMENT_HEAD,
       p.PAYMENT_DATE,
       ap.TRANSACTION_DATE,
       p.PAYMENT_NUM,
       dtp.DOC_DIRECTION,
       p.DOC_TYPE_NAME,
       D.DESCRIPTION,
       a.ID_ACCOUNT,
       iif(ap.IS_INITIAL_PAYMENT = 1, ap.PAY_AMOUNT, -ap.PAY_AMOUNT),
       P.PAY_CURRENCY,
       iif(ap.IS_INITIAL_PAYMENT = 1, 0, p.IS_ANUL) as IS_ANUL,
       P.USER_CREATED as USER_CREATED,
       P.DATETIME_CREATED as DATETIME_CREATED,
       SL.ACTION_USER as USER_ANNUL,
       SL.ACTION_DATETIME as DATETIME_ANNUL,
       iif(p.IS_STORNO = 0, dt.EXPORT_TAG, dtp.STORNO_EXPORT_TAG)
from   ACCOUNT_PAYMENTS AP
       join DEPOSIT D on D.ID_DEPOSIT = AP.ID_DEPOSIT
       join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
       join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = aP.ID_PAYMENT_HEAD and p.ID_DOC_HEAD is null
       join DOC_TYPE dt on dt.ID_DOC_TYPE = p.ID_DOC_TYPE
       join DOC_TYPE_PAY dtp on dtp.ID_DOC_TYPE = dt.ID_DOC_TYPE
       left outer join SYSTEM_LOG_EVENT SL on SL.ID_SYSTEM_LOG = P.ID_LOG_EVENT_ANNUL and ap.IS_INITIAL_PAYMENT is distinct from 1
where  not exists (select tr.ID_ACCOUNT_PAYMENT_SOURCE
                   from   ACCOUNT_PAYMENT_TRANSFER tr
                   where  (tr.ID_ACCOUNT_PAYMENT_SOURCE = ap.ID_ACCOUNT_PAYMENT)
                          or (tr.ID_ACCOUNT_PAYMENT_DEST = ap.ID_ACCOUNT_PAYMENT))
;

COMMENT ON COLUMN ENA_DEPOSIT.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_DEPOSIT_PAYMENT IS
'  .         . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_DATE IS
'        .            . .';

COMMENT ON COLUMN ENA_DEPOSIT.SYSTEM_DATE IS
'   .         PAYMENT_DATE.        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_NUM IS
'           .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_DIRECTION IS
'0 -   , 1 -   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_TYPE_NAME IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_ACCOUNT IS
'        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_AMOUNT IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DEPOSIT.IS_ANUL IS
'   . 0 - , 1 - .           /    .     IS_ANUL = 0,    1.           ID_DEPOSIT.  .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_CREATED IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_CREATED IS
'       . .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_ANNUL IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_ANNUL IS
'     .  .';

/* Create view: ENA_DOC_DEPOSIT_CONSUMPTION */
CREATE VIEW ENA_DOC_DEPOSIT_CONSUMPTION(
ID_DOC_HEAD,
ID_DOC_TYPE,
DOC_TYPE_NAME,
PAYMENT_NUM,
PAYMENT_TYPE,
PAYMENT_DATE,
PAY_CURRENCY,
DESCRIPTION,
PAY_VALUE,
PAY_RATE,
PAY_DOC_RATE,
EQUAL_DOC_VALUE,
NAT_VALUE,
ID_DEPOSIT_PAYMENT,
EXPORT_TAG)
 AS 
select
   DP.ID_DOC_HEAD,
   p.ID_DOC_TYPE,
   P.DOC_TYPE_NAME,
   P.PAYMENT_NUM,
   PT.PAYMENT_TYPE,
   P.PAYMENT_DATE,
   P.PAY_CURRENCY,
   P.DESCRIPTION,
   DP.PAY_AMOUNT as INIT_PAY_VALUE,
   DP.PAY_RATE as INIT_PAY_RATE,
   cast(DP.PAY_RATE / dp.DOC_RATE as double precision) as PAY_DOC_RATE,
   cast(DP.DOC_AMOUNT as numeric(15,4)) as EQUAL_DOC_VALUE,
   cast(DP.DOC_AMOUNT * Dh.DOC_RATE as numeric(15,4)) as NAT_VALUE,
   p.ID_PAYMENT_HEAD,
   iif(p.IS_STORNO = 0, dt.EXPORT_TAG, dtp.STORNO_EXPORT_TAG)
from
   DOC_PAY_USAGE DP
   join DOC_HEAD dh on dh.ID_DOC = dp.ID_DOC_HEAD
   join ACCOUNT A on A.ID_ACCOUNT = dh.ID_ACCOUNT
   join ACCOUNT_PAYMENTS AP on AP.ID_ACCOUNT_PAYMENT = DP.ID_ACCOUNT_PAYMENT
   join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = ap.ID_PAYMENT_HEAD
   join PAYMENT_TYPE pt on pt.ID_PAYMENT_TYPE = p.ID_PAYMENT_TYPE
   join DOC_TYPE dt on dt.ID_DOC_TYPE = p.ID_DOC_TYPE
   join DOC_TYPE_PAY dtp on dtp.ID_DOC_TYPE = dt.ID_DOC_TYPE
where P.ID_DOC_HEAD is null
;

COMMENT ON VIEW ENA_DOC_DEPOSIT_CONSUMPTION IS
' !!!!!!    ID_DOC_TYPE - za mapowe.';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DOC_TYPE_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_NUM IS
'         .  .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_DATE IS
'      .          . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_VALUE IS
'         . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.EQUAL_DOC_VALUE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.NAT_VALUE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DEPOSIT_PAYMENT IS
'      (  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT ). .';

/* Create view: ENA_DOC_HEAD_ADVANCE */
CREATE VIEW ENA_DOC_HEAD_ADVANCE(
ID_HOTEL,
ID_DOC,
ID_BASE_DOC,
ID_DOC_TYPE,
DOC_SUB_TYPE,
DOC_TYPE_NAME,
DOC_TYPE_EXPORT_TAG,
DOC_TYPE_DESCRIPTION,
DOC_NUM,
DOC_DATE,
SYSTEM_DATE,
IS_ANUL,
DOC_FISC_STATUS,
DOC_CURRENCY,
DOC_TOTAL_VALUE,
DOC_RATE,
DOC_ACC_RATE,
TAX_EVENT_DATE,
DOC_DESCRIPTION,
ONE_LINE_TEXT,
DIFF_VAT_REASON,
DOC_SECOND_CURRENCY,
DOC_SECOND_CURR_RATE,
CLIENT_IS_LEGAL_ENTITY,
CLIENT_NAME,
CLIENT_IDENT_NO,
CLIENT_TAX_REG_NUM,
CLIENT_COUNTRY_CODE,
CLIENT_POST_ADDRESS,
CLIENT_ZIP_CODE,
CLIENT_MOL,
CLIENT_RECIPIENT_NAME,
CLIENT_BANK_NAME,
CLIENT_BIC,
CLIENT_IBAN,
CLIENT_EMAIL,
SUPPLIER_SEND_NAME,
ACCOUNT_ID,
ANNUL_PROT_NUM,
DOC_NET_VALUE,
DOC_SECOND_CURR_NET_VALUE,
DOC_SECOND_CURR_GROSS_VALUE)
 AS 
select
       A.ID_HOTEL,
       dh.ID_DOC_HEAD,
       dh.ID_BASE_DOC,
       dh.ID_DOC_TYPE,
       dh.DOC_SUB_TYPE,
       dh.DOC_TYPE_NAME,
       case
         when dh.DOC_SUB_TYPE = 0 then dt.EXPORT_TAG
         when dh.DOC_SUB_TYPE = 1 then dti.DEBIT_EXPORT_TAG
         when dh.DOC_SUB_TYPE = 2 then dti.CREDIT_EXPORT_TAG
       end as EXPORT_TAG,
       dt.DESCRIPTION,
       dh.DOC_NUM,
       dh.DOC_DATE,
       rd.RELEASE_DATE,
       iif((RD.VALUE_CORR_INDEX = -1) or (m.TAG = 1), 1, 0),
       dc.FISC_STATUS,
       dh.DOC_CURRENCY,
       dh.DOC_VALUE_A,
       dh.DOC_RATE,
       dh.DOC_ACC_RATE,
       dc.TAX_EVENT_DATE,
       dh.DESCRIPTION,
       dh.ONE_LINE_TEXT,
       dh.DIFF_VAT_REASON,
       dh.SECOND_CURRENCY,
       dh.SECOND_CURR_RATE,
       c.IS_JURIDICAL_PERSON,
       c.CONTRAGENT_NAME,
       c.IDENT_NO,
       c.VAT_REG_NUM,
       c.COUNTRY_CODE,
       c.POST_ADDRESS,
       c.ZIP_CODE,
       c.MOL,
       c.RECIPIENT_NAME,
       c.BANK_NAME,
       c.BIC,
       c.IBAN,
       c.EMAIL,
       ds.SEND_NAME,
       a.ID_ACCOUNT,
       da.PROT_DOC_NUM,
       dh.DOC_NET_VALUE,
       dh.SECOND_CURR_NET_VALUE,
       dh.SECOND_CURR_GROSS_VALUE
from DOC_HEAD$INT dh
     join DOC_COMPLETION dc on dc.ID_DOC_HEAD = dh.ID_DOC_HEAD
     join DOC_RELEASE_DATE rd on rd.ID_DOC_HEAD = dh.ID_DOC_HEAD
     join ACCOUNT a on a.ID_ACCOUNT = dh.ID_ACCOUNT
     join DOC_TYPE dt on dt.ID_DOC_TYPE = dh.ID_DOC_TYPE
     join DOC_TYPE_INV dti on dti.ID_DOC_TYPE = dh.ID_DOC_TYPE
     join DOC_SUPPLIER ds on ds.ID_DOC_SUPPLIER = dh.ID_DOC_SUPPLIER
     join DOC_CONTRAGENT c on c.ID_DOC_CONTRAGENT = dh.ID_DOC_CONTRAGENT
     left outer join RECORD_MULTIPLIER m on 0 = rd.VALUE_CORR_INDEX
     left outer join DOC_ANNULMENT da on da.ID_DOC_HEAD = dh.ID_DOC_HEAD
                                         and ((RD.VALUE_CORR_INDEX = -1) or (m.TAG = 1))
where dh.FOR_DEPOSIT = 1
;

COMMENT ON VIEW ENA_DOC_HEAD_ADVANCE IS
'!      ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC IS
'  .             .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_ADVANCE.ID_DOC.  .     - , ..       ,      - .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SUB_TYPE IS
'   . ,  : 0 - / , 1 -  ,  , 2 -  ,  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_NAME IS
'    . ,       .              .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_DESCRIPTION IS
'   .         .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_NUM IS
'   ,        .      . ,     ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DATE IS
'        . .    SYSTEM_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.IS_ANUL IS
'        . . 0 - , 1 - .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TOTAL_VALUE IS
' (, )       . .      .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ONE_LINE_TEXT IS
' ,         .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURR_RATE IS
'   ()    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_POST_ADDRESS IS
'    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_ZIP_CODE IS
'     ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_MOL IS
'    ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_RECIPIENT_NAME IS
'     ()';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BANK_NAME IS
'  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BIC IS
'BIC  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IBAN IS
'IBAN  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_EMAIL IS
'email  .        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SUPPLIER_SEND_NAME IS
'     .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ACCOUNT_ID IS
'        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

/* Create view: ENA_DOC_HEAD_SERVICE */
CREATE VIEW ENA_DOC_HEAD_SERVICE(
ID_HOTEL,
ID_DOC,
ID_BASE_DOC,
ID_DOC_TYPE,
DOC_SUB_TYPE,
DOC_TYPE_NAME,
DOC_TYPE_EXPORT_TAG,
DOC_TYPE_DESCRIPTION,
DOC_NUM,
DOC_DATE,
SYSTEM_DATE,
IS_ANUL,
DOC_FISC_STATUS,
DOC_CURRENCY,
DOC_TOTAL_VALUE,
DOC_RATE,
DOC_ACC_RATE,
TAX_EVENT_DATE,
DOC_DESCRIPTION,
ONE_LINE_TEXT,
DIFF_VAT_REASON,
DOC_SECOND_CURRENCY,
DOC_SECOND_CURR_RATE,
DOC_PROFORMA_DATE,
DOC_PROFORMA_NUM,
CLIENT_IS_LEGAL_ENTITY,
CLIENT_NAME,
CLIENT_IDENT_NO,
CLIENT_TAX_REG_NUM,
CLIENT_COUNTRY_CODE,
CLIENT_POST_ADDRESS,
CLIENT_ZIP_CODE,
CLIENT_MOL,
CLIENT_RECIPIENT_NAME,
CLIENT_BANK_NAME,
CLIENT_BIC,
CLIENT_IBAN,
CLIENT_EMAIL,
SUPPLIER_SEND_NAME,
ACCOUNT_ID,
ANNUL_PROT_NUM,
DOC_NET_VALUE,
DOC_SECOND_CURR_NET_VALUE,
DOC_SECOND_CURR_GROSS_VALUE)
 AS 
select
       A.ID_HOTEL,
       dh.ID_DOC_HEAD,
       dh.ID_BASE_DOC,
       dh.ID_DOC_TYPE,
       dh.DOC_SUB_TYPE,
       dh.DOC_TYPE_NAME,
       case
         when dh.DOC_SUB_TYPE = 0 then dt.EXPORT_TAG
         when dh.DOC_SUB_TYPE = 1 then dti.DEBIT_EXPORT_TAG
         when dh.DOC_SUB_TYPE = 2 then dti.CREDIT_EXPORT_TAG
       end as EXPORT_TAG,
       dt.DESCRIPTION,
       dh.DOC_NUM,
       dh.DOC_DATE,
       rd.RELEASE_DATE,
       iif((RD.VALUE_CORR_INDEX = -1) or (m.TAG = 1), 1, 0),
       dc.FISC_STATUS,
       dh.DOC_CURRENCY,
       dh.DOC_VALUE_A,
       dh.DOC_RATE,
       dh.DOC_ACC_RATE,
       dc.TAX_EVENT_DATE,
       dh.DESCRIPTION,
       dh.ONE_LINE_TEXT,
       dh.DIFF_VAT_REASON,
       dh.SECOND_CURRENCY,
       dh.SECOND_CURR_RATE,
       di.DOC_DATE,
       di.DOC_NUM,
       c.IS_JURIDICAL_PERSON,
       c.CONTRAGENT_NAME,
       c.IDENT_NO,
       c.VAT_REG_NUM,
       c.COUNTRY_CODE,
       c.POST_ADDRESS,
       c.ZIP_CODE,
       c.MOL,
       c.RECIPIENT_NAME,
       c.BANK_NAME,
       c.BIC,
       c.IBAN,
       c.EMAIL,
       ds.SEND_NAME,
       a.ID_ACCOUNT,
       da.PROT_DOC_NUM,
       dh.DOC_NET_VALUE,
       dh.SECOND_CURR_NET_VALUE,
       dh.SECOND_CURR_GROSS_VALUE
from DOC_HEAD$INT dh
     join DOC_COMPLETION dc on dc.ID_DOC_HEAD = dh.ID_DOC_HEAD
     join DOC_RELEASE_DATE rd on rd.ID_DOC_HEAD = dh.ID_DOC_HEAD
     join ACCOUNT a on a.ID_ACCOUNT = dh.ID_ACCOUNT
     join DOC_TYPE dt on dt.ID_DOC_TYPE = dh.ID_DOC_TYPE
     join DOC_TYPE_INV dti on dti.ID_DOC_TYPE = dt.ID_DOC_TYPE
     join DOC_SUPPLIER ds on ds.ID_DOC_SUPPLIER = dh.ID_DOC_SUPPLIER
     join DOC_CONTRAGENT c on c.ID_DOC_CONTRAGENT = dh.ID_DOC_CONTRAGENT
     left outer join RECORD_MULTIPLIER m on 0 = rd.VALUE_CORR_INDEX
     left outer join DOC_HEAD$INT di on di.ID_DOC_HEAD = dc.ID_DOC_PROFORMA
     left outer join DOC_ANNULMENT da on da.ID_DOC_HEAD = dh.ID_DOC_HEAD
                                         and ((RD.VALUE_CORR_INDEX = -1) or (m.TAG = 1))
where dh.FOR_DEPOSIT = 0
;

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC IS
'  .             .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_SERVICE.ID_DOC.     - , ..       ,      - .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC_TYPE IS
'    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SUB_TYPE IS
'   .  : 0 - / , 1 -  ,  , 2 -  ,  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_NAME IS
'    .              .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_DESCRIPTION IS
'   .         .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_NUM IS
'   ,        .      .  -       ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DATE IS
'        .    SYSTEM_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.IS_ANUL IS
'        . 0 - , 1 - .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_CURRENCY IS
'  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TOTAL_VALUE IS
' (, )       .      .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ONE_LINE_TEXT IS
' ,         .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURR_RATE IS
'   ()    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_DATE IS
'   ,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_NUM IS
'  -,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_POST_ADDRESS IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_ZIP_CODE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_MOL IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_RECIPIENT_NAME IS
'     (). .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BANK_NAME IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BIC IS
'BIC  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IBAN IS
'IBAN  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_EMAIL IS
'email  .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SUPPLIER_SEND_NAME IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ACCOUNT_ID IS
'        .    ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

/* Create view: ENA_DOC_LINE_ADVANCE */
CREATE VIEW ENA_DOC_LINE_ADVANCE(
ID_DOC_HEAD,
ID_SERVICE,
ID_SALE_TAXATION,
TAXATION_NAME,
TAXATION_ACCOUNT_NAME,
VAT_PERCENT,
QTY_POST,
SINGLE_VALUE,
SINGLE_WOT_VAT,
WOT_VAT,
LINE_NAME,
DATE_POST,
NAT_NET_VALUE,
NAT_GROSS_VALUE,
SEC_CURR_NET_VALUE,
SEC_CURR_GROSS_VALUE,
ID_DOC_ADVANCE_REFERENCE)
 AS 
select
    dl.ID_DOC_HEAD,
    dl.ID_SERVICE,
    dl.ID_SALE_TAXATION,
    st.NAME,
    st.ACCOUNT_NAME,
    dl.VAT_PERCENT,
    dl.QTY_POST,
    dl.SINGLE_VALUE,
    dl.SINGLE_WOT_VAT,
    dl.WOT_VAT,
    dl.LINE_NAME,
    dl.DATE_POST,
    dl.NAT_NET_VALUE,
    dl.NAT_GROSS_VALUE,
    dl.SEC_CURR_NET_VALUE,
    dl.SEC_CURR_GROSS_VALUE,
    (select p.ID_DOC_HEAD
     from   DEPOSIT d
            join PAYMENT_HEAD p on p.ID_PAYMENT_HEAD = d.ID_PAYMENT_HEAD and p.ID_DOC_HEAD is distinct from dh.ID_DOC
     where  d.ID_DEPOSIT = dv.ID_DEPOSIT
            and dh.FOR_DEPOSIT = 0)
from DOC_LINE dl
     join DOC_HEAD dh on dh.ID_DOC = dl.ID_DOC_HEAD
     join SALE_TAXATION st on st.ID_SALE_TAXATION = dl.ID_SALE_TAXATION
     join ACCOUNT A on a.ID_ACCOUNT = dh.ID_ACCOUNT
     join DOC_LINE_DEP_VALUES dv on dv.ID_DOC_LINE = dl.ID_DOC_LINE
;

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SERVICE IS
'     .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.DATE_POST IS
'    . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

/* Create view: ENA_DOC_LINE_AGENT_DISCOUNT */
CREATE VIEW ENA_DOC_LINE_AGENT_DISCOUNT(
ID_DOC_HEAD,
ID_SERVICE,
ID_SALE_TAXATION,
TAXATION_NAME,
TAXATION_ACCOUNT_NAME,
VAT_PERCENT,
QTY_POST,
SINGLE_VALUE,
SINGLE_WOT_VAT,
WOT_VAT,
LINE_NAME,
NAT_NET_VALUE,
NAT_GROSS_VALUE,
SEC_CURR_NET_VALUE,
SEC_CURR_GROSS_VALUE)
 AS 
select
    dl.ID_DOC_HEAD,
    dl.ID_SERVICE,
    dl.ID_SALE_TAXATION,
    st.NAME,
    st.ACCOUNT_NAME,
    dl.VAT_PERCENT,
    dl.QTY_POST,
    dl.SINGLE_VALUE,
    dl.SINGLE_WOT_VAT,
    dl.WOT_VAT,
    dl.LINE_NAME,
    dl.NAT_NET_VALUE,
    dl.NAT_GROSS_VALUE,
    dl.SEC_CURR_NET_VALUE,
    dl.SEC_CURR_GROSS_VALUE
from DOC_LINE dl
     join DOC_FOOTER DF on df.ID_DOC_LINE = dl.ID_DOC_LINE
     join DOC_HEAD dh on dh.ID_DOC = dl.ID_DOC_HEAD
     join SALE_TAXATION st on st.ID_SALE_TAXATION = dl.ID_SALE_TAXATION
     join ACCOUNT A on a.ID_ACCOUNT = dh.ID_ACCOUNT
;

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SERVICE IS
'      .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

/* Create view: ENA_DOC_LINE_SERVICE */
CREATE VIEW ENA_DOC_LINE_SERVICE(
ID_DOC_HEAD,
ID_SERVICE,
ID_SALE_TAXATION,
TAXATION_NAME,
TAXATION_ACCOUNT_NAME,
VAT_PERCENT,
QTY_POST,
SINGLE_VALUE,
SINGLE_WOT_VAT,
WOT_VAT,
IS_CORRECT,
LINE_NAME,
ID_GUEST,
DATE_POST,
ROOM_NAME,
NAT_NET_VALUE,
NAT_GROSS_VALUE,
SEC_CURR_NET_VALUE,
SEC_CURR_GROSS_VALUE,
ACCOUNT_PRICE)
 AS 
select
    dl.ID_DOC_HEAD,
    dl.ID_SERVICE,
    dl.ID_SALE_TAXATION,
    st.NAME,
    st.ACCOUNT_NAME,
    dl.VAT_PERCENT,
    dl.QTY_POST,
    dl.SINGLE_VALUE,
    dl.SINGLE_WOT_VAT,
    dl.WOT_VAT,
    dl.IS_CORRECT,
    dl.LINE_NAME,
    dl.ID_GUEST,
    dl.DATE_POST,
    dl.ROOM_NAME,
    dl.NAT_NET_VALUE,
    dl.NAT_GROSS_VALUE,
    dl.SEC_CURR_NET_VALUE,
    dl.SEC_CURR_GROSS_VALUE,
    pv.ACCOUNT_PRICE
from DOC_LINE dl
     join DOC_LINE_POST_VALUES pv on pv.ID_DOC_LINE = dl.ID_DOC_LINE
     join DOC_HEAD dh on dh.ID_DOC = dl.ID_DOC_HEAD
     join SALE_TAXATION st on st.ID_SALE_TAXATION = dl.ID_SALE_TAXATION
     join ACCOUNT A on a.ID_ACCOUNT = dh.ID_ACCOUNT
;

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.IS_CORRECT IS
'            .      1,        . 0 -   ; 1 -      0. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_GUEST IS
'   ,        .    null,       ''  ''     .    ENA_GUEST.ID_GUEST. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.DATE_POST IS
'        .    ,    . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ROOM_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ACCOUNT_PRICE IS
'         /.             /. .';

/* Create view: ENA_DOC_LINE_SURGARGE */
CREATE VIEW ENA_DOC_LINE_SURGARGE(
ID_DOC_HEAD,
ID_SERVICE,
ID_SALE_TAXATION,
TAXATION_NAME,
TAXATION_ACCOUNT_NAME,
VAT_PERCENT,
QTY_POST,
SINGLE_VALUE,
SINGLE_WOT_VAT,
WOT_VAT,
LINE_NAME,
NAT_NET_VALUE,
NAT_GROSS_VALUE,
SEC_CURR_NET_VALUE,
SEC_CURR_GROSS_VALUE)
 AS 
select
    dl.ID_DOC_HEAD,
    dl.ID_SERVICE,
    dl.ID_SALE_TAXATION,
    st.NAME,
    st.ACCOUNT_NAME,
    dl.VAT_PERCENT,
    dl.QTY_POST,
    dl.SINGLE_VALUE,
    dl.SINGLE_WOT_VAT,
    dl.WOT_VAT,
    dl.LINE_NAME,
    dl.NAT_NET_VALUE,
    dl.NAT_GROSS_VALUE,
    dl.SEC_CURR_NET_VALUE,
    dl.SEC_CURR_GROSS_VALUE
from DOC_LINE dl
     join PAYMENT_FOOTER PF on pf.ID_DOC_LINE = dl.ID_DOC_LINE
     join DOC_HEAD dh on dh.ID_DOC = dl.ID_DOC_HEAD
     join SALE_TAXATION st on st.ID_SALE_TAXATION = dl.ID_SALE_TAXATION
     join ACCOUNT A on a.ID_ACCOUNT = dh.ID_ACCOUNT
;

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SERVICE IS
'    (, , , ,  ).  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

/* Create view: ENA_DOC_PAYMENT */
CREATE VIEW ENA_DOC_PAYMENT(
ID_DOC_HEAD,
DOC_TYPE_NAME,
PAYMENT_NUM,
PAYMENT_TYPE,
PAYMENT_DATE,
PAY_CURRENCY,
DESCRIPTION,
DUE_DATE,
PAY_VALUE,
PAY_RATE,
PAY_DOC_RATE,
EQUAL_DOC_VALUE,
NAT_VALUE,
EXPORT_TAG)
 AS 
select
   DP.ID_DOC_HEAD,
   P.DOC_TYPE_NAME,
   P.PAYMENT_NUM,
   PT.PAYMENT_TYPE,
   P.PAYMENT_DATE,
   P.PAY_CURRENCY,
   P.DESCRIPTION,
   P.DUE_DATE,
   DP.PAY_AMOUNT as INIT_PAY_VALUE,
   DP.PAY_RATE as INIT_PAY_RATE,
   cast(DP.PAY_RATE / dp.DOC_RATE as double precision) as PAY_DOC_RATE,
   cast(DP.DOC_AMOUNT as numeric(15,4)) as EQUAL_DOC_VALUE,
   cast(DP.DOC_AMOUNT * Dh.DOC_RATE as numeric(15,4)) as NAT_VALUE,
   iif(p.IS_STORNO = 0, dt.EXPORT_TAG, dtp.STORNO_EXPORT_TAG)
from
   DOC_PAY_USAGE DP
   join DOC_HEAD dh on dh.ID_DOC = dp.ID_DOC_HEAD
   join ACCOUNT A on A.ID_ACCOUNT = dh.ID_ACCOUNT
   join ACCOUNT_PAYMENTS AP on AP.ID_ACCOUNT_PAYMENT = DP.ID_ACCOUNT_PAYMENT
   join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = ap.ID_PAYMENT_HEAD and p.ID_DOC_HEAD = dp.ID_DOC_HEAD
   join PAYMENT_TYPE pt on pt.ID_PAYMENT_TYPE = p.ID_PAYMENT_TYPE
   join DOC_TYPE dt on dt.ID_DOC_TYPE = p.ID_DOC_TYPE
   join DOC_TYPE_PAY dtp on dtp.ID_DOC_TYPE = dt.ID_DOC_TYPE
;

COMMENT ON VIEW ENA_DOC_PAYMENT IS
'   ,     .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.ID_DOC_HEAD IS
'  ( ENA_DOC_HEAD.ID_DOC)      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DOC_TYPE_NAME IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_NUM IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_DATE IS
'     .        ,                 . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_CURRENCY IS
'  .        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DUE_DATE IS
'       .          ,      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_VALUE IS
'           . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.EQUAL_DOC_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.NAT_VALUE IS
'     . .';

/* Create view: ENA_DOC_PAYMENT_DISCOUNT */
CREATE VIEW ENA_DOC_PAYMENT_DISCOUNT(
ID_DOC_HEAD,
DESCRIPTION,
DISCOUNT_VALUE,
DISCOUNTABLE_VALUE,
IS_PERCENT_DISCOUNT,
FIXED_DISCOUNT_CURRENCY,
DISCOUNT_PERCENT_OR_AMOUNT,
SECOND_CURR_DISCOUNT_VALUE,
SECOND_CURR_DISCOUNTABLE_VALUE)
 AS 
select df.ID_DOC_HEAD,
       df.DESCRIPTION,
       df.FOOTER_VALUE as discount_value,
       df.TAXABLE_VALUE,
       iif(sd.DISCOUNT_CALC_METHOD = 'fixedValue', 0, 1),
       sd.FIXED_DISCOUNT_CURRENCY ,
       sd.DISCOUNT_VALUE,
       df.SECOND_CURR_DISCOUNT_VALUE,
       df.SECOND_CURR_DISCOUNTABLE_VALUE
from   DOC_FOOTER df
       join SALE_DISCOUNT sd on sd.ID_SALE_DISCOUNT = df.ID_TAX
       join DOC_HEAD d on d.ID_DOC = df.ID_DOC_HEAD
       join ACCOUNT A on a.ID_ACCOUNT = d.ID_ACCOUNT
where  df.ID_DOC_LINE is null
;

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.ID_DOC_HEAD IS
'         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNTABLE_VALUE IS
'  .       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.IS_PERCENT_DISCOUNT IS
'  .         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.FIXED_DISCOUNT_CURRENCY IS
'  .       -     . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_PERCENT_OR_AMOUNT IS
'  .       . .';

/* Create view: ENA_DOC_TAX */
CREATE VIEW ENA_DOC_TAX(
ID_DOC_HEAD,
ID_SALE_TAX,
NONTAXABLE_VALUE,
TAXABLE_VALUE,
TAX_VALUE,
TAX_NAME,
TAX_PERCENT,
FISCAL_CODE,
ACCOUNT_NAME,
SEC_CURR_NONTAXABLE_VALUE,
SEC_CURR_TAXABLE_VALUE,
SEC_CURR_TAX_VALUE)
 AS 
select T.ID_DOC_HEAD,
       T.ID_SALE_TAX,
       T.NONTAXABLE_VALUE,
       T.TAXABLE_VALUE,
       T.TAX_VALUE,
       T.TAX_NAME,
       T.TAX_PERCENT,
       st.FISCAL_CODE,
       st.ACCOUNT_NAME,
       t.SEC_CURR_NONTAXABLE_VALUE,
       t.SEC_CURR_TAXABLE_VALUE,
       t.SEC_CURR_TAX_VALUE
from   DOC_TAXES T
       join SALE_TAXES st on st.ID_SALE_TAX = t.ID_SALE_TAX
       join DOC_HEAD d on d.ID_DOC = t.ID_DOC_HEAD
       join ACCOUNT A on a.ID_ACCOUNT = d.ID_ACCOUNT
;

COMMENT ON COLUMN ENA_DOC_TAX.ID_DOC_HEAD IS
'         ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_SALE_TAX IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.NONTAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_VALUE IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_NAME IS
'  .  -        .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_PERCENT IS
'   ().  .';

COMMENT ON COLUMN ENA_DOC_TAX.FISCAL_CODE IS
' .        .  -      .';

COMMENT ON COLUMN ENA_DOC_TAX.ACCOUNT_NAME IS
' .              . .';

/* Create view: ENA_SERVICES */
CREATE VIEW ENA_SERVICES(
ID_HOTEL,
ID_SERVICE,
SERVICE_NAME,
GROUP_NAME,
SERVICE_TYPE,
REVENUE_GROUP,
REVENUE_ACCOUNT,
ACCOUNT_NAME,
EXT_CODE,
IS_BREAKFAST,
IS_LUNCH,
IS_DINNER,
IS_EXTRAFOOD1,
IS_EXTRAFOOD2,
ID_ROOM_TYPE,
TYPE_ROOM,
TYPE_ROOM_EXT_CODE,
TYPE_STAY_CODE)
 AS 
select
    s.ID_HOTEL,
    s.ID_SERVICE,
    s.SERVICE_NAME,
    sg.GROUP_NAME,
    s.SERVICE_TYPE,
    s.REVENUE_GROUP,
    s.REVENUE_ACCOUNT,
    s.ACCOUNT_NAME,
    s.EXT_CODE,
    case
      when s.SERVICE_TYPE = 'MEAL' then (select m.IS_BREAKFAST from SERVICE_MEALS m where m.ID_SERVICE = s.ID_SERVICE)
      when s.SERVICE_TYPE = 'BASE' then (select m.IS_BREAKFAST from SERVICE_PACKET sp join SERVICE_MEALS m on m.ID_BOARD = sp.ID_BOARD where  sp.ID_SERVICE = s.ID_SERVICE)
      else null end,
    case
      when s.SERVICE_TYPE = 'MEAL' then (select m.IS_LUNCH from SERVICE_MEALS m where m.ID_SERVICE = s.ID_SERVICE)
      when s.SERVICE_TYPE = 'BASE' then (select m.IS_LUNCH from SERVICE_PACKET sp join SERVICE_MEALS m on m.ID_BOARD = sp.ID_BOARD where  sp.ID_SERVICE = s.ID_SERVICE)
      else null end,
    case
      when s.SERVICE_TYPE = 'MEAL' then (select m.IS_DINNER from SERVICE_MEALS m where m.ID_SERVICE = s.ID_SERVICE)
      when s.SERVICE_TYPE = 'BASE' then (select m.IS_DINNER from SERVICE_PACKET sp join SERVICE_MEALS m on m.ID_BOARD = sp.ID_BOARD where  sp.ID_SERVICE = s.ID_SERVICE)
      else null end,
    case
      when s.SERVICE_TYPE = 'MEAL' then (select m.IS_EXTRAFOOD1 from SERVICE_MEALS m where m.ID_SERVICE = s.ID_SERVICE)
      when s.SERVICE_TYPE = 'BASE' then (select m.IS_EXTRAFOOD1 from SERVICE_PACKET sp join SERVICE_MEALS m on m.ID_BOARD = sp.ID_BOARD where  sp.ID_SERVICE = s.ID_SERVICE)
      else null end,
    case
      when s.SERVICE_TYPE = 'MEAL' then (select m.IS_EXTRAFOOD2 from SERVICE_MEALS m where m.ID_SERVICE = s.ID_SERVICE)
      when s.SERVICE_TYPE = 'BASE' then (select m.IS_EXTRAFOOD2 from SERVICE_PACKET sp join SERVICE_MEALS m on m.ID_BOARD = sp.ID_BOARD where  sp.ID_SERVICE = s.ID_SERVICE)
      else null end,
    (select rt.ID_ROOM_TYPE from SERVICE_PACKET sp join ROOM_TYPES rt on rt.ID_ROOM_TYPE = sp.ID_ROOM_TYPE where sp.ID_SERVICE = s.ID_SERVICE),
    (select RT.TYPE_ROOM from SERVICE_PACKET sp join ROOM_TYPES rt on rt.ID_ROOM_TYPE = sp.ID_ROOM_TYPE where sp.ID_SERVICE = s.ID_SERVICE),
    (select RT.EXT_CODE from SERVICE_PACKET sp join ROOM_TYPES rt on rt.ID_ROOM_TYPE = sp.ID_ROOM_TYPE where sp.ID_SERVICE = s.ID_SERVICE),
    (select ts.TYPE_STAY_CODE from SERVICE_PACKET sp join TYPE_STAY ts on ts.ID_TYPE_STAY = sp.ID_TYPE_STAY where sp.ID_SERVICE = s.ID_SERVICE)
from SERVICES s
     join SERVICE_GROUPS sg on sg.ID_SERVICE_GROUP = s.ID_SERVICE_GROUP
;

COMMENT ON COLUMN ENA_SERVICES.ID_HOTEL IS
'       . .';

COMMENT ON COLUMN ENA_SERVICES.ID_SERVICE IS
'   . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_NAME IS
'  . .';

COMMENT ON COLUMN ENA_SERVICES.GROUP_NAME IS
'    .            a       . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_TYPE IS
'  .  : ''BASE'',''EXTRA'',''COMMISSION'',''MEAL''. ''BASE'' -    ,     ,''EXTRA'' -  , ''MEAL'' - , ''COMMISSION'' - ,        (  ). .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_GROUP IS
'       .  : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_ACCOUNT IS
' -      . .';

COMMENT ON COLUMN ENA_SERVICES.ACCOUNT_NAME IS
'      (. ),      .          . .';

COMMENT ON COLUMN ENA_SERVICES.EXT_CODE IS
'         . .';

COMMENT ON COLUMN ENA_SERVICES.IS_BREAKFAST IS
'   . 0 - , 1 - .    1,   SERVICE_TYPE e ''BASE''  ''MEAL''.  -          .';

COMMENT ON COLUMN ENA_SERVICES.IS_LUNCH IS
'   .   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_DINNER IS
'   .   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_EXTRAFOOD1 IS
'     1.   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_EXTRAFOOD2 IS
'     2.   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.ID_ROOM_TYPE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ). .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  -             .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM_EXT_CODE IS
'    ( )     ,      .  -        .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_STAY_CODE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  : ''ALONE'' -      , ''BED'' -            , ''EXTRA_BED'' -      . .';

/* Create view: FB_GUESTS */
CREATE VIEW FB_GUESTS(
ID_HOTEL,
MEAL_DATE,
ID_GUEST,
IS_CHILD,
ID_ROOM,
ID_RESERV_DETAIL,
ID_ORGANIZER_PROFILE,
GFROM_DATE,
GTO_DATE,
ID_BOARD,
SOURCE,
BREAKFAST_CNT,
EXTRAFOOD1_CNT,
LUNCH_CNT,
EXTRAFOOD2_CNT,
DINER_CNT)
 AS 
select RD1.ID_HOTEL,
       GS1.FOR_DATE,
       G1.ID_GUEST,
       G1.IS_CHILD,
       G1.ID_ROOM,
       RD1.ID_RESERV_DETAIL,
       RD1.ID_AGENT_PROFILE,
       G1.FROM_DATE,
       G1.TO_DATE,
       GS1.ID_BOARD,
       cast(iif(RD1.CHECK_STATUS in (0, 1), 'GUESTS', 'RESERVS') as varchar(10)),
       iif(G1.FIRST_FOOD_ORDER <= 1, TH1.IS_BREAKFAST, 0),
       iif(G1.FIRST_FOOD_ORDER <= 2, TH1.IS_EXTRAFOOD1, 0),
       iif(G1.FIRST_FOOD_ORDER <= 3, TH1.IS_LUNCH, 0),
       iif(G1.FIRST_FOOD_ORDER <= 4, TH1.IS_EXTRAFOOD2, 0),
       iif(G1.FIRST_FOOD_ORDER <= 5, TH1.IS_DINNER, 0)
from   GUEST G1
       join RESERV_DETAIL RD1 on RD1.ID_RESERV_DETAIL = G1.ID_RESERV_DETAIL
                                 and RD1.CHECK_STATUS > -3
                                 and RD1.IS_ANUL = 0
       join GUEST_STAY GS1 on GS1.ID_GUEST = G1.ID_GUEST
                              and GS1.FOR_DATE < coalesce(G1.EARLYCHECKOUT_DATE, GS1.FOR_DATE + 1)
       join SERVICE_MEALS TH1 on TH1.ID_BOARD = GS1.ID_BOARD
union
select RD2.ID_HOTEL,
       GS2.FOR_DATE + 1,
       G2.ID_GUEST,
       G2.IS_CHILD,
       G2.ID_ROOM,
       RD2.ID_RESERV_DETAIL,
       RD2.ID_AGENT_PROFILE,
       G2.FROM_DATE,
       G2.TO_DATE,
       GS2.ID_BOARD,
       cast(iif(RD2.CHECK_STATUS in (0, 1), 'GUESTS', 'RESERVS') as varchar(10)),
       iif(G2.FIRST_FOOD_ORDER > 1, TH2.IS_BREAKFAST, 0),
       iif(G2.FIRST_FOOD_ORDER > 2, TH2.IS_EXTRAFOOD1, 0),
       iif(G2.FIRST_FOOD_ORDER > 3, TH2.IS_LUNCH, 0),
       iif(G2.FIRST_FOOD_ORDER > 4, TH2.IS_EXTRAFOOD2, 0),
       iif(G2.FIRST_FOOD_ORDER > 5, TH2.IS_DINNER, 0)
from   GUEST G2
       join RESERV_DETAIL RD2 on RD2.ID_RESERV_DETAIL = G2.ID_RESERV_DETAIL
                                 and RD2.CHECK_STATUS > -3
                                 and RD2.IS_ANUL = 0
       join GUEST_STAY GS2 on GS2.ID_GUEST = G2.ID_GUEST
                              and GS2.FOR_DATE < coalesce(G2.EARLYCHECKOUT_DATE, GS2.FOR_DATE + 1)
       join SERVICE_MEALS TH2 on TH2.ID_BOARD = GS2.ID_BOARD
union all
select A3.ID_HOTEL,
       AP3.DATE_POST,
       G3.ID_GUEST,
       coalesce(G3.IS_CHILD, 0),
       AP3.ID_ROOM,
       G3.ID_RESERV_DETAIL,
       case
         when AP3.ID_MASTER_ADDINS_ACC_POST > 0 then RD3.ID_AGENT_PROFILE
         else A3.ID_PROFILE
       end as ID_ORGANIZER_PROFILE,
       G3.FROM_DATE,
       G3.TO_DATE,
       null as id_board,
       cast('POSTS' as varchar(10)),
       cast((TH3.IS_BREAKFAST * AP3.QTY_POST) as integer),
       cast((TH3.IS_EXTRAFOOD1 * AP3.QTY_POST) as integer),
       cast((TH3.IS_LUNCH * AP3.QTY_POST) as integer),
       cast((TH3.IS_EXTRAFOOD2 * AP3.QTY_POST) as integer),
       cast((TH3.IS_DINNER * AP3.QTY_POST) as integer)
from   ACCOUNT_POST AP3
       join ACCOUNT A3 on A3.ID_ACCOUNT = AP3.ID_ACCOUNT
       join SERVICE_MEALS TH3 on TH3.ID_SERVICE = ap3.ID_SERVICE
       left outer join GUEST G3 on G3.ID_GUEST = AP3.ID_GUEST
       left outer join RESERV_DETAIL RD3 on RD3.ID_RESERV_DETAIL = G3.ID_RESERV_DETAIL
where  AP3.IS_BASE = 0
       and AP3.IS_ANUL = 0
       and ((AP3.ID_MASTER_ADDINS_ACC_POST = -1) or (AP3.SHORT_CODE = 'PACK'))
;

/* Create view: HK_GUEST */
CREATE VIEW HK_GUEST(
BUSY_DATE,
ID_HK_PLAN,
ID_ROOM_TYPE,
ID_ROOM,
ADULT_COUNT,
CHILD_COUNT,
DAY_ACTION,
DAY_OF_STAY,
ID_AGENT_PROFILE,
ID_RESERV_DETAIL,
FROM_DATE,
TO_DATE,
NUMBER,
I_SPECIAL_TREATMENT,
ID_HOTEL)
 AS 
select RM.BUSY_DATE, RD.ID_HK_PLAN, RM.ID_ROOM_TYPE, RM.ID_ROOM, RM.ADULT_COUNT+RM.GST_AD_OUT, RM.CHILDREN_COUNT+RM.GST_CH_OUT,
       RM.DAY_ACTION, RM.BUSY_DATE - G.FROM_DATE + 1 as DAY_OF_STAY,
       RD.ID_AGENT_PROFILE, RM.ID_RESERV_DETAIL,
       G.FROM_DATE, G.TO_DATE, RD.NUMBER, RD.I_SPECIAL_TREATMENT, RD.ID_HOTEL
from   ROOM_MAGIC RM
       join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = RM.ID_RESERV_DETAIL
       join GUEST G on G.ID_RESERV_DETAIL = RD.ID_RESERV_DETAIL
where  RD.CHECK_STATUS in (0, 1)
       and RD.ID_ROOM > 0
;

/* Create view: HK_RESERVATION */
CREATE VIEW HK_RESERVATION(
BUSY_DATE,
ID_HK_PLAN,
ID_ROOM_TYPE,
ID_ROOM,
ADULT_COUNT,
CHILD_COUNT,
DAY_ACTION,
DAY_OF_STAY,
ID_AGENT_PROFILE,
FROM_DATE,
TO_DATE,
NUMBER,
I_SPECIAL_TREATMENT,
ID_RESERVATION_DETAIL,
ID_HOTEL,
HOUR_ACTION,
IS_OWNER)
 AS 
select RM.BUSY_DATE, RD.ID_HK_PLAN, RM.ID_ROOM_TYPE, RM.ID_ROOM,
       RM.ADULT_COUNT + RM.GST_AD_OUT, RM.CHILDREN_COUNT + RM.GST_CH_OUT,
       RM.DAY_ACTION,
       RM.BUSY_DATE - RD.FROM_DATE + 1 as DAY_OF_STAY, RD.ID_AGENT_PROFILE,
       RD.FROM_DATE, RD.TO_DATE, RD.NUMBER, RD.I_SPECIAL_TREATMENT, RM.ID_RESERV_DETAIL,
       RD.ID_HOTEL,
        CASE
            WHEN DAY_ACTION containing 'CHECK_IN' then RD.transfer_in_time
            WHEN DAY_ACTION containing 'CHECK_OUT' then RD.transfer_out_time
        ELSE NULL
       END,
       iif(RD.ACC_ROUTING = 'OWNER', 1, 0)
from   ROOM_MAGIC RM
       join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = RM.ID_RESERV_DETAIL
where  RD.CHECK_STATUS in (-3, -2, -1, 0, 1)
       and RD.ID_ROOM > 0
;

/* Create view: HOTEL_ROOM_OCCUPANCY */
CREATE VIEW HOTEL_ROOM_OCCUPANCY(
BUSY_DATE,
ID_ROOM_TYPE,
ID_ROOM,
ID_HOTEL,
ID_RESERV_STATISTICS,
BUSY_GROUP_TYPE,
BUSY_TYPE,
ID_AGENT,
OOO_ROOM,
OOI_ROOM,
STAYOVER_ADULTS,
STAYOVER_CHILDREN,
STAYOVER_ROOM,
ARRIVAL_ADULTS,
ARRIVAL_CHILDREN,
ARRIVAL_ROOM,
DEPARTURE_ADULTS,
DEPARTURE_CHILDREN,
DEPARTURE_ROOM,
MULTIPLE_GUEST_ROOM,
DAY_USE_ADULTS,
DAY_USE_CHILDREN,
BOOKINGS_CNT)
 AS 
select RM.BUSY_DATE,
       RM.ID_ROOM_TYPE,
       RM.ID_ROOM,
       RM.ID_HOTEL,
       coalesce(rsp.ID_RESERV_STATISTICS, RS.ID_RESERV_STATISTICS, RM.ID_RESERV_DETAIL),
       coalesce(rs.BUSY_GROUP_TYPE, rm.BUSY_GROUP_TYPE),
       coalesce(rsp.BUSY_TYPE, rs.BUSY_TYPE, rm.BUSY_TYPE),
       case
         when rsp.ID_ROOM_SHARE is not null then rsp.ID_AGENT
         when rs.ID_ROOM_SHARE is not null then rs.ID_AGENT
         else rm.ID_AGENT
       end,
       -- blocks
       count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 18 and coalesce(RS.DAY_ACTION, RM.DAY_ACTION) not containing 'CHECK_OUT', RM.ID_ROOM, null)),
       count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 20 and coalesce(RS.DAY_ACTION, RM.DAY_ACTION) not containing 'CHECK_OUT', RM.ID_ROOM, null)),
       -- stayovers
       sum(iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.GST_AD_STAY, 0)),
       sum(iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.GST_CH_STAY, 0)),
       count(distinct iif(coalesce(RS.DAY_ACTION, RM.DAY_ACTION) = 'STAY' and coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.ID_ROOM, null)),
       -- arrivals
       sum(iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.GST_AD_IN, 0)),
       sum(iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.GST_CH_IN, 0)),
       count(distinct iif(coalesce(RS.DAY_ACTION, RM.DAY_ACTION) = 'CHECK_IN' and coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.ID_ROOM, null)),
       -- departures
       sum(iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.GST_AD_OUT, 0)),
       sum(iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.GST_CH_OUT, 0)),
       count(distinct iif(coalesce(RS.DAY_ACTION, RM.DAY_ACTION) = 'CHECK_OUT' and coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.ID_ROOM, null)),
       -- multiple guest rooms
       count(distinct iif((coalesce(RS.DAY_ACTION, RM.DAY_ACTION) in ('STAY', 'CHECK_IN'))
                          and (RM.ADULT_COUNT+RM.CHILDREN_COUNT > 1)
                          and coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 24, RM.ID_ROOM, null)),
       -- daily uses
       sum(iif(RM.DAY_ACTION = 'CHECK_IN,CHECK_OUT', RM.ADULT_COUNT, 0)),
       sum(iif(RM.DAY_ACTION = 'CHECK_IN,CHECK_OUT', RM.CHILDREN_COUNT, 0)),
       -- bookings count
       count(distinct iif((coalesce(RS.DAY_ACTION, RM.DAY_ACTION) in ('STAY', 'CHECK_IN'))
                          and coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 24, RM.ID_RESERV_DETAIL, null))
from   ROOM_MAGIC RM
       left outer join RESERV_DETAIL rd on rd.id_reserv_detail = rm.id_reserv_detail
       left outer join ROOMS_SHARE RS on RS.ID_ROOM_SHARE = RM.ID_ROOM_MAGIC
       left outer join ROOMS_SHARE rsp on rsp.BUSY_DATE = (rm.BUSY_DATE - 1) and rsp.ID_RESERV_DETAIL = rm.ID_RESERV_DETAIL and rm.DAY_ACTION = 'CHECK_OUT' -- because of missed share on check_out date
where  rm.ROOM_STATUS is distinct from 'PRIVATE'  -- only hotel rooms occupancy
group by 1, 2, 3, 4, 5, 6, 7, 8
;

/* Create view: OWNER_POST_INVOICED */
CREATE VIEW OWNER_POST_INVOICED(
ID_DOC,
DATE_POST,
ROOM_NAME,
LINE_DESC,
POST_VALUE,
POST_CURR,
IS_ANUL,
IS_INVOICED,
ID_ACCOUNT_POST,
ID_BILL,
BILLING_INFO,
ID_OWNER,
ID_ROOM,
ID_SERVICE,
INV_DESCRIPTION,
DEVICE_READING_INFO,
ID_EXPORT_HEAD,
ID_ACCOUNT,
ID_HOTEL,
EVENT_DESCRIPTION)
 AS 
select
      DL.ID_DOC_HEAD,
      DL.DATE_POST,
      DL.ROOM_NAME,
      DL.LINE_NAME,
      cast(DL.QTY_POST * PV.ACCOUNT_PRICE as numeric(15,4)),
      AP.CURR_POST,
      cast(iif(DH.IS_ANUL = 1, 1, coalesce(BH.IS_ANUL, 0)) as smallint),
      cast(substring(AP.AC from 2 for 1) as  smallint),
      AP.ID_ACCOUNT_POST,
      BR.ID_OWNER_BILL,
      cast(substring(coalesce(BH.BILL_NUM||', '||formatdate(BH.BILL_DATE,'D;dd/mm/yyyy'), '') from 1 for 100) as varchar(100)),
      ACC.ID_PROFILE,
      E.ID_ROOM,
      AP.ID_SERVICE,
      cast(substring(DT.DOC_TYPE_NAME || ' ' || DH.DOC_NUM || ', ' || formatdate(DH.DOC_DATE,'D;dd/mm/yyyy') from 1 for 100) as varchar(100)) as doc_descr,
      (select cast(substring(list(DR.ID_DEVICE_READING || ', ' || coalesce(formatdate(DR.DATE_READ, 'dd/mm/yyyy'), ''), '/ ') from 1 for 300) as  varchar(300))
       from   DEVICE_READING_POST DRP
              join DEVICE_READING_EVIDENCE DRE on DRE.ID_DEVICE_READING_EVIDENCE = DRP.ID_DEVICE_READING_EVIDENCE
              join DEVICE_READING DR on DR.ID_DEVICE_READING = DRE.ID_DEVICE_READING
       where  DRP.ID_ACCOUNT_POST = ap.ID_ACCOUNT_POST),
      E.ID_EXPORT_HEAD,
      acc.ID_ACCOUNT,
      acc.ID_HOTEL,
      e.DESCRIPTION
from  ACCOUNT_POST AP
      join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
      join PMS_EVENT$PMS E on E.ID_PMS_EVENT = PP.ID_PMS_EVENT
      join ACCOUNT ACC on ACC.ID_ACCOUNT = AP.ID_ACCOUNT
      join OWNER$PMS O on O.ID_OWNER = ACC.ID_PROFILE
      join DOC_LINE_POST_VALUES PV on AP.ID_ACCOUNT_POST = PV.ID_ACCOUNT_POST
      join DOC_LINE DL on PV.ID_DOC_LINE = DL.ID_DOC_LINE
      join DOC_HEAD DH on DH.ID_DOC = DL.ID_DOC_HEAD
      join DOC_TYPE DT on DT.ID_DOC_TYPE = DH.ID_DOC_TYPE  
      left outer join OWNER_BILL_ROW$PMS BR on BR.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
      left outer join OWNER_BILL$PMS BH on BH.ID_OWNER_BILL = BR.ID_OWNER_BILL
;

COMMENT ON COLUMN OWNER_POST_INVOICED.DATE_POST IS
'        .    ,    . .';

COMMENT ON COLUMN OWNER_POST_INVOICED.ROOM_NAME IS
'       . .';

COMMENT ON COLUMN OWNER_POST_INVOICED.ID_SERVICE IS
'    (, , , ,  ).  ENA_SERVICES.ID_SERVICE. .';

/* Create view: PACKETS_VOUCHERS */
CREATE VIEW PACKETS_VOUCHERS(
ID_ACCOUNT_POST,
ID_GUEST,
ID_RESERV_DETAIL,
ID_ACCOUNT,
FROM_DATE,
TO_DATE,
IS_CHILD,
ID_AGENT,
ID_TARIFA,
ID_ROOM,
ROOM_NAME,
DATE_POST,
CURR_POST,
VAUCHER_GRP,
GVAUCHER_NUM,
GVAUCHER_NUM2,
VAUCHER_DATE,
VAUCHER_DATE2,
NIGHTS,
ID_BASE_DOC)
 AS 
select
  AP.ID_ACCOUNT_POST,
  G.ID_GUEST, G.ID_RESERV_DETAIL, AP.ID_ACCOUNT,
  AP.FROM_DATE, AP.TO_DATE, G.IS_CHILD, G.ID_AGENT, G.ID_TARIFA, G.ID_ROOM, AP.ROOM_NAME,
  AP.DATE_POST, AP.CURR_POST,
  coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) as VAUCHER_GRP,
  G.VAUCHER_NUM, G.VAUCHER_NUM2,
  G.VAUCHER_DATE, G.VAUCHER_DATE2,
  case when coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'BASE' then AP.QTY_POST else 0 end as NIGHTS,
  AP.ID_BASE_DOC
from
  ACCOUNT_POST AP
  join GUEST G on G.ID_GUEST = AP.ID_GUEST
  left outer join AGENT_PACKET APA on APA.ID_AGENT = G.ID_AGENT and APA.ID_SERVICE = AP.ID_SERVICE
  left outer join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
where
  AP.ID_MASTER_ADDINS_ACC_POST > 0
  and ((AP.IS_BASE = 1) or ((AP.IS_BASE = 0) and (coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) in ('OTHER', 'PARALLEL', 'SECONDARY'))))
  and AP.IS_ANUL = 0
--  and G.VAUCHER_NUM is not null
;

/* Create view: PAYMENT_TYPE_S */
CREATE VIEW PAYMENT_TYPE_S(
ID_PAYMENT_TYPE,
PAYMENT_TYPE,
GROUP_TAG,
DESCRIPTION,
IS_AR_DEBT,
IS_CASH,
IS_CC,
IS_USE,
FISCAL_CODE,
ID_HOTEL)
 AS 
select
  PT.ID_PAYMENT_TYPE,
  PT.PAYMENT_TYPE,
  PT.GROUP_TAG,
  PT.DESCRIPTION,
  PT.IS_AR_DEBT,
  PT.IS_CASH,
  PT.IS_CC,
  PT.IS_USE,
  PT.FISCAL_CODE,
  PT.ID_HOTEL
from PAYMENT_TYPE PT
     join (select count (distinct R.RIGHT_CODE) as HAS_RIGHT
           from   USER_RIGHTS R
           where  R.RIGHT_CODE  = 'DOC_AR_DEBT') R on R.HAS_RIGHT >= PT.IS_AR_DEBT
;

/* Create view: RES_ROOM_TYPES */
CREATE VIEW RES_ROOM_TYPES(
ID_RESERV_DETAIL,
RES_ID_ROOM_TYPE,
ROOM_ID_ROOM_TYPE)
 AS 
select rd.ID_RESERV_DETAIL,
       rd.ID_ROOM_TYPE,
       coalesce(r.ID_ROOM_TYPE, rm.ID_ROOM_TYPE)
from   RESERV_DETAIL RD
       left outer join ROOMS r on r.ID_ROOM = rd.ID_ROOM
       left outer join ROOM_MAP$EXC rm on rm.ID_ROOM = rd.ID_ROOM
;

/* Create view: SALE_DETAIL */
CREATE VIEW SALE_DETAIL(
UNIQUE_SALES_NUMBER,
ID_SALE_NUM,
ID_OBJECT,
OBJECT_NAME,
SALE_DATE,
ID_SERVICE,
SERVICE_NAME,
QTY,
SALE_PRICE,
DISCOUNT_SUM,
TAX_PERCENT,
TAX_SUM,
TOTAL_SUM,
USER_CODE,
USER_NAME,
POS_UNIQUE_SALES_NUMBER,
POS_TRANSFER,
ID_DOC_HEAD)
 AS 
select  sn.UNIQUE_SALES_NUMBER,
        sn.ID_SALE_NUM,
        h.ID_HOTEL,
        h.HOTEL_NAME,
        sn.SALE_DATE,
        ap.ID_SERVICE,
        s.SERVICE_NAME,
        ap.QTY_POST,
        iif(ap.QTY_POST <> 0, round_f(ap.POST_GROSS_VALUE / ap.QTY_POST, 0.01), 0),
        0,
        (select sum(t.TAX_PERCENT)
         from   SALE_TAXATION_TAX st
                join SALE_TAXES t on t.ID_SALE_TAX = st.ID_SALE_TAX and t.REVENUE_DEDUCTION_TAX is distinct from 1
         where  st.ID_SALE_TAXATION = ap.ID_SALE_TAXATION) as tax_percent,
        ap.POST_GROSS_VALUE - ap.POST_NET_VALUE,
        ap.POST_GROSS_VALUE,
        u.CODE,
        ap.USER_NAME,
        pt.UNIQUE_SALES_NUMBER,
        pt.TAG_NAME || '|' || pt.TAG_VALUE,
        null
from    SALE_NUM sn
        join ACCOUNT A on a.ID_SALE_NUM = sn.ID_SALE_NUM
        join HOTEL h on h.ID_HOTEL = a.ID_HOTEL
        join ACCOUNT_POST AP on ap.ID_ACCOUNT = a.ID_ACCOUNT and ap.IS_ANUL = 0 and ap.ID_BASE_DOC is null
        join SERVICES s on s.ID_SERVICE = ap.ID_SERVICE
        left outer join ACCOUNT_POST_POS_TRANSFER pt on pt.ID_ACCOUNT_POST = ap.ID_ACCOUNT_POST
        left outer join RIGHTS_USERS u on u.USER_NAME = ap.USER_NAME
where   sn.UNIQUE_SALES_NUMBER not starting with '_hpt'
union all
select  sn.UNIQUE_SALES_NUMBER,
        sn.ID_SALE_NUM,
        h.ID_HOTEL,
        h.HOTEL_NAME,
        sn.SALE_DATE,
        l.ID_SERVICE,
        l.LINE_NAME,
        l.QTY_POST,
        l.SINGLE_VALUE,
        0,
        l.VAT_PERCENT,
        l.SINGLE_VALUE * l.QTY_POST - l.WOT_VAT,
        l.SINGLE_VALUE * l.QTY_POST,
        u.CODE,
        d.USER_CREATED,
        pt.UNIQUE_SALES_NUMBER,
        pt.TAG_NAME || '|' || pt.TAG_VALUE,
        d.ID_DOC
from    SALE_NUM sn
        join DOC_HEAD d on d.ID_SALE_NUM = sn.ID_SALE_NUM and d.IS_ANUL = 0 and d.IS_STORNO = 0 and d.IS_STORNED = 0
        join ACCOUNT a on a.ID_ACCOUNT = d.ID_ACCOUNT
        join HOTEL h on h.ID_HOTEL = a.ID_HOTEL
        join DOC_LINE l on l.ID_DOC_HEAD = d.ID_DOC
        left outer join DOC_LINE_POST_VALUES pv on pv.ID_DOC_LINE = l.ID_DOC_LINE
        left outer join ACCOUNT_POST_POS_TRANSFER pt on pt.ID_ACCOUNT_POST = pv.ID_ACCOUNT_POST
        left outer join RIGHTS_USERS u on u.USER_NAME = d.USER_CREATED
where   sn.UNIQUE_SALES_NUMBER not starting with '_hpt'
;

/* Create view: SALE_DETAIL_OPEN_VOID */
CREATE VIEW SALE_DETAIL_OPEN_VOID(
UNIQUE_SALES_NUMBER,
ID_SALE_NUM,
ID_OBJECT,
OBJECT_NAME,
SALE_DATE,
ID_SERVICE,
SERVICE_NAME,
QTY,
SALE_PRICE,
DISCOUNT_SUM,
TAX_PERCENT,
TAX_SUM,
TOTAL_SUM,
START_DATE,
START_TIME,
VOID_DATE,
VOID_TIME,
USER_NAME,
USER_CODE,
POS_UNIQUE_SALES_NUMBER,
POS_TRANSFER,
ID_DOC_HEAD)
 AS 
select  sn.UNIQUE_SALES_NUMBER,
        sn.ID_SALE_NUM,
        h.ID_HOTEL,
        h.HOTEL_NAME,
        sn.SALE_DATE,
        ap.ID_SERVICE,
        s.SERVICE_NAME,
        ap.QTY_POST,
        round_f(ap.PRICE_POST * ap.RATE_POST, 0.01),
        0,
        (select sum(t.TAX_PERCENT)
         from   SALE_TAXATION_TAX st
                join SALE_TAXES t on t.ID_SALE_TAX = st.ID_SALE_TAX and t.REVENUE_DEDUCTION_TAX is distinct from 1
         where  st.ID_SALE_TAXATION = ap.ID_SALE_TAXATION) as tax_percent,
        (select tv.TAX_VALUE
         from   TAX_VALUE_DEDUCT(ap.QTY_POST * ap.PRICE_POST * ap.RATE_POST, 0.01, ap.ID_SALE_TAXATION) tv),
        round_f(ap.QTY_POST * ap.PRICE_POST * ap.RATE_POST, 0.01),
        cast(sn.CREATED_AT as date) as start_date,
        cast(sn.CREATED_AT as time) as start_time,
        cast(ap.ANUL_DATETIME as date) as void_date,
        cast(ap.ANUL_DATETIME as time) as void_time,
        ap.USER_ANUL as void_user_name,
        u.CODE as void_user_code,
        pt.UNIQUE_SALES_NUMBER,
        pt.TAG_NAME || '|' || pt.TAG_VALUE,
        cast(null as integer)
from    SALE_NUM sn
        left join ACCOUNT A on a.ID_SALE_NUM = sn.ID_SALE_NUM
        join HOTEL h on h.ID_HOTEL = a.ID_HOTEL
        join ACCOUNT_POST AP on ap.ID_ACCOUNT = a.ID_ACCOUNT
        join SERVICES s on s.ID_SERVICE = ap.ID_SERVICE
        left outer join ACCOUNT_POST_POS_TRANSFER pt on pt.ID_ACCOUNT_POST = ap.ID_ACCOUNT_POST
        left outer join RIGHTS_USERS u on u.USER_NAME = ap.USER_ANUL
where   sn.UNIQUE_SALES_NUMBER not starting with '_hpt'
        and ap.IS_ANUL = 1
;

/* Create view: SALE_DETAIL_VOID */
CREATE VIEW SALE_DETAIL_VOID(
UNIQUE_SALES_NUMBER,
ID_SALE_NUM,
ID_OBJECT,
OBJECT_NAME,
SALE_DATE,
ID_SERVICE,
SERVICE_NAME,
QTY,
SALE_PRICE,
DISCOUNT_SUM,
TAX_PERCENT,
TAX_SUM,
TOTAL_SUM,
END_DATE,
END_TIME,
VOID_DATE,
VOID_TIME,
FISCAL_DEVICE_NUMBER,
USER_NAME,
USER_CODE,
POS_UNIQUE_SALES_NUMBER,
POS_TRANSFER,
ID_DOC_HEAD)
 AS 
select  sn.UNIQUE_SALES_NUMBER,
        sn.ID_SALE_NUM,
        h.ID_HOTEL,
        h.HOTEL_NAME,
        sn.SALE_DATE,
        l.ID_SERVICE,
        l.LINE_NAME,
        l.QTY_POST * iif(d.IS_STORNO = 1 and l.IS_CORRECT = 0, -1, 1),
        l.SINGLE_VALUE * iif(d.IS_STORNO = 1 and l.IS_CORRECT = 1, -1, 1),
        0,
        l.VAT_PERCENT,
        (l.SINGLE_VALUE * l.QTY_POST - l.WOT_VAT) * iif(d.IS_STORNO = 1, -1, 1),
        l.SINGLE_VALUE * l.QTY_POST * iif(d.IS_STORNO = 1, -1, 1),
        cast(bd.DATETIME_CREATED as date) as end_date,
        cast(bd.DATETIME_CREATED as time) as end_time,
        cast(coalesce(a_log.ACTION_DATETIME, d.DATETIME_CREATED) as date) as void_date,
        cast(coalesce(a_log.ACTION_DATETIME, d.DATETIME_CREATED) as time) as void_time,
        fd.STORNO_FISCAL_DEVICE_ID,
        u.USER_NAME,
        u.CODE,
        pt.UNIQUE_SALES_NUMBER,
        pt.TAG_NAME || '|' || pt.TAG_VALUE,
        D.ID_DOC
from    SALE_NUM sn
        left join DOC_HEAD d on d.ID_SALE_NUM = sn.ID_SALE_NUM
        join DOC_HEAD bd on bd.ID_DOC = d.ID_BASE_DOC
        join ACCOUNT a on a.ID_ACCOUNT = d.ID_ACCOUNT
        join HOTEL h on h.ID_HOTEL = a.ID_HOTEL
        left join DOC_LINE l on l.ID_DOC_HEAD = d.ID_DOC
        left outer join DOC_LINE_POST_VALUES pv on pv.ID_DOC_LINE = l.ID_DOC_LINE
        left outer join ACCOUNT_POST_POS_TRANSFER pt on pt.ID_ACCOUNT_POST = pv.ID_ACCOUNT_POST
        left outer join DOC_FISCAL_DATA fd on fd.ID_DOC_HEAD = d.ID_DOC
        left outer join DOC_ANNULMENT da on da.ID_DOC_HEAD = d.ID_DOC
        left outer join SYSTEM_LOG_EVENT a_log on a_log.ID_SYSTEM_LOG = da.ID_LOG_EVENT
        left outer join RIGHTS_USERS u on u.USER_NAME = coalesce(a_log.ACTION_USER, d.USER_CREATED)
where   sn.UNIQUE_SALES_NUMBER not starting with '_hpt'
        and ((d.IS_ANUL = 1 and d.IS_STORNO = 0) or (d.IS_STORNO = 1 and d.IS_ANUL = 0))
;

/* Create view: SALE_PAYMENT */
CREATE VIEW SALE_PAYMENT(
UNIQUE_SALES_NUMBER,
ID_SALE_NUM,
ID_OBJECT,
OBJECT_NAME,
SALE_DATE,
START_DATE,
END_DATE,
TOTAL_SUM,
PAYMENT_DATE,
USER_NAME,
USER_CODE,
PAYMENT_SUM,
PAYMENT_TYPE,
FISCAL_DEVICE_NUMBER,
ID_DOC_HEAD)
 AS 
select  sn.UNIQUE_SALES_NUMBER,
        sn.ID_SALE_NUM,
        h.ID_HOTEL,
        h.HOTEL_NAME,
        sn.SALE_DATE,
        sn.SALE_DATE,
        cast(dp.DATETIME_CREATED as date), --dp.REALIZE_DATE,
        dp.NAT_VALUE,
        cast(dp.DATETIME_CREATED as date), -- dp.PAYMENT_DATE,
        dp.USER_CREATED,
        u.CODE,
        dp.NAT_VALUE,  --- currency ?????????
        pt.PAYMENT_TYPE,
        iif((dp.IS_STORNO = 1) or (dp.IS_ANUL = 1) or (dtp.DOC_DIRECTION = 1), fd.STORNO_FISCAL_DEVICE_ID, fd.FISCAL_DEVICE_ID),
        dp.ID_DOC_HEAD
from    SALE_NUM sn
        left join DOCUMENT_PAYMENT dp on dp.ID_SALE_NUM = sn.ID_SALE_NUM
        join RIGHTS_USERS u on u.USER_NAME = dp.USER_CREATED
        join ACCOUNT a on a.ID_ACCOUNT = dp.ID_ACCOUNT
        join HOTEL h on h.ID_HOTEL = a.ID_HOTEL
        join DOC_TYPE_PAY dtp on dtp.ID_DOC_TYPE = dp.ID_DOC_TYPE
        join PAYMENT_TYPE pt on pt.ID_PAYMENT_TYPE = dp.ID_PAYMENT_TYPE
        left outer join DOC_FISCAL_DATA fd on fd.ID_DOC_HEAD = dp.ID_DOC_HEAD
where   sn.UNIQUE_SALES_NUMBER not starting with '_hpt'
        and dp.REALIZED_VALUE <> 0
;

/* Create view: SALE_TOTAL */
CREATE VIEW SALE_TOTAL(
UNIQUE_SALES_NUMBER,
ID_SALE_NUM,
ID_OBJECT,
OBJECT_NAME,
SALE_DATE,
START_DATE,
START_TIME,
USER_NAME,
USER_CODE,
NETO_SUM,
DISCOUNT_SUM,
TAX_SUM,
TOTAL_SUM,
INVOICE_NUM,
INVOICE_DATE,
END_DATE,
END_TIME,
CLIENT_NUM,
CLIENT_NAME,
ID_DOC_HEAD)
 AS 
select  sn.UNIQUE_SALES_NUMBER,
        sn.ID_SALE_NUM,
        h.ID_HOTEL,
        h.HOTEL_NAME,
        sn.SALE_DATE,
        cast(sn.CREATED_AT as date) as start_date,
        cast(sn.CREATED_AT as time) as start_time,
        sn.USER_CREATED,
        u.CODE,
        sum(ap.POST_NET_VALUE) as neto_sum,
        0 as discount_sum,
        sum(ap.POST_GROSS_VALUE) - sum(ap.POST_NET_VALUE) as tax_sum,
        sum(ap.POST_GROSS_VALUE) as total_sum,
        null as invoice_num,
        null as invoice_date,
        null as end_date,
        null as end_time,
        c.IDENT_NO as client_num,
        coalesce(c.CONTRAGENT_NAME, p.PROFILE_NAME) as client_name,
        null
from    ACCOUNT A
        join SALE_NUM sn on sn.ID_SALE_NUM = a.ID_SALE_NUM
        join RIGHTS_USERS u on u.USER_NAME = sn.USER_CREATED
        join HOTEL h on h.ID_HOTEL = a.ID_HOTEL
        join ACCOUNT_POST AP on ap.ID_ACCOUNT = a.ID_ACCOUNT and ap.IS_ANUL = 0 and ap.ac = '00'
        join PROFILE p on p.ID_PROFILE = a.ID_PROFILE
        left outer join CONTRAGENTS c on c.ID_CONTRAGENT = p.ID_DEF_CONTRAGENT
where   sn.UNIQUE_SALES_NUMBER not starting with '_hpt'
group by 1, 2, 3, 4, 5, 6, 7, 8, 9, 18, 19
union all
select  sn.UNIQUE_SALES_NUMBER,
        sn.ID_SALE_NUM,
        h.ID_HOTEL,
        h.HOTEL_NAME,
        sn.SALE_DATE,
        cast(sn.CREATED_AT as date),
        cast(sn.CREATED_AT as time),
        sn.USER_CREATED,
        u.CODE,
        d.DOC_NET_VALUE,
        (select cast(sum(f.FOOTER_VALUE) as numeric(15,4)) from DOC_FOOTER f where f.ID_DOC_HEAD = d.ID_DOC),
        d.DOC_VALUE_A - d.DOC_NET_VALUE,
        d.DOC_VALUE_A,
        d.DOC_NUM,
        d.DOC_DATE,
        cast(d.DATETIME_CREATED as date),
        cast(d.DATETIME_CREATED as time),
        dc.IDENT_NO,
        dc.CONTRAGENT_NAME,
        d.ID_DOC
from    DOC_HEAD d
        join SALE_NUM sn on sn.ID_SALE_NUM = d.ID_SALE_NUM
        join RIGHTS_USERS u on u.USER_NAME = sn.USER_CREATED
        join ACCOUNT a on a.ID_ACCOUNT = d.ID_ACCOUNT
        join HOTEL h on h.ID_HOTEL = a.ID_HOTEL
        left outer join DOC_CONTRAGENT dc on dc.ID_DOC_CONTRAGENT = d.ID_DOC_CONTRAGENT
where   sn.UNIQUE_SALES_NUMBER not starting with '_hpt'
        and d.IS_ANUL = 0
        and d.IS_STORNO = 0
        and d.IS_STORNED = 0
;

/* Create view: VIEW_PHONECALLS */
CREATE VIEW VIEW_PHONECALLS(
ID_PHONECALL,
LINE,
ROOM_NAME,
DATETIME_CALL,
DIAL_NUMBER,
UNITS,
DURATION,
PRICE,
CURR,
IS_ARCHIVE,
IS_TAXABLE,
ID_ACCOUNT_POST,
DATETIME_INSERTED,
IS_LOGICLESS_RECORD,
INTERNAL_LINE,
INT_PRICE,
ATA,
ID_HOTEL,
ID_ROOM,
NUMBER_ZONE,
NUMBER_PREFIX)
 AS 
SELECT
    ID_PHONECALL,
    LINE,
    ROOM_NAME,
    DATETIME_CALL,
    DIAL_NUMBER,
    UNITS,
    DURATION,
    PRICE,
    CURR,
    IS_ARCHIVE,
    IS_TAXABLE,
    ID_ACCOUNT_POST,
    DATETIME_INSERTED,
    IS_LOGICLESS_RECORD,
    INTERNAL_LINE,
    INT_PRICE,
    ATA,
    ID_HOTEL,
    ID_ROOM,
    NUMBER_ZONE,
    NUMBER_PREFIX
FROM PHONECALLS PH
  join (select max(cast(iif(R.RIGHT_CODE is not null, 1, 0) as integer)) as GRANTED_LEVEL
        from   RIGHTS_USERS RU
               left outer join USER_RIGHTS R on R.RIGHT_CODE  = 'ARCHIVE_PHONE_LINES'
        where  RU.USER_NAME = current_user
        union
        select cast(0 as integer)
        from   RDB$DATABASE
        where  not exists (select *
                           from   RIGHTS_USERS RU
                           where  RU.USER_NAME = current_user)) UR on UR.GRANTED_LEVEL >= PH.IS_ARCHIVE
;


COMMENT ON COLUMN ENA_ACCOUNT.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT.ID_ACCOUNT IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_NAME IS
'   .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_EXT_CODE IS
'             .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ID IS
'         . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_NAME IS
'    .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ACCOUNT_NO IS
'             .  -    .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_TYPE IS
'       .  : AGENT -  , PERSON -  , HOUSE -    . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_HOUSE_TYPE IS
'      (PROFILE_TYPE = ''HOUSE''),    -.  : hptExternalClient -          ( ,      ); hptExternalRevenue -                (,   ..); hptComplimentary -           ,  ,        . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_HOTEL IS
'       .  ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT_POST_HISTORY IS
'   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT IS
'      .  ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.SYSTEM_DATE IS
'    / . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_DATE IS
'        (). .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_CURR IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_AMOUNT IS
'    (   )    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_NET_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_GROSS_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_TYPE IS
'  . BASE -  ; ADD_INS -  - ,    ; EXTRA -     ,     ; TAX -            ,     .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_GUEST IS
'       .  ENA_GUEST.ID_GUEST.        : 1.    "  "; 2.           ; 3.        ,      . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_GROUP IS
'       .    : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_ACCOUNT IS
' -      .    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_SUB_ACCOUNT IS
' --      . ,     -. .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.ID_DOC_HEAD IS
'        .  ENA_DOC_HEAD_ADVANCE.ID_DOC. .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.SYSTEM_DATE IS
'      . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAYMENT_DATE IS
'     . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.SRC_ID_ACCOUNT IS
'   . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.DEST_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAY_AMOUNT IS
' .        . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAY_CURRENCY IS
' . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.USER_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.DATETIME_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_DEPOSIT_PAYMENT IS
'  .         . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_DATE IS
'        .            . .';

COMMENT ON COLUMN ENA_DEPOSIT.SYSTEM_DATE IS
'   .         PAYMENT_DATE.        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_NUM IS
'           .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_DIRECTION IS
'0 -   , 1 -   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_TYPE_NAME IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_ACCOUNT IS
'        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_AMOUNT IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DEPOSIT.IS_ANUL IS
'   . 0 - , 1 - .           /    .     IS_ANUL = 0,    1.           ID_DEPOSIT.  .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_CREATED IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_CREATED IS
'       . .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_ANNUL IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_ANNUL IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_HOTEL IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_DEPOSIT_PAYMENT IS
'   ,   .  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT. .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SYSTEM_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAYMENT_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SRC_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DEST_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_AMOUNT IS
' .        . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_CURRENCY IS
' . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.USER_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DATETIME_CREATED IS
'     . .';

COMMENT ON VIEW ENA_DOC_DEPOSIT_CONSUMPTION IS
' !!!!!!    ID_DOC_TYPE - za mapowe.';


COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DOC_TYPE_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_NUM IS
'         .  .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_DATE IS
'      .          . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_VALUE IS
'         . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.EQUAL_DOC_VALUE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.NAT_VALUE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DEPOSIT_PAYMENT IS
'      (  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT ). .';

COMMENT ON VIEW ENA_DOC_HEAD_ADVANCE IS
'!      ';


COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC IS
'  .             .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_ADVANCE.ID_DOC.  .     - , ..       ,      - .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SUB_TYPE IS
'   . ,  : 0 - / , 1 -  ,  , 2 -  ,  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_NAME IS
'    . ,       .              .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_DESCRIPTION IS
'   .         .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_NUM IS
'   ,        .      . ,     ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DATE IS
'        . .    SYSTEM_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.IS_ANUL IS
'        . . 0 - , 1 - .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TOTAL_VALUE IS
' (, )       . .      .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ONE_LINE_TEXT IS
' ,         .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURR_RATE IS
'   ()    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_POST_ADDRESS IS
'    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_ZIP_CODE IS
'     ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_MOL IS
'    ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_RECIPIENT_NAME IS
'     ()';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BANK_NAME IS
'  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BIC IS
'BIC  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IBAN IS
'IBAN  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_EMAIL IS
'email  .        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SUPPLIER_SEND_NAME IS
'     .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ACCOUNT_ID IS
'        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC IS
'  .             .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_SERVICE.ID_DOC.     - , ..       ,      - .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC_TYPE IS
'    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SUB_TYPE IS
'   .  : 0 - / , 1 -  ,  , 2 -  ,  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_NAME IS
'    .              .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_DESCRIPTION IS
'   .         .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_NUM IS
'   ,        .      .  -       ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DATE IS
'        .    SYSTEM_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.IS_ANUL IS
'        . 0 - , 1 - .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_CURRENCY IS
'  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TOTAL_VALUE IS
' (, )       .      .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ONE_LINE_TEXT IS
' ,         .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURR_RATE IS
'   ()    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_DATE IS
'   ,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_NUM IS
'  -,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_POST_ADDRESS IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_ZIP_CODE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_MOL IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_RECIPIENT_NAME IS
'     (). .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BANK_NAME IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BIC IS
'BIC  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IBAN IS
'IBAN  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_EMAIL IS
'email  .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SUPPLIER_SEND_NAME IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ACCOUNT_ID IS
'        .    ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SERVICE IS
'     .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.DATE_POST IS
'    . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SERVICE IS
'      .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.IS_CORRECT IS
'            .      1,        . 0 -   ; 1 -      0. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_GUEST IS
'   ,        .    null,       ''  ''     .    ENA_GUEST.ID_GUEST. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.DATE_POST IS
'        .    ,    . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ROOM_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ACCOUNT_PRICE IS
'         /.             /. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SERVICE IS
'    (, , , ,  ).  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON VIEW ENA_DOC_PAYMENT IS
'   ,     .';


COMMENT ON COLUMN ENA_DOC_PAYMENT.ID_DOC_HEAD IS
'  ( ENA_DOC_HEAD.ID_DOC)      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DOC_TYPE_NAME IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_NUM IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_DATE IS
'     .        ,                 . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_CURRENCY IS
'  .        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DUE_DATE IS
'       .          ,      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_VALUE IS
'           . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.EQUAL_DOC_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.NAT_VALUE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.ID_DOC_HEAD IS
'         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNTABLE_VALUE IS
'  .       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.IS_PERCENT_DISCOUNT IS
'  .         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.FIXED_DISCOUNT_CURRENCY IS
'  .       -     . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_PERCENT_OR_AMOUNT IS
'  .       . .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_DOC_HEAD IS
'         ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_SALE_TAX IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.NONTAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_VALUE IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_NAME IS
'  .  -        .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_PERCENT IS
'   ().  .';

COMMENT ON COLUMN ENA_DOC_TAX.FISCAL_CODE IS
' .        .  -      .';

COMMENT ON COLUMN ENA_DOC_TAX.ACCOUNT_NAME IS
' .              . .';

COMMENT ON VIEW ENA_GUEST IS
'!!! .    (    )';


COMMENT ON COLUMN ENA_GUEST.ID_GUEST IS
'   ( )   . .';

COMMENT ON COLUMN ENA_GUEST.ID_RESERV_DETAIL IS
'        ( ENA_RESERV_DETAIL.ID_RESERV_DETAIL). .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME2 IS
'      . .';

COMMENT ON COLUMN ENA_GUEST.IS_CHILD IS
'   . 0 - ; 1 - . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE IS
'    . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_TEXT IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.RATING_AGE IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.COUNTRY_CODE IS
'    .        ISO. .';

COMMENT ON COLUMN ENA_GUEST.MASK IS
'  .         . .';

COMMENT ON COLUMN ENA_HOTEL.ID_HOTEL IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.HOTEL_NAME IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.CODE IS
'   . .';

COMMENT ON COLUMN ENA_HOTEL.SYSTEM_DATE IS
'     .                  ENA.                . .';

COMMENT ON COLUMN ENA_HOTEL.IS_USE IS
'    (  ). 0 -   , 1 -  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_RESERV_DETAIL IS
'   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NUMBER IS
'  .    (   ). .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_GUEST_MAIN IS
'      .      .  -     .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME IS
'    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME2 IS
'       . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.FROM_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.TO_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NIGHTS IS
'. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ADULT_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHILD_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_EATING_OBJECT IS
'          . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHECK_STATUS IS
'  . -3 =  ; -2 =   ; -1 =  ; 0 =  ; 1 =  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.IS_ANUL IS
'   . 0 - , 1 - .  -       0  1.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ID IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_NAME IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_TYPE IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ACCOUNT_NO IS
'             .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SEGMENT_CODE IS
'   ''segment''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SOURCE_CODE IS
'   ''source''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_CHANNEL_CODE IS
'   ''channel''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_HEAR_CODE IS
'   ''hear reason''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_COME_CODE IS
'   ''come reason''.   . .';

COMMENT ON COLUMN ENA_SERVICES.ID_HOTEL IS
'       . .';

COMMENT ON COLUMN ENA_SERVICES.ID_SERVICE IS
'   . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_NAME IS
'  . .';

COMMENT ON COLUMN ENA_SERVICES.GROUP_NAME IS
'    .            a       . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_TYPE IS
'  .  : ''BASE'',''EXTRA'',''COMMISSION'',''MEAL''. ''BASE'' -    ,     ,''EXTRA'' -  , ''MEAL'' - , ''COMMISSION'' - ,        (  ). .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_GROUP IS
'       .  : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_ACCOUNT IS
' -      . .';

COMMENT ON COLUMN ENA_SERVICES.ACCOUNT_NAME IS
'      (. ),      .          . .';

COMMENT ON COLUMN ENA_SERVICES.EXT_CODE IS
'         . .';

COMMENT ON COLUMN ENA_SERVICES.IS_BREAKFAST IS
'   . 0 - , 1 - .    1,   SERVICE_TYPE e ''BASE''  ''MEAL''.  -          .';

COMMENT ON COLUMN ENA_SERVICES.IS_LUNCH IS
'   .   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_DINNER IS
'   .   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_EXTRAFOOD1 IS
'     1.   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_EXTRAFOOD2 IS
'     2.   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.ID_ROOM_TYPE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ). .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  -             .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM_EXT_CODE IS
'    ( )     ,      .  -        .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_STAY_CODE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  : ''ALONE'' -      , ''BED'' -            , ''EXTRA_BED'' -      . .';

/* Alter View (Drop, Create)... */
/* Drop altered view: HOTEL_S */
SET TERM ^ ;

ALTER PROCEDURE ALLOTMENT_GET$INT(ID_ALLOTMENT INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ROOM_TYPE_FILTER INTEGER,
OPTIONS VARCHAR(255),
HOTELS VARCHAR(255) = '')
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ROOM_TYPE VARCHAR(30),
ID_HOTEL INTEGER,
CNT_DEFINED INTEGER,
CNT_BOOKED INTEGER,
ACTIVE_FRAME_BEGIN INTEGER,
IS_DEFINED INTEGER,
GRP_TAG INTEGER,
IS_RELEASED INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE EAI_EXT_ROOM_BALANCE(ROOM_NAME VARCHAR(20))
 RETURNS(ID_GUEST INTEGER,
ID_ACCOUNT_POST INTEGER,
IS_DEPOSIT_POST SMALLINT,
ID_ACCOUNT INTEGER,
ACCOUNT_NAME VARCHAR(40),
ID_SERVICE INTEGER,
SERVICE_NAME VARCHAR(30),
SERVICE_NAME2 VARCHAR(30),
POST_VALUE NUMERIC(15,2),
CURR_POST VARCHAR(3),
RATE_POST NUMERIC(15,4),
DATE_POST DATE,
POST_TEXT VARCHAR(50))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE EAI_ROOM_STATUS_SET(ROOM_NAME VARCHAR(10),
OPERATION VARCHAR(20),
TAG VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE EXPORT_PMS RETURNS(ID_EXPORT_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE HK_PROCEDURES_CALC$INT(FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM INTEGER,
WITH_NON_OPER SMALLINT,
WITH_AGENT SMALLINT)
 RETURNS(ID_AGENT_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
ITEM_NAME VARCHAR(50),
ROOM_NAME VARCHAR(10),
ROOM_TYPE_NAME VARCHAR(20),
OUT_HOTEL INTEGER,
QTY INTEGER,
AMOUNT NUMERIC(15,2))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE HK_PROCEDURES_CALC$RPT(FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM INTEGER,
PER_HOTEL VARCHAR(255),
PER_SECTOR INTEGER,
PER_FLOOR INTEGER,
WITH_NON_OPER SMALLINT,
WITH_AGENT SMALLINT)
 RETURNS(ID_AGENT_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
ITEM_NAME VARCHAR(50),
ROOM_NAME VARCHAR(10),
ROOM_TYPE_NAME VARCHAR(20),
OUT_HOTEL INTEGER,
QTY INTEGER,
AMOUNT NUMERIC(15,2))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE HK_ROOM_STATUS$RPT(FROM_DATE DATE,
TO_DATE DATE,
PER_HOTEL VARCHAR(255),
PER_SECTOR INTEGER,
PER_FLOOR INTEGER,
PRIVATE_STATUS_ADDING SMALLINT = 0)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
SECTOR INTEGER,
ID_ROOM_TYPE INTEGER,
TYPE_ROOM VARCHAR(20),
IS_CLEAN INTEGER,
IS_INSPECTED INTEGER,
CLEAN_TEXT VARCHAR(30),
CLEAN_STATUS VARCHAR(30),
BUSY_DAY SMALLINT,
GUESTS_CNT INTEGER,
LEAVING_GUESTS_CNT INTEGER,
IS_LEAVING SMALLINT,
IS_COMMING SMALLINT,
IS_SHARED SMALLINT,
IS_LEAVING_WORDS VARCHAR(30),
BUSY_GRP INTEGER,
DAYS_THIS_STATUS INTEGER,
DTS_CONTEXT VARCHAR(10),
COMMING_OCCUPANTS VARCHAR(1024),
ID_BLOCK_ROOM INTEGER,
OTHER_OCCUPANTS VARCHAR(1024),
SPECIAL_TREATMENT VARCHAR(1024),
ID_HOTEL INTEGER,
IS_BUSY SMALLINT,
IS_OWNER SMALLINT)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE PROFILE_GET_STATISTIC(ID_PROFILE INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER,
IS_VAT SMALLINT,
PERIODICITY VARCHAR(30) = null)
 RETURNS(OUT_ID_HOTEL INTEGER,
OUT_PERIOD VARCHAR(20),
ARRIVALS INTEGER,
NIGHTS INTEGER,
NIGHTS_NOSHOW INTEGER,
NIGHTS_CANCELED INTEGER,
GUESTS INTEGER,
GUEST_NIGHTS INTEGER,
ROOM_REVENUE NUMERIC(15,4),
FB_REVENUE NUMERIC(15,4),
OTHER_OPERATED_REVENUE NUMERIC(15,4),
OTHER_RENTAL_REVENUE NUMERIC(15,4))
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW HOTEL_S;

/* Create altered view: HOTEL_S */
/* Create view: HOTEL_S */
CREATE VIEW HOTEL_S(
ID_HOTEL,
HOTEL_NAME,
CODE,
SYSTEM_DATE,
COMPANY_NAME,
COMPANY_IDENT_NUM,
COMPANY_VAT_REG_NUM,
COMPANY_MOL,
COMPANY_ADDRESS,
ID_LOGO,
HOTEL_ADDRESS,
ID_OVERBOOK_ALLOTMENT,
ID_PHYSICAL_ALLOTMENT,
ID_INVENTORY_ALLOTMENT,
ID_EXTERNAL_OCCUPANCY_ALLOTMENT,
ID_GUEST_NUMERATOR,
ID_EXTRA_RATE,
LETTER_HEADER,
LETTER_FOOTER,
RES_CONFIRM_TEXT,
DOC_PACK_SRV_TEXT,
DOC_ONE_LINE_TEXT,
MONITOR_MAP,
ORDER_TAG,
IS_USE,
EXTERNAL_TYPE,
WBE_ENABLED,
NATION_CURR,
ACCOMODATION_PLACE_UIN)
 AS 
select h.ID_HOTEL,
       HOTEL_NAME,
       CODE,
       SYSTEM_DATE,
       COMPANY_NAME,
       COMPANY_IDENT_NUM,
       COMPANY_VAT_REG_NUM,
       COMPANY_MOL,
       COMPANY_ADDRESS,
       ID_LOGO,
       HOTEL_ADDRESS,
       ID_OVERBOOK_ALLOTMENT,
       ID_PHYSICAL_ALLOTMENT,
       ID_INVENTORY_ALLOTMENT,
       ID_EXTERNAL_OCCUPANCY_ALLOTMENT,
       ID_GUEST_NUMERATOR,
       ID_EXTRA_RATE,
       LETTER_HEADER,
       LETTER_FOOTER,
       RES_CONFIRM_TEXT,
       DOC_PACK_SRV_TEXT,
       DOC_ONE_LINE_TEXT,
       MONITOR_MAP,
       ORDER_TAG,
       IS_USE,
       EXTERNAL_TYPE,
       WBE_ENABLED,
       NATION_CURR,
       ACCOMODATION_PLACE_UIN
from   HOTEL H
       join RIGHTS_USER_HOTEL R on R.ID_HOTEL = H.ID_HOTEL
where  R.USER_NAME = current_user
union
select h.ID_HOTEL,
       HOTEL_NAME,
       CODE,
       SYSTEM_DATE,
       COMPANY_NAME,
       COMPANY_IDENT_NUM,
       COMPANY_VAT_REG_NUM,
       COMPANY_MOL,
       COMPANY_ADDRESS,
       ID_LOGO,
       HOTEL_ADDRESS,
       ID_OVERBOOK_ALLOTMENT,
       ID_PHYSICAL_ALLOTMENT,
       ID_INVENTORY_ALLOTMENT,
       ID_EXTERNAL_OCCUPANCY_ALLOTMENT,
       ID_GUEST_NUMERATOR,
       ID_EXTRA_RATE,
       LETTER_HEADER,
       LETTER_FOOTER,
       RES_CONFIRM_TEXT,
       DOC_PACK_SRV_TEXT,
       DOC_ONE_LINE_TEXT,
       MONITOR_MAP,
       ORDER_TAG,
       IS_USE,
       EXTERNAL_TYPE,
       WBE_ENABLED,
       NATION_CURR,
       ACCOMODATION_PLACE_UIN
from   HOTEL H
where  current_user in ('SYSDBA', '_AUDITOR_')
;

COMMENT ON COLUMN OWNER_POST.POST_STATUS IS
'11  
22  ';

COMMENT ON COLUMN OWNER_POST_INVOICED.DATE_POST IS
'        .    ,    . .';

COMMENT ON COLUMN OWNER_POST_INVOICED.ROOM_NAME IS
'       . .';

COMMENT ON COLUMN OWNER_POST_INVOICED.ID_SERVICE IS
'    (, , , ,  ).  ENA_SERVICES.ID_SERVICE. .';

/* Create index... */
CREATE INDEX SN_CREATED_AT_IDX ON SALE_NUM(CREATED_AT);

CREATE INDEX SN_SALE_DATE_IDX ON SALE_NUM COMPUTED BY(cast(CREATED_AT as date));


/* Create generator... */
CREATE GENERATOR GEN_SALE_NUM;


/* Create Exception... */
CREATE EXCEPTION FISCALIZE_EXCEPTION '';


/* Create Primary Key... */
ALTER TABLE ACCOUNT_POST_POS_TRANSFER ADD CONSTRAINT PK_ACCOUNT_POST_POS_TRANSFER PRIMARY KEY (ID_ACCOUNT_POST);

ALTER TABLE DOC_FISCAL_DATA ADD CONSTRAINT PK_DOC_FISCAL_DATA PRIMARY KEY (ID_DOC_HEAD);

ALTER TABLE SALE_NUM ADD CONSTRAINT PK_SALE_NUM PRIMARY KEY (ID_SALE_NUM);

/* Create Unique... */
ALTER TABLE RIGHTS_USERS ADD CONSTRAINT UNQ_RU_CODE UNIQUE (CODE);

ALTER TABLE SALE_NUM ADD CONSTRAINT UNQ1_SALE_NUM UNIQUE (UNIQUE_SALES_NUMBER);

/* Create Foreign Key... */
RECONNECT;

ALTER TABLE ACCOUNT ADD CONSTRAINT FK_A_SALE_NUM FOREIGN KEY (ID_SALE_NUM) REFERENCES SALE_NUM (ID_SALE_NUM);

ALTER TABLE ACCOUNT_POST_POS_TRANSFER ADD CONSTRAINT FK_ACCOUNT_POST_POS_TRANSFER_1 FOREIGN KEY (ID_ACCOUNT_POST) REFERENCES ACCOUNT_POST (ID_ACCOUNT_POST) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE ACCOUNT_POST ADD CONSTRAINT FK_AP_ACCOUNT FOREIGN KEY (ID_ACCOUNT) REFERENCES ACCOUNT (ID_ACCOUNT) ON UPDATE CASCADE
USING INDEX FK_ACCOUNT_POST_1;

ALTER TABLE DOC_COMPLETION ADD CONSTRAINT FK_DC_SALE_NUM FOREIGN KEY (ID_SALE_NUM) REFERENCES SALE_NUM (ID_SALE_NUM);

/* Create Check... */
ALTER TABLE RIGHTS_USERS ADD CONSTRAINT CHK_RIGHTS_USERS_CODE CHECK(char_length(CODE)<=4);

/*  Empty ACCOUNT_POSTING_ADD$INT for ACCOUNT_VALIDATE$INT(param list change)  */
SET TERM ^ ;

ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_GUEST /* TYPE OF ID_REF */ INTEGER,
ID_SECQUENCE /* TYPE OF ID_REF */ INTEGER,
DATE_POST /* TYPE OF TDATE */ DATE,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
IS_BASE /* TYPE OF TLOGICAL */ SMALLINT,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
ORIG_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
CHANGED_TEXT /* TYPE OF TTEXT_SHORT */ VARCHAR(30),
ID_MASTER_ADDINS_ACC_POST /* TYPE OF ID_REF */ INTEGER,
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
NEW_ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty ACCOUNT_POSTING_UPDATE$INT for ACCOUNT_VALIDATE$INT(param list change)  */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
ID_SERVICE /* TYPE OF ID_REF */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
QTY_FREE /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TVALUE */ DOUBLE PRECISION,
CURR /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
CHANGED_TEXT VARCHAR(40),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
IS_CONSEQUENTIAL_UPDATE /* TYPE OF TBOOLEAN */ SMALLINT = 0,
RE_ROUTE_ACCOUNT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(OUT_QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
OUT_PRICE_POST /* TYPE OF TVALUE */ DOUBLE PRECISION,
OUT_AC VARCHAR(2))
 AS
 BEGIN SUSPEND; END
^

/*  Empty PAYMENT_CREATE$INT for ACCOUNT_VALIDATE$INT(param list change)  */
ALTER PROCEDURE PAYMENT_CREATE$INT(ID_DOC_TYPE /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
PAYMENT_DATE /* TYPE OF TDATE */ DATE,
PAY_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
PAY_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
PAY_RATE /* TYPE OF TRATE */ NUMERIC(15,6),
ACC_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
ACC_RATE /* TYPE OF TRATE */ NUMERIC(15,6),
DESCRIPTION /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100))
 RETURNS(ID_PAYMENT_HEAD /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_PAYMENT /* TYPE OF ID */ INTEGER,
IS_TAXABLE /* TYPE OF TLOGICAL */ SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/*  Empty RES_ACCOUNTS_RECIEVE$INT for ACCOUNT_VALIDATE$INT(param list change)  */
ALTER PROCEDURE RES_ACCOUNTS_RECIEVE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
ID_AGENT_ACCOUNT_RULE INTEGER,
ID_BASE_ACCOUNT_PROFILE INTEGER,
ID_EXTRA_ACCOUNT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ID_ACC_TEMPLATE_PERSON INTEGER,
IS_SEPARATE_ACCOUNTS SMALLINT)
 RETURNS(NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty DOCUMENT_INITIALIZE$DOC for DOC_SUPPLIER_SET$DOC(param list change)  */
ALTER PROCEDURE DOCUMENT_INITIALIZE$DOC(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
DOC_SELECTED /* TYPE OF ID */ INTEGER,
PROFORMA_NAME_PREFIX VARCHAR(30) = null)
 RETURNS(ID_DOC_HEAD INTEGER,
ID_HOTEL INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty DOCUMENT_ON_PROFORMA_INIT$DOC for DOCUMENT_CHECK_SELECTION$INT(param list change)  */
ALTER PROCEDURE DOCUMENT_ON_PROFORMA_INIT$DOC(ID_PROFORMA_DOC /* TYPE OF ID */ INTEGER)
 RETURNS(ID_DOC_HEAD /* TYPE OF ID */ INTEGER,
ID_HOTEL /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty DOCUMENT_CREATE$INT for DOCUMENT_COMPLETE$INT(param list change)  */
ALTER PROCEDURE DOCUMENT_CREATE$INT(DOC_SELECTED INTEGER,
ID_ACCOUNT INTEGER,
ID_DOC_TYPE INTEGER,
DOC_TYPE_NAME /* TYPE OF TOBJECT_NAME */ VARCHAR(50),
DOC_DATE DATE,
DOC_CURR VARCHAR(3),
ID_BASE_DOC INTEGER,
TAX_EVENT_DATE DATE,
IS_PROFORMA /* TLOGICAL */ SMALLINT,
ID_ADVANCE_PAYMENT /* ID_REF */ INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER,
DOC_SUB_TYPE SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/*  Empty DEPOSIT_DOCUMENT_INITIALIZE$DOC for DOCUMENT_INITIALIZE$DOC(param list change)  */
ALTER PROCEDURE DEPOSIT_DOCUMENT_INITIALIZE$DOC(ID_PAYMENT_HEAD /* TYPE OF ID */ INTEGER,
ID_BILLING_SERVICE /* TYPE OF ID */ INTEGER)
 RETURNS(ID_DOC_HEAD /* TYPE OF ID */ INTEGER,
ID_HOTEL /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty TEST_DOC for DOCUMENT_INITIALIZE$DOC(param list change)  */
ALTER PROCEDURE TEST_DOC(ID_ACCOUNT INTEGER,
DOC_SELECTED INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty EAI_POS_POSTING_ADD for EAI_POS_POSTING_ADD$P2E(param list change)  */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty HOTEL_AUTO_IMPORT$WBE for HOTEL_MODIFY$CFG(param list change)  */
ALTER PROCEDURE HOTEL_AUTO_IMPORT$WBE(NAME VARCHAR(50),
UUID VARCHAR(40))
 RETURNS(ID_HOTEL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty IMPORT_HOTEL$EXC for HOTEL_MODIFY$CFG(param list change)  */
ALTER PROCEDURE IMPORT_HOTEL$EXC(HOTEL_NAME VARCHAR(50),
IS_USE SMALLINT,
CODE VARCHAR(10),
LETTER_FOOTER BLOB SUB_TYPE 1,
FIRM_DATA BLOB SUB_TYPE 1,
LETTER_HEADER BLOB SUB_TYPE 1,
ORDER_TAG INTEGER,
RES_CONFIRM_TEXT BLOB SUB_TYPE 1,
DOC_PACK_SRV_TEXT VARCHAR(50),
DOC_ONE_LINE_TEXT VARCHAR(50),
MONITOR_MAP BLOB SUB_TYPE 1,
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
UUID VARCHAR(40),
EXTERNAL_TYPE VARCHAR(50),
WBE_ENABLED SMALLINT,
CREATE_IF_NOT_FOUND SMALLINT,
NATION_CURR CHAR(3),
REG_CARD_TEXT BLOB SUB_TYPE 1 = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100),
ID_HOTEL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure ACCOUNT_VALIDATE$INT with new param-list */
ALTER PROCEDURE ACCOUNT_VALIDATE$INT(ID_ACCOUNT TYPE OF ID_REF,
CHECK_OPTIONS TYPE OF TDESCRIPTION_LONG)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100),
ACCOUNT_CURRENCY TYPE OF TCURRENCY,
ID_TAX_POLICY TYPE OF ID_REF,
ID_HOTEL TYPE OF ID_REF,
ACCOUNT_NAME TYPE OF TOBJECT_NAME,
ID_SALE_NUM TYPE OF ID_REF)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure DOC_SUPPLIER_SET$DOC with new param-list */
ALTER PROCEDURE DOC_SUPPLIER_SET$DOC(ID_DOC_HEAD TYPE OF ID)
 AS
 BEGIN EXIT; END
^

/* Alter empty procedure DOCUMENT_CHECK_SELECTION$INT with new param-list */
ALTER PROCEDURE DOCUMENT_CHECK_SELECTION$INT(DOC_SELECTED INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_DOC_TYPE INTEGER,
ID_BASE_DOC INTEGER,
DOC_CURR VARCHAR(3),
ID_DOC_CONTRAGENT INTEGER,
ID_ADVANCE_PAYMENT INTEGER,
CLOSING_WHOLE_ACCOUNT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure DOCUMENT_COMPLETE$INT with new param-list */
ALTER PROCEDURE DOCUMENT_COMPLETE$INT(ID_DOC_HEAD TYPE OF ID,
DOC_DATE TYPE OF TDATE,
TAX_EVENT_DATE TYPE OF TDATE,
ID_DOC_PROFORMA TYPE OF ID_REF,
ID_SALE_NUM TYPE OF ID_REF = null)
 AS
 BEGIN EXIT; END
^

/* Alter empty procedure DOCUMENT_INITIALIZE$DOC with new param-list */
ALTER PROCEDURE DOCUMENT_INITIALIZE$DOC(ID_ACCOUNT TYPE OF ID,
DOC_SELECTED TYPE OF ID,
PROFORMA_NAME_PREFIX VARCHAR(30) = null)
 RETURNS(ID_DOC_HEAD INTEGER,
ID_HOTEL INTEGER,
WARN_CODE INTEGER,
REQUIRE_ARCHIVE_CONFIRMATION TYPE OF TLOGICAL)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure DOCUMENT_VALIDATE$DOC with new param-list */
ALTER PROCEDURE DOCUMENT_VALIDATE$DOC(ID_DOC_HEAD TYPE OF ID_REF,
ARCHIVE_ACCOUNT TYPE OF TLOGICAL = 0)
 RETURNS(FIRM_DATA TYPE OF TNOTE_BLOB,
WARN_CODE TYPE OF TRANGE,
NEW_DOC_DATE TYPE OF TDATE)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure EAI_POS_POSTING_ADD$P2E with new param-list */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30),
UNIQUE_SALES_NUMBER VARCHAR(30) = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure HOTEL_MODIFY$CFG with new param-list */
ALTER PROCEDURE HOTEL_MODIFY$CFG(ID_HOTEL INTEGER,
HOTEL_NAME VARCHAR(50),
IS_USE SMALLINT,
CODE VARCHAR(10),
LETTER_FOOTER BLOB SUB_TYPE 1,
LETTER_HEADER BLOB SUB_TYPE 1,
ID_LOGO INTEGER,
ORDER_TAG INTEGER,
RES_CONFIRM_TEXT BLOB SUB_TYPE 1,
COMPANY_NAME TYPE OF TDESCRIPTION_LONG,
COMPANY_IDENT_NUM TYPE OF TTEXT_SHORT,
COMPANY_VAT_REG_NUM TYPE OF TTEXT_SHORT,
COMPANY_MOL TYPE OF TPERSON_NAME,
COMPANY_ADDRESS TYPE OF TDESCRIPTION_LONG,
DOC_PACK_SRV_TEXT VARCHAR(50),
DOC_ONE_LINE_TEXT VARCHAR(50),
EXTERNAL_TYPE VARCHAR(50),
HOTEL_ADDRESS VARCHAR(100),
OPERATION VARCHAR(10),
NATION_CURR CHAR(3),
REG_CARD_TEXT BLOB SUB_TYPE 1 = null,
USE_DIFFERENT_TT_NUMERATORS TLOGICAL = null,
ACCOMODATION_PLACE_UIN TYPE OF TDESCRIPTION_LONG = null)
 RETURNS(NEW_ID_HOTEL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure RIGHTS_MODIFY_USER with new param-list */
ALTER PROCEDURE RIGHTS_MODIFY_USER(IN_USER_NAME VARCHAR(30),
IN_USER_NAME_LONG VARCHAR(30),
IN_NEW_PASSWORD VARCHAR(8),
LANG_UI VARCHAR(10),
FISCAL_ID INTEGER,
IS_ACTIVE INTEGER,
OPERATION VARCHAR(20),
CODE VARCHAR(50),
USER_POSITION VARCHAR(100))
 AS
 BEGIN EXIT; END
^

/* Alter Procedure... */
/* Alter (ACC_STATEMENT_GET_INFO$PMS) */
ALTER PROCEDURE ACC_STATEMENT_GET_INFO$PMS(FROM_DATE DATE,
TO_DATE DATE,
ID_SERVICE_HL_LIST VARCHAR(255))
 RETURNS(ID_BILL INTEGER,
ID_DOC INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
POST_DATE DATE,
ID_ROOM INTEGER,
ID_OWNER INTEGER,
ROOM_INFO VARCHAR(30),
OWNER_NAME VARCHAR(100),
BILLING_INFO VARCHAR(100),
ID_SERVICE INTEGER,
SERVICE_DESC VARCHAR(100),
DESCRIPTION VARCHAR(300),
REF_DOC_INFO VARCHAR(300),
DEVICE_READING_INFO VARCHAR(300),
INCOME_VALUE NUMERIC(15,4),
INCOME_CURR VARCHAR(3),
OUTGO_VALUE NUMERIC(15,4),
OUTGO_CURR VARCHAR(3),
IS_ANUL SMALLINT,
IS_INVOICED SMALLINT,
ID_EXPORT_HEAD INTEGER)
 AS
declare variable info_delim varchar(3);
  declare variable curr_format varchar(20);
  declare variable res_period_delim varchar(3);
  declare variable short_date_format varchar(20);
  declare variable doc_description varchar(255);
  declare variable id_doc_head integer;
  declare variable id_service_hl_list_found varchar(255);
  declare variable description_event varchar(255);
  declare variable res_number varchar(62);
  declare variable res_from_date date;
  declare variable res_to_date date;
  declare variable res_stay integer;
  declare variable curr_id_room integer;
  declare variable curr_id_owner integer;
begin
  info_delim = '/ ';
  curr_format = 'F;#.00';
  short_date_format = 'D;dd.mm';
  res_period_delim = '-';

  for
    select T.ID_ROOM, T.ID_OWNER
    from   TMP_SELECT$PMS T
    where  T.ID_SESSION = current_transaction
    into   :curr_id_room, :curr_id_owner
  do begin
    id_service_hl_list_found = ',';
    id_doc = null;
    for
      select BH.ID_OWNER_BILL, BR.DATE_POST, BR.ID_ROOM, coalesce(H.CODE, '')||:info_delim||R.ROOM_NAME,
             coalesce(BH.BILL_NUM||', '||formatdate(BH.BILL_DATE,'D;dd/mm/yyyy'), ''), BH.ID_OWNER, P.PROFILE_NAME,
             S.ID_SERVICE, S.SERVICE_NAME, BR.DESCRIPTION, BR.DOC_DESCRIPTION,
             iif(BR.IS_OWNER_INCOME = 1, BR.VALUE_POST, null) as INCOME,
             iif(BR.IS_OWNER_INCOME = 1, BR.CURR_POST, null) as IN_CURR,
             iif(BR.IS_OWNER_INCOME = 0, BR.VALUE_POST, null) as OUTGO,
             iif(BR.IS_OWNER_INCOME = 0, BR.CURR_POST, null) as OUT_CURR, BH.IS_ANUL,
             iif(BR.ID_ACCOUNT_POST is not null, 1, null) as IS_INVOICED,
             RD.NUMBER, PEP.IMP_PERIOD_FROM, PEP.IMP_PERIOD_TO + 1, PEP.IMP_PERIOD_TO - PEP.IMP_PERIOD_FROM + 1,
             BR.ID_ACCOUNT_POST, BR.ID_ACCOUNT_POST_PMS, PEP.ID_EXPORT_HEAD
      from   OWNER_BILL$PMS BH
             left outer join OWNER_BILL_ROW$PMS BR on BH.ID_OWNER_BILL = BR.ID_OWNER_BILL
                                                      and BR.ID_ACCOUNT_POST_PMS is not null
             join PROFILE P on P.ID_PROFILE = BH.ID_OWNER
             left outer join ROOMS R on R.ID_ROOM = BR.ID_ROOM
             left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
             left outer join HOTEL H on H.ID_HOTEL = RT.ID_HOTEL
             left outer join SERVICES S on S.ID_SERVICE = BR.ID_SERVICE
             left outer join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = BR.ID_RESERV_DETAIL
             left outer join ACCOUNT_POST$PMS APP on APP.ID_ACCOUNT_POST = BR.ID_ACCOUNT_POST_PMS
             left outer join PMS_EVENT$PMS PEP on PEP.ID_PMS_EVENT = APP.ID_PMS_EVENT
      where  BH.BILL_DATE between coalesce(:from_date, '01.01.1500') and coalesce(:to_date, '01.01.2500')
             and ((:curr_id_room is null) or (BR.ID_ROOM = :curr_id_room))
             and ((:curr_id_owner is null) or (BH.ID_OWNER = :curr_id_owner))
      into   :ID_BILL, :POST_DATE, :ID_ROOM, :ROOM_INFO, :BILLING_INFO, :ID_OWNER, :OWNER_NAME,
             :ID_SERVICE, :SERVICE_DESC, :DESCRIPTION_EVENT, :DOC_DESCRIPTION,
             :INCOME_VALUE, :INCOME_CURR, :OUTGO_VALUE, :OUTGO_CURR, :IS_ANUL, :IS_INVOICED,
             :res_number, :RES_FROM_DATE, :RES_TO_DATE, :RES_STAY,
             :ID_ACCOUNT_POST, :ID_ACCOUNT_POST_PMS, :ID_EXPORT_HEAD
    do begin
      DESCRIPTION = '';
      ref_doc_info = null;
      for
        select ITEM
        from   SYSTEM_STRING_PARSER(:doc_description,',')
        into   :id_doc_head
      do begin
        select coalesce(:ref_doc_info||'; ','')||DH.DOC_NUM||:info_delim||formatfloat(DH.DOC_VALUE, :curr_format)||' '||DH.DOC_CURRENCY
        from   DOC_HEAD DH
        where  DH.ID_DOC = :id_doc_head
        into   :ref_doc_info;
      end

      select substring(list(DR.ID_DEVICE_READING || ', ' || coalesce(formatdate(DR.DATE_READ, 'dd/mm/yyyy'), ''), :info_delim) from 1 for 300)
      from   DEVICE_READING_POST DRP
             join DEVICE_READING_EVIDENCE DRE on DRE.ID_DEVICE_READING_EVIDENCE = DRP.ID_DEVICE_READING_EVIDENCE
             join DEVICE_READING DR on DR.ID_DEVICE_READING = DRE.ID_DEVICE_READING
      where  DRP.ID_ACCOUNT_POST$PMS = :id_account_post_pms
      into   :device_reading_info;
  
      DESCRIPTION = :res_number||', '
                  ||formatdate(:res_from_date,:short_date_format)||:res_period_delim||:res_stay||:res_period_delim||formatdate(:res_to_date,:short_date_format);
      DESCRIPTION = coalesce(:DESCRIPTION, '');
      DESCRIPTION = iif(:DESCRIPTION = '', :DESCRIPTION, :DESCRIPTION||', ')||coalesce(:DESCRIPTION_EVENT, '');

      if (trim(coalesce(:ID_SERVICE_HL_LIST, '')) = '') then begin
        suspend;
      end else begin
        if (:ID_SERVICE_HL_LIST containing :ID_SERVICE) then begin
          if (:ID_SERVICE_HL_LIST_FOUND not containing :ID_SERVICE and :is_anul = 0) then begin
            id_service_hl_list_found = :id_service_hl_list_found ||:id_service|| ',';
          end
          suspend;
        end
      end
    end

    REF_DOC_INFO = '';
    ID_ACCOUNT_POST_PMS = null;
    INCOME_VALUE = null;
    INCOME_CURR = null;
    for
      select AP.INV_DESCRIPTION, AP.BILLING_INFO, AP.ID_ACCOUNT_POST, AP.DATE_POST,
             AP.ID_OWNER, AP.ID_ROOM, coalesce(H.CODE, '')||:info_delim||R.ROOM_NAME, P.PROFILE_NAME, AP.ID_SERVICE,
             AP.LINE_DESC,
             round_f(AP.POST_VALUE * iif(ap.POST_CURR = o.ID_CURRENCY, 1, (select cr.RATE
                                                                           from   CURR_CROSS_RATE_GET (ap.POST_CURR, o.ID_CURRENCY, ap.DATE_POST, ap.ID_HOTEL) cr)), c.ROUND_TO),
             o.ID_CURRENCY, AP.IS_ANUL, AP.IS_INVOICED,
             AP.ID_BILL, AP.ID_DOC, AP.DEVICE_READING_INFO, AP.ID_EXPORT_HEAD, ap.EVENT_DESCRIPTION
      from   OWNER_POST_INVOICED Ap
             join OWNER$PMS o on o.ID_OWNER = ap.ID_OWNER
             join CURRS c on c.CURR = o.ID_CURRENCY
             left outer join ROOMS R on R.ID_ROOM = AP.ID_ROOM
             left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
             left outer join HOTEL H on H.ID_HOTEL = RT.ID_HOTEL
             join PROFILE P on P.ID_PROFILE = AP.ID_OWNER
      where  AP.DATE_POST between coalesce(:FROM_DATE, '01.01.1500') and coalesce(:TO_DATE, '01.01.2500')
             and ((:curr_id_room is null) or (AP.ID_ROOM = :curr_id_room))
             and ((:curr_id_owner is null) or (AP.ID_OWNER = :curr_id_owner))
      into   :REF_DOC_INFO, :BILLING_INFO, :ID_ACCOUNT_POST, :POST_DATE,
             :ID_OWNER, :ID_ROOM, :ROOM_INFO, :OWNER_NAME, :ID_SERVICE,
             :SERVICE_DESC, :OUTGO_VALUE, :OUTGO_CURR, :IS_ANUL, :IS_INVOICED,
             :ID_BILL, :ID_DOC, :DEVICE_READING_INFO, :ID_EXPORT_HEAD, :DESCRIPTION
    do begin
      if (trim(coalesce(:ID_SERVICE_HL_LIST, '')) = '') then
        suspend;
      else begin
        if (:ID_SERVICE_HL_LIST containing :ID_SERVICE) then begin
          if (:ID_SERVICE_HL_LIST_FOUND not containing :ID_SERVICE and :is_anul = 0) then begin
            id_service_hl_list_found = :id_service_hl_list_found ||:id_service|| ',';
          end
          suspend;
        end
      end
    end
     

    ID_ACCOUNT_POST = null;
    ID_ACCOUNT_POST_PMS = null;
    ID_BILL = null;
    POST_DATE = iif(:TO_DATE = '01.01.2500', null, :TO_DATE-1);
    BILLING_INFO = '';
    DESCRIPTION = 'missing service '||iif(:TO_DATE = '01.01.2500', '', ': billing date '||formatdate(:TO_DATE,'D;dd.mm.yy'));
    REF_DOC_INFO = null;
    INCOME_VALUE = null;
    INCOME_CURR = null;
    OUTGO_VALUE = null;
    OUTGO_CURR = null;
    IS_ANUL = 0;
    IS_INVOICED = null;
  
    for
      select ITEM
      from   SYSTEM_STRING_PARSER(:ID_SERVICE_HL_LIST, ',')
      into   :ID_SERVICE
    do begin
      if (:ID_SERVICE_HL_LIST_FOUND not containing (','||:ID_SERVICE||',')) then begin
        id_service_hl_list_found = :id_service_hl_list_found ||:id_service|| ',';
  
        select S.SERVICE_NAME
        from   SERVICES S
        where  S.ID_SERVICE = :ID_SERVICE
        into   :SERVICE_DESC;
  
        suspend;
      end
    end
  end
end
^

/* Alter (ACC_STATEMENT_INVOICES_GET$PMS) */
ALTER PROCEDURE ACC_STATEMENT_INVOICES_GET$PMS(ID_BILL INTEGER)
 RETURNS(ID_DOC INTEGER,
ID_SERVICE INTEGER,
DATE_POST DATE,
ROOM_NAME VARCHAR(100),
LINE_DESC VARCHAR(100),
OUTGO_VALUE NUMERIC(15,4),
CURR_POST VARCHAR(3),
IS_ANUL SMALLINT,
INV_DESCRIPTION VARCHAR(100))
 AS
declare variable id_hotel integer;
  declare variable sign_ smallint;
  declare variable doc_sub_type smallint;
begin

  for
    select distinct DL.ID_DOC_HEAD, DH.DOC_SUB_TYPE, O.ID_CURRENCY,
           DT.DOC_TYPE_NAME || ' ' || DH.DOC_NUM || ', ' || formatdate(DH.DOC_DATE,'D;dd/mm/yyyy'),
           DH.IS_ANUL, B.ID_SERVICE, a.ID_HOTEL
    from   OWNER_BILL_ROW$PMS B
           join OWNER_BILL$PMS BH on BH.ID_OWNER_BILL = B.ID_OWNER_BILL
           join OWNER$PMS O on O.ID_OWNER = BH.ID_OWNER
           join DOC_LINE_POST_VALUES PV on B.ID_ACCOUNT_POST = PV.ID_ACCOUNT_POST
           join DOC_LINE DL on PV.ID_DOC_LINE = DL.ID_DOC_LINE
           join DOC_HEAD DH on DH.ID_DOC = DL.ID_DOC_HEAD
           join ACCOUNT A on A.ID_ACCOUNT = dh.ID_ACCOUNT
           join DOC_TYPE DT on DT.ID_DOC_TYPE = DH.ID_DOC_TYPE
    where  B.ID_OWNER_BILL = :ID_BILL
           and B.ID_ACCOUNT_POST is not null
    into   :id_doc, :doc_sub_type, :CURR_POST, :INV_DESCRIPTION, :IS_ANUL, :ID_SERVICE, :id_hotel
  do begin
    select case when SGV.SETTING_VALUE = 'AS_POSITIVE' and :DOC_SUB_TYPE = 2 then -1 else 1 end
    from   SETTING_GET_VALUE('VIEW_STORNO_SUMS_IN_DOCUMENTS', :id_hotel) SGV
    into   :sign_;

    for
      select
        DL.LINE_NAME,
        DL.ROOM_NAME,
        DL.DATE_POST,
        DL.LINE_VALUE as line_sum
      from
        DOC_LINES_SUSPEND (:ID_DOC, :sign_, '', 'details', 'acc', 'as_doc', 0) DL
      order by
        DL.IS_FOR_PAY asc, DL.DATE_POST, DL.IS_BASE desc, DL.ROOM_NAME, DL.LINE_NAME asc
      into :LINE_DESC,
           :ROOM_NAME,
           :DATE_POST,
           :OUTGO_VALUE
    do begin
      suspend;
    end
  end

end
^

/* Alter (ACCOUNT_CHECK_CREDIT_STATUS$INT) */
ALTER PROCEDURE ACCOUNT_CHECK_CREDIT_STATUS$INT(ID_ACCOUNT TYPE OF ID_REF,
POST_VALUE TYPE OF TPRICE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_credit_account integer;
  declare variable id_reserv_detail integer;
  declare variable credit_limit tprice;
  declare variable b_post_sum tprice;
  declare variable b_pay_sum tprice;
  declare variable difference_value tprice;
  declare variable no_use varchar(255);
  declare variable account_currency tcurrency;
  declare variable round_to numeric(15,4);
begin
  if (:POST_VALUE = 0) then exit;

  select a.IS_CREDIT_ACCOUNT, a.CREDIT_LIMIT, a.ID_RESERV_DETAIL
  from   ACCOUNT A
  where  a.ID_ACCOUNT = :ID_ACCOUNT
  into   :is_credit_account, :credit_limit, :id_reserv_detail;

  if (:is_credit_account = 0
      and exists (select rd.ID_RESERV_DETAIL
                  from   RESERV_DETAIL rd
                  where  rd.ID_RESERV_DETAIL = :id_reserv_detail
                         and rd.CHECK_STATUS = 1)) then
  begin
    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, :credit_limit, 1);
  end

  if (coalesce(:credit_limit, 0) > 0) then begin
    /* FIND BALANCE OF ACCOUNT */
    execute procedure ACCOUNT_BALANCE$INT(:id_account)
    returning_values  :account_currency, :round_to, :no_use, :b_post_sum, :b_pay_sum, :no_use, :no_use;
    b_post_sum = coalesce(:b_post_sum, 0);
    b_pay_sum  = coalesce(:b_pay_sum, 0);

    /* IS THIS POST IS IN LIMIT */
    if ((:b_post_sum + :POST_VALUE) > :credit_limit) then begin
      err_code = -13; /*  */
      difference_value = :b_post_sum + :POST_VALUE - :credit_limit;
      err_text = f_character(29)||FormatFloat(:credit_limit, :round_to)||' '||:account_currency||
                 f_character(28)||FormatFloat(:difference_value, :round_to);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: SUMMARY_FINANCE_STATISTIC$EW for: ACCOUNT_DEBT_FILL$INT */
ALTER PROCEDURE SUMMARY_FINANCE_STATISTIC$EW(ID_END_WORK INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_DEBT_FILL$INT) */
ALTER PROCEDURE ACCOUNT_DEBT_FILL$INT(ID_END_WORK INTEGER)
 AS
declare variable id_account_post integer;
  declare variable id_account integer;
  declare variable id_sale_taxation integer;
  declare variable is_primary_post integer;
  declare variable date_post date;
  declare variable id_service integer;
  declare variable revenue_group varchar(50);
  declare variable revenue_account varchar(50);
  declare variable revenue_sub_account varchar(50);
  declare variable curr_post varchar(3);
  declare variable post_amount double precision;
  declare variable nat_net_value numeric(15,4);
  declare variable nat_gross_value numeric(15,4);
  declare variable id_hotel integer;
  declare variable id_guest integer;
  declare variable ew_date date;
  declare variable post_type varchar(10);
  declare variable round_to numeric(15,4);
  declare variable qty_post tqty;
  declare variable rev_deduction_tax_value tprice;
  declare variable nat_round_to tprice;
begin
  select EW.PREV_DATE, EW.ID_HOTEL, c.ROUND_TO
  from   END_WORKS EW
         join HOTEL h on h.ID_HOTEL = ew.ID_HOTEL
         join CURRS  c on c.CURR = h.NATION_CURR
  where  EW.ID_END_WORK = :ID_END_WORK
  into   :EW_DATE, :ID_HOTEL, :nat_round_to;

  for
    select  AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_SALE_TAXATION, AP.DATE_POST,
            iif(AP.ID_ACCOUNT_POST = AP.SEQUENCE_ID, 1, 0), AP.ID_SERVICE, AP.ID_GUEST, AP.CURR_POST,
            S.REVENUE_GROUP, RA.REVENUE_ACCOUNT, RA.REVENUE_SUB_ACCOUNT, AP.POST_TYPE,
            sum(PRA.OUT_POST_AMOUNT), sum(PRA.OUT_POST_NET_VALUE), sum(PRA.OUT_POST_GROSS_VALUE),
            max(ap.QTY_POST)
    from    SERVICE_POSTING_REVENUE$INT (:ID_END_WORK) AP
            left outer join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
            left outer join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
            left outer join GUEST G on G.ID_GUEST = AP.ID_GUEST
            left outer join PROFILE_HOUSE PH on PH.ID_PROFILE = A.ID_PROFILE
            left outer join REVENUE_ACCOUNT_PARSE$INT (S.REVENUE_ACCOUNT, coalesce(G.ID_RESERV_DETAIL, A.ID_RESERV_DETAIL)) RA on 1=1
            left outer join ACCOUNT_POST_REVENUE_GET$INT (AP.POST_DBKEY, AP.QTY_POST * cast(AP.PRICE_POST as double precision),
                            AP.POST_NET_VALUE, AP.POST_GROSS_VALUE,
                            S.REVENUE_GROUP, RA.REVENUE_ACCOUNT, RA.REVENUE_SUB_ACCOUNT) PRA on 1=1
    where   PH.HOUSE_TYPE is distinct from 'hptComplimentary'
    group by 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12
    union all
    select  DR.ID_ACCOUNT_POST, DR.ID_ACCOUNT, DR.ID_SALE_TAXATION, DR.DATE_POST,
            iif(DR.ID_ACCOUNT_POST is null , 1, 0), DR.ID_SERVICE, DR.ID_GUEST, DR.ACC_CURR,
            S.REVENUE_GROUP, RA.REVENUE_ACCOUNT, RA.REVENUE_SUB_ACCOUNT, DR.POST_TYPE,
            sum(DR.ACC_POST_AMOUNT), sum(DR.NET_VALUE), sum(DR.GROSS_VALUE),
            max(dr.QTY_POST)
    from    DOCUMENT_REVENUE DR
            left outer join SERVICES S on S.ID_SERVICE = DR.ID_SERVICE
            left outer join ACCOUNT A on A.ID_ACCOUNT = DR.ID_ACCOUNT
            left outer join GUEST G on G.ID_GUEST = DR.ID_GUEST
            left outer join PROFILE_HOUSE PH on PH.ID_PROFILE = A.ID_PROFILE
            left outer join REVENUE_ACCOUNT_PARSE$INT (S.REVENUE_ACCOUNT, coalesce(G.ID_RESERV_DETAIL, A.ID_RESERV_DETAIL)) RA on 1=1
    where   DR.DOC_DATE = :EW_DATE
            and DR.ID_HOTEL = :ID_HOTEL
            and PH.HOUSE_TYPE is distinct from 'hptComplimentary'
    group by 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12
--    order by 1 asc nulls last -- get postings and corrections first, ascending
    into   :id_account_post, :id_account, :id_sale_taxation, :date_post,
           :is_primary_post, :id_service, :id_guest, :curr_post,
           :revenue_group, :revenue_account, :revenue_sub_account, :post_type,
           :post_amount, :nat_net_value, :nat_gross_value, :qty_post
  do begin
    select c.ROUND_TO
    from   CURRS c
    where  c.CURR = :curr_post
    into   :round_to;

    if ((round_f (:post_amount, :round_to/10) <> 0) or (:nat_net_value <> 0) or (:nat_gross_value <> 0) ) then begin
      select sum(rd.TAX_AMOUNT)
      from   REVENUE_DEDUCTION_TAXES$INT (:nat_gross_value, iif(:is_primary_post = 1, :qty_post, 0), :nat_round_to, :id_sale_taxation) rd
      into   :rev_deduction_tax_value;

      insert into ACCOUNT_DEBT (ID_ACCOUNT, ID_SERVICE, ID_SALE_TAXATION, DEBT_DATE, POST_DATE, POST_CURR,
             POST_AMOUNT, NAT_NET_VALUE, NAT_GROSS_VALUE, ID_ACCOUNT_POST, IS_PRIMARY_POST, ID_GUEST,
             REVENUE_GROUP, REVENUE_ACCOUNT, REVENUE_SUB_ACCOUNT, POST_TYPE, ID_HOTEL,
             REVENUE_DEDUCTION_TAX_VALUE)
      values (:id_account, :id_service, :id_sale_taxation, :ew_date, :date_post, :curr_post,
             :post_amount, :nat_net_value, :nat_gross_value, :id_account_post, :is_primary_post, nullif(:id_guest, -1),
             :revenue_group, :revenue_account, :revenue_sub_account, :post_type, :id_hotel,
             :rev_deduction_tax_value);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: DOC_CONTRAGENT_INITIALIZE$INT for: ACCOUNT_GET_CONTRAGENT_DATA$INT */
ALTER PROCEDURE DOC_CONTRAGENT_INITIALIZE$INT(ID_DOC INTEGER,
ID_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_GET_CONTRAGENT_DATA$INT) */
ALTER PROCEDURE ACCOUNT_GET_CONTRAGENT_DATA$INT(ID_ACCOUNT INTEGER)
 RETURNS(ID_CONTRAGENT INTEGER,
IS_JURIDICAL_PERSON SMALLINT,
CONTRAGENT_NAME VARCHAR(100),
VAT_REG_NUM VARCHAR(30),
IDENT_NO VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(100),
RECIPIENT_NAME VARCHAR(100),
RECIPIENT_PAS_NUM VARCHAR(20),
RECIPIENT_PAS_DATE DATE,
RECIPIENT_PAS_FROM VARCHAR(30),
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30))
 AS
declare variable profile_type varchar(20);
  declare variable id_doc_contragent_last integer;
  declare variable id_profile integer;
begin
  IS_JURIDICAL_PERSON = 0;
  BANK_NAME = null;
  BIC = null;
  IBAN = null;

  select P.PROFILE_TYPE, p.ID_PROFILE,
         coalesce(a.ID_CONTRAGENT, P.ID_DEF_CONTRAGENT) as id_contragent,
         (select first 1 D.ID_DOC_CONTRAGENT
          from   ACCOUNT A
                 join DOC_HEAD D on D.ID_ACCOUNT = A.ID_ACCOUNT
          where  A.ID_PROFILE = P.ID_PROFILE
          order by D.DOC_DATE desc, D.DATETIME_CREATED desc) as last_doc_contragent
  from   ACCOUNT a
         join PROFILE P on p.ID_PROFILE = a.ID_PROFILE
  where  a.ID_ACCOUNT = :ID_ACCOUNT
  into   :profile_type, :id_profile, :id_contragent, :id_doc_contragent_last;

  if (:profile_type = 'HOUSE') then begin
    ID_CONTRAGENT = null;
    EXIT;
  end

  if (:id_contragent is not null) then begin
    select C.ID_CONTRAGENT, C.IS_JURIDICAL_PERSON, C.CONTRAGENT_NAME, C.VAT_REG_NUM, C.IDENT_NO,
           C.COUNTRY, C.POST_ADDRESS, C.ZIP_CODE, C.MOL, c.BANK_NAME, c.BIC, c.IBAN, c.EMAIL
    from   CONTRAGENTS C
    where  C.ID_CONTRAGENT = :ID_CONTRAGENT
    into   :ID_CONTRAGENT, :IS_JURIDICAL_PERSON, :CONTRAGENT_NAME, :VAT_REG_NUM, :IDENT_NO,
           :COUNTRY_CODE, :POST_ADDRESS, :ZIP_CODE, :MOL, :BANK_NAME, :BIC, :IBAN, :EMAIL;

  end else if (:id_doc_contragent_last is not null) then begin
    select DC.ID_CONTRAGENT, DC.IS_JURIDICAL_PERSON, DC.CONTRAGENT_NAME, DC.VAT_REG_NUM, DC.IDENT_NO,
           DC.COUNTRY_CODE, DC.POST_ADDRESS, DC.ZIP_CODE, DC.MOL, DC.RECIPIENT_NAME,
           DC.RECIPIENT_PAS_NUM, DC.RECIPIENT_PAS_DATE, DC.RECIPIENT_PAS_FROM,
           DC.BANK_NAME, DC.BIC, DC.IBAN, dc.EMAIL
    from   DOC_CONTRAGENT DC
    where  DC.ID_DOC_CONTRAGENT = :id_doc_contragent_last
    into   :ID_CONTRAGENT, :IS_JURIDICAL_PERSON, :CONTRAGENT_NAME, :VAT_REG_NUM, :IDENT_NO,
           :COUNTRY_CODE, :POST_ADDRESS, :ZIP_CODE, :MOL, :RECIPIENT_NAME,
           :RECIPIENT_PAS_NUM, :RECIPIENT_PAS_DATE, :RECIPIENT_PAS_FROM,
           :BANK_NAME, :BIC, :IBAN, :EMAIL;

  end else if (:profile_type = 'PERSON') then begin
    select GF.PERSON_NAME, GF.COUNTRY_CODE, GF.EGN, substring(GF.CITY || ' ' || GF.ADDRESS from 1 for 100),
           GF.PERSON_NAME, GF.PASS_NUM, GF.PASS_DATE, GF.PASS_PLACE, P.EMAIL
    from   PROFILE_PERSON PP
           join PERSON_DATA GF on GF.ID_PERSON_DATA = PP.ID_PERSON_DATA
           join PROFILE P on P.ID_PROFILE = PP.ID_PROFILE
    where  PP.ID_PROFILE = :ID_PROFILE
    into   :CONTRAGENT_NAME, :COUNTRY_CODE, :IDENT_NO, :POST_ADDRESS,
           :RECIPIENT_NAME, :RECIPIENT_PAS_NUM, :RECIPIENT_PAS_DATE, :RECIPIENT_PAS_FROM, :EMAIL;
     
  end else if (:profile_type = 'AGENT') then begin
    select P.PROFILE_NAME, '', '',
           null, null, null, null, P.EMAIL
    from   PROFILE_AGENT PA
           join PROFILE P on P.ID_PROFILE = PA.ID_PROFILE
    where  PA.ID_PROFILE = :ID_PROFILE
    into   :CONTRAGENT_NAME, :COUNTRY_CODE, :POST_ADDRESS,
           :RECIPIENT_NAME, :RECIPIENT_PAS_NUM, :RECIPIENT_PAS_DATE, :RECIPIENT_PAS_FROM, :EMAIL;
  end

   
end
^

/* Alter (ACCOUNT_MANIP_VIEW) */
ALTER PROCEDURE ACCOUNT_MANIP_VIEW(IN_IS_CLOSED SMALLINT,
IN_ID_ACCOUNTS VARCHAR(5000),
IN_IS_ANUL SMALLINT,
IN_INCLUDE SMALLINT,
IN_ID_DOC_HEAD INTEGER)
 RETURNS(OUT_ID_SERVICE INTEGER,
OUT_SERVICE_NAME VARCHAR(100),
OUT_IS_BASE INTEGER,
OUT_ID_ACCOUNT_POST INTEGER,
OUT_ID_CORRECT_POST INTEGER,
OUT_ID_ACCOUNT INTEGER,
OUT_ROOM_NAME VARCHAR(10),
OUT_GUEST_NAME VARCHAR(50),
OUT_QTY_POST NUMERIC(15,4),
OUT_QTY_FREE NUMERIC(15,4),
OUT_PRICE_POST NUMERIC(15,4),
OUT_SUM_PRICE NUMERIC(15,4),
OUT_QTY_POST_ORIG NUMERIC(15,4),
OUT_QTY_FREE_ORIG NUMERIC(15,4),
OUT_PRICE_POST_ORIG NUMERIC(15,4),
OUT_SUM_PRICE_ORIG NUMERIC(15,4),
OUT_DATE_POST DATE,
OUT_CURR_POST VARCHAR(3),
OUT_IS_ANUL INTEGER,
OUT_IS_CORRECT SMALLINT,
OUT_ID_SERVICE_GROUP INTEGER,
OUT_SRV_GROUP_NAME VARCHAR(100),
OUT_ID_ROOM INTEGER,
OUT_ID_GUEST INTEGER,
OUT_USER_CHANGED VARCHAR(30),
OUT_DATETIME_CHANGED TIMESTAMP,
OUT_CHANGE_TEXT VARCHAR(20),
OUT_PREV_POST VARCHAR(30),
OUT_DATE_CAME DATE)
 AS
declare variable QTY_CORRECT numeric(15,4);
  declare variable EXTRA_CORRECT numeric(15,4);
  declare variable PRICE_CORRECT numeric(15,4);
  declare variable MY_ID_ACCOUNT integer;
  declare variable STRCORRECTION varchar(50);
  declare variable STRCORR varchar(50);
  declare variable STR1 varchar(4);
  declare variable OLD_ID_GUEST integer;
  declare variable OLD_ID_SERVICE integer;
  declare variable IS_POSITIVE integer;
  declare variable round_to numeric(15,4);
begin
  if (:IN_IS_CLOSED = -1) then STR1 = cast(:IN_IS_ANUL as char(1)) || '%';
  else STR1 = cast(:IN_IS_ANUL as char(1)) || cast(:IN_IS_CLOSED as char(1));

  STRCORRECTION = '@{rep.acc.correction}';

  for
    select cast(ITEM as integer)
    from   SYSTEM_STRING_PARSER(:IN_ID_ACCOUNTS, 'x')
    into   :MY_ID_ACCOUNT
  do begin
    select c.ROUND_TO
    from   ACCOUNT A
           join CURRS C on c.CURR = a.ACCOUNT_CURR
    where  a.ID_ACCOUNT = :MY_ID_ACCOUNT
    into   :round_to;

    if (:IN_INCLUDE in (0, 2)) then begin
      OLD_ID_GUEST =  null ;
      OLD_ID_SERVICE = null;
      if (:IN_ID_DOC_HEAD = -1) then begin
        for
          select  AP.ID_ACCOUNT_POST, -1, AP.ID_ACCOUNT, AP.ID_SERVICE, AP.IS_BASE,
                  AP.DATE_POST, AP.USER_CHANGED, AP.DATETIME_CHANGED, substring(AP.CHANGED_TEXT from 1 for 20), AP.ORIGINAL_POST,
                  AP.QTY_POST, AP.QTY_FREE, round_f(AP.PRICE_POST, :round_to),round_f((AP.QTY_POST - AP.QTY_FREE)*AP.PRICE_POST, :round_to),
                  AP.CURR_POST, AP.IS_ANUL, 0, AP.ID_GUEST, AP.ROOM_NAME
          from    ACCOUNT_POST AP
          where   AP.ID_ACCOUNT = :MY_ID_ACCOUNT
                  and AP.AC like :STR1
          order by AP.ID_GUEST asc nulls last, AP.ID_SERVICE asc
          into    :OUT_ID_ACCOUNT_POST, :OUT_ID_CORRECT_POST, :OUT_ID_ACCOUNT, :OUT_ID_SERVICE,  :OUT_IS_BASE,
                  :OUT_DATE_POST, :OUT_USER_CHANGED, :OUT_DATETIME_CHANGED, :OUT_CHANGE_TEXT, :OUT_PREV_POST,
                  :OUT_QTY_POST, :OUT_QTY_FREE, :OUT_PRICE_POST, :OUT_SUM_PRICE,
                  :OUT_CURR_POST, :OUT_IS_ANUL, :OUT_IS_CORRECT, :OUT_ID_GUEST, :OUT_ROOM_NAME
        do begin
          /* EXTRA DATA */
          if (:OLD_ID_GUEST is distinct from :OUT_ID_GUEST) then begin
             OUT_DATE_CAME = null;
             OUT_ID_ROOM = null;
             OUT_GUEST_NAME = null;
             select G.FROM_DATE , G.ID_ROOM, GC.GUEST_NAME1
             from   GUEST G
                    left outer join GUEST_CARD GC on G.ID_GUEST = GC.ID_GUEST
             where  G.ID_GUEST = :OUT_ID_GUEST
             into   :OUT_DATE_CAME, :OUT_ID_ROOM, :OUT_GUEST_NAME;
          end
          if ((:OLD_ID_SERVICE is null) or (:OUT_ID_SERVICE <> :OLD_ID_SERVICE)) then  begin
            select S.SERVICE_NAME, S.ID_SERVICE_GROUP, SG.GROUP_NAME
            from   SERVICES S
                   left outer join SERVICE_GROUPS SG on S.ID_SERVICE_GROUP = SG.ID_SERVICE_GROUP
            where  S.ID_SERVICE = :OUT_ID_SERVICE
            into   :OUT_SERVICE_NAME, :OUT_ID_SERVICE_GROUP, :OUT_SRV_GROUP_NAME;
          end
          OLD_ID_GUEST =  :OUT_ID_GUEST ;
          OLD_ID_SERVICE = :OUT_ID_SERVICE;
          if (:IN_IS_CLOSED = 1)  then begin
             select sum(APC.IS_QTY_CORRECT * (APC.IS_POSITIVE * 2-1) * APC.QTY_CORRECT),
                    sum(APC.IS_QTY_CORRECT * APC.EXTRA_QTY_CORRECT),
                    round_f(sum(APC.IS_PRICE_CORRECT * (APC.IS_POSITIVE * 2-1) * APC.PRICE_CORRECT), :round_to)
             from   ACCOUNT_POST_CORRECTION APC
             where  APC.ID_ACCOUNT_POST = :OUT_ID_ACCOUNT_POST
                    and ((APC.IS_OPEN) = 1 or (APC.ID_DOC_HEAD > 0))
             into   :QTY_CORRECT, :EXTRA_CORRECT, :PRICE_CORRECT;
             if (:QTY_CORRECT <> 0) then OUT_QTY_POST_ORIG = :OUT_QTY_POST - :QTY_CORRECT;
              else OUT_QTY_POST_ORIG = null;
             if (:EXTRA_CORRECT <> 0) then OUT_QTY_FREE_ORIG = :OUT_QTY_FREE - :EXTRA_CORRECT ;
              else OUT_QTY_FREE_ORIG = null;
             if (:PRICE_CORRECT <> 0) then OUT_PRICE_POST_ORIG = round_f(:OUT_PRICE_POST - :PRICE_CORRECT, :round_to);
              else OUT_PRICE_POST_ORIG = null;
             if (:QTY_CORRECT <> 0 or :EXTRA_CORRECT <> 0 or :PRICE_CORRECT <> 0) then OUT_SUM_PRICE_ORIG = round_f((:OUT_QTY_POST - :OUT_QTY_FREE) * :OUT_PRICE_POST, :round_to);
              else OUT_SUM_PRICE_ORIG = null;
          end
          if (:IN_IS_CLOSED = -1)  then begin
             select sum(APC.IS_QTY_CORRECT * (APC.IS_POSITIVE * 2 - 1) * APC.QTY_CORRECT),
                    sum(APC.IS_QTY_CORRECT * APC.EXTRA_QTY_CORRECT),
                    round_f(sum(APC.IS_PRICE_CORRECT * (APC.IS_POSITIVE * 2 - 1) * APC.PRICE_CORRECT), :round_to)
             from   ACCOUNT_POST_CORRECTION APC
             where  APC.ID_ACCOUNT_POST = :OUT_ID_ACCOUNT_POST
                    and ((APC.IS_OPEN) = 1 or (APC.ID_DOC_HEAD > 0))
             into   :QTY_CORRECT, :EXTRA_CORRECT, :PRICE_CORRECT;
             if (:QTY_CORRECT <> 0) then OUT_QTY_POST = :OUT_QTY_POST - :QTY_CORRECT;
             if (:EXTRA_CORRECT <> 0) then OUT_QTY_FREE = :OUT_QTY_FREE - :EXTRA_CORRECT;
             if (:PRICE_CORRECT <> 0) then OUT_PRICE_POST = round_f(:OUT_PRICE_POST - :PRICE_CORRECT, :round_to);
             if (:QTY_CORRECT <> 0 or :EXTRA_CORRECT <> 0 or :PRICE_CORRECT <> 0) then OUT_SUM_PRICE = round_f((:OUT_QTY_POST - :OUT_QTY_FREE) * :OUT_PRICE_POST, :round_to);
          end
          suspend;
        end
      end else begin
        /* JOIN TO DOCUMENT */
        for
          select  AP.ID_ACCOUNT_POST, -1, AP.ID_ACCOUNT, AP.ID_SERVICE,  AP.IS_BASE,
                  AP.DATE_POST, AP.USER_CHANGED, AP.DATETIME_CHANGED, substring(AP.CHANGED_TEXT from 1 for 20), AP.ORIGINAL_POST,
                  AP.QTY_POST, AP.QTY_FREE, round_f(AP.PRICE_POST, :round_to),round_f((AP.QTY_POST - AP.QTY_FREE)*AP.PRICE_POST, :round_to),
                  AP.CURR_POST, AP.IS_ANUL, 0, AP.ID_GUEST, AP.ROOM_NAME
          from    ACCOUNT_POST AP /* left outer join DOC_LINES DL on ap.ID_ACCOUNT_POST = dl.ID_ACCOUNT_POST*/
          where   AP.ID_BASE_DOC = :IN_ID_DOC_HEAD
                  and AP.ID_ACCOUNT = :MY_ID_ACCOUNT
                  and AP.AC like :STR1
                  /*and DL.IS_CORRECT = 0
                  and DL.ID_DOC_HEAD = :IN_ID_DOC_HEAD */
          order by AP.ID_GUEST asc nulls last, AP.ID_SERVICE asc
          into    :OUT_ID_ACCOUNT_POST, :OUT_ID_CORRECT_POST, :OUT_ID_ACCOUNT, :OUT_ID_SERVICE,  :OUT_IS_BASE,
                  :OUT_DATE_POST, :OUT_USER_CHANGED, :OUT_DATETIME_CHANGED, :OUT_CHANGE_TEXT, :OUT_PREV_POST,
                  :OUT_QTY_POST, :OUT_QTY_FREE, :OUT_PRICE_POST, :OUT_SUM_PRICE,
                  :OUT_CURR_POST, :OUT_IS_ANUL, :OUT_IS_CORRECT, :OUT_ID_GUEST, :OUT_ROOM_NAME
        do begin
          /* EXTRA DATA */
          if (:OLD_ID_GUEST is distinct from :OUT_ID_GUEST) then begin
             OUT_DATE_CAME = null;
             OUT_ID_ROOM = null;
             OUT_GUEST_NAME = null;
             select G.FROM_DATE , G.ID_ROOM, GC.GUEST_NAME1
             from   GUEST G
                    left outer join GUEST_CARD GC on G.ID_GUEST = GC.ID_GUEST
             where  G.ID_GUEST = :OUT_ID_GUEST
             into  :OUT_DATE_CAME, :OUT_ID_ROOM, :OUT_GUEST_NAME;
          end
          if ((:OLD_ID_SERVICE is null) or (:OUT_ID_SERVICE <> :OLD_ID_SERVICE)) then  begin
            select S.SERVICE_NAME, S.ID_SERVICE_GROUP, SG.GROUP_NAME
            from   SERVICES S
                   left outer join SERVICE_GROUPS SG on S.ID_SERVICE_GROUP = SG.ID_SERVICE_GROUP
            where  S.ID_SERVICE = :OUT_ID_SERVICE
            into   :OUT_SERVICE_NAME, :OUT_ID_SERVICE_GROUP, :OUT_SRV_GROUP_NAME;
          end
          OLD_ID_GUEST =  :OUT_ID_GUEST ;
          OLD_ID_SERVICE = :OUT_ID_SERVICE;

          if (:IN_IS_CLOSED = 1)  then begin
             select sum(APC.IS_QTY_CORRECT * (APC.IS_POSITIVE * 2 - 1) * APC.QTY_CORRECT),
                    sum(APC.IS_QTY_CORRECT * APC.EXTRA_QTY_CORRECT),
                    round_f(sum(APC.IS_PRICE_CORRECT * (APC.IS_POSITIVE * 2 - 1) * APC.PRICE_CORRECT), :round_to)
             from   ACCOUNT_POST_CORRECTION APC
             where  APC.ID_ACCOUNT_POST = :OUT_ID_ACCOUNT_POST
                    and ((APC.IS_OPEN) = 1 or (APC.ID_DOC_HEAD > 0))
             into   :QTY_CORRECT, :EXTRA_CORRECT, :PRICE_CORRECT;
             if (:QTY_CORRECT <> 0) then OUT_QTY_POST_ORIG = :OUT_QTY_POST - :QTY_CORRECT;
              else OUT_QTY_POST_ORIG = null;
             if (:EXTRA_CORRECT <> 0) then OUT_QTY_FREE_ORIG = :OUT_QTY_FREE - :EXTRA_CORRECT;
              else OUT_QTY_FREE_ORIG = null;
             if (:PRICE_CORRECT <> 0) then OUT_PRICE_POST_ORIG = round_f(:OUT_PRICE_POST - :PRICE_CORRECT, :round_to);
              else OUT_PRICE_POST_ORIG = null;
             if (:QTY_CORRECT <> 0 or :EXTRA_CORRECT <> 0 or :PRICE_CORRECT <> 0) then OUT_SUM_PRICE_ORIG = round_f((:OUT_QTY_POST - :OUT_QTY_FREE) * :OUT_PRICE_POST, :round_to);
              else OUT_SUM_PRICE_ORIG = null;
          end
          if (:IN_IS_CLOSED = -1)  then begin
             select sum(APC.IS_QTY_CORRECT * (APC.IS_POSITIVE * 2 - 1) * APC.QTY_CORRECT),
                    sum(APC.IS_QTY_CORRECT * APC.EXTRA_QTY_CORRECT),
                    round_f(sum(APC.IS_PRICE_CORRECT * (APC.IS_POSITIVE * 2 - 1) * APC.PRICE_CORRECT), :round_to)
             from   ACCOUNT_POST_CORRECTION APC
             where  APC.ID_ACCOUNT_POST = :OUT_ID_ACCOUNT_POST
                    and ((APC.IS_OPEN) = 1 or (APC.ID_DOC_HEAD > 0))
             into   :QTY_CORRECT, :EXTRA_CORRECT, :PRICE_CORRECT;
             if (:QTY_CORRECT <> 0) then OUT_QTY_POST = :OUT_QTY_POST - :QTY_CORRECT;
             if (:EXTRA_CORRECT <> 0) then OUT_QTY_FREE = :OUT_QTY_FREE - :EXTRA_CORRECT;
             if (:PRICE_CORRECT <> 0) then OUT_PRICE_POST = round_f(:OUT_PRICE_POST - :PRICE_CORRECT, :round_to);
             if (:QTY_CORRECT <> 0 or :EXTRA_CORRECT <> 0 or :PRICE_CORRECT <> 0) then OUT_SUM_PRICE = round_f((:OUT_QTY_POST - :OUT_QTY_FREE) * :OUT_PRICE_POST, :round_to);
          end
          suspend;
        end
      end
    end
    /* ACCOUNT POST CORRECTIONS  */
    if (:IN_INCLUDE in (1, 2)) then begin
      OUT_QTY_POST_ORIG = null;
      OUT_QTY_FREE_ORIG = null;
      OUT_PRICE_POST_ORIG = null;
      OUT_SUM_PRICE_ORIG = null;
      OLD_ID_GUEST =  null ;
      OLD_ID_SERVICE = null;
      if (:IN_ID_DOC_HEAD = -1) then begin
        for
          select APC.ID_ACCOUNT_POST, APC.ID_ACC_POST_CORRECT, APC.ID_ACCOUNT, APC.ID_SERVICE,  0, APC.IS_POSITIVE,
                 APC.CORRECTION_DATE, APC.USER_CORRECT, APC.CORRECTION_DATE, substring(APC.REASON_OF_CORRECT from 1 for 20), null,
                 round_f((APC.QTY_CORRECT*APC.IS_QTY_CORRECT + APC.NEW_QTY*APC.IS_PRICE_CORRECT)*(1 + APC.IS_QTY_CORRECT*(APC.IS_POSITIVE - 1)*2), :round_to) SUM_QTY,
                 round_f(APC.EXTRA_QTY_CORRECT, :round_to) SUM_EXTRA_QTY,
                 round_f((APC.PRICE_CORRECT*APC.IS_PRICE_CORRECT + APC.NEW_PRICE*APC.IS_QTY_CORRECT)*(1 + APC.IS_PRICE_CORRECT*(APC.IS_POSITIVE - 1)*2), :round_to) PRICE,
                 round_f((APC.QTY_CORRECT*APC.NEW_PRICE + APC.NEW_QTY*APC.PRICE_CORRECT)*(APC.IS_POSITIVE*2 - 1), :round_to) SUM_QTY_PRICE,
                 APC.NEW_CURR_POST, 0, 1 + APC.IS_PRICE_CORRECT, APC.ID_GUEST, AP.ROOM_NAME
          from   ACCOUNT_POST_CORRECTION APC
                 join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = APC.ID_ACCOUNT_POST
          where   APC.ID_ACCOUNT = :MY_ID_ACCOUNT
                 and ((APC.IS_OPEN = (1 - :IN_IS_CLOSED)) or (:IN_IS_CLOSED = -1))
                 and (APC.ID_DOC_HEAD + APC.IS_OPEN) > -1
                 and :IN_IS_ANUL = 0
          into   :OUT_ID_ACCOUNT_POST, :OUT_ID_CORRECT_POST, :OUT_ID_ACCOUNT, :OUT_ID_SERVICE, :OUT_IS_BASE, :IS_POSITIVE,
                 :OUT_DATE_POST, :OUT_USER_CHANGED, :OUT_DATETIME_CHANGED, :OUT_CHANGE_TEXT, :OUT_PREV_POST,
                 :OUT_QTY_POST, :OUT_QTY_FREE, :OUT_PRICE_POST, :OUT_SUM_PRICE,
                 :OUT_CURR_POST, :OUT_IS_ANUL, :OUT_IS_CORRECT, :OUT_ID_GUEST, :OUT_ROOM_NAME
        do begin
          if (:OLD_ID_GUEST is distinct from :OUT_ID_GUEST) then begin
            OUT_DATE_CAME = null;
            OUT_ID_ROOM = null;
            OUT_GUEST_NAME = null;
            select G.FROM_DATE, G.ID_ROOM, GC.GUEST_NAME1
            from   GUEST G
                   left outer join GUEST_CARD GC on G.ID_GUEST = GC.ID_GUEST
            where  G.ID_GUEST = :OUT_ID_GUEST
            into  :OUT_DATE_CAME, :OUT_ID_ROOM, :OUT_GUEST_NAME;
          end
          if ((:OLD_ID_SERVICE is null) or (:OUT_ID_SERVICE <> :OLD_ID_SERVICE)) then  begin
            select S.SERVICE_NAME, S.ID_SERVICE_GROUP, SG.GROUP_NAME
            from   SERVICES S
                   left outer join SERVICE_GROUPS SG on S.ID_SERVICE_GROUP = SG.ID_SERVICE_GROUP
            where  S.ID_SERVICE = :OUT_ID_SERVICE
            into   :OUT_SERVICE_NAME, :OUT_ID_SERVICE_GROUP, :OUT_SRV_GROUP_NAME;
            if (:IS_POSITIVE = 1) then STRCORR = ' + '||:STRCORRECTION||':';
            else STRCORR = ' - '||:STRCORRECTION||':';
            OUT_SRV_GROUP_NAME  = :STRCORR||:OUT_SRV_GROUP_NAME;
            OUT_SERVICE_NAME    = :STRCORR||:OUT_SERVICE_NAME;
          end
          OLD_ID_GUEST =  :OUT_ID_GUEST ;
          OLD_ID_SERVICE = :OUT_ID_SERVICE;
          suspend;
        end
      end else begin
        /* JOIN TO DOCUMENT */
        for
          select APC.ID_ACCOUNT_POST, APC.ID_ACC_POST_CORRECT, APC.ID_ACCOUNT, APC.ID_SERVICE,  0, APC.IS_POSITIVE,
                 APC.CORRECTION_DATE, APC.USER_CORRECT, APC.CORRECTION_DATE, substring(APC.REASON_OF_CORRECT from 1 for 20), null,
                 round_f((APC.QTY_CORRECT*APC.IS_QTY_CORRECT + APC.NEW_QTY*APC.IS_PRICE_CORRECT)*(1 + APC.IS_QTY_CORRECT*(APC.IS_POSITIVE - 1)*2), :round_to) SUM_QTY,
                 round_f(APC.EXTRA_QTY_CORRECT, :round_to) SUM_EXTRA_QTY,
                 round_f((APC.PRICE_CORRECT*APC.IS_PRICE_CORRECT + APC.NEW_PRICE*APC.IS_QTY_CORRECT)*(1 + APC.IS_PRICE_CORRECT*(APC.IS_POSITIVE - 1)*2), :round_to) PRICE,
                 round_f((APC.QTY_CORRECT*APC.NEW_PRICE + APC.NEW_QTY*APC.PRICE_CORRECT)*(APC.IS_POSITIVE*2 - 1), :round_to) SUM_QTY_PRICE,
                 APC.NEW_CURR_POST, 0, 1 + APC.IS_PRICE_CORRECT, APC.ID_GUEST, AP.ROOM_NAME
          from   ACCOUNT_POST_CORRECTION APC
                 join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = APC.ID_ACCOUNT_POST
          where  APC.ID_ACCOUNT = :MY_ID_ACCOUNT
                 and ((:IN_IS_CLOSED = -1) or (APC.IS_OPEN = (1 - :IN_IS_CLOSED)))
                 and (APC.ID_DOC_HEAD + APC.IS_OPEN) > -1
                 and AP.ID_BASE_DOC = :IN_ID_DOC_HEAD /*((APC.ID_DOC_HEAD = :IN_ID_DOC_HEAD) or
                     (DL.IS_CORRECT = 0 and DL.ID_DOC_HEAD = :IN_ID_DOC_HEAD))*/
                 and :IN_IS_ANUL = 0
          into   :OUT_ID_ACCOUNT_POST, :OUT_ID_CORRECT_POST, :OUT_ID_ACCOUNT, :OUT_ID_SERVICE, :OUT_IS_BASE, :IS_POSITIVE,
                 :OUT_DATE_POST, :OUT_USER_CHANGED, :OUT_DATETIME_CHANGED, :OUT_CHANGE_TEXT, :OUT_PREV_POST,
                 :OUT_QTY_POST, :OUT_QTY_FREE, :OUT_PRICE_POST, :OUT_SUM_PRICE,
                 :OUT_CURR_POST, :OUT_IS_ANUL, :OUT_IS_CORRECT, :OUT_ID_GUEST, :OUT_ROOM_NAME
        do begin
          if (:OLD_ID_GUEST is distinct from :OUT_ID_GUEST) then begin
            OUT_DATE_CAME = null;
            OUT_ID_ROOM = null;
            OUT_GUEST_NAME = null;
            select G.FROM_DATE, G.ID_ROOM, GC.GUEST_NAME1
            from   GUEST G
                   left outer join GUEST_CARD GC on G.ID_GUEST = GC.ID_GUEST
            where  G.ID_GUEST = :OUT_ID_GUEST
            into   :OUT_DATE_CAME, :OUT_ID_ROOM, :OUT_GUEST_NAME;
          end
          if ((:OLD_ID_SERVICE is null) or (:OUT_ID_SERVICE <> :OLD_ID_SERVICE)) then  begin
            select S.SERVICE_NAME, S.ID_SERVICE_GROUP, SG.GROUP_NAME
            from   SERVICES S
                   left outer join SERVICE_GROUPS SG on S.ID_SERVICE_GROUP = SG.ID_SERVICE_GROUP
            where  S.ID_SERVICE = :OUT_ID_SERVICE
            into   :OUT_SERVICE_NAME, :OUT_ID_SERVICE_GROUP, :OUT_SRV_GROUP_NAME;
            if (:IS_POSITIVE = 1) then STRCORR = ' + '||:STRCORRECTION||':';
            else STRCORR = ' - '||:STRCORRECTION||':';
            OUT_SRV_GROUP_NAME  = :STRCORR||:OUT_SRV_GROUP_NAME;
            OUT_SERVICE_NAME    = :STRCORR||:OUT_SERVICE_NAME;
          end
          OLD_ID_GUEST =  :OUT_ID_GUEST ;
          OLD_ID_SERVICE = :OUT_ID_SERVICE;
          suspend;
        end
      end
    end
  end
end
^

/* Alter (ACCOUNT_MODIFY$PROFILE) */
ALTER PROCEDURE ACCOUNT_MODIFY$PROFILE(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_CONTRAGENT INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable is_pms_account tlogical;
  declare variable id_sale_num integer;
begin

  select a.ID_RESERV_DETAIL, a.IS_PMS_ACCOUNT
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :id_reserv_detail, :is_pms_account;

  execute procedure ACCOUNT_MODIFY$INT (:ID_ACCOUNT, :ID_PROFILE, :ACCOUNT_CURR, :ACCOUNT_NAME,
          :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT, :ID_TYPE_PAYMENT, :NOTE, :IS_BLOCKED, :BLOCK_TEXT,
          :SECURITY_LEVEL, :IS_BASE, :IS_EXTRA, :IS_ALOWED_POS_INTERFACE, :POS_INTERFACE_NOTE,
          :EXT_CODE, :ID_TAX_POLICY, :IS_DEFAULT, :ID_HOTEL, :ID_RESERV_DETAIL, :IS_PMS_ACCOUNT, :OPERATION)
  returning_values (:NEW_ID_ACCOUNT);

  update ACCOUNT a
  set    a.ID_CONTRAGENT = :ID_CONTRAGENT
  where  a.ID_ACCOUNT = :NEW_ID_ACCOUNT;

  if (:OPERATION = 'add' and exists (select p.ID_PROFILE
                                     from   PROFILE_HOUSE p
                                     where  p.ID_PROFILE = :ID_PROFILE
                                            and p.HOUSE_TYPE in ('hptExternalRevenue', 'hptComplimentary'))) then
  begin
    execute procedure ACCOUNT_SALE_NUMBER_SET(:ID_ACCOUNT)
    returning_values (:id_sale_num);
  end
end
^

/* Alter (ACCOUNT_POST_TRANSFER_ACC$ACC) */
ALTER PROCEDURE ACCOUNT_POST_TRANSFER_ACC$ACC(ID_SELECTED INTEGER)
 RETURNS(ID_ACCOUNT INTEGER)
 AS
declare variable DBG varchar(2000);
  declare variable ID_PERSON_PROFILE integer;
  declare variable PP_CNT integer;
  declare variable GST_POST_CNT integer;
  declare variable HOTELS_CNT integer;
  declare variable ID_HOTEL integer;
begin
  PP_CNT = 0;

  select count(distinct RD.ID_PERSON_PROFILE) as GUESTS_PROFILES_CNT,
         min(RD.ID_PERSON_PROFILE) as GUEST_PROFILE,
         count(AP.ID_ACCOUNT_POST) as GUESTS_POST_CNT,
         count(distinct A.ID_HOTEL),
         min(A.ID_HOTEL)
  from   ACCOUNT_POST AP
         join ACCOUNT  A on A.ID_ACCOUNT = AP.ID_ACCOUNT
         join GUEST G on G.ID_GUEST = AP.ID_GUEST
         join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
  where  AP.DOC_SELECTED = :ID_SELECTED
  into   :PP_CNT, :ID_PERSON_PROFILE, :GST_POST_CNT, :HOTELS_CNT, :ID_HOTEL;

  if (coalesce(:HOTELS_CNT, 0) > 1) then exception POSTING_TRANSFER_EXCEPTION '-375';

  if (coalesce(:GST_POST_CNT, 0) = 0) then begin
    /* all postings are posted "on account" */
    for
      select distinct SA.ID_ACCOUNT
      from   ACCOUNT_POST AP
             join ACCOUNT A on AP.ID_ACCOUNT = A.ID_ACCOUNT
             join ACCOUNT_S SA on SA.ID_PROFILE = A.ID_PROFILE
      where  AP.DOC_SELECTED = :ID_SELECTED
             and SA.ID_HOTEL = A.ID_HOTEL
      into   :ID_ACCOUNT
    do suspend;

  end else begin
    if (:PP_CNT = 1) then begin
      for
        select A.ID_ACCOUNT
        from   ACCOUNT_S A
        where  A.ID_PROFILE = :ID_PERSON_PROFILE
               and A.IS_ARCHIVE = 0
               and A.IS_BLOCKED = 0
               and A.ID_HOTEL = :ID_HOTEL
        into   :ID_ACCOUNT
      do suspend;
    end
  
    for
      select SA.ID_ACCOUNT, count(distinct AP.ID_ACCOUNT_POST)
      from   ACCOUNT_POST AP
             join GUEST G on G.ID_GUEST = AP.ID_GUEST
             join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
             join ACCOUNT_S SA on SA.ID_PROFILE = RD.ID_AGENT_PROFILE
      where  AP.DOC_SELECTED = :ID_SELECTED
             and SA.IS_ARCHIVE = 0
             and SA.IS_BLOCKED = 0
             and SA.ID_HOTEL = :ID_HOTEL
      group by SA.ID_ACCOUNT
      having count(AP.ID_ACCOUNT_POST) = :GST_POST_CNT
      into   :ID_ACCOUNT, :DBG
    do suspend;

  end
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ACCOUNT$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
QTY /* TYPE OF TQTY */ NUMERIC(15,2),
ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
DATE_POST /* TYPE OF TDATE */ DATE,
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ROOM /* TYPE OF ID */ INTEGER = null,
POST_DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_GUEST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ACCOUNT_ROUTING /* TYPE OF TSHORT_CODE */ VARCHAR(10),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_REPOST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC /* TYPE OF ID_REF */ INTEGER,
ID_RESERV_DETAIL /* TYPE OF ID_REF */ INTEGER,
RECALC_MARKER VARCHAR(40))
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE ACCOUNT_VALIDATE$INT(ID_ACCOUNT TYPE OF ID_REF,
CHECK_OPTIONS TYPE OF TDESCRIPTION_LONG)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100),
ACCOUNT_CURRENCY TYPE OF TCURRENCY,
ID_TAX_POLICY TYPE OF ID_REF,
ID_HOTEL TYPE OF ID_REF,
ACCOUNT_NAME TYPE OF TOBJECT_NAME,
ID_SALE_NUM TYPE OF ID_REF)
 AS
declare variable is_blocked integer;
  declare variable block_text varchar (100);
  declare variable is_archive integer;
  declare variable err_text_account varchar(255);
  declare variable is_base integer;
  declare variable is_extra integer;
begin
  /*  Description:
  ||  PERMENENT CHECKS ARE - existence, IS_ARCHIVE, IS_BLOCKED (full)
  ||  CHECK_OPTIONS = 'IS_BASE', 'IS_EXTRA', 'ALLOW_POSTING'
  */
  err_code = 0;
  err_text = '';
  account_name = null;
  check_options = ';' || :check_options || ';';
  select A.IS_BLOCKED, A.BLOCK_TEXT, A.IS_BASE, A.IS_EXTRA,
         A.IS_ARCHIVE, A.ACCOUNT_CURR, A.ACCOUNT_NAME, A.ID_HOTEL,
         A.ID_TAX_POLICY, A.ID_SALE_NUM
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :is_blocked, :block_text, :is_base, :is_extra,
         :is_archive, :account_currency, :account_name, :id_hotel,
         :ID_TAX_POLICY, :ID_SALE_NUM;

  /****************************************************************************/
  /* PERMANENT CHECKS */
  err_text_account = substring(f_character(29)||:id_account||'-'||:account_name from 1 for 255);

  if (:account_name is null) then begin
    exception WRONG_VALUE 'Non existent account (' || :ID_ACCOUNT || ') or account name is null!';
  end else if (:is_archive = 1) then begin
    err_code = -45; /* ARCHIV ACCOUNT */
    err_text = :err_text_account;
  end else if (:is_blocked = 2) then begin
    err_code = -19; /* BLOCKED ACCOUNT - full block */
    if (:block_text is null) then block_text = '';
    err_text = :block_text||:err_text_account;
  end else if (:is_blocked = 1 and :CHECK_OPTIONS containing ';ALLOW_POSTING;') then begin
    err_code = -12; /* BLOCKED ACCOUNT - postings block */
    if (:block_text is null) then block_text = '';
    err_text = :block_text||:err_text_account;
  end

  if (:err_code < 0) then EXIT;

  /****************************************************************************/
  /* SPECIAL CHECKS */
  if (:check_options containing ';IS_BASE;') then begin
    if (:is_base = 0) then begin
      err_code = -48;
      err_text = :err_text_account;
      exit;
    end
  end
  if (:check_options containing ';IS_EXTRA;') then begin
    if (:is_extra = 0) then begin
      err_code = -49;
      err_text = :err_text_account;
      exit;
    end
  end

end
^

/* Alter (ACCOUNT_POSTING_ADD$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT TYPE OF ID,
ID_GUEST TYPE OF ID_REF,
ID_SECQUENCE TYPE OF ID_REF,
DATE_POST TYPE OF TDATE,
ID_SERVICE TYPE OF ID,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
IS_BASE TYPE OF TLOGICAL,
QTY_POST TYPE OF TQTY,
PRICE TYPE OF TPRICE,
ORIG_CURRENCY TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
CHANGED_TEXT TYPE OF TTEXT_SHORT,
ID_MASTER_ADDINS_ACC_POST TYPE OF ID_REF,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
NEW_ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable price_post double precision;
  declare variable post_rate numeric (15, 6);
  declare variable curr_post char(3);
  declare variable account_currency char(3);
  declare variable id_pack_service integer;
  declare variable id_room_type integer;
  declare variable room_name varchar(30);
  declare variable is_archive integer;
  declare variable id_tax_policy integer;
  declare variable id_sale_taxation integer;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable check_option varchar(255);
  declare variable id_hotel integer;
  declare variable id_srv_hotel integer;
  declare variable service_name varchar(30);
  declare variable account_name varchar(50);
  declare variable id_sale_num integer;
begin
  ID_GUEST = nullif(:ID_GUEST, -1);

  execute procedure POST_PRICE_CHECK$INT (:QTY_POST, :PRICE, :ORIG_CURRENCY);

  if ( (:IS_BASE = 1) or (:ID_MASTER_ADDINS_ACC_POST > 0) ) then
    check_option = 'IS_BASE;ALLOW_POSTING;UNIQUE_SALES_NUMBER';
  else
    check_option = 'IS_EXTRA;ALLOW_POSTING;UNIQUE_SALES_NUMBER';

  execute procedure ACCOUNT_VALIDATE$INT(:id_account, :check_option)
  returning_values  (:err_code, :err_text, :account_currency, :id_tax_policy, :id_hotel,
                     :account_name, :id_sale_num);
  if (:err_code < 0) then EXIT; --  exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;

  if (:id_sale_num is null) then begin
    execute procedure ACCOUNT_SALE_NUMBER_SET(:ID_ACCOUNT)
    returning_values (:id_sale_num);
  end

  select s.ID_HOTEL, s.SERVICE_NAME
  from   SERVICES S
  where  s.ID_SERVICE = :ID_SERVICE
  into   :id_srv_hotel, :service_name;

  if (:id_srv_hotel is distinct from :id_hotel) then
    exception POSTING_EXCEPTION '-1056' || f_character(31) || f_character(29) || :service_name || f_character(28) || :account_name;

  if (:rate is null) then begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :orig_currency, :date_post, :id_guest)
    returning_values  :rate;
  end

  curr_post  = :account_currency;
  if (:orig_currency = :account_currency) then begin
    post_rate  = :rate;
  end else begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :account_currency, :date_post, :id_guest)
    returning_values  :post_rate;
  end

  execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :DATE_POST - :FROM_DATE)
  returning_values (:id_sale_taxation);

  execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                    :RATE, :post_rate, :id_sale_taxation)
  returning_values  :price_post, :post_net_value, :post_gross_value;

  execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:ID_ACCOUNT, :price_post * :QTY_POST)
  returning_values (:ERR_CODE, :ERR_TEXT);
  if (:ERR_CODE <> 0) then exit;

  --
  new_id_account_post = gen_id (id_account_post_gen, 1);

  if (:post_text starting with 'PACK') then begin
    id_pack_service = substring(:post_text from 6 for 20);
    post_text = '';
  end else begin
    id_pack_service = -1;
  end
  if (:is_base = 1) then id_master_addins_acc_post = :new_id_account_post;

  select R.ROOM_NAME, R.ID_ROOM_TYPE
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name, :id_room_type;

  if (:id_guest is null) then begin
    is_archive = 1;
  end else begin
    select iif(G.CHECK_STATUS = 1, 1, 0)
    from   GUEST G
    where  G.ID_GUEST = :id_guest
    into   :is_archive;
  end

  insert into ACCOUNT_POST (
    ID_ACCOUNT_POST, ID_ACCOUNT, ID_GUEST, ID_SERVICE, ID_TARIFF, ID_ROOM,
    IS_BASE, DATE_POST, QTY_POST, QTY_FREE, PRICE_POST, POST_NET_VALUE, POST_GROSS_VALUE, CURR_POST, RATE_POST,
    PRICE_ORIG, CURR_ORIG, RATE_ORIG, IS_LOCKED_FOR_UPDATE, TO_DATE, FROM_DATE, ID_SEQUENCE,
    SHORT_CODE, CHANGED_TEXT, ID_MASTER_ADDINS_ACC_POST, ID_PACK_SERVICE, ROOM_NAME, ID_ROOM_TYPE,
    ID_SALE_TAXATION, AC, IS_ARCHIVE, IN_DOC_QTY, IN_DOC_VALUE, DESCRIPTION)
  values (
    :new_id_account_post, :id_account, :id_guest, :id_service, :id_tariff, coalesce(:id_room, -1),
    :is_base, :date_post, :qty_post, 0, :price_post, :post_net_value, :post_gross_value, :curr_post, :post_rate,
    :price, :orig_currency, :rate, 0, :TO_DATE, :FROM_DATE, :id_secquence,
    :short_code, :changed_text, :id_master_addins_acc_post, :id_pack_service, :room_name, :id_room_type,
    :id_sale_taxation, '00', :is_archive, 0, 0, :DESCRIPTION);

  if ((coalesce(:post_text, '') <> '') or (coalesce(:resource_text, '') <> '')) then begin
    insert into ACCOUNT_POSTING_DET (ID_ACCOUNT_POST, POST_TEXT, QTY, FROM_DATETIME, TO_DATETIME, RESOURCE_TEXT)
    values (:new_id_account_post, :post_text, :qty_post, :FROM_DATE, :TO_DATE, :resource_text);
  end
end
^

/* Alter (ACCOUNT_POSTING_DOC_UPDATE$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_DOC_UPDATE$INT(DH_DBKEY TYPE OF TDB_KEY)
 RETURNS(WARN_CODE TYPE OF TRANGE)
 AS
declare variable date_post date;
  declare variable old_date_post date;
  declare variable curr_post varchar(3);
  declare variable old_curr_post varchar(3);
  declare variable rate_post numeric(15,6);
  declare variable curr_orig varchar(3);
  declare variable old_curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable dbkey char(8);
  declare variable id_account_post integer;
  declare variable doc_date date;
  declare variable doc_release_ap integer;
  declare variable qty_post numeric(15,2);
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable price_orig numeric(15,4);
  declare variable price_post double precision;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable id_sale_taxation integer;
  declare variable id_base_doc integer;
  declare variable doc_operation varchar(10);
  declare variable is_anul_doc integer;
  declare variable is_storno integer;
  declare variable id_doc_head integer;
  declare variable posts_value double precision;
  declare variable line_value double precision ;
  declare variable action_text varchar(255);
  declare variable action_code varchar(30);
  declare variable account_curr varchar(3);
  declare variable id_ap_base_doc integer;
  declare variable new_is_anul integer;
  declare variable new_is_closed integer;
  declare variable doc_qty numeric(15,2);
  declare variable doc_price double precision;
  declare variable id_hotel integer;
  declare variable round_to numeric(15,4);
  declare variable proforma_dt_created timestamp;
  declare variable new_ac varchar(2);
  declare variable id_tax_policy integer;
  declare variable id_service integer;
  declare variable nat_round_to numeric(15,4);
  declare variable id_sale_num integer;
begin

  select D.ID_DOC_HEAD, iif(D.IS_ANUL = 0, D.DOC_DATE, DA.ANNULMENT_DATE),
         D.ID_BASE_DOC, D.IS_ANUL, D.IS_STORNO, a.ID_TAX_POLICY, c.ROUND_TO,
         A.ID_ACCOUNT, A.ACCOUNT_CURR, a.id_hotel, pd.DATETIME_CREATED
  from   DOC_HEAD$INT D
         join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join HOTEL h on h.ID_HOTEL = a.ID_HOTEL
         join CURRS c on c.CURR = h.NATION_CURR
         left outer join DOC_ANNULMENT DA on DA.ID_DOC_HEAD = D.ID_DOC_HEAD
         left outer join DOC_HEAD$INT pd on pd.ID_DOC_HEAD = dc.ID_DOC_PROFORMA
  where  D.RDB$DB_KEY = :DH_DBKEY
  into   :id_doc_head, :doc_date, :id_base_doc, :is_anul_doc, :is_storno, :id_tax_policy, :nat_round_to,
         :id_account, :account_curr, :id_hotel, :proforma_dt_created;

  if (:id_doc_head is null) then exit;

  doc_operation = case when :is_anul_doc = 1 then 'anul'
                       when :is_storno   = 1 then 'storno'
                       else 'new'
                  end;

  doc_release_ap = -gen_id(DOC_SELECTED_GEN, 1);
  /*   */
  posts_value = 0;
  if (:doc_operation = 'new') then begin
    for
      select AP.RDB$DB_KEY, AP.ID_ACCOUNT_POST, DL.QTY_POST, PV.ACCOUNT_PRICE,
             ap.QTY_POST, ap.PRICE_POST, c.ROUND_TO
      from   ACCOUNT_POST AP
             join DOC_LINE_POST_VALUES PV on PV.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
             join DOC_LINE DL on DL.ID_DOC_LINE = PV.ID_DOC_LINE
             join CURRS C on c.CURR = ap.CURR_POST
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
      into   :dbkey, :id_account_post, :doc_qty, :doc_price,
             :qty_post, :price_post, :round_to
    do begin
      posts_value = :posts_value + :doc_price * :doc_qty;  -- logable value accumulation
      /*  if (:is_anul = 1) - annul corrective document, else - new valid document */
      /* annulment/storno of base document is in other case - operation "anul"  */
      if (:proforma_dt_created is not null) then begin
        new_is_anul = 0;
        new_is_closed = iif(cast(round_f(:qty_post - :doc_qty, :round_to) as numeric(15,2)) = 0
                            and cast(round_f(:price_post - :doc_price, :round_to) as numeric(15,2)) = 0,
                            1,
                            0);
      end else begin
        new_is_anul = 0;
        new_is_closed = 1;
        doc_qty = :qty_post;
        doc_price = :price_post;
      end

      update ACCOUNT_POST AP
      set    AP.ID_BASE_DOC   = :id_base_doc,
             AP.IN_DOC_QTY    = :doc_qty,
             AP.IN_DOC_VALUE  = :doc_price,
             AP.IS_ANUL       = :new_is_anul,
             AP.AC            = :new_is_anul || :new_is_closed,
             AP.DOC_SELECTED  = :doc_release_ap,
             AP.DATETIME_CHANGED = current_timestamp
      where  AP.RDB$DB_KEY = :DBKEY
      returning ap.ac into :new_ac;
      if (:new_ac = '00') then begin
        execute procedure SYSTEM_WARNING_ADD (-1061, '')
        returning_values (:warn_code);
      end

      update ACCOUNT_POST_CORRECTION APCU
      set    APCU.ID_DOC_HEAD  = iif(apcu.DATETIME_CREATED < coalesce(:proforma_dt_created, current_timestamp), :ID_DOC_HEAD, -1),
             APCU.IS_OPEN      = iif(apcu.DATETIME_CREATED < coalesce(:proforma_dt_created, current_timestamp), 0, 1)
      where  APCU.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
             and coalesce(APCU.ID_DOC_HEAD, -1) = -1;
    end

    action_text = f_character(29) || formatfloat(abs(:posts_value), 'F;0.00') || ' ' || :account_curr;
    action_code = 'CLOSE_POSTINGS';
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, :action_code, :action_text);

  end else if (:doc_operation in ('anul', 'storno')) then begin
    /* annulment/storno of base document - release all postings */
    /*   */
    old_date_post = '01.01.1900';
    old_curr_post = '';
    old_curr_orig = '';
    posts_value = 0;
    /*   */
    for
      select distinct AP.RDB$DB_KEY, AP.ID_ACCOUNT, AP.ID_GUEST, AP.ID_SALE_TAXATION, AP.ID_BASE_DOC,
             AP.QTY_POST, AP.PRICE_POST, AP.DATE_POST, AP.CURR_POST, AP.CURR_ORIG, AP.PRICE_ORIG,
             AP.ID_ACCOUNT_POST, AP.POST_NET_VALUE, AP.POST_GROSS_VALUE, AP.RATE_POST, AP.RATE_ORIG,
             PV.ACCOUNT_PRICE * DL.QTY_POST, c.ROUND_TO, ap.ID_SERVICE
      from   ACCOUNT_POST AP
             join DOC_LINE_POST_VALUES PV on PV.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
             join DOC_LINE DL on DL.ID_DOC_LINE = PV.ID_DOC_LINE
             join CURRS C on c.CURR = ap.CURR_POST
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
      order by AP.DATE_POST, AP.CURR_POST, AP.CURR_ORIG
      into   :dbkey, :id_account, :id_guest, :id_sale_taxation, :id_ap_base_doc,
             :qty_post, :price_post, :date_post, :curr_post, :curr_orig, :price_orig,
             :id_account_post, :post_net_value, :post_gross_value, :rate_post, :rate_orig,
             :line_value, :round_to, :id_service
    do begin
      if (:id_ap_base_doc is not null and :id_ap_base_doc is distinct from :id_base_doc) then
        exception DOCUMENT_EXCEPTION '-365';

      doc_qty = null;
      doc_price = 0;
      if (:DOC_OPERATION = 'anul') then begin
        select sum(DL.QTY_POST * (1 - DL.IS_CORRECT)) as DOC_QTY,
               sum(DLP.ACCOUNT_PRICE * DL.QTY_POST) /* / sum(DL.QTY_POST * (1 - DL.IS_CORRECT))*/ as DOC_VALUE
        from   DOC_HEAD DH
               join DOC_LINE DL on DL.ID_DOC_HEAD = DH.ID_DOC
               join DOC_LINE_POST_VALUES DLP on dlp.ID_DOC_LINE = dl.ID_DOC_LINE
        where  DH.IS_ANUL = 0
               and DLP.ID_ACCOUNT_POST = :id_account_post
               and DH.ID_BASE_DOC = :id_base_doc
        into   :doc_qty, :doc_price;
        if (:doc_qty = 0) then doc_price = 0;
        else doc_price = :doc_price / :doc_qty;
      end

      if (:doc_qty is null) then begin
        -- update prices only for released posting
        select tp.ID_SALE_TAXATION
        from   SERVICE_TAXATION tp
        where  tp.ID_TAX_POLICY = :id_tax_policy
               and tp.ID_SERVICE = :id_service
        into   :id_sale_taxation;  -- get actual taxation

        if (:date_post >= :doc_date) then begin
          /* update rates for prepaid postings (date_post >= doc_date) if base doc is annul */
          if ((:old_date_post <> :date_post) or (:old_curr_post <> :curr_post) ) then begin
            execute procedure ACCOUNT_POSTING_RATE_GET (:id_hotel, :curr_post, :date_post, :id_guest)
            returning_values  :RATE_POST;
          end
    
          if ((:OLD_DATE_POST <> :DATE_POST) or (:OLD_CURR_ORIG <> :CURR_ORIG) ) then begin
            execute procedure ACCOUNT_POSTING_RATE_GET (:id_hotel, :curr_orig, :date_post, :id_guest)
            returning_values  :rate_orig;
          end
  
          execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:qty_post, :price_orig,
                            :rate_orig, :rate_post, :id_sale_taxation)
          returning_values  :price_post, :post_net_value, :post_gross_value;
        end else begin
          -- recalc only nat net value with actual taxation
          select tv.VALUE_WOT_TAX
          from   TAX_VALUE_DEDUCT (:qty_post * :price_post * :rate_post, :nat_round_to, :id_sale_taxation) tv
          into   :post_net_value;
        end
      end

      new_is_anul = iif(:qty_post = 0 and :doc_qty is null, 1, 0);
      new_is_closed = iif(:doc_qty is not null
                          and cast(round_f(:qty_post - :doc_qty, :round_to) as numeric(15,2)) = 0
                          and cast(round_f(:price_post - :doc_price, :round_to)  as numeric(15,2)) = 0,
                          1,
                          0);

      update ACCOUNT_POST AP
      set    AP.IN_DOC_VALUE  = iif(:doc_qty is null, 0, :doc_price),
             AP.IN_DOC_QTY    = iif(:doc_qty is null, 0, :doc_qty),
             AP.RATE_ORIG     = :rate_orig,
             AP.RATE_POST     = :rate_post,
             AP.PRICE_POST    = :price_post,
             AP.POST_NET_VALUE = :post_net_value,
             AP.POST_GROSS_VALUE = :post_gross_value,
             AP.ID_SALE_TAXATION  = :id_sale_taxation,
             AP.ID_BASE_DOC   = iif(:doc_qty is null, null, :ID_BASE_DOC),
             AP.IS_ANUL       = :new_is_anul,
             AP.AC            = :new_is_anul || :new_is_closed,
             AP.ANUL_DATETIME = iif(:new_is_anul = 1, current_timestamp, ap.anul_datetime),
             AP.DATETIME_CHANGED = current_timestamp
      where  AP.RDB$DB_KEY = :DBKEY;

      if (:doc_operation = 'anul') then begin
        update ACCOUNT_POST_CORRECTION APCU
        set    APCU.ID_DOC_HEAD  = -1,
               APCU.IS_OPEN      = iif(:DOC_QTY is not null, 1, apcu.IS_OPEN)
        where  APCU.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and APCU.ID_DOC_HEAD = :ID_DOC_HEAD;
      end else begin  -- 'storno'
        update ACCOUNT_POST_CORRECTION APCU
        set    APCU.ID_DOC_HEAD  = -1,
               APCU.IS_OPEN      = iif(:DOC_QTY is not null, 1, apcu.IS_OPEN)
        where  APCU.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and APCU.ID_DOC_HEAD in (select d.ID_DOC from DOC_HEAD d where d.ID_BASE_DOC = :id_base_doc);
      end

      old_curr_post = :curr_post;
      old_curr_orig = :curr_orig;

      posts_value = :posts_value + :line_value;
    end  /* for select ... do begin  */

    execute procedure ACCOUNT_SALE_NUMBER_SET(:id_account)
    returning_values (:id_sale_num);

    action_text = f_character(29) || formatfloat(abs(:posts_value), 'F;0.00') || ' ' || :account_curr;
    action_code = 'OPEN_POSTINGS';
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, :action_code, :action_text);
  end  /* call type in (STORNO, ANUL)  */
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER,
IS_MANUAL_TRANSFER /* TYPE OF TLOGICAL */ SMALLINT = 1)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE_PERC for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_POSTING$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
PRICE_DESCRIPTION /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(DOC_SELECTED /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_POSTING_UPDATE$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY TYPE OF TDB_KEY,
ID_SERVICE TYPE OF ID_REF,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
QTY_POST TYPE OF TQTY,
QTY_FREE TYPE OF TQTY,
PRICE TYPE OF TVALUE,
CURR TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
CHANGED_TEXT VARCHAR(40),
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
IS_CONSEQUENTIAL_UPDATE TYPE OF TBOOLEAN = 0,
RE_ROUTE_ACCOUNT TYPE OF ID_REF = null)
 RETURNS(OUT_QTY_POST TYPE OF TQTY,
OUT_PRICE_POST TYPE OF TVALUE,
OUT_AC VARCHAR(2))
 AS
declare variable date_post date;
  declare variable orig_is_base integer;
  declare variable orig_id_service integer;
  declare variable orig_id_room integer;
  declare variable orig_short_code varchar(255);
  declare variable orig_qty_post integer;
  declare variable orig_ac varchar(2);
  declare variable is_locked_for_update integer;
  declare variable orig_locked_for_update integer;
  declare variable orig_id_tariff integer;
  declare variable orig_id_guest integer;
  declare variable id_type_stay integer;
  declare variable id_room_type integer;
  declare variable id_board integer;
  declare variable id_pack_service integer;
  declare variable new_id_pack_service integer;
  declare variable post_currency char(3);
  declare variable room_name varchar(30);
  declare variable original_post varchar(30);
  declare variable new_ac varchar(2);
  declare variable orig_in_doc_qty numeric(15,2);
  declare variable orig_in_doc_value double precision;
  declare variable rate_post numeric(15,6);
  declare variable id_base_doc integer;
  declare variable id_tax_policy integer;
  declare variable price_post double precision;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable id_sale_taxation integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable orig_price_post tprice;
  declare variable round_to numeric(15,4);
  declare variable account_name tobject_name;
  declare variable err_code integer;
  declare variable err_text varchar(100);
  declare variable id_account integer;
  declare variable orig_id_master_addins_acc_post integer;
  declare variable check_options varchar(255);
  declare variable id_sale_num integer;
begin
  /* GET DATA */
  original_post = '';
  new_id_pack_service = null;

  select AP.DATE_POST, AP.IS_BASE, AP.ID_SERVICE, AP.ID_BASE_DOC,
         AP.SHORT_CODE, AP.QTY_POST, ap.PRICE_POST, AP.IS_LOCKED_FOR_UPDATE,
         AP.AC, AP.ID_TARIFF, AP.ID_GUEST, AP.ID_ROOM,
         AP.ID_PACK_SERVICE, AP.ID_ROOM_TYPE,
         AP.IN_DOC_QTY, AP.IN_DOC_VALUE, AP.RATE_POST, ap.ID_SALE_TAXATION,
         ap.ID_ACCOUNT, ap.ID_ACCOUNT_POST, ap.ID_MASTER_ADDINS_ACC_POST
  from   ACCOUNT_POST AP
  where  AP.rdb$db_key = :AP_DBKEY
  into   :date_post, :orig_is_base, :orig_id_service, :id_base_doc,
         :orig_short_code, :orig_qty_post, :orig_price_post, :orig_locked_for_update,
         :orig_ac, :orig_id_tariff, :orig_id_guest, :orig_id_room,
         :id_pack_service, :id_room_type,
         :orig_in_doc_qty, :orig_in_doc_value, :rate_post, :id_sale_taxation,
         :id_account, :id_account_post, :orig_id_master_addins_acc_post;

  check_options = 'ALLOW_POSTING;';
  if (:RE_ROUTE_ACCOUNT is not null and :id_base_doc is null and :id_account <> :RE_ROUTE_ACCOUNT) then begin
    -- IMPORTANT !!! Re-routing is possible only in this case!
    id_account = :RE_ROUTE_ACCOUNT;
    if ( (:orig_is_base = 1) or (:orig_id_master_addins_acc_post > 0) ) then
      check_options = :check_options || 'IS_BASE;';
    else
      check_options = :check_options || 'IS_EXTRA;';
  end
  is_locked_for_update = :orig_locked_for_update; /* to initialize and preserve from null */

  if (:IS_CONSEQUENTIAL_UPDATE is distinct from 1) then begin
    -- direct post update - manual edition restrictions check
    if (:QTY_POST = -1) then QTY_POST = :orig_qty_post;   -- preserve current qty

    if (:QTY_POST <> :orig_qty_post) then exception POSTING_EXCEPTION '-379';

    if ((:orig_is_base = 1) and ((:QTY_POST <> 1) or (:ID_SERVICE <> :orig_id_service))) then
      exception POSTING_EXCEPTION '-223';

    if (:orig_ac = '01') then execute procedure RIGHTS_CHECK_GRANTED$INT('BALANCES_EDIT_CLOSED');

    short_code = :orig_short_code;
    id_tariff  = :orig_id_tariff;
    id_room    = :orig_id_room;
    is_locked_for_update = 1;  /* manual corrections must lock the postings  */

  end else begin
    /* post changes is a result from some user operation, indirect update ('NORMAL', 'FORCED', safes recalc, etc....) */
    is_locked_for_update = iif(:CHANGED_TEXT = 'TRANSFER_POSTING', :orig_locked_for_update, 0);

    if (:orig_is_base = 1) then begin
      /* PREPARING THE PACKET SERVICE */
      select Sp.ID_TYPE_STAY, Sp.ID_ROOM_TYPE, s.ID_HOTEL
      from   SERVICE_PACKET Sp
             join SERVICES s on s.ID_SERVICE = sp.ID_SERVICE
      where  s.ID_SERVICE = :id_service
      into   :id_type_stay, :id_room_type, :id_hotel;

      select GS.ID_BOARD
      from   GUEST_STAY GS
      where  GS.ID_GUEST = :orig_id_guest
             and GS.FOR_DATE = :date_post
      into   :id_board;

      execute procedure TAR_GET_BASE_SERVICE$INT(:id_type_stay, :id_room_type, :id_board, :id_hotel)
      returning_values  :id_pack_service;
      /* detecting change of STAY_TYPE or ROOM_TYPE */
      if (exists(
        select *
        from   SERVICE_PACKET S
        where  S.ID_SERVICE = :orig_id_service
               and ((S.ID_TYPE_STAY is distinct from :id_type_stay) or (S.ID_ROOM_TYPE is distinct from :id_room_type))
      )) then original_post = 'CHANGED';
    end
  end

  select R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name;

  if (:orig_locked_for_update = 1
      and :changed_text starting with 'NORMALRECALC'
      and :id_service = :orig_id_service
      --and :orig_is_anul = 0
      and :id_tariff = :orig_id_tariff) then
  begin
    -- price is locked for update
    update ACCOUNT_POST AP
    set    AP.ID_ROOM      = :ID_ROOM,
           AP.ROOM_NAME    = :room_name,
           Ap.FROM_DATE    = :FROM_DATE,
           Ap.TO_DATE      = :TO_DATE,
           AP.ID_PACK_SERVICE  = :id_pack_service,
           AP.CHANGED_TEXT     = :CHANGED_TEXT,
           AP.USER_CHANGED     = current_user,
           AP.DATETIME_CHANGED = current_timestamp,
           AP.SHORT_CODE       = :SHORT_CODE
    where  AP.rdb$db_key   = :AP_DBKEY;
    OUT_QTY_POST = :orig_qty_post;
    OUT_PRICE_POST = :orig_price_post;
    OUT_AC = :orig_ac;
  end else begin
    -- fully update
    execute procedure ACCOUNT_VALIDATE$INT(:id_account, :check_options)
    returning_values  (:err_code, :err_text, :post_currency, :id_tax_policy, :id_hotel,
                      :account_name, :id_sale_num);
    if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;
  
    if (:id_sale_num is null) then begin
      execute procedure ACCOUNT_SALE_NUMBER_SET(:ID_ACCOUNT)
      returning_values (:id_sale_num);
    end

    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :curr, :date_post, :orig_id_guest)
    returning_values  :rate;
  
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :post_currency, :date_post, :orig_id_guest)
    returning_values  :rate_post;
  
    if (:id_base_doc is null) then begin
      execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :date_post - :from_date)
      returning_values (:id_sale_taxation);
    end

    execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                      :RATE, :rate_post, :id_sale_taxation)
    returning_values  :price_post, :post_net_value, :post_gross_value;

    select c.ROUND_TO
    from   CURRS c
    where  c.CURR = :post_currency
    into   :round_to;

    if ( (:id_base_doc is not null)
         and (:qty_post = :orig_in_doc_qty)
         and (round_f(:price_post * :qty_post - :orig_in_doc_value * :orig_in_doc_qty, :round_to) = 0))
    then new_ac = '01';
    else new_ac = '00';                   
  
    if (:new_ac = '00') then begin
      execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:id_account, :price_post * :QTY_POST - :orig_price_post * :orig_qty_post)
      returning_values (:err_code, :err_text);
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;
    end

    update ACCOUNT_POST AP
    set    AP.ID_ACCOUNT           = :id_account,
           AP.ID_SERVICE           = :id_service,
  
           AP.QTY_POST             = :qty_post,
           AP.QTY_FREE             = :qty_free,
           AP.PRICE_POST           = :price_post,
           AP.CURR_POST            = :post_currency,
           AP.RATE_POST            = :rate_post,
           AP.RATE_ORIG            = :rate,
           AP.PRICE_ORIG           = :price,
           AP.CURR_ORIG            = :curr,
           AP.POST_NET_VALUE       = :post_net_value,
           AP.POST_GROSS_VALUE     = :post_gross_value,
  
           AP.AC                   = :new_ac,
           AP.IS_ANUL              = 0,
           AP.ANUL_REASON          = '',
           AP.IS_LOCKED_FOR_UPDATE = :is_locked_for_update,
           AP.ID_TARIFF            = :id_tariff,
           AP.ID_PACK_SERVICE      = :id_pack_service,
           AP.ID_ROOM              = :id_room,
           AP.ID_ROOM_TYPE         = :id_room_type,
           AP.ROOM_NAME            = :room_name,
           AP.ID_SALE_TAXATION     = :id_sale_taxation,
           AP.ORIGINAL_POST        = :original_post,
           AP.SHORT_CODE           = :short_code,
           AP.CHANGED_TEXT         = :changed_text,
           AP.USER_CHANGED         = current_user,
           AP.DATETIME_CHANGED     = current_timestamp,
           Ap.FROM_DATE            = :from_date,
           Ap.TO_DATE              = :to_date
    where  AP.rdb$db_key = :AP_DBKEY
    returning new.id_account_post, new.id_pack_service
    into   :id_account_post, :new_id_pack_service;
  
    if (:new_ac = '01') then begin
      update ACCOUNT_POST_CORRECTION APC
      set    APC.IS_OPEN = 0
      where  APC.ID_ACCOUNT_POST = :id_account_post
             and APC.IS_OPEN = 1;
    end

    if (:orig_is_base = 1 and :new_id_pack_service <> :id_pack_service) then begin
      -- update add_inses with new pack service
      update ACCOUNT_POST AP
      set    ap.ID_PACK_SERVICE = :new_id_pack_service
      where  ap.ID_MASTER_ADDINS_ACC_POST = :id_account_post
             and ap.IS_BASE = 0;
    end

    OUT_QTY_POST = :qty_post;
    OUT_PRICE_POST = :price_post;
    OUT_AC = :new_ac;
  end
end
^

/* Alter (ACCOUNT_POSTING_UPDATE_PERC) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
declare variable id_account_post integer;
  declare variable ap_dbkey char(8);
  declare variable id_service integer;
  declare variable id_tariff integer;
  declare variable id_room integer;
  declare variable id_account integer;
  declare variable qty_post numeric (15,4);
  declare variable qty_free numeric (15,4);
  declare variable short_code varchar(255);
  declare variable curr_post char(3);
  declare variable price_post numeric (15,4);
  declare variable new_qty_post numeric (15,4);
  declare variable new_price_post numeric (15,4);
  declare variable orig_currency char(3);
  declare variable orig_rate numeric (15,4);
  declare variable orig_price numeric (15,4);
  declare variable new_orig_price double precision;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
  declare variable date_post date;
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
begin
  for
    select item
    from   SYSTEM_STRING_PARSER(:in_id_account_post, ',')
    into   :id_account_post
  do begin
    select AP.rdb$db_key, AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, ap.ID_ACCOUNT,
           AP.QTY_POST, ap.PRICE_POST, ap.CURR_POST, ap.DATE_POST,
           AP.QTY_FREE, AP.SHORT_CODE, AP.CURR_ORIG, AP.RATE_ORIG, AP.PRICE_ORIG,
           ap.FROM_DATE, ap.TO_DATE
    from   ACCOUNT_POST AP
    where  AP.ID_ACCOUNT_POST = :id_account_post
    into   :ap_dbkey, :id_service, :id_tariff, :id_room, :id_account,
           :qty_post, :price_post, :curr_post,:date_post,
           :qty_free, :short_code, :orig_currency, :orig_rate, :orig_price,
           :from_date, :to_date;

    new_orig_price = :orig_price + :orig_price * :in_perc;

    execute procedure ACCOUNT_POSTING_UPDATE$INT(:ap_dbkey,
            :id_service, :id_tariff, :id_room,
            :qty_post, :qty_free, :new_orig_price, :orig_currency, :orig_rate,
            :in_changed_text, :short_code, :from_date, :to_date)
    returning_values  :new_qty_post, :new_price_post, :no_use;

    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :id_service
    into   :action_text;

    log_old_value = formatfloat(:qty_post * :price_post, 'F;0.00') || ' ' || :curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :curr_post;
    action_text = f_character(29) || :action_text
                  || f_character(28) || formatfloat(:IN_PERC*100, 'F;0.0') || '%'
                  || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                  || f_character(28) || :log_old_value
                  || f_character(28) || :log_new_value
                  || f_character(28) || replace(:IN_CHANGED_TEXT, 'MANUAL', '');
    execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_PERC_UPDATE', :action_text);
  end
end
^

/* Alter (ACCOUNT_POSTS_EW_MARK$INT) */
ALTER PROCEDURE ACCOUNT_POSTS_EW_MARK$INT(ID_END_WORK INTEGER)
 AS
declare variable revenue_account_method integer;
  declare variable doc_selected integer;
  declare variable ap_dbkey char(8);
  declare variable ew_date date;
  declare variable id_hotel integer;
begin
  select EW.ID_HOTEL, EW.PREV_DATE
  from   END_WORKS EW
  where  EW.ID_END_WORK = :ID_END_WORK
  into   :id_hotel, :ew_date;

  execute procedure SETTING_GET_VALUE ('REVENUE_ACCOUNT_METHOD', :id_hotel)
  returning_values  :revenue_account_method;

  doc_selected = -gen_id(DOC_SELECTED_GEN, 1); /* to prevent correction checks on trigger  */
  /* UPDATE POSTINGS FOR SUMMARY ********************************************/
  for
    select AP.RDB$DB_KEY
    from   ACCOUNT_POST AP
           join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
    where  AP.ID_END_WORK is null
           and AP.DATE_POST <= :ew_date
           and A.ID_HOTEL = :id_hotel
    union all
    select APP.RDB$DB_KEY
    from   ACCOUNT_POST APP
           join ACCOUNT A on A.ID_ACCOUNT = APP.ID_ACCOUNT
           join DOC_HEAD D on D.ID_DOC = APP.ID_BASE_DOC
    where  :revenue_account_method = 1  /* SELECT PREPAIED POSTINGS FOR SUMMARY */
           and APP.ID_END_WORK is null
           and APP.DATE_POST > :ew_date
           and A.ID_HOTEL = :id_hotel
           and D.DOC_DATE = :ew_date
    into   :ap_dbkey
  do begin
    update ACCOUNT_POST APU
    set    APU.ID_END_WORK = :id_end_work,
           APU.DOC_SELECTED = :doc_selected
    where  APU.RDB$DB_KEY = :ap_dbkey;
  end

  for
    select APC.RDB$DB_KEY
    from   ACCOUNT_POST_CORRECTION APC
           join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = APC.ID_ACCOUNT_POST
           join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
    where  apc.CORRECTION_DATE = :ew_date
           and apc.ID_END_WORK is null
           and a.ID_HOTEL = :id_hotel
           and AP.ID_END_WORK < :ID_END_WORK
    into   :ap_dbkey
  do begin
    update ACCOUNT_POST_CORRECTION C
    set    C.ID_END_WORK = :ID_END_WORK
    where  c.RDB$DB_KEY = :ap_dbkey;
  end

end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_MODIFY$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE ACCOUNT_MODIFY$INT(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL /* TYPE OF ID_REF */ INTEGER,
IS_PMS_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_GET_ACCOUNT$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE PROFILE_GET_ACCOUNT$INT(ID_PROFILE INTEGER,
ID_RESERV_DETAIL INTEGER,
ACCOUNT_CURR VARCHAR(3),
ID_ACC_TEMPLATE INTEGER,
IS_BASE_ENABLE SMALLINT = 1,
IS_EXTRA_ENABLE SMALLINT = 1)
 RETURNS(ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_SET_ARCHIVE$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE PROFILE_SET_ARCHIVE$INT(P_DBKEY CHAR(8),
ARCHIVE_STATUS SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_ARCHIVATE_ACCOUNTS$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE RES_ARCHIVATE_ACCOUNTS$INT(ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACC_ARCHIVE$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE RES_SAVE_ACC_ARCHIVE$INT(ACCOUNTS_FOR_ARCHIVE VARCHAR(2000),
ID_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_SET_ARCHIVE_STATUS) */
ALTER PROCEDURE ACCOUNT_SET_ARCHIVE_STATUS(ID_ACCOUNT INTEGER,
IS_ARCHIVE SMALLINT)
 AS
declare variable post_sum numeric (15,2);
  declare variable dep_sum numeric (15,2);
  declare variable open_charges integer;
  declare variable old_is_archive integer;
  declare variable id_profile integer;
  declare variable id_hotel integer;
  declare variable p_dbkey char(8);
  declare variable acc_dbkey char(8);
  declare variable archived_date date;
  declare variable is_used integer;
  declare variable action_text varchar(255);
  declare variable account_name varchar(50);
  declare variable id_reserv_detail integer;
  declare variable id_sale_num integer;
begin

  select A.RDB$DB_KEY, A.IS_ARCHIVE, A.ID_PROFILE, A.ID_HOTEL, A.ACCOUNT_NAME,
         a.ID_RESERV_DETAIL, a.ID_SALE_NUM
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :acc_dbkey, :old_is_archive, :id_profile, :id_hotel, :account_name,
         :id_reserv_detail, :id_sale_num;
  /* --------------------------------------- */
  if (:old_is_archive = :IS_ARCHIVE) then exit;
  /* --------------------------------------- */
  if (:IS_ARCHIVE = 0) then begin
    -- unarchive
    update ACCOUNT A
    set    A.IS_ARCHIVE = 0
    where  A.RDB$DB_KEY = :acc_dbkey;

    p_dbkey = null;
    select P.RDB$DB_KEY
    from   PROFILE P
    where  P.ID_PROFILE = :id_profile
           and p.IS_ARCHIVE = 1
    into   :p_dbkey;

    if (:p_dbkey is not null) then begin
      /* restore profile active status */
      execute procedure PROFILE_SET_ARCHIVE$INT (:p_dbkey, 0);
    end

    if (:id_reserv_detail is not null and :id_sale_num is null) then begin
      if (exists (select rd.ID_RESERV_DETAIL
                  from   RESERV_DETAIL rd
                  where  rd.ID_RESERV_DETAIL = :id_reserv_detail
                         and rd.CHECK_STATUS = 0)) then
      begin
        execute procedure ACCOUNT_SALE_NUMBER_SET(:ID_ACCOUNT)
        returning_values (:id_sale_num);

        when any do begin end -- nothing
      end
    end
  end else begin
    execute procedure ACCOUNT_USE_CHECK$INT (:ID_ACCOUNT)
    returning_values (:is_used);

    if (:is_used = 1) then begin
      select AB.POST_VALUE, AB.DEP_VALUE, AB.OPEN_CHARGES
      from   ACCOUNT_BALANCE$INT(:id_account) AB
      into   :post_sum, :dep_sum, :open_charges;
  
      if ((:post_sum <> 0) or (:open_charges = 1)) then
        exception ACCOUNT_EXCEPTION '-44' || f_character(31) || :ID_ACCOUNT;

      if (:dep_sum <> 0) then
        exception ACCOUNT_EXCEPTION '-40' || f_character(31) || :ID_ACCOUNT;
    
      execute procedure SYSTEM_DATE_GET (:id_hotel)
      returning_values (:archived_date);
    end else begin
      archived_date = null;  /* mark account as unused */
    end

    update ACCOUNT A
    set    A.IS_ARCHIVE = 1,
           A.ARCHIVED_DATE = :archived_date
    where  A.RDB$DB_KEY = :acc_dbkey;

    action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'ARCHIVE_ACCOUNT', :action_text);
  end
end
^

/* Alter (ACCOUNTS_BALANCE_TO_DATE$RPT) */
ALTER PROCEDURE ACCOUNTS_BALANCE_TO_DATE$RPT(ID_HOTEL INTEGER,
TO_DATE DATE)
 RETURNS(ID_ACCOUNT INTEGER,
ACCOUNT_CURR CHAR(3),
CURR_RATE NUMERIC(15,6),
POSTING_AMOUNT NUMERIC(15,4),
PAYMENT_AMOUNT NUMERIC(15,4),
OPEN_DEP_AMOUNT NUMERIC(15,4),
OPEN_CHARGES INTEGER)
 AS
declare variable rates_marker integer;
declare variable all_payment_amount numeric(15,4);
declare variable used_payments numeric(15,4);
declare variable round_to numeric(15,4);
declare variable max_fin_date date;
begin
  select max(S.SUMMARY_DATE)
  from   SUMMARY_END_WORK S
  where  S.ID_HOTEL = :id_hotel
  into   :max_fin_date;

  if (:to_date > :max_fin_date) then to_date = :max_fin_date;

  execute procedure CURR_RATES_PREPARE$RPT (:ID_HOTEL, :TO_DATE)
  returning_values :rates_marker;

  for
    select A.ID_ACCOUNT, A.ACCOUNT_CURR, T.CURR_RATE, c.ROUND_TO,
           (select sum(AD.POST_AMOUNT)
            from   ACCOUNT_DEBT AD
            where  AD.ID_ACCOUNT = A.ID_ACCOUNT
                   and (AD.DEBT_DATE - 1) < :to_date),
           (select sum(ap.ACC_AMOUNT)
            from   ACCOUNT_PAYMENTS AP
            where  Ap.ID_ACCOUNT = A.ID_ACCOUNT
                   and AP.TRANSACTION_DATE <= :to_date),
           (select cast(sum(rp.realized_value * cast(tr.CURR_RATE / t.CURR_RATE as double precision)) as numeric(15,4))
             from  DOCUMENT_PAYMENT rp
                   left outer join CURR_RATES$TMP TR on TR.DOC_SELECTED = :rates_marker and tr.curr = rp.pay_currency
             where rp.id_account = a.id_account
                   and rp.realize_date <= :to_date)
    from   ACCOUNT A
           join CURRS c on c.CURR = a.ACCOUNT_CURR
           left outer join CURR_RATES$TMP T on T.DOC_SELECTED = :rates_marker and T.CURR = A.ACCOUNT_CURR
    where  A.ID_HOTEL = :id_hotel
           and ((A.IS_ARCHIVE = 0) or (a.ARCHIVED_DATE > :to_date))
    into   :ID_ACCOUNT, :ACCOUNT_CURR, :CURR_RATE, :round_to, :POSTING_AMOUNT, :all_payment_amount, :used_payments
  do begin
    if (round_f(coalesce(:POSTING_AMOUNT, 0) - coalesce(:used_payments, 0), :round_to) = 0) then OPEN_CHARGES = 0; else OPEN_CHARGES = 1;
    PAYMENT_AMOUNT = :used_payments;
    OPEN_DEP_AMOUNT = :all_payment_amount - coalesce(:used_payments, 0);
    suspend;
  end

  delete from CURR_RATES$TMP T
  where  T.DOC_SELECTED = :rates_marker;
end
^

/* Alter (AGENT_AGES_MODIFY$PROFILE) */
ALTER PROCEDURE AGENT_AGES_MODIFY$PROFILE(ID_AGENT_AGES INTEGER,
ID_AGENT INTEGER,
AGE_START INTEGER,
AGE_END INTEGER,
AGES_NAME VARCHAR(50),
IS_CHILD SMALLINT,
OPERATION VARCHAR(10))
 RETURNS(NEW_ID_AGENT_AGES INTEGER)
 AS
declare variable birth_day date;
declare variable from_date date;
declare variable g_dbkey char(8);
begin
  /* Procedure Text */
  execute procedure SYSTEM_CHECK_OPERATION (:OPERATION, 'add,mod,del');

  if (:operation = 'add') then begin
    insert into AGENT_AGES (ID_AGENT, AGE_START, AGE_END, AGES_NAME, IS_CHILD)
    values (:ID_AGENT, :AGE_START, :AGE_END, :AGES_NAME, :IS_CHILD)
    returning ID_AGENT_AGES
    into      :NEW_ID_AGENT_AGES;

  end else if (:operation = 'mod') then begin
    update AGENT_AGES
    set    ID_AGENT = :ID_AGENT,
           AGE_START = :AGE_START,
           AGE_END = :AGE_END,
           AGES_NAME = :AGES_NAME,
           IS_CHILD = :IS_CHILD
    where  ID_AGENT_AGES = :ID_AGENT_AGES;

    NEW_ID_AGENT_AGES = :ID_AGENT_AGES;

    for
      select gc.BIRTH_DAY, g.FROM_DATE, g.RDB$DB_KEY
      from   GUEST G
             left join GUEST_CARD GC on gc.ID_GUEST = g.ID_GUEST
      where  G.ID_AGENT = :ID_AGENT
             and gc.BIRTH_DAY is not null
      into   :birth_day, :from_date, :g_dbkey
    do begin
      execute procedure GUEST_GET_AGENT_AGES(:ID_AGENT, :birth_day, :from_date)
      returning_values  :id_agent_ages;

      update GUEST G
      set    g.ID_AGENT_AGES = :ID_AGENT_AGES
      where  g.RDB$DB_KEY = :g_dbkey;
    end 
  end else if (:operation = 'del') then begin
    delete from  AGENT_AGES AA
    where  AA.ID_AGENT_AGES = :ID_AGENT_AGES;

    NEW_ID_AGENT_AGES = null;
  end
end
^

/* empty dependent procedure body */
/* Clear: ALLOTMENT_AGENT_GET for: ALLOTMENT_GET$INT */
ALTER PROCEDURE ALLOTMENT_AGENT_GET(FROM_DATE DATE,
TO_DATE DATE,
IN_ID_ROOM_TYPE INTEGER,
IN_ID_AGENT INTEGER,
INFO_TYPE VARCHAR(40),
MIND_RELEASE_DATES SMALLINT)
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ROOM_TYPE VARCHAR(50),
CNT_ROOMS INTEGER,
IS_DEFINED INTEGER,
IS_RELEASED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ALLOTMENT_GET for: ALLOTMENT_GET$INT */
ALTER PROCEDURE ALLOTMENT_GET(ID_ALLOTMENT INTEGER,
ID_HOTEL INTEGER)
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ROOM_TYPE VARCHAR(30),
CNT_DEFINED INTEGER,
CNT_BOOKED INTEGER,
ACTIVE_FRAME_BEGIN INTEGER,
IS_DEFINED INTEGER,
IS_RELEASED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ALLOTMENT_OVERBOOK_GET for: ALLOTMENT_GET$INT */
ALTER PROCEDURE ALLOTMENT_OVERBOOK_GET(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER)
 RETURNS(FOR_DATE DATE,
ROOM_TYPE VARCHAR(30),
ROOM_TYPE2 VARCHAR(30),
QTY_ALLOW INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ALLOTMENT_GET$INT) */
ALTER PROCEDURE ALLOTMENT_GET$INT(ID_ALLOTMENT INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ROOM_TYPE_FILTER INTEGER,
OPTIONS VARCHAR(255),
HOTELS VARCHAR(255) = '')
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ROOM_TYPE VARCHAR(30),
ID_HOTEL INTEGER,
CNT_DEFINED INTEGER,
CNT_BOOKED INTEGER,
ACTIVE_FRAME_BEGIN INTEGER,
IS_DEFINED INTEGER,
GRP_TAG INTEGER,
IS_RELEASED INTEGER)
 AS
declare variable sys_date date;
  declare variable prev_date date;
  declare variable ifrom_date date;
  declare variable ito_date date;
  declare variable icnt_defined integer;
  declare variable cnt_bp_define integer;
  declare variable cnt_bp_nonbooked integer;
  declare variable id_agent integer;
  declare variable id_booking_position integer;
  declare variable prev_frame_begin integer;
begin
  /*
  || MIND_RELEASE_DATES HAS MEANING ONLY FOR THE CONTINGENT.
  !!!!! not as you may expect: IS_RELEASED = 0 means RELEASED, =1 means NOT RELEASED
  */
  IS_DEFINED = 1;
  grp_tag = 1;
  for
    select MAXDATE(AD.FROM_DATE, :FROM_DATE), MINDATE(AD.TO_DATE, :TO_DATE),
           AD.CNT_ROOMS,
           AD.ID_ROOM_TYPE, RT.ID_HOTEL, RT.TYPE_ROOM
    from   ALLOTMENT A
           join ALLOTMENT_DETAIL AD on AD.ID_ALLOTMENT = A.ID_ALLOTMENT
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = AD.ID_ROOM_TYPE
           join HOTEL_S H on H.ID_HOTEL = RT.ID_HOTEL
    where  A.ID_ALLOTMENT = :ID_ALLOTMENT
           and ((:room_type_filter is null) or (AD.ID_ROOM_TYPE = :room_type_filter))
           and AD.FROM_DATE <= :to_date
           and AD.TO_DATE   >= :from_date
           and ((:hotels = '') or (','||:hotels||',' containing ','||H.ID_HOTEL||','))
    order by AD.TO_DATE asc
    into   :ifrom_date, :ito_date,
           :icnt_defined,
           :id_room_type, :id_hotel, :room_type
  do begin
    execute procedure sys_dbg('occ ALLOTMENT_GET$INT :ID_ALLOTMENT, :ifrom_date, :ito_date, :icnt_defined, :id_room_type, :id_hotel = ' || :ID_ALLOTMENT ||','|| :ifrom_date ||','|| :ito_date||','|| :icnt_defined||','|| :id_room_type||','|| :id_hotel);
    grp_tag = :grp_tag + 1;
    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :sys_date;
    prev_frame_begin = 0;
    for
      select SLP.OUT_DATE
      from   SYSTEM_LOOP_PERIOD(:ifrom_date, :ito_date) SLP
      into   :for_date
    do begin
      active_frame_begin = null;
      select first 1 AR.DAYS_BEFORE
      from   ALLOTMENT_RELEASE AR
      where  AR.ID_ALLOTMENT = :id_allotment
             and AR.ID_ROOM_TYPE = :id_room_type
             and :for_date between AR.FROM_DATE and AR.TO_DATE
      into   :active_frame_begin;
      execute procedure sys_dbg('occ ALLOTMENT_GET$INT :for_date, :id_room_type, :active_frame_begin = ' || :for_date ||','|| :id_room_type ||','|| coalesce(:active_frame_begin, '') );
      --TODO for optimisation days_before may be moved as for select breaking the room_count period into smaller ones
      active_frame_begin = coalesce (active_frame_begin, 0); --if no defined release days - 0 is defaulting.
      if ((:for_date-:sys_date) < :active_frame_begin) then is_released = 0; else is_released = 1; --!!! att. is_released = 0 mean NOT RELEASED
      if ((:options containing 'RELEASES') and (:options not containing 'EDIT') and (:is_released = 0)) then cnt_defined = 0;
      else cnt_defined = :icnt_defined;
      execute procedure sys_dbg('occ ALLOTMENT_GET$INT :for_date, :id_room_type, :is_released = ' || :for_date ||','|| :id_room_type ||','|| :is_released );
      if ((:for_date <> :prev_date + 1)
         or (:active_frame_begin <> :prev_frame_begin)
      )  then grp_tag = :grp_tag + 1;
      suspend;
      prev_frame_begin = :active_frame_begin;
      prev_date = :for_date;
    end
  end

  IS_DEFINED = 0;
  IS_RELEASED = 1;
  if (:OPTIONS containing 'CONTINGENT_PERIOD') then begin
    select  PA.ID_AGENT, PA.ID_BOOKING_POSITION
    from    PROFILE_AGENT PA
    where   PA.ID_CONTINGENT = :ID_ALLOTMENT
    into    :ID_AGENT, :ID_BOOKING_POSITION;

    for
      select RT.ID_ROOM_TYPE, RT.TYPE_ROOM, RT.ID_HOTEL
      from   ROOM_TYPES RT
             join HOTEL_S H on H.ID_HOTEL = RT.ID_HOTEL
      where  ((:ROOM_TYPE_FILTER is null) or (RT.ID_ROOM_TYPE = :ROOM_TYPE_FILTER))
             and ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
      into   :ID_ROOM_TYPE, :ROOM_TYPE, :ID_HOTEL
    do begin
      CNT_BOOKED = 0;
      for
        select SLP.OUT_DATE, 0
        from   SYSTEM_LOOP_PERIOD(:FROM_DATE, :TO_DATE) SLP
        into   :FOR_DATE, :CNT_DEFINED
      do begin
        if (:OPTIONS containing 'BOOKED') then begin
          select count(distinct RM.ID_ROOM)
          from   ROOM_MAGIC RM
                 join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = rm.ID_RESERV_DETAIL
          where  RM.BUSY_DATE = :FOR_DATE
                 and RD.ID_ROOM_TYPE = :ID_ROOM_TYPE
                 and RM.ID_AGENT = :ID_AGENT /* OCCUPANCY GAN BE GET ONLY FOR PARTICULAR AGENT, NOT FOR ALL */
                 and RM.DAY_ACTION not containing 'CHECK_OUT'
          into   :CNT_BOOKED;

          select ACD.CNT_DEFINED
          from   ALLOTMENT_GET$INT(:ID_BOOKING_POSITION, :FOR_DATE, :FOR_DATE, :ID_ROOM_TYPE, '', :HOTELS) ACD
          into   :CNT_BP_DEFINE;
          CNT_BP_NONBOOKED = (:CNT_BP_DEFINE - :CNT_BOOKED);
          if (:CNT_BP_NONBOOKED < 0) then CNT_BP_NONBOOKED = 0;
          CNT_BOOKED = (:CNT_BOOKED + :CNT_BP_NONBOOKED);
        end
        suspend;
      end
    end
  end

  if (:OPTIONS containing 'PLAIN_PERIOD') then begin
    for
      select RT.ID_ROOM_TYPE, RT.TYPE_ROOM, RT.ID_HOTEL
      from   ROOM_TYPES RT
             join HOTEL_S H on H.ID_HOTEL = RT.ID_HOTEL
      where  ((:ROOM_TYPE_FILTER is null) or (RT.ID_ROOM_TYPE = :ROOM_TYPE_FILTER))
             and ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
      into   :ID_ROOM_TYPE, :ROOM_TYPE, :ID_HOTEL
    do begin
      for
        select SLP.OUT_DATE, 0
        from   SYSTEM_LOOP_PERIOD(:FROM_DATE, :TO_DATE) SLP
        into   :FOR_DATE, :CNT_DEFINED
      do suspend;
    end
  end
end
^

/* Alter (ALLOTMENT_OVERBOOK_GET) */
ALTER PROCEDURE ALLOTMENT_OVERBOOK_GET(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER)
 RETURNS(FOR_DATE DATE,
ROOM_TYPE VARCHAR(30),
ROOM_TYPE2 VARCHAR(30),
QTY_ALLOW INTEGER)
 AS
declare variable id_room_type integer;
begin
  for
    select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ROOM_TYPE, ACG.CNT_DEFINED
    from   HOTEL H
           left outer join ALLOTMENT_GET$INT(H.ID_OVERBOOK_ALLOTMENT, :from_date, :to_date, null, 'PLAIN_PERIOD', :id_hotel) ACG on 0=0
    where  H.ID_HOTEL = :id_hotel
    into   :for_date, :id_room_type, :room_type, :qty_allow
  do begin
    room_type2 = :room_type;
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUPANCY$AVL for: AVAILABILITY_OCCUPANCY$INT */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUPANCY_PREPARE for: AVAILABILITY_OCCUPANCY$INT */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY_PREPARE(FROM_DATE DATE,
TO_DATE DATE,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (AVAILABILITY_OCCUPANCY$INT) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$INT(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
declare variable id_global_agent integer;
  declare variable for_date date;
  declare variable id_agent integer;
  declare variable id_room_type integer;
  declare variable g_capacity integer;
  declare variable bp_defined integer;
  declare variable c_defined integer;
  declare variable fdata integer;
  declare variable bp_is_released integer;
  declare variable c_is_released integer;
  declare variable gsts_in_house integer;
  declare variable gsts_come integer;
  declare variable gsts_gone integer;
  declare variable rooms_come integer;
  declare variable rooms_gone integer;
  declare variable id_hotel integer;
  declare variable id_b_allotment integer;
  declare variable id_c_allotment integer;
  declare variable ooo_rooms integer;
  declare variable ooi_rooms integer;
  declare variable sold_rooms integer;
  declare variable res_room_conf integer;
  declare variable res_room_notconf integer;
  declare variable res_room_wait integer;
  declare variable id_booked_room_type integer;
begin
  /*  Description:   */
  ID_GLOBAL_AGENT = -100; /* HOLDS DATA GLOBAL FOR THE HOTEL */

  if (coalesce(:HOTELS, '') = '') then begin
    select list (h.ID_HOTEL)
    from   HOTEL_S H
    into   :HOTELS;
  end

  delete from SMART_OCCUP$TMP;

  for
    select RC.ID_ROOM_TYPE, RC.ID_HOTEL, RC.FOR_DATE, sum(RC.CNT_DEFINED)
    from   HOTEL_S H
           left outer join ALLOTMENT_GET$INT(H.ID_INVENTORY_ALLOTMENT, :FROM_DATE, :TO_DATE, null, 'PLAIN_PERIOD', :HOTELS) RC on 0=0
    where  (','||:HOTELS||',' containing ','||H.ID_HOTEL||',')
           and rc.ID_ROOM_TYPE is not null
    group by 1, 2, 3
    into   :ID_ROOM_TYPE, :ID_HOTEL, :FOR_DATE, :G_CAPACITY
  do begin
    execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_global_agent, :id_room_type, :id_hotel, :g_capacity);
  end

  for
    select   RM.BUSY_DATE, RM.ID_ROOM_TYPE, rd.ID_ROOM_TYPE, RM.ID_HOTEL,
             iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (18,20),
                 :ID_GLOBAL_AGENT,
                 iif(RS.ID_ROOM_SHARE is not null, rs.ID_AGENT, RM.ID_AGENT)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 18, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 20, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 24, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_CONFIRMED', RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_NOTCONFIRMED', RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_RESERVS', RM.ID_ROOM, null))
    from     SYSTEM_STRING_PARSER(:HOTELS) sp
             left join ROOM_MAGIC RM on rm.ID_HOTEL = sp.ITEM
             left outer join ROOMS_SHARE RS on RS.ID_ROOM_SHARE = RM.ID_ROOM_MAGIC
             left outer join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = coalesce(rs.ID_RESERV_STATISTICS, rm.ID_RESERV_DETAIL)
    where    RM.BUSY_DATE between :from_date and :to_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and rm.ROOM_STATUS is distinct from 'PRIVATE'
             and ((not (:RES_CONFIRMED = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_CONFIRMED'))
                  or (not (:RES_NOTCONFIRMED = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_NOTCONFIRMED'))
                  or (not (:RES_WAITING = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_RESERVS')))
    group by 1, 2, 3, 4, 5
    into     :for_date, :id_room_type, :id_booked_room_type, :id_hotel, :id_agent,
             :ooo_rooms, :ooi_rooms, :sold_rooms, :res_room_conf, :res_room_notconf, :res_room_wait
  do begin
    execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
            null, :ooo_rooms, :ooi_rooms, null, :sold_rooms, :res_room_conf, :res_room_notconf, :res_room_wait);
    if (:id_agent > 0 and :id_booked_room_type is not null) then
      execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, -:id_booked_room_type, :id_hotel,
              null, :ooo_rooms, :ooi_rooms, null, :sold_rooms, :res_room_conf, :res_room_notconf, :res_room_wait);
  end

  if (:BOOKING_POSITIONS + :CONTINGENT > 0) then begin
    for
      select PA.ID_AGENT, PA.ID_BOOKING_POSITION, pa.ID_CONTINGENT
      from   PROFILE_AGENT PA
      where  (pa.ID_CONTINGENT is not null) or (pa.ID_BOOKING_POSITION is not null)
      into   :id_agent, :id_b_allotment, :id_c_allotment
    do begin
      for
        select al.for_date, al.id_room_type, al.id_hotel,
               sum(al.b_defined), max(al.b_is_released), sum(al.c_defined), max(al.c_is_released)
        from   (select ABP.FOR_DATE, ABP.ID_ROOM_TYPE, ABP.ID_HOTEL,
                       ABP.CNT_DEFINED as b_defined, ABP.IS_RELEASED as b_is_released, null as c_defined, null as c_is_released
                from   ALLOTMENT BA
                       left join ALLOTMENT_GET$INT(ba.ID_ALLOTMENT, :from_date, :to_date, null, 'RELEASES', :hotels) ABP on 1=1
                where  :BOOKING_POSITIONS = 1 and ba.ID_ALLOTMENT = :id_b_allotment
                union all
                select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ID_HOTEL, null, null, ACG.CNT_DEFINED, ACG.IS_RELEASED
                from   ALLOTMENT CA
                       left join ALLOTMENT_GET$INT(ca.ID_ALLOTMENT, :from_date, :to_date, null, '', :hotels) ACG on 1=1
                where  :CONTINGENT = 1 and CA.ID_ALLOTMENT = :id_c_allotment
               ) al
        where  al.for_date is not null
        group by 1, 2, 3
        into   :for_date, :id_room_type, :id_hotel,
               :bp_defined, :bp_is_released, :c_defined, :c_is_released
      do begin
        execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, -:id_room_type, :id_hotel,
                null, null, null, null, null, null, null, null, :c_defined, :c_is_released, :bp_defined, :bp_is_released);
      end
    end
  end

  if (:OVERBOOK = 1) then begin
    for
      select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ID_HOTEL, ACG.CNT_DEFINED
      from   HOTEL_S H
             left outer join ALLOTMENT_GET$INT(H.ID_OVERBOOK_ALLOTMENT, :FROM_DATE, :TO_DATE, null, '', :HOTELS) ACG on 0=0
      where  ACG.FOR_DATE is not null
             and (','||:HOTELS||',' containing ','||H.ID_HOTEL||',')
      into   :for_date, :id_room_type, :id_hotel, :fdata
    do begin
      execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
              null, null, null, :fdata);
    end
  end

  if (:FETCH_TOTALS = 1) then begin
    for
      select RM.BUSY_DATE, RM.ID_ROOM_TYPE, RM.ID_HOTEL, RM.ID_AGENT,
             sum(RM.STAYOVER_ADULTS + RM.STAYOVER_CHILDREN + RM.ARRIVAL_ADULTS + RM.ARRIVAL_CHILDREN),
             sum(RM.ARRIVAL_ADULTS + RM.ARRIVAL_CHILDREN),
             sum(RM.DEPARTURE_ADULTS + RM.DEPARTURE_CHILDREN),
             sum(rm.ARRIVAL_ROOM),
             sum(rm.DEPARTURE_ROOM)
      from   SYSTEM_STRING_PARSER(:HOTELS) sp
             left join HOTEL_ROOM_OCCUPANCY RM on rm.ID_HOTEL = sp.ITEM
      where  RM.BUSY_DATE between :from_date and :to_date
             and rm.BUSY_GROUP_TYPE in (1, 24)
             and RM.BUSY_TYPE not in ('VALUE_RESERVS')
      group by 1, 2, 3, 4
      into   :for_date, :id_room_type, :id_hotel, :id_agent,
               :gsts_in_house, :gsts_come, :gsts_gone, :rooms_come, :rooms_gone
    do begin
      execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
              null, null, null, null, null, null, null, null, null, null, null, null,
              :gsts_in_house, :gsts_come, :gsts_gone, :rooms_come, :rooms_gone);
    end
  end
end
^

/* Alter (AVAILABILITY_OCCUPANCY_PREPARE) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY_PREPARE(FROM_DATE DATE,
TO_DATE DATE,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
begin
  -- used from some reports - generate occupancy for selection
  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, 1, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT, :HOTELS);
   
  execute procedure AVAILABILITY_OCCUPANCY_OPT$INT (:RELEASE_DATES, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT);

  ID_OCCUPANCY_SESSION = current_transaction;
  suspend;
end
^

/* Alter (AVAILABILITY_RATE_SMALL$WBE) */
ALTER PROCEDURE AVAILABILITY_RATE_SMALL$WBE(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER,
ROOMS INTEGER,
ADULTS INTEGER,
CHILDREN INTEGER,
QUERY_ID INTEGER,
PROFILE_ID INTEGER)
 AS
declare variable id_room_type integer;
declare variable nonavaialbility_note varchar(255);
declare variable is_available smallint;
declare variable id_rate integer;
declare variable id_board integer;
declare variable roomtype_list varchar(2000);
declare variable rate_list varchar(2000);
declare variable board_list varchar(2000);
declare variable hotels varchar(255);
declare variable room_status integer;
declare variable rate_status integer;
declare variable rate_min_los integer;
declare variable rate_max_los integer;
declare variable id_channel integer;
declare variable helper_session_id integer;
declare variable error_check integer;
declare variable available_roomtype_list varchar(2000);
declare variable special_rate_list varchar(2000);
declare variable available_rooms integer;
declare variable is_public smallint;
begin
    
  /*Produces data in result table availabiliti_rate$wbe.
   Get availability as AVAILABILITY_OCCUP_SMALL$WBE see there for notes */

  /*empty WBE specific table*/
  delete from product_availability$wbe p
  where p.query_id = :query_id;

  /* find id_channel for wbe*/
  select max(c.id_channel), count(c.id_channel)  from channel c where c.name = 'WBE'
  into :id_channel, :error_check;
  if (not (:error_check = 1)) then  exception WRONG_VALUE 'Missing channel WBE or dublicated definition!';

  /*First check chennel management - find rates, room type for sale and restrictions*/
  special_rate_list = ',';
  available_roomtype_list = ',';
  helper_session_id =  gen_id(SELECTION_GEN, 1);
  for
    select c.id_room_type, c.id_tar_head, c.is_product_avaialable, c.room_status, c.rate_status,
           c.rate_min_los, c.rate_max_los, c.available_rooms, c.is_public
    from   channel_product_avail_req$int (:id_channel, :id_hotel, :from_date, :to_date, :rooms) c
    into   :id_room_type, :id_rate, :is_available, :room_status, :rate_status,
           :rate_min_los, :rate_max_los, :available_rooms, :is_public
  do begin
      /*make a list of available roomt types - needed for special rate product building*/
      if ((:room_status = 2) and (','|| :available_roomtype_list ||',' not containing ','|| :id_room_type ||',')) then
        available_roomtype_list = :available_roomtype_list || :id_room_type ||',';

      /*set nonavaialbility_note*/
      nonavaialbility_note = '';
      if (:is_available = 0) then begin
        if ((:room_status = 0) or (:room_status is null) ) then nonavaialbility_note = '@{No rooms available.} ';
        else begin
            if (:rate_status = 0) then nonavaialbility_note = nonavaialbility_note || '@{Rate is closed.} ';
            if (:rate_status = 1) then nonavaialbility_note = nonavaialbility_note || '@{Rate is closed for arrival.} ';
            if (:rate_status = 2 and :rate_min_los = :rate_max_los) then nonavaialbility_note = nonavaialbility_note || '@{Required stay} ' || rate_min_los || ' @{days.} ';
            if ((:rate_status = 2) and (:rate_min_los > 0) and (:rate_min_los is distinct from :rate_max_los)) then  nonavaialbility_note = nonavaialbility_note || '@{Minimum stay} ' || rate_min_los || ' @{days.} ';
            if ((:rate_status = 2) and (:rate_max_los > 0) and (:rate_min_los is distinct from :rate_max_los)) then  nonavaialbility_note = nonavaialbility_note || '@{Maximum stay} ' || rate_max_los || ' @{days.} ';
        end
      end

      /*insert status and note in int table for this product IF RATE IS PUBLIC or If it is Private but allowed in current profile. Supress 'closed' rate, but show closed for arrival, min los, etc.*/
      /* !! new behaviour - SPECIAL/PRIVATE rates must be managed from CHANNEL MANAGEMENT too */
      if (:rate_status <> 0) then begin
        if (:is_public = 1) then begin
          insert into product_availability$int (session_id, room_type_id, rate_id, is_available, nonavaialbility_note, available_rooms)
          values (:helper_session_id, :id_room_type, :id_rate, :is_available, :nonavaialbility_note, :available_rooms);
        end else begin /* If it is PRIVATE */
          if (exists ( select phr.id_tariff
                        from profile_hotel_rate phr
                        where phr.id_profile = :profile_id
                          and phr.id_hotel = :id_hotel
                          and phr.id_tariff = :id_rate )) then
          begin
              insert into product_availability$int (session_id, room_type_id, rate_id, is_available, nonavaialbility_note, available_rooms)
              values (:helper_session_id, :id_room_type, :id_rate, :is_available, :nonavaialbility_note, :available_rooms);
              /*Making special rate list for indicating in WBE GUI. Rate will be indicated as special if they are private */
              special_rate_list = :special_rate_list || :id_rate ||',';
          end
        end
      end

  end


  /* for available rates - make a rate list. */
  rate_list = ',';
  for
    select distinct pa.rate_id
    from   product_availability$int pa
    where  pa.session_id = :helper_session_id
      /*$$IBEC$$   and pa.is_available = 1 $$IBEC$$*/
    into :id_rate
  do begin
    rate_list = :rate_list || :id_rate || ',';
  end

  /* make a room type list from prepared int table*/
  ROOMTYPE_LIST = ',';
  for
    select distinct pa.room_type_id
    from product_availability$int pa
    where pa.session_id = :helper_session_id
       /*$$IBEC$$  and pa.is_available = 1 $$IBEC$$*/
    into :id_room_type
  do begin
    roomtype_list = :roomtype_list || :id_room_type || ',';
  end

  /* make a list of all boards. Rating will remove non used boards */
  --BOARD_LIST = ',0,'; -- without board
  BOARD_LIST = ',';
  for
    select th.ID_BOARD
    from   MEALS th
    where  th.IS_ARCHIVE = 0
           and th.IS_BOARD = 1
           and th.ID_HOTEL = :ID_HOTEL
           --and th.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
    into   :id_board
  do begin
    BOARD_LIST = :BOARD_LIST || coalesce(:id_board, 0) || ',';
  end

  hotels = ',' || :id_hotel ||',';

  execute procedure sys_dbg('wbe PARAMS FOR  availability_raiting_sub$int :');
  execute procedure sys_dbg('wbe -:helper_session_id = '|| :helper_session_id);
  execute procedure sys_dbg('wbe -:from_date = '|| :from_date);
  execute procedure sys_dbg('wbe -:to_date = '|| :to_date);
  execute procedure sys_dbg('wbe -:rooms = '|| :rooms);
  execute procedure sys_dbg('wbe -:adults = '|| :adults);
  execute procedure sys_dbg('wbe -:children = '|| :children);
  execute procedure sys_dbg('wbe -:roomtype_list = '|| :roomtype_list);
  execute procedure sys_dbg('wbe -:rate_list = '|| :rate_list);
  execute procedure sys_dbg('wbe -:board_list = '|| :board_list);
  execute procedure sys_dbg('wbe -:hotels = '|| :hotels  );
  execute procedure sys_dbg('wbe -:available_roomtype_list = '|| :available_roomtype_list );

  /*calc prices for request in TMP_AVAILABILITY */
  execute procedure AVAILABILITY_RATING_LOOP$INT (:helper_session_id,  :from_date, :to_date,
                    :rooms, :adults, :children, :roomtype_list, :rate_list, :board_list, :hotels);

  /*Copy data to WBE specific table*/
  insert into PRODUCT_AVAILABILITY$WBE
       (query_id, room_type_id, room_name, rate_id, rate_name, board_id, board_name,
       price_night, price_total, currency, is_available, nonavailability_note,
       is_special_rate, available_rooms)
  select :query_id, pa.room_type_id, rt.type_room, pa.rate_id, t.tarifa_name, ta.id_board, th.NAME,
        ta.price, ta.total_price, ta.currency, coalesce( pa.is_available, 0), pa.nonavaialbility_note,
        iif( ','|| :special_rate_list ||',' containing ','|| pa.rate_id ||',', 1, 0), pa.available_rooms
  from  PRODUCT_AVAILABILITY$INT pa /*left outer join*/
        join TMP_AVAILABILITY ta on pa.room_type_id = ta.id_room_type
                                    and pa.rate_id = ta.id_rate
                                    and pa.session_id = ta.ID_SESSION
        join ROOM_TYPES rt on rt.id_room_type =  ta.id_room_type
        join TARIFA t on t.id_tarifa = ta.id_rate
        join MEALS th on th.ID_BOARD = ta.id_board
  where pa.session_id = :helper_session_id;
        --and ta.id_board is not null; -- ???

/*Empty tmp_availability*/
  delete from TMP_AVAILABILITY ta
  where  ta.ID_SESSION = :helper_session_id;

  /*Empty helper in table product_availability$int*/
  delete from  PRODUCT_AVAILABILITY$INT p
  where p.session_id = :helper_session_id;

end
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_RATING$AVL for: AVAILABILITY_RATING_LOOP$INT */
ALTER PROCEDURE AVAILABILITY_RATING$AVL(ID_AGENT_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ROOMS_COUNT INTEGER,
ADULTS_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ROOMTYPE_LIST VARCHAR(2000),
RATE_LIST VARCHAR(2000),
BOARD_LIST VARCHAR(2000),
HOTELS VARCHAR(255) = '')
 RETURNS(ID_SESSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (AVAILABILITY_RATING_LOOP$INT) */
ALTER PROCEDURE AVAILABILITY_RATING_LOOP$INT(ID_SESSION INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ROOMS_COUNT INTEGER,
ADULTS_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ROOMTYPE_LIST VARCHAR(2000),
RATE_LIST VARCHAR(2000),
BOARD_LIST VARCHAR(2000),
HOTELS VARCHAR(255) = '')
 AS
declare variable id_rate integer;
declare variable id_board integer;
declare variable id_room_type integer;
declare variable price_currency char(3);
declare variable price numeric (15,4);
declare variable total_price numeric (15,4);
declare variable round_to numeric (15,4);
declare variable price_details varchar(100);
declare variable stay_length integer;
declare variable calc_adult_count integer;
declare variable calc_children_count integer;
declare variable beds integer;
declare variable id_hotel integer;
declare variable id_tar_calc integer;
begin
  /* This proc produced calculations in result table TMP_AVAILABILITY*/
  stay_length = :departure_date - :arrival_date;
  calc_children_count = coalesce(:children_count, 0);
  /* 1. LOOP RATES */
  id_tar_calc = gen_id(GEN_ID_TAR_CALC, 1);
  for
    select distinct T.ID_TARIFA, t.ID_HOTEL,
           rt.ID_ROOM_TYPE, rt.BEDS, tbt.ID_BOARD
    from   SYSTEM_STRING_PARSER (:RATE_LIST, ',') SP
           join TARIFA T on t.ID_TARIFA = sp.ITEM
                            and T.IS_ACTIVE = 1
                            and (
                                  (cast(:hotels as varchar(2000))  = '')
                                 or
                                  (','||(cast(:hotels as varchar(2000)))||',' containing ','||T.ID_HOTEL||',')
                                )
           join TAR_HEAD th on t.id_tarifa = th.id_tar_head
           left outer join TAR_SIMPLE ts on ts.id_tar_head = th.ID_TAR_HEAD
           left outer join TARIFA_ROOM_TYPES_SUPPORTED (th.ID_TAR_HEAD) trt on 1=1
           left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = trt.ID_ROOM_TYPE
           left outer join TARIFA_BOARDS_SUPPORTED (th.ID_TAR_HEAD) tbt on 1=1
           left outer join MEALS b on b.ID_BOARD = tbt.ID_BOARD
    where  cast(:roomtype_list as varchar(2000)) containing ','|| TRT.ID_ROOM_TYPE ||','
           and cast(:board_list as varchar(2000)) containing ','|| coalesce(tbt.ID_BOARD, 0) ||','
    order by th.ID_TAR_HEAD asc,
           rt.beds desc, rt.ID_ROOM_TYPE asc
    into   :id_rate, :id_hotel, :id_room_type, :beds, :id_board
  do begin
    /* fall back to room type bed count but max 2 */
    calc_adult_count = coalesce(:adults_count, iif(:beds >= 2, 2, 1));

    if ((:calc_adult_count is null) or (:calc_children_count is null)) then
      exception assert ('null for calc_adult_count or calc_children_count parameter!' );

    price_currency = null;
    price = null;
    total_price = null;
    price_details = null;

    execute procedure PRODUCT_RATING$INT (:id_hotel, :ARRIVAL_DATE, :DEPARTURE_DATE,
            :calc_adult_count, :calc_children_count, :id_room_type, :id_board, :id_rate, null, null, :id_tar_calc)
    returning_values  :total_price, :price_currency, :price_details;

    if (:total_price is not null) then begin
      select c.ROUND_TO
      from   CURRS c
      where  c.CURR = :price_currency
      into   :round_to;

      price = round_f(:total_price/:stay_length, :round_to);
      total_price = :rooms_count * :total_price;
      insert into TMP_AVAILABILITY (ID_SESSION, ID_ROOM_TYPE, ID_RATE, ID_BOARD, CURRENCY,
              PRICE, TOTAL_PRICE, PRICE_DETAILS, TOTAL_ROOMS, ALLOTMENT_ROOMS)
      values (:id_session, :id_room_type, :id_rate, :id_board, :price_currency,
              :price, :total_price, :price_details, 0, 0);
    end

  end
end
^

/* empty dependent procedure body */
/* Clear: ROOM_TYPE_MODIFY$CFG for: BASE_SERVICES_GEN$INT */
ALTER PROCEDURE ROOM_TYPE_MODIFY$CFG(ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
TYPE_ROOM VARCHAR(20),
BEDS INTEGER,
EXT_CODE VARCHAR(30),
OPERATION VARCHAR(10))
 RETURNS(NEW_ID_ROOM_TYPE INTEGER,
OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SERVICE_MEAL_MODIFY$INT for: BASE_SERVICES_GEN$INT */
ALTER PROCEDURE SERVICE_MEAL_MODIFY$INT(ID_SERVICE /* TYPE OF ID */ INTEGER,
IS_BREAKFAST /* TYPE OF TLOGICAL */ SMALLINT,
IS_LUNCH /* TYPE OF TLOGICAL */ SMALLINT,
IS_DINNER /* TYPE OF TLOGICAL */ SMALLINT,
IS_EXTRAFOOD1 /* TYPE OF TLOGICAL */ SMALLINT,
IS_EXTRAFOOD2 /* TYPE OF TLOGICAL */ SMALLINT,
IS_BOARD /* TYPE OF TLOGICAL */ SMALLINT,
ID_HOTEL /* TYPE OF ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (BASE_SERVICES_GEN$INT) */
ALTER PROCEDURE BASE_SERVICES_GEN$INT(ID_HOTEL INTEGER)
 AS
declare variable id_board integer;
  declare variable type_hrana varchar(30);
  declare variable id_room_type integer;
  declare variable type_room varchar(30);
  declare variable id_type_stay integer;
  declare variable type_stay varchar(30);
  declare variable id_service integer;
  declare variable new_service_name varchar(30);
  declare variable existing_id_service integer;
  declare variable id_service_group integer;
begin

  select (select st.OUTPUT_INT from STR2INT_DEF(sv.SETTING_VALUE) st)
  from   SETTING_GET_VALUE('DEF_BASE_SERVICE_GROUP', :ID_HOTEL, 1) sv
  into   :id_service_group;

  if (:id_service_group is null) then begin
    select min(sg.ID_SERVICE_GROUP)
    from   SERVICE_GROUPS sg
    where  sg.ID_HOTEL = :id_hotel
    into   :id_service_group;
  end
  /*
    CRS/WBE support
    when running the wizard in replication environment the groups are replicated
    as emebeded component and the current subscriber may heve no records in SERVICE_GROUPS
    to resolve this autocreate the default group
   */
  if (:id_service_group is null) then begin
    execute procedure IMPORT_SERVICE_GROUP$EXC(:id_hotel, '-')
    returning_values :id_service_group;
  end

  /* CREATE BASE SERVICES FOR THE FULL COMBINATION FROM HRANI, ROOM_TYPES AND STAY TYPES */
  for
    select sm.ID_BOARD, sm.NAME, ts.ID_TYPE_STAY, ts.TYPE_STAY, rt.ID_ROOM_TYPE, rt.TYPE_ROOM
    from   MEALS sm,
           ROOM_TYPES rt,
           TYPE_STAY ts
    where  sm.ID_HOTEL = :ID_HOTEL
           and sm.IS_BOARD = 1
           and rt.ID_HOTEL = :id_hotel
    into   :id_board, :type_hrana, :id_type_stay, :type_stay, :id_room_type, :type_room
  do begin
    new_service_name = substring(:type_hrana from 1 for 9)||'\'
                       ||substring(:type_room from 1 for 9)||'\'
                       ||substring(:type_stay from 1 for 9);
    existing_id_service = null;
    select sp.ID_SERVICE
    from   SERVICE_PACKET sp
           join SERVICES s on s.ID_SERVICE = sp.ID_SERVICE
    where  s.ID_HOTEL = :id_hotel
           --and s.IS_BASE = 1
           and sp.ID_ROOM_TYPE = :id_room_type
           and sp.ID_TYPE_STAY = :id_type_stay
           and sp.ID_BOARD = :id_board
    into   :existing_id_service;

    if (:existing_id_service is null) then begin
      id_service = gen_id(ID_SERVICE_GEN, 1);
      insert into SERVICES (ID_SERVICE, ID_SERVICE_GROUP, SERVICE_TYPE, /*IS_BASE,*/ SERVICE_NAME,
             IS_DELETED, IS_MANUAL_PRICE, IS_DETAILS,
             REVENUE_GROUP, REVENUE_ACCOUNT, ACCOUNT_NAME, VAUCHER_PACKET, ID_HOTEL)
      values (:id_service, :id_service_group, 'BASE', /*1,*/ :new_service_name,
             0, 0, 0,
             'ROOMS', '<Market segment>', '', 'BASE', :ID_HOTEL);
    end else begin
      id_service = :existing_id_service;
    end

    update or insert into SERVICE_PACKET (ID_SERVICE, ID_TYPE_STAY, ID_ROOM_TYPE, ID_BOARD)
    values (:id_service, :id_type_stay, :id_room_type, :id_board)
    matching(ID_SERVICE);

    update SERVICES s
    set    s.ID_SERVICE_PACKET = :id_service,
           s.SERVICE_NAME = :new_service_name,
           s.IS_DELETED = 0
    where  s.ID_SERVICE = :id_service;

  end

end
^

/* Alter (BOARD_TO_FOODS) */
ALTER PROCEDURE BOARD_TO_FOODS(ID_BOARD TYPE OF ID)
 RETURNS(ID_SERVICE TYPE OF ID_REF)
 AS
declare variable is_breakfast integer;
  declare variable is_lunch integer;
  declare variable IS_DINNER integer;
  declare variable is_extrafood1 integer;
  declare variable is_extrafood2 integer;
  declare variable id_hotel integer;
begin

  select TH.IS_BREAKFAST, TH.IS_LUNCH, TH.IS_DINNER, TH.IS_EXTRAFOOD1, TH.IS_EXTRAFOOD2, TH.ID_HOTEL
  from   MEALS TH
  where  TH.ID_BOARD = :id_board
  into   :is_breakfast, :is_lunch, :IS_DINNER, :is_extrafood1, :is_extrafood2, :ID_HOTEL;

  if (:is_breakfast = 1) then begin
    ID_SERVICE = -1;
    select first 1 TH.ID_SERVICE
    from   MEALS TH
    where  TH.IS_BREAKFAST = 1
           and TH.IS_LUNCH = 0
           and TH.IS_DINNER = 0
           and TH.IS_EXTRAFOOD1 = 0
           and TH.IS_EXTRAFOOD2 = 0
           and TH.IS_BOARD = 0
           and TH.ID_HOTEL = :ID_HOTEL
    order by th.IS_ARCHIVE asc, TH.ID_SERVICE asc
    into   :ID_SERVICE;
    suspend;
  end

  if (:is_lunch = 1) then begin
    ID_SERVICE = -1;
    select first 1 TH.ID_SERVICE
    from   MEALS TH
    where  TH.IS_BREAKFAST = 0
           and TH.IS_LUNCH = 1
           and TH.IS_DINNER = 0
           and TH.IS_EXTRAFOOD1 = 0
           and TH.IS_EXTRAFOOD2 = 0
           and TH.IS_BOARD = 0
           and TH.ID_HOTEL = :ID_HOTEL
    order by th.IS_ARCHIVE asc, TH.ID_SERVICE asc
    into   :ID_SERVICE;
    suspend;
  end

  if (:IS_DINNER = 1) then begin
    ID_SERVICE = -1;
    select first 1 TH.ID_SERVICE
    from   MEALS TH
    where  TH.IS_BREAKFAST = 0
           and TH.IS_LUNCH = 0
           and TH.IS_DINNER = 1
           and TH.IS_EXTRAFOOD1 = 0
           and TH.IS_EXTRAFOOD2 = 0
           and TH.IS_BOARD = 0
           and TH.ID_HOTEL = :ID_HOTEL
    order by th.IS_ARCHIVE asc, TH.ID_SERVICE asc
    into   :ID_SERVICE;
    suspend;
  end

 if (:is_extrafood1 = 1) then begin
    ID_SERVICE = -1;
    select first 1 TH.ID_SERVICE
    from   MEALS TH
    where  TH.IS_BREAKFAST = 0
           and TH.IS_LUNCH = 0
           and TH.IS_DINNER = 0
           and TH.IS_EXTRAFOOD1 = 1
           and TH.IS_EXTRAFOOD2 = 0
           and TH.IS_BOARD = 0
           and TH.ID_HOTEL = :ID_HOTEL
    order by th.IS_ARCHIVE asc, TH.ID_SERVICE asc
    into   :ID_SERVICE;
    suspend;
  end

  if (:is_extrafood2 = 1) then begin
    ID_SERVICE = -1;
    select first 1 TH.ID_SERVICE
    from   MEALS TH
    where  TH.IS_BREAKFAST = 0
           and TH.IS_LUNCH = 0
           and TH.IS_DINNER = 0
           and TH.IS_EXTRAFOOD1 = 0
           and TH.IS_EXTRAFOOD2 = 1
           and TH.IS_BOARD = 0
           and TH.ID_HOTEL = :ID_HOTEL
    order by th.IS_ARCHIVE asc, TH.ID_SERVICE asc
    into   :ID_SERVICE;
    suspend;
  end
end
^

/* Alter (BP_SCHEME_CALC_TURNOVER_POINTS) */
ALTER PROCEDURE BP_SCHEME_CALC_TURNOVER_POINTS(ID_BONUSPOINT_SCHEME INTEGER,
ID_DOC_HEAD INTEGER,
ID_RESERV_DETAIL INTEGER,
POSTING_TYPES VARCHAR(20))
 RETURNS(POINTS INTEGER,
TURNOVER NUMERIC(15,4),
TURNOVER_CURR CHAR(3),
POINTS_REASON VARCHAR(50))
 AS
declare variable turnover_kind varchar(50) ;
declare variable turnover_amount numeric(15,4);
declare variable turnover_points integer;
begin

  select BS.TURNOVER_KIND, BS.TURNOVER_AMOUNT, BS.TURNOVER_POINTS, h.NATION_CURR
  from   BONUSPOINT_SCHEME BS
         join HOTEL H on h.ID_HOTEL = bs.ID_HOTEL
  where  BS.ID_BONUSPOINT_SCHEME = :ID_BONUSPOINT_SCHEME
  into   :turnover_kind, :turnover_amount, :turnover_points, :turnover_curr;

  if (:turnover_kind is not null and :turnover_amount > 0) then begin
    POINTS = null;
    TURNOVER = 0;

    select sum(dl.NAT_GROSS_VALUE) --sum(DL.SINGLE_VALUE * dl.QTY_POST)
    from   DOC_HEAD d
           join DOC_LINE Dl on dl.ID_DOC_HEAD = d.ID_DOC
           join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = dl.ID_DOC_LINE /* only service postings */
           join SERVICES S on S.ID_SERVICE = DL.ID_SERVICE
           left outer join GUEST G on G.ID_GUEST = DL.ID_GUEST
    where  D.ID_DOC = :ID_DOC_HEAD
           and G.ID_RESERV_DETAIL is not distinct from :ID_RESERV_DETAIL /* nulls is possible */
           and ( (:POSTING_TYPES containing 'BASE' and PV.ID_MASTER_ADDINS > 0)
                  or (:POSTING_TYPES containing 'EXTRA' and PV.ID_MASTER_ADDINS is null) )
           and ( (:turnover_kind = 'ALL')
                 or (exists (select BSG.ID_SERVICE_GROUP
                             from   BONUSPOINT_SERVICE_GROUP BSG
                             where  BSG.ID_BONUSPOINT_SCHEME = :ID_BONUSPOINT_SCHEME
                                    and BSG.ID_SERVICE_GROUP = s.ID_SERVICE_GROUP) ))
    into   :TURNOVER;

    points = cast(:TURNOVER * 10000 as integer) / cast(:turnover_amount * 10000 as integer) * :turnover_points;
    POINTS_REASON = 'TURNOVER';
    if (:POINTS is not null) then suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: DOC_CONTRAGENT_SET$DOC for: CONTRAGENT_MODIFY$CONTR */
ALTER PROCEDURE DOC_CONTRAGENT_SET$DOC(ID_DOC INTEGER,
IS_PAY_DOC SMALLINT,
ID_CONTRAGENT INTEGER,
IS_JURIDICAL_PERSON SMALLINT,
CONTRAGENT_NAME VARCHAR(100),
VAT_REG_NUM VARCHAR(30),
IDENT_NO VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(100),
RECIPIENT_NAME VARCHAR(100),
RECIPIENT_PAS_NUM VARCHAR(20),
RECIPIENT_PAS_DATE DATE,
RECIPIENT_PAS_FROM VARCHAR(30),
RECIPIENT_LETTER VARCHAR(30),
NUM_DOGOVOR VARCHAR(30),
NUM_SPECIF VARCHAR(30),
ADD_PERMANENTLY SMALLINT,
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30))
 RETURNS(ID_DOC_CONTRAGENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_CONTRAGENT$EXC for: CONTRAGENT_MODIFY$CONTR */
ALTER PROCEDURE IMPORT_CONTRAGENT$EXC(CONTRAGENT_NAME VARCHAR(100),
IS_JURIDICAL_PERSON SMALLINT,
IDENT_NO VARCHAR(30),
VAT_REG_NUM VARCHAR(30),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(100),
COUNTRY_CODE VARCHAR(10),
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30),
UUID VARCHAR(40),
CREATE_ONLY SMALLINT)
 RETURNS(ID_CONTRAGENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (CONTRAGENT_MODIFY$CONTR) */
ALTER PROCEDURE CONTRAGENT_MODIFY$CONTR(ID_CONTRAGENT INTEGER,
CONTRAGENT_NAME VARCHAR(100),
IS_JURIDICAL_PERSON SMALLINT,
IDENT_NO VARCHAR(30),
VAT_REG_NUM VARCHAR(30),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(100),
COUNTRY_CODE VARCHAR(10),
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30))
 RETURNS(NEW_ID_CONTRAGENT INTEGER)
 AS
declare variable id_profile integer;
begin

  if (:ID_CONTRAGENT is null) then begin
    insert into CONTRAGENTS (CONTRAGENT_NAME, IS_JURIDICAL_PERSON,
           IDENT_NO, VAT_REG_NUM, POST_ADDRESS, ZIP_CODE,
           MOL, BANK_NAME, BIC, IBAN, COUNTRY, EMAIL)
    values (:CONTRAGENT_NAME, :IS_JURIDICAL_PERSON,
           :IDENT_NO, :VAT_REG_NUM, :POST_ADDRESS, :ZIP_CODE,
           :MOL, :BANK_NAME, :BIC, :IBAN, :COUNTRY_CODE, :EMAIL)
    returning ID_CONTRAGENT into :NEW_ID_CONTRAGENT;
  end else begin
    update CONTRAGENTS C
    set    C.CONTRAGENT_NAME = :CONTRAGENT_NAME,
           C.IS_JURIDICAL_PERSON = :IS_JURIDICAL_PERSON,
           C.IDENT_NO = :IDENT_NO,
           C.VAT_REG_NUM = :VAT_REG_NUM,
           C.POST_ADDRESS = :POST_ADDRESS,
           C.ZIP_CODE = :ZIP_CODE,
           C.MOL = :MOL,
           C.COUNTRY = :COUNTRY_CODE,
           C.BANK_NAME = :BANK_NAME,
           C.BIC = :BIC,
           C.IBAN = :IBAN,
           C.EMAIL = :EMAIL
    where  C.ID_CONTRAGENT = :ID_CONTRAGENT;
    NEW_ID_CONTRAGENT = :ID_CONTRAGENT;

    execute procedure SYSTEM_LOG_ADD ('CONTRAGENT', :NEW_ID_CONTRAGENT, 'CONTRAGENT_CHANGED', :CONTRAGENT_NAME || '/' || coalesce(:IDENT_NO, ''));
  end

  for
    select p.ID_PROFILE
    from   PROFILE p
    where  p.ID_DEF_CONTRAGENT = :ID_CONTRAGENT
           and p.PROFILE_TYPE = 'AGENT'
    into   :id_profile
  do begin
    update PROFILE p
    set    p.MERGE_IDENT_NUM = (select trim(ss.UNICODE_STRING) from SYSTEM_STRING_TO_UNICODE(:IDENT_NO) ss),
           p.MERGE_IDENT_NUM_ALT = (select trim(ss.UNICODE_STRING) from SYSTEM_STRING_TO_UNICODE(:VAT_REG_NUM) ss)
    where  p.ID_PROFILE = :id_profile;
  end
end
^

ALTER PROCEDURE DOCUMENT_INITIALIZE$DOC(ID_ACCOUNT TYPE OF ID,
DOC_SELECTED TYPE OF ID,
PROFORMA_NAME_PREFIX VARCHAR(30) = null)
 RETURNS(ID_DOC_HEAD INTEGER,
ID_HOTEL INTEGER,
WARN_CODE INTEGER,
REQUIRE_ARCHIVE_CONFIRMATION TYPE OF TLOGICAL)
 AS
declare variable id_doc_type integer;
  declare variable id_base_doc integer;
  declare variable doc_date date;
  declare variable doc_curr varchar(3);
  declare variable id_doc_contragent integer;
  declare variable doc_sub_type integer;
  declare variable id_advance_payment integer;
  declare variable is_proforma tlogical;
  declare variable is_archive tlogical;
  declare variable doc_type_name varchar(50);
  declare variable hp_type varchar(50);
  declare variable is_credit_account smallint;
  declare variable closing_whole_account smallint;
  declare variable chk_out_date date;
begin
  chk_out_date = null;
  REQUIRE_ARCHIVE_CONFIRMATION = -1;

  is_proforma = iif(:PROFORMA_NAME_PREFIX is null, 0, 1);

  if (:IS_PROFORMA is distinct from 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_NOPAY_CREATE');
  end else begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('PROFORMA_CREATE');
  end

  select A.ID_HOTEL, p.HOUSE_TYPE, a.IS_CREDIT_ACCOUNT, RD.TO_DATE
  from   ACCOUNT A
         left outer join PROFILE_HOUSE p on p.ID_PROFILE = a.ID_PROFILE
         left outer join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = a.ID_RESERV_DETAIL
  where  A.ID_ACCOUNT = :id_account
  into   :id_hotel, :hp_type, :is_credit_account, :chk_out_date;

  if (coalesce(:hp_type, '') in ('hptExternalRevenue', 'hptComplimentary')) then
    exception DOCUMENT_EXCEPTION '-601';

  id_advance_payment = null;
  execute procedure DOCUMENT_CHECK_SELECTION$INT (:DOC_SELECTED, :ID_ACCOUNT)
  returning_values  (:id_doc_type, :id_base_doc, :doc_curr, :id_doc_contragent,
                     :id_advance_payment, :closing_whole_account);

  if (:is_proforma = 1 and :id_base_doc is not null) then
    exception DOCUMENT_EXCEPTION '-1062';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :doc_date;

  if (:id_doc_type is null) then begin
    execute procedure DOC_TYPE_GET$INT (:id_hotel, :IS_PROFORMA, :id_advance_payment)
    returning_values (:id_doc_type);
  end

  execute procedure CURR_RATES_PREPARE$INT (:DOC_SELECTED, :ID_ACCOUNT, :doc_date);

  select coalesce(:doc_curr, DT.DOC_CURR),
         iif (:is_proforma = 1, substring(trim(:PROFORMA_NAME_PREFIX) || ' ' || dt.doc_type_name from 1 for 50), dt.DOC_TYPE_NAME),
         dt.IS_ARCHIVE
  from   DOC_TYPE DT
  where  DT.ID_DOC_TYPE = :id_doc_type
  into   :doc_curr, :DOC_TYPE_NAME, :is_archive;

  if (:is_archive = 1) then begin
    execute procedure SYSTEM_WARNING_ADD(-312, '')
    returning_values :WARN_CODE;
  end

  execute procedure DOCUMENT_CREATE$INT (:DOC_SELECTED, :ID_ACCOUNT, :id_doc_type, :doc_type_name, :doc_date, :doc_curr, :id_base_doc, :doc_date, :is_proforma, :id_advance_payment)
  returning_values  (:ID_DOC_HEAD, :doc_sub_type);

  if (:ID_ADVANCE_PAYMENT is null and :IS_PROFORMA is distinct from 1 and :doc_sub_type < 2) then begin
    execute procedure DOCUMENT_ATTACH_AVAIL_PAYS$INT (:ID_DOC_HEAD, :ID_ACCOUNT);
  end

  if (:id_doc_contragent is not null) then begin
    execute procedure DOC_CONTRAGENT_INITIALIZE$DOC (:ID_DOC_HEAD, null, :id_doc_contragent);
  end else begin
    execute procedure DOC_CONTRAGENT_INITIALIZE$INT (:ID_DOC_HEAD, :ID_ACCOUNT);
  end

  execute procedure DOC_SUPPLIER_SET$DOC (:ID_DOC_HEAD);

  if (:is_proforma = 0 and :closing_whole_account = 1 and :is_credit_account is distinct from 1) then begin
    if ((:chk_out_date is null) or (:doc_date >= :chk_out_date)) then
      REQUIRE_ARCHIVE_CONFIRMATION = 1;
    else
      REQUIRE_ARCHIVE_CONFIRMATION = 0;
  end

  when exception DOC_ON_EMPTY_SELECTION do begin
    ID_DOC_HEAD = null;
  end
end
^

/* Alter (DEPOSIT_DOCUMENT_INITIALIZE$DOC) */
ALTER PROCEDURE DEPOSIT_DOCUMENT_INITIALIZE$DOC(ID_PAYMENT_HEAD TYPE OF ID,
ID_BILLING_SERVICE TYPE OF ID)
 RETURNS(ID_DOC_HEAD TYPE OF ID,
ID_HOTEL TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable id_dep_doc integer;
  declare variable doc_selected integer;
  declare variable payment_date date;
  declare variable system_date date;
  declare variable require_archive_confirmation smallint;
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_BILLING');

  id_dep_doc = null;

  select p.ID_DOC_HEAD, p.ID_ACCOUNT, p.PAYMENT_DATE, a.ID_HOTEL
  from   PAYMENT_HEAD P
         join DEPOSIT d on d.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
         join ACCOUNT a on a.ID_ACCOUNT = p.ID_ACCOUNT
  where  p.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
         and p.IS_ANUL = 0
  into   :id_dep_doc, :id_account, :payment_date, :id_hotel;

  if (:id_account is null) then
    exception DOCUMENT_EXCEPTION '-355';

  if (:id_dep_doc is not null) then
    exception DOCUMENT_EXCEPTION '-364';

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :system_date;

  if (:payment_date < :system_date) then
    exception DOCUMENT_EXCEPTION '-399';

  doc_selected = gen_id(DOC_SELECTED_GEN, 1);

  update DEPOSIT P
  set    p.DOC_SELECTED = :doc_selected,
         p.ID_BILLING_SERVICE = :ID_BILLING_SERVICE
  where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;

  execute procedure DOCUMENT_INITIALIZE$DOC (:ID_ACCOUNT, :doc_selected)
  returning_values  (:ID_DOC_HEAD, :ID_HOTEL, :WARN_CODE, :REQUIRE_ARCHIVE_CONFIRMATION);
end
^

ALTER PROCEDURE DOCUMENT_VALIDATE$DOC(ID_DOC_HEAD TYPE OF ID_REF,
ARCHIVE_ACCOUNT TYPE OF TLOGICAL = 0)
 RETURNS(FIRM_DATA TYPE OF TNOTE_BLOB,
WARN_CODE TYPE OF TRANGE,
NEW_DOC_DATE TYPE OF TDATE)
 AS
declare variable no_use varchar(255);
  declare variable doc_value numeric(15,4);
  declare variable rest_value numeric(15,4);
  declare variable lines_value numeric(15,4);
  declare variable lines_wot_vat numeric(15,4);
  declare variable tax_value numeric(15,4);
  declare variable taxable_value numeric(15,4);
  declare variable round_to numeric(15,4);
  declare variable id_doc_contragent integer;
  declare variable id_doc_supplier integer;
  declare variable for_deposit integer;
  declare variable id_profile integer;
  declare variable dbkey char(8);
  declare variable id_contragent integer;
  declare variable ident_no varchar(30) ;
  declare variable action_text varchar(255);
  declare variable doc_currency varchar(3);
  declare variable is_juridical_person smallint;
  declare variable vat_ident_no varchar(30);
  declare variable id_doc_type integer;
  declare variable doc_sub_type integer;
  declare variable required_ident_no smallint;
  declare variable required_vat_no smallint;
  declare variable required_egn smallint;
  declare variable required_recipient_name smallint;
  declare variable lines_count integer;
  declare variable recipient_name varchar(100);
  declare variable id_doc_completed integer;
  declare variable action_code varchar(50);
  declare variable id_sale_num integer;
  declare variable id_acc_sale_num integer;
  declare variable id_account integer;
  declare variable fiscal_device_id varchar(10);
  declare variable created_at timestamp;
begin

  select D.RDB$DB_KEY, D.DOC_VALUE_A, C.ROUND_TO,
         D.ID_DOC_CONTRAGENT, D.ID_DOC_SUPPLIER, D.FOR_DEPOSIT,
         A.ID_PROFILE, D.DOC_CURRENCY, D.TAXABLE_VALUE, d.ID_DOC_TYPE, d.DOC_SUB_TYPE,
         dc.ID_DOC_HEAD, coalesce(ds.FIRM_DATA, ds.COMPANY_IDENT_NUM), dc.ID_SALE_NUM, a.ID_SALE_NUM, d.DATETIME_CREATED, a.ID_ACCOUNT
  from   DOC_HEAD$INT D
         join CURRS C on C.CURR = D.DOC_CURRENCY
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         left outer join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
         left outer join DOC_SUPPLIER ds on ds.ID_DOC_SUPPLIER = d.ID_DOC_SUPPLIER
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dbkey, :doc_value, :round_to,
         :id_doc_contragent, :id_doc_supplier, :for_deposit,
         :id_profile, :doc_currency, :taxable_value, :id_doc_type, :doc_sub_type,
         :id_doc_completed, :FIRM_DATA, :id_sale_num, :id_acc_sale_num, :created_at, :id_account;

  if (:id_doc_contragent is null) then
    exception DOCUMENT_EXCEPTION '-356'; --'Contragent is not set!';

  if (:id_doc_supplier is null) then
    exception DOCUMENT_EXCEPTION '-357'; --'Supplier is not set!';

  select sum(DT.TAX_VALUE)
  from   DOC_TAXES DT
  where  DT.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :tax_value;

  /*if (round_f(:doc_value - :total_value, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Total value is not correct!';
  */
  select round_f(sum(DL.SINGLE_VALUE * DL.QTY_POST), :round_to),
         round_f(sum(DL.WOT_VAT), :round_to),
         count(*)
  from   DOC_LINE DL
  where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :lines_value, :lines_wot_vat, :lines_count;
 
  if (:lines_count = 0) then
    exception INTERNAL_DOC_EXCEPTION 'Document is empty! Not exists sale lines!';

  if (round_f(:doc_value - :lines_value, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines total value is not correct!' || :doc_value ||  ' / ' || :lines_value || ' ; '|| (:doc_value - :tax_value) ||  ' / ' || :lines_wot_vat;

  if (round_f(:doc_value - :tax_value - :lines_wot_vat, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines wot tax value is not correct!';

  if (round_f(abs(:lines_wot_vat) - abs(:taxable_value), :round_to) < 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines wot tax value is less than total taxable value!';

  if (:id_doc_completed is not null) then begin
    select DV.PAYABLE_VALUE
    from   DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, null) DV
    into   :rest_value;
  
    if (round_f(:rest_value, :round_to) <> 0) then
      exception DOCUMENT_EXCEPTION '-371'; --'Insufficient amount of payments !';

    execute procedure FISCAL_DEVICE_STATUS_CHECK
    returning_values (:fiscal_device_id);
  end

  /* Validate contragent data */
  select dt.REQUIRED_IDENT_NO, dt.REQUIRED_VAT_NO, dt.REQUIRED_EGN, dt.REQUIRED_RECIPIENT_NAME
  from   DOC_TYPE_INV DT
  where  dt.ID_DOC_TYPE = :id_doc_type
  into   :required_ident_no, :required_vat_no, :required_egn, :required_recipient_name;

  select dc.ID_CONTRAGENT, dc.IS_JURIDICAL_PERSON,
         trim(coalesce(dc.IDENT_NO, '')), trim(coalesce(dc.VAT_REG_NUM, '')),
         trim(coalesce(dc.RECIPIENT_NAME, ''))
  from   DOC_CONTRAGENT dc
  where  dc.ID_DOC_CONTRAGENT = :id_doc_contragent
  into   :id_contragent, :is_juridical_person, :ident_no, :vat_ident_no, :recipient_name;

  if (:doc_sub_type = 0 and :required_ident_no = 1 and :is_juridical_person = 1 and :ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-324'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_egn = 1 and :is_juridical_person = 0 and :ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-324'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_vat_no = 1 and :is_juridical_person = 1 and :vat_ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-326'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_recipient_name = 1 and :recipient_name = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-327'; --'Recipient_name is empty.';
  /*if (:post_address = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-325'; --'Contragent address is empty.';
  /* save contragent link for profile */
  if (:id_contragent is not null) then begin
    update PROFILE P
    set    P.ID_DEF_CONTRAGENT = :id_contragent
    where  P.ID_PROFILE = :id_profile
           and P.ID_DEF_CONTRAGENT is null;
  end

  /*  */
  execute procedure DOC_INIT_FISCAL_STATUS$INT(:ID_DOC_HEAD);
  /*  */
  execute procedure DOCUMENT_SET_NUMBER$INT (:dbkey)
  returning_values (:no_use, :no_use);
  /*  */
  if (:id_doc_completed is not null) then begin
    if (:for_deposit = 0) then begin
      /* update account posts */
      execute procedure ACCOUNT_POSTING_DOC_UPDATE$INT (:dbkey)
      returning_values :WARN_CODE;
    end

    execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT (:dbkey);
    /* ... */
    execute procedure DOCUMENT_BONUSPOINTS_APPLY$CL (:ID_DOC_HEAD);
    /* ... */
  end

  if (:id_doc_completed is not null and :id_sale_num is null) then begin
    if (not exists (select ap.ID_ACCOUNT_POST
                    from   ACCOUNT_POST Ap
                    where  ap.ID_ACCOUNT = :id_account
                           and ap.ac in ('00', '10'))) then
    begin
      update DOC_COMPLETION c
      set    c.ID_SALE_NUM = :id_acc_sale_num
      where  c.ID_DOC_HEAD = :ID_DOC_HEAD;

      update ACCOUNT a
      set    a.ID_SALE_NUM = null
      where  a.ID_ACCOUNT = :id_account;
      id_acc_sale_num = null;
    end else begin
      execute procedure DOCUMENT_SALE_NUMBER_SET(:ID_DOC_HEAD, :created_at)
      returning_values (:id_sale_num);
    end
  end

  execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, coalesce(:ARCHIVE_ACCOUNT, 0));

  if (:ARCHIVE_ACCOUNT is distinct from 1 and :id_acc_sale_num is null) then begin
    execute procedure ACCOUNT_SALE_NUMBER_SET(:id_account)
    returning_values (:id_acc_sale_num);
  end
  /*  */
  action_text = f_character(29) || formatfloat(:doc_value, 'F;0.00') || ' ' || :doc_currency;
  action_code = iif(:id_doc_completed is null,  'PROFORMA_CREATE', 'CREATE');
  execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :ID_DOC_HEAD, :action_code, :action_text);

  select cast('31.12.1899' as date) + count(d.ID_DOC_HEAD)
  from   DOC_HEAD$INT d
  where  d.DOC_DATE is not null
  into   :NEW_DOC_DATE;

end
^

/* Alter (DEPOSIT_REFUND$DOC) */
ALTER PROCEDURE DEPOSIT_REFUND$DOC(ID_DEPOSIT INTEGER,
REFUND_AMOUNT NUMERIC(15,4),
REFUND_CURRENCY VARCHAR(3),
ID_PAY_DOC_TYPE INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_REFUND_PAYMENT INTEGER,
ID_STORNO_DOC INTEGER,
WARN_CODE INTEGER)
 AS
declare variable no_use varchar(2000);
  declare variable id_account integer;
  declare variable avail_value numeric(15,4);
  declare variable id_doc_head integer;
  declare variable pay_currency varchar(3);
  declare variable pay_rate numeric(15,6);
  declare variable sys_date date;
  declare variable round_to numeric(15,4);
  declare variable p_dbkey char(8);
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable id_account_payment integer;
  declare variable id_doc_type integer;
  declare variable account_curr varchar(3);
  declare variable account_rate numeric(15,6);
  declare variable id_reserv_detail integer;
  declare variable is_posting_stopped integer;
begin
  WARN_CODE = null;
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_REFUND');

  select D.ID_ACCOUNT, DH.ID_DOC, dh.ID_DOC_TYPE, c.ROUND_TO, d.ID_RESERV_DETAIL,
         D.AVAIL_VALUE, D.PAY_CURRENCY, D.PAY_RATE, A.ID_HOTEL, A.ACCOUNT_CURR
  from   DEPOSIT_AVAILABLE D
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join CURRS C on c.CURR = d.PAY_CURRENCY
         left outer join DOC_HEAD DH on DH.ID_DOC = D.ID_DOC_HEAD
                                        and DH.IS_STORNED = 0
                                        and DH.IS_ANUL = 0
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_account, :id_doc_head, :id_doc_type, :round_to, :id_reserv_detail,
         :avail_value, :pay_currency, :pay_rate, :id_hotel, :account_curr;

  if (:pay_currency is distinct from :refund_currency) then exception PAYMENT_EXCEPTION 'Currency mismatch!';

  if (round_f(:avail_value - :REFUND_AMOUNT, :round_to) < 0) then exception PAYMENT_EXCEPTION '-305';
  --'Issued value is more than available deposit amount.';

  select r.IS_POSTING_STOPPED
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :is_posting_stopped;

  if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';

  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET(:id_hotel) SD
  into   :sys_date;

  select first 1 ap.ACC_RATE
  from   ACCOUNT_PAYMENTS ap
  where  ap.ID_DEPOSIT = :ID_DEPOSIT
  order by ap.ID_ACCOUNT_PAYMENT asc
  into   :account_rate;

  execute procedure PAYMENT_CREATE$INT (:ID_PAY_DOC_TYPE, :ID_ACCOUNT, :SYS_DATE,
          -:REFUND_AMOUNT, :PAY_CURRENCY, :PAY_RATE, :account_curr, :account_rate, :DESCRIPTION)
  returning_values  (:id_refund_payment, :id_account_payment, :no_use);

  insert into DEPOSIT_REFUND (ID_DEPOSIT, ID_PAYMENT_HEAD, DESCRIPTION)
  values (:ID_DEPOSIT, :ID_REFUND_PAYMENT, :DESCRIPTION);

  update ACCOUNT_PAYMENTS AP
  set    AP.ID_DEPOSIT = :ID_DEPOSIT
  where  ap.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

  if (:ID_DOC_HEAD is not null) then begin
    execute procedure DOC_TYPE_EVALUATE$INT (:id_doc_type, :id_hotel, 0, :ID_REFUND_PAYMENT);

    execute procedure DOCUMENT_ADVANCE_STORNO$INT (:ID_DEPOSIT, :REFUND_AMOUNT, :DESCRIPTION)
    returning_values  (:ID_STORNO_DOC, :WARN_CODE);

    execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:ID_STORNO_DOC, :id_account_payment, :pay_rate, null)
    returning_values :no_use;
     
    update  PAYMENT_HEAD P
    set     P.ID_DOC_HEAD = :ID_STORNO_DOC
    where   P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

    execute procedure DOCUMENT_VALIDATE$DOC (:ID_STORNO_DOC)
    returning_values (:no_use, :no_use, :no_use);
  end else begin
    select P.RDB$DB_KEY
    from   PAYMENT_HEAD P
    where  P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT
    into   :P_DBKEY;
     
    execute procedure PAYMENT_SET_NUMBER$INT (:P_DBKEY);
  end

  action_text = F_CHARACTER(29) || :REFUND_AMOUNT || ' ' || :PAY_CURRENCY;
  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'REFUND', :ACTION_TEXT);
end
^

/* Alter (DEPOSIT_TRANSFER_ACCOUNTS$ACC) */
ALTER PROCEDURE DEPOSIT_TRANSFER_ACCOUNTS$ACC(ID_DEPOSIT INTEGER)
 RETURNS(ID_ACCOUNT INTEGER)
 AS
declare variable id_current_account integer;
declare variable id_dep_profile integer;
declare variable id_reserv_detail integer;
begin

  select D.ID_ACCOUNT, D.ID_PROFILE, D.ID_RESERV_DETAIL
  from   DEPOSIT D
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :ID_CURRENT_ACCOUNT, :ID_DEP_PROFILE, :ID_RESERV_DETAIL;

  for
    select distinct DPA.ID_ACCOUNT
    from   ACCOUNT_S DPA
    where  DPA.ID_PROFILE = :ID_DEP_PROFILE
           and DPA.ID_ACCOUNT is distinct from :ID_CURRENT_ACCOUNT
           and DPA.IS_ARCHIVE = 0
    union
    select distinct APA.ID_ACCOUNT
    from   ACCOUNT_S APA
    where  APA.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
           and APA.ID_ACCOUNT is distinct from :ID_CURRENT_ACCOUNT
           and APA.IS_ARCHIVE = 0
    into   :ID_ACCOUNT
  do
    suspend;
end
^

/* Alter (DOC_CONTRAGENT_INITIALIZE$INT) */
ALTER PROCEDURE DOC_CONTRAGENT_INITIALIZE$INT(ID_DOC INTEGER,
ID_ACCOUNT INTEGER)
 AS
declare variable is_juridical_person integer;
  declare variable contragent_name varchar(100);
  declare variable vat_reg_num varchar(30);
  declare variable ident_no varchar(30);
  declare variable post_address varchar(100);
  declare variable zip_code varchar(10);
  declare variable country_code varchar(20);
  declare variable mol varchar(100);
  declare variable id_contragent integer;
  declare variable recipient_name varchar(100);
  declare variable recipient_pas_num varchar(20);
  declare variable recipient_pas_date date;
  declare variable recipient_pas_from varchar(30);
  declare variable bank_name varchar(50);
  declare variable bic varchar(30);
  declare variable iban varchar(30);
  declare variable id_doc_contragent integer;
  declare variable email varchar(50);
begin
  execute procedure ACCOUNT_GET_CONTRAGENT_DATA$INT (:ID_ACCOUNT)
  returning_values (:id_contragent, :is_juridical_person, :contragent_name,
                    :vat_reg_num, :ident_no, :country_code, :post_address, :zip_code, :email,
                    :mol, :recipient_name, :recipient_pas_num, :recipient_pas_date, :recipient_pas_from,
                    :bank_name, :bic, :iban);
  if (:id_contragent is null and trim(coalesce(:contragent_name, '')) = '') then exit; /* not valid contragent */

  execute procedure DOC_CONTRAGENT_SET$DOC (:ID_DOC, 0, :id_contragent,
          coalesce(:is_juridical_person, 0), :contragent_name, :vat_reg_num, :ident_no,
          :country_code, :post_address, :zip_code, :email, :mol, :recipient_name,
          :recipient_pas_num, :recipient_pas_date, :recipient_pas_from, null, null, null,
          0, :bank_name, :bic, :iban)
  returning_values :id_doc_contragent;

end
^

/* Alter (DOC_CONTRAGENT_SET$DOC) */
ALTER PROCEDURE DOC_CONTRAGENT_SET$DOC(ID_DOC INTEGER,
IS_PAY_DOC SMALLINT,
ID_CONTRAGENT INTEGER,
IS_JURIDICAL_PERSON SMALLINT,
CONTRAGENT_NAME VARCHAR(100),
VAT_REG_NUM VARCHAR(30),
IDENT_NO VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(100),
RECIPIENT_NAME VARCHAR(100),
RECIPIENT_PAS_NUM VARCHAR(20),
RECIPIENT_PAS_DATE DATE,
RECIPIENT_PAS_FROM VARCHAR(30),
RECIPIENT_LETTER VARCHAR(30),
NUM_DOGOVOR VARCHAR(30),
NUM_SPECIF VARCHAR(30),
ADD_PERMANENTLY SMALLINT,
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30))
 RETURNS(ID_DOC_CONTRAGENT INTEGER)
 AS
declare variable doc_num varchar(20);
begin

  if (:IS_PAY_DOC = 1) then begin
    select P.ID_DOC_CONTRAGENT, P.PAYMENT_NUM
    from   PAYMENT_HEAD P
    where  p.ID_PAYMENT_HEAD = :ID_DOC
    into   :id_doc_contragent, :doc_num;
  end else begin
    select D.ID_DOC_CONTRAGENT, D.DOC_NUM
    from   DOC_HEAD$INT D
    where  D.ID_DOC_HEAD = :ID_DOC
    into   :id_doc_contragent, :doc_num;
  end

  if (trim(:doc_num) <> '') then
    exception DOCUMENT_EXCEPTION '-354'; --'Cannot edit valid document!';
   
  if (:IS_JURIDICAL_PERSON = 1 and ((:ID_CONTRAGENT is null) or (:ADD_PERMANENTLY = 1)) ) then begin
    execute procedure CONTRAGENT_MODIFY$CONTR (:ID_CONTRAGENT, :CONTRAGENT_NAME,
            :IS_JURIDICAL_PERSON, :IDENT_NO, :VAT_REG_NUM, :POST_ADDRESS, :ZIP_CODE, :EMAIL,
            :MOL, :COUNTRY_CODE, :BANK_NAME, :BIC, :IBAN)
    returning_values (:ID_CONTRAGENT);
  end

  if (:id_doc_contragent is null) then begin
    id_doc_contragent = gen_id(GEN_DOC_CONTRAGENT_ID, 1);
    insert into DOC_CONTRAGENT (
         ID_DOC_CONTRAGENT, ID_CONTRAGENT, IS_JURIDICAL_PERSON, CONTRAGENT_NAME,
         VAT_REG_NUM, IDENT_NO, POST_ADDRESS, ZIP_CODE, COUNTRY_CODE,
         MOL, RECIPIENT_NAME, RECIPIENT_PAS_NUM, RECIPIENT_PAS_DATE, RECIPIENT_PAS_FROM,
         RECIPIENT_LETTER, NUM_DOGOVOR, NUM_SPECIF, BANK_NAME, BIC, IBAN, EMAIL)
    values (:ID_DOC_CONTRAGENT, :ID_CONTRAGENT, :IS_JURIDICAL_PERSON, :CONTRAGENT_NAME,
         :VAT_REG_NUM, :IDENT_NO, :POST_ADDRESS, :ZIP_CODE, :COUNTRY_CODE,
         :MOL, :RECIPIENT_NAME, :RECIPIENT_PAS_NUM, :RECIPIENT_PAS_DATE, :RECIPIENT_PAS_FROM,
         :RECIPIENT_LETTER, :NUM_DOGOVOR, :NUM_SPECIF, :BANK_NAME, :BIC, :IBAN, :EMAIL);

    if (:IS_PAY_DOC = 1) then begin
      update PAYMENT_HEAD P
      set    P.ID_DOC_CONTRAGENT = :id_doc_contragent
      where  P.ID_PAYMENT_HEAD = :ID_DOC;
    end else begin
      update DOC_HEAD$INT D
      set    D.ID_DOC_CONTRAGENT = :id_doc_contragent
      where  D.ID_DOC_HEAD = :ID_DOC;
    end

  end else begin
    update DOC_CONTRAGENT DC
    set    DC.ID_CONTRAGENT = :ID_CONTRAGENT,
           DC.IS_JURIDICAL_PERSON = :IS_JURIDICAL_PERSON,
           DC.CONTRAGENT_NAME = :CONTRAGENT_NAME,
           DC.VAT_REG_NUM = :VAT_REG_NUM,
           DC.IDENT_NO = :IDENT_NO,
           DC.POST_ADDRESS = :POST_ADDRESS,
           DC.ZIP_CODE = :ZIP_CODE,
           DC.COUNTRY_CODE = :COUNTRY_CODE,
           dc.EMAIL = :EMAIL,
           DC.MOL = :MOL,
           DC.RECIPIENT_NAME = :RECIPIENT_NAME,
           DC.RECIPIENT_PAS_NUM = :RECIPIENT_PAS_NUM,
           DC.RECIPIENT_PAS_DATE = :RECIPIENT_PAS_DATE,
           DC.RECIPIENT_PAS_FROM = :RECIPIENT_PAS_FROM,
           DC.RECIPIENT_LETTER = :RECIPIENT_LETTER,
           DC.NUM_DOGOVOR = :NUM_DOGOVOR,
           DC.NUM_SPECIF = :NUM_SPECIF,
           DC.BANK_NAME = :BANK_NAME,
           DC.BIC = :BIC,
           DC.IBAN = :IBAN
    where  DC.ID_DOC_CONTRAGENT = :ID_DOC_CONTRAGENT;
  end
end
^

/* Alter (DOC_LINES_SUSPEND_INVOICE) */
ALTER PROCEDURE DOC_LINES_SUSPEND_INVOICE(ID_DOC_HEAD INTEGER,
CORRECTION_INDEX INTEGER,
RPT_TYPE VARCHAR(20),
RPT_CURR VARCHAR(10),
RPT_VAT VARCHAR(20),
IN_VAUCHER_NUM VARCHAR(20))
 RETURNS(TAX_STATUS INTEGER,
ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
VAUCHER_NUM VARCHAR(20),
GUEST_NAME VARCHAR(100),
IS_CHILD INTEGER,
AGES_NAME VARCHAR(50),
GFROM_DATE DATE,
GTO_DATE DATE,
PACKET_NAME VARCHAR(50),
LINE_NAME VARCHAR(100),
ID_SERVICE INTEGER,
DATE_POST DATE,
QTY_POST NUMERIC(15,2),
SINGLE_PRICE NUMERIC(15,4),
LINE_VALUE NUMERIC(15,4),
PACKET_PRICE NUMERIC(15,4),
PACKET_PRICE_WOT_DIFF DOUBLE PRECISION,
ID_TARIFA INTEGER,
BIRTH_DATE DATE,
NIGHTS INTEGER,
IS_BASE INTEGER)
 AS
declare variable doc_vat_status integer;
  declare variable dl_dbkey char(8);
  declare variable no_use varchar(255);
begin
  /*  Description:
  ||  RPT_TYPE - PACKETS, OTHER, TAX_STATUS, TAXES
  */
  select DT.IS_VAT
  from   DOC_HEAD$INT DH
         join DOC_TYPE DT on DT.ID_DOC_TYPE = DH.ID_DOC_TYPE
  where  DH.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :DOC_VAT_STATUS;

  if (:RPT_TYPE = 'PACKETS') then begin
    for
      select DL.RDB$DB_KEY, DL.TAX_STATUS, DL.ID_GUEST, DL.DATE_POST, G.ID_TARIFA, PV.IS_BASE,
             GC.GUEST_NAME1, G.IS_CHILD, AG.AGES_NAME, G.FROM_DATE, G.TO_DATE, G.ID_RESERV_DETAIL,
             case when coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'SECONDARY' then G.VAUCHER_NUM2 else G.VAUCHER_NUM end,
             GC.BIRTH_DAY, S.ID_SERVICE
      from   DOC_LINE DL
             join SERVICES S on S.ID_SERVICE = DL.ID_SERVICE
             left outer join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
             left outer join GUEST G on G.ID_GUEST = DL.ID_GUEST
             left outer join AGENT_PACKET APA on APA.ID_AGENT = G.ID_AGENT and APA.ID_SERVICE = DL.ID_SERVICE
             left outer join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
             left outer join AGENT_AGES AG on AG.ID_AGENT_AGES = G.ID_AGENT_AGES
             left outer join AGENT_TYPE_STAY ATS on ATS.ID_AGENT = G.ID_AGENT and ATS.ID_SERVICE = case when coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'BASE' then PV.ID_PACK_SERVICE else DL.ID_SERVICE end
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
             and ((PV.IS_BASE = 1) or (coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) in ('SECONDARY', 'PARALLEL')))
             and ((:IN_VAUCHER_NUM = '') or (case when coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'SECONDARY' then G.VAUCHER_NUM2 else G.VAUCHER_NUM end = :IN_VAUCHER_NUM))
      into   :DL_DBKEY, :TAX_STATUS, :ID_GUEST, :DATE_POST, :ID_TARIFA, :IS_BASE,
             :GUEST_NAME, :IS_CHILD, :AGES_NAME, :GFROM_DATE, :GTO_DATE, :ID_RESERV_DETAIL,
             :VAUCHER_NUM, :BIRTH_DATE, :ID_SERVICE
    do begin
      if (:IS_BASE = 0) then begin
        execute procedure DOC_LINES_SUSPEND_LINE(:DL_DBKEY, :RPT_CURR, :RPT_VAT, 'NONE', :DOC_VAT_STATUS, :CORRECTION_INDEX)
        returning_values :NO_USE, :PACKET_NAME, :PACKET_PRICE, :PACKET_PRICE_WOT_DIFF, :SINGLE_PRICE, :LINE_VALUE,
                         :NO_USE, :NO_USE, :QTY_POST, :QTY_POST, :NO_USE, :NO_USE, :NO_USE;

        PACKET_PRICE = :LINE_VALUE;
        NIGHTS = 0;
      end else begin
        execute procedure DOC_LINES_SUSPEND_LINE(:DL_DBKEY, :RPT_CURR, :RPT_VAT, 'IN_PACKET', :DOC_VAT_STATUS, :CORRECTION_INDEX)
        returning_values :ID_SERVICE, :PACKET_NAME, :PACKET_PRICE, :PACKET_PRICE_WOT_DIFF, :NO_USE, :NO_USE,
                         :NO_USE, :NO_USE, :QTY_POST, :QTY_POST, :NO_USE, :NO_USE, :NO_USE;                                      

        NIGHTS = 1;
      end
      suspend;
    end
  end if (:RPT_TYPE = 'OTHER') then begin
    for
      select DL.RDB$DB_KEY, DL.LINE_NAME, G.ID_GUEST, G.ID_RESERV_DETAIL, DL.ID_SERVICE
      from   DOC_LINE DL
             join SERVICES S on S.ID_SERVICE = DL.ID_SERVICE
             left outer join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
             left outer join GUEST G on G.ID_GUEST = DL.ID_GUEST
             left outer join AGENT_PACKET APA on APA.ID_AGENT = G.ID_AGENT and APA.ID_SERVICE = DL.ID_SERVICE
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
             and DL.TAX_STATUS in (0, 1)
             and coalesce(PV.IS_BASE, 0) = 0
             and (/*(coalesce(PV.ID_MASTER_ADDINS, -1) = -1)
                  or*/ (coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'OTHER')
                  or ((coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) not in ('SECONDARY', 'PARALLEL'))
                       and not exists (select DML.ID_DOC_LINE
                                  from   DOC_LINE DML
                                         join DOC_LINE_POST_VALUES DPV on DPV.ID_DOC_LINE = DML.ID_DOC_LINE
                                  where  DML.ID_DOC_HEAD = DL.ID_DOC_HEAD
                                         and DPV.ID_ACCOUNT_POST = PV.ID_MASTER_ADDINS)) )
      into   :DL_DBKEY, :LINE_NAME, :ID_GUEST, :ID_RESERV_DETAIL, :ID_SERVICE
    do begin
      execute procedure DOC_LINES_SUSPEND_LINE(:DL_DBKEY, :RPT_CURR, :RPT_VAT, 'NONE',
        :DOC_VAT_STATUS, :CORRECTION_INDEX)
      returning_values (:NO_USE, :NO_USE, :PACKET_PRICE,
        :PACKET_PRICE_WOT_DIFF, :SINGLE_PRICE, :LINE_VALUE, :NO_USE, :NO_USE,
        :QTY_POST, :QTY_POST, :NO_USE, :NO_USE, :NO_USE);
      suspend;
    end
  end if (:RPT_TYPE = 'TAXES') then begin
    for
      select DL.RDB$DB_KEY, DL.LINE_NAME, DL.ID_SERVICE
      from   DOC_LINE DL
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
             and DL.TAX_STATUS > 1
      into   :DL_DBKEY, :LINE_NAME, :ID_SERVICE
    do begin
      execute procedure DOC_LINES_SUSPEND_LINE(:DL_DBKEY, :RPT_CURR, :RPT_VAT, 'NONE',
        :DOC_VAT_STATUS, :CORRECTION_INDEX)
      returning_values (:NO_USE, :NO_USE, :PACKET_PRICE,
        :PACKET_PRICE_WOT_DIFF, :SINGLE_PRICE, :LINE_VALUE, :NO_USE, :NO_USE,
        :QTY_POST, :QTY_POST, :NO_USE, :NO_USE, :NO_USE);
      suspend;
    end
  end
end
^

/* Alter (DOC_SUPPLIER_GET_COPY$DOC) */
ALTER PROCEDURE DOC_SUPPLIER_GET_COPY$DOC(ID_DOC_SUPPLIER INTEGER)
 RETURNS(NEW_ID_DOC_SUPPLIER INTEGER)
 AS
declare variable send_name varchar(100);
begin

  select RU.USER_NAME_LONG
  from   RIGHTS_USERS RU
  where  RU.USER_NAME = current_user
  into   :send_name;

  new_id_doc_supplier = gen_id(GEN_DOC_SUPPLIER_ID, 1);

  insert into DOC_SUPPLIER (ID_DOC_SUPPLIER, COMPANY_NAME, COMPANY_ADDRESS, COMPANY_IDENT_NUM,
         COMPANY_VAT_REG_NUM, COMPANY_MOL, SEND_NAME, FIRM_DATA)
  select :NEW_ID_DOC_SUPPLIER, DS.COMPANY_NAME, ds.COMPANY_ADDRESS, ds.COMPANY_IDENT_NUM,
         ds.COMPANY_VAT_REG_NUM, ds.COMPANY_MOL, :send_name, ds.FIRM_DATA
  from   DOC_SUPPLIER DS
  where  DS.ID_DOC_SUPPLIER = :ID_DOC_SUPPLIER;

end
^

/* Alter (DOC_SUPPLIER_SET$DOC) */
ALTER PROCEDURE DOC_SUPPLIER_SET$DOC(ID_DOC_HEAD TYPE OF ID)
 AS
declare variable id_doc_supplier integer;
declare variable doc_num varchar(20);
declare variable send_name varchar(100);
declare variable id_hotel integer;
begin
  select D.ID_DOC_SUPPLIER, D.DOC_NUM, a.ID_HOTEL
  from   DOC_HEAD$INT D
         join ACCOUNT a on a.ID_ACCOUNT = d.ID_ACCOUNT
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :id_doc_supplier, :doc_num, :id_hotel;

  if (trim(:doc_num) <> '') then
    exception DOCUMENT_EXCEPTION '-354'; --'Cannot edit valid document!';

  if (:id_doc_supplier is not null) then begin
    delete from DOC_SUPPLIER s
    where  s.ID_DOC_SUPPLIER = :id_doc_supplier;
  end

  select RU.USER_NAME_LONG
  from   RIGHTS_USERS RU
  where  RU.USER_NAME = current_user
  into   :send_name;

  id_doc_supplier = gen_id(GEN_DOC_SUPPLIER_ID, 1);
  insert into DOC_SUPPLIER (ID_DOC_SUPPLIER, COMPANY_NAME, COMPANY_ADDRESS, COMPANY_IDENT_NUM,
         COMPANY_VAT_REG_NUM, COMPANY_MOL, SEND_NAME)
  select :id_doc_supplier, DS.COMPANY_NAME, ds.COMPANY_ADDRESS, ds.COMPANY_IDENT_NUM,
         ds.COMPANY_VAT_REG_NUM, ds.COMPANY_MOL, :send_name
  from   HOTEL ds
  where  ds.ID_HOTEL = :id_hotel;

  update DOC_HEAD$INT D
  set    D.ID_DOC_SUPPLIER = :id_doc_supplier
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD;
end
^

/* empty dependent procedure body */
/* Clear: DOC_TYPE_INV_MODIFY$DOC for: DOC_TYPE_MODIFY$INT */
ALTER PROCEDURE DOC_TYPE_INV_MODIFY$DOC(ID_DOC_TYPE INTEGER,
DOC_TYPE_NAME VARCHAR(50),
DEBIT_DOC_NAME VARCHAR(50),
CREDIT_DOC_NAME VARCHAR(50),
ANNUL_PROTOCOL_NAME VARCHAR(50),
EXPORT_TAG VARCHAR(20),
DEBIT_EXPORT_TAG VARCHAR(20),
CREDIT_EXPORT_TAG VARCHAR(20),
ANNUL_EXPORT_TAG VARCHAR(20),
DOC_CURR CHAR(3),
PRINT_ORIGINAL SMALLINT,
RAPORT_NAME VARCHAR(50),
DESCRIPTION VARCHAR(100),
IS_VAT SMALLINT,
PRINT_ANNUL_REPORT_CLASS VARCHAR(50),
IS_ARCHIVE SMALLINT,
REQUIRED_IDENT_NO SMALLINT,
REQUIRED_VAT_NO SMALLINT,
REQUIRED_EGN SMALLINT,
REQUIRED_RECIPIENT_NAME /* TYPE OF TLOGICAL */ SMALLINT,
OPERATION VARCHAR(10),
ID_HOTEL /* TYPE OF ID */ INTEGER,
ID_DOC_NUM /* TYPE OF ID_REF */ INTEGER,
ID_ANNUL_DOC_NUM /* TYPE OF ID_REF */ INTEGER,
SECOND_CURRENCY CHAR(3) = null,
CURRENCY_LIST VARCHAR(1000) = null,
PAY_DOC_TYPE_RESTRICT_LIST VARCHAR(1000) = null,
ID_PROFORMA_NUM /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_DOC_TYPE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DOC_TYPE_PAY_MODIFY$DOC for: DOC_TYPE_MODIFY$INT */
ALTER PROCEDURE DOC_TYPE_PAY_MODIFY$DOC(ID_DOC_TYPE INTEGER,
DOC_DIRECTION INTEGER,
DOC_TYPE_NAME VARCHAR(50),
EXPORT_TAG VARCHAR(20),
STORNO_DOC_NAME VARCHAR(50),
STORNO_EXPORT_TAG VARCHAR(20),
DOC_CURR CHAR(3),
RAPORT_NAME VARCHAR(50),
DESCRIPTION VARCHAR(100),
IS_FISC SMALLINT,
ID_PAYMENT_TYPE INTEGER,
IS_ARCHIVE SMALLINT,
RIGHT_CODE VARCHAR(30),
OPERATION VARCHAR(10),
ID_HOTEL /* TYPE OF ID */ INTEGER,
ID_DOC_NUM /* TYPE OF ID_REF */ INTEGER,
CURRENCY_LIST VARCHAR(1000) = null)
 RETURNS(NEW_ID_DOC_TYPE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOC_TYPE_MODIFY$INT) */
ALTER PROCEDURE DOC_TYPE_MODIFY$INT(ID_DOC_TYPE TYPE OF ID,
DOC_TYPE_NAME TYPE OF TOBJECT_NAME,
DEF_CURR TYPE OF TCURRENCY,
RAPORT_NAME TYPE OF TOBJECT_NAME,
DESCRIPTION TYPE OF TDESCRIPTION_SHORT,
EXPORT_TAG TYPE OF TSEARCH_CODE,
IS_VAT TYPE OF TENUM_SMALL,
DOC_SUB_TYPE TYPE OF TENUM_SMALL,
PRINT_ORIGINAL TYPE OF TLOGICAL,
IS_ARCHIVE TYPE OF TLOGICAL,
ID_HOTEL TYPE OF ID,
ID_DOC_NUM TYPE OF ID_REF,
ID_ANNUL_DOC_NUM TYPE OF ID_REF,
CURRENCY_LIST VARCHAR(1000),
OPERATION VARCHAR(10))
 RETURNS(NEW_ID_DOC_TYPE TYPE OF ID_REF)
 AS
begin

  if (coalesce(:CURRENCY_LIST, '') not containing :DEF_CURR) then
    CURRENCY_LIST = coalesce(nullif(:CURRENCY_LIST, '') || ',', '') || :DEF_CURR;

  if (:OPERATION = 'add') then begin
    NEW_ID_DOC_TYPE = gen_id(G_AUTO_INC_DOC_TYPE, 1);
    insert into DOC_TYPE (ID_DOC_TYPE, DOC_TYPE_NAME,
           DOC_CURR, IS_TAXED, DESCRIPTION, RAPORT_NAME,
           EXPORT_TAG, IS_VAT,
           DOC_SUB_TYPE, PRINT_ORIGINAL, IS_ARCHIVE,
           ID_HOTEL, ID_DOC_NUM, ID_ANNUL_DOC_NUM, CURRENCY_LIST)
    values (:new_id_doc_type, :doc_type_name,
           :def_curr, 0, :description, :raport_name,
           :export_tag, :is_vat,
           :doc_sub_type, :print_original, :is_archive,
           :id_hotel, :id_doc_num, :id_annul_doc_num, :currency_list);
  end else if (:OPERATION = 'mod') then begin
    update DOC_TYPE
    set    DOC_TYPE_NAME = :doc_type_name,
           DOC_CURR = :def_curr,
           DESCRIPTION = :description,
           RAPORT_NAME = :raport_name,
           EXPORT_TAG = :export_tag,
           IS_VAT = :is_vat,
           PRINT_ORIGINAL = :print_original,
           IS_ARCHIVE = :is_archive,
           ID_DOC_NUM = :ID_DOC_NUM,
           ID_ANNUL_DOC_NUM = :ID_ANNUL_DOC_NUM,
           CURRENCY_LIST = :CURRENCY_LIST
    where  ID_DOC_TYPE = :ID_DOC_TYPE;
    NEW_ID_DOC_TYPE = :ID_DOC_TYPE;
  
    execute procedure SYSTEM_LOG_ADD ('DOC_TYPE', :NEW_ID_DOC_TYPE, 'DOC_TYPE_CHANGED', :DOC_TYPE_NAME);
  end else if (:OPERATION = 'del') then begin
    execute procedure SYSTEM_LOG_ADD ('DOC_TYPE', :ID_DOC_TYPE, 'DELETE', '');

    delete from  DOC_TYPE DT
    where  dt.ID_DOC_TYPE = :ID_DOC_TYPE;
    NEW_ID_DOC_TYPE = null;
  end

end
^

/* Alter (DOC_TYPE_PAY_MODIFY$DOC) */
ALTER PROCEDURE DOC_TYPE_PAY_MODIFY$DOC(ID_DOC_TYPE INTEGER,
DOC_DIRECTION INTEGER,
DOC_TYPE_NAME VARCHAR(50),
EXPORT_TAG VARCHAR(20),
STORNO_DOC_NAME VARCHAR(50),
STORNO_EXPORT_TAG VARCHAR(20),
DOC_CURR CHAR(3),
RAPORT_NAME VARCHAR(50),
DESCRIPTION VARCHAR(100),
IS_FISC SMALLINT,
ID_PAYMENT_TYPE INTEGER,
IS_ARCHIVE SMALLINT,
RIGHT_CODE VARCHAR(30),
OPERATION VARCHAR(10),
ID_HOTEL TYPE OF ID,
ID_DOC_NUM TYPE OF ID_REF,
CURRENCY_LIST VARCHAR(1000) = null)
 RETURNS(NEW_ID_DOC_TYPE INTEGER)
 AS
declare variable is_cash smallint;
  declare variable is_cc smallint;
  declare variable is_bank_transfer smallint;
  declare variable is_check smallint;
  declare variable is_ar_debt smallint;
  declare variable is_use integer;
  declare variable old_direction integer;
  declare variable old_id_payment_type integer;
  declare variable old_doc_name varchar(50);
  declare variable old_id_doc_num integer;
  declare variable is_num_used integer;
begin
  right_code = nullif(:right_code,'');

  execute procedure SYSTEM_CHECK_OPERATION(:OPERATION, 'add, mod, del');

  select DT.DOC_TYPE_NAME, P.ID_PAYMENT_TYPE, P.DOC_DIRECTION, dt.ID_DOC_NUM
  from   DOC_TYPE DT
         join DOC_TYPE_PAY P on p.ID_DOC_TYPE = DT.ID_DOC_TYPE
  where  DT.ID_DOC_TYPE = :ID_DOC_TYPE
  into   :old_doc_name, :old_id_payment_type, :old_direction, :old_id_doc_num;

  if (:OPERATION = 'mod') then begin
    /* doc type exists */
    if ((:old_doc_name <> :DOC_TYPE_NAME)
        or (:old_id_payment_type <> :ID_PAYMENT_TYPE)
        or (:old_direction <> :DOC_DIRECTION)
        or (:old_id_doc_num is distinct from :ID_DOC_NUM) ) then
    begin
      execute procedure DOC_TYPE_CHECK_USED (:ID_DOC_TYPE)
      returning_values  :is_use;
      if (:is_use = 1) then exception DOC_TYPE_EXCEPTION '-360';
    end

    if (:IS_ARCHIVE = 0
        and
        exists (select pt.ID_PAYMENT_TYPE
                from   PAYMENT_TYPE pt
                where  pt.ID_PAYMENT_TYPE = :ID_PAYMENT_TYPE
                       and pt.IS_USE = 0)) then exception DOC_TYPE_EXCEPTION '-331';
  end

  if (:OPERATION <> 'del') then begin
    select max(DT.ID_DOC_TYPE)
    from   DOC_TYPE DT
           join DOC_TYPE_INV dti on dti.ID_DOC_TYPE = dt.ID_DOC_TYPE
    where  DT.ID_DOC_NUM = :id_doc_num
    into   :is_num_used;
    if (:is_num_used is not null) then exception DOC_TYPE_EXCEPTION '-358';
  end

  execute procedure DOC_TYPE_MODIFY$INT (:id_doc_type, :doc_type_name, :doc_curr, :raport_name,
          :description, :export_tag, 0, 1, 0, :is_archive, :id_hotel,
          :id_doc_num, null, :CURRENCY_LIST, :operation)
  returning_values :new_id_doc_type;

  select PT.IS_CASH, PT.IS_CC, PT.IS_AR_DEBT
  from   PAYMENT_TYPE PT
  where  PT.ID_PAYMENT_TYPE = :ID_PAYMENT_TYPE
  into   :is_cash, :is_cc, :is_ar_debt;

  is_bank_transfer = 0;
  is_check = 0;
  --if (:DOC_DIRECTION = 1 and :is_cc = 1 /*+ :is_ar_debt) > 0*/) then
  --  exception DOC_TYPE_EXCEPTION '-363';  /* expense doc can't be credit card or AR */

  if (:is_cash = 1 and :is_ar_debt = 1) then
    exception DOC_TYPE_EXCEPTION '-362';  /* duplicated check for payment type compatibility  */

  if (:OPERATION = 'add') then begin
    insert into DOC_TYPE_PAY (ID_DOC_TYPE, DOC_DIRECTION, STORNO_DOC_NAME, STORNO_EXPORT_TAG,
           IS_CASH, IS_CC, IS_BANK_TRANSFER, IS_CHECK, IS_AR_DEBT, IS_FISC, RIGHT_CODE, ID_PAYMENT_TYPE)
    values (:NEW_ID_DOC_TYPE, :DOC_DIRECTION, :STORNO_DOC_NAME, :STORNO_EXPORT_TAG,
           :IS_CASH, :IS_CC, :IS_BANK_TRANSFER, :IS_CHECK, :is_ar_debt, :IS_FISC, :RIGHT_CODE, :ID_PAYMENT_TYPE);
  end else if (:OPERATION = 'mod') then begin
    update DOC_TYPE_PAY DP
    set    DP.STORNO_DOC_NAME = :STORNO_DOC_NAME,
           DP.STORNO_EXPORT_TAG = :STORNO_EXPORT_TAG,
           DP.IS_CASH = :is_cash,
           DP.IS_CC = :is_cc,
           DP.IS_BANK_TRANSFER = :is_bank_transfer,
           DP.IS_CHECK = :is_check,
           DP.IS_AR_DEBT = :is_ar_debt,
           DP.IS_FISC = :IS_FISC,
           DP.DOC_DIRECTION = :DOC_DIRECTION,
           DP.RIGHT_CODE = :RIGHT_CODE,
           DP.ID_PAYMENT_TYPE = :ID_PAYMENT_TYPE
    where  DP.ID_DOC_TYPE = :NEW_ID_DOC_TYPE;
  end
end
^

/* Alter (DOCUMENT_ADD_DEF_PAYMENT$DOC) */
ALTER PROCEDURE DOCUMENT_ADD_DEF_PAYMENT$DOC(ID_DOC_HEAD INTEGER,
ID_PAY_DOC_TYPE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable pay_curr varchar(3);
  declare variable doc_curr varchar(3);
  declare variable id_account integer;
  declare variable doc_sub_type integer;
  declare variable id_base_doc integer;
  declare variable paydocs_cnt integer;
  declare variable id_payment_head integer;
  declare variable storno_amount numeric(15,4);
  declare variable rest_value numeric(15,4);
  declare variable doc_rnd_to numeric(15,4);
  declare variable doc_value numeric(15,4);
  declare variable pay_rate numeric(15,6);
  declare variable doc_rate numeric(15,6);
  declare variable extra_info_needed smallint;
  declare variable id_doc_type integer;
begin                         /* create payment */
  PAY_CURR = null;
  select D.ID_ACCOUNT, D.DOC_SUB_TYPE, D.ID_BASE_DOC,
         D.DOC_CURRENCY, D.DOC_VALUE_A, d.DOC_RATE, d.ID_DOC_TYPE
  from   DOC_HEAD D
         join DOC_TYPE DT on dt.ID_DOC_TYPE = d.ID_DOC_TYPE
  where  D.ID_DOC = :ID_DOC_HEAD
  into   :id_account, :doc_sub_type, :id_base_doc,
         :doc_curr, :doc_value, :doc_rate, :id_doc_type;

  if (:doc_sub_type < 2) then begin
    if (:ID_PAY_DOC_TYPE is null) then begin
      /* = case */
      execute procedure PAYMENT_GET_DEFAULT$INT (:ID_ACCOUNT)
      returning_values  (:ID_PAY_DOC_TYPE, :pay_curr);

      if (:pay_curr <> :doc_curr) then begin
        execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, null)
        returning_values  (:dbg, :dbg, :dbg, :dbg, :rest_value);

        select C.ROUND_TO
        from   CURRS C
        where  C.CURR = :DOC_CURR
        into   :doc_rnd_to;
         
        if (:REST_VALUE = :DOC_RND_TO) then begin
          select iif(pdt.CURRENCY_LIST containing :doc_curr, :doc_curr, null)
          from   DOC_TYPE pdt
          where  pdt.ID_DOC_TYPE = :ID_DOC_TYPE
          into   :pay_curr;
        end
      end
    end else begin
      select  PDT.DEF_CURRENCY
      from    PAY_DOC_TYPE_S PDT
      where   PDT.ID_DOC_TYPE = :ID_PAY_DOC_TYPE
              and PDT.IS_ARCHIVE = 0
              and PDT.DOC_DIRECTION = 1
      into    :PAY_CURR;
    end

    if (:ID_PAY_DOC_TYPE is not null and :PAY_CURR is not null) then begin
      select coalesce(dtp.IS_CC, 0) + coalesce(dtp.IS_AR_DEBT, 0)
      from   DOC_TYPE_PAY DTp
      where  DTP.ID_DOC_TYPE = :ID_PAY_DOC_TYPE
      into   :extra_info_needed;

      if (:extra_info_needed = 0) then begin
        execute procedure DOCUMENT_ADD_PAYMENT$DOC (:ID_DOC_HEAD, :ID_PAY_DOC_TYPE, null, :PAY_CURR, '')
        returning_values :DBG;
      end
    end
  end else begin
    select count(P.ID_PAYMENT_HEAD)
    from   PAYMENT_HEAD P
    where  P.ID_DOC_HEAD = :ID_BASE_DOC
    into   :PAYDOCS_CNT;

    if (:PAYDOCS_CNT = 1) then begin
      select P.ID_PAYMENT_HEAD, P.PAY_CURRENCY, P.PAY_RATE
      from   PAYMENT_HEAD P
      where  P.ID_DOC_HEAD = :ID_BASE_DOC
      into   :id_payment_head, :pay_curr, :pay_rate;

      if (:pay_curr = :doc_curr) then pay_rate = :doc_rate;
      execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, :pay_curr, :pay_rate)
      returning_values  (:dbg, :dbg, :dbg, :dbg, :rest_value);

      STORNO_AMOUNT = -:REST_VALUE;

      execute procedure PAYMENT_STORNO$INT (:ID_PAYMENT_HEAD, :ID_ACCOUNT, :ID_DOC_HEAD, :STORNO_AMOUNT, '', :DOC_VALUE)
      returning_values  :DBG;

      when any do exit;
       
    end
  end
end
^

/* Alter (DOCUMENT_ADD_PAYMENT$DOC) */
ALTER PROCEDURE DOCUMENT_ADD_PAYMENT$DOC(ID_DOC_HEAD INTEGER,
ID_PAY_DOC_TYPE INTEGER,
PAY_VALUE NUMERIC(15,4),
PAY_CURRENCY VARCHAR(3),
DESCRIPTION VARCHAR(100))
 RETURNS(ID_PAYMENT_HEAD INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_account integer;
  declare variable doc_date date;
  declare variable pay_rate numeric(15,6);
  declare variable acc_curr varchar(3);
  declare variable acc_rate numeric(15,6);
  declare variable id_doc_contragent integer;
  declare variable is_taxable integer;
  declare variable id_tax_policy integer;
  declare variable dh_dbkey char(8);
  declare variable id_account_payment integer;
  declare variable id_doc_type integer;
  declare variable id_hotel integer;
begin
  select D.ID_ACCOUNT, D.DOC_DATE,
         A.ACCOUNT_CURR, D.DOC_RATE / D.DOC_ACC_RATE,
         D.ID_DOC_CONTRAGENT, A.ID_TAX_POLICY, D.RDB$DB_KEY,
         D.ID_DOC_TYPE, a.ID_HOTEL
  from   DOC_HEAD$INT D
         join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :id_account, :doc_date,
         :acc_curr, :acc_rate, :id_doc_contragent, :id_tax_policy, :dh_dbkey,
         :id_doc_type, :id_hotel;

  if (exists (select dtp.ID_DOC_TYPE
              from   DOC_TYPE_PAY_RESTRICT dtp
              where  dtp.ID_DOC_TYPE = :id_doc_type
                     and dtp.ID_PAY_DOC_TYPE = :ID_PAY_DOC_TYPE)) then
    exception DOCUMENT_EXCEPTION '-1048';

  if (not exists (select dt.ID_DOC_TYPE
                  from   DOC_TYPE DT
                  where  dt.ID_DOC_TYPE = :ID_PAY_DOC_TYPE
                         and dt.ID_HOTEL = :id_hotel)) then
    exception DOCUMENT_EXCEPTION '-1049';

  execute procedure DOCUMENT_CURR_RATE_GET$INT (:ID_DOC_HEAD, :PAY_CURRENCY)
  returning_values  (:pay_rate, :dbg);

  if (:PAY_VALUE is null) then begin
    execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, :PAY_CURRENCY)
    returning_values  (:dbg, :dbg, :dbg, :dbg, :PAY_VALUE);
  end

  if (:PAY_VALUE = 0) then exit;

  execute procedure PAYMENT_CREATE$INT(:ID_PAY_DOC_TYPE, :id_account, :doc_date,
          :PAY_VALUE, :PAY_CURRENCY, :pay_rate, :acc_curr, :acc_rate, :DESCRIPTION)
  returning_values (:id_payment_head, :id_account_payment, :is_taxable);

  update PAYMENT_HEAD P
  set    P.ID_DOC_HEAD = :ID_DOC_HEAD,
         P.ID_DOC_CONTRAGENT = :id_doc_contragent
  where  P.ID_PAYMENT_HEAD = :id_payment_head;
   
  if (:is_taxable = 1) then begin
    execute procedure DOCUMENT_ADD_PAY_TAXES$INT (:ID_DOC_HEAD,
            :ID_PAYMENT_HEAD, :id_tax_policy, :doc_date);

    execute procedure DOCUMENT_SAVE_TOTAL$INT (:ID_DOC_HEAD)
    returning_values :dbg;
  end

  execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:ID_DOC_HEAD, :id_account_payment, :pay_rate, null)
  returning_values :dbg;
   
  execute procedure DOC_INIT_FISCAL_STATUS$INT(:ID_DOC_HEAD);
end
^

ALTER PROCEDURE DOCUMENT_COMPLETE$INT(ID_DOC_HEAD TYPE OF ID,
DOC_DATE TYPE OF TDATE,
TAX_EVENT_DATE TYPE OF TDATE,
ID_DOC_PROFORMA TYPE OF ID_REF,
ID_SALE_NUM TYPE OF ID_REF = null)
 AS
begin
  insert into DOC_RELEASE_DATE (ID_DOC_HEAD, RELEASE_DATE, VALUE_CORR_INDEX)
  values (:ID_DOC_HEAD, :doc_date, 1);

  insert into DOC_COMPLETION (ID_DOC_HEAD, FISC_STATUS, IS_EFAKTURA_EXPORTED, TAX_EVENT_DATE, ID_DOC_PROFORMA, ID_SALE_NUM)
  values (:ID_DOC_HEAD, 0, 0, :TAX_EVENT_DATE, :ID_DOC_PROFORMA, :ID_SALE_NUM);
end
^

/* Alter (DOCUMENT_ADVANCE_STORNO$INT) */
ALTER PROCEDURE DOCUMENT_ADVANCE_STORNO$INT(ID_DEPOSIT INTEGER,
PAY_AMOUNT NUMERIC(15,2),
DESCRIPTION VARCHAR(100))
 RETURNS(ID_STORNO_DOC INTEGER,
WARN_CODE INTEGER)
 AS
declare variable no_use varchar(2000);
  declare variable id_doc_head integer;
  declare variable doc_date date;
  declare variable doc_value numeric(15,4);
  declare variable pay_rate numeric(15,6);
  declare variable doc_rate numeric(15,6);
  declare variable id_vat_group integer;
  declare variable is_storned integer;
  declare variable is_full_storno integer;
  declare variable is_anul integer;
  declare variable id_doc_supplier integer;
  declare variable id_hotel integer;
  declare variable id_account integer;
  declare variable received_amount numeric(15,4);
  declare variable sec_gross_value numeric(15,4);
  declare variable nat_gross_value numeric(15,4);
  declare variable nat_round_to numeric(15,4);
  declare variable doc_round_to numeric(15,4);
  declare variable sec_round_to numeric(15,4);
  declare variable sec_curr_rate numeric(15,6);
  declare variable line_name varchar(100) ;
  declare variable id_service integer;
  declare variable id_doc_line integer;
  declare variable id_payment_head integer;
  declare variable sec_curr varchar(3);
  declare variable round_to numeric(15,4);
  declare variable is_archive integer;
  declare variable id_sale_num integer;
begin
  id_doc_head = null;
  WARN_CODE = null;
  select DH.ID_DOC, ph.PAY_RATE, DH.DOC_RATE, DH.IS_STORNED, DH.IS_ANUL,
         DH.ID_DOC_SUPPLIER, A.ID_HOTEL, A.ID_ACCOUNT, ph.ID_PAYMENT_HEAD,
         dt.IS_ARCHIVE, dh.ID_SALE_NUM
  from   DEPOSIT D
         join PAYMENT_HEAD PH on PH.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
         join DOC_HEAD DH on DH.ID_DOC = PH.ID_DOC_HEAD
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join DOC_TYPE dt on dt.ID_DOC_TYPE = dh.ID_DOC_TYPE
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_doc_head, :pay_rate, :doc_rate, :is_storned, :is_anul,
         :id_doc_supplier, :id_hotel, :id_account, :id_payment_head,
         :is_archive, :id_sale_num;

  if (:id_doc_head is null) then EXIT; /* !?! */

  if (:is_anul = 1) then
    exception DOCUMENT_EXCEPTION '-352';
  if (:is_storned = 1) then
    exception MULTIPLE_STORNO_ON_DOC;

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values  (:doc_date);

  select sum(d.RECEIVED_AMOUNT), min(c.ROUND_TO)
  from   DEPOSITS D
         join CURRS c on c.CURR = d.PAY_CURRENCY
  where  D.ID_PAYMENT_HEAD = :id_payment_head
  into   :received_amount, :round_to;

  if (round_f(:received_amount, :round_to) = 0) then is_full_storno = 1;  -- Refund whole deposit payment
  else is_full_storno = 0;
   
  execute procedure DOC_SUPPLIER_GET_COPY$DOC (:id_doc_supplier)
  returning_values  (:id_doc_supplier);
   
  ID_STORNO_DOC = gen_id(DOC_SELECTED_GEN, 1);
  insert into DOC_HEAD$INT
         (ID_DOC_HEAD, ID_DOC_TYPE, ID_DOC_NUM, ID_ACCOUNT, DOC_CURRENCY, DOC_DATE,
         DOC_TYPE_NAME, IS_ANUL, IS_STORNED, DESCRIPTION,
         DOC_RATE, DOC_VALUE, DOC_VALUE_A, DOC_NET_VALUE, DOC_ACC_RATE, ID_BASE_DOC, FOR_DEPOSIT,
         ID_DOC_CONTRAGENT, ID_DOC_SUPPLIER, DOC_SUB_TYPE,
         IS_STORNO, SECOND_CURRENCY, SECOND_CURR_RATE, SECOND_CURR_NET_VALUE, SECOND_CURR_GROSS_VALUE, DOC_VALUE_ROUNDLESS)
  select :ID_STORNO_DOC, ID_DOC_TYPE, ID_DOC_NUM, :id_account, DOC_CURRENCY, :doc_date,
         DOC_TYPE_NAME, IS_ANUL, IS_STORNED, :DESCRIPTION,
         DOC_RATE, 0, 0, DOC_NET_VALUE, DOC_ACC_RATE, ID_BASE_DOC, FOR_DEPOSIT,
         ID_DOC_CONTRAGENT, :id_doc_supplier, 2,
         :is_full_storno, dh.SECOND_CURRENCY, dh.SECOND_CURR_RATE, dh.SECOND_CURR_NET_VALUE, dh.SECOND_CURR_GROSS_VALUE, dh.DOC_VALUE_ROUNDLESS
  from   DOC_HEAD$INT DH
  where  DH.ID_DOC_HEAD = :id_doc_head;

  execute procedure DOCUMENT_COMPLETE$INT (:ID_STORNO_DOC, :DOC_DATE, :doc_date, null, :id_sale_num);

  -- sum all invoice lines for this payment
  select min(dl.ID_SALE_TAXATION), min(dl.LINE_NAME), min(dl.ID_SERVICE),
         -sum(dl.SINGLE_VALUE * dl.QTY_POST), -sum(dl.NAT_GROSS_VALUE), -sum(dl.SEC_CURR_GROSS_VALUE)
  from   DEPOSIT d
         join DOC_LINE_DEP_VALUES DV on dv.ID_DEPOSIT = d.ID_DEPOSIT
         join DOC_LINE DL on dl.ID_DOC_LINE = dv.ID_DOC_LINE
         join DOC_HEAD$INT dh on dh.ID_DOC_HEAD = dl.ID_DOC_HEAD
  where  d.ID_PAYMENT_HEAD = :id_payment_head
         and dh.FOR_DEPOSIT = 1
         and dh.IS_ANUL = 0
  into   :id_vat_group, :line_name, :id_service, :doc_value, :nat_gross_value, :sec_gross_value;

  execute procedure DOCUMENT_CURRS_GET$INT (:ID_STORNO_DOC)
  returning_values (:no_use, :doc_rate, :doc_round_to, :no_use, :nat_round_to, :sec_curr, :sec_curr_rate, :sec_round_to);

  if (:is_full_storno = 0) then begin
    doc_value = -:PAY_AMOUNT * cast(:pay_rate / :doc_rate as double precision);
    nat_gross_value = round_f(:doc_value * :doc_rate, :nat_round_to);
    sec_gross_value = round_f(:doc_value * cast(:doc_rate / :sec_curr_rate as double precision), :sec_round_to);
  end

  execute procedure DOCUMENT_LINE_ADD$INT (:ID_STORNO_DOC, :id_service, :id_vat_group,
          :line_name, -1, :doc_date, :doc_date, :doc_date, null,
          1, :DOC_VALUE, round_f(:doc_value, :doc_round_to), :doc_round_to,
          :nat_gross_value, :nat_round_to, :sec_curr, :sec_gross_value, :sec_round_to,
          0, 1, 0)
  returning_values (:id_doc_line, :no_use, :no_use, :no_use);

  insert into DOC_LINE_DEP_VALUES (ID_DOC_LINE, ID_DEPOSIT)
  values (:id_doc_line, :ID_DEPOSIT);
  /*  */

  execute procedure DOCUMENT_SAVE_TOTAL$INT (:ID_STORNO_DOC)
  returning_values :no_use;

  if (:is_full_storno = 1) then begin
    update DOC_HEAD$INT D
    set    D.IS_STORNED = 1
    where  D.ID_DOC_HEAD = :id_doc_head;
  end

  if (:is_archive = 1) then execute procedure SYSTEM_WARNING_ADD(-312, '') returning_values :WARN_CODE;
end
^

/* Alter (DOCUMENT_ANUL$DOC) */
ALTER PROCEDURE DOCUMENT_ANUL$DOC(ID_DOC_HEAD INTEGER,
ANUL_REASON VARCHAR(100),
MAKE_ANNUL_REPORT SMALLINT)
 AS
/**/
  declare variable id_account  integer;
  declare variable id_payment_head integer;
  declare variable for_deposit integer;
  declare variable id_base_doc integer;
  declare variable is_anul integer;
  declare variable dh_dbkey char(8);
  declare variable id_annul_protocol_num integer;
  declare variable num integer;
  declare variable doc_num varchar(20);
  declare variable system_date date;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable doc_date date;
  declare variable id_system_log integer;
  declare variable id_hotel integer;
  declare variable is_storno_doc integer;
  declare variable no_use integer;
  declare variable doc_sub_type integer;
begin
  select H.RDB$DB_KEY, H.ID_ACCOUNT, H.FOR_DEPOSIT, H.ID_BASE_DOC, H.IS_ANUL, A.ID_HOTEL,
         A.ID_RESERV_DETAIL, T.ID_ANNUL_DOC_NUM, h.DOC_DATE, H.IS_STORNO, h.DOC_SUB_TYPE
  from   DOC_HEAD$INT H
         join DOC_COMPLETION dc on dc.ID_DOC_HEAD = h.ID_DOC_HEAD
         join DOC_TYPE T on H.ID_DOC_TYPE = T.ID_DOC_TYPE
         join DOC_TYPE_INV DTI on DTI.ID_DOC_TYPE = T.ID_DOC_TYPE
         join ACCOUNT A on A.ID_ACCOUNT = H.ID_ACCOUNT
  where  H.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dh_dbkey, :id_account, :for_deposit, :id_base_doc, :is_anul, :id_hotel,
         :id_reserv_detail, :id_annul_protocol_num, :doc_date, :is_storno_doc, :doc_sub_type;

  if (:is_anul = 1) then
    exception DOCUMENT_ANNUL_EXCEPTION '-352'; --'Document is already annul';

  if (exists (select D.ID_DOC
              from   DOC_HEAD D
              where  D.ID_BASE_DOC = :ID_BASE_DOC
                     and D.ID_DOC > :ID_DOC_HEAD
                     and D.IS_ANUL = 0))
  then exception DOCUMENT_ANNUL_EXCEPTION '-314';

  if (exists (select D.ID_DEPOSIT
              from   DEPOSIT_DEDUCT DD
                     join DEPOSITS d on d.ID_DEPOSIT = dd.ID_DEPOSIT
              where  DD.ID_DOC_USED = :ID_DOC_HEAD
                     and D.RECEIVED_AMOUNT = 0))
  then exception DOCUMENT_ANNUL_EXCEPTION '-315';

  execute procedure SYSTEM_DATE_GET(:ID_HOTEL)
  returning_values  :system_date;

  if (:DOC_DATE < :SYSTEM_DATE) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_PREV_DATE');
  end
  if (:doc_sub_type > 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_CORR_DOC');
  end
  /* unarchive account and set as credit account, for shecked out bookings only */
  execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:ID_ACCOUNT, 0);

  if (:ID_RESERV_DETAIL is not null) then begin
    select RD.CHECK_STATUS
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :check_status;

    if (:check_status = 1) then begin
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, null, 1);
    end
  end
  /* MARK THE DOCUMENT AS ANUL - before posting and payment updates */
  update DOC_HEAD$INT DH
  set    DH.IS_ANUL = 1
  where  DH.RDB$DB_KEY = :dh_dbkey;

  update DOC_COMPLETION Dc
  set    Dc.IS_EFAKTURA_EXPORTED = 0
  where  Dc.ID_DOC_HEAD = :ID_DOC_HEAD;


  if (:is_storno_doc = 1) then begin
    /* annul storno doc */
    update DOC_HEAD$INT BD
    set    BD.IS_STORNED = 0
    where  BD.ID_BASE_DOC = :id_base_doc
           and BD.IS_STORNED = 1;
  end
  /* RELEASE ACCOUNT_POSTS */
  if (:for_deposit = 0) then
    execute procedure ACCOUNT_POSTING_DOC_UPDATE$INT (:DH_DBKEY)
    returning_values (:no_use);

  /* PAYMENTS REFLECTION */
  for
    select PH.ID_PAYMENT_HEAD
    from   PAYMENT_HEAD PH
           join DOC_TYPE_PAY dt on dt.ID_DOC_TYPE = ph.ID_DOC_TYPE
    where  PH.ID_DOC_HEAD = :ID_DOC_HEAD
           and PH.IS_STORNED = 0
    into   :ID_PAYMENT_HEAD
  do begin

    execute procedure PAYMENT_ANUL$INT (:ID_PAYMENT_HEAD, :ANUL_REASON);
  end

  /* ANNUL_PROTOCOL creating section */
  NUM = null;
  DOC_NUM = null;
  if (:MAKE_ANNUL_REPORT = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_WITH_PROT');

    if (:ID_ANNUL_PROTOCOL_NUM is null) then exception DOCUMENT_ANNUL_EXCEPTION '-345';

    execute procedure SYSTEM_GEN_NUM ('ANNUL_PROT', :ID_ANNUL_PROTOCOL_NUM)
    returning_values  (:num, :doc_num);
  end
  /* log annul event */
  execute procedure SYSTEM_EVENT_LOG$INT ('DOCUMENT', :ID_DOC_HEAD, 'ANNUL', f_character(29)||:ANUL_REASON)
  returning_values  :id_system_log;

  insert into DOC_ANNULMENT (ID_DOC_HEAD, ANNULMENT_DATE, ID_PROT_DOC_NUM, PROT_NUM, PROT_DOC_NUM, ID_LOG_EVENT)
  values (:ID_DOC_HEAD, :SYSTEM_DATE, :ID_ANNUL_PROTOCOL_NUM, :NUM, :DOC_NUM, :ID_SYSTEM_LOG);
  /* reflect annul date on doc release dates */
  if (:DOC_DATE < :SYSTEM_DATE) then begin
    insert into DOC_RELEASE_DATE (ID_DOC_HEAD, RELEASE_DATE, VALUE_CORR_INDEX)
    values (:ID_DOC_HEAD, :SYSTEM_DATE, -1);
  end else begin
    update DOC_RELEASE_DATE RD
    set    RD.VALUE_CORR_INDEX = 0
    where  RD.ID_DOC_HEAD = :ID_DOC_HEAD
           and RD.RELEASE_DATE = :DOC_DATE;
  end
  /* reflect on AR module */
  execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT (:DH_DBKEY, :ANUL_REASON);
  /* reflect on client loyalty module */
  execute procedure DOCUMENT_BONUSPOINTS_VOID$CL (:ID_DOC_HEAD);

end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ADVANCE_PAYMENT$INT for: DOCUMENT_ATTACH_PAYMENT$INT */
ALTER PROCEDURE DOCUMENT_ADVANCE_PAYMENT$INT(ID_DOC_HEAD INTEGER,
ID_PAYMENT_HEAD INTEGER,
ACC_RATE NUMERIC(15,6))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_REUSE_PAYMENTS$INT for: DOCUMENT_ATTACH_PAYMENT$INT */
ALTER PROCEDURE DOCUMENT_REUSE_PAYMENTS$INT(OLD_ID_DOC_HEAD INTEGER,
NEW_ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (DOCUMENT_ATTACH_PAYMENT$INT) */
ALTER PROCEDURE DOCUMENT_ATTACH_PAYMENT$INT(ID_DOC_HEAD INTEGER,
ID_ACCOUNT_PAYMENT INTEGER,
PAY_CURR_RATE NUMERIC(15,6),
PAY_VALUE NUMERIC(15,4))
 RETURNS(DOC_VALUE NUMERIC(15,4))
 AS
declare variable doc_rate numeric(15,6);
  declare variable doc_curr varchar(3);
  declare variable rest_value numeric(15,4);
  declare variable doc_round_to numeric(15,4);
  declare variable pay_round_to numeric(15,4);
  declare variable pay_amount numeric(15,4);
  declare variable equal_pay_doc_rate double precision;
  declare variable id_deposit integer;
  declare variable id_reserv_detail integer;
begin
  if (:PAY_CURR_RATE is null) then exception DOCUMENT_EXCEPTION 'Unspecified payment currency rate!';

  select D.DOC_RATE, D.DOC_CURRENCY, C.ROUND_TO
  from   DOC_HEAD D
         join CURRS C on C.CURR = D.DOC_CURRENCY
  where  D.ID_DOC = :ID_DOC_HEAD
  into   :doc_rate, :doc_curr, :doc_round_to;

  select AP.PAY_AMOUNT, c.ROUND_TO, ap.ID_DEPOSIT
  from   ACCOUNT_PAYMENTS AP
         join PAYMENT_HEAD P on p.ID_PAYMENT_HEAD = ap.ID_PAYMENT_HEAD
         join CURRS C on C.CURR = p.PAY_CURRENCY
  where  aP.ID_ACCOUNT_PAYMENT = :ID_ACCOUNT_PAYMENT
  into   :pay_amount, :pay_round_to, :id_deposit;

  if (:id_deposit is not null) then begin
    select d.ID_RESERV_DETAIL
    from   DEPOSIT D
    where  d.ID_DEPOSIT = :id_deposit
    into   :id_reserv_detail;

    if (:id_reserv_detail is not null) then begin
      execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:id_reserv_detail);
  
      when any do begin
        exception DOCUMENT_EXCEPTION 'Can not manipulate deposit!';
      end
    end
  end

  if (:PAY_VALUE is null) then PAY_VALUE = :pay_amount;

  select first 1 DV.PAYABLE_VALUE
  from   DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, :doc_curr, :doc_rate) DV
  into   :rest_value;

  execute procedure PAYMENT_EQUIVALENCE_CALC$INT (:PAY_CURR_RATE, :PAY_VALUE, :pay_round_to, :doc_rate, :doc_round_to, :rest_value)
  returning_values  (:DOC_VALUE, :equal_pay_doc_rate);
  --doc_rate = :PAY_CURR_RATE / :equal_pay_doc_rate;

  insert into DOC_PAY_USAGE (ID_DOC_HEAD, ID_ACCOUNT_PAYMENT, PAY_AMOUNT, PAY_RATE,
         DOC_AMOUNT, /*DOC_RATE,*/ EQUAL_PAY_DOC_RATE)
  values (:id_doc_head, :id_account_payment, :pay_value, :PAY_CURR_RATE,
         :DOC_VALUE, /*:doc_rate,*/ :equal_pay_doc_rate);

end
^

/* Alter (DOCUMENT_BONUSPOINTS_APPLY$CL) */
ALTER PROCEDURE DOCUMENT_BONUSPOINTS_APPLY$CL(ID_DOC_HEAD INTEGER)
 AS
declare variable points integer;
  declare variable id_guest_profile integer;
  declare variable id_guest_scheme integer;
  declare variable id_organizer_profile integer;
  declare variable id_organizer_scheme integer;
  declare variable reason varchar(50);
  declare variable note varchar(255);
  declare variable new_id_profile_wallet_points integer;
  declare variable turnover numeric(15,4);
  declare variable id_reserv_detail integer;
  declare variable acc_routing varchar(30);
  declare variable id_doc_footer integer;
  declare variable id_profile integer;
  declare variable bonuspoint_cnt integer;
  declare variable turnover_curr char(3);
begin
  points = null;
  reason = null;
  note = null;

  for
    select  DF.ID, P.ID_PROFILE, DF.TAXABLE_VALUE,
            substring(d.DOC_TYPE_NAME || ' ' || d.DOC_NUM || ' / ' || formatdate(d.DOC_DATE, 'D;dd.MM.yyyy') from 1 for 255)
    from    DOC_FOOTER DF
            join DOC_HEAD D on d.ID_DOC = df.ID_DOC_HEAD
            join ACCOUNT A on A.ID_ACCOUNT = d.ID_ACCOUNT
            join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
    where   DF.ID_DOC_HEAD = :ID_DOC_HEAD
            and df.ID_DOC_LINE is null
            and df.ID_TAX is null
    into    :id_doc_footer, :id_profile, :bonuspoint_cnt, :note
  do begin
    /* register spended bonus points */
    execute procedure PROFILE_WALLET_POINTS_REGISTER (:id_profile, :bonuspoint_cnt, 'CONSUME', :note)
    returning_values (:new_id_profile_wallet_points);
  
    insert into PROFILE_WALLET_POINTS_SPEND (ID_PROFILE_WALLET_POINTS, ID_DOC_FOOTER)
    values (:new_id_profile_wallet_points, :id_doc_footer);
  end

  for
    select distinct rd.ID_RESERV_DETAIL,
           RD.ACC_ROUTING, P.ID_PROFILE, P.ID_BONUSPOINT_SCHEME,
           PO.ID_PROFILE, PO.ID_BONUSPOINT_SCHEME,
           substring(d.DOC_TYPE_NAME || ' ' || d.DOC_NUM || ' / ' || formatdate(d.DOC_DATE, 'D;dd.MM.yyyy') from 1 for 255)
    from   DOC_HEAD D
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
           join DOC_LINE DL on DL.ID_DOC_HEAD = D.ID_DOC
           join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
           left outer join GUEST G on G.ID_GUEST = DL.ID_GUEST
           left outer join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
           left outer join PROFILE_BONUSPOINT_SCHEME P on P.ID_PROFILE = coalesce(RD.ID_PERSON_PROFILE, A.ID_PROFILE)
                                                          and P.ID_HOTEL = RD.ID_HOTEL
           left outer join PROFILE_BONUSPOINT_SCHEME PO on PO.ID_PROFILE = coalesce(RD.ID_AGENT_PROFILE, A.ID_PROFILE)
                                                           and PO.ID_HOTEL = RD.ID_HOTEL
    where  D.ID_DOC = :ID_DOC_HEAD
           and D.IS_ANUL = 0
    into   :id_reserv_detail, :acc_routing, :id_guest_profile, :id_guest_scheme,
           :id_organizer_profile, :id_organizer_scheme, :note
  do begin
    if (:id_organizer_scheme is not null) then begin
      for
        select BPC.POINTS, BPC.TURNOVER, BPC.POINTS_REASON, BPC.TURNOVER_CURR
        from   BP_SCHEME_CALC_TURNOVER_POINTS (:id_organizer_scheme, :ID_DOC_HEAD, :id_reserv_detail, 'BASE,EXTRA') BPC
        where  BPC.POINTS <> 0
        into   :points, :turnover, :reason, :turnover_curr
      do begin
        execute procedure PROFILE_WALLET_POINTS_REGISTER (:id_organizer_profile, :points, :reason, :note)
        returning_values (:new_id_profile_wallet_points);
      
        insert into PROFILE_WALLET_POINTS_SOURCE
               (ID_PROFILE_WALLET_POINTS, ID_RESERV_DETAIL, ID_DOC_HEAD, TURNOVER, TURNOVER_CURR, ID_BONUSPOINT_SCHEME)
        values (:new_id_profile_wallet_points, :id_reserv_detail, :ID_DOC_HEAD, :turnover, :turnover_curr, :id_organizer_scheme);
      end
    end
  
    if (:id_guest_profile is distinct from :id_organizer_profile
        and :acc_routing in ('GUEST', 'MIXED')
        and :id_guest_scheme is not null) then
    begin
      for
        select BPC.POINTS, BPC.TURNOVER, BPC.POINTS_REASON, BPC.TURNOVER_CURR
        from   BP_SCHEME_CALC_TURNOVER_POINTS (:id_guest_scheme, :ID_DOC_HEAD, :id_reserv_detail,
               iif(:acc_routing = 'GUEST', 'BASE,EXTRA', 'EXTRA')) BPC
        where  BPC.POINTS <> 0
        into   :points, :turnover, :reason, :turnover_curr
      do begin
        execute procedure PROFILE_WALLET_POINTS_REGISTER (:id_guest_profile, :points, :reason, :note)
        returning_values (:new_id_profile_wallet_points);
      
        insert into PROFILE_WALLET_POINTS_SOURCE
               (ID_PROFILE_WALLET_POINTS, ID_RESERV_DETAIL, ID_DOC_HEAD, TURNOVER, TURNOVER_CURR, ID_BONUSPOINT_SCHEME)
        values (:new_id_profile_wallet_points, :id_reserv_detail, :ID_DOC_HEAD, :turnover, :turnover_curr, :id_guest_scheme);
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_RESET_TYPE$DOC for: DOCUMENT_BONUSPOINTS_SPEND */
ALTER PROCEDURE DOCUMENT_RESET_TYPE$DOC(ID_DOC_HEAD INTEGER,
ID_DOC_TYPE INTEGER,
DOC_CURRENCY VARCHAR(3),
PROFORMA_NAME_PREFIX VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* Alter (DOCUMENT_BONUSPOINTS_SPEND) */
ALTER PROCEDURE DOCUMENT_BONUSPOINTS_SPEND(ID_DOC_HEAD INTEGER,
BONUSPOINT_CNT INTEGER)
 RETURNS(DOC_REST_AMOUNT NUMERIC(15,4))
 AS
declare variable bonuspoints_avail integer;
  declare variable id_bonuspoint_scheme integer;
  declare variable consume_discount_txt varchar(100) ;
  declare variable consume_point_price numeric(15,4);
  declare variable consume_point_curr varchar(3);
  declare variable doc_curr varchar(3);
  declare variable second_curr varchar(3);
  declare variable discount_value numeric(15,4);
  declare variable doc_discount_value numeric(15,4);
  declare variable sec_curr_discount_value numeric(15,4);
  declare variable round_to numeric(15,4);
  declare variable doc_rate numeric(15,6);
  declare variable second_curr_rate numeric(15,6);
  declare variable bp_price_rate numeric(15,6);
  declare variable no_use varchar(255);
  declare variable consume_point_nominal integer;
begin
  delete from DOC_FOOTER DF
  where  DF.ID_DOC_HEAD = :ID_DOC_HEAD
         and df.ID_TAX is null;

  if (:BONUSPOINT_CNT <= 0) then exit;

  select D.DOC_CURRENCY, D.DOC_RATE, PB.ID_BONUSPOINT_SCHEME, c.ROUND_TO, d.SECOND_CURRENCY, d.SECOND_CURR_RATE,
         cast(coalesce(P.BONUSPOINT_GAINED, 0) - coalesce(p.BONUSPOINT_CONSUMED, 0) as integer)
  from   DOC_HEAD D
         join ACCOUNT A on A.ID_ACCOUNT = d.ID_ACCOUNT
         join PROFILE P on P.ID_PROFILE = a.ID_PROFILE
         join PROFILE_BONUSPOINT_SCHEME PB on PB.ID_PROFILE = P.ID_PROFILE and PB.ID_HOTEL = a.ID_HOTEL
         join CURRS c on c.CURR = d.DOC_CURRENCY
  where  D.ID_DOC = :ID_DOC_HEAD
  into   :doc_curr, :doc_rate, :id_bonuspoint_scheme, :round_to, :second_curr, :second_curr_rate,
         :bonuspoints_avail;

  if (:BONUSPOINT_CNT > :bonuspoints_avail) then exception DOCUMENT_EXCEPTION 'Insufficient bonus points !';

  select BS.CONSUME_DISCOUNT_TXT, BS.CONSUME_POINT_PRICE, BS.CONSUME_POINT_CURR, BS.CONSUME_POINT_NOMINAL
  from   BONUSPOINT_SCHEME BS
  where  BS.ID_BONUSPOINT_SCHEME = :id_bonuspoint_scheme
  into   :consume_discount_txt, :consume_point_price, :consume_point_curr, :consume_point_nominal;

  discount_value = -round_f(:BONUSPOINT_CNT * iif(:consume_point_nominal = 0, 0, cast(:consume_point_price / :consume_point_nominal as double precision)), :round_to);

  if (:doc_curr <> :consume_point_curr) then begin
    -- convert to document currency
    execute procedure DOCUMENT_CURR_RATE_GET$INT (:ID_DOC_HEAD, :consume_point_curr)
    returning_values (:bp_price_rate, :no_use);

    doc_discount_value = round_f(:discount_value * cast(:bp_price_rate / :doc_rate as double precision), :round_to);
  end else begin
    doc_discount_value = :discount_value;
  end
  if (:second_curr = :doc_curr) then begin
    sec_curr_discount_value = :doc_discount_value;
  end else if (:second_curr = :consume_point_curr) then begin
    sec_curr_discount_value = :discount_value;
  end else if (:second_curr is not null) then begin
    execute procedure DOCUMENT_CURR_RATE_GET$INT (:ID_DOC_HEAD, :consume_point_curr)
    returning_values (:bp_price_rate, :no_use);

    sec_curr_discount_value = round_f(:discount_value * cast(:bp_price_rate / :second_curr_rate as double precision), :round_to);
  end

  insert into DOC_FOOTER (ID_DOC_HEAD, ID_TAX, TAX_ORDER, TAXABLE_VALUE,
         ID_DOC_LINE, FOOTER_VALUE, DESCRIPTION, SECOND_CURR_DISCOUNTABLE_VALUE, SECOND_CURR_DISCOUNT_VALUE)
  values (:ID_DOC_HEAD, null, 0, :BONUSPOINT_CNT,
         null, :doc_discount_value, :consume_discount_txt, :BONUSPOINT_CNT, :sec_curr_discount_value);

  execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, null)
  returning_values (:no_use, :no_use, :no_use, :no_use, :DOC_REST_AMOUNT);

  if (:DOC_REST_AMOUNT < 0) then exception DOCUMENT_EXCEPTION '-380';
end
^

/* Alter (DOCUMENT_CHECK_SELECTION$INT) */
ALTER PROCEDURE DOCUMENT_CHECK_SELECTION$INT(DOC_SELECTED INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_DOC_TYPE INTEGER,
ID_BASE_DOC INTEGER,
DOC_CURR VARCHAR(3),
ID_DOC_CONTRAGENT INTEGER,
ID_ADVANCE_PAYMENT INTEGER,
CLOSING_WHOLE_ACCOUNT SMALLINT)
 AS
declare variable cnt_base_docs integer;
  declare variable cnt_posts integer;
  declare variable ac varchar(2);
begin
  ID_DOC_TYPE = null;
  DOC_CURR = null;
  ID_DOC_CONTRAGENT = null;
  ID_BASE_DOC = null;
  CLOSING_WHOLE_ACCOUNT = 0;

  select count(distinct(AP.ID_ACCOUNT_POST)),
         count(distinct(ap.ID_BASE_DOC)),
         min(ap.ID_BASE_DOC),
         max(ap.ac)
  from   ACCOUNT_POST ap
  where  ap.DOC_SELECTED = :doc_selected
         and ap.ID_ACCOUNT = :ID_ACCOUNT
         --and ap.ac = '00'
  into   :cnt_posts, :cnt_base_docs, :ID_BASE_DOC, :ac;
    
  if (:ac = '01') then exception DOCUMENT_EXCEPTION '-397';
  if (:ac = '10') then exception DOCUMENT_EXCEPTION '-398';

  if (:cnt_posts = 0) then begin
    -- deposit document issued
    select min(P.ID_DOC_CONTRAGENT),
           count(distinct(D.ID_DEPOSIT)),
           min(d.ID_PAYMENT_HEAD)
    from   DEPOSIT D
           join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
    where  D.DOC_SELECTED = :DOC_SELECTED
    into   :ID_DOC_CONTRAGENT, :cnt_posts, :ID_ADVANCE_PAYMENT;

    if (:cnt_posts = 0) then exception DOC_ON_EMPTY_SELECTION;

  end else begin
    -- service document issued
    if (:cnt_base_docs > 1) then
      exception DOCUMENT_EXCEPTION '-302'; --'There are correctoins on more than one document. Automatic storno type is impossible!';

    if (:cnt_base_docs = 1) then begin
      select  D.ID_DOC_TYPE, D.DOC_CURRENCY, D.ID_DOC_CONTRAGENT
      from    DOC_HEAD$INT D
      where   D.ID_DOC_HEAD = :ID_BASE_DOC
      into    :ID_DOC_TYPE, :DOC_CURR, :ID_DOC_CONTRAGENT;
    end

    if (not exists (select p.ID_ACCOUNT_POST
                    from   ACCOUNT_POST p
                    where  p.ID_ACCOUNT = :ID_ACCOUNT
                           and p.DOC_SELECTED is distinct from :DOC_SELECTED
                           and p.AC = '00')) then
      CLOSING_WHOLE_ACCOUNT = 1;

  end
end
^

/* Alter (DOCUMENT_CREATE$INT) */
ALTER PROCEDURE DOCUMENT_CREATE$INT(DOC_SELECTED INTEGER,
ID_ACCOUNT INTEGER,
ID_DOC_TYPE INTEGER,
DOC_TYPE_NAME TYPE OF TOBJECT_NAME,
DOC_DATE DATE,
DOC_CURR VARCHAR(3),
ID_BASE_DOC INTEGER,
TAX_EVENT_DATE DATE,
IS_PROFORMA TLOGICAL,
ID_ADVANCE_PAYMENT ID_REF)
 RETURNS(ID_DOC_HEAD INTEGER,
DOC_SUB_TYPE SMALLINT)
 AS
declare variable no_use varchar(255);
  declare variable acc_currency char(3);
  declare variable second_currency char(3);
  declare variable acc_curr_rate numeric(15,6);
  declare variable doc_curr_rate numeric(15,6);
  declare variable sec_curr_rate numeric(15,6);
  declare variable id_doc_num integer;
  declare variable id_hotel integer;
  declare variable currency_list varchar(1000);
  declare variable id_sale_num integer;
begin
  /* FIND THE ACCOUNT CURRENCY ************************************************/
  select A.ACCOUNT_CURR, A.ID_HOTEL, a.ID_SALE_NUM
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :acc_currency, :id_hotel, :id_sale_num;

  if (:id_sale_num is null) then begin
    execute procedure ACCOUNT_SALE_NUMBER_SET(:ID_ACCOUNT)
    returning_values (:id_sale_num);
  end
  /* FIND THE DOCUMENT LOOKUPS FROM THE DOCUMENT TYPE *************************/
  select iif(:IS_PROFORMA = 1, dti.ID_PROFORMA_NUM, DT.ID_DOC_NUM), dti.SECOND_CURRENCY, dt.CURRENCY_LIST
  from   DOC_TYPE DT
         join DOC_TYPE_INV DTI on DTI.ID_DOC_TYPE = DT.ID_DOC_TYPE
  where  DT.ID_DOC_TYPE = :id_doc_type
         and DT.ID_HOTEL = :id_hotel
  into   :id_doc_num, :second_currency, :currency_list;

  if (:IS_PROFORMA = 1 and :ID_ADVANCE_PAYMENT is not null) then
     exception DOCUMENT_EXCEPTION '-392';
  if (:IS_PROFORMA = 1 and :id_doc_num is null) then
     exception DOCUMENT_EXCEPTION '-393';
  if (:id_doc_num is null) then
    exception DOCUMENT_EXCEPTION '-92' || f_character(31) || f_character(29) || :doc_type_name;
  /* CHECK DOC_TYPE CURRENCY RESTRICTIONS *************************************/
  if (:currency_list not containing :DOC_CURR) then
    exception CURRENCY_IS_NOT_SUPPORTED f_character (29) || :DOC_CURR || f_character (28) || :doc_type_name;
  /* GET ACTUAL CURRENCY RATES ************************************************/
  execute procedure DOCUMENT_CURR_RATE_GET$INT (:DOC_SELECTED, :acc_currency)
  returning_values  (:acc_curr_rate, :no_use);

  execute procedure DOCUMENT_CURR_RATE_GET$INT (:DOC_SELECTED, :DOC_CURR)
  returning_values  (:doc_curr_rate, :no_use);

  if (:second_currency is not null) then
    execute procedure DOCUMENT_CURR_RATE_GET$INT (:DOC_SELECTED, :second_currency)
    returning_values  (:sec_curr_rate, :no_use);
  /*****------------------------------------------------------------------*****/
  /*****                 CREATING THE NEW DOCUMENT                        *****/
  /*****              CREATING NEW RECORD IN DOC_HEAD                     *****/
  /*****                    AND NEW DOC LINES                             *****/
  /*****------------------------------------------------------------------*****/
  ID_DOC_HEAD = :DOC_SELECTED;
  ID_BASE_DOC = coalesce(:ID_BASE_DOC, :ID_DOC_HEAD);

  insert into DOC_HEAD$INT(ID_DOC_HEAD, ID_DOC_TYPE, DOC_SUB_TYPE, ID_ACCOUNT, DOC_DATE,
         DOC_CURRENCY, DOC_RATE, DOC_ACC_RATE, DOC_TYPE_NAME,
         DOC_VALUE, DOC_VALUE_A, DOC_NET_VALUE, DOC_VALUE_ROUNDLESS, ID_BASE_DOC, FOR_DEPOSIT,
         IS_STORNO, IS_STORNED, IS_ANUL,SECOND_CURRENCY, SECOND_CURR_RATE, SECOND_CURR_NET_VALUE, SECOND_CURR_GROSS_VALUE, ID_DOC_NUM)
  values (:id_doc_head, :id_doc_type, 0, :id_account, :DOC_DATE,
         :DOC_CURR, :doc_curr_rate, cast(:doc_curr_rate/:acc_curr_rate as double precision), :DOC_TYPE_NAME,
         0, 0, 0, 0, :id_base_doc, iif(:ID_ADVANCE_PAYMENT is null,  0, 1),
         0, 0, 0, :second_currency, :sec_curr_rate, iif(:second_currency is null, null, 0), iif(:second_currency is null, null, 0), :id_doc_num);

  if (:IS_PROFORMA is distinct from 1) then begin
    id_sale_num = null;
    if (:ID_BASE_DOC <> :ID_DOC_HEAD) then begin
      select d.ID_SALE_NUM
      from   DOC_HEAD d
      where  d.ID_DOC = :ID_BASE_DOC
      into   :id_sale_num;
    end
    execute procedure DOCUMENT_COMPLETE$INT (:ID_DOC_HEAD, :DOC_DATE, :TAX_EVENT_DATE, null, :id_sale_num);
  end

  if (:ID_ADVANCE_PAYMENT is null) then begin
    execute procedure DOCUMENT_ADD_SERVICES$INT (:ID_DOC_HEAD, :ID_ACCOUNT);

    execute procedure DOCUMENT_ADD_DISCOUNTS$INT(:ID_DOC_HEAD, :ID_ACCOUNT);

  end else begin
    execute procedure DOCUMENT_ADVANCE_PAYMENT$INT (:ID_DOC_HEAD, :ID_ADVANCE_PAYMENT, :acc_curr_rate);
  end

  execute procedure DOCUMENT_SAVE_TOTAL$INT (:ID_DOC_HEAD)
  returning_values :DOC_SUB_TYPE;

end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_REUSE_DEPOSITS$INT for: DOCUMENT_DETACH_DEPOSIT$INT */
ALTER PROCEDURE DOCUMENT_REUSE_DEPOSITS$INT(OLD_ID_DOC_HEAD INTEGER,
NEW_ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (DOCUMENT_DETACH_DEPOSIT$INT) */
ALTER PROCEDURE DOCUMENT_DETACH_DEPOSIT$INT(ID_DOC_HEAD INTEGER,
ID_DEPOSIT INTEGER,
ID_STORNO_DOC INTEGER = null)
 AS
declare variable id_doc_line integer;
  declare variable id_payment_head integer;
  declare variable is_anul integer;
  declare variable num integer;
  declare variable id_account_payment integer;
  declare variable is_storned integer;
  declare variable no_use varchar(255);
  declare variable pay_amount numeric(15,4);
  declare variable doc_amount double precision;
  declare variable pay_rate double precision;
  declare variable equal_pay_doc_rate double precision;
begin

  select D.ID_PAYMENT_HEAD, DH.IS_ANUL, DH.IS_STORNED, Dh.NUM
  from   DEPOSIT_DEDUCT D
         join DOC_HEAD DH on DH.ID_DOC = D.ID_DOC_USED
         join ACCOUNT A on A.ID_ACCOUNT = DH.ID_ACCOUNT
  where  D.ID_DEPOSIT = :ID_DEPOSIT
         and D.ID_DOC_USED = :ID_DOC_HEAD
  into   :id_payment_head, :is_anul, :is_storned, :num;

  if (:id_payment_head is null) then exit;

  if (:is_anul + :is_storned = 0) then begin
    /* in internal deposit detach, caused by changes on new document processing */
    if (:num is not null) then exception INTERNAL_DOC_EXCEPTION 'Cannot detach deposit from valid document!';

    for
      select ap.ID_ACCOUNT_PAYMENT
      from   ACCOUNT_PAYMENTS AP
             join DOC_PAY_USAGE DP on DP.ID_ACCOUNT_PAYMENT = ap.ID_ACCOUNT_PAYMENT
      where  dp.ID_DOC_HEAD = :ID_DOC_HEAD
             and ap.ID_DEPOSIT = :ID_DEPOSIT
      into   :id_account_payment
    do begin
      delete
      from    DOC_PAY_USAGE dp
      where   dp.ID_ACCOUNT_PAYMENT = :ID_ACCOUNT_PAYMENT
              and dp.ID_DOC_HEAD = :ID_DOC_HEAD;
    end

    if (:ID_DOC_HEAD > 0) then begin
      /* if id_doc_head is negative then it will be deleted after deposit detach */
      /* total update is needless in this case                                   */
      ID_DOC_LINE = null;
      select DL.ID_DOC_LINE
      from   DOC_LINE DL
             join DOC_LINE_DEP_VALUES DV on DV.ID_DOC_LINE = DL.ID_DOC_LINE
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
             and DV.ID_DEPOSIT = :ID_DEPOSIT
      into   :ID_DOC_LINE;
    
      if (:ID_DOC_LINE is not null) then begin
        delete from DOC_LINE DL
        where  DL.ID_DOC_LINE = :ID_DOC_LINE;
    
        execute procedure DOCUMENT_SAVE_TOTAL$INT (:ID_DOC_HEAD)
        returning_values :no_use;
      end
    end
  end else if (:is_storned = 1) then begin
    /* in case when document is storned */
    for
      select dp.ID_ACCOUNT_PAYMENT, -dp.PAY_AMOUNT, dp.PAY_RATE, -dp.DOC_AMOUNT, dp.EQUAL_PAY_DOC_RATE
      from   DOC_PAY_USAGE DP
             join ACCOUNT_PAYMENTS AP on AP.ID_ACCOUNT_PAYMENT = dp.ID_ACCOUNT_PAYMENT
      where  DP.ID_DOC_HEAD = :ID_DOC_HEAD
             and ap.ID_DEPOSIT = :ID_DEPOSIT
      into   :id_account_payment, :pay_amount, :pay_rate, :doc_amount, :equal_pay_doc_rate
    do begin
      update DOC_PAY_USAGE p
      set    p.PAY_AMOUNT = p.PAY_AMOUNT + :pay_amount,
             p.DOC_AMOUNT = p.DOC_AMOUNT + :doc_amount
      where  p.ID_DOC_HEAD = :ID_STORNO_DOC
             and p.ID_ACCOUNT_PAYMENT = :id_account_payment;

      if (row_count = 0) then begin
        insert into DOC_PAY_USAGE (ID_DOC_HEAD, ID_ACCOUNT_PAYMENT, PAY_AMOUNT, PAY_RATE, DOC_AMOUNT, EQUAL_PAY_DOC_RATE)
        values (:ID_STORNO_DOC, :id_account_payment, :pay_amount, :pay_rate, :doc_amount, :equal_pay_doc_rate);
      end
    end
  end
end
^

/* Alter (DOCUMENT_ON_PROFORMA_INIT$DOC) */
ALTER PROCEDURE DOCUMENT_ON_PROFORMA_INIT$DOC(ID_PROFORMA_DOC TYPE OF ID)
 RETURNS(ID_DOC_HEAD TYPE OF ID,
ID_HOTEL TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
REQUIRE_ARCHIVE_CONFIRMATION TYPE OF TLOGICAL)
 AS
declare variable id_account_post id_ref;
  declare variable id_base_doc integer;
  declare variable id_doc_num integer;
  declare variable doc_date date;
  declare variable no_use varchar(255);
  declare variable proforma_date date;
  declare variable proforma_exp_date date;
  declare variable doc_type_name varchar(50);
  declare variable closing_whole_account smallint;
  declare variable is_credit_account smallint;
  declare variable chk_out_date date;
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_NOPAY_CREATE');

  REQUIRE_ARCHIVE_CONFIRMATION = -1;
  chk_out_date = null;

  select dt.ID_DOC_NUM, a.ID_HOTEL, a.ID_ACCOUNT, d.PROFORMA_EXP_DATE, d.DOC_DATE,
         dt.DOC_TYPE_NAME, a.IS_CREDIT_ACCOUNT, rd.TO_DATE
  from   DOC_PROFORMA d
         join DOC_TYPE dt on dt.ID_DOC_TYPE = d.ID_DOC_TYPE
         join ACCOUNT a on a.ID_ACCOUNT = d.ID_ACCOUNT
         left outer join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = a.ID_RESERV_DETAIL
  where  d.ID_DOC = :ID_PROFORMA_DOC
  into   :id_doc_num, :id_hotel, :id_account, :proforma_exp_date, :proforma_date,
         :doc_type_name, :is_credit_account, :chk_out_date;

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :doc_date;

  if (:proforma_exp_date < :doc_date) then exception DOCUMENT_EXCEPTION '-394';

  if (exists (select d.ID_DOC_HEAD
              from   DOC_HEAD$INT d
                     join  DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
              where  dc.ID_DOC_PROFORMA = :ID_PROFORMA_DOC
                     and d.IS_ANUL = 0)) then exception DOCUMENT_EXCEPTION '-396';

  execute procedure DOCUMENT_DRAFT_COPY$INT (:ID_PROFORMA_DOC, :doc_date)
  returning_values (:ID_DOC_HEAD);

  for
    select dp.ID_ACCOUNT_POST
    from   DOC_LINE dl
           join DOC_LINE_POST_VALUES dp on dp.ID_DOC_LINE = dl.ID_DOC_LINE
    where  dl.ID_DOC_HEAD = :ID_PROFORMA_DOC
    into   :id_account_post
  do begin
    update ACCOUNT_POST ap
    set    ap.DOC_SELECTED = :ID_DOC_HEAD
    where  ap.ID_ACCOUNT_POST = :id_account_post;
  end 

  execute procedure DOCUMENT_CHECK_SELECTION$INT (:ID_DOC_HEAD, :id_account)
  returning_values  (:no_use, :id_base_doc, :no_use, :no_use, :no_use, :closing_whole_account);

  if (:id_base_doc is not null) then
    exception DOCUMENT_EXCEPTION '-395';

  execute procedure CURR_RATES_PREPARE$INT (:ID_DOC_HEAD, :id_account, :proforma_date);

  execute procedure DOCUMENT_COMPLETE$INT (:ID_DOC_HEAD, :doc_date, :doc_date, :ID_PROFORMA_DOC);

  update DOC_HEAD$INT d
  set    d.DOC_TYPE_NAME = :doc_type_name,
         d.ID_DOC_NUM = :id_doc_num
  where  d.ID_DOC_HEAD = :ID_DOC_HEAD;

  if (:closing_whole_account = 1 and :is_credit_account is distinct from 1) then begin
    if ((:chk_out_date is null) or (:doc_date >= :chk_out_date)) then
      REQUIRE_ARCHIVE_CONFIRMATION = 1;
    else
      REQUIRE_ARCHIVE_CONFIRMATION = 0;
  end
end
^

/* Alter (DOCUMENT_PAY_TYPES) */
ALTER PROCEDURE DOCUMENT_PAY_TYPES(ID_DOC_HEAD INTEGER)
 RETURNS(PAY_TYPE_LIST VARCHAR(255),
PAY_TYPE_IDS VARCHAR(255))
 AS
declare variable pay_type varchar(50);
  declare variable id_pay_type integer;
begin
  PAY_TYPE_LIST = '';
  PAY_TYPE_IDS = '';
  for
    select distinct p.ID_PAYMENT_TYPE, PT.PAYMENT_TYPE
    from   DOCUMENT_PAYMENT p
           join PAYMENT_TYPE PT on PT.ID_PAYMENT_TYPE = P.ID_PAYMENT_TYPE
    where  P.ID_DOC_HEAD = :ID_DOC_HEAD
    into   :id_pay_type, :pay_type
  do begin
    PAY_TYPE_LIST = :PAY_TYPE_LIST || trim(iif(:PAY_TYPE_LIST <> '', ',', '')) || ' ' || :pay_type;
    PAY_TYPE_IDS = :PAY_TYPE_IDS || trim(iif(:PAY_TYPE_IDS <> '', ',', '')) || :id_pay_type;
  end 
  suspend;
end
^

/* Alter (DOCUMENT_PAYMENTS_CLEAR$DOC) */
ALTER PROCEDURE DOCUMENT_PAYMENTS_CLEAR$DOC(ID_DOC_HEAD INTEGER)
 AS
declare variable id_payment_head integer;
  declare variable is_storno integer;
  declare variable storno_cnt integer;
  declare variable dbkey char(8);
begin

  storno_cnt = 0;
  for
    select P.ID_PAYMENT_HEAD, P.IS_STORNO
    from   PAYMENT_HEAD P
    where  P.ID_DOC_HEAD = :ID_DOC_HEAD
    into   :id_payment_head, :is_storno
  do begin
    execute procedure DOCUMENT_REMOVE_PAYMENT$DOC (:id_payment_head);

    storno_cnt = :storno_cnt + :is_storno;
  end 

  if (:storno_cnt > 0) then begin
    for
      select P.RDB$DB_KEY, P.ID_PAYMENT_HEAD
      from   DOC_HEAD STORNO_DOC
             join DOC_HEAD D on D.ID_BASE_DOC = STORNO_DOC.ID_BASE_DOC
             join PAYMENT_HEAD P on P.ID_DOC_HEAD = D.ID_DOC
      where  STORNO_DOC.ID_DOC = :ID_DOC_HEAD
      into   :dbkey, :id_payment_head
    do begin
      update PAYMENT_HEAD PH
      set    PH.IS_STORNED = 0
      where  PH.RDB$DB_KEY = :dbkey;
    end
  end
end
^

/* Alter (DOCUMENT_REMOVE_PAYMENT$DOC) */
ALTER PROCEDURE DOCUMENT_REMOVE_PAYMENT$DOC(ID_PAYMENT_HEAD INTEGER)
 AS
declare variable id_doc_head integer;
  declare variable is_taxable integer;
  declare variable id_doc_line integer;
  declare variable doc_num varchar(20);
  declare variable id_payment_storned integer;
  declare variable no_use varchar(255);
begin
  doc_num = null;
  select d.ID_DOC, d.DOC_NUM, p.ID_PAYMENT_STORNED
  from   DOC_HEAD D
         join PAYMENT_HEAD P on P.ID_DOC_HEAD = d.ID_DOC
  where  p.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  into   :id_doc_head, :doc_num, :id_payment_storned;
  if (:doc_num is not null) then exception PAYMENT_EXCEPTION 'Can not delete payment from valid document!';

  is_taxable = 0;
  for
    select pf.ID_DOC_LINE
    from   PAYMENT_FOOTER PF
    where  PF.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
    into   :id_doc_line
  do begin
    delete from DOC_LINE DL
    where  DL.ID_DOC_LINE = :id_doc_line;

    is_taxable = 1;
  end 

  if (:is_taxable = 1) then
    execute procedure DOCUMENT_SAVE_TOTAL$INT (:id_doc_head)
    returning_values :no_use;

  delete from PAYMENT_HEAD P
  where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;

  update PAYMENT_HEAD SP
  set    sp.IS_STORNED = 0
  where  sp.ID_PAYMENT_HEAD = :id_payment_storned;

end
^

/* Alter (DOCUMENT_RESET_TYPE$DOC) */
ALTER PROCEDURE DOCUMENT_RESET_TYPE$DOC(ID_DOC_HEAD INTEGER,
ID_DOC_TYPE INTEGER,
DOC_CURRENCY VARCHAR(3),
PROFORMA_NAME_PREFIX VARCHAR(30))
 AS
declare variable id_account integer;
  declare variable old_id_doc_type integer;
  declare variable id_doc_contragent integer;
  declare variable id_doc_supplier integer;
  declare variable is_deposit integer;
  declare variable old_doc_curr varchar(3);
  declare variable doc_date date;
  declare variable tax_event_date date;
  declare variable id_base_doc integer;
  declare variable dbg varchar(1000);
  declare variable d_dbkey char(8);
  declare variable bonuspoints integer;
  declare variable id_advance_payment integer;
  declare variable id_payment_head integer;
  declare variable id_hotel integer;
  declare variable is_proforma tlogical;
  declare variable doc_type_name varchar(50);
  declare variable doc_sub_type smallint;
begin
  is_proforma = iif(:PROFORMA_NAME_PREFIX is null, 0, 1);

  select D.ID_ACCOUNT, D.ID_DOC_TYPE, D.ID_DOC_CONTRAGENT, D.ID_DOC_SUPPLIER,
         D.FOR_DEPOSIT, D.DOC_CURRENCY, D.DOC_DATE, DC.TAX_EVENT_DATE,
         D.ID_BASE_DOC, D.RDB$DB_KEY, a.ID_HOTEL, d.DOC_SUB_TYPE
  from   DOC_HEAD$INT D
         join ACCOUNT A on a.ID_ACCOUNT = d.ID_ACCOUNT
         left outer join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :id_account, :old_id_doc_type, :id_doc_contragent, :id_doc_supplier,
         :is_deposit, :old_doc_curr, :doc_date, :tax_event_date,
         :id_base_doc, :d_dbkey, :id_hotel, :doc_sub_type;
  /***************/
  if (:doc_sub_type > 0) then exit; -- can't change type for credit or debit document
  /***************/
  if ((:old_id_doc_type <> :ID_DOC_TYPE) or (:old_doc_curr <> :DOC_CURRENCY)) then begin
    for
      select p.ID_PAYMENT_HEAD
      from   PAYMENT_HEAD p
      where  p.ID_DOC_HEAD = :ID_DOC_HEAD
      into   :id_payment_head
    do begin
      execute procedure DOC_TYPE_EVALUATE$INT (:ID_DOC_TYPE, :id_hotel, :is_proforma, :id_payment_head);
    end

    id_advance_payment = null;
    if (:is_deposit = 1) then begin
      select first 1 p.ID_PAYMENT_HEAD
      from   PAYMENT_HEAD p
      where  p.ID_DOC_HEAD = :ID_DOC_HEAD
      into   :id_advance_payment;

      update PAYMENT_HEAD DP
      set    DP.ID_DOC_HEAD = null
      where  DP.ID_DOC_HEAD = :ID_DOC_HEAD;
    end
    /* update old document with reverse ID, to be deleted on the end */
    update DOC_HEAD$INT OD
    set    OD.ID_DOC_HEAD = -OD.ID_DOC_HEAD
    where  OD.RDB$DB_KEY = :d_dbkey;
    /* recreate document */
    select iif (:is_proforma = 1, substring(trim(:PROFORMA_NAME_PREFIX) || ' ' || dt.doc_type_name from 1 for 50), dt.DOC_TYPE_NAME)
    from   DOC_TYPE dt
    where  dt.ID_DOC_TYPE = :ID_DOC_TYPE
    into   :doc_type_name;

    execute procedure DOCUMENT_CREATE$INT (:ID_DOC_HEAD, :id_account, :ID_DOC_TYPE,
            :doc_type_name, :doc_date, :DOC_CURRENCY, :id_base_doc, :tax_event_date, :is_proforma, :id_advance_payment)
    returning_values  (:dbg, :dbg);
    /* reuse bonuspoints discounts */
    for
      select DF.TAXABLE_VALUE
      from   DOC_FOOTER DF
      where  DF.ID_DOC_HEAD = -:ID_DOC_HEAD
             and DF.ID_TAX is null
      into   :bonuspoints
    do begin
      execute procedure DOCUMENT_BONUSPOINTS_SPEND (:ID_DOC_HEAD, :bonuspoints)
      returning_values (:dbg);
    end 
    /* reuse deposits and payments */
    if (:is_deposit = 0) then begin
      execute procedure DOCUMENT_REUSE_DEPOSITS$INT (-:ID_DOC_HEAD, :ID_DOC_HEAD);

      execute procedure DOCUMENT_REUSE_PAYMENTS$INT (-:ID_DOC_HEAD, :ID_DOC_HEAD);
    end
    /* get client and sipplier data */
    update DOC_HEAD$INT D
    set    D.ID_DOC_CONTRAGENT = :id_doc_contragent,
           D.ID_DOC_SUPPLIER = :id_doc_supplier
    where  D.ID_DOC_HEAD = :ID_DOC_HEAD;
    /* delete old document */
    delete from DOC_HEAD$INT D
    where  D.ID_DOC_HEAD = -:ID_DOC_HEAD;
    /*  */
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_CLEAR_DEPOSITS$DOC for: DOCUMENT_REUSE_DEPOSITS$INT */
ALTER PROCEDURE DOCUMENT_CLEAR_DEPOSITS$DOC(ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (DOCUMENT_REUSE_DEPOSITS$INT) */
ALTER PROCEDURE DOCUMENT_REUSE_DEPOSITS$INT(OLD_ID_DOC_HEAD INTEGER,
NEW_ID_DOC_HEAD INTEGER)
 AS
declare variable ID_DEPOSIT integer;
declare variable DEPOSIT_AMOUNT numeric(15,4);
begin

  for
    select  D.ID_DEPOSIT, sum(D.USED_PAY_VALUE)
    from    DEPOSIT_DEDUCT D
    where   D.ID_DOC_USED = :OLD_ID_DOC_HEAD
    group by D.ID_DEPOSIT
    into    :ID_DEPOSIT, :DEPOSIT_AMOUNT
  do begin
    execute procedure DOCUMENT_DETACH_DEPOSIT$INT (:OLD_ID_DOC_HEAD, :ID_DEPOSIT);

    if (:NEW_ID_DOC_HEAD is not null) then begin
      execute procedure DOCUMENT_USE_DEPOSIT$DOC (:NEW_ID_DOC_HEAD, :ID_DEPOSIT, :DEPOSIT_AMOUNT);

      when exception DOCUMENT_EXCEPTION do post_event 'dummy';
    end
  end

end
^

/* Alter (DOCUMENT_REUSE_PAYMENTS$INT) */
ALTER PROCEDURE DOCUMENT_REUSE_PAYMENTS$INT(OLD_ID_DOC_HEAD INTEGER,
NEW_ID_DOC_HEAD INTEGER)
 AS
declare variable id_payment_head integer;
  declare variable id_account_payment integer;
  declare variable p_dbkey char(8);
  declare variable no_use varchar(255);
  declare variable pay_rate numeric(15,6);
begin
  for
    select AP.ID_ACCOUNT_PAYMENT, P.RDB$DB_KEY, ap.ID_PAYMENT_HEAD, p.PAY_RATE
    from   DOC_PAY_USAGE P
           join ACCOUNT_PAYMENTS AP on AP.ID_ACCOUNT_PAYMENT = p.ID_ACCOUNT_PAYMENT
    where  P.ID_DOC_HEAD = :OLD_ID_DOC_HEAD
    into   :id_account_payment, :p_dbkey, :id_payment_head, :pay_rate
  do begin
    delete from DOC_PAY_USAGE DP
    where  DP.RDB$DB_KEY = :p_dbkey;

    update PAYMENT_HEAD PH
    set    PH.ID_DOC_HEAD = :NEW_ID_DOC_HEAD
    where  PH.ID_PAYMENT_HEAD = :id_payment_head;
     
    execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:NEW_ID_DOC_HEAD, :id_account_payment, :pay_rate, null)
    returning_values :no_use;
  end 
end
^

/* Alter (DOCUMENT_SET_NUMBER$INT) */
ALTER PROCEDURE DOCUMENT_SET_NUMBER$INT(DH_DBKEY TYPE OF TDB_KEY)
 RETURNS(NUM TYPE OF TRANGE,
DOC_NUM VARCHAR(20))
 AS
declare variable id_doc_num integer;
  declare variable id_doc_completed integer;
  declare variable pay_dbkey char(8);
begin

  select D.ID_DOC_NUM, dc.ID_DOC_HEAD
  from   DOC_HEAD$INT D
         left outer join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
  where  D.RDB$DB_KEY = :DH_DBKEY
  into   :id_doc_num, :id_doc_completed;

  if (:id_doc_num is not null) then begin
    if (:id_doc_completed is not null) then begin
      execute procedure SYSTEM_GEN_NUM ('DOCUMENT', :id_doc_num)
      returning_values  (:num, :doc_num);
    end else begin
      execute procedure SYSTEM_GEN_NUM ('PROFORMA', :id_doc_num)
      returning_values  (:num, :doc_num);
    end

    update DOC_HEAD$INT D
    set    D.NUM = :num,
           D.DOC_NUM = :doc_num,
           d.DATETIME_CREATED = current_timestamp -- moves created_at to finalization timestamp
    where  D.RDB$DB_KEY = :DH_DBKEY;
  end

  for
    select PH.RDB$DB_KEY
    from   PAYMENT_HEAD PH
    where  PH.ID_DOC_HEAD = :id_doc_completed
           and PH.NUM is null  /* because of following deposit billing */
    into   :pay_dbkey
  do begin
    execute procedure PAYMENT_SET_NUMBER$INT (:pay_dbkey);
  end
end
^

/* Alter (DOCUMENT_STORNO$DOC) */
ALTER PROCEDURE DOCUMENT_STORNO$DOC(ID_DOC_HEAD INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_STORNO_DOC INTEGER,
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER,
WARN_CODE INTEGER)
 AS
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_STORN_WITHP');

  execute procedure DOCUMENT_STORNO$INT (:ID_DOC_HEAD, :DESCRIPTION, 1)
  returning_values  (:ID_STORNO_DOC, :ID_HOTEL, :WARN_CODE);

  select D.ID_ACCOUNT
  from   DOC_HEAD D
  where  D.ID_DOC = :id_storno_doc
  into   :id_account;

  execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :ID_DOC_HEAD, 'STORNO', f_character(29)||:DESCRIPTION);

end
^

/* Alter (DOCUMENT_STORNO$INT) */
ALTER PROCEDURE DOCUMENT_STORNO$INT(ID_DOC_HEAD INTEGER,
DESCRIPTION VARCHAR(100),
STORNO_PAYMENTS SMALLINT)
 RETURNS(ID_STORNO_DOC INTEGER,
ID_HOTEL INTEGER,
WARN_CODE INTEGER)
 AS
declare variable id_deposit integer;
  declare variable id_account integer;
  declare variable is_storned integer;
  declare variable is_anul integer;
  declare variable doc_sub_type integer;
  declare variable id_doc_line integer;
  declare variable new_id_doc_line integer;
  declare variable post_value numeric(15,4);
  declare variable doc_value_a numeric(15,4);
  declare variable doc_net_value numeric(15,4);
  declare variable line_value numeric(15,4);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable doc_date date;
  declare variable id_doc_supplier integer;
  declare variable id_doc_used integer;
  declare variable taxable_value numeric(15,4);
  declare variable second_curr_net_value numeric(15,4);
  declare variable second_curr_gross_value numeric(15,4);
  declare variable doc_value_roundless double precision;
  declare variable is_archive integer;
  declare variable id_sale_num integer;
begin
  WARN_CODE = null;

  select D.ID_ACCOUNT, D.IS_STORNED, D.DOC_SUB_TYPE, D.IS_ANUL,
         A.ID_RESERV_DETAIL, D.ID_DOC_SUPPLIER, A.ID_HOTEL, dt.is_archive, d.ID_SALE_NUM
  from   DOC_HEAD D
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join DOC_TYPE dt on dt.ID_DOC_TYPE = d.ID_DOC_TYPE
  where  D.ID_DOC = :ID_DOC_HEAD
  into   :ID_ACCOUNT, :IS_STORNED, :DOC_SUB_TYPE, :IS_ANUL,
         :ID_RESERV_DETAIL, :ID_DOC_SUPPLIER, :ID_HOTEL, :is_archive, :id_sale_num;

  if (:DOC_SUB_TYPE <> 0) then
    exception DOCUMENT_EXCEPTION '-316';
  if (:IS_ANUL = 1) then
    exception DOCUMENT_EXCEPTION '-352';
  if (:IS_STORNED = 1) then
    exception MULTIPLE_STORNO_ON_DOC;

  if (:is_archive = 1) then execute procedure SYSTEM_WARNING_ADD(-312, '') returning_values :WARN_CODE;

  execute procedure SYSTEM_DATE_GET(:ID_HOTEL)
  returning_values  (:DOC_DATE);

  ID_STORNO_DOC = gen_id(DOC_SELECTED_GEN, 1);

  execute procedure CURR_RATES_PREPARE$INT (:ID_STORNO_DOC, :ID_ACCOUNT, :DOC_DATE);

  execute procedure DOC_SUPPLIER_GET_COPY$DOC (:ID_DOC_SUPPLIER)
  returning_values  :ID_DOC_SUPPLIER;

  insert into DOC_HEAD$INT(ID_DOC_HEAD, ID_DOC_TYPE, DOC_SUB_TYPE, ID_ACCOUNT,
         DOC_CURRENCY, DOC_RATE, DOC_ACC_RATE, DOC_TYPE_NAME, ID_DOC_NUM, DOC_DATE,
         DOC_VALUE_A, DOC_VALUE, DOC_NET_VALUE, ID_BASE_DOC, FOR_DEPOSIT,
         ID_DOC_CONTRAGENT, ID_DOC_SUPPLIER, DESCRIPTION, IS_STORNO, TAXABLE_VALUE,
         SECOND_CURRENCY, SECOND_CURR_RATE, SECOND_CURR_NET_VALUE, SECOND_CURR_GROSS_VALUE, DOC_VALUE_ROUNDLESS)
  select :ID_STORNO_DOC, D.ID_DOC_TYPE, 2, D.ID_ACCOUNT,
         D.DOC_CURRENCY, D.DOC_RATE, D.DOC_ACC_RATE, DT.CREDIT_DOC_NAME, ID_DOC_NUM, :doc_date,
         0, D.DOC_VALUE, d.DOC_NET_VALUE, D.ID_BASE_DOC, D.FOR_DEPOSIT,
         D.ID_DOC_CONTRAGENT, :ID_DOC_SUPPLIER, :DESCRIPTION, 1, D.TAXABLE_VALUE,
         d.SECOND_CURRENCY, d.SECOND_CURR_RATE, d.SECOND_CURR_NET_VALUE, d.SECOND_CURR_GROSS_VALUE, d.DOC_VALUE_ROUNDLESS
  from   DOC_HEAD$INT D
         join DOC_TYPE_INV DT on DT.ID_DOC_TYPE = D.ID_DOC_TYPE
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD;

  execute procedure DOCUMENT_COMPLETE$INT (:ID_STORNO_DOC, :DOC_DATE, :doc_date, null, :id_sale_num);

  /* doc lines */
  POST_VALUE = 0;
  DOC_VALUE_A = 0;
  for
    select DL.ID_DOC_LINE, -(DL.SINGLE_VALUE * DL.QTY_POST)
    from   DOC_HEAD BD
           join DOC_LINE DL on BD.ID_DOC = DL.ID_DOC_HEAD
    where  BD.ID_BASE_DOC = :ID_DOC_HEAD
           and BD.IS_ANUL = 0
           and DL.ID_DOC_HEAD is distinct from :ID_STORNO_DOC
    order by DL.ID_DOC_LINE asc
    into   :ID_DOC_LINE, :LINE_VALUE
  do begin
    NEW_ID_DOC_LINE = gen_id(G_AUTO_INC_DOC_LINES, 1);
    insert into DOC_LINE(ID_DOC_LINE, ID_DOC_HEAD, DATE_POST, LINE_NAME,
           ID_SERVICE, QTY_POST, TO_DATE, FROM_DATE, VAT_PERCENT, ID_SALE_TAXATION,
           SINGLE_VALUE, SINGLE_WOT_VAT, WOT_VAT, WOT_DIFF,
           TAX_STATUS, IS_CORRECT, GROUP_TAG,
           ID_GUEST, ROOM_NAME, NAT_NET_VALUE, NAT_GROSS_VALUE, SEC_CURR_NET_VALUE, SEC_CURR_GROSS_VALUE)
    select :NEW_ID_DOC_LINE, :ID_STORNO_DOC, DL.DATE_POST, DL.LINE_NAME,
           DL.ID_SERVICE, DL.QTY_POST*(2*DL.IS_CORRECT-1), DL.TO_DATE, DL.FROM_DATE, DL.VAT_PERCENT, DL.ID_SALE_TAXATION,
           DL.SINGLE_VALUE*(1-2*DL.IS_CORRECT), DL.SINGLE_WOT_VAT*(1-2*DL.IS_CORRECT), -DL.WOT_VAT, DL.WOT_DIFF*(1-2*DL.IS_CORRECT),
           DL.TAX_STATUS, DL.IS_CORRECT, DL.GROUP_TAG,
           DL.ID_GUEST, DL.ROOM_NAME, -DL.NAT_NET_VALUE, -DL.NAT_GROSS_VALUE, -DL.SEC_CURR_NET_VALUE, -DL.SEC_CURR_GROSS_VALUE
    from   DOC_LINE DL
    where  DL.ID_DOC_LINE = :ID_DOC_LINE;

    insert into DOC_LINE_DISCOUNTED (ID_DOC_LINE, ID_DOC_DISCOUNT)
    select :NEW_ID_DOC_LINE, DLT.ID_DOC_DISCOUNT
    from   DOC_LINE_DISCOUNTED DLT
    where  DLT.ID_DOC_LINE = :ID_DOC_LINE;

    insert into DOC_LINE_POST_VALUES (
           ID_DOC_LINE, ID_ACCOUNT_POST,POST_RATE_IN_ACC, POST_RATE_IN_DOC,
           NET_RATE_DIFF, GROSS_RATE_DIFF, NET_ROUND_DIFF, GROSS_ROUND_DIFF,
           ID_MASTER_ADDINS, ID_PACK_SERVICE, IS_BASE, ACCOUNT_PRICE)
    select :NEW_ID_DOC_LINE, ID_ACCOUNT_POST, POST_RATE_IN_ACC, POST_RATE_IN_DOC,
           -NET_RATE_DIFF, -GROSS_RATE_DIFF, -NET_ROUND_DIFF, -GROSS_ROUND_DIFF,
           ID_MASTER_ADDINS, ID_PACK_SERVICE, IS_BASE, ACCOUNT_PRICE
    from   DOC_LINE_POST_VALUES PV
    where  PV.ID_DOC_LINE = :ID_DOC_LINE;

    if (row_count = 1) then POST_VALUE = :POST_VALUE + :LINE_VALUE;

    insert into DOC_LINE_DEP_VALUES (
           ID_DOC_LINE, DEP_RATE_IN_ACC, DEP_RATE_IN_DOC, ID_DEPOSIT)
    select :NEW_ID_DOC_LINE, DEP_RATE_IN_ACC, DEP_RATE_IN_DOC, ID_DEPOSIT
    from   DOC_LINE_DEP_VALUES DV
    where  DV.ID_DOC_LINE = :ID_DOC_LINE;

    insert into DOC_LINE_REV_DEDUCTION_TAX (ID_DOC_LINE, ID_SALE_TAX, TAX_NAME, TAX_UNIT, TAX_VALUE, NAT_TAX_VALUE)
    select :NEW_ID_DOC_LINE, rdt.ID_SALE_TAX, rdt.TAX_NAME, rdt.TAX_UNIT, -rdt.TAX_VALUE, -rdt.NAT_TAX_VALUE
    from   DOC_LINE_REV_DEDUCTION_TAX rdt
    where  rdt.ID_DOC_LINE = :id_doc_line;

    insert into DOC_FOOTER (
           ID_DOC_HEAD, ID_DOC_LINE, ID_TAX, TAX_ORDER, TAXABLE_VALUE, FOOTER_VALUE, DESCRIPTION,
           SECOND_CURR_DISCOUNTABLE_VALUE, SECOND_CURR_DISCOUNT_VALUE)
    select :ID_STORNO_DOC, :NEW_ID_DOC_LINE, ID_TAX, TAX_ORDER, -TAXABLE_VALUE, -DF.FOOTER_VALUE, DF.DESCRIPTION,
           -df.SECOND_CURR_DISCOUNTABLE_VALUE, -df.SECOND_CURR_DISCOUNT_VALUE
    from   DOC_FOOTER DF
    where  DF.ID_DOC_LINE = :ID_DOC_LINE;
    DOC_VALUE_A = :DOC_VALUE_A + :LINE_VALUE;
    /* payment footer lines ?!?!?!? */
  end
  /* totals */
  select -sum(d.DOC_VALUE), -sum(d.DOC_VALUE_A), -sum(d.DOC_VALUE_ROUNDLESS), -sum(d.TAXABLE_VALUE),
         -sum(d.DOC_NET_VALUE), -sum(d.SECOND_CURR_NET_VALUE), -sum(d.SECOND_CURR_GROSS_VALUE)
  from   DOC_HEAD$INT D
  where  D.ID_BASE_DOC = :ID_DOC_HEAD
         and D.IS_ANUL = 0
         and D.ID_DOC_HEAD is distinct from :ID_STORNO_DOC
  into   :POST_VALUE, :DOC_VALUE_A, :doc_value_roundless, :taxable_value,
         :doc_net_value, :second_curr_net_value, :second_curr_gross_value;

  update DOC_HEAD$INT SD
  set    SD.DOC_VALUE = :POST_VALUE,
         SD.DOC_VALUE_A = :DOC_VALUE_A,
         SD.DOC_NET_VALUE = :doc_net_value,
         sd.DOC_VALUE_ROUNDLESS = :doc_value_roundless,
         sd.TAXABLE_VALUE = :taxable_value,
         sd.SECOND_CURR_NET_VALUE = :second_curr_net_value,
         sd.SECOND_CURR_GROSS_VALUE = :second_curr_gross_value
  where  SD.ID_DOC_HEAD = :ID_STORNO_DOC;

  insert into DOC_TAXES (ID_DOC_HEAD, ID_SALE_TAX, TAX_NAME, TAX_PERCENT, NONTAXABLE_VALUE, TAXABLE_VALUE, TAX_VALUE,
         TAXATION_REASON, SEC_CURR_NONTAXABLE_VALUE, SEC_CURR_TAXABLE_VALUE, SEC_CURR_TAX_VALUE)
  select :ID_STORNO_DOC, DT.ID_SALE_TAX, DT.TAX_NAME, DT.TAX_PERCENT, -sum(DT.NONTAXABLE_VALUE), -sum(DT.TAXABLE_VALUE), -sum(DT.TAX_VALUE),
         DT.TAXATION_REASON, -sum(dt.SEC_CURR_NONTAXABLE_VALUE), -sum(dt.SEC_CURR_TAXABLE_VALUE), -sum(dt.SEC_CURR_TAX_VALUE)
  from   DOC_HEAD D
         join DOC_TAXES DT on DT.ID_DOC_HEAD = D.ID_DOC
  where  D.ID_BASE_DOC = :ID_DOC_HEAD
         and D.IS_ANUL = 0
         and D.ID_DOC is distinct from :ID_STORNO_DOC
  group by DT.ID_SALE_TAX, DT.TAX_NAME, DT.TAX_PERCENT, DT.TAXATION_REASON;

  update DOC_HEAD$INT D
  set    D.IS_STORNED = 1
  where  D.ID_BASE_DOC = :ID_DOC_HEAD
         -- and D.ID_DOC is distinct from :ID_STORNO_DOC
         and d.IS_STORNO = 0 -- and d.DOC_SUB_TYPE < 2 -- Bug 5672#c42 !!!?
         and D.IS_ANUL = 0;

  /* discounts */
  insert into DOC_FOOTER (ID_DOC_HEAD, ID_TAX, ID_DOC_LINE, TAX_ORDER, DESCRIPTION,
         TAXABLE_VALUE, FOOTER_VALUE, SECOND_CURR_DISCOUNTABLE_VALUE, SECOND_CURR_DISCOUNT_VALUE)
  select :ID_STORNO_DOC, DF.ID_TAX, null, DF.TAX_ORDER, DF.DESCRIPTION,
         sum(-DF.TAXABLE_VALUE), sum(-DF.FOOTER_VALUE), sum(-df.SECOND_CURR_DISCOUNTABLE_VALUE), sum(-df.SECOND_CURR_DISCOUNT_VALUE)
  from   DOC_HEAD D
         join DOC_FOOTER DF on DF.ID_DOC_HEAD = D.ID_DOC
  where  DF.ID_DOC_HEAD = :ID_DOC_HEAD
         and DF.ID_DOC_LINE is null
  group by DF.ID_TAX, DF.DESCRIPTION, DF.TAX_ORDER;

  /* storno payments */
  if (:STORNO_PAYMENTS = 1/* and :for_deposit = 0*/) then begin
    execute procedure DOCUMENT_STORNO_PAYS_SET$DOC (:ID_STORNO_DOC);

    /* free deposits */
    for
      select D.ID_DEPOSIT, d.ID_DOC_USED
      from   DEPOSIT_DEDUCT D
             join DOC_HEAD dh on dh.ID_DOC = d.ID_DOC_USED
      where  ((Dh.ID_BASE_DOC = :ID_DOC_HEAD) or (dh.ID_DOC = :ID_DOC_HEAD))
             and dh.ID_DOC is distinct from :ID_STORNO_DOC
      into   :ID_DEPOSIT, :id_doc_used
    do begin
      execute procedure DOCUMENT_DETACH_DEPOSIT$INT (:id_doc_used, :id_deposit, :ID_STORNO_DOC);
    end
  end

  if (:ID_RESERV_DETAIL is not null) then begin
    select RD.CHECK_STATUS
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :CHECK_STATUS;

    if (:CHECK_STATUS = 1) then begin
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, null, 1);
    end
  end

end
^

/* Alter (DOCUMENT_STORNO_PAYS_SET$DOC) */
ALTER PROCEDURE DOCUMENT_STORNO_PAYS_SET$DOC(ID_STORNO_DOC INTEGER)
 AS
declare variable id_account integer;
  declare variable id_payment_head integer;
  declare variable id_storned_doc integer;
  declare variable description varchar(100);
  declare variable id_storno_payment integer;
  declare variable storno_amount numeric(15,4);
  declare variable doc_amount numeric(15,4);
begin
  execute procedure DOCUMENT_PAYMENTS_CLEAR$DOC (:ID_STORNO_DOC);

  select D.ID_BASE_DOC, D.DESCRIPTION
  from   DOC_HEAD D
  where  D.ID_DOC = :ID_STORNO_DOC
  into   :id_storned_doc, :description;
   
  for
    select P.ID_PAYMENT_HEAD, BD.ID_ACCOUNT, sum(dp.PAY_AMOUNT), sum(dp.DOC_AMOUNT)
    from   DOC_HEAD BD
           join PAYMENT_HEAD P on P.ID_DOC_HEAD = BD.ID_DOC
           join ACCOUNT_PAYMENTS AP on AP.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
           join DOC_PAY_USAGE DP on dp.ID_ACCOUNT_PAYMENT = ap.ID_ACCOUNT_PAYMENT
                                   and dp.ID_DOC_HEAD = bd.ID_DOC
    where  BD.ID_BASE_DOC = :id_storned_doc
           and P.IS_STORNED = 0
           and P.IS_STORNO = 0
           and P.IS_ANUL = 0
    group by 1, 2
    into   :id_payment_head, :id_account, :storno_amount, :doc_amount
  do begin
    select :storno_amount + coalesce(sum(sdp.PAY_AMOUNT), 0),
           :doc_amount + coalesce(sum(sdp.DOC_AMOUNT), 0)
    from   PAYMENT_HEAD SP
           join ACCOUNT_PAYMENTS sap on sap.ID_PAYMENT_HEAD = sp.ID_PAYMENT_HEAD
           join DOC_PAY_USAGE sdp on sdp.ID_ACCOUNT_PAYMENT = sap.ID_ACCOUNT_PAYMENT
    where  sp.ID_PAYMENT_STORNED = :id_payment_head
           and sp.IS_ANUL = 0
    into   :storno_amount, :doc_amount;

    execute procedure PAYMENT_STORNO$INT (:id_payment_head, :id_account, :ID_STORNO_DOC, :storno_amount, :DESCRIPTION, :doc_amount)
    returning_values  (:id_storno_payment);

  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ATTACH_AVAIL_PAYS$INT for: DOCUMENT_USE_DEPOSIT$DOC */
ALTER PROCEDURE DOCUMENT_ATTACH_AVAIL_PAYS$INT(ID_DOC_HEAD INTEGER,
ID_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (DOCUMENT_USE_DEPOSIT$DOC) */
ALTER PROCEDURE DOCUMENT_USE_DEPOSIT$DOC(ID_DOC_HEAD INTEGER,
ID_DEPOSIT INTEGER,
DEPOSIT_AMOUNT NUMERIC(15,4))
 AS
declare variable id_deposit_doc integer;
  declare variable id_dep_doc_type integer;
  declare variable id_new_doc_type integer;
  declare variable id_dep_taxation integer;
  declare variable dep_doc_curr varchar(3);
  declare variable new_doc_curr varchar(3);
  declare variable pay_curr varchar(3);
  declare variable deposit_doc_value numeric(15,4);
  declare variable id_doc_line integer;
  declare variable doc_round_to numeric(15,4);
  declare variable pay_round_to numeric(15,4);
  declare variable pay_rate numeric(15,6);
  declare variable doc_sub_type integer;
  declare variable id_account_payment integer;
  declare variable service_amount numeric(15,4);
begin
  ID_DEPOSIT_DOC = null;
  select DH.DOC_SUB_TYPE
  from   DOC_HEAD DH
  where  DH.ID_DOC = :ID_DOC_HEAD
  into   :doc_sub_type;
   
  if (:doc_sub_type = 2) then exception DOCUMENT_EXCEPTION '-372';  /* Can not use deposit into credit doc */
  /*  */
  execute procedure DOCUMENT_DETACH_DEPOSIT$INT (:ID_DOC_HEAD, :ID_DEPOSIT);

  select DH.ID_DOC, DH.ID_DOC_TYPE, DH.DOC_CURRENCY, ph.PAY_CURRENCY
  from   DEPOSIT D
         join PAYMENT_HEAD PH on PH.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
         left outer join DOC_HEAD DH on DH.ID_DOC = PH.ID_DOC_HEAD
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_deposit_doc, :id_dep_doc_type, :dep_doc_curr, :pay_curr;

  execute procedure DOCUMENT_CURR_RATE_GET$INT (:ID_DOC_HEAD, :pay_curr)
  returning_values (:pay_rate, :pay_round_to);
  /*********************************************************/
  if (round_f(:DEPOSIT_AMOUNT, :PAY_ROUND_TO) = 0) then exit;
  /*********************************************************/
  select first 1 AP.ID_ACCOUNT_PAYMENT
  from   ACCOUNT_PAYMENTS AP
  where  AP.ID_DEPOSIT = :ID_DEPOSIT
  order by ap.ID_ACCOUNT_PAYMENT asc
  into   :id_account_payment;

  execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:ID_DOC_HEAD, :id_account_payment, :pay_rate, :DEPOSIT_AMOUNT)
  returning_values :deposit_doc_value;
   
  if (:ID_DEPOSIT_DOC is not null) then begin
    select first 1 DDL.ID_SALE_TAXATION
    from   DOC_LINE DDL
           join DOC_LINE_DEP_VALUES DV on DV.ID_DOC_LINE = DDL.ID_DOC_LINE
    where  DDL.ID_DOC_HEAD = :ID_DEPOSIT_DOC
    into   :id_dep_taxation;
     
    select  D.ID_DOC_TYPE, D.DOC_CURRENCY, c.ROUND_TO
    from    DOC_HEAD D
            join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
            join CURRS c on c.CURR = d.DOC_CURRENCY
    where   D.ID_DOC = :ID_DOC_HEAD
    into    :id_new_doc_type, :new_doc_curr, :doc_round_to;

    if (not (:id_dep_doc_type = :id_new_doc_type and :dep_doc_curr = :new_doc_curr) ) then
       exception DOCUMENT_EXCEPTION '-374';

    select round_f(sum(dl.QTY_POST * dl.SINGLE_VALUE), :doc_round_to)
    from   DOC_LINE DL
           join SALE_TAXATION_TAX ST on ST.ID_SALE_TAXATION = DL.ID_SALE_TAXATION
           join SALE_TAXES t on t.ID_SALE_TAX = st.ID_SALE_TAX and t.REVENUE_DEDUCTION_TAX is distinct from 1
    where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
           and ST.ID_SALE_TAX in (select STT.ID_SALE_TAX
                                  from   SALE_TAXATION_TAX STT
                                         join SALE_TAXES t2 on t2.ID_SALE_TAX = stt.ID_SALE_TAX
                                                               and t2.REVENUE_DEDUCTION_TAX is distinct from 1
                                         where  STT.ID_SALE_TAXATION = :id_dep_taxation)
    into   :service_amount;

    if (coalesce(:service_amount, 0) < :deposit_doc_value) then
      exception DOCUMENT_EXCEPTION '-334' || f_character(31) || f_character(29) || formatfloat(:service_amount, 'F;0.00') || ' ' || :new_doc_curr;

    deposit_doc_value = -:deposit_doc_value; /* !!! Value should be NEGATIVE - to reduce document total amount */
    execute procedure DOCUMENT_ADD_PAYMENT_LINE$INT (:ID_DEPOSIT, :ID_DOC_HEAD, :deposit_doc_value, :id_dep_taxation)
    returning_values  (:id_doc_line);
  
    execute procedure DOCUMENT_SAVE_TOTAL$INT (:ID_DOC_HEAD)
    returning_values :doc_sub_type;
  end
end
^

/* Alter (EAI_EXT_POST_TO_FRONT_ONLINE) */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable ID_HOTEL integer;
begin
  if (singular(select HS.ID_HOTEL
               from HOTEL_S HS
               where HS.IS_USE = 1)) then
    select H.ID_HOTEL
    from   HOTEL_S H
    where H.IS_USE = 1
    into   :id_hotel;
  else begin
    err_code = -1044;
    exit;
  end

  execute procedure EAI_EXT_POST_TO_MH_FRONT_ONLINE(:ID_HOTEL, :ROOM_NAME,
    :SERVICE_CODE, :CODE_TYPE, :QTY_POST, :PRICE_POST, :CURR_POST, :POST_TEXT)
  returning_values (:ERR_CODE, :ERR_TEXT, :ID_ROOM, :ID_GUEST, :GUEST_NAME1,
    :ID_ACCOUNT, :ID_ACCOUNT_POST, :ID_SERVICE);

end
^

/* Alter (EAI_EXT_POST_TO_MH_FRONT_ONLINE) */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:ID_ACCOUNT_POST, :SERVICE_CODE, null, null);

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Alter (EAI_EXT_ROOM_BALANCE) */
ALTER PROCEDURE EAI_EXT_ROOM_BALANCE(ROOM_NAME VARCHAR(20))
 RETURNS(ID_GUEST INTEGER,
ID_ACCOUNT_POST INTEGER,
IS_DEPOSIT_POST SMALLINT,
ID_ACCOUNT INTEGER,
ACCOUNT_NAME VARCHAR(40),
ID_SERVICE INTEGER,
SERVICE_NAME VARCHAR(30),
SERVICE_NAME2 VARCHAR(30),
POST_VALUE NUMERIC(15,2),
CURR_POST VARCHAR(3),
RATE_POST NUMERIC(15,4),
DATE_POST DATE,
POST_TEXT VARCHAR(50))
 AS
declare variable id_room integer;
  declare variable account_posts varchar(5000);
  declare variable is_guest_post smallint;
  declare variable tmp_id_guest integer;
begin
  account_posts = '';
  if (singular(select RO.ID_ROOM
               from ROOMS RO
                  join HOTEL_S HO on HO.ID_HOTEL = RO.ID_HOTEL
               where  RO.ROOM_NAME = :ROOM_NAME
                      and HO.IS_USE = 1)) then
    select R.ID_ROOM
    from   ROOMS R
      join HOTEL_S HS on HS.ID_HOTEL = R.ID_HOTEL
    where  R.ROOM_NAME = :ROOM_NAME
           and HS.IS_USE = 1
    into   :id_room;
  else
    exception assert '-1044';

  for
    select G.ID_GUEST
    from   RESERV_DETAIL RD
           join GUEST G on G.ID_RESERV_DETAIL = RD.ID_RESERV_DETAIL
    where  RD.ID_ROOM = :id_room
           and G.CHECK_STATUS = 0
    into   :tmp_id_guest 
  do begin
    for
      select ID_ACCOUNT_POST, IS_DEPOSIT_POST, ID_ACCOUNT, ACCOUNT_NAME,
             ID_SERVICE, SERVICE_NAME, SERVICE_NAME2,
             POST_VALUE, CURR_POST, RATE_POST, DATE_POST, substring(coalesce(POST_TEXT, '') from 1 for 49),
             IS_GUEST_POST
      from   EAI_EXT_GUEST_BALANCE (:tmp_id_guest) GB
      into   :ID_ACCOUNT_POST, :IS_DEPOSIT_POST, :ID_ACCOUNT, :ACCOUNT_NAME,
             :ID_SERVICE, :SERVICE_NAME, :SERVICE_NAME2,
             :POST_VALUE, :CURR_POST, :RATE_POST, :DATE_POST, :POST_TEXT, :is_guest_post
    do begin
      if (:is_guest_post = 1) then begin
        ID_GUEST = :tmp_id_guest;
        suspend;
      end else if (position(:ID_ACCOUNT_POST, :account_posts) = 0) then begin
        ID_GUEST = -1;
        suspend;
        account_posts = :account_posts || ',' || :ID_ACCOUNT_POST;
      end
    end
  end
end
^

/* Alter (EAI_EXT_ROOM_GUESTS) */
ALTER PROCEDURE EAI_EXT_ROOM_GUESTS(IN_ROOM_NAME VARCHAR(10),
ID_HOTEL INTEGER = null)
 RETURNS(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ROOM_NAME VARCHAR(10),
FROM_DATE DATE,
TO_DATE DATE,
COUNTRY VARCHAR(30),
AGE INTEGER,
ID_AGENT INTEGER,
ID_GROUP INTEGER,
SEX CHAR,
GUEST_CODE VARCHAR(50))
 AS
declare variable birth_day date;
  declare variable sys_date date;
begin
  IN_ROOM_NAME = trim(:IN_ROOM_NAME);

  if (:ID_HOTEL is null) then begin
    if (singular(select RO.ID_ROOM
                 from ROOMS RO
                    join HOTEL_S HO on HO.ID_HOTEL = RO.ID_HOTEL
                 where RO.ROOM_NAME = :in_room_name
                       and HO.IS_USE = 1)) then
      select HS.ID_HOTEL
      from   ROOMS ROO
        join HOTEL_S HS on HS.ID_HOTEL = ROO.ID_HOTEL
      where ROO.ROOM_NAME = :in_room_name
            and HS.IS_USE = 1
      into :id_hotel;
    else
      exception assert '-1044';
  end

  select SYSTEM_DATE
  from   SYSTEM_DATE_GET (:ID_HOTEL)
  into   :SYS_DATE;

  for
    select G.ID_GUEST, GC.GUEST_NAME1, GC.GUEST_NAME2,
           G.FROM_DATE, G.TO_DATE, R.ROOM_NAME,
           GC.COUNTRY, G.ID_AGENT,
           GC.BIRTH_DAY, GC.SEX, GC.GUEST_CODE
    from   GUEST G
           join ROOMS R on R.ID_ROOM = G.ID_ROOM
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
           left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
    where  G.FROM_DATE <= :SYS_DATE
           and G.TO_DATE >= :SYS_DATE
           and G.CHECK_STATUS < 1
           and rd.IS_ANUL = 0
           and ((R.ROOM_NAME  = :IN_ROOM_NAME)
                or
                (:IN_ROOM_NAME = ''))
    order by R.ROOM_NAME asc, G.ID_GUEST asc
    into   :ID_GUEST, :GUEST_NAME1, :GUEST_NAME2,
           :FROM_DATE, :TO_DATE, :ROOM_NAME,
           :COUNTRY, :ID_AGENT,
           :BIRTH_DAY, :SEX, :GUEST_CODE
  do begin
    select CA.AGE_INYEARS
    from   SYSTEM_CALC_AGE_INYEARS (:BIRTH_DAY, :FROM_DATE) CA
    into   :AGE;

    suspend;
  end
end
^

/* Alter (EAI_EXT_ROOM_STATUS) */
ALTER PROCEDURE EAI_EXT_ROOM_STATUS(ROOMS_FILTER VARCHAR(512) = '',
ID_HOTEL INTEGER = null)
 RETURNS(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
GUEST_NAME2 VARCHAR(50),
ROOM_NAME VARCHAR(10),
FROM_DATE DATE,
TO_DATE DATE,
COUNTRY VARCHAR(30),
AGE INTEGER,
ID_AGENT INTEGER,
ID_GROUP INTEGER,
SEX CHAR,
GUEST_CODE VARCHAR(50),
GUESTS_IN_ROOM INTEGER)
 AS
declare variable sys_date date;
  declare variable is_free integer;
begin
  if (:ID_HOTEL is null) then begin
    if (singular(select HS.ID_HOTEL
                 from HOTEL_S HS
                 where HS.IS_USE = 1)) then
      select H.ID_HOTEL
      from   HOTEL_S H
      where  H.IS_USE = 1
      into   :id_hotel;
    else
      exception assert '-1044';
  end

  select SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel)
  into   :SYS_DATE;

  for
    select R.ROOM_NAME,
           sum(Ro.ARRIVAL_ADULTS + ro.ARRIVAL_CHILDREN + ro.STAYOVER_ADULTS + ro.STAYOVER_CHILDREN),
           iif(sum(ro.ARRIVAL_ROOM + ro.STAYOVER_ROOM + ro.OOI_ROOM) > 0, 0, 1)
    from   ROOMS r
           join ROOM_PERIOD$PMS rp on rp.ID_ROOM = r.ID_ROOM
           left outer join HOTEL_ROOM_OCCUPANCY ro on ro.ID_ROOM = r.ID_ROOM
                                                      and ro.BUSY_DATE = :sys_date
                                                      and ro.ID_HOTEL = :ID_HOTEL
    where  r.ID_HOTEL = :ID_HOTEL
           and rp.FROM_DATE <= :sys_date
           and rp.TO_DATE >= :sys_date
           and rp.STATUS in ('HOTEL', 'CONTRACT')
    group by 1
    into   :room_name, :guests_in_room, :is_free
  do begin
    if (:is_free = 1) then begin
      id_guest = null;
      guest_name1 = null;
      guest_name2 = null;
      from_date = null;
      to_date = null;
      country = null;
      id_agent = null;
      id_group = null;
      sex = null;
      guests_in_room = 0;
      guest_code = null;
      suspend;
    end else begin
      for
        select RG.ID_GUEST, RG.GUEST_NAME1, RG.GUEST_NAME2, RG.FROM_DATE, RG.TO_DATE,
               RG.COUNTRY, RG.ID_AGENT, RG.ID_GROUP, RG.SEX, RG.GUEST_CODE, rg.AGE
        from   EAI_EXT_ROOM_GUESTS(:room_name) RG
        into   :id_guest, :guest_name1, :guest_name2, :from_date, :to_date,
               :country, :id_agent, :id_group, :sex, :guest_code, :AGE
      do suspend;
    end
  end
end
^

/* Alter (EAI_EXT_SERVICE_POST) */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:ID_ACCOUNT_POST, :SERVICE_EXT_CODE, null, null);

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_CALL$INT for: EAI_MAP_SERVICE */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_MAP_SERVICE) */
ALTER PROCEDURE EAI_MAP_SERVICE(SERVICE_TAG VARCHAR(30),
SERVICE_NAME VARCHAR(30),
EXTERNAL_IFC VARCHAR(30),
ID_HOTEL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_MAPPED_SERVICE INTEGER)
 AS
declare variable id_service_group integer;
  declare variable setting_code varchar(30);
  declare variable revenue_group varchar(30);
  declare variable is_base integer;
  declare variable is_deleted integer;
  declare variable hotel_name varchar(50);
begin
  /*  Description:
  ||
  */
  err_code = 0;
  err_text = '';
  id_mapped_service = null;
  select first 1 S.ID_SERVICE, S.IS_BASE, s.IS_DELETED
  from   SERVICES S
  where  S.EXT_CODE = :service_tag
         and s.ID_HOTEL = :id_hotel
  order by s.IS_DELETED asc, s.ID_SERVICE asc
  into   :id_mapped_service, :is_base, :is_deleted;

  if (:is_base = 1) then begin
    ERR_CODE = -63;
    ERR_TEXT= '';
    exit;
  end
  if (:is_deleted = 1) then begin
    ERR_CODE = -64;
    ERR_TEXT= '';
    exit;
  end
  if (:id_mapped_service is not null) then exit;

  if (:external_ifc = 'POS') then revenue_group = 'Food and Beverage';
  else revenue_group = 'Other Operated departments';

  setting_code = 'IFC_'||:external_ifc||'_SRVGRP';
  execute procedure SETTING_GET_VALUE(:setting_code, :ID_HOTEL)
  returning_values  :id_service_group;

  begin
    execute procedure SERVICE_MODIFY(null, :id_service_group, 'EXTRA', :service_name, 0, 1, 0,
                      :revenue_group, null, null, :service_tag, 'BASE', '', 0, 'add', :ID_HOTEL,
                      0, 0, 0, 0, 0, 0, null, null)
    returning_values  :id_mapped_service;
  
    when sqlcode -803 do begin
      -- catch SERVICE_NAME_UNQ_HASH unique index exception
      select h.HOTEL_NAME
      from   HOTEL h
      where  h.ID_HOTEL = :ID_HOTEL
      into   :hotel_name;
  
      err_code = -68;
      err_text = f_character(29) || :SERVICE_NAME || f_character(28) || :hotel_name;
      exit;
    end
  end
end
^

/* Alter (EAI_POS_CHECK_CARD$P2E) */
ALTER PROCEDURE EAI_POS_CHECK_CARD$P2E(IN_CARD_NUMBER VARCHAR(50),
ID_HOTEL INTEGER)
 RETURNS(ID_GUEST INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100),
GUEST_NAME VARCHAR(100),
ROOM_NAME VARCHAR(20),
BOARD_NAME VARCHAR(30))
 AS
declare variable id_guest_check integer;
  declare variable check_status integer;
  declare variable to_date date;
  declare variable check_date date;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  if (coalesce(:IN_CARD_NUMBER, '') = '') then begin
     ERR_CODE = -401;
     ERR_TEXT = '';
     suspend;
     exit ;
  end

  select max(GD.ID_GUEST), min(GD.ID_GUEST)
  from   GUEST_DATA GD
         join GUEST G on G.ID_GUEST = GD.ID_GUEST
         join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
  where  GD.GUEST_CODE = :IN_CARD_NUMBER
         and RD.ID_HOTEL = :ID_HOTEL
         and rd.IS_ANUL = 0
         and rd.CHECK_STATUS >= 0
  into   :ID_GUEST, :ID_GUEST_CHECK;

  if (:ID_GUEST is null) then begin
     ERR_CODE = -402;
     ERR_TEXT = '';
     suspend;
     exit;
  end

  if (:ID_GUEST <> :ID_GUEST_CHECK) then begin
     ERR_CODE = -403;
     ERR_TEXT = '';
     suspend;
     exit;
  end
  /*FIND SYSTEM DATE - check to today, not to system date - for security*/

  select  TO_DATE, G.CHECK_STATUS
  from    GUEST G
  where   ID_GUEST = :ID_GUEST
  into    :TO_DATE, :CHECK_STATUS;

  if ((:TO_DATE < current_date) or (:CHECK_STATUS = 1)) then  begin
     ERR_CODE = -404;
     ERR_TEXT = '';
     suspend;
     exit;
  end

  check_date = iif(current_date = :to_date, current_date - 1, current_date);

  select GC.GUEST_NAME1, R.ROOM_NAME,
         (select m.NAME
          from   GUEST_STAY gs
                 join MEALS M on m.ID_BOARD = gs.ID_BOARD
          where  gs.ID_GUEST = g.ID_GUEST
                 and gs.FOR_DATE = :check_date)
  from   GUEST_CARD GC
         join GUEST G on G.ID_GUEST = GC.ID_GUEST
         join ROOMS R on G.ID_ROOM = R.ID_ROOM
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME, :ROOM_NAME, :BOARD_NAME;

  suspend;
end
^

/* Alter (EAI_POS_GET_GUESTS$P2E) */
ALTER PROCEDURE EAI_POS_GET_GUESTS$P2E(IN_ROOM_NAME VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(OUT_ID_GUEST INTEGER,
OUT_GUEST_NAME VARCHAR(100),
OUT_FROM_DATE DATE,
OUT_TO_DATE DATE,
OUT_OK_FOR_POST INTEGER,
OUT_COUNTRY VARCHAR(30),
OUT_TEXT VARCHAR(100),
OUT_BOARD_NAME VARCHAR(30),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100))
 AS
declare variable id_room integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  OUT_GUEST_NAME = null;

  /*FIND ROOM*/
  select R.ID_ROOM
  from   ROOMS R
         join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
  where  R.ROOM_NAME = :IN_ROOM_NAME
         and RT.ID_HOTEL = :ID_HOTEL
  into   :ID_ROOM;
  if ((:ID_ROOM is null) or (:ID_ROOM <= 0) ) then begin
    ERR_CODE = -5;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Room number not found!    ! ';
    suspend;
    exit;
  end

  /*FIND GUESTS*/
  for
    select G.ID_GUEST, GC.GUEST_NAME1, G.FROM_DATE, G.TO_DATE, C.COUNTRY_NAME,
           (select m.NAME
            from   GUEST_STAY gs
                   join MEALS M on m.ID_BOARD = gs.ID_BOARD
            where  gs.ID_GUEST = g.ID_GUEST
                   and gs.FOR_DATE = iif(current_date = g.to_date, current_date - 1, current_date))
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
           left outer join GUEST_CARD GC on G.ID_GUEST = GC.ID_GUEST
           left outer join COUNTRY C on C.COUNTRY_CODE = GC.COUNTRY
    where  G.ID_ROOM = :ID_ROOM
           and G.CHECK_STATUS = 0
           and rd.IS_ANUL = 0
    into   :OUT_ID_GUEST, :OUT_GUEST_NAME, :OUT_FROM_DATE,  :OUT_TO_DATE, :OUT_COUNTRY, :OUT_BOARD_NAME
  do begin
    OUT_OK_FOR_POST = iif(:OUT_TO_DATE < current_date, 0, 1) ;
    suspend;
  end

  if (:OUT_GUEST_NAME is null) then begin
    ERR_CODE = -1;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Guests not found!     !';
    suspend;
  end
end
^

ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30),
UNIQUE_SALES_NUMBER VARCHAR(30) = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable my_post_text varchar(255);
  declare variable my_resource_text varchar(255);
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
  declare variable id_account_post integer;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  my_post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  my_resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  my_post_text = substring(:my_post_text from 1 for 100);
  my_resource_text = substring(:my_resource_text from 1 for 49);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code, '')
    returning_values  :err_code, :err_text, :out_id_account, :id_account_post;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code)
    returning_values  :err_code, :err_text, :id_account_post;
    out_id_account = :in_id_account;
  end

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:id_account_post, :post_short_code, :IN_POS_USER, :IN_DATETIME);

  insert into ACCOUNT_POST_POS_TRANSFER (ID_ACCOUNT_POST, UNIQUE_SALES_NUMBER, POS_ID_SMETKA, POS_SMETKA_NUM,
         POS_SMETKA_DATE, POS_OBJECT_NAME, TAG_VALUE, TAG_NAME, TRANSFER_VALUE)
  values (:id_account_post, :UNIQUE_SALES_NUMBER, nullif(:IN_ID_SMETKA, 'END_WORK'), :IN_SMETKA_NUM,
         :IN_DATE_SMETKA, :IN_OBJ_NAME, :IN_SERVICE_TAG, :IN_SERVICE_NAME, :IN_PRICE);
end
^

/* Alter (EAI_POS_POSTING_ADD) */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
begin
  -- used external inteface - for compatability with Front 2008
  execute procedure EAI_POS_POSTING_ADD$P2E (:IN_ON_GUEST, :IN_ID_ACCOUNT, :IN_ID_GUEST, :IN_DATE_SMETKA,
          :IN_PRICE, :IN_DATETIME, :IN_OBJ_NAME, :IN_TABLE, :IN_SITE, :IN_SMETKA_NUM, :IN_POS_USER,
          :IN_ID_SMETKA, :IN_SERVICE_TAG, :IN_SERVICE_NAME)
  returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT);

end
^

/* Alter (EAI_ROOM_STATUS_SET) */
ALTER PROCEDURE EAI_ROOM_STATUS_SET(ROOM_NAME VARCHAR(10),
OPERATION VARCHAR(20),
TAG VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_room integer;
  declare variable set_options varchar(255);
begin
  err_code = 0;
  err_text = '';

  execute procedure SYSTEM_CHECK_OPERATION(:OPERATION, 'setclean,setdirty,settext');

  id_room = null;
  if (singular(select RO.ID_ROOM
               from ROOMS RO
                  join HOTEL_S HO on HO.ID_HOTEL = RO.ID_HOTEL
               where  RO.ROOM_NAME = :ROOM_NAME
                      and HO.IS_USE = 1)) then
    select R.ID_ROOM
    from   ROOMS R
      join HOTEL_S HS on HS.ID_HOTEL = R.ID_HOTEL
    where  R.ROOM_NAME = :ROOM_NAME
           and HS.IS_USE = 1
    into   :id_room;
  else begin
    err_code = -1044;
    exit;
  end

  if (:id_room is null) then begin
    err_code = -5;
    err_text = :room_name;
    exit;
  end

  if (:operation = 'setclean') then set_options = 'set_clean';
  else if (:operation = 'setdirty') then set_options = 'set_dirty';
  else if (:operation = 'settext') then set_options = 'set_text'||f_character(28)||:tag;

  execute procedure ROOM_HOUSEKEEPING(:id_room, 'EXT_IFC', :set_options);
end
^

/* empty dependent procedure body */
/* Clear: EXPORT_BOOKING$RSV for: EXPORT_BOOKING$EXC */
ALTER PROCEDURE EXPORT_BOOKING$RSV(DATA_RANGE VARCHAR(50))
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20),
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_NAME VARCHAR(100),
POSTING_ROUTING VARCHAR(20),
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EXPORT_BOOKING$EXC) */
ALTER PROCEDURE EXPORT_BOOKING$EXC(BOOKING_ID INTEGER)
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20,
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_ID INTEGER,
IS_GUEST_ARRANGER INTEGER,
POSTING_ROUTING VARCHAR(20),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IS_DIFFERENT_TARIFF SMALLINT,
IS_DIFFERENT_BOARD SMALLINT,
IS_CUSTOM_PRICE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
EXC_LOCAL_VERSION BIGINT,
EXC_REMOTE_VERSION BIGINT,
CREATE_DATETIME TIMESTAMP,
EATING_OBJECT VARCHAR(50),
CHECK_OUT_KIND SMALLINT,
EARLYCHECKOUT_DATE DATE)
 AS
declare variable arrival_type_code smallint;
BEGIN
  number = null;
  select h.hotel_name, b.number, bei.confirmation_number, bei.cancelation_number,
        bs.status, rg.id_reserv_group, rg.group_name, rg.uuid, b.is_vip, b.arrival_date, b.comming_kind,
        b.departure_date, b.is_late_departure, b.transfer_in_time, b.transfer_in_note,
        b.transfer_out_time, b.transfer_out_note, rt.type_room, board.name,
        b.room_features, b.i_special_treatment, hk.plan_name, r.tarifa_name, b.custom_price, b.custom_currency,
        b.deposit_required, b.deposit_required_currency, apt.payment_type, ppt.payment_type,
        b.voucher_num, b.voucher_date, b.voucher_text, ms.segment_name, sc.description,
        cc.description, hr.description, cr.description, b.note, b.note_reminders,
        b.code_first_food, ap.id_profile, isperson.id_profile as is_guest_arranger,
        b.acc_routing, b.is_different_room_type, b.is_different_stay_type, b.is_different_tariff,
        b.is_different_board, b.is_custom_price, b.is_different_price, bei.split_on_checkin,
        gp.name, b.block_cc, bei.guarantee_deposit_percent, bei.guarantee_deposit_nights,
        bei.guarantee_due_days_bef_arrival, bei.guarantee_due_days_after_create, bx.minibar_rights,
        bx.paytv_rights, bx.video_rights, bx.nopost_pms, bx.phone_rights, bx.seminar_cahnnel_rights,
        bei.posting_transaction_uuid, bei.exc_local_version, bei.exc_remote_version, bei.create_datetime,
        eo.name, bei.check_out_kind, bei.earlycheckout_date
  from  RES_LOAD(:booking_id) b
        join reserv_detail bei on bei.id_reserv_detail = :booking_id
        join HOTEL h on h.id_hotel = b.id_hotel
        join export_booking_status$exc(b.check_status, b.annul_status) bs on 1=1
        left outer join RESERV_GROUP RG on RG.ID_RESERV_GROUP = b.ID_GROUP
        join room_types rt on rt.id_room_type = b.id_res_room_type
        left outer join hk_plan hk on hk.id_plan = b.id_hk_plan
        join tarifa r on r.id_tarifa = b.id_tariff
        left outer join payment_type apt on apt.id_payment_type = b.id_agent_payment
        left outer join payment_type ppt on ppt.id_payment_type = b.id_person_payment
        left outer join nom_market_segments ms on ms.id_nom_market_segment = b.id_nom_market_segment
        left outer join nom_source_codes sc on sc.id_nom_source_code = b.id_nom_source_code
        left outer join nom_channel_codes cc on cc.id_nom_channel_code = b.id_nom_channel_code
        left outer join nom_hear_reasons hr on hr.id_nom_hear_reason = b.id_nom_hear_reason
        left outer join nom_come_reasons cr on cr.id_nom_come_reason = b.id_nom_come_reason
        left outer join profile ap on ap.id_profile = b.id_agent_profile
        left outer join profile_person isperson on isperson.id_profile = b.id_agent_profile
        left outer join meals board on board.ID_BOARD = bei.ID_BOARD
        left outer join guarantee_policy gp on gp.id_guarantee_policy=b.id_guarantee_policy
        left outer join reserv_detail_external bx on bx.id_reserv_detail = :booking_id
        left outer join eating_object eo on eo.id_eating_object = b.id_eating_object
  into  :hotel,
        :number,
        :confirmation_number,
        :cancelation_number,
        :status,
        :group_id,
        :group_name,
        :group_uuid,
        :is_vip,
        :arrival,
        :arrival_type_code,
        :departure,
        :is_late_departure,
        :transfer_in_time,
        :transfer_in_note,
        :transfer_out_time,
        :transfer_out_note,
        :room_type,
        :board,
        :room_preferences,
        :special_treatment,
        :maintance_shema,
        :rate,
        :manual_price,
        :manual_price_currency,
        :deposit_required,
        :deposit_required_currency,
        :arranger_payment_type,
        :guest_payment_type,
        :voucher,
        :voucher_date,
        :voucher_text,
        :marketing_segment,
        :marketing_source_code,
        :marketing_channel_code,
        :marketing_hear_reason,
        :marketing_come_reason,
        :note,
        :note_reminders,
        :first_food,
        :arranger_profile_id,
        :is_guest_arranger,
        :posting_routing,
        :is_different_room_type,
        :is_different_stay_type,
        :is_different_tariff,
        :is_different_board,
        :is_custom_price,
        :is_different_price,
        :split_on_checkin,
        :guarantee_policy,
        :block_cc,
        :guarantee_deposit_percent,
        :guarantee_deposit_nights,
        :guarantee_due_days_bef_arrival,
        :guarantee_due_days_after_create,
        :minibar_rights,
        :paytv_rights,
        :video_rights,
        :nopost_pms,
        :phone_rights,
        :seminar_cahnnel_rights,
        :posting_transaction_uuid,
        :exc_local_version,
        :exc_remote_version,
        :create_datetime,
        :eating_object,
        :check_out_kind,
        :earlycheckout_date;

  if (:number is not null) then begin -- Check if we have export
    arrival_type = null;
    if (0 = :arrival_type_code) then begin
      arrival_type = 'early';
    end else if (2 = :arrival_type_code) then begin
      arrival_type = 'late';
    end
    suspend;
  end
END
^

/* Alter (EXPORT_BOOKING$RSV) */
ALTER PROCEDURE EXPORT_BOOKING$RSV(DATA_RANGE VARCHAR(50))
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20,
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_NAME VARCHAR(100),
POSTING_ROUTING VARCHAR(20),
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
BEGIN
  for select EB.HOTEL,
             EB.NUMBER, 
             EB.CONFIRMATION_NUMBER, 
             EB.CANCELATION_NUMBER,
             EB.STATUS, 
             EB.GROUP_ID, 
             EB.GROUP_NAME, 
             EB.IS_VIP,
             EB.ARRIVAL, 
             EB.ARRIVAL_TYPE, 
             EB.DEPARTURE, 
             EB.IS_LATE_DEPARTURE, 
             EB.TRANSFER_IN_TIME, 
             EB.TRANSFER_IN_NOTE, 
             EB.TRANSFER_OUT_TIME, 
             EB.TRANSFER_OUT_NOTE, 
             EB.ROOM_TYPE, 
             EB.BOARD, 
             EB.ROOM_PREFERENCES,
             EB.SPECIAL_TREATMENT, 
             EB.MAINTANCE_SHEMA, 
             EB.RATE, 
             EB.MANUAL_PRICE, 
             EB.MANUAL_PRICE_CURRENCY, 
             EB.DEPOSIT_REQUIRED, 
             EB.DEPOSIT_REQUIRED_CURRENCY, 
             EB.ARRANGER_PAYMENT_TYPE, 
             EB.GUEST_PAYMENT_TYPE, 
             EB.VOUCHER, 
             EB.VOUCHER_DATE, 
             EB.VOUCHER_TEXT, 
             EB.MARKETING_SEGMENT, 
             EB.MARKETING_SOURCE_CODE, 
             EB.MARKETING_CHANNEL_CODE, 
             EB.MARKETING_HEAR_REASON, 
             EB.MARKETING_COME_REASON, 
             EB.NOTE, 
             EB.NOTE_REMINDERS, 
             EB.FIRST_FOOD, 
             P.PROFILE_NAME,
             EB.POSTING_ROUTING, 
             EB.SPLIT_ON_CHECKIN, 
             EB.GUARANTEE_POLICY, 
             EB.GUARANTEE_DEPOSIT_PERCENT, 
             EB.GUARANTEE_DEPOSIT_NIGHTS, 
             EB.GUARANTEE_DUE_DAYS_BEF_ARRIVAL, 
             EB.GUARANTEE_DUE_DAYS_AFTER_CREATE
  from TMP_IDS ids
       left outer join EXPORT_BOOKING$EXC(ids.ID) EB on 1=1
       left outer join PROFILE P on P.ID_PROFILE = EB.ARRANGER_PROFILE_ID
  where ids.CONTEXT = :data_range
  into :hotel,
       :number, 
       :confirmation_number, 
       :cancelation_number,
       :status,
       :group_id, 
       :group_name, 
       :is_vip,
       :arrival, 
       :arrival_type, 
       :departure, 
       :is_late_departure, 
       :transfer_in_time, 
       :transfer_in_note, 
       :transfer_out_time, 
       :transfer_out_note, 
       :room_type, 
       :board, 
       :room_preferences,
       :special_treatment, 
       :maintance_shema, 
       :rate, 
       :manual_price, 
       :manual_price_currency, 
       :deposit_required, 
       :deposit_required_currency, 
       :arranger_payment_type, 
       :guest_payment_type, 
       :voucher, 
       :voucher_date, 
       :voucher_text, 
       :marketing_segment, 
       :marketing_source_code, 
       :marketing_channel_code, 
       :marketing_hear_reason, 
       :marketing_come_reason, 
       :note, 
       :note_reminders, 
       :first_food, 
       :arranger_profile_name,
       :posting_routing, 
       :split_on_checkin, 
       :guarantee_policy, 
       :guarantee_deposit_percent, 
       :guarantee_deposit_nights, 
       :guarantee_due_days_bef_arrival, 
       :guarantee_due_days_after_create
  do suspend;
END
^

/* Alter (EXPORT_DOCS$PMS) */
ALTER PROCEDURE EXPORT_DOCS$PMS(START_DATE TYPE OF TDATE,
END_DATE TYPE OF TDATE,
ID_HOTEL TYPE OF ID_REF)
 RETURNS(ID_ROOM ID_REF,
ID_RESERV_DETAIL ID_REF,
ID_CONTRACT ID_REF,
FROM_DATE TDATE,
TO_DATE TDATE,
PRICE_WITH_VAT TPRICE,
PRICE_WO_VAT TPRICE,
BEDNIGHTS TCOUNT,
STAY TCOUNT,
RESERVS TCOUNT,
LAST_ID_DOC_HEAD ID_REF,
DOC_DESCRIPTION TDESCRIPTION_LONG)
 AS
declare variable room_stay integer;
declare variable doc_list varchar(4000);
declare variable id_doc integer;
declare variable docs_idx integer;
declare variable contr_from_date date;
declare variable contr_to_date date;
declare variable first_date date;
declare variable id_titular integer;
begin
  for
    select dv.id_room, dv.id_reserv_detail, RC.ID_ROOM_CONTRACT, rp.FROM_DATE, rp.TO_DATE, RD.ID_TITULAR,
           --mindate(rd.TO_DATE, rp.TO_DATE + 1) - maxdate(rd.FROM_DATE, rp.FROM_DATE) as res_stay,
           cast(maxdate(min(dv.date_post), min(rp.FROM_DATE)) as date) as imp_from,
           cast(mindate(max(dv.date_post), max(rp.TO_DATE)) as date) as imp_to,
           sum(dv.value_with_vat), sum(dv.value_wot_vat),
           sum(dv.bednights) bednights,
           sum(floor(dv.bednights/(rd.ADULT_COUNT + rd.CHILD_COUNT))) stay,
           max(dv.id_doc),
           list(distinct dv.doc_list),
           coalesce
             (max(case when dv.docs_idx > 0 then 1
                       when dv.docs_idx < 0 then -1
                       else null end), 0)
    from   (select DL.DATE_POST, r.ID_ROOM, G.ID_RESERV_DETAIL,
                   sum(DRD.VALUE_CORR_INDEX*DL.SINGLE_VALUE*DL.QTY_POST*cast(CCF.RATE_ as double precision)) as value_with_vat,
                   sum(DRD.VALUE_CORR_INDEX*DL.WOT_VAT*cast(CCF.RATE_ as double precision)) as value_wot_vat,
                   sum(DRD.VALUE_CORR_INDEX*DL.QTY_POST*(1-dl.IS_CORRECT)) as bednights,
                   max(dh.ID_DOC) as ID_DOC,
                   F_BLOBASPCHAR(list(distinct dh.ID_DOC)) as doc_list,
                   sum(iif(dh.DOC_SUB_TYPE = 0, 1, -dh.IS_STORNO) * DRD.VALUE_CORR_INDEX) as docs_idx
            from   GUEST G
                   join DOC_LINE DL on G.ID_GUEST = DL.ID_GUEST
                   join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE and PV.IS_BASE = 1
                   join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = PV.ID_ACCOUNT_POST
                   join ROOMS R on R.ID_ROOM = AP.ID_ROOM
                   join DOC_HEAD DH on DH.ID_DOC = DL.ID_DOC_HEAD
                   join ACCOUNT a on a.ID_ACCOUNT = dh.ID_ACCOUNT
                   join DOC_RELEASE_DATE drd on drd.ID_DOC_HEAD = dh.ID_DOC
                   left outer join CURR_RATE_GET(DH.DOC_CURRENCY, :end_date, :id_hotel) CCF on 0=0
            where  DRD.RELEASE_DATE between :start_date and :end_date
                   and a.ID_HOTEL = :id_hotel
                   and not exists (select da.ID_DOC_HEAD
                                   from   DOC_ANNULMENT da
                                   where  dh.DOC_DATE between :start_date and :end_date
                                          and da.ID_DOC_HEAD = dh.ID_DOC
                                          and da.ANNULMENT_DATE between :start_date and :end_date)
            group by 1, 2, 3) dv
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = dv.ID_RESERV_DETAIL
           join ROOM_PERIOD$PMS rp on rp.ID_ROOM = dv.id_room
                                      and rp.FROM_DATE <= dv.date_post
                                      and rp.to_date >= dv.date_post
           join ROOM_CONTRACT$PMS rc on rc.ID_ROOM_PERIOD = rp.ID_ROOM_PERIOD
    group by 1, 2, 3, 4, 5, 6--, 7
    into    :id_room, :id_reserv_detail, :id_contract, :contr_from_date, :contr_to_date, :id_titular, --:res_stay,
            :from_date, :to_date, :price_with_vat, :price_wo_vat,
            :bednights, :stay, :last_id_doc_head, :doc_list, :docs_idx
  do begin
    select  min(gs.FOR_DATE),
            count(iif(gs.FOR_DATE between :contr_from_date and :contr_to_date, gs.FOR_DATE, null))
    from    GUEST_STAY gs
    where   gs.ID_ROOM = :ID_ROOM
            and gs.ID_GUEST = :id_titular
    into    :first_date, :room_stay;

    if (:room_stay <= 0 and :docs_idx = 0) then
      RESERVS = -1;  -- res stay is shorted out of this contract
    else if ((:first_date between :FROM_DATE and :TO_DATE)
        or
        (:contr_from_date between :FROM_DATE and :TO_DATE)) then
      RESERVS = :docs_idx;
    else
      RESERVS = 0;

    DOC_DESCRIPTION = ',';
    for
      select sp.ITEM
      from   SYSTEM_STRING_PARSER (:doc_list, ',') sp
      into   :id_doc
    do begin
      if (:DOC_DESCRIPTION not containing ','||:id_doc||',') then DOC_DESCRIPTION = substring(:DOC_DESCRIPTION || :id_doc || ',' from 1 for 255);
    end 

    suspend;
  end

end
^

/* Alter (EXPORT_DOCUMENT) */
ALTER PROCEDURE EXPORT_DOCUMENT(FROM_DATE DATE,
TO_DATE DATE,
DOC_TAG VARCHAR(20),
PAY_TAG VARCHAR(20),
NO_PAY_DOCS VARCHAR(20),
GROUP_TAG VARCHAR(20),
ID_HOTEL INTEGER = null,
RETURN_CLIENT_PERSON_ID SMALLINT = 0)
 RETURNS(DOC_TYPE_ID INTEGER,
DOC_SUB_TYPE SMALLINT,
DOC_TYPE_NAME VARCHAR(50),
DOC_DATE DATE,
DOC_FOR_DEPOSIT SMALLINT,
TAX_EVENT_DATE DATE,
DIFF_VAT_REASON VARCHAR(254),
DOC_NUM VARCHAR(20),
DOC_CURRENCY CHAR(3),
DOC_RATE NUMERIC(15,4),
DOC_IS_STORNED SMALLINT,
DOC_IS_STORNO SMALLINT,
DOC_ID_BASE_DOC INTEGER,
DOC_EXPORT_TAG VARCHAR(20),
DOC_SEND_NAME VARCHAR(100),
DOC_DOGOVOR_NUM VARCHAR(30),
DOC_NOTE VARCHAR(100),
DOC_SUPPLIER_ID INTEGER,
CLT_ID INTEGER,
CLT_NAME VARCHAR(100),
CLT_VAT_REG_NUM VARCHAR(30),
CLT_IDENT_NO VARCHAR(30),
CLT_MOL VARCHAR(100),
CLT_ADDRESS VARCHAR(100),
CLT_COUNTRY_CODE VARCHAR(10),
CLT_ZIP_CODE VARCHAR(10),
CLT_RECIEVE_NAME VARCHAR(100),
PAY_TYPE_ID INTEGER,
PAY_TYPE VARCHAR(20),
PAY_CURRENCY CHAR(3),
PAY_VALUE NUMERIC(15,4),
PAY_RATE NUMERIC(15,6),
PAY_CC_NAME VARCHAR(50),
PAY_CC_NUM VARCHAR(50),
PAY_CC_BANK VARCHAR(50),
PAY_EXPORT_TAG VARCHAR(20),
LINE_ID INTEGER,
LINE_NAME VARCHAR(50),
LINE_WOT_VAT NUMERIC(15,4),
LINE_VAT_FREE NUMERIC(15,4),
LINE_VAT_BASE NUMERIC(15,4),
LINE_VAT NUMERIC(15,4),
VAT_VALUE NUMERIC(15,4),
ID_VAT_GROUP INTEGER,
ID_SALE_TAXATION INTEGER,
LINE_QTY NUMERIC(15,4),
ACC_NO VARCHAR(30),
POSITION_NO INTEGER)
 AS
declare variable id_doc_head integer;
  declare variable doc_grand_total numeric(15,4);
  declare variable pay_coeficient double precision;
  declare variable value_corr_idx numeric(15,2);
  declare variable doc_total numeric(15,2);
  declare variable doc_rate_int numeric(15,4);
  declare variable curr_sel varchar(10);
  declare variable delim_pos integer;
begin
  /*  Description:
  ||
  */

  POSITION_NO = 1;
  delim_pos = position(';', :GROUP_TAG);
  if (:delim_pos > 0) then begin
    curr_sel = substring(:GROUP_TAG from :delim_pos + 1 for char_length(:group_tag) - :delim_pos);
    GROUP_TAG = substring(:GROUP_TAG from 1 for :delim_pos - 1);
  end

  for
    select DH.ID_DOC, DH.DOC_TYPE_NAME, DH.REAL_DOC_DATE, DH.DOC_NUM,
           coalesce(DD.ID_CONTRAGENT, iif(:RETURN_CLIENT_PERSON_ID = 1, 1000000000 + a.ID_PROFILE, null)),
           DH.ID_DOC_TYPE, DH.DOC_RATE, DD.CONTRAGENT_NAME, DD.VAT_REG_NUM, DD.IDENT_NO,
           DD.MOL, DD.POST_ADDRESS, DD.COUNTRY_CODE, DD.ZIP_CODE,
           DS.SEND_NAME, DD.RECIPIENT_NAME, DH.DESCRIPTION, DD.NUM_DOGOVOR,
           DH.DOC_VALUE_A, DH.DOC_CURRENCY, DH.ID_BASE_DOC,
           DH.IS_STORNED, DH.IS_STORNO,
           case when D.DOC_SUB_TYPE = 2 then DI.CREDIT_EXPORT_TAG
                when D.DOC_SUB_TYPE = 1 then DI.DEBIT_EXPORT_TAG
                else DT.EXPORT_TAG
           end as EXPORT_TAG, DH.TAX_EVENT_DATE, DH.DIFF_VAT_REASON,
           DH.FOR_DEPOSIT,
           iif(dh.ANNULMENT_DATE between :from_date and :to_date /*and dh.VALUE_CORR_IDX = 1*/, 0, DH.VALUE_CORR_IDX) as VALUE_CORR_IDX,
           D.DOC_SUB_TYPE, DS.ID_DOC_SUPPLIER, DH.DOC_VALUE_A
    from   DOCUMENT_RELEASE DH
           join DOC_CONTRAGENT DD on DD.ID_DOC_CONTRAGENT = DH.ID_DOC_CONTRAGENT
           join DOC_SUPPLIER DS on DS.ID_DOC_SUPPLIER = DH.ID_DOC_SUPPLIER
           join DOC_TYPE DT on DT.ID_DOC_TYPE = DH.ID_DOC_TYPE
           join DOC_TYPE_INV DI on DI.ID_DOC_TYPE = DT.ID_DOC_TYPE
           join DOC_HEAD D on D.ID_DOC = DH.ID_DOC
           join ACCOUNT A on A.ID_ACCOUNT = DH.ID_ACCOUNT
    where  DH.RPT_DOC_DATE between :from_date and :to_date
           and ((upper(:doc_tag) = 'ALL') or (coalesce(DI.ANNUL_EXPORT_TAG, DT.EXPORT_TAG) = :doc_tag))
           --and DH.IS_ANNUL_ON_DATE = 0
           and ((:ID_HOTEL is null) or (A.ID_HOTEL = :ID_HOTEL))
           and not (dh.REAL_DOC_DATE between :from_date and :to_date
                    and dh.ANNULMENT_DATE between :from_date and :to_date
                    and dh.VALUE_CORR_IDX = -1)  -- skip annul records into same period
    into   :id_doc_head, :doc_type_name, :doc_date, :doc_num, :clt_id,
           :doc_type_id, :doc_rate, :clt_name, :clt_vat_reg_num, :clt_ident_no,
           :clt_mol, :clt_address, :clt_country_code, :clt_zip_code,
           :doc_send_name, :clt_recieve_name, :doc_note, :doc_dogovor_num,
           :doc_grand_total, :doc_currency, :doc_id_base_doc,
           :doc_is_storned, :doc_is_storno, :doc_export_tag, :tax_event_date, :diff_vat_reason,
           :DOC_FOR_DEPOSIT, :value_corr_idx, :doc_sub_type, :doc_supplier_id, :doc_total
  do begin
    if (:curr_sel = 'ORIG') then doc_rate_int = 1; else doc_rate_int = :DOC_RATE;
    /****************************************/
    if (upper(:group_tag) = 'DOC_TOTAL') then begin
      line_vat_free = null;
      line_vat_base = null;
      line_vat = null;
      doc_total = null;

      select sum(dt.NONTAXABLE_VALUE), sum(dt.TAXABLE_VALUE), sum(dt.TAX_VALUE), min(dt.ID_SALE_TAX)
      from   DOC_TAXES DT
      where  DT.ID_DOC_HEAD = :id_doc_head
      into   :LINE_VAT_FREE, :LINE_VAT_BASE, :LINE_VAT, :ID_VAT_GROUP;
      line_vat_free = coalesce(:line_vat_free, 0) * :value_corr_idx;
      line_vat_base = coalesce(:line_vat_base, 0) * :value_corr_idx;
      line_vat = coalesce(:line_vat, 0) * :value_corr_idx;
      doc_total = coalesce(:doc_total, 0)* :value_corr_idx;

      select st.TAX_PERCENT
      from   SALE_TAXES ST
      where  ST.ID_SALE_TAX = :ID_VAT_GROUP
      into   :VAT_VALUE;
       
      LINE_WOT_VAT = (:LINE_VAT_BASE + :LINE_VAT_FREE) * :value_corr_idx; /*:doc_total - :LINE_VAT;*/
      LINE_ID = :id_doc_head;
      LINE_NAME = '';
      LINE_QTY = 1;
      ACC_NO = '';

      select   first 1 EDP.PAY_TYPE_ID, EDP.PAY_TYPE, EDP.PAY_CURRENCY, EDP.PAY_RATE, EDP.PAY_VALUE,
               EDP.PAY_CC_NUM, EDP.PAY_CC_NAME, EDP.PAY_CC_BANK, EDP.PAY_COEFICIENT, EDP.EXPORT_TAG
      from     EXPORT_DOCUMENT_PAYMENT(:id_doc_head, :pay_tag, :no_pay_docs, :doc_currency,
                                       :doc_id_base_doc, :doc_grand_total) EDP
      into     :pay_type_id, :pay_type, :pay_currency, :pay_rate, :pay_value,
               :pay_cc_num, :pay_cc_name, :pay_cc_bank, :pay_coeficient, :pay_export_tag;

      PAY_VALUE = :PAY_VALUE * :value_corr_idx;
      suspend;
      POSITION_NO = :POSITION_NO + 1;
    end else if (upper(:group_tag) = 'TAXES') then begin
      ID_SALE_TAXATION = null;
      POSITION_NO = 1;
      for
        select dt.TAX_NAME, 1, dt.ID_SALE_TAX,
               (dt.TAXABLE_VALUE + dt.NONTAXABLE_VALUE) * :value_corr_idx,
               dt.NONTAXABLE_VALUE * :value_corr_idx,
               dt.TAXABLE_VALUE * :value_corr_idx,
               dt.TAX_VALUE * :value_corr_idx,
               dt.TAX_PERCENT, st.ACCOUNT_NAME, dt.ID_SALE_TAX
        from   DOC_TAXES dt
               join SALE_TAXES st on st.ID_SALE_TAX = dt.ID_SALE_TAX
        where  dt.ID_DOC_HEAD = :ID_DOC_HEAD
        into   :line_name, :line_qty, :LINE_ID, :line_wot_vat, :line_vat_free, :line_vat_base,
               :line_vat, :vat_value, :acc_no, :id_vat_group
      do begin
      
        suspend;
        POSITION_NO = :POSITION_NO + 1;
      end 
    end else begin
      LINE_VAT_BASE = null;
      LINE_VAT_FREE = null;
      ID_VAT_GROUP = null;
      for
        select   EDP.PAY_TYPE_ID, EDP.PAY_TYPE, EDP.PAY_CURRENCY, EDP.PAY_RATE, EDP.PAY_VALUE,
                 EDP.PAY_CC_NUM, EDP.PAY_CC_NAME, EDP.PAY_CC_BANK, EDP.PAY_COEFICIENT, EDP.EXPORT_TAG
        from     EXPORT_DOCUMENT_PAYMENT(:id_doc_head, :pay_tag, :no_pay_docs, :doc_currency,
                                         :doc_id_base_doc, :doc_grand_total) EDP
        into     :pay_type_id, :pay_type, :pay_currency, :pay_rate, :pay_value,
                 :pay_cc_num, :pay_cc_name, :pay_cc_bank, :pay_coeficient, :pay_export_tag
      do begin
        PAY_VALUE = :PAY_VALUE * :value_corr_idx;
        for
          select EDL.LINE_ID, EDL.LINE_NAME, EDL.LINE_WOT_TAX, EDL.LINE_TAX, EDL.LINE_QTY,
                 EDL.ACC_NO, EDL.TAX_PERCENT, EDL.POSITION_NO, EDL.ID_SALE_TAXATION
          from   EXPORT_DOCUMENT_LINES(:id_doc_head, :group_tag, :pay_coeficient, :doc_rate_int) EDL
          into   :line_id, :line_name, :line_wot_vat, :line_vat, :line_qty,
                 :acc_no, :vat_value, :POSITION_NO, :ID_SALE_TAXATION
        do begin
          LINE_WOT_VAT = :LINE_WOT_VAT * :value_corr_idx;
          LINE_VAT = :LINE_VAT * :value_corr_idx;
          select min(st.ID_SALE_TAX)
          from   SALE_TAXATION_TAX ST
                 join SALE_TAXES t on t.ID_SALE_TAX = st.ID_SALE_TAX
          where  ST.ID_SALE_TAXATION = :ID_SALE_TAXATION
                 and t.REVENUE_DEDUCTION_TAX is distinct from 1
          having count(st.ID_SALE_TAX) = 1
          into   :ID_VAT_GROUP;

          suspend;
        end
      end
    end
  end
end
^

/* Alter (EXPORT_DOCUMENT_LINES) */
ALTER PROCEDURE EXPORT_DOCUMENT_LINES(ID_DOC_HEAD INTEGER,
GROUP_TAG VARCHAR(20),
PAY_COEFICIENT DOUBLE PRECISION,
DOC_RATE NUMERIC(15,4))
 RETURNS(LINE_ID INTEGER,
LINE_NAME VARCHAR(50),
LINE_WOT_TAX NUMERIC(15,4),
LINE_TAX NUMERIC(15,4),
LINE_QTY NUMERIC(15,4),
ACC_NO VARCHAR(30),
TAX_PERCENT NUMERIC(15,4),
ID_SALE_TAXATION INTEGER,
POSITION_NO INTEGER)
 AS
declare variable round_to numeric(15,4);
begin
  /*  Description:
  ||
  */

  select c.ROUND_TO
  from   DOC_HEAD d
         join currs c on c.CURR = d.DOC_CURRENCY
  where  d.ID_DOC = :ID_DOC_HEAD
  into   :round_to;

  POSITION_NO = 1;
  --PAY_COEFICIENT = abs(:PAY_COEFICIENT);    /* implicitly must be positive */
  if (upper(:group_tag) = 'SERVICES') then begin
    for
      select S.ID_SERVICE, S.SERVICE_NAME, S.ACCOUNT_NAME, DL.ID_SALE_TAXATION,
             round_f((DL.SINGLE_VALUE*(DL.QTY_POST) - DL.WOT_VAT) * :DOC_RATE * :PAY_COEFICIENT, :round_to),
             DL.QTY_POST, round_f(DL.WOT_VAT * :DOC_RATE * :PAY_COEFICIENT, :round_to), DL.VAT_PERCENT
      from   DOC_LINE DL
             join SERVICES S on S.ID_SERVICE = DL.ID_SERVICE
      where  DL.ID_DOC_HEAD = :id_doc_head
      into   :line_id, :line_name, :acc_no /* S-KA NAME - SCHETOVODNA */, :id_sale_taxation,
             :line_tax,
             :line_qty, :line_wot_tax, :tax_percent
    do begin
      suspend;
      POSITION_NO = :POSITION_NO + 1;
    end
  end else if (upper(:group_tag) = 'GRP_SERVICES') then begin
    for
      select SG.ID_SERVICE_GROUP, SG.GROUP_NAME, 'N/A', DL.ID_SALE_TAXATION,
             sum((DL.SINGLE_VALUE*(DL.QTY_POST) - DL.WOT_VAT) * :DOC_RATE * :PAY_COEFICIENT),
             sum(DL.QTY_POST), sum(DL.WOT_VAT * :DOC_RATE * :PAY_COEFICIENT), DL.VAT_PERCENT
      from   DOC_LINE DL
             join SERVICES S on S.ID_SERVICE = DL.ID_SERVICE
             join SERVICE_GROUPS SG on SG.ID_SERVICE_GROUP = S.ID_SERVICE_GROUP 
      where  DL.ID_DOC_HEAD = :id_doc_head
      group by SG.ID_SERVICE_GROUP, SG.GROUP_NAME, DL.VAT_PERCENT, DL.ID_SALE_TAXATION
      into   :line_id, :line_name, :acc_no /* S-KA NAME - SCHETOVODNA */, :id_sale_taxation,
             :line_tax,
             :line_qty, :line_wot_tax, :tax_percent
    do begin
      suspend;
      POSITION_NO = :POSITION_NO + 1;
    end
  end else if (upper(:group_tag) = 'GRP_ACCNO') then begin
    for
      select 1, S.ACCOUNT_NAME, S.ACCOUNT_NAME, DL.ID_SALE_TAXATION,
             sum((DL.SINGLE_VALUE*(DL.QTY_POST) - DL.WOT_VAT) * :DOC_RATE * :PAY_COEFICIENT),
             sum(DL.QTY_POST), sum(DL.WOT_VAT * :DOC_RATE * :PAY_COEFICIENT), DL.VAT_PERCENT
      from   DOC_LINE DL
             join SERVICES S on S.ID_SERVICE = DL.ID_SERVICE
      where  DL.ID_DOC_HEAD = :id_doc_head
      group by S.ACCOUNT_NAME, DL.VAT_PERCENT, DL.ID_SALE_TAXATION
      into   :line_id, :line_name, :acc_no /* S-KA NAME - SCHETOVODNA */, :id_sale_taxation,
             :line_tax,
             :line_qty, :line_wot_tax, :tax_percent
    do begin
      suspend;
      POSITION_NO = :POSITION_NO + 1;
    end
  end else if (upper(:group_tag) = 'FLAT') then begin
    acc_no = 'N/A'; line_id = 1;
    for
      select sum(DL.QTY_POST),
             sum(dl.WOT_VAT) * :DOC_RATE * :PAY_COEFICIENT,
             sum(dl.SINGLE_VALUE * dl.QTY_POST - dl.WOT_VAT) * :DOC_RATE * :PAY_COEFICIENT,
             DL.VAT_PERCENT, DL.ID_SALE_TAXATION
      from   DOC_LINE DL
      where  DL.ID_DOC_HEAD = :id_doc_head
      group by DL.VAT_PERCENT, DL.ID_SALE_TAXATION
      into   :line_qty, :line_wot_tax, :line_tax, :tax_percent, :id_sale_taxation
    do begin
      select substring(se.DEFAULT_CAPTION from 1 for 50)
      from   SYSTEM_ENUM SE
      where  SE.GROUP_ = 'doc.texts'
             and se.KEY_ = 'taxable'
      into   :line_name;

      if (:line_tax is null) then line_tax = 0;
      suspend;
      POSITION_NO = :POSITION_NO + 1;
    end
  end
end
^

/* Alter (EXPORT_PMS) */
ALTER PROCEDURE EXPORT_PMS RETURNS(ID_EXPORT_HEAD INTEGER)
 AS
declare variable start_date date;
  declare variable end_date date;
  declare variable id_hotel integer;
  declare variable initial_begining date;

  declare variable id_room integer;
  declare variable from_date date;
  declare variable to_date date;
  declare variable id_reserv_detail integer;
  declare variable id_doc_head integer;
  declare variable price_with_vat numeric (15,4);
  declare variable price_wo_vat numeric (15,4);
  declare variable curr char(3);
  declare variable new_id_event integer;
  declare variable export_cnt smallint;
  declare variable bednights integer;
  declare variable stay integer;
  declare variable reservs integer;
  declare variable id_contract integer;
  declare variable doc_description tdescription_long;
begin
  export_cnt = 0;
  for
    select H.ID_HOTEL, h.NATION_CURR
    from   HOTEL_S H
    into   :id_hotel, :curr
  do begin
    start_date = null;
    select first 1 EH.TO_SYS_DATE + 1
    from   RESERV_EXPORT$PMS EH
    where  EH.ID_HOTEL = :id_hotel
           and EH.IS_ANUL = 0
    order by EH.ID_EXPORT_HEAD desc
    into   :start_date;

    if (:start_date is null) then begin
      select min(RP.FROM_DATE)
      from   ROOMS R
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
             join ROOM_PERIOD$PMS RP on RP.ID_ROOM = R.ID_ROOM
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RT.ID_HOTEL = :id_hotel
             and RP.STATUS in ('PRIVATE','CONTRACT')
      into   :initial_begining;
      start_date = :initial_begining;
    end

    select sd.SYSTEM_DATE - 1
    from   SYSTEM_DATE_GET(:id_hotel) sd
    into   :end_date;

    if (:start_date <= :end_date) then begin
      export_cnt = :export_cnt + 1;
      id_export_head = gen_id(GEN_EXPORT_PMS_ID, 1);
  
      insert into RESERV_EXPORT$PMS (ID_EXPORT_HEAD, ID_HOTEL, FROM_SYS_DATE, TO_SYS_DATE, DT_CREATED, IS_ANUL, DT_ANUL)
      values (:id_export_head, :id_hotel, :start_date, :end_date, current_timestamp, 0, null);
  
      for
        select  ed.id_room, ed.id_reserv_detail, ed.id_contract,
                ed.from_date, ed.to_date, ed.price_with_vat, ed.price_wo_vat,
                ed.bednights, ed.stay, ed.reservs, ed.LAST_ID_DOC_HEAD, ed.DOC_DESCRIPTION
        from    EXPORT_DOCS$PMS (:start_date, :end_date, :id_hotel) ed
        into    :id_room, :id_reserv_detail, :id_contract,
                :from_date, :to_date, :price_with_vat, :price_wo_vat,
                :bednights, :stay, :reservs, :id_doc_head, :doc_description
      do begin
        execute procedure PMS_EVENT_CREATE$INT('INCOME', :id_room, null, '',
                null, :from_date, :to_date, :id_reserv_detail, :id_doc_head,
                :price_with_vat, :price_wo_vat, :curr, :id_export_head,
                :id_contract, :reservs, :stay, :bednights, :doc_description)
        returning_values :new_id_event;
      end

      suspend;
    end
  end

  if (:export_cnt = 0) then exception PMS_EXCEPTION '-618';
end
^

/* Alter (FISCAL_VALUE_GET$INT) */
ALTER PROCEDURE FISCAL_VALUE_GET$INT(ID_DOC_HEAD INTEGER)
 RETURNS(FISCAL_VALUE NUMERIC(15,2),
FISCAL_PAYMENT_CNT INTEGER,
FISCAL_PAYMENT_VALUE NUMERIC(15,2),
SALE_REDUCTION_COEF DOUBLE PRECISION)
 AS
begin
  fiscal_value = 0;
  fiscal_payment_cnt = 0;
  fiscal_payment_value = 0;
  sale_reduction_coef = 1;

  select count(*),
         cast(iif(DH.DOC_VALUE_A = 0, 1, sum(PH.EQUAL_DOC_VALUE) / DH.DOC_VALUE_A) as double precision),
         sum(ph.NAT_VALUE) * iif(dh.DOC_SUB_TYPE = 2, -1, 1)
  from   DOC_HEAD DH
         join DOCUMENT_PAYMENT PH on PH.ID_DOC_HEAD = DH.ID_DOC
         join PAY_DOC_TYPE_S PT on PT.ID_DOC_TYPE = PH.ID_DOC_TYPE
  where  DH.ID_DOC = :ID_DOC_HEAD
         and dh.FISC_STATUS > 0
         -- and pt.DOC_DIRECTION = 0
         and PT.IS_FISCALIZE = 1   --  get only fiscal payments
         -- and PH.IS_STORNO = 0
  group by dh.DOC_SUB_TYPE, DH.DOC_VALUE_A
  into   :fiscal_payment_cnt, :sale_reduction_coef, :fiscal_payment_value;

  if (:sale_reduction_coef > 1) then begin
    fiscal_value = :fiscal_payment_value / :sale_reduction_coef;
    sale_reduction_coef = 1;
  end else begin
    fiscal_value = :fiscal_payment_value;
  end
end
^

/* Alter (FISCALIZE_LINE$FISC) */
ALTER PROCEDURE FISCALIZE_LINE$FISC(ID_DOC_HEAD INTEGER)
 RETURNS(FISC_PRICE NUMERIC(15,4),
FISC_QTY NUMERIC(15,4),
FISC_TEXT VARCHAR(30),
FISC_GRP VARCHAR(10),
TRANSACTION_VALUE NUMERIC(15,4))
 AS
declare variable fld_sep varchar(10);
  declare variable line_sep varchar(10);
  declare variable line varchar(255);
  declare variable end_pos integer;
  declare variable lines_data blob sub_type 1 segment size 100;
  declare variable i integer;
  declare variable is_anul integer;
  declare variable fiscal_device_id varchar(10);
  declare variable storno_fiscal_device_id varchar(10);
  declare variable doc_sub_type integer;
begin
  select f.FISCAL_LINES, h.is_anul, f.FISCAL_DEVICE_ID, f.STORNO_FISCAL_DEVICE_ID, h.DOC_SUB_TYPE
  from   DOC_FISCAL_DATA f
         join DOC_HEAD h on h.ID_DOC = f.ID_DOC_HEAD
  where  f.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :lines_data, :is_anul, :fiscal_device_id, :storno_fiscal_device_id, :doc_sub_type;
  -- Status && fiscal data compatibility check
  if (:is_anul = 0 and :fiscal_device_id is not null) then
    exception FISCALIZE_EXCEPTION '-708';

  if (:is_anul = 1) then begin
    if (:doc_sub_type = 2) then exit;
    else if (:storno_fiscal_device_id is not null) then exception FISCALIZE_EXCEPTION '-709';
  end

  i = 0;
  fld_sep = f_character(28);
  line_sep = f_character(29);
  while (trim(:lines_data) <> '') do begin
    end_pos = position(:line_sep, :lines_data);
    line = substring(:lines_data from 1 for end_pos);
    lines_data = substring(:lines_data from end_pos + 1);
    if (:line <> '') then begin
      FISC_PRICE = substring(:line from 1 for position(:fld_sep, :line)-1);
      line = substring(:line from position(:fld_sep, :line)+1);
      FISC_QTY = substring(:line from 1 for position(:fld_sep, :line)-1);
      line = substring(:line from position(:fld_sep, :line)+1);
      FISC_TEXT = substring(:line from 1 for position(:fld_sep, :line)-1);
      line = substring(:line from position(:fld_sep, :line)+1);
      FISC_GRP = substring(:line from 1 for position(:fld_sep, :line)-1);
      line = substring(:line from position(:fld_sep, :line)+1);
      TRANSACTION_VALUE = substring(:line from 1 for position(:line_sep, :line)-1);
      suspend;
    end
    i= :i + 1;
    if (:i = 1000) then exit; -- Too many cycles, recursion prevents.
  end
end
^

/* Alter (FISCALIZE_MARK_DOC$FISC) */
ALTER PROCEDURE FISCALIZE_MARK_DOC$FISC(ID_DOC_HEAD INTEGER,
IS_MANUAL INTEGER,
FISCAL_DEVICE_ID VARCHAR(10))
 AS
declare variable fisc_status integer;
declare variable is_anul integer;
declare variable doc_sub_type integer;
begin
  fisc_status = null;
  select DH.FISC_STATUS, dh.IS_ANUL, dh.DOC_SUB_TYPE
  from   DOC_HEAD DH
  where  DH.ID_DOC = :id_doc_head
  into   :fisc_status, :is_anul, :doc_sub_type;

  if (:fisc_status is null) then begin
    exception INTERNAL_DOC_EXCEPTION 'The document does not exists! id='||:id_doc_head;
  end else if (:fisc_status = 0) then begin
    exit;
  end else if (:fisc_status = 2 and :is_anul = 0) then begin
    exception INTERNAL_DOC_EXCEPTION 'The document is already fiscalized. id='||:id_doc_head;
  end

  update DOC_COMPLETION Dc
  set    Dc.FISC_STATUS = 2,
         dc.DATETIME_FISCALIZED = current_timestamp
  where  Dc.ID_DOC_HEAD = :id_doc_head;

  if (:is_anul = 0 and :doc_sub_type < 2) then begin
    update DOC_FISCAL_DATA FD
    set    FD.FISCAL_DEVICE_ID = :FISCAL_DEVICE_ID
    where  fd.ID_DOC_HEAD = :id_doc_head;
  end else begin
    update DOC_FISCAL_DATA FD
    set    FD.STORNO_FISCAL_DEVICE_ID = :FISCAL_DEVICE_ID
    where  fd.ID_DOC_HEAD = :id_doc_head;
  end

  if (:IS_MANUAL is not distinct from 1) then
    execute procedure SYSTEM_LOG_ADD('DOCUMENT', :ID_DOC_HEAD, 'RE-FISCALIZE', '');
  else
    execute procedure SYSTEM_LOG_ADD('DOCUMENT', :ID_DOC_HEAD, 'FISCALIZE', '');
end
^

/* Alter (FISCALIZE_PAYMENT$FISC) */
ALTER PROCEDURE FISCALIZE_PAYMENT$FISC(ID_DOC_HEAD INTEGER)
 RETURNS(FISC_SUM NUMERIC(15,4),
FISC_TEXT VARCHAR(30),
FISC_GRP VARCHAR(10))
 AS
declare variable fld_sep varchar(10);
  declare variable line_sep varchar(10);
  declare variable line varchar(255);
  declare variable end_pos integer;
  declare variable payments_data blob sub_type 1 segment size 100;
  declare variable i integer;
  declare variable is_anul integer;
  declare variable fiscal_device_id varchar(10);
  declare variable storno_fiscal_device_id varchar(10);
  declare variable doc_sub_type integer;
begin
  select f.FISCAL_PAYMENTS, h.IS_ANUL, f.FISCAL_DEVICE_ID, f.STORNO_FISCAL_DEVICE_ID, h.DOC_SUB_TYPE
  from   DOC_FISCAL_DATA f
         join DOC_HEAD h on h.ID_DOC = f.ID_DOC_HEAD
  where  f.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :payments_data, :is_anul, :fiscal_device_id, :storno_fiscal_device_id, :doc_sub_type;
  -- Status && fiscal data compatibility check
  if (:is_anul = 0 and :fiscal_device_id is not null) then
    exception FISCALIZE_EXCEPTION '-708';

  if (:is_anul = 1) then begin
    if (:doc_sub_type = 2) then exit;
    else if (:storno_fiscal_device_id is not null) then exception FISCALIZE_EXCEPTION '-709';
  end

  i = 0;
  fld_sep = f_character(28);
  line_sep = f_character(29);
  while (trim(:payments_data) <> '') do begin
    end_pos = position(:line_sep, :payments_data);
    line = substring(:payments_data from 1 for :end_pos);
    payments_data = substring(:payments_data from :end_pos + 1);
    if (:line <> '') then begin
      FISC_SUM = substring(:line from 1 for position(:fld_sep, :line)-1);
      line = substring(:line from position(:fld_sep, :line)+1);
      FISC_TEXT = substring(:line from 1 for position(:fld_sep, :line)-1);
      line = substring(:line from position(:fld_sep, :line)+1);
      FISC_GRP = substring(:line from 1 for position(:line_sep, :line)-1);
      suspend;
    end
    i= :i + 1;
    if (:i = 1000) then exit; -- Too many cycles, recursion prevents.
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_SAVE_STAY$INT for: GUEST_ADJUST_GUESTSTAY$INT */
ALTER PROCEDURE RES_GUEST_SAVE_STAY$INT(G_DBKEY CHAR(8),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (GUEST_ADJUST_GUESTSTAY$INT) */
ALTER PROCEDURE GUEST_ADJUST_GUESTSTAY$INT(G_DBKEY CHAR(8))
 AS
declare variable id_guest integer;
  declare variable from_date date;
  declare variable to_date date;
  declare variable old_from_date date;
  declare variable old_to_date date;
  declare variable id_room_type integer;
  declare variable id_room integer;
  declare variable id_board integer;
  declare variable id_type_stay integer;
  declare variable id_tariff integer;
  declare variable for_date date;
  declare variable id_hotel integer;
  declare variable current_id_room integer;
  declare variable system_date date;
begin
  for
    select G.ID_GUEST, rd.FROM_DATE, rd.TO_DATE, rd.ID_ROOM, rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  G.RDB$DB_KEY = :g_dbkey
    into   :id_guest, :from_date, :to_date, :current_id_room, :id_hotel
  do begin
    execute procedure SYSTEM_DATE_GET (:id_hotel)
    returning_values (:system_date);
  
    if (:to_date <= :from_date) then exception ASSERT '-53';
  --  else if ((:to_date - :from_date) > 366) then exception WRONG_GUEST_PERIOD;
  
    select min(GS.FOR_DATE), max(GS.FOR_DATE)+1
    from   GUEST_STAY GS
    where  GS.ID_GUEST = :id_guest
    into   :old_from_date, :old_to_date;
  
    if (:old_to_date < :to_date) then begin
      select GS.ID_ROOM_TYPE, GS.ID_BOARD, GS.ID_TYPE_STAY, GS.ID_TARIFF, /*GS.ID_PACKET, */GS.ID_ROOM
      from   GUEST_STAY GS
      where  GS.ID_GUEST =  :id_guest
             and GS.FOR_DATE = :old_to_date - 1
      into   :id_room_type, :id_board, :id_type_stay, :id_tariff, /*:id_packet, */:id_room;
      for
        select RLP.OUT_DATE
        from   SYSTEM_LOOP_PERIOD(:old_to_date, :to_date - 1) RLP
        into   :for_date
      do begin
        insert into GUEST_STAY (ID_GUEST, FOR_DATE, ID_ROOM_TYPE, ID_BOARD, ID_TYPE_STAY,
               ID_TARIFF, /*ID_PACKET, */ID_ROOM)
        values (:id_guest, :for_date, :id_room_type, :id_board, :id_type_stay,
               :id_tariff, /*:id_packet, */iif(:for_date < :system_date, :id_room, :current_id_room)/* !!!! */ );
      end
    end
    if (:old_from_date > :from_date) then begin
      select GS.ID_ROOM_TYPE, GS.ID_BOARD, GS.ID_TYPE_STAY, GS.ID_TARIFF, /*GS.ID_PACKET, */GS.ID_ROOM
      from   GUEST_STAY GS
      where  GS.ID_GUEST = :id_guest
             and GS.FOR_DATE = :old_from_date
      into   :id_room_type, :id_board, :id_type_stay, :id_tariff, /*:id_packet, */:id_room;
      for
        select RLP.OUT_DATE
        from   SYSTEM_LOOP_PERIOD(:from_date, :old_from_date - 1) RLP
        into   :for_date
      do begin
        insert into GUEST_STAY (ID_GUEST, FOR_DATE, ID_ROOM_TYPE, ID_BOARD, ID_TYPE_STAY, ID_TARIFF, /*ID_PACKET, */ID_ROOM)
        values (:id_guest, :for_date, :id_room_type, :id_board, :id_type_stay, :id_tariff, /*:id_packet, */:id_room);
      end
    end
    if (:old_from_date < :from_date) then
      delete from GUEST_STAY GS
      where  GS.ID_GUEST = :id_guest
             and GS.FOR_DATE < :from_date;
    if (:old_to_date > :to_date) then begin
      delete from GUEST_STAY GS
      where  GS.ID_GUEST = :id_guest
             and GS.FOR_DATE >= :to_date;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTING$INT for: GUEST_AGENT_SET$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (GUEST_AGENT_SET$INT) */
ALTER PROCEDURE GUEST_AGENT_SET$INT(G_DBKEY CHAR(8),
NEW_ID_AGENT_PROFILE INTEGER)
 AS
declare variable id_guest integer;
  declare variable old_id_agent integer;
  declare variable new_id_agent integer;
  declare variable from_date date;
  declare variable birth_day date;
  declare variable id_agent_ages integer;
  declare variable is_check_in smallint;
begin

  new_id_agent = null;
  select PA.ID_AGENT
  from   PROFILE_AGENT PA
  where  PA.ID_PROFILE = :new_id_agent_profile
  into   :new_id_agent;

  select G.ID_AGENT, G.ID_GUEST, g.FROM_DATE, g.IS_CHECK_IN
  from   GUEST G
  where  G.RDB$DB_KEY = :g_dbkey
  into   :old_id_agent, :id_guest, :from_date, :is_check_in;

  -- new_id_agent = iif(:is_different_organizer = 1, null, :new_id_agent);
  -- different arranged guests can be walkins only

  if (:new_id_agent is distinct from :old_id_agent) then begin
    update GUEST G
    set    G.ID_AGENT = :new_id_agent
    where  G.RDB$DB_KEY = :g_dbkey;

    if (:is_check_in = 1) then begin
      execute procedure GUEST_REGISTRATION_UPDATE(:id_guest);
    end
  end

  if (:new_id_agent is distinct from :old_id_agent) then begin
    select gc.BIRTH_DAY
    from   GUEST_CARD GC
    where  gc.ID_GUEST = :id_guest
    into   :birth_day;

    execute procedure GUEST_GET_AGENT_AGES(:new_id_agent, :birth_day, :from_date)
    returning_values  :id_agent_ages;

    update GUEST G
    set    g.ID_AGENT_AGES = :id_agent_ages
    where  g.RDB$DB_KEY = :G_DBKEY;
  end
end
^

/* empty dependent procedure body */
/* Clear: POST_PREPARE_ON_GUEST$POST for: GUEST_GET_POSTING_ACCOUNT$INT */
ALTER PROCEDURE POST_PREPARE_ON_GUEST$POST(ID_GUEST /* ID_REF */ INTEGER,
ID_SERVICE /* ID_REF */ INTEGER,
QTY /* TQTY */ NUMERIC(15,2),
ID_SEQUENCE /* TRANGE */ INTEGER,
PRICE_POST /* TPRICE */ NUMERIC(15,4),
CURR_POST /* TCURRENCY */ CHAR(3),
POST_TEXT /* TOBJECT_TEXT */ VARCHAR(50),
FROM_DATE /* TDATE */ DATE,
TO_DATE /* TDATE */ DATE)
 RETURNS(NEW_FROM_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* Alter (GUEST_GET_POSTING_ACCOUNT$INT) */
ALTER PROCEDURE GUEST_GET_POSTING_ACCOUNT$INT(ID_GUEST INTEGER,
ACCOUNT_ROUTING VARCHAR(10))
 RETURNS(ID_ACCOUNT INTEGER,
ID_ROOM INTEGER)
 AS
declare variable ID_BASE_ACCOUNT integer;
begin

  select A.ID_ACCOUNT, BA.ID_ACCOUNT, G.ID_ROOM
  from   GUEST G
         left outer join ACCOUNT_S A on A.ID_ACCOUNT = G.ID_ACCOUNT
         left outer join ACCOUNT_S BA on BA.ID_ACCOUNT = G.ID_BASE_ACCOUNT
  where  G.ID_GUEST = :ID_GUEST
  into   :ID_ACCOUNT, :ID_BASE_ACCOUNT, :ID_ROOM;

  if ((:ACCOUNT_ROUTING = 'BASE') or (coalesce(:ID_ACCOUNT, -1) <= 0)) then ID_ACCOUNT = :ID_BASE_ACCOUNT;

  if (coalesce(:ID_ACCOUNT, -1) <= 0) then exception POSTING_EXCEPTION '-55';
     
end
^

/* Alter (HK_PLAN_LINES_FINALIZE$HK) */
ALTER PROCEDURE HK_PLAN_LINES_FINALIZE$HK(ID_PLAN_PERIOD INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
begin
  WARN_CODE = null;

/*
  if ( exists (select *
               from   HK_PLAN_PERIOD PP
                      join HK_RESERVATION R on R.ID_HK_PLAN = PP.ID_PLAN
               where  PP.ID_PLAN_PERIOD = :ID_PLAN_PERIOD )) then begin
    execute procedure SYSTEM_WARNING_ADD(-607, 'HK_PLAN_LINES_FINALIZE$HK_1');
    WARN_CODE = current_transaction; */


  if ( exists (select *
               from   HK_RESERVATION R
                      join HK_PLAN_PERIOD PP on PP.ID_PLAN = R.ID_HK_PLAN
                      join HK_PLAN_LINE L on L.ID_PLAN_PERIOD = PP.ID_PLAN_PERIOD
                      join TMP_SELECT$HK TMP on TMP.ID_PLAN_LINE = L.ID_PLAN_LINE
                                            and TMP.ID_ROOM_TYPE = R.ID_ROOM_TYPE
               where TMP.ID_SESSION = current_transaction
                     and PP.ID_PLAN_PERIOD = :ID_PLAN_PERIOD )) then begin
    execute procedure SYSTEM_WARNING_ADD(-607, 'HK_PLAN_LINES_FINALIZE$HK')
    returning_values :WARN_CODE;
  end

  delete from TMP_SELECT$HK H
  where H.ID_SESSION = current_transaction;
end
^

/* Alter (HK_PLAN_PERIOD_MODIFY$HK) */
ALTER PROCEDURE HK_PLAN_PERIOD_MODIFY$HK(ID_PLAN_PERIOD INTEGER,
ID_PLAN INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
OPERATION VARCHAR(10))
 RETURNS(NEW_ID_PLAN_PERIOD INTEGER,
WARN_CODE INTEGER)
 AS
begin
  WARN_CODE = null;
  execute procedure SYSTEM_CHECK_OPERATION(:OPERATION, 'add, mod, del');

  if (:OPERATION in ('add', 'mod')) then begin
    if (exists (select P.FROM_DATE, P.TO_DATE
                from   HK_PLAN_PERIOD P
                where  P.ID_PLAN = :ID_PLAN
                       and P.ID_PLAN_PERIOD is distinct from :ID_PLAN_PERIOD
                       and P.FROM_DATE <= :TO_DATE
                       and P.TO_DATE >= :FROM_DATE)) then
    exception VALIDATE_EXCEPTION '-608';
  end

  if (:OPERATION = 'add') then begin
    NEW_ID_PLAN_PERIOD = gen_id(GEN_HK_PLAN_PERIOD_ID, 1);
    insert into HK_PLAN_PERIOD(ID_PLAN_PERIOD, ID_PLAN, FROM_DATE, TO_DATE)
    values (:NEW_ID_PLAN_PERIOD, :ID_PLAN, :FROM_DATE, :TO_DATE);

  end else if (:OPERATION = 'mod') then begin
    update HK_PLAN_PERIOD
    set ID_PLAN = :ID_PLAN,
        FROM_DATE = :FROM_DATE,
        TO_DATE = :TO_DATE
    where (ID_PLAN_PERIOD = :ID_PLAN_PERIOD);

  end else if (:OPERATION = 'del') then begin
    select K.FROM_DATE, K.TO_DATE
    from   HK_PLAN_PERIOD K
    where  K.ID_PLAN_PERIOD = :ID_PLAN_PERIOD
    into   :FROM_DATE, :TO_DATE;

    delete from HK_PLAN_PERIOD
    where (ID_PLAN_PERIOD = :ID_PLAN_PERIOD);
  end

  if ( exists (select *
               from   HK_RESERVATION R
               where  R.ID_HK_PLAN = :ID_PLAN
                      and R.BUSY_DATE between :FROM_DATE and :TO_DATE )) then begin
    execute procedure SYSTEM_WARNING_ADD(-607, 'HK_PLAN_PERIOD_MODIFY$HK')
    returning_values :WARN_CODE;
  end
end
^

/* Alter (HK_PROCEDURES_CALC$INT) */
ALTER PROCEDURE HK_PROCEDURES_CALC$INT(FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM INTEGER,
WITH_NON_OPER SMALLINT,
WITH_AGENT SMALLINT)
 RETURNS(ID_AGENT_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
ITEM_NAME VARCHAR(50),
ROOM_NAME VARCHAR(10),
ROOM_TYPE_NAME VARCHAR(20),
OUT_HOTEL INTEGER,
QTY INTEGER,
AMOUNT NUMERIC(15,2))
 AS
BEGIN
  for
    select G1.ID_AGENT_PROFILE, G1.PROFILE_NAME, G1.ITEM_NAME, G1.ROOM_NAME,
           G1.ROOM_TYPE_NAME, G1.OUT_HOTEL, sum(G1.QTY), sum(G1.AMOUNT)
    from   SYSTEM_LOOP_PERIOD(:from_date, :to_date) S1
           join HK_CALC_GUEST(S1.OUT_DATE, :id_room, :with_non_oper, :with_agent) G1 on 1=1
           join HOTEL_S H1 on H1.ID_HOTEL = G1.OUT_HOTEL
    group by 1, 2, 3, 4, 5, 6
    union all
    select G2.ID_AGENT_PROFILE, G2.proFILE_NAME, G2.ITEM_NAME, G2.ROOM_NAME,
           G2.ROOM_TYPE_NAME, G2.OUT_HOTEL, sum(G2.QTY), sum(G2.AMOUNT)
    from   SYSTEM_LOOP_PERIOD(:from_date, :to_date) S2
           join HK_CALC_RESERVATION(S2.OUT_DATE, :id_room, :with_non_oper, :with_agent) G2 on 1=1
           join HOTEL_S H2 on H2.ID_HOTEL = G2.OUT_HOTEL
    group by 1, 2, 3, 4, 5, 6
    into   :id_agent_profile, :profile_name, :item_name, :room_name,
           :room_type_name, :out_hotel, :qty, :amount
  do suspend;
END
^

/* Alter (HK_PROCEDURES_CALC$RPT) */
ALTER PROCEDURE HK_PROCEDURES_CALC$RPT(FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM INTEGER,
PER_HOTEL VARCHAR(255),
PER_SECTOR INTEGER,
PER_FLOOR INTEGER,
WITH_NON_OPER SMALLINT,
WITH_AGENT SMALLINT)
 RETURNS(ID_AGENT_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
ITEM_NAME VARCHAR(50),
ROOM_NAME VARCHAR(10),
ROOM_TYPE_NAME VARCHAR(20),
OUT_HOTEL INTEGER,
QTY INTEGER,
AMOUNT NUMERIC(15,2))
 AS
declare variable curr_id_room integer;
BEGIN

  if (:ID_ROOM is null) then begin
    for
      select R.ID_ROOM
      from   ROOMS R
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
             join HOTEL_S H on H.ID_HOTEL = RT.ID_HOTEL
             join SYSTEM_STRING_PARSER(:per_hotel,',') S on S.ITEM = H.ID_HOTEL
      where  ((:per_sector = -1) or (R.SECTOR = :per_sector))
             and ((:per_floor = -1) or (R.FLOOR = :per_floor))
      into   :curr_id_room
    do begin
      for
        select G1.ID_AGENT_PROFILE, G1.PROFILE_NAME, G1.ITEM_NAME, G1.ROOM_NAME,
               G1.ROOM_TYPE_NAME, G1.OUT_HOTEL, G1.QTY, G1.AMOUNT
        from   HK_PROCEDURES_CALC$INT(:from_date, :to_date, :curr_id_room, :with_non_oper, :with_agent) G1
        into   :id_agent_profile, :profile_name, :item_name, :room_name,
               :room_type_name, :out_hotel, :qty, :amount
      do suspend;
    end
  end else begin
    for
      select G1.ID_AGENT_PROFILE, G1.PROFILE_NAME, G1.ITEM_NAME, G1.ROOM_NAME,
             G1.ROOM_TYPE_NAME, G1.OUT_HOTEL, G1.QTY, G1.AMOUNT
      from   HK_PROCEDURES_CALC$INT(:from_date, :to_date, :id_room, :with_non_oper, :with_agent) G1
      into   :id_agent_profile, :profile_name, :item_name, :room_name,
             :room_type_name, :out_hotel, :qty, :amount
    do suspend;
  end
END
^

/* Alter (HK_ROOM_STATUS$RPT) */
ALTER PROCEDURE HK_ROOM_STATUS$RPT(FROM_DATE DATE,
TO_DATE DATE,
PER_HOTEL VARCHAR(255),
PER_SECTOR INTEGER,
PER_FLOOR INTEGER,
PRIVATE_STATUS_ADDING SMALLINT = 0)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
SECTOR INTEGER,
ID_ROOM_TYPE INTEGER,
TYPE_ROOM VARCHAR(20),
IS_CLEAN INTEGER,
IS_INSPECTED INTEGER,
CLEAN_TEXT VARCHAR(30),
CLEAN_STATUS VARCHAR(30),
BUSY_DAY SMALLINT,
GUESTS_CNT INTEGER,
LEAVING_GUESTS_CNT INTEGER,
IS_LEAVING SMALLINT,
IS_COMMING SMALLINT,
IS_SHARED SMALLINT,
IS_LEAVING_WORDS VARCHAR(30),
BUSY_GRP INTEGER,
DAYS_THIS_STATUS INTEGER,
DTS_CONTEXT VARCHAR(10),
COMMING_OCCUPANTS VARCHAR(1024),
ID_BLOCK_ROOM INTEGER,
OTHER_OCCUPANTS VARCHAR(1024),
SPECIAL_TREATMENT VARCHAR(1024),
ID_HOTEL INTEGER,
IS_BUSY SMALLINT,
IS_OWNER SMALLINT)
 AS
BEGIN

  insert into TMP_SMART_ROOMS (ID_SESSION, ID_ROOM)
  select current_connection, R.ID_ROOM
  from   ROOMS R
         join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
         join HOTEL_S H on H.ID_HOTEL = RT.ID_HOTEL
         join SYSTEM_STRING_PARSER(:per_hotel,',') S on S.ITEM = H.ID_HOTEL
  where  ((:per_sector = -1) or (R.SECTOR = :per_sector))
         and ((:per_floor = -1) or (R.FLOOR = :per_floor));

  for
    select ID_ROOM, ROOM_NAME, FLOOR, SECTOR, ID_ROOM_TYPE, TYPE_ROOM,
           IS_CLEAN, IS_INSPECTED, CLEAN_TEXT, CLEAN_STATUS, BUSY_DAY,
           GUESTS_CNT, LEAVING_GUESTS_CNT, IS_LEAVING, IS_COMMING, IS_SHARED,
           IS_LEAVING_WORDS, BUSY_GRP, DAYS_THIS_STATUS, DTS_CONTEXT,
           COMMING_OCCUPANTS, ID_BLOCK_ROOM, OTHER_OCCUPANTS,
           SPECIAL_TREATMENT, ID_HOTEL, IS_BUSY, IS_OWNER
    from   SYSTEM_LOOP_PERIOD(:FROM_DATE, :TO_DATE) S
           join HK_ROOM_STATUS$INT(S.OUT_DATE, :private_status_adding) G on 1=1
    into   :ID_ROOM, :ROOM_NAME, :FLOOR, :SECTOR, :ID_ROOM_TYPE, :TYPE_ROOM,
           :IS_CLEAN, :IS_INSPECTED, :CLEAN_TEXT, :CLEAN_STATUS, :BUSY_DAY,
           :GUESTS_CNT, :LEAVING_GUESTS_CNT, :IS_LEAVING, :IS_COMMING, :IS_SHARED,
           :IS_LEAVING_WORDS, :BUSY_GRP, :DAYS_THIS_STATUS, :DTS_CONTEXT,
           :COMMING_OCCUPANTS, :ID_BLOCK_ROOM, :OTHER_OCCUPANTS,
           :SPECIAL_TREATMENT, :ID_HOTEL, :IS_BUSY, :IS_OWNER
  do suspend;

  delete
  from TMP_SMART_ROOMS T
  where T.ID_SESSION = current_connection;
END
^

ALTER PROCEDURE HOTEL_MODIFY$CFG(ID_HOTEL INTEGER,
HOTEL_NAME VARCHAR(50),
IS_USE SMALLINT,
CODE VARCHAR(10),
LETTER_FOOTER BLOB SUB_TYPE 1,
LETTER_HEADER BLOB SUB_TYPE 1,
ID_LOGO INTEGER,
ORDER_TAG INTEGER,
RES_CONFIRM_TEXT BLOB SUB_TYPE 1,
COMPANY_NAME TYPE OF TDESCRIPTION_LONG,
COMPANY_IDENT_NUM TYPE OF TTEXT_SHORT,
COMPANY_VAT_REG_NUM TYPE OF TTEXT_SHORT,
COMPANY_MOL TYPE OF TPERSON_NAME,
COMPANY_ADDRESS TYPE OF TDESCRIPTION_LONG,
DOC_PACK_SRV_TEXT VARCHAR(50),
DOC_ONE_LINE_TEXT VARCHAR(50),
EXTERNAL_TYPE VARCHAR(50),
HOTEL_ADDRESS VARCHAR(100),
OPERATION VARCHAR(10),
NATION_CURR CHAR(3),
REG_CARD_TEXT BLOB SUB_TYPE 1 = null,
USE_DIFFERENT_TT_NUMERATORS TLOGICAL = null,
ACCOMODATION_PLACE_UIN TYPE OF TDESCRIPTION_LONG = null)
 RETURNS(NEW_ID_HOTEL INTEGER)
 AS
declare variable id_extra_rate integer;
  declare variable init_sys_date date;
  declare variable new_id_physical_allotment integer;
  declare variable new_id_overbook_allotment integer;
  declare variable id_guest_numerator integer;
  declare variable tt_numerator_use integer;
  declare variable tt_numerator_1 integer;
  declare variable tt_numerator_2 integer;
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  new_id_hotel = :id_hotel;
  if (:operation = 'add') then begin

    execute procedure ALLOTMENT_CREATE$INT
    returning_values  :new_id_overbook_allotment;

    execute procedure ALLOTMENT_CREATE$INT
    returning_values  :new_id_physical_allotment;

    new_id_hotel = gen_id(GEN_HOTEL_ID,1);
    init_sys_date = '01.01.2011';
    code = coalesce(:code, :NEW_ID_HOTEL);

    insert into HOTEL (ID_HOTEL, HOTEL_NAME, IS_USE, CODE, LETTER_HEADER, LETTER_FOOTER, ID_LOGO, SYSTEM_DATE,
           ID_OVERBOOK_ALLOTMENT, ID_PHYSICAL_ALLOTMENT, ID_INVENTORY_ALLOTMENT, ORDER_TAG,
           RES_CONFIRM_TEXT, DOC_PACK_SRV_TEXT, DOC_ONE_LINE_TEXT, EXTERNAL_TYPE, HOTEL_ADDRESS,
           COMPANY_NAME, COMPANY_IDENT_NUM, COMPANY_VAT_REG_NUM, COMPANY_MOL, COMPANY_ADDRESS,
           NATION_CURR, REG_CARD_TEXT, ACCOMODATION_PLACE_UIN)
    values (:new_id_hotel, :hotel_name, :is_use, :code, :letter_header, :letter_footer, :id_logo, :init_sys_date,
           :new_id_overbook_allotment, :new_id_physical_allotment, :new_id_physical_allotment, :order_tag,
           :res_confirm_text, :doc_pack_srv_text, :doc_one_line_text, :external_type, :hotel_address,
           :company_name, :company_ident_num, :company_vat_reg_num, :company_mol, :company_address,
           :nation_curr, :reg_card_text, :ACCOMODATION_PLACE_UIN);
    --returning subscriber_id into :subscriber_id;

    execute procedure GUEST_NUMERATOR_MODIFY$INT (null, :CODE || '_GUEST_NUM', 1, 'add', :NEW_ID_HOTEL)
    returning_values  :id_guest_numerator;

    select si.INFO_VALUE
    from   SYSTEM_INFO_GET ('TT_NUMERATOR_USE') si
    into   :tt_numerator_use;

    if (:tt_numerator_use = 1) then begin
      execute procedure GUEST_NUMERATOR_MODIFY$INT (null, :CODE || '_TT_NUM_1', 1, 'add', :new_id_hotel)
      returning_values  :tt_numerator_1;
      execute procedure GUEST_NUMERATOR_MODIFY$INT (null, :CODE || '_TT_NUM_2', 1, 'add', :new_id_hotel)
      returning_values  :tt_numerator_2;
    end

    execute procedure TARIFA_MODIFY$CFG(null, null, 'Extra service rates', null, :NATION_CURR, 1, '', :new_id_hotel, 0, null, 1, 'addextra')
    returning_values  :id_extra_rate;

    update HOTEL H
    set    h.ID_GUEST_NUMERATOR = :id_guest_numerator,
           h.ID_TT_NUMERATOR_1 = :tt_numerator_1,
           h.ID_TT_NUMERATOR_2 = :tt_numerator_2,
           h.USE_DIFFERENT_TT_NUMERATORS = :USE_DIFFERENT_TT_NUMERATORS,
           H.ID_EXTRA_RATE = :id_extra_rate
    where  h.ID_HOTEL = :NEW_ID_HOTEL;

    execute procedure RES_TEMPLATE_MODIFY$CFG (gen_id(GEN_RES_TEMPLATE_ID,1),
      1, 0, null, null, null, 'dinner', -2, null, null, null, :new_id_hotel,
      '', 'TU', 'VA', '', '', NULL);

    execute procedure CURR_RATE_MODIFY (:NATION_CURR, :NEW_ID_HOTEL, 1, :init_sys_date);

    insert into RIGHTS_USER_HOTEL (USER_NAME, ID_HOTEL)
    values (current_user, :NEW_ID_HOTEL);

    execute procedure SYSTEM_CACHE_APPLY('end_work');

  end else if (:operation = 'mod') then begin
    update HOTEL h
    set    HOTEL_NAME = :hotel_name,
           IS_USE = :is_use,
           CODE = :code,
           COMPANY_NAME = :COMPANY_NAME,
           COMPANY_IDENT_NUM = :COMPANY_IDENT_NUM,
           COMPANY_VAT_REG_NUM = :COMPANY_VAT_REG_NUM,
           COMPANY_MOL = :COMPANY_MOL,
           COMPANY_ADDRESS = :COMPANY_ADDRESS,
           LETTER_HEADER = :letter_header,
           LETTER_FOOTER = :letter_footer,
           ID_LOGO = :id_logo,
           ORDER_TAG = :order_tag,
           RES_CONFIRM_TEXT = :res_confirm_text,
           DOC_PACK_SRV_TEXT = :doc_pack_srv_text,
           DOC_ONE_LINE_TEXT = :doc_one_line_text,
           EXTERNAL_TYPE = :external_type,
           HOTEL_ADDRESS = :hotel_address,
           REG_CARD_TEXT = :reg_card_text,
           USE_DIFFERENT_TT_NUMERATORS = coalesce(:USE_DIFFERENT_TT_NUMERATORS, h.USE_DIFFERENT_TT_NUMERATORS),
           ACCOMODATION_PLACE_UIN = :ACCOMODATION_PLACE_UIN
    where  ID_HOTEL = :id_hotel;

    execute procedure SYSTEM_LOG_ADD ('HOTEL', :ID_HOTEL, 'HOTEL_CHANGED', :HOTEL_NAME);

  end else if (:OPERATION = 'del') then begin
    execute procedure SYSTEM_LOG_ADD ('HOTEL', :ID_HOTEL, 'DELETE', '');

    select h.ID_LOGO
    from   HOTEL h
    where  h.ID_HOTEL = :id_hotel
    into   :ID_LOGO;

    delete from HOTEL
    where  ID_HOTEL = :id_hotel;

    if (:ID_LOGO is not null) then begin
      execute procedure PICTURE_MODIFY(:ID_LOGO, null, null, null, 'del')
      returning_values  (:ID_LOGO);
    end
  end
end
^

/* Alter (HOTEL_AUTO_IMPORT$WBE) */
ALTER PROCEDURE HOTEL_AUTO_IMPORT$WBE(NAME VARCHAR(50),
UUID VARCHAR(40))
 RETURNS(ID_HOTEL INTEGER)
 AS
declare variable tmp_id integer;
declare variable nation_curr tcurrency;
declare variable id_sale_tax integer;
declare variable id_sale_taxation integer;
declare variable id_tax_policy integer;
declare variable id_acc_template integer;
begin
  select id_hotel
  from   hotel
  where  uuid = :uuid
         and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :id_hotel;

  execute procedure sys_dbg('wbe HOTEL_AUTO_IMPORT$WBE('
  || 'name => ' || coalesce(:name, '<null>')
  || ', uuid => ' || coalesce(:uuid, '<null>')
  ||') => {:id_hotel => ' || coalesce(:id_hotel, '<null>')
  || '}');

  if (:id_hotel is null) then begin
    execute procedure PICTURE_MODIFY (null, null, 'ptEmpty', 'plAsIs', 'add')
    returning_values :tmp_id;

    nation_curr = 'BGN';

    execute procedure HOTEL_MODIFY$CFG(null, :uuid, 1, null, null, null, :tmp_id, null, null, null, null, null,
            null, null, null, null, null, null, 'add', :nation_curr, null)
    returning_values  :id_hotel;

    update hotel
    set    uuid=:uuid
    where  id_hotel=:id_hotel;

    execute procedure SALE_TAX_MODIFY$CFG(null, 'WBE default', 0, 0, null, 0, 0, 'A', null, 'add', :id_hotel, '')
    returning_values :id_sale_tax;

    execute procedure SALE_TAXATION_MODIFY$CFG(null, 'WBE default',
            :id_sale_tax, null, 'add', :id_hotel)
    returning_values :id_sale_taxation;

    execute procedure TAX_POLICY_MODIFY$CFG(null, 'WBE default', 0, 'add', :id_hotel)
    returning_values :id_tax_policy;

    execute procedure SETTINGS_MODIFY_VALUE ('DEF_SERVICE_TAXATION', :id_sale_taxation, :id_hotel);

    execute procedure ACCOUNT_MODIFY_TEMPLATE$PROFILE(null,
        :ID_HOTEL || ' - WBE default', 0, null, 0, 1, :id_tax_policy, 0, 'add', :id_hotel)
    returning_values :id_acc_template;

    execute procedure SETTINGS_MODIFY_VALUE ('DEF_ACC_TEMPLATE', :id_acc_template, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('DEF_OWNER_ACC_TEMPLATE', :id_acc_template, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('NATIVE_NATION', 'BG', :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('DEF_COUNTRY', 'BG', :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('ROOMTYPE_ON_CHANGE_ROOM', 'ASK', :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('ROOMS_PREFERD_SORT_ORDER', 2, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('GUEST_POSTING_RATE', 'OCCUR_DATE', :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('MARK_DIRTY_EXPIRED_BLOCK', 0, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('MARK_DIRTY_OCC_ROOM', 0, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('DAY_KEEP_TYPES', 1, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('DAY_KEEP_NUMBERS', 0, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('CLEANING_RESTRICTION', 0, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('DEF_GUEST_MASK', '', :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('DEFAULT_DEPOSIT_DESCRIPTION', 'Booking deposit', :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('REPORT_LEAVING', 'AS_LEAVING', :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('CHECK_OVERBOOK', 1, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('RESTRICT_VATS_IN_DOC', 1, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('NEGATIVE_POSTINGS', 0, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('REVENUE_ACCOUNT_METHOD', 0, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('ACCOUNT_TO_DOC_RATE', 'CURRENT_RATE', :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('CHILDREN_MAX_AGE', 18, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('FEMALE_2ND_GROUP_MIN_AGE', 55, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('MALE_2ND_GROUP_MIN_AGE', 60, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('MARKETING_SEGMENT_REQUIRED', 0, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('VIEW_STORNO_SUMS_IN_DOCUMENTS', 'AS_POSITIVE', :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('STORNO_PAYMENTS_RESTRICT', 1, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('CHECK_OUT_HOUR', 12, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('CHECK_IN_HOUR', 14, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('SEPARATE_ACCOUNTS_PER_PAYER', 0, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('IFC_USE_FOLIO_NO', 1, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('IFC_AUTO_ATTACH_FOLIO_NUM', 0, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('ACTIVITY_OFFER_COPY', 0, :id_hotel);

  end
end
^

/* Alter (IMPORT_CONTRAGENT$EXC) */
ALTER PROCEDURE IMPORT_CONTRAGENT$EXC(CONTRAGENT_NAME VARCHAR(100),
IS_JURIDICAL_PERSON SMALLINT,
IDENT_NO VARCHAR(30),
VAT_REG_NUM VARCHAR(30),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(100),
COUNTRY_CODE VARCHAR(10),
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30),
UUID VARCHAR(40),
CREATE_ONLY SMALLINT)
 RETURNS(ID_CONTRAGENT INTEGER)
 AS
declare variable IS_INSERT smallint;
begin
  execute procedure import_mark_transaction$exc;

  ID_CONTRAGENT = null;
  select c.ID_CONTRAGENT
  from CONTRAGENTS c
  where c.uuid = :UUID and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :ID_CONTRAGENT;

  /* FIXME - remove this fallback lookup by name (depends on the separate contragents exchange implementation)*/
  if (:ID_CONTRAGENT is null) then begin
    select c.ID_CONTRAGENT
    from CONTRAGENTS c
    where c.contragent_name = :contragent_name and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
    into :ID_CONTRAGENT;
  end

  IS_INSERT = 0;
  if (ID_CONTRAGENT is null) then begin
    IS_INSERT = 1;
  end else if (1 = :create_only) then begin
    exit;
  end

  execute procedure CONTRAGENT_MODIFY$CONTR(:ID_CONTRAGENT, :CONTRAGENT_NAME,
    :IS_JURIDICAL_PERSON, :IDENT_NO, :VAT_REG_NUM, :POST_ADDRESS, :ZIP_CODE,
    :EMAIL, :MOL, :COUNTRY_CODE, :BANK_NAME, :BIC, :IBAN)
  returning_values :ID_CONTRAGENT;

  if (IS_INSERT = 1) then begin
    update CONTRAGENTS c
      set c.UUID = :UUID
      where c.ID_CONTRAGENT = :ID_CONTRAGENT;
  end
end
^

/* empty dependent procedure body */
/* Clear: CREATE_BOOKING$WBE for: IMPORT_GUEST$EXC */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
 BEGIN SUSPEND; END
^

/* Alter (IMPORT_GUEST$EXC) */
ALTER PROCEDURE IMPORT_GUEST$EXC(BOOKING_ID INTEGER,
PROFILE_UUID VARCHAR(40),
GUEST_UUID VARCHAR(40),
GUEST_NAME VARCHAR(100),
IS_CHILD SMALLINT,
AGE INTEGER,
IS_DIFFERENT_ARRANGER SMALLINT,
ARRIVAL DATE,
DEPARTURE DATE,
VOUCHER VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
RATING_AGE INTEGER,
KPP VARCHAR(50),
KPP_DATE DATE,
STAY_REASON VARCHAR(255),
CAR VARCHAR(30),
IS_REGISTRED SMALLINT,
PERSONAL_NUMBER VARCHAR(30),
TITLE VARCHAR(10),
PT_NAME VARCHAR(100),
PT_EXTCODE VARCHAR(50),
PASS_NUM VARCHAR(20),
PASS_PLACE VARCHAR(20),
PASS_DATE DATE,
PASS_EXP_DATE DATE,
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_DATE DATE,
SEX CHAR,
BIRTH_PLACE VARCHAR(30),
MASK VARCHAR(10),
PACKAGE VARCHAR(255),
VISA TDESCRIPTION_SHORT)
 RETURNS(GUEST_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable warn_code integer;

declare variable birth_date_old date;
declare variable title_old varchar(10);
declare variable id_passport_type_old integer;
declare variable pass_num_old varchar(20);
declare variable pass_date_old date;
declare variable personal_number_old varchar(30);
declare variable id_stay_reason_old integer;
declare variable is_registred_old integer;
declare variable pass_place_old varchar(20);
declare variable city_old varchar(100);
declare variable address_old varchar(100);
declare variable birth_place_old varchar(30);
declare variable sex_old char(1);
declare variable mask_old varchar(10);
declare variable car_old varchar(30);
declare variable kpp_id_old integer;
declare variable kpp_date_old date;
declare variable pass_exp_date_old date;
declare variable rating_age_old integer;
declare variable visa_old tdescription_short;

declare variable guest_name_old varchar(100);
declare variable is_child_old integer;
declare variable arrival_old date;
declare variable departure_old date;
declare variable voucher_old varchar(30);
declare variable voucher_date_old date;
declare variable voucher_text_old varchar(30);
declare variable country_code_old varchar(10);

declare variable id_passport_type integer;
declare variable kpp_id integer;
declare variable id_stay_reason integer;
begin
  execute procedure import_mark_transaction$exc;

  guest_name = substring(:guest_name from 1 for 50);

  execute procedure sys_dbg('exc IMPORT_GUEST$EXC(:guest_uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
  guest_id = null;

  select pd.person_name, --g.is_different_organizer,
         g.id_guest, g.from_date, g.to_date,
         pd.birthday_internal, pd.title, pd.id_passport_type,
         pd.pass_num, pd.pass_date, pd.egn, gd.id_stay_reason,
         gd.is_registred, pd.pass_place, pd.city, pd.address, pd.birth_place,
         pd.sex, pd.mask, g.is_child, gd.car, gd.kpp, gd.kpp_date,
         pd.pass_exp_date, gd.rating_age, g.vaucher_num, g.vaucher_date, g.vaucher_text, pd.country_code,
         gd.id_stay_reason, gd.visa
  from   GUEST g
         join guest_data gd on gd.id_guest=g.id_guest
         join person_data pd on pd.id_person_data=gd.id_person_data
  where  g.uuid=:guest_uuid
         and g.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and g.id_reserv_detail=:booking_id
  into   :guest_name_old, --:is_different_arranger_old,
         :guest_id, :arrival_old, :departure_old, :birth_date_old,
         :title_old, :id_passport_type_old,
         :pass_num_old, :pass_date_old, :personal_number_old, :id_stay_reason_old,
         :is_registred_old, :pass_place_old, :city_old, :address_old, :birth_place_old,
         :sex_old, :mask_old, :is_child_old, :car_old, :kpp_id_old, :kpp_date_old,
         :pass_exp_date_old, :rating_age_old, :voucher_old, :voucher_date_old,
         :voucher_text_old, :country_code_old, :id_stay_reason_old, :visa_old;

  execute procedure import_passport_type$exc(:pt_name, pt_extcode)
  returning_values :id_passport_type;

  execute procedure import_kpp$exc(:kpp, null)
  returning_values :kpp_id;

  execute procedure import_stay_reason$exc(:stay_reason, null)
  returning_values :id_stay_reason;

  guest_name = coalesce(:guest_name, :guest_name_old);
--  DISABLE age/is_child merge (RIU rating cases)
--  is_child = coalesce(:is_child, :is_child_old);
--  is_different_arranger = coalesce(:is_different_arranger, :is_different_arranger_old);
  arrival = coalesce(:arrival, :arrival_old);
  departure = coalesce(:departure, :departure_old);
--  arrival = :arrival_old;
--  departure = :departure_old;
  voucher = coalesce(:voucher, :voucher_old);
  voucher_date = coalesce(:voucher_date, :voucher_date_old);
  voucher_text = coalesce(:voucher_text, :voucher_text_old);
  country_code = coalesce(:country_code, :country_code_old);

--  DISABLE age/is_child merge (RIU rating cases)
--  rating_age = coalesce(:rating_age, :rating_age_old);
  kpp_id = coalesce(:kpp_id, :kpp_id_old);
  kpp_date = coalesce(:kpp_date, :kpp_date_old);
  id_stay_reason = coalesce(:id_stay_reason, :id_stay_reason_old);
  car = coalesce(:car, :car_old);
  is_registred = coalesce(:is_registred, 0);
  if (1 = :is_registred_old) then begin --one way update
    is_registred = 1;
  end
  personal_number = coalesce(:personal_number, :personal_number_old);
  title = coalesce(:title, :title_old);
  id_passport_type = coalesce(:id_passport_type, :id_passport_type_old);
  pass_num = coalesce(:pass_num, :pass_num_old);
  pass_place = coalesce(:pass_place, :pass_place_old);
  pass_date = coalesce(:pass_date, :pass_date_old);
  pass_exp_date = coalesce(:pass_exp_date, :pass_exp_date_old);
  city = coalesce(:city, :city_old);
  address = coalesce(:address, :address_old);
  birth_date = coalesce(:birth_date, :birth_date_old);
  sex = coalesce(:sex, :sex_old);
  birth_place = coalesce(:birth_place, :birth_place_old);
  mask = coalesce(:mask, :mask_old);
  visa = coalesce(:visa, :visa_old);

  if (:guest_id is null) then begin
    execute procedure RES_GUEST_SAVE$RSV(null, :booking_id, :guest_name, null, null, :is_child)
    returning_values :guest_id;

    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - get_next_auto_guest = :guest_id=>' || coalesce(:guest_id, '<null>'));
    if (:guest_id is null) then begin 
      execute procedure sys_dbg('exc IMPORT_GUEST$EXC - exhausted auto guests list - create new guest');
      execute procedure RES_GUEST_ADD$RSV(:booking_id, :is_child)
      returning_values :err_code, :err_text, :warn_code, :guest_id;
      if (0 <> :err_code) then exit;
    end

    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - update_new_guest_uuid(:guest_id=>' || coalesce(:guest_id, '<null>') || ', :uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
    update GUEST
    set    uuid = :guest_uuid
    where  id_guest=:guest_id;

    /* preserve default mask */
    if (:mask is null) then begin
      select pd.mask
      from   guest_data gd
             join person_data pd on pd.id_person_data=gd.id_person_data
      where  gd.id_guest=:guest_id
      into   :mask;
    end          
  end else begin
    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - update_guest(:update_guest_id=>' || coalesce(:guest_id, '<null>') || ')');

--    DISABLE age/is_child merge (RIU rating cases) 
--    if (:age is null) then begin
--      select age from GUEST_AGE_CALC(:guest_id)
--      into :age;
--    end
  end

  /*
  execute procedure sys_dbg('exc IMPORT_GUEST$EXC->GUEST_ADDRESSCARD_SET$RSV('
  || 'update_guest_id => ' || coalesce(:update_guest_id, '<null>')
  || ', guest_name => ' || coalesce(:guest_name, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  || ', :id_passport_type => ' || coalesce(:id_passport_type, '<null>')
  || ', :pass_num => ' || coalesce(:pass_num, '<null>')
  || ', :pass_date => ' || coalesce(:pass_date, '<null>')
  || ', :egn => ' || coalesce(:egn_old, '<null>')
  || ', :country => ' || coalesce(:country_old, '<null>')
  || ', :id_stay_reason => ' || coalesce(:id_stay_reason, '<null>')
  || ', :is_registred => ' || coalesce(:is_registred, '<null>')
  || ', :pass_place => ' || coalesce(:pass_place, '<null>')
  || ', :city => ' || coalesce(:city, '<null>')
  || ', :address => ' || coalesce(:address, '<null>')
  || ', :birth_place => ' || coalesce(:birth_place, '<null>')
  || ', :sex => ' || coalesce(:sex, '<null>')
  || ', :mask => ' || coalesce(:mask, '<null>')
  || ', :is_child => ' || coalesce(:is_child, '<null>')
  || ', :car => ' || coalesce(:car, '<null>')
  || ', :kpp => ' || coalesce(:kpp_old, '<null>')
  || ', :kpp_date => ' || coalesce(:kpp_date, '<null>')
  || ', :pass_exp_date => ' || coalesce(:pass_exp_date, '<null>')
  || ', :age => ' || coalesce(:age, '<null>')
  || ', :birth_date => ' || coalesce(:birth_date, '<null>')
  || ', :rating_age => ' || coalesce(:rating_age, '<null>')
  || ', :title => ' || coalesce(:title, '<null>')
  ||')');
  */
  execute procedure GUEST_ADDRESSCARD_SET$RSV(
    :guest_id,
    :guest_name,
    null,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :personal_number,
    :country_code,
    :id_stay_reason,
    :is_registred,
    :pass_place,
    :city,
    :address,
    :birth_place,
    :sex,
    :mask,
    :is_child,
    :car,
    :kpp_id,
    :kpp_date,
    :pass_exp_date,
    :age,
    :birth_date,
    :visa,
    :rating_age,
    :title,
    0
  )
  returning_values :err_code, :err_text, :warn_code;
  if (0 <> :err_code) then exit;

  --execute procedure RES_GUEST_SAVE_ORGANIZER$RSV(:guest_id, :is_different_arranger);

  if ((:arrival is not null) and (:departure is not null)) then begin
    execute procedure RES_GUEST_SAVE_STAY$RSV(:guest_id, :arrival, :departure)
    returning_values :err_code, :err_text, :warn_code;
    if (0 <> :err_code) then exit;
  end

  if (:voucher is not null) then begin
    execute procedure RES_GUEST_SAVE_VOUCHER$RSV(:guest_id, :voucher,
            :voucher_date, :voucher_text, null, null);
  end

  execute procedure IMPORT_GUEST_PACK$EXC(:guest_id, :package);

  update GUEST
  set    ORPHANED_IMPORT$EXC = null
  where  id_guest=:guest_id;
end
^

/* Alter (IMPORT_HOTEL$EXC) */
ALTER PROCEDURE IMPORT_HOTEL$EXC(HOTEL_NAME VARCHAR(50),
IS_USE SMALLINT,
CODE VARCHAR(10),
LETTER_FOOTER BLOB SUB_TYPE 1,
LETTER_HEADER BLOB SUB_TYPE 1,
ORDER_TAG INTEGER,
RES_CONFIRM_TEXT BLOB SUB_TYPE 1,
COMPANY_NAME TYPE OF TDESCRIPTION_LONG,
COMPANY_IDENT_NUM TYPE OF TTEXT_SHORT,
COMPANY_VAT_REG_NUM TYPE OF TTEXT_SHORT,
COMPANY_MOL TYPE OF TPERSON_NAME,
COMPANY_ADDRESS TYPE OF TDESCRIPTION_LONG,
DOC_PACK_SRV_TEXT VARCHAR(50),
DOC_ONE_LINE_TEXT VARCHAR(50),
MONITOR_MAP BLOB SUB_TYPE 1,
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
UUID VARCHAR(40),
EXTERNAL_TYPE VARCHAR(50),
WBE_ENABLED SMALLINT,
CREATE_IF_NOT_FOUND SMALLINT,
NATION_CURR CHAR(3),
REG_CARD_TEXT BLOB SUB_TYPE 1 = null,
ACCOMODATION_PLACE_UIN TYPE OF TDESCRIPTION_LONG = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100),
ID_HOTEL INTEGER)
 AS
declare variable logo_operation varchar(10);
declare variable hotel_operation varchar(10);
declare variable id_logo integer;
declare variable hotel_address varchar(100);
begin
  execute procedure import_mark_transaction$exc;

  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_HOTEL = null;
  ID_LOGO = null;

  select h.ID_HOTEL, h.ID_LOGO, H.HOTEL_ADDRESS
  from   HOTEL h
  where  h.UUID = :UUID
         and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :id_hotel, :id_logo, :hotel_address;

  if (:ID_HOTEL is null) then begin
    if (:create_if_not_found is distinct from 1) then exit;

    hotel_operation = 'add';
  end else begin
    hotel_operation = 'mod';
  end

  if (:ID_LOGO is null) then begin
    LOGO_OPERATION = 'add';
  end else begin
    LOGO_OPERATION = 'mod';
  end

  execute procedure PICTURE_MODIFY(:ID_LOGO, :PICTURE, :PICTURE_TYPE, :PICTURE_LAYOUT, :LOGO_OPERATION)
  returning_values :ID_LOGO;

  execute procedure HOTEL_MODIFY$CFG(:ID_HOTEL, :HOTEL_NAME, :IS_USE, :CODE,
    :LETTER_FOOTER, :LETTER_HEADER, :ID_LOGO, :ORDER_TAG, :RES_CONFIRM_TEXT,
    :COMPANY_NAME, :COMPANY_IDENT_NUM, :COMPANY_VAT_REG_NUM, :COMPANY_MOL, :COMPANY_ADDRESS,
    :DOC_PACK_SRV_TEXT, :DOC_ONE_LINE_TEXT, :EXTERNAL_TYPE, :hotel_address, :HOTEL_OPERATION,
    :NATION_CURR, :REG_CARD_TEXT, null, :ACCOMODATION_PLACE_UIN)
  returning_values :ID_HOTEL;

  update HOTEL h
  set    h.MONITOR_MAP = :MONITOR_MAP,
         h.UUID = :UUID,
         h.WBE_ENABLED = :WBE_ENABLED
  where  h.ID_HOTEL = :ID_HOTEL;
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_RATE$EXC for: LOOKUP_BOARD$EXC */
ALTER PROCEDURE IMPORT_RATE$EXC(TARIFA_NAME VARCHAR(50),
TARIFA_GROUP VARCHAR(30),
HOTEL_NAME VARCHAR(50),
TARIFA_CURR VARCHAR(3),
IS_ACTIVE SMALLINT,
TARIFA_NOTE VARCHAR(500),
PERIOD_DEPEND_ON_CHECKIN SMALLINT,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BOARD_TYPE VARCHAR(10),
SOURCE_BASE_BOARDS_LIST VARCHAR(255),
TMP_DATA BLOB SUB_TYPE 1,
LOCK_KEY VARCHAR(100),
LOCK_STAMP TIMESTAMP,
UUID VARCHAR(40),
RATE_TYPE VARCHAR(20),
IS_SIMPLE SMALLINT,
CHILD_AGE_INCL INTEGER,
IS_PUBLIC /* TYPE OF TLOGICAL */ SMALLINT,
EXPLICIT_TAX_POLICY_NAME /* TDESCRIPTION_SHORT */ VARCHAR(100) = null,
EXPLICIT_POLICY_NIGHTS_REQUIRED /* TCOUNT */ INTEGER = null)
 RETURNS(ID_TARIFA INTEGER,
ID_TARIFA_GROUP INTEGER,
ID_HOTEL INTEGER,
ID_TAR_SIMPLE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_RATE_SIMPLE_BOARD$EXC for: LOOKUP_BOARD$EXC */
ALTER PROCEDURE IMPORT_RATE_SIMPLE_BOARD$EXC(ID_HOTEL INTEGER,
ID_TAR_SIMPLE_SEASON INTEGER,
RATE_NAME VARCHAR(30),
BOARD_NAME VARCHAR(30),
ADULT_PRICE NUMERIC(15,4),
CHILD_PRICE NUMERIC(15,4))
 RETURNS(ID_TAR_SIMPLE_BOARDS INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_RATE_SIMPLE_PRICE$EXC for: LOOKUP_BOARD$EXC */
ALTER PROCEDURE IMPORT_RATE_SIMPLE_PRICE$EXC(ID_TAR_SIMPLE_SEASON INTEGER,
RATE_NAME VARCHAR(30),
HOTEL_NAME VARCHAR(50),
ROOM_TYPE VARCHAR(20),
BOARD_NAME VARCHAR(30),
SINGLE_PRICE NUMERIC(15,4),
DOUBLE_PRICE NUMERIC(15,4),
GUEST3_PRICE NUMERIC(15,4),
GUEST4PLUS_PRICE NUMERIC(15,4),
CHILD1_W_ADULT1_PRICE NUMERIC(15,4),
CHILD1_W_ADULT2PLUS_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT1_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT2PLUS_PRICE NUMERIC(15,4),
IS_BASE_DAYS_PRICE SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: MAP_BOOKING_RELATIONS$EXC for: LOOKUP_BOARD$EXC */
ALTER PROCEDURE MAP_BOOKING_RELATIONS$EXC(BOOKING_ID INTEGER,
HOTEL VARCHAR(50),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
MARKETING1 VARCHAR(30),
MARKETING2 VARCHAR(30),
MARKETING3 VARCHAR(30),
MARKETING4 VARCHAR(30),
MARKETING5 VARCHAR(30),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
ARRIVAL_TYPE VARCHAR(20),
GUARANTEE_POLICY VARCHAR(50),
EATING_OBJECT VARCHAR(50))
 RETURNS(ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
RATE_ID INTEGER,
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
HOTEL_ID INTEGER,
MAINTANCE_SHEMA_ID INTEGER,
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
FIRST_FOOD_CODE /* TFOOD_CODE */ VARCHAR(20),
ARRIVAL_TYPE_CODE SMALLINT,
GUARANTEE_POLICY_ID INTEGER,
EATING_OBJECT_ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (LOOKUP_BOARD$EXC) */
ALTER PROCEDURE LOOKUP_BOARD$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30),
ONLY_BOARDS SMALLINT)
 RETURNS(ID INTEGER)
 AS
begin
  ID = null;
  select first 1 m.ID_SERVICE
  from   MEALS m
  where  m.ID_HOTEL = :HOTEL_ID
         and m.NAME = :NAME
         and ((:ONLY_BOARDS is distinct from 1) or (m.IS_BOARD = 1))
  into   :ID;

  execute procedure LOG_ID_LOOKUP_ERROR$EXC(:OBJECT_ID, :OBJECT_TYPE, :ID, :NAME, 'board');
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_BOOKING$EXC for: MAP_BOOKING_RELATIONS$EXC */
ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP,
CHECK_OUT_KIND SMALLINT,
EARLYCHECKOUT_DATE DATE)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (MAP_BOOKING_RELATIONS$EXC) */
ALTER PROCEDURE MAP_BOOKING_RELATIONS$EXC(BOOKING_ID INTEGER,
HOTEL VARCHAR(50),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
MARKETING1 VARCHAR(30),
MARKETING2 VARCHAR(30),
MARKETING3 VARCHAR(30),
MARKETING4 VARCHAR(30),
MARKETING5 VARCHAR(30),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
ARRIVAL_TYPE VARCHAR(20),
GUARANTEE_POLICY VARCHAR(50),
EATING_OBJECT VARCHAR(50))
 RETURNS(ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
RATE_ID INTEGER,
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
HOTEL_ID INTEGER,
MAINTANCE_SHEMA_ID INTEGER,
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
FIRST_FOOD_CODE TFOOD_CODE,
ARRIVAL_TYPE_CODE SMALLINT,
GUARANTEE_POLICY_ID INTEGER,
EATING_OBJECT_ID INTEGER)
 AS
declare variable dummy char(8);
BEGIN
  execute procedure lookup_hotel$exc(:hotel, 'BOOKING', :booking_id)
  returning_values :hotel_id;

  execute procedure lookup_rate$exc(:hotel_id, :booking_id, 'BOOKING', :rate)
  returning_values :rate_id;

  execute procedure lookup_room_type$exc(:hotel_id, :booking_id, 'BOOKING', :room_type)
  returning_values :room_type_id;

  execute procedure LOOKUP_BOARD$EXC(:hotel_id, :booking_id, 'BOOKING', :board, 0)
  returning_values :board_id;

  maintance_shema_id = null;
  select first 1 ms.id_plan
  from   hk_plan ms
  where  ms.id_hotel=:hotel_id
         and ms.is_use=1
         and ms.plan_name=:maintance_shema
  into   :maintance_shema_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :maintance_shema_id, :maintance_shema, 'maintance_shema');

  arranger_payment_type_id = null;
  select first 1 pt.id_payment_type
  from   payment_type pt
  where  pt.payment_type=:arranger_payment_type
         and pt.ID_HOTEL = :HOTEL_ID
         and pt.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :arranger_payment_type_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :arranger_payment_type_id, :arranger_payment_type, 'arranger_payment_type');

  guest_payment_type_id = null;
  select first 1 pt.id_payment_type
  from   payment_type pt
  where  pt.payment_type=:guest_payment_type
         and pt.ID_HOTEL = :HOTEL_ID
         and pt.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :guest_payment_type_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :guest_payment_type_id, :guest_payment_type, 'guest_payment_type');

  execute procedure LOOKUP_MARKET_SEGMENT$EXC(:booking_id, 'BOOKING', :marketing1)
  returning_values :marketing1_id;

  marketing2_id = null;
  select first 1 m2.id_nom_source_code from nom_source_codes m2
  where m2.description = :marketing2 and m2.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :marketing2_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :marketing2_id, :marketing2, 'marketing2');

  marketing3_id = null;
  select first 1 m3.id_nom_channel_code from nom_channel_codes m3
  where m3.description = :marketing3 and m3.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :marketing3_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :marketing3_id, :marketing3, 'marketing3');

  marketing4_id = null;
  select first 1 m4.id_nom_hear_reason from nom_hear_reasons m4
  where m4.description = :marketing4 and m4.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :marketing4_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :marketing4_id, :marketing4, 'marketing4');

  marketing5_id = null;
  select first 1 m5.id_nom_come_reason from nom_come_reasons m5
  where m5.description = :marketing5 and m5.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :marketing5_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :marketing5_id, :marketing5, 'marketing5');

  execute procedure lookup_profile$exc(:arranger_profile_uuid, :arranger_profile_name)
  returning_values :dummy, :arranger_profile_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :arranger_profile_id, :arranger_profile_uuid, 'arranger_profile');

  main_guest_profile_id = null;
  select first 1 p.id_profile from profile p where p.uuid=:main_guest_profile_uuid and p.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :main_guest_profile_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :main_guest_profile_id, :main_guest_profile_uuid, 'main_guest_profile');

  execute procedure LOOKUP_FIRST_FOOD$EXC(:first_food)
  returning_values :first_food_code;

  execute procedure LOOKUP_GUARANTEE_POLICY$EXC(:hotel_id, :booking_id, 'BOOKING', :guarantee_policy)
  returning_values :guarantee_policy_id;

  execute procedure LOOKUP_EATING_OBJECT$EXC(:hotel_id, :booking_id, 'BOOKING', :eating_object)
  returning_values :eating_object_id;

  arrival_type_code = 1; /*normal*/
  if ('early' = :arrival_type) then begin
    arrival_type_code = 0;
  end else if ('late' = :arrival_type) then begin
    arrival_type_code = 2;
  end
END
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_NEW$DOC for: PAYMENT_CREATE$INT */
ALTER PROCEDURE DEPOSIT_NEW$DOC(ID_ACCOUNT INTEGER,
ID_DOC_TYPE INTEGER,
PAY_VALUE NUMERIC(15,4),
PAY_CURRENCY VARCHAR(3),
DESCRIPTION VARCHAR(100),
ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_DEPOSIT INTEGER,
ID_PAYMENT_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PAYMENT_CREATE$INT) */
ALTER PROCEDURE PAYMENT_CREATE$INT(ID_DOC_TYPE TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
PAYMENT_DATE TYPE OF TDATE,
PAY_VALUE TYPE OF TPRICE,
PAY_CURRENCY TYPE OF TCURRENCY,
PAY_RATE TYPE OF TRATE,
ACC_CURRENCY TYPE OF TCURRENCY,
ACC_RATE TYPE OF TRATE,
DESCRIPTION TYPE OF TDESCRIPTION_SHORT)
 RETURNS(ID_PAYMENT_HEAD TYPE OF ID,
ID_ACCOUNT_PAYMENT TYPE OF ID,
IS_TAXABLE TYPE OF TLOGICAL)
 AS
declare variable id_doc_num integer;
  declare variable doc_type_name varchar(40);
  declare variable pay_taxes numeric(15,4);
  declare variable dbg varchar(1000);
  declare variable round_to numeric(15,4);
  declare variable acc_round_to numeric(15,4);
  declare variable id_tax integer;
  declare variable tax_percent numeric(15,4);
  declare variable tax_value numeric(15,4);
  declare variable id_service integer;
  declare variable line_name varchar(50);
  declare variable err_code integer;
  declare variable acc_value numeric(15,4);
  declare variable doc_direction integer;
  declare variable id_payment_type integer;
  declare variable is_archive integer;
  declare variable id_hotel integer;
  declare variable err_text varchar(255);
  declare variable currency_list varchar(1000);
  declare variable hp_type varchar(50);
begin
/******************************************************************************/
  IS_TAXABLE = 0;
  select p.HOUSE_TYPE
  from   ACCOUNT A
         left outer join PROFILE_HOUSE p on p.ID_PROFILE = a.ID_PROFILE
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :hp_type;

  if (coalesce(:hp_type, '') in ('hptExternalRevenue', 'hptComplimentary')) then
    exception DOCUMENT_EXCEPTION '-601';

  /* CHECK FOR VALID ACCOUNT */
  execute procedure ACCOUNT_VALIDATE$INT(:ID_ACCOUNT, '')  -- permanent checks only
  returning_values  (:err_code, :err_text, :dbg, :dbg, :id_hotel, :dbg, :dbg);
  /* skip account blockage error: -12 */
  if (:err_code < 0) then exception ACCOUNT_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');

  /* TIPA NA DOCUMENTA E STORNIRASHT */
  /*------- PAYMENT HEADER LOOKUPS FROM "DOC_TYPE"   --------*/
  select DT.ID_DOC_NUM, DT.DOC_TYPE_NAME, DTP.DOC_DIRECTION, DTP.ID_PAYMENT_TYPE, DT.IS_ARCHIVE, dt.CURRENCY_LIST
  from   DOC_TYPE DT
         join DOC_TYPE_PAY DTP on DTP.ID_DOC_TYPE = Dt.ID_DOC_TYPE
  where  DT.ID_DOC_TYPE = :ID_DOC_TYPE
         and DT.ID_HOTEL = :ID_HOTEL
  into   :id_doc_num, :doc_type_name, :doc_direction , :id_payment_type, :is_archive, :currency_list;

  if (:doc_type_name is null) then /* SELECTED NO PAY DOC TYPE  */
    exception DOCUMENT_EXCEPTION '-93';
  if (:id_doc_num is null) then
    exception DOCUMENT_EXCEPTION '-92' || f_character(31) || f_character(29) || :doc_type_name;
  if (:is_archive = 1) then
    exception PAYMENT_EXCEPTION '-309' || f_character(31) || f_character(29) || :doc_type_name;
    --'Pay document is archive.';
  if ((:PAY_VALUE = 0) or (:PAY_VALUE < 0 and :doc_direction = 0) or (:PAY_VALUE > 0 and :doc_direction = 1)) then
    exception PAYMENT_EXCEPTION '-340' || f_character(31) || f_character(29) || :PAY_VALUE;
    --'Payment value iz zero.' ;
    --'Payment value is incompatible with document type.';
  /* check currency  */
  if (:currency_list not containing :PAY_CURRENCY) then
    exception CURRENCY_IS_NOT_SUPPORTED f_character (29) || :PAY_CURRENCY || f_character (28) || :doc_type_name;

  select c.ROUND_TO
  from   CURRS C
  where  c.CURR = :PAY_CURRENCY
  into   :round_to;
  /*-------------------- PAYMENT HEADER ---------------------*/
  ID_PAYMENT_HEAD = gen_id(G_ID_PAYMENT_HEAD, 1);
  insert into PAYMENT_HEAD (ID_PAYMENT_HEAD, ID_ACCOUNT, ID_DOC_TYPE, ID_DOC_NUM,
         ID_PAYMENT_TYPE, DOC_TYPE_NAME, PAYMENT_DATE, DUE_DATE,
         PAY_VALUE, PAY_VALUE_A, PAY_CURRENCY, PAY_RATE, DESCRIPTION)
  values (:ID_PAYMENT_HEAD, :ID_ACCOUNT, :ID_DOC_TYPE, :id_doc_num,
         :id_payment_type, :doc_type_name, :PAYMENT_DATE, :PAYMENT_DATE,
         :PAY_VALUE, :PAY_VALUE, :PAY_CURRENCY, :PAY_RATE, :DESCRIPTION);
  /* VALUE (PAY_VALUE) IS IN THE PAYMENT CURRENCY */
  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :ACC_CURRENCY
  into   :ACC_ROUND_TO;
   
  acc_value = round_f(:pay_value * cast(:pay_rate / :acc_rate as double precision), :acc_round_to);

  PAY_TAXES = 0;
  /* ADDING THE TAXES (RESULT IS IN PAYMENT CURRENCY) */
  if (:DOC_DIRECTION = 0) then begin
    for
      select T.PID_TAX, T.PPERCENT,
             T.TAX_VALUE, T.ID_SERVICE, T.LINE_NAME
      from   PAYMENT_CALC_TAXES$INT(:ID_DOC_TYPE, :PAY_VALUE, :ROUND_TO) T
      into   :ID_TAX, :TAX_PERCENT,
             :TAX_VALUE, :ID_SERVICE, :LINE_NAME
    do begin
      insert into PAYMENT_FOOTER
             (ID_PAYMENT_HEAD, ID_TAX, TAX_PERCENT,
              TAX_VALUE, ID_SERVICE, LINE_NAME)
      values (:ID_PAYMENT_HEAD, :ID_TAX, :TAX_PERCENT,
              :TAX_VALUE, :ID_SERVICE, :LINE_NAME);
  
      PAY_TAXES = :PAY_TAXES + :TAX_VALUE;
      ACC_VALUE = :ACC_VALUE + ROUND_F(:TAX_VALUE * cast(:PAY_RATE / :ACC_RATE as double precision), :ACC_ROUND_TO);
      IS_TAXABLE = 1;
    end
  end

  update PAYMENT_HEAD PH
  set    PH.PAY_VALUE_A = PH.PAY_VALUE_A + :PAY_TAXES
  where  PH.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;

  /*-------------------- ACCOUNT_PAYMENT ---------------------*/
  insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
         ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT, IS_INITIAL_PAYMENT)
  values (:ID_ACCOUNT, :ID_PAYMENT_HEAD, :PAY_VALUE + :PAY_TAXES, :PAY_RATE,
         :ACC_VALUE, :ACC_RATE, :PAYMENT_DATE, null, 1)
  returning ID_ACCOUNT_PAYMENT into :ID_ACCOUNT_PAYMENT;
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_GET_VALUE$INT for: PAYMENT_GET_DEFAULT$INT */
ALTER PROCEDURE DOCUMENT_GET_VALUE$INT(ID_DOC_HEAD INTEGER,
TARGET_CURR VARCHAR(3),
TARGET_RATE NUMERIC(15,6) = null)
 RETURNS(ID_PAY_DOC_DEF INTEGER,
TOTAL_CURR VARCHAR(3),
TOTAL_RATE NUMERIC(15,6),
TOTAL_VALUE NUMERIC(15,4),
PAYABLE_VALUE NUMERIC(15,4))
 AS
 BEGIN SUSPEND; END
^

/* Alter (PAYMENT_GET_DEFAULT$INT) */
ALTER PROCEDURE PAYMENT_GET_DEFAULT$INT(ID_ACCOUNT INTEGER)
 RETURNS(ID_PAY_DOC_TYPE INTEGER,
PAY_CURR VARCHAR(3))
 AS
declare variable id_profile integer;
  declare variable id_reserv_detail integer;
  declare variable id_payment_type integer;
  declare variable id_acc_payment_type integer;
  declare variable id_hotel integer;
  declare variable acc_curr varchar(3);
  declare variable def_curr varchar(3);
  declare variable id_def_pay_doc_type integer;
begin
  ID_PAY_DOC_TYPE = null;
  PAY_CURR = null;
  id_payment_type = null;

  select A.ID_PROFILE, A.ID_RESERV_DETAIL, A.ACCOUNT_CURR, A.ID_HOTEL,
         (select pt.ID_PAYMENT_TYPE
          from   PAYMENT_TYPE pt
          where  pt.ID_PAYMENT_TYPE = a.ID_TYPE_PAYMENT)
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :id_profile, :id_reserv_detail, :acc_curr, :id_hotel, :id_acc_payment_type;

  if (:id_reserv_detail is not null) then begin
    select case
             when RD.ID_PERSON_PROFILE = :ID_PROFILE then RD.ID_PERSON_PAYMENT
             when RD.ID_AGENT_PROFILE = :ID_PROFILE then RD.ID_AGENT_PAYMENT
             else null
           end as RESERV_PAYMENT_TYPE
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :id_payment_type;
  end

  id_payment_type = coalesce(:id_payment_type, :id_acc_payment_type);

  if (:id_payment_type is not null) then begin
    select first 1 DT.ID_DOC_TYPE, DT.DEF_CURRENCY,
           iif (dt.CURRENCY_LIST containing :ACC_CURR, :ACC_CURR, null) as PAY_CURR,
           iif (dt.ID_DOC_TYPE = :id_def_pay_doc_type, dt.ID_DOC_TYPE, null)
    from   PAY_DOC_TYPE_S DT
    where  DT.ID_PAYMENT_TYPE = :id_payment_type
           and DT.DOC_DIRECTION = 0
           and DT.ID_HOTEL = :ID_HOTEL
           and DT.IS_ARCHIVE = 0
    order by 3 desc nulls last, 4 asc nulls last, 1 asc    /* pull up doc types, that supports account currency */
    into   :ID_PAY_DOC_TYPE, :def_curr, :PAY_CURR, :id_def_pay_doc_type;
  end else begin
    begin
      execute procedure SETTING_GET_VALUE ('DEF_CASH_PAY_DOC', :id_hotel)
      returning_values  :id_def_pay_doc_type;

      when any do begin end
    end

    select dt.ID_DOC_TYPE, DT.DEF_CURRENCY, iif (dt.CURRENCY_LIST containing :ACC_CURR, :ACC_CURR, null) as PAY_CURR
    from   PAY_DOC_TYPE_S DT
    where  DT.ID_DOC_TYPE = :id_def_pay_doc_type
           and DT.DOC_DIRECTION = 0
           and DT.ID_HOTEL = :ID_HOTEL
           and dt.IS_ARCHIVE = 0
    into   :ID_PAY_DOC_TYPE, :def_curr, :PAY_CURR;
  end

  if (:PAY_CURR is null) then PAY_CURR = :DEF_CURR;

end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_SET_NUMBER$INT for: PAYMENT_SET_NUMBER$INT */
ALTER PROCEDURE DOCUMENT_SET_NUMBER$INT(DH_DBKEY /* TYPE OF TDB_KEY */ CHAR(8))
 RETURNS(NUM /* TYPE OF TRANGE */ INTEGER,
DOC_NUM VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* Alter (PAYMENT_SET_NUMBER$INT) */
ALTER PROCEDURE PAYMENT_SET_NUMBER$INT(PAY_DOC_DBKEY CHAR(8))
 AS
declare variable id_doc_num integer;
  declare variable num integer;
  declare variable doc_num varchar(20);
begin
  select P.ID_DOC_NUM
  from   PAYMENT_HEAD P
  where  P.RDB$DB_KEY = :PAY_DOC_DBKEY
  into   :id_doc_num;

  execute procedure SYSTEM_GEN_NUM ('PAYMENT', :id_doc_num)
  returning_values  (:num, :doc_num);

  update PAYMENT_HEAD P
  set    P.NUM = :num,
         P.PAYMENT_NUM = :doc_num,
         p.DATETIME_CREATED = current_timestamp -- moves created_at to finalization timestamp
  where  P.RDB$DB_KEY = :PAY_DOC_DBKEY;

end
^

/* Alter (PAYMENT_STORNO$INT) */
ALTER PROCEDURE PAYMENT_STORNO$INT(ID_PAYMENT_HEAD INTEGER,
ID_ACCOUNT INTEGER,
NEW_ID_DOC_HEAD INTEGER,
STORNO_AMOUNT NUMERIC(15,4),
DESCRIPTION VARCHAR(100),
TARGET_DOC_AMOUNT NUMERIC(15,4))
 RETURNS(ID_STORNO_PAYMENT INTEGER)
 AS
declare variable payment_date date;
  declare variable acc_currency varchar(3);
  declare variable id_doc_type integer;
  declare variable doc_type_name varchar(50);
  declare variable id_doc_num integer;
  declare variable is_storno integer;
  declare variable round_to numeric(15,4);
  declare variable pay_rate numeric(15,6);
  declare variable pay_curr varchar(3);
  declare variable doc_value numeric(15,4);
  declare variable acc_value numeric(15,4);
  declare variable acc_rate numeric(15,6);
  declare variable doc_rate numeric(15,6);
  declare variable doc_curr varchar(3);
  declare variable id_doc_contragent integer;
  declare variable id_storned_doc_head integer;
  declare variable id_payment_type integer;
  declare variable id_hotel integer;
  declare variable due_date date;
  declare variable equal_pay_doc_rate double precision;
  declare variable is_partial_storno numeric(15,4);
  declare variable id_account_payment integer;
  declare variable id_deposit integer;
  declare variable avail_pay_amount numeric(15,4);
begin
  execute procedure PAYMENT_VOID_CHECK$INT (:ID_PAYMENT_HEAD, substring(:DESCRIPTION from 1 for 50));

  select PH.ID_DOC_TYPE, DTP.STORNO_DOC_NAME, PH.ID_DOC_NUM, PH.ID_PAYMENT_TYPE, PH.DUE_DATE,
         ph.IS_STORNO, PH.PAY_CURRENCY, PH.PAY_RATE, PH.ID_DOC_HEAD,
         A.ID_HOTEL, c.ROUND_TO
  from   PAYMENT_HEAD PH
         join DOC_TYPE DP on DP.ID_DOC_TYPE = PH.ID_DOC_TYPE
         join DOC_TYPE_PAY dtp on dtp.ID_DOC_TYPE = dp.ID_DOC_TYPE
         join ACCOUNT A on A.ID_ACCOUNT = PH.ID_ACCOUNT
         join CURRS c on c.CURR = ph.PAY_CURRENCY
  where  PH.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  into   :id_doc_type, :doc_type_name, :id_doc_num, :id_payment_type, :due_date,
         :is_storno, :pay_curr, :pay_rate, :id_storned_doc_head,
         :id_hotel, :round_to;

  if (:is_storno = 1) then
    exception PAYMENT_EXCEPTION 'Storno payment cannot be voided !';

  select sum(AP.PAY_AMOUNT)
  from   ACCOUNT_PAYMENTS AP
  where  AP.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  into   :avail_pay_amount;

  if ((:STORNO_AMOUNT is null) or (round_f(:STORNO_AMOUNT - :avail_pay_amount, :round_to) = 0) ) then begin
    /* storn whole available payment */
    is_partial_storno = 0;
    STORNO_AMOUNT = :avail_pay_amount;
  end else begin
    is_partial_storno =1;
  end

  if (:STORNO_AMOUNT = 0 ) then
    exception PAYMENT_EXCEPTION '-340' || f_character(31) || '' || f_character(29) || :storno_amount;
    --'Payment value iz zero.' ;

  execute procedure SYSTEM_DATE_GET (:ID_HOTEL)
  returning_values  (:payment_date);
   
  /* CHECK FOR VALID ACCOUNT */
  select A.ACCOUNT_CURR
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :acc_currency;

  execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:ID_ACCOUNT, 0);
  /*-------------------- PAYMENT HEADER ---------------------*/
  select D.DOC_CURRENCY, D.ID_DOC_CONTRAGENT, D.DOC_RATE
  from   DOC_HEAD D
  where  D.ID_DOC = :NEW_ID_DOC_HEAD
  into   :doc_curr, :id_doc_contragent, :doc_rate;

  ID_STORNO_PAYMENT = gen_id(G_ID_PAYMENT_HEAD, 1);
  insert into PAYMENT_HEAD
         (ID_PAYMENT_HEAD, ID_ACCOUNT, ID_DOC_TYPE, ID_DOC_NUM,
         ID_PAYMENT_TYPE, DOC_TYPE_NAME, PAYMENT_DATE, DUE_DATE,
         PAY_VALUE, PAY_VALUE_A, PAY_CURRENCY, PAY_RATE, IS_STORNO, ID_DOC_HEAD,
         DESCRIPTION, ID_DOC_CONTRAGENT, ID_PAYMENT_STORNED)
  values (:ID_STORNO_PAYMENT, :ID_ACCOUNT, :id_doc_type, :id_doc_num,
         :id_payment_type, :doc_type_name, :payment_date, :due_date,
         -:STORNO_AMOUNT, -:STORNO_AMOUNT, :pay_curr, :pay_rate, 1, :NEW_ID_DOC_HEAD,
         :DESCRIPTION, :id_doc_contragent, :ID_PAYMENT_HEAD);
  /*-------------------- ACCOUNT_PAYMENT ---------------------*/
  execute procedure CURR_RATE_GET (:acc_currency, :payment_date, :id_hotel)
  returning_values  (:acc_rate);

  if (:is_partial_storno = 1 /*and :TARGET_DOC_AMOUNT is not null */) then begin
    if (:pay_curr = :doc_curr) then pay_rate = :doc_rate;
    execute procedure PAYMENT_EQUIVALENCE_CALC$INT (:pay_rate, -:STORNO_AMOUNT, :round_to, :doc_rate, :round_to, :TARGET_DOC_AMOUNT)
    returning_values  (:doc_value, :equal_pay_doc_rate);
    --doc_rate = :pay_rate / :equal_pay_doc_rate;
     
    if (:acc_currency = :doc_curr) then begin
      acc_value = :doc_value;
      acc_rate = :pay_rate / :equal_pay_doc_rate; --:doc_rate;
    end else begin
      acc_value = (-:storno_amount) * cast(:pay_rate/:acc_rate as double precision);
    end

    insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
           ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT, IS_INITIAL_PAYMENT)
    values (:ID_ACCOUNT, :ID_STORNO_PAYMENT, -:STORNO_AMOUNT , :pay_rate,
           :acc_value, :acc_rate, :payment_date, null, 1)
    returning id_account_payment into :id_account_payment;
  
    if (:NEW_ID_DOC_HEAD is not null) then begin
      insert into DOC_PAY_USAGE (ID_DOC_HEAD, ID_ACCOUNT_PAYMENT, PAY_AMOUNT, PAY_RATE,
             DOC_AMOUNT, /*DOC_RATE,*/ EQUAL_PAY_DOC_RATE)
      values (:NEW_ID_DOC_HEAD, :id_account_payment, -:storno_amount, :pay_rate,
             :doc_value, /*:doc_rate,*/ :equal_pay_doc_rate);
    end
  end else begin
    /* whole paymnent is storned */
    select dp.EQUAL_PAY_DOC_RATE
    from   DOC_PAY_USAGE DP
           join ACCOUNT_PAYMENTS AP on AP.ID_ACCOUNT_PAYMENT = dp.ID_ACCOUNT_PAYMENT
    where  DP.ID_DOC_HEAD = :id_storned_doc_head
           and AP.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
    into   :equal_pay_doc_rate;

    for
      select ap.ID_DEPOSIT, ap.id_account, ap.PAY_RATE, ap.ACC_RATE,
             sum(ap.PAY_AMOUNT), sum(ap.ACC_AMOUNT)
      from   ACCOUNT_PAYMENTS AP
      where  AP.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
      group by 1, 2, 3, 4
      having round_f(sum(AP.PAY_AMOUNT), :round_to) <> 0
      into   :id_deposit, :ID_ACCOUNT, :pay_rate, :acc_rate,
             :STORNO_AMOUNT, :acc_value
    do begin
      insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
             ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT, IS_INITIAL_PAYMENT)
      values (:ID_ACCOUNT, :ID_STORNO_PAYMENT, -:STORNO_AMOUNT, :pay_rate,
             -:acc_value, :acc_rate, :payment_date, :id_deposit, 1)
      returning id_account_payment into :id_account_payment;

      if (:NEW_ID_DOC_HEAD is not null) then begin
        doc_value = :storno_amount * :equal_pay_doc_rate;
        --doc_rate = :pay_rate / :equal_pay_doc_rate;
        insert into DOC_PAY_USAGE (ID_DOC_HEAD, ID_ACCOUNT_PAYMENT, PAY_AMOUNT, PAY_RATE,
               DOC_AMOUNT, /*DOC_RATE, */EQUAL_PAY_DOC_RATE)
        values (:NEW_ID_DOC_HEAD, :id_account_payment, -:storno_amount, :pay_rate,
               -:doc_value, /*:doc_rate, */:equal_pay_doc_rate);
      end
    end

  end

  insert into PAYMENT_CREDIT_CARD (ID_PAYMENT_HEAD, CARD_CODE, ID_CC_TYPE,
         HOLDER_NAME, HOLDER_ADDRESS, VALIDITY_YEAR, VALIDITY_MONTH, VERIFICTION_CODE, CARD_CODE_PREVIEW)
  select :ID_STORNO_PAYMENT, CARD_CODE, ID_CC_TYPE,
         HOLDER_NAME, HOLDER_ADDRESS, VALIDITY_YEAR, VALIDITY_MONTH, VERIFICTION_CODE, CARD_CODE_PREVIEW
  from   PAYMENT_CREDIT_CARD pcc
  where  pcc.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;

  /* Mark storned pay doc and account payments for it as storned */
  if (:is_partial_storno = 0) then begin
    update PAYMENT_HEAD P
    set    P.IS_STORNED = 1
    where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;
  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_PAYMENT_TYPE$EXC for: PAYMENT_TYPE_MODIFY$CFG */
ALTER PROCEDURE IMPORT_PAYMENT_TYPE$EXC(UUID VARCHAR(40),
NAME VARCHAR(50),
GROUP_TAG VARCHAR(20),
DESCRIPTION VARCHAR(100),
IS_AR_DEBT SMALLINT,
IS_CASH SMALLINT,
IS_CC SMALLINT,
IS_USE SMALLINT,
FISCAL_CODE VARCHAR(50),
HOTEL_NAME VARCHAR(50))
 RETURNS(PAYMENT_TYPE_ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PAYMENT_TYPE_MODIFY$CFG) */
ALTER PROCEDURE PAYMENT_TYPE_MODIFY$CFG(ID_PAYMENT_TYPE INTEGER,
PAYMENT_TYPE VARCHAR(20),
GROUP_TAG VARCHAR(20),
DESCRIPTION VARCHAR(100),
IS_AR_DEBT SMALLINT,
IS_CASH SMALLINT,
IS_CC SMALLINT,
IS_USE SMALLINT,
FISCAL_CODE VARCHAR(50),
OPERATION VARCHAR(10),
ID_HOTEL TYPE OF ID)
 RETURNS(NEW_ID_PAYMENT_TYPE INTEGER)
 AS
declare variable id_doc_type integer;
  declare variable used smallint;
begin

  execute procedure SYSTEM_CHECK_OPERATION(:OPERATION, 'add, mod, del');

  if (:IS_CASH = 1 and :IS_AR_DEBT = 1) then
    exception PAYMENT_TYPE_EXCEPTION '-362';

  if (:OPERATION = 'add') then begin
    if (coalesce(:ID_PAYMENT_TYPE, -1) < 0) then
      NEW_ID_PAYMENT_TYPE = gen_id(G_AUTO_INC_PAYMENT_TYPE, 1);
    else
      NEW_ID_PAYMENT_TYPE = :ID_PAYMENT_TYPE;

    insert into PAYMENT_TYPE (ID_PAYMENT_TYPE, PAYMENT_TYPE, GROUP_TAG, DESCRIPTION,
           IS_AR_DEBT, IS_CASH, IS_CC, IS_USE, FISCAL_CODE, ID_HOTEL)
    values (:NEW_ID_PAYMENT_TYPE, :PAYMENT_TYPE, :GROUP_TAG, :DESCRIPTION,
           :IS_AR_DEBT, :IS_CASH, :IS_CC, :IS_USE, :FISCAL_CODE, :ID_HOTEL);
  end else if (:OPERATION = 'mod') then begin
    /* checks pay docs usage on is_cash, is_cc or is_ar_debt change and updates them */
    if (:IS_USE = 0 and exists(select dtp.ID_DOC_TYPE
                               from   DOC_TYPE_PAY dtp
                                      join DOC_TYPE dt on dt.ID_DOC_TYPE = dtp.ID_DOC_TYPE
                               where  dtp.ID_PAYMENT_TYPE = :ID_PAYMENT_TYPE
                                      and dt.IS_ARCHIVE = 0)) then
    begin
      exception PAYMENT_TYPE_EXCEPTION '-332';
    end

    for
      select PD.ID_DOC_TYPE,
             (select DCU.IN_USE
              from   DOC_TYPE_CHECK_USED (PD.ID_DOC_TYPE) DCU) as USED
      from   DOC_TYPE_PAY PD
             join DOC_TYPE DT on DT.ID_DOC_TYPE = pd.ID_DOC_TYPE
      where  pd.ID_PAYMENT_TYPE = :ID_PAYMENT_TYPE
             and ((PD.IS_CASH <> :IS_CASH)
                  or (PD.IS_CC <> :IS_CC)
                  or (PD.IS_AR_DEBT <> :IS_AR_DEBT) )
      into   :id_doc_type, :used
    do begin
      if (:used = 1) then exception PAYMENT_TYPE_EXCEPTION '-359';

      update DOC_TYPE_PAY P
      set    P.IS_CASH = :IS_CASH,
             P.IS_CC = :IS_CC,
             P.IS_AR_DEBT = :IS_AR_DEBT
      where  P.ID_DOC_TYPE = :id_doc_type;
    end

    update PAYMENT_TYPE
    set    PAYMENT_TYPE = :PAYMENT_TYPE,
           GROUP_TAG = :GROUP_TAG,
           DESCRIPTION = :DESCRIPTION,
           IS_AR_DEBT = :IS_AR_DEBT,
           IS_CASH = :IS_CASH,
           IS_CC = :IS_CC,
           IS_USE = :IS_USE,
           FISCAL_CODE = :FISCAL_CODE
    where  ID_PAYMENT_TYPE = :ID_PAYMENT_TYPE;

    NEW_ID_PAYMENT_TYPE = :ID_PAYMENT_TYPE;

    execute procedure SYSTEM_LOG_ADD ('PAYMENT_TYPE', :NEW_ID_PAYMENT_TYPE, 'PAYMENT_TYPE_CHANGED', :PAYMENT_TYPE);

  end else if (:OPERATION = 'del') then begin
    execute procedure SYSTEM_LOG_ADD ('PAYMENT_TYPE', :ID_PAYMENT_TYPE, 'DELETE', '');

    delete from PAYMENT_TYPE
    where  ID_PAYMENT_TYPE = :ID_PAYMENT_TYPE;

    NEW_ID_PAYMENT_TYPE = null;
  end
end
^

/* empty dependent procedure body */
/* Clear: PAYMENT_ANUL$INT for: PAYMENT_VOID_CHECK$INT */
ALTER PROCEDURE PAYMENT_ANUL$INT(ID_PAYMENT_HEAD INTEGER,
ANUL_REASON VARCHAR(100))
 AS
 BEGIN EXIT; END
^

/* Alter (PAYMENT_VOID_CHECK$INT) */
ALTER PROCEDURE PAYMENT_VOID_CHECK$INT(ID_PAYMENT_HEAD TYPE OF ID,
VOID_REASON TYPE OF TREASON)
 AS
declare variable no_use integer;
  declare variable avail_dep_value tprice;
  declare variable id_deposit integer;
  declare variable id_account integer;
  declare variable payment_description varchar(100);
  declare variable is_voided integer;
begin
  select p.IS_ANUL + p.IS_STORNED, p.DOC_TYPE_NAME || ' ' || p.PAYMENT_NUM || '/' || p.PAYMENT_DATE
  from   PAYMENT_HEAD P
  where  p.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  into   :is_voided, :payment_description;

  if (:is_voided > 0) then
    exception PAYMENT_ANNUL_EXCEPTION '-355' || f_character(31) || f_character(29) || :payment_description;
    -- 'Payment is already voided !'

  if (exists (select ap.ID_ACCOUNT_PAYMENT
              from   PAYMENT_HEAD P
                     join ACCOUNT_PAYMENTS ap on ap.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
                     join DOC_PAY_USAGE dp on dp.ID_ACCOUNT_PAYMENT = ap.ID_ACCOUNT_PAYMENT
                                             and dp.ID_DOC_HEAD is distinct from p.ID_DOC_HEAD
                     join DOC_HEAD D on d.ID_DOC = dp.ID_DOC_HEAD
              where  p.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
                     and d.IS_ANUL = 0
                     and d.IS_STORNED = 0)) then
    exception PAYMENT_ANNUL_EXCEPTION '-351' || f_character(31) || f_character(29) || :payment_description;
    --'Payment is used into valid document.';

  -- Check for transfered deposit into other accounts and return it to source (payment) account
  for
    select d.ID_DEPOSIT, d.AVAIL_VALUE, p.ID_ACCOUNT
    from   DEPOSIT_AVAILABLE D
           join PAYMENT_HEAD P on p.ID_PAYMENT_HEAD = d.ID_PAYMENT_HEAD
    where  D.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
           and d.ID_ACCOUNT <> p.ID_ACCOUNT
    into   :id_deposit, :avail_dep_value, :id_account
  do begin
    execute procedure DEPOSIT_TRANSFER$INT (:id_deposit, :id_account, :avail_dep_value, null, :VOID_REASON)
    returning_values  (:no_use);
  end
end
^

/* Alter (PAYMENTS_EW_SUMMARIZE$INT) */
ALTER PROCEDURE PAYMENTS_EW_SUMMARIZE$INT(ID_END_WORK INTEGER)
 AS
declare variable ID_HOTEL integer;
declare variable DATE_SUMMARY date;
declare variable PAYMENT_AMOUNT numeric(15,4);
declare variable PAYMENT_TRANSACTIONS integer;
declare variable FISCAL_PAY_AMOUNT numeric(15,4);
declare variable FISCAL_PAY_TRANSACTIONS integer;
declare variable ACCEPTED_AMOUNT numeric(15,4);
declare variable USED_AMOUNT numeric(15,4);
declare variable REFUNDED_AMOUNT numeric(15,4);
declare variable CURRENCY varchar(3);
declare variable DISCOUNTS_VALUE numeric(15,4);
begin

  select EW.ID_HOTEL, EW.PREV_DATE
  from   END_WORKS EW
  where  EW.ID_END_WORK = :ID_END_WORK
  into   :ID_HOTEL, :DATE_SUMMARY;

  select sum(P.NAT_VALUE) as PAY_AMOUNT,
         count(distinct P.ID_PAYMENT_HEAD) as PAY_CNT,
         sum(P.NAT_VALUE * iif(P.FISC_STATUS = 2, 1, 0)) as FISC_PAY_AMOUNT,
         count(distinct iif(P.FISC_STATUS = 2, P.ID_PAYMENT_HEAD, null)) as FISC_PAY_CNT
  from   DOCUMENT_PAYMENT P
  where  P.REALIZE_DATE = :DATE_SUMMARY
         and P.ID_HOTEL = :ID_HOTEL
  into   :PAYMENT_AMOUNT, :PAYMENT_TRANSACTIONS,
         :FISCAL_PAY_AMOUNT, :FISCAL_PAY_TRANSACTIONS;

  select sum(DD.FOOTER_VALUE * D.VALUE_CORR_IDX)
  from   DOCUMENT_RELEASE D
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join DOC_FOOTER DD on DD.ID_DOC_HEAD = D.ID_DOC and DD.ID_DOC_LINE is null
  where  D.RPT_DOC_DATE = :DATE_SUMMARY
         and A.ID_HOTEL = :ID_HOTEL
  into   :DISCOUNTS_VALUE;

  update SUMMARY_END_WORK
  set    PAYMENT_AMOUNT = coalesce(:PAYMENT_AMOUNT, 0),
         PAYMENT_TRANSACTIONS = coalesce(:PAYMENT_TRANSACTIONS, 0),
         FISCAL_PAY_AMOUNT = coalesce(:FISCAL_PAY_AMOUNT, 0),
         FISCAL_PAY_TRANSACTIONS = coalesce(:FISCAL_PAY_TRANSACTIONS, 0),
         DISCOUNTS_AMOUNT = coalesce(-:DISCOUNTS_VALUE, 0)
  where  ID_END_WORK = :ID_END_WORK;

  for
    select D.PAY_CURRENCY,
           sum(iif (D.FLOW_TYPE = 'create', D.PAY_VALUE, 0)) as ACCEPTED_AMOUNT,
           sum(iif (D.FLOW_TYPE = 'use', D.PAY_VALUE, 0)) as USED_AMOUNT,
           sum(iif (D.FLOW_TYPE = 'refund', D.PAY_VALUE, 0)) as REFUNDED_AMOUNT
    from   DEPOSIT_FLOW D
    where  /*D.IS_ANUL = 0
           and*/ D.OCCUR_DATE = :DATE_SUMMARY
           and D.ID_HOTEL = :ID_HOTEL
    group by D.PAY_CURRENCY
    into   :CURRENCY, :ACCEPTED_AMOUNT, :USED_AMOUNT, :REFUNDED_AMOUNT
  do begin
    insert into SUMMARY_DEPOSITS (ID_END_WORK, CURRENCY, ACCEPTED_AMOUNT, USED_AMOUNT, REFUNDED_AMOUNT)
    values (:ID_END_WORK, :CURRENCY, :ACCEPTED_AMOUNT, :USED_AMOUNT, :REFUNDED_AMOUNT);

  end
end
^

/* Alter (PMS_ROOM_DOCS_PREPARE$RPT) */
ALTER PROCEDURE PMS_ROOM_DOCS_PREPARE$RPT(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER)
 RETURNS(REC_COUNT INTEGER)
 AS
begin
  delete from PMS_ROOM_DOCS$TMP;


  insert into PMS_ROOM_DOCS$TMP (id_room, id_doc_head,  for_date, ID_RESERV_DETAIL, id_room_contract, ID_ROOM_PERIOD,
         post_net_value, post_gross_value, nat_net_value, nat_gross_value, nights)
  select ap.ID_ROOM, dh.ID_DOC, dh.RPT_DOC_DATE, g.ID_RESERV_DETAIL, rc.ID_ROOM_CONTRACT, RP.ID_ROOM_PERIOD,
         sum(SV.VALUE_WOT_TAX * dh.VALUE_CORR_IDX),
         sum(pv.ACCOUNT_PRICE * dl.QTY_POST * dh.VALUE_CORR_IDX),
         sum(dl.NAT_NET_VALUE * dh.VALUE_CORR_IDX),
         sum(dl.NAT_GROSS_VALUE * dh.VALUE_CORR_IDX),
         --count(distinct dl.DATE_POST),
         floor(sum(DH.VALUE_CORR_IDX*DL.QTY_POST*(1-dl.IS_CORRECT))/max(rd.ADULT_COUNT + rd.CHILD_COUNT))
  from   DOCUMENT_RELEASE DH
         join DOC_LINE DL on DL.ID_DOC_HEAD = DH.ID_DOC
         join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
         join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = PV.ID_ACCOUNT_POST and ap.IS_BASE = 1
         join ROOMS R on R.ID_ROOM = AP.ID_ROOM
         join GUEST G on G.ID_GUEST = ap.ID_GUEST
         join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
         join CURRS c on c.CURR = ap.CURR_POST
         left outer join TAX_VALUE_DEDUCT (pv.ACCOUNT_PRICE * dl.QTY_POST, c.ROUND_TO, dl.ID_SALE_TAXATION) SV on 1=1
         left outer join ROOM_PERIOD$PMS rp on rp.ID_ROOM = r.id_room
                                      and rp.FROM_DATE <= dl.DATE_POST
                                      and rp.TO_DATE >= dl.DATE_POST
         left outer join ROOM_CONTRACT$PMS rc on rc.ID_ROOM_PERIOD = rp.ID_ROOM_PERIOD
  where  DH.RPT_DOC_DATE between :FROM_DATE and :TO_DATE
         and R.ID_HOTEL = :ID_HOTEL
  group by 1, 2, 3, 4, 5, 6;

  REC_COUNT = row_count;
  suspend;
end
^

/* Alter (POST_PREPARE_ON_GUEST$POST) */
ALTER PROCEDURE POST_PREPARE_ON_GUEST$POST(ID_GUEST ID_REF,
ID_SERVICE ID_REF,
QTY TQTY,
ID_SEQUENCE TRANGE,
PRICE_POST TPRICE,
CURR_POST TCURRENCY,
POST_TEXT TOBJECT_TEXT,
FROM_DATE TDATE,
TO_DATE TDATE)
 RETURNS(NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable no_use varchar(255);
begin
  /* check if exists available posting account for guest */
  execute procedure GUEST_GET_POSTING_ACCOUNT$INT (:ID_GUEST, '')
  returning_values  (:no_use, :no_use);

  execute procedure POST_PREPARE$INT(null, :ID_GUEST, :ID_SERVICE, :QTY, :ID_SEQUENCE,
          :PRICE_POST, :CURR_POST, :POST_TEXT, :FROM_DATE, :TO_DATE, null)
  returning_values (:NEW_FROM_DATE);
end
^

/* empty dependent procedure body */
/* Clear: PMS_POSTING_CREATE$INT for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
POST_DATE /* TYPE OF TDATE */ DATE,
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
POST_ON_PMS_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
IS_OWNER_INCOME /* TYPE OF TLOGICAL */ SMALLINT,
ID_ROOM /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_FINALIZE$POST for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_ACCOUNT$INT) */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
QTY TYPE OF TQTY,
ID_SECQUENCE TYPE OF ID,
IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
DATE_POST TYPE OF TDATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ID_ROOM TYPE OF ID = null,
POST_DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable action_text varchar(255);
begin
  if (:date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :date_post;
  end
/* NO AUTO PRICE !!!!!!
  if (:in_is_manual_price = 0) then begin

    select P.ID_EXTRA_TARIFF
    from   ACCOUNT A
           join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
    where  A.ID_ACCOUNT = :in_id_account
    into   :id_extra_tarifa;
    if ((:id_extra_tarifa is null) or (:id_extra_tarifa < 0)) then begin
      err_code = -14;
      exit;
    end
    execute procedure TAR_RECALC_EXTRASRV(:id_extra_tarifa, :in_id_service, :in_date_post)
    returning_values  :err_code, :err_text, :post_price, :post_currency;
    if (:err_code < 0) then exit;
  end else begin
    --MANUAL PRICE
    post_currency = :manual_curr ;
    post_price = :manual_price ;
  end
*/

  post_currency = :manual_curr ;
  post_price = :manual_price ;
  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, -1, :id_secquence, :date_post, :id_service, -1, :id_room, 0, :qty, :post_price,
    :post_currency, null, :short_code, :from_date, :to_date, :post_text, :resource_text, '', -1, :POST_DESCRIPTION)
  returning_values :err_code, :err_text, :id_account_post;
  if (:err_code <> 0) then exit;

  select S.SERVICE_NAME
  from   SERVICES S
  where  S.ID_SERVICE = :ID_SERVICE
  into   :action_text;
   
  action_text = f_character(29) || coalesce(:action_text, '')
                || f_character(28) || formatdate(:DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || coalesce(:post_currency, '');
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_RESERVATION$INT for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ROOM for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255))
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_GUEST /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_GUEST$INT) */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TDESCRIPTION_SHORT,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ACCOUNT_ROUTING TYPE OF TSHORT_CODE,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable id_room integer;
  declare variable no_use varchar(255);
  declare variable action_text varchar(255);
  declare variable is_guest_check_in smallint;
  declare variable service_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  select g.check_status
  from   guest g
  where  g.id_guest = :in_id_guest
  into   :is_guest_check_in;

  if (:is_guest_check_in < 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
  end

  execute procedure GUEST_GET_POSTING_ACCOUNT$INT (:in_id_guest, :account_routing)
  returning_values  :id_account, :id_room;

  if (:in_date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :in_date_post;
  end

  if (:in_is_manual_price = 0) then begin
    execute procedure SERVICE_GET_POSTING_DETAILS(:in_id_service, :IN_DATE_POST)
    returning_values  :no_use, :no_use, :service_name, :post_price, :post_currency;
  end else begin
    /* MANUAL PRICE */
    post_currency = :manual_curr;
    post_price = :manual_price;
    select s.SERVICE_NAME
    from   SERVICES s
    where  s.ID_SERVICE = :IN_ID_SERVICE
    into   :service_name;
  end

  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, :in_id_guest, :in_id_secquence, :in_date_post, :in_id_service, -1, :id_room, 0, :in_qty,
    :post_price, :post_currency, null, :in_short_code, :in_from_datetime, :in_to_datetime, :in_post_text,
    :in_resource_text, '', -1, :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account_post;

  action_text = f_character(29) || coalesce(:service_name, '')
                || f_character(28) || formatdate(:IN_DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:IN_QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || coalesce(:post_currency, '');
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: RESOURCE_RESERVATION_CHECK_IN for: POST_SERVICE_ON_RESERVATION$INT */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_RESERVATION$INT) */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TREASON,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable id_guest integer;
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select RD.ID_TITULAR
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :id_guest;

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence,
                    :in_is_manual_price, :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime,
                    :in_post_text, :in_resource_text, :in_date_post, :in_short_code, '', :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* Alter (POST_SERVICE_ON_ROOM) */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TREASON,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_GUEST TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select first 1 G.ID_GUEST
  from   GUEST G
  where  G.ID_ROOM = :in_id_room
         and G.CHECK_STATUS = 0
  order by G.FROM_DATE desc, G.ID_GUEST asc
        /************************************************/
        /* DESCENDANT ORDER IS VERY IMPORTANT!!         */
        /* IF TWO GUESTS HAVE:                          */
        /* TO_DATE OF THE 1'ST = FROM_DATE OF THE 2'ND, */
        /* THEN PHONACALLS SHOULD GO TO THE 2'ND        */         
        /************************************************/
  into   :id_guest;

  if (:id_guest is null) then begin
    err_code = -24;   /* NO GUESTS ARE CHECKED_IN INTO THE REQUESTED ROOM! */
    exit;
  end

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence, :in_is_manual_price,
    :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime, :in_post_text, :in_resource_text,
    :in_date_post, :in_short_code, '')
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* empty dependent procedure body */
/* Clear: EAI_TELECOUNT_TRANSFER for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALL_POST$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL /* ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALLS_POST_TO_ACCOUNT$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_TRANSFER$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_TELECOUNT_CALL$INT) */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ext_ifc_name varchar(20);
  declare variable room_name varchar(30);
  declare variable datetime_call timestamp;
  declare variable price numeric(15,2);
  declare variable dial_number varchar(50);
  declare variable units integer;
  declare variable pc_id_service integer;
  declare variable def_manual_curr char(3);
  declare variable post_text varchar(50);
  declare variable id_account_post integer;
  declare variable is_archive integer;
  declare variable id_account integer;
  declare variable new_id_account_post integer;
  declare variable pc_tag varchar(30);
  declare variable number_zone varchar(50);
  declare variable id_hotel integer;
  declare variable id_phonecall integer;
  declare variable no_use varchar(255);
begin
  /* Description:
  || POST_TO_TYPE = 0 - ACCOUNT, 1 - GUEST, 2 - RESERV_DETAIL, 3 - JUST PREPARE, FOR EXTERNAL CLIENT
  */
  err_code = 0;
  err_text = '';
  ext_ifc_name = 'TELECOUNT';

  select PC.ID_PHONECALL, PC.ROOM_NAME, PC.DATETIME_CALL, PC.PRICE, PC.DIAL_NUMBER, PC.UNITS,
         PC.ID_ACCOUNT_POST, PC.IS_ARCHIVE, PC.TAG, substring(PC.NUMBER_ZONE from 1 for 30), pc.ID_HOTEL
  from   PHONECALLS PC 
  where  PC.rdb$db_key = :ph_dbkey
  into   :id_phonecall, :room_name, :datetime_call, :price, :dial_number, :units,
         :id_account_post, :is_archive, :pc_tag, :number_zone, :id_hotel;

  if ((:is_archive = 1) or (coalesce(:id_account_post, 0) > 0)) then exit;

  if ((:pc_tag is null) or (:pc_tag = '')) then pc_tag = 'TELECOUNT_DEFAULT';
  else pc_tag = 'TELECOUNT_' || :pc_tag;

  execute procedure EAI_MAP_SERVICE(:pc_tag, :number_zone, :ext_ifc_name, :id_hotel)
  returning_values  :err_code, :err_text, :pc_id_service;
  if (:err_code < 0) then exit;

  post_text = substring(:dial_number || ', impulses ' || :units from 1 for 50);

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :def_manual_curr;

  new_id_account_post = null;
  if (:post_to_type = 0) then begin
    id_account = :post_to_id;
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :new_id_account_post;
  end else if (:post_to_type = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:post_to_id, :pc_id_service, 1, -1, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name, '')
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 2) then begin
    execute procedure POST_SERVICE_ON_RESERVATION$INT(:post_to_id, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 3) then begin
    execute procedure POST_PREPARE_ON_ACCOUNT$POST (:post_to_id, :pc_id_service,
      1, :ID_SEQUENCE, :price, :def_manual_curr, :post_text, null, null, :ID_PHONECALL)
    returning_values :no_use;
  end
  if (:err_code < 0) then exit;

  if (:new_id_account_post is not null) then begin
    update PHONECALLS PC
    set    PC.ID_ACCOUNT_POST = :new_id_account_post,
           pc.POSTING_ERROR = null
    where  PC.rdb$db_key = :ph_dbkey;

    insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
    values (:new_id_account_post, :ext_ifc_name, null, :datetime_call);
  end

end
^

/* Alter (POST_TELECOUNT_TRANSFER$TC) */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ph_dbkey char(8);
  declare variable id_account_post integer;
  declare variable account_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  for
    select PC.RDB$DB_KEY, PC.ID_ACCOUNT_POST
    from   PHONECALLS PC
    where  PC.SELECTION_ID = :selection_id
    into   :ph_dbkey, :id_account_post
  do begin
    if ((:id_account_post is not null) and (:id_account_post <> -1)) then begin
      err_code = -117;
      select A.ACCOUNT_NAME
      from   ACCOUNT_POST AP
             join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
      where  AP.ID_ACCOUNT_POST = :id_account_post
      into   :account_name;
      err_text = f_character(29) || :account_name;
      exit;
    end

    execute procedure POST_TELECOUNT_CALL$INT(2, :id_reserv_detail, :ph_dbkey, 0)
    returning_values :err_code, :err_text;
    if (:err_code < 0) then exit;
  end
end
^

/* Alter (PROFILE_GET_ACCOUNT$INT) */
ALTER PROCEDURE PROFILE_GET_ACCOUNT$INT(ID_PROFILE INTEGER,
ID_RESERV_DETAIL INTEGER,
ACCOUNT_CURR VARCHAR(3),
ID_ACC_TEMPLATE INTEGER,
IS_BASE_ENABLE SMALLINT = 1,
IS_EXTRA_ENABLE SMALLINT = 1)
 RETURNS(ID_ACCOUNT INTEGER)
 AS
declare variable is_archive integer;
declare variable id_hotel integer;
begin
  id_account = null;

  select first 1 A.ID_ACCOUNT, a.IS_ARCHIVE
  from   ACCOUNT A
  where  A.ID_PROFILE = :id_profile
         and A.ACCOUNT_CURR = :account_curr
         and A.ID_RESERV_DETAIL is not distinct from :id_reserv_detail
         and A.IS_BASE >= :IS_BASE_ENABLE
         and A.IS_EXTRA >= :IS_EXTRA_ENABLE
  order by A.IS_ARCHIVE asc, A.ID_ACCOUNT asc
  into   :id_account, :is_archive;

  if (:id_account is null) then begin
    if (:id_acc_template is null) then begin
      select rd.ID_HOTEL
      from   RESERV_DETAIL RD
      where  rd.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
      into   :id_hotel;

      select P.ID_ACCOUNT_TEMPLATE
      from   PROFILE_BOOKING_DEFAULTS P
      where  P.ID_PROFILE = :id_profile
             and P.ID_HOTEL = :id_hotel
      into   :id_acc_template;
    end

    execute procedure RES_ACCOUNT_CREATE$INT(:id_profile, :id_acc_template, :account_curr,
            :id_reserv_detail, :IS_BASE_ENABLE, :IS_EXTRA_ENABLE)
    returning_values  :id_account;

  end else if (:is_archive = 1) then begin
    execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 0);
  end
end
^

/* Alter (PROFILE_GET_ACCOUNT$PROFILE) */
ALTER PROCEDURE PROFILE_GET_ACCOUNT$PROFILE(ID_PROFILE INTEGER,
SHOW_ARCHIVE SMALLINT)
 RETURNS(ID_ACCOUNT INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
DEPOSIT_VALUE NUMERIC(15,4),
BALANCE_VALUE NUMERIC(15,4),
IS_DEFAULT SMALLINT,
IS_CREDIT SMALLINT,
CREDIT_LIMIT NUMERIC(15,4),
ID_TYPE_PAYMENT INTEGER,
IS_LEVEL_1 INTEGER,
IS_ARCHIVE INTEGER,
HOTEL_NAME VARCHAR(50))
 AS
begin
  for
    select A.ID_ACCOUNT, A.ACCOUNT_CURR, A.ACCOUNT_NAME, A.CREDIT_LIMIT,
           A.IS_CREDIT_ACCOUNT, A.ID_TYPE_PAYMENT, AB.DEP_VALUE, AB.ACCOUNT_BALANCE,
           A.IS_DEFAULT,
           case
             when A.SECURITY_LEVEL = 1 then 1
             else 0
           end,
           A.IS_ARCHIVE, H.HOTEL_NAME
    from  ACCOUNT_S A
          join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
          join HOTEL_S H on H.ID_HOTEL = A.ID_HOTEL
          left outer join ACCOUNT_BALANCE$INT(A.ID_ACCOUNT) AB on 0=0
    where A.ID_PROFILE = :ID_PROFILE
          and (:SHOW_ARCHIVE = 1 or A.IS_ARCHIVE = 0)
    into  :ID_ACCOUNT, :ACCOUNT_CURR, :ACCOUNT_NAME, :CREDIT_LIMIT,
          :IS_CREDIT, :ID_TYPE_PAYMENT, :DEPOSIT_VALUE, :BALANCE_VALUE,
          :IS_DEFAULT, :IS_LEVEL_1, :IS_ARCHIVE, :HOTEL_NAME
  do begin
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: PROFILE_STATISTIC_COMPARABLE for: PROFILE_GET_STATISTIC */
ALTER PROCEDURE PROFILE_STATISTIC_COMPARABLE(ID_PROFILE INTEGER,
TO_DATE DATE,
ID_HOTEL INTEGER,
COMPARABLE_YEAR SMALLINT,
IS_VAT SMALLINT)
 RETURNS(FIELD_NAME VARCHAR(50),
DAY_VALUE NUMERIC(15,4),
MONTH_VALUE NUMERIC(15,4),
YEAR_VALUE NUMERIC(15,4),
COMPARABLE_DAY_VALUE NUMERIC(15,4),
COMPARABLE_MONTH_VALUE NUMERIC(15,4),
COMPARABLE_YEAR_VALUE NUMERIC(15,4))
 AS
 BEGIN SUSPEND; END
^

/* Alter (PROFILE_GET_STATISTIC) */
ALTER PROCEDURE PROFILE_GET_STATISTIC(ID_PROFILE INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER,
IS_VAT SMALLINT,
PERIODICITY VARCHAR(30) = null)
 RETURNS(OUT_ID_HOTEL INTEGER,
OUT_PERIOD VARCHAR(20),
ARRIVALS INTEGER,
NIGHTS INTEGER,
NIGHTS_NOSHOW INTEGER,
NIGHTS_CANCELED INTEGER,
GUESTS INTEGER,
GUEST_NIGHTS INTEGER,
ROOM_REVENUE NUMERIC(15,4),
FB_REVENUE NUMERIC(15,4),
OTHER_OPERATED_REVENUE NUMERIC(15,4),
OTHER_RENTAL_REVENUE NUMERIC(15,4))
 AS
declare variable profile_type varchar(50);
declare variable from_ timestamp;
declare variable to_ timestamp;
begin
  -- ID_PROFILE = null - interpret as walkins, without arranger
  select P.PROFILE_TYPE
  from   PROFILE p
  where  P.ID_PROFILE = :id_profile
  into   :profile_type;

  if (:profile_type is null) then profile_type = coalesce(:profile_type, 'AGENT');

  for
    select H.ID_HOTEL, cast(SP.FROM_TIMESTAMP as date), cast(SP.TO_TIMESTAMP as date), SP.OUT_PERIOD
    from   HOTEL_S H
           left outer join SYSTEM_DATE_GET(h.id_hotel) sdg on 1=1
           left outer join SYSTEM_DIVIDE_PERIOD (:FROM_DATE, mindate(cast(:TO_DATE as timestamp), cast((sdg.system_date - 1) as timestamp)), :PERIODICITY) SP on 1=1
    where  H.ID_HOTEL = coalesce(:id_hotel, H.ID_HOTEL)
    into   :out_id_hotel, :from_, :to_, :OUT_PERIOD
  do begin
    NIGHTS = null; ROOM_REVENUE = null;
    if (:profile_type = 'AGENT') then begin
      select sum(S.ROOMS_SOLD), sum(S.ROOMS_ARRIVAL), sum(S.ROOMS_NOSHOW), sum(S.ROOMS_CANCELED),
             sum(iif(s.FOR_DATE = cast(:from_ as date), s.GUESTS_IN_HOUSE, s.GUESTS_ARRIVAL)), sum(s.GUESTS_IN_HOUSE)
      from   SUMMARY_OCCUPANCY_OTHER S
      where  S.ID_PROFILE_AGENT is not distinct from :id_profile -- because of <null> AGENT - without arranger
             and S.ID_HOTEL = :out_id_hotel
             and S.FOR_DATE between :from_ and :to_
      into   :NIGHTS, :ARRIVALS, :NIGHTS_NOSHOW, :NIGHTS_CANCELED,
             :GUESTS, :GUEST_NIGHTS;

      select sum(iif(sg.REVENUE_GROUP = 'ROOMS', iif(:is_vat = 0, sp.TOTAL_REVENUE, sp.TOTAL_REVENUE + sp.vat_amount), 0)),
             sum(iif(sg.REVENUE_GROUP = 'Food and Beverage', iif(:is_vat = 0, sp.TOTAL_REVENUE, sp.TOTAL_REVENUE + sp.vat_amount), 0)),
             sum(iif(sg.REVENUE_GROUP = 'Other Operated Departments', iif(:is_vat = 0, sp.TOTAL_REVENUE, sp.TOTAL_REVENUE + sp.vat_amount), 0)),
             sum(iif(sg.REVENUE_GROUP = 'Rentals and Other Income', iif(:is_vat = 0, sp.TOTAL_REVENUE, sp.TOTAL_REVENUE + sp.vat_amount), 0))
      from   SUMMARY_PROFILES$REV Sp
             join SUMMARY_REV_GROUPS$REV SG on sg.ID_SUMMARY_REV_GROUP = sp.ID_SUMMARY_REVENUE_GROUP
             join SUMMARY_END_WORK se on se.ID_END_WORK = sg.ID_END_WORK
      where  se.ID_HOTEL = :out_id_hotel
             and sp.SUMMARY_DATE between :from_ and :to_
             and sp.ID_PROFILE is not distinct from :ID_PROFILE -- because of <null> AGENT - without arranger
      into   :ROOM_REVENUE, :FB_REVENUE, :OTHER_OPERATED_REVENUE, :OTHER_RENTAL_REVENUE;

      if ((coalesce(:NIGHTS, 0) <> 0) or (coalesce(:ARRIVALS, 0) <> 0) or (coalesce(:NIGHTS_NOSHOW, 0) <> 0) or (coalesce(:NIGHTS_CANCELED, 0) <> 0)
          or (coalesce(:GUESTS, 0) <> 0) or (coalesce(:GUEST_NIGHTS, 0) <> 0)
          or (coalesce(:ROOM_REVENUE, 0) <> 0) or (coalesce(:FB_REVENUE, 0) <> 0) or (coalesce(:OTHER_OPERATED_REVENUE, 0) <> 0) or (coalesce(:OTHER_RENTAL_REVENUE, 0) <> 0)) then suspend;

    end else begin
      select count(iif(RD.IS_ANUL = 0 and rm.DAY_ACTION not containing 'CHECK_OUT', rm.ID_ROOM_MAGIC, null)),
             count(iif(RD.IS_ANUL = 0 and rm.DAY_ACTION containing 'CHECK_IN', rm.ID_ROOM_MAGIC, null)),
             count(iif(RD.IS_ANUL = 1 and RD.REASON_OF_ANUL = 'NOSHOW', sp.OUT_DATE, null)),
             count(iif(RD.IS_ANUL = 1 and RD.REASON_OF_ANUL is distinct from 'NOSHOW', sp.OUT_DATE, null)),
             sum(iif(RD.IS_ANUL = 0 and rm.DAY_ACTION containing 'CHECK_IN', rm.ADULT_COUNT + rm.CHILDREN_COUNT, 0)),
             sum(iif(RD.IS_ANUL = 0 and rm.DAY_ACTION not containing 'CHECK_OUT', rm.ADULT_COUNT + rm.CHILDREN_COUNT, 0))
      from   RESERV_DETAIL RD
             left outer join SYSTEM_LOOP_PERIOD (maxdate(rd.FROM_DATE, :from_), mindate(rd.TO_DATE - 1, :to_)) SP on 1=1
             left outer join ROOM_MAGIC RM on rm.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                              and RM.BUSY_DATE = sp.out_date
                                              and rm.DAY_ACTION <> 'CHECK_OUT'
      where  RD.ID_PERSON_PROFILE = :id_profile
             and RD.ID_HOTEL = :out_id_hotel
             and RD.FROM_DATE <= :to_
             and rd.TO_DATE > :from_
      into   :NIGHTS, :ARRIVALS, :NIGHTS_NOSHOW, :NIGHTS_CANCELED,
             :GUESTS, :GUEST_NIGHTS;

      select sum(iif(s.REVENUE_GROUP = 'ROOMS', iif(:is_vat = 0, ad.NAT_NET_VALUE, ad.NAT_GROSS_VALUE), null)),
             sum(iif(s.REVENUE_GROUP = 'Food and Beverage', iif(:is_vat = 0, ad.NAT_NET_VALUE, ad.NAT_GROSS_VALUE), null)),
             sum(iif(s.REVENUE_GROUP = 'Other Operated Departments', iif(:is_vat = 0, ad.NAT_NET_VALUE, ad.NAT_GROSS_VALUE), null)),
             sum(iif(s.REVENUE_GROUP = 'Rentals and Other Income', iif(:is_vat = 0, ad.NAT_NET_VALUE, ad.NAT_GROSS_VALUE), null))
      from   RESERV_DETAIL RD
             join GUEST G on G.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
             join ACCOUNT_DEBT AD on AD.ID_GUEST = g.ID_GUEST
             join SERVICES S on S.ID_SERVICE = AD.ID_SERVICE
      where  RD.ID_PERSON_PROFILE = :id_profile
             and RD.ID_HOTEL = :out_id_hotel
             and AD.DEBT_DATE between :from_ and :to_
      into   :ROOM_REVENUE, :FB_REVENUE, :OTHER_OPERATED_REVENUE, :OTHER_RENTAL_REVENUE;

      if ((coalesce(:NIGHTS, 0) <> 0) or (coalesce(:ARRIVALS, 0) <> 0) or (coalesce(:NIGHTS_NOSHOW, 0) <> 0) or (coalesce(:NIGHTS_CANCELED, 0) <> 0)
          or (coalesce(:GUESTS, 0) <> 0) or (coalesce(:GUEST_NIGHTS, 0) <> 0)
          or (coalesce(:ROOM_REVENUE, 0) <> 0) or (coalesce(:FB_REVENUE, 0) <> 0) or (coalesce(:OTHER_OPERATED_REVENUE, 0) <> 0) or (coalesce(:OTHER_RENTAL_REVENUE, 0) <> 0)) then suspend;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_SET_ARCHIVE_STATUS for: PROFILE_SET_ARCHIVE$INT */
ALTER PROCEDURE ACCOUNT_SET_ARCHIVE_STATUS(ID_ACCOUNT INTEGER,
IS_ARCHIVE SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_COMMON_MODIFY$INT for: PROFILE_SET_ARCHIVE$INT */
ALTER PROCEDURE PROFILE_COMMON_MODIFY$INT(ID_PROFILE INTEGER,
PROFILE_TYPE VARCHAR(20),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PROFILE_SET_ARCHIVE$INT) */
ALTER PROCEDURE PROFILE_SET_ARCHIVE$INT(P_DBKEY CHAR(8),
ARCHIVE_STATUS SMALLINT)
 AS
declare variable old_is_archive smallint;
  declare variable id_profile integer;
  declare variable id_account integer;
  declare variable id_merge_profile integer;
begin
  select P.IS_ARCHIVE, P.ID_PROFILE, p.ID_MERGE_PROFILE
  from   PROFILE P
  where  P.RDB$DB_KEY = :P_DBKEY
  into   :old_is_archive, :id_profile, :id_merge_profile;
   
  if (:ARCHIVE_STATUS > :old_is_archive) then begin
    /* archive */
    if (exists (select app.ID_ACCOUNT_POST
                from   ACCOUNT_POST$PMS APP
                where  app.ID_OWNER = :id_profile
                       and app.LINE_STATUS = 11)) then
      exception PROFILE_EXCEPTION '-1050';

    for
      select A.ID_ACCOUNT
      from   ACCOUNT A
      where  A.ID_PROFILE = :id_profile
             and a.IS_ARCHIVE is distinct from 1
      into   :id_account
    do begin
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS (:id_account, 1);
    end 

  end else if (:ARCHIVE_STATUS < :old_is_archive) then begin
    /* unarchive */
    if (:id_merge_profile is not null) then exception PROFILE_EXCEPTION '-1045';

    for
      select A.ID_ACCOUNT
      from   ACCOUNT A
      where  A.ID_PROFILE = :id_profile
             and a.IS_PMS_ACCOUNT = 1
             and a.IS_ARCHIVE = 1
      into   :id_account
    do begin
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS (:id_account, 0);
    end 

  end

  update PROFILE P
  set    P.IS_ARCHIVE = :ARCHIVE_STATUS
  where  P.RDB$DB_KEY = :P_DBKEY;
   
end
^

/* Alter (PROFILE_STATISTIC_COMPARABLE) */
ALTER PROCEDURE PROFILE_STATISTIC_COMPARABLE(ID_PROFILE INTEGER,
TO_DATE DATE,
ID_HOTEL INTEGER,
COMPARABLE_YEAR SMALLINT,
IS_VAT SMALLINT)
 RETURNS(FIELD_NAME VARCHAR(50),
DAY_VALUE NUMERIC(15,4),
MONTH_VALUE NUMERIC(15,4),
YEAR_VALUE NUMERIC(15,4),
COMPARABLE_DAY_VALUE NUMERIC(15,4),
COMPARABLE_MONTH_VALUE NUMERIC(15,4),
COMPARABLE_YEAR_VALUE NUMERIC(15,4))
 AS
declare variable from_ date;
declare variable comparable_from date;
declare variable comparable_to date;
declare variable field_names varchar(255);
begin
  field_names = 'arrivals,nights,nights_noshow,nights_canceled,guests,guest_nights,room_revenue,fb_revenue,other_operated_revenue,other_rental_revenue';
  -- this is permissible value indicators, returned as FIELD_NAME

  from_ = cast('01.01.'||extract(year from :to_date) as date);
  comparable_from = cast('01.01.'||:comparable_year as date);
  comparable_to = cast(extract(day from :to_date)||'.'||extract(month from :to_date)||'.'||:comparable_year as date);
  for
    select sp.item as field_name,
       sum(case
             when ps.OUT_PERIOD = 'day' and sp.ITEM = 'arrivals' then ps.ARRIVALS
             when ps.OUT_PERIOD = 'day' and sp.ITEM = 'nights' then ps.NIGHTS
             when ps.OUT_PERIOD = 'day' and sp.ITEM = 'nights_noshow' then ps.NIGHTS_NOSHOW
             when ps.OUT_PERIOD = 'day' and sp.ITEM = 'nights_canceled' then ps.NIGHTS_CANCELED
             when ps.OUT_PERIOD = 'day' and sp.ITEM = 'guests' then ps.GUESTS
             when ps.OUT_PERIOD = 'day' and sp.ITEM = 'guest_nights' then ps.GUEST_NIGHTS
             when ps.OUT_PERIOD = 'day' and sp.ITEM = 'room_revenue' then ps.ROOM_REVENUE
             when ps.OUT_PERIOD = 'day' and sp.ITEM = 'fb_revenue' then ps.FB_REVENUE
             when ps.OUT_PERIOD = 'day' and sp.ITEM = 'other_operated_revenue' then ps.OTHER_OPERATED_REVENUE
             when ps.OUT_PERIOD = 'day' and sp.ITEM = 'other_rental_revenue' then ps.OTHER_RENTAL_REVENUE
             else null
           end) as day_value,
       sum(case
             when ps.OUT_PERIOD = 'month' and sp.ITEM = 'arrivals' then ps.ARRIVALS
             when ps.OUT_PERIOD = 'month' and sp.ITEM = 'nights' then ps.NIGHTS
             when ps.OUT_PERIOD = 'month' and sp.ITEM = 'nights_noshow' then ps.NIGHTS_NOSHOW
             when ps.OUT_PERIOD = 'month' and sp.ITEM = 'nights_canceled' then ps.NIGHTS_CANCELED
             when ps.OUT_PERIOD = 'month' and sp.ITEM = 'guests' then ps.GUESTS
             when ps.OUT_PERIOD = 'month' and sp.ITEM = 'guest_nights' then ps.GUEST_NIGHTS
             when ps.OUT_PERIOD = 'month' and sp.ITEM = 'room_revenue' then ps.ROOM_REVENUE
             when ps.OUT_PERIOD = 'month' and sp.ITEM = 'fb_revenue' then ps.FB_REVENUE
             when ps.OUT_PERIOD = 'month' and sp.ITEM = 'other_operated_revenue' then ps.OTHER_OPERATED_REVENUE
             when ps.OUT_PERIOD = 'month' and sp.ITEM = 'other_rental_revenue' then ps.OTHER_RENTAL_REVENUE
             else null
           end) as month_value,
       sum(case
             when ps.OUT_PERIOD = 'year' and sp.ITEM = 'arrivals' then ps.ARRIVALS
             when ps.OUT_PERIOD = 'year' and sp.ITEM = 'nights' then ps.NIGHTS
             when ps.OUT_PERIOD = 'year' and sp.ITEM = 'nights_noshow' then ps.NIGHTS_NOSHOW
             when ps.OUT_PERIOD = 'year' and sp.ITEM = 'nights_canceled' then ps.NIGHTS_CANCELED
             when ps.OUT_PERIOD = 'year' and sp.ITEM = 'guests' then ps.GUESTS
             when ps.OUT_PERIOD = 'year' and sp.ITEM = 'guest_nights' then ps.GUEST_NIGHTS
             when ps.OUT_PERIOD = 'year' and sp.ITEM = 'room_revenue' then ps.ROOM_REVENUE
             when ps.OUT_PERIOD = 'year' and sp.ITEM = 'fb_revenue' then ps.FB_REVENUE
             when ps.OUT_PERIOD = 'year' and sp.ITEM = 'other_operated_revenue' then ps.OTHER_OPERATED_REVENUE
             when ps.OUT_PERIOD = 'year' and sp.ITEM = 'other_rental_revenue' then ps.OTHER_RENTAL_REVENUE
             else null
           end) as year_value,
       sum(case
             when psc.OUT_PERIOD = 'day' and sp.ITEM = 'arrivals' then psc.ARRIVALS
             when psc.OUT_PERIOD = 'day' and sp.ITEM = 'nights' then psc.NIGHTS
             when psc.OUT_PERIOD = 'day' and sp.ITEM = 'nights_noshow' then psc.NIGHTS_NOSHOW
             when psc.OUT_PERIOD = 'day' and sp.ITEM = 'nights_canceled' then psc.NIGHTS_CANCELED
             when psc.OUT_PERIOD = 'day' and sp.ITEM = 'guests' then psc.GUESTS
             when psc.OUT_PERIOD = 'day' and sp.ITEM = 'guest_nights' then psc.GUEST_NIGHTS
             when psc.OUT_PERIOD = 'day' and sp.ITEM = 'room_revenue' then psc.ROOM_REVENUE
             when psc.OUT_PERIOD = 'day' and sp.ITEM = 'fb_revenue' then psc.FB_REVENUE
             when psc.OUT_PERIOD = 'day' and sp.ITEM = 'other_operated_revenue' then psc.OTHER_OPERATED_REVENUE
             when psc.OUT_PERIOD = 'day' and sp.ITEM = 'other_rental_revenue' then psc.OTHER_RENTAL_REVENUE
             else null
           end) as comparable_day_value,
       sum(case
             when psc.OUT_PERIOD = 'month' and sp.ITEM = 'arrivals' then psc.ARRIVALS
             when psc.OUT_PERIOD = 'month' and sp.ITEM = 'nights' then psc.NIGHTS
             when psc.OUT_PERIOD = 'month' and sp.ITEM = 'nights_noshow' then psc.NIGHTS_NOSHOW
             when psc.OUT_PERIOD = 'month' and sp.ITEM = 'nights_canceled' then psc.NIGHTS_CANCELED
             when psc.OUT_PERIOD = 'month' and sp.ITEM = 'guests' then psc.GUESTS
             when psc.OUT_PERIOD = 'month' and sp.ITEM = 'guest_nights' then psc.GUEST_NIGHTS
             when psc.OUT_PERIOD = 'month' and sp.ITEM = 'room_revenue' then psc.ROOM_REVENUE
             when psc.OUT_PERIOD = 'month' and sp.ITEM = 'fb_revenue' then psc.FB_REVENUE
             when psc.OUT_PERIOD = 'month' and sp.ITEM = 'other_operated_revenue' then psc.OTHER_OPERATED_REVENUE
             when psc.OUT_PERIOD = 'month' and sp.ITEM = 'other_rental_revenue' then psc.OTHER_RENTAL_REVENUE
             else null
           end) as comparable_month_value,
       sum(case
             when psc.OUT_PERIOD = 'year' and sp.ITEM = 'arrivals' then psc.ARRIVALS
             when psc.OUT_PERIOD = 'year' and sp.ITEM = 'nights' then psc.NIGHTS
             when psc.OUT_PERIOD = 'year' and sp.ITEM = 'nights_noshow' then psc.NIGHTS_NOSHOW
             when psc.OUT_PERIOD = 'year' and sp.ITEM = 'nights_canceled' then psc.NIGHTS_CANCELED
             when psc.OUT_PERIOD = 'year' and sp.ITEM = 'guests' then psc.GUESTS
             when psc.OUT_PERIOD = 'year' and sp.ITEM = 'guest_nights' then psc.GUEST_NIGHTS
             when psc.OUT_PERIOD = 'year' and sp.ITEM = 'room_revenue' then psc.ROOM_REVENUE
             when psc.OUT_PERIOD = 'year' and sp.ITEM = 'fb_revenue' then psc.FB_REVENUE
             when psc.OUT_PERIOD = 'year' and sp.ITEM = 'other_operated_revenue' then psc.OTHER_OPERATED_REVENUE
             when psc.OUT_PERIOD = 'year' and sp.ITEM = 'other_rental_revenue' then psc.OTHER_RENTAL_REVENUE
             else null
           end) as comparable_year_value  --,null, null, null
    from   PROFILE_GET_STATISTIC (:id_profile, :from_, :to_date, :id_hotel, :IS_VAT, 'DMY') PS
           join PROFILE_GET_STATISTIC (:id_profile, :comparable_from, :comparable_to, :id_hotel, :IS_VAT, 'DMY') psc on psc.out_period = ps.out_period
           join SYSTEM_STRING_PARSER (:field_names, ',') SP on 1=1
    group by 1
    into   :field_name, :day_value, :month_value, :year_value, :comparable_day_value, :comparable_month_value, :comparable_year_value
  do begin
    --if (:YEAR_VALUE is not null and :COMPARABLE_YEAR_VALUE is not null) then
      suspend;
  end

end
^

/* Alter (RATE_GET_AVAILABILITY$CHM) */
ALTER PROCEDURE RATE_GET_AVAILABILITY$CHM(ID_RATE INTEGER,
FOR_DATE DATE)
 RETURNS(ACTIVE_STATUS INTEGER,
MIN_LOS INTEGER,
MAX_LOS INTEGER)
 AS
declare variable date_from date;
  declare variable date_to date;
  declare variable RATE_capacity integer;
  declare variable to_sell integer;
begin
  --ACTIVE_STATUS 0 - closed
  --ACTIVE_STATUS 1 - closed fro arrival
  --ACTIVE_STATUS 2 - opened
  --opala ID_HOTEL
--  date_from = null;
--  ACTIVE_STATUS -  autoclose, t.e. AUTO_PERCENT






/*  select min(FOR_DATE), max(FOR_DATE)
  from RATE_ALLOTMENT
  where ID_RATE = :id_RATE
  into :date_from, :date_to;
  if (date_from is null) then exit;

  for select distinct ID_ROOM_TYPE
      from RATE_ALLOTMENT
      where ID_RATE = :id_RATE
        and FOR_DATE between :date_from and :date_to
      into :id_room_type
  do begin
    for select RTR.FOR_DATE,
               CA.STATUS,
               CA.AUTO_FREE_ROOMS, CA.ROOM_COUNT, RTR.AVAILABLE as FREE_ROOMS
        from ROOM_TYPE_GET_FREE$CHM(:date_from, :date_to, :id_room_type) RTR
             join RATE_ALLOTMENT CA on CA.ID_ROOM_TYPE = :id_room_type
                                      and CA.ID_RATE = :id_RATE
                                      and CA.FOR_DATE = RTR.FOR_DATE
    into :for_date, :status,
         :auto_free_rooms, :RATE_capacity, :free_rooms
    do begin
      if (:auto_free_rooms is not null) then
        if (coalesce(:free_rooms,0) >= :auto_free_rooms) then
          is_active = 1;
        else is_active = 0;
      else if (:status = 0) then
             is_active = 1;
           else is_active = 0;

      to_sell = coalesce(:free_rooms,0) - coalesce(:auto_free_rooms,0);
      if (to_sell < 0) then to_sell = 0;

      room_count = :to_sell;
      if (:RATE_capacity is not null) then
        if (RATE_capacity < room_count) then
          room_count = :RATE_capacity;

      suspend;
    end
  end*/
end
^

/* Alter (RES_ACCOUNT_CREATE$INT) */
ALTER PROCEDURE RES_ACCOUNT_CREATE$INT(ID_PROFILE INTEGER,
ID_ACC_TEMPLATE INTEGER,
ACC_CURRENCY CHAR(3),
ID_RESERV_DETAIL INTEGER,
IS_BASE_ENABLE SMALLINT = 1,
IS_EXTRA_ENABLE SMALLINT = 1)
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable acc_name varchar(50);
  declare variable id_hotel integer;
  declare variable is_credit_account integer;
  declare variable credit_limit numeric (15,4);
  declare variable sec_level integer;
  declare variable is_pos_allowed integer;
  declare variable id_tax_policy integer;
  declare variable id_sale_num integer;
  declare variable check_status smallint;
begin
  select 'res. ' || substring(RD.NUMBER from 1 for 45), RD.ID_HOTEL, rd.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :acc_name, :id_hotel, :check_status;

  if (:id_acc_template is null) then begin
    select sv.SETTING_VALUE
    from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :id_hotel) sv
    into   :id_acc_template;
  end

  is_credit_account = null;
  select ACT.IS_CREDIT_ACCOUNT, ACT.CREDIT_LIMIT, ACT.SECURITY_LEVEL,
         ACT.IS_ALOWED_POS_INTERFACE, ACT.ID_TAX_POLICY
  from   ACC_TEMPLATE ACT
  where  ACT.ID_ACC_TEMPLATE = :id_acc_template
         and act.ID_HOTEL = :id_hotel
  into   :is_credit_account, :credit_limit, :sec_level,
         :is_pos_allowed, :id_tax_policy;

  if (:is_credit_account is null) then exception ACCOUNT_EXCEPTION '-50';

  execute procedure ACCOUNT_MODIFY$INT (null, :ID_PROFILE, :ACC_CURRENCY, :acc_name, :is_credit_account, :credit_limit,
          null, null, 0, '', :sec_level, :IS_BASE_ENABLE, :IS_EXTRA_ENABLE, :is_pos_allowed, null,
          null, :id_tax_policy, null, :id_hotel, :ID_RESERV_DETAIL, 0, 'add')
  returning_values (:NEW_ID_ACCOUNT);

  if (:check_status = 0) then begin
    execute procedure ACCOUNT_SALE_NUMBER_SET(:NEW_ID_ACCOUNT)
    returning_values (:id_sale_num);
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTS$INT for: RES_ACCOUNTS_RECIEVE$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
 BEGIN EXIT; END
^

/* Alter (RES_ACCOUNTS_RECIEVE$INT) */
ALTER PROCEDURE RES_ACCOUNTS_RECIEVE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
ID_AGENT_ACCOUNT_RULE INTEGER,
ID_BASE_ACCOUNT_PROFILE INTEGER,
ID_EXTRA_ACCOUNT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ID_ACC_TEMPLATE_PERSON INTEGER,
IS_SEPARATE_ACCOUNTS SMALLINT)
 RETURNS(NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable id_acc_profile integer;
  declare variable base_account_curr varchar(3);
  declare variable base_tariff_currency char(3);
  declare variable extra_tariff_currency char(3);
  declare variable id_hotel integer;
  declare variable id_base_acc_reserv integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
begin
  id_acc_profile = null;
  select A.ID_PROFILE, A.ACCOUNT_CURR, A.ID_RESERV_DETAIL
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :old_id_base_account
  into   :id_acc_profile, :base_account_curr, :id_base_acc_reserv;

  select first 1 T.CURR, T.ID_HOTEL
  from   GUEST G
         join GUEST_STAY GS on gs.ID_GUEST = g.ID_GUEST
         join TARIFA T on T.ID_TARIFA = GS.ID_TARIFF
  where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  order by GS.FOR_DATE asc
  into   :base_tariff_currency, :id_hotel;

  if (:base_tariff_currency is null) then EXIT;

  select first 1 T.CURR
  from   TARIFA T
  where  T.IS_EXTRA = 1
         and T.ID_HOTEL = :id_hotel
  into   :extra_tariff_currency;

  if (coalesce(:id_agent_account_rule, 0) > 0) then begin
    /* get specified account */
    new_id_base_account = :id_agent_account_rule;
    execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:NEW_ID_BASE_ACCOUNT, 0);
  end else if (:id_acc_profile = :id_base_account_profile
               and :base_account_curr = :base_tariff_currency
               and :id_base_acc_reserv is not distinct from :ID_RESERV_DETAIL) then
  begin
    /* preserve old base personal account */
    new_id_base_account = :old_id_base_account;
  end else begin
    /* get new personal account */
    execute procedure PROFILE_GET_ACCOUNT$INT (:id_base_account_profile, :id_reserv_detail, 
            :base_tariff_currency, iif(:id_base_account_profile = :id_person_profile, :id_acc_template_person, null),
            1, iif(:IS_SEPARATE_ACCOUNTS = 0, 1, 0))
    returning_values (:new_id_base_account);
  end

  select ba.ACCOUNT_CURR
  from   ACCOUNT BA
  where  ba.ID_ACCOUNT = :NEW_ID_BASE_ACCOUNT
  into   :base_account_curr;

  if (:IS_SEPARATE_ACCOUNTS = 1
      and :base_account_curr = :extra_tariff_currency
      and :ID_BASE_ACCOUNT_PROFILE = :ID_EXTRA_ACCOUNT_PROFILE)
  then IS_SEPARATE_ACCOUNTS = 0;


  if (:IS_SEPARATE_ACCOUNTS = 0) then begin
    new_id_extra_account = :new_id_base_account;
    update ACCOUNT A
    set    a.IS_EXTRA = 1
    where  a.ID_ACCOUNT = :NEW_ID_EXTRA_ACCOUNT
           and a.IS_EXTRA is distinct from 1;
  end else begin
    id_acc_profile = null;
    select A.ID_PROFILE/*, A.ACCOUNT_CURR*/
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :old_id_extra_account
    into   :id_acc_profile/*, :account_curr*/;

    if (:id_acc_profile = :id_extra_account_profile /*and :account_curr = :extra_tariff_currency*/ and :old_id_extra_account is not null) then begin
      -- CHANGED after p27 -> condition {:account_curr = :extra_tariff_currency} is removed;
      -- if exists extra account by this profile, it must be preserve, independent of currency,
      -- because of unnecessary posting transfer and archiving of unused accounts (by the same profile);
      -- this can be forced with ACC_ROUTING changing (MIXED -> AGENT -> MIXED)
      new_id_extra_account = :old_id_extra_account;
    end else begin
      execute procedure PROFILE_GET_ACCOUNT$INT (:id_extra_account_profile, :id_reserv_detail,
              :extra_tariff_currency, iif(:id_extra_account_profile = :id_person_profile, :id_acc_template_person, null),
              1, 1)
      returning_values (:new_id_extra_account);
    end
  end
  /*  */
  if (:NEW_ID_BASE_ACCOUNT is distinct from :OLD_ID_BASE_ACCOUNT) then begin
    execute procedure ACCOUNT_VALIDATE$INT(:NEW_ID_BASE_ACCOUNT, 'IS_BASE')
    returning_values  :err_code, :err_text, :no_use, :no_use, :no_use, :no_use, :no_use;
    if (:err_code < 0) then exception ACCOUNT_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end
  if (:NEW_ID_EXTRA_ACCOUNT is distinct from :OLD_ID_EXTRA_ACCOUNT) then begin
    execute procedure ACCOUNT_VALIDATE$INT(:NEW_ID_EXTRA_ACCOUNT, 'IS_EXTRA')
    returning_values  :err_code, :err_text, :no_use, :no_use, :no_use, :no_use, :no_use;
    if (:err_code < 0) then exception ACCOUNT_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end

end
^

/* Alter (RES_ACCOUNTS_UNUSED_CLEAR$INT) */
ALTER PROCEDURE RES_ACCOUNTS_UNUSED_CLEAR$INT(ID_RESERV_DETAIL INTEGER)
 AS
declare variable id_account integer;
  declare variable id_account_profile integer;
  declare variable is_used integer;
  declare variable id_sale_num integer;
begin
  for
    select A.ID_ACCOUNT, A.ID_PROFILE, a.ID_SALE_NUM
    from   RESERV_DETAIL RD
           join ACCOUNT_S A on a.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
    where  rd.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
           and A.IS_ARCHIVE = 0
           and A.ID_ACCOUNT is distinct from rd.ID_BASE_ACCOUNT
           and A.ID_ACCOUNT is distinct from rd.ID_EXTRA_ACCOUNT
           and A.IS_CREDIT_ACCOUNT = 0
           and not exists(select G.ID_GUEST
                          from   GUEST G
                          where  (G.ID_BASE_ACCOUNT = A.ID_ACCOUNT)
                                 or (G.ID_ACCOUNT = A.ID_ACCOUNT))
    into   :id_account, :id_account_profile, :id_sale_num
  do begin
    execute procedure ACCOUNT_USE_CHECK$INT (:id_account)
    returning_values  :is_used;

    if (:id_sale_num is null and :is_used = 0) then
      delete from ACCOUNT a
      where  a.ID_ACCOUNT = :id_account;
    else
      exception ACCOUNT_EXCEPTION 'Account cannot be deleted';

  end

  when any do begin
    exception ACCOUNT_EXCEPTION '-';
  end
end
^

/* empty dependent procedure body */
/* Clear: APPLY_BOOKING_STATUS$EXC for: RES_ANUL_DETAIL$INT */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_ANUL_DETAIL$RSV for: RES_ANUL_DETAIL$INT */
ALTER PROCEDURE RES_ANUL_DETAIL$RSV(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_ANUL_DETAIL$WBE for: RES_ANUL_DETAIL$INT */
ALTER PROCEDURE RES_ANUL_DETAIL$WBE(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_ANUL_NOSHOW$INT for: RES_ANUL_DETAIL$INT */
ALTER PROCEDURE RES_ANUL_NOSHOW$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_ANUL_DETAIL$INT) */
ALTER PROCEDURE RES_ANUL_DETAIL$INT(RD_DBKEY CHAR(8),
REASON VARCHAR(50),
CANCELATION_NUMBER TYPE OF NAME_20 = null)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable id_reserv_detail integer;
  declare variable is_anul integer;
  declare variable id_log_event integer;
  declare variable id_guest integer;
  declare variable id_group integer;
  declare variable g_dbkey char(8);
  declare variable no_use varchar(255);
  declare variable tmp_extra_posts_left smallint;
  declare variable is_check_in smallint;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:reason, 'NOSHOW, CANCELED, USERERROR, TRANSFER', 'Annul reason');

  select RD.IS_ANUL, RD.ID_RESERV_DETAIL, rd.ID_GROUP
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :is_anul, :id_reserv_detail, :id_group;

  if (:is_anul = 1) then begin
    exception BOOKING_EXCEPTION '-1021';
    -- Reservation is already annuled or checkedin !
  end

  if (:reason = 'NOSHOW') then begin
    execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    returning_values  :no_use, :no_use;
  end

  execute procedure SYSTEM_EVENT_LOG$INT ('RES_DETAIL', :id_reserv_detail, 'RES_ANUL', f_character(29) || :reason)
  returning_values :id_log_event;

  update RESERV_DETAIL RDU
  set    RDU.IS_ANUL = 1,
         RDU.REASON_OF_ANUL = :reason,
         RDU.ID_LOG_EVENT_ANNUL = :id_log_event,
         RDU.CANCELATION_NUMBER = coalesce(:CANCELATION_NUMBER, strhash_large(rdu.NUMBER || 'CANCELATION'))
  where  RDU.RDB$DB_KEY = :rd_dbkey;

  EXTRA_POSTS_LEFT = 0;
  for
    select g.ID_GUEST, G.RDB$DB_KEY, g.IS_CHECK_IN
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest, :g_dbkey, :is_check_in
  do begin
    execute procedure GUEST_ANUL_POSTINGS$INT(:id_guest)
    returning_values  :tmp_extra_posts_left;
    EXTRA_POSTS_LEFT = iif(:EXTRA_POSTS_LEFT = 1, 1, :tmp_extra_posts_left);

    update GUEST G
    set    G.UUID = null
    where  g.RDB$DB_KEY = :g_dbkey;

    if (:is_check_in = 1) then begin
      execute procedure GUEST_REGISTRATION_UPDATE(:id_guest);
    end
  end

  execute procedure RES_FINALIZE$INT (:RD_DBKEY, 0)
  returning_values (:warn_code);

  execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

  if (:id_group is not null) then
    execute procedure RESGRP_GUESTDATA_INVALIDATE$INT(:id_group);

end
^

/* empty dependent procedure body */
/* Clear: RES_TRANSFER_FINALIZE$RSV for: RES_ANUL_DETAIL$RSV */
ALTER PROCEDURE RES_TRANSFER_FINALIZE$RSV(ID_RESERV_DETAIL_NEW INTEGER,
ID_RESERV_DETAIL_OLD INTEGER)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_ANUL_DETAIL$RSV) */
ALTER PROCEDURE RES_ANUL_DETAIL$RSV(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable rd_dbkey char(8);
declare variable check_status integer;
begin

  select RD.RDB$DB_KEY, rd.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :check_status;

  if (:check_status < 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('RESERV_ANNUL');
  end else begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('RESERV_CHECKED_IN_ANNUL');
  end

  execute procedure RES_ANUL_DETAIL$INT(:rd_dbkey, :reason)
  returning_values :WARN_CODE, :EXTRA_POSTS_LEFT;

end
^

/* Alter (RES_ANUL_DETAIL$WBE) */
ALTER PROCEDURE RES_ANUL_DETAIL$WBE(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable no_use varchar(255);
declare variable rd_dbkey char(8);
begin
  rd_dbkey = null;
  select rd.rdb$db_key
  from   reserv_detail rd
  where  rd.id_reserv_detail = :ID_RESERV_DETAIL
  into   :rd_dbkey;

  if (:rd_dbkey is null) then
    exception assert 'Reservation not found - RESERV_DETAIL_ID=' || coalesce(:ID_RESERV_DETAIL, '<null>');

  execute procedure EXPORT_LOG_FORCE$EXC(1);

  execute procedure RES_ANUL_DETAIL$INT (:rd_dbkey, coalesce(:REASON, 'CANCELED'))
  returning_values  :no_use, :no_use;
end
^

/* empty dependent procedure body */
/* Clear: RESERVS_EXPIRE$INT for: RES_ANUL_NOSHOW$INT */
ALTER PROCEDURE RESERVS_EXPIRE$INT(CLEAR_TODATE DATE,
ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_ANUL_NOSHOW$INT) */
ALTER PROCEDURE RES_ANUL_NOSHOW$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable extra_posts_left smallint;
begin
  execute procedure RES_ANUL_DETAIL$INT(:rd_dbkey, 'NOSHOW')
  returning_values  :warn_code, :extra_posts_left;
  if (:extra_posts_left = 1) then exception ACCOUNT_EXCEPTION '-1042';

  when exception ACCOUNT_EXCEPTION do begin
    -- continue;
    execute procedure sys_dbg('res RES_ANUL_NOSHOW$INT exception ACCOUNT_EXCEPTION');
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_CHECK_OUT_GUESTS$RSV for: RES_ARCHIVATE_ACCOUNTS$INT */
ALTER PROCEDURE RES_CHECK_OUT_GUESTS$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND SMALLINT = 0,
EARLYCHECKOUT_DATE DATE = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_DELETE$INT for: RES_ARCHIVATE_ACCOUNTS$INT */
ALTER PROCEDURE RES_DELETE$INT(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_ARCHIVATE_ACCOUNTS$INT) */
ALTER PROCEDURE RES_ARCHIVATE_ACCOUNTS$INT(ID_RESERV_DETAIL INTEGER)
 AS
declare variable id_account integer;
begin
  for
    select RA.ID_ACCOUNT
    from   RES_GET_ACCOUNTS(:id_reserv_detail, 'BALANCE') RA
    into   :id_account
  do begin
    execute procedure ACCOUNT_BALANCE_INVALIDATE$INT (:id_account);

    execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 1);
  end

end
^

/* empty dependent procedure body */
/* Clear: EAI_RES_CHECK_OUT_FAST for: RES_CHECK_OUT_GUESTS$RSV */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_CHECK_OUT_GUESTS$RSV) */
ALTER PROCEDURE RES_CHECK_OUT_GUESTS$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND SMALLINT = 0,
EARLYCHECKOUT_DATE DATE = null)
 AS
declare variable action_code varchar(100);
  declare variable cleaning_restriction varchar(10);
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable id_reserv_detail integer;
  declare variable id_guest integer;
  declare variable id_room integer;
  declare variable rd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable checkout_status integer;
  declare variable sys_date date;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
begin
  checkout_status = 1;
  action_code = case when :check_out_kind = 0 then 'CHECK_OUT'
                     when :check_out_kind = 1 then 'CHECK_OUT_EARLY1'
                     when :check_out_kind = 2 then 'CHECK_OUT_EARLY2'
                     when :check_out_kind = 3 then 'CHECK_OUT_EARLY3'
                end;

  for
    select RD.ID_RESERV_DETAIL, RD.ID_ROOM, RD.RDB$DB_KEY, rd.ID_HOTEL,
           (select sd.SYSTEM_DATE
            from   SYSTEM_DATE_GET (rd.ID_HOTEL) sd)
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_room, :rd_dbkey, :id_hotel, :sys_date
  do begin

    for
      select G.ID_GUEST, G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.CHECK_STATUS = 0 /* checked in */
      into   :id_guest, :g_dbkey
    do begin
      if (:CHECK_OUT_KIND = 3) then begin
        -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
        update GUEST G
        set    G.EARLYCHECKOUT_DATE = coalesce(:EARLYCHECKOUT_DATE, :sys_date)
        where  g.RDB$DB_KEY = :g_dbkey;

        execute procedure GUEST_SET_MANUAL_STAY$INT(:rd_dbkey, :id_guest, coalesce(:EARLYCHECKOUT_DATE, :sys_date))
        returning_values  :err_code, :err_text;
        if (:err_code < 0) then exception RESERV_CHECK_OUT_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
      end

      update ACCOUNT_POST AP
      set    AP.IS_ARCHIVE = 1
      where  AP.ID_GUEST = :id_guest;
    
      execute procedure GUEST_SET_STATUS$INT (:g_dbkey, :checkout_status);

      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, :action_code, '');
    end

    if (:CHECK_OUT_KIND = 3) then begin
      -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
      execute procedure OCCUPANCY_RESERV$INT(:rd_dbkey);

      execute procedure OCCUPANCY_SHARES_COMPLETE$INT (:id_reserv_detail)
      returning_values (:no_use, :no_use);
    end

    execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :cleaning_restriction;
  
    if (:cleaning_restriction <> '0' and :id_room > 0) then begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'CHECK_OUT', 'set_dirty');
    end

    execute procedure RES_SAVE_STATUS$INT (:rd_dbkey, :checkout_status);

    update RESERV_DETAIL rd
    set    rd.CHECK_OUT_KIND = :CHECK_OUT_KIND,
           rd.EARLYCHECKOUT_DATE = iif(:check_out_kind > 0, coalesce(:EARLYCHECKOUT_DATE, :sys_date), null)
    where  rd.RDB$DB_KEY = :rd_dbkey;

    execute procedure RES_BONUSPOINTS_APPLY$CL (:id_reserv_detail);
  end

end
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN_MULTI$RSV for: RES_CHECKIN$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_CHECKIN$RSV) */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable old_check_status integer;
  declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_anul integer;
  declare variable arrival_date date;
  declare variable system_date date;
  declare variable id_base_account integer;
  declare variable id_extra_account integer;
  declare variable id_sale_num integer;
begin
  /*  Description:
  ||
  */
  select RD.CHECK_STATUS, RD.RDB$DB_KEY, RD.FROM_DATE, RD.ID_HOTEL,
         RD.ID_ROOM, RD.IS_ANUL, rd.ID_BASE_ACCOUNT, rd.ID_EXTRA_ACCOUNT
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_check_status, :rd_dbkey, :arrival_date, :id_hotel,
         :old_id_room, :is_anul, :id_base_account, :id_extra_account;

  if (:is_anul = 1) then exception BOOKING_EXCEPTION '-2';

  if (:old_check_status >= 0) then exception BOOKING_EXCEPTION '-1003';

  if (:old_id_room < 0 and coalesce(:ID_ROOM, 0) <= 0) then exception BOOKING_EXCEPTION '-1018';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date < :arrival_date) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CHECK_IN_FUTURE');
  end
  /*----*/
  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'lock');

  execute procedure sys_dbg('occ RES_CHECKIN$RSV id_room = '||coalesce(:id_room, 'null'));
  execute procedure sys_dbg('occ RES_CHECKIN$RSV old_id_room = '||coalesce(:old_id_room, 'null'));

  if (:id_room is not null) then begin
    if (:old_check_status = -3) then begin
      execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, -2);
    end

    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option)
    returning_values (:WARN_CODE);
  end

  execute procedure ACCOUNT_SALE_NUMBER_SET(:id_base_account)
  returning_values (:id_sale_num);
  execute procedure ACCOUNT_SALE_NUMBER_SET(:id_extra_account)
  returning_values (:id_sale_num);

  execute procedure RES_SET_CHECKIN$INT (:rd_dbkey)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'release');
  /*----*/
  select f_character(29) || R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = coalesce(:ID_ROOM, :old_id_room)
  into   :action_text;
   
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'CHECK_IN', :action_text);

end
^

/* Alter (RES_CHECKIN_MULTI$RSV) */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable checkin_count integer;
  declare variable split_on_checkin integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
  declare variable tmp_warn_code integer;
begin
  checkin_count = 0;
  warn_code = null;
  for
    select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, RD.SPLIT_ON_CHECKIN, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :SELECTION_ID
    into   :id_reserv_detail, :check_status, :split_on_checkin, :id_titular
  do begin
    if (:check_status >= 0) then begin
      checkin_count = :checkin_count + 1;
    end else begin
      if (:split_on_checkin = 1) then begin
        for
          select G.ID_GUEST
          from   GUEST G
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and G.ID_GUEST <> :id_titular
          into   :id_guest
        do begin
          execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
          returning_values  :id_splited_reservation;

          execute procedure RES_CHECKIN$RSV (:id_splited_reservation)
          returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

          update RESERV_DETAIL RD
          set    RD.SELECTION_ID = :selection_id
          where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
        end
      end

      execute procedure RES_CHECKIN$RSV (:id_reserv_detail)
      returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
      WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end

  if (:checkin_count > 0) then begin
    execute procedure SYSTEM_WARNING_ADD(-1011, f_character(29)||:checkin_count)
    returning_values  :warn_code;
  end
end
^

/* empty dependent procedure body */
/* Clear: DEFAULT_BOOKING_VALUES$EXC for: RES_CREATE_GET$RSV */
ALTER PROCEDURE DEFAULT_BOOKING_VALUES$EXC(BOOKING_DBKEY CHAR(8),
HOTEL_ID INTEGER,
RATE_ID_IN INTEGER,
ROOM_TYPE_ID_IN INTEGER,
BOARD_ID_IN INTEGER,
MAINTANCE_SHEMA_ID_IN INTEGER,
ARRANGER_PAYMENT_TYPE_ID_IN INTEGER,
GUEST_PAYMENT_TYPE_ID_IN INTEGER,
MARKETING1_ID_IN INTEGER,
MARKETING2_ID_IN INTEGER,
MARKETING3_ID_IN INTEGER,
MARKETING4_ID_IN INTEGER,
MARKETING5_ID_IN INTEGER,
ARRANGER_PROFILE_ID_IN INTEGER,
MAIN_GUEST_PROFILE_ID_IN INTEGER,
POSTING_ROUTING_IN VARCHAR(50),
FIRST_FOOD_CODE_IN /* TFOOD_CODE */ VARCHAR(20),
GUARANTEE_POLICY_ID_IN INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_LATE_DEPARTURE_IN INTEGER,
EATING_OBJECT_ID_IN INTEGER)
 RETURNS(RATE_ID INTEGER,
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
MAINTANCE_SHEMA_ID INTEGER,
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
ARRANGER_PROFILE_ID INTEGER,
ARRANGER_ACCOUNT_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
POSTING_ROUTING VARCHAR(50),
FIRST_FOOD_CODE /* TFOOD_CODE */ VARCHAR(20),
GUARANTEE_POLICY_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_LATE_DEPARTURE INTEGER,
EATING_OBJECT_ID INTEGER,
DEFAULT_GUEST_MASK VARCHAR(10))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_CREATE_GET$RSV) */
ALTER PROCEDURE RES_CREATE_GET$RSV(ID_HOTEL INTEGER)
 RETURNS(ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIMESTAMP,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIMESTAMP,
TRANSFER_OUT_NOTE VARCHAR(30),
IS_LATE_DEPARTURE INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
COUNTRY_CODE VARCHAR(20),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
CHECK_STATUS INTEGER,
ID_HK_PLAN INTEGER,
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF,
DEFAULT_GUEST_MASK VARCHAR(10))
 AS
declare variable stay_length integer;
  declare variable sys_date date;
begin
/* on the GUI
id_room_type;
id_tariff;
id_board;
code_first_food;

adult_count
child_count
check_status
*/

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :sys_date;
   
  select sv.SETTING_VALUE
  from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :ID_HOTEL) sv
  into   :ID_ACC_TEMPLATE_PERSON;
--  ID_ACC_TEMPLATE_PERSON = 0;
  select RT.ARRIVAL_DATE, RT.DEPARTURE_DATE, RT.ADULT_COUNT, RT.CHILD_COUNT, RT.STAY_LENGTH,
         RT.ID_ROOM_TYPE, RT.ID_ROOM, m.ID_BOARD, T.ID_TARIFA, RT.CUSTOM_PRICE,
         RT.CUSTOM_CURRENCY, RT.VOUCHER_NUM, RT.VOUCHER_DATE, RT.VOUCHER_TEXT, RT.VOUCHER2_NUM,
         RT.VOUCHER2_DATE, RT.TRANSFER_IN_TIME, RT.TRANSFER_IN_NOTE, RT.TRANSFER_OUT_TIME,
         RT.TRANSFER_OUT_NOTE, RT.IS_LATE_DEPARTURE, RT.CODE_FIRST_FOOD, RT.ID_NOM_MARKET_SEGMENT,
         RT.ID_NOM_SOURCE_CODE, RT.ID_NOM_CHANNEL_CODE, RT.ID_NOM_HEAR_REASON, RT.ID_NOM_COME_REASON,
         RT.ID_AGENT_PROFILE, RT.ID_PERSON_PROFILE, RT.COUNTRY_CODE, RT.ACC_ROUTING,
         RT.ID_PERSON_PAYMENT, RT.ID_AGENT_PAYMENT, RT.ID_AGENT_ACCOUNT, RT.CHECK_STATUS, RT.ID_HK_PLAN,
         RT.ID_GUARANTEE_POLICY, e.ID_EATING_OBJECT
  from   RES_TEMPLATE RT
         left outer join MEALS m on m.ID_BOARD = rt.ID_BOARD and m.IS_ARCHIVE = 0
         left outer join TARIFA t on t.ID_TARIFA = rt.ID_TARIFF and t.IS_ACTIVE = 1
         left outer join EATING_OBJECT e on e.ID_EATING_OBJECT = rt.ID_EATING_OBJECT and e.IS_ARCHIVE = 0
  where  RT.ID_HOTEL = :id_hotel
  into   :arrival_date, :departure_date, :adult_count, :child_count, :stay_length,
         :id_room_type, :id_room, :id_board, :id_tariff, :custom_price,
         :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
         :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time,
         :transfer_out_note, :is_late_departure, :code_first_food, :id_nom_market_segment,
         :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason,
         :id_agent_profile, :id_person_profile, :country_code, :acc_routing,
         :id_person_payment, :id_agent_payment, :id_agent_account, :check_status, :id_hk_plan,
         :id_guarantee_policy, :id_eating_object;


  if (:arrival_date is null) then arrival_date = :sys_date;
  if (:stay_length is null) then stay_length = 1;
  if (:departure_date is null) then departure_date = :arrival_date + :stay_length;
  if (:is_late_departure is null) then is_late_departure = 0; 
  if (:adult_count is null) then adult_count = 2;
  if (:child_count is null) then child_count = 0;

  if (:country_code is null) then begin
    execute procedure SETTING_GET_VALUE('DEF_COUNTRY', :ID_HOTEL)
    returning_values  :country_code;
  end
  if (:id_person_payment is null) then begin
    execute procedure SETTING_GET_VALUE('DEF_PAY_TYPE', :ID_HOTEL)
    returning_values  :id_person_payment;
  end
  if (:id_agent_payment is null) then begin
    execute procedure SETTING_GET_VALUE('DEF_PAY_TYPE', :ID_HOTEL)
    returning_values  :id_agent_payment;
  end
  if (:ID_PERSON_PROFILE is null) then begin
    execute procedure SETTING_GET_VALUE ('DEF_GUEST_MASK', :ID_HOTEL)
    returning_values  :DEFAULT_GUEST_MASK;
  end

  if (:acc_routing is null) then acc_routing = 'GUEST';
  if (:check_status is null) then check_status = -3;

  guarantee_deposit = null;
  guarantee_currency = null;
  suspend;
end
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$INT for: RES_CREATE_LOG$INT */
ALTER PROCEDURE RES_CREATE_SET$INT(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_HOTEL INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
SPLIT_ON_CHECKIN SMALLINT,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_ACC_TEMPLATE_PERSON INTEGER = null,
ID_GUARANTEE_POLICY INTEGER = null,
BLOCK_CC VARCHAR(255) = null,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(RD_DBKEY CHAR(8),
NEW_ID_RESERV_DETAIL INTEGER,
WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_CREATE_LOG$INT) */
ALTER PROCEDURE RES_CREATE_LOG$INT(RD_DBKEY CHAR(8))
 AS
declare variable action_text varchar(255);
  declare variable room_name varchar(30);
  declare variable agent_profile varchar(100);
  declare variable tarifa_name varchar(50);
  declare variable type_hrana varchar(30);
  declare variable id_reserv_detail integer;
  declare variable number varchar(62);
  declare variable arrival_date date;
  declare variable departure_date date;
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable custom_price numeric(15,4);
  declare variable custom_currency varchar(3);
  declare variable id_event_log integer;
begin
  select rd.ID_RESERV_DETAIL, rd.NUMBER, rd.FROM_DATE, rd.TO_DATE, rd.ADULT_COUNT, rd.CHILD_COUNT,
         rt.TYPE_ROOM || ' ' || coalesce (R.ROOM_NAME, ''),
         P.PROFILE_NAME, T.TARIFA_NAME, TH.NAME, rd.CUSTOM_PRICE, rd.CUSTOM_CURRENCY
  from   RESERV_DETAIL RD
         left outer join ROOM_TYPES RT on rt.ID_ROOM_TYPE = rd.ID_ROOM_TYPE
         left outer join ROOMS R on R.ID_ROOM_TYPE = RT.ID_ROOM_TYPE and R.ID_ROOM = rd.ID_ROOM
         left outer join PROFILE P on P.ID_PROFILE = rd.ID_AGENT_PROFILE
         left outer join TARIFA T on T.ID_TARIFA = RD.ID_RATE
         left outer join MEALS TH on TH.ID_BOARD = rd.ID_BOARD
  where  RD.RDB$DB_KEY = :RD_DBKEY
  into   :id_reserv_detail, :number, :arrival_date, :departure_date, :adult_count, :child_count,
         :room_name,
         :agent_profile, :tarifa_name, :type_hrana, :custom_price, :custom_currency;

  action_text = substring(f_character(29) || :number
                || f_character(28) || formatdate(:arrival_date, 'D;dd.mm.yyyy') || '-' || formatdate(:departure_date, 'D;dd.mm.yyyy')
                || f_character(28) || :room_name
                || f_character(28) || :ADULT_COUNT || '+' || :CHILD_COUNT
                || f_character(28) || coalesce(:type_hrana, '')
                || f_character(28) || coalesce(substring(:agent_profile from 1 for 50), '')
                || f_character(28) || :tarifa_name
                || f_character(28) || coalesce(formatfloat(:custom_price, '0.00') || ' ' || :custom_currency, '')
                from 1 for 255);

  execute procedure SYSTEM_EVENT_LOG$INT ('RES_DETAIL', :id_reserv_detail, 'RES_CREATE', :action_text)
  returning_values :id_event_log;

  if (:id_event_log is not null) then
    update RESERV_DETAIL R
    set    r.ID_LOG_EVENT_CREATE = :id_event_log
    where  r.RDB$DB_KEY = :RD_DBKEY;
end
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$EXC for: RES_CREATE_SET$INT */
ALTER PROCEDURE RES_CREATE_SET$EXC(ID_RESERV_DETAIL INTEGER,
RES_NUMBER VARCHAR(62),
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER,
CREATE_DATETIME TIMESTAMP)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_RESERV_DETAIL INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$RSV for: RES_CREATE_SET$INT */
ALTER PROCEDURE RES_CREATE_SET$RSV(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
SUPPRESS_WARNINGS INTEGER,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT$RSV for: RES_CREATE_SET$INT */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_CREATE$RSV for: RES_CREATE_SET$INT */
ALTER PROCEDURE RESMULTI_CREATE$RSV(ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
TRANSFER_OUT_TIME TIME,
TRANSFER_IN_TIME TIME,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
TRANSFER_OUT_NOTE VARCHAR(50),
TRANSFER_IN_NOTE VARCHAR(50),
NOTE VARCHAR(255),
ID_BOARD INTEGER,
VOUCHER_DATE DATE,
VOUCHER_NUMBER VARCHAR(20),
VOUCHER_TEXT VARCHAR(30),
CHECK_STATUS INTEGER,
ID_TARIFF INTEGER,
COUNTRY_CODE VARCHAR(20),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
NOTE_REMINDERS VARCHAR(50),
TITULAR_NAME VARCHAR(100),
SPLIT_ON_CHECKIN INTEGER,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
NUMBER VARCHAR(62),
NEW_ID_TITULAR INTEGER,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE,
WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_CREATE_SET$INT) */
ALTER PROCEDURE RES_CREATE_SET$INT(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(255),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_HOTEL INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
SPLIT_ON_CHECKIN SMALLINT,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_ACC_TEMPLATE_PERSON INTEGER = null,
ID_GUARANTEE_POLICY INTEGER = null,
BLOCK_CC VARCHAR(255) = null,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(RD_DBKEY CHAR(8),
NEW_ID_RESERV_DETAIL INTEGER,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable guarantee_deposit_percent numeric(15,4);
  declare variable guarantee_deposit_nights integer;
  declare variable guarantee_due_days_bef_arrival integer;
  declare variable guarantee_due_days_after_create integer;
  declare variable gp_check_status integer;
  declare variable log_suppressed integer;
  declare variable id_guest integer;
  declare variable minibar_rights varchar(50);
  declare variable video_rights varchar(50);
  declare variable nopost_pms varchar(50);
  declare variable phone_rights varchar(50);
  declare variable paytv_rights varchar(50);
  declare variable is_profile_exclusive_debt_ownership integer;
  declare variable id_base_account integer;
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CREATE');

  select GP.DEPOSIT_NIGHTS_COUNT, GP.DEPOSIT_TOTALSUM_PART,
         GP.DUE_DAYS_BEFORE_ARRIVAL, GP.DUE_DAYS_AFTER_CREATE, gp.CHECK_STATUS
  from   GUARANTEE_POLICY GP
  where  GP.ID_GUARANTEE_POLICY = :ID_GUARANTEE_POLICY
         and gp.ID_HOTEL = :ID_HOTEL
  into   :guarantee_deposit_nights, :guarantee_deposit_percent,
         :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create, :gp_check_status;

  CHECK_STATUS = coalesce(:CHECK_STATUS, :gp_check_status, -2);

  execute procedure RES_CREATE_ROOM$INT(:check_status, :arrival_date, :departure_date, :adult_count, :child_count,
                    :id_room_type, 1, :id_board, :id_tariff, comming_kind, :is_late_departure, :country_code, :code_first_food,
                    :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note, :i_special_treatment, :id_agent_profile,
                    :id_hk_plan, '', :room_features, :id_person_profile, :acc_routing, :id_acc_template_person, :id_hotel, :id_agent_account,
                    :id_group, :id_reserv_detail, :res_number, :id_guarantee_policy, :id_eating_object)
  returning_values  :new_id_reserv_detail, :rd_dbkey, :id_person_profile;

  if (RDB$GET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE') is not distinct from 'disable') then begin
    log_suppressed = 1;
  end else begin
    log_suppressed = 0;
    RDB$SET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE', 'disable');
    -- disable only for intermediate changes
  end

  execute procedure RES_SAVE_ACCOUNTING$INT (:rd_dbkey, :id_agent_profile, :id_agent_account, :acc_routing,
          :id_person_payment, :id_agent_payment, :id_group);

  execute procedure RES_SAVE_MARKETING$INT(:rd_dbkey, :id_nom_market_segment,
                    :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason);

  execute procedure sys_dbg('res RES_CREATE_SET$INT id_room = '||coalesce(:id_room, 'null'));
  if (:id_room is not null) then begin
    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_room_type, 'nrttRoom')
    returning_values (:WARN_CODE);
  end

  execute procedure RES_SAVE_VOUCHER$INT(:RD_DBKEY, :voucher_num, :voucher_date, :voucher_text, :voucher2_num, :voucher2_date);

  execute procedure RES_SAVE_NOTE$RSV(:new_id_reserv_detail, :note, :note_reminders);

  for
    select  g.ID_GUEST
    from    GUEST G
    where   G.ID_RESERV_DETAIL = :NEW_ID_RESERV_DETAIL
    into    :id_guest
  do begin
    execute procedure RES_GUEST_SAVE_PACKET$RSV (:id_guest, :PACKET_ITEM_IDS);
  end 

  update RESERV_DETAIL RD
  set    RD.CUSTOM_PRICE = :CUSTOM_PRICE,
         RD.CUSTOM_CURRENCY = :CUSTOM_CURRENCY,
         RD.SPLIT_ON_CHECKIN = :SPLIT_ON_CHECKIN,
         RD.IS_VIP = coalesce(:IS_VIP, RD.IS_VIP),
         RD.ID_GUARANTEE_POLICY = :ID_GUARANTEE_POLICY,
         RD.GUARANTEE_DEPOSIT = :GUARANTEE_DEPOSIT,
         RD.GUARANTEE_CURRENCY = :GUARANTEE_CURRENCY,
         RD.BLOCK_CC = :BLOCK_CC,
         RD.GUARANTEE_DEPOSIT_PERCENT = :guarantee_deposit_percent,
         RD.GUARANTEE_DEPOSIT_NIGHTS = :guarantee_deposit_nights,
         RD.GUARANTEE_DUE_DAYS_BEF_ARRIVAL = :guarantee_due_days_bef_arrival,
         RD.GUARANTEE_DUE_DAYS_AFTER_CREATE = :guarantee_due_days_after_create
         /*rd.POSTING_TRANSACTION_UUID =  (select iif(p.IS_EXCLUSIVE_DEBT_OWNERSHIP = 1, uuid_create(), null)
                                         from   ACCOUNT A
                                                join PROFILE P on P.ID_PROFILE = a.ID_PROFILE
                                         where  a.ID_ACCOUNT = rd.ID_BASE_ACCOUNT)*/
  where  RD.RDB$DB_KEY = :rd_dbkey
  returning new.ID_BASE_ACCOUNT
  into      :id_base_account;

  select p.IS_EXCLUSIVE_DEBT_OWNERSHIP
  from   ACCOUNT A
         join PROFILE P on P.ID_PROFILE = a.ID_PROFILE
  where  a.ID_ACCOUNT = :id_base_account
  into   :is_profile_exclusive_debt_ownership;

  if (:is_profile_exclusive_debt_ownership = 1) then begin
    execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:NEW_ID_RESERV_DETAIL);
  end

  select rt.MINIBAR_RIGHTS, rt.VIDEO_RIGHTS, rt.NOPOST_PMS, rt.PHONE_RIGHTS, rt.PAYTV_RIGHTS
  from   RES_TEMPLATE RT
  where  rt.ID_HOTEL = :ID_HOTEL
  into   :minibar_rights, :video_rights, :nopost_pms, :phone_rights, :paytv_rights;

  execute procedure RESERV_DETAIL_EXTERNAL_MOD$RSV (:NEW_ID_RESERV_DETAIL,
          :minibar_rights, :paytv_rights, :video_rights, :nopost_pms, :phone_rights, null, null);

  if (:log_suppressed = 0) then RDB$SET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE', 'enable');

  execute procedure RES_CREATE_LOG$INT (:RD_DBKEY);

end
^

/* Alter (RES_CREATE_SET$RSV) */
ALTER PROCEDURE RES_CREATE_SET$RSV(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
SUPPRESS_WARNINGS INTEGER,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER,
NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable rd_dbkey char(8);
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, :PACKET_ITEM_IDS,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, :split_on_checkin, null, null, :ID_ACC_TEMPLATE_PERSON,
                    :ID_GUARANTEE_POLICY, null, :ID_EATING_OBJECT)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :WARN_CODE;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :ERR_TEXT, :share_transaction_id, :tmp_warn_code;
  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

  if (:suppress_warnings = 1) then begin
    delete from SYSTEM_WARNINGS W
    where W.ID_TRANSACTION = :warn_code;
    warn_code = null;
  end

  update RESERV_DETAIL RD
  set    RD.NOTE_REMINDERS = :note_reminders
  where  RD.RDB$DB_KEY = :rd_dbkey;

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;

end
^

/* empty dependent procedure body */
/* Clear: RES_DELETE$RSV for: RES_DELETE$INT */
ALTER PROCEDURE RES_DELETE$RSV(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESGRP_DELETE$RSV for: RES_DELETE$INT */
ALTER PROCEDURE RESGRP_DELETE$RSV(ID_GROUP INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_DELETE$INT) */
ALTER PROCEDURE RES_DELETE$INT(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable action_text varchar(255);
  declare variable from_date date;
  declare variable to_date date;
  declare variable room_type varchar(20);
  declare variable number varchar(62);
  declare variable tmp_extra_posts_left integer;
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_DELETE');

  if (exists (select ap.ID_ACCOUNT_POST
              from   GUEST G
                     join ACCOUNT_POST ap on ap.ID_GUEST = g.ID_GUEST
              where  g.ID_RESERV_DETAIL = :ID_RESERV_DETAIL)) then
    exception BOOKING_EXCEPTION '-1004';

  select RD.RDB$DB_KEY, RD.FROM_DATE, rd.TO_DATE, RT.TYPE_ROOM, rd.NUMBER
  from   RESERV_DETAIL RD
         left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = RD.ID_ROOM_TYPE
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :from_date, :to_date, :room_type, :number;

  update RESERV_DETAIL R
  set    r.ID_TITULAR = null
  where  r.RDB$DB_KEY = :rd_dbkey;

  EXTRA_POSTS_LEFT = 0;
  for
    select G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest
  do begin
    execute procedure RES_GUEST_DEL$INT(:id_guest, :id_reserv_detail, :REASON)
    returning_values  :tmp_extra_posts_left;
    EXTRA_POSTS_LEFT = iif(:EXTRA_POSTS_LEFT = 1, 1, :tmp_extra_posts_left);
  end

  execute procedure RES_FINALIZE$INT (:RD_DBKEY, 1)
  returning_values (:warn_code);


  execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

  action_text = f_character(29) || coalesce(:number, '')
                || f_character(28) || coalesce(:room_type, '')
                || f_character(28) || :from_date
                || f_character(28) || :to_date
                || f_character(28) || :reason;
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'DELETE', :action_text);

  delete from RESERV_DETAIL RDD
  where  RDD.RDB$DB_KEY = :rd_dbkey;

  delete from XML_MESSAGE$EXC xml
  where  xml.OBJECT_TYPE = 'BOOKING'
         and xml.OBJECT_ID = :number;

end
^

/* Alter (RES_DELETE$RSV) */
ALTER PROCEDURE RES_DELETE$RSV(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT,
NEW_FROM_DATE TYPE OF TDATE)
 AS
begin

  execute procedure RES_DELETE$INT(:ID_RESERV_DETAIL, :REASON)
  returning_values :WARN_CODE, :EXTRA_POSTS_LEFT;

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;
end
^

/* empty dependent procedure body */
/* Clear: RES_PENDING_DEPOSITS_POST$INT for: RES_GET_ACCOUNTS */
ALTER PROCEDURE RES_PENDING_DEPOSITS_POST$INT(ID_RESERV_DETAIL /* ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RESERV_POSTING_SELECT$DOC for: RES_GET_ACCOUNTS */
ALTER PROCEDURE RESERV_POSTING_SELECT$DOC(ID_RESERV_DETAIL INTEGER,
IN_DOC_SELECTED INTEGER)
 RETURNS(OUT_DOC_SELECTED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GET_ACCOUNTS) */
ALTER PROCEDURE RES_GET_ACCOUNTS(ID_RESERV_DETAIL INTEGER,
OPERATION VARCHAR(50))
 RETURNS(ID_ACCOUNT INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable res_account integer;
begin
  /*  Description:
  ||
  */
  if (:OPERATION in ('CURRENT', 'GUARANTEE_DEPOSIT_CREATE', 'DEPOSIT_CREATE')) then begin
    for
      select 0, rd1.ID_EXTRA_ACCOUNT
      from   RESERV_DETAIL RD1
      where  rd1.ID_RESERV_DETAIL = :id_reserv_detail
             and :OPERATION <> 'GUARANTEE_DEPOSIT_CREATE'
      union
      select 1, rd2.ID_BASE_ACCOUNT
      from   RESERV_DETAIL RD2
      where  rd2.ID_RESERV_DETAIL = :id_reserv_detail
      order by 1  -- extra account first !
      into   :dbg, :res_account
    do begin
      ID_ACCOUNT = null;
      select A.ID_ACCOUNT
      from   ACCOUNT_S A
             join PROFILE P on P.ID_PROFILE = a.ID_PROFILE
      where  a.ID_ACCOUNT = :res_account
             and not (P.PROFILE_TYPE = 'HOUSE' and :OPERATION containing 'DEPOSIT_CREATE')
      into   :ID_ACCOUNT;
  
      if (:ID_ACCOUNT is not null) then suspend;
    end
  end else if (:OPERATION in ('DEPOSIT_BACK', 'PAYABLE')) then begin
    for
      select A.ID_ACCOUNT
      from   ACCOUNT_S A
      where  A.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
             and A.IS_CREDIT_ACCOUNT = 0
             --and A.IS_ARCHIVE = 0
      into   :ID_ACCOUNT
    do begin
      suspend;
    end
  end else if (:OPERATION in ('DEPOSIT_PREVIEW', 'BALANCE')) then begin
    for
      select A.ID_ACCOUNT
      from   ACCOUNT A
      where  A.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
             and A.IS_CREDIT_ACCOUNT = 0
             --and A.IS_ARCHIVE = 0
      into   :ID_ACCOUNT
    do begin
      suspend;
    end
  end else if (:OPERATION = 'MANIP') then begin
    for
      select distinct GA.ID_ACCOUNT
      from   GUEST G
             left join GUEST_RELATED_ACCOUNTS GA on GA.ID_GUEST = G.ID_GUEST
             join ACCOUNT_S A on A.ID_ACCOUNT = GA.ID_ACCOUNT
      where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
      into   :ID_ACCOUNT
    do suspend;
  end /*else begin
    exception WRONG_VALUE ' operation = '|| :OPERATION;
  end */
end
^

/* empty dependent procedure body */
/* Clear: REP_ROOM_STATUS$INT for: RES_GET_BALLANCE$INT */
ALTER PROCEDURE REP_ROOM_STATUS$INT(FOR_DATE DATE,
STAT_OPTIONS VARCHAR(255),
PRIVATE_STATUS_ADDING SMALLINT = 0)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
SECTOR INTEGER,
ID_ROOM_TYPE INTEGER,
TYPE_ROOM VARCHAR(20),
IS_CLEAN INTEGER,
IS_INSPECTED INTEGER,
CLEAN_TEXT VARCHAR(30),
IS_LEAVING SMALLINT,
IS_COMMING SMALLINT,
IS_SHARED SMALLINT,
IS_LEAVING_WORDS VARCHAR(30),
BUSY_GRP INTEGER,
DAYS_THIS_STATUS INTEGER,
DTS_CONTEXT VARCHAR(10),
COMMING_OCCUPANTS VARCHAR(1024),
ID_BLOCK_ROOM INTEGER,
OTHER_OCCUPANTS VARCHAR(1024),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ID_HOTEL INTEGER,
HAS_OPENED_POSTINGS SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_BALLANCE$RPT for: RES_GET_BALLANCE$INT */
ALTER PROCEDURE RES_GET_BALLANCE$RPT(ID_RESERV_DETAIL INTEGER)
 RETURNS(RESERVATION_BALLANCE VARCHAR(255),
RECIEVED_DEPOSITS VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_INFO$RSV for: RES_GET_BALLANCE$INT */
ALTER PROCEDURE RES_GET_INFO$RSV(ID_RESERV_DETAIL INTEGER,
RETURN_BALANCE SMALLINT = 1,
RETURN_SHARE SMALLINT = 1,
RETURN_GEUSTDATA SMALLINT = 1)
 RETURNS(NUMBER VARCHAR(62),
AGENT_PROFILE_NAME VARCHAR(100),
ARRIVALS VARCHAR(255),
DEPARTURES VARCHAR(255),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
ID_ROOM INTEGER,
ROOM VARCHAR(60),
ID_ROOM_TYPE INTEGER,
ROOM_FEATURES BLOB,
GUESTS VARCHAR(255),
GUESTS_CNT INTEGER,
PERSON_PROFILE_NAME VARCHAR(150),
RATES VARCHAR(255),
BOARDS VARCHAR(255),
PACKETS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY VARCHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
BALANCE VARCHAR(255),
OPEN_CHARGES INTEGER,
CHECK_STATUS INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
NOTE VARCHAR(2000),
NOTE_GRP VARCHAR(255),
VOUCHER_RENDER VARCHAR(512),
ACC_ROUTING VARCHAR(255),
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
BUSY_GRP INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
GUEST_TYPE_COLOR INTEGER,
IS_CLEAN INTEGER,
ROOM_PRIVATE_STATUS /* TLOGICAL */ SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_LOAD for: RES_GET_BALLANCE$INT */
ALTER PROCEDURE RES_LOAD(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_AGENT_PROFILE INTEGER,
AGENT_PROFILE_NAME VARCHAR(100),
ID_PERSON_PROFILE INTEGER,
PERSON_PROFILE_NAME VARCHAR(100),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_RES_ROOM_TYPE INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
BOARD_NAMES VARCHAR(255),
TARIFF_NAMES VARCHAR(255),
PACKET_NAMES VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100),
VOUCHER_RENDER VARCHAR(512),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
TRANSFER_RENDER VARCHAR(255),
CODE_FIRST_FOOD_RENDER VARCHAR(255),
IS_LATE_DEPARTURE INTEGER,
CODE_FIRST_FOOD VARCHAR(20),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
I_SPECIAL_TREATMENT VARCHAR(255),
COMMING_KIND SMALLINT,
IS_VIP SMALLINT,
HAS_GUEST_LIST SMALLINT,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
AGENT_ACCOUNT_NAME VARCHAR(100),
IS_DIFFERENT_VOUCHER INTEGER,
IS_DIFFERENT_OTHER INTEGER,
IS_DIFFERENT_BOARD INTEGER,
IS_DIFFERENT_TARIFF INTEGER,
IS_CUSTOM_PRICE INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
ID_RATE INTEGER,
ROOM_FEATURES BLOB,
ID_GROUP INTEGER,
NUMBER VARCHAR(62),
CHECK_STATUS INTEGER,
BALANCE VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER,
RECIEVED_DEPOSITS VARCHAR(255),
ROOM_HISTORY VARCHAR(200),
TAR_ROOM_TYPE VARCHAR(100),
ID_HK_PLAN INTEGER,
COUNTRIES VARCHAR(812),
IS_RESGRP INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
IS_ANUL INTEGER,
NOTE VARCHAR(2000),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
GROUP_NAME VARCHAR(50),
ID_HOTEL INTEGER,
NOTE_REMINDERS VARCHAR(50),
IS_DIFFERENT_PRICE INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER,
ROOM_PRIVATE_STATUS /* TLOGICAL */ SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESGRP_GET_INFO$RSV for: RES_GET_BALLANCE$INT */
ALTER PROCEDURE RESGRP_GET_INFO$RSV(ID_INFO_GROUP INTEGER)
 RETURNS(AGENT_PROFILE_NAME VARCHAR(100),
ARRIVALS VARCHAR(255),
DEPARTURES VARCHAR(255),
ROOM_DATA VARCHAR(255),
ROOMS VARCHAR(255),
ID_ROOM INTEGER,
GUESTS VARCHAR(255),
PERSON_PROFILE_NAME VARCHAR(100),
RATES VARCHAR(255),
BOARDS VARCHAR(255),
PACKETS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY VARCHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
BALANCE VARCHAR(255),
OPEN_CHARGES INTEGER,
CHECK_STATUS VARCHAR(255),
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
NOTE VARCHAR(2000),
NOTE_GRP VARCHAR(255),
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
FIRST_ARRIVAL DATE,
FIRST_DEPARTURE DATE,
HOTELS VARCHAR(255),
ID_HOTEL INTEGER,
ACC_ROUTING VARCHAR(255),
RES_NUMBER VARCHAR(62))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GET_BALLANCE$INT) */
ALTER PROCEDURE RES_GET_BALLANCE$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(RESERVATION_BALLANCE VARCHAR(255),
RECIEVED_DEPOSITS VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER)
 AS
declare variable account_balance numeric(15,2);
  declare variable account_curr char(3);
  declare variable dep_money_bag varchar(255);
  declare variable dep_value numeric(15,2);
  declare variable curr_display_format varchar(10);
  declare variable open_charges_int integer;
  declare variable account_curr_current char(3);
  declare variable account_balance_current numeric (15,4);
  declare variable partial_ballance integer;
  declare variable id_account integer;
  declare variable round_to numeric(15,4) ;
begin
  /*  Description:
  ||
  */
  RESERVATION_BALLANCE = '';
  RECIEVED_DEPOSITS = '';
  PARTIAL_BALLANCE = 0;
  OPEN_DEPOSIT = 0;
  OPEN_CHARGES = 0;
  HAS_CHARGES = 0;

  ACCOUNT_BALANCE = 0;
  ACCOUNT_CURR = '';

  for
    select AB.ACCOUNT_CURR, AB.CURR_DISPLAY_FORMAT, AB.ACCOUNT_BALANCE, AB.OPEN_CHARGES,
           AB.DEP_VALUE, AB.DEP_MONEY_BAG, RA.ID_ACCOUNT
    from   RES_GET_ACCOUNTS(:ID_RESERV_DETAIL, 'BALANCE') RA
           left outer join ACCOUNT_BALANCE$INT(RA.ID_ACCOUNT) AB on 0=0
    union all
    select 'ZZZ', null, null, null,
           null, null, null
    from   RDB$DATABASE
    order by 1 asc
    into   :ACCOUNT_CURR_CURRENT, :CURR_DISPLAY_FORMAT, :ACCOUNT_BALANCE_CURRENT, :OPEN_CHARGES_INT,
           :DEP_VALUE, :DEP_MONEY_BAG, :ID_ACCOUNT
  do begin
    if ((:ACCOUNT_CURR_CURRENT <> 'ZZZ') and (not exists(
      select *
      from   ACCOUNT_S A
      where  A.ID_ACCOUNT = :ID_ACCOUNT
    ))) then PARTIAL_BALLANCE = 1;
    else begin
      if (:ACCOUNT_CURR_CURRENT = :ACCOUNT_CURR) then begin
        ACCOUNT_BALANCE = :ACCOUNT_BALANCE + :ACCOUNT_BALANCE_CURRENT;
      end else begin
        select c.ROUND_TO
        from   currs c
        where  c.CURR = :ACCOUNT_CURR_CURRENT
        into   :round_to;

        if (round_f(:ACCOUNT_BALANCE, :round_to) <> 0) then begin
          if (:RESERVATION_BALLANCE = '') then RESERVATION_BALLANCE = formatfloat (:ACCOUNT_BALANCE, :CURR_DISPLAY_FORMAT) ||' '|| :ACCOUNT_CURR;
          else RESERVATION_BALLANCE = :RESERVATION_BALLANCE ||', '||formatfloat (:ACCOUNT_BALANCE, :CURR_DISPLAY_FORMAT) ||' '|| :ACCOUNT_CURR;
        end
  
        ACCOUNT_BALANCE = :ACCOUNT_BALANCE_CURRENT;
        ACCOUNT_CURR = :ACCOUNT_CURR_CURRENT;
      end
  
      if (:ACCOUNT_CURR_CURRENT <> 'ZZZ') then begin
        if (:OPEN_CHARGES_INT = 1) then OPEN_CHARGES = 1;
        if (:DEP_VALUE > 0) then OPEN_DEPOSIT = 1;

        if (:RECIEVED_DEPOSITS = '') then RECIEVED_DEPOSITS = :DEP_MONEY_BAG;
        else if (:DEP_MONEY_BAG <> '') then RECIEVED_DEPOSITS = :RECIEVED_DEPOSITS || :DEP_MONEY_BAG;
      end
    end

    if (:HAS_CHARGES = 0) then begin
      if (:OPEN_CHARGES = 1) then HAS_CHARGES = 1;
      else if (exists (select ap.ID_ACCOUNT_POST
                       from   ACCOUNT_POST AP
                       where  ap.ID_ACCOUNT = :ID_ACCOUNT)) then HAS_CHARGES = 1;
    end
  end

  if (:PARTIAL_BALLANCE = 1) then RESERVATION_BALLANCE = :RESERVATION_BALLANCE || ' xxx';
end
^

/* Alter (RES_GET_BALLANCE$RPT) */
ALTER PROCEDURE RES_GET_BALLANCE$RPT(ID_RESERV_DETAIL INTEGER)
 RETURNS(RESERVATION_BALLANCE VARCHAR(255),
RECIEVED_DEPOSITS VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER)
 AS
begin
  execute procedure RES_GET_BALLANCE$INT (:ID_RESERV_DETAIL)
  returning_values  (:RESERVATION_BALLANCE, :RECIEVED_DEPOSITS, :HAS_CHARGES, :OPEN_CHARGES, :OPEN_DEPOSIT);

  suspend;
end
^

/* Alter (RES_GET_GUEST_BOARDS$RSV) */
ALTER PROCEDURE RES_GET_GUEST_BOARDS$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(BOARD_NAMES VARCHAR(255),
ID_BOARD INTEGER)
 AS
declare variable board_name varchar(100);
  declare variable id_board_rd integer;
  declare variable hasDifference smallint;
begin
  /*  Description:
  ||
  */
  hasDifference = 0;
  board_names = '';

  select RD.ID_BOARD
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :id_board_rd;

  for
    select distinct
           TH.NAME, TH.ID_BOARD
    from   GUEST G
           join GUEST_STAY GS on GS.ID_GUEST = G.ID_GUEST
           left outer join MEALS TH on TH.ID_BOARD = GS.ID_BOARD
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :board_name, :id_board
  do begin
    if (:id_board_rd is distinct from :id_board) then
        hasDifference = 1;
    if (:board_names not containing :board_name) then begin
      board_names = case
                      when :board_names='' then :board_name
                      else :board_names||','||:board_name
                    end;
    end
  end

  if (:hasDifference = 1) then
    id_board = null;

  suspend;
end
^

/* empty dependent procedure body */
/* Clear: CACHES_RESOLVE for: RES_GET_GUEST_DATA$INT */
ALTER PROCEDURE CACHES_RESOLVE AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_LOAD$RSV for: RES_GET_GUEST_DATA$INT */
ALTER PROCEDURE RESMULTI_LOAD$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(CHECK_STATUS INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
IS_DIFFERENT_BOARD SMALLINT,
BOARDS VARCHAR(255),
IS_DIFFERENT_VOUCHER SMALLINT,
VOUCHERS VARCHAR(255),
IS_DIFFERENT_TRANSFER_IN_TIME SMALLINT,
TRANSFER_IN_TIMES VARCHAR(255),
IS_DIFFERENT_TRANSFER_OUT_TIME SMALLINT,
TRANSFER_OUT_TIMES VARCHAR(255),
IS_DIFFERENT_TRANSFER_IN_NOTE SMALLINT,
TRANSFER_IN_NOTES VARCHAR(500),
IS_DIFFERENT_TRANSFER_OUT_NOTE SMALLINT,
TRANSFER_OUT_NOTES VARCHAR(500))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GET_GUEST_DATA$INT) */
ALTER PROCEDURE RES_GET_GUEST_DATA$INT(RESERV_DATA VARCHAR(20),
ID_RESERV_DATA TYPE OF ID)
 RETURNS(BOARD_NAMES TYPE OF TDESCRIPTION_LONG,
TARIFF_NAMES TYPE OF TDESCRIPTION_LONG,
PACKET_NAMES TYPE OF TDESCRIPTION_LONG,
VOUCHERS_RENDER TYPE OF TDESCRIPTION_LONG)
 AS
declare variable board_name varchar(100);
  declare variable packet_name varchar(100);
  declare variable tarifa_name varchar(50);

  declare variable voucher_idx varchar(255);
  declare variable voucher2_idx varchar(255);

  declare variable voucher_num varchar(30);
  declare variable voucher_date date;
  declare variable voucher_text varchar(30);
  declare variable voucher2_num varchar(30);
  declare variable voucher2_date date;

  declare variable id_group integer;
  declare variable id_reserv_detail integer;
  declare variable cache_cnt integer;
  declare variable id_guest integer;
begin
  /*  Description:
  ||
  */
  id_reserv_detail = iif(:RESERV_DATA = 'DETAIL', :ID_RESERV_DATA, null);
  id_group = iif(:RESERV_DATA = 'GROUP', :ID_RESERV_DATA, null);

  select min(RGC.BOARD_NAMES), min(RGC.TARIFF_NAMES), min(RGC.PACKET_NAMES), min(RGC.VOUCHERS_RENDER),
         count(rgc.RDB$DB_KEY)
  from   RESERV_GUESTDATA_CACHE RGC
  where  RGC.ID_RESERV_DETAIL is not distinct from :id_reserv_detail
         and RGC.ID_GROUP is not distinct from :id_group
  into   :board_names, :tariff_names, :packet_names, :vouchers_render, :cache_cnt;

--  execute procedure sys_dbg('res RES_GET_GUEST_DATA$INT cached value board_names = '||coalesce(:board_names, 'null'));
--  execute procedure sys_dbg('res RES_GET_GUEST_DATA$INT cached value tariff_names = '||coalesce(:tariff_names, 'null'));

  if ((:cache_cnt <> 1) or (:board_names is null)) then begin
    board_names = '';
    tariff_names = '';
    packet_names = '';
    vouchers_render = '';voucher2_idx = 'x';voucher_idx = 'x';

    for
      select coalesce(G.VAUCHER_NUM, ''), G.VAUCHER_DATE, coalesce(G.VAUCHER_TEXT, ''),
             coalesce(G.VAUCHER_NUM2, ''), G.VAUCHER_DATE2, g.ID_GUEST
      from   RESERV_DETAIL RD
             join GUEST G on G.ID_RESERV_DETAIL = RD.ID_RESERV_DETAIL
      where  (rd.ID_RESERV_DETAIL = :id_reserv_detail)
             or (rd.ID_GROUP = :id_group and rd.IS_ANUL = 0)
      into   :voucher_num, :voucher_date, :voucher_text,
             :voucher2_num, :voucher2_date, :id_guest
    do begin
      for
        select distinct coalesce(m.NAME, ''), t.TARIFA_NAME
        from   GUEST_STAY GS
               left outer join MEALS M on M.ID_BOARD = GS.ID_BOARD
               left outer join TARIFA T on T.ID_TARIFA = GS.ID_TARIFF
        where  GS.ID_GUEST = :id_guest
        into   :board_name, :tarifa_name
      do begin
        if ( (:board_names || ',') not containing (:board_name || ',')) then
          board_names = substring(iif(:board_names='', :board_name, :board_names||','||:board_name) from 1 for 255);
        if ( (:tariff_names || ',') not containing (:tarifa_name || ',')) then
          tariff_names = substring(iif(:tariff_names='', :tarifa_name, :tariff_names||','||:tarifa_name) from 1 for 255);
      end

      for
        select p.PACKET_ITEM_TAG
        from   GUEST_PACKET Gp
               join PACKET_ITEM P on p.ID_PACKET_ITEM = gp.ID_PACKET_ITEM
        where  Gp.ID_GUEST = :id_guest
        into   :packet_name
      do begin
        if (:packet_names not containing :packet_name) then packet_names = substring(iif(:packet_names='', :packet_name, :packet_names||'/'||:packet_name) from 1 for 255);
      end

      if (:RESERV_DATA <> 'GROUP') then begin
        if ((:voucher_num <> '') and (:voucher_idx not containing :voucher_num)) then begin
          voucher_idx = :voucher_idx || :voucher_num || 'x';
          vouchers_render = substring(iif(:vouchers_render = '', :voucher_num, :vouchers_render || ' ' || :voucher_num) from 1 for 255);
          if (:voucher_date is not null) then vouchers_render = substring(iif(:vouchers_render = '', '', :vouchers_render || ' ') || FormatDate(:voucher_date, 'D;dd/mm') from 1 for 255);
          if (:voucher_text is not null) then vouchers_render = substring(iif(:vouchers_render = '', '', :vouchers_render || ' ') || ' (' || :voucher_text || ')' from 1 for 255);
        end
        
        if ((:voucher2_num <> '') and (:voucher2_idx not containing :voucher2_num)) then begin
          voucher2_idx = :voucher2_idx || :voucher2_num || 'x';
          vouchers_render = substring(iif(:vouchers_render = '', :voucher2_num, :vouchers_render || ' ' || :voucher2_num) from 1 for 255);
          if (:voucher2_date is not null) then vouchers_render = substring(iif(:vouchers_render = '', '', :vouchers_render || ' ') || FormatDate(:voucher2_date, 'D;dd/mm') from 1 for 255);
        end
      end
    end
--    execute procedure sys_dbg('res RES_GET_GUEST_DATA$INT calculated value board_names = '||coalesce(:board_names, 'null'));
--    execute procedure sys_dbg('res RES_GET_GUEST_DATA$INT calculated value tariff_names = '||coalesce(:tariff_names, 'null'));

    execute procedure RES_GUESTDATA_CACHE$INT(:RESERV_DATA, :id_reserv_data, :board_names, :tariff_names, :packet_names, :vouchers_render);
  end
end
^

/* empty dependent procedure body */
/* Clear: MONITOR_ROOM_GANTT$HM for: RES_GET_INFO$RSV */
ALTER PROCEDURE MONITOR_ROOM_GANTT$HM(FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ID_ROOM INTEGER,
GFROM_DATE DATE,
IS_MOVED_FROM INTEGER,
GTO_DATE DATE,
IS_MOVED_TO INTEGER,
BUSY_GRP INTEGER,
OCCUPANT_ID INTEGER,
IN_SHARE SMALLINT,
ID_GROUP INTEGER,
ATTENTION_STATUS SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: MONITOR_ROOM_GANTT_OCCUPANT$HM for: RES_GET_INFO$RSV */
ALTER PROCEDURE MONITOR_ROOM_GANTT_OCCUPANT$HM(FROM_DATE DATE,
TO_DATE DATE,
REQUEST_OCCUPANT_ID INTEGER)
 RETURNS(ID_ROOM INTEGER,
GFROM_DATE DATE,
IS_MOVED_FROM INTEGER,
GTO_DATE DATE,
IS_MOVED_TO INTEGER,
BUSY_GRP INTEGER,
OCCUPANT_ID INTEGER,
IN_SHARE SMALLINT,
ID_GROUP INTEGER,
ATTENTION_STATUS SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: OCCUPANT_GET_INFO for: RES_GET_INFO$RSV */
ALTER PROCEDURE OCCUPANT_GET_INFO(ID_OCCUPANT INTEGER,
IN_BUSY_GRP INTEGER = null)
 RETURNS(BUSY_GRP INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
INFO VARCHAR(1024))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_SMART_LIST_OOS$INT for: RES_GET_INFO$RSV */
ALTER PROCEDURE ROOM_SMART_LIST_OOS$INT(FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ROOM_NAME VARCHAR(50),
DESCRIPTION VARCHAR(100),
PERIOD VARCHAR(100),
FREE_BASE INTEGER,
FREE_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
IS_CLEAN INTEGER,
FEATURES BLOB)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_SMART_LIST_SHARE$INT for: RES_GET_INFO$RSV */
ALTER PROCEDURE ROOM_SMART_LIST_SHARE$INT(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(50),
SUPPRESS_PRIVATE SMALLINT = 1)
 RETURNS(ROOM_NAME VARCHAR(50),
DESCRIPTION VARCHAR(255),
PERIOD VARCHAR(255),
FREE_BASE INTEGER,
FREE_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
FEATURES BLOB)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GET_INFO$RSV) */
ALTER PROCEDURE RES_GET_INFO$RSV(ID_RESERV_DETAIL INTEGER,
RETURN_BALANCE SMALLINT = 1,
RETURN_SHARE SMALLINT = 1,
RETURN_GEUSTDATA SMALLINT = 1)
 RETURNS(NUMBER VARCHAR(62),
AGENT_PROFILE_NAME VARCHAR(100),
ARRIVALS VARCHAR(255),
DEPARTURES VARCHAR(255),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
ID_ROOM INTEGER,
ROOM VARCHAR(60),
ID_ROOM_TYPE INTEGER,
ROOM_FEATURES BLOB,
GUESTS VARCHAR(255),
GUESTS_CNT INTEGER,
PERSON_PROFILE_NAME VARCHAR(150),
RATES VARCHAR(255),
BOARDS VARCHAR(255),
PACKETS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY VARCHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
BALANCE VARCHAR(255),
OPEN_CHARGES INTEGER,
CHECK_STATUS INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
NOTE VARCHAR(2000),
NOTE_GRP VARCHAR(255),
VOUCHER_RENDER VARCHAR(512),
ACC_ROUTING VARCHAR(255),
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
BUSY_GRP INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
GUEST_TYPE_COLOR INTEGER,
IS_CLEAN INTEGER,
ROOM_PRIVATE_STATUS TLOGICAL)
 AS
declare variable arrival varchar(20);
declare variable departure varchar(20);
declare variable rd_dbkey char(8);
declare variable no_use varchar(1024);
declare variable rd_adult_count integer;
declare variable rd_child_count integer;
declare variable groupname varchar(100);
declare variable virtual_room varchar(10);
declare variable earlycheckout_date date;
declare variable occupied_room_type integer;
begin
  arrivals = '';
  departures = '';
  rates = '';
  NOTE_GRP = null;

  IS_CLEAN = 0;

  select AP.PROFILE_NAME, RD.ADULT_COUNT, RD.CHILD_COUNT,
         R.ID_ROOM, R.ROOM_NAME, coalesce(rd.VIRTUAL_ROOM, 'i'||RM.ID_ROOM),
         rd.ID_ROOM_TYPE, --coalesce(R.ID_ROOM_TYPE, RM.ID_ROOM_TYPE, RD.ID_ROOM_TYPE),
         RD.CHECK_STATUS, PP.PROFILE_NAME || coalesce(' (' || GT.GUEST_TYPE_NAME || ')', ''),
         RD.FROM_DATE, RD.TO_DATE, RG.GROUP_NAME,
         RD.ID_GROUP, RD.ROOM_FEATURES, RD.COMMING_KIND, RD.LEAVING_KIND - 1,
         RD.NUMBER, RD.NOTE, RD.RDB$DB_KEY, RD.ID_HOTEL, RD.ACC_ROUTING,
         GT.GUEST_TYPE_COLOR, coalesce(r.IS_CLEAN, 1), g.EARLYCHECKOUT_DATE,
         coalesce(R.ID_ROOM_TYPE, RM.ID_ROOM_TYPE)
  from   RESERV_DETAIL RD
         left outer join RESERV_GROUP RG on RG.ID_RESERV_GROUP = RD.ID_GROUP
         left outer join PROFILE AP on AP.ID_PROFILE = RD.ID_AGENT_PROFILE
         left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
         left outer join ROOM_MAP$EXC RM on RM.ID_ROOM = RD.ID_ROOM
         left outer join PROFILE PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join PROFILE_PERSON PPp on PPp.ID_PROFILE = PP.ID_PROFILE
         left outer join GUEST_TYPE GT on GT.ID_GUEST_TYPE = PPp.ID_GUEST_TYPE
         left outer join GUEST G on g.ID_GUEST = rd.ID_TITULAR
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :agent_profile_name, :rd_adult_count, :rd_child_count,
         :id_room, :room, :virtual_room, :id_room_type,
         :check_status, :person_profile_name,
         :arrival_date, :departure_date, :groupname,
         :id_group, :room_features, :comming_kind, :is_late_departure,
         :number, :note, :rd_dbkey, :id_hotel, :acc_routing,
         :guest_type_color, :is_clean, :earlycheckout_date,
         :occupied_room_type;


  ARRIVALS = iif(extract(year from current_date) = extract(year from :ARRIVAL_DATE),
               formatDate(:ARRIVAL_DATE, 'D;dd.mm')||' ('||(:DEPARTURE_DATE - :ARRIVAL_DATE)||')',
               formatDate(:ARRIVAL_DATE, 'D;dd.mm.yy')||' ('||(:DEPARTURE_DATE - ARRIVAL_DATE)||')');
  DEPARTURES = iif(extract(year from current_date) = extract(year from :DEPARTURE_DATE),
               formatDate(:DEPARTURE_DATE, 'D;dd.mm'),
               formatDate(:DEPARTURE_DATE, 'D;dd.mm.yy'));
  for
    select iif(extract(year from current_date) = extract(year from g.FROM_DATE),
               formatDate(g.FROM_DATE, 'D;dd.mm')||' ('||(G.TO_DATE - G.FROM_DATE)||')',
               formatDate(g.FROM_DATE, 'D;dd.mm.yy')||' ('||(G.TO_DATE - G.FROM_DATE)||')'),
           iif(extract(year from current_date) = extract(year from g.TO_DATE),
               formatDate(g.TO_DATE, 'D;dd.mm'),
               formatDate(g.TO_DATE, 'D;dd.mm.yy'))
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
           and ((g.FROM_DATE <> :ARRIVAL_DATE) or (g.TO_DATE <> :DEPARTURE_DATE))
    into   :arrival, :departure
  do begin
    if (:ARRIVALS not containing :arrival) then ARRIVALS = :ARRIVALS || ','||:arrival;
    if (:DEPARTURES not containing :departure) then DEPARTURES = :DEPARTURES || ','||:departure;
  end

  execute procedure RES_GET_PRICE$INT(:rd_dbkey, 'SECURITY')
  returning_values  :room_price, :room_currency, :room_price_details, :no_use, :no_use;

  if (coalesce(:return_balance,1)=1) then
    execute procedure RES_GET_BALLANCE$INT(:id_reserv_detail)
    returning_values  :balance, :no_use, :no_use, :open_charges, :no_use;

  if (:groupname <> '') then agent_profile_name = substring(coalesce(:agent_profile_name, '') || ' / ' || coalesce(:groupname, '') from 1 for 100);

  execute procedure RES_GET_ATTENTION_STATUS$INT(:arrival_date, :departure_date, :check_status, :id_hotel)
  returning_values  :attention_status;

  if (coalesce(:return_share,1)=1) then begin
    execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'RENDER', null)
    returning_values  :in_share, :no_use, :shares_preview;
    if (:IN_SHARE = 1) then ROOM = coalesce(:ROOM, :virtual_room);
  end

  if (coalesce(:return_geustdata,1)=1) then begin
    execute procedure RES_GET_GUEST_DATA$INT('DETAIL', :id_reserv_detail)
    returning_values  :boards, :rates, :packets, :voucher_render;
  end

  execute procedure RES_GET_ANNULSTATUS(:rd_dbkey)
  returning_values  :annul_status;

  guests = :rd_adult_count || ' + ' || :rd_child_count || ' ';
  guests_cnt = :rd_adult_count + :rd_child_count;

  if (:check_status > 1) then  busy_grp = 24;
  else busy_grp = 1;

  ROOM_PRIVATE_STATUS = 0;
  select cast(1 as smallint)
  from   SYSTEM_DATE_GET (:ID_HOTEL) sd
         join ROOM_MAGIC rm on rm.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                               and rm.ROOM_STATUS = 'PRIVATE'
                               and rm.BUSY_DATE = mindate(maxdate(:ARRIVAL_DATE, sd.SYSTEM_DATE), coalesce(:earlycheckout_date, :DEPARTURE_DATE) - 1)
  into   :ROOM_PRIVATE_STATUS;

  if (:occupied_room_type is not null and :occupied_room_type <> :ID_ROOM_TYPE) then begin
    select :ROOM || '/' || rt.TYPE_ROOM
    from   ROOM_TYPES rt
    where  rt.ID_ROOM_TYPE = :occupied_room_type
    into   :ROOM;
  end
  suspend;
end
^

/* empty dependent procedure body */
/* Clear: RES_GET_DEPOSIT$INT for: RES_GET_PRICE$INT */
ALTER PROCEDURE RES_GET_DEPOSIT$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(DEPOSIT_VALUE NUMERIC(15,4),
DEPOSIT_CURRENCY CHAR(3))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_PRICE$RPT for: RES_GET_PRICE$INT */
ALTER PROCEDURE RES_GET_PRICE$RPT(ID_RESERV_DETAIL INTEGER,
OPTIONS VARCHAR(255) = 'FORCED')
 RETURNS(ROOM_PRICE NUMERIC(15,4),
PRICE_CURRENCY VARCHAR(3),
ROOM_DAY_PRICE NUMERIC(15,4),
ROOM_PRICE_DETAILS VARCHAR(255),
IS_MANUAL_PRICE SMALLINT,
REQUIRED_DEPOSIT_VALUE NUMERIC(15,4),
REQUIRED_DEPOSIT_CURRENCY CHAR(3))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_PRICE$RSV for: RES_GET_PRICE$INT */
ALTER PROCEDURE RES_GET_PRICE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(ROOM_PRICE_DETAILS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GET_PRICE$INT) */
ALTER PROCEDURE RES_GET_PRICE$INT(RD_DBKEY CHAR(8),
OPTIONS VARCHAR(255))
 RETURNS(ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
REQUIRED_DEPOSIT_VALUE NUMERIC(15,4),
REQUIRED_DEPOSIT_CURRENCY CHAR(3))
 AS
declare variable id_reserv_detail integer;
  declare variable no_access integer;

  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable guarantee_deposit_percent integer;
  declare variable guarantee_deposit_nights integer;
  declare variable res_days integer;
begin
  /*  Description:
  ||  OPTIONS = [FORCED || SECURITY || POSTED ]
  */

  select RD.ROOM_PRICE, RD.ROOM_CURRENCY, RD.ROOM_PRICE_DETAILS,
         RD.ID_RESERV_DETAIL, rd.GUARANTEE_DEPOSIT_PERCENT, rd.GUARANTEE_DEPOSIT_NIGHTS,
         RD.GUARANTEE_DEPOSIT, rd.GUARANTEE_CURRENCY,rd.TO_DATE - rd.FROM_DATE
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :room_price, :room_currency, :room_price_details,
         :id_reserv_detail, :guarantee_deposit_percent, :guarantee_deposit_nights,
         :required_deposit_value, :required_deposit_currency, :res_days;

  if (:options containing 'POSTED' /*and (:check_status >= 0)*/) then begin
    -- can be posted and not checked in
    select sum(AP.PRICE_ORIG * AP.QTY_POST * CR.RATE)
    from   ACCOUNT_POST AP
           join GUEST G on G.ID_GUEST = AP.ID_GUEST
           join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
           left outer join CURR_CROSS_RATE_GET(AP.CURR_ORIG, :room_currency, AP.DATE_POST, A.ID_HOTEL) CR on 0=0
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
           and AP.IS_ANUL = 0
           and AP.ID_MASTER_ADDINS_ACC_POST > 0
    into   :room_price;
    room_price_details = '';
    REQUIRED_DEPOSIT_CURRENCY = null;
    REQUIRED_DEPOSIT_VALUE = null;
  end

  if (:options containing 'SECURITY') then begin
    select max(A.SECURITY_LEVEL - SEC.GRANTED_LEVEL)
    from   GUEST G
           join ACCOUNT A on A.ID_ACCOUNT = G.ID_BASE_ACCOUNT
           left outer join (select cast(iif(
                exists(
                  select *
                  from   USER_RIGHTS R
                  where  R.RIGHT_CODE  = 'ACCSECURLEVEL1'
                ) , 1, 0) as integer) as GRANTED_LEVEL
           from RDB$DATABASE) SEC on 0=0
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :no_access;
    if (:no_access = 1) then begin
      room_price = null;
      room_currency = null;
      room_price_details = '-';
      exit;
    end
  end

  if ((:room_price is null) and (:options containing 'FORCED')) then begin
    execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    returning_values  :err_code, :err_text;
    if (:err_code < 0) then exit;
  
    -- execute procedure TAR_CALC_FINALIZE$INT(:err_code, :id_tar_calc, :rd_dbkey);

    select RD.ROOM_PRICE, RD.ROOM_CURRENCY, RD.ROOM_PRICE_DETAILS
    from   RESERV_DETAIL RD
    where  RD.RDB$DB_KEY = :rd_dbkey
    into   :room_price, :room_currency, :room_price_details;

  end

  if (:REQUIRED_DEPOSIT_VALUE is null) then begin
    REQUIRED_DEPOSIT_CURRENCY = :ROOM_CURRENCY;
    if (:guarantee_deposit_percent is not null) then
      REQUIRED_DEPOSIT_VALUE = :ROOM_PRICE * cast(:guarantee_deposit_percent as double precision) / 100;
    else if (:guarantee_deposit_nights is not null) then
      REQUIRED_DEPOSIT_VALUE = :ROOM_PRICE * cast(:guarantee_deposit_nights as double precision) / :res_days;
  end

end
^

/* empty dependent procedure body */
/* Clear: ACTIVITY_OFFER_CALC_PRICES for: RES_GET_PRICE$RPT */
ALTER PROCEDURE ACTIVITY_OFFER_CALC_PRICES(ID_ACTIVITY_OFFER /* TYPE OF ID */ INTEGER,
WITH_DISCOUNT /* TYPE OF TBOOLEAN */ SMALLINT = 1)
 RETURNS(OFFER_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
OFFER_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GET_PRICE$RPT) */
ALTER PROCEDURE RES_GET_PRICE$RPT(ID_RESERV_DETAIL INTEGER,
OPTIONS VARCHAR(255) = 'FORCED')
 RETURNS(ROOM_PRICE NUMERIC(15,4),
PRICE_CURRENCY VARCHAR(3),
ROOM_DAY_PRICE NUMERIC(15,4),
ROOM_PRICE_DETAILS VARCHAR(255),
IS_MANUAL_PRICE SMALLINT,
REQUIRED_DEPOSIT_VALUE NUMERIC(15,4),
REQUIRED_DEPOSIT_CURRENCY CHAR(3))
 AS
declare variable rd_dbkey char(8);
  declare variable r_days integer;
begin
  /*  Description:
  ||
  */
  rd_dbkey = null;
  room_price = null;
  price_currency = null;
  select RD.RDB$DB_KEY, RD.TO_DATE - RD.FROM_DATE,
         iif((RD.HAS_DIFFERENT_PRICE = 1) or (RD.CUSTOM_PRICE is not null), 1, 0)
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
         and RD.IS_ANUL = 0
  into   :rd_dbkey, :r_days, :IS_MANUAL_PRICE;

  if (:rd_dbkey is null) then exit;
  execute procedure RES_GET_PRICE$INT(:rd_dbkey, :options)
  returning_values  :room_price, :price_currency, :room_price_details, :required_deposit_value, :required_deposit_currency;
  room_day_price = :room_price / :r_days;

  suspend;
end
^

/* Alter (RES_GET_PRICE$RSV) */
ALTER PROCEDURE RES_GET_PRICE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(ROOM_PRICE_DETAILS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3))
 AS
declare variable rd_dbkey char(8);
declare variable dummy varchar(255);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_GET_PRICE$INT(:rd_dbkey, 'SECURITY, FORCED')
  returning_values  :room_price, :room_currency, :room_price_details, :dummy, :dummy;

  room_price_details = formatFloat(:room_price, 'F;0.00')||:room_currency||' ('|| :room_price_details||')';
end
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_DEL$RSV for: RES_GUEST_DEL$INT */
ALTER PROCEDURE RES_GUEST_DEL$RSV(ID_GUEST INTEGER,
REASON VARCHAR(50) = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_GUESTCOUNT_DEL$INT for: RES_GUEST_DEL$INT */
ALTER PROCEDURE RES_GUESTCOUNT_DEL$INT(RD_DBKEY CHAR(8),
DEL_ADULT_COUNT INTEGER,
DEL_CHILD_COUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_GUEST_DEL$INT) */
ALTER PROCEDURE RES_GUEST_DEL$INT(ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50) = null)
 RETURNS(EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable action_text varchar(255);
  declare variable guest_name varchar(100);
  declare variable is_child smallint;
  declare variable is_check_in smallint;
  declare variable id_titular integer;
BEGIN

  select pd.PERSON_NAME, G.IS_CHILD, red.ID_TITULAR, g.IS_CHECK_IN
  from   GUEST g
         join GUEST_DATA GD on gd.ID_GUEST = g.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = gd.ID_PERSON_DATA
         join RESERV_DETAIL RED on RED.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
         left outer join PROFILE_PERSON PP on PP.ID_PERSON_DATA = GD.ID_PERSON_DATA
  where  G.ID_GUEST = :ID_GUEST
  into   :guest_name, :is_child, :id_titular, :is_check_in;

  if (:ID_GUEST = :id_titular) then exception BOOKING_EXCEPTION '-1007';

  execute procedure GUEST_ANUL_POSTINGS$INT(:id_guest)
  returning_values :EXTRA_POSTS_LEFT;

  update GUEST G
  set    G.ID_RESERV_DETAIL = null,
         g.ID_BASE_ACCOUNT = null,
         g.ID_ACCOUNT = null
  where  G.ID_GUEST = :id_guest;

  update RESERV_DETAIL RD
  set    RD.ADULT_COUNT = RD.ADULT_COUNT - (1 - :is_child),
         RD.CHILD_COUNT = RD.CHILD_COUNT - :is_child
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL;

  if (:is_check_in = 1) then begin
    execute procedure GUEST_REGISTRATION_UPDATE(:id_guest);
  end

  action_text = f_character(29) || '"' || :guest_name || '" (' || :id_guest || ')' || f_character(28) || coalesce(:REASON, '');
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_GUEST_DEL', :action_text);

END
^

/* empty dependent procedure body */
/* Clear: CLEAR_ORPHAN_GUESTS$EXC for: RES_GUEST_DEL$RSV */
ALTER PROCEDURE CLEAR_ORPHAN_GUESTS$EXC(BOOKING_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_GUEST_DEL$RSV) */
ALTER PROCEDURE RES_GUEST_DEL$RSV(ID_GUEST INTEGER,
REASON VARCHAR(50) = null)
 AS
declare variable rd_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable extra_posts_left integer;
begin
  select G.RDB$DB_KEY, RD.ID_RESERV_DETAIL, RD.CHECK_STATUS
  from   GUEST G
         join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
  where  G.ID_GUEST = :id_guest
  into   :rd_dbkey, :id_reserv_detail, :check_status;

  if (:check_status >= 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('RESERV_GUEST_DELETE');
  end

  execute procedure RES_GUEST_DEL$INT(:ID_GUEST, :id_reserv_detail, :REASON)
  returning_values :extra_posts_left;

  execute procedure OCCUPANCY_RESERV$INT(:rd_dbkey);
  --
end
^

/* Alter (RES_GUEST_LOAD) */
ALTER PROCEDURE RES_GUEST_LOAD(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_GUEST INTEGER,
STATUS INTEGER,
GUEST_NAME1 VARCHAR(255),
GUEST_NAME2 VARCHAR(255),
IS_CHILD INTEGER,
AGE INTEGER,
BIRTH_DAY DATE,
BIRTHDAY_INTERNAL DATE,
COUNTRY_CODE VARCHAR(10),
FROM_DATE DATE,
TO_DATE DATE)
 AS
begin
  /*  Description:
  ||
  */

  for
    select G.ID_GUEST, GC.GUEST_NAME1, GC.GUEST_NAME2, G.FROM_DATE, G.TO_DATE, GC.BIRTHDAY_INTERNAL, GC.BIRTH_DAY,
           GC.COUNTRY, G.CHECK_STATUS, G.IS_CHILD
    from   GUEST G
           left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
    where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    order by G.IS_CHILD, G.ID_GUEST
    into   :ID_GUEST, :GUEST_NAME1, :GUEST_NAME2, :FROM_DATE, :TO_DATE, :BIRTHDAY_INTERNAL, :BIRTH_DAY,
           :COUNTRY_CODE, :STATUS, :IS_CHILD
  do begin
    select sca.AGE_INYEARS
    from   SYSTEM_CALC_AGE_INYEARS(:BIRTH_DAY, :FROM_DATE) SCA
    into   :AGE;

    suspend;
  end
end
^

/* Alter (RES_GUEST_SAVE_BOARD$RSV) */
ALTER PROCEDURE RES_GUEST_SAVE_BOARD$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_BOARD INTEGER)
 AS
declare variable id_reserv_detail integer;
declare variable old_id_board integer;
  declare variable action_text varchar(255);
  declare variable guest_name varchar(50);
  declare variable old_board_name varchar(50);
  declare variable new_board_name varchar(50);
begin
  ID_BOARD = :ID_BOARD;
  if (:ID_BOARD = -1) then begin
    -- default to booking board
    select rd.ID_BOARD
    from   GUEST g
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :ID_GUEST
    into   :ID_BOARD;
  end

  update GUEST_STAY GS
  set    gs.ID_BOARD = :ID_BOARD
  where  gs.ID_GUEST = :ID_GUEST
         and gs.FOR_DATE = :FOR_DATE
  returning old.id_board
  into      :old_id_board;

  if (:old_id_board is distinct from :ID_BOARD) then begin
    select g.ID_RESERV_DETAIL, gc.GUEST_NAME1
    from   GUEST G
           left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
    where  g.ID_GUEST = :ID_GUEST
    into   :id_reserv_detail, :guest_name;

    select M.NAME
    from   MEALS M
    where  M.ID_BOARD = :old_id_board
    into   :old_board_name;

    select M.NAME
    from   MEALS M
    where  M.ID_BOARD = :ID_BOARD
    into   :new_board_name;

    action_text = f_character(29) || :guest_name
                  || f_character(28) || formatdate(:for_date, 'd;dd.mm.yyyy')
                  || f_character(28) || coalesce(:new_board_name, '')
                  || f_character(28) || coalesce(:old_board_name, '');
    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'GUEST_DIFF_BOARD', :action_text);
  end
end
^

/* Alter (RES_GUEST_SAVE_RATE$RSV) */
ALTER PROCEDURE RES_GUEST_SAVE_RATE$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TARIFF INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_tariff integer;
  declare variable guest_name varchar(50);
  declare variable action_text varchar(255);
  declare variable old_rate varchar(50);
  declare variable new_rate varchar(50);
begin

  if (:ID_TARIFF = -1) then begin
    -- default to booking board
    select rd.ID_RATE
    from   GUEST g
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :ID_GUEST
    into   :ID_TARIFF;
  end

  update GUEST_STAY GS
  set    gs.ID_TARIFF = :ID_TARIFF
  where  gs.ID_GUEST = :ID_GUEST
         and gs.FOR_DATE = :FOR_DATE
  returning old.id_tariff
  into      :old_id_tariff;
  --

  if (:OLD_ID_TARIFF <> :ID_TARIFF) then begin
    select g.ID_RESERV_DETAIL, gc.GUEST_NAME1
    from   GUEST G
           left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
    where  g.ID_GUEST = :ID_GUEST
    into   :id_reserv_detail, :guest_name;

    select T.TARIFA_NAME
    from   TARIFA T
    where  T.ID_TARIFA = :old_id_tariff
    into   :old_rate;
     
    select T.TARIFA_NAME
    from   TARIFA T
    where  T.ID_TARIFA = :ID_TARIFF
    into   :new_rate;
     
    action_text = f_character(29) || :guest_name
                  || f_character(28) || formatdate(:for_date, 'D;dd.mm.yyyy')
                  || f_character(28) || :new_rate
                  || f_character(28) || :old_rate;
    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :ID_RESERV_DETAIL, 'GUEST_DIFF_TARIFF', :ACTION_TEXT);
  end
end
^

/* Alter (RES_GUEST_SAVE_ROOMTYPE$RSV) */
ALTER PROCEDURE RES_GUEST_SAVE_ROOMTYPE$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TAR_ROOM_TYPE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_room_type integer;
  declare variable action_text varchar(255);
  declare variable guest_name varchar(50);
  declare variable old_room_type varchar(50);
  declare variable new_room_type varchar(50);
begin
 /* select G.TO_DATE - 1, G.ID_RESERV_DETAIL, GC.GUEST_NAME1
  from   GUEST G
         left outer join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
  where  G.ID_GUEST = :ID_GUEST
  into   :to_date, :id_reserv_detail, :guest_name;
  is_departure = iif(:to_date = :for_date, 1, 0);

  select GS.ID_TARIFF, GS.ID_BOARD, GS.ID_TYPE_STAY, GS.ID_ROOM_TYPE
  from   GUEST_STAY GS
  where  GS.ID_GUEST = :ID_GUEST
         and GS.FOR_DATE = :FOR_DATE
  into   :id_tariff, :id_board, :id_type_stay, :old_id_room_type;

  execute procedure RES_GUEST_DYNAMICPARAMS_SAVE(:id_reserv_detail, :id_guest, :for_date,
          :id_tar_room_type, :id_board, :id_type_stay, :id_tariff, :is_departure);
  */
  --
  update GUEST_STAY GS
  set    gs.ID_ROOM_TYPE = :ID_TAR_ROOM_TYPE
  where  gs.ID_GUEST = :ID_GUEST
         and gs.FOR_DATE = :FOR_DATE
  returning old.ID_ROOM_TYPE
  into      :old_id_room_type;

  if (:OLD_ID_ROOM_TYPE <> :ID_TAR_ROOM_TYPE) then begin
    select g.ID_RESERV_DETAIL, gc.GUEST_NAME1
    from   GUEST G
           left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
    where  g.ID_GUEST = :ID_GUEST
    into   :id_reserv_detail, :guest_name;

    if (:old_id_room_type = -1) then begin
      old_room_type = '@{other.AUTO_TYPE_STAY}';
    end else begin
      select RT.TYPE_ROOM
      from   ROOM_TYPES RT
      where  RT.ID_ROOM_TYPE = :old_id_room_type
      into   :old_room_type;
    end

    if (:ID_TAR_ROOM_TYPE = -1) then begin
      new_room_type = '@{other.AUTO_TYPE_STAY}';
    end else begin
      select RT.TYPE_ROOM
      from   ROOM_TYPES RT
      where  RT.ID_ROOM_TYPE = :ID_TAR_ROOM_TYPE
      into   :new_room_type;
    end

    action_text = f_character(29) || :guest_name
                  || f_character(28) || formatdate(:for_date, 'd;dd.mm.yyyy')
                  || f_character(28) || :new_room_type
                  || f_character(28) || :old_room_type;
    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'GUEST_DIFF_ROOM_TYPE', :action_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_AUTO$INT for: RES_GUEST_SAVE_STAY$INT */
ALTER PROCEDURE RES_GUEST_AUTO$INT(G_DBKEY CHAR(8),
RD_DBKEY CHAR(8),
IS_NEW_GUEST SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_SAVE_STAY$RSV for: RES_GUEST_SAVE_STAY$INT */
ALTER PROCEDURE RES_GUEST_SAVE_STAY$RSV(ID_GUEST INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_STAY$INT for: RES_GUEST_SAVE_STAY$INT */
ALTER PROCEDURE RES_SAVE_STAY$INT(RD_DBKEY CHAR(8),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_GUEST_SAVE_STAY$INT) */
ALTER PROCEDURE RES_GUEST_SAVE_STAY$INT(G_DBKEY CHAR(8),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable guest_status varchar(250);
  declare variable old_arrival_date date;
  declare variable old_departure_date date;
  declare variable system_date date;
  declare variable id_guest integer;
  declare variable is_check_in smallint;
begin

  if (:arrival_date >= :departure_date) then exception BOOKING_EXCEPTION '-53';

  guest_status = '';
  select G.FROM_DATE, G.TO_DATE, G.IS_CHECK_IN
  from   GUEST G
  where  G.RDB$DB_KEY = :g_dbkey
  into   :old_arrival_date, :old_departure_date, :is_check_in;

  if (:arrival_date <> :old_arrival_date) then guest_status = 'FROM_DATE_CHANGED';
  if (:departure_date <> :old_departure_date) then guest_status = 'TO_DATE_CHANGED';

  if (:guest_status containing 'DATE_CHANGED') then begin
    update GUEST G
    set    G.OLD_FROM_DATE = iif(G.OLD_FROM_DATE is null, :old_arrival_date, cast(minDate(:old_arrival_date, G.OLD_FROM_DATE) as date)),
           G.OLD_TO_DATE = iif(G.OLD_TO_DATE is null, :old_departure_date, cast(maxDate(:old_departure_date, G.OLD_TO_DATE) as date)),
           G.FROM_DATE = :arrival_date,
           G.TO_DATE = :departure_date
    where  G.RDB$DB_KEY = :g_dbkey
    returning g.ID_GUEST
    into      :id_guest;

    execute procedure GUEST_SET_EDIT_STATUS$INT (:G_DBKEY, :guest_status, 'add');

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :system_date;

    -- if past dates are conserned
    if ( (:old_arrival_date is not null
          and :old_arrival_date <> :arrival_date
          and MinDate(:arrival_date, :old_arrival_date) < :system_date
         )
         or
         (:old_departure_date is not null
          and :old_departure_date <> :departure_date
          and MinDate(:departure_date, :old_departure_date) < :system_date
         )
       ) then
    begin
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MODIFY_PAST_STAY');
    end

    execute procedure GUEST_ADJUST_GUESTSTAY$INT(:g_dbkey);

    if (:is_check_in = 1) then begin
      execute procedure GUEST_REGISTRATION_UPDATE(:id_guest);
    end
  end

end
^

/* empty dependent procedure body */
/* Clear: IMPORT_GUEST$EXC for: RES_GUEST_SAVE_STAY$RSV */
ALTER PROCEDURE IMPORT_GUEST$EXC(BOOKING_ID INTEGER,
PROFILE_UUID VARCHAR(40),
GUEST_UUID VARCHAR(40),
GUEST_NAME VARCHAR(100),
IS_CHILD SMALLINT,
AGE INTEGER,
IS_DIFFERENT_ARRANGER SMALLINT,
ARRIVAL DATE,
DEPARTURE DATE,
VOUCHER VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
RATING_AGE INTEGER,
KPP VARCHAR(50),
KPP_DATE DATE,
STAY_REASON VARCHAR(255),
CAR VARCHAR(30),
IS_REGISTRED SMALLINT,
PERSONAL_NUMBER VARCHAR(30),
TITLE VARCHAR(10),
PT_NAME VARCHAR(100),
PT_EXTCODE VARCHAR(50),
PASS_NUM VARCHAR(20),
PASS_PLACE VARCHAR(20),
PASS_DATE DATE,
PASS_EXP_DATE DATE,
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_DATE DATE,
SEX CHAR,
BIRTH_PLACE VARCHAR(30),
MASK VARCHAR(10),
PACKAGE VARCHAR(255),
VISA /* TDESCRIPTION_SHORT */ VARCHAR(100))
 RETURNS(GUEST_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GUEST_SAVE_STAY$RSV) */
ALTER PROCEDURE RES_GUEST_SAVE_STAY$RSV(ID_GUEST INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable g_dbkey char(8);
declare variable id_hotel integer;
  declare variable old_arrival date;
  declare variable old_departure date;
  declare variable action_text varchar(255);
begin
  err_code = 0;
  warn_code = 0;
  select G.RDB$DB_KEY, RD.ID_HOTEL, G.FROM_DATE, G.TO_DATE
  from   GUEST G
         join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :id_hotel, :old_arrival, old_departure;

  execute procedure RES_GUEST_SAVE_STAY$INT(:g_dbkey, :arrival_date, :departure_date, :id_hotel);

  if ((:old_arrival <> :arrival_date) or (:old_departure <> :departure_date) ) then begin
    action_text = f_character(29) || '{' || formatdate(:old_arrival, 'D;dd.mm.yyyy') || '-' || formatdate(:old_departure, 'D;dd.mm.yyyy') || '}'
                  || f_character(28) || '{' || formatdate(:arrival_date, 'D;dd.mm.yyyy') || '-' || formatdate(:departure_date, 'D;dd.mm.yyyy') || '}';
    execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'GUEST_MOD_PERIOD', :action_text);
  end
end
^

/* Alter (RES_GUEST_SAVE_TYPESTAY$RSV) */
ALTER PROCEDURE RES_GUEST_SAVE_TYPESTAY$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TYPE_STAY INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_type_stay integer;
  declare variable action_text varchar(255);
  declare variable guest_name varchar(50);
  declare variable old_type_stay varchar(50);
  declare variable new_type_stay varchar(50);
begin
/*  select G.TO_DATE - 1, G.ID_RESERV_DETAIL, GC.GUEST_NAME1
  from   GUEST G
         left outer join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
  where  G.ID_GUEST = :ID_GUEST
  into   :to_date, :id_reserv_detail, :guest_name;
  is_departure = iif(:TO_DATE = :FOR_DATE, 1, 0);

  select GS.ID_ROOM_TYPE, GS.ID_TARIFF, GS.ID_BOARD, GS.ID_TYPE_STAY
  from   GUEST_STAY GS
  where  GS.ID_GUEST = :ID_GUEST
         and GS.FOR_DATE = :FOR_DATE
  into   :id_tar_room_type, :id_tariff, :id_board, :old_id_type_stay;

  execute procedure RES_GUEST_DYNAMICPARAMS_SAVE(:id_reserv_detail, :id_guest, :for_date,
          :id_tar_room_type, :id_board, :id_type_stay, :id_tariff, :is_departure);
  */
  --
  update GUEST_STAY GS
  set    gs.ID_TYPE_STAY = :ID_TYPE_STAY
  where  gs.ID_GUEST = :ID_GUEST
         and gs.FOR_DATE = :FOR_DATE
  returning old.ID_TYPE_STAY
  into      :old_id_type_stay;

  if (:old_id_type_stay <> :id_type_stay) then begin
    select g.ID_RESERV_DETAIL, gc.GUEST_NAME1
    from   GUEST G
           left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
    where  g.ID_GUEST = :ID_GUEST
    into   :id_reserv_detail, :guest_name;

    if (:old_id_type_stay = -1) then begin
      old_type_stay = '@{other.AUTO_TYPE_STAY}';
    end else begin
      select TS.TYPE_STAY
      from   TYPE_STAY TS
      where  TS.ID_TYPE_STAY = :old_id_type_stay
      into   :old_type_stay;
    end
    if (:ID_TYPE_STAY = -1) then begin
      new_type_stay = '@{other.AUTO_TYPE_STAY}';
    end else begin
      select TS.TYPE_STAY
      from   TYPE_STAY TS
      where  TS.ID_TYPE_STAY = :id_type_stay
      into   :new_type_stay;
    end
     
    action_text = f_character(29) || :guest_name
                  || f_character(28) || formatdate(:for_date, 'd;dd.mm.yyyy')
                  || f_character(28) || :new_type_stay
                  || f_character(28) || :old_type_stay;
    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'GUEST_DIFF_TYPESTAY', :action_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUESTCOUNT$INT for: RES_GUESTCOUNT_DEL$INT */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$INT(RD_DBKEY CHAR(8),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_GUESTCOUNT_DEL$INT) */
ALTER PROCEDURE RES_GUESTCOUNT_DEL$INT(RD_DBKEY CHAR(8),
DEL_ADULT_COUNT INTEGER,
DEL_CHILD_COUNT INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable del_count integer;
  declare variable id_guest integer;
  declare variable extra_posts_left integer;
begin
  /*  Description:
  ||
  */
  select RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail;

  del_count = 0;
  if (:del_adult_count > 0) then begin
    for
      select first (:DEL_ADULT_COUNT) g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.IS_CHILD = 0
             and G.CHECK_STATUS = -2
      order by G.ID_GUEST desc
      into   :id_guest
    do begin
      execute procedure RES_GUEST_DEL$INT(:id_guest, :id_reserv_detail)
      returning_values  :extra_posts_left;
      del_count = :del_count + 1;
    end
    if (:del_count < :DEL_ADULT_COUNT) then exception BOOKING_EXCEPTION '-1002';
  end

  del_count = 0;
  if (:del_child_count > 0) then begin
    for
      select first (:DEL_CHILD_COUNT) g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.IS_CHILD = 1
             and G.CHECK_STATUS = -2
      order by G.ID_GUEST desc
      into   :id_guest
    do begin
      execute procedure RES_GUEST_DEL$INT(:id_guest, :id_reserv_detail)
      returning_values  :extra_posts_left;
      del_count = :del_count + 1;
    end
    if (:del_count < :DEL_CHILD_COUNT) then exception BOOKING_EXCEPTION '-1002';
  end

end
^

/* Alter (RES_LOAD) */
ALTER PROCEDURE RES_LOAD(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_AGENT_PROFILE INTEGER,
AGENT_PROFILE_NAME VARCHAR(100),
ID_PERSON_PROFILE INTEGER,
PERSON_PROFILE_NAME VARCHAR(100),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_RES_ROOM_TYPE INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
BOARD_NAMES VARCHAR(255),
TARIFF_NAMES VARCHAR(255),
PACKET_NAMES VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100),
VOUCHER_RENDER VARCHAR(512),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
TRANSFER_RENDER VARCHAR(255),
CODE_FIRST_FOOD_RENDER VARCHAR(255),
IS_LATE_DEPARTURE INTEGER,
CODE_FIRST_FOOD VARCHAR(20),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
I_SPECIAL_TREATMENT VARCHAR(255),
COMMING_KIND SMALLINT,
IS_VIP SMALLINT,
HAS_GUEST_LIST SMALLINT,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
AGENT_ACCOUNT_NAME VARCHAR(100),
IS_DIFFERENT_VOUCHER INTEGER,
IS_DIFFERENT_OTHER INTEGER,
IS_DIFFERENT_BOARD INTEGER,
IS_DIFFERENT_TARIFF INTEGER,
IS_CUSTOM_PRICE INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
ID_RATE INTEGER,
ROOM_FEATURES BLOB,
ID_GROUP INTEGER,
NUMBER VARCHAR(62),
CHECK_STATUS INTEGER,
BALANCE VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER,
RECIEVED_DEPOSITS VARCHAR(255),
ROOM_HISTORY VARCHAR(200),
TAR_ROOM_TYPE VARCHAR(100),
ID_HK_PLAN INTEGER,
COUNTRIES VARCHAR(812),
IS_RESGRP INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
IS_ANUL INTEGER,
NOTE VARCHAR(2000),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
GROUP_NAME VARCHAR(50),
ID_HOTEL INTEGER,
NOTE_REMINDERS VARCHAR(50),
IS_DIFFERENT_PRICE INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ID_EATING_OBJECT TYPE OF ID_REF,
ROOM_PRIVATE_STATUS TLOGICAL)
 AS
declare variable rd_dbkey char(8);
  declare variable reason_of_anul varchar(100);
  declare variable shared_resvations varchar(1024);
  declare variable virtual_room varchar(10);
  declare variable packet_item_ids varchar(255);
  declare variable earlycheckout_date date;
begin
  select RD.RDB$DB_KEY, RD.ID_AGENT_PROFILE, PA.PROFILE_NAME,
         RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON, RD.ID_NOM_COME_REASON,
         RD.ADULT_COUNT, RD.CHILD_COUNT, RD.CUSTOM_PRICE, RD.CUSTOM_CURRENCY,
         RD.IS_VIP, RD.CHECK_STATUS, RD.ID_AGENT_ACCOUNT,
         RD.ACC_ROUTING, RD.ID_PERSON_PAYMENT,
         RD.ID_AGENT_PAYMENT, RD.ID_PERSON_PROFILE, PP.PROFILE_NAME, RD.ID_GROUP,
         RD.COMMING_KIND, RD.I_SPECIAL_TREATMENT, ACC.ACCOUNT_NAME, RD.ROOM_FEATURES, RD.ID_HK_PLAN,
         RD.NUMBER, RD.IS_ANUL, RD.REASON_OF_ANUL, RD.NOTE,
         RD.HAS_DIFFERENT_VOUCHERS, RD.HAS_DIFFERENT_OTHER,
         RD.HAS_DIFFERENT_BOARD, RD.HAS_DIFFERENT_TARIFF, RD.HAS_DIFFERENT_TYPE_STAY, RD.HAS_DIFFERENT_ROOM_TYPE,
         RD.ID_HOTEL, RG.GROUP_NAME, RD.ID_RATE, RD.NOTE_REMINDERS, RD.has_different_price,
         RD.ID_GUARANTEE_POLICY, RD.BLOCK_CC, rd.ID_EATING_OBJECT, g.EARLYCHECKOUT_DATE
  from   RESERV_DETAIL RD
         left outer join RESERV_GROUP RG on RG.ID_RESERV_GROUP = RD.ID_GROUP
         left outer join PROFILE PA on PA.ID_PROFILE = RD.ID_AGENT_PROFILE
         left outer join PROFILE PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join ACCOUNT ACC on ACC.ID_ACCOUNT = RD.ID_AGENT_ACCOUNT
         left outer join GUEST G on g.ID_GUEST = rd.ID_TITULAR
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :id_agent_profile, :agent_profile_name,
         :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason,
         :adult_count, :child_count, :custom_price, :custom_currency,
         :is_vip, :check_status, :id_agent_account, :acc_routing, :id_person_payment,
         :id_agent_payment, :id_person_profile, :person_profile_name, :id_group,
         :comming_kind, :i_special_treatment, :agent_account_name, :room_features, :id_hk_plan,
         :number, :is_anul, :reason_of_anul, :note,
         :is_different_voucher, :is_different_other,
         :is_different_board, :is_different_tariff, :is_different_stay_type, :is_different_room_type,
         :id_hotel, :group_name, :id_rate, :note_reminders, :is_different_price,
         :id_guarantee_policy, :block_cc, :id_eating_object, :earlycheckout_date;

  is_resgrp = iif(:id_group is not null, 1, 0);

  if ((:is_different_price = 1) or (:custom_price is not null) ) then
    IS_CUSTOM_PRICE = 1;
  else
    IS_CUSTOM_PRICE = 0;

  execute procedure RES_GET_PRICE$INT(:rd_dbkey, 'SECURITY')
  returning_values  :room_price, :room_currency, :room_price_details,
                    :deposit_required, :deposit_required_currency;

  execute procedure RES_GET_BALLANCE$INT(:id_reserv_detail)
  returning_values  :balance, :recieved_deposits, :has_charges, :open_charges, :open_deposit;

  execute procedure RES_GET_STATIC_DATA$INT(:rd_dbkey)
  returning_values  :arrival_date, :departure_date, :voucher_num, :voucher_date,
                    :voucher_text, :voucher2_num, :voucher2_date, :transfer_in_time,
                    :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :is_late_departure, :code_first_food;

  execute procedure RES_GET_DYNAMIC_DATA$INT(:rd_dbkey, 1)
  returning_values  :id_res_room_type, :id_room_type, :id_room, :id_board,
                    :id_tariff, :packet_item_ids, :room_name, :room_history, :tar_room_type, :virtual_room;

  execute procedure RES_GET_GUEST_DATA$INT('DETAIL', :id_reserv_detail)
  returning_values  :board_names, :tariff_names, :packet_names, :voucher_render;

  execute procedure RES_GET_GUEST_DATA2$INT(:id_reserv_detail)
  returning_values  :has_guest_list, :countries, :transfer_render, :code_first_food_render;

  execute procedure RES_GET_ATTENTION_STATUS$INT(:arrival_date, :departure_date, :check_status, :id_hotel)
  returning_values  :attention_status;

  execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'RENDER', null)
  returning_values  :in_share, :shared_resvations, :shares_preview;
  if (:IN_SHARE = 1) then ROOM_NAME = coalesce(:ROOM_NAME, :virtual_room);

  annul_status = :is_anul;
  if (:reason_of_anul = 'EXPIRE') then annul_status = 2;
  execute procedure sys_dbg('res RES_LOAD comming_kind = '||coalesce(:comming_kind, 'null'));

  ROOM_PRIVATE_STATUS = 0;
  select cast(1 as smallint)
  from   SYSTEM_DATE_GET (:ID_HOTEL) sd
         join ROOM_MAGIC rm on rm.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                               and rm.ROOM_STATUS = 'PRIVATE'
                               and rm.BUSY_DATE = mindate(maxdate(:ARRIVAL_DATE, sd.SYSTEM_DATE), coalesce(:earlycheckout_date, :DEPARTURE_DATE) - 1)
  into   :ROOM_PRIVATE_STATUS;

  suspend;
end
^

/* empty dependent procedure body */
/* Clear: RES_TAKE_POSTING_RESPONSIBILITY for: RES_PENDING_DEPOSITS_POST$INT */
ALTER PROCEDURE RES_TAKE_POSTING_RESPONSIBILITY(ID_RESERV_DETAIL /* ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_PENDING_DEPOSITS_POST$INT) */
ALTER PROCEDURE RES_PENDING_DEPOSITS_POST$INT(ID_RESERV_DETAIL ID)
 AS
declare variable id_doc_type integer;
  declare variable deposit_value numeric(15,4);
  declare variable currency char(3);
  declare variable id_account integer;
  declare variable id_payment_head integer;
  declare variable id_deposit integer;
  declare variable def_text varchar(255);
  declare variable description type of TDESCRIPTION_SHORT ;
  declare variable uuid uuid;
  declare variable mapped_doc_type integer;
  declare variable booking_prefix varchar(20);
  declare variable map_prefix varchar(20);
  declare variable hotel_name varchar(50);
begin
  id_doc_type = null;
  id_account = null;

  if (exists (select pd.ID_PENDING_DEPOSIT
              from   PENDING_DEPOSIT pd
              where  pd.ID_RESERV_DETAIL = :ID_RESERV_DETAIL)) then
  begin
    def_text = '';
    map_prefix = null;
    mapped_doc_type = null;
    select sv.SETTING_VALUE, h.hotel_name, r.number_1, ddm.prefix, ddm.doc_type_id, dt.id_doc_type
    from   RESERV_DETAIL r 
           join HOTEL h on h.id_hotel = r.id_hotel
           left outer join DEPOSIT_DOCTYPE_MAP$EXC ddm on ddm.prefix = r.number_1
                                                       and ddm.ID_HOTEL = r.ID_HOTEL
           left outer join DOC_TYPE dt on dt.id_doc_type = ddm.doc_type_id
                                          and dt.id_hotel = r.id_hotel
                                          and dt.IS_ARCHIVE = 0
           left outer join SETTING_GET_VALUE ('DEFAULT_DEPOSIT_DESCRIPTION', r.ID_HOTEL) sv on 1=1
    where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :def_text, :hotel_name, :booking_prefix, :map_prefix, :mapped_doc_type, :id_doc_type;
  
    if (:map_prefix is null) then begin
    /* missed map - raise exception */
      exception DOC_TYPE_EXCEPTION '-1058' || f_character(31) || f_character(29) || :booking_prefix || f_character(28) || :hotel_name;
    end
  
    if (:mapped_doc_type is null) then exit;
    /* empty map (null id_doc_type) supports - skip deposit for this database */
  
    if (:ID_DOC_TYPE is null) then begin
      /* mapped to inexisting doc_type */
      exception DOC_TYPE_EXCEPTION '-1059' || f_character(31) || f_character(29) || :hotel_name;
    end
    /* get reserv account */
    select first 1 ra.ID_ACCOUNT
    from   RES_GET_ACCOUNTS (:ID_RESERV_DETAIL, 'GUARANTEE_DEPOSIT_CREATE') ra
    into   :id_account;
  end

  for
    select pd.DESCRIPTION, pd.DEPOSIT_VALUE, pd.CURRENCY, pd.UUID
    from   PENDING_DEPOSIT pd
    where  pd.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    with lock
    into   :description, :deposit_value, :currency, :uuid
  do begin
    execute procedure DEPOSIT_NEW$DOC (:id_account, :id_doc_type, :deposit_value, :currency,
            substring(:def_text || ' (' || :description || ')' from 1 for 100), :ID_RESERV_DETAIL)
    returning_values (:id_deposit, :id_payment_head);

    update DEPOSIT D
    set    d.UUID = :uuid
    where  d.ID_DEPOSIT = :id_deposit;
  end
end
^

/* Alter (RES_SAVE_ACC_ARCHIVE$INT) */
ALTER PROCEDURE RES_SAVE_ACC_ARCHIVE$INT(ACCOUNTS_FOR_ARCHIVE VARCHAR(2000),
ID_PROFILE INTEGER)
 AS
declare variable id_account integer;
  declare variable old_id_profile integer;
  declare variable is_used integer;
  declare variable errtxt_acc_name varchar(50);
  declare variable errtxt_prof_name varchar(100);
  declare variable id_sale_num integer;
begin
  /*  Description:
  ||
  */
  for
    select ITEM
    from   SYSTEM_STRING_PARSER(:accounts_for_archive, ',')
    into   :id_account                                 
  do begin
    select A.ID_PROFILE, a.ID_SALE_NUM
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :old_id_profile, :id_sale_num;

    execute procedure sys_dbg('acc RES_SAVE_ACC_ARCHIVE$INT old_id_profile = '||coalesce(:old_id_profile, 'null'));
    execute procedure sys_dbg('acc RES_SAVE_ACC_ARCHIVE$INT id_profile = '||coalesce(:id_profile, 'null'));

    execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 1);
    execute procedure sys_dbg('acc RES_SAVE_ACC_ARCHIVE$INT id_account = '||coalesce(:id_account, 'null'));

    if (:old_id_profile is distinct from :id_profile) then begin
      execute procedure ACCOUNT_USE_CHECK$INT(:id_account)
      returning_values  :is_used;
      if (:id_sale_num is null and :is_used = 0) then
        delete from ACCOUNT A
        where  A.ID_ACCOUNT = :id_account;
    end

    when exception ACCOUNT_EXCEPTION do begin
      -- catch the exception raised from archivate procedure (err_code = -44)
      select A.ACCOUNT_NAME
      from   ACCOUNT A
      where  A.ID_ACCOUNT = :id_account
      into   :errtxt_acc_name;
  
      select P.PROFILE_NAME
      from   PROFILE P
      where  P.ID_PROFILE = :old_id_profile
      into   :errtxt_prof_name;
      -- override error code with most concrete
      exception ACCOUNT_EXCEPTION '-1009' || f_character(31) || '' || f_character(29)||:errtxt_acc_name||f_character(28)||:errtxt_prof_name;
    end

  end
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTING$RSV for: RES_SAVE_ACCOUNTING$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$RSV(ID_RESERV_DETAIL INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER,
ID_CREDIT_CARD INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_COMMON_MODIFY$RSV for: RES_SAVE_ACCOUNTING$INT */
ALTER PROCEDURE RESMULTI_COMMON_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
CHECK_STATUS SMALLINT,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
NOTE VARCHAR(2000),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(30),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
NOTE_REMINDERS VARCHAR(50),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: UPDATE_BOOKING$EXC for: RES_SAVE_ACCOUNTING$INT */
ALTER PROCEDURE UPDATE_BOOKING$EXC(BOOKING_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE INTEGER,
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA_ID INTEGER,
POSTING_ROUTING VARCHAR(20),
ID_AGENT_ACCOUNT INTEGER,
RATE_ID INTEGER,
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD_CODE /* TFOOD_CODE */ VARCHAR(20),
ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ACCOUNTING$INT) */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
declare variable old_id_agent_profile integer;
  declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable action_text varchar(255);
  declare variable old_account_routing varchar(30);
  declare variable id_acc_profile integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:acc_routing, 'GUEST, AGENT, MIXED, OWNER, FULL_COMPLIMENTARY, PART_COMPLIMENTARY', 'Account routing');

  if (exists (select *
              from   PROFILE_HOUSE PH
              where  PH.ID_PROFILE = :id_agent_profile)) then
  begin
    exception BOOKING_EXCEPTION '-1016';
  end

  --execute procedure RESERV_TRACK_CHANGES$INT(:rd_dbkey);

  select RD.ID_AGENT_PROFILE, RD.ID_RESERV_DETAIL, RD.ACC_ROUTING
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_agent_profile, :id_reserv_detail, :old_account_routing;

  if (:ACC_ROUTING in ('AGENT','MIXED') and :ID_AGENT_ACCOUNT is not null) then begin
    select A.ID_PROFILE
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :ID_AGENT_ACCOUNT
    into   :id_acc_profile;
    -- check up agent account ownership
    if (:id_acc_profile is distinct from :ID_AGENT_PROFILE) then ID_AGENT_ACCOUNT = null;
  end

  update RESERV_DETAIL RD
  set    RD.ID_AGENT_ACCOUNT_RULE = :ID_AGENT_ACCOUNT,
         RD.ACC_ROUTING = :ACC_ROUTING,
         RD.ID_AGENT_PROFILE = :ID_AGENT_PROFILE,
         RD.ID_AGENT_PAYMENT = :ID_AGENT_PAYMENT,
         RD.ID_PERSON_PAYMENT = coalesce(:ID_PERSON_PAYMENT, RD.ID_PERSON_PAYMENT),
         RD.ID_GROUP = :ID_GROUP
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_id_agent_profile is distinct from :id_agent_profile) then begin
    execute procedure RES_SET_EDIT_STATUS$INT(:RD_DBKEY, 'AGENT', 'add');

    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure GUEST_AGENT_SET$INT(:g_dbkey, :id_agent_profile);
    end

    select f_character(29)||coalesce(old_A.PROFILE_NAME, '')||f_character(28)||coalesce(new_A.PROFILE_NAME, '')
    from   PROFILE old_A, PROFILE new_A
    where  old_A.ID_PROFILE = :old_id_agent_profile
           and new_A.ID_PROFILE = :ID_AGENT_PROFILE
    into   :action_text;

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_AGENT', :action_text);
  end

  if (:ACC_ROUTING <> :old_account_routing) then begin
    action_text = f_character(29) || coalesce(:old_account_routing, '')
                  || f_character(28) || coalesce(:acc_routing, '');

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_ACC_ROUTING', :action_text);
  end

  execute procedure RES_SAVE_ACCOUNTS$INT (:RD_DBKEY);
end
^

/* Alter (RES_SAVE_ACCOUNTING$RSV) */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$RSV(ID_RESERV_DETAIL INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER,
ID_CREDIT_CARD INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);


begin
  /* Description : ACC_ROUTING = {GUEST, AGENT, MIXED, OWNER,  }
  ||
  */
  select rd.RDB$DB_KEY
  from   RESERV_DETAIL rd
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SAVE_ACCOUNTING$INT(:rd_dbkey, :id_agent_profile, :id_agent_account, :acc_routing,
                    :id_person_payment, :id_agent_payment, :id_group);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
  returning_values  :warn_code;

  --
end
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_CHANGE$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUESTCOUNT$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ACCOUNTS$INT) */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_base_account integer;
  declare variable old_id_extra_account integer;
  declare variable new_id_base_account integer;
  declare variable new_id_extra_account integer;
  declare variable acc_routing varchar(30);
  declare variable is_sep_accounts integer;
  declare variable id_base_account_profile integer;
  declare variable id_extra_account_profile integer;
  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable id_agent_account_rule integer;
  declare variable id_acc_template_person integer;
  declare variable id_guest integer;
  declare variable id_hotel integer;
  declare variable check_status integer;
  declare variable id_sale_num integer;
begin

  select RD.ID_RESERV_DETAIL, RD.ID_PERSON_PROFILE, RD.ID_ACC_TEMPLATE_PERSON,
         RD.ACC_ROUTING, RD.ID_BASE_ACCOUNT, RD.ID_EXTRA_ACCOUNT,
         RD.ID_AGENT_PROFILE, RD.ID_AGENT_ACCOUNT_RULE, rd.id_hotel
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :RD_DBKEY
  into   :id_reserv_detail, :id_person_profile, :id_acc_template_person,
         :acc_routing, :old_id_base_account, :old_id_extra_account,
         :id_agent_profile, :id_agent_account_rule, :id_hotel;

  id_agent_account_rule = nullif(:id_agent_account_rule, -1);
  /* --- new */
  execute procedure SETTING_GET_VALUE ('SEPARATE_ACCOUNTS_PER_PAYER', :id_hotel)
  returning_values (:IS_SEP_ACCOUNTS);

  NEW_ID_BASE_ACCOUNT = null; --:old_id_base_account;
  NEW_ID_EXTRA_ACCOUNT = null; --:old_id_extra_account;

  /* identify profiles for base and extra account */
  if (:ACC_ROUTING in ('MIXED')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else if (:ACC_ROUTING in ('AGENT')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
  end else if (:ACC_ROUTING in ('FULL_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = null;
    IS_SEP_ACCOUNTS = 0;  -- never
  end else if (:ACC_ROUTING in ('PART_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else begin -- if (:acc_routing in ('GUEST', 'OWNER'))
    ID_BASE_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_AGENT_ACCOUNT_RULE = null;
  end

  execute procedure RES_ACCOUNTS_RECIEVE$INT (:ID_RESERV_DETAIL, :old_id_base_account, :old_id_extra_account,
          :id_agent_account_rule, :id_base_account_profile, :id_extra_account_profile, :id_person_profile,
          :id_acc_template_person, :is_sep_accounts)
  returning_values (:new_id_base_account, :new_id_extra_account);

--  if (:new_id_base_account is null) then exception WRONG_VALUE 'Invalid base account!';
--  if (:new_id_extra_account is null) then exception WRONG_VALUE 'Invalid extra account!';
  if ((:old_id_base_account is distinct from :new_id_base_account)
       or (:old_id_extra_account is distinct from :new_id_extra_account)) then
  begin
    update RESERV_DETAIL RD
    set    RD.ID_BASE_ACCOUNT = :new_id_base_account,
           RD.ID_EXTRA_ACCOUNT = :new_id_extra_account
    where  RD.RDB$DB_KEY = :RD_DBKEY
    returning CHECK_STATUS into :check_status;
    /* end --- */
    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
             --and G.CHECK_STATUS < 1
      into   :id_guest
    do begin
      execute procedure GUEST_REROUTE_POSTINGS$INT(:id_guest, :new_id_base_account, :new_id_extra_account);
    end

    if (:check_status = 0) then begin
      execute procedure ACCOUNT_SALE_NUMBER_SET(:new_id_base_account)
      returning_values (:id_sale_num);
      execute procedure ACCOUNT_SALE_NUMBER_SET(:new_id_extra_account)
      returning_values (:id_sale_num);
    end
    -- Log account changes
    execute procedure RES_SAVE_ACCOUNTS_FINALIZE$INT(:id_reserv_detail, :old_id_base_account, :old_id_extra_account,
            :new_id_base_account, :new_id_extra_account);
  end

end
^

/* Alter (RES_SAVE_ACCOUNTS_FINALIZE$INT) */
ALTER PROCEDURE RES_SAVE_ACCOUNTS_FINALIZE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable id_old_account integer;
  declare variable action_text varchar(255);
  declare variable acc_name varchar(50);
  declare variable is_used integer;
  declare variable id_sale_num integer;
begin
  if (:NEW_ID_BASE_ACCOUNT is distinct from :OLD_ID_BASE_ACCOUNT) then begin
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OLD_ID_BASE_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = F_CHARACTER(29) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:OLD_ID_BASE_ACCOUNT, '')  || ')';
    ACC_NAME = null;
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :NEW_ID_BASE_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = :ACTION_TEXT || F_CHARACTER(28) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:NEW_ID_BASE_ACCOUNT, '')  || ')';

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_MOD_BASE_ACCOUNT', :ACTION_TEXT);
  end

  ACTION_TEXT = '';
  ACC_NAME = null;
  if (:NEW_ID_EXTRA_ACCOUNT is distinct from :OLD_ID_EXTRA_ACCOUNT) then begin
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OLD_ID_EXTRA_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = F_CHARACTER(29) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:OLD_ID_EXTRA_ACCOUNT, '')  || ')';
    ACC_NAME = null;
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :NEW_ID_EXTRA_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = :ACTION_TEXT || F_CHARACTER(28) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:NEW_ID_EXTRA_ACCOUNT, '')  || ')';

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_MOD_EXTRA_ACCOUNT', :ACTION_TEXT);
  end

  -- Archivate old unused accounts
  for
    select A.ID_ACCOUNT, a.ID_SALE_NUM
    from   ACCOUNT_S A
    where  A.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
           and A.IS_ARCHIVE = 0
           and A.ID_ACCOUNT <> :NEW_ID_BASE_ACCOUNT
           and A.ID_ACCOUNT <> :NEW_ID_EXTRA_ACCOUNT
           and A.IS_CREDIT_ACCOUNT = 0
           and not exists(select G.ID_GUEST
                          from   GUEST G
                          where  (G.ID_BASE_ACCOUNT = A.ID_ACCOUNT)
                                 or (G.ID_ACCOUNT = A.ID_ACCOUNT))
    into   :ID_OLD_ACCOUNT, :id_sale_num
  do begin
    select auc.is_used
    from   ACCOUNT_USE_CHECK$INT(:id_old_account) auc
    into   :is_used;

    if (:id_sale_num is null and :is_used = 0) then begin
      delete from ACCOUNT A
      where  a.ID_ACCOUNT = :id_old_account;
    end else if (not exists(select ap.ID_ACCOUNT_POST from account_post ap where ap.ID_ACCOUNT = :id_old_account and ap.IS_ANUL = 0)) then  begin
      -- archive only used accounts without valid postings
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS (:ID_OLD_ACCOUNT, 1);
  
      when exception ACCOUNT_EXCEPTION do post_event 'dummy';
    end
  end 
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_BOARD$RSV for: RES_SAVE_BOARD$INT */
ALTER PROCEDURE RES_SAVE_BOARD$RSV(ID_RESERV_DETAIL INTEGER,
ID_BOARD INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_MODIFY_BOARD$RSV for: RES_SAVE_BOARD$INT */
ALTER PROCEDURE RESMULTI_MODIFY_BOARD$RSV(ID_RESERV_DETAIL INTEGER,
ID_BOARD INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SAVE_BOARD$INT) */
ALTER PROCEDURE RES_SAVE_BOARD$INT(RD_DBKEY CHAR(8),
ID_BOARD INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_guest integer;
  declare variable old_id_board integer;
  declare variable action_text varchar(255);
  declare variable old_board varchar(30);
  declare variable new_board varchar(30);
begin
  id_board = :ID_BOARD;
  select RD.ID_RESERV_DETAIL, RD.ID_BOARD, TH.NAME
  from   RESERV_DETAIL RD
         left outer join MEALS TH on TH.ID_BOARD = RD.ID_BOARD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail, :old_id_board, :old_board;

  update RESERV_DETAIL RD
  set    RD.ID_BOARD = :id_board,
         RD.HAS_DIFFERENT_BOARD = 0
  where  RD.RDB$DB_KEY = :rd_dbkey;

  for
    select G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest
  do begin
    update GUEST_STAY GS
    set    GS.ID_BOARD = :id_board
    where  GS.ID_GUEST = :id_guest;
  end

  execute procedure RES_GUESTDATA_INVALIDATE$INT(:rd_dbkey);

  if (:old_id_board is distinct from :id_board) then begin
    select TH.NAME
    from   MEALS TH
    where  TH.ID_BOARD = :id_board
    into   :new_board;

    action_text = f_character(29) || coalesce(:old_board, '') || f_character(28) || coalesce(:new_board, '');
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'BOARD_CHANGED', :action_text);
  end
end
^

/* Alter (RES_SAVE_BOARD$RSV) */
ALTER PROCEDURE RES_SAVE_BOARD$RSV(ID_RESERV_DETAIL INTEGER,
ID_BOARD INTEGER)
 AS
declare variable rd_dbkey char(8);
declare variable err_code integer;
declare variable err_text varchar(255);
begin

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_SAVE_BOARD$INT(:rd_dbkey, :id_board);
   
  execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
  returning_values  :err_code, :err_text;

  execute procedure RES_FINALIZE_ERRHANDLING$INT(:id_reserv_detail, :err_code, :err_text, 'RECALC', 0);
end
^

/* Alter (RES_SAVE_GUESTCOUNT$INT) */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$INT(RD_DBKEY CHAR(8),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 AS
declare variable old_adult_count integer;
  declare variable old_child_count integer;
  declare variable add_adult_count integer;
  declare variable add_child_count integer;
  declare variable del_adult_count integer;
  declare variable del_child_count integer;
begin

  if (((:adult_count + :child_count) <= 0) or (:adult_count < 0) or (:child_count < 0)) then begin
    exception BOOKING_EXCEPTION '-1005' || f_character(31) || f_character(29) || :adult_count || f_character(28) || :child_count;
  end

  select RD.ADULT_COUNT, RD.CHILD_COUNT
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_adult_count, :old_child_count;
  add_adult_count = 0;
  add_child_count = 0;
  del_adult_count = 0;
  del_child_count = 0;
  if (:old_adult_count < :adult_count) then add_adult_count = adult_count - :old_adult_count;
  else del_adult_count = :old_adult_count - :adult_count;
  if (:old_child_count < :child_count) then add_child_count = child_count - :old_child_count;
  else del_child_count = :old_child_count - :child_count;

  execute procedure RES_GUESTCOUNT_ADD$INT(:rd_dbkey, :add_adult_count, :add_child_count);

  execute procedure RES_GUESTCOUNT_DEL$INT(:rd_dbkey, :del_adult_count, :del_child_count);
end
^

/* Alter (RES_SAVE_GUESTCOUNT$RSV) */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select rd.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  rd.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SAVE_GUESTCOUNT$INT(:rd_dbkey, :adult_count, :child_count);

  execute procedure RES_SAVE_ACCOUNTS$INT (:rd_dbkey);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :warn_code;

end
^

/* empty dependent procedure body */
/* Clear: RES_EARLY_DEPARTURE_SET$RSV for: RES_SAVE_STAY$INT */
ALTER PROCEDURE RES_EARLY_DEPARTURE_SET$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND INTEGER)
 RETURNS(RECALC_MARKER_LIST VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_STAY$RSV for: RES_SAVE_STAY$INT */
ALTER PROCEDURE RES_SAVE_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_STAY$RSV for: RES_SAVE_STAY$INT */
ALTER PROCEDURE RES_SET_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_STAY_MODIFY$RSV for: RES_SAVE_STAY$INT */
ALTER PROCEDURE RESMULTI_STAY_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SAVE_STAY$INT) */
ALTER PROCEDURE RES_SAVE_STAY$INT(RD_DBKEY CHAR(8),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER)
 AS
declare variable day_keep_types integer;
  declare variable exp_date date;
  declare variable leaving_kind integer;
  declare variable old_arrival date;
  declare variable old_departure date;
  declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable old_comming_kind integer;
  declare variable old_leaving_kind integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_stay_changed integer;
begin
  -- TODO exp_date must become input parameter, because the user may change it! or add exp_scheme!

  select RD.FROM_DATE, RD.TO_DATE, RD.COMMING_KIND, RD.LEAVING_KIND, RD.ID_HOTEL,
         rd.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_arrival, :old_departure, :old_comming_kind, :old_leaving_kind, :id_hotel,
         :id_reserv_detail;

  if (:DEPARTURE_DATE <= :ARRIVAL_DATE) then exception BOOKING_EXCEPTION '-53';

  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :id_hotel)
  returning_values  :day_keep_types;

  exp_date = :arrival_date + :day_keep_types;
  leaving_kind = coalesce(:is_late_departure + 1, :old_leaving_kind);
  comming_kind = coalesce(:comming_kind, :old_comming_kind);
  /*
  if ((:arrival_date <> :old_arrival) or (:departure_date <> :old_departure)) then begin
    execute procedure RESERV_TRACK_CHANGES$INT (:RD_DBKEY);
  end
  */
  if ((:arrival_date <> :old_arrival)
      or (:departure_date <> :old_departure)
      or (:comming_kind <> :old_comming_kind)
      or (:leaving_kind <> :old_leaving_kind)) then is_stay_changed = 1;
  else is_stay_changed = 0;

  update RESERV_DETAIL RD
  set    RD.COMMING_KIND = :comming_kind,
         RD.LEAVING_KIND = :leaving_kind,
         RD.EXP_DATE = :exp_date,
         RD.FROM_DATE = :arrival_date,
         RD.TO_DATE = :departure_date,
         rd.ROOM_PRICE = iif(:is_stay_changed = 1, null, rd.ROOM_PRICE) -- force recalculation
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:is_stay_changed = 1) then begin
    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure RES_GUEST_SAVE_STAY$INT(:g_dbkey, :arrival_date, :departure_date, :id_hotel);
    end

    execute procedure RES_SET_EDIT_STATUS$INT (:RD_DBKEY, 'DATE_CHANGED');

    --Remove manual prices (if any) outer new period--/
    if (:old_arrival < :arrival_date) then
      delete from RESERV_CUSTOM_PRICE rcp
      where  rcp.id_reserv_detail = :id_reserv_detail
             and rcp.FOR_DATE < :arrival_date;

    if (:old_departure > :departure_date) then
      delete from RESERV_CUSTOM_PRICE rcp
      where  rcp.id_reserv_detail = :id_reserv_detail
             and RCP.FOR_DATE >= :departure_date;

    if (not exists (select * from RESERV_CUSTOM_PRICE rmp where rmp.id_reserv_detail = :id_reserv_detail)) then
        update RESERV_DETAIL set  has_different_price = 0 where id_reserv_detail = :id_reserv_detail;
    ----
  end

  if ((:old_arrival <> :arrival_date) or (:old_departure <> :departure_date) ) then begin
    action_text = f_character(29) || '{' || formatdate(:old_arrival, 'D;dd.mm.yyyy') || '-' || formatdate(:old_departure, 'D;dd.mm.yyyy') || '}'
                  || f_character(28) || '{' || formatdate(:arrival_date, 'D;dd.mm.yyyy') || '-' || formatdate(:departure_date, 'D;dd.mm.yyyy') || '}';
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MOD_PERIOD', :action_text);
  end
end
^

/* Alter (RES_SAVE_STAY$RSV) */
ALTER PROCEDURE RES_SAVE_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure sys_dbg('res RES_SAVE_STAY$RSV comming_kind = '||coalesce(:comming_kind, 'null'));
  execute procedure sys_dbg('res RES_SAVE_STAY$RSV is_late_departure = '||coalesce(:is_late_departure, 'null'));

  execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :departure_date, :is_late_departure, :comming_kind);

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
    returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;
    execute procedure sys_dbg('res RES_SAVE_STAY$RSV share_err_code = '||coalesce(:share_err_code, 'null'));
  end
  --
end
^

/* Alter (RES_SET_STAY$RSV) */
ALTER PROCEDURE RES_SET_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable is_late_departure integer;
  declare variable comming_kind integer;
begin
  select RD.COMMING_KIND, RD.LEAVING_KIND - 1, RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :comming_kind, :is_late_departure, :rd_dbkey;

  execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :departure_date, :is_late_departure, :comming_kind);

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

end
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SPLIT$RSV) */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
declare variable rd_dbkey_old char(8);
  declare variable rd_dbkey_new char(8);
  declare variable id_guest integer;
  declare variable warn_code integer;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;

  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable check_status integer;
  declare variable arrival_date date;
  declare variable departure_date date;
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable id_room_type integer;
  declare variable id_room integer;
  declare variable id_board integer;
  declare variable id_tariff integer;
  declare variable custom_price numeric(15,4);
  declare variable custom_currency char(3);
  declare variable voucher_num varchar(30);
  declare variable voucher_date date;
  declare variable voucher_text varchar(30);
  declare variable voucher2_num varchar(30);
  declare variable voucher2_date date;
  declare variable transfer_in_time time;
  declare variable transfer_in_note varchar(255);
  declare variable transfer_out_time time;
  declare variable transfer_out_note varchar(255);
  declare variable comming_kind integer;
  declare variable is_late_departure integer;
  declare variable is_vip integer;
  declare variable country_code varchar(20);
  declare variable code_first_food tfood_code;
  declare variable i_special_treatment varchar(255);
  declare variable id_nom_market_segment integer;
  declare variable id_nom_source_code integer;
  declare variable id_nom_channel_code integer;
  declare variable id_nom_hear_reason integer;
  declare variable id_nom_come_reason integer;
  declare variable id_agent_account integer;
  declare variable acc_routing varchar(50);
  declare variable id_person_payment integer;
  declare variable id_agent_payment integer;
  declare variable room_features blob sub_type 1 segment size 80;
  declare variable id_hk_plan integer;
  declare variable id_group integer;
  declare variable id_hotel integer;
  declare variable note varchar(2000);
  declare variable note_reminders varchar(50);
  declare variable guarantee_deposit numeric(15,4);
  declare variable guarantee_currency char(3);
  declare variable id_titular integer;
  declare variable id_profile_data integer;
  declare variable id_acc_template_person integer;
  declare variable number_1 varchar(20);
  declare variable number_2 varchar(20);
  declare variable new_res_number varchar(62);
  declare variable g_dbkey char(8);
  declare variable is_child integer;
  declare variable id_guarantee_policy integer;
  declare variable block_cc varchar(255);
  declare variable virtual_room varchar(10);
  declare variable err_text varchar(255);
  declare variable is_posting_stopped integer;
  declare variable id_eating_object integer;
begin
  select RD.RDB$DB_KEY, RD.ID_AGENT_PROFILE, RD.CHECK_STATUS, RD.FROM_DATE, RD.TO_DATE,
         RD.ADULT_COUNT, RD.CHILD_COUNT, RD.ID_ROOM_TYPE, RD.ID_ROOM, RD.ID_BOARD, RD.ID_RATE,
         RD.CUSTOM_PRICE, RD.CUSTOM_CURRENCY, RD.VAUCHER_NUM, RD.VAUCHER_DATE, RD.VAUCHER_TEXT, RD.VAUCHER_NUM2,
         RD.VAUCHER_DATE2, RD.TRANSFER_IN_TIME, RD.TRANSFER_IN_NOTE, RD.TRANSFER_OUT_TIME, RD.TRANSFER_OUT_NOTE,
         RD.COMMING_KIND, RD.LEAVING_KIND - 1, RD.IS_VIP, RD.COUNTRY, RD.CODE_FIRST_FOOD, RD.I_SPECIAL_TREATMENT,
         RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON,
         RD.ID_NOM_COME_REASON, RD.ID_AGENT_ACCOUNT_RULE, RD.ACC_ROUTING, RD.ID_PERSON_PAYMENT, RD.ID_AGENT_PAYMENT,
         RD.ROOM_FEATURES, RD.ID_HK_PLAN, RD.ID_GROUP, RD.ID_HOTEL, RD.NOTE, RD.NOTE_REMINDERS,
         RD.GUARANTEE_DEPOSIT, RD.GUARANTEE_CURRENCY, RD.ID_ACC_TEMPLATE_PERSON,
         RD.NUMBER_1, rd.NUMBER_2, rd.ID_GUARANTEE_POLICY, rd.BLOCK_CC, rd.IS_POSTING_STOPPED, rd.ID_EATING_OBJECT
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail_source
  into   :rd_dbkey_old, :id_agent_profile, :check_status, :arrival_date, :departure_date,
         :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff,
         :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
         :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
         :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
         :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
         :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
         :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
         :guarantee_deposit, :guarantee_currency, :id_acc_template_person,
         :number_1, :number_2,:id_guarantee_policy, :block_cc, :is_posting_stopped, :id_eating_object;

  select first 1 sp.ITEM
  from   SYSTEM_STRING_PARSER(:guest_ids, ',') sp
  into   :id_titular;

  select min(g.FROM_DATE), max(g.TO_DATE)
  from   GUEST G
  where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL_SOURCE
         and ','||:GUEST_IDS||',' containing ','||g.ID_GUEST||','
  into   :arrival_date, :departure_date;

  if (exists (select *
              from   RESERV_DETAIL RD
              where  RD.ID_TITULAR = :id_titular
                     and RD.ID_RESERV_DETAIL = :id_reserv_detail_source))
  then exception BOOKING_EXCEPTION 'Titular can not be splited in new reservation';

  execute procedure RES_GET_PERSON_PROFILE$INT(:id_titular)
  returning_values  :id_person_profile, :id_profile_data;

  new_res_number = iif(coalesce(:number_1,'')='','.',:number_1||'.')
                   || coalesce(:number_2, '')
                   || '.0';  -- fictive suffix, needed for unique constraint limitation, that will be replaced with real one


  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    0, 0, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, 0, null, :new_res_number, :id_acc_template_person,
                    :id_guarantee_policy, :block_cc, :id_eating_object)
  returning_values  :rd_dbkey_new, :new_id_reserv_detail, :warn_code;

  execute procedure RES_NUMBER_SUFFIX_GEN (:NEW_ID_RESERV_DETAIL)
  returning_values  (:new_res_number);  -- add suffix to new (splited) booking number (empty on create)

  update RESERV_DETAIL NR
  set    nr.IS_POSTING_STOPPED = :is_posting_stopped
  where  nr.RDB$DB_KEY = :rd_dbkey_new;

  -- there is no need guests deleting, because new splited reservation is created with 0 guests
  adult_count = 0; child_count = 0;
  for
    select G.ID_GUEST, G.RDB$DB_KEY, G.IS_CHILD
    from   SYSTEM_STRING_PARSER(:guest_ids, ',') SP
           join GUEST G on G.ID_GUEST = SP.ITEM
    into   :id_guest, :g_dbkey, :is_child
  do begin
    execute procedure GUEST_SET_EDIT_STATUS$INT (:g_dbkey, 'REBUILD', 'add');

    update GUEST G
    set    G.ID_RESERV_DETAIL = :new_id_reserv_detail
    where  G.ID_GUEST = :id_guest;

    adult_count = :adult_count + (1-:is_child);
    child_count = :child_count + :is_child;

    if (:id_guest = :id_titular) then begin
      update RESERV_DETAIL RD
      set    RD.ID_TITULAR = :id_titular
      where  RD.RDB$DB_KEY = :rd_dbkey_new;

      update GUEST_DATA GD
      set    GD.ID_PERSON_DATA = :id_profile_data
      where  GD.ID_GUEST = :id_titular;
    end
  end

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL_SOURCE, 'RES_SPLIT',
          f_character(29) || :new_res_number || f_character(28) || :adult_count || ' + ' || :child_count);

  -- calling RES_SAVE_PROFILING$INT is unnecessary, it is called into RES_CREATE_SET$INT with same params
  -- here is needed to set reserv accounts per splited guests and reroute posting only (accomplished in next procedure)
  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey_new);

  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_old);
  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_new);

  update RESERV_DETAIL ORD
  set    ord.ROOM_PRICE = null
  where  ord.RDB$DB_KEY = :rd_dbkey_old;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_old, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_new, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  if (:id_room < 0) then begin
    virtual_room = gen_id(GEN_VIRTUAL_ROOM, 1);
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = '<'||:virtual_room||'>'
    where  rd.ID_ROOM = :id_room;
  end
end
^

/* Alter (RES_SPLIT_MULTI$RSV) */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
begin
  for
    select RD.ID_RESERV_DETAIL, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_titular
  do begin
    for
      select G.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.ID_GUEST <> :id_titular
      into   :id_guest
    do begin
      execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
      returning_values  :id_splited_reservation;

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
    end
  end
end
^

/* Alter (RES_TAKE_POSTING_RESPONSIBILITY) */
ALTER PROCEDURE RES_TAKE_POSTING_RESPONSIBILITY(ID_RESERV_DETAIL ID)
 AS
declare variable is_posting_stopped tboolean;
  declare variable old_posting_transaction_uuid uuid;
  declare variable new_posting_transaction_uuid uuid;
begin
  update RESERV_DETAIL RD
  set    rd.POSTING_TRANSACTION_UUID = iif(rd.POSTING_TRANSACTION_UUID is null, uuid_create(), rd.POSTING_TRANSACTION_UUID)
  where  rd.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  returning old.IS_POSTING_STOPPED, old.POSTING_TRANSACTION_UUID, new.POSTING_TRANSACTION_UUID
  into   :is_posting_stopped, :old_posting_transaction_uuid, :new_posting_transaction_uuid;

  if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION 'Can not get posting responsibility! (is_posting_stopped = 1)';

  if (:new_posting_transaction_uuid is distinct from :old_posting_transaction_uuid) then begin
    -- executing once - on real responsibility taking, when posting_transaction_uuid is generated
    execute procedure RES_PENDING_DEPOSITS_POST$INT (:ID_RESERV_DETAIL);
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_FINALIZE$INT for: RES_TAR_CALC_REPOST$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(ID_TAR_CALC INTEGER,
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_TAR_CALC_REPOST$INT) */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC TYPE OF ID_REF,
ID_RESERV_DETAIL TYPE OF ID_REF,
RECALC_MARKER VARCHAR(40))
 AS
declare variable id_guest type of id_ref;
  declare variable id_service type of id_ref;
  declare variable id_tariff type of id_ref;
  declare variable date_post type of tdate;
  declare variable qty_post type of tqty;
  declare variable price_orig type of tprice;
  declare variable curr_orig type of tcurrency;
  declare variable id_room type of id_ref;
  declare variable is_base type of tlogical;
  declare variable short_code type of tdescription_long;
  declare variable id_account type of id_ref;
  declare variable gfrom_date type of tdate;
  declare variable gto_date type of tdate;
  declare variable ap_db_key char(8);
  declare variable id_pack_service type of id_ref;
  declare variable err_code type of id_ref;
  declare variable err_text type of tdescription_long;
  declare variable id_master_account_post type of id_ref;
  declare variable id_acc_post type of id_ref;
  declare variable is_base_account type of id_ref;
  declare variable id_extra_account type of id_ref;
  declare variable no_use varchar(255);
begin
  for
    select   TCP.ID_GUEST, TCP.ID_SERVICE, TCP.ID_TARIFF, TCP.DATE_POST, TCP.QTY_POST,
             round_f(TCP.PRICE_ORIG, c.ROUND_TO), TCP.CURR_ORIG, TCP.ID_ROOM, TCP.IS_BASE,
             TCP.SHORT_CODE, iif(coalesce(AGP.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'NONE', 0, 1),
             G.ID_BASE_ACCOUNT, G.FROM_DATE, G.TO_DATE, G.ID_ACCOUNT
    from     TAR_CALC_POST$TMP TCP
             join GUEST G on G.ID_GUEST = TCP.ID_GUEST
             join SERVICES S on S.ID_SERVICE = TCP.ID_SERVICE
             join CURRS c on c.CURR = tcp.CURR_ORIG
             left outer join AGENT_PACKET AGP on AGP.ID_SERVICE = S.ID_SERVICE and AGP.ID_AGENT = G.ID_AGENT
    where    TCP.ID_TAR_CALC = :id_tar_calc
             and tcp.ID_RESERV = :ID_RESERV_DETAIL
                  --or (coalesce(RD.IS_POSTING_STOPPED, 0) = 0 and RD.POSTING_TRANSACTION_UUID is not null))
    order by TCP.ID_GUEST asc, TCP.DATE_POST asc, TCP.IS_BASE desc
    into     :id_guest, :id_service, :id_tariff, :date_post, :qty_post,
             :price_orig, :curr_orig, :id_room, :is_base, :short_code, :is_base_account,
             :id_account, :gfrom_date, :gto_date, :id_extra_account
  do begin
    ap_db_key = null;
    if (:is_base = 1) then begin
      select AP.RDB$DB_KEY, AP.ID_MASTER_ADDINS_ACC_POST, AP.ID_PACK_SERVICE
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.DATE_POST = :date_post
             and AP.IS_BASE = 1
      into   :ap_db_key, :id_master_account_post, :id_pack_service;

      --execute procedure sys_dbg('tar TAR_CALC_REPOST$INT price_orig = '||coalesce(:price_orig, 'null'));
      --execute procedure sys_dbg('tar TAR_CALC_REPOST$INT ap_db_key = '||coalesce(:ap_db_key, 'null'));

      if (:ap_db_key is null) then begin
        id_master_account_post = -1;
        execute procedure GUEST_POST_GET_PACK_SERVICE(:id_service, :id_guest, :date_post)
        returning_values  :id_pack_service;
      end
    end else begin
      -- short_code = '';
      select first 1 APU.rdb$db_key
      from   ACCOUNT_POST APU
      where  APU.ID_MASTER_ADDINS_ACC_POST = :id_master_account_post
             and APU.ID_SERVICE = :id_service
             and APU.CHANGED_TEXT is distinct from :recalc_marker
      order by apu.IS_ANUL asc, apu.ID_ACCOUNT_POST asc
      into   :ap_db_key;

      if ((:is_base_account <> 1)) then id_account = :id_extra_account;
    end

    if (:ap_db_key is null) then begin
      execute procedure ACCOUNT_POSTING_ADD$INT(
        :id_account, :id_guest, -1, :date_post, :id_service, :id_tariff, :id_room, :is_base, :qty_post,
        :price_orig, :curr_orig, null, :short_code, :gfrom_date, :gto_date, 'PACK='||:id_pack_service, '',
        :recalc_marker, :id_master_account_post)
      returning_values  :err_code, :err_text, :id_acc_post;
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

      if (:is_base = 1) then id_master_account_post = :id_acc_post;

    end else begin
      execute procedure ACCOUNT_POSTING_UPDATE$INT(
        :ap_db_key, :id_service, :id_tariff, :id_room, :qty_post, 0, :price_orig, :curr_orig, null,
        :recalc_marker, :short_code, :gfrom_date, :gto_date, 1, :id_account)
      returning_values  :no_use, :no_use, :no_use;
    end

  end

  ap_db_key = null;
  id_guest = null;
  for
    select distinct TCP.ID_GUEST
    from   TAR_CALC_POST$TMP TCP
    where  tcp.ID_TAR_CALC = :ID_TAR_CALC
           and tcp.ID_RESERV = :ID_RESERV_DETAIL
    into   :id_guest
  do begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.CHANGED_TEXT is distinct from :recalc_marker
             and AP.ID_MASTER_ADDINS_ACC_POST > 0
             and AP.IS_ANUL = 0
      into   :ap_db_key
    do begin
      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_db_key, :recalc_marker);
    end
  end

  delete from RESERV_PREPOST RP where RP.ID_RESERV_DETAIL = :id_reserv_detail;
  execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:ID_RESERV_DETAIL);
end
^

/* Alter (RES_TRANSFER_FINALIZE$RSV) */
ALTER PROCEDURE RES_TRANSFER_FINALIZE$RSV(ID_RESERV_DETAIL_NEW INTEGER,
ID_RESERV_DETAIL_OLD INTEGER)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
begin
  execute procedure RES_ANUL_DETAIL$RSV(:id_reserv_detail_old, 'TRANSFER')
  returning_values  :WARN_CODE, :EXTRA_POSTS_LEFT;
end
^

/* Alter (RESERV_POSTING_SELECT$DOC) */
ALTER PROCEDURE RESERV_POSTING_SELECT$DOC(ID_RESERV_DETAIL INTEGER,
IN_DOC_SELECTED INTEGER)
 RETURNS(OUT_DOC_SELECTED INTEGER)
 AS
declare variable id_account integer;
begin
  OUT_DOC_SELECTED = :IN_DOC_SELECTED;

  for
    select RA.ID_ACCOUNT
    from   RES_GET_ACCOUNTS (:ID_RESERV_DETAIL, 'PAYABLE') RA
    into   :id_account
  do begin
    execute procedure ACCOUNT_POSTING_SELECT$DOC (:id_account, :OUT_DOC_SELECTED)
    returning_values  (:OUT_DOC_SELECTED);
     
  end
end
^

/* empty dependent procedure body */
/* Clear: RESERV_STATISTIC_CANCELED$INT for: RESERV_STATISTIC_SLICE$INT */
ALTER PROCEDURE RESERV_STATISTIC_CANCELED$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(BUSY_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_PROFILE_AGENT INTEGER,
COUNTRY_CODE VARCHAR(20),
MARKET_SEGMENT_CODE VARCHAR(3),
SOURCE_CODE VARCHAR(3),
CHANNEL_CODE VARCHAR(3),
HEAR_REASON_CODE VARCHAR(3),
COME_REASON_CODE VARCHAR(3),
ROOMS_NOSHOW SMALLINT,
GUESTS_NOSHOW SMALLINT,
ROOMS_CANCELED SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RESERV_STATISTIC_SLICE$INT) */
ALTER PROCEDURE RESERV_STATISTIC_SLICE$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_PROFILE_AGENT INTEGER,
COUNTRY_CODE VARCHAR(20),
MARKET_SEGMENT_CODE VARCHAR(3),
SOURCE_CODE VARCHAR(3),
CHANNEL_CODE VARCHAR(3),
HEAR_REASON_CODE VARCHAR(3),
COME_REASON_CODE VARCHAR(3))
 AS
begin
  select iif(PA.ID_AGENT > 0, PA.ID_PROFILE, null), GC.COUNTRY,
         MS.MARKET_CODE, SC.SOURCE_CODE, CC.CHANNEL_CODE, HR.HEAR_REASON_CODE, CR.COME_REASON_CODE
  from   RESERV_DETAIL RD
         left outer join GUEST_CARD GC on GC.ID_GUEST = RD.ID_TITULAR
         left outer join PROFILE_AGENT PA on PA.ID_PROFILE = RD.ID_AGENT_PROFILE
         left outer join NOM_CHANNEL_CODES CC on CC.ID_NOM_CHANNEL_CODE = RD.ID_NOM_CHANNEL_CODE
         left outer join NOM_COME_REASONS CR on CR.ID_NOM_COME_REASON = RD.ID_NOM_COME_REASON
         left outer join NOM_HEAR_REASONS HR on HR.ID_NOM_HEAR_REASON = RD.ID_NOM_HEAR_REASON
         left outer join NOM_SOURCE_CODES SC on SC.ID_NOM_SOURCE_CODE = RD.ID_NOM_SOURCE_CODE
         left outer join NOM_MARKET_SEGMENTS MS on MS.ID_NOM_MARKET_SEGMENT = RD.ID_NOM_MARKET_SEGMENT
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :ID_PROFILE_AGENT, :COUNTRY_CODE,
         :MARKET_SEGMENT_CODE, :SOURCE_CODE, :CHANNEL_CODE, :HEAR_REASON_CODE, :COME_REASON_CODE;

  COUNTRY_CODE = coalesce(:COUNTRY_CODE, '');

  suspend;
end
^

/* empty dependent procedure body */
/* Clear: END_WORK for: RESERVS_EXPIRE$INT */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RESERVS_EXPIRE$INT) */
ALTER PROCEDURE RESERVS_EXPIRE$INT(CLEAR_TODATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable day_keep_number integer;
  declare variable rd_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable nouse integer;
  declare variable day_keep_types integer;
begin
  /*AA NA IONEA I?AAE I?EEE??AAIA -BF END WORK-*/
  execute procedure SETTING_GET_VALUE('DAY_KEEP_NUMBERS', :ID_HOTEL)
  returning_values  :day_keep_number;
  /*************************************************************/
  /*    REMOVE ROOM NUMBERS FROM EXPIRED RESERV DETAILS        */
  /*************************************************************/
  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.IS_ANUL = 0
           and RD.CHECK_STATUS < 0
           and RD.IS_VIP = 0
           and RD.ID_ROOM > 0
           and (RD.FROM_DATE <=  cast(:clear_todate - :day_keep_number as date))
    into   :rd_dbkey, :id_reserv_detail
  do begin
    execute procedure RES_ROOM_REMOVE$INT(:rd_dbkey)
    returning_values  :nouse;

    when any do begin
      -- nothing
    end
  end
  /*************************************************************/
  /*    EXPIRED NON VIP or VIP TYPES                           */
  /*************************************************************/
  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :ID_HOTEL)
  returning_values  :day_keep_types;

  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.CHECK_STATUS < 0
           and RD.IS_ANUL = 0
           and RD.FROM_DATE <= cast(:clear_todate - :day_keep_types as date)
           and RD.IS_VIP = 0
    union
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.CHECK_STATUS < 0
           and RD.IS_ANUL = 0
           and RD.TO_DATE < :clear_todate
           and RD.IS_VIP = 1
    into   :rd_dbkey, :id_reserv_detail
  do begin
    execute procedure sys_dbg('res RESERVS_EXPIRE: id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

    execute procedure RES_ANUL_NOSHOW$INT(:rd_dbkey)
    returning_values  :nouse;

    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_NOSHOW', '');

    when any do begin
      -- nothing
    end
  end
end
^

/* Alter (RESGRP_DELETE$RSV) */
ALTER PROCEDURE RESGRP_DELETE$RSV(ID_GROUP INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable id_reserv_detail integer;
  declare variable tmp_warn_code integer;
begin

  for
    select RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
           left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = rd.ID_ROOM_TYPE
    where  RD.ID_GROUP = :id_group
    into   :id_reserv_detail
  do begin
    execute procedure RES_DELETE$INT(:id_reserv_detail, :REASON)
    returning_values :tmp_warn_code, :extra_posts_left;
    if (:warn_code is null) then WARN_CODE = :tmp_warn_code;
  end
end
^

/* Alter (RESGRP_GET_INFO$RSV) */
ALTER PROCEDURE RESGRP_GET_INFO$RSV(ID_INFO_GROUP INTEGER)
 RETURNS(AGENT_PROFILE_NAME VARCHAR(100),
ARRIVALS VARCHAR(255),
DEPARTURES VARCHAR(255),
ROOM_DATA VARCHAR(255),
ROOMS VARCHAR(255),
ID_ROOM INTEGER,
GUESTS VARCHAR(255),
PERSON_PROFILE_NAME VARCHAR(100),
RATES VARCHAR(255),
BOARDS VARCHAR(255),
PACKETS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY VARCHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
BALANCE VARCHAR(255),
OPEN_CHARGES INTEGER,
CHECK_STATUS VARCHAR(255),
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
NOTE VARCHAR(2000),
NOTE_GRP VARCHAR(255),
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
FIRST_ARRIVAL DATE,
FIRST_DEPARTURE DATE,
HOTELS VARCHAR(255),
ID_HOTEL INTEGER,
ACC_ROUTING VARCHAR(255),
RES_NUMBER VARCHAR(62))
 AS
declare variable arrival date;
  declare variable departure date;
  declare variable room varchar(10);
  declare variable type_room varchar(20);
  declare variable stay_length varchar(60);
  declare variable id_reserv_detail integer;
  declare variable no_use varchar(255);
  declare variable rd_adult_count integer;
  declare variable rd_child_count integer;
  declare variable is_group integer;
  declare variable current_arrival varchar(60);
  declare variable current_departure varchar(60);
  declare variable nights varchar(255);
  declare variable roomcount integer;
  declare variable adultcount integer;
  declare variable childrencount integer;
  declare variable groupname varchar(100);
  declare variable rd_check_status integer;
  declare variable is_anul_detail integer;
  declare variable reason_of_anul varchar(100);
  declare variable hotel_code varchar(10);
  declare variable current_acc_routing varchar(255);
begin
  arrivals = '';
  departures = '';
  rooms = '';
  nights = '';
  rates = '';
  hotels = '';
  roomcount = 0;
  adultcount = 0;
  childrencount = 0;
  check_status = '';
  acc_routing = '';
  arrival = null;
  first_arrival = null;
  first_departure = null;

  ATTENTION_STATUS = null;  -- OUT of use ?!
  NOTE_GRP = null;

  for
    select RD.FROM_DATE, RD.ADULT_COUNT, RD.CHILD_COUNT, R.ROOM_NAME, RT.TYPE_ROOM,
           cast(RD.TO_DATE - RD.FROM_DATE as integer), RD.CHECK_STATUS, PP.PROFILE_NAME,
           RD.ROOM_PRICE, RD.ROOM_CURRENCY, RD.ROOM_PRICE_DETAILS, RD.ID_RESERV_DETAIL,
           RD.TO_DATE, R.ID_ROOM, RD.IS_ANUL, RD.REASON_OF_ANUL, RD.NOTE, H.CODE,
           RD.NUMBER, RD.ACC_ROUTING,
           AP.PROFILE_NAME, RG.GROUP_NAME, RD.ID_HOTEL, iif(RD.ID_GROUP is not null, 1, 0)
    from   RESERV_GROUP RG
           join HOTEL H on H.ID_HOTEL = RG.ID_HOTEL
           left outer join RESERV_DETAIL RD on RG.ID_RESERV_GROUP = RD.ID_GROUP and RD.IS_ANUL = 0
           left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
           left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = coalesce(R.ID_ROOM_TYPE, RD.ID_ROOM_TYPE)
           left outer join PROFILE PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
           left outer join PROFILE AP on AP.ID_PROFILE = RD.ID_AGENT_PROFILE
    where  RG.ID_RESERV_GROUP = :id_info_group
    order by RD.FROM_DATE asc
    into   :arrival, :rd_adult_count, :rd_child_count, :room, :type_room,
           :stay_length, :rd_check_status, :person_profile_name,
           :room_price, :room_currency, :room_price_details, :id_reserv_detail,
           :departure, :id_room, :is_anul_detail, :reason_of_anul, :note, :hotel_code,
           :res_number, :current_acc_routing,
           :agent_profile_name, :groupname, :id_hotel, :is_group
  do begin
    if (:first_arrival is null) then first_arrival = :arrival;
    if (:first_departure is null) then first_departure = :departure;

    if (:arrival is not null) then begin
      if (extract(year from current_date) = extract(year from :arrival)) then
        current_arrival = formatDate(:arrival, 'D;dd.mm');
      else
        current_arrival = formatDate(:arrival, 'D;dd.mm.yy');
  
      if (:arrivals not containing :current_arrival) then begin
        nights = :stay_length;
        if (:arrivals = '') then arrivals = :current_arrival||' ('||:stay_length;
        else if (char_length(:arrivals) < 100) then arrivals = :arrivals||')  '||:current_arrival||' ('||:stay_length;
      end else begin
        if (:nights not containing :stay_length) then begin
          nights = :nights ||','||:stay_length;
          arrivals = :arrivals||','||:stay_length;
        end
      end
    end

    if (:departure is not null) then begin
      if (extract(year from current_date) = extract(year from :departure)) then
        current_departure = formatDate(:departure, 'D;dd.mm');
      else
        current_departure = formatDate(:departure, 'D;dd.mm.yy');
  
      if (:departures not containing :current_departure) then begin
        if (:departures = '') then departures = :current_departure;
        else if (char_length(:departures) < 100) then departures = :departures||'  '||:current_departure;
      end
    end

    if (:acc_routing not containing :current_acc_routing) then begin
      if (:acc_routing = '') then acc_routing = :current_acc_routing;
      else if (char_length(:acc_routing) < 100) then acc_routing = :acc_routing||'  '||:current_acc_routing;
    end

    if (:check_status not containing :rd_check_status) then begin
      if (:check_status = '') then check_status = :rd_check_status;
      else check_status = :check_status||', '||:rd_check_status;
    end

    if (:hotels not containing :hotel_code) then begin
      if (:hotels = '') then hotels = :hotel_code;
      else hotels = :hotels||','||:hotel_code;
    end

    if (:is_group is distinct from 1) then begin
      if (:room is null) then room_data = :type_room;
      else room_data = :room || ' / ' || :type_room;
    end

    if (:is_group = 1) then begin
      in_share = null;
      balance = '-';
      res_number = '';
    end else begin
      execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'RENDER', null)
      returning_values  :in_share, :no_use, :shares_preview;

      execute procedure RES_GET_BALLANCE$INT(:id_reserv_detail)
      returning_values  :balance, :no_use, :no_use, :open_charges, :no_use;
    end
    adultcount = :adultcount + :rd_adult_count;
    childrencount = :childrencount + :rd_child_count;
  end
  if (coalesce(:groupname, '') <> '') then agent_profile_name = substring(coalesce(:agent_profile_name, ' ') || ' / ' || :groupname from 1 for 100);
  if (:is_group = 1) then person_profile_name = '';
  if (:arrivals <> '') then arrivals = :arrivals||')';
  guests = :adultcount || ' + ' || :childrencount || ' ';

  if (:arrivals <> '') then begin
    if (:is_group = 1) then begin
      note = '';
      room_data = '';
      for
        select RT.TYPE_ROOM, count(*)
        from   RESERV_DETAIL RD
               left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
               join ROOM_TYPES RT on RT.ID_ROOM_TYPE = coalesce(R.ID_ROOM_TYPE, RD.ID_ROOM_TYPE)
        where  RD.ID_GROUP = :id_info_group
               and RD.IS_ANUL = 0
        group by 1
        into   :type_room, :roomcount
      do begin
        if (:room_data = '') then room_data = :roomcount ||'x '||:type_room;
        else room_data = room_data ||', '|| :roomcount ||'x '||:type_room;
      end
    end
/*
    execute procedure RES_GET_ATTENTION_STATUS$INT(:arrival, :departure, :rd_check_status)
    returning_values  :attention_status;
*/
    execute procedure RES_GET_GUEST_DATA$INT('GROUP', :id_info_group)
    returning_values  :boards, :rates, :packets, :no_use;
  
    annul_status = :is_anul_detail;
    if (:reason_of_anul = 'EXPIRE') then annul_status = 2;
  end

  if (char_length(:arrivals) >= 100) then arrivals = :arrivals||'...';
  if (char_length(:departures) >= 100) then departures = :departures||'...';
  suspend;
end
^

/* Alter (RESMULTI_COMMON_MODIFY$RSV) */
ALTER PROCEDURE RESMULTI_COMMON_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
CHECK_STATUS SMALLINT,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
NOTE VARCHAR(2000),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(30),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
NOTE_REMINDERS VARCHAR(50),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(WARN_CODE TYPE OF TRANGE)
 AS
declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable old_id_room_type integer;
  declare variable old_status integer;
begin
  select RD.RDB$DB_KEY, RD.ID_ROOM, RD.ID_ROOM_TYPE, rd.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_id_room, :old_id_room_type, :old_status;

  execute procedure RES_SAVE_GUESTCOUNT$INT(:rd_dbkey, :adult_count, :children_count);

  execute procedure RES_SAVE_NOTE$RSV(:id_reserv_detail, :note, null);

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_room_type, 'nrttAsIs')
  returning_values (:WARN_CODE);

  execute procedure RES_SAVE_ROOM_LOG$INT(:rd_dbkey, :old_id_room, :old_id_room_type);

  execute procedure RES_SAVE_ACCOUNTING$INT(:rd_dbkey, :id_agent_profile, :id_agent_account, :acc_routing,
                    :id_person_payment, :id_agent_payment, :id_group);

  update RESERV_DETAIL RD
  set    RD.CUSTOM_PRICE = :CUSTOM_PRICE,
         RD.CUSTOM_CURRENCY = :CUSTOM_CURRENCY,
         RD.SPLIT_ON_CHECKIN = :SPLIT_ON_CHECKIN,
         RD.NOTE_REMINDERS = :NOTE_REMINDERS,
         rd.ID_HK_PLAN = :ID_HK_PLAN
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_status <> :CHECK_STATUS) then begin
    if (:CHECK_STATUS >= 0) then exception BOOKING_EXCEPTION 'Can not set status ''CHECKED IN'' or ''CHECKED OUT'' manually!';
  
    execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, :check_status);
  end
  --
end
^

/* Alter (RESMULTI_CREATE$RSV) */
ALTER PROCEDURE RESMULTI_CREATE$RSV(ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
TRANSFER_OUT_TIME TIME,
TRANSFER_IN_TIME TIME,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
TRANSFER_OUT_NOTE VARCHAR(50),
TRANSFER_IN_NOTE VARCHAR(50),
NOTE VARCHAR(255),
ID_BOARD INTEGER,
VOUCHER_DATE DATE,
VOUCHER_NUMBER VARCHAR(20),
VOUCHER_TEXT VARCHAR(30),
CHECK_STATUS INTEGER,
ID_TARIFF INTEGER,
COUNTRY_CODE VARCHAR(20),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
NOTE_REMINDERS VARCHAR(50),
TITULAR_NAME VARCHAR(100),
SPLIT_ON_CHECKIN INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
NUMBER VARCHAR(62),
NEW_ID_TITULAR INTEGER,
NEW_FROM_DATE TYPE OF TDATE,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable rd_dbkey char(8);
  declare variable id_person_profile integer;
  declare variable pd_dbkey char(8);
  declare variable id_acc_template_person integer;
begin

  select sv.SETTING_VALUE
  from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :ID_HOTEL) sv
  into   :id_acc_template_person;

  execute procedure RES_CREATE_SET$INT(:id_agent_profile, null, :check_status, :arrival_date, :departure_date,
                    :adult_count, :children_count, :id_room_type, null, :id_board, :id_tariff, null,
                    null, null, :voucher_number, :voucher_date, :voucher_text, '',
                    null, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    1, 0, 0, :country_code, :code_first_food, '',
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    '', :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders, null, null,
                    :split_on_checkin, null, null, :id_acc_template_person, null, null, :ID_EATING_OBJECT)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :WARN_CODE;

  select RD.NUMBER, RD.ID_PERSON_PROFILE, RD.ID_TITULAR
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :number, :id_person_profile, :new_id_titular;

  if (:titular_name <> '') then begin
    select PD.RDB$DB_KEY
    from   PROFILE P
           join PROFILE_PERSON PP on PP.ID_PROFILE = P.ID_PROFILE
           join PERSON_DATA PD on PD.ID_PERSON_DATA = PP.ID_PERSON_DATA
    where  P.ID_PROFILE = :id_person_profile
    into   :pd_dbkey;

    update PERSON_DATA PD
    set    PD.PERSON_NAME = :titular_name,
           PD.PERSON_NAME2 = :titular_name
    where  PD.RDB$DB_KEY = :pd_dbkey;
  end

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;
end
^

/* Alter (RESMULTI_LOAD$RSV) */
ALTER PROCEDURE RESMULTI_LOAD$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(CHECK_STATUS INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
IS_DIFFERENT_BOARD SMALLINT,
BOARDS VARCHAR(255),
IS_DIFFERENT_VOUCHER SMALLINT,
VOUCHERS VARCHAR(255),
IS_DIFFERENT_TRANSFER_IN_TIME SMALLINT,
TRANSFER_IN_TIMES VARCHAR(255),
IS_DIFFERENT_TRANSFER_OUT_TIME SMALLINT,
TRANSFER_OUT_TIMES VARCHAR(255),
IS_DIFFERENT_TRANSFER_IN_NOTE SMALLINT,
TRANSFER_IN_NOTES VARCHAR(500),
IS_DIFFERENT_TRANSFER_OUT_NOTE SMALLINT,
TRANSFER_OUT_NOTES VARCHAR(500))
 AS
declare variable is_different_other integer;
  declare variable rd_dbkey char(8);
  declare variable rates varchar(255);
  declare variable packets varchar(255);
  declare variable arrival date;
  declare variable departure date;
  declare variable id_hotel integer;
begin
  select RD.RDB$DB_KEY, RD.FROM_DATE, RD.TO_DATE, RD.CHECK_STATUS, RD.ID_HOTEL,
         RD.HAS_DIFFERENT_BOARD, RD.HAS_DIFFERENT_VOUCHERS, RD.HAS_DIFFERENT_OTHER
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :arrival, :departure, :check_status, :id_hotel,
         :is_different_board, :is_different_voucher, :is_different_other;

  is_different_transfer_in_time = :is_different_other;
  is_different_transfer_out_time = :is_different_other;
  is_different_transfer_in_note = :is_different_other;
  is_different_transfer_out_note = :is_different_other;

  execute procedure RES_GET_GUEST_DATA$INT('DETAIL', :id_reserv_detail)
  returning_values  :boards, :rates, :packets, :vouchers;

  execute procedure RES_GET_ANNULSTATUS(:rd_dbkey)
  returning_values  :annul_status;

  execute procedure RES_GET_ATTENTION_STATUS$INT(:arrival, :departure, :check_status, :id_hotel)
  returning_values  :attention_status;

  execute procedure RES_GET_GUEST_TRANSFERS$INT(:id_reserv_detail)
  returning_values  :transfer_in_times, :transfer_out_times, :transfer_in_notes, :transfer_out_notes;

  suspend;
end
^

/* Alter (RESMULTI_MODIFY_BOARD$RSV) */
ALTER PROCEDURE RESMULTI_MODIFY_BOARD$RSV(ID_RESERV_DETAIL INTEGER,
ID_BOARD INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_SAVE_BOARD$INT(:rd_dbkey, :id_board);
end
^

/* Alter (RESMULTI_STAY_MODIFY$RSV) */
ALTER PROCEDURE RESMULTI_STAY_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 AS
declare variable rd_dbkey char(8);
  declare variable is_late_departure integer;
  declare variable comming_kind integer;
begin

  select RD.RDB$DB_KEY, RD.COMMING_KIND, RD.LEAVING_KIND - 1
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :comming_kind, :is_late_departure;

  execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :departure_date, :is_late_departure, :comming_kind);
end
^

/* Alter (RESOURCE_RESERVATION_CHECK_IN) */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
declare variable old_status varchar(20);
  declare variable new_status varchar(20);
  declare variable dbkey char(8);
  declare variable id_service id_ref;
  declare variable price_post tprice;
  declare variable curr_post TCURRENCY;
  declare variable is_manual_price TLOGICAL;
  declare variable is_details tlogical;
  declare variable post_description tobject_text;
  declare variable id_reserv_detail integer;
  declare variable post_date tdate;
  declare variable from_datetime tdatetime;
  declare variable to_datetime tdatetime;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  new_status = 'CHECKED_IN';

  select r.RDB$DB_KEY, R.STATUS, rd.ID_RESERV_DETAIL
  from   RESOURCE_RESERVATION R
         left outer join RESERV_DETAIL rd on rd.NUMBER = r.BOOKING_NUMBER
                                             and rd.IS_ANUL = 0
                                             and rd.SUBSCRIBER_ID is not distinct from r.SUBSCRIBER_ID
  where  R.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
  into   :dbkey, :old_status, :id_reserv_detail;

  if (:old_status = :NEW_STATUS) then exit;
 
  if (:old_status is distinct from 'RESERVED') then exception ASSERT '-511';

  if (exists (select RP.ID_RESOURCE_RESERVATION
              from   RESOURCE_RESERV_POST RP
                     join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = RP.ID_ACCOUNNT_POST
              where  RP.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION)) then
  begin
    exception ASSERT '-505';
  end

  if (:id_reserv_detail is not null) then begin
    execute procedure RESOURCE_RESERV_SERVICE_GET (:ID_RESOURCE_RESERVATION)
    returning_values (:id_service, :price_post, :curr_post, :is_manual_price, :is_details, :post_description,
                     :post_date, :from_datetime, :to_datetime);
  
    if (:is_manual_price = 1) then begin
      price_post = :SERVICE_PRICE;
      curr_post = :SERVICE_CURR;
    end

    if (:price_post is null) then exception ASSERT 'Unspecified service price!';
    if (:curr_post is null) then exception ASSERT 'Unspecified price currency!';
  
    execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
            1, :price_post, :curr_post, :from_datetime, :to_datetime,
            '', '', :post_date, 'RESOURCE', :post_description)
    returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT, :OUT_ID_ACCOUNT_POST);
    if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
  
    insert into RESOURCE_RESERV_POST(ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:ID_RESOURCE_RESERVATION, :OUT_ID_ACCOUNT_POST);
  end

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = :NEW_STATUS
  where  RR.RDB$DB_KEY = :dbkey;

end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_ANUL$INT for: RIGHTS_CHECK_GRANTED$INT */
ALTER PROCEDURE ACCOUNT_POSTING_ANUL$INT(AP_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
ANUL_REASON /* TYPE OF TREASON */ VARCHAR(50))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$ACC for: RIGHTS_CHECK_GRANTED$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_SET_CREDIT_STATUS$INT for: RIGHTS_CHECK_GRANTED$INT */
ALTER PROCEDURE ACCOUNT_SET_CREDIT_STATUS$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
IS_CREDIT_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
CREDIT_LIMIT /* TYPE OF TPRICE */ NUMERIC(15,4),
SET_UNCONDITIONAL /* TYPE OF TLOGICAL */ SMALLINT = 0)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_ANUL$DOC for: RIGHTS_CHECK_GRANTED$INT */
ALTER PROCEDURE DEPOSIT_ANUL$DOC(ID_DEPOSIT INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_PAYMENT_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_TRANSFER$ACC for: RIGHTS_CHECK_GRANTED$INT */
ALTER PROCEDURE DEPOSIT_TRANSFER$ACC(ID_DEPOSIT INTEGER,
ID_DEST_ACCOUNT INTEGER,
SPLIT_AMOUNT NUMERIC(15,2),
DESCRIPTION VARCHAR(255))
 RETURNS(NEW_ID_DEPOSIT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: GUEST_SET_MANUAL_STAY$INT for: RIGHTS_CHECK_GRANTED$INT */
ALTER PROCEDURE GUEST_SET_MANUAL_STAY$INT(RD_DBKEY CHAR(8),
ID_GUEST INTEGER,
FROM_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: OCCUPANCY_ACTIVE_FRAME_CHK$INT for: RIGHTS_CHECK_GRANTED$INT */
ALTER PROCEDURE OCCUPANCY_ACTIVE_FRAME_CHK$INT(ID_AGENT INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM_TYPE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: OCCUPANCY_OVERBOOK_CHECK$INT for: RIGHTS_CHECK_GRANTED$INT */
ALTER PROCEDURE OCCUPANCY_OVERBOOK_CHECK$INT(ID_AGENT INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM_TYPE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_CHECK_OUT_CHECK$RSV for: RIGHTS_CHECK_GRANTED$INT */
ALTER PROCEDURE RES_CHECK_OUT_CHECK$RSV(SELECTION_ID INTEGER)
 RETURNS(IS_EARLY_CHECK_OUT SMALLINT,
EARLY_CHECK_OUT_DEP_DATE DATE,
CHECK_OUT_DATE DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN$RSV for: RIGHTS_CHECK_GRANTED$INT */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_RECALC$INT for: RIGHTS_CHECK_GRANTED$INT */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_RECALC$RSV for: RIGHTS_CHECK_GRANTED$INT */
ALTER PROCEDURE RES_RECALC$RSV(ID_RESERV_DETAIL INTEGER,
FORCE_POSTING SMALLINT = null)
 AS
 BEGIN EXIT; END
^

/* Alter (RIGHTS_CHECK_GRANTED$INT) */
ALTER PROCEDURE RIGHTS_CHECK_GRANTED$INT(RIGHT_CODE VARCHAR(30))
 AS
begin
  if (current_user in ('SYSDBA')) then exit;
  -- All rights are granted to SYSDBA permanently!!!

  if (RDB$GET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX') = 'EW') then exit;
  -- We are called from the end_work chain, so everething is allowed


  if (not exists (select RU.USER_NAME
                  from   RIGHTS_USERS RU
                  where  RU.USER_NAME = current_user)) then exit;
  -- Assiming we are called from external interface, i.e. pos2front, so everething is allowed

  if (exists (select RGL.RIGHT_CODE
              from   RIGHTS_USER_GROUPS R
                     join RIGHTS_GROUPS_LINES RGL on R.ID_RIGHT_GROUP = RGL.ID_RIGHT_GROUP
              where  R.USER_NAME = current_user
                     and RGL.RIGHT_CODE  = :right_code)) then exit;
  -- The checked right is granted to the user

  -- And last - all checks are negative and current user hasn't a right
  exception RIGHT_NOT_GRANTED f_character(29) || '@{right.name.'||:right_code||'}';

end
^

/* Alter (RIGHTS_GROUP_USER_MODIFY) */
ALTER PROCEDURE RIGHTS_GROUP_USER_MODIFY(USER_NAME VARCHAR(30),
ID_RIGHT_GROUP INTEGER,
OPERATION VARCHAR(50))
 AS
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add,del');

  if (:USER_NAME = 'SYSDBA') then exit;

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS RG
  where  RG.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'add') then begin
    update or insert into RIGHTS_USER_GROUPS (USER_NAME, ID_RIGHT_GROUP)
    values (:user_name, :id_right_group)
    matching (USER_NAME, ID_RIGHT_GROUP);

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_ADDED',
            f_character(29) || :USER_NAME  || f_character(28) || :right_group);

  end else begin
    delete from RIGHTS_USER_GROUPS
    where USER_NAME = :user_name
          and ID_RIGHT_GROUP = :id_right_group;

    if (row_count > 0) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_REMOVED',
              f_character(29) || :USER_NAME || f_character(28) || :right_group);

  end

  when sqlcode -803 do begin
    /* ERR_TEXT = '       ! ' ;*/
    exit;
  end
end
^

ALTER PROCEDURE RIGHTS_MODIFY_USER(IN_USER_NAME VARCHAR(30),
IN_USER_NAME_LONG VARCHAR(30),
IN_NEW_PASSWORD VARCHAR(8),
LANG_UI VARCHAR(10),
FISCAL_ID INTEGER,
IS_ACTIVE INTEGER,
OPERATION VARCHAR(20),
CODE VARCHAR(50),
USER_POSITION VARCHAR(100))
 AS
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod');

  if (char_length(:CODE) > 4) then exception ASSERT '-88';
  code = nullif(:code, '');

  if (:operation = 'add') then begin
    insert into RIGHTS_USERS (USER_NAME, USER_NAME_LONG, USER_PASSWORD, FISCAL_ID, LANG_UI, IS_ACTIVE, CODE, USER_POSITION)
    values (:in_user_name, :in_user_name_long, :in_new_password, :fiscal_id, :lang_ui, :is_active, :code, :user_position);

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_NEW', f_character(29) || :IN_USER_NAME);
  end else if (:operation = 'mod') then begin
    update RIGHTS_USERS U
    set    U.USER_PASSWORD  = :in_new_password,
           U.USER_NAME_LONG = :in_user_name_long,
           U.LANG_UI = :lang_ui,
           U.IS_ACTIVE = :is_active,
           U.FISCAL_ID = :fiscal_id,
           U.CODE = :code,
           U.USER_POSITION = :user_position
    where  U.USER_NAME = :in_user_name;

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_MODIFY', f_character(29) || :IN_USER_NAME);
  end/* else if (:operation = 'del') then begin

    delete from RIGHTS_USERS
    where USER_NAME = :in_user_name;

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_DEL', f_character(29) || :IN_USER_NAME);
  end*/ -- deletion is restricted

  when sqlcode -803 do begin
    exception ASSERT '-87';
  end
end
^

/* Alter (RIGHTS_REGRANT) */
ALTER PROCEDURE RIGHTS_REGRANT AS
declare variable relation_name char(31);
  declare variable ui_role_name char(31);
  declare variable ena_role_name char(31);
  declare variable auditor_role_name char(31);
begin
  ui_role_name = 'CLOCKBS_ROLE';
  ena_role_name = 'HTTPDBA_ROLE';
  auditor_role_name = 'AUDITOR_ROLE';

  /* PRIVILEGES GIVEN DIRECTLY TO SOME DB USER MUST BE PRESERVED.
  || AUTOGRANTS ARE MADE ONLY TO THE 'UI' and 'ENA' ROLES AND 'PUBLIC' USER.
  */
  delete from RDB$USER_PRIVILEGES UP
  where  (UP.RDB$USER_TYPE not in (8 /* user*/, 13 /* role */));

  delete from RDB$USER_PRIVILEGES UP
  where  (UP.RDB$USER = :ui_role_name)
         or (UP.RDB$USER = :ena_role_name)
         or (UP.RDB$USER = 'PUBLIC');

  /* THE 'UI' ROLE MUST HAVE ALL PRIVILIGES LIKE THE USER 'SYSDBA'.
  || ONLY NATIVE CLOCKBS APPLICATIONS ARE USING THIS ROLE.
  */
  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION,
         RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select :ui_role_name, 'SYSDBA', U.RDB$PRIVILEGE, 0,
         U.RDB$RELATION_NAME, U.RDB$FIELD_NAME, 13, U.RDB$OBJECT_TYPE
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = 'SYSDBA'
         and (not exists (select u2.RDB$PRIVILEGE
                          from   RDB$USER_PRIVILEGES u2
                          where  u2.RDB$USER = :ui_role_name
                                 and u2.RDB$PRIVILEGE = U.RDB$PRIVILEGE 
                                 and u2.RDB$RELATION_NAME = u.RDB$RELATION_NAME))
         and U.RDB$PRIVILEGE <> 'M' /* MEMBERSHIP */;

  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION,
         RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select :ena_role_name, 'SYSDBA', U.RDB$PRIVILEGE, 0,
         U.RDB$RELATION_NAME, U.RDB$FIELD_NAME, 13, U.RDB$OBJECT_TYPE
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = 'SYSDBA'
         and u.RDB$RELATION_NAME starting with 'ENA_'
         and (not exists (select u2.RDB$PRIVILEGE
                          from   RDB$USER_PRIVILEGES u2
                          where  u2.RDB$USER = :ena_role_name
                                 and u2.RDB$PRIVILEGE = U.RDB$PRIVILEGE 
                                 and u2.RDB$RELATION_NAME = u.RDB$RELATION_NAME))
         and U.RDB$PRIVILEGE in ('S') /* Select (and Reference ??) */;

  /* grant READ access to AUDITOR_ROLE  */
  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION, RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select :auditor_role_name , 'SYSDBA' , U.RDB$PRIVILEGE, 0 , U.RDB$RELATION_NAME, U.RDB$FIELD_NAME, 13, U.RDB$OBJECT_TYPE
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = :ui_role_name
         and not exists
           (select *
            from RDB$USER_PRIVILEGES U2
            where U2.RDB$USER = 'AUDITOR_ROLE'
                  and U2.RDB$PRIVILEGE = U.RDB$PRIVILEGE 
                  and U2.RDB$RELATION_NAME = U.RDB$RELATION_NAME);           

  delete
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = :auditor_role_name
         and u.RDB$PRIVILEGE in ('I', 'U', 'D')
         and u.RDB$RELATION_NAME like '%$PMS%';

  delete
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = :auditor_role_name
         and u.RDB$PRIVILEGE in ('I', 'U', 'D')
         and ( (u.RDB$RELATION_NAME starting with 'SUMMARY_')
              or (u.RDB$RELATION_NAME starting with 'RIGHTS_')
              or (u.RDB$RELATION_NAME starting with 'PROFILE_')
              or (u.RDB$RELATION_NAME starting with 'AGENT_')
              or (u.RDB$RELATION_NAME starting with 'RESOURCE_')
              or (u.RDB$RELATION_NAME starting with 'ACTIVITY_')
              or (u.RDB$RELATION_NAME starting with 'NOM_')
              or (u.RDB$RELATION_NAME starting with 'AR_')
              or (u.RDB$RELATION_NAME starting with 'HK_')
              or (u.RDB$RELATION_NAME starting with 'ALLOTMENT_')
              or (u.RDB$RELATION_NAME starting with 'SERVICE_')
              or (u.RDB$RELATION_NAME starting with 'TARIFA_')
              or (u.RDB$RELATION_NAME starting with 'TAR_BO_')
              or (u.RDB$RELATION_NAME starting with 'REPORT_')
              or (u.RDB$RELATION_NAME starting with 'CHANNEL')
              or (u.RDB$RELATION_NAME starting with 'TAR_UI_')
              or (u.RDB$RELATION_NAME starting with 'TAR_SIMPLE_')
              or (u.RDB$RELATION_NAME starting with 'DEVICE')
              or (u.RDB$RELATION_NAME starting with 'DOC_')
              or (u.RDB$RELATION_NAME starting with 'GUEST_')
              or (u.RDB$RELATION_NAME starting with 'SALE_')
              or (u.RDB$RELATION_NAME starting with 'WORKING_')
             ) ;
  delete
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = :auditor_role_name
         and u.RDB$PRIVILEGE in ('I', 'U', 'D')
         and u.RDB$RELATION_NAME in ('SERVICES', 'DOC_TYPE', 'DOC_TYPE_INV', 'DOC_TYPE_PAY', 'DOC_HEAD$INT',
             'PAYMENT_TYPE', 'CREDIT_CARD_TYPE', 'CURRS', 'CURR_RATES', 'PROFILE', 'AGENT',
             'ACCOUNT', 'ACCOUNT_POST_EXTERNAL',
             'ACC_TEMPLATE', 'CONTRAGENTS', 'HOTEL', 'SETTING_HOTEL_VALUE', 'GUARANTEE_POLICY',
             'RESOURCE$INT', 'RESOURCE_TYPE$INT', 'SAFE', 'SAFE_TYPE', 
             'ROOMS', 'ROOM_TYPES', 'ROOM_CLEAN_LOG',
             'TAX_POLICY',
             'TAR_HEAD', 'TRAIFA_GROUP', 'TAR_SIMPLE',
             'COUNTRY', 'KPPS', 'STAY_REASON', 'PASSPORT_TYPE', 'PHONE_LINE_CONVERT', 'LISTS_ITEMS',
             'RES_TEMPLATE', 'INFOMATIC_ACCOUNT', 'INFOMATIC_CHANNEL', 'ALLOTMENT',
             'PHONECALLS', 'BLOCK_ROOM', 'TASK', 'TASK_FILE', 'TASK_RESERVATION', 'TASK_RESPONSIBLE',
             'REPORT', 'PACKET_ITEM', 'BONUSPOINT_SCHEME', 'BONUSPOINT_SERVICE_GROUP',
             'EATING_OBJECT', 'END_WORKS', 'TASK');

  delete
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = :auditor_role_name
         and u.RDB$PRIVILEGE in ('X')
         and ((u.RDB$RELATION_NAME like '%$CFG%')
              or (u.RDB$RELATION_NAME like '%_MODIFY%')
              or (u.RDB$RELATION_NAME like '%$POST%')
              or (u.RDB$RELATION_NAME in ('RES_SET_STATUS$RSV', 'RES_SAVE_VOUCHER$RSV', 'RES_SAVE_OTHER$RSV',
                  'RES_SAVE_FINALIZE$RSV', 'RES_GUEST_ADD$RSV', 'RES_GUEST_DEL $RSV',
                  'RES_SAVE_NOTE$RSV', 'RESERV_DETAIL_EXTERNAL_MOD$RSV', 'RES_ANUL_DETAIL$RSV',
                  'RES_DELETE$RSV', 'POST_TELECOUNT_TRANSFER$TC', 'PROFILE_MERGE$PROFILE'))) ;
  /* GRANT REFERENCE RIGHT TO 'PUBLIC' FOR ALL TABLES THAT ARE REFERENCED WITH
  || FOREIGN KEYS.
  */
  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION,
         RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select distinct
         'PUBLIC', 'SYSDBA', 'R', 0, RC2.RDB$RELATION_NAME, null, 8, 0
  from   RDB$RELATION_CONSTRAINTS RC
         join RDB$REF_CONSTRAINTS C on C.RDB$CONSTRAINT_NAME = RC.RDB$CONSTRAINT_NAME
         join RDB$RELATION_CONSTRAINTS RC2 on RC2.RDB$CONSTRAINT_NAME = C.RDB$CONST_NAME_UQ
  where  RC.RDB$CONSTRAINT_TYPE = 'FOREIGN KEY';

  /* ALL EXTERNAL INTERFACES FROM OTHER VENDORS ARE NOT USING ROLES, SO
  || THEY WILL TAKE THE PRIVILEDGES OF THE 'PUBLIC' USER. THEY MUST HAVE
  || ACCESS ONLY TO THEIR SPECIFIC PROCEDURES OR OTHER METADATA OBJECTS WICH
  || MUST BE ENUMERATED HERE.
  */
  for
    select R.RDB$RELATION_NAME
    from   RDB$RELATIONS R
    where  (R.RDB$RELATION_NAME starting with 'EAI_')
           or (R.RDB$RELATION_NAME in ('SYSTEM_INFO_MODULE','PHONECALLS','SYSTEM_SESSION'))
           or (R.RDB$RELATION_NAME containing '$TMP')
           or (R.RDB$RELATION_NAME containing '_CACHE')
    union

    select R.RDB$PROCEDURE_NAME
    from   RDB$PROCEDURES R
    where  (R.RDB$PROCEDURE_NAME starting with 'EAI_')
           or (R.RDB$PROCEDURE_NAME in ('SYSTEM_INFO_GET', 'RDB$F_SP'))
    into   :relation_name
  do begin
    execute procedure RIGHTS_REGRANT_SUB('PUBLIC', :relation_name, 8);
  end
end
^

/* empty dependent procedure body */
/* Clear: RIGHTS_REGRANT for: RIGHTS_REGRANT_SUB */
ALTER PROCEDURE RIGHTS_REGRANT AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RIGHTS_REGRANT_SUB for: RIGHTS_REGRANT_SUB */
ALTER PROCEDURE RIGHTS_REGRANT_SUB(GRANT_TO CHAR(31),
GRANT_ON CHAR(31),
USER_TYPE INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RIGHTS_REGRANT_SUB) */
ALTER PROCEDURE RIGHTS_REGRANT_SUB(GRANT_TO CHAR(31),
GRANT_ON CHAR(31),
USER_TYPE INTEGER)
 AS
declare variable dependent_name char(31);
  declare variable trigger_name char(31);
  declare variable trigger_dependent char(31);
begin
  /* PREVENT SHORT RECURSION WHEN ONE POCEDURE IS ITSELF */
  if (:grant_to = :grant_on) then exit;

  /* PREVENT LONG RECURSION */
  if (exists(
    select *
    from   RDB$USER_PRIVILEGES U
    where  U.RDB$USER = :grant_to
           and U.RDB$RELATION_NAME = :grant_on
           and U.RDB$PRIVILEGE <> 'R')
  ) then exit;

  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION,
         RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select :grant_to, 'SYSDBA', U.RDB$PRIVILEGE, 0,
         U.RDB$RELATION_NAME, U.RDB$FIELD_NAME, :user_type, U.RDB$OBJECT_TYPE
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = 'SYSDBA'
         and U.RDB$RELATION_NAME = :grant_on
         and (not exists( /* NOT ALREADY GRANTED */
           select 'X'
           from   RDB$USER_PRIVILEGES u2
           where  u2.RDB$USER = :grant_to
                  and u2.RDB$PRIVILEGE = U.RDB$PRIVILEGE 
                  and u2.RDB$RELATION_NAME = u.RDB$RELATION_NAME
           ))
         and U.RDB$PRIVILEGE <> 'M' /* NOT A MEMBERSHIP PRIVILIGE */;

  for
    select D.RDB$DEPENDED_ON_NAME
    from   RDB$DEPENDENCIES D
    where  D.RDB$DEPENDENT_NAME = :grant_on
           and D.RDB$DEPENDENT_TYPE not in (2, 3) /* 2 TRIGGERS, 3 DOMAINS */
           and D.RDB$DEPENDED_ON_TYPE in (0, 5) /*0 TABLE/VIEW, 5 PROCEDURE, 14 GENERATOR, 15 UDF, 7 EXCEPTION */
    into   :dependent_name
  do begin
    execute procedure RIGHTS_REGRANT_SUB(:grant_on, :dependent_name, 5);
  end

  /* if grant_on is table then
  ||
  */
  for
    select distinct T.RDB$TRIGGER_NAME, D.RDB$DEPENDED_ON_NAME
    from   RDB$TRIGGERS T
           join RDB$DEPENDENCIES D on D.RDB$DEPENDENT_NAME = T.RDB$TRIGGER_NAME
    where  T.RDB$RELATION_NAME = :grant_on
           and ((T.RDB$SYSTEM_FLAG is null) or (T.RDB$SYSTEM_FLAG = 0))
           and D.RDB$DEPENDED_ON_TYPE in (0, 5) /*0 TABLE/VIEW, 5 PROCEDURE, 14 GENERATOR, 15 UDF, 7 EXCEPTION */
    into   :trigger_name, :trigger_dependent
  do begin
    execute procedure RIGHTS_REGRANT_SUB(:trigger_name, :trigger_dependent, 2);
  end
end
^

/* Alter (ROOM_MODIFY$PMS) */
ALTER PROCEDURE ROOM_MODIFY$PMS(ID_ROOM INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
BEDS INTEGER,
EXTRA_BEDS INTEGER,
SECTOR INTEGER,
SORT_ORDER INTEGER,
FEATURES BLOB SUB_TYPE 1 SEGMENT SIZE 100,
EXTERNAL_NAME VARCHAR(20),
ID_EATING_OBJECT TYPE OF ID_REF,
OPERATION VARCHAR(20),
ACCOMODATION_PLACE_UIN TYPE OF TDESCRIPTION_LONG = null)
 RETURNS(OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255),
NEW_ID_ROOM INTEGER)
 AS
declare variable old_id_room_type integer;
  declare variable old_room_name varchar(10);
  declare variable rebuild_id_hotel integer;
  declare variable rebuild_id_room_type integer;
  declare variable no_use varchar(20);
  declare variable old_capacity integer;
  declare variable sys_date date;
  declare variable action_text varchar(255);
  declare variable old_floor integer;
  declare variable old_sector integer;
  declare variable old_extra_beds integer;
  declare variable id_hotel integer;
begin
  overrule_need = 0;
  overrule_context = '';
  new_id_room = null;
  --if OVERRULE_NEED = 1 then OVERRULE_CONTEXT = ERR_TEXT like ERR_CODE = -9
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    if (coalesce(:room_name, '') = '') then
      exception ASSERT '-119';

    if ((:room_name containing '<') or (:room_name containing '>') or (:room_name starting with 'i')) then
      exception ASSERT '-120';
  end

  room_name = upper(:room_name);

  if (:operation='mod') then begin
    select R.ROOM_NAME, R.ID_ROOM_TYPE, R.BEDS+R.EXTRA_BEDS, r.floor, r.sector, r.extra_beds
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :id_room
    into   :old_room_name, :old_id_room_type, :old_capacity, :old_floor, :old_sector, :old_extra_beds;

    if (:id_room_type <> :old_id_room_type) then begin
      exception OCCUPANCY_EXCEPTION '-65';
    end

    new_id_room = :id_room;
    execute procedure ROOM_CAPACITY_CHECK$INT(:NEW_ID_ROOM, :ROOM_NAME, :old_capacity, :BEDS + :EXTRA_BEDS)
    returning_values (:OVERRULE_NEED, :OVERRULE_CONTEXT);

    update ROOMS RU
    set    RU.ID_ROOM_TYPE = :id_room_type,
           RU.ROOM_NAME = :room_name,
           RU.FLOOR = :floor,
           RU.BEDS = :beds,
           RU.EXTRA_BEDS = :extra_beds,
           RU.SECTOR = :sector,
           RU.FEATURES = :features,
           RU.SORT_ORDER = :sort_order,
           RU.EXTERNAL_NAME = :external_name,
           RU.ID_EATING_OBJECT = :ID_EATING_OBJECT,
           ru.ACCOMODATION_PLACE_UIN = :ACCOMODATION_PLACE_UIN
    where  RU.ID_ROOM = :id_room;

    if ((:room_name <> :old_room_name)
        or (:floor <> :old_floor)
        or (:sector <> :old_sector)
        or (:extra_beds <> :old_extra_beds)) then
    begin
      action_text = f_character(29) || '(' || :old_room_name || '/' || :old_floor || '/' || :old_sector || '/'
                    || :old_extra_beds || ')' || f_character(28) || '(' || :room_name || '/' || :floor || '/'
                    || :sector || '/' || :extra_beds || ')';
      execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_PARAMS_CHANGED', :action_text);
    end

    if (:room_name <> :old_room_name) then begin
      update ACCOUNT_POST AP
      set    AP.ROOM_NAME = :room_name
      where  AP.ROOM_NAME = :old_room_name
             and ap.ID_ROOM = :ID_ROOM
             and ap.ac = '00';
    end

  end else if (:operation = 'add') then begin
    select rt.ID_HOTEL
    from   ROOM_TYPES RT
    where  rt.ID_ROOM_TYPE = :ID_ROOM_TYPE
    into   :id_hotel;

    insert into ROOMS (
      ID_ROOM, ID_ROOM_TYPE, ROOM_NAME, FLOOR, BEDS, EXTRA_BEDS, SECTOR,
      FEATURES, SORT_ORDER, ID_HOTEL, EXTERNAL_NAME, ID_EATING_OBJECT, ACCOMODATION_PLACE_UIN)
    values (gen_id(ID_ROOM_GEN, 1), :id_room_type, :room_name, :floor, :beds, :extra_beds, :sector,
      :features, :sort_order, :id_hotel, :external_name, :ID_EATING_OBJECT, :ACCOMODATION_PLACE_UIN)
    returning ID_ROOM into :NEW_ID_ROOM;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :sys_date;

    execute procedure ROOM_PERIOD_MODIFY$PMS(null, :new_id_room, :sys_date, 'HOTEL', 'add')
    returning_values  :no_use;

    insert into ROOMS_ADD (ID_ROOM, PMS_MARKERS, ADDRESS)
    values (:new_id_room, null, null);
  end else if (:operation = 'del') then begin
    -- Booked rooms are preserved with FK constraint on room_magic
    execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'DELETE', '');

    select RT.ID_ROOM_TYPE, RT.ID_HOTEL
    from   ROOM_TYPES RT
    where  RT.ID_ROOM_TYPE = :id_room_type
    into   :rebuild_id_room_type, :rebuild_id_hotel;

    delete from ROOMS where ID_ROOM = :id_room;

    execute procedure ALLOTMENT_PHYS_REBUILD$INT(:rebuild_id_hotel, :rebuild_id_room_type);

    when sqlcode -530 do begin
      -- Violation of FOREIGN KEY constraint "%s" on table "%s"
      exception ASSERT '-34';
    end
  end
end
^

/* Alter (ROOM_SMART_LIST_OOS$INT) */
ALTER PROCEDURE ROOM_SMART_LIST_OOS$INT(FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ROOM_NAME VARCHAR(50),
DESCRIPTION VARCHAR(100),
PERIOD VARCHAR(100),
FREE_BASE INTEGER,
FREE_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
IS_CLEAN INTEGER,
FEATURES BLOB)
 AS
declare variable id_reserv_detail integer;
  declare variable sys_date date;
  declare variable dummy integer;
  declare variable beds integer;
  declare variable extra_beds integer;
  declare variable guests_cnt integer;
begin
  if (:from_date >= :to_date) then exit;

  for
    select SRLF.ROOM_NAME, SRLF.BEDS, SRLF.EXTRA_BEDS, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
           SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.SYS_DATE
    from   ROOM_SMART_FILTER$INT(:from_date, :to_date, 'SHARE', 0, 1) SRLF
    into   :room_name, :beds, :extra_beds, :is_clean, :type_room,
           :id_room, :floor, :features, :sys_date
  do begin
    for
      select distinct RM.ID_RESERV_DETAIL
      from   ROOM_MAGIC RM
      where  RM.ID_ROOM = :id_room
             and RM.BUSY_DATE between :from_date and :to_date
             and RM.DAY_ACTION not containing 'CHECK_IN'
      into   :id_reserv_detail
    do begin
      select RGI.NUMBER ||', '|| RGI.PERSON_PROFILE_NAME ||', '||  RGI.AGENT_PROFILE_NAME,
             RGI.ARRIVALS ||' '|| RGI.DEPARTURES, RGI.GUESTS_CNT
      from   RES_GET_INFO$RSV(:id_reserv_detail, 0, 0, 0) RGI
      into   :description, :period, :guests_cnt;

      if (:guests_cnt < (:beds+:extra_beds)) then begin
        if (:guests_cnt < :beds) then begin
          free_base = (:beds - :guests_cnt);
          free_extra = extra_beds;
        end else begin
          free_base = 0;
          free_extra = ((:beds+:extra_beds)-:guests_cnt);
        end
        suspend;
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: ROOM_SMART_LIST$RSV for: ROOM_SMART_LIST_SHARE$INT */
ALTER PROCEDURE ROOM_SMART_LIST$RSV(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(50))
 RETURNS(ROOM_NAME VARCHAR(50),
FREE_BEDS_BASE INTEGER,
FREE_BEDS_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
FEATURES BLOB,
BUSY_GROUP_TYPE INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
DATA1 VARCHAR(255),
DATA2 VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (ROOM_SMART_LIST_SHARE$INT) */
ALTER PROCEDURE ROOM_SMART_LIST_SHARE$INT(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(50),
SUPPRESS_PRIVATE SMALLINT = 1)
 RETURNS(ROOM_NAME VARCHAR(50),
DESCRIPTION VARCHAR(255),
PERIOD VARCHAR(255),
FREE_BASE INTEGER,
FREE_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
FEATURES BLOB)
 AS
declare variable id_reserv_detail integer;
  declare variable beds integer;
  declare variable extra_beds integer;
  declare variable guests_cnt integer;
  declare variable busy_group_type integer;
  declare variable r_guests_cnt integer;
  declare variable r_description varchar(255);
  declare variable r_period varchar(255);
  declare variable min_day_action integer;
begin
  if (:from_date >= :to_date) then exit;
  report_type = iif(:report_type = 'POTENTIAL_SHARE', 'SHARE', 'BLOCKED');
  for
    select SRLF.ROOM_NAME, SRLF.BEDS, SRLF.EXTRA_BEDS, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
           SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.CLEAN_TEXT
    from   ROOM_SMART_FILTER$INT(:from_date, :to_date, :report_type, 0, :SUPPRESS_PRIVATE) SRLF
    into   :room_name, :beds, :extra_beds, :is_clean, :type_room,
           :id_room, :floor, :features, :clean_text
  do begin
    guests_cnt = 0;
    description = '';
    for
      select RM.ID_RESERV_DETAIL, RM.BUSY_GROUP_TYPE, min(RM.DAY_ACTION_INT)
      from   ROOM_MAGIC RM   --TODO order by arrival
      where  RM.ID_ROOM = :id_room
             and RM.BUSY_DATE between :from_date and :to_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
      group by 1, 2
      into   :id_reserv_detail, :busy_group_type, :min_day_action
    do begin
      if ((:busy_group_type in (1, 24)) or (:min_day_action > 0)) then begin
        select substring(RGI.NUMBER ||', '|| RGI.PERSON_PROFILE_NAME ||', '||  RGI.AGENT_PROFILE_NAME from 1 for 254),
               substring(RGI.ARRIVALS ||' '|| RGI.DEPARTURES from 1 for 254), RGI.GUESTS_CNT
        from   RES_GET_INFO$RSV(:id_reserv_detail, 0, 0, 0) RGI
        into   :r_description, :r_period, :r_guests_cnt;
      end else begin
        select iif(BR.BLOCK_GRP=18, 'OOO', 'OOI') ||', ' || substring(BR.REASON ||', '|| BR.NOTE from 1 for 254),
               substring(formatDate(BR.FROM_DATE, 'D;dd.mm')||' ('|| cast((BR.TO_DATE - BR.FROM_DATE) as integer) ||') '||formatDate(BR.TO_DATE, 'D;dd.mm') from 1 for 254)
        from   BLOCK_ROOM BR
        where  BR.ID_BLOCK_ROOM = :id_reserv_detail
        into   :r_description, :r_period;
        r_guests_cnt = 0;
      end
      if (:r_guests_cnt > :guests_cnt) then guests_cnt = :r_guests_cnt;

      if (:description <> '') then description = :description || F_CRLF();
      description = substring(:description || :r_description || ', ' || :r_period from 1 for 250);
    end
    if (:guests_cnt < (:beds+:extra_beds)) then begin
      if (:guests_cnt < :beds) then begin
        free_base = (:beds - :guests_cnt);
        free_extra = extra_beds;
      end else begin
        free_base = 0;
        free_extra = ((:beds+:extra_beds)-:guests_cnt);
      end
    end
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_ROOM_TYPE$EXC for: ROOM_TYPE_MODIFY$CFG */
ALTER PROCEDURE IMPORT_ROOM_TYPE$EXC(TYPE_ROOM VARCHAR(20),
BEDS INTEGER,
EXT_CODE VARCHAR(30),
UUID VARCHAR(40),
HOTEL_NAME VARCHAR(50))
 RETURNS(ID_ROOM_TYPE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ROOM_TYPE_MODIFY$CFG) */
ALTER PROCEDURE ROOM_TYPE_MODIFY$CFG(ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
TYPE_ROOM VARCHAR(20),
BEDS INTEGER,
EXT_CODE VARCHAR(30),
OPERATION VARCHAR(10))
 RETURNS(NEW_ID_ROOM_TYPE INTEGER,
OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255))
 AS
declare variable id_room integer;
  declare variable room_name varchar(10);
  declare variable old_beds integer;
  declare variable extra_beds integer;
  declare tmp_overrule_need integer;
  declare tmp_overrule_context varchar(255);
  declare variable old_type_room varchar(20);
  declare variable err_rooms varchar(255);
  declare variable err_beds varchar(255);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation = 'add') then begin
    new_id_room_type = gen_id(ID_ROOM_TYPE_GEN, 1);
    insert into ROOM_TYPES (ID_ROOM_TYPE, TYPE_ROOM, BEDS, EXT_CODE, ID_HOTEL)
    values      (:new_id_room_type, :type_room, :beds, :ext_code, :id_hotel);

    execute procedure BASE_SERVICES_GEN$INT(:ID_HOTEL);

  end else if (:operation = 'mod') then begin
    update ROOM_TYPES
    set    TYPE_ROOM = :type_room,
           BEDS = :beds,
           EXT_CODE = :ext_code
    where  ID_ROOM_TYPE = :id_room_type
    returning old.beds, old.type_room, new.id_room_type
    into   :old_beds, :old_type_room, :NEW_ID_ROOM_TYPE;

    if (:old_beds <> :beds) then begin
      err_rooms = '';
      err_beds = '';
      for
        select  r.ID_ROOM, r.ROOM_NAME, r.BEDS, r.EXTRA_BEDS
        from    ROOMS r
        where   r.ID_ROOM_TYPE = :ID_ROOM_TYPE
        into    :id_room, :room_name, :old_beds, :extra_beds
      do begin
        execute procedure ROOM_CAPACITY_CHECK$INT(:id_room, :room_name, :old_beds + :extra_beds, :BEDS + :extra_beds)
        returning_values (:tmp_overrule_need, :tmp_overrule_context);
        if (:tmp_overrule_need <> 0) then begin
          if (:OVERRULE_NEED = 0) then OVERRULE_NEED = :tmp_overrule_need;
          err_rooms = substring(:err_rooms||','||substring(:tmp_overrule_context from (position(f_character(29), :tmp_overrule_context)+1) for (position(f_character(28), :tmp_overrule_context)-1)) from 1 for 255);
          err_beds = substring(:err_beds||','||substring(:tmp_overrule_context from (position(f_character(28), :tmp_overrule_context)+1)) from 1 for 255);
        end
  
        update ROOMS r
        set    r.BEDS = :BEDS
        where  r.ID_ROOM = :id_room;
      end
      if (:OVERRULE_NEED <> 0) then OVERRULE_CONTEXT = substring(f_character(29)||:err_rooms||f_character(28)||:err_beds from 1 for 255);
    end

    if (:old_type_room <> :TYPE_ROOM) then
      execute procedure BASE_SERVICES_GEN$INT(:ID_HOTEL);

  end else if (:operation = 'del') then begin
    delete from ROOM_TYPES
    where  ID_ROOM_TYPE = :id_room_type;
    NEW_ID_ROOM_TYPE = null;
  end
end
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_MODIFY for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE /* TYPE OF ID */ INTEGER,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100))
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_NEW for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE /* TYPE OF ID */ INTEGER,
FROM_DATETIME /* TDATETIME */ TIMESTAMP,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100),
BOOKING_NUMBER /* TYPE OF TRES_NUMBER */ VARCHAR(62),
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
ID_RESOURCE_RESERVATION /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SAFE_OCCUPANCY_POSTING$INT) */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION TYPE OF ID,
ID_SERVICE TYPE OF ID,
PRICE TYPE OF TPRICE,
CURRENCY TYPE OF TCURRENCY,
PRICE_DESCRIPTION TYPE OF TDESCRIPTION_SHORT,
ID_RESERV_DETAIL TYPE OF ID,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF = null)
 RETURNS(DOC_SELECTED TYPE OF TRANGE)
 AS
declare variable from_datetime timestamp;
  declare variable to_datetime timestamp;
  declare variable ap_dbkey TDB_KEY;
  declare variable id_account_post integer;
  declare variable safe_name TOBJECT_NAME;
  declare variable no_use varchar(255);
  declare variable new_ac varchar(2);
  declare variable err_code integer;
  declare variable err_text varchar(255) ;
  declare variable occupant_name tperson_name;
  declare variable id_room integer;
  declare variable id_tariff integer;
begin
  DOC_SELECTED = null;
  select od.FROM_DATETIME, od.TO_DATETIME, ap.RDB$DB_KEY, ap.ID_ACCOUNT_POST,
         s.SAFE_NAME, rr.OCCUPANT_NAME, ap.ID_ROOM, ap.ID_TARIFF
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join SAFES s on s.ID_SAFE = od.ID_RESOURCE
         left outer join RESOURCE_RESERV_POST rrp on rrp.ID_RESOURCE_RESERVATION = rr.ID_RESOURCE_RESERVATION
         left outer join ACCOUNT_POST ap on ap.ID_ACCOUNT_POST = rrp.ID_ACCOUNNT_POST
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :from_datetime, :to_datetime, :ap_dbkey, :id_account_post,
         :safe_name, :occupant_name, :id_room, :id_tariff;

  new_ac = null;
  if (:id_account_post is not null) then begin
    execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
            :id_tariff, :id_room, 1, 0, :price, :currency, null, null, 'RESOURCE', :from_datetime, :TO_DATETIME, 1)
    returning_values :no_use, :no_use, :new_ac;
  end else begin
    if (:id_reserv_detail is not null) then begin
      execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
              1, :price, :currency, :from_datetime, :to_datetime,
              '', '', cast(:from_datetime as date), 'RESOURCE', null)
      returning_values (:ERR_CODE, :ERR_TEXT, :no_use, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end else if (:ID_EXTERNAL_CLIENT_ACCCOUNT is not null) then begin
      execute procedure POST_SERVICE_ON_ACCOUNT$INT (:ID_EXTERNAL_CLIENT_ACCCOUNT, :id_service,
              1, 0, 1, :price, :currency, :from_datetime, :TO_DATETIME, '', '',
              cast(:from_datetime as date), 'RESOURCE', null, null)
      returning_values (:err_code, :err_text, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end
  end

  if (:new_ac is null) then
    exception ASSERT '-1067' || f_character(31) || f_character(29) || :safe_name || f_character(28) || :occupant_name;

  if (:new_ac = '00') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);
    update ACCOUNT_POST AP
    set    ap.DOC_SELECTED = :DOC_SELECTED
    where  ap.ID_ACCOUNT_POST = :id_account_post;
  end

  update or insert into ACCOUNT_POSTING_DET (ID_ACCOUNT_POST, POST_TEXT, QTY,
         FROM_DATETIME, TO_DATETIME, RESOURCE_TEXT)
  values (:id_account_post, :safe_name ||' / '||formatdate(:from_datetime, 'D;dd.mm.yy(hh:mm)')||' - '||formatdate(:to_datetime, 'D;dd.mm.yy(hh:mm)')||' / '
          ||substring(replace(:price_description, F_CRLF(), ';') from 1 for 100), 1, :from_datetime, :to_datetime, :safe_name);

  if (not exists (select rp.ID_ACCOUNNT_POST
                  from   RESOURCE_RESERV_POST rp
                  where  rp.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
                         and rp.ID_ACCOUNNT_POST = :id_account_post)) then
  begin
    insert into RESOURCE_RESERV_POST (ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:id_resource_reservation, :id_account_post);
  end
end
^

/* empty dependent procedure body */
/* Clear: SERVICE_MODIFY for: SERVICE_MEAL_MODIFY$INT */
ALTER PROCEDURE SERVICE_MODIFY(ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_SERVICE_GROUP /* TYPE OF ID */ INTEGER,
SERVICE_TYPE /* TYPE OF TENUM_STRING */ VARCHAR(50),
SERVICE_NAME /* TYPE OF TNAME_SHORT */ VARCHAR(30),
IS_DELETED /* TYPE OF TLOGICAL */ SMALLINT,
IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
IS_DETAILS /* TYPE OF TLOGICAL */ SMALLINT,
REVENUE_GROUP /* TYPE OF TOBJECT_NAME */ VARCHAR(50),
REVENUE_ACCOUNT /* TYPE OF TOBJECT_NAME */ VARCHAR(50),
ACCOUNT_NAME /* TYPE OF TSEARCH_CODE */ VARCHAR(30),
EXT_CODE /* TYPE OF TSEARCH_CODE */ VARCHAR(30),
VAUCHER_PACKET VARCHAR(20),
EXTRA_PACKET_NAME /* TYPE OF TSHORT_CODE */ VARCHAR(10),
IS_RATE_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
OPERATION VARCHAR(20),
ID_HOTEL /* TYPE OF ID_REF */ INTEGER,
IS_BREAKFAST /* TYPE OF TLOGICAL */ SMALLINT = null,
IS_LUNCH /* TYPE OF TLOGICAL */ SMALLINT = null,
IS_DINNER /* TYPE OF TLOGICAL */ SMALLINT = null,
IS_EXTRAFOOD1 /* TYPE OF TLOGICAL */ SMALLINT = null,
IS_EXTRAFOOD2 /* TYPE OF TLOGICAL */ SMALLINT = null,
IS_BOARD /* TYPE OF TLOGICAL */ SMALLINT = null,
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4) = null,
PRICE_CURR /* TYPE OF TCURRENCY */ CHAR(3) = null)
 RETURNS(NEW_ID_SERVICE /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SERVICE_MEAL_MODIFY$INT) */
ALTER PROCEDURE SERVICE_MEAL_MODIFY$INT(ID_SERVICE TYPE OF ID,
IS_BREAKFAST TYPE OF TLOGICAL,
IS_LUNCH TYPE OF TLOGICAL,
IS_DINNER TYPE OF TLOGICAL,
IS_EXTRAFOOD1 TYPE OF TLOGICAL,
IS_EXTRAFOOD2 TYPE OF TLOGICAL,
IS_BOARD TYPE OF TLOGICAL,
ID_HOTEL TYPE OF ID)
 AS
declare variable id_board integer;
  declare variable weight_tag integer;
  declare variable old_id_board integer;
  declare variable old_is_breakfast integer;
  declare variable old_is_dinner integer;
  declare variable old_is_lunch integer;
  declare variable old_is_extrafood1 integer;
  declare variable old_is_extrafood2 integer;
begin
  IS_BREAKFAST = coalesce(:IS_BREAKFAST, 0);
  IS_LUNCH = coalesce(:IS_LUNCH, 0);
  IS_DINNER = coalesce(:IS_DINNER, 0);
  IS_EXTRAFOOD1 = coalesce(:IS_EXTRAFOOD1, 0);
  IS_EXTRAFOOD2 = coalesce(:IS_EXTRAFOOD2, 0);

  id_board = iif(:IS_BOARD = 1, :ID_SERVICE, null);
  weight_tag = :IS_BREAKFAST + :IS_LUNCH + :IS_DINNER + :IS_EXTRAFOOD1 + :IS_EXTRAFOOD2;

  if (:IS_BOARD = 0 and :weight_tag = 0) then exception ASSERT '-30';

  select sm.Id_BOARD, sm.IS_BREAKFAST, sm.IS_LUNCH, sm.IS_DINNER, sm.IS_EXTRAFOOD1, sm.IS_EXTRAFOOD2
  from   SERVICE_MEALS sm
  where  sm.ID_SERVICE = :ID_SERVICE
  into   :old_id_board, :old_is_breakfast, :old_is_lunch, :old_is_dinner, :old_is_extrafood1, :old_is_extrafood2;

  if ((:id_board is distinct from :old_id_board)
      or (:IS_BREAKFAST <> :old_is_breakfast)
      or (:IS_LUNCH <> :old_is_lunch)
      or (:IS_DINNER <> :old_is_dinner)
      or (:IS_EXTRAFOOD1 <> :old_is_extrafood1)
      or (:IS_EXTRAFOOD2 <> :old_is_extrafood2)) then
  begin
    -- to force FK validations, check usage !!!
    delete from SERVICE_MEALS sm
    where  sm.ID_SERVICE = :ID_SERVICE;

    when sqlcode -530 do begin
      exception ASSERT '-39';
    end
  end

  update or insert into SERVICE_MEALS (ID_SERVICE, IS_BREAKFAST, IS_LUNCH,
      IS_DINNER, IS_EXTRAFOOD1, IS_EXTRAFOOD2, WEIGHT_TAG, ID_BOARD)
  values (:ID_SERVICE, :IS_BREAKFAST, :IS_LUNCH,
      :IS_DINNER, :IS_EXTRAFOOD1, :IS_EXTRAFOOD2, :WEIGHT_TAG, :ID_BOARD)
  matching (id_service);

  if (:id_board is not null) then begin
    execute procedure BASE_SERVICES_GEN$INT (:ID_HOTEL);
  end

end
^

/* empty dependent procedure body */
/* Clear: EAI_MAP_SERVICE for: SERVICE_MODIFY */
ALTER PROCEDURE EAI_MAP_SERVICE(SERVICE_TAG VARCHAR(30),
SERVICE_NAME VARCHAR(30),
EXTERNAL_IFC VARCHAR(30),
ID_HOTEL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_MAPPED_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_SERVICE$EXC for: SERVICE_MODIFY */
ALTER PROCEDURE IMPORT_SERVICE$EXC(SERVICE_NAME VARCHAR(30),
SERVICE_GROUP VARCHAR(30),
SERVICE_TYPE VARCHAR(50),
IS_DELETED SMALLINT,
IS_MANUAL_PRICE SMALLINT,
IS_DETAILS SMALLINT,
REVENUE_GROUP VARCHAR(50),
REVENUE_ACCOUNT VARCHAR(50),
ACCOUNT_NAME VARCHAR(30),
EXT_CODE VARCHAR(30),
VAUCHER_PACKET VARCHAR(20),
EXTRA_PACKET_NAME VARCHAR(10),
IS_RATE_PRICE SMALLINT,
IS_BREAKFAST SMALLINT,
IS_LUNCH SMALLINT,
IS_DINNER SMALLINT,
IS_EXTRAFOOD1 SMALLINT,
IS_EXTRAFOOD2 SMALLINT,
IS_BOARD SMALLINT,
PRICE NUMERIC(15,4),
PRICE_CURR VARCHAR(3),
HOTEL_NAME VARCHAR(50),
UUID VARCHAR(40))
 RETURNS(ID_SERVICE INTEGER,
ID_SERVICE_GROUP INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SERVICE_MODIFY) */
ALTER PROCEDURE SERVICE_MODIFY(ID_SERVICE TYPE OF ID,
ID_SERVICE_GROUP TYPE OF ID,
SERVICE_TYPE TYPE OF TENUM_STRING,
SERVICE_NAME TYPE OF TNAME_SHORT,
IS_DELETED TYPE OF TLOGICAL,
IS_MANUAL_PRICE TYPE OF TLOGICAL,
IS_DETAILS TYPE OF TLOGICAL,
REVENUE_GROUP TYPE OF TOBJECT_NAME,
REVENUE_ACCOUNT TYPE OF TOBJECT_NAME,
ACCOUNT_NAME TYPE OF TSEARCH_CODE,
EXT_CODE TYPE OF TSEARCH_CODE,
VAUCHER_PACKET VARCHAR(20),
EXTRA_PACKET_NAME TYPE OF TSHORT_CODE,
IS_RATE_PRICE TYPE OF TLOGICAL,
OPERATION VARCHAR(20),
ID_HOTEL TYPE OF ID_REF,
IS_BREAKFAST TYPE OF TLOGICAL = null,
IS_LUNCH TYPE OF TLOGICAL = null,
IS_DINNER TYPE OF TLOGICAL = null,
IS_EXTRAFOOD1 TYPE OF TLOGICAL = null,
IS_EXTRAFOOD2 TYPE OF TLOGICAL = null,
IS_BOARD TYPE OF TLOGICAL = null,
PRICE TYPE OF TPRICE = null,
PRICE_CURR TYPE OF TCURRENCY = null)
 RETURNS(NEW_ID_SERVICE TYPE OF ID_REF)
 AS
declare variable check_srv_group integer;
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:OPERATION in ('add', 'mod')) then begin
    check_srv_group = null;
    select sg.ID_SERVICE_GROUP
    from   SERVICE_GROUPS sg
    where  sg.ID_SERVICE_GROUP = :ID_SERVICE_GROUP
           and sg.ID_HOTEL = :ID_HOTEL
    into   :check_srv_group;

    if (:check_srv_group is null) then
       exception ASSERT 'Hotel mismatch for service and service group!';
  end

  if (:operation = 'add') then begin
    if (:SERVICE_TYPE = 'BASE') then
       exception ASSERT 'Unsupported service type: ''' || coalesce(:SERVICE_TYPE, 'null') || ''' !';
       -- BASE services are creating by another procedure */

    if (coalesce(:id_service, 0) <= 0) then
      new_id_service = gen_id(ID_SERVICE_GEN, 1);
    else new_id_service = :id_service;

    /*if ((:ext_code is null) or (:ext_code = '')) then EXT_CODE = :new_id_service;   */

    insert into SERVICES (ID_SERVICE, ID_SERVICE_GROUP, SERVICE_TYPE,
      SERVICE_NAME, IS_DELETED, IS_MANUAL_PRICE,
      IS_DETAILS, REVENUE_GROUP, REVENUE_ACCOUNT, ACCOUNT_NAME, EXT_CODE, VAUCHER_PACKET,
      EXTRA_PACKET_NAME, IS_RATE_PRICE, ID_HOTEL, PRICE, PRICE_CURR)
    values (:new_id_service, :id_service_group, :SERVICE_TYPE,
      :service_name, :is_deleted, :is_manual_price,
      :is_details, :revenue_group, :revenue_account, :account_name, :ext_code, :vaucher_packet,
      :extra_packet_name, :is_rate_price, :id_hotel, :price, :price_curr)
    returning id_service into :NEW_ID_SERVICE;

  end else if (:operation = 'mod') then begin
    update SERVICES
    set    ID_SERVICE_GROUP = :id_service_group,
           SERVICE_NAME = :service_name,
           IS_RATE_PRICE = :is_rate_price,
           IS_DELETED = :is_deleted,
           IS_MANUAL_PRICE = :is_manual_price,
           IS_DETAILS = :is_details,
           REVENUE_GROUP = :revenue_group,
           REVENUE_ACCOUNT = :revenue_account,
           ACCOUNT_NAME = :account_name,
           EXT_CODE = :ext_code,
           VAUCHER_PACKET = :vaucher_packet,
           EXTRA_PACKET_NAME = :extra_packet_name,
           PRICE = :price,
           PRICE_CURR = :price_curr
    where  ID_SERVICE = :id_service
    returning new.id_service into :NEW_ID_SERVICE;

  end else if (:operation = 'del') then begin
    delete from SERVICES S
    where  S.ID_SERVICE = :id_service;
  end

  if (:OPERATION <> 'del') then begin
    if (:SERVICE_TYPE = 'MEAL') then begin
      execute procedure SERVICE_MEAL_MODIFY$INT (:NEW_ID_SERVICE, :IS_BREAKFAST,
              :IS_LUNCH, :IS_DINNER, :IS_EXTRAFOOD1, :IS_EXTRAFOOD2, :IS_BOARD, :ID_HOTEL);
    end

    execute procedure LIST_ITEM_MODIFY(:revenue_group, null, :revenue_account, 'add');
    execute procedure LIST_ITEM_MODIFY('service_account', null, :account_name, 'add');

    execute procedure SYSTEM_CACHE_APPLY('service_account');
  end
end
^

/* Alter (SERVICE_PAYMENT_ANALYSIS$RPT) */
ALTER PROCEDURE SERVICE_PAYMENT_ANALYSIS$RPT(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER)
 RETURNS(ID_SERVICE INTEGER,
ID_PAYMENT_TYPE INTEGER,
SALE_AMOUNT NUMERIC(15,4))
 AS
declare variable id_doc integer;
  declare variable pay_coef double precision;
  declare variable doc_value numeric(15,4);
  declare variable data_orig numeric(15,4);
  declare variable d_rate numeric(15,6);
  declare variable value_corr_idx integer;
  declare variable for_deposit integer;
begin

  for
    select DH.ID_DOC, DH.DOC_RATE, DH.VALUE_CORR_IDX, DH.FOR_DEPOSIT
    from   DOCUMENT_RELEASE_S DH
           join ACCOUNT A on A.ID_ACCOUNT = DH.ID_ACCOUNT
    where  A.ID_HOTEL = :ID_HOTEL
           and DH.RPT_DOC_DATE between :FROM_DATE and :TO_DATE
           and DH.IS_ANNUL_ON_DATE = 0
    into   :id_doc, :d_rate, :value_corr_idx, :for_deposit
  do begin
    doc_value = null;
    select sum(DP.DOC_AMOUNT)
    from   DOC_PAY_USAGE DP
    where  DP.ID_DOC_HEAD = :id_doc
    into   :doc_value;

    if (:doc_value <> 0) then begin
      for
        /* get all used payments */
        select  PT.ID_PAYMENT_TYPE, sum(dP.DOC_AMOUNT) / :doc_value
        from    DOC_PAY_USAGE DP
                join ACCOUNT_PAYMENTS AP on AP.ID_ACCOUNT_PAYMENT = dp.ID_ACCOUNT_PAYMENT
                join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = AP.ID_PAYMENT_HEAD
                join PAYMENT_TYPE PT on PT.ID_PAYMENT_TYPE = P.ID_PAYMENT_TYPE
        where   DP.ID_DOC_HEAD = :ID_DOC
        group by 1
        into     :ID_PAYMENT_TYPE, :pay_coef
      do begin
        /* apportion payments to services */
        for
          select DL.ID_SERVICE, sum(DL.SINGLE_VALUE * DL.QTY_POST)
          from   DOC_LINE DL
                 left outer join DOC_LINE_DEP_VALUES DV on DV.ID_DOC_LINE = DL.ID_DOC_LINE and :for_deposit = 0
          where  DL.ID_DOC_HEAD = :ID_DOC
                 and DV.ID_DOC_LINE is null /* skip used advance payments */
          group by 1
          into   :ID_SERVICE, :data_orig
        do begin
          SALE_AMOUNT = :data_orig * :pay_coef * :d_rate * :value_corr_idx;
          suspend;
        end
      end
      /* subtract used advance payments (invoiced) */
      for
        select DL.ID_SERVICE, PT.ID_PAYMENT_TYPE, -sum(DD.USED_DOC_VALUE)
        from   DOC_LINE DL
               join DOC_LINE_DEP_VALUES DV on DV.ID_DOC_LINE = DL.ID_DOC_LINE
               join DEPOSIT_DEDUCT DD on DD.ID_DEPOSIT = DV.ID_DEPOSIT
               join PAYMENT_TYPE PT on PT.ID_PAYMENT_TYPE = DD.ID_PAYMENT_TYPE
        where  DL.ID_DOC_HEAD = :ID_DOC
               and DD.ID_DOC_USED = :ID_DOC
        group by 1, 2
        into   :ID_SERVICE, :ID_PAYMENT_TYPE, :DATA_ORIG
      do begin
        SALE_AMOUNT = :DATA_ORIG * :D_RATE * :VALUE_CORR_IDX;
        suspend;
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTS_ON_DATE$RPT for: SERVICE_POSTING_REVENUE$INT */
ALTER PROCEDURE ACCOUNT_POSTS_ON_DATE$RPT(ID_HOTEL INTEGER,
TO_DATE DATE,
INCL_CORR SMALLINT,
INCL_POSTS SMALLINT,
IN_ID_ACCOUNT INTEGER = null)
 RETURNS(POST_ID INTEGER,
ID_ACCOUNT INTEGER,
ID_GUEST INTEGER,
ROOM_NAME VARCHAR(20),
ID_SERVICE INTEGER,
ARISE_DATE DATE,
DATE_POST DATE,
IS_PRIMARY_POST SMALLINT,
POST_TYPE VARCHAR(10),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,4),
POST_NET_VALUE NUMERIC(15,4),
POST_GROSS_VALUE NUMERIC(15,4),
RATE_POST NUMERIC(15,6),
CURR_POST VARCHAR(3),
DATETIME_POST TIMESTAMP,
USER_NAME VARCHAR(30),
POST_REASON VARCHAR(30),
ID_VAT_GROUP INTEGER,
ID_ACCOUNT_POST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SERVICE_POSTING_REVENUE$INT) */
ALTER PROCEDURE SERVICE_POSTING_REVENUE$INT(ID_END_WORK INTEGER)
 RETURNS(SEQUENCE_ID INTEGER,
POST_DBKEY CHAR(8),
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT INTEGER,
ID_SERVICE INTEGER,
ID_SALE_TAXATION INTEGER,
ID_GUEST INTEGER,
ROOM_NAME VARCHAR(10),
ARISE_DATE DATE,
DATE_POST DATE,
IS_PRIMARY_POST SMALLINT,
POST_TYPE VARCHAR(10),
QTY_POST NUMERIC(15,4),
PRICE_POST NUMERIC(15,4),
RATE_POST NUMERIC(15,6),
CURR_POST VARCHAR(3),
POST_NET_VALUE NUMERIC(15,4),
POST_GROSS_VALUE NUMERIC(15,4),
DATETIME_POST TIMESTAMP,
USER_NAME VARCHAR(30),
POST_REASON VARCHAR(30))
 AS
declare variable is_base integer;
  declare variable id_master_post integer;
  declare variable id_ew_arise integer;
  declare variable system_date date;
  declare variable id_base_doc integer;
  declare variable doc_net_diff numeric(15,4);
  declare variable doc_gross_diff numeric(15,4);
  declare variable round_to numeric(15,4);
begin
  system_date = null;
  room_name = null;

  select first 1 ew.PREV_DATE
  from   END_WORKS EW
  where  EW.ID_END_WORK = :id_end_work
         and EW.END_WORK_KIND = '3'
         and EW.PREV_DATE < EW.NEXT_DATE
  order by EW.PREV_DATE asc, EW.ID_END_WORK asc
  into   :system_date;

  for
    /* postings */
    select cast(1 as smallint), AP.RDB$DB_KEY, AP.ID_ACCOUNT_POST, ap.ID_ACCOUNT_POST,
           AP.ID_ACCOUNT, AP.ID_GUEST, AP.ROOM_NAME, AP.ID_END_WORK,
           AP.QTY_POST * (1-AP.IS_ANUL), AP.PRICE_POST, AP.RATE_POST, AP.CURR_POST,
           AP.DATE_POST, AP.ID_SERVICE, AP.IS_BASE, AP.ID_MASTER_ADDINS_ACC_POST,
           AP.POST_NET_VALUE, AP.POST_GROSS_VALUE,
           AP.POST_DATETIME, cast(AP.USER_NAME as varchar(30)) ,
           cast('' as varchar(30)) as POST_REASON, AP.ID_SALE_TAXATION, ap.ID_BASE_DOC
    from   ACCOUNT_POST AP
    where  AP.ID_END_WORK = :id_end_work
    union all
    /* corrections  */
    select 0, APC.RDB$DB_KEY, APC.ID_ACC_POST_CORRECT, APC.ID_ACCOUNT_POST,
           APC.ID_ACCOUNT, APC.ID_GUEST, AP.ROOM_NAME, AP.ID_END_WORK,
           iif(APC.IS_QTY_CORRECT = 0, APC.NEW_QTY, APC.NEW_QTY - APC.OLD_QTY) as QTY_POST,
           iif(APC.IS_QTY_CORRECT = 1, APC.NEW_PRICE, cast(APC.NEW_PRICE * APC.NEW_RATE_POST - APC.OLD_PRICE * APC.OLD_RATE_POST as double precision) / APC.NEW_RATE_POST) as PRICE_POST,
           apc.NEW_RATE_POST, apc.NEW_CURR_POST,
           apc.DATE_POST_ORIG, apc.ID_SERVICE, AP.IS_BASE, AP.ID_MASTER_ADDINS_ACC_POST,
           APC.NEW_POST_NET_VALUE - APC.OLD_POST_NET_VALUE, APC.NEW_POST_GROSS_VALUE - APC.OLD_POST_GROSS_VALUE,
           APC.DATETIME_CREATED, cast(APC.USER_CORRECT as varchar(30)),
           APC.REASON_OF_CORRECT, APC.ID_SALE_TAXATION, ap.ID_BASE_DOC
    from   ACCOUNT_POST_CORRECTION APC
           left join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = APC.ID_ACCOUNT_POST
    where  APC.ID_END_WORK = :ID_END_WORK
    into   :IS_PRIMARY_POST, :POST_DBKEY, :SEQUENCE_ID, :ID_ACCOUNT_POST,
           :ID_ACCOUNT, :ID_GUEST, :ROOM_NAME, :id_ew_arise,
           :QTY_POST, :PRICE_POST, :RATE_POST, :CURR_POST,
           :DATE_POST, :ID_SERVICE, :is_base, :id_master_post,
           :POST_NET_VALUE,  :POST_GROSS_VALUE,
           :DATETIME_POST, :USER_NAME, :POST_REASON, :ID_SALE_TAXATION, :id_base_doc
  do begin
    if (:IS_PRIMARY_POST = 1) then begin
      select first 1 APCC.ID_ACCOUNT, APCC.ID_SERVICE, APCC.ID_GUEST, APCC.ID_SALE_TAXATION,
             APCC.OLD_QTY, APCC.OLD_PRICE, APCC.OLD_RATE_POST, APCC.OLD_CURR_POST,
             APCC.OLD_POST_NET_VALUE, APCC.OLD_POST_GROSS_VALUE
      from   ACCOUNT_POST_CORRECTION APCC
      where  APCC.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
             and APCC.ID_END_WORK > :ID_END_WORK
      order by APCC.ID_END_WORK asc, APCC.ID_ACC_POST_CORRECT asc
      into   :ID_ACCOUNT, :ID_SERVICE, :ID_GUEST, :ID_SALE_TAXATION,
             :QTY_POST, :PRICE_POST, :RATE_POST, :CURR_POST,
             :POST_NET_VALUE, :POST_GROSS_VALUE;

      /* get round diffs from released documents for this posting */
      select sum(pv.NET_RATE_DIFF + pv.NET_ROUND_DIFF), sum(pv.GROSS_RATE_DIFF + pv.GROSS_ROUND_DIFF)
      from   DOC_LINE_POST_VALUES PV
             join DOC_LINE dl on dl.ID_DOC_LINE = pv.ID_DOC_LINE
             join DOC_HEAD D on D.ID_DOC = dl.ID_DOC_HEAD
      where  pv.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
             and d.DOC_DATE < :system_date
             and d.ID_BASE_DOC = :id_base_doc
      into   :doc_net_diff, :doc_gross_diff;

      POST_NET_VALUE = :POST_NET_VALUE + coalesce (:doc_net_diff, 0);
      POST_GROSS_VALUE = :POST_GROSS_VALUE + coalesce (:doc_gross_diff, 0);
    end

    if (:id_ew_arise = :id_end_work) then begin
      ARISE_DATE = mindate(:SYSTEM_DATE, :DATE_POST);
    end else begin
      select ewa.PREV_DATE
      from   END_WORKS ewa
      where  ewa.ID_END_WORK = :id_ew_arise
      into   :ARISE_DATE;
    end

    POST_TYPE = case when :is_base = 1 then 'BASE'
                     when :is_base = 0 and :id_master_post > 0 then 'ADD_INS'
                     else 'EXTRA'
                end;
                                                           
    select c.ROUND_TO
    from   CURRS c
    where  c.CURR = :CURR_POST
    into   :round_to;

    if (round_f(:QTY_POST * cast(:PRICE_POST as double precision), :round_to/10) <> 0
        or (:POST_NET_VALUE <> 0)
        or (:POST_GROSS_VALUE <> 0)) then suspend;

  end
end
^

/* Alter (SPR_DOC_MATRIX) */
ALTER PROCEDURE SPR_DOC_MATRIX(FROM_DATE DATE,
TO_DATE DATE,
ID_CONTRAGENT INTEGER,
ID_TYPE_PAYMENT INTEGER,
ID_BASE_DOC_TYPE INTEGER,
SRV_GROUP_TAG VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(DOC_DATA VARCHAR(30),
IS_ANUL SMALLINT,
CONTRAGENT_NAME VARCHAR(100),
USER_NAME VARCHAR(50),
COL_NAME VARCHAR(30),
COL_VALUE NUMERIC(15,4),
COL_ORIG_VALUE NUMERIC(15,4),
SORT_ORDER SMALLINT)
 AS
declare variable id_doc integer;
  declare variable tmp_id_contragent integer;
  declare variable doc_num varchar(20);
  declare variable doc_date date;
  declare variable payment_allowed smallint;
  declare variable doc_rate numeric(15,6);
  declare variable value_corr_idx numeric(15,2);
  declare variable doc_value numeric(15,4);
  declare variable nontaxable_value numeric(15,4);
  declare variable taxable_value numeric(15,4);
  declare variable tax_value numeric(15,4);
  declare variable tax_name varchar(50);
begin
  /* GROUP_TAGs : 'SRV_ACC', 'SRV_GRP' */

  VALUE_CORR_IDX = 1;
  ID_CONTRAGENT = case when :ID_CONTRAGENT = -1 then null else :ID_CONTRAGENT end;
  ID_TYPE_PAYMENT = case when :ID_TYPE_PAYMENT = -1 then null else :ID_TYPE_PAYMENT end;
  ID_BASE_DOC_TYPE = case when :ID_BASE_DOC_TYPE = -1 then null else :ID_BASE_DOC_TYPE end;

  for
    select DH.ID_DOC, DH.USER_CREATED, DC.ID_CONTRAGENT, DH.DOC_NUM,
           DH.REAL_DOC_DATE, DH.DOC_RATE, DH.IS_ANNUL_FLAG, DH.VALUE_CORR_IDX,
           DH.DOC_VALUE_A
    from   DOCUMENT_RELEASE_S DH
           join DOC_CONTRAGENT DC on DC.ID_DOC_CONTRAGENT = DH.ID_DOC_CONTRAGENT
           join DOC_TYPE DT on DT.ID_DOC_TYPE = DH.ID_DOC_TYPE
           join ACCOUNT A on A.ID_ACCOUNT = DH.ID_ACCOUNT
    where  A.ID_HOTEL = :ID_HOTEL
           and DH.RPT_DOC_DATE between :FROM_DATE and :TO_DATE
           and DC.ID_CONTRAGENT is not distinct from coalesce(:ID_CONTRAGENT, DC.ID_CONTRAGENT)
           and DT.ID_DOC_TYPE is not distinct from coalesce(:ID_BASE_DOC_TYPE, DT.ID_DOC_TYPE)
    order by 1
    into   :id_doc, :user_name, :tmp_id_contragent, :doc_num,
           :doc_date, :doc_rate, :is_anul, :value_corr_idx, :doc_value
  do begin
    PAYMENT_ALLOWED = 0;
    if ((:ID_TYPE_PAYMENT is null)
        or (exists (select P.ID_PAYMENT_HEAD
                    from   DOCUMENT_PAYMENT P
                    where  P.ID_DOC_HEAD = :ID_DOC
                           and P.ID_PAYMENT_TYPE = :ID_TYPE_PAYMENT)) ) then
    begin
      PAYMENT_ALLOWED = 1;
    end

    if (:PAYMENT_ALLOWED = 1) then begin
      CONTRAGENT_NAME = null;
      select  C.CONTRAGENT_NAME
      from    CONTRAGENTS C
      where   C.ID_CONTRAGENT = :TMP_ID_CONTRAGENT
      into    :CONTRAGENT_NAME;
      CONTRAGENT_NAME = coalesce(:CONTRAGENT_NAME, '-');

      DOC_DATA = case when :is_anul = 1 then '*' else ' ' end
                 || f_padright(:doc_num, ' ', 10)
                 || ' / ' || formatdate(:doc_date, 'D;dd.mm.yyyy');

      for
        select   cast(case
                        when cast(:SRV_GROUP_TAG as varchar(20))  = 'SRV_ACC' then S.ACCOUNT_NAME
                        when cast(:SRV_GROUP_TAG as varchar(20)) = 'SRV_GRP' then SG.GROUP_NAME
                        else ''
                      end as varchar(30)),
                 sum(D.WOT_VAT * cast(:DOC_RATE as numeric(15,6)) * :VALUE_CORR_IDX), 100
        from     DOC_LINE D
                 join SERVICES S on D.ID_SERVICE = S.ID_SERVICE
                 join SERVICE_GROUPS SG on SG.ID_SERVICE_GROUP = S.ID_SERVICE_GROUP
        where    D.ID_DOC_HEAD = :ID_DOC     
                 and cast(:SRV_GROUP_TAG as varchar(20)) <> ''
        group by 1
        union all
        select   cast(PT.PAYMENT_TYPE as varchar(30)),
                 sum(PH.NAT_VALUE), 200
        from     DOCUMENT_PAYMENT PH
                 join PAYMENT_TYPE PT on PT.ID_PAYMENT_TYPE = PH.ID_PAYMENT_TYPE
        where    PH.ID_DOC_HEAD = :ID_DOC
                 and PH.REALIZE_DATE between :FROM_DATE and :TO_DATE
--                 and :is_anul = 0
        group by 1
        into     :COL_NAME, :COL_ORIG_VALUE, :SORT_ORDER
      do begin
        /********************/
        /*   FINAL MAKEUP   */  
        /********************/
        COL_NAME = substring(:COL_NAME from 1 for 11);
        COL_VALUE = :COL_ORIG_VALUE; --  * :VALUE_CORR_IDX;
        suspend;
      end
      /********************/  
      /*     SUMMARY      */  
      /********************/
      for
        select t.NONTAXABLE_VALUE, t.TAXABLE_VALUE, t.TAX_VALUE, t.TAX_NAME
        from   DOC_TAXES t
        where  t.ID_DOC_HEAD = :id_doc
        into   :nontaxable_value, :taxable_value, :tax_value, :tax_name
      do begin
        if (:nontaxable_value <> 0) then begin
          COL_NAME = '@nontaxable';
          COL_ORIG_VALUE = :nontaxable_value;
          COL_VALUE = :nontaxable_value * cast(:DOC_RATE as numeric(15,6)) * :VALUE_CORR_IDX;
          SORT_ORDER = 300;
          suspend;
        end
        if (:taxable_value <> 0) then begin
          COL_NAME = '@taxable';
          COL_ORIG_VALUE = :taxable_value;
          COL_VALUE = :taxable_value * cast(:DOC_RATE as numeric(15,6)) * :VALUE_CORR_IDX;
          SORT_ORDER = 301;
          suspend;
        end
        if (:tax_value <> 0) then begin
          COL_NAME = :tax_name;
          COL_ORIG_VALUE = :tax_value;
          COL_VALUE = :tax_value * cast(:DOC_RATE as numeric(15,6)) * :VALUE_CORR_IDX;
          SORT_ORDER = 302;
          suspend;
        end
      end
      COL_NAME = '@total';
      COL_ORIG_VALUE = :doc_value;
      COL_VALUE = :doc_value * cast(:DOC_RATE as numeric(15,6)) * :VALUE_CORR_IDX;
      SORT_ORDER = 303;
      suspend;
    end
  end
end
^

/* Alter (SPR_HOTEL_REGISTER) */
ALTER PROCEDURE SPR_HOTEL_REGISTER(IN_FROM DATE,
IN_TO DATE,
IN_FROM_GUEST INTEGER,
IN_TO_GUEST INTEGER,
IN_MASK VARCHAR(10),
ID_HOTEL INTEGER = null)
 RETURNS(ID_GUEST INTEGER,
GUEST_NAME VARCHAR(100),
ROOM_NAME VARCHAR(10),
CITIZENSHIP_EGN VARCHAR(65),
PERIOD_FROM DATE,
PERIOD_TO DATE,
NIGHTS INTEGER,
RESERVATION VARCHAR(100),
ID_ACCOUNT_NIGHTS VARCHAR(30),
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
ADDRESS_BULGARIAN VARCHAR(100),
PASSPORT VARCHAR(40),
NOTE VARCHAR(255))
 AS
declare variable egn varchar(50);
  declare variable country_code varchar(20);
  declare variable country varchar(50);
  declare variable id_account integer;
  declare variable address varchar(100);
  declare variable city varchar(100);
  declare variable pass_num varchar(20);
  declare variable pass_date date;
  declare variable mask varchar(10);
begin
  select  coalesce((select first 1 cast(:in_mask as varchar(10))
                   from   USER_RIGHTS R
                   where  R.RIGHT_CODE = 'MASK_DIFF_FROM_DEF'),
                  (select iif(coalesce(nullif(cast(:in_mask as varchar(10)), ''), SGV.SETTING_VALUE) is distinct from SGV.SETTING_VALUE, 'unknown', SGV.SETTING_VALUE)
                   from   SETTING_GET_VALUE('DEF_GUEST_MASK', :id_hotel) SGV))
  from    dummy
  into    :in_mask;
  
  for
    select G.ID_GUEST, GC.GUEST_NAME1, R.ROOM_NAME, GC.COUNTRY, CN.COUNTRY_NAME,
           GC.EGN, G.FROM_DATE, G.TO_DATE, G.ID_ACCOUNT, GC.BIRTH_DAY, GC.BIRTH_PLACE,
           GC.ADDRESS, gc.SITY, GC.PASS_NUM, GC.PASS_DATE, GC.MASK, RD.NUMBER
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
           left outer join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
           left outer join ROOMS R on G.ID_ROOM = R.ID_ROOM
           left outer join COUNTRY CN on CN.COUNTRY_CODE = GC.COUNTRY
    where  G.FROM_DATE between :IN_FROM and :IN_TO
           and rd.IS_ANUL = 0
           and RD.CHECK_STATUS >= 0
           and ((RD.ID_HOTEL = :id_hotel) or (:id_hotel is null))
    into   :ID_GUEST, :GUEST_NAME, :ROOM_NAME, :COUNTRY_CODE, :COUNTRY,
           :EGN, :PERIOD_FROM, :PERIOD_TO, :ID_ACCOUNT, :BIRTH_DATE, :BIRTH_PLACE,
           :ADDRESS, :city, :PASS_NUM, :PASS_DATE, :MASK, :RESERVATION
  do begin
    CITIZENSHIP_EGN = :COUNTRY;

    if ((:EGN is not null) and (EGN <> '')) then
      CITIZENSHIP_EGN = :CITIZENSHIP_EGN || ' (' || :EGN || ')';

    if (upper(:COUNTRY_CODE) = 'BG') then begin
      ADDRESS_BULGARIAN = substring(iif(trim(coalesce(:city, '')) <> '', :city || ' ' || :address, :address) from 1 for 100);
    end else begin
      ADDRESS_BULGARIAN = '';
    end

    if (:PASS_NUM is null) then PASS_NUM = '';
    PASSPORT = :PASS_NUM;
    if (:PASS_DATE is not null and :PASS_DATE <> '30.12.1899') then
      PASSPORT = trim(:PASSPORT || FORMATDATE(:PASS_DATE,'D; dd/mm/yyyy'));

    NIGHTS = :PERIOD_TO - :PERIOD_FROM;
    ID_ACCOUNT_NIGHTS = ''|| :ID_ACCOUNT || ' (' || :NIGHTS || ')';
    NOTE = '';
    if (((:IN_FROM_GUEST is null) or (:ID_GUEST >= :IN_FROM_GUEST))
        and ((:IN_TO_GUEST is null) or (:ID_GUEST <= IN_TO_GUEST))
        and ((:IN_MASK is null) or (:IN_MASK = '') or (:MASK like '%' || :IN_MASK||'%'))) then
      suspend;
  end
end
^

/* Alter (SUMMARY_FINANCE_STATISTIC$EW) */
ALTER PROCEDURE SUMMARY_FINANCE_STATISTIC$EW(ID_END_WORK INTEGER)
 AS
declare variable id_hotel integer;
  declare variable summary_date date;
begin
  select EW.ID_HOTEL, EW.PREV_DATE
  from   END_WORKS EW
  where  EW.ID_END_WORK = :ID_END_WORK
  into   :id_hotel, :summary_date;

  /* summarize affected postings && payments */
  execute procedure ACCOUNT_POSTS_EW_MARK$INT (:ID_END_WORK);

  execute procedure ACCOUNT_DEBT_FILL$INT(:ID_END_WORK);

  insert into SUMMARY_END_WORK (ID_END_WORK, ID_HOTEL, SUMMARY_DATE,
         REVENUE_AMOUNT, CORRECTION_AMOUNT, DOC_TAXES_AMOUNT, VAT_AMOUNT,
         DISCOUNTS_AMOUNT, PAYMENT_AMOUNT, PAYMENT_TRANSACTIONS,
         FISCAL_PAY_AMOUNT, FISCAL_PAY_TRANSACTIONS, DEPOSIT_AMOUNT)
  values (:ID_END_WORK, :ID_HOTEL, :SUMMARY_DATE, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);

  execute procedure REVENUE_EW_SUMMARIZE$INT (:ID_END_WORK, 'full');

  execute procedure PAYMENTS_EW_SUMMARIZE$INT (:ID_END_WORK);

end
^

/* empty dependent procedure body */
/* Clear: OCCUPANCY_SUMMARY_REMAKE$SYS for: SUMMARY_OCCUPANCY_STATISTIC$INT */
ALTER PROCEDURE OCCUPANCY_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SUMMARY_STATISTIC_REBUILD$EW for: SUMMARY_OCCUPANCY_STATISTIC$INT */
ALTER PROCEDURE SUMMARY_STATISTIC_REBUILD$EW(ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (SUMMARY_OCCUPANCY_STATISTIC$INT) */
ALTER PROCEDURE SUMMARY_OCCUPANCY_STATISTIC$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
declare variable busy_date date;
  declare variable id_room_type integer;
  declare variable id_profile_agent integer;
  declare variable country_code varchar(20);
  declare variable market_segment_code varchar(3);
  declare variable source_code varchar(3);
  declare variable channel_code varchar(3);
  declare variable hear_reason_code varchar(3);
  declare variable come_reason_code varchar(3);
  declare variable rooms_noshow smallint;
  declare variable rooms_canceled smallint;

  declare variable rooms_ooi smallint;
  declare variable rooms_ooo smallint;

  declare variable rooms_sold smallint;
  declare variable rooms_sold_multiple_gst smallint;
  declare variable rooms_arrival smallint;
  declare variable rooms_departure smallint;
  declare variable ad_in_house smallint;
  declare variable ad_arrival smallint;
  declare variable ad_departure smallint;
  declare variable ch_in_house smallint;
  declare variable ch_arrival smallint;
  declare variable ch_departure smallint;
  declare variable guests_noshow smallint;
  declare variable guests_day_use smallint;
begin
  -- REBUILD THE "NO SLICE"
  delete from SUMMARY_OCCUPANCY D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY (ID_ROOM_TYPE, FOR_DATE, ROOMS_AVAILABLE, ID_HOTEL)
  select RC.ID_ROOM_TYPE, RC.FOR_DATE, sum(RC.CNT_DEFINED), :id_hotel
  from   HOTEL H
         left outer join ALLOTMENT_GET$INT(H.ID_INVENTORY_ALLOTMENT, :from_date, :to_date, null, 'PLAIN_PERIOD', H.ID_HOTEL) RC on 0=0
  where  H.ID_HOTEL = :id_hotel
         and RC.ID_ROOM_TYPE is not null
  group by 1, 2;

  for
    select RO.ID_ROOM_TYPE, RO.BUSY_DATE,
           sum(RO.OOI_ROOM), sum(RO.OOO_ROOM),
           sum(RO.ARRIVAL_ROOM + ro.STAYOVER_ROOM) as sold_rooms,
           sum(RO.MULTIPLE_GUEST_ROOM),
           sum(RO.ARRIVAL_ROOM),
           sum(RO.DEPARTURE_ROOM),
           sum(RO.ARRIVAL_ADULTS + ro.STAYOVER_ADULTS - ro.DAY_USE_ADULTS) as AD_IN_HOUSE,
           sum(RO.ARRIVAL_ADULTS),
           sum(RO.DEPARTURE_ADULTS),
           sum(RO.ARRIVAL_CHILDREN + ro.STAYOVER_CHILDREN - ro.DAY_USE_CHILDREN) as CH_IN_HOUSE,
           sum(RO.ARRIVAL_CHILDREN),
           sum(RO.DEPARTURE_CHILDREN),
           sum(RO.DAY_USE_ADULTS + ro.DAY_USE_CHILDREN)
    from   HOTEL_ROOM_OCCUPANCY ro
    where  ro.ID_HOTEL = :id_hotel
           and ro.BUSY_DATE between :from_date and :to_date
           and ro.BUSY_GROUP_TYPE > 1 -- excludes expected bookings
    group by RO.ID_ROOM_TYPE, RO.BUSY_DATE
    into   :id_room_type, :busy_date,
           :rooms_ooi, :rooms_ooo,
           :rooms_sold, :rooms_sold_multiple_gst, :rooms_arrival, :rooms_departure,
           :ad_in_house, :ad_arrival, :ad_departure,
           :ch_in_house, :ch_arrival, :ch_departure, :guests_day_use
  do begin
    update or insert into SUMMARY_OCCUPANCY (ID_ROOM_TYPE, FOR_DATE, ROOMS_OOI, ROOMS_OOO, ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST,
           ROOMS_ARRIVAL, ROOMS_DEPARTURE, GST_AD_IN_HOUSE, GST_AD_ARRIVAL, GST_AD_DEPARTURE,
           GST_CH_IN_HOUSE, GST_CH_ARRIVAL, GST_CH_DEPARTURE, GUESTS_DAY_USE)
    values (:id_room_type, :busy_date, :rooms_ooi, :rooms_ooo, :rooms_sold, :rooms_sold_multiple_gst,
           :rooms_arrival, :rooms_departure, :ad_in_house, :ad_arrival, :ad_departure,
           :ch_in_house, :ch_arrival, :ch_departure, :guests_day_use)
    matching (ID_ROOM_TYPE, FOR_DATE);
  end

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, 
           sum(M.ROOMS_NOSHOW), sum(M.ROOMS_CANCELED), sum(M.GUESTS_NOSHOW)
    from   RESERV_STATISTIC_CANCELED$INT(:id_hotel, :from_date, :to_date) M
    group by M.ID_ROOM_TYPE, M.BUSY_DATE
    into   :id_room_type, :busy_date, 
           :rooms_noshow, :rooms_canceled, :guests_noshow
  do begin
    update SUMMARY_OCCUPANCY SO
    set    SO.ROOMS_NOSHOW = :rooms_noshow,
           SO.ROOMS_CANCELED = :rooms_canceled,
           SO.GUESTS_NOSHOW = :guests_noshow
    where  SO.FOR_DATE = :busy_date
           and SO.ID_ROOM_TYPE = :id_room_type;

  end

  -- REBUILD THE "MARKET SLICE"
  delete from SUMMARY_OCCUPANCY_MARKET D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY_MARKET (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
         MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
         ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST, ROOMS_ARRIVAL, ROOMS_DEPARTURE,
         ROOMS_NOSHOW, ROOMS_CANCELED, GUESTS_IN_HOUSE,
         GUESTS_ARRIVAL, GUESTS_DEPARTURE, GUESTS_DAY_USE)
  select M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL,
         S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE,
         sum(m.ARRIVAL_ROOM + m.STAYOVER_ROOM), sum(M.MULTIPLE_GUEST_ROOM), sum(M.ARRIVAL_ROOM), sum(M.DEPARTURE_ROOM),
         0, 0, sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN + m.STAYOVER_ADULTS + m.STAYOVER_CHILDREN - m.DAY_USE_ADULTS - m.DAY_USE_CHILDREN),
         sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN), sum(M.DEPARTURE_ADULTS + m.DEPARTURE_CHILDREN), sum(M.DAY_USE_ADULTS + m.DAY_USE_CHILDREN)
  from   HOTEL_ROOM_OCCUPANCY M
         left outer join RESERV_STATISTIC_SLICE$INT (m.ID_RESERV_STATISTICS) s on 1=1
  where  m.ID_HOTEL = :id_hotel
         and m.BUSY_DATE between :from_date and :to_date
         and m.BUSY_GROUP_TYPE > 1 -- excludes expected bookings
  group by M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL,
         S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE;

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, 
           M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE,
           sum(M.ROOMS_NOSHOW), sum(M.ROOMS_CANCELED)
    from   RESERV_STATISTIC_CANCELED$INT(:id_hotel, :from_date, :to_date) M
    group by M.ID_ROOM_TYPE, M.BUSY_DATE, M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE
    into   :id_room_type, :busy_date,
           :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
           :rooms_noshow, :rooms_canceled
  do begin
    update SUMMARY_OCCUPANCY_MARKET MA
    set    MA.ROOMS_NOSHOW = :rooms_noshow,
           MA.ROOMS_CANCELED = :rooms_canceled
    where  MA.FOR_DATE = :busy_date
           and MA.ID_ROOM_TYPE = :id_room_type
           and MA.MARKET_SEGMENT_CODE = :market_segment_code
           and MA.SOURCE_CODE = :source_code
           and MA.CHANNEL_CODE = :channel_code
           and MA.HEAR_REASON_CODE = :hear_reason_code
           and MA.COME_REASON_CODE = :come_reason_code;
    if (row_count = 0) then begin
      insert into SUMMARY_OCCUPANCY_MARKET (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
             MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
             ROOMS_NOSHOW, ROOMS_CANCELED)
      values (:id_room_type, :busy_date, :id_hotel,
             :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
             :rooms_noshow, :rooms_canceled);
    end
  end

  -- REBUILD THE "PROFILE/COUNTRY SLICE"
  delete from SUMMARY_OCCUPANCY_OTHER D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY_OTHER (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL, ID_PROFILE_AGENT, COUNTRY_CODE,
         ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST, ROOMS_ARRIVAL, ROOMS_DEPARTURE,
         ROOMS_NOSHOW, ROOMS_CANCELED, GUESTS_IN_HOUSE, GUESTS_ARRIVAL, GUESTS_DEPARTURE, GUESTS_DAY_USE)
  select M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL, S.ID_PROFILE_AGENT, S.COUNTRY_CODE,
         sum(m.ARRIVAL_ROOM + m.STAYOVER_ROOM), sum(M.MULTIPLE_GUEST_ROOM), sum(M.ARRIVAL_ROOM), sum(M.DEPARTURE_ROOM),
         0, 0, sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN + m.STAYOVER_ADULTS + m.STAYOVER_CHILDREN - m.DAY_USE_ADULTS - m.DAY_USE_CHILDREN),
         sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN), sum(M.DEPARTURE_ADULTS + m.DEPARTURE_CHILDREN), sum(M.DAY_USE_ADULTS + m.DAY_USE_CHILDREN)
  from   HOTEL_ROOM_OCCUPANCY M
         left outer join RESERV_STATISTIC_SLICE$INT (m.ID_RESERV_STATISTICS) s on 1=1
  where  m.ID_HOTEL = :id_hotel
         and m.BUSY_DATE between :from_date and :to_date
         and m.BUSY_GROUP_TYPE > 1 -- excludes expected bookings
  group by M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL, S.ID_PROFILE_AGENT, S.COUNTRY_CODE;

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, M.ID_PROFILE_AGENT, M.COUNTRY_CODE,
           sum(M.ROOMS_NOSHOW), sum(M.ROOMS_CANCELED)
    from   RESERV_STATISTIC_CANCELED$INT(:id_hotel, :from_date, :to_date) M
    group by M.ID_ROOM_TYPE, M.BUSY_DATE, M.ID_PROFILE_AGENT, M.COUNTRY_CODE
    into   :id_room_type, :busy_date, :id_profile_agent, :country_code,
           :rooms_noshow, :rooms_canceled
  do begin

    update SUMMARY_OCCUPANCY_OTHER MA
    set    MA.ROOMS_NOSHOW = :rooms_noshow,
           MA.ROOMS_CANCELED = :rooms_canceled
    where  MA.FOR_DATE = :busy_date
           and MA.ID_ROOM_TYPE = :id_room_type
           and MA.ID_PROFILE_AGENT = :id_profile_agent
           and MA.COUNTRY_CODE = :country_code;
    if (row_count = 0) then begin
      insert into SUMMARY_OCCUPANCY_OTHER (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
             ID_PROFILE_AGENT, COUNTRY_CODE, ROOMS_NOSHOW, ROOMS_CANCELED)
      values (:id_room_type, :busy_date, :id_hotel,
             :id_profile_agent, :country_code, :rooms_noshow, :rooms_canceled);
    end
  end

  -- REBUILD THE "PROFILE/MARKETING SLICE"
  delete from SUMMARY_OCCUPANCY_PROFILE_MRKT D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY_PROFILE_MRKT (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL, ID_PROFILE_AGENT,
         MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
         ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST, ROOMS_ARRIVAL, ROOMS_DEPARTURE,
         ROOMS_NOSHOW, ROOMS_CANCELED, GUESTS_IN_HOUSE, GUESTS_ARRIVAL, GUESTS_DEPARTURE, GUESTS_DAY_USE)
  select M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL, S.ID_PROFILE_AGENT,
         S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE,
         sum(m.ARRIVAL_ROOM + m.STAYOVER_ROOM), sum(M.MULTIPLE_GUEST_ROOM), sum(M.ARRIVAL_ROOM), sum(M.DEPARTURE_ROOM),
         0, 0, sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN + m.STAYOVER_ADULTS + m.STAYOVER_CHILDREN - m.DAY_USE_ADULTS - m.DAY_USE_CHILDREN),
         sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN), sum(M.DEPARTURE_ADULTS + m.DEPARTURE_CHILDREN), sum(M.DAY_USE_ADULTS + m.DAY_USE_CHILDREN)
  from   HOTEL_ROOM_OCCUPANCY M
         left outer join RESERV_STATISTIC_SLICE$INT (m.ID_RESERV_STATISTICS) s on 1=1
  where  m.ID_HOTEL = :id_hotel
         and m.BUSY_DATE between :from_date and :to_date
         and m.BUSY_GROUP_TYPE > 1 -- excludes expected bookings
  group by M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL, s.ID_PROFILE_AGENT,
         S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE;

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, M.ID_PROFILE_AGENT,
           M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE,
           sum(M.ROOMS_NOSHOW), sum(M.ROOMS_CANCELED)
    from   RESERV_STATISTIC_CANCELED$INT(:id_hotel, :from_date, :to_date) M
    group by M.ID_ROOM_TYPE, M.BUSY_DATE, M.ID_PROFILE_AGENT,
           M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE
    into   :id_room_type, :busy_date,  :id_profile_agent,
           :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
           :rooms_noshow, :rooms_canceled
  do begin

    update SUMMARY_OCCUPANCY_PROFILE_MRKT MA
    set    MA.ROOMS_NOSHOW = :rooms_noshow,
           MA.ROOMS_CANCELED = :rooms_canceled
    where  MA.FOR_DATE = :busy_date
           and MA.ID_ROOM_TYPE = :id_room_type
           and MA.ID_PROFILE_AGENT = :id_profile_agent
           and MA.MARKET_SEGMENT_CODE = :market_segment_code
           and MA.SOURCE_CODE = :source_code
           and MA.CHANNEL_CODE = :channel_code
           and MA.HEAR_REASON_CODE = :hear_reason_code
           and MA.COME_REASON_CODE = :come_reason_code;
    if (row_count = 0) then begin
      insert into SUMMARY_OCCUPANCY_PROFILE_MRKT (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL, ID_PROFILE_AGENT,
             MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
             ROOMS_NOSHOW, ROOMS_CANCELED)
      values (:id_room_type, :busy_date, :id_hotel, :id_profile_agent,
             :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
             :rooms_noshow, :rooms_canceled);
    end
  end
end
^

/* Alter (SUMMARY_STATISTIC_REBUILD$EW) */
ALTER PROCEDURE SUMMARY_STATISTIC_REBUILD$EW(ID_HOTEL INTEGER)
 AS
declare variable id_end_work integer;
  declare variable summary_date date;
  declare variable system_date date;
  declare variable reservs_count integer;
begin
  execute procedure SYSTEM_DATE_GET (:ID_HOTEL)
  returning_values :system_date;

  for
    select d.REBUILD_DATE, count(rd.ID_RESERV_DETAIL)
    from   SUMMARY_REBUILD_DATE d
           left outer join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = d.ID_RESERV
    where  d.ID_HOTEL = :ID_HOTEL
           and d.REBUILD_DATE < :system_date --!!! rebuild old ew dates only
    group by d.REBUILD_DATE
    into   :summary_date, :reservs_count
  do begin
    execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:id_hotel, :summary_date, :summary_date);

    if (:reservs_count > 0) then begin
      id_end_work = null;
      select first 1 ew.ID_END_WORK
      from   END_WORKS ew
      where  ew.PREV_DATE = :summary_date
             and ew.NEXT_DATE > :summary_date
             and ew.END_WORK_KIND = '3'
             and ew.ID_HOTEL = :ID_HOTEL
      into   :id_end_work;

      if (:id_end_work is not null) then
         execute procedure REVENUE_EW_SUMMARIZE$INT (:id_end_work, 'statistic');
    end
  end

  delete from SUMMARY_REBUILD_DATE rd where rd.ID_HOTEL = :ID_HOTEL;
end
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_TRANSFER$INT for: SYSTEM_EVENT_LOG$INT */
ALTER PROCEDURE DEPOSIT_TRANSFER$INT(ID_DEPOSIT /* TYPE OF ID */ INTEGER,
ID_DEST_ACCOUNT /* TYPE OF ID */ INTEGER,
SPLIT_AMOUNT /* TYPE OF TPRICE */ NUMERIC(15,4),
DEPOSIT_DESCRIPTION /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
TRANSFER_REASON /* TYPE OF TREASON */ VARCHAR(50) = null)
 RETURNS(NEW_ID_DEPOSIT /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SALE_TAXATION_MODIFY$CFG for: SYSTEM_EVENT_LOG$INT */
ALTER PROCEDURE SALE_TAXATION_MODIFY$CFG(ID_SALE_TAXATION /* TYPE OF ID */ INTEGER,
NAME /* TYPE OF TOBJECT_NAME */ VARCHAR(50),
TAXES VARCHAR(250),
ACCOUNT_NAME /* TYPE OF TOBJECT_NAME */ VARCHAR(50),
OPERATION VARCHAR(10),
ID_HOTEL /* TYPE OF ID */ INTEGER)
 RETURNS(NEW_ID_SALE_TAXATION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SYSTEM_LOG_ADD for: SYSTEM_EVENT_LOG$INT */
ALTER PROCEDURE SYSTEM_LOG_ADD(OBJECT_CLASS VARCHAR(30),
OBJECT_ID INTEGER,
ACTION_CODE VARCHAR(50),
ACTION_TEXT VARCHAR(255),
EXTRA_DATA VARCHAR(255) = null)
 AS
 BEGIN EXIT; END
^

/* Alter (SYSTEM_EVENT_LOG$INT) */
ALTER PROCEDURE SYSTEM_EVENT_LOG$INT(OBJECT_CLASS VARCHAR(30),
OBJECT_ID INTEGER,
EVENT_CODE VARCHAR(50),
EVENT_TEXT VARCHAR(255),
EXTRA_DATA VARCHAR(255) = null)
 RETURNS(NEW_ID_SYSTEM_LOG INTEGER)
 AS
declare variable machine_name varchar(30);
  declare variable log_object_class varchar(30);
  declare variable log_object_id integer;
  declare variable action_ctx varchar(50);
begin
  if (RDB$GET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE') = 'disable') then EXIT;

  action_ctx = RDB$GET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX');

  execute procedure SYSTEM_SESSION_GET('MACHINE_NAME')
  returning_values  :machine_name;

  object_id = coalesce(object_id,0);
  log_object_class = :object_class;
  log_object_id = :object_id;


  new_id_system_log = gen_id(gen_system_log_id, 1);

  insert into SYSTEM_LOG_EVENT (ID_SYSTEM_LOG, LOG_OBJECT_CLASS, LOG_OBJECT_ID, ACTION_CODE,
         ACTION_DATETIME, ACTION_USER, MACHINE_NAME, ACTION_TEXT, ACTION_CTX)
  values (:new_id_system_log, :log_object_class, :log_object_id, :event_code,
         current_timestamp, current_user, :machine_name, :event_text, :action_ctx);

  -- get related bookings
  if (:OBJECT_CLASS = 'RES_DETAIL') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    values (:OBJECT_ID, :new_id_system_log);
  end else if (:OBJECT_CLASS = 'GUEST') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select G.ID_RESERV_DETAIL, :new_id_system_log
    from   GUEST G
    where  G.ID_GUEST = :OBJECT_ID;
  end else if (:OBJECT_CLASS = 'DOCUMENT') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select A.ID_RESERV_DETAIL, :new_id_system_log
    from   DOC_HEAD D
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  D.ID_DOC = :OBJECT_ID
           and A.ID_RESERV_DETAIL is not null;
  end else if (:OBJECT_CLASS = 'DEPOSIT') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select A.ID_RESERV_DETAIL, :new_id_system_log
    from   DEPOSIT D
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  D.ID_DEPOSIT = :OBJECT_ID
           and A.ID_RESERV_DETAIL is not null;
  end else if (:OBJECT_CLASS = 'PAYMENT') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select distinct A.ID_RESERV_DETAIL, :new_id_system_log
    from   PAYMENT_HEAD P
           join DEPOSIT D on D.ID_PAYMENT_HEAD = P.ID_PAYMENT_HEAD
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  P.ID_PAYMENT_HEAD = :OBJECT_ID
           and A.ID_RESERV_DETAIL is not null;
  end else if (:OBJECT_CLASS = 'ACCOUNT') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select A.ID_RESERV_DETAIL, :new_id_system_log
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OBJECT_ID
           and A.ID_RESERV_DETAIL is not null;
  end

  if (:EVENT_CODE = 'DELETE') then begin
    insert into SYSTEM_LOG_DELETED (LOG_OBJECT_CLASS, LOG_OBJECT_ID, DESCRIPTION, HOTEL_CODE)
    select :log_object_class, :log_object_id, SL.OBJECT_DESCRIPTION, SL.HOTEL_CODE
    from   SYSTEM_LOG_OBJECT_INFO_GET (:OBJECT_CLASS, :OBJECT_ID) SL;
  end

  if (:EXTRA_DATA is not null) then begin
    insert into SYSTEM_LOG_EXTRA (ID_SYSTEM_LOG, EXTRA_DATA)
    values (:new_id_system_log, :EXTRA_DATA);
  end

  if (exists(
    select *
    from   EAI_EVENTQ_PUBLISH P
    where  P.ACTION_CODE = :EVENT_CODE
  )) then post_event 'EAI_EVENTQ';

end
^

/* Alter (SYSTEM_GET_RIGHTS) */
ALTER PROCEDURE SYSTEM_GET_RIGHTS(USER_NAME VARCHAR(30))
 RETURNS(RIGHT_ITEM VARCHAR(100),
RIGHT_KIND VARCHAR(10))
 AS
begin
  if ((:user_name is null) or (:user_name = '')) then exception RIGHTS_ERR_LOGON;

  right_kind = 'right';
  for 
    select distinct UR.RIGHT_CODE
    from   USER_RIGHTS UR
    into   :right_item
  do suspend ;

  right_kind = 'report';
  for
    select distinct RGR.REPORT_NAME
    from   RIGHTS_USER_GROUPS RUG
           join RIGHTS_GROUPS_REPORTS RGR on RUG.ID_RIGHT_GROUP = RGR.ID_RIGHT_GROUP
    where  RUG.USER_NAME = :user_name
    into :right_item
  do suspend;
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_MODIFY_TEMPLATE$PROFILE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_MODIFY_TEMPLATE$PROFILE(ID_ACC_TEMPLATE INTEGER,
TEMPLATE_NAME VARCHAR(40),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,4),
SECURITY_LEVEL INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
ID_TAX_POLICY INTEGER,
IS_ARCHIVE INTEGER,
OPERATION VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(NEW_ID_ACC_TEMPLATE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_ANUL for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_POSTING_ANUL(IN_ID_ACCOUNT_POST INTEGER,
IN_ANUL_REASON VARCHAR(70))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_MULTIANUL for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_POSTING_MULTIANUL(AP_LIST VARCHAR(4096),
ANUL_REASON VARCHAR(70))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_SET_CURRENCY$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_SET_CURRENCY$INT(A_DBKEY CHAR(8),
NEW_CURR CHAR(3))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACTIVITY_OFFER_COPY for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACTIVITY_OFFER_COPY(ID_ACTIVITY_OFFER /* TYPE OF ID */ INTEGER)
 RETURNS(NEW_ID_ACTIVITY_OFFER /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: AR_OWING_ADD$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE AR_OWING_ADD$INT(ID_PROFILE /* TYPE OF ID */ INTEGER,
SUM_OWING /* TYPE OF TPRICE */ NUMERIC(15,4),
CURR_OWING /* TYPE OF TCURRENCY */ CHAR(3),
ID_DOC_HEAD /* TYPE OF ID_REF */ INTEGER,
DUE_DATE /* TYPE OF TDATE */ DATE,
SYSTEM_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_AR_TYPE /* TYPE OF ID */ INTEGER,
ID_HOTEL /* TYPE OF ID */ INTEGER)
 RETURNS(NEW_ID_AR_OWING /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: AR_OWING_ANUL$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE AR_OWING_ANUL$INT(ID_AR_OWING /* TYPE OF ID */ INTEGER,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_MANUAL_ANUL /* TYPE OF TLOGICAL */ SMALLINT = 1)
 RETURNS(NEW_ID_AR_OWING /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: AR_OWING_PAYMENT_ADD$AR for: SYSTEM_LOG_ADD */
ALTER PROCEDURE AR_OWING_PAYMENT_ADD$AR(ID_AR_OWING INTEGER,
ID_AR_PAYMENT INTEGER,
SUM_OWING NUMERIC(15,4),
SUM_PAYMENT NUMERIC(15,4),
PAYMENT_RATE_TO_BGN NUMERIC(15,6),
OWING_RATE_TO_BGN NUMERIC(15,6),
DESCRIPTION VARCHAR(255))
 RETURNS(NEW_ID_AR_OWING_PAYMENT_POST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: AR_OWING_PAYMENT_ANUL$AR for: SYSTEM_LOG_ADD */
ALTER PROCEDURE AR_OWING_PAYMENT_ANUL$AR(ID_AR_OWING_PAYMENT_POST INTEGER,
DESCRIPTION VARCHAR(255))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: AR_PAYMENT_ADD$AR for: SYSTEM_LOG_ADD */
ALTER PROCEDURE AR_PAYMENT_ADD$AR(ID_PROFILE /* TYPE OF ID */ INTEGER,
ID_AR_PAYMENT_TYPE /* TYPE OF ID_REF */ INTEGER,
ACCOUNT_NAME /* TYPE OF TNAME_SHORT */ VARCHAR(30),
SUM_PAYMENT /* TYPE OF TPRICE */ NUMERIC(15,4),
CURR_PAYMENT /* TYPE OF TCURRENCY */ CHAR(3),
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
DATE_PAYMENT /* TYPE OF TDATE */ DATE)
 RETURNS(NEW_ID_AR_PAYMENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: AR_PAYMENT_ANUL$AR for: SYSTEM_LOG_ADD */
ALTER PROCEDURE AR_PAYMENT_ANUL$AR(ID_AR_PAYMENT INTEGER,
DESCRIPTION VARCHAR(255))
 RETURNS(NEW_ID_AR_PAYMENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: BLOCK_ANNUL$BLK for: SYSTEM_LOG_ADD */
ALTER PROCEDURE BLOCK_ANNUL$BLK(ID_BLOCK_ROOM INTEGER,
OPERATION VARCHAR(30))
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: BLOCK_CREATE$BLK for: SYSTEM_LOG_ADD */
ALTER PROCEDURE BLOCK_CREATE$BLK(ROOM_NAMES /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_HOTEL /* TYPE OF ID */ INTEGER,
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
BLOCK_GRP /* TYPE OF TRANGE */ INTEGER,
REASON /* TYPE OF TREASON */ VARCHAR(50),
NOTE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_FULL_FROM /* TYPE OF TRANGE */ INTEGER,
IS_FULL_TO /* TYPE OF TRANGE */ INTEGER)
 RETURNS(NEW_ID_BLOCK_ROOM /* TYPE OF ID */ INTEGER,
SHARE_TRANSACTION_ID /* TYPE OF ID */ INTEGER,
SHARE_ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE /* TYPE OF ID */ INTEGER,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: BLOCK_MODIFY$BLK for: SYSTEM_LOG_ADD */
ALTER PROCEDURE BLOCK_MODIFY$BLK(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
IS_FULL_FROM INTEGER,
IS_FULL_TO INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: CONTRACT_CALENDAR_MODIFY$PMS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE CONTRACT_CALENDAR_MODIFY$PMS(ID_CONTRACT_CALENDAR_POST /* TYPE OF ID */ INTEGER,
ID_ROOM_CONTRACT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
IS_INCOME /* TYPE OF TLOGICAL */ SMALLINT,
SERVICE_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
ID_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
IS_ACC_POST_ITEM /* TYPE OF TLOGICAL */ SMALLINT,
POSTING_DATE_LIST /* TYPE OF TTEXT_EXTENDED */ VARCHAR(2000),
POSTING_PERIOD_DURATION /* TYPE OF TCOUNT */ INTEGER,
MONTH_NEXT_DATE /* TYPE OF TDATE */ DATE,
IS_FIXED_DATE /* TYPE OF TLOGICAL */ SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_CALENDAR_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: CONTRACT_EXPENSE_MODIFY$PMS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE CONTRACT_EXPENSE_MODIFY$PMS(ID_CONTRACT_EXPENSE /* TYPE OF ID */ INTEGER,
ID_CONTRACT /* TYPE OF ID */ INTEGER,
SUB_CONTRACT /* TYPE OF TSUB_CONTRACT */ VARCHAR(10),
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
SERVICE_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
CONTRACT_EXPENSE_TYPE VARCHAR(50),
MULTIPLIER_TYPE VARCHAR(50),
ORDER_TAG /* TYPE OF TCOUNT */ INTEGER,
IS_ACC_POST_ITEM /* TYPE OF TLOGICAL */ SMALLINT,
ID_AGENT_PROFILE /* TYPE OF ID_REF */ INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_EXPENSE /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: CONTRACT_MANAGEMENT_MODIFY$PMS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE CONTRACT_MANAGEMENT_MODIFY$PMS(ID_CONTRACT_MANAGEMENT /* TYPE OF ID */ INTEGER,
ID_CONTRACT /* TYPE OF ID */ INTEGER,
SUB_CONTRACT /* TYPE OF TSUB_CONTRACT */ VARCHAR(10),
ID_SERVICE /* TYPE OF ID */ INTEGER,
MIN_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
MIN_VALUE_CURR /* TYPE OF TCURRENCY */ CHAR(3),
MAX_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
MAX_VALUE_CURR /* TYPE OF TCURRENCY */ CHAR(3),
NIGHT_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
NIGHT_PRICE_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IS_NETO /* TYPE OF TLOGICAL */ SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_MANAGEMENT /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: CURR_RATE_MODIFY for: SYSTEM_LOG_ADD */
ALTER PROCEDURE CURR_RATE_MODIFY(CURR CHAR(3),
ID_HOTEL INTEGER,
RATE NUMERIC(15,6),
FOR_DATE DATE = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_ANUL$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE DEPOSIT_ANUL$INT(ID_DEPOSIT INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_PAYMENT_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_REFUND_PAY_ANNUL$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE DEPOSIT_REFUND_PAY_ANNUL$INT(ID_REFUND_PAYMENT INTEGER,
ANNUL_REASON VARCHAR(255) = '')
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: EAI_AIRCONDITION_SMARTSTART for: SYSTEM_LOG_ADD */
ALTER PROCEDURE EAI_AIRCONDITION_SMARTSTART AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: EAI_EVENTQ_ADD for: SYSTEM_LOG_ADD */
ALTER PROCEDURE EAI_EVENTQ_ADD(EAI_IFC VARCHAR(50),
EVENT_CODE VARCHAR(50),
OBJECT_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: GUEST_ADDRESSCARD_SET$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA /* TDESCRIPTION_SHORT */ VARCHAR(100),
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PERSON_DATA_SET$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PERSON_DATA_SET$INT(P_DBKEY CHAR(8),
PD_DBKEY CHAR(8),
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
COUNTRY VARCHAR(10),
BIRTH_DAY DATE,
BIRTHDAY_INTERNAL DATE,
TITLE VARCHAR(10) = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONE_LINE_CONVERT_MODIFY$CFG for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PHONE_LINE_CONVERT_MODIFY$CFG(ID INTEGER,
LINE VARCHAR(30),
ROOM_NAME VARCHAR(30),
IS_TAXABLE SMALLINT,
IS_ARCHIVE SMALLINT,
PRICE_INDEX NUMERIC(15,4),
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER,
OPERATION VARCHAR(10))
 RETURNS(NEW_ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_AGENT_MODIFY$PROFILE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PROFILE_AGENT_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
AGENT_GROUP VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IATA_NUMBER VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null,
THRESHOLD_NOTE VARCHAR(255) = null,
THRESHOLD_AMOUNT NUMERIC(15,4) = null,
THRESHOLD_CURR CHAR(3) = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_DELETE$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PROFILE_DELETE$INT(ID_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_HOUSE_MODIFY$PROFILE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PROFILE_HOUSE_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(20),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
HOUSE_TYPE VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_MERGE$PROFILE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PROFILE_MERGE$PROFILE(ID_SOURCE INTEGER,
ID_TARGET INTEGER,
OPERATION VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_PERSON_CREATEQ$PROFILE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PROFILE_PERSON_CREATEQ$PROFILE(PROFILE_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100),
PHONE /* TYPE OF TPHONE */ VARCHAR(50),
ID_PASSPORT_TYPE /* TYPE OF ID */ INTEGER,
PASS_NUM /* TYPE OF NAME_20 */ VARCHAR(20),
EGN /* TYPE OF TTEXT_SHORT */ VARCHAR(30),
COUNTRY_CODE /* TYPE OF TSHORT_CODE */ VARCHAR(10),
CARD_CODE /* TYPE OF TCARD_CODE */ VARCHAR(50),
ID_PERSON_DATA /* TYPE OF ID_REF */ INTEGER = null,
TITLE /* TYPE OF TSHORT_CODE */ VARCHAR(10) = null,
ID_HOTEL /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_PROFILE /* TYPE OF ID */ INTEGER,
P_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
PD_DBKEY /* TYPE OF TDB_KEY */ CHAR(8))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_ADD$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_GUEST_ADD$INT(RD_DBKEY CHAR(8),
IS_CHILD INTEGER,
INITIALIZE_BOOKING /* TYPE OF TLOGICAL */ SMALLINT = 0)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_SAVE_OTHER$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_GUEST_SAVE_OTHER$RSV(ID_GUEST INTEGER,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUARANTEE$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_GUARANTEE$RSV(ID_RESERV_DETAIL INTEGER,
IS_VIP SMALLINT,
CHECK_STATUS INTEGER,
ID_GUARANTEE_POLICY INTEGER,
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_MARKETING$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_MARKETING$RSV(ID_RESERV_DETAIL INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_PRICE$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_PRICE$RSV(ID_RESERV_DETAIL INTEGER,
FOR_DATE DATE,
PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_RATE$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_RATE$INT(RD_DBKEY CHAR(8),
ID_RATE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_RATE$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_RATE$RSV(ID_RESERV_DETAIL INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
IS_DIFFERENT_TARIFF INTEGER,
IS_DIFFERENT_PRICE INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM_LOG$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_ROOM_LOG$INT(RD_DBKEY CHAR(8),
OLD_ID_ROOM INTEGER,
OLD_ID_RES_ROOM_TYPE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_STATUS$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_STATUS$INT(RD_DBKEY CHAR(8),
CHECK_STATUS INTEGER,
CONFIRMATION_NUMBER /* TYPE OF NAME_20 */ VARCHAR(20) = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_VOUCHER$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_VOUCHER$INT(RD_DBKEY CHAR(8),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_MULTI$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SET_ROOM_MULTI$RSV(OPERATION VARCHAR(20),
FROM_ROOM VARCHAR(20),
SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESERV_DETAIL_EXTERNAL_MOD$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RESERV_DETAIL_EXTERNAL_MOD$RSV(ID_RESERV_DETAIL INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
LOCATOR VARCHAR(100))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RESGRP_SAVE_OTHER$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RESGRP_SAVE_OTHER$INT(RD_DBKEY CHAR(8),
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: REVENUE_SUMMARY_REMAKE$SYS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE REVENUE_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
STATISTIC_ONLY SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RIGHTS_GROUP_MODIFY for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RIGHTS_GROUP_MODIFY(ID_RIGHT_GROUP INTEGER,
GROUP_NAME VARCHAR(20),
GROUP_DESCRIPTION VARCHAR(100),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_RIGHT_GROUP INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RIGHTS_GROUP_REPORTS_MODIFY for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RIGHTS_GROUP_REPORTS_MODIFY(ID_RIGHT_GROUP INTEGER,
REPORT_NAME VARCHAR(200),
OPERATION VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RIGHTS_GROUP_RIGHTS_MODIFY for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RIGHTS_GROUP_RIGHTS_MODIFY(ID_RIGHT_GROUP INTEGER,
RIGHT_CODE VARCHAR(30),
VALUE_CODE INTEGER,
OPERATION VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RIGHTS_GROUP_USER_MODIFY for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RIGHTS_GROUP_USER_MODIFY(USER_NAME VARCHAR(30),
ID_RIGHT_GROUP INTEGER,
OPERATION VARCHAR(50))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ROOM_CONTRACT_MODIFY$PMS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ROOM_CONTRACT_MODIFY$PMS(ID_ROOM_CONTRACT INTEGER,
ID_ROOM_PERIOD INTEGER,
CONTRACT_TYPE VARCHAR(50),
PMS_MARKERS BLOB SUB_TYPE 1 SEGMENT SIZE 100,
IMPORT_INCOME_WITH_VAT SMALLINT,
ID_RENTAL_POOL INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_CONTRACT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_MODIFY$PMS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ROOM_MODIFY$PMS(ID_ROOM INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
BEDS INTEGER,
EXTRA_BEDS INTEGER,
SECTOR INTEGER,
SORT_ORDER INTEGER,
FEATURES BLOB SUB_TYPE 1 SEGMENT SIZE 100,
EXTERNAL_NAME VARCHAR(20),
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER,
OPERATION VARCHAR(20))
 RETURNS(OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255),
NEW_ID_ROOM INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_OWNER_MODIFY$PMS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ROOM_OWNER_MODIFY$PMS(ID_ROOM_OWNER INTEGER,
ID_ROOM_CONTRACT INTEGER,
ID_OWNER INTEGER,
OWNERSHIP_PERCENT NUMERIC(15,4),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_OWNER INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_PERIOD_ADD$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ROOM_PERIOD_ADD$INT(ID_ROOM_PERIOD INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
STATUS VARCHAR(30))
 RETURNS(NEW_ID_ROOM_PERIOD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_PERIOD_DEL$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ROOM_PERIOD_DEL$INT(ID_ROOM_PERIOD INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ROOM_PERIOD_MODIFY$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ROOM_PERIOD_MODIFY$INT(ID_ROOM_PERIOD INTEGER,
FROM_DATE DATE,
STATUS VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SAFE_CHECK_OUT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE /* TYPE OF ID */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
WARN_CODE /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_ANNUL for: SYSTEM_LOG_ADD */
ALTER PROCEDURE SAFE_OCCUPANCY_ANNUL(ID_SAFE /* TYPE OF ID */ INTEGER,
REASON /* TYPE OF TREASON */ VARCHAR(50))
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SALE_TAX_MODIFY$CFG for: SYSTEM_LOG_ADD */
ALTER PROCEDURE SALE_TAX_MODIFY$CFG(ID_SALE_TAX INTEGER,
TAX_NAME VARCHAR(50),
TAX_PERCENT NUMERIC(15,4),
TAXABLE_BASE_PERCENT NUMERIC(15,4),
TAX_VALUE NUMERIC(15,4),
REVENUE_DEDUCTION_TAX SMALLINT,
REPORT_IN_DOCUMENT SMALLINT,
FISCAL_CODE VARCHAR(30),
ACCOUNT_NAME VARCHAR(50),
OPERATION VARCHAR(10),
ID_HOTEL /* TYPE OF ID */ INTEGER,
TAXATION_REASON /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255))
 RETURNS(NEW_ID_SALE_TAX INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SERVICE_TAXATION_MODIFY$CFG for: SYSTEM_LOG_ADD */
ALTER PROCEDURE SERVICE_TAXATION_MODIFY$CFG(ID_TAX_POLICY /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_SALE_TAXATION /* TYPE OF ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SETTINGS_MODIFY_VALUE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE SETTINGS_MODIFY_VALUE(SETTING_CODE /* TYPE OF TSEARCH_CODE */ VARCHAR(30),
SETTING_VALUE /* TYPE OF TOBJECT_TEXT */ VARCHAR(50),
ID_HOTEL /* TYPE OF ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SYSTEM_LOGON_USER for: SYSTEM_LOG_ADD */
ALTER PROCEDURE SYSTEM_LOGON_USER(OPERATION VARCHAR(20),
MACHINE_NAME VARCHAR(50))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE TAR_SAVE(ID_TAR_HEAD INTEGER,
PERIOD_DEPEND_ON_CHECKIN INTEGER,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BASE_BOARDS_LIST VARCHAR(255),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
BO_TYPE VARCHAR(20),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TASK_MODIFY for: SYSTEM_LOG_ADD */
ALTER PROCEDURE TASK_MODIFY(ID_TASK INTEGER,
DESCRIPTION VARCHAR(255),
DT_ACTIVATE TIMESTAMP,
STATUS SMALLINT,
TYPE_ SMALLINT,
PRIORITY SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_TASK INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAX_POLICY_MODIFY$CFG for: SYSTEM_LOG_ADD */
ALTER PROCEDURE TAX_POLICY_MODIFY$CFG(ID_TAX_POLICY /* TYPE OF ID */ INTEGER,
POLICY_NAME /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
IS_ARCHIVE /* TYPE OF TLOGICAL */ SMALLINT,
OPERATION VARCHAR(10),
ID_HOTEL /* TYPE OF ID */ INTEGER)
 RETURNS(NEW_ID_TAX_POLICY INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SYSTEM_LOG_ADD) */
ALTER PROCEDURE SYSTEM_LOG_ADD(OBJECT_CLASS VARCHAR(30),
OBJECT_ID INTEGER,
ACTION_CODE VARCHAR(50),
ACTION_TEXT VARCHAR(255),
EXTRA_DATA VARCHAR(255) = null)
 AS
declare variable new_id_system_log integer;
begin
  -- Description: fasade without output parameter (id)
  execute procedure SYSTEM_EVENT_LOG$INT(:OBJECT_CLASS, :OBJECT_ID, :ACTION_CODE, :ACTION_TEXT, :EXTRA_DATA)
  returning_values  :new_id_system_log;
end
^

/* Alter (SYSTEM_LOG_OBJECT_INFO_GET) */
ALTER PROCEDURE SYSTEM_LOG_OBJECT_INFO_GET(OBJECT_CLASS VARCHAR(30),
OBJECT_ID INTEGER)
 RETURNS(OBJECT_DESCRIPTION VARCHAR(100),
HOTEL_CODE VARCHAR(10))
 AS
declare variable id_hotel integer;
begin
  object_description = null;
  id_hotel = null;
  hotel_code = null;

  if (:OBJECT_CLASS = 'RES_DETAIL') then begin
    select substring(RD.NUMBER || ', '
           || coalesce(rt.TYPE_ROOM, '') || ', '
           || formatdate(rd.FROM_DATE, 'D;dd/mm') || '-'
           || formatdate(rd.TO_DATE, 'D;dd/mm/yy') || ', '
           || coalesce(P.PROFILE_NAME, '') from 1 for 100), RD.ID_HOTEL
    from   RESERV_DETAIL RD
           join PROFILE P on P.ID_PROFILE = RD.ID_PERSON_PROFILE
           left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = rd.ID_ROOM_TYPE
    where  RD.ID_RESERV_DETAIL = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'GUEST') then begin
    select pd.PERSON_NAME, rd.ID_HOTEL
    from   GUEST G
           join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
           join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  G.ID_GUEST = :OBJECT_ID
    into   :OBJECT_DESCRIPTION, :id_hotel;
  end else if (:OBJECT_CLASS = 'DOCUMENT') then begin
    select substring(d.DOC_TYPE_NAME || ' ' || D.DOC_NUM || '/' || formatdate(D.DOC_DATE, 'D;dd.mm.yyyy') from 1 for 100), A.ID_HOTEL
    from   DOC_HEAD D
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  D.ID_DOC = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'DEPOSIT') then begin
    select substring(D.DESCRIPTION || ', ' || P.DOC_TYPE_NAME || ' ' || P.PAYMENT_NUM || '/' || formatdate(P.PAYMENT_DATE, 'D;dd.mm.yyyy') from 1 for 100), A.ID_HOTEL
    from   DEPOSIT D
           join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  D.ID_DEPOSIT = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'ACCOUNT') then begin
    select A.ACCOUNT_NAME, A.ID_HOTEL
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'ACC_TEMPLATE') then begin
    select A.TEMPLATE_NAME, A.ID_HOTEL
    from   ACC_TEMPLATE A
    where  A.ID_ACC_TEMPLATE = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'TAX_POLICY') then begin
    select t.POLICY_NAME, t.ID_HOTEL
    from   TAX_POLICY t
    where  t.ID_TAX_POLICY = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'SALE_TAX') then begin
    select st.TAX_NAME, st.ID_HOTEL
    from   SALE_TAXES st
    where  st.ID_SALE_TAX = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'PROFILE') then begin
    select P.PROFILE_NAME, null
    from   PROFILE P
    where  P.ID_PROFILE = :OBJECT_ID
    into   :OBJECT_DESCRIPTION, :id_hotel;
  end else if (:OBJECT_CLASS = 'ACCOUNT_RECIEVABLE') then begin
    select P.PROFILE_NAME, null
    from   PROFILE P
    where  P.ID_PROFILE = :OBJECT_ID
    into   :OBJECT_DESCRIPTION, :id_hotel;
  end else if (:OBJECT_CLASS = 'BLOCK') then begin
    select substring(R.ROOM_NAME || ' (' || H.CODE || ')' from 1 for 100), H.ID_HOTEL
    from   BLOCK_ROOM BR     
           join ROOMS R on R.ID_ROOM = BR.ID_ROOM
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
           join HOTEL H on H.ID_HOTEL = R.ID_HOTEL
    where  BR.ID_BLOCK_ROOM = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'PAYMENT') then begin
    select substring(p.DOC_TYPE_NAME || ' ' || P.PAYMENT_NUM || '/' || formatdate(P.PAYMENT_DATE, 'D;dd.mm.yyyy') from 1 for 100), A.ID_HOTEL
    from   PAYMENT_HEAD P
           join ACCOUNT A on A.ID_ACCOUNT = P.ID_ACCOUNT
    where  P.ID_PAYMENT_HEAD = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'ROOM') then begin
    select r.ROOM_NAME, r.ID_HOTEL
    from   ROOMS R
    where  R.ID_ROOM = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'CONTRACT') then begin
    select substring(r.ROOM_NAME || ' {' || formatdate(rp.FROM_DATE, 'D;dd.mm.yyyy') || '-' || iif(extract(year from rp.TO_DATE) = 2500, '~', formatdate(rp.TO_DATE, 'dd.mm.yyyy')) || '}' from 1 for 255), r.ID_HOTEL
    from   ROOM_CONTRACT$PMS RC
           join ROOM_PERIOD$PMS rp on rp.ID_ROOM_PERIOD = rc.ID_ROOM_PERIOD
           join ROOMS R on r.ID_ROOM = rp.ID_ROOM
    where  Rc.ID_ROOM_CONTRACT = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'CURRENCY') then begin
    select c.CURR, c.ID_HOTEL
    from   CURR_RATES c
    where  c.ID_CURR_RATE = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'HOTEL') then begin
    select H.HOTEL_NAME, H.ID_HOTEL
    from   HOTEL H
    where  H.ID_HOTEL = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'SAFE') then begin
    select c.SAFE_NAME, c.ID_HOTEL
    from   SAFES c
    where  c.ID_SAFE = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'ACTIVITY_OFFER') then begin
    select ao.id_activity_offer, ao.id_hotel
    from   ACTIVITY_OFFER AO
    where  AO.ID_ACTIVITY_OFFER = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'RATE') then begin
    select t.TARIFA_NAME, t.ID_HOTEL
    from   TARIFA T
    where  T.ID_TARIFA = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'PHONE_LINES') then begin
    select pl.LINE, pl.ID_HOTEL
    from   PHONE_LINE_CONVERT PL
    where  PL.ID = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'DAY_END_WORK') then begin
    select ew.ID_END_WORK, ew.ID_HOTEL
    from END_WORKS ew
    where ew.ID_END_WORK = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'DOC_TYPE') then begin
    select dt.DOC_TYPE_NAME, dt.ID_HOTEL
    from DOC_TYPE dt
    where dt.ID_DOC_TYPE = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'PAYMENT_TYPE') then begin
    select dt.PAYMENT_TYPE, dt.ID_HOTEL
    from PAYMENT_TYPE dt
    where dt.ID_PAYMENT_TYPE = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'SERVICE') then begin
    select s.SERVICE_NAME, s.ID_HOTEL
    from SERVICES s
    where s.ID_SERVICE = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'CONTRAGENT') then begin
    select c.CONTRAGENT_NAME, null
    from CONTRAGENTS c
    where c.ID_CONTRAGENT = :OBJECT_ID
    into   :object_description, :id_hotel;
  end

  if (:OBJECT_DESCRIPTION is null) then begin
    select SLD.DESCRIPTION, sld.HOTEL_CODE
    from   SYSTEM_LOG_DELETED SLD
    where  SLD.LOG_OBJECT_CLASS = :OBJECT_CLASS
           and SLD.LOG_OBJECT_ID = :OBJECT_ID
    into   :OBJECT_DESCRIPTION, :HOTEL_CODE;
  end

  if (:id_hotel is not null) then
    select H.CODE
    from   HOTEL H
    where  H.ID_HOTEL = :id_hotel
    into   :hotel_code;

  suspend;
end
^

/* Alter (SYSTEM_LOGON_USER) */
ALTER PROCEDURE SYSTEM_LOGON_USER(OPERATION VARCHAR(20),
MACHINE_NAME VARCHAR(50))
 RETURNS(FISCAL_SESSION_ID INTEGER)
 AS
begin

  if (:operation = 'log_on') then begin
    execute procedure SYSTEM_SESSION_SET('MACHINE_NAME', :MACHINE_NAME);
    execute procedure SYSTEM_LOG_ADD ('SYSTEM', 0, 'APP_LOG_ON', '');

    execute procedure SYSTEM_SESSION_SET('LOGON_ID', gen_id(gen_system_log_id, 1));

    FISCAL_SESSION_ID = current_connection;
    execute procedure FISCAL_SESSION_UPDATE$FISC(:FISCAL_SESSION_ID, null);
  end else if (:operation = 'log_off') then begin
    execute procedure SYSTEM_LOG_ADD ('SYSTEM', 0, 'APP_LOG_OFF', '');

    delete from SYSTEM_SESSION ss
    where  ID_CONNECTION = current_connection
           and SESSION_KEY = 'FISCAL_DEVICE_ID';
    FISCAL_SESSION_ID = null;
  end
end
^

/* Alter (SYSTEM_NUM_GETINFO$CFG) */
ALTER PROCEDURE SYSTEM_NUM_GETINFO$CFG(ID_NUMERATOR INTEGER)
 RETURNS(IN_USE INTEGER,
NEXT_NUM_VALUE INTEGER,
NEXT_NUM_TEXT VARCHAR(20))
 AS
declare variable num_class varchar(20);
  declare variable leading_part varchar(20);
  declare variable max_len integer;
  declare variable num_value integer;
begin
  select SN.NUM_CLASS, SN.NUM_VALUE, SN.LEADING_PART, SN.NUM_LENGTH
  from   SYSTEM_NUMERATOR SN
  where  SN.ID_NUMERATOR = :id_numerator
  into   :num_class, :num_value, :leading_part, :max_len;

  in_use = 0;
  if (:num_class = 'DOCUMENT') then begin
    if (exists(
      select d.ID_DOC
      from   DOC_HEAD d
      where  d.ID_DOC_NUM = :id_numerator
    )) then in_use = 1;
  end else if (:num_class = 'PROFORMA') then begin
    if (exists(
      select d.ID_DOC
      from   DOC_PROFORMA d
      where  d.ID_DOC_NUM = :id_numerator
    )) then in_use = 1;
  end else if (:num_class = 'ANNUL_PROT') then begin
    if (exists(
      select da.ID_DOC_HEAD
      from   DOC_ANNULMENT da
      where  da.ID_PROT_DOC_NUM = :id_numerator
    )) then in_use = 1;
  end else if (:num_class = 'PAYMENT') then begin
    if (exists(
      select p.ID_PAYMENT_HEAD
      from   PAYMENT_HEAD p
      where  p.ID_DOC_NUM = :id_numerator
    )) then in_use = 1;
  end else if (:num_class = 'BOOKING') then begin
    if (exists(
      select *
      from   RESERV_DETAIL RD
    )) then in_use = 1;
  end

  NEXT_NUM_VALUE = :NUM_VALUE + 1;
  execute procedure SYSTEM_FORMAT_NUM$INT (:NEXT_NUM_VALUE, :leading_part, :max_len)
  returning_values :NEXT_NUM_TEXT;

  suspend;
end
^

/* empty dependent procedure body */
/* Clear: GUEST_NUMERATOR_MODIFY$INT for: SYSTEM_NUMERATOR_MODIFY$INT */
ALTER PROCEDURE GUEST_NUMERATOR_MODIFY$INT(ID_NUMERATOR INTEGER,
NUM_NAME VARCHAR(50),
NUM_NEXT INTEGER,
OPERATION VARCHAR(20),
ID_HOTEL /* TYPE OF ID_REF */ INTEGER)
 RETURNS(NEW_ID_NUMERATOR INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: NUMERATOR_MODIFY$CFG for: SYSTEM_NUMERATOR_MODIFY$INT */
ALTER PROCEDURE NUMERATOR_MODIFY$CFG(ID_NUMERATOR INTEGER,
NUM_NAME VARCHAR(50),
NUM_NEXT INTEGER,
LEADING_PART VARCHAR(20),
NUM_LENGTH INTEGER,
NUM_CLASS /* TYPE OF TNAME_SHORT */ VARCHAR(30),
ID_HOTEL /* TYPE OF ID_REF */ INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_NUMERATOR INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SYSTEM_NUMERATOR_MODIFY$INT) */
ALTER PROCEDURE SYSTEM_NUMERATOR_MODIFY$INT(ID_NUMERATOR INTEGER,
NUM_CLASS VARCHAR(30),
NUM_NAME VARCHAR(50),
NUM_VALUE INTEGER,
LEADING_PART VARCHAR(20),
NUM_LENGTH INTEGER,
ID_HOTEL TYPE OF ID_REF,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_NUMERATOR INTEGER)
 AS
declare variable restart_condition varchar(30);
  declare variable num_object integer;
  declare variable last_date date;
  declare variable old_num_value integer;
begin 
  restart_condition = 'NONE';
  num_object = :id_numerator;
  last_date = current_timestamp;

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:NUM_CLASS not in ('BOOKING', 'GUEST_NUM', 'DOCUMENT', 'PROFORMA', 'ANNUL_PROT', 'PAYMENT', 'FISCAL_DEVICE')) then
    exception NUMERATOR_EXCEPTION 'Invalid numerator class: ' || coalesce(:NUM_CLASS, '<null>');

  if (:OPERATION in ('add', 'mod') and ((:NUM_LENGTH > 20) or (char_length(coalesce(:LEADING_PART, '')) + char_length(:NUM_VALUE) > 20)) ) then
    exception NUMERATOR_EXCEPTION '-79';

  if (:operation = 'mod') then begin
    select SN.NUM_VALUE
    from   SYSTEM_NUMERATOR SN
    where  SN.ID_NUMERATOR = :id_numerator
    into   :old_num_value;

    if (:old_num_value > :NUM_VALUE) then exception NUMERATOR_EXCEPTION '-361';

    update SYSTEM_NUMERATOR
    set    NUM_NAME = :num_name,
           NUM_CLASS = :num_class,
           NUM_OBJECT = :num_object,
           RESTART_CONDITION = :restart_condition,
           NUM_VALUE = :NUM_VALUE,
           LAST_DATE = :last_date,
           LEADING_PART = :leading_part,
           NUM_LENGTH = :num_length,
           ID_HOTEL = :ID_HOTEL
    where  ID_NUMERATOR = :id_numerator;
    new_id_numerator = :id_numerator;
  end else if (:operation = 'add') then begin
    new_id_numerator = gen_id(GEN_SYSTEM_NUMERATOR_ID, 1);
    num_object = :new_id_numerator;

    insert into SYSTEM_NUMERATOR (ID_NUMERATOR, NUM_NAME, NUM_CLASS, NUM_OBJECT,
           RESTART_CONDITION, NUM_VALUE, LAST_DATE, LEADING_PART, NUM_LENGTH, ID_HOTEL)
    values (:new_id_numerator, :num_name, :num_class, :num_object,
           :restart_condition, :num_value, :last_date, :leading_part, :num_length, :id_hotel);
  end else if (:operation = 'del') then begin
    if (:NUM_CLASS = 'BOOKING') then exception NUMERATOR_EXCEPTION 'Unallowable operation! Can not delete booking numerator!';

    delete from SYSTEM_NUMERATOR
    where  ID_NUMERATOR = :id_numerator;

    when any do exception REF_INTEGRITY_DELETE;
  end
end
^

/* Alter (SYSTEM_SESSION_MANAGE) */
ALTER PROCEDURE SYSTEM_SESSION_MANAGE(OPERATION VARCHAR(20))
 AS
begin
  if (:operation = 'log_on') then begin
    /* CONNECTION_ID is recycled after backup and restore, so we must
    || delete all greater IDs which are created before the restore.
    */
    delete from SYSTEM_SESSION SSD
    where  SSD.ID_CONNECTION >= current_connection;
    exit;
  end

  if (:operation = 'log_off') then begin
    /* CONNECTION_ID is recycled after backup and restore, so on
    || normal log_off we must clear the session data.
    */
    delete from SYSTEM_SESSION SSD
    where  SSD.ID_CONNECTION = current_connection;
    exit;
  end
end
^

/* Alter (TAR_BOARD_DECOMPOSE$INT) */
ALTER PROCEDURE TAR_BOARD_DECOMPOSE$INT(ID_BOARD TYPE OF ID,
ID_TAR_HEAD TYPE OF ID)
 RETURNS(ID_SERVICE TYPE OF ID_REF)
 AS
declare variable is_breakfast integer;
  declare variable is_lunch integer;
  declare variable is_dinner integer;
  declare variable is_extrafood1 integer;
  declare variable is_extrafood2 integer;
  declare variable id_hotel integer;
begin

  select TH.IS_BREAKFAST, TH.IS_LUNCH, TH.IS_DINNER, TH.IS_EXTRAFOOD1, TH.IS_EXTRAFOOD2, TH.ID_HOTEL
  from   MEALS TH
  where  TH.ID_BOARD = :id_board
  into   :is_breakfast, :is_lunch, :IS_DINNER, :is_extrafood1, :is_extrafood2, :ID_HOTEL;

  if (:is_breakfast = 1) then begin
    ID_SERVICE = -1;
    select first 1 TH.ID_SERVICE
    from   MEALS TH
           join TAR_BO_BOARD tb on tb.ID_BOARD = th.ID_SERVICE and tb.ID_TAR_HEAD = :ID_TAR_HEAD
    where  TH.IS_BREAKFAST = 1
           and TH.IS_LUNCH = 0
           and TH.IS_DINNER = 0
           and TH.IS_EXTRAFOOD1 = 0
           and TH.IS_EXTRAFOOD2 = 0
           and TH.IS_BOARD = 0
           and TH.ID_HOTEL = :ID_HOTEL
    order by th.IS_ARCHIVE asc, TH.ID_SERVICE asc
    into   :ID_SERVICE;
    suspend;
  end

  if (:is_lunch = 1) then begin
    ID_SERVICE = -1;
    select first 1 TH.ID_SERVICE
    from   MEALS TH
           join TAR_BO_BOARD tb on tb.ID_BOARD = th.ID_SERVICE and tb.ID_TAR_HEAD = :ID_TAR_HEAD
    where  TH.IS_BREAKFAST = 0
           and TH.IS_LUNCH = 1
           and TH.IS_DINNER = 0
           and TH.IS_EXTRAFOOD1 = 0
           and TH.IS_EXTRAFOOD2 = 0
           and TH.IS_BOARD = 0
           and TH.ID_HOTEL = :ID_HOTEL
    order by th.IS_ARCHIVE asc, TH.ID_SERVICE asc
    into   :ID_SERVICE;
    suspend;
  end

  if (:IS_DINNER = 1) then begin
    ID_SERVICE = -1;
    select first 1 TH.ID_SERVICE
    from   MEALS TH
           join TAR_BO_BOARD tb on tb.ID_BOARD = th.ID_SERVICE and tb.ID_TAR_HEAD = :ID_TAR_HEAD
    where  TH.IS_BREAKFAST = 0
           and TH.IS_LUNCH = 0
           and TH.IS_DINNER = 1
           and TH.IS_EXTRAFOOD1 = 0
           and TH.IS_EXTRAFOOD2 = 0
           and TH.IS_BOARD = 0
           and TH.ID_HOTEL = :ID_HOTEL
    order by th.IS_ARCHIVE asc, TH.ID_SERVICE asc
    into   :ID_SERVICE;
    suspend;
  end

 if (:is_extrafood1 = 1) then begin
    ID_SERVICE = -1;
    select first 1 TH.ID_SERVICE
    from   MEALS TH
           join TAR_BO_BOARD tb on tb.ID_BOARD = th.ID_SERVICE and tb.ID_TAR_HEAD = :ID_TAR_HEAD
    where  TH.IS_BREAKFAST = 0
           and TH.IS_LUNCH = 0
           and TH.IS_DINNER = 0
           and TH.IS_EXTRAFOOD1 = 1
           and TH.IS_EXTRAFOOD2 = 0
           and TH.IS_BOARD = 0
           and TH.ID_HOTEL = :ID_HOTEL
    order by th.IS_ARCHIVE asc, TH.ID_SERVICE asc
    into   :ID_SERVICE;
    suspend;
  end

  if (:is_extrafood2 = 1) then begin
    ID_SERVICE = -1;
    select first 1 TH.ID_SERVICE
    from   MEALS TH
           join TAR_BO_BOARD tb on tb.ID_BOARD = th.ID_SERVICE and tb.ID_TAR_HEAD = :ID_TAR_HEAD
    where  TH.IS_BREAKFAST = 0
           and TH.IS_LUNCH = 0
           and TH.IS_DINNER = 0
           and TH.IS_EXTRAFOOD1 = 0
           and TH.IS_EXTRAFOOD2 = 1
           and TH.IS_BOARD = 0
           and TH.ID_HOTEL = :ID_HOTEL
    order by th.IS_ARCHIVE asc, TH.ID_SERVICE asc
    into   :ID_SERVICE;
    suspend;
  end
end
^

/* Alter (TAR_CALC_EVAL_COMPLEX_RATE$INT) */
ALTER PROCEDURE TAR_CALC_EVAL_COMPLEX_RATE$INT(INPUT_DETAIL_DBKEY CHAR(8),
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
BEDS SMALLINT,
ID_TYPE_STAY INTEGER,
IS_MANUAL_TYPE_STAY SMALLINT,
ID_BOARD INTEGER,
ID_ROOM_TYPE INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
CHECKIN_DATE DATE,
DAY_OF_STAY INTEGER,
PAYORS INTEGER,
MINORS INTEGER,
PERIOD_DEPEND_ON_CHECKIN SMALLINT,
CNT_DAYS_BP INTEGER,
CNT_DAYS_BOARD INTEGER,
BOARD_TYPE_FIND VARCHAR(10),
TOTAL_GUESTS INTEGER,
SEQ_NUM INTEGER,
TARIFF_CURR CHAR(3),
REAL_RECALC SMALLINT)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_PAYORS INTEGER,
OUT_MINORS INTEGER)
 AS
declare variable id_tar_input_detail integer;
  declare variable price numeric(15,4);
  declare variable auto_stay_type integer;
  declare variable base_per_day numeric(15,4);
  declare variable board_per_day numeric(15,4);
  declare variable guest_board_weight integer;
--  declare variable guest_food varchar(20);
  declare variable match_date date;
  declare variable manual_total_gsts integer;
  declare variable manual_payors integer;
  declare variable manual_minors integer;
  declare variable service_type varchar(20);
  declare variable base_price numeric(15,4);
  declare variable board_price numeric(15,4);
  declare variable food_per_day numeric(15,4);
  declare variable base_price_tar numeric(15,4);
  declare variable custom_cross_rate double precision;
  declare variable ptext varchar(20);
  declare variable id_service integer;
  declare variable qty_post integer;
  declare variable pack_currency char(3);
  declare variable minors_input integer;
  declare variable packet_item integer;
  declare variable price_tariff numeric(15,4);
  declare variable is_inside_base integer;
  declare variable id_bo_bp integer;
  declare variable id_board_include integer;
  declare variable separate_board integer;
  declare variable incomplete_bp integer;
  declare variable id_bo_eg integer;
  declare variable id_eg_price integer;
  declare variable disc_tag varchar(50);
  declare variable id_discount_service integer;
  declare variable var_board_price numeric(15,4);
  declare variable type_stay_code varchar(10);
  declare variable id_hotel integer;
begin
  base_per_day = 0;
  board_per_day = 0;

  select TH.WEIGHT_TAG
  from   MEALS TH
  where  TH.ID_BOARD = :ID_BOARD
  into   :guest_board_weight;
  guest_board_weight = coalesce(:guest_board_weight, 0);

  /*if (:guest_board_weight = 0) then GUEST_FOOD = 'NONE';
  else GUEST_FOOD = 'SOME';*/
  if (:PERIOD_DEPEND_ON_CHECKIN = 1) then MATCH_DATE = :CHECKIN_DATE;
  else MATCH_DATE = :FOR_DATE;

  select st.TYPE_STAY_CODE
  from   TYPE_STAY st
  where  st.ID_TYPE_STAY = :id_type_stay
  into   :type_stay_code;

  if (:IS_MANUAL_TYPE_STAY = 1) then begin
    if (:type_stay_code = 'ALONE') then begin
      MANUAL_TOTAL_GSTS = 1;
      MANUAL_PAYORS = 0;
      MANUAL_MINORS = 0;
    end else if (:type_stay_code = 'BED') then begin
      MANUAL_TOTAL_GSTS = 2;
      MANUAL_PAYORS = 1;
      MANUAL_MINORS = 0;
    end else if (:type_stay_code = 'EXTRA_BED') then begin
      MANUAL_TOTAL_GSTS = :BEDS+1;
      MANUAL_PAYORS = :BEDS;
      MANUAL_MINORS = :MINORS;
    end

    execute procedure TAR_MATCH_BP(:INPUT_DETAIL_DBKEY, :MATCH_DATE, :MANUAL_TOTAL_GSTS, :MANUAL_TOTAL_GSTS,
                      :GUEST_BOARD_WEIGHT, :REAL_RECALC, :DAY_OF_STAY, :CNT_DAYS_BP)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_BP, :ID_BOARD_INCLUDE,
                      :INCOMPLETE_BP, :BASE_PRICE, :PTEXT, :BASE_PER_DAY;
  end else begin
    execute procedure TAR_MATCH_BP(:INPUT_DETAIL_DBKEY, :MATCH_DATE, :SEQ_NUM, :TOTAL_GUESTS,
                      :GUEST_BOARD_WEIGHT, :REAL_RECALC, :DAY_OF_STAY, :CNT_DAYS_BP)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_BP, :ID_BOARD_INCLUDE,
                      :INCOMPLETE_BP, :BASE_PRICE, :PTEXT, :BASE_PER_DAY;
  end

  execute procedure sys_dbg('tar base_per_day = '||coalesce(:BASE_PER_DAY, 'null'));
  execute procedure sys_dbg('tar base_price = '||coalesce(:BASE_PRICE, 'null'));
  if (:ERR_CODE < 0) then exit;

  SEPARATE_BOARD = 0;
  if (:REAL_RECALC = 1) then begin
    if (:CUSTOM_PRICE is not null) then begin
      base_price = :CUSTOM_PRICE;
      select tr.ID_HOTEL
      from   TAR_CALC_INPUT_DETAIL$TMP t
             join TARIFA tr on tr.ID_TARIFA = t.ID_TAR_HEAD
      where  t.RDB$DB_KEY = :INPUT_DETAIL_DBKEY
      into   :id_hotel;

      execute procedure CURR_CROSS_RATE_GET(:CUSTOM_CURRENCY, :TARIFF_CURR, current_timestamp, :id_hotel)
      returning_values  :custom_cross_rate;
      base_price_tar = (:custom_cross_rate * :base_price);
      pack_currency = :custom_currency;
    end else begin
      base_price_tar = :base_per_day;
      pack_currency = :tariff_curr;
    end
    /*DEBUG*/
    if (:base_price is null) then exception RATING_EXCEPTION ('4. base price is null');
    if (:base_price_tar is null) then exception RATING_EXCEPTION ('5. base price tar is null');

    select TBP.PACKET_ITEM
    from   TAR_BO_BASE_POSITION TBP
    where  TBP.ID_TAR_BP = :id_bo_bp
    into   :packet_item;

    insert into TAR_CALC_OUTPUT$TMP (
           ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
           FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
           CURRENCY, CURRENCY_TARIFF, REQUIRED_ID_PACKET_ITEM)
    values (:ID_TAR_INPUT, :ID_TAR_CALC, -1, 'BASE',
           :FOR_DATE, :BASE_PER_DAY, :BASE_PRICE_TAR, 'BASE', 1, :PTEXT,
           :PACK_CURRENCY, :TARIFF_CURR, :packet_item);
    /* BOARDS */
    var_board_price = 0;
    for
      select TMB.ERR_CODE, TMB.ERR_TEXT, TMB.SEPARATE_BOARD, TMB.BOARD_PRICE, TMB.PTEXT,
             TMB.SERVICE_TYPE, TMB.ID_SERVICE, TMB.FOOD_PER_DAY, TMB.PACKET_ITEM
      from   TAR_MATCH_BOARD(:INPUT_DETAIL_DBKEY, :id_bo_bp, :BOARD_TYPE_FIND,
             :ID_BOARD, :id_board_include, :match_date, :base_per_day,
             :DAY_OF_STAY, :CNT_DAYS_BOARD, :CNT_DAYS_BP, :CUSTOM_PRICE) TMB
      into   :err_code, :err_text, :separate_board, :board_price, :ptext,
             :service_type, :id_service, :food_per_day, :packet_item
    do begin
      if (:ERR_CODE < 0) then exit;

      /*DEBUG*/
      if (:board_price is null) then exception RATING_EXCEPTION ('6. board_price is null');
      if (:id_service is null) then exception RATING_EXCEPTION ('7. id_service is null');

      insert into TAR_CALC_OUTPUT$TMP (
             ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
             FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
             CURRENCY, CURRENCY_TARIFF, REQUIRED_ID_PACKET_ITEM)
      values (:ID_TAR_INPUT, :ID_TAR_CALC, :ID_SERVICE, :SERVICE_TYPE,
             :FOR_DATE, :food_per_day, :food_per_day, 'FOOD', 1, :PTEXT,
             :TARIFF_CURR, :TARIFF_CURR, :packet_item);

      -- board_per_day = (:board_per_day + :food_per_day); ???
      var_board_price = :var_board_price + iif(:service_type in ('BASE_BOARD', 'EXTRA_BOARD'), :food_per_day, 0);
    end

    select TID.ID_TAR_INPUT_DETAIL
    from   TAR_CALC_INPUT_DETAIL$TMP TID
    where  tid.RDB$DB_KEY = :INPUT_DETAIL_DBKEY
    into   :id_tar_input_detail;

    execute procedure TAR_SET_VAR('board='||:VAR_BOARD_PRICE, :id_tar_input_detail, :id_tar_calc);
  end

  if (:SEPARATE_BOARD is null) then SEPARATE_BOARD = 0;
  minors_input = :MINORS;

  if (:IS_MANUAL_TYPE_STAY = 1) then begin
    /* ONLY TO FIND THE REAL POSITION PAYORS, MINORS ARE NOT IMPORTANT
    || ALL OTHER GUESTS IN THE ROOM MUST SEE THE MANUAL ONE AS AUTOMATIC. SO
    || HERE WE ARE FINDING HIS AUTOMATIC TYPE STAY.
    */
    execute procedure TAR_MATCH_EG(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :total_guests, :PAYORS, :MINORS, :MATCH_DATE, :INCOMPLETE_BP, :ID_ROOM_TYPE, 1)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_EG, :ID_EG_PRICE, :PAYORS, :MINORS, :AUTO_STAY_TYPE;
    if (:ERR_CODE < 0) then exit;
    /* REAL PRICE FIND AND EVAL */
    execute procedure TAR_MATCH_MANUAL_EG(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :MANUAL_TOTAL_GSTS, :MANUAL_PAYORS, :MANUAL_MINORS, :MATCH_DATE, :INCOMPLETE_BP, :ID_TYPE_STAY)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_EG, :ID_EG_PRICE, :AUTO_STAY_TYPE;
    if (:ERR_CODE < 0) then exit;

    if ((:MINORS = :minors_input) and
        (exists (select *
                 from   TYPE_STAY TS
                 where  TS.ID_TYPE_STAY = :ID_TYPE_STAY
                        and TS.TYPE_STAY_CODE = 'EXTRA_BED'))) then begin
      /* TO MANAGE PARAMETER "EXTRA GUEST IN TURN" WHEN MANUAL SET TO ADD */
      MINORS = :MINORS + 1;
      PAYORS = :PAYORS - 1;
    end
  end else begin
    execute procedure TAR_MATCH_EG(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :TOTAL_GUESTS, :PAYORS, :MINORS, :MATCH_DATE, :INCOMPLETE_BP, :ID_ROOM_TYPE, 0)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_EG, :ID_EG_PRICE, :PAYORS, :MINORS, :AUTO_STAY_TYPE;
    if (:ERR_CODE < 0) then exit;
  end

  update TAR_CALC_INPUT_DETAIL$TMP TID
  set    TID.SEPARATE_BOARD = :SEPARATE_BOARD,
         TID.ID_TYPE_STAY   = :AUTO_STAY_TYPE
  where  TID.RDB$DB_KEY = :INPUT_DETAIL_DBKEY;

  if (:REAL_RECALC = 1) then begin
    if (:CUSTOM_PRICE is null) then begin
      for
        select TSP.SERVICE_TYPE, TSP.PRICE,  TSP.PTEXT, TSP.ERR_CODE, TSP.ID_SERVICE
        from   TAR_PRICES_SET_EG(:ID_TAR_INPUT, :FOR_DATE, :DAY_OF_STAY, :CNT_DAYS_BP,
               :guest_board_weight, :id_bo_eg, :id_eg_price, :base_price) TSP
        into   :service_type, :price,  :ptext, :ERR_CODE, :id_service
      do begin
        if (:ERR_CODE < 0) then exit; -- exception INTERNAL_RATING_EXCEPTION;

        /*DEBUG*/
        if (:PRICE is null) then exception RATING_EXCEPTION ('8. price is null');
        if (:ID_SERVICE is null) then exception RATING_EXCEPTION ('9. id_service is null');

        insert into TAR_CALC_OUTPUT$TMP (
               ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
               FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
               CURRENCY, CURRENCY_TARIFF, REQUIRED_ID_PACKET_ITEM)
        values (:ID_TAR_INPUT, :ID_TAR_CALC, :id_service, :service_type,
               :FOR_DATE, :price, :price, 'EG', 1, :ptext,
               :TARIFF_CURR, :TARIFF_CURR, :packet_item);
      end
    end

    for
      select TMT.ID_SERVICE, TMT.SERVICE_TYPE, TMT.PRICE, TMT.PRICE_TARIFF, TMT.QTY_POST,
             TMT.PTEXT, TMT.PACK_CURRENCY, TMT.ERR_CODE, TMT.ERR_TEXT, TMT.PACKET_ITEM, TMT.DISC_TAG
      from   TAR_PRICES_SET_PACKS(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :DAY_OF_STAY, :CUSTOM_PRICE) TMT
      into   :ID_SERVICE, :SERVICE_TYPE, :PRICE, :PRICE_TARIFF, :QTY_POST,
             :PTEXT, :PACK_CURRENCY, :ERR_CODE, :ERR_TEXT, :PACKET_ITEM, :DISC_TAG
    do begin
      if (:ERR_CODE < 0) then exit; --exception INTERNAL_RATING_EXCEPTION;
      /*DEBUG*/
      if (:price_tariff is null) then exception RATING_EXCEPTION ('10. PRICE_TARIFF is null');
      if (:id_service is null) then exception RATING_EXCEPTION ('11. ID_SERVICE is null');

      insert into TAR_CALC_OUTPUT$TMP (
             ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
             FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
             CURRENCY, CURRENCY_TARIFF, DISC_TAG, REQUIRED_ID_PACKET_ITEM)
      values (:ID_TAR_INPUT, :ID_TAR_CALC, :ID_SERVICE, :SERVICE_TYPE,
             :FOR_DATE, :PRICE, :PRICE_TARIFF, 'PACK', :QTY_POST, :PTEXT,
             :PACK_CURRENCY, :TARIFF_CURR, :DISC_TAG, :packet_item);

    end

    for
      select TMT.ID_SERVICE, TMT.SERVICE_TYPE, TMT.PRICE, TMT.PTEXT, TMT.ERR_CODE, TMT.ERR_TEXT, TMT.PACKET_ITEM,
             TMT.IS_INSIDE_BASE, TMT.DISC_TAG, TMT.ID_DISCOUNT_SERVICE
      from   TAR_PRICES_SET_TAX(:ID_TAR_INPUT, :INPUT_DETAIL_DBKEY, :ID_BO_BP, :DAY_OF_STAY) tmt
      into   :ID_SERVICE, :SERVICE_TYPE, :PRICE, :PTEXT, :ERR_CODE, :ERR_TEXT, :PACKET_ITEM,
             :IS_INSIDE_BASE, :DISC_TAG, :ID_DISCOUNT_SERVICE
    do begin
      if (:ERR_CODE < 0) then exit; --exception INTERNAL_RATING_EXCEPTION;
      if ((:IS_INSIDE_BASE = 0) and (:CUSTOM_PRICE is not null)) then begin
        -- SKIP IT. SIMPLE DISCOUNTS MUST NOT CHANGE THE CUSTOM PRICE
      end else begin
        /*DEBUG*/
        if (:PRICE is null) then exception RATING_EXCEPTION ('12. price is null');
        if (:ID_SERVICE is null) then exception RATING_EXCEPTION ('13. id_service is null');
        -- !!! Service type and id_service of discount is as object that they discounting but in TAR_CALC_REPOST$INT type and id_service is changed to PACKAGES if discounts have ID_DISCOUNT_SERVICE
        if ((:DISC_TAG = '') or (:DISC_TAG is null)) then DISC_TAG =  'DISC';
        insert into TAR_CALC_OUTPUT$TMP (
               ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
               FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
               CURRENCY, CURRENCY_TARIFF, DISC_TAG, ID_DISCOUNT_SERVICE, REQUIRED_ID_PACKET_ITEM)
        values (:ID_TAR_INPUT, :ID_TAR_CALC, :ID_SERVICE, :SERVICE_TYPE,
               :FOR_DATE, :PRICE, :PRICE, 'DISC', 1, :PTEXT,
               :TARIFF_CURR, :TARIFF_CURR, :DISC_TAG, :id_discount_service, :packet_item);

        execute procedure sys_dbg('tar TAR_CALC_EVAL_DATE$INT - :DISC_TAG=' || coalesce(:DISC_TAG, 'null') );
      end
    end
  end

  OUT_MINORS = :MINORS;
  OUT_PAYORS = :PAYORS;
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_EVAL_ALL$INT for: TAR_CALC_EVAL_DATE$INT */
ALTER PROCEDURE TAR_CALC_EVAL_ALL$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_EVAL_DATE$INT) */
ALTER PROCEDURE TAR_CALC_EVAL_DATE$INT(ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
FOR_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_input integer;
declare variable checkin_date date;
declare variable day_of_stay integer;
declare variable real_recalc integer;
declare variable id_guest integer;
declare variable input_detail_dbkey char(8);
declare variable id_room_type integer;
declare variable id_board integer;
declare variable id_tar_head integer;
declare variable id_type_stay integer;
declare variable id_hotel integer;
declare variable period_depend_on_checkin integer;
declare variable cnt_days_board integer;
declare variable cnt_days_bp integer;
declare variable tariff_curr char(3);
declare variable board_type_find varchar(10);
declare variable id_room integer;
declare variable custom_price numeric(15,4);
declare variable custom_currency char(3);
declare variable id_tar_input_detail integer;
declare variable is_simple integer;
declare variable guest_age integer;
declare variable tar_name varchar(50);
declare variable guest_name varchar(50);
declare variable total_guests integer;
declare variable old_id_room integer;
declare variable beds integer;
declare variable payors integer;
declare variable minors integer;
declare variable int_err_text varchar(255);
declare variable is_manual_type_stay smallint;
declare variable seq_num integer;
declare variable current_child_num integer;
declare variable current_adult_num integer;
begin
  ERR_CODE = 0;
  OLD_ID_ROOM = NULL;
  for
    select   TCI.ID_TAR_INPUT, TCI.FROM_DATE, (:FOR_DATE - TCI.FROM_DATE + 1),
             TCI.REAL_RECALC, TCI.ID_GUEST, TCID.RDB$DB_KEY, TCID.ID_ROOM_TYPE,
             TCID.ID_BOARD, TCID.ID_TAR_HEAD, TCID.ID_TYPE_STAY, TCID.IS_MANUAL_TYPE_STAY, T.ID_HOTEL,
             TH.PERIOD_DEPEND_ON_CHECKIN, TH.CNT_DAYS_PRICE_BOARD, TH.CNT_DAYS_PRICE_BP, T.CURR, TH.BOARD_TYPE,
             TCID.ID_ROOM, TCID.CUSTOM_PRICE, TCID.CUSTOM_CURRENCY,
             TCID.ID_TAR_INPUT_DETAIL, TH.IS_SIMPLE, TCI.GUEST_AGE
    from     TAR_CALC_INPUT_DETAIL$TMP TCID
             join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
             join TAR_HEAD TH on TH.ID_TAR_HEAD = TCID.ID_TAR_HEAD
             join TARIFA T on T.ID_TARIFA = TH.ID_TAR_HEAD
    where    TCI.ID_TAR_CALC = :ID_TAR_CALC
             and TCI.ROOM_STATUS = :ROOM_STATUS
             and TCID.FOR_DATE = :FOR_DATE
    order by TCID.ID_ROOM asc,
             iif(TCI.IS_CHILD = 1, TCI.GUEST_AGE, 999) desc,
             --iif(TCI.GUEST_AGE > 16, 999, TCI.GUEST_AGE) desc,
             TCID.CHECKIN_ORDER asc,
             TCI.ID_GUEST asc
             /* ADULTS MUST BE HANDLED FIRST, THEN BY CHECKIN ORDER and ID_GUEST because of shares */
    into     :id_tar_input, :checkin_date, :day_of_stay,
             :real_recalc, :id_guest, :input_detail_dbkey, :id_room_type,
             :id_board, :id_tar_head, :id_type_stay, :is_manual_type_stay, :id_hotel,
             :period_depend_on_checkin, :cnt_days_board, :cnt_days_bp, :tariff_curr, :board_type_find,
             :id_room, :custom_price, :custom_currency,
             :id_tar_input_detail, :is_simple, :guest_age

  do begin
    if (coalesce(:id_room_type, -1) < 0) then exception RATING_EXCEPTION 'Unspecified room type!';
    if (coalesce(:id_type_stay, -1) < 0) then exception RATING_EXCEPTION 'Unspecified type stay!';
    --if (coalesce(:id_board, -1) < 0) then exception ASSERT 'Unspecified board!';
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    /* - - - - - PART 1 - For Both Simple and Complex Rates - */
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    select count(*)
    from   TAR_CALC_INPUT_DETAIL$TMP TCID
           join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
    where  TCI.ID_TAR_CALC = :ID_TAR_CALC
           and TCID.FOR_DATE = :FOR_DATE
           and TCID.ID_ROOM = :ID_ROOM
    into   :TOTAL_GUESTS;

    if (:TOTAL_GUESTS = 0) then exit;
  
    select RT.BEDS
    from   ROOM_TYPES RT
    where  RT.ID_ROOM_TYPE = :ID_ROOM_TYPE
    into   :BEDS;

    if (:IS_SIMPLE = 1) then begin
      /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
      /* - - - - - - - PART 2 - Simple Rates - - - - - - - - -  */
      /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
      if (:old_id_room is distinct from :id_room) then begin
        current_adult_num = 0;
        current_child_num = 0;
        old_id_room = :id_room;
      end

      execute procedure TAR_CALC_EVAL_SIMPLE_RATE$INT (:id_tar_input_detail, :id_tar_input, :ID_TAR_CALC,
              :FOR_DATE, :id_tar_head, :beds, :guest_age, :id_type_stay, :is_manual_type_stay, :id_board, :id_room_type,
              :custom_price, :custom_currency, :id_hotel, :total_guests, :current_adult_num, :current_child_num)
      returning_values (:ERR_CODE, :int_err_text, :current_adult_num, :current_child_num);
      if (:ERR_CODE < 0) then exception INTERNAL_RATING_EXCEPTION;

    end else begin
      /* - - -  - - - - - - - - - - - -  - - - - - - - - */
      /* - - -  - PART 3 - Complex Rates - - - - - - - - */
      /* - - -  - - - - - - - - - - - -  - - - - - - - - */
      if (:old_id_room is distinct from :id_room) then begin
        payors  = 0;
        minors  = 0;
        old_id_room = :id_room;
        seq_num = 0;
      end
      seq_num = :seq_num + 1;

      execute procedure TAR_CALC_EVAL_COMPLEX_RATE$INT (:input_detail_dbkey, :id_tar_input, :ID_TAR_CALC,
              :FOR_DATE, :beds, :id_type_stay, :is_manual_type_stay, :id_board, :id_room_type, :custom_price, :custom_currency,
              :checkin_date, :day_of_stay, :payors, :minors, :period_depend_on_checkin, :cnt_days_bp, :cnt_days_board,
              :board_type_find, :total_guests, :seq_num, :tariff_curr, :real_recalc)
      returning_values (:ERR_CODE, :int_err_text, :payors, :minors);
      if (:ERR_CODE < 0) then exception INTERNAL_RATING_EXCEPTION;
    end
  /* - --- - END PART 3 - complex Rates*/
  end

  when exception INTERNAL_RATING_EXCEPTION do begin
    if (coalesce(:ERR_CODE, 0) = 0) then ERR_CODE = -211;
    select TH.TARIFA_NAME
    from   TARIFA TH
    where  TH.ID_TARIFA = :ID_TAR_HEAD
    into   :TAR_NAME;

    select GC.GUEST_NAME1
    from   GUEST_CARD GC
    where  GC.ID_GUEST = :ID_GUEST
    into   :GUEST_NAME;
    ERR_TEXT = substring('GUEST='||cast(:ID_GUEST as varchar(20))||'-'||:GUEST_NAME||f_crlf()
                         || 'DATE='||:FOR_DATE||f_crlf()
                         || 'TARIFF='||:TAR_NAME||f_crlf()
                         || :int_err_text
                        from 1 for 255);

    exit;
  end
end
^

/* Alter (TAR_CALC_EVAL_SIMPLE_RATE$INT) */
ALTER PROCEDURE TAR_CALC_EVAL_SIMPLE_RATE$INT(ID_TAR_INPUT_DETAIL INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
ID_TAR_HEAD INTEGER,
BEDS SMALLINT,
GUEST_AGE INTEGER,
ID_TYPE_STAY INTEGER,
IS_MANUAL_TYPE_STAY INTEGER,
ID_BOARD INTEGER,
ID_ROOM_TYPE INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
TOTAL_GUESTS INTEGER,
CURRENT_ADULT_NUM INTEGER,
CURRENT_CHILD_NUM INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
NEW_CURRENT_ADULT_NUM INTEGER,
NEW_CURRENT_CHILD_NUM INTEGER)
 AS
declare variable id_tar_simple integer;
  declare variable child_age_incl integer;
  declare variable is_adult_by_sample_rate integer;
  declare variable type_stay_code varchar(10);
  declare variable board_price numeric(15,4);
  declare variable price numeric(15,4);
  declare variable calc_total_guests integer;
  declare variable calc_adult_num integer;
  declare variable calc_child_num integer;
  declare variable curr char(3);
  declare variable custom_cross_rate double precision ;
  declare variable board_id_service integer;
begin
  select TS.ID_TAR_SIMPLE, TS.CHILD_AGE_INCL
  from   TAR_SIMPLE TS
  where  ts.ID_TAR_HEAD = :ID_TAR_HEAD
  into   :id_tar_simple, :child_age_incl;

  /*Find current guest num */
  if (:GUEST_AGE <= :child_age_incl) then is_adult_by_sample_rate = 0; else is_adult_by_sample_rate = 1;
  if (:is_adult_by_sample_rate = 0) then begin
    NEW_CURRENT_ADULT_NUM = :CURRENT_ADULT_NUM;
    NEW_CURRENT_CHILD_NUM = :CURRENT_CHILD_NUM + 1;
  end else begin
    NEW_CURRENT_ADULT_NUM = :CURRENT_ADULT_NUM + 1;
    NEW_CURRENT_CHILD_NUM = :CURRENT_CHILD_NUM;
  end
  /*!!!!!!!!!! setup type stai according manual or room type  */

  select st.TYPE_STAY_CODE
  from   TYPE_STAY st
  where  st.ID_TYPE_STAY = :id_type_stay
  into   :type_stay_code;

  if (:IS_MANUAL_TYPE_STAY = 1) then begin
    if (:type_stay_code = 'ALONE') then begin  /*SGL*/
      calc_total_guests = 1;
      calc_adult_num = 1;
      calc_child_num = 1;
    end else if (:type_stay_code = 'BED') then begin  /*TWN*/
      calc_total_guests = 2;
      calc_adult_num = 1;
      calc_child_num = 1;
    end else if (:type_stay_code = 'EXTRA_BED') then begin  /*ADD*/
      calc_total_guests = :beds + 1;
      calc_adult_num = :beds + 1;
      calc_child_num = :beds + 1;
    end
  end else begin
    calc_total_guests = :TOTAL_GUESTS;
    calc_adult_num = :NEW_CURRENT_ADULT_NUM;
    calc_child_num = :NEW_CURRENT_CHILD_NUM;
  end
  /*Calc price */
  board_price = null;
  price = null;
  /* Calc base rate and board */
  execute procedure TAR_CALC_SIMPLERATE_PRICE$INT ( :id_tar_simple, :FOR_DATE, :CALC_TOTAL_GUESTS, :CALC_ADULT_NUM, :CALC_CHILD_NUM,
                    :is_adult_by_sample_rate, :ID_BOARD, :ID_ROOM_TYPE)
  returning_values (:ERR_CODE, :ERR_TEXT, :PRICE, :CURR, :BOARD_PRICE);
  if (:ERR_CODE < 0) then exit;

  /*Handle Custom price*/
  if (:CUSTOM_PRICE is not null ) then begin
    execute procedure CURR_CROSS_RATE_GET(:CUSTOM_CURRENCY, :CURR, current_timestamp, :id_hotel)
    returning_values  :CUSTOM_CROSS_RATE;
    PRICE = :CUSTOM_PRICE * :CUSTOM_CROSS_RATE;
  end
  /* Board price is always included in simple rates - deduct it from base*/
  if (:board_price is not null ) then begin
    price = :price - :board_price;
    /*if base price become minus - board is reduced to base and base become 0*/
    if (:price < 0) then begin
      board_price = board_price + price;
      price = 0;
    end
  end
  /*Put base price in output tbl*/
  /*DEBUG*/
  if (:price is null) then exception RATING_EXCEPTION ('1. price is null');

  insert into TAR_CALC_OUTPUT$TMP (
        ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
        FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT, CURRENCY, CURRENCY_TARIFF)
  values (:ID_TAR_INPUT, :ID_TAR_CALC, -1, 'BASE',
        :FOR_DATE, :price, :price, 'BASE', 1, '', :curr, :curr);
  /*Put Boards in output*/
  if (:board_price is not null ) then begin
    /*Allways separate boards if price is defined in rate*/
    update  TAR_CALC_INPUT_DETAIL$TMP TCID
    set     TCID.SEPARATE_BOARD = 1,
            TCID.ID_BOARD_INCLUDE = :ID_BOARD
    where   TCID.ID_TAR_INPUT_DETAIL = :ID_TAR_INPUT_DETAIL;

    select S.ID_SERVICE
    from   MEALS S
    where  S.ID_BOARD = :ID_BOARD
    into   :board_id_service;

    /*DEBUG*/
    if (:board_price is null) then exception RATING_EXCEPTION ('2. board price is null');
    if (:board_id_service is null) then exception RATING_EXCEPTION ('3. board_id_service is null');

    insert into TAR_CALC_OUTPUT$TMP (
         ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
         FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT, CURRENCY, CURRENCY_TARIFF)
    values (:ID_TAR_INPUT, :ID_TAR_CALC, :BOARD_ID_SERVICE, 'BASE_BOARD',
         :FOR_DATE, :board_price, :board_price, 'FOOD', 1, '', :curr, :curr);
  end
end
^

/* empty dependent procedure body */
/* Clear: GUEST_POST_GET_PACK_SERVICE for: TAR_GET_BASE_SERVICE$INT */
ALTER PROCEDURE GUEST_POST_GET_PACK_SERVICE(IN_ID_SERVICE INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_POST DATE)
 RETURNS(ID_PACK_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_GET_BASE_SERVICE$INT) */
ALTER PROCEDURE TAR_GET_BASE_SERVICE$INT(ID_TYPE_STAY INTEGER,
ID_ROOM_TYPE INTEGER,
ID_BOARD INTEGER,
ID_HOTEL INTEGER)
 RETURNS(ID_SERVICE INTEGER)
 AS
declare variable args varchar(255);
begin
  id_service = null;
  select first 1 S.ID_SERVICE
  from   SERVICE_PACKET SP
         join SERVICES s on s.ID_SERVICE = sp.ID_SERVICE
  where  Sp.ID_ROOM_TYPE = :id_room_type
         and Sp.ID_TYPE_STAY = :id_type_stay
         and sp.ID_BOARD = :id_board
  order by s.IS_DELETED asc, s.ID_SERVICE desc
  into   :id_service;

  if (:id_service is null) then begin
    select coalesce((select h.HOTEL_NAME from HOTEL H where h.ID_HOTEL = :ID_HOTEL), '<null>') || f_character(28)
           || coalesce((select rt.TYPE_ROOM from ROOM_TYPES RT where rt.ID_ROOM_TYPE = :ID_ROOM_TYPE), '<null>') || f_character(28)
           || coalesce((select ts.TYPE_STAY from TYPE_STAY ts where ts.ID_TYPE_STAY = :ID_TYPE_STAY), '<null>') || f_character(28)
           || coalesce((select s.NAME from MEALS s where s.ID_BOARD = :ID_BOARD), '<null>')
    from   RDB$DATABASE r
    into   :args;

    execute procedure sys_dbg('TAR_GET_BASE_SERVICE id_rt: '|| :ID_ROOM_TYPE|| f_crlf()
                              || 'id_ts: '|| :ID_TYPE_STAY|| f_crlf()
                              || 'id_board: ' || :ID_BOARD);
    exception RATING_EXCEPTION '-81' || f_character(31) || f_character(29) || :args;
  end
end
^

/* Alter (TAR_MATCH_BOARD) */
ALTER PROCEDURE TAR_MATCH_BOARD(TID_DBKEY CHAR(8),
ID_TAR_BP INTEGER,
BOARD_TYPE_FIND VARCHAR(10),
ID_BOARD INTEGER,
ID_BOARD_INCLUDE INTEGER,
MATCH_DATE DATE,
BASE_PER_DAY NUMERIC(15,4),
DAY_OF_STAY INTEGER,
CNT_DAYS_BOARD INTEGER,
CNT_DAYS_BP INTEGER,
CUSTOM_PRICE NUMERIC(15,4))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SEPARATE_BOARD INTEGER,
SERVICE_TYPE VARCHAR(20),
BOARD_PRICE NUMERIC(15,4),
PTEXT VARCHAR(20),
ID_SERVICE INTEGER,
FOOD_PER_DAY NUMERIC(15,4),
PACKET_ITEM INTEGER,
DISC_TAG VARCHAR(50))
 AS
declare variable id_tar_head integer;
  declare variable id_tar_calc integer;
  declare variable ID_BO_BOARD integer;
  declare variable ID_TAR_BO_PRICE integer;
  declare variable param_filter varchar(2000);
  declare variable param_data varchar(2000);
  declare variable filter_result double precision;
  declare variable success integer;
  declare variable id_tar_board_tmp integer;
  declare variable board_name varchar(50);
  declare variable no_use numeric(15, 4);
  declare variable price_type varchar(20);
  declare variable is_board_in_bp integer;
  declare variable id_meal integer;
  declare variable delim integer;
  declare variable set_var varchar(255);
  declare variable rnd_method varchar(20);
  declare variable id_tar_input_detail integer;
  declare variable round_to numeric(15,4) ;
  declare variable meal_chksum integer;
  declare variable applicable_service_ids varchar(255);
begin
  err_code = 0;
  err_text = '';
  id_tar_bo_price = -1;
  separate_board = 0;
  id_bo_board = -1;
  success = 0;
  packet_item = null;
  if (:id_board = 0) then exit;

  if (:board_type_find = 'HRANI') then begin
    for
      select BTF.ID_SERVICE
      from   BOARD_TO_FOODS(:id_board) BTF
      into   :id_meal
    do begin
      for
        select ERR_CODE, ERR_TEXT, SEPARATE_BOARD, SERVICE_TYPE, BOARD_PRICE,
               PTEXT, ID_SERVICE, FOOD_PER_DAY, DISC_TAG
        from   TAR_MATCH_BOARD(:tid_dbkey, :id_tar_bp, 'TO_HRANI',
                               :id_meal, :id_board_include, :match_date,
                               :base_per_day, :day_of_stay, :cnt_days_board, :cnt_days_bp, :custom_price)
        into   :err_code, :err_text, :separate_board, :service_type, :board_price,
               :ptext, :id_service, :food_per_day, :disc_tag
      do suspend;
    end
    exit;
  end

  if (:BOARD_TYPE_FIND = 'TO_HRANI') then begin
    select m.CHKSUM
    from   MEALS m
    where  m.ID_SERVICE = :ID_BOARD
    into   :meal_chksum;

    select ','||list(im.ID_SERVICE)||','
    from   MEALS im
    where  im.CHKSUM = :meal_chksum
           and im.IS_BOARD = 0
    into   :applicable_service_ids;
  end else begin
    applicable_service_ids = ','||:ID_BOARD||',';
  end

  for
    select   TBB.ID_TAR_BOARD, TRBP.PARAM_FILTER, TBB.ID_SERVICE, TBB.PACKET_ITEM, TBB.SET_VAR, TCI.ID_TAR_CALC,
             TCID.ID_TAR_HEAD, TCID.PARAM_VALUES, TBB.SEPARATE_BOARD, TBB.PTEXT, TBB.DISC_TAG, TBB.RND_METHOD,
             TCID.ID_TAR_INPUT_DETAIL, m.ID_SERVICE
    from     TAR_CALC_INPUT_DETAIL$TMP TCID
             join  TAR_CALC_INPUT$TMP TCI
               on  TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
             join TAR_BO_BOARD TBB
               on  TBB.ID_TAR_HEAD = TCID.ID_TAR_HEAD
             join TAR_BO_RELATION TRBP
               on  TRBP.ID_BO = TBB.ID_TAR_BOARD
               and TRBP.BO_TYPE = 'BOARD'
             join MEALS m on m.ID_SERVICE = tbb.ID_BOARD
    where    TCID.RDB$DB_KEY = :tid_dbkey
             and TRBP.ID_TAR_BP = :id_tar_bp
             and :applicable_service_ids containing ','||m.ID_SERVICE||','
             --and ((M.ID_SERVICE = :id_board) or (m.CHKSUM = :meal_chksum))
    order by m.IS_ARCHIVE asc, m.ID_SERVICE asc
    into     :id_tar_board_tmp, :param_filter, :id_service, :packet_item, :set_var, :id_tar_calc,
             :id_tar_head, :param_data, :separate_board, :ptext, :disc_tag, :rnd_method,
             :id_tar_input_detail, :ID_BOARD
  do begin
    execute procedure TAR_EVAL_FILTER(:param_filter, :param_data, :id_tar_input_detail)
    returning_values  :err_code, :filter_result;
    if (:err_code < 0) then begin suspend; exit; end
    if (:filter_result = 1) then begin
      id_bo_board = :id_tar_board_tmp;
      success = 1;
      break;
    end
  end
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;

  if (exists (select *
              from   TAR_HEAD TH
              where  TH.ID_TAR_HEAD = :id_tar_head
                     and f_character(:delim)||TH.BASE_BOARDS_LIST||f_character(:delim) containing f_character(:delim)||:id_board||f_character(:delim)))
  then begin
    service_type = 'BASE_BOARD';
    disc_tag = 'FB';
  end else begin
    service_type = 'EXTRA_BOARD';
    disc_tag = 'FE';
  end

  if (:success = 0) then begin
    if ((:board_type_find = 'BOARD') and (:id_board_include is distinct from :id_board)) then begin
      /* NOT FOUND BOARD */
      err_code = -234;
      select T.NAME
      from   MEALS T
      where  T.ID_BOARD = :id_board
      into   :board_name;
      err_text = 'BOARD='||coalesce(:board_name, '<null>');
      suspend;
      exit;
    end else if (:board_type_find = 'TO_HRANI') then begin
      if (not exists(
        select BTF.ID_SERVICE
        from   BOARD_TO_FOODS(:id_board_include) BTF
               join SYSTEM_STRING_PARSER (:applicable_service_ids) sp on sp.ITEM = BTF.ID_SERVICE)) then
      begin
        err_code = -234;
        select T.NAME
        from   MEALS T
        where  T.ID_BOARD = :id_board
        into   :board_name;
        err_text = 'BOARD='||coalesce(:board_name, '<null>');
        suspend;
        exit;
      end
    end
    /* ONLY IF THE BOARD IN THE BASE POSITION FULLY SATISFIES THE BOARD LOOKUP
    || OR IT IS PART OF THE LOOKING BOARD
    */
    update TAR_CALC_INPUT_DETAIL$TMP TID
    set    TID.ID_BOARD_INCLUDE = :id_board_include
    where  TID.RDB$DB_KEY = :tid_dbkey;

    exit;
  end

  if (:id_bo_board <> -1) then begin
    execute procedure TAR_SET_VAR(:set_var, :id_tar_input_detail, :id_tar_calc);
    --
    execute procedure TAR_MATCH_PRICE(:id_tar_head, :id_bo_board, 'BOARD', :match_date)
    returning_values  :err_code, :err_text, :id_tar_bo_price;
    if (:err_code < 0) then begin suspend; exit; end
    /* FIRST WE HAVE TO DECIDE WEATHER THE BOARD IS IN THE BASE PRICE */
    if (:custom_price is not null) then is_board_in_bp = 1;
    else if (:board_type_find = 'TO_HRANI') then begin
      if (exists (
        select BTF.ID_SERVICE
        from   BOARD_TO_FOODS(:id_board_include) BTF
               join SYSTEM_STRING_PARSER (:applicable_service_ids) sp on sp.ITEM = BTF.ID_SERVICE))
      then is_board_in_bp = 1;
      else is_board_in_bp = 0;
    end else begin
      if (:id_board_include = :id_board) then is_board_in_bp = 1;
      else is_board_in_bp = 0;
    end

    select TP.PRICE_VALUE, TP.PRICE_TYPE
    from   TAR_BO_PRICE_GET(:id_tar_bo_price) TP
    into   :board_price, :price_type;

    select c.ROUND_TO
    from   TARIFA t
           join CURRS c on c.CURR = t.CURR
    where  t.ID_TARIFA = :id_tar_head
    into   :round_to;

    execute procedure TAR_EVAL_PRICE(:price_type, :board_price, :base_per_day, :is_board_in_bp,
            :rnd_method, :round_to, :id_tar_input_detail)
    returning_values  :err_code, :board_price, :no_use;

    FOOD_PER_DAY = :BOARD_PRICE;
    if (:CNT_DAYS_BOARD > 1) then begin
      execute procedure TAR_EVAL_PRICE('DIVIDE', :CNT_DAYS_BOARD, :BOARD_PRICE, 0, :rnd_method, :round_to, :id_tar_input_detail)
      returning_values  :err_code, :food_per_day, :no_use;
      if (:err_code < 0) then exit;
      food_per_day = round_f(:food_per_day, 0.01);
  
      if ((mod(:DAY_OF_STAY, :CNT_DAYS_BOARD) = 0)) then food_per_day = :BOARD_PRICE - (:CNT_DAYS_BOARD - 1) * :FOOD_PER_DAY;
    end

    suspend;

    if (:is_board_in_bp = 1) then begin
      id_service = -1;
      service_type = 'BASE';
      disc_tag = 'F';
      FOOD_PER_DAY  = -:FOOD_PER_DAY;
       /* THIS SUSPEND IS FOR THE REDUCTION OF THE BASE PRICE */
      suspend;
    end
  end else begin
    board_price = 0;  /* !!!! suspend  */
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_POST_PREPARE$INT for: TAR_OUTPUT_BASE */
ALTER PROCEDURE TAR_CALC_POST_PREPARE$INT(ID_TAR_CALC INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (TAR_OUTPUT_BASE) */
ALTER PROCEDURE TAR_OUTPUT_BASE(ID_TAR_CALC INTEGER)
 RETURNS(ID_GUEST INTEGER,
ID_RESERV INTEGER,
ID_SERVICE INTEGER,
ID_TARIFF INTEGER,
DATE_POST DATE,
QTY_POST INTEGER,
PRICE_ORIG NUMERIC(15,4),
CURR_ORIG CHAR(3),
SHORT_CODE VARCHAR(255),
ID_ROOM INTEGER)
 AS
declare variable ptext varchar(20);
  declare variable id_tar_input integer;
  declare variable separate_board integer;
  declare variable id_type_stay integer;
  declare variable id_room_type integer;
  declare variable id_board integer;
  declare variable base_orig numeric(15,4);
  declare variable board_orig numeric(15,4);
  declare variable id_food_service integer;
  declare variable id_found_board integer;
  declare variable id_hotel integer;
begin

  for
    select   TCI.ID_TAR_INPUT, TCI.ID_GUEST, tci.ID_RESERV
    from     TAR_CALC_INPUT$TMP TCI
    where    TCI.ID_TAR_CALC = :id_tar_calc
    order by TCI.ID_GUEST asc
    into     :id_tar_input, :id_guest, :id_reserv
  do begin
    for
      select   TCO.FOR_DATE, TCO.CURRENCY_TARIFF, sum(TCO.PRICE_TARIFF)
      from     TAR_CALC_OUTPUT$TMP TCO
      where    TCO.ID_TAR_INPUT = :id_tar_input
               and TCO.SERVICE_TYPE = 'BASE'
      group by TCO.FOR_DATE, TCO.CURRENCY_TARIFF
      order by TCO.FOR_DATE asc
      into     :date_post, :curr_orig, :base_orig
    do begin
      if (:base_orig < 0) then base_orig = 0;
      qty_post = 1;
      select TCID.ID_BOARD, TCID.ID_ROOM_TYPE, TCID.ID_TYPE_STAY, TCID.SEPARATE_BOARD,
             TCID.ID_BOARD_INCLUDE, TCID.ID_TAR_HEAD, TCID.ID_ROOM, t.ID_HOTEL
      from   TAR_CALC_INPUT_DETAIL$TMP TCID
             join TARIFA T on T.ID_TARIFA = tcid.ID_TAR_HEAD
      where  TCID.ID_TAR_INPUT = :id_tar_input
             and TCID.FOR_DATE = :date_post
      into   :id_board, :id_room_type, :id_type_stay, :separate_board,
             :id_found_board, :id_tariff, :id_room, :id_hotel;

      short_code = '';
      for
        select TCO.PTEXT
        from   TAR_CALC_OUTPUT$TMP TCO
        where  TCO.ID_TAR_INPUT = :id_tar_input
               and TCO.SERVICE_TYPE = 'BASE'
               and TCO.FOR_DATE = :date_post
        into   :ptext
      do if ((:ptext <> '') and (position(:ptext, short_code)=0)) then short_code = substring(:short_code||' '||:ptext from 1 for 255);

      if (:separate_board <> 0) then begin
        --TODO a new separate field may be used for modified SERVICE_TYPE
        update   TAR_CALC_OUTPUT$TMP TCO
        set      tco.SOURCE_TYPE = tco.SERVICE_TYPE,
                 TCO.SERVICE_TYPE = 'PACKETS',
                 tco.ID_POSTING_SERVICE = tco.ID_SERVICE
        where    TCO.ID_TAR_INPUT = :id_tar_input
                 and TCO.SERVICE_TYPE in ('BASE_BOARD', 'EXTRA_BOARD')
                 and TCO.FOR_DATE = :date_post;
        /* WEHAVE SEPARATE BOARD OR FOOD */
        price_orig = :base_orig;
        if ((:id_found_board is null) or (:id_found_board = -1)) then begin
          id_found_board = null;
          select first 1 m.ID_BOARD
          from   MEALS m
          where  m.IS_ARCHIVE = 0
                 and m.IS_BREAKFAST = 0
                 and m.IS_LUNCH = 0
                 and m.IS_DINNER = 0
                 and m.IS_EXTRAFOOD1 = 0
                 and m.IS_EXTRAFOOD2 = 0
                 and m.IS_BOARD = 1
                 and m.ID_HOTEL = :id_hotel
          order by m.ID_BOARD asc
          into   :id_found_board;
          if (:id_found_board is null) then exception RATING_EXCEPTION '-82';
        end

        execute procedure TAR_GET_BASE_SERVICE$INT(:id_type_stay, :id_room_type, :id_found_board, :id_hotel)
        returning_values  :id_service;
        suspend;

      end else begin
        /* THE BOARD IS IN THE BASE SERVICE */
        execute procedure TAR_GET_BASE_SERVICE$INT(:id_type_stay, :id_room_type, :id_board, :id_hotel)
        returning_values  :id_service;

        board_orig = null;
        for
          select   TCO.ID_SERVICE, sum(TCO.PRICE_TARIFF)
          from     TAR_CALC_OUTPUT$TMP TCO
          where    TCO.ID_TAR_INPUT = :id_tar_input
                   and TCO.SERVICE_TYPE in ('BASE_BOARD', 'EXTRA_BOARD')
                   and TCO.FOR_DATE = :date_post
          group by TCO.ID_SERVICE
          into     :id_food_service, :board_orig
        do begin
          for
            select TCO.PTEXT
            from   TAR_CALC_OUTPUT$TMP TCO
            where  TCO.ID_TAR_INPUT = :id_tar_input
                   and TCO.SERVICE_TYPE in ('BASE_BOARD', 'EXTRA_BOARD')
                   and TCO.FOR_DATE = :date_post
                   and TCO.ID_SERVICE = :id_food_service
            into   :ptext
          do if ((:ptext <> '') and (position(:ptext, short_code)=0)) then short_code = substring(:short_code||' '||:ptext from 1 for 255);
        end

        price_orig = coalesce(:board_orig, 0) + :base_orig;

        suspend;
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_RATE_RECORD_RELINK$EXC for: TAR_SAVE */
ALTER PROCEDURE IMPORT_RATE_RECORD_RELINK$EXC(ID_RATE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_SAVE) */
ALTER PROCEDURE TAR_SAVE(ID_TAR_HEAD INTEGER,
PERIOD_DEPEND_ON_CHECKIN INTEGER,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BASE_BOARDS_LIST VARCHAR(255),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
BO_TYPE VARCHAR(20),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable delim integer;
  declare variable id_hotel integer;
  declare variable action_text varchar(255);
begin
  if (:base_boards_list is null) then base_boards_list = '';
  if (:board_type not in ('BOARD', 'HRANI')) then begin
    if (:board_type = '0') then board_type = 'BOARD';
    else board_type = 'HRANI';
  end
  err_code = 0;
  err_text = '';
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;

  -- TAR_BO_PRICES are never cleared
  delete from TAR_BO_SEASON
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_BASE_POSITION
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_BOARD
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_EXTRA_GUEST
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_DISCOUNT
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_PACK
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_PARAMS
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_DISCOUNT_STAY
  where  ID_TAR_HEAD = :id_tar_head;
  update TAR_HEAD TH
  set    PERIOD_DEPEND_ON_CHECKIN = :period_depend_on_checkin,
         CNT_DAYS_PRICE_BP        = :cnt_days_price_bp,
         CNT_DAYS_PRICE_BOARD     = :cnt_days_price_board,
         BASE_BOARDS_LIST         = coalesce(f_character(:delim)|| (select list(p.item, f_character(:delim)) from SYSTEM_STRING_PARSER(:base_boards_list, f_character(:delim)) p) || f_character(:delim), ''),
         BOARD_TYPE               = :board_type,
         LOCK_STAMP               = current_timestamp
  where  TH.ID_TAR_HEAD = :id_tar_head;
  update TARIFA T
  set    T.IS_BASE = 1
  where  T.ID_TARIFA = :id_tar_head;
  bo_type = 'SEASON';
  execute procedure TAR_SAVE_BO_SEASON(:id_tar_head)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'BASE';
  execute procedure TAR_SAVE_BO_BP(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'BOARD';
  execute procedure TAR_SAVE_BO_BOARD(:id_tar_head, :bo_type, :board_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'EXTRA_GUEST';
  execute procedure TAR_SAVE_BO_EG(:id_tar_head, :bo_type, :board_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'PACK';
  execute procedure TAR_SAVE_BO_PACK(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'DISCOUNT';
  execute procedure TAR_SAVE_BO_DISC(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'DISCOUNT_PERIOD';
  execute procedure TAR_SAVE_BO_DISC_PERIOD(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end

  select f_character(29) || T.TARIFA_NAME, T.id_hotel
  from   TARIFA T
  where  T.ID_TARIFA = :ID_TAR_HEAD
  into   :action_text, :id_hotel;

  execute procedure EXPORT_LOG_INSERT$EXC ('RATE_BASE', :id_tar_head, :id_hotel, 0);

  execute procedure SYSTEM_LOG_ADD ('RATE', :ID_TAR_HEAD, 'RATE_CHANGED', :action_text);

  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||'NONE'||', '||:err_text;
    exception;
  end
end
^

/* Alter (TAR_SAVE_BO_BOARD) */
ALTER PROCEDURE TAR_SAVE_BO_BOARD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
/*****************************************************/
  declare variable id_tar_board integer;
  declare variable id_board integer;
  declare variable id_service integer;
  declare variable pos_numbers varchar(2000);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable separate_board integer;
  declare variable id_bo_price integer;
  declare variable price_type varchar(20);
  declare variable price_type_equal_exists integer;
  declare variable is_board integer;
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  err_text = '';
  iteration = 'FIRST';
  price_type_equal_exists = 0;

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_board, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
      if (:price_type_equal_exists = 1) then begin
        if (exists(
          select *
          from   TAR_BO_RELATION TBR
                 join TAR_BO_BASE_POSITION TBB on TBR.ID_TAR_BP = TBB.ID_TAR_BP
          where  TBR.ID_BO = :id_tar_board
                 and TBR.BO_TYPE = 'BOARD'
                 and TBB.ID_BOARD_INCLUDE is not distinct from :id_board
        )) then begin
          err_code = -237;
          exit;
        end
      end
      price_type_equal_exists = 0;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_board = gen_id(GEN_TAR_BO_BOARD_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers = '';
      id_board = null;
      separate_board = 0;
      ptext = '';
      disc_tag = 'F';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'PTEXT') then ptext = :data;
      else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
      else if (:param_name = 'SET_VAR')       then set_var = :data;
      else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
      else if (:param_name = 'LIST_BASE_POS') then pos_numbers = :data;
      else if (:param_name = 'SEPARATE_BOARD') then begin
        separate_board = :data;
        if ((:separate_board = 0) and (:board_type = 'HRANI')) then err_code = -226;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'PACKET_ITEM') then begin
        packet_item = :data;
      end else if (:param_name = 'HRANI') then begin
        if (:data = -1) then err_code = -210;
        else begin
          id_service = :data;
          select m.IS_BOARD
          from   MEALS M
          where  M.ID_SERVICE = :id_service
          into   :is_board;
          id_board = :id_service;

          if ((:is_board = 1) and (:board_type = 'HRANI')) then err_code = -228;
          else if ((:is_board = 0) and (:board_type = 'BOARD')) then err_code = -229;
        end
      end
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        /* WE ARE STARTING THE SEASON PRICES SO: */
        if ((:id_board is null) or (:id_board = -1)) then err_code = -210;
        else if ((:separate_board = 0) and (:board_type = 'HRANI')) then err_code = -226;
        if (:err_code < 0) then exit;
        if ((:separate_board = 1) and (:board_type = 'HRANI')) then separate_board = 2;
        insert into TAR_BO_BOARD(ID_TAR_BOARD, ID_TAR_HEAD, ID_SERVICE, ID_BOARD, PTEXT, SEPARATE_BOARD,
                    PACKET_ITEM, DISC_TAG, SET_VAR, RND_METHOD)
        values (:id_tar_board, :id_tar_head, :id_service, :id_board, :ptext, :separate_board,
               :packet_item, :disc_tag, :set_var, :rnd_method);
        iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_board, :bo_type, :id_tar_season)
      returning_values  :err_code, :id_bo_price, :price_type;
      if (:price_type = 'EQUAL') then begin
        if (:board_type = 'HRANI') then err_code = -225;
        price_type_equal_exists = 1;
      end
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:BO_TYPE||', '||:err_text;
  end
end
^

/* Alter (TAR_SAVE_BO_BP) */
ALTER PROCEDURE TAR_SAVE_BO_BP(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable no_use integer;
  declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
/*****************************************************/
  declare variable id_tar_bp integer;
  declare variable position_number varchar(20);
  declare variable id_room_type integer;
  declare variable max_persons integer;
  declare variable id_board_include integer;
  declare variable is_price_for_room integer;
  declare variable ptext varchar(20);
  declare variable price_type varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable board_weight integer;
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      insert into TAR_BO_RELATION(ID_TAR_BP, BO_TYPE, ID_BO, PARAM_FILTER)
      values (:id_tar_bp, :bo_type, :id_tar_bp, :param_filter);
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_bp = gen_id(GEN_TAR_BO_BP_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      position_number = null;
      id_room_type = null;
      max_persons = null;
      id_board_include = -1;
      is_price_for_room = 0;
      ptext = '';
      disc_tag = 'B';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'BASE_POS')            then begin
        if (:data = '') then err_code = -203;
        else position_number = :data;
      end else if (:param_name = 'ROOM_TYPE')  then begin
        if (:data = '') then err_code = -204;
        else id_room_type = :data;
      end else if (:param_name = 'MAX_PERSONS')then begin
        if (:data = '') then err_code = -205;
        else max_persons = :data;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'BOARD')      then id_board_include = :data;
      else if (:param_name = 'BPRICE_ROOM')    then is_price_for_room = :data;
      else if (:param_name = 'PACKET_ITEM')    then packet_item = :data;
      else if (:param_name = 'PTEXT')          then ptext = :data;
      else if (:param_name = 'DISC_TAG')       then disc_tag = :data;
      else if (:param_name = 'SET_VAR')        then set_var = :data;
      else if (:param_name = 'ROUND_TYPE')     then rnd_method = :data;
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        /* WE ARE STARTING THE SEASON PRICES SO: */
        board_weight = null;
        select m.WEIGHT_TAG
        from   MEALS M
        where  m.ID_BOARD = :id_board_include
        into   :board_weight;
        board_weight = coalesce(:board_weight, 0);

        insert into TAR_BO_BASE_POSITION(
          ID_TAR_BP, ID_TAR_HEAD, POSITION_NUMBER, ID_ROOM_TYPE, MAX_PERSONS, SET_VAR, RND_METHOD,
          ID_BOARD_INCLUDE, BOARD_WEIGHT, IS_PRICE_FOR_ROOM, PTEXT, PACKET_ITEM, DISC_TAG)
        values (
          :id_tar_bp, :id_tar_head, :position_number, :id_room_type, :max_persons, :set_var, :rnd_method,
          :id_board_include, :board_weight, :is_price_for_room, :ptext, :packet_item, :disc_tag);
       iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_bp, :bo_type, :id_tar_season)
      returning_values  :err_code, :no_use, :price_type;
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:BO_TYPE||', '||:err_text;
  end
end
^

/* Alter (TARIFA_BOARDS_SUPPORTED) */
ALTER PROCEDURE TARIFA_BOARDS_SUPPORTED(ID_TAR_HEAD INTEGER)
 RETURNS(ID_BOARD INTEGER)
 AS
declare variable is_simlpe integer;
declare variable id_hotel integer;
declare variable board_type varchar(10);
begin

  /*Looks into simple and complex rates and returns boards present in rate in format ,ID,ID, */

  select th.is_simple, t.ID_HOTEL, th.board_type
  from   TAR_HEAD th
         join TARIFA T on T.ID_TARIFA = th.ID_TAR_HEAD
  where  th.id_tar_head = :id_tar_head
  into   :is_simlpe, :id_hotel, :board_type;

  if (:is_simlpe is distinct from 1) then begin
    /*Complex*/
    if (:board_type = 'BOARD') then begin
      for
        select distinct tbpo.id_board_include
        from   TAR_BO_BASE_POSITION tbpo
        where  tbpo.id_tar_head = :id_tar_head
        union
        select distinct tbb.id_board
        from   TAR_BO_BOARD tbb
               join TAR_HEAD th on th.id_tar_head = tbb.id_tar_head
        where  th.id_tar_head = :id_tar_head

        into   :id_board
      do begin
        suspend;
      end
    end else begin
      -- board_type =  'HRANI' !!! MOJE DA SE POUMNI
      -- Ako tarifata e sa prosti hrani, ne se analizira kakwi kombinacii sa wazmojni, a se wra6tat wsi4ki hrani */
      for
        select h.ID_BOARD
        from   MEALS h
        where  h.IS_BOARD = 1
               and h.ID_HOTEL = :id_hotel
        into   :id_board
      do begin
        suspend;
      end
    end

  end else begin
    /*Simple*/
    for
      select distinct tsp.ID_BOARD
      from   TAR_SIMPLE_PRICE tsp
             join TAR_SIMPLE_SEASON tss on tsp.id_tar_simple_season = tss.id_tar_simple_season
             join TAR_SIMPLE ts on ts.id_tar_simple = tss.id_tar_simple
      where  ts.id_tar_head = :id_tar_head
      into   :id_board
    do begin
      suspend;
    end

  end

end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_PARAMS$INT for: TARIFA_GET_PARAM */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TARIFA_GET_PARAM) */
ALTER PROCEDURE TARIFA_GET_PARAM(ID_PARAM INTEGER,
FOR_DATE DATE,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER)
 RETURNS(OUT_VALUE VARCHAR(255))
 AS
declare variable is_interface integer;
  declare variable param_code varchar(30);
  declare variable is_value integer;
  declare variable int1 integer;
  declare variable data_type varchar(10);
  declare variable pvalue varchar(20);
  declare variable from_ date;
  declare variable to_ date;
begin
  select TP.IS_INTERFACE, TP.PARAM_CODE, TP.IS_VALUE, TP.DATA_TYPE, TP.PVALUE
  from   TARIFA_PARAMS TP
  where  ID_TARIFA_PARAM = :ID_PARAM 
  into   :is_interface, :param_code, :is_value, :data_type, :pvalue;
  /*get interface params*/
  if (:PARAM_CODE = 'NATION2') then
    PARAM_CODE = 'NATION'; /* !!!!!!!!!! */

  /*get value params*/
  if (:IS_VALUE = 1) then
    OUT_VALUE = :pvalue;

  /*get internal params*/
  OUT_VALUE = null;
  if (:IS_INTERFACE = 0) then begin
    if (:PARAM_CODE = 'TODAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'D;dd/mm/yyyy');

    end else if (:PARAM_CODE = 'WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'DW;MON');

    end else if (:PARAM_CODE = 'NEXT_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE + 1, 'DW;MON');

    end else if (:PARAM_CODE = 'PREV_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE - 1, 'DW;MON');

    end else if (:PARAM_CODE = 'REQUIRED_WEEK_DAYS') then begin
      select ti.FROM_DATE, ti.TO_DATE - 1
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :from_, :to_;
      
      select list(formatdate(RLP.OUT_DATE, 'DW;MON'))
      from   SYSTEM_LOOP_PERIOD(:from_, :to_) RLP
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'ARRIVAL_WEEK_DAYS') then begin
      select formatdate(ti.FROM_DATE, 'DW;MON')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PRESTOI') then begin
      select cast(ti.TO_DATE - ti.FROM_DATE as integer)
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'FROM_DATE') then begin
      select formatdate(ti.FROM_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TO_DATE') then begin
      select formatdate(ti.TO_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'FIRST_NIGHT') then begin
      select formatdate(ti.FROM_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'LAST_NIGHT') then begin
      select formatdate(ti.TO_DATE - 1, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_PASSED') then begin
       /* 01  03 -  01-1, 02-2   (        )*/   
       select cast((:FOR_DATE - G.FROM_DATE + 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_TO_STAY') then begin
       /* 01  03 -  01-2, 02-1    (  )*/
       select cast((G.TO_DATE - :FOR_DATE - 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_CHILDREN') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD = 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_ADULTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD is distinct from 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS_BY_ACCOUNT') then begin
      select (select count(*)
              from   GUEST G
                     join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
              where  G.ID_BASE_ACCOUNT = ti.ID_BASE_ACCOUNT
                     and G.FROM_DATE <= :FOR_DATE
                     and G.TO_DATE > :FOR_DATE
                     and RD.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP ti
      where  ti.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_ROOM') then begin
      select trim(rt.TYPE_ROOM)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = tid.ID_ROOM_TYPE
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;
      /* TO PRESEVE COMPATIBILITY WITH OLD TARIFF VERSIONS */
      /* WE HAVE TO RETURN THE NAME NOT THE ID !           */

    end else if (:PARAM_CODE = 'TYPE_STAY') then begin
      select trim(ts.TYPE_STAY)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join TYPE_STAY TS on ts.ID_TYPE_STAY = tid.ID_TYPE_STAY
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_HRANA') then  begin
      select trim(m.NAME)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join MEALS m on m.ID_BOARD = tid.ID_BOARD
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = trim(coalesce(:OUT_VALUE, ''));

    end else if (:PARAM_CODE = 'PACK_ITEMS') then begin
      OUT_VALUE = null;
      select TID.PACKET_ITEMS
      from   TAR_CALC_INPUT$TMP TID
      where  TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = coalesce(:OUT_VALUE, '~~');
      -- strfloateval('POS("~2~", :PACK_ITEMS)>0', ';:PACK_ITEMS,STRING,~2~3~D~')

    end else if (:PARAM_CODE = 'AGE') then begin
      select ti.GUEST_AGE
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_SEX') then begin
      select G.GUEST_SEX
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE ;
      if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then OUT_VALUE = '-' ;

    end else if (:PARAM_CODE = 'NATION') then begin
      select tid.COUNTRY_CODE
      from   TAR_CALC_INPUT$TMP TID
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_DATE') then begin
      select cast(iif(G.FROM_DATE = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LAST_DATE') then begin
      select cast(iif(G.TO_DATE -1 = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LATE_CHECKOUT') then begin
      select g.IS_LATE_CHECKOUT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_GUEST_IN_ROOM') then begin
      select (select count(ti.ID_TAR_INPUT)
              from   TAR_CALC_INPUT$TMP ti
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and ti.ID_GUEST < t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :int1;

      if (:int1 = 0) then OUT_VALUE = 1; else OUT_VALUE = 0;
      
    end else if (:PARAM_CODE = 'IS_DIFER_NATIONS') then begin
      select (select cast(iif(count(distinct ti.COUNTRY_CODE) > 1, 1, 0) as integer)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_GROUP') then begin
      select cast(iif(g.ID_GROUP is not null, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_NIGHTS_BY_ACCOUNT') then begin
      /*          . */
      select (select cast(sum (G_IN_R.TO_DATE - G_IN_R.FROM_DATE) as integer)
              from   GUEST G_IN_R
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_R.ID_RESERV_DETAIL
              where  G_IN_R.ID_BASE_ACCOUNT = G.ID_BASE_ACCOUNT
                     and G_IN_R.CHECK_STATUS = 0
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYACCOUNT') then begin
      select (select cast(count(G.ID_GUEST) as integer)
              from   GUEST G
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  G.ID_BASE_ACCOUNT = t.ID_BASE_ACCOUNT
                     and G.ID_GUEST <= t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PAX_PRICE_WO_ADDINS') then begin
      /*             */
      /* PRICE_ORIG          */
      -- ?????    ???
      /*select  max(AP.PRICE_ORIG)
      from    ACCOUNT_POST AP 
      where   AP.ID_GUEST = :ID_GUEST
              and AP.DATE_POST = :FOR_DATE
              and AP.IS_BASE = 1
      plan    (AP index (ACCOUNT_POST_IDX6))
      into    :OUT_VALUE;
      */
      OUT_VALUE = null;

    end else if (:PARAM_CODE = 'ROOM_FEATURES') then begin
      select substring(R.FEATURES from 1 for 255)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join ROOMS R on r.ID_ROOM = tid.ID_ROOM
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_NIGHTS') then begin
      select (select cast(sum (G_IN_V.TO_DATE - G_IN_V.FROM_DATE) as integer)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE ;

    end else if (:PARAM_CODE = 'VAUCHER_GUESTS') then begin
      select (select count (G_IN_V.ID_GUEST)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_DATE') then begin
      select formatdate(G.VOUCHER_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_TEXT') then begin
      select G.VOUCHER_TEXT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYROOM') then begin
      select (select count(*) + 1
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ((t.IS_CHILD = 0 and ti.IS_CHILD = 0 and td.CHECKIN_ORDER < tid.CHECKIN_ORDER)
                          or (t.IS_CHILD = 1 and ((ti.IS_CHILD = 0) or (ti.GUEST_AGE > t.GUEST_AGE) or (ti.GUEST_AGE = t.GUEST_AGE and td.CHECKIN_ORDER < tid.CHECKIN_ORDER) )))
              )
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'ADULT_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*) + 1
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and td.CHECKIN_ORDER < tid.CHECKIN_ORDER
                     and ti.IS_CHILD = 0)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 0
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'CHILD_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*) + 1
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ( (ti.GUEST_AGE > t.GUEST_AGE) or (ti.GUEST_AGE = t.GUEST_AGE and td.CHECKIN_ORDER < tid.CHECKIN_ORDER) )
                     and ti.IS_CHILD = 1)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 1
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_TYPE') then begin
      select G.ID_GUEST_TYPE
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TO_AGENT') then begin
      select G.ID_AGENT_PROFILE
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else begin
      exception RATING_EXCEPTION 'Unsupported param - '||:PARAM_CODE;
    end

  end /*PART OF INTERNAL PARAMS*/


  /**********************************************/
  begin
    /* the source of the next check is gone with the wind
    /* but we must distinguish different data types */
    if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then begin
      /*not allow nulls*/
      if (:DATA_TYPE = 'DATE') then OUT_VALUE = '01/01/1899';
      else OUT_VALUE = '-1';  -- Unspecified
    end else if (:DATA_TYPE = 'INTEGER') then begin
      OUT_VALUE = cast(:OUT_VALUE as integer);
      /* to prevent errors like OUT_VALUE = '00001' */
    end

    when any do exception RATING_EXCEPTION 'Unsupported param value: ' || :param_code || ' = "' || coalesce(:OUT_VALUE, '<null>') || '"';
  end
  /**********************************************/
end
^

/* Alter (TASK_MODIFY) */
ALTER PROCEDURE TASK_MODIFY(ID_TASK INTEGER,
DESCRIPTION VARCHAR(255),
DT_ACTIVATE TIMESTAMP,
STATUS SMALLINT,
TYPE_ SMALLINT,
PRIORITY SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_TASK INTEGER)
 AS
declare variable oldStatus smallint;
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del, undel, complete, snooze');

  if ((:id_task is null) or (:id_task <= 0)) then
    new_id_task = gen_id(GEN_TASK_ID, 1);
  else new_id_task = :id_task;
                              
  if (:operation = 'add') then begin
    insert into TASK (ID_TASK, DESCRIPTION, DT_ACTIVATE, DT_CREATE, USER_CREATE, STATUS, PRIORITY, IS_DELETED, TYPE_)
    values (:new_id_task, :description, :dt_activate, current_timestamp, current_user, :status, :priority, 0, :type_);
  end else if (:operation = 'mod') then begin
    select STATUS
    from  TASK
    where  ID_TASK = :id_task
    into :oldStatus;

    update TASK
    set    DESCRIPTION = :description,
           DT_ACTIVATE = :dt_activate,
           STATUS = :status,
           PRIORITY = :priority,
           TYPE_ = :type_
    where  ID_TASK = :id_task;

    if (:oldStatus <> :status) then
      if (status = 1) then begin
        execute procedure TASK_MODIFY (:id_task, :description, :dt_activate, :status, :type_, priority, 'complete')
        returning_values :new_id_task;
      end
  end else if (:operation = 'del') then begin
    update TASK
    set    IS_DELETED = 1,
           USER_DELETED = current_user,
           DT_DELETED = current_timestamp
    where  ID_TASK = :id_task;
  end else if (:operation = 'undel') then begin
    update TASK
    set    IS_DELETED = 0
    where  ID_TASK = :id_task;
  end else if (:operation = 'complete') then begin
    update TASK
    set    STATUS = 1,
           USER_COMPLETED = current_user,
           DT_COMPLETED = current_timestamp
    where  ID_TASK = :id_task;
  end else if (:operation = 'snooze') then begin
    update TASK
    set    STATUS = 0,
           DT_ACTIVATE = ADDMINUTE(current_timestamp,extract(minute from :dt_activate)+extract(hour from :dt_activate)*60)
    where  ID_TASK = :id_task;
  end
  execute procedure SYSTEM_CACHE_APPLY('task');
  execute procedure SYSTEM_CACHE_APPLY('task_lm');

  execute procedure SYSTEM_LOG_ADD('SYSTEM', :new_id_task, 'TASK_CHANGED', '');
end
^

/* Alter (TAX_POLICY_MODIFY$CFG) */
ALTER PROCEDURE TAX_POLICY_MODIFY$CFG(ID_TAX_POLICY TYPE OF ID,
POLICY_NAME TYPE OF TDESCRIPTION_SHORT,
IS_ARCHIVE TYPE OF TLOGICAL,
OPERATION VARCHAR(10),
ID_HOTEL TYPE OF ID)
 RETURNS(NEW_ID_TAX_POLICY INTEGER)
 AS
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation = 'add') then begin
    insert into TAX_POLICY (ID_TAX_POLICY, POLICY_NAME, IS_ARCHIVE, ID_HOTEL)
    values (nullif(:ID_TAX_POLICY, -1), :POLICY_NAME, :IS_ARCHIVE, :ID_HOTEL)
    returning ID_TAX_POLICY
    into      :NEW_ID_TAX_POLICY;

  end else if (:operation = 'mod') then begin
    update TAX_POLICY TP
    set    TP.POLICY_NAME = :POLICY_NAME,
           TP.IS_ARCHIVE = :is_archive
    where  TP.ID_TAX_POLICY = :ID_TAX_POLICY;

    NEW_ID_TAX_POLICY = :ID_TAX_POLICY;
  end else if (:operation = 'del') then begin
    execute procedure SYSTEM_LOG_ADD ('TAX_POLICY', :ID_TAX_POLICY, 'DELETE', '');
    delete from TAX_POLICY TP
    where  TP.ID_TAX_POLICY = :ID_TAX_POLICY;

    NEW_ID_TAX_POLICY = null;
  end

  execute procedure SYSTEM_CACHE_APPLY('TAX_POLICY');
end
^

/* Alter (TEST_DOC) */
ALTER PROCEDURE TEST_DOC(ID_ACCOUNT INTEGER,
DOC_SELECTED INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER)
 AS
declare variable is_dep_doc integer;
  declare variable id_hotel integer;
  declare variable dummy varchar(255);
begin
  is_dep_doc = 0;

  execute procedure DOCUMENT_INITIALIZE$DOC (:id_account, :doc_selected, null)
  returning_values (:id_doc_head, :id_hotel, :dummy, :dummy);

  execute procedure DOCUMENT_ADD_DEF_PAYMENT$DOC (:id_doc_head, null);

  execute procedure DOCUMENT_VALIDATE$DOC (:id_doc_head)
  returning_values :dummy, :dummy, :dummy;
  suspend;
end
^

/* Alter (UPDATE_BOOKING$EXC) */
ALTER PROCEDURE UPDATE_BOOKING$EXC(BOOKING_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE INTEGER,
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA_ID INTEGER,
POSTING_ROUTING VARCHAR(20),
ID_AGENT_ACCOUNT INTEGER,
RATE_ID INTEGER,
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD_CODE TFOOD_CODE,
ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable hotel_id integer;
  declare variable warn_code integer;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable rd_dbkey char(8);
  declare variable current_status_code smallint;
BEGIN
  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => START(' || :booking_id || ')');

  select RD.RDB$DB_KEY, RD.ID_HOTEL, RD.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :booking_id
  into  :rd_dbkey, :hotel_id, :current_status_code;

  execute procedure update_posting_transaction$exc(:rd_dbkey, :posting_transaction_uuid, 0);

  /* lock all guests */
  update guest set ORPHANED_IMPORT$EXC=1 where id_reserv_detail=:booking_id;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_GUARANTEE$RSV');
  execute procedure RES_SAVE_GUARANTEE$RSV(
    :booking_id, :is_vip, :current_status_code, :id_guarantee_policy,
    :deposit_required, :deposit_required_currency, :block_cc,
    :guarantee_deposit_percent, :guarantee_deposit_nights, :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_STAY$RSV');
  execute procedure RES_SAVE_STAY$RSV(
    :booking_id, :arrival, :departure, :is_late_departure,
    :arrival_type, 0
  ) returning_values :share_err_code, :err_text, :share_transaction_id, :warn_code;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_BOARD$INT');
  execute procedure RES_SAVE_BOARD$INT(
    :rd_dbkey, :board_id
  ) ;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_OTHER$RSV');
  execute procedure RES_SAVE_OTHER$RSV(
    :booking_id, :transfer_in_time, :transfer_in_note,
    :transfer_out_time, transfer_out_note, :first_food_code
  ) ;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_ROOM$EXC(room_type_id=>' || coalesce(:room_type_id, '<null>') || ')');
  execute procedure RES_SAVE_ROOM$EXC(
    :rd_dbkey, :room_type_id, :maintance_shema_id, :room_preferences, :special_treatment, :split_on_checkin
  ) returning_values :err_text, :warn_code, :share_transaction_id, :share_err_code;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_MARKETING$RSV');
  execute procedure RES_SAVE_MARKETING$RSV(
    :booking_id, :marketing1_id, :marketing2_id, :marketing3_id, :marketing4_id, :marketing5_id
  ) returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_RATE$RSV(:rate_id=>'
  || coalesce(:rate_id, '<null>')
  || ', :booking_id=>' || coalesce(:booking_id, '<null>')
  || ', :manual_price=>' || coalesce(:manual_price, '<null>')
  || ', :manual_price_currency=>' || coalesce(:manual_price_currency, '<null>')
  || ', :is_different_rate=>' || coalesce(:is_different_rate, '<null>')
  || ')');
  execute procedure RES_SAVE_RATE$RSV(
    :booking_id, :rate_id, :manual_price, :manual_price_currency,
    :is_different_rate, :is_different_price, 0
  );

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_VOUCHER$RSV');
  execute procedure RES_SAVE_VOUCHER$RSV(
    :booking_id, :voucher, :voucher_date, :voucher_text, null,  null
  );

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_NOTE$RSV');
  execute procedure RES_SAVE_NOTE$RSV(
    :booking_id, :note, :note_reminders);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_ACCOUNTING$RSV(arranger_profile_id=>'
    || coalesce(:arranger_profile_id, '<null>')
    || ', posting_routing=>' || coalesce(:posting_routing, '<null>')
    || ', id_agent_account=>' || coalesce(:id_agent_account, '<null>')
    || ')');
  execute procedure RES_SAVE_ACCOUNTING$INT(
    :rd_dbkey, :arranger_profile_id,
    :id_agent_account,
    :posting_routing,
    :guest_payment_type_id,
    :arranger_payment_type_id,
    :reserv_group_id
  ) ;

  /*execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_PACKET$RSV');
  execute procedure RES_SAVE_PACKET$RSV(
    :booking_id, :packet_id, 0
  );
  */
  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_EATING_OBJECT$RSV');
  execute procedure RES_SAVE_EATING_OBJECT$RSV(:booking_id, :id_eating_object);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => END(' || :booking_id || ')');
END
^

/* Restore proc. body: ACCOUNT_MODIFY$INT */
ALTER PROCEDURE ACCOUNT_MODIFY$INT(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL TYPE OF ID_REF,
IS_PMS_ACCOUNT TYPE OF TLOGICAL,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable a_dbkey char(8);
  declare variable old_sec_level integer;
  declare variable action_text varchar(255);
  declare variable old_acc_name varchar(50);
  declare variable old_acc_curr varchar(3);
  declare variable old_tax_policy integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, archive');

  new_id_account = :id_account;
  if (:operation = 'add') then begin
    if ((:new_id_account is null) or (:new_id_account <= 0)) then new_id_account = gen_id(ID_ACCOUNT_GEN, 1);

    insert into ACCOUNT(ID_ACCOUNT, ACCOUNT_CURR, ACCOUNT_NAME, IS_CREDIT_ACCOUNT, CREDIT_LIMIT,
           ID_TYPE_PAYMENT, NOTE, IS_BLOCKED, BLOCK_TEXT, SECURITY_LEVEL, IS_BASE, IS_EXTRA,
           IS_ALOWED_POS_INTERFACE, POS_INTERFACE_NOTE, EXT_CODE, ID_TAX_POLICY, ID_PROFILE,
           ID_HOTEL, IS_DEFAULT, IS_PMS_ACCOUNT, ID_RESERV_DETAIL)
    values (:new_id_account, :account_curr, :account_name, 0, null,
           :id_type_payment, :note, :is_blocked, :block_text, :security_level, :is_base, :is_extra,
           :is_alowed_pos_interface, :pos_interface_note, :ext_code, :id_tax_policy, :id_profile,
           :id_hotel, :is_default, coalesce(:IS_PMS_ACCOUNT, 0), :ID_RESERV_DETAIL)
    returning RDB$DB_KEY
    into   :a_dbkey;

    action_text = f_character(29) || :new_id_account || '/' || :account_name;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'ADD_ACCOUNT', :action_text);

    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:NEW_ID_ACCOUNT, :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT);
    -- check special right and log event

  end else begin
    ID_RESERV_DETAIL = null;
    select A.RDB$DB_KEY, A.ID_RESERV_DETAIL, A.SECURITY_LEVEL,
           A.ACCOUNT_NAME, A.ACCOUNT_CURR, A.ID_TAX_POLICY
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :a_dbkey, :id_reserv_detail, :old_sec_level,
           :old_acc_name, :old_acc_curr, :old_tax_policy;
    if (:operation = 'mod') then begin
  
      update ACCOUNT A
      set    A.ACCOUNT_NAME = :account_name,
             A.ID_TYPE_PAYMENT = :id_type_payment,
             A.NOTE = :note,
             A.IS_BLOCKED = :is_blocked,
             A.BLOCK_TEXT = :block_text,
             A.SECURITY_LEVEL = :security_level,
             A.IS_BASE = :is_base,
             A.IS_EXTRA = :is_extra,
             A.IS_ALOWED_POS_INTERFACE = :is_alowed_pos_interface,
             A.POS_INTERFACE_NOTE = :pos_interface_note,
             A.EXT_CODE = :ext_code,
             A.ID_TAX_POLICY = :id_tax_policy,
             A.IS_DEFAULT = :is_default
      where  A.RDB$DB_KEY = :a_dbkey;
  
      execute procedure ACCOUNT_SET_CURRENCY$INT (:a_dbkey, :account_curr);
  
      if (:old_acc_name <> :account_name) then begin
        action_text = f_character(29 ) || :ID_ACCOUNT || '/' || :old_acc_name || ', ' || :old_acc_curr
                      || f_character(28) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME || ', ' || :ACCOUNT_CURR;
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'EDIT_ACCOUNT', :action_text);
      end
  
      if (:old_sec_level <> :SECURITY_LEVEL) then begin
        action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME
                      || f_character(28) || :SECURITY_LEVEL;
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'SET_ACC_SEC_LEVEL', :action_text);
      end
  
      if (:old_tax_policy <> :id_tax_policy) then begin
        execute procedure ACCOUNT_TAXATION_RECALC$INT (:ID_ACCOUNT, :ID_TAX_POLICY);
  
        action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME;                        
  
        select :action_text || f_character(28) || OTP.POLICY_NAME
        from   TAX_POLICY OTP
        where  OTP.ID_TAX_POLICY = :old_tax_policy
        into   :action_text;
        select :action_text || f_character(28) || NTP.POLICY_NAME
        from   TAX_POLICY NTP
        where  NTP.ID_TAX_POLICY = :ID_TAX_POLICY
        into   :action_text;
         
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'VAT_POLICY_CHNG', :action_text);
      end
  
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:ID_ACCOUNT, :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT); -- check special right and log event
  
    end else if (:operation = 'archive') then begin
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 1);

    end
  end

  if ((:id_reserv_detail is null) and (:IS_CREDIT_ACCOUNT = 0)) then begin
    exception ACCOUNT_EXCEPTION '-1010';
    -- The account must have active credit status
    exit;
  end

  if (:is_default = 1) then begin
    update ACCOUNT A
    set    A.IS_DEFAULT = 0
    where  A.ID_HOTEL = :id_hotel
           and A.ID_PROFILE = :id_profile
           and A.ID_ACCOUNT <> :new_id_account;
  end
end
^

/* Restore proc. body: ACCOUNT_MODIFY_TEMPLATE$PROFILE */
ALTER PROCEDURE ACCOUNT_MODIFY_TEMPLATE$PROFILE(ID_ACC_TEMPLATE INTEGER,
TEMPLATE_NAME VARCHAR(40),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,4),
SECURITY_LEVEL INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
ID_TAX_POLICY INTEGER,
IS_ARCHIVE INTEGER,
OPERATION VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(NEW_ID_ACC_TEMPLATE INTEGER)
 AS
declare variable action_text varchar(255);
declare variable tax_policy_name varchar(100);
declare variable old_template_name varchar(50);
declare variable old_security_level integer;
declare variable old_is_credit_account smallint;
declare variable old_credit_limit numeric(15,4);
declare variable old_is_alowed_pos_interface smallint;
declare variable old_id_tax_policy integer;
declare variable old_is_archive integer;
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  new_id_acc_template = :id_acc_template;
  if (:operation = 'add') then begin
    if ((:new_id_acc_template is null) or (:new_id_acc_template <= 0)) then new_id_acc_template = gen_id(ID_ACCOUNT_GEN, 1);

    insert into ACC_TEMPLATE (ID_ACC_TEMPLATE, TEMPLATE_NAME, SECURITY_LEVEL, IS_CREDIT_ACCOUNT, CREDIT_LIMIT,
           IS_ALOWED_POS_INTERFACE, ID_TAX_POLICY, IS_ARCHIVE, ID_HOTEL)
    values (:new_id_acc_template, :template_name, :security_level, :is_credit_account, :credit_limit,
           :is_alowed_pos_interface, :id_tax_policy, 0, :ID_HOTEL);

    action_text = f_character(29) || :template_name;
    execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACCOUNT_TEMPLATE_CREATE', :action_text);

  end else if (:operation = 'mod') then begin
    select act.template_name,
           act.security_level,
           act.is_credit_account,
           act.credit_limit,
           act.is_alowed_pos_interface,
           act.id_tax_policy,
           act.is_archive
    from   ACC_TEMPLATE act
    where  act.id_acc_template = :id_acc_template
    into   :old_template_name, :old_security_level, :old_is_credit_account, :old_credit_limit, :old_is_alowed_pos_interface,
           :old_id_tax_policy, :old_is_archive;
    if (:template_name <> :old_template_name) then begin
      action_text = f_character(29) || :old_template_name || f_character(28) || :template_name;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_NAME_CHANGED', :action_text);
    end
    if (:security_level <> :old_security_level) then begin
      action_text = f_character(29) || :old_security_level || f_character(28) || :security_level;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_SEC_LEVEL_CHANGED', :action_text);
    end
    if (:is_credit_account <> :old_is_credit_account) then begin
      action_text = f_character(29) || :old_is_credit_account || f_character(28) || :is_credit_account;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_CR_ACC_CHANGED', :action_text);
    end
    if (coalesce(:credit_limit, 0) <> coalesce(:old_credit_limit, 0)) then begin
      action_text = f_character(29) || formatfloat(:old_credit_limit, '0.00') || f_character(28) || formatfloat(:credit_limit, '0.00');
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_CR_LIM_CHANGED', :action_text);
    end
    if (:is_alowed_pos_interface <> :old_is_alowed_pos_interface) then begin
      action_text = f_character(29) || :old_is_alowed_pos_interface || f_character(28) || :is_alowed_pos_interface;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_POS_CHANGED', :action_text);
    end
    if (:id_tax_policy <> :old_id_tax_policy) then begin
      select f_character(29) || policy_name
      from tax_policy
      where id_tax_policy = :old_id_tax_policy
      into :action_text;
      select f_character(28) || policy_name
      from tax_policy
      where id_tax_policy = :id_tax_policy
      into :tax_policy_name;
      action_text = :action_text || :tax_policy_name;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_TAX_POL_CHANGED', :action_text);
    end
    if (:is_archive <> :old_is_archive) then begin
      action_text = f_character(29) || :old_is_archive|| f_character(28) || :is_archive;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_IS_ARCH_CHANGED', :action_text);
    end
    update ACC_TEMPLATE
    set    TEMPLATE_NAME = :template_name,
           SECURITY_LEVEL = :security_level,
           IS_CREDIT_ACCOUNT = :is_credit_account,
           CREDIT_LIMIT = :credit_limit,
           IS_ALOWED_POS_INTERFACE = :is_alowed_pos_interface,
           ID_TAX_POLICY = :id_tax_policy,
           IS_ARCHIVE = :is_archive
    where  ID_ACC_TEMPLATE = :id_acc_template;
  end else if (:operation = 'del') then begin
    select template_name
    from   ACC_TEMPLATE
    where  ID_ACC_TEMPLATE = :id_acc_template
    into   :old_template_name;

    execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'DELETE', '');

    delete from ACC_TEMPLATE
    where  ID_ACC_TEMPLATE = :id_acc_template;

  --  action_text = f_character(29) || :old_template_name;
  --  execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_DELETED', :action_text);
  end

end
^

/* Restore proc. body: ACCOUNT_POSTING_ANUL */
ALTER PROCEDURE ACCOUNT_POSTING_ANUL(IN_ID_ACCOUNT_POST INTEGER,
IN_ANUL_REASON VARCHAR(70))
 AS
declare variable action_text varchar(255);
  declare variable id_account integer;
  declare variable qty_post numeric(15,2);
  declare variable price_post double precision;
  declare variable date_post date;
  declare variable id_service integer;
  declare variable curr_post varchar(3);
  declare variable ap_dbkey char(8);
begin
  /* called only from GUI - manual anullment */
  select AP.RDB$DB_KEY, AP.ID_ACCOUNT, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST
  from   ACCOUNT_POST AP
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :ap_dbkey, :id_account, :qty_post, :price_post,
         :date_post, :id_service, :curr_post;

  execute procedure ACCOUNT_POSTING_ANUL$INT (:ap_dbkey, :IN_ANUL_REASON);

  select S.SERVICE_NAME
  from   SERVICES S
  where  S.ID_SERVICE = :id_service
  into   :action_text;

  action_text = f_character(29) || :action_text
                || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:qty_post * :price_post, 'F;0.00') || ' ' || :curr_post
                || f_character(28) || replace(:IN_ANUL_REASON, 'MANUAL', '');
  execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_ANUL', :action_text);
end
^

/* Restore proc. body: ACCOUNT_POSTING_ANUL$INT */
ALTER PROCEDURE ACCOUNT_POSTING_ANUL$INT(AP_DBKEY TYPE OF TDB_KEY,
ANUL_REASON TYPE OF TREASON)
 AS
declare variable is_anul integer;
  declare variable qty_post integer;
  declare variable orig_is_base integer;
  declare variable orig_short_code varchar(255);
  declare variable id_base_doc integer;
  declare variable rp_dbkey char(8);
  declare variable id_resource_reserv integer;
  declare variable id_account_post integer;
  declare variable is_locked_for_update integer;
  declare variable orig_ac varchar(2);
  declare variable doc_qty numeric(15,2);
begin
  select AP.ID_ACCOUNT_POST, AP.IS_ANUL, AP.QTY_POST,
         AP.IS_BASE, AP.SHORT_CODE, AP.ID_BASE_DOC, ap.AC, ap.IN_DOC_QTY
  from   ACCOUNT_POST AP
  where  AP.rdb$db_key = :AP_DBKEY
  into   :id_account_post, :is_anul, :qty_post,
         :orig_is_base, :orig_short_code, :id_base_doc, :orig_ac, :doc_qty;

  /*if (:is_anul = 1) then begin
    exception POSTING_ANNUL_EXCEPTION '-33'; /* POSTING IS ALREADY ANULED */
  /*end*/

  if (:ANUL_REASON not like '%RECALC_%') then begin
    /* MANUAL ANUL */
    is_locked_for_update = 1;
    execute procedure RIGHTS_CHECK_GRANTED$INT('ACCPOSTANUL');
    if (:orig_ac = '01') then execute procedure RIGHTS_CHECK_GRANTED$INT('BALANCES_EDIT_CLOSED');

    if (:orig_is_base = 1) then exception POSTING_ANNUL_EXCEPTION '-103'; /* CAN`T ANUL BASE SERVICE */
  end else begin
    /* AUTO RECALC */
    is_locked_for_update = 0;
  end

  if (:id_base_doc > 0) then begin -- has a valid doc
    if (:qty_post = 0) then exit;  -- already anul
    qty_post = 0;
    if (:doc_qty = 0) then begin   -- has a storno doc for this posting
      is_anul = 1;
    end else begin
      is_anul = 0;
    end
  end else begin
    if (:is_anul = 1) then exit;   -- already anul
    is_anul = 1;
  end

  update ACCOUNT_POST APU
  set    APU.IS_ANUL = :is_anul,
         APU.QTY_POST = :qty_post,
         APU.USER_ANUL = current_user,
         APU.ANUL_DATETIME = current_timestamp,
         APU.ANUL_REASON = :anul_reason,
         APU.CHANGED_TEXT = substring(:anul_reason from 1 for 30),
         APU.AC = :is_anul || '0',
         APU.DATETIME_CHANGED = current_timestamp,
         APU.POST_NET_VALUE = 0,
         APU.POST_GROSS_VALUE = 0,
         APU.IS_LOCKED_FOR_UPDATE = :is_locked_for_update
  where  APU.rdb$db_key = :AP_DBKEY;

  if (:orig_short_code = 'TELECOUNT') then begin
    update PHONECALLS PH
    set    PH.ID_ACCOUNT_POST = -1,
           PH.IS_LOGICLESS_RECORD = 1
            /*!!! TO PREVENT FUTURE AUTO TRANSFER !!!*/
    where  PH.ID_ACCOUNT_POST = :id_account_post;
  end else if (:orig_short_code = 'RESOURCE') then begin
    select RP.RDB$DB_KEY, RP.ID_RESOURCE_RESERVATION
    from   RESOURCE_RESERV_POST RP
    where  RP.ID_ACCOUNNT_POST = :id_account_post
    into   :rp_dbkey, :id_resource_reserv;

    delete from RESOURCE_RESERV_POST RRP
    where  RRP.RDB$DB_KEY = :rp_dbkey;

    execute procedure RESOURCE_RESERV_RESET$INT (:id_resource_reserv);

  end else if (:orig_short_code = 'PMS') then begin
    if (exists ( select *
                 from   PMS_EVENT_POST P
                 where  P.LINE_STATUS > 11
                        and P.ID_ACCOUNT_POST = :id_account_post )) then exception PMS_EXCEPTION '-620';

    update PMS_EVENT_POST PP
    set    PP.LINE_STATUS = 22
    where  PP.ID_ACCOUNT_POST = :id_account_post;
  end


  if (:orig_is_base = 1) then begin
    /* ANUL THE REST OF THE PACKET (ADDINS) */
    for
      select AP_addins.rdb$db_key
      from   ACCOUNT_POST AP_addins
      where  AP_addins.ID_MASTER_ADDINS_ACC_POST = :id_account_post
             and AP_addins.IS_BASE = 0
             and AP_addins.IS_ANUL = 0
      into   :ap_dbkey
    do begin
      execute procedure ACCOUNT_POSTING_ANUL$INT (:AP_DBKEY, :ANUL_REASON);
    end
  end

end
^

/* Restore proc. body: ACCOUNT_POSTING_MULTIANUL */
ALTER PROCEDURE ACCOUNT_POSTING_MULTIANUL(AP_LIST VARCHAR(4096),
ANUL_REASON VARCHAR(70))
 AS
declare variable ap_dbkey char(8);
  declare variable id_account integer;
  declare variable prev_id_account integer;
  declare variable curr_post varchar(3);
  declare variable post_value double precision;
  declare variable log_curr varchar(3);
  declare variable log_value double precision;
  declare variable action_text varchar(255);
begin
  prev_id_account = null;
  log_value = 0;
  for
    select AP.RDB$DB_KEY, AP.ID_ACCOUNT, AP.CURR_POST, AP.QTY_POST * AP.PRICE_POST
    from   SYSTEM_STRING_PARSER(:ap_list, ',') SP
           left outer join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = SP.ITEM
    order by AP.ID_ACCOUNT asc
    into   :ap_dbkey, :id_account, :curr_post, :post_value
  do begin
    execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_dbkey,  :anul_reason);

    if (:prev_id_account is not null and :prev_id_account <> :id_account) then begin
      action_text = f_character(29) || formatfloat(:log_value, 'F;0.00') || ' ' || :log_curr
                    || f_character(28) || replace(:ANUL_REASON, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_MULTIANUL', :action_text);
    end
    log_value = :log_value + :post_value;
    log_curr = :curr_post;
    prev_id_account = :id_account;
  end

  if (:id_account is not null) then begin
    action_text = f_character(29) || formatfloat(:log_value, 'F;0.00') || ' ' || :log_curr
                  || f_character(28) || replace(:ANUL_REASON, 'MANUAL', '');
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_MULTIANUL', :action_text);
 end
end
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$ACC */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
declare variable ap_dbkey char(8);
  declare variable transfer_value double precision;
  declare variable post_value double precision;
  declare variable id_account integer;
  declare variable tmp_id_account integer;
  declare variable curr_post varchar(3);
  declare variable acc_name varchar(50);
  declare variable action_text varchar(255);
  declare variable is_pms_account integer;
  declare variable dest_acc_name varchar(50);
begin

  id_account = null;
  transfer_value = 0;

  select ACC.ACCOUNT_NAME, acc.IS_PMS_ACCOUNT
  from   ACCOUNT ACC
  where  ACC.ID_ACCOUNT = :ID_DEST_ACCOUNT
  into   :dest_acc_name, is_pms_account;

  if (:is_pms_account = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('PMS_TRANSFER_POSTINGS');
  end

  for
    select AP.RDB$DB_KEY, AP.ID_ACCOUNT, ap.PRICE_POST * ap.QTY_POST
    from   ACCOUNT_POST AP
    where  AP.DOC_SELECTED = :DOC_SELECTED
           and AP.ID_ACCOUNT = coalesce(:ID_SRC_ACCOUNT, AP.ID_ACCOUNT)
           and AP.ID_ACCOUNT is distinct from :ID_DEST_ACCOUNT
    order by AP.ID_ACCOUNT asc
    into   :ap_dbkey, :tmp_id_account, :post_value
  do begin
    execute procedure ACCOUNT_POSTING_TRANSFER$INT (:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:id_account is null) then id_account = :tmp_id_account;

    /* update from/to pms account */
    execute procedure ACCOUNT_POST_EVENT_REROUTE$INT(:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:tmp_id_account is distinct from :id_account) then begin
      select A.ACCOUNT_NAME, A.ACCOUNT_CURR
      from   ACCOUNT A
      where  A.ID_ACCOUNT = :id_account
      into   :acc_name, :curr_post;

      action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                    f_character(28) || :id_account || '/' || :acc_name ||
                    f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
      execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
      id_account = :tmp_id_account;
      transfer_value = 0;
    end
    transfer_value = :transfer_value + :post_value;
  end

  if (:id_account is not null) then begin
    select A.ACCOUNT_NAME, A.ACCOUNT_CURR
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :acc_name, :curr_post;
  
    action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                  f_character(28) || :id_account || '/' || :acc_name ||
                  f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
  end
end
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER,
IS_MANUAL_TRANSFER TYPE OF TLOGICAL = 1)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date,
                    iif(:IS_MANUAL_TRANSFER is distinct from 1, 1, 0), :id_target_account)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Restore proc. body: ACCOUNT_POSTING_UPDATE */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    action_text = f_character(29) || :action_text
                  || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                  || f_character(28) || :log_old_value
                  || f_character(28) || :log_new_value
                  || f_character(28) || replace(:IN_CHANGED_TEXT, 'MANUAL', '');
    execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
  end

end
^

/* Restore proc. body: ACCOUNT_POSTS_ON_DATE$RPT */
ALTER PROCEDURE ACCOUNT_POSTS_ON_DATE$RPT(ID_HOTEL INTEGER,
TO_DATE DATE,
INCL_CORR SMALLINT,
INCL_POSTS SMALLINT,
IN_ID_ACCOUNT INTEGER = null)
 RETURNS(POST_ID INTEGER,
ID_ACCOUNT INTEGER,
ID_GUEST INTEGER,
ROOM_NAME VARCHAR(20),
ID_SERVICE INTEGER,
ARISE_DATE DATE,
DATE_POST DATE,
IS_PRIMARY_POST SMALLINT,
POST_TYPE VARCHAR(10),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,4),
POST_NET_VALUE NUMERIC(15,4),
POST_GROSS_VALUE NUMERIC(15,4),
RATE_POST NUMERIC(15,6),
CURR_POST VARCHAR(3),
DATETIME_POST TIMESTAMP,
USER_NAME VARCHAR(30),
POST_REASON VARCHAR(30),
ID_VAT_GROUP INTEGER,
ID_ACCOUNT_POST INTEGER)
 AS
declare variable ID_EW integer;
begin
  select ew.ID_END_WORK
  from   END_WORKS EW
  where  EW.ID_HOTEL = :ID_HOTEL
         and ew.PREV_DATE = :to_date
         and ew.END_WORK_KIND = '3'
         and ew.PREV_DATE is distinct from ew.NEXT_DATE
  into   :id_ew;

  for
    select R.SEQUENCE_ID, R.ID_ACCOUNT, R.ID_GUEST, R.ROOM_NAME, R.ID_SERVICE,
           R.ARISE_DATE, R.DATE_POST, R.IS_PRIMARY_POST, R.POST_TYPE,
           R.QTY_POST, R.PRICE_POST, R.POST_NET_VALUE, R.POST_GROSS_VALUE, R.RATE_POST, R.CURR_POST,
           R.DATETIME_POST, R.USER_NAME, R.POST_REASON, R.ID_SALE_TAXATION, R.ID_ACCOUNT_POST
    from   SERVICE_POSTING_REVENUE$INT(:ID_EW) R
           left outer join ACCOUNT A on A.ID_ACCOUNT = R.ID_ACCOUNT
           left outer join PROFILE_HOUSE PH on PH.ID_PROFILE = A.ID_PROFILE
    where  PH.HOUSE_TYPE is distinct from 'hptComplimentary'
           and ((:IN_ID_ACCOUNT is null) or (R.ID_ACCOUNT = :IN_ID_ACCOUNT))
    into   :POST_ID, :ID_ACCOUNT, :ID_GUEST, :ROOM_NAME, ID_SERVICE,
           :ARISE_DATE, :DATE_POST, :IS_PRIMARY_POST, :POST_TYPE,
           :QTY_POST, :PRICE_POST, :POST_NET_VALUE, :POST_GROSS_VALUE, :RATE_POST, :CURR_POST,
           :DATETIME_POST, :USER_NAME, :POST_REASON, :ID_VAT_GROUP, :id_account_post
  do begin
    if ((:INCL_POSTS = 1 and :IS_PRIMARY_POST = 1)
        or (:INCL_CORR = 1 and :IS_PRIMARY_POST = 0)
       ) then suspend;
  end
end
^

/* Restore proc. body: ACCOUNT_SALE_NUMBER_SET */
ALTER PROCEDURE ACCOUNT_SALE_NUMBER_SET(ID_ACCOUNT TYPE OF ID,
OVERRIDE_EXISTING TYPE OF TLOGICAL = 0)
 RETURNS(ID_SALE_NUM TYPE OF ID)
 AS
declare variable dbkey char(8);
  declare variable unique_sales_number varchar(50);
  declare variable hp_type varchar(50);
  declare variable is_archive integer;
begin
  select a.RDB$DB_KEY, a.ID_SALE_NUM, p.HOUSE_TYPE, a.IS_ARCHIVE
  from   ACCOUNT A
         left outer join PROFILE_HOUSE p on p.ID_PROFILE = a.ID_PROFILE
  where  a.ID_ACCOUNT = :ID_ACCOUNT
  into   :dbkey, :id_sale_num, :hp_type, :is_archive;

  if ((:id_sale_num is null) or (:OVERRIDE_EXISTING is not distinct from 1)) then begin
    if (:is_archive = 1) then
      exception ACCOUNT_EXCEPTION '-712';

    if (coalesce(:hp_type, '') in ('hptExternalRevenue', 'hptComplimentary')) then begin
      unique_sales_number = '_' || :hp_type || :ID_ACCOUNT;
    end else begin
      execute procedure UNIQUE_SALES_NUMBER_GEN
      returning_values (:unique_sales_number);
    end

    insert into SALE_NUM (UNIQUE_SALES_NUMBER)
    values (:unique_sales_number)
    returning id_sale_num into :id_sale_num;
  
    update ACCOUNT A
    set    a.ID_SALE_NUM = :id_sale_num
    where  a.RDB$DB_KEY = :dbkey;
  end
end
^

/* Restore proc. body: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE ACCOUNT_SET_ARCHIVE_STATUS(ID_ACCOUNT INTEGER,
IS_ARCHIVE SMALLINT)
 AS
declare variable post_sum numeric (15,2);
  declare variable dep_sum numeric (15,2);
  declare variable open_charges integer;
  declare variable old_is_archive integer;
  declare variable id_profile integer;
  declare variable id_hotel integer;
  declare variable p_dbkey char(8);
  declare variable acc_dbkey char(8);
  declare variable archived_date date;
  declare variable is_used integer;
  declare variable action_text varchar(255);
  declare variable account_name varchar(50);
  declare variable id_reserv_detail integer;
  declare variable id_sale_num integer;
begin

  select A.RDB$DB_KEY, A.IS_ARCHIVE, A.ID_PROFILE, A.ID_HOTEL, A.ACCOUNT_NAME,
         a.ID_RESERV_DETAIL, a.ID_SALE_NUM
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :acc_dbkey, :old_is_archive, :id_profile, :id_hotel, :account_name,
         :id_reserv_detail, :id_sale_num;
  /* --------------------------------------- */
  if (:old_is_archive = :IS_ARCHIVE) then exit;
  /* --------------------------------------- */
  if (:IS_ARCHIVE = 0) then begin
    -- unarchive
    update ACCOUNT A
    set    A.IS_ARCHIVE = 0
    where  A.RDB$DB_KEY = :acc_dbkey;

    p_dbkey = null;
    select P.RDB$DB_KEY
    from   PROFILE P
    where  P.ID_PROFILE = :id_profile
           and p.IS_ARCHIVE = 1
    into   :p_dbkey;

    if (:p_dbkey is not null) then begin
      /* restore profile active status */
      execute procedure PROFILE_SET_ARCHIVE$INT (:p_dbkey, 0);
    end

    if (:id_reserv_detail is not null and :id_sale_num is null) then begin
      if (exists (select rd.ID_RESERV_DETAIL
                  from   RESERV_DETAIL rd
                  where  rd.ID_RESERV_DETAIL = :id_reserv_detail
                         and rd.CHECK_STATUS = 0)) then
      begin
        execute procedure ACCOUNT_SALE_NUMBER_SET(:ID_ACCOUNT)
        returning_values (:id_sale_num);

        when any do begin end -- nothing
      end
    end
  end else begin
    execute procedure ACCOUNT_USE_CHECK$INT (:ID_ACCOUNT)
    returning_values (:is_used);

    if (:is_used = 1) then begin
      select AB.POST_VALUE, AB.DEP_VALUE, AB.OPEN_CHARGES
      from   ACCOUNT_BALANCE$INT(:id_account) AB
      into   :post_sum, :dep_sum, :open_charges;
  
      if ((:post_sum <> 0) or (:open_charges = 1)) then
        exception ACCOUNT_EXCEPTION '-44' || f_character(31) || :ID_ACCOUNT;

      if (:dep_sum <> 0) then
        exception ACCOUNT_EXCEPTION '-40' || f_character(31) || :ID_ACCOUNT;
    
      execute procedure SYSTEM_DATE_GET (:id_hotel)
      returning_values (:archived_date);
    end else begin
      archived_date = null;  /* mark account as unused */
    end

    update ACCOUNT A
    set    A.IS_ARCHIVE = 1,
           A.ARCHIVED_DATE = :archived_date
    where  A.RDB$DB_KEY = :acc_dbkey;

    action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'ARCHIVE_ACCOUNT', :action_text);
  end
end
^

/* Restore proc. body: ACCOUNT_SET_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_SET_CREDIT_STATUS$INT(ID_ACCOUNT TYPE OF ID,
IS_CREDIT_ACCOUNT TYPE OF TLOGICAL,
CREDIT_LIMIT TYPE OF TPRICE,
SET_UNCONDITIONAL TYPE OF TLOGICAL = 0)
 AS
declare variable account_name varchar(50);
  declare variable old_is_credit_account smallint;
  declare variable action_code varchar(50);
  declare variable action_text varchar(255);
  declare variable id_profile integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable a_dbkey char(8);
  declare variable old_credit_limit tprice;
begin

  select A.IS_CREDIT_ACCOUNT, a.CREDIT_LIMIT, A.ID_ACCOUNT, A.ACCOUNT_NAME,
         A.ID_PROFILE, A.ID_RESERV_DETAIL, a.RDB$DB_KEY
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :old_is_credit_account, :old_credit_limit, :id_account, :account_name,
         :id_profile, :id_reserv_detail, :a_dbkey;
  /* --------------------------------------- */
  if (:IS_CREDIT_ACCOUNT is not distinct from :old_is_credit_account
      and :CREDIT_LIMIT is not distinct from :old_credit_limit) then exit;
  /* --------------------------------------- */
  if (:is_credit_account > :old_is_credit_account and :set_unconditional = 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('ACC_SET_CREDIT');

  end else if (:is_credit_account < :old_is_credit_account and :id_reserv_detail is not null) then begin
    select RD.CHECK_STATUS
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :id_reserv_detail
    into   :check_status;

    if (:check_status = 1) then exception ACCOUNT_EXCEPTION '-1017';
  end

  update ACCOUNT A
  set    A.IS_CREDIT_ACCOUNT = :is_credit_account,
         A.CREDIT_LIMIT = :credit_limit
  where  A.RDB$DB_KEY = :a_dbkey;

  if (:old_is_credit_account <> :is_credit_account) then begin
    action_code = iif(:is_credit_account = 1, 'SET_CREDIT_ACCOUNT', 'RESET_CREDIT_ACCOUNT');
    action_text = f_character(29) || :id_account || '/' || :account_name;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, :action_code, :action_text);
  end
end
^

/* Restore proc. body: ACCOUNT_SET_CURRENCY$INT */
ALTER PROCEDURE ACCOUNT_SET_CURRENCY$INT(A_DBKEY CHAR(8),
NEW_CURR CHAR(3))
 AS
declare variable id_account integer;
  declare variable old_acc_curr char(3);
  declare variable account_name varchar(50);
  declare variable id_profile integer;
  declare variable is_used integer;
  declare variable action_text varchar(255);
begin
  select A.ID_ACCOUNT, A.ACCOUNT_NAME, A.ACCOUNT_CURR, A.ID_PROFILE
  from   ACCOUNT A
  where  A.RDB$DB_KEY = :a_dbkey
  into   :id_account, :account_name, :old_acc_curr, :id_profile;

  if (:old_acc_curr <> :new_curr) then begin
    execute procedure ACCOUNT_USE_CHECK$INT (:id_account)
    returning_values  :is_used;
    if (:is_used = 1) then exception ACCOUNT_EXCEPTION '-41';
    action_text = f_character(29 ) || :id_account || '/' || :account_name
                  || f_character(28) || :old_acc_curr
                  || f_character(28) || :new_curr;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'EDIT_ACCOUNT_CURR', :action_text);

    update ACCOUNT A
    set    A.ACCOUNT_CURR = :new_curr
    where  A.RDB$DB_KEY = :a_dbkey;
  end

end
^

/* Restore proc. body: ACTIVITY_OFFER_CALC_PRICES */
ALTER PROCEDURE ACTIVITY_OFFER_CALC_PRICES(ID_ACTIVITY_OFFER TYPE OF ID,
WITH_DISCOUNT TYPE OF TBOOLEAN = 1)
 RETURNS(OFFER_PRICE TYPE OF TPRICE,
OFFER_CURRENCY TYPE OF TCURRENCY)
 AS
begin
  for
    select cast(
           coalesce((select sum(coalesce(AE.EVENT_PRICE, 0)
                            + coalesce((select sum(AEE.QTY * AEE.EQUIPMENT_PRICE)
                                        from   ACTIVITY_EVENT_EQUIPMENT AEE
                                        where  AEE.ID_ACTIVITY_EVENT = AE.ID_ACTIVITY_EVENT), 0))
                     from   ACTIVITY_EVENT AE
                     where  AE.ID_ACTIVITY_OFFER = AO.ID_ACTIVITY_OFFER), 0)
           +
           coalesce((select sum(AM.QTY * AM.MENU_ITEM_PRICE)
                     from   ACTIVITY_FB AFB
                            join ACTIVITY_FB_MENU AM on AM.ID_ACTIVITY_FB = AFB.ID_ACTIVITY_FB
                     where  AFB.ID_ACTIVITY_OFFER = AO.ID_ACTIVITY_OFFER), 0)
           +
           coalesce((select sum(AA.ADDITION_PRICE)
                     from   ACTIVITY_ADDITION AA
                     where  AA.ID_ACTIVITY_OFFER = AO.ID_ACTIVITY_OFFER), 0)
           +
           coalesce((select sum(AD.DISCOUNT_PRICE)
                     from   ACTIVITY_DISCOUNT AD
                     where  AD.ID_ACTIVITY_OFFER = AO.ID_ACTIVITY_OFFER
                            and :WITH_DISCOUNT = 1), 0)
           +
           coalesce((select sum(Rp.ROOM_PRICE)
                     from   RESERV_DETAIL RD
                            left outer join RES_GET_PRICE$RPT (RD.ID_RESERV_DETAIL, 'SECURITY') rp on 1=1                   
                     where  RD.ID_GROUP = ao.ID_RESERV_GROUP
                            and rd.is_anul = 0
                            and rp.PRICE_CURRENCY = AO.OFFER_CURRENCY), 0)
           as numeric(15,4)) as offer_price,
           cast(AO.OFFER_CURRENCY as varchar(3)) as offer_currency
    from   ACTIVITY_OFFER AO
    where  AO.ID_ACTIVITY_OFFER = :ID_ACTIVITY_OFFER
    union
    select cast(sum(rp.ROOM_PRICE) as numeric(15,4)), cast(rp.PRICE_CURRENCY as varchar(3))
    from   ACTIVITY_OFFER AO2
           join RESERV_DETAIL RD on RD.ID_GROUP = ao2.ID_RESERV_GROUP and rd.is_anul = 0
           left outer join RES_GET_PRICE$RPT (RD.ID_RESERV_DETAIL, 'SECURITY') rp on 1=1           
    where  AO2.ID_ACTIVITY_OFFER = :ID_ACTIVITY_OFFER
           and not (rp.PRICE_CURRENCY = AO2.OFFER_CURRENCY)
    group by rp.PRICE_CURRENCY
    having sum(rp.ROOM_PRICE) > 0
    into  :OFFER_PRICE, :OFFER_CURRENCY
  do begin
    suspend;
  end
end
^

/* Restore proc. body: ACTIVITY_OFFER_COPY */
ALTER PROCEDURE ACTIVITY_OFFER_COPY(ID_ACTIVITY_OFFER TYPE OF ID)
 RETURNS(NEW_ID_ACTIVITY_OFFER TYPE OF ID)
 AS
declare variable activity_date type of TDATE;
declare variable status type of TENUM_SMALL;
declare variable offer_currency type of TCURRENCY;
declare variable recipient type of TPERSON_NAME;
declare variable recipient_comment type of TDESCRIPTION_LONG;
declare variable person_name type of TPERSON_NAME;
declare variable phone_num type of TPHONE;
declare variable fax type of TPHONE;
declare variable e_mail type of TEMAIL;
declare variable accomodation_note type of TNOTE_BLOB;
declare variable events_note type of TNOTE_BLOB;
declare variable fb_note type of TNOTE_BLOB;
declare variable addition_note type of TNOTE_BLOB;
declare variable extra_note type of TNOTE_BLOB;
declare variable offer_header type of TNOTE_BLOB;
declare variable offer_footer type of TNOTE_BLOB;
declare variable discount_note type of TNOTE_BLOB;
declare variable id_reserv_group type of ID_REF;
declare variable id_hotel type of ID;
declare variable id_agent_profile type of ID_REF;
declare variable id_activity_event type of ID;
declare variable id_activity_fb type of ID;
declare variable no_use type of ID_REF;
declare variable ad_additional_date type of TDATE;
declare variable ad_from_time type of TTIME;
declare variable ad_to_time type of TTIME;
declare variable ad_description type of TOBJECT_TEXT;
declare variable ad_speciality type of TDESCRIPTION_LONG;
declare variable ad_addition_price type of TPRICE;
declare variable ad_note type of TDESCRIPTION_LONG;
declare variable act_description type of TDESCRIPTION_SHORT;
declare variable discount_price type of TPRICE;
declare variable user_attached TUSER_NAME;
begin
  select AO.ACTIVITY_DATE, AO.STATUS, AO.OFFER_CURRENCY, AO.RECIPIENT, AO.RECIPIENT_COMMENT, AO.PERSON_NAME,
         AO.PHONE_NUM, AO.FAX, AO.E_MAIL, AO.ACCOMODATION_NOTE, AO.EVENTS_NOTE, AO.FB_NOTE, AO.ADDITION_NOTE,
         AO.EXTRA_NOTE, AO.OFFER_HEADER, AO.OFFER_FOOTER, AO.DISCOUNT_NOTE, AO.ID_RESERV_GROUP,
         AO.ID_HOTEL, AO.ID_AGENT_PROFILE, USER_ATTACHED
  from   ACTIVITY_OFFER AO
  where  AO.ID_ACTIVITY_OFFER = :id_activity_offer
  into   :activity_date, :status, :offer_currency, :recipient, :recipient_comment, :person_name,
         :phone_num, :fax, :e_mail, :accomodation_note, :events_note, :fb_note, :addition_note,
         :extra_note, :offer_header, :offer_footer, :discount_note, :id_reserv_group,
         :id_hotel, :id_agent_profile, :user_attached;

  execute procedure ACTIVITY_OFFER_MODIFY$RESERV(null, :activity_date, :status, :offer_currency, :recipient, :recipient_comment,
          :person_name, :phone_num, :fax, :e_mail, events_note, :fb_note, :addition_note, :accomodation_note, :offer_header, :offer_footer,
          :extra_note, :discount_note, :id_reserv_group, :id_hotel, :id_agent_profile, :user_attached, 'add')
  returning_values :new_id_activity_offer;

  for
    select AE.ID_ACTIVITY_EVENT
    from   ACTIVITY_EVENT AE
    where  AE.ID_ACTIVITY_OFFER = :id_activity_offer
    into   :id_activity_event
  do begin
    execute procedure ACTIVITY_EVENT_COPY(:id_activity_event, :new_id_activity_offer)
    returning_values  :no_use;
  end

  for
    select AF.ID_ACTIVITY_FB
    from   ACTIVITY_FB AF
    where  AF.ID_ACTIVITY_OFFER = :id_activity_offer
    into   :id_activity_fb
  do begin
    execute procedure ACTIVITY_FB_COPY(:id_activity_fb, :new_id_activity_offer)
    returning_values  :no_use;
  end

  for
    select AD.ADDITION_DATE, AD.FROM_TIME, AD.TO_TIME, AD.DESCRIPTION, AD.SPECIALITY, AD.ADDITION_PRICE,
           AD.NOTE
    from   ACTIVITY_ADDITION AD
    where  AD.ID_ACTIVITY_OFFER = :id_activity_offer
    into   :ad_additional_date, :ad_from_time, :ad_to_time, :ad_description, :ad_speciality, :ad_addition_price,
           :ad_note
  do begin
    execute procedure ACTIVITY_ADDITION_MODIFY$RESERV(null, :new_id_activity_offer, :ad_additional_date, :ad_from_time,
            :ad_to_time, :ad_description, :ad_speciality, :ad_addition_price, :ad_note, 'add')
    returning_values :no_use;
  end

  for
    select ACT.DESCRIPTION, ACT.DISCOUNT_PRICE
    from   ACTIVITY_DISCOUNT ACT
    where  ACT.ID_ACTIVITY_OFFER = :id_activity_offer
    into   :act_description, :discount_price
  do begin
    execute procedure ACTIVITY_DISCOUNT_MODIFY$RESERV(null, :new_id_activity_offer, :act_description, :discount_price, 'add')
    returning_values  :no_use;
  end

  execute procedure SYSTEM_LOG_ADD ('ACTIVITY_OFFER', :id_activity_offer, 'ACTIVITY_OFFER_COPY', f_character(29) || :new_id_activity_offer);
end
^

/* Restore proc. body: ALLOTMENT_AGENT_GET */
ALTER PROCEDURE ALLOTMENT_AGENT_GET(FROM_DATE DATE,
TO_DATE DATE,
IN_ID_ROOM_TYPE INTEGER,
IN_ID_AGENT INTEGER,
INFO_TYPE VARCHAR(40),
MIND_RELEASE_DATES SMALLINT)
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ROOM_TYPE VARCHAR(50),
CNT_ROOMS INTEGER,
IS_DEFINED INTEGER,
IS_RELEASED INTEGER)
 AS
declare variable id_allotment integer;
  declare variable allotment_options varchar(255);
  declare variable cnt_booked integer;
  declare variable cnt_defined integer;
begin
  /*  Description:
  || INFO_TYPE = 'CONTINGENT_DEFINE', 'CONTINGENT_BOOKED', 'BOOKING_DEFINE', 'BOOKING_BOOKED',
  ||              +EDIT, NONBOOKED
  */
  allotment_options = '';
  id_allotment = null;
  select iif(:info_type starting with 'CONTINGENT', PA.ID_CONTINGENT, PA.ID_BOOKING_POSITION)
  from   PROFILE_AGENT PA
  where  PA.ID_AGENT = :in_id_agent
  into   :id_allotment;

  if (:mind_release_dates = 1) then allotment_options = :allotment_options||',RELEASES';
  if (:info_type like '%BOOKED%') then allotment_options = :allotment_options||',BOOKED';
  if (:info_type like '%EDIT') then allotment_options = :allotment_options||',CONTINGENT_PERIOD,EDIT';
  else if (:info_type like '%RPT') then allotment_options = :allotment_options||',PLAIN_PERIOD';

  for
    select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ROOM_TYPE,
           sum(ACG.CNT_DEFINED), sum(ACG.CNT_BOOKED), sum(ACG.IS_DEFINED), min(ACG.IS_RELEASED)
    from   ALLOTMENT_GET$INT(:id_allotment, :from_date, :to_date, :in_id_room_type, :allotment_options) ACG
    group by 1, 2, 3
    into   :for_date, :id_room_type, :room_type,
           :cnt_defined, :cnt_booked, :is_defined, :is_released
  do begin
    if (:info_type like '%BOOKED%') then begin
      if (:info_type like '%NONBOOKED%') then cnt_rooms = (:cnt_defined - :cnt_booked);
      else cnt_rooms = :cnt_booked;
    end else cnt_rooms = :cnt_defined;                  
    suspend;
  end
end
^

/* Restore proc. body: ALLOTMENT_GET */
ALTER PROCEDURE ALLOTMENT_GET(ID_ALLOTMENT INTEGER,
ID_HOTEL INTEGER)
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ROOM_TYPE VARCHAR(30),
CNT_DEFINED INTEGER,
CNT_BOOKED INTEGER,
ACTIVE_FRAME_BEGIN INTEGER,
IS_DEFINED INTEGER,
IS_RELEASED INTEGER)
 AS
begin
  for
    select a.FOR_DATE, a.ID_ROOM_TYPE, a.ROOM_TYPE, a.CNT_DEFINED, a.CNT_BOOKED,
           a.ACTIVE_FRAME_BEGIN, a.IS_DEFINED, a.IS_RELEASED
    from   ALLOTMENT_GET$INT(:ID_ALLOTMENT, '01.01.2001', '31.12.2099', null, '', :id_hotel) a
    into   :FOR_DATE, :ID_ROOM_TYPE, :ROOM_TYPE, :CNT_DEFINED, :CNT_BOOKED,
           :ACTIVE_FRAME_BEGIN, :IS_DEFINED, :IS_RELEASED
  do suspend;
end
^

/* Restore proc. body: APPLY_BOOKING_STATUS$EXC */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20)
 AS
declare variable err_text varchar(255);
declare variable dummy_int integer;
declare variable anul_reason varchar(30);
declare variable selection_id integer;

declare variable status_code smallint;
declare variable current_anul_code smallint;
declare variable current_status_code smallint;
declare variable current_status_text varchar(50);
declare variable new_status_text varchar(50);
declare variable extra_posts_left integer;
declare variable check_out_kind smallint;
declare variable earlycheckout_date date;
begin
  if (:booking_db_key is null) then begin
    select rd.RDB$DB_KEY, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.ID_RESERV_DETAIL = :BOOKING_ID
    into   :booking_db_key, :current_status_code, :current_anul_code;
  end else begin
    select rd.id_reserv_detail, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.rdb$db_key = :booking_db_key
    into   :booking_id, :current_status_code, :current_anul_code;
  end

  execute procedure IMPORT_BOOKING_STATUS$EXC(:status, -2)
  returning_values :status_code;

  execute procedure EXPORT_BOOKING_STATUS$EXC(:current_status_code, :current_anul_code)
  returning_values :current_status_text;
  execute procedure IMPORT_BOOKING_STATUS$EXC(:current_status_text, :current_status_code)
  returning_values :current_status_code;

  /* nop - exit */
  if (:current_status_code = :status_code) then exit;

  /* validate status transition */
  if (
     /* terminal status values - void booking */
    (:current_status_code in (1004/*no show*/, 1005/*canceled*/))

    /* void over checkin */
    or ((:current_status_code >= 0) and (:status_code in (1004/*no show*/, 1005/*canceled*/)))

    /* positive status downgrade */
    or ((:current_status_code > 0) and (:current_status_code > :status_code))
  )  then begin
    execute procedure PRINT_BOOKING_STATUS$EXC(:current_status_code) returning_values :current_status_text;
    execute procedure PRINT_BOOKING_STATUS$EXC(:status_code) returning_values :new_status_text;

    exception VALIDATE_EXCEPTION '-1022' || f_character(31) || '@{invalid_status_transition} ' || :current_status_text || ' -> ' || :new_status_text;
  end

  anul_reason = null;
  if (1004 = :status_code) then begin
    anul_reason = 'NOSHOW';
  end else if (1005 = :status_code) then begin
    anul_reason = 'CANCELED';
  end

  if (:anul_reason is null) then begin
    if (0 > :status_code) then begin
      execute procedure RES_SAVE_STATUS$INT(:booking_db_key, :status_code, :CONFIRMATION_NUMBER);
    end else begin
      if (:status_code in (0, 1) and 0 > :current_status_code) then begin
        -- checkin
        execute procedure RES_SET_CHECKIN$INT (:booking_db_key)
        returning_values (:dummy_int, :err_text, :dummy_int, :dummy_int);
      end
      if (1 = :status_code and 1 > :current_status_code) then begin
        -- checkout
        selection_id = gen_id(SELECTION_GEN, 1);
        update RESERV_DETAIL
        set    selection_id=:selection_id
        where  rdb$db_key=:booking_db_key
        returning new.CHECK_OUT_KIND, new.EARLYCHECKOUT_DATE
        into   :check_out_kind, :earlycheckout_date;
    
        execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, :check_out_kind, :earlycheckout_date);
      end
    end
  end else begin
    -- void
    execute procedure RES_ANUL_DETAIL$INT(:booking_db_key, :anul_reason, :CANCELATION_NUMBER)
    returning_values  :dummy_int, :extra_posts_left;
    if (:extra_posts_left = 1) then exception BOOKING_EXCEPTION '-1042';

  end
end
^

/* Restore proc. body: AR_OWING_ADD$INT */
ALTER PROCEDURE AR_OWING_ADD$INT(ID_PROFILE TYPE OF ID,
SUM_OWING TYPE OF TPRICE,
CURR_OWING TYPE OF TCURRENCY,
ID_DOC_HEAD TYPE OF ID_REF,
DUE_DATE TYPE OF TDATE,
SYSTEM_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
ID_AR_TYPE TYPE OF ID,
ID_HOTEL TYPE OF ID)
 RETURNS(NEW_ID_AR_OWING TYPE OF ID)
 AS
declare variable round_to numeric(15,4);
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
begin

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :CURR_OWING
  into   :round_to;

  select P.PROFILE_NAME
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :profile_name;

  new_id_ar_owing = gen_id(GEN_AR_OWING_ID, 1);
  sum_owing = ROUND_F(:sum_owing, :round_to);

  insert into AR_OWING (ID_AR_OWING, ID_PROFILE, SUM_OWING, CURR_OWING,
         USER_CREATED, DATETIME_CREATED, ID_DOC, SYSTEM_DATE,
         ID_AR_OWING_BASE, DESCRIPTION, DUE_DATE, ID_AR_TYPE, ID_HOTEL,
         REST_OWING, OWING_STATUS)
  values (:new_id_ar_owing, :ID_PROFILE, :SUM_OWING, :CURR_OWING,
         user, current_timestamp, :ID_DOC_HEAD, :system_date,
         null, :description, STRIPTIME(:due_date), :ID_AR_TYPE, :ID_HOTEL,
         :SUM_OWING, 11);

  action_text = substring(f_character(29) || :profile_name
                          || f_character(28) || formatfloat(:SUM_OWING, 'F;0.00') || ' ' || :CURR_OWING
                          || f_character(28) || :description from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'OWING_CREATE', :action_text);

end
^

/* Restore proc. body: AR_OWING_ANUL$INT */
ALTER PROCEDURE AR_OWING_ANUL$INT(ID_AR_OWING TYPE OF ID,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_MANUAL_ANUL TYPE OF TLOGICAL = 1)
 RETURNS(NEW_ID_AR_OWING TYPE OF ID)
 AS
declare variable system_date type of TDATE;
  declare variable curr_id integer;
  declare variable owing_status smallint;
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable id_doc_head integer;
  declare variable sum_owing numeric(15,4) ;
  declare variable curr_owing char(3);
  declare variable id_profile integer;
begin

    select O.OWING_STATUS, O.ID_DOC, SDG.SYSTEM_DATE, o.SUM_OWING, o.CURR_OWING, o.ID_PROFILE
    from   AR_OWING O
           left outer join SYSTEM_DATE_GET(O.ID_HOTEL) SDG on 1=1
    where  O.ID_AR_OWING = :ID_AR_OWING
    into   :owing_status, :id_doc_head, :system_date, :sum_owing, :curr_owing, :id_profile;

    if (:OWING_STATUS = 22) then
      exception ACCOUNT_RECEIVABLE_EXCEPTION '-606' ;
    if (:IS_MANUAL_ANUL = 1 and :id_doc_head is not null) then
      exception ACCOUNT_RECEIVABLE_EXCEPTION '-609' ;

    update AR_OWING A  -- lock for update
    set    A.ID_AR_OWING = A.ID_AR_OWING,
           A.OWING_STATUS = 22,
           A.REST_OWING = :sum_owing
    where  A.ID_AR_OWING = :ID_AR_OWING;

    new_id_ar_owing = gen_id(GEN_AR_OWING_ID, 1);

    insert into AR_OWING (ID_AR_OWING, ID_PROFILE, SUM_OWING, CURR_OWING,
           USER_CREATED, DATETIME_CREATED, ID_DOC, SYSTEM_DATE,
           ID_AR_OWING_BASE, DESCRIPTION, DUE_DATE, ID_AR_TYPE, ID_HOTEL,
           REST_OWING, OWING_STATUS)
    select :new_id_ar_owing, A.ID_PROFILE, -A.SUM_OWING, A.CURR_OWING,
           user, current_timestamp, A.ID_DOC, :system_date,
           :ID_AR_OWING, :description, A.DUE_DATE, A.ID_AR_TYPE, a.ID_HOTEL,
           -A.SUM_OWING, 22
    from   AR_OWING A
    where  A.ID_AR_OWING = :ID_AR_OWING;

    for
      select A.ID_AR_OWING_PAYMENT_POST
      from   AR_OWING_PAYMENT_POST A
      where  A.ID_AR_OWING = :ID_AR_OWING
             and A.IS_ANUL = 0
      into   :curr_id
    do begin
      execute procedure AR_OWING_PAYMENT_ANUL$AR(:curr_id, :DESCRIPTION);
    end
    -- transaction finalize
    execute procedure AR_POST_FINALIZE(iif(:IS_MANUAL_ANUL = 1, 'anul_owing', 'anul_link'));

    select P.PROFILE_NAME
    from   PROFILE P
    where  P.ID_PROFILE = :id_profile
    into   :profile_name;

    action_text = substring(f_character(29) || :profile_name
                            || f_character(28) || formatfloat(:sum_owing, 'F;0.00') || ' ' || :CURR_OWING
                            || f_character(28) || :description from 1 for 255);
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :id_profile, 'OWING_ANNUL', :action_text);

end
^

/* Restore proc. body: AR_OWING_PAYMENT_ADD$AR */
ALTER PROCEDURE AR_OWING_PAYMENT_ADD$AR(ID_AR_OWING INTEGER,
ID_AR_PAYMENT INTEGER,
SUM_OWING NUMERIC(15,4),
SUM_PAYMENT NUMERIC(15,4),
PAYMENT_RATE_TO_BGN NUMERIC(15,6),
OWING_RATE_TO_BGN NUMERIC(15,6),
DESCRIPTION VARCHAR(255))
 RETURNS(NEW_ID_AR_OWING_PAYMENT_POST INTEGER)
 AS
declare variable curr_payment varchar(3);
  declare variable curr_owing varchar(3);
  declare variable owing_status smallint;
  declare variable payment_status smallint;
  declare variable system_date date;
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable payment_type varchar(20);
  declare variable id_profile integer;
  declare variable id_hotel integer;
  declare variable payment_round_to numeric(15,4);
  declare variable owing_round_to numeric(15,4);
begin
  select A.CURR_PAYMENT, A.PAYMENT_STATUS, pt.PAYMENT_TYPE, c.ROUND_TO
  from   AR_PAYMENT A
         join AR_PAYMENT_TYPE PT on PT.ID_AR_PAYMENT_TYPE = a.ID_AR_PAYMENT_TYPE
         join CURRS c on c.CURR = a.CURR_PAYMENT
  where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT
  into   :curr_payment, :PAYMENT_STATUS, :payment_type, :payment_round_to;

  select A.CURR_OWING, A.OWING_STATUS, P.PROFILE_NAME, p.ID_PROFILE, a.ID_HOTEL, c.ROUND_TO
  from   AR_OWING A
         join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
         join CURRS c on c.CURR = a.CURR_OWING
  where  A.ID_AR_OWING = :id_ar_owing
  into   :curr_owing, :owing_status, :profile_name, :id_profile, :id_hotel, :owing_round_to;

  if ( (:OWING_STATUS = 22) or (:PAYMENT_STATUS = 22) ) then
    exception ACCOUNT_RECEIVABLE_EXCEPTION '-604';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  (:system_date);

  /* lock records for update */
  select P.ID_AR_PAYMENT
  from   AR_PAYMENT P
  where  P.ID_AR_PAYMENT = :ID_AR_PAYMENT
  with lock  -- lock for update
  into   :ID_AR_PAYMENT;

  select O.ID_AR_OWING
  from   AR_OWING O
  where  O.ID_AR_OWING = :ID_AR_OWING
  with lock  -- lock for update
  into   :ID_AR_OWING;

  if (:SUM_OWING = 0.00) then exception ACCOUNT_RECEIVABLE_EXCEPTION '-602';

  SUM_OWING = round_f(:SUM_OWING, :owing_round_to);
  SUM_PAYMENT = round_f(:SUM_PAYMENT, :payment_round_to);

  insert into AR_OWING_PAYMENT_POST(ID_AR_OWING, ID_AR_PAYMENT, ID_PROFILE,
         SUM_OWING, CURR_OWING, SUM_PAYMENT, CURR_PAYMENT, IS_ANUL,
         PAYMENT_RATE_TO_BGN, OWING_RATE_TO_BGN, ID_TRANSACTION, SYSTEM_DATE,
         ID_AR_OWING_PAYMENT_BASE, DESCRIPTION, USER_CREATED, DATETIME_CREATED)
  values (:ID_AR_OWING, :ID_AR_PAYMENT, :id_profile,
         :SUM_OWING, :curr_owing, :SUM_PAYMENT, :curr_payment, 0,
         :payment_rate_to_bgn, :owing_rate_to_bgn, current_transaction, :system_date,
         null, :DESCRIPTION, user, current_timestamp)
  returning ID_AR_OWING_PAYMENT_POST
  into   :new_id_ar_owing_payment_post;

  action_text = substring(f_character(29) || :profile_name
                          || f_character(28) || formatfloat(:SUM_OWING, 'F;0.00') || ' ' || :CURR_OWING
                          || f_character(28) || :payment_type
                          || f_character(28) || formatfloat(:SUM_PAYMENT, 'F;0.00') || ' ' || :CURR_PAYMENT
                          || f_character(28) || :description
                          from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'OWING_PAY', :action_text);

end
^

/* Restore proc. body: AR_OWING_PAYMENT_ANUL$AR */
ALTER PROCEDURE AR_OWING_PAYMENT_ANUL$AR(ID_AR_OWING_PAYMENT_POST INTEGER,
DESCRIPTION VARCHAR(255))
 AS
declare variable curr_payment varchar(3);
  declare variable curr_owing varchar(3);
  declare variable is_anul smallint;
  declare variable system_date date;
  declare variable type_code varchar(10);
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable payment_type varchar(20);
  declare variable id_profile integer;
  declare variable id_hotel integer;
  declare variable sum_owing numeric(15,4);
  declare variable sum_payment numeric(15,4);
  declare variable id_ar_owing integer;
  declare variable id_ar_payment integer;
  declare variable payment_rate_to_bgn numeric(15,6);
  declare variable owing_rate_to_bgn numeric(15,6);
begin
  if (:ID_AR_OWING_PAYMENT_POST is null) then
    exception ACCOUNT_RECEIVABLE_EXCEPTION '-85' || f_character(31) || 'ID_AR_OWING_PAYMENT_POST is null';

  /* lock record for update */
  select p.ID_AR_OWING, p.ID_AR_PAYMENT, p.IS_ANUL
  from   AR_OWING_PAYMENT_POST P
  where  P.ID_AR_OWING_PAYMENT_POST = :id_ar_owing_payment_post
  with lock  -- lock for update
  into   :id_ar_owing, :id_ar_payment, :is_anul;

  if (:is_anul = 1) then exception ACCOUNT_RECEIVABLE_EXCEPTION '-605';

  select A.CURR_PAYMENT, pt.PAYMENT_TYPE
  from   AR_PAYMENT A
         join AR_PAYMENT_TYPE PT on PT.ID_AR_PAYMENT_TYPE = a.ID_AR_PAYMENT_TYPE
  where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT
  into   :curr_payment, :payment_type;

  select A.CURR_OWING, P.PROFILE_NAME, p.ID_PROFILE, t.TYPE_CODE, A.ID_HOTEL
  from   AR_OWING A
         join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
         join AR_TYPE T on a.ID_AR_TYPE = T.ID_AR_TYPE
  where  A.ID_AR_OWING = :id_ar_owing
  into   :curr_owing, :profile_name, :id_profile, :type_code, :id_hotel;

  if (:type_code = 'DEPOSIT') then
    exception ACCOUNT_RECEIVABLE_EXCEPTION 'Operation (type_code=DEPOSIT) is not supported!';

  /* lock records for update */
  select P.ID_AR_PAYMENT
  from   AR_PAYMENT P
  where  P.ID_AR_PAYMENT = :ID_AR_PAYMENT
  with lock  -- lock for update
  into   :ID_AR_PAYMENT;

  select O.ID_AR_OWING
  from   AR_OWING O
  where  O.ID_AR_OWING = :ID_AR_OWING
  with lock  -- lock for update
  into   :ID_AR_OWING;

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  (:system_date);

  update AR_OWING_PAYMENT_POST A
  set    A.IS_ANUL = 1
  where  A.ID_AR_OWING_PAYMENT_POST = :ID_AR_OWING_PAYMENT_POST;

  select -P.SUM_OWING, -P.SUM_PAYMENT, P.ID_AR_OWING, P.ID_AR_PAYMENT, p.ID_PROFILE,
         P.PAYMENT_RATE_TO_BGN, P.OWING_RATE_TO_BGN, P.CURR_OWING, P.CURR_PAYMENT
  from   AR_OWING_PAYMENT_POST P
  where  P.ID_AR_OWING_PAYMENT_POST = :ID_AR_OWING_PAYMENT_POST
  into   :SUM_OWING, :SUM_PAYMENT, :ID_AR_OWING, :ID_AR_PAYMENT, :id_profile,
         :PAYMENT_RATE_TO_BGN, :OWING_RATE_TO_BGN, :CURR_OWING, :CURR_PAYMENT;

  insert into AR_OWING_PAYMENT_POST(ID_AR_OWING, ID_AR_PAYMENT, ID_PROFILE,
         SUM_OWING, CURR_OWING, SUM_PAYMENT, CURR_PAYMENT, IS_ANUL,
         PAYMENT_RATE_TO_BGN, OWING_RATE_TO_BGN, ID_TRANSACTION, SYSTEM_DATE,
         ID_AR_OWING_PAYMENT_BASE, DESCRIPTION, USER_CREATED, DATETIME_CREATED)
  values (:id_ar_owing, :id_ar_payment, :id_profile,
         :sum_owing, :curr_owing, :sum_payment, :curr_payment, 1,
         :payment_rate_to_bgn, :owing_rate_to_bgn, current_transaction, :system_date,
         :id_ar_owing_payment_post, :DESCRIPTION, user, current_timestamp);

  action_text = substring(f_character(29) || :profile_name
                          || f_character(28) || formatfloat(:sum_owing, 'F;0.00') || ' ' || :curr_owing
                          || f_character(28) || :payment_type
                          || f_character(28) || formatfloat(:sum_payment, 'F;0.00') || ' ' || :curr_payment
                          || f_character(28) || :DESCRIPTION
                          from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'OWING_PAY_ANNUL', :action_text);

end
^

/* Restore proc. body: AR_PAYMENT_ADD$AR */
ALTER PROCEDURE AR_PAYMENT_ADD$AR(ID_PROFILE TYPE OF ID,
ID_AR_PAYMENT_TYPE TYPE OF ID_REF,
ACCOUNT_NAME TYPE OF TNAME_SHORT,
SUM_PAYMENT TYPE OF TPRICE,
CURR_PAYMENT TYPE OF TCURRENCY,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
DATE_PAYMENT TYPE OF TDATE)
 RETURNS(NEW_ID_AR_PAYMENT INTEGER)
 AS
declare variable payment_status smallint;
  declare variable round_to numeric(15,6);
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable payment_type varchar(20);
begin
  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :CURR_PAYMENT
  into   :round_to;

  select p.PROFILE_NAME
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :profile_name;

  select P.PAYMENT_TYPE
  from   AR_PAYMENT_TYPE P
  where  P.ID_AR_PAYMENT_TYPE = :ID_AR_PAYMENT_TYPE
  into   :payment_type;

  payment_status = 11;
  SUM_PAYMENT = round_f(:SUM_PAYMENT, :round_to);

  new_id_ar_payment = gen_id(GEN_AR_PAYMENT_ID, 1);
  insert into AR_PAYMENT(ID_AR_PAYMENT, ID_PROFILE, SUM_PAYMENT, CURR_PAYMENT,
         USER_CREATED, DATETIME_CREATED, DESCRIPTION,
         ID_AR_PAYMENT_BASE, ID_AR_PAYMENT_TYPE, ACCOUNT_NAME,
         DATE_PAYMENT, REST_PAYMENT, PAYMENT_STATUS)
  values (:new_id_ar_payment, :ID_PROFILE, :SUM_PAYMENT, :CURR_PAYMENT,
         user, current_timestamp, :DESCRIPTION,
         null, :ID_AR_PAYMENT_TYPE, :ACCOUNT_NAME,
         :DATE_PAYMENT, :SUM_PAYMENT, :PAYMENT_STATUS);

  action_text = substring(f_character(29) || :payment_type
                          || f_character(28) || :profile_name
                          || f_character(28) || formatfloat(:SUM_PAYMENT, 'F;0.00') || ' ' || :CURR_PAYMENT from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'PAYMENT_CREATE', :action_text);

end
^

/* Restore proc. body: AR_PAYMENT_ANUL$AR */
ALTER PROCEDURE AR_PAYMENT_ANUL$AR(ID_AR_PAYMENT INTEGER,
DESCRIPTION VARCHAR(255))
 RETURNS(NEW_ID_AR_PAYMENT INTEGER)
 AS
declare variable curr_id integer;
  declare variable payment_status smallint;
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable payment_type varchar(20);
  declare variable curr_payment char(3);
  declare variable id_profile integer;
  declare variable id_payment_type integer;
  declare variable sum_payment numeric(15,4);
begin
  if (:ID_AR_PAYMENT is null) then exit;

  select p.CURR_PAYMENT, p.ID_PROFILE, p.ID_AR_PAYMENT_TYPE, p.SUM_PAYMENT, p.PAYMENT_STATUS
  from   AR_PAYMENT P
  where  P.ID_AR_PAYMENT = :ID_AR_PAYMENT
  into   :CURR_PAYMENT, :id_profile, :id_payment_type, :sum_payment, :payment_status;

  if (:payment_status = 22) then exception ACCOUNT_RECEIVABLE_EXCEPTION '-606';

  payment_status = 22;

  update AR_PAYMENT A
  set    A.PAYMENT_STATUS = :payment_status
  where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT;

  new_id_ar_payment = gen_id(GEN_AR_PAYMENT_ID, 1);

  insert into AR_PAYMENT(ID_AR_PAYMENT, ID_PROFILE, SUM_PAYMENT, CURR_PAYMENT,
         USER_CREATED, DATETIME_CREATED, DESCRIPTION,
         ID_AR_PAYMENT_BASE, ID_AR_PAYMENT_TYPE, ACCOUNT_NAME,
         DATE_PAYMENT, REST_PAYMENT, PAYMENT_STATUS)
  select :new_id_ar_payment, A.ID_PROFILE, -A.SUM_PAYMENT, A.CURR_PAYMENT,
         user, current_timestamp, :DESCRIPTION,
         :ID_AR_PAYMENT, A.ID_AR_PAYMENT_TYPE, A.ACCOUNT_NAME,
         A.DATE_PAYMENT, -A.SUM_PAYMENT, :payment_status
  from   AR_PAYMENT A
  where  A.ID_AR_PAYMENT = :id_ar_payment;

  -- storno links
  for
    select A.ID_AR_OWING_PAYMENT_POST
    from   AR_OWING_PAYMENT_POST A
    where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT
           and A.IS_ANUL = 0
    into   :curr_id
  do begin
    execute procedure AR_OWING_PAYMENT_ANUL$AR(:curr_id, :DESCRIPTION);
  end
  -- transaction finalize
  execute procedure AR_POST_FINALIZE('anul_pay');

  select p.PROFILE_NAME
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :profile_name;

  select P.PAYMENT_TYPE
  from   AR_PAYMENT_TYPE P
  where  P.ID_AR_PAYMENT_TYPE = :id_payment_type
  into   :payment_type;

  action_text = substring(f_character(29) || :payment_type
                          || f_character(28) || :profile_name
                          || f_character(28) || formatfloat(:SUM_PAYMENT, 'F;0.00') || ' ' || :CURR_PAYMENT from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'PAYMENT_ANNUL', :action_text);
end
^

/* Restore proc. body: AVAILABILITY_OCCUPANCY$AVL */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
begin

  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, :FETCH_TOTALS, 1, 1, 1, 1, 1, 1, :HOTELS);

  ID_OCCUPANCY_SESSION = current_transaction;
end
^

/* Restore proc. body: AVAILABILITY_RATING$AVL */
ALTER PROCEDURE AVAILABILITY_RATING$AVL(ID_AGENT_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ROOMS_COUNT INTEGER,
ADULTS_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ROOMTYPE_LIST VARCHAR(2000),
RATE_LIST VARCHAR(2000),
BOARD_LIST VARCHAR(2000),
HOTELS VARCHAR(255) = '')
 RETURNS(ID_SESSION INTEGER)
 AS
declare variable id_room_type integer;
  declare variable total_rooms integer;
  declare variable allotment_rooms integer;
  declare variable id_agent integer;
  declare variable min_occ_date date;
  declare variable max_occ_date date;
begin
  /*
   this proc calculate prices and check availabiliti
   data is leaved in table TMP_AVAILABILITY
  */
  roomtype_list = ','||:roomtype_list||',';
  rate_list = ','||:rate_list||',';
  board_list = ','||:board_list||',';

  id_agent = null;
  select PA.ID_AGENT
  from   PROFILE_AGENT PA
  where  PA.ID_PROFILE = :id_agent_profile
  into   :id_agent;

  select min(SOT.FOR_DATE), max(SOT.FOR_DATE)
  from   SMART_OCCUP$TMP SOT
  where  ((:hotels = '') or (','||:hotels||',' containing ','||SOT.ID_HOTEL||','))
  into   :min_occ_date, :max_occ_date;
  if ((:min_occ_date > :arrival_date)
     or (:max_occ_date < :departure_date))
  then begin
    exception WRONG_VALUE 'Wrong input period for calculation! ';
  end

  /*New refactored procedure*/
  ID_SESSION = gen_id(SELECTION_GEN, 1);
  execute procedure AVAILABILITY_RATING_LOOP$INT (:ID_SESSION, :arrival_date, :departure_date,
          :rooms_count, :adults_count, :children_count, :roomtype_list, :rate_list, :board_list, :hotels);

  /*Update Available to output table*/
  for
    select RT.ID_ROOM_TYPE
    from   ROOM_TYPES RT
    where  :roomtype_list containing ','|| RT.ID_ROOM_TYPE ||','
            and ((:hotels = '') or (','||:hotels||',' containing ','||RT.ID_HOTEL||','))
    into   :id_room_type
  do begin
    total_rooms = null;
    execute procedure AVAILABILITY_GET_AVAIL$INT(:id_room_type, :arrival_date, :departure_date, :id_agent)
    returning_values  :total_rooms, :allotment_rooms;

    total_rooms = coalesce(:total_rooms, 0);

    update TMP_AVAILABILITY
    set    TOTAL_ROOMS =  :total_rooms,
           ALLOTMENT_ROOMS =  :allotment_rooms
    where  ID_SESSION  = :ID_SESSION
           and ID_ROOM_TYPE = :id_room_type;
  end

  /**/
  execute procedure AVAILABILITY_RATING_FILL$INT(:ID_SESSION, :roomtype_list, :rate_list,
          :arrival_date, :departure_date, :id_agent);
  --
end
^

/* Restore proc. body: BLOCK_ANNUL$BLK */
ALTER PROCEDURE BLOCK_ANNUL$BLK(ID_BLOCK_ROOM INTEGER,
OPERATION VARCHAR(30))
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable share_err_text varchar(255);
  declare variable system_date date;
  declare variable cancel_date date;
  declare variable from_date date;
  declare variable b_dbkey char(8);
  declare variable new_id_block_room integer;
  declare variable id_room integer;
  declare variable block_grp integer;
  declare variable reason varchar(50);
  declare variable note varchar(255);
  declare variable action_text varchar(255);
  declare variable room_name varchar(10);
  declare variable id_hotel integer;
  declare variable mark_dirty_expired_block integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION (:operation, 'cancel, annul');

  select BR.FROM_DATE, BR.RDB$DB_KEY, R.ID_HOTEL
  from   BLOCK_ROOM BR
         join ROOMS R on R.ID_ROOM = BR.ID_ROOM
  where  BR.ID_BLOCK_ROOM = :id_block_room
  into   :from_date, :b_dbkey, :id_hotel;

  if (:operation = 'annul') then begin
    update BLOCK_ROOM BR
    set    BR.IS_ANNUL = 1
    where  BR.RDB$DB_KEY = :b_dbkey;
  
    execute procedure BLOCK_MODIFY_CONTROL$INT(:b_dbkey, :from_date);
    execute procedure ROOM_MAGIC_CLEAR(:id_block_room);
    action_text = '';
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :id_block_room, 'ANNUL_BLOCK', :action_text);
  end else begin
    select BR.ID_ROOM, BR.BLOCK_GRP, BR.REASON, BR.NOTE, R.ROOM_NAME
    from   BLOCK_ROOM BR
           join ROOMS R on R.ID_ROOM = BR.ID_ROOM
    where  BR.RDB$DB_KEY = :b_dbkey
    into   :id_room, :block_grp, :reason, :note, :room_name;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :system_date;
    cancel_date = :system_date - 1;

    execute procedure BLOCK_MODIFY$INT(:id_block_room, :id_room, :from_date, :cancel_date, :block_grp, :reason,
                      :note, 'mod')
    returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :share_err_text, :warn_code;
    --ignore possible entering into share

    execute procedure SETTING_GET_VALUE('MARK_DIRTY_EXPIRED_BLOCK', :id_hotel)
    returning_values  :mark_dirty_expired_block;
    if (:mark_dirty_expired_block = '1') then begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'BLOCK_STOP', 'set_dirty');
    end

    action_text = f_character(29) || :room_name || f_character(28) || formatdate(:cancel_date, 'D;dd.mm.yyyy');
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :new_id_block_room, 'CANCEL_BLOCK', :action_text);
  end
end
^

/* Restore proc. body: BLOCK_CREATE$BLK */
ALTER PROCEDURE BLOCK_CREATE$BLK(ROOM_NAMES TYPE OF TDESCRIPTION_LONG,
ID_HOTEL TYPE OF ID,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
BLOCK_GRP TYPE OF TRANGE,
REASON TYPE OF TREASON,
NOTE TYPE OF TDESCRIPTION_LONG,
IS_FULL_FROM TYPE OF TRANGE,
IS_FULL_TO TYPE OF TRANGE)
 RETURNS(NEW_ID_BLOCK_ROOM TYPE OF ID,
SHARE_TRANSACTION_ID TYPE OF ID,
SHARE_ERR_CODE TYPE OF ID,
ERR_TEXT VARCHAR(255),
WARN_CODE TYPE OF ID,
NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable room_name varchar(50);
  declare variable id_room integer;
  declare variable action_text varchar(255);
  declare variable block_name varchar(30);
begin
  id_room = null;
  warn_code = null;
  SHARE_ERR_CODE = 0;

  for
    select ITEM
    from   SYSTEM_STRING_PARSER(:room_names, ',')
    into   :room_name
  do begin
    id_room = null;
    select R.ID_ROOM
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ROOM_NAME = :room_name
           and RT.ID_HOTEL = :id_hotel
    into   :id_room;

    if (:id_room is null) then exception BLOCK_EXCEPTION '-5' || f_character(31) || :room_name;

    execute procedure BLOCK_MODIFY$INT(null, :id_room, :from_date, :to_date, :block_grp,
                      :reason, :note, 'add')
    returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :err_text, :warn_code;

    block_name = iif(:block_grp = 18, 'OUT OF ORDER', 'OUT OF INVENTORY');
    action_text = f_character(29) || :room_name
                  || f_character(28) || formatdate(:from_date, 'D;dd.mm.yyyy') || '-' || formatdate(:to_date, 'D;dd.mm.yyyy')
                  || f_character(28) || :block_name;
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :new_id_block_room, 'BLOCK_ROOM', :action_text);

  end

  select cast('31.12.1899' as date) + count(b.ID_BLOCK_ROOM)
  from   BLOCK_ROOM b
  where  b.ID_ROOM is not null
  into   :NEW_FROM_DATE;
end
^

/* Restore proc. body: BLOCK_MODIFY$BLK */
ALTER PROCEDURE BLOCK_MODIFY$BLK(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
IS_FULL_FROM INTEGER,
IS_FULL_TO INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable new_id_block_room integer;
  declare variable action_text varchar(255);
  declare variable old_from_date date;
  declare variable old_to_date date;
  declare variable old_group integer;
  declare variable room_name varchar(10);
  declare variable block_name varchar(30);
begin
  --  IS_FULL_FROM  - deprecated
  --  IS_FULL_TO  - deprecated

  select BR.FROM_DATE, BR.TO_DATE, BR.BLOCK_GRP, R.ROOM_NAME
  from   BLOCK_ROOM BR
         join ROOMS R on R.ID_ROOM = BR.ID_ROOM
  where  BR.ID_BLOCK_ROOM = :ID_BLOCK_ROOM              
  into   :old_from_date, :old_to_date, :old_group, :room_name;

  execute procedure BLOCK_MODIFY$INT(:id_block_room, :id_room, :from_date, :to_date, :block_grp,
                    :reason, :note, 'mod')
  returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :err_text, :warn_code;

  if ( (:old_from_date <> :FROM_DATE) or (:old_to_date <> :TO_DATE) or (:old_group <> :BLOCK_GRP) ) then begin
    block_name = iif(:block_grp = 18, 'OUT OF ORDER', 'OUT OF INVENTORY');
    action_text = f_character(29) || :room_name
                  || f_character(28) || formatdate(:FROM_DATE, 'D;dd.mm.yyyy') || '-' || formatdate(:TO_DATE, 'D;dd.mm.yyyy')
                  || f_character(28) || :block_name;
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :NEW_ID_BLOCK_ROOM, 'EDIT_BLOCK', :action_text);
  end
end
^

/* Restore proc. body: CACHES_RESOLVE */
ALTER PROCEDURE CACHES_RESOLVE AS
declare variable id_res_detail integer;
  declare variable id_group integer;
  declare variable cache_cnt integer;
  declare variable id_account integer;
  declare variable no_use varchar(1024);
begin
  /* resolve reservs cache conflicts */
  for
    select first 20 RG.ID_RESERV_DETAIL, rg.ID_GROUP, sum(iif(rg.BOARD_NAMES is null, 2, 1))
    from   RESERV_GUESTDATA_CACHE RG
    group by RG.ID_RESERV_DETAIL, rg.ID_GROUP
    having sum(iif(rg.BOARD_NAMES is null, 2, 1)) > 1
    into   :id_res_detail, :id_group, :cache_cnt
  do begin
    execute procedure RES_GET_GUEST_DATA$INT (iif(:id_res_detail is not null, 'DETAIL', 'GROUP'), coalesce(:id_res_detail, :id_group))
    returning_values  (:no_use, :no_use, :no_use, :no_use);

    when any do begin
      execute procedure sys_dbg('all Cache resolve error for reserv '|| iif(:id_res_detail is not null, 'DETAIL', 'GROUP') || ': ' || coalesce(:id_res_detail, :id_group));
    end
  end 

  /* resolve account balances cache conflicts */
  for
    select first 20 AC.ID_ACCOUNT, sum(iif(AC.ACCOUNT_BALANCE is null, 2, 1))
    from   ACCOUNT_BALANCE_CACHE AC
    group by AC.ID_ACCOUNT
    having sum(iif(AC.ACCOUNT_BALANCE is null, 2, 1)) > 1
    into   :id_account, :cache_cnt
  do begin
    execute procedure ACCOUNT_BALANCE$INT (:id_account, 0)
    returning_values  (:no_use, :no_use, :no_use, :no_use, :no_use, :no_use, :no_use);

    when any do begin
      execute procedure sys_dbg('all Cache resolve error for account: ' || :id_account);
    end
  end 
end
^

/* Restore proc. body: CLEAR_ORPHAN_GUESTS$EXC */
ALTER PROCEDURE CLEAR_ORPHAN_GUESTS$EXC(BOOKING_ID INTEGER)
 AS
declare variable guest_id integer;
  declare variable guest_uuid varchar(50);
begin

  for
    select g.id_guest, g.uuid
    from guest g
    where g.id_reserv_detail=:booking_id and g.orphaned_import$exc=1
    into :guest_id, :guest_uuid do
  begin
    execute procedure sys_dbg('exc CLEAR_ORPHAN_GUESTS$EXC - RES_GUEST_DEL$RSV(:guest_id=>' || coalesce(:guest_id, '<null>') || ', :guest_uuid=>' || coalesce(:guest_uuid, '<null>') || ')');

    execute procedure RES_GUEST_DEL$RSV(:guest_id);
  end
end
^

/* Restore proc. body: CONTRACT_CALENDAR_MODIFY$PMS */
ALTER PROCEDURE CONTRACT_CALENDAR_MODIFY$PMS(ID_CONTRACT_CALENDAR_POST TYPE OF ID,
ID_ROOM_CONTRACT TYPE OF ID,
ID_SERVICE TYPE OF ID,
IS_INCOME TYPE OF TLOGICAL,
SERVICE_PRICE TYPE OF TPRICE,
ID_CURRENCY TYPE OF TCURRENCY,
IS_ACC_POST_ITEM TYPE OF TLOGICAL,
POSTING_DATE_LIST TYPE OF TTEXT_EXTENDED,
POSTING_PERIOD_DURATION TYPE OF TCOUNT,
MONTH_NEXT_DATE TYPE OF TDATE,
IS_FIXED_DATE TYPE OF TLOGICAL,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_CALENDAR_POST TYPE OF ID)
 AS
declare variable post_date date;
  declare variable post_next_date date;
  declare variable service_name varchar(30);
  declare variable old_service_name varchar(30);
  declare variable old_post_next_date date;
  declare variable old_is_income smallint;
  declare variable old_service_price numeric(15,4);
  declare variable old_id_currency varchar(3);
  declare variable old_is_acc_post_item smallint;
  declare variable old_posting_period_duration integer;
  declare variable old_posting_date_list varchar(2000);
  declare variable old_id_service integer;
  declare variable old_is_fixed_date smallint;
  declare variable old_id_room_contract integer;
  declare variable action_text varchar(255);
begin

  /* POSTING_DATE_LIST - list ot dates(dd.mm.yyyy) comma separated;
     POSTING_PERIOD_DURATION must be in months,
     operation in ('add','mod','del') */

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del,mod_next_date');

  post_date = null;
  post_next_date = null;
  if (:OPERATION in ('add','mod')) then begin
    if (:is_fixed_date = 0) then begin
      post_date = :month_next_date;
      if (:posting_period_duration is not null and :post_date is not null) then begin
        post_next_date = addmonth(:post_date, :posting_period_duration);
      end
    end else begin
      select first 1 S.ITEM
      from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') S
      order by cast(S.ITEM as date)
      into :post_date;

      select first 1 SSP.ITEM
      from SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') SSP
      where cast(SSP.ITEM as date) > :post_date
      order by cast(SSP.ITEM as date)
      into :post_next_date;
    end

 --   select first 1 S.ITEM
 --   from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') S
 --   order by S.INTURN
 --   into   :post_date;

 --   if (:posting_period_duration is not null and :post_date is not null) then begin
 --     execute procedure ADD_MONTH(:post_date, :posting_period_duration)
 --     returning_values (:post_next_date);
 --   end else if (:posting_date_list is not null) then begin
 --     select S.ITEM
 --     from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') S
 --     where  S.INTURN = 2
 --     into   :post_next_date;
 --   end
  end

  select SE.SERVICE_NAME
  from SERVICES SE
  where SE.ID_SERVICE = :ID_SERVICE
  into :service_name;

  if (:operation = 'add') then begin
    if (coalesce(:ID_CONTRACT_CALENDAR_POST, -1) > 0) then
      NEW_ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST;
    else
      NEW_ID_CONTRACT_CALENDAR_POST = gen_id(GEN_CONTRACT_CAL_POST$PMS_ID, 1);

    insert into CONTRACT_CALENDAR_POST$PMS (
           ID_CONTRACT_CALENDAR_POST, ID_ROOM_CONTRACT, ID_SERVICE, IS_INCOME,
           SERVICE_PRICE, ID_CURRENCY, IS_ACC_POST_ITEM, POST_DATE, POST_NEXT_DATE, POSTING_PERIOD_DURATION, IS_FIXED_DATE)
    values (:NEW_ID_CONTRACT_CALENDAR_POST, :ID_ROOM_CONTRACT, :ID_SERVICE, :IS_INCOME,
            :SERVICE_PRICE, :ID_CURRENCY, :IS_ACC_POST_ITEM, :POST_DATE, :POST_NEXT_DATE, :POSTING_PERIOD_DURATION, :IS_FIXED_DATE);
    ID_CONTRACT_CALENDAR_POST = :NEW_ID_CONTRACT_CALENDAR_POST;

    if ((:is_fixed_date = 0) and (:month_next_date is not null)) then
      insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
      values (:ID_CONTRACT_CALENDAR_POST, :MONTH_NEXT_DATE);
    else if ((:is_fixed_date = 1) and (:posting_date_list is not null)) then begin
      for
        select SY.ITEM
        from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') SY
        into   :post_date
      do begin
        insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
        values (:ID_CONTRACT_CALENDAR_POST, :POST_DATE);
      end
    end

 --   for
 --     select S.ITEM
 --     from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') S
 --     into   :post_date
 --   do begin
 --     insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
 --     values (:ID_CONTRACT_CALENDAR_POST, :POST_DATE);
 --   end

    action_text = substring(f_character(29) || '@{pms.contract.is_income.' || :is_income || '}' || ', ' || :service_name ||
                  f_character(28) || '@{pms.is_acc_post_item.' || :is_acc_post_item || '}' ||
                  ', ' || formatfloat(:service_price, '0.00') ||
                  ', ' || :id_currency ||
                  ', ' || iif(:is_fixed_date = 0, '@{pms.montly_plannig_scheme}' || ', ' || coalesce(:posting_period_duration, ' ') || ', ' ||
                                                  iif(:month_next_date is not null, formatdate(:month_next_date, 'D;dd.mm.yyyy'), ' '),
                                                             '@{pms.fixed_plannig_scheme}' || ', ' ||coalesce(:posting_date_list, ' ')) from 1 for 255);

    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_CALEN_ADD', :ACTION_TEXT);
  end else begin
    select S.SERVICE_NAME, CCP.IS_INCOME, CCP.SERVICE_PRICE, CCP.ID_CURRENCY, CCP.IS_ACC_POST_ITEM,
           CCP.POSTING_PERIOD_DURATION, CCP.POST_NEXT_DATE, CCP.ID_SERVICE, CCP.IS_FIXED_DATE, CCP.ID_ROOM_CONTRACT
    from CONTRACT_CALENDAR_POST$PMS CCP
      join SERVICES S on S.ID_SERVICE = CCP.ID_SERVICE
    where CCP.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST
    into :old_service_name, old_is_income, :old_service_price, :old_id_currency, :old_is_acc_post_item,
         :old_posting_period_duration, :old_post_next_date, :old_id_service, :old_is_fixed_date, :old_id_room_contract;

    select list(formatdate(CCS.POST_DATE, 'D;dd.mm.yyyy'), ',')
    from CONTRACT_CALENDAR_SCHEME$PMS CCS
    where CCS.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST
    into :old_posting_date_list;

    if (:operation = 'mod') then begin
      if ((:old_is_income <> :is_income) or (:old_id_service <> :id_service)) then begin
        execute procedure CONTRACT_CALENDAR_MODIFY$PMS(:ID_CONTRACT_CALENDAR_POST, :ID_ROOM_CONTRACT, :ID_SERVICE, :IS_INCOME, :SERVICE_PRICE,
                                                       :ID_CURRENCY, :IS_ACC_POST_ITEM, :POSTING_DATE_LIST, :POSTING_PERIOD_DURATION,
                                                       :MONTH_NEXT_DATE, :IS_FIXED_DATE, 'del')
        returning_values :new_id_contract_calendar_post;
        execute procedure CONTRACT_CALENDAR_MODIFY$PMS(:ID_CONTRACT_CALENDAR_POST, :ID_ROOM_CONTRACT, :ID_SERVICE, :IS_INCOME, :SERVICE_PRICE,
                                                       :ID_CURRENCY, :IS_ACC_POST_ITEM, :POSTING_DATE_LIST, :POSTING_PERIOD_DURATION,
                                                       :MONTH_NEXT_DATE, :IS_FIXED_DATE, 'add')
        returning_values :new_id_contract_calendar_post;
      end else begin
        update CONTRACT_CALENDAR_POST$PMS C
        set    C.SERVICE_PRICE = :SERVICE_PRICE,
               C.ID_CURRENCY = :ID_CURRENCY,
               C.IS_ACC_POST_ITEM = :IS_ACC_POST_ITEM,
               C.POST_DATE = :POST_DATE,
               C.POST_NEXT_DATE = :POST_NEXT_DATE,
               C.POSTING_PERIOD_DURATION = :POSTING_PERIOD_DURATION,
               C.IS_FIXED_DATE = :IS_FIXED_DATE
        where C.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST;

        delete from CONTRACT_CALENDAR_SCHEME$PMS
        where (ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST);

        if ((:is_fixed_date = 0) and (:month_next_date is not null)) then
          insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
          values (:ID_CONTRACT_CALENDAR_POST, :MONTH_NEXT_DATE);
        else if ((:is_fixed_date = 1) and (:posting_date_list is not null)) then begin
          for
            select SY.ITEM
            from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') SY
            into   :post_date
          do begin
            insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
            values (:ID_CONTRACT_CALENDAR_POST, :POST_DATE);
          end
        end

 --       for
 --         select S.ITEM
 --         from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') S
 --         into   :post_date
 --       do begin
 --         insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
 --         values (:ID_CONTRACT_CALENDAR_POST, :POST_DATE);
 --       end

        if ((:old_is_acc_post_item <> :is_acc_post_item) or (:old_service_price <> :service_price) or (:old_id_currency <> :id_currency)) then begin
          action_text = substring(f_character(29) || '@{pms.contract.is_income.' || :is_income || '}' ||
                        ', ' || :service_name ||
                        f_character(28) || '@{pms.is_acc_post_item.' || :old_is_acc_post_item || '}' || ', '
                        || formatfloat(:old_service_price, '0.00') || ', ' ||
                        :old_id_currency ||
                        f_character(28) || '@{pms.is_acc_post_item.' || :is_acc_post_item || '}' || ', ' ||
                        formatfloat(:service_price, '0.00') || ', ' || :id_currency from 1 for 255);
          execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_CALEN_MOD', :ACTION_TEXT);
        end

        if ((coalesce(:old_posting_period_duration, 0) <> coalesce(:posting_period_duration, 0)) or
            (coalesce(:old_posting_date_list, ' ') <> coalesce(:posting_date_list, formatdate(:month_next_date, 'D;dd.mm.yyyy')))) then begin
          action_text = substring(f_character(29) || '@{pms.contract.is_income.' || :is_income || '}' ||
                        ', ' || :service_name || ', ' || f_character(28) ||
                        iif(:old_is_fixed_date = 0, '@{pms.montly_plannig_scheme}' || ', ' || coalesce(:old_posting_period_duration, ' ') || ', ' ||
                                                    coalesce(:old_posting_date_list, ' '),
                                                    '@{pms.fixed_plannig_scheme}' || ', ' ||coalesce(:old_posting_date_list, ' ')) ||
                        f_character(28) || iif(:is_fixed_date = 0, '@{pms.montly_plannig_scheme}' || ', ' || coalesce(:posting_period_duration, ' ')
                                                                   || ', ' || /*coalesce(:posting_date_list, ' ')*/iif(:month_next_date is not null, formatdate(:month_next_date, 'D;dd.mm.yyyy'), ' '),
                                                                   '@{pms.fixed_plannig_scheme}' || ', ' || coalesce(:posting_date_list, ' ')) from 1 for 255);
          execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_CALEN_MOD_SCHM', :ACTION_TEXT);
        end
      end
    end
    if (:operation = 'mod_next_date') then begin
      select C.POST_NEXT_DATE, C.POSTING_PERIOD_DURATION, C.IS_FIXED_DATE
      from   CONTRACT_CALENDAR_POST$PMS C
      where  C.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST
      into   :post_date, :posting_period_duration, :is_fixed_date;

      if ((:is_fixed_date = 0) and (:posting_period_duration is not null) and (:post_date is not null)) then begin
        POST_NEXT_DATE = addmonth(:POST_DATE, :POSTING_PERIOD_DURATION);
      end else begin
        select first 1 skip 1 S.POST_DATE
        from   CONTRACT_CALENDAR_SCHEME$PMS S
        where  S.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST
        order by S.POST_DATE
        into   :POST_NEXT_DATE;
      end

      update CONTRACT_CALENDAR_POST$PMS C
      set    C.POST_DATE = :POST_DATE,
             C.POST_NEXT_DATE = :POST_NEXT_DATE
      where  C.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST;
    end
    if (:operation = 'del') then begin
      action_text = f_character(29) || '@{pms.contract.is_income.' || :old_is_income || '}' || f_character(28) || :old_service_name ||
                    f_character(28) || '@{pms.is_acc_post_item.' || :old_is_acc_post_item || '}' ||
                    ', ' || formatfloat(:old_service_price, '0.00') ||
                    ', ' || :old_id_currency ||
                    ', ' || iif(:old_is_fixed_date = 0, '@{pms.montly_plannig_scheme}' || ', ' || coalesce(:old_posting_period_duration, ' ') ||
                                                        ', ' || coalesce(:old_post_next_date, ' '),
                                                        '@{pms.fixed_plannig_scheme}' || ', ' || coalesce(:old_posting_date_list, ' '));
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :OLD_ID_ROOM_CONTRACT, 'ROOM_CONTR_CALEN_DEL', substring(:ACTION_TEXT from 1 for 255));
      delete from CONTRACT_CALENDAR_POST$PMS
      where (ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST);
    end
  end
end
^

/* Restore proc. body: CONTRACT_EXPENSE_MODIFY$PMS */
ALTER PROCEDURE CONTRACT_EXPENSE_MODIFY$PMS(ID_CONTRACT_EXPENSE TYPE OF ID,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
SERVICE_PRICE TYPE OF TPRICE,
CONTRACT_EXPENSE_TYPE VARCHAR(50),
MULTIPLIER_TYPE VARCHAR(50),
ORDER_TAG TYPE OF TCOUNT,
IS_ACC_POST_ITEM TYPE OF TLOGICAL,
ID_AGENT_PROFILE TYPE OF ID_REF,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_EXPENSE TYPE OF ID)
 AS
declare variable is_use smallint;
  declare variable formula varchar(100);
  declare variable service_name varchar(30);
  declare variable id_room_contract integer;
  declare variable old_service_name varchar(30);
  declare variable old_is_acc_post_item smallint;
  declare variable old_multiplier_type varchar(50);
  declare variable old_contract_expense_type varchar(50);
  declare variable old_order_tag integer;
  declare variable old_id_currency char(3);
  declare variable old_service_price numeric(15,4);
  declare variable old_id_service integer;
  declare variable contract_acc varchar(50);
  declare variable action_text varchar(255);
  declare variable id_hotel_contract integer;
  declare variable id_hotel_service integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  if ( :CONTRACT_EXPENSE_TYPE not in ('PERCENT', 'RUNNING_TOTAL_PERCENT', 'CURR_VALUE') ) then
    exception WRONG_PARAM_VALUE;

  if ( :MULTIPLIER_TYPE not in ('RESERVATION', 'STAY', 'GUESTS', 'BED_NIGHTS') ) then
    exception WRONG_PARAM_VALUE;

  if (:ORDER_TAG is null) then ORDER_TAG = 0;
  formula = '';
  is_use = 1;

  select SE.SERVICE_NAME, SE.id_hotel
  from   SERVICES SE
  where  SE.ID_SERVICE = :ID_SERVICE
  into   :service_name, :id_hotel_service;

  select R.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS RP on RP.ID_ROOM_PERIOD = RC.ID_ROOM_PERIOD
         join ROOMS R on R.ID_ROOM = RP.ID_ROOM
  where  RC.ID_ROOM_CONTRACT = :ID_CONTRACT
  into   :id_hotel_contract;

  if (:id_hotel_contract is distinct from :id_hotel_service) then exception PMS_EXCEPTION '-626';

  if (:OPERATION = 'add') then begin
    id_room_contract = :ID_CONTRACT;
    contract_acc = case
                     when :SUB_CONTRACT = 'GUEST_USE' then '@{pms.contract_base_account}'
                     when :SUB_CONTRACT = 'OWNER_USE' then '@{pms.contract_owner_use}'
                     when :SUB_CONTRACT = 'SHADOW_ACC' then '@{pms.contract_shadow_account}'
                     else 'N/A'
                   end;

    NEW_ID_CONTRACT_EXPENSE = gen_id(GEN_CONTRACT_EXPENSE$PMS_ID, 1);
    insert into CONTRACT_EXPENSE$PMS (ID_CONTRACT_EXPENSE, ID_CONTRACT, SUB_CONTRACT, ID_SERVICE, ORDER_TAG,
           FORMULA, ID_CURRENCY, SERVICE_PRICE, CONTRACT_EXPENSE_TYPE, IS_ACC_POST_ITEM, MULTIPLIER_TYPE, ID_AGENT_PROFILE)
    values (:NEW_ID_CONTRACT_EXPENSE, :ID_CONTRACT, :SUB_CONTRACT, :ID_SERVICE, :ORDER_TAG,
           :FORMULA, :ID_CURRENCY, :SERVICE_PRICE, :CONTRACT_EXPENSE_TYPE, :IS_ACC_POST_ITEM, :MULTIPLIER_TYPE, :ID_AGENT_PROFILE);

    action_text = substring(f_character(29) || :contract_acc || f_character(28) || :order_tag || f_character(28) || :service_name ||
                  f_character(28) || '@{pms.is_acc_post_item.' || :is_acc_post_item || '}' ||
                  f_character(28) || '@{pms.multiplier_type.' || :multiplier_type || '}' ||
                  f_character(28) || coalesce(:id_currency, '@{pms.contract_expense_type.' || :contract_expense_type || '}') ||
                  f_character(28) || formatfloat(:service_price, '0.00') from 1 for 255);
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_SERV_ADD', :ACTION_TEXT);
  end else begin
    select S.SERVICE_NAME, CEP.IS_ACC_POST_ITEM, CEP.MULTIPLIER_TYPE, CEP.CONTRACT_EXPENSE_TYPE, CEP.ORDER_TAG,
           CEP.ID_CURRENCY, CEP.SERVICE_PRICE, CEP.ID_SERVICE,
           case
             when CEP.SUB_CONTRACT = 'GUEST_USE' then '@{pms.contract_base_account}'
             when CEP.SUB_CONTRACT = 'OWNER_USE' then '@{pms.contract_owner_use}'
             when CEP.SUB_CONTRACT = 'SHADOW_ACC' then '@{pms.contract_shadow_account}'
             else 'N/A'
           end,
           CEP.ID_CONTRACT
    from   CONTRACT_EXPENSE$PMS CEP
           join SERVICES S on S.ID_SERVICE = CEP.ID_SERVICE
    where  CEP.ID_CONTRACT_EXPENSE = :ID_CONTRACT_EXPENSE
    into   :old_service_name, :old_is_acc_post_item, :old_multiplier_type, :old_contract_expense_type, :old_order_tag,
           :old_id_currency, :old_service_price, :old_id_service, :contract_acc, :id_room_contract;

    if (:OPERATION = 'mod') then begin
      if (:old_id_service <> :id_service) then begin
        execute procedure CONTRACT_EXPENSE_MODIFY$PMS(:ID_CONTRACT_EXPENSE, :ID_CONTRACT, :SUB_CONTRACT, :ID_SERVICE, :ID_CURRENCY, :SERVICE_PRICE,
                                                      :CONTRACT_EXPENSE_TYPE, :MULTIPLIER_TYPE, :ORDER_TAG, :IS_ACC_POST_ITEM, :ID_AGENT_PROFILE, 'del')
        returning_values :new_id_contract_expense;
        execute procedure CONTRACT_EXPENSE_MODIFY$PMS(:ID_CONTRACT_EXPENSE, :ID_CONTRACT, :SUB_CONTRACT, :ID_SERVICE, :ID_CURRENCY, :SERVICE_PRICE,
                                                      :CONTRACT_EXPENSE_TYPE, :MULTIPLIER_TYPE, :ORDER_TAG, :IS_ACC_POST_ITEM, :ID_AGENT_PROFILE, 'add')
        returning_values :new_id_contract_expense;
      end else begin
        update CONTRACT_EXPENSE$PMS
        set    FORMULA = :FORMULA,
               ID_CURRENCY = :ID_CURRENCY,
               SERVICE_PRICE = :SERVICE_PRICE,
               CONTRACT_EXPENSE_TYPE = :CONTRACT_EXPENSE_TYPE,
               IS_ACC_POST_ITEM = :IS_ACC_POST_ITEM,
               MULTIPLIER_TYPE = :MULTIPLIER_TYPE,
               ORDER_TAG = :ORDER_TAG,
               ID_AGENT_PROFILE = :ID_AGENT_PROFILE
        where  ID_CONTRACT_EXPENSE = :ID_CONTRACT_EXPENSE;

        if ((:old_is_acc_post_item <> :is_acc_post_item) or (:old_multiplier_type <> :multiplier_type) or
                   (coalesce(:old_id_currency, :old_contract_expense_type) <> coalesce(:id_currency, :contract_expense_type)) or
                   (:old_service_price <> :service_price)) then begin
          action_text = substring(f_character(29) || :old_service_name || f_character(28) || :contract_acc ||
                        f_character(28) || '@{pms.is_acc_post_item.' || :old_is_acc_post_item || '}' ||
                        f_character(28) || '@{pms.multiplier_type.' || :old_multiplier_type || '}' ||
                        f_character(28) || coalesce(:old_id_currency, '@{pms.contract_expense_type.' || :old_contract_expense_type || '}') ||
                        f_character(28) || formatfloat(:old_service_price, '0.00') ||
                        f_character(28) || '@{pms.is_acc_post_item.' || :is_acc_post_item || '}' ||
                        f_character(28) || '@{pms.multiplier_type.' || :multiplier_type || '}' ||
                        f_character(28) || coalesce(:id_currency, '@{pms.contract_expense_type.' || :contract_expense_type || '}') ||
                        f_character(28) || formatfloat(:service_price, '0.00') from 1 for 255);
          execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_SERV_CHANG', :ACTION_TEXT);
        end
      end
    end else if (:OPERATION = 'del') then begin
      action_text = substring(f_character(29) || :contract_acc || f_character(28) || :old_order_tag || f_character(28) || :old_service_name ||
                      f_character(28) || '@{pms.is_acc_post_item.' || :old_is_acc_post_item || '}' ||
                      f_character(28) || '@{pms.multiplier_type.' || :old_multiplier_type || '}' ||
                      f_character(28) || coalesce(:old_id_currency, '@{pms.contract_expense_type.' || :old_contract_expense_type || '}') ||
                      f_character(28) || formatfloat(:old_service_price, '0.00') from 1 for 255);
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_SERV_DEL', :ACTION_TEXT);

      delete from CONTRACT_EXPENSE$PMS
      where (ID_CONTRACT_EXPENSE = :ID_CONTRACT_EXPENSE);
    end
  end
end
^

/* Restore proc. body: CONTRACT_MANAGEMENT_MODIFY$PMS */
ALTER PROCEDURE CONTRACT_MANAGEMENT_MODIFY$PMS(ID_CONTRACT_MANAGEMENT TYPE OF ID,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_SERVICE TYPE OF ID,
MIN_VALUE TYPE OF TPRICE,
MIN_VALUE_CURR TYPE OF TCURRENCY,
MAX_VALUE TYPE OF TPRICE,
MAX_VALUE_CURR TYPE OF TCURRENCY,
NIGHT_PRICE TYPE OF TPRICE,
NIGHT_PRICE_CURR TYPE OF TCURRENCY,
IS_NETO TYPE OF TLOGICAL,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_MANAGEMENT TYPE OF ID)
 AS
declare variable is_use smallint;
  declare variable formula varchar(100);
  declare variable contract_acc varchar(50);
  declare variable id_room_contract integer;
  declare variable service_name varchar(30);
  declare variable old_id_contract integer;
  declare variable old_service_name varchar(30);
  declare variable old_min_value numeric(15,4);
  declare variable old_min_value_curr varchar(3);
  declare variable old_max_value numeric(15,4);
  declare variable old_max_value_curr varchar(3);
  declare variable old_night_price numeric(15,4);
  declare variable old_night_price_curr varchar(3);
  declare variable is_commision_service smallint;
  declare variable old_is_commision_service smallint;
  declare variable action_text varchar(255);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  formula = '';
  is_use = 1;

  select SE.SERVICE_NAME, iif(se.SERVICE_TYPE = 'COMMISSION', 0, 1) --SE.IS_ACC_POST_ITEM
  from   SERVICES SE
  where  SE.ID_SERVICE = :ID_SERVICE
  into   :service_name, :is_commision_service;

  if (:OPERATION = 'add') then begin
    /*select case
              when :ID_CONTRACT = RCP.ID_CONTRACT_GUEST then '@{pms.contract_base_account}'
              when :ID_CONTRACT = RCP.ID_CONTRACT_OWNER then '@{pms.contract_owner_use}'
              else  '@{pms.contract_shadow_account}'
           end as CONTRACT_ACC,
           RCP.ID_ROOM_CONTRACT
    from   ROOM_CONTRACT$PMS RCP
    where  :ID_CONTRACT in (RCP.ID_CONTRACT_GUEST, RCP.ID_CONTRACT_OWNER, RCP.ID_CONTRACT_SHADOW)
    into   :contract_acc, :id_room_contract; */
    id_room_contract = :ID_CONTRACT;
    contract_acc = case
                     when :SUB_CONTRACT = 'GUEST_USE' then '@{pms.contract_base_account}'
                     when :SUB_CONTRACT = 'OWNER_USE' then '@{pms.contract_owner_use}'
                     when :SUB_CONTRACT = 'SHADOW_ACC' then '@{pms.contract_shadow_account}'
                     else 'N/A'
                   end;

    new_id_contract_management = gen_id(GEN_CONTRACT_MANAGEMENT$PMS_ID, 1);
    insert into CONTRACT_MANAGEMENT$PMS (ID_CONTRACT_MANAGEMENT, ID_CONTRACT, SUB_CONTRACT,
           MIN_VALUE, MIN_VALUE_CURR, MAX_VALUE, MAX_VALUE_CURR,
           NIGHT_PRICE, NIGHT_PRICE_CURR, FORMULA, IS_NETO, IS_USE, ID_SERVICE)
    values (:new_id_contract_management, :ID_CONTRACT, :SUB_CONTRACT,
           :MIN_VALUE, :MIN_VALUE_CURR, :MAX_VALUE, :MAX_VALUE_CURR,
           :NIGHT_PRICE, :NIGHT_PRICE_CURR, :FORMULA, :IS_NETO, :IS_USE, :ID_SERVICE);

    action_text = f_character(29) || :contract_acc || f_character(28) ||
                  iif(:is_commision_service = 0, '@{word.commission}' || ' ' ||'@{word.the_service}' || ' ' || :service_name, :service_name) || f_character(28) ||
                  iif(:min_value is null, '', formatfloat(min_value, '0.00')) ||
                  iif(:max_value is null, '', formatfloat(max_value, '0.00')) ||
                  iif(:night_price is null, '', formatfloat(night_price, '0.00')) || f_character(28) ||
                  coalesce(min_value_curr, '') ||
                  coalesce(max_value_curr, '') || coalesce(night_price_curr, '');
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_KOM_SERV_ADD', :ACTION_TEXT);

  end else begin
    /*select CMP.ID_CONTRACT, CMP.MIN_VALUE, CMP.MIN_VALUE_CURR, CMP.MAX_VALUE, CMP.MAX_VALUE_CURR,
           CMP.NIGHT_PRICE, CMP.NIGHT_PRICE_CURR, SE.SERVICE_NAME, SE.IS_ACC_POST_ITEM,
           case
              when CMP.ID_CONTRACT = RCP.ID_CONTRACT_GUEST then '@{pms.contract_base_account}'
              when CMP.ID_CONTRACT = RCP.ID_CONTRACT_OWNER then '@{pms.contract_owner_use}'
              else  '@{pms.contract_shadow_account}'
           end as CONTRACT_ACC,
           RCP.ID_ROOM_CONTRACT
    from   CONTRACT_MANAGEMENT$PMS CMP
           join SERVICES SE on SE.ID_SERVICE = CMP.ID_SERVICE
           join ROOM_CONTRACT$PMS RCP on CMP.ID_CONTRACT in (RCP.ID_CONTRACT_GUEST, RCP.ID_CONTRACT_OWNER, RCP.ID_CONTRACT_SHADOW)
    where  CMP.ID_CONTRACT_MANAGEMENT = :ID_CONTRACT_MANAGEMENT
    into   :old_id_contract, :old_min_value, :old_min_value_curr, :old_max_value, :old_max_value_curr,
           :old_night_price, :old_night_price_curr, :old_service_name, :old_is_commision_service, :contract_acc, :id_room_contract;*/
    select CMP.ID_CONTRACT, CMP.MIN_VALUE, CMP.MIN_VALUE_CURR, CMP.MAX_VALUE, CMP.MAX_VALUE_CURR,
           CMP.NIGHT_PRICE, CMP.NIGHT_PRICE_CURR, SE.SERVICE_NAME, iif(se.SERVICE_TYPE = 'COMMISSION', 0, 1), --SE.IS_ACC_POST_ITEM,
           case
             when CMP.SUB_CONTRACT = 'GUEST_USE' then '@{pms.contract_base_account}'
             when CMP.SUB_CONTRACT = 'OWNER_USE' then '@{pms.contract_owner_use}'
             when CMP.SUB_CONTRACT = 'SHADOW_ACC' then '@{pms.contract_shadow_account}'
             else 'N/A'
           end as CONTRACT_ACC,
           CMP.ID_CONTRACT
    from   CONTRACT_MANAGEMENT$PMS CMP
           join SERVICES SE on SE.ID_SERVICE = CMP.ID_SERVICE
    where  CMP.ID_CONTRACT_MANAGEMENT = :ID_CONTRACT_MANAGEMENT
    into   :old_id_contract, :old_min_value, :old_min_value_curr, :old_max_value, :old_max_value_curr,
           :old_night_price, :old_night_price_curr, :old_service_name, :old_is_commision_service, :contract_acc, :id_room_contract;

    if (:OPERATION = 'mod') then begin
      update CONTRACT_MANAGEMENT$PMS
      set    -- ID_CONTRACT = :ID_CONTRACT,
             MIN_VALUE = :MIN_VALUE,
             MIN_VALUE_CURR = :MIN_VALUE_CURR,
             MAX_VALUE = :MAX_VALUE,
             MAX_VALUE_CURR = :MAX_VALUE_CURR,
             NIGHT_PRICE = :NIGHT_PRICE,
             NIGHT_PRICE_CURR = :NIGHT_PRICE_CURR,
             FORMULA = :FORMULA,
             IS_NETO = :IS_NETO,
             IS_USE = :IS_USE,
             ID_SERVICE = :ID_SERVICE
      where (ID_CONTRACT_MANAGEMENT = :ID_CONTRACT_MANAGEMENT);

      if ((:old_id_contract <> :id_contract) or (coalesce(:old_min_value, 0) <> coalesce(:min_value, 0)) or
          (coalesce(:old_min_value_curr, ' ') <> coalesce(:min_value_curr, ' ')) or
          (coalesce(:old_max_value, 0) <> coalesce(:max_value, 0)) or
          (coalesce(:old_max_value_curr, ' ') <> coalesce(:max_value_curr, ' ')) or
          (coalesce(:old_night_price, 0) <> coalesce(:night_price, 0)) or
          (coalesce(:old_night_price_curr, ' ') <> coalesce(:night_price_curr, ' ')) or
          (:is_commision_service <> :old_is_commision_service) or
          (coalesce(:service_name, ' ') <> coalesce(:old_service_name, ' '))) then begin
        action_text = f_character(29) || :contract_acc || f_character(28) ||
                      iif(:old_is_commision_service = 0, '@{word.commission}' || ' ' ||'@{word.the_service}' || ' ' || :old_service_name, :old_service_name) || f_character(28) ||
                      iif(:old_min_value is null, '', formatfloat(:old_min_value, '0.00')) ||
                      iif(:old_max_value is null, '', formatfloat(:old_max_value, '0.00')) ||
                      iif(:old_night_price is null, '', formatfloat(:old_night_price, '0.00')) || f_character(28) ||
                      coalesce(old_min_value_curr, '') ||
                      coalesce(old_max_value_curr, '') || coalesce(old_night_price_curr, '') ||
                      f_character(28) ||
                      iif(:is_commision_service = 0, '@{word.commission}' || ' ' ||'@{word.the_service}' || ' ' || :service_name, :service_name) || f_character(28) ||
                      iif(:min_value is null, '', formatfloat(:min_value, '0.00')) ||
                      iif(:max_value is null, '', formatfloat(:max_value, '0.00')) ||
                      iif(:night_price is null, '', formatfloat(:night_price, '0.00')) || f_character(28) || coalesce(min_value_curr, '') ||
                      coalesce(max_value_curr, '') || coalesce(night_price_curr, '');
        execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_KOM_SERV_CHANG', :ACTION_TEXT);
      end
    end else if (:OPERATION = 'del') then begin
      action_text = f_character(29) || coalesce(:contract_acc, '') || f_character(28) ||
                    iif(:old_is_commision_service = 0, '@{word.commission}' || ' ' ||'@{word.the_service}' || ' ' || :old_service_name, :old_service_name) || f_character(28) ||
                    iif(:old_min_value is null, '', formatfloat(:old_min_value, '0.00')) ||
                    iif(:old_max_value is null, '', formatfloat(:old_max_value, '0.00')) ||
                    iif(:old_night_price is null, '', formatfloat(:old_night_price, '0.00')) || f_character(28) || coalesce(old_min_value_curr, '') ||
                    coalesce(old_max_value_curr, '') || coalesce(old_night_price_curr, '');
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_KOM_SERV_DEL', :ACTION_TEXT);

      delete from CONTRACT_MANAGEMENT$PMS
      where (ID_CONTRACT_MANAGEMENT = :ID_CONTRACT_MANAGEMENT);
    end
  end
end
^

/* Restore proc. body: CREATE_BOOKING$WBE */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
declare variable rate varchar(50);
declare variable room_type varchar(20);
declare variable arrival date;
declare variable departure date;
declare variable adults integer;
declare variable children integer;
declare variable profile_name varchar(100);
declare variable aranger_name varchar(100);
declare variable guest_profile_uuid varchar(40);
declare variable aranger_profile_uuid varchar(40);
declare variable hotel_name varchar(50);
declare variable wbe_session_id bigint;
declare variable main_guest_profile_id integer;
declare variable board varchar(50);
declare variable hotel_id integer;
declare variable guarantee_policy_name varchar(50);
declare variable guarantee_deposit_percent numeric(15,4);
declare variable guarantee_deposit_nights integer;
declare variable guarantee_due_days_bef_arrival integer;
declare variable guarantee_due_days_after_create integer;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable profile_type varchar(20);
declare variable profile_import_time timestamp;
declare variable b_count integer;
declare variable age integer;
declare variable is_child smallint;
declare variable guest_id integer;
declare variable special_treatment varchar(250);
declare variable maintenance varchar(30);
declare variable routing varchar(20);
declare variable arranger_paymeny_type varchar(20);
declare variable market_segment varchar(30);
declare variable market_source varchar(30);
declare variable market_channel varchar(30);
declare variable market_hear_reason varchar(30);
declare variable market_come_reason varchar(30);
declare variable first_food varchar(30);
declare variable bnote varchar(2000);
begin
  -- get wbe product selection
  select  PA.rate_name,PA.room_name, AQ.first_date, AQ.first_date+AQ.day_count,
          PS.adults, PS.children, PS.person_name, H.hotel_name, H.id_hotel,
          WS.id, PA.board_name, GP.name, GP.deposit_totalsum_part, GP.deposit_nights_count, GP.due_days_before_arrival, GP.due_days_after_create,
          PS.bnote
   from   PRODUCT_SELECTION$WBE PS
          join WBE_SESSION$WBE WS on WS.id = PS.wbe_session_id
          join PRODUCT_AVAILABILITY$WBE PA on pa.id = PS.product_availability_id
          join AVAILABILITY_QUERY$WBE AQ on aq.id = WS.product_query_id
          join HOTEL H on H.id_hotel = WS.hotel_id
          join GUARANTEE_POLICY GP on GP.id_guarantee_policy = PS.guarantee_policy_id
   where  PS.id = :product_selection_id
   into   :rate, :room_type, :arrival, :departure,
          :adults,  :children, :profile_name, :hotel_name, :hotel_id,
          :wbe_session_id, :board, :guarantee_policy_name,
          :guarantee_deposit_percent, :guarantee_deposit_nights,
          :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create,
          :bnote;

  select PA.uuid , PA.profile_name, PA.profile_type
  from   PROFILE PA
  where  PA.id_profile = :aranger_profile_id
  into   :aranger_profile_uuid,:aranger_name,  :profile_type;

  if (:aranger_name = :profile_name and :profile_type = 'PERSON') then begin
    -- aranger is main guest
    select count(*)
    from   PRODUCT_SELECTION$WBE PSC
    where  PSC.wbe_session_id = :wbe_session_id
    into   :b_count;
       -- only if single reservation bugfix 2228
    if (1 = :b_count) then begin
     guest_profile_uuid =  aranger_profile_uuid;
     aranger_profile_uuid = null;
    end
  end else begin
    -- create profile for main guest
    execute procedure IMPORT_PERSON_PROFILE$EXC(
      uuid_create(),:profile_name,null,null,null,null,null,null,null,null,null,null, null,
      null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
      null,null,null,null,null, null, null)
    returning_values :main_guest_profile_id, :profile_import_time;

    select P.uuid
    from   PROFILE P
    where  P.id_profile = :main_guest_profile_id
    into   :guest_profile_uuid;
  end

    -- apply default map + forced arranger
    special_treatment = null;
    maintenance = null;
    routing = null;
    arranger_paymeny_type = null;
    market_segment = null;
    market_source = null;
    market_channel = null;
    market_hear_reason = null;
    market_come_reason = null;


  select hc.special_treatment, hk.plan_name, hc.routing,
         pt.payment_type, ms.segment_name, sc.description, cc.description,
         hr.description, cr.description, hc.first_food
  from   HOTEL_PRODUCT_CFG$WBE hc
         left join HK_PLAN hk on hk.id_plan = hc.id_hk_plan
         left join PAYMENT_TYPE pt on pt.id_payment_type = hc.arranger_id_payment_type
         left join NOM_MARKET_SEGMENTS ms on ms.id_nom_market_segment = hc.id_m_segment
         left join NOM_SOURCE_CODES sc on sc.id_nom_source_code = hc.id_m_source
         left join NOM_CHANNEL_CODES cc on cc.id_nom_channel_code = hc.id_m_channel
         left join NOM_HEAR_REASONS hr on hr.id_nom_hear_reason = hc.id_m_hear_reason
         left join NOM_COME_REASONS cr on cr.id_nom_come_reason = hc.id_m_come_reason
  where  hc.hotel_id = :hotel_id
  into   :special_treatment,:maintenance,:routing,:arranger_paymeny_type,
         :market_segment,:market_source,:market_channel,:market_hear_reason,:market_come_reason,:first_food;
  -- create reseravation
  execute procedure IMPORT_BOOKING$EXC(
     :hotel_name, :number, null, null, 0,
     :arrival, null, :departure, null, null, null, null, null, :room_type, :board, null,
     :special_treatment, :maintenance, :routing, :rate, null, null, null, null, :arranger_paymeny_type, null, null, null, null,
     :market_segment, :market_source,:market_channel, :market_hear_reason, :market_come_reason,
     :bnote, null, :first_food, :adults, :children, :aranger_profile_uuid, null, :guest_profile_uuid,
     0, 0, null, :guarantee_policy_name, null, :guarantee_deposit_percent, :guarantee_deposit_nights,
     :guarantee_due_days_bef_arrival,  :guarantee_due_days_after_create, null, null, null, null,  null, null, null, null, null, null, null, null)
  returning_values
     :hotel_id, :booking_id, :err_code, err_text;
  if (0 <> :err_code) then exception WRONG_VALUE ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');

  -- import guests
  for
    select psg.guest_name, psg.is_child, psg.age
    from   PRODUCT_SELECTION_GUESTS$WBE psg
    where  psg.product_selection_id = :product_selection_id
    into   :profile_name,:is_child,:age
  do begin
    execute procedure IMPORT_GUEST$EXC(:booking_id, null, null, :profile_name, :is_child, :age, null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null)
    returning_values :guest_id, :err_code,:err_text;
    if (0 <> :err_code) then exception WRONG_VALUE ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');
  end
  ----------------

  select RD.number_2
  from   RESERV_DETAIL RD
  where  RD.id_reserv_detail = :booking_id
  into   :number_2;

  update PRODUCT_SELECTION$WBE uPS
  set    uPS.booking_id = :booking_id, uPS.selection_id = :number_2
  where  uPS.id = :product_selection_id;
end
^

/* Restore proc. body: CURR_RATE_MODIFY */
ALTER PROCEDURE CURR_RATE_MODIFY(CURR CHAR(3),
ID_HOTEL INTEGER,
RATE NUMERIC(15,6),
FOR_DATE DATE = null)
 AS
declare variable ap_dbkey char(8);
  declare variable guest_posting_rate varchar(20);
  declare variable from_date date;
  declare variable cr_dbkey char(8);
  declare variable old_rate numeric(15,6);
  declare variable id_curr_rate integer;
  declare variable hotel_name varchar(50);
  declare variable action_text varchar(255);
  declare variable nation_curr tcurrency;
begin
  for_date = coalesce(:FOR_DATE, current_date);

  select h.HOTEL_NAME, h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :ID_HOTEL
  into   :hotel_name, :nation_curr;

  if (:nation_curr = :CURR and :RATE <> 1) then exception ASSERT '-35';

  select cr.RDB$DB_KEY, cr.CURR_RATE
  from   CURR_RATES CR
  where  CR.CURR = :CURR
         and cr.ID_HOTEL = :ID_HOTEL
         and cr.DATE_ = :FOR_DATE
  into   :cr_dbkey, :old_rate;

  if (:old_rate is null) then begin
    insert into CURR_RATES (CURR, ID_HOTEL, DATE_, CURR_RATE)
    values (:CURR, :ID_HOTEL, :FOR_DATE, :RATE)
    returning ID_CURR_RATE into :id_curr_rate;

    select first 1 r.CURR_RATE
    from   CURR_RATES r
    where  r.ID_HOTEL = :ID_HOTEL
           and r.CURR = :CURR
           and r.DATE_ < :FOR_DATE
    order by r.DATE_ desc
    into   :old_rate;

  end else if (:old_rate <> :RATE) then begin
    update CURR_RATES r
    set    r.CURR_RATE = :RATE
    where  r.RDB$DB_KEY = :cr_dbkey;
  end else begin
    exit;
  end

  action_text = f_character(29) || :hotel_name || f_character(28)
                || formatdate(:FOR_DATE, 'D;dd.mm.yyyy') || f_character(28)
                || coalesce(:old_rate, 'N/A') || f_character(28)
                || coalesce(:RATE, 'N/A');

  execute procedure SYSTEM_LOG_ADD ('CURRENCY', :id_curr_rate, 'RATE_CHANGED', :action_text, :RATE);

  if (:old_rate is not null) then begin   -- this is not first, initial rate
    /* CHANGE THE CURRENR_RATE OF THE OPEN POSTINGS */
    execute procedure SETTING_GET_VALUE('GUEST_POSTING_RATE', :ID_HOTEL)
    returning_values  :guest_posting_rate;
  
    for
      select AP.rdb$db_key, G.FROM_DATE
      from   ACCOUNT_POST AP
             join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
             left outer join GUEST G on G.ID_GUEST = AP.ID_GUEST
      where  ((AP.CURR_POST = :CURR) or (AP.CURR_ORIG = :CURR))
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null
             and AP.DATE_POST >= current_date
             and A.ID_HOTEL = :ID_HOTEL
      into   :ap_dbkey, :from_date
    do begin
      if (:guest_posting_rate = 'CHECKIN_DATE' and :from_date < current_date) then begin
        /* Do nothing. Theese postings are by guest check_in date rate,
        || which is not changing now
        */
      end else begin
        execute procedure ACCOUNT_POSTING_UPDATE_RATE$INT (:ap_dbkey, :CURR, :RATE);
      end
    end
  end
end
^

/* Restore proc. body: DEFAULT_BOOKING_VALUES$EXC */
ALTER PROCEDURE DEFAULT_BOOKING_VALUES$EXC(BOOKING_DBKEY CHAR(8),
HOTEL_ID INTEGER,
RATE_ID_IN INTEGER,
ROOM_TYPE_ID_IN INTEGER,
BOARD_ID_IN INTEGER,
MAINTANCE_SHEMA_ID_IN INTEGER,
ARRANGER_PAYMENT_TYPE_ID_IN INTEGER,
GUEST_PAYMENT_TYPE_ID_IN INTEGER,
MARKETING1_ID_IN INTEGER,
MARKETING2_ID_IN INTEGER,
MARKETING3_ID_IN INTEGER,
MARKETING4_ID_IN INTEGER,
MARKETING5_ID_IN INTEGER,
ARRANGER_PROFILE_ID_IN INTEGER,
MAIN_GUEST_PROFILE_ID_IN INTEGER,
POSTING_ROUTING_IN VARCHAR(50),
FIRST_FOOD_CODE_IN TFOOD_CODE,
GUARANTEE_POLICY_ID_IN INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_LATE_DEPARTURE_IN INTEGER,
EATING_OBJECT_ID_IN INTEGER)
 RETURNS(RATE_ID INTEGER,
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
MAINTANCE_SHEMA_ID INTEGER,
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
ARRANGER_PROFILE_ID INTEGER,
ARRANGER_ACCOUNT_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
POSTING_ROUTING VARCHAR(50),
FIRST_FOOD_CODE TFOOD_CODE,
GUARANTEE_POLICY_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_LATE_DEPARTURE INTEGER,
EATING_OBJECT_ID INTEGER,
DEFAULT_GUEST_MASK VARCHAR(10))
 AS
declare variable arrival_date_def date;
  declare variable departure_date_def date;
  declare variable adult_count_def integer;
  declare variable child_count_def integer;
  declare variable id_room_def integer;
  declare variable custom_price_def numeric(15,4);
  declare variable custom_currency_def char(3);
  declare variable voucher_num_def varchar(30);
  declare variable voucher_date_def date;
  declare variable voucher_text_def varchar(30);
  declare variable voucher2_num_def varchar(30);
  declare variable voucher2_date_def date;
  declare variable transfer_in_time_def timestamp;
  declare variable transfer_in_note_def varchar(30);
  declare variable transfer_out_time_def timestamp;
  declare variable transfer_out_note_def varchar(30);
  declare variable is_late_departure_def integer;
  declare variable country_code_def varchar(20);
  declare variable check_status_def integer;
  declare variable id_acc_template_person_def integer;
  declare variable arranger_marketing1_id integer;
  declare variable arranger_rate_id integer;
  declare variable arranger_maintance_shema_id integer;
  declare variable deposit_def numeric(15,4);
  declare variable deposit_currency_def char(3);
  declare variable group_name_old varchar(50);
  declare variable group_uuid_old varchar(40);
begin
  if (:booking_dbkey is null) then begin
    execute procedure RES_CREATE_GET$RSV (:hotel_id)
    returning_values
      :arrival_date_def,
      :departure_date_def,
      :arranger_profile_id,
      :main_guest_profile_id,
      :adult_count_def,
      :child_count_def,
      :room_type_id,
      :id_room_def,
      :board_id,
      :rate_id,
      :custom_price_def,
      :custom_currency_def,
      :voucher_num_def,
      :voucher_date_def,
      :voucher_text_def,
      :voucher2_num_def,
      :voucher2_date_def,
      :transfer_in_time_def,
      :transfer_in_note_def,
      :transfer_out_time_def,
      :transfer_out_note_def,
      :is_late_departure_def,
      :first_food_code,
      :country_code_def,
      :marketing1_id,
      :marketing2_id,
      :marketing3_id,
      :marketing4_id,
      :marketing5_id,
      :arranger_account_id,
      :posting_routing,
      :guest_payment_type_id,
      :arranger_payment_type_id,
      :check_status_def,
      :maintance_shema_id,
      :deposit_def,
      :deposit_currency_def,
      :id_acc_template_person_def,
      :guarantee_policy_id,
      :eating_object_id,
      :DEFAULT_GUEST_MASK;
  end else begin
    select RD.id_rate, rd.id_room_type, rd.id_board, rd.id_hk_plan,
      rd.id_agent_payment, rd.id_person_payment, rd.id_nom_market_segment,
      rd.id_nom_source_code, rd.id_nom_channel_code, rd.id_nom_hear_reason,
      rd.id_nom_come_reason, rd.id_agent_profile, rd.id_person_profile,
      rd.acc_routing, rd.id_agent_account_rule, rd.code_first_food,
      rd.id_guarantee_policy, rg.group_name, rg.uuid, (rd.leaving_kind - 1) as is_late_departure
    from   RESERV_DETAIL RD
    left outer join reserv_group rg on rg.id_reserv_group=rd.id_group
    where  RD.RDB$DB_KEY = :booking_dbkey
    into  :rate_id, :room_type_id, :board_id, :maintance_shema_id,
      :arranger_payment_type_id, :guest_payment_type_id, :marketing1_id,
      :marketing2_id, :marketing3_id, :marketing4_id,
      :marketing5_id, :arranger_profile_id, :main_guest_profile_id,
      :posting_routing, :arranger_account_id, :first_food_code,
      :guarantee_policy_id, :group_name_old, :group_uuid_old, :is_late_departure_def;
  end

  /* MERGE ARRANGER PROFILE VALUE  */
  arranger_profile_id = coalesce(:arranger_profile_id_in, :arranger_profile_id);
  posting_routing = coalesce(:posting_routing_in, :posting_routing);

  /* APPLY ARRANGER DEFAULTS TO NEW BOOKINGS */
  if ((:booking_dbkey is null) and (:arranger_profile_id is not null)) then begin
    select p.id_nom_market_segment,
           (select min(id_tariff)
            from profile_hotel_rate aa
            where aa.id_hotel=:hotel_id and aa.id_profile = p.ID_PROFILE
            group by aa.id_profile
            having count(aa.id_profile)=1) as rate_id,
           pbd.ID_HK_PLAN
    from   profile p
    left outer join PROFILE_BOOKING_DEFAULTS pbd on pbd.ID_PROFILE = p.id_profile and pbd.ID_HOTEL = :hotel_id
    where p.id_profile=:arranger_profile_id
    into :arranger_marketing1_id, :arranger_rate_id, :arranger_maintance_shema_id;
    
    marketing1_id = coalesce(:arranger_marketing1_id, :marketing1_id);
    rate_id = coalesce(:arranger_rate_id, :rate_id);
    maintance_shema_id = coalesce(:arranger_maintance_shema_id, :maintance_shema_id);

    if (upper(:posting_routing) in ('AGENT', 'MIXED')) then begin
      select first 1 a.id_account
      from account a
      where
        a.id_profile = :arranger_profile_id
        and a.id_hotel=:hotel_id
        and a.is_credit_account=1
        and a.is_default=1
      into :arranger_account_id;
    end
  end

  /* MERGE THE REST OF THE *_IN VALUES */
  rate_id = coalesce(:rate_id_in, :rate_id);
  room_type_id = coalesce(:room_type_id_in, :room_type_id);
  board_id = coalesce(:board_id_in, :board_id);
  maintance_shema_id = coalesce(:maintance_shema_id_in, :maintance_shema_id);
  arranger_payment_type_id = coalesce(:arranger_payment_type_id_in, :arranger_payment_type_id);
  guest_payment_type_id = coalesce(:guest_payment_type_id_in, :guest_payment_type_id);
  marketing1_id = coalesce(:marketing1_id_in, :marketing1_id);
  marketing2_id = coalesce(:marketing2_id_in, :marketing2_id);
  marketing3_id = coalesce(:marketing3_id_in, :marketing3_id);
  marketing4_id = coalesce(:marketing4_id_in, :marketing4_id);
  marketing5_id = coalesce(:marketing5_id_in, :marketing5_id);
  main_guest_profile_id = coalesce(:main_guest_profile_id_in, :main_guest_profile_id);
  first_food_code = coalesce(:first_food_code_in, :first_food_code);
  guarantee_policy_id = coalesce(:guarantee_policy_id_in, :guarantee_policy_id);
  group_name = coalesce(:group_name, :group_name_old);
  group_uuid = coalesce(:group_uuid, :group_uuid_old);
  is_late_departure = coalesce(:is_late_departure_in, :is_late_departure_def);
  eating_object_id = coalesce(:eating_object_id_in, :eating_object_id);

  execute procedure sys_dbg('exc DEFAULT_BOOKING_VALUES$EXC => IMPORT_GROUP$EXC');
  execute procedure IMPORT_GROUP$EXC(:hotel_id, :group_uuid, :group_name)
  returning_values :reserv_group_id;
end
^

/* Restore proc. body: DEPOSIT_ANUL$DOC */
ALTER PROCEDURE DEPOSIT_ANUL$DOC(ID_DEPOSIT INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_PAYMENT_HEAD INTEGER)
 AS
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_ANUL');

  execute procedure DEPOSIT_ANUL$INT (:ID_DEPOSIT, :DESCRIPTION)
  returning_values :ID_PAYMENT_HEAD;

end
^

/* Restore proc. body: DEPOSIT_ANUL$INT */
ALTER PROCEDURE DEPOSIT_ANUL$INT(ID_DEPOSIT INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_PAYMENT_HEAD INTEGER)
 AS
declare variable id_doc_head integer;
  declare variable id_account integer;
  declare variable deposit_init_amount numeric(15,4);
  declare variable avail_value numeric(15,4);
  declare variable pay_currency varchar(3);
  declare variable payment_date date;
  declare variable dep_current_value numeric(15,4);
  declare variable sys_date date;
  declare variable id_hotel integer;
begin
  select D.ID_PAYMENT_HEAD, D.ID_ACCOUNT, P.PAY_VALUE_A, P.PAYMENT_DATE,
         D.RECEIVED_AMOUNT - d.DEDUCTED_AMOUNT as AVAIL_VALUE, D.ID_DOC_HEAD,
         D.PAY_CURRENCY, D.RECEIVED_AMOUNT
  from   DEPOSITS D
         join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_payment_head, :id_account, :deposit_init_amount, :payment_date,
         :avail_value, :id_doc_head, :pay_currency, :dep_current_value;

  if ((:dep_current_value is null) or (:dep_current_value < :deposit_init_amount)) then
    exception PAYMENT_ANNUL_EXCEPTION '-369';
    --'Part of deposit is refunded or transfered';

  if ((:avail_value is null) or (:avail_value < :deposit_init_amount)) then
    exception PAYMENT_ANNUL_EXCEPTION '-350';
    --'Part of deposit is used into document.';

  if (:id_doc_head is not null) then
    exception PAYMENT_ANNUL_EXCEPTION '-351';
    --'Can not storno deposit, because has invoice for it. First - storno invoice.';

  select A.ID_HOTEL
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :id_hotel;

  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) SD
  into   :SYS_DATE;

  if (:sys_date > :payment_date) then
    exception PAYMENT_ANNUL_EXCEPTION '-349';
    -- Can not void deposit payment for previous date ! May refund it! It's very important for payments control!!!

  execute procedure PAYMENT_ANUL$INT (:ID_PAYMENT_HEAD, :DESCRIPTION);

  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'ANNUL', f_character(29) || formatfloat(:deposit_init_amount, 'F;0.00') || ' ' || :PAY_CURRENCY || f_character(28) || :DESCRIPTION);

end
^

/* Restore proc. body: DEPOSIT_NEW$DOC */
ALTER PROCEDURE DEPOSIT_NEW$DOC(ID_ACCOUNT INTEGER,
ID_DOC_TYPE INTEGER,
PAY_VALUE NUMERIC(15,4),
PAY_CURRENCY VARCHAR(3),
DESCRIPTION VARCHAR(100),
ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_DEPOSIT INTEGER,
ID_PAYMENT_HEAD INTEGER)
 AS
declare variable pay_rate numeric(15,6);
  declare variable payment_date date;
  declare variable is_taxable smallint;
  declare variable id_profile integer;
  declare variable dbkey char(8);
  declare variable acc_curr varchar(3);
  declare variable acc_rate numeric(15,6);
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable id_account_payment integer;
  declare variable is_posting_stopped integer;
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_NEW');

  select r.IS_POSTING_STOPPED
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :is_posting_stopped;

  if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';

  select A.ID_PROFILE, A.ACCOUNT_CURR, A.ID_HOTEL
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :id_profile, :acc_curr, :id_hotel;

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values  (:payment_date);

  execute procedure CURR_RATE_GET (:acc_curr, :payment_date, :id_hotel)
  returning_values  (:acc_rate);

  execute procedure CURR_RATE_GET (:PAY_CURRENCY, :payment_date, :id_hotel)
  returning_values  (:pay_rate);

  execute procedure PAYMENT_CREATE$INT (:ID_DOC_TYPE, :ID_ACCOUNT, :payment_date,
                    :PAY_VALUE, :PAY_CURRENCY, :pay_rate,
                    :acc_curr, :acc_rate, :DESCRIPTION)
  returning_values  :id_payment_head, :id_account_payment, :is_taxable;

  ID_DEPOSIT = gen_id(GEN_DEPOSITS_ID, 1);
  insert into DEPOSIT (ID_DEPOSIT, DESCRIPTION, ID_ACCOUNT, ID_PAYMENT_HEAD, ID_PROFILE, ID_RESERV_DETAIL)
  values (:ID_DEPOSIT, :DESCRIPTION, :ID_ACCOUNT, :ID_PAYMENT_HEAD, :id_profile, :id_reserv_detail);

  select PH.RDB$DB_KEY
  from   PAYMENT_HEAD PH
  where  PH.ID_PAYMENT_HEAD = :id_payment_head
  into   :dbkey;

  update PAYMENT_HEAD P
  set    p.ID_DEPOSIT = :ID_DEPOSIT
  where  p.RDB$DB_KEY = :dbkey;

  update ACCOUNT_PAYMENTS AP
  set    AP.ID_DEPOSIT = :ID_DEPOSIT
  where  ap.ID_ACCOUNT_PAYMENT = :id_account_payment;

  execute procedure PAYMENT_SET_NUMBER$INT(:dbkey);

  action_text = f_character(29) || formatfloat(:PAY_VALUE, 'F;0.00') || ' ' || :PAY_CURRENCY;
  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'CREATE', :action_text);

end
^

/* Restore proc. body: DEPOSIT_REFUND_PAY_ANNUL$INT */
ALTER PROCEDURE DEPOSIT_REFUND_PAY_ANNUL$INT(ID_REFUND_PAYMENT INTEGER,
ANNUL_REASON VARCHAR(255) = '')
 AS
declare variable id_deposit integer;
  declare variable pay_value numeric(15,4);
  declare variable pay_curr varchar(3);
  declare variable id_hotel integer;
  declare variable sys_date date;
  declare variable payment_date date;
begin
  select ap.ID_DEPOSIT, P.PAY_CURRENCY, a.ID_HOTEL, p.PAYMENT_DATE, coalesce(sum(aP.PAY_AMOUNT), 0)
  from   PAYMENT_HEAD P
         join ACCOUNT A on a.ID_ACCOUNT = p.ID_ACCOUNT
         join ACCOUNT_PAYMENTS ap on ap.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
  where  P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT
  group by P.ID_PAYMENT_HEAD, ap.ID_DEPOSIT, P.PAY_CURRENCY, a.ID_HOTEL, p.PAYMENT_DATE
  into   :id_deposit, :pay_curr, :id_hotel, :payment_date, :pay_value;
  /* !!! - check if is real deposit refund */
  if (:id_deposit is null) then EXIT;

  if (:pay_value = 0) then exception PAYMENT_EXCEPTION 'Zero payment amount!';
  /*  */
  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) SD
  into   :sys_date;

  if (:sys_date > :payment_date) then
    exception PAYMENT_ANNUL_EXCEPTION '-349';
    -- Can not void deposit payment for previous date ! May refund it! It's very important for payments control!!!

  execute procedure PAYMENT_ANUL$INT(:ID_REFUND_PAYMENT, :ANNUL_REASON);

  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'REFUND_ANNUL', f_character(29) || formatfloat(:pay_value, 'F;0.00') || ' ' || :pay_curr || f_character(28) || :ANNUL_REASON);

end
^

/* Restore proc. body: DEPOSIT_TRANSFER$ACC */
ALTER PROCEDURE DEPOSIT_TRANSFER$ACC(ID_DEPOSIT INTEGER,
ID_DEST_ACCOUNT INTEGER,
SPLIT_AMOUNT NUMERIC(15,2),
DESCRIPTION VARCHAR(255))
 RETURNS(NEW_ID_DEPOSIT INTEGER)
 AS
begin
  /* Fasade with rights check */
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_TRANSFER');

  execute procedure DEPOSIT_TRANSFER$INT (:ID_DEPOSIT, :ID_DEST_ACCOUNT, :SPLIT_AMOUNT, :DESCRIPTION)
  returning_values (:NEW_ID_DEPOSIT);
end
^

/* Restore proc. body: DEPOSIT_TRANSFER$INT */
ALTER PROCEDURE DEPOSIT_TRANSFER$INT(ID_DEPOSIT TYPE OF ID,
ID_DEST_ACCOUNT TYPE OF ID,
SPLIT_AMOUNT TYPE OF TPRICE,
DEPOSIT_DESCRIPTION TYPE OF TDESCRIPTION_SHORT,
TRANSFER_REASON TYPE OF TREASON = null)
 RETURNS(NEW_ID_DEPOSIT TYPE OF ID)
 AS
declare variable id_source_account integer;
  declare variable id_payment_head integer;
  declare variable doc_selected integer;
  declare variable id_profile integer;
  declare variable orig_descr varchar(100);
  declare variable action_text varchar(255);
  declare variable pay_currency varchar(3);
  declare variable curr_dest varchar(3);
  declare variable curr_src varchar(3);
  declare variable pay_date date;
  declare variable dest_acc_rate numeric(15,6);
  declare variable src_acc_rate numeric(15,6);
  declare variable is_anul integer;
  declare variable sys_date date;
  declare variable id_reserv_detail integer;
  declare variable id_hotel integer;
  declare variable pay_rate numeric(15,6);
  declare variable id_account_payment_src integer;
  declare variable id_account_payment_dest integer;
  declare variable is_posting_stopped integer;
  declare variable id_system_log integer;
  declare variable id_billing_service integer;
begin

  select D.ID_ACCOUNT, D.ID_PAYMENT_HEAD, D.DOC_SELECTED, D.ID_PROFILE, D.DESCRIPTION,
         P.PAY_CURRENCY, P.IS_ANUL, P.PAYMENT_DATE, D.ID_RESERV_DETAIL, A.ID_HOTEL,
         p.PAY_RATE, d.ID_BILLING_SERVICE, a.ACCOUNT_CURR
  from   DEPOSIT D
         join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_source_account, :id_payment_head, :doc_selected, :id_profile, :orig_descr,
         :pay_currency, :is_anul, :pay_date, :id_reserv_detail, :id_hotel,
         :pay_rate, :id_billing_service, :curr_src;

  if (:is_anul = 1) then
    exception PAYMENT_EXCEPTION '-355'; -- payment is annul

  select r.IS_POSTING_STOPPED
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :is_posting_stopped;

  if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';

  if (not exists (select A.ID_ACCOUNT
                  from   ACCOUNT A
                  where  A.ID_ACCOUNT = :ID_DEST_ACCOUNT
                         and A.ID_HOTEL = :id_hotel)) then exception ACCOUNT_EXCEPTION '-376';

  if (coalesce(:DEPOSIT_DESCRIPTION, '') = '') then DEPOSIT_DESCRIPTION = :orig_descr;

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values :sys_date;

  select first 1 ap.ACC_RATE
  from   ACCOUNT_PAYMENTS ap
  where  ap.ID_PAYMENT_HEAD = :id_payment_head
         and ap.ID_ACCOUNT = :id_source_account
  order by ap.ID_ACCOUNT_PAYMENT asc
  into   :src_acc_rate;

  insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
         ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT)
  values (:id_source_account, :id_payment_head, -:SPLIT_AMOUNT, :pay_rate,
         -:SPLIT_AMOUNT * cast(:pay_rate / :src_acc_rate as double precision), :src_acc_rate,
         :sys_date, :ID_DEPOSIT)
  returning id_account_payment into :id_account_payment_src;

  NEW_ID_DEPOSIT = gen_id(GEN_DEPOSITS_ID, 1);
  insert into DEPOSIT (ID_DEPOSIT, DESCRIPTION, ID_ACCOUNT, ID_PAYMENT_HEAD, DOC_SELECTED, ID_PROFILE, ID_RESERV_DETAIL, ID_BILLING_SERVICE)
  values (:NEW_ID_DEPOSIT, :DEPOSIT_DESCRIPTION, :ID_DEST_ACCOUNT, :id_payment_head, :doc_selected, :id_profile, :id_reserv_detail, :id_billing_service);

  select A.ACCOUNT_CURR
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_DEST_ACCOUNT
  into   :curr_dest;
   
  if (:curr_dest is distinct from :curr_src) then begin
    execute procedure CURR_RATE_GET(:curr_dest, :pay_date, :id_hotel)
    returning_values  :dest_acc_rate;
  end else begin
    dest_acc_rate = :src_acc_rate;
  end

  insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
         ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT)
  values (:ID_DEST_ACCOUNT, :id_payment_head, :SPLIT_AMOUNT, :pay_rate,
         :SPLIT_AMOUNT * cast(:pay_rate / :dest_acc_rate as double precision), :dest_acc_rate,
         :sys_date, :NEW_ID_DEPOSIT)
  returning id_account_payment into :id_account_payment_dest;

  action_text = f_character(29) || :id_source_account ||
                f_character(28) || :id_dest_account ||
                f_character(28) || formatfloat(:split_amount, '0.00') || ' ' || :pay_currency ||
                f_character(28) || coalesce(:TRANSFER_REASON, '');
  execute procedure SYSTEM_EVENT_LOG$INT ('DEPOSIT', :ID_DEPOSIT, 'TRANSFER', :ACTION_TEXT)
  returning_values :id_system_log;

  insert into ACCOUNT_PAYMENT_TRANSFER (ID_ACCOUNT_PAYMENT_SOURCE, ID_ACCOUNT_PAYMENT_DEST, ID_SYSTEM_LOG)
  values (:id_account_payment_src, :id_account_payment_dest, :id_system_log);

end
^

/* Restore proc. body: DOC_INIT_FISCAL_STATUS$INT */
ALTER PROCEDURE DOC_INIT_FISCAL_STATUS$INT(ID_DOC_HEAD TYPE OF ID)
 AS
declare variable fisc_status integer;
begin
  if (exists (select d.ID_DOC
              from   DOC_HEAD d
                     join DOC_HEAD bd on bd.ID_DOC = d.ID_BASE_DOC
              where  d.ID_DOC = :ID_DOC_HEAD
                     and d.DOC_SUB_TYPE = 2
                     and bd.FISC_STATUS = 0)) then begin
    fisc_status = 0;
  end else if (exists (select ph.ID_PAYMENT_HEAD
              from   DOCUMENT_PAYMENT PH
                     join DOC_TYPE DT on DT.ID_DOC_TYPE = PH.ID_DOC_TYPE
                     join DOC_TYPE_PAY DTP on DTP.ID_DOC_TYPE = DT.ID_DOC_TYPE
              where  PH.ID_DOC_HEAD = :ID_DOC_HEAD
                     and dtp.IS_FISC = 1
                     --and DTP.DOC_DIRECTION = 0
                     --and PH.IS_STORNO = 0
                     )) then begin
    fisc_status = 1;
  end else begin
    fisc_status = 0;
  end

  update DOC_COMPLETION Dc
  set    Dc.FISC_STATUS = :fisc_status
  where  Dc.ID_DOC_HEAD = :ID_DOC_HEAD;
end
^

/* Restore proc. body: DOC_TYPE_INV_MODIFY$DOC */
ALTER PROCEDURE DOC_TYPE_INV_MODIFY$DOC(ID_DOC_TYPE INTEGER,
DOC_TYPE_NAME VARCHAR(50),
DEBIT_DOC_NAME VARCHAR(50),
CREDIT_DOC_NAME VARCHAR(50),
ANNUL_PROTOCOL_NAME VARCHAR(50),
EXPORT_TAG VARCHAR(20),
DEBIT_EXPORT_TAG VARCHAR(20),
CREDIT_EXPORT_TAG VARCHAR(20),
ANNUL_EXPORT_TAG VARCHAR(20),
DOC_CURR CHAR(3),
PRINT_ORIGINAL SMALLINT,
RAPORT_NAME VARCHAR(50),
DESCRIPTION VARCHAR(100),
IS_VAT SMALLINT,
PRINT_ANNUL_REPORT_CLASS VARCHAR(50),
IS_ARCHIVE SMALLINT,
REQUIRED_IDENT_NO SMALLINT,
REQUIRED_VAT_NO SMALLINT,
REQUIRED_EGN SMALLINT,
REQUIRED_RECIPIENT_NAME TYPE OF TLOGICAL,
OPERATION VARCHAR(10),
ID_HOTEL TYPE OF ID,
ID_DOC_NUM TYPE OF ID_REF,
ID_ANNUL_DOC_NUM TYPE OF ID_REF,
SECOND_CURRENCY CHAR(3) = null,
CURRENCY_LIST VARCHAR(1000) = null,
PAY_DOC_TYPE_RESTRICT_LIST VARCHAR(1000) = null,
ID_PROFORMA_NUM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_DOC_TYPE INTEGER)
 AS
declare variable is_use integer;
  declare variable old_is_vat integer;
  declare variable old_id_doc_num integer;
  declare variable old_doc_name varchar(50);
  declare variable is_num_used integer;
  declare variable id_pay_doc_type integer;
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  select DT.DOC_TYPE_NAME, DT.IS_VAT, DT.ID_DOC_NUM
  from   DOC_TYPE DT
         join DOC_TYPE_INV I on I.ID_DOC_TYPE = DT.ID_DOC_TYPE
  where  DT.ID_DOC_TYPE = :ID_DOC_TYPE
  into   :old_doc_name, :old_is_vat, :old_id_doc_num;

  if (:operation = 'mod') then begin
    /* doc_type exists */
    if ((:old_doc_name <> :doc_type_name)
        or (:old_is_vat <> :IS_VAT)
        or (:old_id_doc_num is distinct from :ID_DOC_NUM) ) then
    begin
      execute procedure DOC_TYPE_CHECK_USED (:ID_DOC_TYPE)
      returning_values  :is_use;
      if (:is_use = 1) then exception DOC_TYPE_EXCEPTION '-360';
    end
  end

  if (:OPERATION <> 'del') then begin
    select max(DT.ID_DOC_TYPE)
    from   DOC_TYPE DT
           join DOC_TYPE_PAY DTP on DTP.ID_DOC_TYPE = DT.ID_DOC_TYPE
    where  DT.ID_DOC_NUM = :id_doc_num
    into   :is_num_used;
    if (:is_num_used is not null) then exception DOC_TYPE_EXCEPTION '-358';
  end

  execute procedure DOC_TYPE_MODIFY$INT (:id_doc_type, :doc_type_name,
          :doc_curr, :raport_name, :description, :export_tag, :is_vat,
          0, :print_original, :is_archive, :ID_HOTEL,
          :id_doc_num, :id_annul_doc_num, :currency_list, :operation)
  returning_values  :new_id_doc_type;

  if (:OPERATION = 'add') then begin
    insert into DOC_TYPE_INV (ID_DOC_TYPE,
           DEBIT_DOC_NAME, DEBIT_EXPORT_TAG, CREDIT_DOC_NAME, CREDIT_EXPORT_TAG,
           ANNUL_PROTOCOL_NAME, ANNUL_EXPORT_TAG, PRINT_ANNUL_REPORT_CLASS,
           REQUIRED_IDENT_NO, REQUIRED_VAT_NO, REQUIRED_EGN, REQUIRED_RECIPIENT_NAME,
           SECOND_CURRENCY, ID_PROFORMA_NUM)
    values (:new_id_doc_type,
           :debit_doc_name, :debit_export_tag, :credit_doc_name, :credit_export_tag,
           :annul_protocol_name, :annul_export_tag, :print_annul_report_class,
           :required_ident_no, :required_vat_no, :required_egn, :required_recipient_name,
           :second_currency, :id_proforma_num);
  end else if (:OPERATION = 'mod') then begin
    update DOC_TYPE_INV DTI
    set    DTI.DEBIT_DOC_NAME = :debit_doc_name,
           DTI.DEBIT_EXPORT_TAG = :debit_export_tag,
           DTI.CREDIT_DOC_NAME = :credit_doc_name,
           DTI.CREDIT_EXPORT_TAG = :credit_export_tag,
           DTI.ANNUL_PROTOCOL_NAME = :annul_protocol_name,
           DTI.ANNUL_EXPORT_TAG = :annul_export_tag,
           DTI.PRINT_ANNUL_REPORT_CLASS = :print_annul_report_class,
           DTI.REQUIRED_IDENT_NO = :required_ident_no,
           DTI.REQUIRED_VAT_NO = :required_vat_no,
           DTI.REQUIRED_EGN = :required_egn,
           DTI.REQUIRED_RECIPIENT_NAME = :required_recipient_name,
           DTI.SECOND_CURRENCY = :second_currency,
           dti.ID_PROFORMA_NUM = :ID_PROFORMA_NUM
    where  DTI.ID_DOC_TYPE = :ID_DOC_TYPE;
  end

  if (:OPERATION <> 'del') then begin
    delete from DOC_TYPE_PAY_RESTRICT dtp
    where  dtp.ID_DOC_TYPE = :NEW_ID_DOC_TYPE;
    -- PAY_DOC_TYPE_RESTRICTED - comma separated ids
    for
      select sp.ITEM
      from   SYSTEM_STRING_PARSER (:PAY_DOC_TYPE_RESTRICT_LIST) sp
      into   :id_pay_doc_type
    do begin
      insert into DOC_TYPE_PAY_RESTRICT (ID_DOC_TYPE, ID_PAY_DOC_TYPE)
      values (:new_id_doc_type, :id_pay_doc_type);
    end 
  end
end
^

/* Restore proc. body: DOCUMENT_ADVANCE_PAYMENT$INT */
ALTER PROCEDURE DOCUMENT_ADVANCE_PAYMENT$INT(ID_DOC_HEAD INTEGER,
ID_PAYMENT_HEAD INTEGER,
ACC_RATE NUMERIC(15,6))
 AS
declare variable id_deposit integer;
  declare variable dep_curr varchar(3);
  declare variable pay_rate numeric(15,6);
  declare variable id_doc_line integer;
  declare variable doc_value numeric(15,4);
  declare variable init_pay_value numeric(15,4);
  declare variable deducted_value numeric(15,4);
  declare variable pay_round_to numeric(15,4);
  declare variable id_account_payment integer;
  declare variable initial_deposit_id integer;
  declare variable pay_value numeric(15,4);
  declare variable total_pay_value numeric(15,4);
  declare variable total_doc_value numeric(15,4);
  declare variable id_dep_doc integer;
begin
  total_pay_value = 0;
  total_doc_value = 0;
  for
    select D.ID_DEPOSIT, D.PAY_CURRENCY, d.INIT_PAY_AMOUNT, d.DEDUCTED_AMOUNT, d.ID_DOC_HEAD
    from   DEPOSITS D
    where  d.ID_PAYMENT_HEAD = :id_payment_head
    order by d.ID_DEPOSIT asc
    into   :id_deposit, :dep_curr, :init_pay_value, :deducted_value, :id_dep_doc
  do begin
    initial_deposit_id = coalesce(:initial_deposit_id, :id_deposit);
    if (coalesce(:deducted_value, 0) > 0) then
      exception DOCUMENT_EXCEPTION '-350';

    if (:id_dep_doc is not null) then
      exception DOCUMENT_EXCEPTION '-364';

    if (:pay_rate is null) then
      execute procedure DOCUMENT_CURR_RATE_GET$INT (:ID_DOC_HEAD, :dep_curr)
      returning_values  (:pay_rate, :pay_round_to);
    /*
    if (round_f(:dep_value, :pay_round_to) <= 0) then
      exception DOCUMENT_EXCEPTION 'Unavailable payment amount!';
    */
    update ACCOUNT_PAYMENTS AP
    set    AP.ACC_AMOUNT = AP.PAY_AMOUNT * cast(:pay_rate / :acc_rate as double precision),
           Ap.ACC_RATE  = :acc_rate
    where  AP.ID_DEPOSIT = :id_deposit;

    select min(ap.ID_ACCOUNT_PAYMENT), sum(ap.PAY_AMOUNT)
    from   ACCOUNT_PAYMENTS AP
    where  AP.ID_DEPOSIT = :id_deposit
    into   :id_account_payment, :pay_value;
    total_pay_value = :total_pay_value + :pay_value;

    execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:ID_DOC_HEAD, :id_account_payment, :pay_rate, :pay_value)
    returning_values (:doc_value);
    total_doc_value = :total_doc_value + :doc_value;
  end

  if (:total_pay_value <> 0) then begin
    if (round_f(:total_pay_value - :init_pay_value, :pay_round_to) <> 0) then
      exception DOCUMENT_EXCEPTION '-390' || f_character(31)
                || f_character(29) || formatfloat(:total_pay_value, 'F;0.00')
                || f_character(28) || formatfloat(:init_pay_value, 'F;0.00');
  
    execute procedure DOCUMENT_ADD_PAYMENT_LINE$INT (:initial_deposit_id, :ID_DOC_HEAD, :total_doc_value)
    returning_values  (:id_doc_line);

    update PAYMENT_HEAD P
    set    P.ID_DOC_HEAD = :ID_DOC_HEAD
    where  P.ID_PAYMENT_HEAD = :id_payment_head;
  end
end
^

/* Restore proc. body: DOCUMENT_ATTACH_AVAIL_PAYS$INT */
ALTER PROCEDURE DOCUMENT_ATTACH_AVAIL_PAYS$INT(ID_DOC_HEAD INTEGER,
ID_ACCOUNT INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_deposit integer;
  declare variable pay_curr varchar(3);
  declare variable dep_value numeric(15,4);
  declare variable rest_value numeric(15,4);
begin

  for
    select D.ID_DEPOSIT, D.PAY_CURRENCY, D.AVAIL_VALUE
    from   DEPOSIT_AVAILABLE D
    where  D.ID_ACCOUNT = :ID_ACCOUNT
    order by D.DATETIME_CREATED asc
    into   :ID_DEPOSIT, :PAY_CURR, :DEP_VALUE
  do begin

    execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, :PAY_CURR)
    returning_values  (:dbg, :dbg, :dbg, :dbg, :REST_VALUE);

    if (:REST_VALUE > 0) then begin
      DEP_VALUE = iif(:DEP_VALUE > :REST_VALUE, :REST_VALUE, :DEP_VALUE);
      execute procedure DOCUMENT_USE_DEPOSIT$DOC (:ID_DOC_HEAD, :ID_DEPOSIT, :DEP_VALUE);

   end else begin
      exit;
    end

    when exception DOCUMENT_EXCEPTION do post_event 'dummy';
  end

end
^

/* Restore proc. body: DOCUMENT_CLEAR_DEPOSITS$DOC */
ALTER PROCEDURE DOCUMENT_CLEAR_DEPOSITS$DOC(ID_DOC_HEAD INTEGER)
 AS
declare variable is_storno_doc smallint;
begin

  execute procedure DOCUMENT_REUSE_DEPOSITS$INT (:ID_DOC_HEAD, null);

end
^

/* Restore proc. body: DOCUMENT_GET_VALUE$INT */
ALTER PROCEDURE DOCUMENT_GET_VALUE$INT(ID_DOC_HEAD INTEGER,
TARGET_CURR VARCHAR(3),
TARGET_RATE NUMERIC(15,6) = null)
 RETURNS(ID_PAY_DOC_DEF INTEGER,
TOTAL_CURR VARCHAR(3),
TOTAL_RATE NUMERIC(15,6),
TOTAL_VALUE NUMERIC(15,4),
PAYABLE_VALUE NUMERIC(15,4))
 AS
declare variable doc_curr varchar(3);
  declare variable doc_round_to numeric(15,4);
  declare variable target_round_to numeric(15,4);
  declare variable doc_rate numeric(15,6);
  declare variable pays_value numeric(15,4);
  declare variable used_dep_value numeric(15,4);
  declare variable ded_dep_value numeric(15,4);
  declare variable discounts numeric(15,4);
  declare variable is_dep_doc integer;
  declare variable id_account integer;
  declare variable doc_sub_type integer;
  declare variable dummy varchar(255);
  declare variable doc_value_a numeric(15,4);
  declare variable total_value_int numeric(15,4);
begin
  select d.DOC_VALUE_ROUNDLESS, d.DOC_VALUE_A,
         D.DOC_CURRENCY, D.DOC_RATE, D.FOR_DEPOSIT, D.ID_ACCOUNT, D.DOC_SUB_TYPE, c.ROUND_TO
  from   DOC_HEAD$INT D
         join DOC_TYPE DT on DT.ID_DOC_TYPE = D.ID_DOC_TYPE
         join CURRS c on C.CURR = d.DOC_CURRENCY
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :total_value_int, :doc_value_a,
         :doc_curr, :doc_rate, :is_dep_doc, :id_account, :doc_sub_type, :doc_round_to;
   
  if (cast(round_f(:total_value_int, :doc_round_to) as numeric(15,4)) <> :doc_value_a) then total_value_int = :doc_value_a;

  select sum(round_f(DD.FOOTER_VALUE, :doc_round_to))
  from   DOC_FOOTER DD
  where  DD.ID_DOC_HEAD = :ID_DOC_HEAD
         and DD.ID_DOC_LINE is null
  into   :discounts;

  select sum(round_f(P.DOC_AMOUNT, :doc_round_to))
  from   DOC_PAY_USAGE P
  where  P.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :pays_value;
  /*  */
  ded_dep_value = 0;  used_dep_value = 0;
  if (:is_dep_doc = 0) then begin
    select sum(round_f(DL.SINGLE_VALUE * DL.QTY_POST, :doc_round_to))
    from   DOC_LINE DL
           join DOC_LINE_DEP_VALUES DV on DV.ID_DOC_LINE = DL.ID_DOC_LINE
    where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
    into   :ded_dep_value;
  end

  PAYABLE_VALUE = :total_value_int
                  - coalesce(:ded_dep_value, 0)
                  - coalesce(:pays_value, 0)
                  - coalesce(:used_dep_value, 0)
                  + coalesce(:discounts, 0);

  if (:TARGET_CURR is null) then begin
    TOTAL_CURR = :doc_curr;
    TARGET_RATE = :doc_rate;
    target_round_to = :doc_round_to;
  end else begin
    TOTAL_CURR = :TARGET_CURR;
    if (:TARGET_RATE is null) then begin
      execute procedure DOC_GET_CURR_RATE$DOC (:ID_DOC_HEAD, :TOTAL_CURR)
      returning_values  (:TARGET_RATE);
    end

    select C.ROUND_TO
    from   CURRS C
    where  C.CURR = :TOTAL_CURR
    into   :target_round_to;
  end

  TOTAL_RATE = :TARGET_RATE;
  if (:TARGET_RATE = :doc_rate) then begin
    TOTAL_VALUE = round_f(:total_value_int, :target_round_to);
  end else begin
    TOTAL_VALUE = round_f(:total_value_int * cast(:doc_rate / :TARGET_RATE as double precision), :target_round_to);
  end

  if ((round_f(:PAYABLE_VALUE, :doc_round_to) = 0) or (cast(abs(:PAYABLE_VALUE) as numeric(15,4)) = :doc_round_to/2)) then begin
    PAYABLE_VALUE = 0;
  end else if (:TARGET_RATE = :doc_rate) then begin
    PAYABLE_VALUE = round_f(:PAYABLE_VALUE, :target_round_to);
  end else begin
    PAYABLE_VALUE = round_f(:PAYABLE_VALUE * cast(:doc_rate / :TARGET_RATE as double precision), :target_round_to);
  end

  if (:doc_sub_type < 2) then begin
    execute procedure PAYMENT_GET_DEFAULT$INT (:id_account)
    returning_values  (:ID_PAY_DOC_DEF, :dummy);
  end

  suspend;
end
^

/* Restore proc. body: DOCUMENT_SALE_NUMBER_SET */
ALTER PROCEDURE DOCUMENT_SALE_NUMBER_SET(ID_DOC_HEAD TYPE OF ID,
CREATED_AT TYPE OF TDATETIME = current_timestamp)
 RETURNS(ID_SALE_NUM TYPE OF ID)
 AS
declare variable unique_sales_number varchar(50);
begin
  select d.ID_SALE_NUM
  from   DOC_HEAD D
         join ACCOUNT a on a.ID_ACCOUNT = d.ID_ACCOUNT
  where  d.ID_DOC = :ID_DOC_HEAD
  into   :id_sale_num;

  if (:id_sale_num is null) then begin
    execute procedure UNIQUE_SALES_NUMBER_GEN
    returning_values (:UNIQUE_SALES_NUMBER);
  
    insert into SALE_NUM (UNIQUE_SALES_NUMBER, CREATED_AT)
    values (:UNIQUE_SALES_NUMBER, :CREATED_AT)
    returning id_sale_num into :id_sale_num;
  
    update DOC_COMPLETION dc
    set    dc.ID_SALE_NUM = :id_sale_num
    where  dc.ID_DOC_HEAD = :ID_DOC_HEAD;
  end
end
^

/* Restore proc. body: DOCUMENT_SET_NUMBER$INT */
ALTER PROCEDURE DOCUMENT_SET_NUMBER$INT(DH_DBKEY TYPE OF TDB_KEY)
 RETURNS(NUM TYPE OF TRANGE,
DOC_NUM VARCHAR(20))
 AS
declare variable id_doc_num integer;
  declare variable id_doc_completed integer;
  declare variable pay_dbkey char(8);
begin

  select D.ID_DOC_NUM, dc.ID_DOC_HEAD
  from   DOC_HEAD$INT D
         left outer join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
  where  D.RDB$DB_KEY = :DH_DBKEY
  into   :id_doc_num, :id_doc_completed;

  if (:id_doc_num is not null) then begin
    if (:id_doc_completed is not null) then begin
      execute procedure SYSTEM_GEN_NUM ('DOCUMENT', :id_doc_num)
      returning_values  (:num, :doc_num);
    end else begin
      execute procedure SYSTEM_GEN_NUM ('PROFORMA', :id_doc_num)
      returning_values  (:num, :doc_num);
    end

    update DOC_HEAD$INT D
    set    D.NUM = :num,
           D.DOC_NUM = :doc_num,
           d.DATETIME_CREATED = current_timestamp -- moves created_at to finalization timestamp
    where  D.RDB$DB_KEY = :DH_DBKEY;
  end

  for
    select PH.RDB$DB_KEY
    from   PAYMENT_HEAD PH
    where  PH.ID_DOC_HEAD = :id_doc_completed
           and PH.NUM is null  /* because of following deposit billing */
    into   :pay_dbkey
  do begin
    execute procedure PAYMENT_SET_NUMBER$INT (:pay_dbkey);
  end
end
^

/* Restore proc. body: EAI_AIRCONDITION_SMARTSTART */
ALTER PROCEDURE EAI_AIRCONDITION_SMARTSTART AS
declare variable id_reserv_detail integer;
begin
  for
    select RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.FROM_DATE = current_date
           and RD.IS_ANUL = 0
           and RD.CHECK_STATUS < 0
           and RD.ID_ROOM > 0
    into   :id_reserv_detail
  do begin
    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'AC.SMARTSTART', '');
  end
end
^

/* Restore proc. body: EAI_EVENTQ_ADD */
ALTER PROCEDURE EAI_EVENTQ_ADD(EAI_IFC VARCHAR(50),
EVENT_CODE VARCHAR(50),
OBJECT_ID INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_first_pushedback integer;
  declare variable m_dbkey char(8);
begin

  execute procedure SYSTEM_LOG_ADD ('EAI_EVENTQ', :object_id, :event_code, :eai_ifc);
end
^

/* Restore proc. body: EAI_MAP_SERVICE */
ALTER PROCEDURE EAI_MAP_SERVICE(SERVICE_TAG VARCHAR(30),
SERVICE_NAME VARCHAR(30),
EXTERNAL_IFC VARCHAR(30),
ID_HOTEL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_MAPPED_SERVICE INTEGER)
 AS
declare variable id_service_group integer;
  declare variable setting_code varchar(30);
  declare variable revenue_group varchar(30);
  declare variable is_base integer;
  declare variable is_deleted integer;
  declare variable hotel_name varchar(50);
begin
  /*  Description:
  ||
  */
  err_code = 0;
  err_text = '';
  id_mapped_service = null;
  select first 1 S.ID_SERVICE, S.IS_BASE, s.IS_DELETED
  from   SERVICES S
  where  S.EXT_CODE = :service_tag
         and s.ID_HOTEL = :id_hotel
  order by s.IS_DELETED asc, s.ID_SERVICE asc
  into   :id_mapped_service, :is_base, :is_deleted;

  if (:is_base = 1) then begin
    ERR_CODE = -63;
    ERR_TEXT= '';
    exit;
  end
  if (:is_deleted = 1) then begin
    ERR_CODE = -64;
    ERR_TEXT= '';
    exit;
  end
  if (:id_mapped_service is not null) then exit;

  if (:external_ifc = 'POS') then revenue_group = 'Food and Beverage';
  else revenue_group = 'Other Operated departments';

  setting_code = 'IFC_'||:external_ifc||'_SRVGRP';
  execute procedure SETTING_GET_VALUE(:setting_code, :ID_HOTEL)
  returning_values  :id_service_group;

  begin
    execute procedure SERVICE_MODIFY(null, :id_service_group, 'EXTRA', :service_name, 0, 1, 0,
                      :revenue_group, null, null, :service_tag, 'BASE', '', 0, 'add', :ID_HOTEL,
                      0, 0, 0, 0, 0, 0, null, null)
    returning_values  :id_mapped_service;
  
    when sqlcode -803 do begin
      -- catch SERVICE_NAME_UNQ_HASH unique index exception
      select h.HOTEL_NAME
      from   HOTEL h
      where  h.ID_HOTEL = :ID_HOTEL
      into   :hotel_name;
  
      err_code = -68;
      err_text = f_character(29) || :SERVICE_NAME || f_character(28) || :hotel_name;
      exit;
    end
  end
end
^

/* Restore proc. body: EAI_RES_CHECK_OUT_FAST */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
declare variable selection_id integer;
  declare variable is_early_check_out smallint;
  declare variable early_check_out_dep_date date;
  declare variable check_out_date date;
begin
  selection_id = gen_id(selection_gen, 1);

  update RESERV_DETAIL RD
  set RD.SELECTION_ID = :SELECTION_ID
  where RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL;

  execute procedure RES_CHECK_OUT_CHECK$RSV(:selection_id)
  returning_values :is_early_check_out, :early_check_out_dep_date, :check_out_date;

  if (:is_early_check_out = 1) then
    exception BOOKING_EXCEPTION '-1043';

  execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, 0);
end
^

/* Restore proc. body: EAI_TELECOUNT_TRANSFER */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* Restore proc. body: END_WORK */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable system_date date;
  declare variable id_end_work integer;
  declare variable last_closed_date date;
  declare variable lock_id integer;
  declare variable dbkey char(8);
begin
  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date >= :in_next_date) then exception END_WORK_EXCEPTION '-43';
  if (:IN_NEXT_DATE > current_date + 1) then exception END_WORK_EXCEPTION '-60';

  last_closed_date = :in_next_date - 1;

  /* LOCK THE CURRENT FINANCIAL (SYSTEM) DATE  */
  lock_id = null;
  while (:lock_id is null) do begin
    lock_id = strhash_large(:system_date || :id_hotel);
    execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'lock');
  
    when any do begin
      exception END_WORK_EXCEPTION '-337' || f_character(31) || f_character(29) || FormatDate(:system_date, 'D;dd.mm.yyyy');
    end
  end

  /* RIGHT IS REQUIRED TO CHANGE THE FINANCIAL DATE IF THERE ARE GUESTS WITH OVERDUE CHECK OUT */
  if (exists(
    select *
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
    where  G.TO_DATE <= :last_closed_date
           and G.CHECK_STATUS < 1
           and RD.ID_HOTEL = :id_hotel
           and rd.IS_ANUL = 0
  )) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('EW_OVERDUE_CHECKOUT');
  end

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', 'EW');
  -- Suppress eventual right checks into next procedures - all is permitted. Is this needed(?!?)

  for
    select p.RDB$DB_KEY
    from   ACCOUNT_POST p
           join ACCOUNT a on a.ID_ACCOUNT = p.ID_ACCOUNT
    where  p.DATE_POST between :system_date and :last_closed_date
           and p.ID_GUEST > 0
           and a.ID_HOTEL = :ID_HOTEL
    into   :dbkey
  do begin
    update ACCOUNT_POST AP
    set    ap.ROOM_NAME = (select R.ROOM_NAME
                           from   GUEST G
                                  join ROOMS R on R.ID_ROOM = G.ID_ROOM
                           where  G.ID_GUEST = ap.ID_GUEST)
    where  ap.RDB$DB_KEY = :dbkey;
  end

  /* CHANGE SYSTEM DATE */
  execute procedure SYSTEM_DATE_SET(:id_hotel, :system_date, :in_next_date)
  returning_values :id_end_work;

  /* AUTO EXPIRATION OF ROOM NUMBERS, ROOMS AND BOOKING POSITIONS */
  execute procedure RESERVS_EXPIRE$INT(:last_closed_date, :id_hotel);

  execute procedure AGENT_CONTINGENT_EXPIRE(:system_date, :last_closed_date, null, 0, 1, :id_hotel);

  /* DELETE PERSON PROFILES WITH EXPIRATION DATE */
  execute procedure PROFILE_PERSON_EXPIRE (:in_next_date);

  execute procedure HOUSEKEEPING_MARK_ROOMS$EW(:id_end_work);

  /* Summary statistic */
  if (:in_next_date > :system_date) then begin
    execute procedure SUMMARY_FINANCE_STATISTIC$EW(:id_end_work);

    execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:ID_HOTEL, :system_date, :last_closed_date);

    execute procedure SUMMARY_STATISTIC_REBUILD$EW(:ID_HOTEL);

    execute procedure SUMMARY_FORECAST$INT(:ID_HOTEL, :system_date);
  end

  /* Delete pseudo-temporal tables */
  delete from RESERV_ERROR;
  /*  */

--  execute procedure CACHES_RESOLVE;

  execute procedure SYSTEM_LOG_ADD('DAY_END_WORK', :id_end_work, 'DAY_EW', f_character(29) || :system_date || f_character(28) || :IN_NEXT_DATE);

  execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'release');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', null);

  execute procedure SYSTEM_CACHE_APPLY('end_work');
end
^

/* Restore proc. body: FISCAL_DEVICE_STATUS_CHECK */
ALTER PROCEDURE FISCAL_DEVICE_STATUS_CHECK RETURNS(FISCAL_DEVICE_ID TYPE OF TSHORT_CODE)
 AS
begin

  select ss.SESSION_VALUE
  from   SYSTEM_SESSION SS
  where  SS.ID_CONNECTION = current_connection
         AND SS.SESSION_KEY = 'FISCAL_DEVICE_ID'
  into   :FISCAL_DEVICE_ID;

  if (:FISCAL_DEVICE_ID is null) then exception FISCALIZE_EXCEPTION '-705';
end
^

/* Restore proc. body: FISCAL_SESSION_UPDATE$FISC */
ALTER PROCEDURE FISCAL_SESSION_UPDATE$FISC(FISCAL_SESSION_ID INTEGER,
FISCAL_DEVICE_ID TYPE OF TSHORT_CODE)
 AS
declare variable current_fiscal_device_id varchar(10);
begin
  select ss.SESSION_VALUE
  from   SYSTEM_SESSION Ss
  where  Ss.ID_CONNECTION = :FISCAL_SESSION_ID
         and ss.SESSION_KEY = 'FISCAL_DEVICE_ID'
  into   :current_fiscal_device_id;

  if (:current_fiscal_device_id is distinct from :FISCAL_DEVICE_ID) then
    update or insert into SYSTEM_SESSION(ID_CONNECTION, SESSION_KEY, SESSION_VALUE)
    values (:FISCAL_SESSION_ID, 'FISCAL_DEVICE_ID', :FISCAL_DEVICE_ID)
    matching (ID_CONNECTION, SESSION_KEY);

end
^

/* Restore proc. body: FISCALIZE_PREPARE$FISC */
ALTER PROCEDURE FISCALIZE_PREPARE$FISC(ID_DOC_HEAD INTEGER,
DETAIL_LEVEL VARCHAR(20),
ADDITIONAL_PAYMENT_TEXT VARCHAR(30) = null)
 RETURNS(UNIQUE_SALES_NUMBER VARCHAR(50),
FISCALIZATION_DETAILS VARCHAR(255),
VOID_REASON VARCHAR(30),
IS_VOID TYPE OF TLOGICAL)
 AS
declare variable fisc_status integer;
  declare variable void_status integer;
  declare variable doc_sub_type integer;
begin
  FISCALIZATION_DETAILS = null;
  VOID_REASON = null;
  IS_VOID = 0;

  select sn.UNIQUE_SALES_NUMBER, h.FISC_STATUS, h.IS_ANUL + h.IS_STORNED, h.DOC_SUB_TYPE
  from   DOC_HEAD h
         join SALE_NUM sn on sn.ID_SALE_NUM = h.ID_SALE_NUM
  where  h.ID_DOC = :ID_DOC_HEAD
  into   :UNIQUE_SALES_NUMBER, :fisc_status, :void_status, :doc_sub_type;

  if (:void_status > 0) then exception FISCALIZE_EXCEPTION '-711';

  if (:fisc_status = 0) then exit;  -- Nothing to fiscalize
  else if (:fisc_status = 2) then exit;  -- Payments are marked as fiscalized already
  -- !!! Only fisc_status=1 allows to continue with data preparation !!!

  if (:doc_sub_type in (0, 1)) then begin
    execute procedure FISCALIZE_PREPARE_DATA$INT(:ID_DOC_HEAD, :UNIQUE_SALES_NUMBER, :DETAIL_LEVEL, :ADDITIONAL_PAYMENT_TEXT);

  end else begin
    -- credit docs
    execute procedure FISCALIZE_VOID_PREPARE$FISC(:ID_DOC_HEAD)
    returning_values (:UNIQUE_SALES_NUMBER, :FISCALIZATION_DETAILS, :ADDITIONAL_PAYMENT_TEXT);
    IS_VOID = 1;
  end
end
^

/* Restore proc. body: FISCALIZE_PREPARE_DATA$INT */
ALTER PROCEDURE FISCALIZE_PREPARE_DATA$INT(ID_DOC_HEAD INTEGER,
UNIQUE_SALES_NUMBER VARCHAR(50),
DETAIL_LEVEL VARCHAR(20),
ADDITIONAL_PAYMENT_TEXT VARCHAR(30) = null)
 AS
declare variable fld_sep varchar(10);
  declare variable line_sep varchar(10);
  declare variable line varchar(255);
  declare variable lines_data blob sub_type 1 segment size 80;
  declare variable payments_data blob sub_type 1 segment size 80;
begin
  if (exists (select fd.ID_DOC_HEAD
              from   DOC_FISCAL_DATA fd
              where  fd.ID_DOC_HEAD = :ID_DOC_HEAD)) then exit;

  fld_sep = f_character(28);
  line_sep = f_character(29);
  lines_data = '';
  for
    select coalesce(l.FISC_PRICE, 0) || :fld_sep
           || coalesce(l.FISC_QTY, 0) || :fld_sep
           || coalesce(l.FISC_TEXT, '') || :fld_sep
           || coalesce(l.FISC_GRP, '') || :fld_sep
           || coalesce(l.TRANSACTION_VALUE, 0) || :line_sep
    from   FISCALIZE_PREPARE_LINES$INT (:ID_DOC_HEAD, :DETAIL_LEVEL, :ADDITIONAL_PAYMENT_TEXT) l
    into   :line
  do begin
    lines_data = :lines_data || :line;
  end

  payments_data = '';
  for
    select coalesce(P.FISC_SUM, 0) || :fld_sep
           || coalesce(P.FISC_TEXT, '') || :fld_sep
           || coalesce(P.FISC_GRP, '') || :line_sep
    from   FISCALIZE_PREPARE_PAYMENT$INT(:ID_DOC_HEAD) p
    into   :line
  do begin
    payments_data = :payments_data || :line;
  end

  insert into DOC_FISCAL_DATA(ID_DOC_HEAD, UNIQUE_SALES_NUMBER,
         DETAIL_LEVEL, ADDITIONAL_PAYMENT_TEXT, FISCAL_LINES, FISCAL_PAYMENTS)
  values (:ID_DOC_HEAD, :UNIQUE_SALES_NUMBER,
         :detail_level, :additional_payment_text, :lines_data, :payments_data);
end
^

/* Restore proc. body: FISCALIZE_PREPARE_LINES$INT */
ALTER PROCEDURE FISCALIZE_PREPARE_LINES$INT(ID_DOC_HEAD INTEGER,
DETAIL_LEVEL VARCHAR(20),
ADDITIONAL_PAYMENT_TEXT VARCHAR(30) = null)
 RETURNS(FISC_PRICE NUMERIC(15,4),
FISC_QTY NUMERIC(15,4),
FISC_TEXT VARCHAR(30),
FISC_GRP VARCHAR(10),
TRANSACTION_VALUE NUMERIC(15,4))
 AS
declare variable payment_cnt integer;
  declare variable fisc_value_coef double precision;
  declare variable target_fiscal_value numeric(15,2);
  declare variable fiscalized_value numeric(15,4);
  declare variable payment_value numeric(15,4);
  declare variable total_lines integer;
  declare variable lines_cnt integer;
  declare variable tmp_cnt integer;
  declare variable for_deposit integer;
  declare variable adv_payment_lines integer;
  declare variable one_line_text varchar(30);
  declare variable srv_groups integer;
  declare variable doc_rate numeric(15,6);
  declare variable round_to numeric(15,4);
  declare variable doc_sub_type integer;
begin
  FISC_PRICE = null;
  FISC_TEXT = null;
  FISC_GRP = null;
  TRANSACTION_VALUE = null;
  FISC_QTY = 1;
  FISCALIZED_VALUE = 0;
  LINES_CNT = 0;
  FISC_VALUE_COEF = 1;

  execute procedure FISCAL_VALUE_GET$INT (:ID_DOC_HEAD)
  returning_values  :target_fiscal_value, :payment_cnt, :payment_value, :fisc_value_coef;

  if (:payment_cnt = 0) then exit;

  doc_rate = null;
  select dh.DOC_RATE, dh.FOR_DEPOSIT, dh.DOC_SUB_TYPE,
         substring(H.DOC_ONE_LINE_TEXT from 1 for 30), c.ROUND_TO
  from   DOC_HEAD DH
         join ACCOUNT A on A.ID_ACCOUNT = dh.ID_ACCOUNT
         join HOTEL H on h.ID_HOTEL = a.ID_HOTEL
         join CURRS c on c.CURR = h.NATION_CURR
  where  DH.ID_DOC = :ID_DOC_HEAD
  into   :doc_rate, :for_deposit, :doc_sub_type,
         :one_line_text, :round_to;

  if (:doc_sub_type = 2) then fisc_value_coef = -:fisc_value_coef; -- Inverse!!!

  select count(dl.ID_DOC_LINE), count(dv.ID_DOC_LINE), count(distinct s.ID_SERVICE_GROUP)
  from   DOC_LINE DL
         join SERVICES S on s.ID_SERVICE = dl.ID_SERVICE
         left outer join DOC_LINE_DEP_VALUES dv on dv.ID_DOC_LINE = dl.ID_DOC_LINE and :for_deposit = 0
  where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :total_lines, :adv_payment_lines, :srv_groups;

  if (:adv_payment_lines > 0 and trim(coalesce(:ADDITIONAL_PAYMENT_TEXT, '')) <> '') then
    DETAIL_LEVEL = 'aditional_payment';

  for
    select case
             when :detail_level = 'aditional_payment' then :ADDITIONAL_PAYMENT_TEXT
             when :DETAIL_LEVEL = 'group' then iif(:srv_groups = 1, SG.GROUP_NAME, :one_line_text)
             else S.SERVICE_NAME
           end,
           lines.fisc_codes,
           round_f(sum(DL.SINGLE_VALUE * DL.QTY_POST * :doc_rate) * :fisc_value_coef, 0.01),
           count(DL.ID_DOC_LINE)
    from   (select l.ID_DOC_LINE,
                   cast(substring(list(trim(coalesce(st.FISCAL_CODE, '')), '') from 1 for 10) as varchar(10)) as fisc_codes
            from   DOC_LINE l
                   join SALE_TAXATION_TAX stt on stt.ID_SALE_TAXATION = l.ID_SALE_TAXATION
                   join SALE_TAXES st on st.ID_SALE_TAX = stt.ID_SALE_TAX
                                         and st.REVENUE_DEDUCTION_TAX is distinct from 1
            where  l.ID_DOC_HEAD = :ID_DOC_HEAD
            group by l.ID_DOC_LINE) lines
           join DOC_LINE DL on dl.ID_DOC_LINE = lines.ID_DOC_LINE
           join SERVICES S on S.ID_SERVICE = DL.ID_SERVICE
           join SERVICE_GROUPS SG on SG.ID_SERVICE_GROUP = S.ID_SERVICE_GROUP
           left outer join DOC_LINE_DEP_VALUES dv on dv.ID_DOC_LINE = dl.ID_DOC_LINE
    group by iif((:DETAIL_LEVEL = 'aditional_payment') or (dv.ID_DOC_LINE is null), 0, 1),
           lines.fisc_codes,
           1
    order by iif((:DETAIL_LEVEL = 'aditional_payment') or (dv.ID_DOC_LINE is null), 0, 1),
           iif(sum(DL.SINGLE_VALUE * DL.QTY_POST) * :fisc_value_coef > 0, 0, 1),  -- pull up positive value lines first
           lines.fisc_codes,
           1
    into   :FISC_TEXT, :FISC_GRP, :FISC_PRICE, :tmp_cnt
  do begin

    lines_cnt = :lines_cnt + :tmp_cnt;
    if (:lines_cnt = :total_lines) then begin
      FISC_PRICE = round_f(:target_fiscal_value, :round_to) - :fiscalized_value;
      -- to fiscalize rest value - in case of mixed fiscal/nonfiscal payments
    end

    if (:FISC_PRICE <> 0) then begin
      TRANSACTION_VALUE = :FISC_PRICE;
      suspend;
    end

    fiscalized_value = :fiscalized_value + :FISC_PRICE;
  end
end
^

/* Restore proc. body: FISCALIZE_PREPARE_PAYMENT$INT */
ALTER PROCEDURE FISCALIZE_PREPARE_PAYMENT$INT(ID_DOC_HEAD INTEGER)
 RETURNS(FISC_SUM NUMERIC(15,4),
FISC_TEXT VARCHAR(30),
FISC_GRP VARCHAR(10))
 AS
declare variable sale_fisc_value numeric (15,4);
declare variable total_payment_value numeric (15,4);
  declare variable payment_value numeric (15,4);
  declare variable payment_cnt integer;
  declare variable payment_i integer;
  declare variable reduction_coef double precision;
begin

  execute procedure FISCAL_VALUE_GET$INT (:ID_DOC_HEAD)
  returning_values  :sale_fisc_value, :payment_cnt, :total_payment_value, :reduction_coef;
  if (:payment_cnt = 0) then exit;

  FISC_SUM = null;
  FISC_TEXT = null;
  FISC_GRP = null;
  PAYMENT_VALUE = 0;
  PAYMENT_I = 0;

  for
    select PT.PAYMENT_TYPE,
           substring(PT.FISCAL_CODE from 1 for 10),
           round_f(sum(PH.NAT_VALUE * iif(d.DOC_SUB_TYPE = 2, -1, 1)), c.ROUND_TO)
    from   DOCUMENT_PAYMENT PH
           join DOC_HEAD d on d.ID_DOC = ph.ID_DOC_HEAD
           join PAYMENT_TYPE PT on PT.ID_PAYMENT_TYPE = PH.ID_PAYMENT_TYPE
           join PAY_DOC_TYPE_S DT on DT.ID_DOC_TYPE = PH.ID_DOC_TYPE
           join HOTEL h on h.ID_HOTEL = dt.ID_HOTEL
           join CURRS c on c.CURR = h.NATION_CURR
    where  PH.ID_DOC_HEAD = :ID_DOC_HEAD
           -- and PH.IS_STORNO = 0
           -- and dt.DOC_DIRECTION = 0
           and DT.IS_FISCALIZE = 1
    group by 1, 2, c.ROUND_TO
    into   :FISC_TEXT, :FISC_GRP, :FISC_SUM
  do begin
    PAYMENT_I = :PAYMENT_I + 1;
    if (:PAYMENT_I < :PAYMENT_CNT) then begin
      PAYMENT_VALUE = :PAYMENT_VALUE + :FISC_SUM;
      suspend;
    end
  end

  FISC_SUM = :total_payment_value - :PAYMENT_VALUE;
  if (:FISC_SUM > 0) then suspend;
end
^

/* Restore proc. body: FISCALIZE_SET_DETAILS$FISC */
ALTER PROCEDURE FISCALIZE_SET_DETAILS$FISC(ID_DOC_HEAD INTEGER,
FISCALIZATION_DETAILS VARCHAR(255))
 AS
declare variable curr_fiscal_details varchar(255);
  declare variable curr_storno_fiscal_details varchar(255);
  declare variable is_anul integer;
  declare variable doc_sub_type integer;
begin
  select fd.FISCALIZATION_DETAILS, fd.STORNO_FISCALIZATION_DETAILS, h.IS_ANUL, h.DOC_SUB_TYPE
  from   DOC_FISCAL_DATA fd
         join DOC_HEAD h on h.ID_DOC = fd.ID_DOC_HEAD
  where  h.ID_DOC = :ID_DOC_HEAD
  into   :curr_fiscal_details, :curr_storno_fiscal_details, :is_anul, :doc_sub_type;

  if (:is_anul = 0 and :doc_sub_type < 2) then begin
    -- Fiscalization mark
    if (:curr_fiscal_details is not null) then
      exception FISCALIZE_EXCEPTION '-308';

    update DOC_FISCAL_DATA FD
    set    FD.FISCALIZATION_DETAILS = :FISCALIZATION_DETAILS
    where  fd.ID_DOC_HEAD = :id_doc_head;

  end else begin
    -- Storno fiscalization mark
    if (:curr_storno_fiscal_details is not null) then
      exception FISCALIZE_EXCEPTION '-309';

    update DOC_FISCAL_DATA FD
    set    FD.STORNO_FISCALIZATION_DETAILS = :FISCALIZATION_DETAILS
    where  fd.ID_DOC_HEAD = :id_doc_head;
  end
end
^

/* Restore proc. body: FISCALIZE_VOID_PREPARE$FISC */
ALTER PROCEDURE FISCALIZE_VOID_PREPARE$FISC(ID_DOC_HEAD INTEGER)
 RETURNS(UNIQUE_SALES_NUMBER VARCHAR(50),
FISCALIZATION_DETAILS VARCHAR(255),
VOID_REASON VARCHAR(30))
 AS
declare variable is_anul integer;
  declare variable fisc_status integer;
  declare variable doc_sub_type integer;
  declare variable id_base_doc integer;
  declare variable storno_fiscal_device_id varchar(10);
  declare variable detail_level varchar(20);
  declare variable additional_payment_text varchar(30);
  declare variable old_unique_sales_number varchar(50);
  declare variable fiscal_device_id varchar(10);
begin
  select h.is_anul, h.FISC_STATUS, h.DOC_SUB_TYPE, h.ID_BASE_DOC, sn.UNIQUE_SALES_NUMBER
  from   DOC_HEAD h
         left outer join SALE_NUM sn on sn.ID_SALE_NUM = h.ID_SALE_NUM
  where  h.ID_DOC = :ID_DOC_HEAD
  into   :is_anul, :fisc_status, :doc_sub_type, :id_base_doc, :old_unique_sales_number;

  if (:is_anul = 1) then begin
    if (:doc_sub_type = 2) then exit; -- voided credit docs - nothing to void
    if (:fisc_status < 2) then exit;  -- Only voided docs with fisc_status = 2 allows to continue with VOID preparation !!!
    if (:old_unique_sales_number = 'XXXXXXXX-0000-0000000') then exit;  -- Old documents without FISCAL_DATA

    if (not exists (select f.ID_DOC_HEAD from DOC_FISCAL_DATA f where f.ID_DOC_HEAD = :ID_DOC_HEAD)) then
      exception FISCALIZE_EXCEPTION '-710';

    select f.UNIQUE_SALES_NUMBER, f.FISCALIZATION_DETAILS, substring(l.ACTION_TEXT from 2 for 30), f.STORNO_FISCAL_DEVICE_ID
    from   DOC_FISCAL_DATA f
           left outer join DOC_ANNULMENT d on d.ID_DOC_HEAD = f.ID_DOC_HEAD
           left outer join SYSTEM_LOG_EVENT l on l.ID_SYSTEM_LOG = d.ID_LOG_EVENT
    where  f.ID_DOC_HEAD = :ID_DOC_HEAD
    into   :UNIQUE_SALES_NUMBER, :FISCALIZATION_DETAILS, :VOID_REASON,
           :storno_fiscal_device_id;
  
    if (:storno_fiscal_device_id is not null) then exception FISCALIZE_EXCEPTION '-709';

  end else begin
    if ( :doc_sub_type in (0, 1) ) then exception FISCALIZE_EXCEPTION '-711';
    if ( :fisc_status <> 1 ) then exit;
    -- !!! Only credit docs with fisc_status = 1 allows to continue with VOID preparation !!!

    select f.UNIQUE_SALES_NUMBER, f.FISCALIZATION_DETAILS, f.DETAIL_LEVEL, f.ADDITIONAL_PAYMENT_TEXT,
           f.FISCAL_DEVICE_ID
    from   DOC_FISCAL_DATA f
    where  f.ID_DOC_HEAD = :id_base_doc
    into   :UNIQUE_SALES_NUMBER, :FISCALIZATION_DETAILS, :detail_level, :additional_payment_text,
           :fiscal_device_id;

    if (:fiscal_device_id is null) then exit;  -- base_doc is not fiscalized -- exception FISCALIZE_EXCEPTION '-710';

    execute procedure FISCALIZE_PREPARE_DATA$INT(:ID_DOC_HEAD, :UNIQUE_SALES_NUMBER, :detail_level, :additional_payment_text);
  end
end
^

/* Restore proc. body: GUEST_ADDRESSCARD_SET$RSV */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA TDESCRIPTION_SHORT,
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable gd_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable rd_dbkey char(8);
  declare variable old_is_registred integer;
  declare variable old_guest_name1 varchar(250);
  declare variable old_guest_name2 varchar(250);
  declare variable old_id_pass_type integer;
  declare variable old_pass_num varchar(20);
  declare variable old_pass_date date;
  declare variable old_egn varchar(30);
  declare variable old_country varchar(20);
  declare variable old_id_stay_reason integer;
  declare variable old_kpp integer;
  declare variable old_kpp_date date;
  declare variable old_pass_exp_date date;
  declare variable old_birth_day date;
  declare variable old_pass_place varchar(20);
  declare variable old_city varchar(100);
  declare variable old_address varchar(100);
  declare variable old_visa TDESCRIPTION_SHORT;
  declare variable old_birth_place varchar(30);
  declare variable old_sex char(1);
  declare variable action_text varchar(250);
  declare variable tt_reg_number integer;
  declare variable id_hotel integer;
  declare variable id_tt_numerator integer;
  declare variable domestic_nation varchar(10);
  declare variable no_use varchar(255);
  declare variable is_anul smallint;
  declare variable acc_routing varchar(20);
begin
  err_code = 0;
  err_text = '';

  select G.RDB$DB_KEY, GD.RDB$DB_KEY, PD.RDB$DB_KEY,
         GD.IS_REGISTRED, PD.PERSON_NAME, PD.PERSON_NAME2, PD.ID_PASSPORT_TYPE, PD.PASS_NUM, PD.PASS_DATE,
         PD.EGN, PD.COUNTRY_CODE, GD.ID_STAY_REASON, GD.KPP, GD.KPP_DATE, PD.PASS_EXP_DATE,
         PD.BIRTH_DAY, PD.PASS_PLACE, PD.CITY, PD.ADDRESS, PD.BIRTH_PLACE, PD.SEX, rd.RDB$DB_KEY,
         g.TT_REG_NUMBER, rd.ID_HOTEL, rd.IS_ANUL, rd.ACC_ROUTING, GD.VISA
  from   GUEST G
         join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
         join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :gd_dbkey, :pd_dbkey,
         :old_is_registred, :old_guest_name1, :old_guest_name2, :old_id_pass_type, :old_pass_num, :old_pass_date,
         :old_egn, :old_country, :old_id_stay_reason, :old_kpp, :old_kpp_date, :old_pass_exp_date,
         :old_birth_day, :old_pass_place, :old_city, :old_address, :old_birth_place, :old_sex, :rd_dbkey,
         :tt_reg_number, :id_hotel, :is_anul, :acc_routing, :old_visa;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, :birth_place, :egn, :id_passport_type, :pass_num, :pass_date, :pass_place,
          :pass_exp_date, :city, :address, :sex, :mask);

  update  GUEST_DATA GD
  set     GD.KPP_DATE = :kpp_date,
          GD.KPP = :kpp,
          GD.VISA = :visa,
          GD.ID_STAY_REASON = :id_stay_reason,
          GD.IS_REGISTRED = :is_registred,
          GD.USER_REGISTRED = iif(:IS_REGISTRED = 1, coalesce(GD.USER_REGISTRED, current_user), null),
          GD.CAR = :car,
          GD.RATING_AGE = :RATING_AGE
  where   GD.RDB$DB_KEY = :gd_dbkey;

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name1, :guest_name2, :country,
          :is_child, :age, :birth_day, :TITLE);

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

  /*  */
  if (:IS_REGISTRED = 1 and :tt_reg_number is null and :is_anul = 0 and :acc_routing is distinct from 'OWNER') then begin
    execute procedure SETTING_GET_VALUE ('NATIVE_NATION', :id_hotel)
    returning_values :domestic_nation;

    select iif(:COUNTRY not in (:domestic_nation, '') and h.USE_DIFFERENT_TT_NUMERATORS = 1,
               h.ID_TT_NUMERATOR_2,
               h.ID_TT_NUMERATOR_1)
    from   HOTEL H
    where  h.ID_HOTEL = :id_hotel
    into   :id_tt_numerator;

    if (:id_tt_numerator is not null) then begin
      execute procedure SYSTEM_GEN_NUM('GUEST_NUM', :id_tt_numerator)
      returning_values :tt_reg_number, :no_use;
  
      update GUEST G
      set    g.TT_REG_NUMBER = :tt_reg_number
      where  G.RDB$DB_KEY = :g_dbkey;
    end
  end else if (:IS_REGISTRED is distinct from 1 and :tt_reg_number is not null) then begin
    update GUEST G
    set    g.TT_REG_NUMBER = null
    where  G.RDB$DB_KEY = :g_dbkey;
  end
  /*  */
  if ((:old_is_registred = 0) and (:is_registred = 1)) then begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'REGISTRED', '');
  end

  if ((:old_is_registred = 1) and (:old_guest_name1 <> :guest_name1)) then begin
    action_text = f_character(29)||:old_guest_name1||f_character(28)||:guest_name1;
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'CHANGE_CARD', :action_text);
  end

  if ((:old_IS_REGISTRED = 1)
      and
      ((:old_guest_name1 <> :guest_name1)
        or (:old_guest_name2 <> :guest_name2)
        or (:old_egn <> :egn)
        or (:old_id_pass_type <> :id_passport_type)
        or (:old_pass_num <> :pass_num)
        or (:old_pass_date <> :pass_date)
        or (:old_pass_exp_date <> :pass_exp_date)
        or (:old_pass_place <> :pass_place)
        or (:old_country <> :country)
        or (:old_city <> :city)
        or (:old_address <> :address)
        or (:old_visa <> :visa)
        or (:old_birth_day <> :birth_day)
        or (:old_birth_place <> :birth_place)
        or (:old_sex  <> :sex)
        or (:old_kpp <> :kpp)
        or (coalesce(:old_id_stay_reason,0) <> coalesce(:id_stay_reason,0))
        or (:old_kpp_date <> :kpp_date)
      )) then
  begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'PREREGISTRED', '');
  end

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;

  end

end
^

/* Restore proc. body: GUEST_ANUL_POSTINGS$INT */
ALTER PROCEDURE GUEST_ANUL_POSTINGS$INT(ID_GUEST INTEGER)
 RETURNS(EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable ap_dbkey char(8);
  declare variable id_master_addins_acc_post integer;
begin
  EXTRA_POSTS_LEFT = 0;
  for
    select AP.RDB$DB_KEY, AP.ID_MASTER_ADDINS_ACC_POST
    from   ACCOUNT_POST AP
    where  AP.ID_GUEST = :ID_GUEST
           and AP.IS_ANUL = 0
    into   :AP_DBKEY, :ID_MASTER_ADDINS_ACC_POST
  do begin
    if (:ID_MASTER_ADDINS_ACC_POST > 0) then begin
      execute procedure ACCOUNT_POSTING_ANUL$INT (:AP_DBKEY, 'RECALC_GUEST_DELETE');
    end else begin
      EXTRA_POSTS_LEFT = 1;
    end
  end
end
^

/* Restore proc. body: GUEST_NUMERATOR_MODIFY$INT */
ALTER PROCEDURE GUEST_NUMERATOR_MODIFY$INT(ID_NUMERATOR INTEGER,
NUM_NAME VARCHAR(50),
NUM_NEXT INTEGER,
OPERATION VARCHAR(20),
ID_HOTEL TYPE OF ID_REF)
 RETURNS(NEW_ID_NUMERATOR INTEGER)
 AS
begin
/*  if (:operation = 'add') then in_use = 0;
  else in_use = 1;
*/
  execute procedure SYSTEM_NUMERATOR_MODIFY$INT(:id_numerator, 'GUEST_NUM',
          :num_name, :num_next - 1, '', 20, :ID_HOTEL, :operation)
  returning_values  :new_id_numerator;
end
^

/* Restore proc. body: GUEST_POST_GET_PACK_SERVICE */
ALTER PROCEDURE GUEST_POST_GET_PACK_SERVICE(IN_ID_SERVICE INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_POST DATE)
 RETURNS(ID_PACK_SERVICE INTEGER)
 AS
declare variable id_type_stay integer;
  declare variable id_room_type integer;
  declare variable id_board integer;
  declare variable id_hotel integer;
begin
  /*  Description:
  ||
  */
  id_pack_service = -1;
  select Sp.ID_TYPE_STAY, Sp.ID_ROOM_TYPE, s.ID_HOTEL
  from   SERVICE_PACKET Sp
         join SERVICES S on s.ID_SERVICE = sp.ID_SERVICE
  where  S.ID_SERVICE = :in_id_service
  into   :id_type_stay, :id_room_type, :id_hotel;

  select GS.ID_BOARD
  from   GUEST_STAY GS
  where  GS.ID_GUEST = :in_id_guest
         and GS.FOR_DATE = :in_date_post
  into   :id_board;

  /*dbg = savedbg('in_id_guest = '||:in_id_guest);
  dbg = savedbg('in_date_post = '||:in_date_post);
  dbg = savedbg('id_board = '||:id_board); */
  execute procedure TAR_GET_BASE_SERVICE$INT(:id_type_stay, :id_room_type, :id_board, :id_hotel)
  returning_values  :id_pack_service;

end
^

/* Restore proc. body: GUEST_SET_MANUAL_STAY$INT */
ALTER PROCEDURE GUEST_SET_MANUAL_STAY$INT(RD_DBKEY CHAR(8),
ID_GUEST INTEGER,
FROM_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable for_date date;
  declare variable id_room_type integer;
  declare variable id_type_stay integer;
  declare variable current_id_type_stay integer;
  declare variable current_id_room_type integer;
  declare variable gs_dbkey char(8);
  declare variable has_manual_stay smallint;
  declare variable id_room integer;
  declare variable room_name varchar(20);
begin
  /*  Description:
  ||
  */
  ERR_CODE = 0;
  ERR_TEXT = '';
  execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MANUAL_STAY');

  has_manual_stay = 0;
  for
    select GS.RDB$DB_KEY, GS.FOR_DATE, gs.ID_TYPE_STAY, gs.ID_ROOM_TYPE, gs.ID_ROOM
    from   GUEST_STAY GS
    where  GS.ID_GUEST = :ID_GUEST
           and GS.FOR_DATE >= :FROM_DATE
    into   :gs_dbkey, :for_date, :current_id_type_stay, :current_id_room_type, :id_room
  do begin
    select gsc.ID_TYPE_STAY, gsc.ID_ROOM_TYPE
    from   GUEST_GET_STAY_CONDITIONS$INT (:id_guest, :for_date) gsc
    into   :id_type_stay, :id_room_type;

    if (coalesce(:id_room_type, 0) < 0) then begin
      err_code = -18;
      err_text = f_character(29) || :ID_GUEST || f_character(28) || :for_date;
      exit;
    end
    if (coalesce(:id_type_stay, -1) < 0) then begin
      if (:id_room > 0) then begin
        select r.ROOM_NAME
        from   ROOMS R
        where  r.ID_ROOM = :id_room
        into   :room_name;
      end else begin
        select rt.TYPE_ROOM
        from   ROOM_TYPES RT
        where  rt.ID_ROOM_TYPE = :id_room_type
        into   :room_name;
      end
      err_code = -17;
      err_text = f_character(29) || :ID_GUEST || f_character(28) || :for_date || f_character(28) || :room_name;
      exit;
    end

    if ((:current_id_room_type <> :id_room_type) or (:current_id_type_stay <> :id_type_stay)) then begin
      update GUEST_STAY GSU
      set    GSU.ID_ROOM_TYPE = :id_room_type,
             GSU.ID_TYPE_STAY = :id_type_stay
      where  GSU.RDB$DB_KEY = :gs_dbkey;
    end
    has_manual_stay = 1;
  end

  if (:has_manual_stay = 1) then
    update RESERV_DETAIL RD
    set    RD.HAS_DIFFERENT_TYPE_STAY = 1,
           RD.HAS_DIFFERENT_ROOM_TYPE = 1
    where  RD.RDB$DB_KEY = :rd_dbkey;

end
^

/* Restore proc. body: HOTEL_COMPANY_DATA */
ALTER PROCEDURE HOTEL_COMPANY_DATA(ID_HOTEL TYPE OF ID,
LANGUAGE_CODE TYPE OF TLANGUAGE,
ID_DOC_SUPPLIER TYPE OF ID,
LC_IDENT_NUM TYPE OF TDESCRIPTION_SHORT,
LC_VAT_REG_NUM TYPE OF TDESCRIPTION_SHORT,
LC_MOL TYPE OF TDESCRIPTION_SHORT,
LC_ADDRESS TYPE OF TDESCRIPTION_SHORT)
 RETURNS(COMPANY_DATA TYPE OF TNOTE_BLOB)
 AS
begin
  select coalesce(s.FIRM_DATA,

           coalesce(lcn.VALUE_PLAIN, iif(s.ID_DOC_SUPPLIER is null, h.COMPANY_NAME, s.COMPANY_NAME), '') || F_CRLF() ||

           coalesce(:LC_IDENT_NUM || ': ', '')
            || coalesce(iif(s.ID_DOC_SUPPLIER is null, h.COMPANY_IDENT_NUM, s.COMPANY_IDENT_NUM), '') || F_CRLF() ||

           coalesce(:LC_VAT_REG_NUM || ': ', '')
            || coalesce(iif(s.ID_DOC_SUPPLIER is null, h.COMPANY_VAT_REG_NUM, s.COMPANY_VAT_REG_NUM), '') || F_CRLF() ||

           coalesce(:LC_MOL || ': ', '')
            || coalesce(lcm.VALUE_PLAIN, iif(s.ID_DOC_SUPPLIER is null, h.COMPANY_MOL, s.COMPANY_MOL), '') || F_CRLF() ||

           coalesce(:LC_ADDRESS || ': ', '')
            || coalesce(lca.VALUE_PLAIN, iif(s.ID_DOC_SUPPLIER is null, h.COMPANY_ADDRESS, s.COMPANY_ADDRESS), '')
         )
  from   HOTEL h
         left outer join DOC_SUPPLIER s on s.ID_DOC_SUPPLIER = :ID_DOC_SUPPLIER
         left outer join TRANSLATION_GET('company_name', :ID_HOTEL, :LANGUAGE_CODE) lcn on 1=1
         left outer join TRANSLATION_GET('company_mol', :ID_HOTEL, :LANGUAGE_CODE) lcm on 1=1
         left outer join TRANSLATION_GET('company_address', :ID_HOTEL, :LANGUAGE_CODE) lca on 1=1
  where  h.ID_HOTEL = :ID_HOTEL
  into   :COMPANY_DATA;

  suspend;
end
^

/* Restore proc. body: IMPORT_BOOKING$EXC */
ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP,
CHECK_OUT_KIND SMALLINT,
EARLYCHECKOUT_DATE DATE)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable current_hotel_id integer;
declare variable booking_update_id integer;
declare variable warn_code integer;
declare variable share_transaction_id integer;
declare variable share_err_code integer;
declare variable arranger_profile_id integer;
declare variable main_guest_profile_id integer;
declare variable rate_id integer;
declare variable room_type_id integer;
declare variable board_id integer;
declare variable maintance_shema_id integer;
declare variable arranger_payment_type_id integer;
declare variable guest_payment_type_id integer;
declare variable marketing_segment_id integer;
declare variable marketing_source_code_id integer;
declare variable marketing_channel_code_id integer;
declare variable marketing_hear_reason_id integer;
declare variable marketing_come_reason_id integer;
declare variable arranger_account_id integer;
declare variable packet_id integer;
declare variable id_guarantee_policy integer;
declare variable first_food_code tfood_code;
declare variable arrival_type_code smallint;
declare variable booking_dbkey char(8);
declare variable reserv_group_id integer;
declare variable id_complimentary_account integer;
declare variable id_eating_object integer;
declare variable default_guest_mask varchar(10);
declare variable id_person_data integer;
begin
  /*execute procedure sys_dbg('exc IMPORT_BOOKING$EXC('
  || 'hotel => ' || coalesce(:hotel, '<null>')
  || ', booking_number => ' || coalesce(:number, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  ||')');
  */
  execute procedure import_mark_transaction$exc;

  /* init */
  err_code = 0;
  err_text = '';
  booking_update_id = null;
  booking_dbkey = null;
  current_hotel_id = null;
  if (:voucher_date is not null) then begin
    voucher_date = striptime(:voucher_date);
  end
  posting_routing = upper(:posting_routing);

  /* detect inser/update mode */
  select b.id_reserv_detail, b.rdb$db_key, b.id_hotel
  from   reserv_detail b
  where  b.number=:number
         and b.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and b.id_log_event_annul is null
  into   :booking_update_id, :booking_dbkey, :current_hotel_id;

  if (:booking_update_id is null) then begin
    booking_id = gen_id (id_reserv_detail_gen, 1);
  end else begin
    booking_id = :booking_update_id;
  end

  /* text to id map */
  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => MAP_BOOKING_RELATIONS$EXC');
  execute procedure MAP_BOOKING_RELATIONS$EXC(
    :booking_id,
    :hotel,
    :room_type,
    :board,
    :maintance_shema,
    :rate,
    :arranger_payment_type,
    :guest_payment_type,
    :marketing_segment,
    :marketing_source_code,
    :marketing_channel_code,
    :marketing_hear_reason,
    :marketing_come_reason,
    :first_food,
    :arranger_profile_uuid,
    :arranger_profile_name,
    :main_guest_profile_uuid,
    :arrival_type,
    :guarantee_policy,
    :eating_object
  ) returning_values
    :arranger_profile_id,
    :main_guest_profile_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :hotel_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :first_food_code,
    :arrival_type_code,
    :id_guarantee_policy,
    :id_eating_object;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* hotel change test */
  if (coalesce(:current_hotel_id, :hotel_id) <> :hotel_id) then begin
    execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', null, :hotel, 'booking hotel changed');
  end

  id_complimentary_account = null;
  if (complimentary_account is not null) then begin
    execute procedure lookup_account$exc(:hotel_id, :complimentary_account, 'booking', :booking_id)
    returning_values :id_complimentary_account;
  end

  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => CREATE_PACK_INSTANCE$EXC');
  packet_id = null;
  /*execute procedure CREATE_PACK_INSTANCE$EXC(
    :hotel_id, :booking_id, :package
  )
  returning_values :packet_id, :err_code, :err_text;
  if (0 <> :err_code) then exit;
  */
  /* merge input and default/persistent database values */
  execute procedure DEFAULT_BOOKING_VALUES$EXC(
    :booking_dbkey, :hotel_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :group_name,
    :group_uuid,
    :is_late_departure,
    :id_eating_object
  ) returning_values
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :arranger_account_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :reserv_group_id,
    :is_late_departure,
    :id_eating_object,
    :default_guest_mask;

  if ('' = :board) then board_id = null; /* preserve "empty board" state and discard default value */

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC DEFAULTED => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* if the booking is complimentary use complimentary account */
  arranger_account_id = coalesce(:id_complimentary_account, :arranger_account_id);

  /* CREATE or UPDATE */
  if (:booking_update_id is not null) then begin
    /* UPDATE booking */
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => UPDATE_BOOKING$EXC');
    execute procedure UPDATE_BOOKING$EXC(
      :booking_id,
      :reserv_group_id,
      :is_vip,
      :arrival,
      :arrival_type_code,
      :departure,
      :is_late_departure,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :room_type_id,
      :board_id,
      :room_preferences,
      :special_treatment,
      :maintance_shema_id,
      :posting_routing,
      :arranger_account_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :deposit_required,
      :deposit_required_currency,
      :arranger_payment_type_id,
      :guest_payment_type_id,
      :voucher,
      :voucher_date,
      :voucher_text,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :note,
      :note_reminders,
      :first_food_code,
      :arranger_profile_id,
      :main_guest_profile_id,
      :is_different_rate,
      :is_different_price,
      :split_on_checkin,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object
    ) returning_values :err_code, :err_text;
    if (0 <> :err_code) then begin
      exit;
    end
  end else begin
    /* CREATE booking */
    if (:default_guest_mask is not null
        and :main_guest_profile_id is not null
        and not exists (select rd.ID_RESERV_DETAIL from reserv_detail rd where rd.ID_PERSON_PROFILE = :main_guest_profile_id)) then
    begin
      -- fill the mask with a default value if its is empty
      select p.id_person_data
      from   PROFILE_PERSON p
      where  p.ID_PROFILE = :main_guest_profile_id
      into   :id_person_data;

      update PERSON_DATA pd
      set    pd.MASK = :default_guest_mask
      where  pd.ID_PERSON_DATA = :id_person_data
             and pd.MASK is null;
    end
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => RES_CREATE_SET$EXC');
    execute procedure RES_CREATE_SET$EXC (
      :booking_id,
      :number,
      :arranger_profile_id,
      :main_guest_profile_id,
      :arrival,
      :departure,
      :adult_count,
      :children_count,
      :room_type_id,
      null,
      :board_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :voucher,
      :voucher_date,
      :voucher_text,
      null,
      null,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :arrival_type_code,
      :is_late_departure,
      :is_vip,
      :first_food_code,
      :special_treatment,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :arranger_account_id,
      :posting_routing,
      :guest_payment_type_id,
      :arranger_payment_type_id,
      null,
      :room_preferences,
      :maintance_shema_id,
      :note,
      :note_reminders,
      :deposit_required,
      :deposit_required_currency,
      :hotel_id,
      :reserv_group_id,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object,
      :create_datetime
      )
    returning_values :err_code, :err_text, :warn_code, :booking_id, :share_transaction_id, :share_err_code;
  end

  update reserv_detail rd
  set    rd.CHECK_OUT_KIND = :CHECK_OUT_KIND,
         rd.EARLYCHECKOUT_DATE = :EARLYCHECKOUT_DATE
  where  rd.ID_RESERV_DETAIL = :BOOKING_ID;

  execute procedure GUEST_STAY_INITIALIZE$INT (:booking_id);
  /* final error check */
  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;

  delete from PENDING_DEPOSIT d
  where  d.ID_RESERV_DETAIL = :BOOKING_ID;
end
^

/* Restore proc. body: IMPORT_GUEST$EXC */
ALTER PROCEDURE IMPORT_GUEST$EXC(BOOKING_ID INTEGER,
PROFILE_UUID VARCHAR(40),
GUEST_UUID VARCHAR(40),
GUEST_NAME VARCHAR(100),
IS_CHILD SMALLINT,
AGE INTEGER,
IS_DIFFERENT_ARRANGER SMALLINT,
ARRIVAL DATE,
DEPARTURE DATE,
VOUCHER VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
RATING_AGE INTEGER,
KPP VARCHAR(50),
KPP_DATE DATE,
STAY_REASON VARCHAR(255),
CAR VARCHAR(30),
IS_REGISTRED SMALLINT,
PERSONAL_NUMBER VARCHAR(30),
TITLE VARCHAR(10),
PT_NAME VARCHAR(100),
PT_EXTCODE VARCHAR(50),
PASS_NUM VARCHAR(20),
PASS_PLACE VARCHAR(20),
PASS_DATE DATE,
PASS_EXP_DATE DATE,
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_DATE DATE,
SEX CHAR,
BIRTH_PLACE VARCHAR(30),
MASK VARCHAR(10),
PACKAGE VARCHAR(255),
VISA TDESCRIPTION_SHORT)
 RETURNS(GUEST_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable warn_code integer;

declare variable birth_date_old date;
declare variable title_old varchar(10);
declare variable id_passport_type_old integer;
declare variable pass_num_old varchar(20);
declare variable pass_date_old date;
declare variable personal_number_old varchar(30);
declare variable id_stay_reason_old integer;
declare variable is_registred_old integer;
declare variable pass_place_old varchar(20);
declare variable city_old varchar(100);
declare variable address_old varchar(100);
declare variable birth_place_old varchar(30);
declare variable sex_old char(1);
declare variable mask_old varchar(10);
declare variable car_old varchar(30);
declare variable kpp_id_old integer;
declare variable kpp_date_old date;
declare variable pass_exp_date_old date;
declare variable rating_age_old integer;
declare variable visa_old tdescription_short;

declare variable guest_name_old varchar(100);
declare variable is_child_old integer;
declare variable arrival_old date;
declare variable departure_old date;
declare variable voucher_old varchar(30);
declare variable voucher_date_old date;
declare variable voucher_text_old varchar(30);
declare variable country_code_old varchar(10);

declare variable id_passport_type integer;
declare variable kpp_id integer;
declare variable id_stay_reason integer;
begin
  execute procedure import_mark_transaction$exc;

  guest_name = substring(:guest_name from 1 for 50);

  execute procedure sys_dbg('exc IMPORT_GUEST$EXC(:guest_uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
  guest_id = null;

  select pd.person_name, --g.is_different_organizer,
         g.id_guest, g.from_date, g.to_date,
         pd.birthday_internal, pd.title, pd.id_passport_type,
         pd.pass_num, pd.pass_date, pd.egn, gd.id_stay_reason,
         gd.is_registred, pd.pass_place, pd.city, pd.address, pd.birth_place,
         pd.sex, pd.mask, g.is_child, gd.car, gd.kpp, gd.kpp_date,
         pd.pass_exp_date, gd.rating_age, g.vaucher_num, g.vaucher_date, g.vaucher_text, pd.country_code,
         gd.id_stay_reason, gd.visa
  from   GUEST g
         join guest_data gd on gd.id_guest=g.id_guest
         join person_data pd on pd.id_person_data=gd.id_person_data
  where  g.uuid=:guest_uuid
         and g.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and g.id_reserv_detail=:booking_id
  into   :guest_name_old, --:is_different_arranger_old,
         :guest_id, :arrival_old, :departure_old, :birth_date_old,
         :title_old, :id_passport_type_old,
         :pass_num_old, :pass_date_old, :personal_number_old, :id_stay_reason_old,
         :is_registred_old, :pass_place_old, :city_old, :address_old, :birth_place_old,
         :sex_old, :mask_old, :is_child_old, :car_old, :kpp_id_old, :kpp_date_old,
         :pass_exp_date_old, :rating_age_old, :voucher_old, :voucher_date_old,
         :voucher_text_old, :country_code_old, :id_stay_reason_old, :visa_old;

  execute procedure import_passport_type$exc(:pt_name, pt_extcode)
  returning_values :id_passport_type;

  execute procedure import_kpp$exc(:kpp, null)
  returning_values :kpp_id;

  execute procedure import_stay_reason$exc(:stay_reason, null)
  returning_values :id_stay_reason;

  guest_name = coalesce(:guest_name, :guest_name_old);
--  DISABLE age/is_child merge (RIU rating cases)
--  is_child = coalesce(:is_child, :is_child_old);
--  is_different_arranger = coalesce(:is_different_arranger, :is_different_arranger_old);
  arrival = coalesce(:arrival, :arrival_old);
  departure = coalesce(:departure, :departure_old);
--  arrival = :arrival_old;
--  departure = :departure_old;
  voucher = coalesce(:voucher, :voucher_old);
  voucher_date = coalesce(:voucher_date, :voucher_date_old);
  voucher_text = coalesce(:voucher_text, :voucher_text_old);
  country_code = coalesce(:country_code, :country_code_old);

--  DISABLE age/is_child merge (RIU rating cases)
--  rating_age = coalesce(:rating_age, :rating_age_old);
  kpp_id = coalesce(:kpp_id, :kpp_id_old);
  kpp_date = coalesce(:kpp_date, :kpp_date_old);
  id_stay_reason = coalesce(:id_stay_reason, :id_stay_reason_old);
  car = coalesce(:car, :car_old);
  is_registred = coalesce(:is_registred, 0);
  if (1 = :is_registred_old) then begin --one way update
    is_registred = 1;
  end
  personal_number = coalesce(:personal_number, :personal_number_old);
  title = coalesce(:title, :title_old);
  id_passport_type = coalesce(:id_passport_type, :id_passport_type_old);
  pass_num = coalesce(:pass_num, :pass_num_old);
  pass_place = coalesce(:pass_place, :pass_place_old);
  pass_date = coalesce(:pass_date, :pass_date_old);
  pass_exp_date = coalesce(:pass_exp_date, :pass_exp_date_old);
  city = coalesce(:city, :city_old);
  address = coalesce(:address, :address_old);
  birth_date = coalesce(:birth_date, :birth_date_old);
  sex = coalesce(:sex, :sex_old);
  birth_place = coalesce(:birth_place, :birth_place_old);
  mask = coalesce(:mask, :mask_old);
  visa = coalesce(:visa, :visa_old);

  if (:guest_id is null) then begin
    execute procedure RES_GUEST_SAVE$RSV(null, :booking_id, :guest_name, null, null, :is_child)
    returning_values :guest_id;

    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - get_next_auto_guest = :guest_id=>' || coalesce(:guest_id, '<null>'));
    if (:guest_id is null) then begin 
      execute procedure sys_dbg('exc IMPORT_GUEST$EXC - exhausted auto guests list - create new guest');
      execute procedure RES_GUEST_ADD$RSV(:booking_id, :is_child)
      returning_values :err_code, :err_text, :warn_code, :guest_id;
      if (0 <> :err_code) then exit;
    end

    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - update_new_guest_uuid(:guest_id=>' || coalesce(:guest_id, '<null>') || ', :uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
    update GUEST
    set    uuid = :guest_uuid
    where  id_guest=:guest_id;

    /* preserve default mask */
    if (:mask is null) then begin
      select pd.mask
      from   guest_data gd
             join person_data pd on pd.id_person_data=gd.id_person_data
      where  gd.id_guest=:guest_id
      into   :mask;
    end          
  end else begin
    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - update_guest(:update_guest_id=>' || coalesce(:guest_id, '<null>') || ')');

--    DISABLE age/is_child merge (RIU rating cases) 
--    if (:age is null) then begin
--      select age from GUEST_AGE_CALC(:guest_id)
--      into :age;
--    end
  end

  /*
  execute procedure sys_dbg('exc IMPORT_GUEST$EXC->GUEST_ADDRESSCARD_SET$RSV('
  || 'update_guest_id => ' || coalesce(:update_guest_id, '<null>')
  || ', guest_name => ' || coalesce(:guest_name, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  || ', :id_passport_type => ' || coalesce(:id_passport_type, '<null>')
  || ', :pass_num => ' || coalesce(:pass_num, '<null>')
  || ', :pass_date => ' || coalesce(:pass_date, '<null>')
  || ', :egn => ' || coalesce(:egn_old, '<null>')
  || ', :country => ' || coalesce(:country_old, '<null>')
  || ', :id_stay_reason => ' || coalesce(:id_stay_reason, '<null>')
  || ', :is_registred => ' || coalesce(:is_registred, '<null>')
  || ', :pass_place => ' || coalesce(:pass_place, '<null>')
  || ', :city => ' || coalesce(:city, '<null>')
  || ', :address => ' || coalesce(:address, '<null>')
  || ', :birth_place => ' || coalesce(:birth_place, '<null>')
  || ', :sex => ' || coalesce(:sex, '<null>')
  || ', :mask => ' || coalesce(:mask, '<null>')
  || ', :is_child => ' || coalesce(:is_child, '<null>')
  || ', :car => ' || coalesce(:car, '<null>')
  || ', :kpp => ' || coalesce(:kpp_old, '<null>')
  || ', :kpp_date => ' || coalesce(:kpp_date, '<null>')
  || ', :pass_exp_date => ' || coalesce(:pass_exp_date, '<null>')
  || ', :age => ' || coalesce(:age, '<null>')
  || ', :birth_date => ' || coalesce(:birth_date, '<null>')
  || ', :rating_age => ' || coalesce(:rating_age, '<null>')
  || ', :title => ' || coalesce(:title, '<null>')
  ||')');
  */
  execute procedure GUEST_ADDRESSCARD_SET$RSV(
    :guest_id,
    :guest_name,
    null,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :personal_number,
    :country_code,
    :id_stay_reason,
    :is_registred,
    :pass_place,
    :city,
    :address,
    :birth_place,
    :sex,
    :mask,
    :is_child,
    :car,
    :kpp_id,
    :kpp_date,
    :pass_exp_date,
    :age,
    :birth_date,
    :visa,
    :rating_age,
    :title,
    0
  )
  returning_values :err_code, :err_text, :warn_code;
  if (0 <> :err_code) then exit;

  --execute procedure RES_GUEST_SAVE_ORGANIZER$RSV(:guest_id, :is_different_arranger);

  if ((:arrival is not null) and (:departure is not null)) then begin
    execute procedure RES_GUEST_SAVE_STAY$RSV(:guest_id, :arrival, :departure)
    returning_values :err_code, :err_text, :warn_code;
    if (0 <> :err_code) then exit;
  end

  if (:voucher is not null) then begin
    execute procedure RES_GUEST_SAVE_VOUCHER$RSV(:guest_id, :voucher,
            :voucher_date, :voucher_text, null, null);
  end

  execute procedure IMPORT_GUEST_PACK$EXC(:guest_id, :package);

  update GUEST
  set    ORPHANED_IMPORT$EXC = null
  where  id_guest=:guest_id;
end
^

/* Restore proc. body: IMPORT_PAYMENT_TYPE$EXC */
ALTER PROCEDURE IMPORT_PAYMENT_TYPE$EXC(UUID VARCHAR(40),
NAME VARCHAR(50),
GROUP_TAG VARCHAR(20),
DESCRIPTION VARCHAR(100),
IS_AR_DEBT SMALLINT,
IS_CASH SMALLINT,
IS_CC SMALLINT,
IS_USE SMALLINT,
FISCAL_CODE VARCHAR(50),
HOTEL_NAME VARCHAR(50))
 RETURNS(PAYMENT_TYPE_ID INTEGER)
 AS
declare variable id_hotel integer;
  declare variable old_name varchar(50);
  declare variable old_group_tag        varchar(20);
  declare variable old_description      varchar(100);
  declare variable old_is_ar_debt       smallint;
  declare variable old_is_cash          smallint;
  declare variable old_is_cc            smallint;
  declare variable old_is_use           smallint;
  declare variable old_fiscal_code      varchar(50);
  declare variable mod_op varchar(10);
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'PAYMENT_TYPE', :NAME)
  returning_values :ID_HOTEL;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:NAME, 'PAYMENT_TYPE');

  select
    id_payment_type,
    payment_type,
    group_tag,
    description,
    is_ar_debt,
    is_cash,
    is_cc,
    is_use,
    fiscal_code
  from payment_type
  where uuid=:uuid and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into
    :payment_type_id,
    :old_name,
    :old_group_tag,
    :old_description,
    :old_is_ar_debt,
    :old_is_cash,
    :old_is_cc,
    :old_is_use,
    :old_fiscal_code;

  name = coalesce(:name, :old_name);
  group_tag = coalesce(:group_tag, :old_group_tag);
  description = coalesce(:description, :old_description);
  is_ar_debt = coalesce(:is_ar_debt, :old_is_ar_debt);
  is_cash = coalesce(:is_cash, :old_is_cash);
  is_cc = coalesce(:is_cc, :old_is_cc);
  is_use = coalesce(:is_use, :old_is_use);
  fiscal_code = coalesce(:fiscal_code, :old_fiscal_code);

  if (:payment_type_id is null) then begin
    mod_op = 'add';
  end else begin
    mod_op = 'mod';
  end

  execute procedure payment_type_modify$cfg(
    :payment_type_id,
    :name,
    :group_tag,
    :description,
    :is_ar_debt,
    :is_cash,
    :is_cc,
    :is_use,
    :fiscal_code,
    :mod_op,
    :id_hotel) returning_values :payment_type_id;

  /* sync uuid field */
  update payment_type
  set uuid=:uuid
  where id_payment_type=:payment_type_id;
end
^

/* Restore proc. body: IMPORT_RATE$EXC */
ALTER PROCEDURE IMPORT_RATE$EXC(TARIFA_NAME VARCHAR(50),
TARIFA_GROUP VARCHAR(30),
HOTEL_NAME VARCHAR(50),
TARIFA_CURR VARCHAR(3),
IS_ACTIVE SMALLINT,
TARIFA_NOTE VARCHAR(500),
PERIOD_DEPEND_ON_CHECKIN SMALLINT,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BOARD_TYPE VARCHAR(10),
SOURCE_BASE_BOARDS_LIST VARCHAR(255),
TMP_DATA BLOB SUB_TYPE 1,
LOCK_KEY VARCHAR(100),
LOCK_STAMP TIMESTAMP,
UUID VARCHAR(40),
RATE_TYPE VARCHAR(20),
IS_SIMPLE SMALLINT,
CHILD_AGE_INCL INTEGER,
IS_PUBLIC TYPE OF TLOGICAL,
EXPLICIT_TAX_POLICY_NAME TDESCRIPTION_SHORT = null,
EXPLICIT_POLICY_NIGHTS_REQUIRED TCOUNT = null)
 RETURNS(ID_TARIFA INTEGER,
ID_TARIFA_GROUP INTEGER,
ID_HOTEL INTEGER,
ID_TAR_SIMPLE INTEGER)
 AS
declare variable BASE_BOARDS_LIST varchar(255);
  declare variable BOARD_NAME varchar(30);
  declare variable ID_BOARD integer;
  declare variable EXPLICIT_TAX_POLICY integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure IMPORT_RATE_COMMON$EXC(:TARIFA_NAME, :TARIFA_GROUP, :HOTEL_NAME, :TARIFA_CURR, 1, :IS_ACTIVE,
    :TARIFA_NOTE, :UUID, :RATE_TYPE, :IS_SIMPLE, :IS_PUBLIC, :CHILD_AGE_INCL)
  returning_values :ID_TARIFA, :ID_TARIFA_GROUP, :ID_HOTEL;

  select ts.ID_TAR_SIMPLE
  from   TAR_SIMPLE ts
  where  ts.ID_TAR_HEAD = :ID_TARIFA
  into   :ID_TAR_SIMPLE;

  BASE_BOARDS_LIST = '';
  for
    select ITEM
    from   SYSTEM_STRING_PARSER(:SOURCE_BASE_BOARDS_LIST, ',')
    into   :BOARD_NAME
  do begin
    execute procedure LOOKUP_BOARD$EXC(:ID_HOTEL, :TARIFA_NAME, :RATE_TYPE, :BOARD_NAME, 0)
    returning_values :ID_BOARD;
    BASE_BOARDS_LIST = BASE_BOARDS_LIST || F_CHARACTER(28) || ID_BOARD;
  end

  if (:EXPLICIT_TAX_POLICY_NAME is not null) then begin
    execute procedure LOOKUP_TAX_POLICY$EXC(:ID_HOTEL, :TARIFA_NAME, :RATE_TYPE, :EXPLICIT_TAX_POLICY_NAME)
    returning_values :EXPLICIT_TAX_POLICY;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:TARIFA_NAME, :RATE_TYPE);

  update TAR_HEAD th
  set    th.PERIOD_DEPEND_ON_CHECKIN = :PERIOD_DEPEND_ON_CHECKIN,
         th.CNT_DAYS_PRICE_BP = :CNT_DAYS_PRICE_BP,
         th.CNT_DAYS_PRICE_BOARD = :CNT_DAYS_PRICE_BOARD,
         th.BASE_BOARDS_LIST = :BASE_BOARDS_LIST,
         th.BOARD_TYPE = :BOARD_TYPE,
         th.TMP_DATA = :TMP_DATA,
         th.LOCK_KEY = :LOCK_KEY,
         th.LOCK_STAMP = :LOCK_STAMP,
         th.EXPLICIT_TAX_POLICY = :EXPLICIT_TAX_POLICY,
         th.EXPLICIT_POLICY_NIGHTS_REQUIRED = :EXPLICIT_POLICY_NIGHTS_REQUIRED
  where  th.ID_TAR_HEAD = :ID_TARIFA;
end
^

/* Restore proc. body: IMPORT_RATE_RECORD_RELINK$EXC */
ALTER PROCEDURE IMPORT_RATE_RECORD_RELINK$EXC(ID_RATE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ID_COLUMN integer;
declare variable ID_NEW_MASTER_RECORD integer;

declare variable PERIOD_DEPEND_ON_CHECKIN INTEGER;
declare variable CNT_DAYS_PRICE_BP INTEGER;
declare variable CNT_DAYS_PRICE_BOARD INTEGER;
declare variable BASE_BOARDS_LIST VARCHAR(255);
declare variable BOARD_TYPE VARCHAR(10);
begin
  execute procedure import_mark_transaction$exc;

  ERR_CODE = 0;
  ERR_TEXT = '';
  for
    select c.ID_TAR_DEFINE_COLUMN, im.ID_NEW
    from   TAR_UI_DEFINE_COLUMNS c
           join IDS_MAP$TMP im on c.ID_DIM2 = im.ID_OLD
    where  c.ID_TAR_HEAD = :ID_RATE
    into   :ID_COLUMN, :ID_NEW_MASTER_RECORD
  do begin
    update TAR_UI_DEFINE_COLUMNS c
    set    c.ID_DIM2 = :ID_NEW_MASTER_RECORD
    where  c.ID_TAR_DEFINE_COLUMN = :ID_COLUMN;
  end

  delete from IDS_MAP$TMP;


  select
        th.PERIOD_DEPEND_ON_CHECKIN,
        th.CNT_DAYS_PRICE_BP,
        th.CNT_DAYS_PRICE_BOARD,
        th.BASE_BOARDS_LIST,
        th.BOARD_TYPE
  from  TAR_HEAD th
  where th.ID_TAR_HEAD = :ID_RATE
  into  :PERIOD_DEPEND_ON_CHECKIN, :CNT_DAYS_PRICE_BP, :CNT_DAYS_PRICE_BOARD, :BASE_BOARDS_LIST, :BOARD_TYPE;

  for
    select ERR_CODE, ERR_TEXT
    from   TAR_SAVE(:ID_RATE, :PERIOD_DEPEND_ON_CHECKIN, :CNT_DAYS_PRICE_BP, :CNT_DAYS_PRICE_BOARD, :BASE_BOARDS_LIST, :BOARD_TYPE)
    into   :err_code, :err_text
  do begin
    if (0 <> :err_code) then begin
      exit;
    end
  end
end
^

/* Restore proc. body: IMPORT_RATE_SIMPLE_BOARD$EXC */
ALTER PROCEDURE IMPORT_RATE_SIMPLE_BOARD$EXC(ID_HOTEL INTEGER,
ID_TAR_SIMPLE_SEASON INTEGER,
RATE_NAME VARCHAR(30),
BOARD_NAME VARCHAR(30),
ADULT_PRICE NUMERIC(15,4),
CHILD_PRICE NUMERIC(15,4))
 RETURNS(ID_TAR_SIMPLE_BOARDS INTEGER)
 AS
declare variable ID_BOARD_TYPE integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_BOARD$EXC(:ID_HOTEL, :RATE_NAME, 'RATE_SIMPLE', :BOARD_NAME, 1)
  returning_values :ID_BOARD_TYPE;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:RATE_NAME, 'ROOM_TYPE');

  execute procedure TAR_SIMPLE_BOARD_MODIFY$CFG(null,
                                                :ID_TAR_SIMPLE_SEASON,
                                                :ID_BOARD_TYPE,
                                                :ADULT_PRICE,
                                                :CHILD_PRICE,
                                                'add')
  returning_values :ID_TAR_SIMPLE_BOARDS;
end
^

/* Restore proc. body: IMPORT_RATE_SIMPLE_PRICE$EXC */
ALTER PROCEDURE IMPORT_RATE_SIMPLE_PRICE$EXC(ID_TAR_SIMPLE_SEASON INTEGER,
RATE_NAME VARCHAR(30),
HOTEL_NAME VARCHAR(50),
ROOM_TYPE VARCHAR(20),
BOARD_NAME VARCHAR(30),
SINGLE_PRICE NUMERIC(15,4),
DOUBLE_PRICE NUMERIC(15,4),
GUEST3_PRICE NUMERIC(15,4),
GUEST4PLUS_PRICE NUMERIC(15,4),
CHILD1_W_ADULT1_PRICE NUMERIC(15,4),
CHILD1_W_ADULT2PLUS_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT1_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT2PLUS_PRICE NUMERIC(15,4),
IS_BASE_DAYS_PRICE SMALLINT)
 AS
declare variable ID_HOTEL integer;
declare variable ID_ROOM_TYPE integer;
declare variable ID_BOARD_TYPE integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'RATE_SIMPLE', :RATE_NAME)
  returning_values :ID_HOTEL;

  execute procedure LOOKUP_ROOM_TYPE$EXC(:ID_HOTEL, :RATE_NAME, 'RATE_SIMPLE', :ROOM_TYPE)
  returning_values :ID_ROOM_TYPE;

  execute procedure LOOKUP_BOARD$EXC(:ID_HOTEL, :RATE_NAME, 'RATE_SIMPLE', :BOARD_NAME, 1)
  returning_values :ID_BOARD_TYPE;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:RATE_NAME, 'RATE_SIMPLE');

  execute procedure TAR_SIMPLE_PRICE_MODIFY$CFG(:ID_TAR_SIMPLE_SEASON,
                                                :ID_ROOM_TYPE,
                                                :ID_BOARD_TYPE,
                                                :SINGLE_PRICE,
                                                :DOUBLE_PRICE,
                                                :GUEST3_PRICE,
                                                :GUEST4PLUS_PRICE,
                                                :CHILD1_W_ADULT1_PRICE,
                                                :CHILD1_W_ADULT2PLUS_PRICE,
                                                :CHILD2PLUS_W_ADULT1_PRICE,
                                                :CHILD2PLUS_W_ADULT2PLUS_PRICE,
                                                :IS_BASE_DAYS_PRICE);
end
^

/* Restore proc. body: IMPORT_ROOM_TYPE$EXC */
ALTER PROCEDURE IMPORT_ROOM_TYPE$EXC(TYPE_ROOM VARCHAR(20),
BEDS INTEGER,
EXT_CODE VARCHAR(30),
UUID VARCHAR(40),
HOTEL_NAME VARCHAR(50))
 RETURNS(ID_ROOM_TYPE INTEGER)
 AS
declare variable id_hotel integer;
declare variable operation varchar(3);
declare variable overrule_need integer;
declare variable overrule_context varchar(255) ;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'ROOM_TYPE', :TYPE_ROOM)
  returning_values :ID_HOTEL;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:TYPE_ROOM, 'ROOM_TYPE');

  ID_ROOM_TYPE = null;
  select rt.ID_ROOM_TYPE
  from   ROOM_TYPES rt
  where  rt.UUID = :UUID and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :ID_ROOM_TYPE;

  if (:ID_ROOM_TYPE is null) then begin
    OPERATION = 'add';
  end else begin
    OPERATION = 'mod';
  end

  execute procedure ROOM_TYPE_MODIFY$CFG(:ID_HOTEL, :ID_ROOM_TYPE, :TYPE_ROOM, :BEDS, :EXT_CODE, :OPERATION)
  returning_values :ID_ROOM_TYPE, :overrule_need, :overrule_context;
  if (:overrule_need <> 0) then exception ASSERT :overrule_need || f_character(31) || coalesce(:overrule_context, '');

  update ROOM_TYPES rt
  set    rt.UUID = :UUID
  where  rt.ID_ROOM_TYPE = :ID_ROOM_TYPE;
end
^

/* Restore proc. body: IMPORT_SERVICE$EXC */
ALTER PROCEDURE IMPORT_SERVICE$EXC(SERVICE_NAME VARCHAR(30),
SERVICE_GROUP VARCHAR(30),
SERVICE_TYPE VARCHAR(50),
IS_DELETED SMALLINT,
IS_MANUAL_PRICE SMALLINT,
IS_DETAILS SMALLINT,
REVENUE_GROUP VARCHAR(50),
REVENUE_ACCOUNT VARCHAR(50),
ACCOUNT_NAME VARCHAR(30),
EXT_CODE VARCHAR(30),
VAUCHER_PACKET VARCHAR(20),
EXTRA_PACKET_NAME VARCHAR(10),
IS_RATE_PRICE SMALLINT,
IS_BREAKFAST SMALLINT,
IS_LUNCH SMALLINT,
IS_DINNER SMALLINT,
IS_EXTRAFOOD1 SMALLINT,
IS_EXTRAFOOD2 SMALLINT,
IS_BOARD SMALLINT,
PRICE NUMERIC(15,4),
PRICE_CURR VARCHAR(3),
HOTEL_NAME VARCHAR(50),
UUID VARCHAR(40))
 RETURNS(ID_SERVICE INTEGER,
ID_SERVICE_GROUP INTEGER)
 AS
declare variable ID_HOTEL integer;
declare variable OPERATION VARCHAR(3);
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'SERVICE', :SERVICE_NAME)
  returning_values :ID_HOTEL;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:SERVICE_NAME, 'SERVICE');

  execute procedure IMPORT_SERVICE_GROUP$EXC(:ID_HOTEL, :SERVICE_GROUP)
  returning_values :ID_SERVICE_GROUP;

  ID_SERVICE = null;
  select s.ID_SERVICE
  from   SERVICES s
  where  s.UUID = :UUID
         and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :ID_SERVICE;

  if (:ID_SERVICE is null) then begin
    OPERATION = 'add';
  end else begin
    OPERATION = 'mod';
  end

  if (:EXTRA_PACKET_NAME is null) then begin
    EXTRA_PACKET_NAME = '';
  end

  execute procedure SERVICE_MODIFY(:ID_SERVICE, :ID_SERVICE_GROUP, :SERVICE_TYPE, :SERVICE_NAME,
    :IS_DELETED, :IS_MANUAL_PRICE, :IS_DETAILS, :REVENUE_GROUP, :REVENUE_ACCOUNT,
    :ACCOUNT_NAME, :EXT_CODE, :VAUCHER_PACKET, :EXTRA_PACKET_NAME, :IS_RATE_PRICE,
    :OPERATION, :ID_HOTEL, :IS_BREAKFAST, :IS_LUNCH, :IS_DINNER, :IS_EXTRAFOOD1, :IS_EXTRAFOOD2,
    :IS_BOARD, :PRICE, :PRICE_CURR)
  returning_values :ID_SERVICE;

  update SERVICES s
  set    s.UUID = :UUID
  where  s.ID_SERVICE = :ID_SERVICE;
end
^

/* Restore proc. body: MONITOR_ROOM_GANTT$HM */
ALTER PROCEDURE MONITOR_ROOM_GANTT$HM(FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ID_ROOM INTEGER,
GFROM_DATE DATE,
IS_MOVED_FROM INTEGER,
GTO_DATE DATE,
IS_MOVED_TO INTEGER,
BUSY_GRP INTEGER,
OCCUPANT_ID INTEGER,
IN_SHARE SMALLINT,
ID_GROUP INTEGER,
ATTENTION_STATUS SMALLINT)
 AS
declare variable contiguous_id_room integer;
begin
  for
    select ID_ROOM, GFROM_DATE, IS_MOVED_FROM, GTO_DATE,
           IS_MOVED_TO, BUSY_GRP, OCCUPANT_ID
    from   MONITOR_ROOM_GANTT$INT(:from_date, :to_date)
    into   :id_room, :gfrom_date, :is_moved_from, :gto_date,
           :is_moved_to, :busy_grp, :occupant_id
  do begin
    if (:gfrom_date = :from_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gfrom_date - 1)
      into   :contiguous_id_room;

      if ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_from = 1;

      select O.FROM_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gfrom_date;
    end

    if (:gto_date = :to_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gto_date + 1)
      into   :contiguous_id_room;

      if ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_to = 1;

      select O.TO_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gto_date;
    end

    if (:busy_grp in (1, 24)) then begin
      select RI.ATTENTION_STATUS, RI.ID_GROUP, RI.IN_SHARE
      from   RES_GET_INFO$RSV(:occupant_id, 0, 1, 0) RI
      into   :attention_status, :id_group, :in_share;
    end else begin
      id_group = null;
      attention_status = null;
      in_share = null;
      if (exists(
        select *
        from   ROOMS_SHARE RS
        where  RS.ID_RESERV_DETAIL = :occupant_id
      )) then in_share = 1;
      else in_share = 0;
    end
    suspend;
  end
end
^

/* Restore proc. body: MONITOR_ROOM_GANTT_OCCUPANT$HM */
ALTER PROCEDURE MONITOR_ROOM_GANTT_OCCUPANT$HM(FROM_DATE DATE,
TO_DATE DATE,
REQUEST_OCCUPANT_ID INTEGER)
 RETURNS(ID_ROOM INTEGER,
GFROM_DATE DATE,
IS_MOVED_FROM INTEGER,
GTO_DATE DATE,
IS_MOVED_TO INTEGER,
BUSY_GRP INTEGER,
OCCUPANT_ID INTEGER,
IN_SHARE SMALLINT,
ID_GROUP INTEGER,
ATTENTION_STATUS SMALLINT)
 AS
declare variable contiguous_id_room integer;
begin
  for
    select ID_ROOM, GFROM_DATE, IS_MOVED_FROM, GTO_DATE,
           IS_MOVED_TO, BUSY_GRP, OCCUPANT_ID
    from   MONITOR_ROOM_GANTT$INT(:from_date, :to_date, :request_occupant_id)
    into   :id_room, :gfrom_date, :is_moved_from, :gto_date,
           :is_moved_to, :busy_grp, :occupant_id
  do begin
    if (:gfrom_date = :from_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gfrom_date - 1)
      into   :contiguous_id_room;

      if     ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_from = 1;

      select O.FROM_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gfrom_date;
    end

    if (:gto_date = :to_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gto_date + 1)
      into   :contiguous_id_room;

      if ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_to = 1;

      select O.TO_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gto_date;
    end

    if (exists(
      select *
      from   ROOMS_SHARE RS
      where  RS.ID_ROOM = :id_room
             and RS.BUSY_DATE between :from_date and :to_date
    )) then in_share = 1;
    else in_share = 0;
  
    if (:busy_grp in (1,24)) then begin
      select RI.ATTENTION_STATUS, RI.ID_GROUP
      from   RES_GET_INFO$RSV(:occupant_id, 0, 0, 0) RI
      into   :attention_status, :id_group;
    end else begin
      id_group = null;
      attention_status = null;
    end
    suspend;
  end
end
^

/* Restore proc. body: NUMERATOR_MODIFY$CFG */
ALTER PROCEDURE NUMERATOR_MODIFY$CFG(ID_NUMERATOR INTEGER,
NUM_NAME VARCHAR(50),
NUM_NEXT INTEGER,
LEADING_PART VARCHAR(20),
NUM_LENGTH INTEGER,
NUM_CLASS TYPE OF TNAME_SHORT,
ID_HOTEL TYPE OF ID_REF,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_NUMERATOR INTEGER)
 AS
begin

  if (:NUM_CLASS = 'BOOKING') then ID_HOTEL = null;

  execute procedure SYSTEM_NUMERATOR_MODIFY$INT(:id_numerator, :num_class, :num_name, :num_next - 1, :leading_part,
                    :num_length, :id_hotel, :operation)
  returning_values  :new_id_numerator;
end
^

/* Restore proc. body: OCCUPANCY_ACTIVE_FRAME_CHK$INT */
ALTER PROCEDURE OCCUPANCY_ACTIVE_FRAME_CHK$INT(ID_AGENT INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM_TYPE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable active_frame_begin integer;
  declare variable active_frame_end integer;
  declare variable outside_frame_end integer;
  declare variable outside_frame_begin integer;
  declare variable id_hotel integer;
  declare variable system_date date;
begin
  /*  Description:
  ||
  */
  if (:ID_AGENT is null) then exit;
  /*  */
  err_code = 0;
  err_text = '';
  active_frame_begin = 0;
  active_frame_end   = 0;

  select rt.ID_HOTEL
  from   ROOM_TYPES rt
  where  rt.ID_ROOM_TYPE = :ID_ROOM_TYPE
  into   :id_hotel;

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  select first 1
         AR.DAYS_BEFORE, AR.DAYS_AFTER
  from   PROFILE_AGENT PA
         join ALLOTMENT A on A.ID_ALLOTMENT = PA.ID_CONTINGENT
         join ALLOTMENT_RELEASE AR on AR.ID_ALLOTMENT = A.ID_ALLOTMENT
  where  PA.ID_AGENT = :id_agent
         and AR.ID_ROOM_TYPE = :id_room_type
         and AR.FROM_DATE <= :to_date
         and AR.TO_DATE   >= :from_date
  into   :active_frame_begin, :active_frame_end;

  /* CHECK CONTINGENT RIGHTS FOR BOOKING OUTSIDE THE ACTIVE FRAME */
  if (:active_frame_end > 0) then outside_frame_end = (:to_date - :system_date) - :active_frame_end;
  else outside_frame_end = 0;
  if (:active_frame_begin > 0) then outside_frame_begin = (:from_date - :system_date) - :active_frame_begin;
  else outside_frame_begin = 0;

  if ((:outside_frame_begin > 0) or (:outside_frame_end > 0)) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_RELEASE_DATE');

    when exception RIGHT_NOT_GRANTED do begin
      if (:outside_frame_begin > :outside_frame_end) then begin
        err_code = -98;
        err_text = f_character(29)||FormatDate(:from_date, 'D;dd.mm.yyyy')||f_character(28)||:outside_frame_begin;
      end else begin
        err_code = -107;
        err_text = f_character(29)||FormatDate(:to_date, 'D;dd.mm.yyyy')||f_character(28)||:outside_frame_end;
      end
    end
  end
end
^

/* Restore proc. body: OCCUPANCY_OVERBOOK_CHECK$INT */
ALTER PROCEDURE OCCUPANCY_OVERBOOK_CHECK$INT(ID_AGENT INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM_TYPE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable must_check_overbook integer;
  declare variable maxbook_date  date;
  declare variable maxbook_rooms  integer;
  declare variable agent_maxbook_date date;
  declare variable agent_maxbook_rooms integer;
  declare variable id_inventory_allotment integer;
  declare variable id_agent_contingent integer;
  declare variable available_rooms integer;
  declare variable problem_date date;
  declare variable room_type varchar(20);
  declare variable id_hotel integer;
begin
  /* 1. DEALING WITH THE TOTAL OVERBOOK.
  || 2. DEALING WITH THE CONTINGENT OVERBOOK.
  */
  err_code = 0;
  err_text = '';
  warn_code = null;

  /* CHECK THE TOTAL HOTEL AVAILABILITY*/
  select H.ID_INVENTORY_ALLOTMENT, RT.TYPE_ROOM, h.ID_HOTEL
  from   ROOM_TYPES RT
         join HOTEL H on H.ID_HOTEL = RT.ID_HOTEL
  where  RT.ID_ROOM_TYPE = :id_room_type
  into   :id_inventory_allotment, :room_type, :id_hotel;

  execute procedure SETTING_GET_VALUE('CHECK_OVERBOOK', :id_hotel)
  returning_values  :must_check_overbook;

  if (:must_check_overbook = 0) then exit;
  /* ********************************** */
  execute procedure OCCUPANCY_OVERBOOK_MAX$INT(:from_date, :to_date, :id_inventory_allotment, :id_room_type)
  returning_values  :maxbook_date, :maxbook_rooms, :available_rooms;

  if (:available_rooms < 0) then begin
    problem_date = :maxbook_date;
    err_text = substring(f_character(29)||cast(abs(:available_rooms) as integer)||f_character(28)||FormatDate(:problem_date, 'D;dd.mm.yyyy')||f_character(28)||:room_type from 1 for 255);

    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_TOTAL_OVERBOOK');

    execute procedure SYSTEM_WARNING_ADD(-95, :err_text)
    returning_values :warn_code;

    when exception RIGHT_NOT_GRANTED do begin
      err_code = -94;
      exit;
    end
  end

  /* check agent contingent overbooko *****************************************/
  select PA.ID_CONTINGENT
  from   PROFILE_AGENT PA
  where  PA.ID_AGENT = :id_agent
  into   :id_agent_contingent;

  if (:id_agent_contingent is not null) then begin
    /* CHECK THE AGENT CONTINGENT AVAILABILITY*/
    execute procedure OCCUPANCY_OVERBOOK_MAX$INT(:from_date, :to_date, :id_agent_contingent, :id_room_type, :id_agent)
    returning_values  :agent_maxbook_date, :agent_maxbook_rooms, :available_rooms;
  
    if (:available_rooms < 0) then begin
      problem_date = :agent_maxbook_date;
      err_text = f_character(29)||FormatDate(:problem_date, 'D;dd.mm.yyyy')||f_character(28)||:room_type||f_character(28)||cast(abs(:available_rooms) as integer);
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CONT_OVERBOOK');

      execute procedure SYSTEM_WARNING_ADD(-97, :err_text)
      returning_values :warn_code;

      when exception RIGHT_NOT_GRANTED do begin
        err_code = -96;
        exit;
      end
    end
  end
end
^

/* Restore proc. body: OCCUPANCY_SUMMARY_REMAKE$SYS */
ALTER PROCEDURE OCCUPANCY_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
begin
  if (not exists (select h.ID_HOTEL
                  from   HOTEL H
                  where  h.ID_HOTEL = :ID_HOTEL)) then exception WRONG_VALUE 'Non-existing hotel!';

  select mindate(sd.SYSTEM_DATE - 1, :TO_DATE)
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :TO_DATE;

  if (:FROM_DATE > :TO_DATE) then exit;

  execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:id_hotel, :FROM_DATE, :TO_DATE);

  execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'OCCUPANCY_REGENERATE',
                                    f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') || f_character(28) || formatdate(:to_date, 'D;dd/mm/yyyy'));
end
^

/* Restore proc. body: OCCUPANT_GET_INFO */
ALTER PROCEDURE OCCUPANT_GET_INFO(ID_OCCUPANT INTEGER,
IN_BUSY_GRP INTEGER = null)
 RETURNS(BUSY_GRP INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
INFO VARCHAR(1024))
 AS
declare variable max_day_action integer;
begin
  --busy_grp = :in_busy_grp;

  select max(RM.DAY_ACTION_INT), min(rm.BUSY_GROUP_TYPE)
  from   ROOM_MAGIC RM
  where  RM.ID_RESERV_DETAIL = :ID_OCCUPANT
         --and RM.BUSY_GROUP_TYPE = :busy_grp
  into   :max_day_action, :busy_grp;

  if (:busy_grp in (18, 20) and :max_day_action = 0) then begin
    select BGI.BUSY_GRP, BGI.REASON, BGI.FROM_DATE, BGI.TO_DATE
    from   BLOCK_GET_INFO(:id_occupant) BGI
    into   :busy_grp, :info, :from_date, :to_date;
  end else begin
    -- when :busy_grp in (1, 24) or (:max_day_action > 0) - reservation with block busy group type - owners, as an example
    select RGI.BUSY_GRP, RGI.NUMBER, RGI.ARRIVAL_DATE, RGI.DEPARTURE_DATE
    from   RES_GET_INFO$RSV(:id_occupant, 0, 0, 0) RGI
    into   :busy_grp, :info, :from_date, :to_date;
  end

  suspend;
end
^

/* Restore proc. body: PAYMENT_ANUL$INT */
ALTER PROCEDURE PAYMENT_ANUL$INT(ID_PAYMENT_HEAD INTEGER,
ANUL_REASON VARCHAR(100))
 AS
declare variable p_dbkey char(8);
  declare variable id_ar_payment integer;
  declare variable id_payment_storned integer;
  declare variable payment_amount numeric(15,4);
  declare variable pay_currency varchar(3);
  declare variable system_date date;
  declare variable id_hotel integer;
  declare variable id_system_log integer;
  declare variable id_deposit integer;
  declare variable is_posting_stopped integer;
  declare variable round_to numeric(15,4);
begin 
  execute procedure PAYMENT_VOID_CHECK$INT (:ID_PAYMENT_HEAD, :ANUL_REASON);

  select P.RDB$DB_KEY, p.ID_PAYMENT_STORNED, P.PAY_VALUE_A, P.PAY_CURRENCY,
         P.ID_AR_PAYMENT, a.ID_HOTEL, p.ID_DEPOSIT, c.ROUND_TO
  from   PAYMENT_HEAD P
         join ACCOUNT A on A.ID_ACCOUNT = p.ID_ACCOUNT
         join CURRS c on c.CURR = p.PAY_CURRENCY
  where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  into   :p_dbkey, :id_payment_storned, :payment_amount, :pay_currency,
         :id_ar_payment, :id_hotel, :id_deposit, :round_to;

  if (:id_ar_payment is not null) then
    exception PAYMENT_ANNUL_EXCEPTION '-353';
    --'Payment is created from AR module.';

  if (:id_deposit is not null) then begin
    select r.IS_POSTING_STOPPED
    from   DEPOSIT d
           join RESERV_DETAIL r on r.ID_RESERV_DETAIL = d.ID_RESERV_DETAIL
    where  d.ID_DEPOSIT = :id_deposit
    into   :is_posting_stopped;

    if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';
  end

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :system_date;

  insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
         ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT)
  select AP.ID_ACCOUNT, AP.ID_PAYMENT_HEAD, -sum(AP.PAY_AMOUNT), AP.PAY_RATE,
         -sum(AP.ACC_AMOUNT), AP.ACC_RATE, :system_date, AP.ID_DEPOSIT
  from   ACCOUNT_PAYMENTS AP
  where  AP.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  group by AP.ID_ACCOUNT, AP.ID_PAYMENT_HEAD, AP.PAY_RATE, AP.ACC_RATE, AP.ID_DEPOSIT
  having round_f(sum(AP.PAY_AMOUNT), :round_to) <> 0;
                            
  if (:id_payment_storned is not null) then begin
    update PAYMENT_HEAD SP
    set    sp.IS_STORNED = 0
    where  sp.ID_PAYMENT_HEAD = :id_payment_storned;
  end

  execute procedure SYSTEM_EVENT_LOG$INT ('PAYMENT', :ID_PAYMENT_HEAD, 'ANNUL', f_character(29) || formatfloat(:payment_amount, 'F;0.00') || ' ' || :pay_currency || f_character(28) || :ANUL_REASON)
  returning_values  :id_system_log;

  update PAYMENT_HEAD PA
  set    PA.IS_ANUL = 1,
         pa.ANNUL_DATE = :system_date,
         pa.ID_LOG_EVENT_ANNUL = :id_system_log
  where  PA.RDB$DB_KEY = :p_dbkey;

end
^

/* Restore proc. body: PERSON_DATA_SET$INT */
ALTER PROCEDURE PERSON_DATA_SET$INT(P_DBKEY CHAR(8),
PD_DBKEY CHAR(8),
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
COUNTRY VARCHAR(10),
BIRTH_DAY DATE,
BIRTHDAY_INTERNAL DATE,
TITLE VARCHAR(10) = null)
 AS
declare variable id_profile integer;
  declare variable id_guest integer;
  declare variable old_name varchar(100);
  declare variable old_country varchar(10);
  declare variable country_name varchar(50);
  declare variable action_text varchar(255);
  declare variable age integer;
  declare variable old_birthday date;
  declare variable id_person_data integer;
  declare variable old_title varchar(10);
begin

  select coalesce(:country, PD.COUNTRY_CODE), PD.BIRTH_DAY, PD.PERSON_NAME, PD.COUNTRY_CODE,
         pd.ID_PERSON_DATA, pd.TITLE
  from   PERSON_DATA PD
  where  PD.RDB$DB_KEY = :pd_dbkey
  into   :country, :old_birthday, :old_name, :old_country,
         :id_person_data, :old_title;

  update  PERSON_DATA PD
  set     PD.PERSON_NAME = :GUEST_NAME1,
          PD.PERSON_NAME2 = coalesce(:guest_name2, iif(PD.PERSON_NAME = PD.PERSON_NAME2, :guest_name1, PD.PERSON_NAME2)),
          PD.COUNTRY_CODE = :country,
          PD.BIRTH_DAY = coalesce(:birthday_internal, :birth_day), -- this is relative date, calculated by input age or equal to real birth day (if exists)
          PD.BIRTHDAY_INTERNAL = :birthday_internal, -- this is real person birth day (can be null)
          PD.TITLE = :TITLE
  where   PD.RDB$DB_KEY = :pd_dbkey;

  if ((:old_name is distinct from :GUEST_NAME1)
      or (:old_birthday is distinct from :BIRTH_DAY)
      or (:old_title is distinct from :TITLE)
      or (:old_country is distinct from :COUNTRY)) then
  begin
    -- update all related checked in and not checked out guest's cards
    for
      select GD.ID_GUEST
      from   GUEST_DATA GD
             join GUEST G on g.ID_GUEST = gd.ID_GUEST
      where  GD.ID_PERSON_DATA = :id_person_data
             and g.ID_RESERV_DETAIL is not null
             and g.IS_CHECK_IN = 1
             -- and g.IS_CHECK_OUT = 0
      into   :id_guest
    do begin
      select C.COUNTRY_NAME
      from   COUNTRY C
      where  C.COUNTRY_CODE = :COUNTRY
      into   :country_name;
  
      select CA.AGE_INYEARS
      from   SYSTEM_CALC_AGE_INYEARS (:birth_day, current_timestamp) CA
      into   :age;
  
      action_text = f_character(29) || '"' || :guest_name1 || '", ' || coalesce(:age, '') || ', ' || coalesce(:country_name, '');
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'GUEST_IDENT_CHNG', :action_text);

      execute procedure GUEST_REGISTRATION_UPDATE(:id_guest);
    end
  end

  if (ascii_val(nullif(trim(:TITLE), '')) > 64) then  -- starting with letter strings only
    execute procedure LIST_ITEM_MODIFY('person_title', null, :TITLE, 'add');

  if (:p_dbkey is not null) then begin
    update PROFILE P
    set    P.PROFILE_NAME = :guest_name1
    where  P.RDB$DB_KEY = :p_dbkey
    returning new.id_profile
    into   :id_profile;

    -- force reserv changes tracking!
    update RESERV_DETAIL rd
    set    rd.ID_PERSON_PROFILE = :id_profile
    where  rd.ID_PERSON_PROFILE = :id_profile;
  end
end
^

/* Restore proc. body: PHONE_LINE_CONVERT_MODIFY$CFG */
ALTER PROCEDURE PHONE_LINE_CONVERT_MODIFY$CFG(ID INTEGER,
LINE VARCHAR(30),
ROOM_NAME VARCHAR(30),
IS_TAXABLE SMALLINT,
IS_ARCHIVE SMALLINT,
PRICE_INDEX NUMERIC(15,4),
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER,
OPERATION VARCHAR(10))
 RETURNS(NEW_ID INTEGER)
 AS
declare variable action_text varchar(255);
declare variable account_name varchar(50);
declare variable hotel_name varchar(50);
declare variable old_line varchar(30);
declare variable old_room_name varchar(30);
declare variable old_is_taxable smallint;
declare variable old_is_archive smallint;
declare variable old_price_index numeric(15,4);
declare variable old_account_name varchar(50);
declare variable old_hotel_name varchar(50);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:OPERATION = 'add') then ID = null;

  if (:OPERATION in ('add', 'mod')) then begin

    update or insert into PHONE_LINE_CONVERT (ID, LINE, ROOM_NAME, IS_TAXABLE, IS_ARCHIVE, PRICE_INDEX, ID_HOTEL, ID_ACCOUNT)
    values      (:ID, :line, :room_name, :is_taxable, :is_archive, :price_index, :id_hotel, :ID_ACCOUNT)
    matching    (ID)
    returning   ID
    into        :new_id;
  
    select coalesce(ACC.ACCOUNT_NAME, '')
    from   ACCOUNT ACC
    where  ACC.ID_ACCOUNT = :ID_ACCOUNT
    into   :account_name;
  
    select H.HOTEL_NAME
    from   HOTEL H
    where  H.ID_HOTEL = :ID_HOTEL
    into   :hotel_name;
  
    action_text = f_character(29) || :line || f_character(28) || :room_name ||
                  f_character(28) || :is_taxable || f_character(28) || :is_archive ||
                  f_character(28) || formatfloat(:price_index, '0.00') || f_character(28) || :hotel_name ||
                  f_character(28) || coalesce(:account_name, '');
    execute procedure SYSTEM_LOG_ADD ('PHONE_LINES', :NEW_ID, 'PHONE_LINE_MODIFY', :ACTION_TEXT);

  end else if (:operation = 'del') then begin
    select PLC.LINE, PLC.ROOM_NAME, PLC.IS_TAXABLE, PLC.IS_ARCHIVE, PLC.PRICE_INDEX,
           A.ACCOUNT_NAME, HO.HOTEL_NAME
    from   PHONE_LINE_CONVERT PLC
           join HOTEL HO on HO.ID_HOTEL = PLC.ID_HOTEL
           left outer join ACCOUNT A on A.ID_ACCOUNT = PLC.ID_ACCOUNT
    where  PLC.ID = :ID
    into   :old_line, :old_room_name, :old_is_taxable, :old_is_archive, :old_price_index,
           :old_account_name, :old_hotel_name;

    action_text = f_character(29) || :old_line || f_character(28) || :old_room_name ||
                  f_character(28) || :old_is_taxable || f_character(28) || :old_is_archive ||
                  f_character(28) || formatfloat(:old_price_index, '0.00') ||
                  f_character(28) || :old_hotel_name ||
                  f_character(28) || coalesce(:old_account_name, '');
    execute procedure SYSTEM_LOG_ADD ('PHONE_LINES', :ID, 'DELETE', :ACTION_TEXT);

    delete from PHONE_LINE_CONVERT
    where  ID = :id;
  end
end
^

/* Restore proc. body: PHONECALL_POST$TC */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Restore proc. body: PHONECALLS_POST_TO_ACCOUNT$TC */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* Restore proc. body: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_OWNER TYPE OF ID,
POST_DATE TYPE OF TDATE,
CURR_ORIG TYPE OF TCURRENCY,
VALUE_ORIG TYPE OF TPRICE,
POST_ON_PMS_ACCOUNT TYPE OF TLOGICAL,
IS_OWNER_INCOME TYPE OF TLOGICAL,
ID_ROOM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  if (:POST_ON_PMS_ACCOUNT = 1) then begin
    execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account, :id_owner,
            :CURR_ORIG, :VALUE_ORIG, :id_service, :is_owner_income, :POST_DATE)
    returning_values  (:new_id_account_post);
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :ID_SERVICE, 1, 0, 1,
            :VALUE_ORIG, :CURR_ORIG, current_date, current_date,
            '', '', :POST_DATE, 'PMS', :ID_ROOM)
    returning_values  :err_code, :err_text, :new_id_account_post;
    if (:err_code <> 0) then exception PMS_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:ID_PMS_EVENT, :NEW_ID_ACCOUNT_POST, :ID_OWNER, 11);
  end
end
^

/* Restore proc. body: POST_SERVICE_FINALIZE$POST */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable post_text varchar(100);
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '')
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '')
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set ID_ACCOUNT_POST = :id_acc_post
      where RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* Restore proc. body: PROFILE_AGENT_MODIFY$PROFILE */
ALTER PROCEDURE PROFILE_AGENT_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
AGENT_GROUP VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IATA_NUMBER VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null,
THRESHOLD_NOTE VARCHAR(255) = null,
THRESHOLD_AMOUNT NUMERIC(15,4) = null,
THRESHOLD_CURR CHAR(3) = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable id_agent integer;
  declare variable action_text varchar(255);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  AGENT_GROUP = nullif(trim(:AGENT_GROUP), '');

  if (:operation in ('add', 'mod')) then begin
    execute procedure PROFILE_COMMON_MODIFY$INT(:id_profile, 'AGENT', :profile_name,
            :phone, :fax, :email, :contact_city, :contact_address,
            :note, :msg, :is_archive, :id_def_contragent, :id_nom_market_segment,
            :wbe_password, :account_no, :is_exclusive_debt_ownership)
    returning_values (:NEW_ID_PROFILE);

    if (:new_id_profile is distinct from :id_profile) then begin
      id_agent = gen_id(G_AUTO_INC_AGENT,1);
      insert into AGENT (ID_AGENT, AGENT_NAME, IS_USE)
      values (:id_agent, :profile_name, 1-:is_archive);
  
      insert into PROFILE_AGENT(ID_PROFILE, ID_AGENT, AGENT_GROUP, COUNTRY_CODE, IATA_NUMBER, THRESHOLD_NOTE, THRESHOLD_AMOUNT, THRESHOLD_CURR)
      values (:new_id_profile, :id_agent, :agent_group, :country_code, :iata_number, :threshold_note, :threshold_amount, :threshold_curr);
  
      action_text = f_character(29) || :profile_name;
      execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_AGENT_PROFILE', :action_text);
    end else begin
      select PA.ID_AGENT
      from   PROFILE_AGENT PA
      where  PA.ID_PROFILE = :NEW_ID_PROFILE
      into   :id_agent;

      update PROFILE_AGENT PA
      set    PA.IATA_NUMBER = :IATA_NUMBER,
             PA.COUNTRY_CODE = :COUNTRY_CODE,
             PA.AGENT_GROUP = :AGENT_GROUP,
             PA.THRESHOLD_NOTE = :THRESHOLD_NOTE,
             PA.THRESHOLD_AMOUNT = :THRESHOLD_AMOUNT,
             PA.THRESHOLD_CURR = :THRESHOLD_CURR
      where  PA.ID_PROFILE = :NEW_ID_PROFILE;

      update AGENT A
      set    A.AGENT_NAME = :profile_name,
             A.IS_USE = 1 - :is_archive
      where  A.ID_AGENT = :id_agent;
    end
  end else if (:operation = 'del') then  begin
    execute procedure PROFILE_DELETE$INT(:id_profile);

    new_id_profile = null;
  end
end
^

/* Restore proc. body: PROFILE_COMMON_MODIFY$INT */
ALTER PROCEDURE PROFILE_COMMON_MODIFY$INT(ID_PROFILE INTEGER,
PROFILE_TYPE VARCHAR(20),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable action_text varchar(255);
  declare variable old_profile_name varchar(100);
  declare variable old_is_archive integer;
  declare variable p_dbkey char(8);
begin
  p_dbkey = null;
  select P.RDB$DB_KEY, P.PROFILE_NAME, P.IS_ARCHIVE
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :p_dbkey, :old_profile_name, :old_is_archive;
   
  is_exclusive_debt_ownership = coalesce(:is_exclusive_debt_ownership, 0);
  new_id_profile = :id_profile;
  if (:p_dbkey is null) then begin
    execute procedure SYSTEM_CHECK_OPERATION (:PROFILE_TYPE, 'PERSON,AGENT,HOUSE', 'Profile type');

    new_id_profile = gen_id(gen_profile_id, 1);
    insert into PROFILE (ID_PROFILE, PROFILE_NAME, PROFILE_TYPE,
           PHONE, FAX, EMAIL, CITY, ADDRESS, NOTE, MSG,
           ID_DEF_CONTRAGENT, ID_NOM_MARKET_SEGMENT, IS_ARCHIVE, ACCOUNT_NO,
           WBE_PASSWORD, IS_EXCLUSIVE_DEBT_OWNERSHIP)
    values (:new_id_profile, :profile_name, :profile_type,
           :phone, :fax, :email, :contact_city, :contact_address, :note, :msg,
           :id_def_contragent, :id_nom_market_segment, 0, :account_no,
           nullif(:wbe_password, ''), :is_exclusive_debt_ownership)
    returning RDB$DB_KEY into :p_dbkey;
  end else begin
    update PROFILE PU
    set    PU.PROFILE_NAME = :profile_name,
           PU.PHONE = :phone,
           PU.FAX = :fax,
           PU.EMAIL = :email,
           PU.CITY = :contact_city,
           PU.ADDRESS = :contact_address,
           PU.NOTE = :note,
           PU.MSG = :msg,
           PU.ID_DEF_CONTRAGENT = :id_def_contragent,
           PU.ID_NOM_MARKET_SEGMENT = :id_nom_market_segment,
           PU.ACCOUNT_NO = :ACCOUNT_NO,
           PU.WBE_PASSWORD = iif(PU.WBE_PASSWORD is null and :wbe_password = '', null, :wbe_password),
           -- empty ('') new password should not relpace NULLs,
           -- empty password indicate for 'deleted real password'
           PU.IS_EXCLUSIVE_DEBT_OWNERSHIP = :IS_EXCLUSIVE_DEBT_OWNERSHIP
    where  PU.RDB$DB_KEY = :p_dbkey;
  
    if (:old_profile_name <> :profile_name) then begin
      action_text = f_character(29) || :old_profile_name || f_character(28) || :profile_name;
      execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'EDIT_NAME', :action_text);
    end
  
    if (:is_archive is distinct from :old_is_archive) then
      execute procedure PROFILE_SET_ARCHIVE$INT (:P_DBKEY, :IS_ARCHIVE);

  end
end
^

/* Restore proc. body: PROFILE_DELETE$INT */
ALTER PROCEDURE PROFILE_DELETE$INT(ID_PROFILE INTEGER)
 AS
declare variable action_text varchar(255);
declare variable id_agent integer;
begin
  id_agent = null;
  select pa.ID_AGENT
  from   PROFILE_AGENT pa
  where  pa.ID_PROFILE = :ID_PROFILE
  into   :id_agent;

  delete from PROFILE P
  where  P.ID_PROFILE = :id_profile;

  if (:id_agent is not null) then
    delete from AGENT A where a.ID_AGENT = :id_agent;

  action_text = '';
  execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'DELETE', :action_text);

end
^

/* Restore proc. body: PROFILE_HOUSE_MODIFY$PROFILE */
ALTER PROCEDURE PROFILE_HOUSE_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(20),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
HOUSE_TYPE VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable action_text varchar(255);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    execute procedure PROFILE_COMMON_MODIFY$INT(:id_profile, 'HOUSE', :profile_name,
            :phone, :fax, :email, :contact_city, :contact_address,
            :note, :msg, :is_archive, :id_def_contragent, :id_nom_market_segment,
            :wbe_password, :account_no, :is_exclusive_debt_ownership)
    returning_values (:new_id_profile);

    if (:operation = 'add') then begin
      insert into PROFILE_HOUSE(ID_PROFILE, HOUSE_TYPE)
      values (:new_id_profile, :house_type);

      action_text = f_character(29) || :PROFILE_NAME;
      execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_HOUSE_PROFILE', :action_text);
    end
  end else if (:operation = 'del') then  begin
    execute procedure PROFILE_DELETE$INT(:id_profile);

    new_id_profile = null;
  end
end
^

/* Restore proc. body: PROFILE_MERGE$PROFILE */
ALTER PROCEDURE PROFILE_MERGE$PROFILE(ID_SOURCE INTEGER,
ID_TARGET INTEGER,
OPERATION VARCHAR(20))
 AS
declare variable source_p_type varchar(30);
  declare variable target_p_type varchar(30);
  declare variable total_points_gained integer;
  declare variable total_points_consumed integer;
  declare variable source_p_name varchar(100);
  declare variable target_p_name varchar(100);
  declare variable id_hotel integer;
  declare variable id_bps integer;
  declare variable target_id_p_data integer;
  declare variable rd_dbkey char(8);
  declare variable gd_dbkey char(8);
  declare variable check_status smallint;
  declare variable id_reserv_detail integer;
  declare variable is_archive integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'merge, notequals');

  if ((:ID_SOURCE is null) or (:ID_TARGET is null)) then exception PROFILE_EXCEPTION '<NULL> profile id is passed!';

  if (:operation = 'notequals') then begin
    insert into PROFILE_DISSIMILAR (ID_PROFILE1, ID_PROFILE2)
    values (iif(:id_source < :id_target, :id_source, :id_target),
            iif(:id_source > :id_target, :id_source, :id_target));

    when any do exit;

  end else if (:operation = 'merge') then begin
    if (exists (select o.ID_OWNER from OWNER$PMS O where O.ID_OWNER in (:ID_SOURCE, :ID_TARGET))) then
      exception PROFILE_EXCEPTION '-1047';

    select p.PROFILE_TYPE, p.PROFILE_NAME
    from   PROFILE P
    where  P.ID_PROFILE = :ID_SOURCE
    into   :source_p_type, :source_p_name;

    select p.PROFILE_TYPE, p.PROFILE_NAME, PP.ID_PERSON_DATA, p.IS_ARCHIVE
    from   PROFILE P
           left outer join PROFILE_PERSON PP on PP.ID_PROFILE = P.ID_PROFILE 
    where  P.ID_PROFILE = :ID_TARGET
    into   :target_p_type, :target_p_name, :target_id_p_data, :is_archive;

    if (:is_archive = 1) then exception PROFILE_EXCEPTION '-1055';
    if (:source_p_type <> :target_p_type) then exception PROFILE_EXCEPTION 'Profile types are incompatible!';

    update RESERV_DETAIL RD
    set    rd.ID_AGENT_PROFILE = :ID_TARGET
    where  rd.ID_AGENT_PROFILE = :ID_SOURCE;

    update ACCOUNT A
    set    a.ID_PROFILE = :ID_TARGET
    where  a.ID_PROFILE = :ID_SOURCE;

    update AR_OWING AO
    set    ao.ID_PROFILE = :ID_TARGET
    where  ao.ID_PROFILE = :ID_SOURCE;

    update AR_PAYMENT ARP
    set    arp.ID_PROFILE = :ID_TARGET
    where  arp.ID_PROFILE = :ID_SOURCE;

    update AR_OWING_PAYMENT_POST AROP
    set    arop.ID_PROFILE = :ID_TARGET
    where  arop.ID_PROFILE = :ID_SOURCE;

    update DEPOSIT D
    set    d.ID_PROFILE = :ID_TARGET
    where  d.ID_PROFILE = :ID_SOURCE;

    update PROFILE_CREDIT_CARD pcc
    set    pcc.ID_PROFILE = :ID_TARGET
    where  pcc.ID_PROFILE = :ID_SOURCE
           and not exists (select spc.CARD_CODE
                           from   PROFILE_CREDIT_CARD spc
                           where  spc.ID_PROFILE = :ID_TARGET
                                  and spc.CARD_CODE = pcc.CARD_CODE);

    update PROFILE_DISCOUNT pd
    set    pd.ID_PROFILE = :ID_TARGET
    where  pd.ID_PROFILE = :ID_SOURCE
           and not exists (select spd.ID_SALE_DISCOUNT
                           from   PROFILE_DISCOUNT spd
                           where  spd.ID_PROFILE = :ID_TARGET
                                  and spd.ID_SALE_DISCOUNT = pd.ID_SALE_DISCOUNT);

    update PROFILE_HOTEL_RATE phr
    set    phr.ID_PROFILE = :ID_TARGET
    where  phr.ID_PROFILE = :ID_SOURCE
           and not exists (select tphr.ID_PROFILE
                           from   PROFILE_HOTEL_RATE tphr
                           where  tphr.ID_PROFILE = :ID_TARGET
                                  and tphr.ID_TARIFF = phr.ID_TARIFF
                                  and tphr.ID_HOTEL = phr.ID_HOTEL);

    update PROFILE_FILE pf
    set    pf.ID_PROFILE = :ID_TARGET
    where  pf.ID_PROFILE = :ID_SOURCE;

    for
      select sbs.ID_HOTEL, sbs.ID_BONUSPOINT_SCHEME
      from   PROFILE_BONUSPOINT_SCHEME sbs
      where  sbs.ID_PROFILE = :ID_SOURCE
      into   :id_hotel, :id_bps
    do begin
      if (not exists (select tbs.ID_BONUSPOINT_SCHEME
                      from   PROFILE_BONUSPOINT_SCHEME tbs
                      where  tbs.ID_PROFILE = :ID_TARGET
                             and tbs.ID_HOTEL = :id_hotel)) then
      begin
        insert into PROFILE_BONUSPOINT_SCHEME (ID_PROFILE, ID_HOTEL, ID_BONUSPOINT_SCHEME)
        values (:ID_TARGET, :id_hotel, :id_bps);
      end

    end

    update PROFILE_WALLET_POINTS pwp
    set    pwp.ID_PROFILE = :ID_TARGET
    where  pwp.ID_PROFILE = :ID_SOURCE;

    select pw.TOTAL_POINTS_GAINED, pw.TOTAL_POINTS_CONSUMED
    from   PROFILE_WALLET pw
    where  pw.ID_PROFILE = :ID_TARGET
    into   :total_points_gained, :total_points_consumed;

    update PROFILE p
    set    p.BONUSPOINT_GAINED = :total_points_gained,
           p.BONUSPOINT_CONSUMED = :total_points_consumed
    where  p.ID_PROFILE = :ID_TARGET;

    if (:source_p_type = 'PERSON') then begin
      for
        select RD.RDB$DB_KEY, GD.RDB$DB_KEY, RD.CHECK_STATUS, RD.ID_RESERV_DETAIL
        from   RESERV_DETAIL RD
               join GUEST_DATA GD on GD.ID_GUEST = RD.ID_TITULAR
        where  rd.ID_PERSON_PROFILE = :id_source
        into   :rd_dbkey, :gd_dbkey, :check_status, :id_reserv_detail
      do begin
        update RESERV_DETAIL RD
        set    RD.ID_PERSON_PROFILE = :id_target
        where  RD.RDB$DB_KEY = :rd_dbkey;

        if (:check_status < 1) then begin
          update GUEST_DATA GD
          set    GD.ID_PERSON_DATA = :target_id_p_data
          where  GD.RDB$DB_KEY = :gd_dbkey;

          execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL,  'TITULAR_CHAN_PROF_MERGE',
                                            f_character(29) || :source_p_name || f_character(28) || :target_p_name);
        end
      end

    end else if (:source_p_type = 'AGENT') then begin
      update SUMMARY_PROFILES$REV spr
      set    spr.ID_PROFILE = :ID_TARGET
      where  spr.ID_PROFILE = :ID_SOURCE;

      update SUMMARY_OCCUPANCY_PROFILE_MRKT sopm
      set    sopm.ID_PROFILE_AGENT = :ID_TARGET
      where  sopm.ID_PROFILE_AGENT = :ID_SOURCE;

      update SUMMARY_OCCUPANCY_OTHER soo
      set    soo.ID_PROFILE_AGENT = :ID_TARGET
      where  soo.ID_PROFILE_AGENT = :ID_SOURCE;
  
      update RES_TEMPLATE rt
      set    rt.ID_AGENT_PROFILE = :ID_TARGET
      where  rt.ID_AGENT_PROFILE = :ID_SOURCE;

      -- PROFILE_HOTEL_ALLOTMENT - keep target's allotments only 
    end

    /* delete or archivate */
    update PROFILE P
    set    p.IS_ARCHIVE = 1,
           p.ID_MERGE_PROFILE = :ID_TARGET
    where  p.ID_PROFILE = :ID_SOURCE;

    -- ficticious update - to force export only
    update PROFILE P
    set    p.UUID = p.UUID
    where  p.ID_PROFILE = :ID_TARGET;
    -- log
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_SOURCE, 'MERGE_TO', f_character(29) || :target_p_name);
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_TARGET, 'CONSOLIDATE_WITH', f_character(29) || :source_p_name);
  end
end
^

/* Restore proc. body: PROFILE_PERSON_CREATEQ$PROFILE */
ALTER PROCEDURE PROFILE_PERSON_CREATEQ$PROFILE(PROFILE_NAME TYPE OF TPERSON_NAME,
PHONE TYPE OF TPHONE,
ID_PASSPORT_TYPE TYPE OF ID,
PASS_NUM TYPE OF NAME_20,
EGN TYPE OF TTEXT_SHORT,
COUNTRY_CODE TYPE OF TSHORT_CODE,
CARD_CODE TYPE OF TCARD_CODE,
ID_PERSON_DATA TYPE OF ID_REF = null,
TITLE TYPE OF TSHORT_CODE = null,
ID_HOTEL TYPE OF ID_REF = null)
 RETURNS(NEW_ID_PROFILE TYPE OF ID,
P_DBKEY TYPE OF TDB_KEY,
PD_DBKEY TYPE OF TDB_KEY)
 AS
declare variable action_text varchar(255);
  declare variable mask varchar(10);
  declare variable merge_ident_num tname_unicode;
  declare variable merge_ident_num_alt tname_unicode;
begin
  select trim(ss.UNICODE_STRING) from SYSTEM_STRING_TO_UNICODE(:EGN) ss into :merge_ident_num;
  select trim(ss.UNICODE_STRING) from SYSTEM_STRING_TO_UNICODE(:PASS_NUM) ss into :merge_ident_num_alt;

  new_id_profile = gen_id(gen_profile_id, 1);
  insert into PROFILE (ID_PROFILE, PROFILE_NAME, PROFILE_TYPE, PHONE, IS_ARCHIVE, MERGE_IDENT_NUM, MERGE_IDENT_NUM_ALT)
  values (:new_id_profile, :profile_name, 'PERSON', :phone, 0, :merge_ident_num, :merge_ident_num_alt)
  returning RDB$DB_KEY into :p_dbkey;

  PD_DBKEY = null;
  if (:id_person_data is null) then begin
    id_person_data = gen_id(gen_person_data_id, 1);

    insert into PERSON_DATA(ID_PERSON_DATA)
    values (:id_person_data)
    returning RDB$DB_KEY into :pd_dbkey;
    -- !!! Search sensitive fields must be filled after the profile link creation (below) !!!
  end

  insert into PROFILE_PERSON (ID_PROFILE, ID_PERSON_DATA, CARD_CODE)
  values (:new_id_profile, :id_person_data, :card_code);

  if (:PD_DBKEY is not null) then begin
    if (:ID_HOTEL is not null) then begin
      execute procedure SETTING_GET_VALUE ('DEF_GUEST_MASK', :ID_HOTEL)
      returning_values  :mask;
    end

    execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :profile_name, :profile_name, :country_code,
            null, null, :TITLE);

    execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, null, :EGN, :ID_PASSPORT_TYPE, :PASS_NUM, null, null,
            null, null, null, null, :mask);
  end

  action_text = f_character(29) || :profile_name;
  execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_PERS_PROFILE', :action_text);
end
^

/* Restore proc. body: REP_ROOM_STATUS$INT */
ALTER PROCEDURE REP_ROOM_STATUS$INT(FOR_DATE DATE,
STAT_OPTIONS VARCHAR(255),
PRIVATE_STATUS_ADDING SMALLINT = 0)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
SECTOR INTEGER,
ID_ROOM_TYPE INTEGER,
TYPE_ROOM VARCHAR(20),
IS_CLEAN INTEGER,
IS_INSPECTED INTEGER,
CLEAN_TEXT VARCHAR(30),
IS_LEAVING SMALLINT,
IS_COMMING SMALLINT,
IS_SHARED SMALLINT,
IS_LEAVING_WORDS VARCHAR(30),
BUSY_GRP INTEGER,
DAYS_THIS_STATUS INTEGER,
DTS_CONTEXT VARCHAR(10),
COMMING_OCCUPANTS VARCHAR(1024),
ID_BLOCK_ROOM INTEGER,
OTHER_OCCUPANTS VARCHAR(1024),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ID_HOTEL INTEGER,
HAS_OPENED_POSTINGS SMALLINT)
 AS
declare variable dbg varchar(6000);
  declare variable id_room_tmp integer;
  declare variable id_room_magic integer;
  declare variable occupant_id integer;
begin
  for
    select RM.ID_ROOM_MAGIC, RM.ID_ROOM
    from   ROOMS R
           join TMP_SMART_ROOMS TSR on TSR.ID_ROOM = R.ID_ROOM
                and TSR.ID_SESSION = current_connection
           join ROOM_MAGIC RM on RM.ID_ROOM = R.ID_ROOM
    where  RM.BUSY_DATE = :for_date
    into   :id_room_magic, :id_room_tmp
  do begin
    insert into TMP_HM_ROOM_STATUS (ID_ROOMS_MAGIC, ID_SESSION, ID_ROOM)
    values (:id_room_magic, current_transaction, :id_room_tmp);
  end

  for
    select R.ID_ROOM, R.ROOM_NAME, R.FLOOR, R.ID_ROOM_TYPE,
           R.IS_CLEAN, R.CLEAN_TEXT, R.IS_INSPECTED,
           RT.TYPE_ROOM, RT.ID_HOTEL, R.SECTOR
    from   (select distinct P.ID_ROOM
            from   TMP_SMART_ROOMS TSR
                   join ROOM_PERIOD$PMS P on P.ID_ROOM = TSR.ID_ROOM
            where  TSR.ID_SESSION = current_connection
                   and ((P.IS_AVAILABLE = 1) or (:private_status_adding = 1))
                   and P.FROM_DATE <= :for_date
                   and P.TO_DATE >= :for_date) AVR
           join ROOMS R on AVR.ID_ROOM = R.ID_ROOM
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    into   :id_room, :room_name, :floor, :id_room_type,
           :is_clean, :clean_text, :is_inspected,
           :type_room, :id_hotel, :sector
  do begin

    execute procedure REP_ROOM_STATUS_BUILD$INT(:id_room, :for_date, :stat_options)
    returning_values  :is_leaving, :is_comming, :is_shared, :is_leaving_words, :busy_grp,
                      :days_this_status, :dts_context, :comming_occupants, :id_block_room,
                      :other_occupants, :adult_count, :children_count;

    is_comming = iif(:comming_occupants = '', 0, 1);

    HAS_OPENED_POSTINGS = 0;
    for
      select distinct sp.ITEM
      from   SYSTEM_STRING_PARSER (:other_occupants || ',' || :COMMING_OCCUPANTS, ',') SP
      into   :occupant_id
    do begin
      execute procedure RES_GET_BALLANCE$INT (:occupant_id)
      returning_values :dbg, :dbg, :dbg, :HAS_OPENED_POSTINGS, :dbg;
      if (:HAS_OPENED_POSTINGS = 1) then break;
    end

    suspend;

  end

  delete from TMP_HM_ROOM_STATUS HM
  where  HM.ID_SESSION = current_transaction;
end
^

/* Restore proc. body: RES_CHECK_OUT_CHECK$RSV */
ALTER PROCEDURE RES_CHECK_OUT_CHECK$RSV(SELECTION_ID INTEGER)
 RETURNS(IS_EARLY_CHECK_OUT SMALLINT,
EARLY_CHECK_OUT_DEP_DATE DATE,
CHECK_OUT_DATE DATE)
 AS
declare variable max_to_date date;
  declare variable cnt_early_dates integer;
  declare variable min_check_status integer;
  declare variable max_check_status integer;
  declare variable id_hotel integer;
  declare variable hotels_cnt integer;
  declare variable booking_number varchar(62);
  declare variable safe_name varchar(50);
begin
  is_early_check_out = 0;
  early_check_out_dep_date = null;
  select min(RD.ID_HOTEL), count(distinct RD.ID_HOTEL)
  from   RESERV_DETAIL RD
  where  RD.SELECTION_ID = :SELECTION_ID
  into   :id_hotel, :hotels_cnt;

  if (:hotels_cnt > 1) then exception RESERV_CHECK_OUT_EXCEPTION '-1020';

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values  :check_out_date;

  for
    select max(G.TO_DATE),
           count(distinct case when RD.CHECK_STATUS = 0 and RD.TO_DATE > :check_out_date then RD.TO_DATE else null end),
           min(RD.CHECK_STATUS), max(RD.CHECK_STATUS)
    from   RESERV_DETAIL RD
           left outer join GUEST G on G.ID_RESERV_DETAIL = RD.ID_RESERV_DETAIL
                                      and G.CHECK_STATUS >= 0 /* checked in guests */
    where  RD.SELECTION_ID = :selection_id
    into   :max_to_date, :cnt_early_dates, :min_check_status, :max_check_status
  do begin
    if (:max_check_status > 0) then
        exception RESERV_CHECK_OUT_EXCEPTION '-1013'; --'Reservation is already checked out.';

    if ((:min_check_status is null) or (:min_check_status < 0)) then
        exception RESERV_CHECK_OUT_EXCEPTION '-1006'; --'Can not check out not checked in reservation.';

    if (:max_to_date > :CHECK_OUT_DATE) then begin
      if (:cnt_early_dates > 1) then begin
        exception RESERV_CHECK_OUT_EXCEPTION '-1014'; --'In selection has different departure dates for early check out.';

      end else if (:max_to_date > :CHECK_OUT_DATE) then begin
        execute procedure RIGHTS_CHECK_GRANTED$INT('CHECK_OUT_EARLY');
      
        is_early_check_out = 1;
        early_check_out_dep_date = :max_to_date;
      end
    end
  end 

  for
    select rd.NUMBER, s.SAFE_NAME
    from   RESERV_DETAIL RD
           join RESOURCE_RESERVATION rr on rr.BOOKING_NUMBER = rd.NUMBER
           join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
           join SAFES s on s.ID_CURRENT_OCCUPANCY = rr.ID_RESOURCE_RESERVATION
    where  rd.SELECTION_ID = :SELECTION_ID
           and s.IS_OCCUPIED = 1
    into   :booking_number, :safe_name
  do begin
    execute procedure ERROR_LOG_ADD (-1060, f_character(29) || :booking_number || f_character(28) || :safe_name);
  end 
end
^

/* Restore proc. body: RES_CHECKIN$RSV */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable old_check_status integer;
  declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_anul integer;
  declare variable arrival_date date;
  declare variable system_date date;
  declare variable id_base_account integer;
  declare variable id_extra_account integer;
  declare variable id_sale_num integer;
begin
  /*  Description:
  ||
  */
  select RD.CHECK_STATUS, RD.RDB$DB_KEY, RD.FROM_DATE, RD.ID_HOTEL,
         RD.ID_ROOM, RD.IS_ANUL, rd.ID_BASE_ACCOUNT, rd.ID_EXTRA_ACCOUNT
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_check_status, :rd_dbkey, :arrival_date, :id_hotel,
         :old_id_room, :is_anul, :id_base_account, :id_extra_account;

  if (:is_anul = 1) then exception BOOKING_EXCEPTION '-2';

  if (:old_check_status >= 0) then exception BOOKING_EXCEPTION '-1003';

  if (:old_id_room < 0 and coalesce(:ID_ROOM, 0) <= 0) then exception BOOKING_EXCEPTION '-1018';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date < :arrival_date) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CHECK_IN_FUTURE');
  end
  /*----*/
  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'lock');

  execute procedure sys_dbg('occ RES_CHECKIN$RSV id_room = '||coalesce(:id_room, 'null'));
  execute procedure sys_dbg('occ RES_CHECKIN$RSV old_id_room = '||coalesce(:old_id_room, 'null'));

  if (:id_room is not null) then begin
    if (:old_check_status = -3) then begin
      execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, -2);
    end

    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option)
    returning_values (:WARN_CODE);
  end

  execute procedure ACCOUNT_SALE_NUMBER_SET(:id_base_account)
  returning_values (:id_sale_num);
  execute procedure ACCOUNT_SALE_NUMBER_SET(:id_extra_account)
  returning_values (:id_sale_num);

  execute procedure RES_SET_CHECKIN$INT (:rd_dbkey)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'release');
  /*----*/
  select f_character(29) || R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = coalesce(:ID_ROOM, :old_id_room)
  into   :action_text;
   
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'CHECK_IN', :action_text);

end
^

/* Restore proc. body: RES_CREATE_SET$EXC */
ALTER PROCEDURE RES_CREATE_SET$EXC(ID_RESERV_DETAIL INTEGER,
RES_NUMBER VARCHAR(62),
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER,
CREATE_DATETIME TIMESTAMP)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_RESERV_DETAIL INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  WARN_CODE = 0;
  SHARE_TRANSACTION_ID = 0;
  SHARE_ERR_CODE = 0;

  execute procedure sys_dbg('exc RES_CREATE_SET$EXC => RES_CREATE_SET$INT('
  || 'code_first_food=>' || coalesce(:code_first_food, '<null>')
  || ', id_person_payment=>' || coalesce(:id_person_payment, '<null>')
  || ')');

  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, null, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, '', :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders, :guarantee_deposit,
                    :guarantee_currency, 0, :id_reserv_detail, :res_number, null,  :id_guarantee_policy, :block_cc,
                    :id_eating_object)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :warn_code;

  execute procedure UPDATE_POSTING_TRANSACTION$EXC(:rd_dbkey, :posting_transaction_uuid, 1);

  execute procedure RES_SAVE_GUARANTEE$RSV(:id_reserv_detail, :is_vip, null,
    :id_guarantee_policy, :guarantee_deposit, :guarantee_currency, :block_cc, :guarantee_deposit_percent,
    :guarantee_deposit_nights, :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create
  );

  execute procedure RESERV_DETAIL_EXTERNAL_MOD$RSV(:id_reserv_detail,
    :minibar_rights, :paytv_rights, :video_rights, :nopost_pms, :phone_rights,
    :seminar_cahnnel_rights, null
  );

  if (:create_datetime is not null) then begin
    update reserv_detail set create_datetime = :create_datetime where rdb$db_key = :rd_dbkey;
  end
end
^

/* Restore proc. body: RES_EARLY_DEPARTURE_SET$RSV */
ALTER PROCEDURE RES_EARLY_DEPARTURE_SET$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND INTEGER)
 RETURNS(RECALC_MARKER_LIST VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable sys_date date;
  declare variable stay integer;
  declare variable rd_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable id_hotel integer;
  declare variable hotels_cnt integer;
  declare variable arrival_date date;
  declare variable is_late_departure smallint;
  declare variable comming_kind smallint;
  declare variable dep_date date;
begin
  /* CHECK_OUT_kind =
  || 1 - DO NOT MODIFY GUEST
  || 2 - SHRINK PERIOD AND OCCUPANCY
  || 3 - DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
  */
  execute procedure RIGHTS_CHECK_GRANTED$INT('CHECK_OUT_EARLY');

  select min(RD.ID_HOTEL), count(distinct RD.ID_HOTEL)
  from   RESERV_DETAIL RD
  where  RD.SELECTION_ID = :SELECTION_ID
  into   :id_hotel, :hotels_cnt;

  if (:hotels_cnt > 1) then exception RESERV_CHECK_OUT_EXCEPTION '-1020';

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values  :sys_date;

  RECALC_MARKER_LIST = null;
  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL, rd.FROM_DATE, rd.TO_DATE, RD.LEAVING_KIND - 1, rd.COMMING_KIND
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :rd_dbkey, :id_reserv_detail, :arrival_date, :dep_date, :is_late_departure, :comming_kind
  do begin
    if ((:check_out_kind = 2) and (:dep_date > :sys_date)) then begin
      -- SHRINK PERIOD AND OCCUPANCY
      execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :sys_date, :is_late_departure, :comming_kind);
    
      execute procedure RES_FINALIZE$INT(:rd_dbkey)
      returning_values  :warn_code;
    end else if ((:check_out_kind = 1) and (:dep_date > :sys_date)) then begin
      /* KEEP BOOKING STAY PERIOD AND ROOM OCCUPANCY */
      for
        select G.TO_DATE - :sys_date
        from   GUEST G
        where  G.ID_RESERV_DETAIL = :id_reserv_detail
        into   :stay
      do begin
  --      if (:check_out_kind = 1) then begin
        if (:stay > 1) then begin
            --THE DEPARTURE DATE IS LATER THAN NEXT DATE. STAY SHOULD BE CHANGED MANUALY.;
            exception RESERV_CHECK_OUT_EXCEPTION '-323';
        end
      end
    end
  end
end
^

/* Restore proc. body: RES_GET_DEPOSIT$INT */
ALTER PROCEDURE RES_GET_DEPOSIT$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(DEPOSIT_VALUE NUMERIC(15,4),
DEPOSIT_CURRENCY CHAR(3))
 AS
declare variable rd_dbkey char(8);
declare variable dummy varchar(255);
begin
  select RD.RDB$DB_KEY, RD.GUARANTEE_DEPOSIT, rd.GUARANTEE_CURRENCY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :deposit_value, :deposit_currency;

  if (:DEPOSIT_VALUE is not null) then begin
    EXIT;
  end else begin
    execute procedure RES_GET_PRICE$INT(:rd_dbkey, 'SECURITY, FORCED')
    returning_values  :dummy, :dummy, :dummy, :deposit_value, :deposit_currency;
  end

end
^

/* Restore proc. body: RES_GUEST_ADD$INT */
ALTER PROCEDURE RES_GUEST_ADD$INT(RD_DBKEY CHAR(8),
IS_CHILD INTEGER,
INITIALIZE_BOOKING TYPE OF TLOGICAL = 0)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable pd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable check_status integer;

  declare variable from_date date;
  declare variable to_date date;
  declare variable id_room integer;
  declare variable id_agent integer;
  declare variable id_tarrif integer;
  declare variable guest_name varchar(100);
  declare variable country_code varchar(10);
  declare variable guest_status varchar(50);
  declare variable default_mask varchar(50);
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable id_titular integer;
  declare variable id_profile_data integer;
  declare variable id_person_data integer;
  declare variable id_base_account integer;
  declare variable id_extra_account integer;
  declare variable id_hotel integer;
  declare variable action_text varchar(255);
begin
  select RD.FROM_DATE, RD.TO_DATE, RD.ID_ROOM, PA.ID_AGENT, RD.ID_RATE,
         RD.ID_RESERV_DETAIL, RD.ID_TITULAR, PP.ID_PERSON_DATA,
         RD.CHECK_STATUS, RD.ADULT_COUNT, RD.CHILD_COUNT, RD.COUNTRY,
         rd.ID_BASE_ACCOUNT, rd.ID_EXTRA_ACCOUNT, rd.ID_HOTEL
  from   RESERV_DETAIL RD
         left outer join PROFILE_PERSON PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join PROFILE_AGENT PA on PA.ID_PROFILE = RD.ID_AGENT_PROFILE
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :from_date, :to_date, :id_room, :id_agent, :id_tarrif,
         :id_reserv_detail, :id_titular, :id_profile_data,
         :check_status, :adult_count, :child_count, :country_code,
         :id_base_account, :id_extra_account, :id_hotel;

  if (:check_status < 0) then begin
    guest_status = '';
    check_status = -2;
  end else if (:check_status = 0) then begin
    guest_status = 'CHECKING_IN';
  end else begin  /* checked out */
    exception BOOKING_EXCEPTION '-1032';
  end


  new_id_guest = gen_id (id_guest_gen, 1);
  insert into GUEST (ID_GUEST, ID_BASE_ACCOUNT, ID_ACCOUNT, FROM_DATE, TO_DATE, ID_ROOM, ID_AGENT, ID_TARIFA,
         ID_RESERV_DETAIL, IS_CHILD, CHECK_STATUS, GUEST_EDIT_STATUS, ID_HOTEL)
  values (:new_id_guest,  :id_base_account, :id_extra_account, :from_date, :to_date, :id_room, :id_agent, :id_tarrif,
         :id_reserv_detail, :is_child, -2, :guest_status, :id_hotel)
  returning RDB$DB_KEY into :g_dbkey;

  execute procedure sys_dbg('res RES_GUEST_ADD$INT new_id_guest = '||coalesce(:new_id_guest, 'null'));

  insert into GUEST_CHANGE_STATUS (ID_GUEST, FROM_DATE_ORIG, TO_DATE_ORIG)
  values (:new_id_guest, :from_date, :to_date);

  if (:is_child = 1) then begin
    child_count = :child_count + 1;
    guest_name = '-';
  end else begin
    adult_count = :adult_count + 1;
    guest_name = '-';
  end

  if (:id_titular is null) then begin
    id_titular = :new_id_guest;
    id_person_data = :id_profile_data;
  end else begin
    execute procedure SETTING_GET_VALUE('DEF_GUEST_MASK', :id_hotel)
    returning_values  :default_mask;

    id_person_data = gen_id(GEN_PERSON_DATA_ID, 1);
    insert into PERSON_DATA (ID_PERSON_DATA, MASK)
    values (:id_person_data, :default_mask)
    returning RDB$DB_KEY into :pd_dbkey;

  end

  insert into GUEST_DATA (ID_GUEST, ID_PERSON_DATA)
  values (:new_id_guest, :id_person_data);

  if (:INITIALIZE_BOOKING is distinct from 1) then begin
    action_text = F_CHARACTER(29) || '"' || :guest_name || '" (' || :NEW_ID_GUEST || ')';
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_GUEST_ADD', :action_text);
  end

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name, :guest_name, coalesce(:country_code, ''),
          :is_child, null, null, null);

  execute procedure RES_GUEST_AUTO$INT(:g_dbkey, :rd_dbkey, 1);

  update RESERV_DETAIL RD
  set    RD.ADULT_COUNT = :adult_count,
         RD.CHILD_COUNT = :child_count,
         RD.ID_TITULAR = :id_titular
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SET_EDIT_STATUS$INT (:RD_DBKEY, 'ADDGUEST', 'add');

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, :check_status);

end
^

/* Restore proc. body: RES_GUEST_AUTO$INT */
ALTER PROCEDURE RES_GUEST_AUTO$INT(G_DBKEY CHAR(8),
RD_DBKEY CHAR(8),
IS_NEW_GUEST SMALLINT)
 AS
declare variable id_guest integer;
  declare variable id_reserv_detail integer;
  declare variable for_date date;
  declare variable id_nom_market_segment integer;
  declare variable id_nom_source_code integer;
  declare variable id_nom_channel_code integer;
  declare variable id_nom_hear_reason integer;
  declare variable id_nom_come_reason integer;
  declare variable from_date date;
  declare variable to_date date;
  declare variable id_room integer;
  declare variable res_id_room integer;
  declare variable id_board integer;
  declare variable id_tarrif integer;
  declare variable voucher_num varchar(30);
  declare variable voucher_date date;
  declare variable voucher_text varchar(30);
  declare variable voucher2_num varchar(30);
  declare variable voucher2_date date;
  declare variable transfer_in_time timestamp;
  declare variable transfer_in_note varchar(255);
  declare variable transfer_out_time timestamp;
  declare variable transfer_out_note varchar(255);
  declare variable code_first_food type of tfood_code;
  declare variable id_hotel integer;
  declare variable id_titular integer;
  declare variable sys_date date;
begin

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -2);

  select G.ID_GUEST
  from   GUEST G
  where  G.RDB$DB_KEY = :g_dbkey
  into   :id_guest;

  select RD.FROM_DATE, RD.TO_DATE, RD.ID_ROOM, RD.ID_BOARD,
         RD.ID_RATE, RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE,
         RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON, RD.ID_NOM_COME_REASON,
         RD.VAUCHER_NUM, RD.VAUCHER_DATE, RD.VAUCHER_TEXT,
         RD.VAUCHER_NUM2, RD.VAUCHER_DATE2, RD.ID_RESERV_DETAIL,
         RD.TRANSFER_IN_TIME, RD.TRANSFER_IN_NOTE, RD.TRANSFER_OUT_TIME, RD.TRANSFER_OUT_NOTE, RD.CODE_FIRST_FOOD,
         RD.ID_HOTEL, rd.ID_TITULAR
  from   RESERV_DETAIL RD
         left outer join PROFILE_PERSON PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join PROFILE_AGENT PA on PA.ID_PROFILE = RD.ID_AGENT_PROFILE
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :from_date, :to_date, :res_id_room, :id_board,
         :id_tarrif, :id_nom_market_segment, :id_nom_source_code,
         :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason,
         :voucher_num, :voucher_date, :voucher_text,
         :voucher2_num, :voucher2_date, :id_reserv_detail,
         :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note, :code_first_food,
         :id_hotel, :id_titular;

  execute procedure RES_GUEST_SAVE_STAY$INT(:g_dbkey, :from_date, :to_date, :id_hotel);

  execute procedure RES_GUEST_SAVE_VOUCHER$INT(:rd_dbkey, :g_dbkey, :voucher_num, :voucher_date,
          :voucher_text, :voucher2_num, :voucher2_date);

  execute procedure RES_GUEST_SAVE_OTHER$INT(:g_dbkey, :transfer_in_time, :transfer_in_note,
          :transfer_out_time, :transfer_out_note, :code_first_food);

  execute procedure RES_GUEST_SAVE_MARKETING$INT(:id_guest, :id_nom_market_segment, :id_nom_source_code,
          :id_nom_channel_code,:id_nom_hear_reason, :id_nom_come_reason);

  if (:IS_NEW_GUEST = 0) then begin
    delete from GUEST_STAY GS
    where  GS.ID_GUEST = :id_guest;

    delete from GUEST_PACKET GP
    where  GP.ID_GUEST = :id_guest;
  end
  --execute procedure sys_dbg('res RES_GUEST_AUTO$INT id_room = '||coalesce(:res_id_room, 'null'));

  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) SD
  into   :sys_date;

  for
    select RLP.OUT_DATE
    from   SYSTEM_LOOP_PERIOD(:from_date, :to_date - 1) RLP
    into   :for_date
  do begin
    id_room = :res_id_room;
    if (:for_date < :sys_date) then begin
      -- get initial room from first checked-in guest for reservation, because may be different from current
      select first 1 GS.ID_ROOM
      from   GUEST G
             join GUEST_STAY GS on GS.ID_GUEST = G.ID_GUEST
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and GS.FOR_DATE = :for_date
      order by g.ID_GUEST asc
      into   :id_room;
    end

    insert into GUEST_STAY (ID_GUEST, FOR_DATE, ID_ROOM_TYPE, ID_BOARD, ID_TYPE_STAY, ID_TARIFF, /*ID_PACKET, */ID_ROOM)
    values (:id_guest, :for_date, -1, :id_board, -1, :id_tarrif, /*:id_packet,*/ :id_room);
  end

  insert into GUEST_PACKET (ID_GUEST, ID_PACKET_ITEM)
  select :id_guest, gp.ID_PACKET_ITEM
  from   GUEST_PACKET GP
  where  GP.ID_GUEST = :id_titular;

  execute procedure RES_GUESTDATA_INVALIDATE$INT(:rd_dbkey);
  --
end
^

/* Restore proc. body: RES_GUEST_CHANGE$RSV */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable check_status integer;
  declare variable id_person_data integer;
  declare variable old_person_profile integer;
  declare variable old_profile_name varchar(100);
  declare variable new_profile_name varchar(100);
begin
  select r.RDB$DB_KEY, r.ID_TITULAR, r.CHECK_STATUS, r.ID_PERSON_PROFILE, p.PROFILE_NAME
  from   RESERV_DETAIL R
         join PROFILE P on P.ID_PROFILE = r.ID_PERSON_PROFILE
  where  R.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :id_guest, :check_status, :old_person_profile, :old_profile_name;

  if (:old_person_profile = :ID_PERSON_PROFILE) then exit; -- NO CHANGES!

  id_person_data = null;
  select pp.ID_PERSON_DATA, p.PROFILE_NAME
  from   PROFILE_PERSON PP
         join PROFILE P on P.ID_PROFILE = pp.ID_PROFILE
  where  pp.ID_PROFILE = :ID_PERSON_PROFILE
  into   :id_person_data, :new_profile_name;

  if (:id_person_data is null) then exception BOOKING_EXCEPTION '-1039';

  update RESERV_DETAIL RD
  set    rd.ID_PERSON_PROFILE = :ID_PERSON_PROFILE
  where  rd.RDB$DB_KEY = :rd_dbkey;

  if (:check_status = 1) then begin
    execute procedure PERSON_DATA_COPY$INT (:id_person_data)
    returning_values (:id_person_data);
  end

  update GUEST_DATA GD
  set    gd.ID_PERSON_DATA = :id_person_data
  where  gd.ID_GUEST = :id_guest;

  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey);

  if (exists (select ap.ID_ACCOUNT_POST
              from   ACCOUNT_POST AP
                     join ACCOUNT A on A.ID_ACCOUNT = ap.ID_ACCOUNT
              where  a.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                     and a.ID_PROFILE = :old_person_profile
                     and ap.IS_ANUL = 0)) then
    exception BOOKING_EXCEPTION '-1038';

  if (exists (select d.ID_DEPOSIT
              from   DEPOSITS D
                     join ACCOUNT A on A.ID_ACCOUNT = d.ID_ACCOUNT
              where  a.ID_PROFILE = :old_person_profile
                     and coalesce(d.ID_RESERV_DETAIL, a.ID_RESERV_DETAIL) = :ID_RESERV_DETAIL
                     and d.RECEIVED_AMOUNT > 0)) then
    exception BOOKING_EXCEPTION '-1040';

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'TITULAR_CHANGED',
          f_character(29) || :old_profile_name || f_character(28) || :new_profile_name, null);

end
^

/* Restore proc. body: RES_GUEST_SAVE_OTHER$RSV */
ALTER PROCEDURE RES_GUEST_SAVE_OTHER$RSV(ID_GUEST INTEGER,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE)
 AS
declare variable g_dbkey char(8);
  declare variable old_code_first_food tfood_code;
  declare variable old_text_first_food varchar(50);
  declare variable text_first_food varchar(50);
  declare variable action_text varchar(255);
begin
  select G.RDB$DB_KEY, G.CODE_FIRST_FOOD
  from   GUEST G
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :old_code_first_food;

  execute procedure RES_GUEST_SAVE_OTHER$INT(:g_dbkey, :transfer_in_time, :transfer_in_note,
          :transfer_out_time, :transfer_out_note, :code_first_food);

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

  if (coalesce(:old_code_first_food, 0) <> coalesce(:code_first_food, 0)) then begin
    old_text_first_food = case
                              when :old_code_first_food = 'breakfast' then 'caption.breakfast'
                              when :old_code_first_food = 'lunch' then 'caption.launch'
                              when :old_code_first_food = 'dinner' then 'caption.dinner'
                              when :old_code_first_food = 'extrafood1' then 'caption.extrafood1'
                              when :old_code_first_food = 'extrafood2' then 'caption.extrafood2'
                              when :old_code_first_food = 'none' then 'caption.no_first_food'
                          end;
    text_first_food = case
                              when :code_first_food = 'breakfast' then 'caption.breakfast'
                              when :code_first_food = 'lunch' then 'caption.launch'
                              when :code_first_food = 'dinner' then 'caption.dinner'
                              when :code_first_food = 'extrafood1' then 'caption.extrafood1'
                              when :code_first_food = 'extrafood2' then 'caption.extrafood2'
                              when :code_first_food = 'none' then 'caption.no_first_food'
                      end;
    action_text = f_character(29) || coalesce('@{' || :old_text_first_food || '}', '') ||
                  f_character(28) || coalesce('@{' || :text_first_food || '}', '');
    execute procedure SYSTEM_LOG_ADD ('GUEST', :ID_GUEST, 'FIRST_FOOD_CHANGED', :ACTION_TEXT);
  end
end
^

/* Restore proc. body: RES_RECALC$INT */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable num_prefix varchar(20);
  declare variable number_1 varchar(20);
begin
  /* CALLER_KIND = {NORMAL, FORCED} */
  err_code = 0;
  /* 1. GET DATA */
  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, rd.NUMBER_1
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :number_1;

  if (:check_status = 1) then begin
    -- CHECKED OUT
    select sn.LEADING_PART
    from   SYSTEM_NUMERATOR SN
    where  sn.ID_NUMERATOR = 0
    into   :num_prefix;

    if (trim('.' from coalesce(:num_prefix, '')) = coalesce(:number_1, '')) then
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_MINE');
    else
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_ELSE');

    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :id_guest
    do begin
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'MANUAL_EDIT_DATA', '');
    end
  end
  /* 2. FIND DEPENDANT GUESTS AND THEIR TARIFFS */
  --execute procedure sys_dbg('calc RES_RECALC$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

  ID_TAR_CALC = gen_id(gen_id_tar_calc, 1);
  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NONE');

  -- 3. UPDATE ROOM PRICE and REPOST ALL AFFECTED BOOKINGS
  execute procedure RES_TAR_CALC_FINALIZE$INT (:ID_TAR_CALC, :CALLER_KIND, :FORCE_POSTING)
  returning_values (:ERR_CODE, :ERR_TEXT);
end
^

/* Restore proc. body: RES_RECALC$RSV */
ALTER PROCEDURE RES_RECALC$RSV(ID_RESERV_DETAIL INTEGER,
FORCE_POSTING SMALLINT = null)
 AS
declare variable id_tar_calc integer;
declare variable err_text varchar(255);
  declare variable err_code integer;
  declare variable rd_dbkey char(8);
begin
  -- FORCED, user activated recalculation
  execute procedure RIGHTS_CHECK_GRANTED$INT ('GUEST_RECALC_POST');

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_RECALC$INT(:rd_dbkey, 'FORCED', :FORCE_POSTING)
  returning_values  :err_code, :err_text, :id_tar_calc;
  if (:err_code < 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'FORCED_RECALC', null);

end
^

/* Restore proc. body: RES_SAVE_GUARANTEE$RSV */
ALTER PROCEDURE RES_SAVE_GUARANTEE$RSV(ID_RESERV_DETAIL INTEGER,
IS_VIP SMALLINT,
CHECK_STATUS INTEGER,
ID_GUARANTEE_POLICY INTEGER,
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
declare variable old_check_status integer;
declare variable warn_code integer;
declare variable rd_dbkey char(8);
declare variable action_text varchar(255);
begin
  /*  Description:
  ||  GUI facade
  */
  select RD.RDB$DB_KEY, rd.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_check_status;

  update RESERV_DETAIL RDU
  set    RDU.IS_VIP = coalesce(:is_vip, RDU.IS_VIP),
         RDU.ID_GUARANTEE_POLICY = :id_guarantee_policy,
         RDU.GUARANTEE_DEPOSIT = :guarantee_deposit,
         RDU.GUARANTEE_CURRENCY = :guarantee_currency,
         RDU.BLOCK_CC = :BLOCK_CC,
         GUARANTEE_DEPOSIT_PERCENT = :GUARANTEE_DEPOSIT_PERCENT,
         GUARANTEE_DEPOSIT_NIGHTS = :GUARANTEE_DEPOSIT_NIGHTS,
         GUARANTEE_DUE_DAYS_BEF_ARRIVAL = :GUARANTEE_DUE_DAYS_BEF_ARRIVAL,
         GUARANTEE_DUE_DAYS_AFTER_CREATE = :GUARANTEE_DUE_DAYS_AFTER_CREATE
  where  RDU.RDB$DB_KEY = :rd_dbkey;

  action_text = '';
  if (:GUARANTEE_DEPOSIT_PERCENT is not null) then begin
    action_text = f_character(29) || '@{caption.guaranteetype.percent} ' || formatfloat(:GUARANTEE_DEPOSIT_PERCENT, '0.00') || f_character(28)
                  || '[' || coalesce(:GUARANTEE_DUE_DAYS_AFTER_CREATE, ' ') || ']'
                  || f_character(28) || '[' || coalesce(:GUARANTEE_DUE_DAYS_BEF_ARRIVAL, ' ') || ']';
  end
  else if (:GUARANTEE_DEPOSIT_NIGHTS is not null) then begin
    action_text = f_character(29) || '@{caption.guaranteetype.nights} ' || :GUARANTEE_DEPOSIT_NIGHTS || f_character(28)
                  || '[' || coalesce(:GUARANTEE_DUE_DAYS_AFTER_CREATE, ' ') || ']'
                  || f_character(28) || '[' || coalesce(:GUARANTEE_DUE_DAYS_BEF_ARRIVAL, ' ') || ']';
  end
  else if (:GUARANTEE_DEPOSIT is not null) then begin
    action_text = f_character(29) || '@{caption.guaranteetype.fixed} ' || formatfloat(:GUARANTEE_DEPOSIT, '0.00') || ' ' || :GUARANTEE_CURRENCY || f_character(28)
                  || '[' || coalesce(:GUARANTEE_DUE_DAYS_AFTER_CREATE, ' ') || ']'
                  || f_character(28) || '[' || coalesce(:GUARANTEE_DUE_DAYS_BEF_ARRIVAL, ' ') || ']';
  end

  if (:action_text <> '') then begin
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_GUARANTEE_CHANGED', :action_text);
  end

  CHECK_STATUS = coalesce(:CHECK_STATUS, :old_check_status);
  if (:CHECK_STATUS <> :old_check_status) then begin

    if (:CHECK_STATUS >= 0) then exception BOOKING_EXCEPTION 'Can not set status ''CHECKED IN'' or ''CHECKED OUT'' manually!';

    execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, :check_status);

    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;
  end
end
^

/* Restore proc. body: RES_SAVE_MARKETING$RSV */
ALTER PROCEDURE RES_SAVE_MARKETING$RSV(ID_RESERV_DETAIL INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable rd_dbkey char(8);
declare variable old_mrkt_profile varchar(255);
declare variable new_mrkt_profile varchar(255);
begin
  err_code = 0;
  err_text = '';
  rd_dbkey = null;
  select RD.RDB$DB_KEY, MP.MARKETING_PROFILE
  from   RESERV_DETAIL RD
         left outer join MARKETING_PROFILE_GET (RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_COME_REASON,
              RD.ID_NOM_HEAR_REASON, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_MARKET_SEGMENT) MP on 1=1
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_mrkt_profile;

  execute procedure RES_SAVE_MARKETING$INT(:rd_dbkey, :id_nom_market_segment,
          :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason);

  select MP.MARKETING_PROFILE
  from   MARKETING_PROFILE_GET (:ID_NOM_CHANNEL_CODE, :ID_NOM_COME_REASON,
              :ID_NOM_HEAR_REASON, :ID_NOM_SOURCE_CODE, :ID_NOM_MARKET_SEGMENT) MP
  into   :new_mrkt_profile;

  if (:new_mrkt_profile is distinct from :old_mrkt_profile) then begin
    --execute procedure RESERV_TRACK_CHANGES$INT (:rd_dbkey);

    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'MARKETING_CHANGE',
            f_character(29) || :old_mrkt_profile || f_character(28) || :new_mrkt_profile);
  end
end
^

/* Restore proc. body: RES_SAVE_PRICE$RSV */
ALTER PROCEDURE RES_SAVE_PRICE$RSV(ID_RESERV_DETAIL INTEGER,
FOR_DATE DATE,
PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3))
 AS
declare variable old_price numeric(14,4);
  declare variable old_price_currency char(3);
  declare variable action_text varchar(255);
begin
  select cp.PRICE, cp.PRICE_CURRENCY
  from   RESERV_CUSTOM_PRICE cp
  where  cp.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
         and cp.FOR_DATE = :FOR_DATE
  into   :old_price, :old_price_currency;

  if ((:old_price is distinct from :price) or (:old_price_currency is distinct from :price_currency) ) then begin
    execute procedure RES_SAVE_CUSTOM_PRICE$INT(:ID_RESERV_DETAIL, :FOR_DATE, :PRICE, :PRICE_CURRENCY);

    action_text = f_character(29) || formatfloat(:price, 'F;0.00') || ' ' || :price_currency || f_character(28) || formatdate(:for_date, 'D;dd.mm.yyyy') ;
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MANUAL_PRICE', :action_text);
  end
end
^

/* Restore proc. body: RES_SAVE_RATE$INT */
ALTER PROCEDURE RES_SAVE_RATE$INT(RD_DBKEY CHAR(8),
ID_RATE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable g_dbkey char(8);
  declare variable id_guest integer;
  declare variable id_old_rate integer;
  declare variable action_text varchar(255);
begin
  select RD.ID_RESERV_DETAIL, rd.ID_RATE
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail, :id_old_rate;

  update RESERV_DETAIL RD
  set    RD.ID_RATE = :id_rate,
         RD.HAS_DIFFERENT_TARIFF = 0
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:ID_RATE is distinct from :id_old_rate) then begin
    select f_character(29) || t.TARIFA_NAME
    from   TARIFA T
    where  t.ID_TARIFA = :id_old_rate
    into   :action_text;

    select :action_text || f_character(28) || t.TARIFA_NAME
    from   TARIFA T
    where  t.ID_TARIFA = :ID_RATE
    into   :action_text;

    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_RATE_CHANGED', :action_text);
  end

  for
    select G.RDB$DB_KEY, G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey, :id_guest
  do begin
    update GUEST GU
    set    GU.ID_TARIFA = :id_rate
    where  GU.RDB$DB_KEY = :g_dbkey;

    update GUEST_STAY GS
    set    GS.ID_TARIFF = :id_rate
    where  GS.ID_GUEST = :id_guest;

    execute procedure RES_GUESTDATA_INVALIDATE$INT(:rd_dbkey);
  end
end
^

/* Restore proc. body: RES_SAVE_RATE$RSV */
ALTER PROCEDURE RES_SAVE_RATE$RSV(ID_RESERV_DETAIL INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
IS_DIFFERENT_TARIFF INTEGER,
IS_DIFFERENT_PRICE INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 AS
declare variable rd_dbkey char(8);
  declare variable old_price numeric(14,4);
  declare variable old_price_currency char(3);
  declare variable old_is_different_price integer;
  declare variable action_text varchar(255);
  declare variable err_code integer;
  declare variable err_text varchar(255) ;
  declare variable id_tar_calc integer;
  declare variable recalc_type varchar(20);
  declare variable old_tariff integer;
begin

  select RD.RDB$DB_KEY, RD.custom_price, rd.custom_currency, rd.HAS_DIFFERENT_PRICE, rd.ID_RATE
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_price, :old_price_currency, :old_is_different_price, :old_tariff;

  if (:is_different_tariff = 0) then begin
    execute procedure RES_SAVE_RATE$INT(:rd_dbkey, :id_tariff);
  end else begin
    execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey);
  end

  if (:IS_DIFFERENT_PRICE = 0) then begin
    delete from RESERV_CUSTOM_PRICE
    where  ID_RESERV_DETAIL  = :ID_RESERV_DETAIL;

    update RESERV_DETAIL RD
    set    RD.CUSTOM_PRICE = :custom_price,
           RD.CUSTOM_CURRENCY = :custom_currency,
           RD.HAS_DIFFERENT_PRICE = :IS_DIFFERENT_PRICE
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end else begin
    if (not exists (select * from RESERV_CUSTOM_PRICE rmp where rmp.id_reserv_detail = :id_reserv_detail)) then IS_DIFFERENT_PRICE = 0;
    update RESERV_DETAIL RD
    set    RD.CUSTOM_PRICE = null,
           RD.CUSTOM_CURRENCY = null,
           RD.HAS_DIFFERENT_PRICE = :IS_DIFFERENT_PRICE
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end


  /*Maintain the flag in RD - HAS_DIFFERENT_PRICE*/
/*  if (exists (select * from RESERV_CUSTOM_PRICE rmp where rmp.id_reserv_detail = :id_reserv_detail)) then
    update RESERV_DETAIL set has_different_price = 1 where id_reserv_detail = :id_reserv_detail;
  else
    update RESERV_DETAIL set has_different_price = 0 where id_reserv_detail = :id_reserv_detail;
*/
  /*Log modifications in custom price if here is diferent values*/
  if ((:old_price is distinct from :custom_price) or (:old_price_currency is distinct from :custom_currency) ) then begin
    action_text = f_character(29) || formatfloat(:custom_price, 'F;0.00') || '' || :custom_currency || f_character(28);
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MANUAL_PRICE', :action_text);
  end

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    if ((:ID_TARIFF is distinct from :old_tariff)
        or (:IS_DIFFERENT_PRICE is distinct from :old_is_different_price)
        or (:CUSTOM_PRICE is distinct from :old_price)
        or (:CUSTOM_CURRENCY is distinct from :old_price_currency) ) then
      recalc_type = 'FORCED';
    else
      recalc_type = 'NORMAL';

    execute procedure RES_RECALC$INT(:rd_dbkey, :recalc_type, 0)
    returning_values  :err_code, :err_text, :id_tar_calc;
    --execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    --returning_values  :err_code, :err_text;
    if (:err_code < 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end
end
^

/* Restore proc. body: RES_SAVE_ROOM_LOG$INT */
ALTER PROCEDURE RES_SAVE_ROOM_LOG$INT(RD_DBKEY CHAR(8),
OLD_ID_ROOM INTEGER,
OLD_ID_RES_ROOM_TYPE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_res_room_type integer;
  declare variable id_room integer;
  declare variable check_status integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable system_date date;
begin

  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, RD.ID_ROOM_TYPE, RD.ID_ROOM, RD.ID_HOTEL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :id_res_room_type, :id_room, :id_hotel;

  /* LOG SECTION */
  action_text = f_character(29);
  if (:old_ID_RES_ROOM_TYPE is distinct from :ID_RES_ROOM_TYPE) then begin
    select :action_text || '<' || coalesce(rt.TYPE_ROOM, '') || '>'
    from   ROOM_TYPES rt
    where  rt.ID_ROOM_TYPE = :old_id_res_room_type
    into   :action_text;
    action_text = :action_text || f_character(28);
    select :action_text || '<' || coalesce(rt.TYPE_ROOM, '') || '>'
    from   ROOM_TYPES rt
    where  rt.ID_ROOM_TYPE = :ID_RES_ROOM_TYPE
    into   :action_text;
    action_text = :action_text || f_character(28);

    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_ROOM_TYPE_CHANGED', :action_text);
  end

  action_text = f_character(29);
  if (:old_id_room is distinct from :ID_ROOM) then begin
    select :action_text || '<' || coalesce(rt.TYPE_ROOM, '') || ' ' || coalesce (R.ROOM_NAME, '') || '>'
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :old_id_room
    into   :action_text;
    action_text = :action_text || f_character(28);

    select :action_text || '<' || coalesce(rt.TYPE_ROOM, '') || ' ' || coalesce (R.ROOM_NAME, '') || '>'
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :id_room
    into   :action_text;
    action_text = :action_text || f_character(28);

    if (:check_status >= 0) then begin
      execute procedure SYSTEM_DATE_GET (:id_hotel)
      returning_values :system_date;
      action_text = :action_text || f_character(28) || :system_date;
      execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'ROOM_MOVED', :action_text, :old_id_room);
    end else
      execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'ROOM_CHANGED', :action_text);
  end
  /*****/
end
^

/* Restore proc. body: RES_SAVE_STATUS$INT */
ALTER PROCEDURE RES_SAVE_STATUS$INT(RD_DBKEY CHAR(8),
CHECK_STATUS INTEGER,
CONFIRMATION_NUMBER TYPE OF NAME_20 = null)
 AS
declare variable old_check_status integer;
  declare variable id_reserv_detail integer;
  declare variable action_text varchar(255);
begin

  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_check_status, :id_reserv_detail;

  if (:old_check_status <> :check_status) then begin
    if (:old_check_status >= 0 and :CHECK_STATUS < :old_check_status) then begin
      exception BOOKING_EXCEPTION 'Can not downgrade status for checked in booking!';
    end

    if (:old_check_status < 0 and :CHECK_STATUS = 1) then begin
      exception BOOKING_EXCEPTION '-1006';
    end

    update RESERV_DETAIL RDU
    set    RDU.CHECK_STATUS = :check_status,
           RDU.CONFIRMATION_NUMBER = iif (:CHECK_STATUS = -1, strhash_large(rdu.NUMBER || 'CONFIRMATION'), rdu.CONFIRMATION_NUMBER)
    where  RDU.RDB$DB_KEY = :rd_dbkey;

    update ROOM_MAGIC RM
    set    rm.BUSY_TYPE = case when :CHECK_STATUS = '1' then 'CHECK_OUT'
                               when :CHECK_STATUS = '0' then 'CHECK_IN'
                               when :CHECK_STATUS = '-1' then 'VALUE_CONFIRMED'
                               when :CHECK_STATUS = '-2' then 'VALUE_NOTCONFIRMED'
                               when :CHECK_STATUS = '-3' then 'VALUE_RESERVS'
                               else rm.BUSY_TYPE
                          end
    where  rm.ID_RESERV_DETAIL = :id_reserv_detail;

    update ROOMS_SHARE Rs
    set    rs.BUSY_TYPE = case when :CHECK_STATUS = '1' then 'CHECK_OUT'
                               when :CHECK_STATUS = '0' then 'CHECK_IN'
                               when :CHECK_STATUS = '-1' then 'VALUE_CONFIRMED'
                               when :CHECK_STATUS = '-2' then 'VALUE_NOTCONFIRMED'
                               when :CHECK_STATUS = '-3' then 'VALUE_RESERVS'
                               else rs.BUSY_TYPE
                          end
    where  rs.ID_RESERV_STATISTICS = :id_reserv_detail;

    execute procedure RES_SET_EDIT_STATUS$INT (:rd_dbkey, 'STATUS', 'add');

    if (:CHECK_STATUS < 0) then begin
      action_text = f_character(29) || '@{booking.status.' || :old_check_status || '}'
                    || f_character(28) || '@{booking.status.' || :CHECK_STATUS || '}';
      execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MOD_STATUS', :action_text);
    end
  end

  if (:CHECK_STATUS = -1 and :CONFIRMATION_NUMBER is not null) then begin
    -- override with incoming confirmation number
    update RESERV_DETAIL rd
    set    rd.CONFIRMATION_NUMBER = :CONFIRMATION_NUMBER
    where  rd.RDB$DB_KEY = :RD_DBKEY;
  end
end
^

/* Restore proc. body: RES_SAVE_VOUCHER$INT */
ALTER PROCEDURE RES_SAVE_VOUCHER$INT(RD_DBKEY CHAR(8),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE)
 AS
declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable action_text varchar(255);
begin

  update RESERV_DETAIL RD
  set    RD.VAUCHER_NUM = :voucher_num,
         RD.VAUCHER_DATE = :voucher_date,
         RD.VAUCHER_TEXT = :voucher_text,
         RD.VAUCHER_NUM2 = :voucher2_num,
         RD.VAUCHER_DATE2 = :voucher2_date,
         RD.HAS_DIFFERENT_VOUCHERS = 0
  where  RD.RDB$DB_KEY = :rd_dbkey
         and
         ((RD.VAUCHER_NUM is distinct from :voucher_num)
          or (RD.VAUCHER_DATE is distinct from :voucher_date)
          or (RD.VAUCHER_TEXT is distinct from :voucher_text)
          or (RD.VAUCHER_NUM2 is distinct from :voucher2_num)
          or (RD.VAUCHER_DATE2 is distinct from :voucher2_date)
          or (RD.HAS_DIFFERENT_VOUCHERS is distinct from 0)
         );

  if (row_count > 0) then begin
    select RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.RDB$DB_KEY = :rd_dbkey
    into   :id_reserv_detail;
  
    action_text = f_character(29)
                  || coalesce(:VOUCHER_NUM, '')
                  || iif(:VOUCHER_DATE is not null, '/' || formatdate(:VOUCHER_DATE, 'D;dd.mm.yyyy'), '')
                  || ' (2: ' || coalesce(:VOUCHER2_NUM, '')
                  || iif(:VOUCHER2_DATE is not null, '/' || formatdate(:VOUCHER2_DATE, 'D;dd.mm.yyyy'), '')
                  || ')';
  
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'VOUCHER_SET', :action_text);
  
    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure RES_GUEST_SAVE_VOUCHER$INT(:rd_dbkey, :g_dbkey, :voucher_num, :voucher_date,
              :voucher_text, :voucher2_num, :voucher2_date);
    end
  
    execute procedure RES_GUESTDATA_INVALIDATE$INT(:rd_dbkey);
  end
end
^

/* Restore proc. body: RES_SET_ROOM_MULTI$RSV */
ALTER PROCEDURE RES_SET_ROOM_MULTI$RSV(OPERATION VARCHAR(20),
FROM_ROOM VARCHAR(20),
SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable cnt_requested integer;
  declare variable cnt_old_room integer;
  declare variable cnt_found integer;
  declare variable is_already_planned integer;
  declare variable is_satisfied integer;
  declare variable new_id_room integer;
  declare variable current_id_room integer;
  declare variable id_res_room_type integer;
  declare variable room_requirements blob sub_type 1 segment size 100;
  declare variable from_date date;
  declare variable to_date date;
  declare variable action_text varchar(255);
  declare variable is_early_arrival smallint;
  declare variable is_late_departure smallint;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable id_reserv_detail integer;
  declare variable tmp_warn_code integer;
  declare variable min_beds integer;
  declare variable virtual_room varchar(10);
  declare variable share_err_text varchar(255);
begin
  /* offer_method :
  ||     0 - NUMBER desc,
  ||     1 - NUMBER asc,
  ||     2 - DAYS FREE(MAX OCCUPANCY),
  ||     3 - FILING FACTOR(EQUAL ROOM USAGE)
  */
  warn_code = null;

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'set_number_asc, set_number_desc, set_max_occupancy, set_max_usage');

  cnt_requested = 0;
  cnt_old_room = 0;
  cnt_found = 0;
  for
    select RD.RDB$DB_KEY, rd.ID_RESERV_DETAIL, rd.ID_ROOM, rd.VIRTUAL_ROOM, RD.ID_ROOM_TYPE, RD.ROOM_FEATURES,
           RD.FROM_DATE, RD.TO_DATE, iif(rd.COMMING_KIND = 0, 1, 0), iif(rd.LEAVING_KIND = 2, 1, 0),
           rd.ADULT_COUNT + rd.CHILD_COUNT
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
           and RD.IS_ANUL = 0
    into   :rd_dbkey, :id_reserv_detail, :current_id_room, :virtual_room, :id_res_room_type, :room_requirements,
           :from_date, :to_date, :is_early_arrival, :is_late_departure, :min_beds
  do begin
    cnt_requested = :cnt_requested + 1;
    new_id_room = null;
    if (:current_id_room < 0) then begin
      if (:virtual_room is not null) then begin
        -- has related bookings with shared virtual room
        -- get cumulative stay for all shared bookings
        select min(vrd.FROM_DATE), min(vrd.FROM_DATE) - min(vrd.FROM_DATE - iif(vrd.COMMING_KIND = 0, 1, 0)),
               max(vrd.TO_DATE), max(vrd.TO_DATE + iif(vrd.LEAVING_KIND = 2, 1, 0)) - max(vrd.TO_DATE),
               sum(vrd.ADULT_COUNT + vrd.CHILD_COUNT)
        from   RESERV_DETAIL VRD
        where  vrd.ID_ROOM = :current_id_room
               and vrd.IS_ANUL = 0
        into   :from_date, :is_early_arrival, :to_date, :is_late_departure, :min_beds;
      end
      -- from_date and to_date are arrival and departure date of reservation,
      -- not first and last accomodation dates !!! this is need to check early arrivals and late departures
      execute procedure ROOM_PICKUP$INT(:id_res_room_type, :from_date, :to_date,
              :is_early_arrival, :is_late_departure,:operation, :from_room, :room_requirements, :min_beds)
      returning_values  :new_id_room;  -- offered room

      if (:new_id_room is not null) then begin
        is_satisfied = 1;
        select R.ROOM_NAME
        from   ROOMS R
        where  r.ID_ROOM = :new_id_room
        into   :action_text;

        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'ROOM_SET_AUTO', :action_text);

        execute procedure RES_SET_ROOM$INT (:rd_dbkey, :new_id_room, 'nrttAsIs')
        returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
        if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
        WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

        if (:virtual_room is not null) then begin
          -- distribute the same room to shared bookings
          execute procedure RES_SET_ROOM_CO_RENTERS$INT (:current_id_room, :new_id_room, :id_reserv_detail, 'nrttAsIs')
          returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
          if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
        end
      end

    end else begin
      is_already_planned = 1;
    end

    cnt_old_room = :cnt_old_room + :is_already_planned;
    cnt_found = :cnt_found + :is_satisfied;

    when exception BOOKING_EXCEPTION do begin
      -- nothing, skip this booking
    end
  end

  if ((:cnt_found + :cnt_old_room) < :cnt_requested) then begin
    execute procedure SYSTEM_WARNING_ADD(-3, f_character(29)||:cnt_found||f_character(28)||:cnt_requested)
    returning_values  :warn_code;
  end
end
^

/* Restore proc. body: RES_TAR_CALC_FINALIZE$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(ID_TAR_CALC INTEGER,
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
declare variable old_room_price numeric(15,4);
  declare variable old_room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
  declare variable reserv_posting_disabled smallint;
  declare variable postings_disabled smallint;
  declare variable warn_code integer;
  declare variable action_text varchar(255);
  declare variable id_guest integer;
begin
  --  Razpiswa cenata na staia, kakto i price_detailite.

  execute procedure TAR_CALC_EVAL_ALL$INT(:ID_TAR_CALC)
  returning_values  :ERR_CODE, :ERR_TEXT;

  if (:ERR_CODE = 0) then execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

  select iif(si.INFO_VALUE = '1', 1, null)
  from   SYSTEM_INFO_GET('RESERV_POSTINGS_DISABLED') si
  into   :postings_disabled;

  for
    select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, coalesce(:postings_disabled, rd.IS_POSTING_STOPPED),
           coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
           coalesce(max((select first 1 AP.IS_BASE
                         from   GUEST G
                                join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                         where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (it`s possible)
    from   TAR_CALC_INPUT$TMP TI
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
           join TARIFA t on t.ID_TARIFA = rd.ID_RATE
    where  ti.ID_TAR_CALC = :ID_TAR_CALC
    group by 1, 2, 3, 4, 5, 6
    into   :id_reserv_detail, :check_status, :is_posting_stopped,
           :room_currency, :id_hotel, :is_anul, :has_postings
  do begin
    reserv_posting_disabled = iif(:is_posting_stopped = 1 and :has_postings = 0, 1, 0);

    if (:ERR_CODE <> 0) then begin
      -- price calculation error handling  !!!!!
      if (:reserv_posting_disabled = 1) then begin
        -- set price to null, posting is disabled
        update RESERV_DETAIL RD
        set    RD.ROOM_PRICE = null,
               RD.ROOM_CURRENCY = null,
               RD.ROOM_PRICE_DETAILS = null,
               RD.LAST_ID_TAR_CALC = null
        where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
      end else begin
        -- exit on error in price calculation - cannot make valid posts
        EXIT;
      end
    end else begin
      room_price = 0;
      room_price_details = '';
    
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);
  
      if (:reserv_posting_disabled = 0 and ((coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1))) then begin
        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);
      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;
  
        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end
  
      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc,
             rd.ROOM_PRICE_LAST$INT = null,
             rd.ROOM_CURRENCY_LAST$INT = null
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail
      returning old.ROOM_PRICE_LAST$INT, old.ROOM_CURRENCY_LAST$INT
      into :old_room_price, :old_room_currency;

      if ((:old_room_price is distinct from :room_price)
          or (:old_room_currency is distinct from :room_currency) ) then
      begin
        action_text = f_character(29) || formatfloat(:old_room_price, 'F;0.00') || ' ' || coalesce(:old_room_currency, '') || f_character(28) || formatfloat(:room_price, 'F;0.00') || ' ' || coalesce(:room_currency, '');
        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_PRICE_RECALC', :action_text);

        if (:check_status >= 0) then begin
          for
            select g.ID_GUEST
            from   GUEST G
            where  g.ID_RESERV_DETAIL = :id_reserv_detail
            into   :id_guest
          do begin
            execute procedure GUEST_REGISTRATION_UPDATE(:id_guest);
          end
        end
      end
    end
  end

  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;

  if (:ERR_CODE <> 0) then begin
    execute procedure SYSTEM_WARNING_ADD(:ERR_CODE, :ERR_TEXT)
    returning_values :warn_code;
    ERR_CODE = 0;
    ERR_TEXT='';
  end
end
^

/* Restore proc. body: RESERV_DETAIL_EXTERNAL_MOD$RSV */
ALTER PROCEDURE RESERV_DETAIL_EXTERNAL_MOD$RSV(ID_RESERV_DETAIL INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
LOCATOR VARCHAR(100))
 AS
BEGIN
  update RESERV_DETAIL_EXTERNAL
  set    MINIBAR_RIGHTS = :minibar_rights,
         PAYTV_RIGHTS = :paytv_rights,
         VIDEO_RIGHTS = :video_rights,
         NOPOST_PMS = :nopost_pms,
         PHONE_RIGHTS = :phone_rights,
         SEMINAR_CAHNNEL_RIGHTS = :seminar_cahnnel_rights,
         LOCATOR = :locator
  where  ID_RESERV_DETAIL = :id_reserv_detail;

  if (row_count = 0) then begin
    insert into RESERV_DETAIL_EXTERNAL (
        ID_RESERV_DETAIL,
        MINIBAR_RIGHTS,
        PAYTV_RIGHTS,
        VIDEO_RIGHTS,
        NOPOST_PMS,
        PHONE_RIGHTS,
        SEMINAR_CAHNNEL_RIGHTS,
        LOCATOR)
    values (
        :id_reserv_detail,
        :minibar_rights,
        :paytv_rights,
        :video_rights,
        :nopost_pms,
        :phone_rights,
        :seminar_cahnnel_rights,
        :locator);
  end

  execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RSV_EXT_DETAIL_CHNG', '');

END
^

/* Restore proc. body: RESERV_STATISTIC_CANCELED$INT */
ALTER PROCEDURE RESERV_STATISTIC_CANCELED$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(BUSY_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_PROFILE_AGENT INTEGER,
COUNTRY_CODE VARCHAR(20),
MARKET_SEGMENT_CODE VARCHAR(3),
SOURCE_CODE VARCHAR(3),
CHANNEL_CODE VARCHAR(3),
HEAR_REASON_CODE VARCHAR(3),
COME_REASON_CODE VARCHAR(3),
ROOMS_NOSHOW SMALLINT,
GUESTS_NOSHOW SMALLINT,
ROOMS_CANCELED SMALLINT)
 AS
begin
  -- {NOSHOW, CANCELED, USERERROR}
  for
    select P.OUT_DATE, RD.ID_ROOM_TYPE, S.ID_PROFILE_AGENT, coalesce(RD.COUNTRY, ''),
           S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE,
           count(distinct iif(RD.REASON_OF_ANUL = 'NOSHOW', RD.ID_ROOM, null)),
           sum(iif(RD.REASON_OF_ANUL = 'NOSHOW', RD.ADULT_COUNT + RD.CHILD_COUNT, 0)),
           count(distinct iif(RD.REASON_OF_ANUL = 'CANCELED', RD.ID_ROOM, null))
    from   RESERV_DETAIL RD
           left outer join RESERV_STATISTIC_SLICE$INT(RD.ID_RESERV_DETAIL) S on 0=0
           left outer join SYSTEM_LOOP_PERIOD(maxdate(:from_date, RD.FROM_DATE), mindate(:to_date, RD.TO_DATE-1)) P on 0=0
    where  RD.ID_HOTEL = :id_hotel
           and RD.FROM_DATE <= :to_date
           and RD.TO_DATE > :from_date
           and RD.IS_ANUL = 1
           and RD.REASON_OF_ANUL in ('NOSHOW', 'CANCELED')
    group by 1, 2, 3, 4, 5, 6, 7, 8, 9
    into   :busy_date, :id_room_type, :id_profile_agent, :country_code,
           :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
           :rooms_noshow,
           :guests_noshow,
           :rooms_canceled
  do begin
    suspend;
  end
end
^

/* Restore proc. body: RESGRP_SAVE_OTHER$INT */
ALTER PROCEDURE RESGRP_SAVE_OTHER$INT(RD_DBKEY CHAR(8),
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
ID_EATING_OBJECT TYPE OF ID_REF)
 AS
declare variable id_reserv_detail integer;
  declare variable g_dbkey char(8);
  declare variable old_code_first_food type of tfood_code;
  declare variable old_text_first_food varchar(50);
  declare variable text_first_food varchar(50);
  declare variable action_text varchar(255);
begin
  select RD.ID_RESERV_DETAIL, RD.CODE_FIRST_FOOD
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail, :old_code_first_food;

  update RESERV_DETAIL RD
  set    RD.HAS_DIFFERENT_OTHER = 0,
         RD.TRANSFER_IN_TIME = :transfer_in_time,
         RD.TRANSFER_IN_NOTE = :transfer_in_note,
         RD.TRANSFER_OUT_TIME = :transfer_out_time,
         RD.TRANSFER_OUT_NOTE = :transfer_out_note,
         RD.CODE_FIRST_FOOD = :code_first_food,
         rd.ID_EATING_OBJECT = :ID_EATING_OBJECT
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_code_first_food is distinct from :code_first_food) then begin
    old_text_first_food = cast(case
                              when :old_code_first_food = 'breakfast' then 'caption.breakfast'
                              when :old_code_first_food = 'lunch' then 'caption.launch'
                              when :old_code_first_food = 'dinner' then 'caption.dinner'
                              when :old_code_first_food = 'extrafood1' then 'caption.extrafood1'
                              when :old_code_first_food = 'extrafood2' then 'caption.extrafood2'
                              when :old_code_first_food = 'none' then 'caption.no_first_food'
                          end as varchar(50));
    text_first_food = cast(case
                              when :code_first_food = 'breakfast' then 'caption.breakfast'
                              when :code_first_food = 'lunch' then 'caption.launch'
                              when :code_first_food = 'dinner' then 'caption.dinner'
                              when :code_first_food = 'extrafood1' then 'caption.extrafood1'
                              when :code_first_food = 'extrafood2' then 'caption.extrafood2'
                              when :code_first_food = 'none' then 'caption.no_first_food'
                           end as varchar(50));
    action_text = f_character(29) || coalesce('@{' || :old_text_first_food || '}', '') ||
                  f_character(28) || coalesce('@{' || :text_first_food || '}', '');
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'FIRST_FOOD_CHANGED', :ACTION_TEXT);
  end

  for
    select G.RDB$DB_KEY
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey
  do begin
    execute procedure RES_GUEST_SAVE_OTHER$INT(:g_dbkey, :transfer_in_time, :transfer_in_note,
            :transfer_out_time, :transfer_out_note, :code_first_food);
  end
end
^

/* Restore proc. body: REVENUE_SUMMARY_REMAKE$SYS */
ALTER PROCEDURE REVENUE_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
STATISTIC_ONLY SMALLINT)
 AS
declare variable id_end_work integer;
declare variable ad_dbkey char(8);
declare variable id_service integer;
declare variable id_guest integer;
declare variable id_account integer;
declare variable revenue_group varchar(50);
declare variable revenue_account varchar(50);
declare variable revenue_sub_account varchar(50);
begin
  if (not exists (select h.ID_HOTEL
                  from   HOTEL H
                  where  h.ID_HOTEL = :ID_HOTEL)) then exception WRONG_VALUE 'Non-existing hotel!';

  if (:STATISTIC_ONLY = 1) then begin

    execute procedure REVENUE_STATISTIC_REMAKE$SYS (:ID_HOTEL, :FROM_DATE, :TO_DATE);

    execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'REV_REGEN_PART',
                                      f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') ||
                                      f_character(28) || formatdate(:to_date, 'D;dd/mm/yyyy'));
  end else begin
    for
      select ad.RDB$DB_KEY, ad.ID_SERVICE, ad.ID_GUEST, ad.ID_ACCOUNT
      from   ACCOUNT_DEBT AD
      where  AD.ID_HOTEL = :id_hotel
             and ad.DEBT_DATE between :FROM_DATE and :TO_DATE
      order by ad.DEBT_DATE asc, ad.ID_ACCOUNT_POST asc
      into   :ad_dbkey, :id_service, :id_guest, :id_account
    do begin
      select  S.REVENUE_GROUP, RA.REVENUE_ACCOUNT, RA.REVENUE_SUB_ACCOUNT
      from    ACCOUNT A
              left outer join SERVICES S on s.ID_SERVICE = :id_service
              left outer join GUEST G on G.ID_GUEST = :id_guest
              left outer join PROFILE_HOUSE PH on PH.ID_PROFILE = A.ID_PROFILE
              left outer join REVENUE_ACCOUNT_PARSE$INT (S.REVENUE_ACCOUNT, coalesce(G.ID_RESERV_DETAIL, A.ID_RESERV_DETAIL)) RA on 1=1
      where   a.ID_ACCOUNT = :id_account
              and PH.HOUSE_TYPE is distinct from 'hptComplimentary'
      into    :revenue_group, :revenue_account, :revenue_sub_account;
  
      update ACCOUNT_DEBT d
      set    d.REVENUE_GROUP = :revenue_group,
             d.REVENUE_ACCOUNT = :revenue_account,
             d.REVENUE_SUB_ACCOUNT = :revenue_sub_account
             -- TODO - revenue deduction tax recalc ???
      where  d.RDB$DB_KEY = :ad_dbkey;
    end
  
  
    for
      select se.ID_END_WORK
      from   SUMMARY_END_WORK SE
      where  se.ID_HOTEL = :ID_HOTEL
             and se.SUMMARY_DATE between :FROM_DATE and :TO_DATE
      order by se.ID_END_WORK
      into   :id_end_work
    do begin
  
      update SUMMARY_END_WORK s
      set    s.REVENUE_AMOUNT = 0,
             s.CORRECTION_AMOUNT = 0,
             s.VAT_AMOUNT = 0
      where  s.ID_END_WORK = :id_end_work;
  
      execute procedure REVENUE_EW_SUMMARIZE$INT (:id_end_work, 'full');
    end

    execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'REV_REGEN_FULL',
                                      f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') || f_character(28) ||
                                      formatdate(:to_date, 'D;dd/mm/yyyy'));
  end
end
^

/* Restore proc. body: RIGHTS_GROUP_MODIFY */
ALTER PROCEDURE RIGHTS_GROUP_MODIFY(ID_RIGHT_GROUP INTEGER,
GROUP_NAME VARCHAR(20),
GROUP_DESCRIPTION VARCHAR(100),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_RIGHT_GROUP INTEGER)
 AS
declare variable old_name varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation = 'add') then begin
    if ((:id_right_group is null) or (:id_right_group <= -1))  then
      new_id_right_group = gen_id(ID_RIGHT_GROUP_GEN, 1);
    else new_id_right_group = :id_right_group;

    insert into RIGHTS_GROUPS (ID_RIGHT_GROUP, GROUP_NAME, GROUP_DESCRIPTION)
    values (:new_id_right_group, :group_name , :group_description);
  end else if (:operation = 'mod') then begin
    select G.GROUP_NAME
    from   RIGHTS_GROUPS G
    where  G.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
    into   :old_name;

    update RIGHTS_GROUPS UG
    set    UG.GROUP_NAME  = :group_name,
           UG.GROUP_DESCRIPTION = :group_description
    where  UG.ID_RIGHT_GROUP = :id_right_group;

    if (:old_name <> :GROUP_NAME) then begin
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'GROUP_EDIT',
              f_character(29) || :old_name || f_character(28) || :GROUP_NAME);
    end
  end else if (:operation = 'del') then begin
    delete from RIGHTS_GROUPS
    where ID_RIGHT_GROUP = :id_right_group;
    delete from RIGHTS_USER_GROUPS
    where ID_RIGHT_GROUP = :id_right_group;
  end
end
^

/* Restore proc. body: RIGHTS_GROUP_REPORTS_MODIFY */
ALTER PROCEDURE RIGHTS_GROUP_REPORTS_MODIFY(ID_RIGHT_GROUP INTEGER,
REPORT_NAME VARCHAR(200),
OPERATION VARCHAR(20))
 AS
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'grant, revoke');

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS rg
  where  rg.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'grant') then begin
    if (not exists (
      select *
      from   RIGHTS_GROUPS_REPORTS RGR
      where  RGR.ID_RIGHT_GROUP = :id_right_group
             and RGR.REPORT_NAME = :report_name)
    ) then begin
      insert into RIGHTS_GROUPS_REPORTS (ID_RIGHT_GROUP, REPORT_NAME)
      values (:id_right_group, :report_name);

      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'RIGHT_GRANT',
              f_character(29) || :REPORT_NAME || f_character(28) || :right_group);

    end
  end else if (:operation = 'revoke') then begin
    delete from RIGHTS_GROUPS_REPORTS RGR
    where  RGR.ID_RIGHT_GROUP = :id_right_group
           and  RGR.REPORT_NAME = :report_name;

    if (row_count = 1) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'RIGHT_REVOKE',
              f_character(29) || :REPORT_NAME || f_character(28) || :right_group);
  end
end
^

/* Restore proc. body: RIGHTS_GROUP_RIGHTS_MODIFY */
ALTER PROCEDURE RIGHTS_GROUP_RIGHTS_MODIFY(ID_RIGHT_GROUP INTEGER,
RIGHT_CODE VARCHAR(30),
VALUE_CODE INTEGER,
OPERATION VARCHAR(20))
 AS
declare variable right_descr varchar(255);
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'grant, revoke');

  right_descr = '@{right.name.' || :right_code || '}';

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS RG
  where  RG.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'grant') then begin
    --if (:value_code <> 0) then exception WRONG_VALUE 'rightType is rtPlain but value_code <> 0';

    if (not exists (select *
                    from   RIGHTS_GROUPS_LINES RGL
                    where  RGL.ID_RIGHT_GROUP = :id_right_group
                           and RGL.RIGHT_CODE = :right_code)) then
    begin
      insert into RIGHTS_GROUPS_LINES (ID_RIGHT_GROUP, RIGHT_CODE)
      values (:id_right_group, :right_code);

      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'RIGHT_GRANT',
              f_character(29) || :right_descr || f_character(28) || :right_group);
    end

  end else if (:operation = 'revoke') then begin
    delete from RIGHTS_GROUPS_LINES RGL
    where  RGL.ID_RIGHT_GROUP = :id_right_group
           and RGL.RIGHT_CODE = :right_code;

    if (row_count > 0) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'RIGHT_REVOKE',
              f_character(29) || :right_descr || f_character(28) || :right_group);
  end
end
^

/* Restore proc. body: RIGHTS_GROUP_USER_MODIFY */
ALTER PROCEDURE RIGHTS_GROUP_USER_MODIFY(USER_NAME VARCHAR(30),
ID_RIGHT_GROUP INTEGER,
OPERATION VARCHAR(50))
 AS
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add,del');

  if (:USER_NAME = 'SYSDBA') then exit;

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS RG
  where  RG.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'add') then begin
    update or insert into RIGHTS_USER_GROUPS (USER_NAME, ID_RIGHT_GROUP)
    values (:user_name, :id_right_group)
    matching (USER_NAME, ID_RIGHT_GROUP);

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_ADDED',
            f_character(29) || :USER_NAME  || f_character(28) || :right_group);

  end else begin
    delete from RIGHTS_USER_GROUPS
    where USER_NAME = :user_name
          and ID_RIGHT_GROUP = :id_right_group;

    if (row_count > 0) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_REMOVED',
              f_character(29) || :USER_NAME || f_character(28) || :right_group);

  end

  when sqlcode -803 do begin
    /* ERR_TEXT = '       ! ' ;*/
    exit;
  end
end
^

/* Restore proc. body: RIGHTS_MODIFY_AUDIT_USER */
ALTER PROCEDURE RIGHTS_MODIFY_AUDIT_USER(USER_PASSWORD VARCHAR(50),
OPERATION VARCHAR(10))
 RETURNS(USER_NAME VARCHAR(30))
 AS
declare variable is_active smallint;
  declare variable lang_code varchar(10);
  declare variable user_operation varchar(10);
  declare variable user_name_long varchar(50);
  declare variable group_name varchar(30);
  declare variable id_right_group integer;
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT('RIGHTS_AUDIT_MANAGE');

  USER_NAME = '_AUDITOR_';
  user_name_long = 'Clock audit system user';
  lang_code = 'bg';
  is_active = iif(:OPERATION = 'activate', 1, 0);

  if (:OPERATION = 'activate' and not exists (select * from RIGHTS_USERS u where u.USER_NAME = :USER_NAME)) then
    user_operation = 'add';
  else
    user_operation = 'mod';

  execute procedure RIGHTS_MODIFY_USER(:user_name, :user_name_long, :USER_PASSWORD,
          :lang_code, 1, :is_active, :user_operation, '', '');

  GROUP_NAME = '_AUDITORS_';
  select g.ID_RIGHT_GROUP
  from   RIGHTS_GROUPS g
  where  g.GROUP_NAME = :group_name
  into   :id_right_group;

  execute procedure RIGHTS_GROUP_USER_MODIFY(:USER_NAME, :id_right_group, 'add');

end
^

/* Restore proc. body: RIGHTS_REGRANT */
ALTER PROCEDURE RIGHTS_REGRANT AS
declare variable relation_name char(31);
  declare variable ui_role_name char(31);
  declare variable ena_role_name char(31);
  declare variable auditor_role_name char(31);
begin
  ui_role_name = 'CLOCKBS_ROLE';
  ena_role_name = 'HTTPDBA_ROLE';
  auditor_role_name = 'AUDITOR_ROLE';

  /* PRIVILEGES GIVEN DIRECTLY TO SOME DB USER MUST BE PRESERVED.
  || AUTOGRANTS ARE MADE ONLY TO THE 'UI' and 'ENA' ROLES AND 'PUBLIC' USER.
  */
  delete from RDB$USER_PRIVILEGES UP
  where  (UP.RDB$USER_TYPE not in (8 /* user*/, 13 /* role */));

  delete from RDB$USER_PRIVILEGES UP
  where  (UP.RDB$USER = :ui_role_name)
         or (UP.RDB$USER = :ena_role_name)
         or (UP.RDB$USER = 'PUBLIC');

  /* THE 'UI' ROLE MUST HAVE ALL PRIVILIGES LIKE THE USER 'SYSDBA'.
  || ONLY NATIVE CLOCKBS APPLICATIONS ARE USING THIS ROLE.
  */
  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION,
         RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select :ui_role_name, 'SYSDBA', U.RDB$PRIVILEGE, 0,
         U.RDB$RELATION_NAME, U.RDB$FIELD_NAME, 13, U.RDB$OBJECT_TYPE
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = 'SYSDBA'
         and (not exists (select u2.RDB$PRIVILEGE
                          from   RDB$USER_PRIVILEGES u2
                          where  u2.RDB$USER = :ui_role_name
                                 and u2.RDB$PRIVILEGE = U.RDB$PRIVILEGE 
                                 and u2.RDB$RELATION_NAME = u.RDB$RELATION_NAME))
         and U.RDB$PRIVILEGE <> 'M' /* MEMBERSHIP */;

  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION,
         RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select :ena_role_name, 'SYSDBA', U.RDB$PRIVILEGE, 0,
         U.RDB$RELATION_NAME, U.RDB$FIELD_NAME, 13, U.RDB$OBJECT_TYPE
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = 'SYSDBA'
         and u.RDB$RELATION_NAME starting with 'ENA_'
         and (not exists (select u2.RDB$PRIVILEGE
                          from   RDB$USER_PRIVILEGES u2
                          where  u2.RDB$USER = :ena_role_name
                                 and u2.RDB$PRIVILEGE = U.RDB$PRIVILEGE 
                                 and u2.RDB$RELATION_NAME = u.RDB$RELATION_NAME))
         and U.RDB$PRIVILEGE in ('S') /* Select (and Reference ??) */;

  /* grant READ access to AUDITOR_ROLE  */
  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION, RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select :auditor_role_name , 'SYSDBA' , U.RDB$PRIVILEGE, 0 , U.RDB$RELATION_NAME, U.RDB$FIELD_NAME, 13, U.RDB$OBJECT_TYPE
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = :ui_role_name
         and not exists
           (select *
            from RDB$USER_PRIVILEGES U2
            where U2.RDB$USER = 'AUDITOR_ROLE'
                  and U2.RDB$PRIVILEGE = U.RDB$PRIVILEGE 
                  and U2.RDB$RELATION_NAME = U.RDB$RELATION_NAME);           

  delete
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = :auditor_role_name
         and u.RDB$PRIVILEGE in ('I', 'U', 'D')
         and u.RDB$RELATION_NAME like '%$PMS%';

  delete
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = :auditor_role_name
         and u.RDB$PRIVILEGE in ('I', 'U', 'D')
         and ( (u.RDB$RELATION_NAME starting with 'SUMMARY_')
              or (u.RDB$RELATION_NAME starting with 'RIGHTS_')
              or (u.RDB$RELATION_NAME starting with 'PROFILE_')
              or (u.RDB$RELATION_NAME starting with 'AGENT_')
              or (u.RDB$RELATION_NAME starting with 'RESOURCE_')
              or (u.RDB$RELATION_NAME starting with 'ACTIVITY_')
              or (u.RDB$RELATION_NAME starting with 'NOM_')
              or (u.RDB$RELATION_NAME starting with 'AR_')
              or (u.RDB$RELATION_NAME starting with 'HK_')
              or (u.RDB$RELATION_NAME starting with 'ALLOTMENT_')
              or (u.RDB$RELATION_NAME starting with 'SERVICE_')
              or (u.RDB$RELATION_NAME starting with 'TARIFA_')
              or (u.RDB$RELATION_NAME starting with 'TAR_BO_')
              or (u.RDB$RELATION_NAME starting with 'REPORT_')
              or (u.RDB$RELATION_NAME starting with 'CHANNEL')
              or (u.RDB$RELATION_NAME starting with 'TAR_UI_')
              or (u.RDB$RELATION_NAME starting with 'TAR_SIMPLE_')
              or (u.RDB$RELATION_NAME starting with 'DEVICE')
              or (u.RDB$RELATION_NAME starting with 'DOC_')
              or (u.RDB$RELATION_NAME starting with 'GUEST_')
              or (u.RDB$RELATION_NAME starting with 'SALE_')
              or (u.RDB$RELATION_NAME starting with 'WORKING_')
             ) ;
  delete
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = :auditor_role_name
         and u.RDB$PRIVILEGE in ('I', 'U', 'D')
         and u.RDB$RELATION_NAME in ('SERVICES', 'DOC_TYPE', 'DOC_TYPE_INV', 'DOC_TYPE_PAY', 'DOC_HEAD$INT',
             'PAYMENT_TYPE', 'CREDIT_CARD_TYPE', 'CURRS', 'CURR_RATES', 'PROFILE', 'AGENT',
             'ACCOUNT', 'ACCOUNT_POST_EXTERNAL',
             'ACC_TEMPLATE', 'CONTRAGENTS', 'HOTEL', 'SETTING_HOTEL_VALUE', 'GUARANTEE_POLICY',
             'RESOURCE$INT', 'RESOURCE_TYPE$INT', 'SAFE', 'SAFE_TYPE', 
             'ROOMS', 'ROOM_TYPES', 'ROOM_CLEAN_LOG',
             'TAX_POLICY',
             'TAR_HEAD', 'TRAIFA_GROUP', 'TAR_SIMPLE',
             'COUNTRY', 'KPPS', 'STAY_REASON', 'PASSPORT_TYPE', 'PHONE_LINE_CONVERT', 'LISTS_ITEMS',
             'RES_TEMPLATE', 'INFOMATIC_ACCOUNT', 'INFOMATIC_CHANNEL', 'ALLOTMENT',
             'PHONECALLS', 'BLOCK_ROOM', 'TASK', 'TASK_FILE', 'TASK_RESERVATION', 'TASK_RESPONSIBLE',
             'REPORT', 'PACKET_ITEM', 'BONUSPOINT_SCHEME', 'BONUSPOINT_SERVICE_GROUP',
             'EATING_OBJECT', 'END_WORKS', 'TASK');

  delete
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = :auditor_role_name
         and u.RDB$PRIVILEGE in ('X')
         and ((u.RDB$RELATION_NAME like '%$CFG%')
              or (u.RDB$RELATION_NAME like '%_MODIFY%')
              or (u.RDB$RELATION_NAME like '%$POST%')
              or (u.RDB$RELATION_NAME in ('RES_SET_STATUS$RSV', 'RES_SAVE_VOUCHER$RSV', 'RES_SAVE_OTHER$RSV',
                  'RES_SAVE_FINALIZE$RSV', 'RES_GUEST_ADD$RSV', 'RES_GUEST_DEL $RSV',
                  'RES_SAVE_NOTE$RSV', 'RESERV_DETAIL_EXTERNAL_MOD$RSV', 'RES_ANUL_DETAIL$RSV',
                  'RES_DELETE$RSV', 'POST_TELECOUNT_TRANSFER$TC', 'PROFILE_MERGE$PROFILE'))) ;
  /* GRANT REFERENCE RIGHT TO 'PUBLIC' FOR ALL TABLES THAT ARE REFERENCED WITH
  || FOREIGN KEYS.
  */
  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION,
         RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select distinct
         'PUBLIC', 'SYSDBA', 'R', 0, RC2.RDB$RELATION_NAME, null, 8, 0
  from   RDB$RELATION_CONSTRAINTS RC
         join RDB$REF_CONSTRAINTS C on C.RDB$CONSTRAINT_NAME = RC.RDB$CONSTRAINT_NAME
         join RDB$RELATION_CONSTRAINTS RC2 on RC2.RDB$CONSTRAINT_NAME = C.RDB$CONST_NAME_UQ
  where  RC.RDB$CONSTRAINT_TYPE = 'FOREIGN KEY';

  /* ALL EXTERNAL INTERFACES FROM OTHER VENDORS ARE NOT USING ROLES, SO
  || THEY WILL TAKE THE PRIVILEDGES OF THE 'PUBLIC' USER. THEY MUST HAVE
  || ACCESS ONLY TO THEIR SPECIFIC PROCEDURES OR OTHER METADATA OBJECTS WICH
  || MUST BE ENUMERATED HERE.
  */
  for
    select R.RDB$RELATION_NAME
    from   RDB$RELATIONS R
    where  (R.RDB$RELATION_NAME starting with 'EAI_')
           or (R.RDB$RELATION_NAME in ('SYSTEM_INFO_MODULE','PHONECALLS','SYSTEM_SESSION'))
           or (R.RDB$RELATION_NAME containing '$TMP')
           or (R.RDB$RELATION_NAME containing '_CACHE')
    union

    select R.RDB$PROCEDURE_NAME
    from   RDB$PROCEDURES R
    where  (R.RDB$PROCEDURE_NAME starting with 'EAI_')
           or (R.RDB$PROCEDURE_NAME in ('SYSTEM_INFO_GET', 'RDB$F_SP'))
    into   :relation_name
  do begin
    execute procedure RIGHTS_REGRANT_SUB('PUBLIC', :relation_name, 8);
  end
end
^

/* Restore proc. body: ROOM_CONTRACT_MODIFY$PMS */
ALTER PROCEDURE ROOM_CONTRACT_MODIFY$PMS(ID_ROOM_CONTRACT INTEGER,
ID_ROOM_PERIOD INTEGER,
CONTRACT_TYPE VARCHAR(50),
PMS_MARKERS BLOB SUB_TYPE 1 SEGMENT SIZE 100,
IMPORT_INCOME_WITH_VAT SMALLINT,
ID_RENTAL_POOL INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_CONTRACT INTEGER)
 AS
declare variable permissible_value_list varchar(255);
  declare variable from_date date;
  declare variable rental_pool_unit_name varchar(100);
  declare variable room_name varchar(10);
  declare variable old_contract_type varchar(50);
  declare variable old_import_income_with_vat smallint;
  declare variable old_from_date date;
  declare variable old_rental_pool_unit_name varchar(100);
  declare variable old_room_name varchar(10);
  declare variable old_id_room_period integer;
  declare variable id_room integer;
  declare variable action_text varchar(255);
  declare variable no_use varchar(255);
begin

  permissible_value_list = '';
  select list(trim(S.KEY_))
  from   SYSTEM_ENUM S
  where  S.GROUP_ = 'pms.contract_type'
  into   :permissible_value_list;

  if (:operation in ('add', 'mod')) then begin
    execute procedure SYSTEM_CHECK_OPERATION(:contract_type, :permissible_value_list, 'contract type');

    select PRO.PROFILE_NAME
    from   PROFILE PRO
    where  PRO.ID_PROFILE = :ID_RENTAL_POOL
    into   :rental_pool_unit_name;

    select ROO.ROOM_NAME, RPP.FROM_DATE
    from   ROOM_PERIOD$PMS RPP
           join ROOMS ROO on ROO.ID_ROOM = RPP.ID_ROOM
    where  RPP.ID_ROOM_PERIOD = :ID_ROOM_PERIOD
    into   :room_name, :from_date;
  end

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  NEW_ID_ROOM_CONTRACT = :id_room_contract;

  if (:operation = 'add') then begin
    if (coalesce(:ID_ROOM_CONTRACT, -1) < 0) then begin
      NEW_ID_ROOM_CONTRACT = gen_id(GEN_ROOM_CONTRACT$PMS_ID, 1);
      ID_ROOM_CONTRACT = :NEW_ID_ROOM_CONTRACT;
    end
    else
      NEW_ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT;

    insert into ROOM_CONTRACT$PMS (ID_ROOM_CONTRACT, ID_ROOM_PERIOD,
           CONTRACT_TYPE, PMS_MARKERS, IMPORT_INCOME_WITH_VAT, ID_RENTAL_POOL)
    values (:NEW_ID_ROOM_CONTRACT, :ID_ROOM_PERIOD,
           :CONTRACT_TYPE, :PMS_MARKERS, :IMPORT_INCOME_WITH_VAT, :ID_RENTAL_POOL);

    action_text = substring(f_character(29) || '@{pms.contract_type.' || :contract_type || '}' || f_character(28) ||
                  formatdate(:from_date, 'D;dd.mm.yyyy') ||
                  f_character(28) || :room_name || f_character(28) || coalesce(:rental_pool_unit_name, ' ') || f_character(28)
                  || coalesce(:import_income_with_vat, 0) from 1 for 255);
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_ADDED', :ACTION_TEXT);

  end else begin
    select RC.CONTRACT_TYPE, RC.IMPORT_INCOME_WITH_VAT,
           RO.ROOM_NAME, PR.PROFILE_NAME, RP.FROM_DATE, RC.ID_ROOM_PERIOD, RP.ID_ROOM
    from   ROOM_CONTRACT$PMS RC
           join ROOM_PERIOD$PMS RP on RP.ID_ROOM_PERIOD = RC.ID_ROOM_PERIOD
           join ROOMS RO on RO.ID_ROOM = RP.ID_ROOM
           left outer join PROFILE PR on PR.ID_PROFILE = RC.ID_RENTAL_POOL
    where  RC.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
    into   :old_contract_type, :old_import_income_with_vat,
           :old_room_name, :old_rental_pool_unit_name, :old_from_date, :old_id_room_period, :id_room;

    if (:operation = 'mod') then begin
      update ROOM_CONTRACT$PMS
      set    CONTRACT_TYPE = :CONTRACT_TYPE,
             PMS_MARKERS = :PMS_MARKERS,
             IMPORT_INCOME_WITH_VAT = :IMPORT_INCOME_WITH_VAT,
             ID_RENTAL_POOL = :ID_RENTAL_POOL
      where (ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT);

      if ((:contract_type <> :old_contract_type) or (:import_income_with_vat <> :old_import_income_with_vat) or
         (coalesce(:rental_pool_unit_name, ' ') <> coalesce(:old_rental_pool_unit_name, ' ')) or
         (:from_date <> :old_from_date) or (:room_name <> :old_room_name)) then begin
        action_text = substring(f_character(29) || '@{pms.contract_type.' || :old_contract_type || '}' || f_character(28) ||
                      formatdate(:old_from_date, 'D;dd.mm.yyyy') ||
                      f_character(28) || :old_room_name ||
                      f_character(28) || coalesce(:old_rental_pool_unit_name, ' ') || f_character(28) || coalesce(:old_import_income_with_vat, 0) ||
                      f_character(28) || '@{pms.contract_type.' || :contract_type || '}' || f_character(28) || formatdate(:from_date, 'D;dd.mm.yyyy') ||
                      f_character(28) || :room_name || f_character(28) || coalesce(:rental_pool_unit_name, ' ') || f_character(28)
                      || coalesce(:import_income_with_vat, 0) from 1 for 255);
        execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_CHANGED', :ACTION_TEXT);
      end

    end

    if (:operation = 'del') then begin
      action_text = substring(f_character(29) || '@{pms.contract_type.' || :old_contract_type || '}' || f_character(28) ||
                    formatdate(:old_from_date, 'D;dd.mm.yyyy') ||
                    f_character(28) || :old_room_name || f_character(28) || coalesce(:old_rental_pool_unit_name, ' ') || f_character(28)
                    || coalesce(:old_import_income_with_vat, 0) from 1 for 255);
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_REMOVED', :ACTION_TEXT);

      delete from ROOM_CONTRACT$PMS where (ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT);

      execute procedure ROOM_PERIOD_MODIFY$PMS (:OLD_ID_ROOM_PERIOD, :id_room,  :old_from_date,
              iif(:contract_type in ('PRIVATE_USE'), 'PRIVATE', 'CONTRACT'),  'del')
      returning_values :no_use;
    end
  end
end
^

/* Restore proc. body: ROOM_MODIFY$PMS */
ALTER PROCEDURE ROOM_MODIFY$PMS(ID_ROOM INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
BEDS INTEGER,
EXTRA_BEDS INTEGER,
SECTOR INTEGER,
SORT_ORDER INTEGER,
FEATURES BLOB SUB_TYPE 1 SEGMENT SIZE 100,
EXTERNAL_NAME VARCHAR(20),
ID_EATING_OBJECT TYPE OF ID_REF,
OPERATION VARCHAR(20),
ACCOMODATION_PLACE_UIN TYPE OF TDESCRIPTION_LONG = null)
 RETURNS(OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255),
NEW_ID_ROOM INTEGER)
 AS
declare variable old_id_room_type integer;
  declare variable old_room_name varchar(10);
  declare variable rebuild_id_hotel integer;
  declare variable rebuild_id_room_type integer;
  declare variable no_use varchar(20);
  declare variable old_capacity integer;
  declare variable sys_date date;
  declare variable action_text varchar(255);
  declare variable old_floor integer;
  declare variable old_sector integer;
  declare variable old_extra_beds integer;
  declare variable id_hotel integer;
begin
  overrule_need = 0;
  overrule_context = '';
  new_id_room = null;
  --if OVERRULE_NEED = 1 then OVERRULE_CONTEXT = ERR_TEXT like ERR_CODE = -9
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    if (coalesce(:room_name, '') = '') then
      exception ASSERT '-119';

    if ((:room_name containing '<') or (:room_name containing '>') or (:room_name starting with 'i')) then
      exception ASSERT '-120';
  end

  room_name = upper(:room_name);

  if (:operation='mod') then begin
    select R.ROOM_NAME, R.ID_ROOM_TYPE, R.BEDS+R.EXTRA_BEDS, r.floor, r.sector, r.extra_beds
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :id_room
    into   :old_room_name, :old_id_room_type, :old_capacity, :old_floor, :old_sector, :old_extra_beds;

    if (:id_room_type <> :old_id_room_type) then begin
      exception OCCUPANCY_EXCEPTION '-65';
    end

    new_id_room = :id_room;
    execute procedure ROOM_CAPACITY_CHECK$INT(:NEW_ID_ROOM, :ROOM_NAME, :old_capacity, :BEDS + :EXTRA_BEDS)
    returning_values (:OVERRULE_NEED, :OVERRULE_CONTEXT);

    update ROOMS RU
    set    RU.ID_ROOM_TYPE = :id_room_type,
           RU.ROOM_NAME = :room_name,
           RU.FLOOR = :floor,
           RU.BEDS = :beds,
           RU.EXTRA_BEDS = :extra_beds,
           RU.SECTOR = :sector,
           RU.FEATURES = :features,
           RU.SORT_ORDER = :sort_order,
           RU.EXTERNAL_NAME = :external_name,
           RU.ID_EATING_OBJECT = :ID_EATING_OBJECT,
           ru.ACCOMODATION_PLACE_UIN = :ACCOMODATION_PLACE_UIN
    where  RU.ID_ROOM = :id_room;

    if ((:room_name <> :old_room_name)
        or (:floor <> :old_floor)
        or (:sector <> :old_sector)
        or (:extra_beds <> :old_extra_beds)) then
    begin
      action_text = f_character(29) || '(' || :old_room_name || '/' || :old_floor || '/' || :old_sector || '/'
                    || :old_extra_beds || ')' || f_character(28) || '(' || :room_name || '/' || :floor || '/'
                    || :sector || '/' || :extra_beds || ')';
      execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_PARAMS_CHANGED', :action_text);
    end

    if (:room_name <> :old_room_name) then begin
      update ACCOUNT_POST AP
      set    AP.ROOM_NAME = :room_name
      where  AP.ROOM_NAME = :old_room_name
             and ap.ID_ROOM = :ID_ROOM
             and ap.ac = '00';
    end

  end else if (:operation = 'add') then begin
    select rt.ID_HOTEL
    from   ROOM_TYPES RT
    where  rt.ID_ROOM_TYPE = :ID_ROOM_TYPE
    into   :id_hotel;

    insert into ROOMS (
      ID_ROOM, ID_ROOM_TYPE, ROOM_NAME, FLOOR, BEDS, EXTRA_BEDS, SECTOR,
      FEATURES, SORT_ORDER, ID_HOTEL, EXTERNAL_NAME, ID_EATING_OBJECT, ACCOMODATION_PLACE_UIN)
    values (gen_id(ID_ROOM_GEN, 1), :id_room_type, :room_name, :floor, :beds, :extra_beds, :sector,
      :features, :sort_order, :id_hotel, :external_name, :ID_EATING_OBJECT, :ACCOMODATION_PLACE_UIN)
    returning ID_ROOM into :NEW_ID_ROOM;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :sys_date;

    execute procedure ROOM_PERIOD_MODIFY$PMS(null, :new_id_room, :sys_date, 'HOTEL', 'add')
    returning_values  :no_use;

    insert into ROOMS_ADD (ID_ROOM, PMS_MARKERS, ADDRESS)
    values (:new_id_room, null, null);
  end else if (:operation = 'del') then begin
    -- Booked rooms are preserved with FK constraint on room_magic
    execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'DELETE', '');

    select RT.ID_ROOM_TYPE, RT.ID_HOTEL
    from   ROOM_TYPES RT
    where  RT.ID_ROOM_TYPE = :id_room_type
    into   :rebuild_id_room_type, :rebuild_id_hotel;

    delete from ROOMS where ID_ROOM = :id_room;

    execute procedure ALLOTMENT_PHYS_REBUILD$INT(:rebuild_id_hotel, :rebuild_id_room_type);

    when sqlcode -530 do begin
      -- Violation of FOREIGN KEY constraint "%s" on table "%s"
      exception ASSERT '-34';
    end
  end
end
^

/* Restore proc. body: ROOM_OWNER_MODIFY$PMS */
ALTER PROCEDURE ROOM_OWNER_MODIFY$PMS(ID_ROOM_OWNER INTEGER,
ID_ROOM_CONTRACT INTEGER,
ID_OWNER INTEGER,
OWNERSHIP_PERCENT NUMERIC(15,4),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_OWNER INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_hotel integer;
  declare variable id_acc_template_pms integer;
  declare variable id_currency varchar(3);
  declare variable owner_name varchar(100);
  declare variable old_owner_name varchar(100);
  declare variable old_ownership_percent NUMERIC(15,4);
  declare variable old_id_room_contract integer;
  declare variable action_text varchar(255);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  new_id_room_owner = :id_room_owner;

  if ( (:operation in ('add', 'mod')) and (not exists ( select * from OWNER$PMS P where P.ID_OWNER = :ID_OWNER ) )) then begin
    exception PMS_EXCEPTION '-610';
    exit;
  end

  select RT.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS RP on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
         join ROOMS R on RP.ID_ROOM = R.ID_ROOM
         join ROOM_TYPES RT on R.ID_ROOM_TYPE = RT.ID_ROOM_TYPE
  where  RC.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
  into   :id_hotel;

  if (:operation not in ('add')) then begin
    select coalesce(PR.PROFILE_NAME, ' '), RO.OWNERSHIP_PERCENT, RO.ID_ROOM_CONTRACT
    from ROOM_OWNER$PMS RO
      left outer join PROFILE PR ON PR.ID_PROFILE = RO.ID_OWNER
    where RO.ID_ROOM_OWNER = :ID_ROOM_OWNER
    into :old_owner_name, :old_ownership_percent, :old_id_room_contract;
  end

  select PRO.PROFILE_NAME
  from PROFILE PRO
    where PRO.ID_PROFILE = :ID_OWNER
  into :owner_name;

  if (:operation in ('add', 'mod')) then begin
    if (coalesce(:OWNERSHIP_PERCENT, 0) <= 0) then begin
      exception PMS_EXCEPTION '-611';
      exit;
    end
  end

  if (:operation = 'add') then begin
    if (coalesce(:ID_ROOM_OWNER, -1) < 0) then
         NEW_ID_ROOM_OWNER = gen_id(GEN_ROOM_OWNER$PMS_ID, 1);
    else NEW_ID_ROOM_OWNER = :ID_ROOM_OWNER;

    insert into ROOM_OWNER$PMS (ID_ROOM_OWNER, ID_ROOM_CONTRACT, ID_OWNER, OWNERSHIP_PERCENT)
    values (:NEW_ID_ROOM_OWNER, :ID_ROOM_CONTRACT, :ID_OWNER, :OWNERSHIP_PERCENT);

    action_text = f_character(29) || :owner_name || f_character(28) || formatfloat(:ownership_percent, '0.00');
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_OWNER_ADDED', :ACTION_TEXT);

    if (not exists ( select *
                     from   ACCOUNT A
                     where  A.IS_PMS_ACCOUNT = 1
                            and A.ID_HOTEL = :id_hotel
                            and A.ID_PROFILE = :ID_OWNER ))
    then begin
      select O.ID_ACC_TEMPLATE_PMS, O.ID_CURRENCY
      from   OWNER$PMS O
      where  O.ID_OWNER = :ID_OWNER
      into   :id_acc_template_pms, :id_currency;

      execute procedure ACCOUNT_CREATE_PMS$PMS(:ID_OWNER, :ID_ACC_TEMPLATE_PMS,
              :ID_CURRENCY, :ID_HOTEL)
      returning_values (:dbg);
    end

    when sqlcode -803 do begin
      exception PMS_EXCEPTION '-1057';
      exit;
    end

  end else if (:operation = 'mod') then begin
    if (not exists ( select *
                     from   ROOM_OWNER$PMS R
                     where  R.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
                            and R.ID_OWNER = :ID_OWNER ))
    then begin /* smenen e sobstwenik */
      if (not exists ( select *
                       from   ACCOUNT A
                       where  A.IS_PMS_ACCOUNT = 1
                              and A.ID_HOTEL = :id_hotel
                              and A.ID_PROFILE = :ID_OWNER ))
      then begin
        select O.ID_ACC_TEMPLATE_PMS, O.ID_CURRENCY
        from   OWNER$PMS O
        where  O.ID_OWNER = :ID_OWNER
        into   :id_acc_template_pms, :id_currency;
  
        execute procedure ACCOUNT_CREATE_PMS$PMS(:ID_OWNER, :ID_ACC_TEMPLATE_PMS,
                :ID_CURRENCY, :ID_HOTEL)
        returning_values (:dbg);
      end
    end

    update ROOM_OWNER$PMS
    set ID_OWNER = :ID_OWNER,
        OWNERSHIP_PERCENT = :OWNERSHIP_PERCENT
    where (ID_ROOM_OWNER = :ID_ROOM_OWNER);

    if ((:old_owner_name <> :owner_name) or (:old_ownership_percent <> :ownership_percent)) then begin
      action_text = f_character(29) || :old_owner_name || f_character(28) || formatfloat(:old_ownership_percent, '0.00') ||
                    f_character(28) || :owner_name || f_character(28) || formatfloat(:ownership_percent, '0.00');
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_OWNER_CHANGED', :ACTION_TEXT);
    end
  end else if (:operation = 'del') then begin
    action_text = f_character(29) || :old_owner_name || f_character(28) || formatfloat(:old_ownership_percent, '0.00');
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :OLD_ID_ROOM_CONTRACT, 'ROOM_OWNER_REMOVED', :ACTION_TEXT);

    delete from ROOM_OWNER$PMS
    where (ID_ROOM_OWNER = :ID_ROOM_OWNER);
  end
end
^

/* Restore proc. body: ROOM_PERIOD_ADD$INT */
ALTER PROCEDURE ROOM_PERIOD_ADD$INT(ID_ROOM_PERIOD INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
STATUS VARCHAR(30))
 RETURNS(NEW_ID_ROOM_PERIOD INTEGER)
 AS
declare variable action_text varchar(255);
  declare variable to_date date;
  declare variable prev_period_status varchar(30);
begin
  new_id_room_period = :id_room_period;

  if (exists (select *
              from   ROOM_PERIOD$PMS R
              where  R.ID_ROOM = :ID_ROOM
                     and R.FROM_DATE = :FROM_DATE)) then exception PMS_EXCEPTION '-612';

  if (coalesce(:id_room_period, 0) <= 0) then new_id_room_period = gen_id(GEN_ROOM_PERIOD$PMS_ID,1);
  else new_id_room_period = :id_room_period;

  select first 1 rpm.status, rpm.TO_DATE
  from   ROOM_PERIOD$PMS rpm
  where  rpm.id_room = :id_room
         and rpm.from_date < :from_date
  order by rpm.from_date desc
  into   :prev_period_status, :to_date;

  execute procedure ROOM_STATUS_CHECK$INT (:ID_ROOM, :FROM_DATE, :to_date, :prev_period_status, :status);

  insert into ROOM_PERIOD$PMS (ID_ROOM_PERIOD, ID_ROOM, FROM_DATE, STATUS)
  values (:new_id_room_period, :id_room, :from_date, :status);

  execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

  action_text = f_character(29) || '@{period_room_status.'||:status||'}' || f_character(28) || formatdate(:from_date, 'dd.mm.yyyy')
                || f_character(28) || iif(extract(year from :to_date) = 2500, '~', formatdate(:to_date, 'dd.mm.yyyy'));
  execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_STATUS_ADDED', :action_text);

end
^

/* Restore proc. body: ROOM_PERIOD_DEL$INT */
ALTER PROCEDURE ROOM_PERIOD_DEL$INT(ID_ROOM_PERIOD INTEGER)
 AS
declare variable id_room integer;
  declare variable status varchar(30);
  declare variable from_date date;
  declare variable id_account_post integer;
  declare variable id_pms_event integer;
  declare variable action_text varchar(255);
  declare variable to_date date;
  declare variable prev_period_status varchar(30);
begin
  select R.STATUS, R.FROM_DATE, R.ID_ROOM, R.TO_DATE
  from   ROOM_PERIOD$PMS R
  where  R.ID_ROOM_PERIOD = :id_room_period
  into   :status, :from_date, :id_room, :to_date;

  if (singular (select *
                from   ROOM_PERIOD$PMS R
                where  R.ID_ROOM = :id_room)) then exception PMS_EXCEPTION '-622';

  select first 1 rpm.status
  from   ROOM_PERIOD$PMS rpm
  where  rpm.id_room = :id_room
         and rpm.from_date < :from_date
  order by rpm.from_date desc
  into   :prev_period_status;

  execute procedure ROOM_STATUS_CHECK$INT (:ID_ROOM, :from_date, :to_date, :status, :prev_period_status);

  for
    select AP1.ID_ACCOUNT_POST, AP1.ID_PMS_EVENT
    from   ACCOUNT_POST$PMS AP1
           join ACCOUNT$PMS A1 on A1.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS
           join PMS_EVENT$PMS E1 on E1.ID_PMS_EVENT = AP1.ID_PMS_EVENT
    where  AP1.DATE_POST between :from_date and :to_date
           and E1.ID_ROOM = :id_room
           and A1.IS_SHADOW = 1
           and AP1.LINE_STATUS = 11 /*  anulirat se samo aktiwnite nachisleniq. Ako ima dokumentirani?! ili anulirani, ne se pipat  */
    into   :id_account_post, :id_pms_event
  do begin
    execute procedure ACCOUNT_POST_PMS_ANUL$INT(:id_pms_event, :id_account_post);
  end

  delete from ROOM_PERIOD$PMS
  where  ID_ROOM_PERIOD = :id_room_period;

  execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

  action_text = f_character(29) || '@{period_room_status.'||:status||'}'
              || f_character(28) || iif(extract(year from :from_date) = 2500, '~', formatdate(:from_date, 'dd.mm.yyyy'))
              || f_character(28) || iif(extract(year from :to_date) = 2500, '~', formatdate(:to_date, 'dd.mm.yyyy'))
              || f_character(28) || '@{period_room_status.'||:prev_period_status||'}' ;
  execute procedure SYSTEM_LOG_ADD ('ROOM', :id_room, 'ROOM_STATUS_DELETED', :action_text);
end
^

/* Restore proc. body: ROOM_PERIOD_MODIFY$INT */
ALTER PROCEDURE ROOM_PERIOD_MODIFY$INT(ID_ROOM_PERIOD INTEGER,
FROM_DATE DATE,
STATUS VARCHAR(30))
 AS
declare variable id_room integer;
  declare variable old_status varchar(30);
  declare variable old_from_date date;
  declare variable id_account_post integer;
  declare variable id_pms_event integer;
  declare variable action_text varchar(255);
  declare variable to_date date;
  declare variable prev_period_status varchar(30);
  declare variable old_id_room_contract integer;
begin
  select R.STATUS, R.FROM_DATE, r.TO_DATE, r.ID_ROOM
  from   ROOM_PERIOD$PMS R
  where  R.ID_ROOM_PERIOD = :id_room_period
  into   :old_status, :old_from_date, :to_date, :id_room;

  select first 1 rpm.status
  from   ROOM_PERIOD$PMS rpm
  where  rpm.id_room = :id_room
         and rpm.from_date < :old_from_date
  order by rpm.from_date desc
  into   :prev_period_status;

  if (:STATUS <> :old_status) then begin
    execute procedure ROOM_STATUS_CHECK$INT (:ID_ROOM, :from_date, :to_date, :old_status, :STATUS);
  end

  if (:old_from_date < :FROM_DATE) then begin
    execute procedure ROOM_STATUS_CHECK$INT (:ID_ROOM, :old_from_date, :from_date, :old_status, :prev_period_status);
  end else if (:old_from_date > :FROM_DATE) then begin
    execute procedure ROOM_STATUS_CHECK$INT (:ID_ROOM, :from_date, :old_from_date, :prev_period_status, :STATUS);
  end

  if ((:old_from_date <> :FROM_DATE) or (:STATUS <> :old_status)) then begin
    for
      select AP1.ID_ACCOUNT_POST, AP1.ID_PMS_EVENT
      from   ACCOUNT_POST$PMS AP1
             join ACCOUNT$PMS A1 on A1.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS
             join PMS_EVENT$PMS E1 on E1.ID_PMS_EVENT = AP1.ID_PMS_EVENT
      where  AP1.DATE_POST between :old_from_date and :to_date
             and E1.ID_ROOM = :id_room
             and A1.IS_SHADOW = 1
             and AP1.LINE_STATUS = 11 /*  anulirat se samo aktiwnite nachisleniq. Ako ima dokumentirani?! ili anulirani, ne se pipat  */
      into   :id_account_post, :id_pms_event
    do begin
      execute procedure ACCOUNT_POST_PMS_ANUL$INT(:id_pms_event, :id_account_post);
    end
  end
  
  update ROOM_PERIOD$PMS p
  set    p.FROM_DATE = :from_date,
         p.STATUS = :status
  where  p.ID_ROOM_PERIOD = :id_room_period;

  execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

  action_text = f_character(29) || '@{period_room_status.'||:old_status||'}'
                || f_character(28) || iif(extract(year from :old_from_date) = 2500, '~', formatdate(:old_from_date, 'dd.mm.yyyy'))
                || f_character(28) || iif(extract(year from :to_date) = 2500, '~', formatdate(:to_date, 'dd.mm.yyyy'))
                || f_character(28) || '@{period_room_status.'||:status||'}'
                || f_character(28) || iif(extract(year from :from_date) = 2500, '~', formatdate(:from_date, 'dd.mm.yyyy'))
                || f_character(28) || iif(extract(year from :to_date) = 2500, '~', formatdate(:to_date, 'dd.mm.yyyy'));

  execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_STATUS_CHANGED', :action_text);

  if((:status in ('PRIVATE', 'CONTRACT')) and (:from_date <> :old_from_date)) then begin
    select first 1 rcp.id_room_contract
    from   ROOM_CONTRACT$PMS rcp
    where  rcp.id_room_period = :id_room_period
    into   :old_id_room_contract;

    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :OLD_ID_ROOM_CONTRACT, 'ROOM_STATUS_CHANGED', :action_text);
  end

end
^

/* Restore proc. body: ROOM_SMART_LIST$RSV */
ALTER PROCEDURE ROOM_SMART_LIST$RSV(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(50))
 RETURNS(ROOM_NAME VARCHAR(50),
FREE_BEDS_BASE INTEGER,
FREE_BEDS_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
FEATURES BLOB,
BUSY_GROUP_TYPE INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
DATA1 VARCHAR(255),
DATA2 VARCHAR(255))
 AS
declare variable report_leaving varchar(20);
declare variable suppress_private integer;
begin
  if (:from_date >= :to_date) then exit;
  execute procedure SYSTEM_CHECK_OPERATION(:report_type, 'FREE_ONLY,FREE_AND_LEAVING,BLOCKED,POTENTIAL_SHARE,PRIVATE_USE,ALL');

  suppress_private = iif(:REPORT_TYPE = 'ALL', 0, 1);
  if (:report_type in ('FREE_ONLY','FREE_AND_LEAVING')) then begin
    if (:report_type = 'FREE_AND_LEAVING') then report_leaving = 'AS_FREE';
    else report_leaving = 'AS_LEAVING';
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DBEFORE, SRLF.DAFTER, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_FREE$INT(:from_date, :to_date, :report_leaving, :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end else if (:report_type in ('BLOCKED','POTENTIAL_SHARE')) then begin
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DESCRIPTION, SRLF.PERIOD, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_SHARE$INT(:from_date, :to_date, :report_type, :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end else if (:report_type in ('ALL')) then begin
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DBEFORE, SRLF.DAFTER, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_FREE$INT(:from_date, :to_date, 'FREE_AND_LEAVING', :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;

    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DESCRIPTION, SRLF.PERIOD, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_SHARE$INT(:from_date, :to_date, 'POTENTIAL_SHARE', :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end
end
^

/* Restore proc. body: SAFE_CHECK_OUT */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE TYPE OF ID)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
WARN_CODE TYPE OF ID_REF)
 AS
declare variable to_dt timestamp;
  declare variable is_occupied integer;
  declare variable expire_tollerance integer;
  declare variable occupant_name varchar(100);
  declare variable id_resource_reservation integer;
  declare variable check_out_datetime timestamp;
begin
  DOC_SELECTED = null;
  select s.IS_OCCUPIED, od.TO_DATETIME,
         st.EXPIRE_TOLLERANCE, rr.OCCUPANT_NAME, rr.ID_RESOURCE_RESERVATION
  from   SAFE s
         join RESOURCE$INT r on r.ID_RESOURCE = s.ID_SAFE
         join SAFE_TYPES st on st.ID_SAFE_TYPE = r.ID_RESOURCE_TYPE
         join RESOURCE_RESERVATION rr on rr.ID_RESOURCE_RESERVATION = s.ID_CURRENT_OCCUPANCY
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join RESOURCE_OCCUPANCY ro on ro.ID_RESOURCE_OCCUPANCY_DATA = od.ID_RESOURCE_OCCUPANCY_DATA
  where  s.ID_SAFE = :ID_SAFE
  into   :is_occupied, :to_dt, :expire_tollerance, :occupant_name, :id_resource_reservation;

  if (:is_occupied = 0) then exit;

  expire_tollerance = coalesce(:expire_tollerance, 0);
  check_out_datetime = current_timestamp;

  execute procedure SAFE_OCCUPANCY_MODIFY (:id_safe, current_timestamp, :occupant_name)
  returning_values  :DOC_SELECTED;

  if (:check_out_datetime > (:to_dt + cast(:expire_tollerance as double precision) / 60 / 24)) then begin
    execute procedure SYSTEM_WARNING_ADD (-1066, f_character(29) || :expire_tollerance || f_character(28) || formatdate(:to_dt + cast(:expire_tollerance as double precision) / 60 / 24, 'D;dd/mm/yyyy HH:MM'))
    returning_values (:WARN_CODE);
  end

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = null
  where  s.ID_SAFE = :ID_SAFE;

  update RESOURCE_RESERVATION rr
  set    rr.STATUS = 'CHECKED_OUT'
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_CHECKED_OUT', :occupant_name);
end
^

/* Restore proc. body: SAFE_OCCUPANCY_ANNUL */
ALTER PROCEDURE SAFE_OCCUPANCY_ANNUL(ID_SAFE TYPE OF ID,
REASON TYPE OF TREASON)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_resource_reservation integer;
  declare variable from_datetime timestamp;
  declare variable to_datetime timestamp;
  declare variable action_text varchar(255);
  declare variable id_account_post integer;
begin
  select s.ID_CURRENT_OCCUPANCY, od.FROM_DATETIME, od.TO_DATETIME, rp.ID_ACCOUNNT_POST
  from   SAFE S
         join RESOURCE_RESERVATION rr on rr.ID_RESOURCE_RESERVATION = s.ID_CURRENT_OCCUPANCY
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESOURCE_RESERV_POST rp on rp.ID_RESOURCE_RESERVATION = rr.ID_RESOURCE_RESERVATION
  where  s.ID_SAFE = :ID_SAFE
  into   :id_resource_reservation, :from_datetime, :to_datetime, :id_account_post;

  execute procedure RESOURCE_RESERVATION_CANCEL (:id_resource_reservation, :REASON);

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = null
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:REASON, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_ANNUL', :action_text);

  execute procedure ACCOUNT_POSTING_ANUL (:id_account_post, :REASON);

  DOC_SELECTED = null;
  update ACCOUNT_POST AP
  set    ap.DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1)
  where  ap.ID_ACCOUNT_POST = :id_account_post
         and ap.ac = '00'
  returning new.doc_selected
  into   :DOC_SELECTED;

end
^

/* Restore proc. body: SAFE_OCCUPANCY_MODIFY */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail)
  returning_values (:DOC_SELECTED);

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Restore proc. body: SAFE_OCCUPANCY_NEW */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* Restore proc. body: SALE_TAX_MODIFY$CFG */
ALTER PROCEDURE SALE_TAX_MODIFY$CFG(ID_SALE_TAX INTEGER,
TAX_NAME VARCHAR(50),
TAX_PERCENT NUMERIC(15,4),
TAXABLE_BASE_PERCENT NUMERIC(15,4),
TAX_VALUE NUMERIC(15,4),
REVENUE_DEDUCTION_TAX SMALLINT,
REPORT_IN_DOCUMENT SMALLINT,
FISCAL_CODE VARCHAR(30),
ACCOUNT_NAME VARCHAR(50),
OPERATION VARCHAR(10),
ID_HOTEL TYPE OF ID,
TAXATION_REASON TYPE OF TDESCRIPTION_LONG)
 RETURNS(NEW_ID_SALE_TAX INTEGER)
 AS
declare variable id_sale_taxation integer;
declare variable old_tax_percent numeric(15,4);
declare variable old_taxable_base_percent numeric(15,4);
declare variable taxation_name varchar(50);
declare variable old_tax_name varchar(50);
declare variable old_fiscal_code varchar(30);
declare variable old_is_percent smallint;
declare variable new_is_percent smallint;
declare variable old_rev_deduction_tax integer;
declare variable old_tax_value tprice;
declare variable old_taxation_reason type of TDESCRIPTION_LONG;
begin
  execute procedure SYSTEM_CHECK_OPERATION (:OPERATION, 'add, mod, del');

  if (:TAX_VALUE is not null and :TAX_PERCENT is not null) then exception ASSERT '-701';

  fiscal_code = nullif(trim(:FISCAL_CODE), '');
  if (:OPERATION = 'add') then begin
    insert into SALE_TAXES (ID_SALE_TAX, TAX_NAME, TAX_PERCENT, TAXABLE_BASE_PERCENT,
           FISCAL_CODE, ACCOUNT_NAME, ID_HOTEL, TAX_VALUE, REVENUE_DEDUCTION_TAX, REPORT_IN_DOCUMENT, TAXATION_REASON)
    values (nullif(:ID_SALE_TAX, -1), :TAX_NAME, :TAX_PERCENT, coalesce(:TAXABLE_BASE_PERCENT, 100),
           :FISCAL_CODE, :ACCOUNT_NAME, :id_hotel, :TAX_VALUE, :REVENUE_DEDUCTION_TAX, :REPORT_IN_DOCUMENT, :TAXATION_REASON)
    returning ID_SALE_TAX
    into   :NEW_ID_SALE_TAX;

  end else if (:OPERATION = 'mod') then begin
    select st.TAX_PERCENT, st.TAXABLE_BASE_PERCENT, st.tax_name, st.fiscal_code, st.IS_PERCENT_TAX,
           st.REVENUE_DEDUCTION_TAX, st.TAX_VALUE, ST.TAXATION_REASON
    from   SALE_TAXES st
    where  st.ID_SALE_TAX = :ID_SALE_TAX
    into   :old_tax_percent, :old_taxable_base_percent, :old_tax_name, :old_fiscal_code, :old_is_percent,
           :old_rev_deduction_tax, :old_tax_value, :old_taxation_reason;

    if (coalesce(:old_rev_deduction_tax, 0) <> coalesce(:REVENUE_DEDUCTION_TAX, 0)) then
      exception SALE_TAX_EXCEPTION '-702';

    if ((:TAX_PERCENT is distinct from :old_tax_percent)
        or (:TAXABLE_BASE_PERCENT is distinct from :old_taxable_base_percent)
        or (:TAX_VALUE is distinct from :old_tax_value)) then begin
      for
        select distinct stt.ID_SALE_TAXATION, t.NAME
        from   SALE_TAXATION_TAX STT
               join SALE_TAXATION t on t.ID_SALE_TAXATION = stt.ID_SALE_TAXATION
        where  stt.ID_SALE_TAX = :ID_SALE_TAX
        into   :id_sale_taxation, :taxation_name
      do begin

        /* check if sale tax is used in postings */
        delete from SALE_TAXATION STT where stt.ID_SALE_TAXATION = :id_sale_taxation;
  
        insert into SALE_TAXATION (ID_SALE_TAXATION, NAME, ID_HOTEL)
        values (:id_sale_taxation, :taxation_name, :id_hotel);
  
        when sqlcode -530 do begin
          exception SALE_TAX_EXCEPTION '-338';
        end
      end 

      execute procedure SYSTEM_LOG_ADD('SALE_TAX', :ID_SALE_TAX, 'TAX_CHANGED',
              f_character(29) || :old_tax_percent  || '%'  || f_character(28) || :old_taxable_base_percent || '%'
              || f_character(28) || :TAX_PERCENT  || '%'  || f_character(28) || :TAXABLE_BASE_PERCENT || '%');
    end

    update SALE_TAXES T
    set    t.TAX_PERCENT = :TAX_PERCENT,
           t.TAXABLE_BASE_PERCENT = :TAXABLE_BASE_PERCENT,
           T.TAX_NAME = :TAX_NAME,
           t.FISCAL_CODE = :FISCAL_CODE,
           t.ACCOUNT_NAME = :ACCOUNT_NAME,
           t.TAX_VALUE = :TAX_VALUE,
           --t.REVENUE_DEDUCTION_TAX = :REVENUE_DEDUCTION_TAX,
           t.REPORT_IN_DOCUMENT = :REPORT_IN_DOCUMENT,
           T.TAXATION_REASON = :TAXATION_REASON
    where  T.ID_SALE_TAX = :ID_SALE_TAX
    returning new.IS_PERCENT_TAX
    into   :new_is_percent;
    NEW_ID_SALE_TAX = :ID_SALE_TAX;

    if (:new_is_percent <> :old_is_percent) then exception ASSERT '-703';

    if ((:old_tax_name <> :tax_name) or (:old_fiscal_code <> :fiscal_code)) then begin
      execute procedure SYSTEM_LOG_ADD('SALE_TAX', :ID_SALE_TAX, 'TAX_NAME_CHANGED',
              f_character(29) || :old_tax_name || f_character(28) || :old_fiscal_code ||
              f_character(28) || :tax_name || f_character(28) || :fiscal_code);
    end

    if (:old_taxation_reason is distinct from :taxation_reason) then begin
      execute procedure SYSTEM_LOG_ADD('SALE_TAX', :ID_SALE_TAX, 'TAX_REASON_CHANGED',
              f_character(29) || :old_taxation_reason || f_character(28) || :taxation_reason);
    end

  end else if (:OPERATION = 'del') then begin
    execute procedure SYSTEM_LOG_ADD ('SALE_TAX', :ID_SALE_TAX, 'DELETE', '');

    delete from SALE_TAXES ST
    where  ST.ID_SALE_TAX = :ID_SALE_TAX;

    NEW_ID_SALE_TAX = null;

    when sqlcode -530 do begin
      exception REF_INTEGRITY_DELETE;
    end
  end
end
^

/* Restore proc. body: SALE_TAXATION_MODIFY$CFG */
ALTER PROCEDURE SALE_TAXATION_MODIFY$CFG(ID_SALE_TAXATION TYPE OF ID,
NAME TYPE OF TOBJECT_NAME,
TAXES VARCHAR(250),
ACCOUNT_NAME TYPE OF TOBJECT_NAME,
OPERATION VARCHAR(10),
ID_HOTEL TYPE OF ID)
 RETURNS(NEW_ID_SALE_TAXATION INTEGER)
 AS
declare variable id_sale_tax integer;
  declare variable old_taxes varchar(250);
  declare variable no_use varchar(255);
begin
  execute procedure SYSTEM_CHECK_OPERATION (:OPERATION, 'add, mod, del');

  if (:OPERATION = 'add') then begin
    insert into SALE_TAXATION (NAME, ACCOUNT_NAME, ID_HOTEL)
    values (:NAME, :ACCOUNT_NAME, :ID_HOTEL)
    returning ID_SALE_TAXATION
    into      :NEW_ID_SALE_TAXATION;

    for
      select T.ITEM
      from   SYSTEM_STRING_PARSER (:TAXES, ',') T
      into   :id_sale_tax
    do begin
      if (not exists (select stt.ID_SALE_TAX
                      from   SALE_TAXATION_TAX STT
                      where  stt.ID_SALE_TAXATION = :NEW_ID_SALE_TAXATION
                             and stt.ID_SALE_TAX = :id_sale_tax)) then
      begin
        insert into SALE_TAXATION_TAX (ID_SALE_TAXATION, ID_SALE_TAX)
        values (:NEW_ID_SALE_TAXATION, :id_sale_tax);

        execute procedure SYSTEM_EVENT_LOG$INT ('SALE_TAX', :id_sale_tax, 'SALE_TAX_ADDED', f_character(29) || :NAME)
        returning_values (:no_use);
      end
    end
  end else if (:OPERATION = 'mod') then begin
    select coalesce(list(distinct(cast(t.ITEM as integer))), '')   -- select new taxes, ordered by ID asc
    from   SYSTEM_STRING_PARSER (:TAXES, ',') T
    into   :TAXES;

    select coalesce(list(distinct(stt.ID_SALE_TAX)), '')           -- select old taxes, ordered by ID asc
    from   SALE_TAXATION_TAX STT
    where  stt.ID_SALE_TAXATION = :ID_SALE_TAXATION
    into   :old_taxes;

    if (:taxes = :old_taxes) then begin
      -- tax contents is not changed
      update SALE_TAXATION ST
      set    ST.NAME = :NAME,
             st.ACCOUNT_NAME = :ACCOUNT_NAME
      where  ST.ID_SALE_TAXATION = :id_sale_taxation;
      NEW_ID_SALE_TAXATION = :ID_SALE_TAXATION;
    end else begin
      -- create new taxation package
      update SALE_TAXATION st
      set    st.NAME = '$$$' || st.NAME || '$$$'
      where  st.ID_SALE_TAXATION = :ID_SALE_TAXATION;

      execute procedure SALE_TAXATION_MODIFY$CFG (null, :name, :taxes, :ACCOUNT_NAME, 'add', :id_hotel)
      returning_values (:NEW_ID_SALE_TAXATION);

      update SERVICE_TAXATION pt
      set    pt.ID_SALE_TAXATION = :NEW_ID_SALE_TAXATION
      where  pt.ID_SALE_TAXATION = :ID_SALE_TAXATION;

      update SETTING_HOTEL_VALUE s
      set    s.SETTING_VALUE = :NEW_ID_SALE_TAXATION
      where  s.SETTING_CODE = 'DEF_SERVICE_TAXATION'
             and s.SETTING_VALUE = :ID_SALE_TAXATION
             and s.ID_HOTEL = :ID_HOTEL;

      -- and delete old, if possible ... else BOOOM! - unallowable changes !
      execute procedure SALE_TAXATION_MODIFY$CFG (:ID_SALE_TAXATION, :name, :taxes, :ACCOUNT_NAME, 'del', :id_hotel)
      returning_values (:ID_SALE_TAXATION);

      when any do begin
        exception SALE_TAX_EXCEPTION '-704';
      end
    end

  end else if (:OPERATION = 'del') then begin
    delete from SALE_TAXATION
    where  ID_SALE_TAXATION = :id_sale_taxation;

    delete from SALE_TAXATION_TAX STT
    where  stt.ID_SALE_TAXATION = :ID_SALE_TAXATION;

    new_id_sale_taxation = null;
  end

  execute procedure SYSTEM_CACHE_APPLY('SALE_TAXATION');
end
^

/* Restore proc. body: SERVICE_TAXATION_MODIFY$CFG */
ALTER PROCEDURE SERVICE_TAXATION_MODIFY$CFG(ID_TAX_POLICY TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_SALE_TAXATION TYPE OF ID)
 AS
declare variable dbkey char(8);
  declare variable nat_round_to numeric(15,4);
  declare variable action_text varchar(255);
  declare variable old_sale_taxation_name varchar(50);
  declare variable service_name varchar(30);
  declare variable id_rate integer;
  declare variable passed_nights integer;
  declare variable id_posting_sale_taxation integer;
begin
  if (:ID_SALE_TAXATION is null) then begin
    delete from SERVICE_TAXATION T
    where  t.ID_TAX_POLICY = :ID_TAX_POLICY
           and t.ID_SERVICE = :ID_SERVICE;

    select f_character(29) || se.service_name
    from   SERVICES se
    where  se.id_service = :id_service
    into   :action_text;
    execute procedure SYSTEM_LOG_ADD ('TAX_POLICY', :id_tax_policy, 'TAX_POLICY_SERVICE_DELETED', :action_text);
  end else begin
    select sta.name
    from   SERVICE_TAXATION TPT
           join SALE_TAXATION sta on sta.id_sale_taxation = tpt.id_sale_taxation
    where  TPT.ID_TAX_POLICY = :ID_TAX_POLICY
           and TPT.ID_SERVICE = :ID_SERVICE
    into   :old_sale_taxation_name;

    select s.SERVICE_NAME, c.ROUND_TO
    from   SERVICES s
           join HOTEL h on h.ID_HOTEL = s.ID_HOTEL
           join CURRS c on c.CURR = h.NATION_CURR
    where  s.ID_SERVICE = :ID_SERVICE
    into   :service_name, :nat_round_to;

    update SERVICE_TAXATION T
    set    T.ID_SALE_TAXATION = :ID_SALE_TAXATION
    where  T.ID_TAX_POLICY = :ID_TAX_POLICY
           and T.ID_SERVICE = :ID_SERVICE;

    if (row_count > 0) then begin
      select st.name
      from   SALE_TAXATION st
      where  st.id_sale_taxation = :id_sale_taxation
      into   :action_text;
      action_text = f_character(29) || :service_name || f_character(28) || coalesce(:old_sale_taxation_name, '') || f_character(28) || :action_text;
      execute procedure SYSTEM_LOG_ADD ('TAX_POLICY', :id_tax_policy, 'TAX_POLICY_SERVICE_UPDATED', :action_text);
    end else begin
      insert into SERVICE_TAXATION (ID_TAX_POLICY, ID_SERVICE, ID_SALE_TAXATION)
      values (:ID_TAX_POLICY, :ID_SERVICE, :ID_SALE_TAXATION);
    end
  
    for
      select AP.RDB$DB_KEY, ap.ID_TARIFF, ap.DATE_POST - ap.FROM_DATE
      from   ACCOUNT A
             join ACCOUNT_POST AP on AP.ID_ACCOUNT = A.ID_ACCOUNT
      where  A.ID_TAX_POLICY = :ID_TAX_POLICY
             and A.IS_ARCHIVE = 0
             and AP.ID_SERVICE = :ID_SERVICE
             and AP.ID_BASE_DOC is null
             and AP.ID_SALE_TAXATION is distinct from :ID_SALE_TAXATION
             and ap.IS_ANUL = 0
      into   :dbkey, :id_rate, :passed_nights
    do begin
      execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :ID_TAX_POLICY, :id_rate, :passed_nights)
      returning_values (:id_posting_sale_taxation);

      if (:id_posting_sale_taxation = :ID_SALE_TAXATION) then begin
        execute procedure ACCOUNT_POSTING_UPDATE_TAX$INT (:dbkey, :ID_SALE_TAXATION, :nat_round_to, 'SERVICE VAT CHANGED');
      end

    end
  end
end
^

/* Restore proc. body: SETTINGS_MODIFY_VALUE */
ALTER PROCEDURE SETTINGS_MODIFY_VALUE(SETTING_CODE TYPE OF TSEARCH_CODE,
SETTING_VALUE TYPE OF TOBJECT_TEXT,
ID_HOTEL TYPE OF ID)
 AS
declare variable old_setting_value varchar(100);
declare variable tmp_setting_value varchar(100);
  declare variable action_text varchar(255);
  declare variable setting_name varchar(255);
  declare variable id_setting_grp integer;
  declare variable settingClass varchar(20);
  declare variable dbkey char(8);
begin
  dbkey = null;
  select SV.SETTING_VALUE, S.ID_SETTING_GRP, S.CONTROL_CLASS, sv.RDB$DB_KEY
  from   SETTING s
         join SETTING_HOTEL_VALUE SV on sv.SETTING_CODE = s.SETTING_CODE
  where  SV.SETTING_CODE = :setting_code
         and sv.ID_HOTEL = :ID_HOTEL
  into   :old_setting_value, :id_setting_grp, :settingClass, :dbkey;

  if (:dbkey is not null) then begin
    update SETTING_HOTEL_VALUE SV
    set    SV.SETTING_VALUE = :setting_value
    where  SV.RDB$DB_KEY = :dbkey;
  end else begin
    insert into SETTING_HOTEL_VALUE (SETTING_CODE, ID_HOTEL, SETTING_VALUE)
    values (:SETTING_CODE, :ID_HOTEL, :SETTING_VALUE);
  end

  RDB$SET_CONTEXT('USER_SESSION', 'setting.'||:setting_code||'.'||:id_hotel, :setting_value);

  if ((:id_setting_grp is not null) and (:setting_value is distinct from :old_setting_value)) then begin
    /* FOR THE FEATURE THIS KIND OF LOGING MUST BE BASED
    || ON MACROS WICH ARE EXECUTED AT DISPLAY TIME.
    || FOR NOW WE ARE HARDCODED TO THE BASE LANG.
    */
    setting_name = '@{set_name.'||:setting_code||'}';
    action_text = f_character(29)||:setting_name;

    if (:settingClass = 'COMBO') then begin
      old_setting_value = '@{set_item.'||:setting_code||'.'||:old_setting_value||'}';
      tmp_setting_value = '@{set_item.'||:setting_code||'.'||:setting_value||'}';
    end else begin
      tmp_setting_value = :setting_value;
    end

    action_text = :action_text
                  || f_character(28) || coalesce(:old_setting_value, '')
                  || f_character(28) || :tmp_setting_value;
    execute procedure SYSTEM_LOG_ADD ('SYSTEM', 0, 'SETTING_CHANGED', :action_text);
  end

  execute procedure SYSTEM_CACHE_APPLY('HOTEL');
end
^

/* Restore proc. body: TAR_CALC_EVAL_ALL$INT */
ALTER PROCEDURE TAR_CALC_EVAL_ALL$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_status varchar(20);
  declare variable from_date date;
  declare variable to_date date;
  declare variable idate date;
  declare variable is_static integer;
  declare variable id_tar_input integer;
  declare variable id_type_stay integer;
  declare variable separate_board integer;
  declare variable id_board_include integer;
  declare variable id_tar_head integer;
  declare variable is_manual_type_stay smallint;
  declare variable seasson_name varchar(50);
begin
  err_code = 0;

  delete from TAR_CALC_OUTPUT$TMP TCO where TCO.ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP TCV where TCV.ID_TAR_CALC = :id_tar_calc;

  execute procedure TAR_CALC_INIT_VARS$INT(:id_tar_calc);

  for
    select TCI.ROOM_STATUS, min(TCI.FROM_DATE_CALC), max(TCI.TO_DATE_CALC), min(TCI.IS_STATIC)
    from   TAR_CALC_INPUT$TMP TCI
    where  TCI.ID_TAR_CALC = :id_tar_calc
    group by TCI.ROOM_STATUS
    into   :room_status, :from_date, :to_date, :is_static
  do begin
    for
      select RLP.OUT_DATE
      from   SYSTEM_LOOP_PERIOD(:from_date, :to_date) RLP
      into   :idate
    do begin
      if ((:is_static = 1) and (:idate > :from_date)) then begin
        insert into TAR_CALC_OUTPUT$TMP (ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
               FOR_DATE, PRICE, CURRENCY, PRICE_TARIFF, CURRENCY_TARIFF, PRICE_NOTE, QTY_POST,
               PTEXT, DISC_TAG, ID_DISCOUNT_SERVICE, REQUIRED_ID_PACKET_ITEM)
        select tco.ID_TAR_INPUT, tco.ID_TAR_CALC, tco.ID_SERVICE, tco.SERVICE_TYPE,
               :idate, PRICE, tco.CURRENCY, tco.PRICE_TARIFF, tco.CURRENCY_TARIFF, tco.PRICE_NOTE, tco.QTY_POST,
               tco.PTEXT, tco.DISC_TAG, tco.ID_DISCOUNT_SERVICE, tco.REQUIRED_ID_PACKET_ITEM
        from   TAR_CALC_OUTPUT$TMP TCO
        where  TCO.FOR_DATE = :from_date
               and TCO.ID_TAR_CALC = :id_tar_calc;
        for
          select TCID.ID_TAR_INPUT, TCID.ID_TYPE_STAY, TCID.SEPARATE_BOARD, TCID.ID_BOARD_INCLUDE,
                 TCID.IS_MANUAL_TYPE_STAY, TCID.ID_TAR_HEAD
          from   TAR_CALC_INPUT_DETAIL$TMP TCID
                 join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
          where  TCID.FOR_DATE = :from_date
                 and TCI.ID_TAR_CALC = :id_tar_calc
          into   :id_tar_input, :id_type_stay, :separate_board, :id_board_include,
                 :is_manual_type_stay, :id_tar_head
        do begin
          seasson_name = null;
          select tp.SEASON_NAME
          from   TARIFA_GET_PERIOD_FOR_DATE (:id_tar_head, :idate) tp
          into   :seasson_name;
          if (:seasson_name is null) then begin
            ERR_CODE = -231;
            ERR_TEXT = '';
            exit;
          end

          update TAR_CALC_INPUT_DETAIL$TMP TCID
          set    TCID.ID_TYPE_STAY = :id_type_stay,
                 TCID.IS_MANUAL_TYPE_STAY = :is_manual_type_stay,
                 TCID.SEPARATE_BOARD = :separate_board,
                 TCID.ID_BOARD_INCLUDE = :id_board_include
          where  TCID.ID_TAR_INPUT = :id_tar_input;
        end
      end else begin
        execute procedure TAR_CALC_EVAL_DATE$INT(:id_tar_calc, :room_status, :idate)
        returning_values  :err_code, :err_text;
        if (:err_code < 0) then exit;
      end
    end
  end

  execute procedure TAR_CALC_EVAL_ZERO$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  if (:err_code is null) then begin
    err_code = -230; /*WRONG INPUT PARAMS - MISSING GUESTS*/
    err_text = 'Missing input data for calculation';
    exit;
  end

  execute procedure TAR_CALC_EVAL_PERIOD$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  execute procedure TAR_CALC_CHECK_PACKETS$INT (:ID_TAR_CALC)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;
end
^

/* Restore proc. body: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* Restore proc. body: TAR_CALC_POST_PREPARE$INT */
ALTER PROCEDURE TAR_CALC_POST_PREPARE$INT(ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
  declare variable id_service integer;
  declare variable id_tariff integer;
  declare variable date_post date;
  declare variable qty_post integer;
  declare variable price_orig numeric(15,4);
  declare variable round_to numeric(15,4);
  declare variable curr_orig char(3);
  declare variable id_room integer;
  declare variable short_code varchar(255);
  declare variable id_reserv integer;
begin

  delete
  from   TAR_CALC_POST$TMP TCP
  where  TCP.ID_TAR_CALC = :id_tar_calc;

  -- update all packets with posting_service_id && source_type
  update  TAR_CALC_OUTPUT$TMP TCO
  set     tco.ID_POSTING_SERVICE = tco.ID_SERVICE,
          tco.SOURCE_TYPE = iif(tco.price_note = 'DISC_STAY', tco.PRICE_NOTE, tco.SERVICE_TYPE)
  where   TCO.id_tar_calc = :id_tar_calc
          and tco.SERVICE_TYPE = 'PACKETS';

  -- transform all 'discounts with service' as packets, with specific source_type
  -- update order is URGENT - 'real' packets must be updated above !!!
  update  TAR_CALC_OUTPUT$TMP TCO
  set     tco.service_type = 'PACKETS',
          tco.ID_POSTING_SERVICE = tco.ID_DISCOUNT_SERVICE,
          tco.SOURCE_TYPE = 'DISC'
  where   TCO.id_tar_calc = :id_tar_calc
          and tco.price_note = 'DISC'
          and tco.id_discount_service > 0;

  -- all packet`s updates must be applied before TAR_OUTPUT_BASE !!!!!!
  for
    select TOB.ID_GUEST, TOB.ID_RESERV, TOB.ID_SERVICE, TOB.ID_TARIFF, TOB.DATE_POST, TOB.QTY_POST,
           round_f(TOB.PRICE_ORIG, c.ROUND_TO), TOB.CURR_ORIG, TOB.ID_ROOM, TOB.SHORT_CODE, c.ROUND_TO
    from   TAR_OUTPUT_BASE(:id_tar_calc) TOB
           left outer join CURRS c on c.CURR = tob.CURR_ORIG
    into   :id_guest, :id_reserv, :id_service, :id_tariff, :date_post, :qty_post,
           :price_orig, :curr_orig, :id_room, :short_code, :round_to
  do begin
    insert into TAR_CALC_POST$TMP(ID_GUEST, ID_RESERV, ID_SERVICE, ID_TARIFF, DATE_POST, QTY_POST,
           PRICE_ORIG, CURR_ORIG, ID_ROOM, IS_BASE, ID_TAR_CALC, SHORT_CODE)
    values(:id_guest, :id_reserv, :id_service, :id_tariff, :date_post, :qty_post,
           :price_orig, :curr_orig, :id_room, 1, :id_tar_calc, :short_code);

    for
        select   TCO.ID_POSTING_SERVICE, coalesce(TCO.SOURCE_TYPE, ''),
                 max(TCO.QTY_POST), round_f(sum(TCO.PRICE_TARIFF), :round_to)
        from     TAR_CALC_OUTPUT$TMP TCO
                 join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCO.ID_TAR_INPUT
        where    TCO.ID_TAR_CALC = :id_tar_calc
                 and TCO.SERVICE_TYPE = 'PACKETS'
                 and TCI.ID_GUEST = :id_guest
                 and TCO.FOR_DATE = :date_post
        group by 1, 2
        into     :id_service, :short_code, :qty_post, :price_orig
    do begin
      if (:short_code not in ('BASE_BOARD', 'EXTRA_BOARD')) then short_code = 'PACK';

      insert into TAR_CALC_POST$TMP(ID_GUEST, ID_RESERV, ID_SERVICE, ID_TARIFF, DATE_POST,
             QTY_POST, PRICE_ORIG, CURR_ORIG, ID_ROOM, IS_BASE, ID_TAR_CALC, SHORT_CODE)
      values(:id_guest, :id_reserv, :id_service, :id_tariff, :date_post, :qty_post,
             :price_orig, :curr_orig, :id_room, 0, :id_tar_calc, :short_code);
    end
  end
end
^

/* Restore proc. body: UNIQUE_SALES_NUMBER_GEN */
ALTER PROCEDURE UNIQUE_SALES_NUMBER_GEN RETURNS(UNIQUE_SALES_NUMBER TYPE OF TNAME_SHORT)
 AS
declare variable num_class varchar(30);
  declare variable fiscal_device_id varchar(10) ;
  declare variable number integer;
  declare variable user_code varchar(50);
  declare variable num_object integer;
begin
  execute procedure FISCAL_DEVICE_STATUS_CHECK
  returning_values (:fiscal_device_id);

  select u.CODE
  from   RIGHTS_USERS u
  where  u.USER_NAME = current_user
  into   :user_code;

  if (coalesce(:user_code, '') = '') then exception ASSERT '-706';

  NUM_CLASS = 'FISCAL_DEVICE';
  select n.NUM_OBJECT
  from   SYSTEM_NUMERATOR n
  where  n.NUM_CLASS = :num_class
         and n.NUM_NAME = :FISCAL_DEVICE_ID
         and n.ID_HOTEL is null
  into   :num_object;
  if (:num_object is null) then begin
    execute procedure NUMERATOR_MODIFY$CFG(null, :fiscal_device_id,
            1, '', 10, :num_class, null, 'add')
    returning_values (:num_object);
  end

  execute procedure SYSTEM_GEN_NUM(:num_class, :num_object)
  returning_values (:number, :number);

  if (:number is null) then exception ASSERT 'Sales number is empty!';

  UNIQUE_SALES_NUMBER = :FISCAL_DEVICE_ID || '-' || lpad(:user_code, 4, '0') || '-' || lpad(:number, 7, '0');
end
^

/* Creating trigger... */
CREATE TRIGGER DOC_TYPE_BIU0 FOR DOC_TYPE
ACTIVE BEFORE INSERT OR UPDATE POSITION 0 
AS
begin
  new.UPDATED_AT = current_timestamp;

  if (inserting or (new.IS_ARCHIVE is distinct from old.IS_ARCHIVE)) then begin
    if (new.IS_ARCHIVE = 1) then
      new.ARCHIVED_AT = current_timestamp;
    else
      new.ARCHIVED_AT = null;
  end
end
^

CREATE TRIGGER HOTEL_BIU0 FOR HOTEL
ACTIVE BEFORE INSERT OR UPDATE POSITION 0 
AS
begin
  new.UPDATED_AT = current_timestamp;

  if (inserting or (new.IS_USE is distinct from old.IS_USE)) then begin
    if (new.IS_USE = 0) then
      new.ARCHIVED_AT = current_timestamp;
    else
      new.ARCHIVED_AT = null;
  end
end
^

CREATE TRIGGER PAYMENT_TYPE_BIU0 FOR PAYMENT_TYPE
ACTIVE BEFORE INSERT OR UPDATE POSITION 0 
AS
begin
  new.UPDATED_AT = current_timestamp;

  if (inserting or (new.IS_USE is distinct from old.IS_USE)) then begin
    if (new.IS_USE = 0) then
      new.ARCHIVED_AT = current_timestamp;
    else
      new.ARCHIVED_AT = null;
  end
end
^

CREATE TRIGGER RIGHTS_GROUPS_BIU0 FOR RIGHTS_GROUPS
ACTIVE BEFORE INSERT OR UPDATE POSITION 0 
AS
begin
  new.UPDATED_AT = current_timestamp;
  /*
  if (inserting or (new.IS_USE is distinct from old.IS_USE)) then begin
    if (new.IS_USE = 0) then
      new.ARCHIVED_AT = current_timestamp;
    else
      new.ARCHIVED_AT = null;
  end
  */
end
^

CREATE TRIGGER RIGHTS_USERS_BIU0 FOR RIGHTS_USERS
ACTIVE BEFORE INSERT OR UPDATE POSITION 0 
AS
begin
  new.UPDATED_AT = current_timestamp;

  if (inserting or (new.IS_ACTIVE is distinct from old.IS_ACTIVE)) then begin
    if (new.IS_ACTIVE = 0) then
      new.ARCHIVED_AT = current_timestamp;
    else
      new.ARCHIVED_AT = null;
  end
end
^

CREATE TRIGGER SALE_NUM_BI0 FOR SALE_NUM
ACTIVE BEFORE INSERT POSITION 0 
AS
BEGIN
  IF (NEW.ID_SALE_NUM IS NULL) THEN
    NEW.ID_SALE_NUM = GEN_ID(GEN_SALE_NUM,1);
END
^


/* Create Views... */

/* Altering existing trigger... */
ALTER TRIGGER PROFILE_BIU0
AS
begin
  if ((inserting) or (new.PROFILE_NAME is distinct from old.PROFILE_NAME) ) then begin
    select ss.UNICODE_STRING
    from   SYSTEM_STRING_TO_UNICODE(new.PROFILE_NAME) ss
    into   new.MERGE_NAME;
  end
  new.UPDATED_AT = current_timestamp;

  if (inserting or (new.IS_ARCHIVE is distinct from old.IS_ARCHIVE)) then begin
    if (new.IS_ARCHIVE = 1) then
      new.ARCHIVED_AT = current_timestamp;
    else
      new.ARCHIVED_AT = null;
  end
end
^

/* Altering existing trigger... */
ALTER TRIGGER SERVICES_BIU1
AS
begin
  new.SERVICE_NAME_UNQ_HASH = MD5HASH(new.service_name|| '-' || new.id_hotel || '-' || iif(new.is_base = 0, 0, new.id_service));

  new.UPDATED_AT = current_timestamp;

  if (inserting or (new.IS_DELETED is distinct from old.IS_DELETED)) then begin
    if (new.IS_DELETED = 1) then
      new.ARCHIVED_AT = current_timestamp;
    else
      new.ARCHIVED_AT = null;
  end
end
^

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: ACCOUNT_CREATE_PMS$PMS for: ACCOUNT_MODIFY$INT */
ALTER PROCEDURE ACCOUNT_CREATE_PMS$PMS(ID_OWNER INTEGER,
ID_ACC_TEMPLATE INTEGER,
ID_CURRENCY CHAR(3),
ID_HOTEL INTEGER)
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_MODIFY$PROFILE for: ACCOUNT_MODIFY$INT */
ALTER PROCEDURE ACCOUNT_MODIFY$PROFILE(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_CONTRAGENT INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_ACCOUNT$EXC for: ACCOUNT_MODIFY$INT */
ALTER PROCEDURE IMPORT_ACCOUNT$EXC(ACCOUNT_NAME VARCHAR(50),
ACCOUNT_CURR VARCHAR(3),
IS_CREDIT_ACCOUNT SMALLINT,
CREDIT_LIMIT NUMERIC(15,4),
PAYMENT_TYPE VARCHAR(20),
NOTE VARCHAR(255),
IS_BLOCKED SMALLINT,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE SMALLINT,
IS_EXTRA SMALLINT,
IS_ALOWED_POS_INTERFACE SMALLINT,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
IS_DEFAULT SMALLINT,
HOTEL_NAME VARCHAR(50))
 RETURNS(ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_ACCOUNT_CREATE$INT for: ACCOUNT_MODIFY$INT */
ALTER PROCEDURE RES_ACCOUNT_CREATE$INT(ID_PROFILE INTEGER,
ID_ACC_TEMPLATE INTEGER,
ACC_CURRENCY CHAR(3),
ID_RESERV_DETAIL INTEGER,
IS_BASE_ENABLE SMALLINT = 1,
IS_EXTRA_ENABLE SMALLINT = 1)
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_MODIFY$INT) */
ALTER PROCEDURE ACCOUNT_MODIFY$INT(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL TYPE OF ID_REF,
IS_PMS_ACCOUNT TYPE OF TLOGICAL,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable a_dbkey char(8);
  declare variable old_sec_level integer;
  declare variable action_text varchar(255);
  declare variable old_acc_name varchar(50);
  declare variable old_acc_curr varchar(3);
  declare variable old_tax_policy integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, archive');

  new_id_account = :id_account;
  if (:operation = 'add') then begin
    if ((:new_id_account is null) or (:new_id_account <= 0)) then new_id_account = gen_id(ID_ACCOUNT_GEN, 1);

    insert into ACCOUNT(ID_ACCOUNT, ACCOUNT_CURR, ACCOUNT_NAME, IS_CREDIT_ACCOUNT, CREDIT_LIMIT,
           ID_TYPE_PAYMENT, NOTE, IS_BLOCKED, BLOCK_TEXT, SECURITY_LEVEL, IS_BASE, IS_EXTRA,
           IS_ALOWED_POS_INTERFACE, POS_INTERFACE_NOTE, EXT_CODE, ID_TAX_POLICY, ID_PROFILE,
           ID_HOTEL, IS_DEFAULT, IS_PMS_ACCOUNT, ID_RESERV_DETAIL)
    values (:new_id_account, :account_curr, :account_name, 0, null,
           :id_type_payment, :note, :is_blocked, :block_text, :security_level, :is_base, :is_extra,
           :is_alowed_pos_interface, :pos_interface_note, :ext_code, :id_tax_policy, :id_profile,
           :id_hotel, :is_default, coalesce(:IS_PMS_ACCOUNT, 0), :ID_RESERV_DETAIL)
    returning RDB$DB_KEY
    into   :a_dbkey;

    action_text = f_character(29) || :new_id_account || '/' || :account_name;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'ADD_ACCOUNT', :action_text);

    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:NEW_ID_ACCOUNT, :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT);
    -- check special right and log event

  end else begin
    ID_RESERV_DETAIL = null;
    select A.RDB$DB_KEY, A.ID_RESERV_DETAIL, A.SECURITY_LEVEL,
           A.ACCOUNT_NAME, A.ACCOUNT_CURR, A.ID_TAX_POLICY
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :a_dbkey, :id_reserv_detail, :old_sec_level,
           :old_acc_name, :old_acc_curr, :old_tax_policy;
    if (:operation = 'mod') then begin
  
      update ACCOUNT A
      set    A.ACCOUNT_NAME = :account_name,
             A.ID_TYPE_PAYMENT = :id_type_payment,
             A.NOTE = :note,
             A.IS_BLOCKED = :is_blocked,
             A.BLOCK_TEXT = :block_text,
             A.SECURITY_LEVEL = :security_level,
             A.IS_BASE = :is_base,
             A.IS_EXTRA = :is_extra,
             A.IS_ALOWED_POS_INTERFACE = :is_alowed_pos_interface,
             A.POS_INTERFACE_NOTE = :pos_interface_note,
             A.EXT_CODE = :ext_code,
             A.ID_TAX_POLICY = :id_tax_policy,
             A.IS_DEFAULT = :is_default
      where  A.RDB$DB_KEY = :a_dbkey;
  
      execute procedure ACCOUNT_SET_CURRENCY$INT (:a_dbkey, :account_curr);
  
      if (:old_acc_name <> :account_name) then begin
        action_text = f_character(29 ) || :ID_ACCOUNT || '/' || :old_acc_name || ', ' || :old_acc_curr
                      || f_character(28) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME || ', ' || :ACCOUNT_CURR;
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'EDIT_ACCOUNT', :action_text);
      end
  
      if (:old_sec_level <> :SECURITY_LEVEL) then begin
        action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME
                      || f_character(28) || :SECURITY_LEVEL;
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'SET_ACC_SEC_LEVEL', :action_text);
      end
  
      if (:old_tax_policy <> :id_tax_policy) then begin
        execute procedure ACCOUNT_TAXATION_RECALC$INT (:ID_ACCOUNT, :ID_TAX_POLICY);
  
        action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME;                        
  
        select :action_text || f_character(28) || OTP.POLICY_NAME
        from   TAX_POLICY OTP
        where  OTP.ID_TAX_POLICY = :old_tax_policy
        into   :action_text;
        select :action_text || f_character(28) || NTP.POLICY_NAME
        from   TAX_POLICY NTP
        where  NTP.ID_TAX_POLICY = :ID_TAX_POLICY
        into   :action_text;
         
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'VAT_POLICY_CHNG', :action_text);
      end
  
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:ID_ACCOUNT, :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT); -- check special right and log event
  
    end else if (:operation = 'archive') then begin
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 1);

    end
  end

  if ((:id_reserv_detail is null) and (:IS_CREDIT_ACCOUNT = 0)) then begin
    exception ACCOUNT_EXCEPTION '-1010';
    -- The account must have active credit status
    exit;
  end

  if (:is_default = 1) then begin
    update ACCOUNT A
    set    A.IS_DEFAULT = 0
    where  A.ID_HOTEL = :id_hotel
           and A.ID_PROFILE = :id_profile
           and A.ID_ACCOUNT <> :new_id_account;
  end
end
^

/* Alter (ACCOUNT_MODIFY$PROFILE) */
ALTER PROCEDURE ACCOUNT_MODIFY$PROFILE(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_CONTRAGENT INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable is_pms_account tlogical;
  declare variable id_sale_num integer;
begin

  select a.ID_RESERV_DETAIL, a.IS_PMS_ACCOUNT
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :id_reserv_detail, :is_pms_account;

  execute procedure ACCOUNT_MODIFY$INT (:ID_ACCOUNT, :ID_PROFILE, :ACCOUNT_CURR, :ACCOUNT_NAME,
          :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT, :ID_TYPE_PAYMENT, :NOTE, :IS_BLOCKED, :BLOCK_TEXT,
          :SECURITY_LEVEL, :IS_BASE, :IS_EXTRA, :IS_ALOWED_POS_INTERFACE, :POS_INTERFACE_NOTE,
          :EXT_CODE, :ID_TAX_POLICY, :IS_DEFAULT, :ID_HOTEL, :ID_RESERV_DETAIL, :IS_PMS_ACCOUNT, :OPERATION)
  returning_values (:NEW_ID_ACCOUNT);

  update ACCOUNT a
  set    a.ID_CONTRAGENT = :ID_CONTRAGENT
  where  a.ID_ACCOUNT = :NEW_ID_ACCOUNT;

  if (:OPERATION = 'add' and exists (select p.ID_PROFILE
                                     from   PROFILE_HOUSE p
                                     where  p.ID_PROFILE = :ID_PROFILE
                                            and p.HOUSE_TYPE in ('hptExternalRevenue', 'hptComplimentary'))) then
  begin
    execute procedure ACCOUNT_SALE_NUMBER_SET(:ID_ACCOUNT)
    returning_values (:id_sale_num);
  end
end
^

/* Alter (ACCOUNT_MODIFY_TEMPLATE$PROFILE) */
ALTER PROCEDURE ACCOUNT_MODIFY_TEMPLATE$PROFILE(ID_ACC_TEMPLATE INTEGER,
TEMPLATE_NAME VARCHAR(40),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,4),
SECURITY_LEVEL INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
ID_TAX_POLICY INTEGER,
IS_ARCHIVE INTEGER,
OPERATION VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(NEW_ID_ACC_TEMPLATE INTEGER)
 AS
declare variable action_text varchar(255);
declare variable tax_policy_name varchar(100);
declare variable old_template_name varchar(50);
declare variable old_security_level integer;
declare variable old_is_credit_account smallint;
declare variable old_credit_limit numeric(15,4);
declare variable old_is_alowed_pos_interface smallint;
declare variable old_id_tax_policy integer;
declare variable old_is_archive integer;
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  new_id_acc_template = :id_acc_template;
  if (:operation = 'add') then begin
    if ((:new_id_acc_template is null) or (:new_id_acc_template <= 0)) then new_id_acc_template = gen_id(ID_ACCOUNT_GEN, 1);

    insert into ACC_TEMPLATE (ID_ACC_TEMPLATE, TEMPLATE_NAME, SECURITY_LEVEL, IS_CREDIT_ACCOUNT, CREDIT_LIMIT,
           IS_ALOWED_POS_INTERFACE, ID_TAX_POLICY, IS_ARCHIVE, ID_HOTEL)
    values (:new_id_acc_template, :template_name, :security_level, :is_credit_account, :credit_limit,
           :is_alowed_pos_interface, :id_tax_policy, 0, :ID_HOTEL);

    action_text = f_character(29) || :template_name;
    execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACCOUNT_TEMPLATE_CREATE', :action_text);

  end else if (:operation = 'mod') then begin
    select act.template_name,
           act.security_level,
           act.is_credit_account,
           act.credit_limit,
           act.is_alowed_pos_interface,
           act.id_tax_policy,
           act.is_archive
    from   ACC_TEMPLATE act
    where  act.id_acc_template = :id_acc_template
    into   :old_template_name, :old_security_level, :old_is_credit_account, :old_credit_limit, :old_is_alowed_pos_interface,
           :old_id_tax_policy, :old_is_archive;
    if (:template_name <> :old_template_name) then begin
      action_text = f_character(29) || :old_template_name || f_character(28) || :template_name;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_NAME_CHANGED', :action_text);
    end
    if (:security_level <> :old_security_level) then begin
      action_text = f_character(29) || :old_security_level || f_character(28) || :security_level;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_SEC_LEVEL_CHANGED', :action_text);
    end
    if (:is_credit_account <> :old_is_credit_account) then begin
      action_text = f_character(29) || :old_is_credit_account || f_character(28) || :is_credit_account;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_CR_ACC_CHANGED', :action_text);
    end
    if (coalesce(:credit_limit, 0) <> coalesce(:old_credit_limit, 0)) then begin
      action_text = f_character(29) || formatfloat(:old_credit_limit, '0.00') || f_character(28) || formatfloat(:credit_limit, '0.00');
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_CR_LIM_CHANGED', :action_text);
    end
    if (:is_alowed_pos_interface <> :old_is_alowed_pos_interface) then begin
      action_text = f_character(29) || :old_is_alowed_pos_interface || f_character(28) || :is_alowed_pos_interface;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_POS_CHANGED', :action_text);
    end
    if (:id_tax_policy <> :old_id_tax_policy) then begin
      select f_character(29) || policy_name
      from tax_policy
      where id_tax_policy = :old_id_tax_policy
      into :action_text;
      select f_character(28) || policy_name
      from tax_policy
      where id_tax_policy = :id_tax_policy
      into :tax_policy_name;
      action_text = :action_text || :tax_policy_name;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_TAX_POL_CHANGED', :action_text);
    end
    if (:is_archive <> :old_is_archive) then begin
      action_text = f_character(29) || :old_is_archive|| f_character(28) || :is_archive;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_IS_ARCH_CHANGED', :action_text);
    end
    update ACC_TEMPLATE
    set    TEMPLATE_NAME = :template_name,
           SECURITY_LEVEL = :security_level,
           IS_CREDIT_ACCOUNT = :is_credit_account,
           CREDIT_LIMIT = :credit_limit,
           IS_ALOWED_POS_INTERFACE = :is_alowed_pos_interface,
           ID_TAX_POLICY = :id_tax_policy,
           IS_ARCHIVE = :is_archive
    where  ID_ACC_TEMPLATE = :id_acc_template;
  end else if (:operation = 'del') then begin
    select template_name
    from   ACC_TEMPLATE
    where  ID_ACC_TEMPLATE = :id_acc_template
    into   :old_template_name;

    execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'DELETE', '');

    delete from ACC_TEMPLATE
    where  ID_ACC_TEMPLATE = :id_acc_template;

  --  action_text = f_character(29) || :old_template_name;
  --  execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_DELETED', :action_text);
  end

end
^

/* empty dependent procedure body */
/* Clear: DEVICE_READING_ANUL$PMS for: ACCOUNT_POSTING_ANUL */
ALTER PROCEDURE DEVICE_READING_ANUL$PMS(ID_DEVICE_READING /* TYPE OF ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ANUL$P2E for: ACCOUNT_POSTING_ANUL */
ALTER PROCEDURE EAI_POS_POSTING_ANUL$P2E(IN_ID_SMETKA INTEGER,
IN_USER_ANUL VARCHAR(100))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_POSTING_ANUL) */
ALTER PROCEDURE ACCOUNT_POSTING_ANUL(IN_ID_ACCOUNT_POST INTEGER,
IN_ANUL_REASON VARCHAR(70))
 AS
declare variable action_text varchar(255);
  declare variable id_account integer;
  declare variable qty_post numeric(15,2);
  declare variable price_post double precision;
  declare variable date_post date;
  declare variable id_service integer;
  declare variable curr_post varchar(3);
  declare variable ap_dbkey char(8);
begin
  /* called only from GUI - manual anullment */
  select AP.RDB$DB_KEY, AP.ID_ACCOUNT, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST
  from   ACCOUNT_POST AP
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :ap_dbkey, :id_account, :qty_post, :price_post,
         :date_post, :id_service, :curr_post;

  execute procedure ACCOUNT_POSTING_ANUL$INT (:ap_dbkey, :IN_ANUL_REASON);

  select S.SERVICE_NAME
  from   SERVICES S
  where  S.ID_SERVICE = :id_service
  into   :action_text;

  action_text = f_character(29) || :action_text
                || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:qty_post * :price_post, 'F;0.00') || ' ' || :curr_post
                || f_character(28) || replace(:IN_ANUL_REASON, 'MANUAL', '');
  execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_ANUL', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POST_MODIFY$PMS for: ACCOUNT_POSTING_ANUL$INT */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PMS_EVENT_VOID$INT for: ACCOUNT_POSTING_ANUL$INT */
ALTER PROCEDURE PMS_EVENT_VOID$INT(ID_PMS_EVENT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_ANUL$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_ANUL$INT(AP_DBKEY TYPE OF TDB_KEY,
ANUL_REASON TYPE OF TREASON)
 AS
declare variable is_anul integer;
  declare variable qty_post integer;
  declare variable orig_is_base integer;
  declare variable orig_short_code varchar(255);
  declare variable id_base_doc integer;
  declare variable rp_dbkey char(8);
  declare variable id_resource_reserv integer;
  declare variable id_account_post integer;
  declare variable is_locked_for_update integer;
  declare variable orig_ac varchar(2);
  declare variable doc_qty numeric(15,2);
begin
  select AP.ID_ACCOUNT_POST, AP.IS_ANUL, AP.QTY_POST,
         AP.IS_BASE, AP.SHORT_CODE, AP.ID_BASE_DOC, ap.AC, ap.IN_DOC_QTY
  from   ACCOUNT_POST AP
  where  AP.rdb$db_key = :AP_DBKEY
  into   :id_account_post, :is_anul, :qty_post,
         :orig_is_base, :orig_short_code, :id_base_doc, :orig_ac, :doc_qty;

  /*if (:is_anul = 1) then begin
    exception POSTING_ANNUL_EXCEPTION '-33'; /* POSTING IS ALREADY ANULED */
  /*end*/

  if (:ANUL_REASON not like '%RECALC_%') then begin
    /* MANUAL ANUL */
    is_locked_for_update = 1;
    execute procedure RIGHTS_CHECK_GRANTED$INT('ACCPOSTANUL');
    if (:orig_ac = '01') then execute procedure RIGHTS_CHECK_GRANTED$INT('BALANCES_EDIT_CLOSED');

    if (:orig_is_base = 1) then exception POSTING_ANNUL_EXCEPTION '-103'; /* CAN`T ANUL BASE SERVICE */
  end else begin
    /* AUTO RECALC */
    is_locked_for_update = 0;
  end

  if (:id_base_doc > 0) then begin -- has a valid doc
    if (:qty_post = 0) then exit;  -- already anul
    qty_post = 0;
    if (:doc_qty = 0) then begin   -- has a storno doc for this posting
      is_anul = 1;
    end else begin
      is_anul = 0;
    end
  end else begin
    if (:is_anul = 1) then exit;   -- already anul
    is_anul = 1;
  end

  update ACCOUNT_POST APU
  set    APU.IS_ANUL = :is_anul,
         APU.QTY_POST = :qty_post,
         APU.USER_ANUL = current_user,
         APU.ANUL_DATETIME = current_timestamp,
         APU.ANUL_REASON = :anul_reason,
         APU.CHANGED_TEXT = substring(:anul_reason from 1 for 30),
         APU.AC = :is_anul || '0',
         APU.DATETIME_CHANGED = current_timestamp,
         APU.POST_NET_VALUE = 0,
         APU.POST_GROSS_VALUE = 0,
         APU.IS_LOCKED_FOR_UPDATE = :is_locked_for_update
  where  APU.rdb$db_key = :AP_DBKEY;

  if (:orig_short_code = 'TELECOUNT') then begin
    update PHONECALLS PH
    set    PH.ID_ACCOUNT_POST = -1,
           PH.IS_LOGICLESS_RECORD = 1
            /*!!! TO PREVENT FUTURE AUTO TRANSFER !!!*/
    where  PH.ID_ACCOUNT_POST = :id_account_post;
  end else if (:orig_short_code = 'RESOURCE') then begin
    select RP.RDB$DB_KEY, RP.ID_RESOURCE_RESERVATION
    from   RESOURCE_RESERV_POST RP
    where  RP.ID_ACCOUNNT_POST = :id_account_post
    into   :rp_dbkey, :id_resource_reserv;

    delete from RESOURCE_RESERV_POST RRP
    where  RRP.RDB$DB_KEY = :rp_dbkey;

    execute procedure RESOURCE_RESERV_RESET$INT (:id_resource_reserv);

  end else if (:orig_short_code = 'PMS') then begin
    if (exists ( select *
                 from   PMS_EVENT_POST P
                 where  P.LINE_STATUS > 11
                        and P.ID_ACCOUNT_POST = :id_account_post )) then exception PMS_EXCEPTION '-620';

    update PMS_EVENT_POST PP
    set    PP.LINE_STATUS = 22
    where  PP.ID_ACCOUNT_POST = :id_account_post;
  end


  if (:orig_is_base = 1) then begin
    /* ANUL THE REST OF THE PACKET (ADDINS) */
    for
      select AP_addins.rdb$db_key
      from   ACCOUNT_POST AP_addins
      where  AP_addins.ID_MASTER_ADDINS_ACC_POST = :id_account_post
             and AP_addins.IS_BASE = 0
             and AP_addins.IS_ANUL = 0
      into   :ap_dbkey
    do begin
      execute procedure ACCOUNT_POSTING_ANUL$INT (:AP_DBKEY, :ANUL_REASON);
    end
  end

end
^

/* Alter (ACCOUNT_POSTING_MULTIANUL) */
ALTER PROCEDURE ACCOUNT_POSTING_MULTIANUL(AP_LIST VARCHAR(4096),
ANUL_REASON VARCHAR(70))
 AS
declare variable ap_dbkey char(8);
  declare variable id_account integer;
  declare variable prev_id_account integer;
  declare variable curr_post varchar(3);
  declare variable post_value double precision;
  declare variable log_curr varchar(3);
  declare variable log_value double precision;
  declare variable action_text varchar(255);
begin
  prev_id_account = null;
  log_value = 0;
  for
    select AP.RDB$DB_KEY, AP.ID_ACCOUNT, AP.CURR_POST, AP.QTY_POST * AP.PRICE_POST
    from   SYSTEM_STRING_PARSER(:ap_list, ',') SP
           left outer join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = SP.ITEM
    order by AP.ID_ACCOUNT asc
    into   :ap_dbkey, :id_account, :curr_post, :post_value
  do begin
    execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_dbkey,  :anul_reason);

    if (:prev_id_account is not null and :prev_id_account <> :id_account) then begin
      action_text = f_character(29) || formatfloat(:log_value, 'F;0.00') || ' ' || :log_curr
                    || f_character(28) || replace(:ANUL_REASON, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_MULTIANUL', :action_text);
    end
    log_value = :log_value + :post_value;
    log_curr = :curr_post;
    prev_id_account = :id_account;
  end

  if (:id_account is not null) then begin
    action_text = f_character(29) || formatfloat(:log_value, 'F;0.00') || ' ' || :log_curr
                  || f_character(28) || replace(:ANUL_REASON, 'MANUAL', '');
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_MULTIANUL', :action_text);
 end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_JOIN_IN_ONE_BY_STRING for: ACCOUNT_POSTING_TRANSFER$ACC */
ALTER PROCEDURE ACCOUNT_JOIN_IN_ONE_BY_STRING(IN_TARGET_ID_ACCOUNT INTEGER,
IN_SOURCE_STRING VARCHAR(1000))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_SELECTION_UNITE$DOC for: ACCOUNT_POSTING_TRANSFER$ACC */
ALTER PROCEDURE ACCOUNT_SELECTION_UNITE$DOC(ID_DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
PROFILE_ACCOUNTS_ONLY SMALLINT = 0)
 RETURNS(SKIP_DOC_SELECTED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_POSTING_TRANSFER$ACC) */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
declare variable ap_dbkey char(8);
  declare variable transfer_value double precision;
  declare variable post_value double precision;
  declare variable id_account integer;
  declare variable tmp_id_account integer;
  declare variable curr_post varchar(3);
  declare variable acc_name varchar(50);
  declare variable action_text varchar(255);
  declare variable is_pms_account integer;
  declare variable dest_acc_name varchar(50);
begin

  id_account = null;
  transfer_value = 0;

  select ACC.ACCOUNT_NAME, acc.IS_PMS_ACCOUNT
  from   ACCOUNT ACC
  where  ACC.ID_ACCOUNT = :ID_DEST_ACCOUNT
  into   :dest_acc_name, is_pms_account;

  if (:is_pms_account = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('PMS_TRANSFER_POSTINGS');
  end

  for
    select AP.RDB$DB_KEY, AP.ID_ACCOUNT, ap.PRICE_POST * ap.QTY_POST
    from   ACCOUNT_POST AP
    where  AP.DOC_SELECTED = :DOC_SELECTED
           and AP.ID_ACCOUNT = coalesce(:ID_SRC_ACCOUNT, AP.ID_ACCOUNT)
           and AP.ID_ACCOUNT is distinct from :ID_DEST_ACCOUNT
    order by AP.ID_ACCOUNT asc
    into   :ap_dbkey, :tmp_id_account, :post_value
  do begin
    execute procedure ACCOUNT_POSTING_TRANSFER$INT (:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:id_account is null) then id_account = :tmp_id_account;

    /* update from/to pms account */
    execute procedure ACCOUNT_POST_EVENT_REROUTE$INT(:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:tmp_id_account is distinct from :id_account) then begin
      select A.ACCOUNT_NAME, A.ACCOUNT_CURR
      from   ACCOUNT A
      where  A.ID_ACCOUNT = :id_account
      into   :acc_name, :curr_post;

      action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                    f_character(28) || :id_account || '/' || :acc_name ||
                    f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
      execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
      id_account = :tmp_id_account;
      transfer_value = 0;
    end
    transfer_value = :transfer_value + :post_value;
  end

  if (:id_account is not null) then begin
    select A.ACCOUNT_NAME, A.ACCOUNT_CURR
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :acc_name, :curr_post;
  
    action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                  f_character(28) || :id_account || '/' || :acc_name ||
                  f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: GUEST_REROUTE_POSTINGS$INT for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_TRANSFER$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER,
IS_MANUAL_TRANSFER TYPE OF TLOGICAL = 1)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date,
                    iif(:IS_MANUAL_TRANSFER is distinct from 1, 1, 0), :id_target_account)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Alter (ACCOUNT_POSTING_UPDATE) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    action_text = f_character(29) || :action_text
                  || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                  || f_character(28) || :log_old_value
                  || f_character(28) || :log_new_value
                  || f_character(28) || replace(:IN_CHANGED_TEXT, 'MANUAL', '');
    execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
  end

end
^

/* Alter (ACCOUNT_POSTS_ON_DATE$RPT) */
ALTER PROCEDURE ACCOUNT_POSTS_ON_DATE$RPT(ID_HOTEL INTEGER,
TO_DATE DATE,
INCL_CORR SMALLINT,
INCL_POSTS SMALLINT,
IN_ID_ACCOUNT INTEGER = null)
 RETURNS(POST_ID INTEGER,
ID_ACCOUNT INTEGER,
ID_GUEST INTEGER,
ROOM_NAME VARCHAR(20),
ID_SERVICE INTEGER,
ARISE_DATE DATE,
DATE_POST DATE,
IS_PRIMARY_POST SMALLINT,
POST_TYPE VARCHAR(10),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,4),
POST_NET_VALUE NUMERIC(15,4),
POST_GROSS_VALUE NUMERIC(15,4),
RATE_POST NUMERIC(15,6),
CURR_POST VARCHAR(3),
DATETIME_POST TIMESTAMP,
USER_NAME VARCHAR(30),
POST_REASON VARCHAR(30),
ID_VAT_GROUP INTEGER,
ID_ACCOUNT_POST INTEGER)
 AS
declare variable ID_EW integer;
begin
  select ew.ID_END_WORK
  from   END_WORKS EW
  where  EW.ID_HOTEL = :ID_HOTEL
         and ew.PREV_DATE = :to_date
         and ew.END_WORK_KIND = '3'
         and ew.PREV_DATE is distinct from ew.NEXT_DATE
  into   :id_ew;

  for
    select R.SEQUENCE_ID, R.ID_ACCOUNT, R.ID_GUEST, R.ROOM_NAME, R.ID_SERVICE,
           R.ARISE_DATE, R.DATE_POST, R.IS_PRIMARY_POST, R.POST_TYPE,
           R.QTY_POST, R.PRICE_POST, R.POST_NET_VALUE, R.POST_GROSS_VALUE, R.RATE_POST, R.CURR_POST,
           R.DATETIME_POST, R.USER_NAME, R.POST_REASON, R.ID_SALE_TAXATION, R.ID_ACCOUNT_POST
    from   SERVICE_POSTING_REVENUE$INT(:ID_EW) R
           left outer join ACCOUNT A on A.ID_ACCOUNT = R.ID_ACCOUNT
           left outer join PROFILE_HOUSE PH on PH.ID_PROFILE = A.ID_PROFILE
    where  PH.HOUSE_TYPE is distinct from 'hptComplimentary'
           and ((:IN_ID_ACCOUNT is null) or (R.ID_ACCOUNT = :IN_ID_ACCOUNT))
    into   :POST_ID, :ID_ACCOUNT, :ID_GUEST, :ROOM_NAME, ID_SERVICE,
           :ARISE_DATE, :DATE_POST, :IS_PRIMARY_POST, :POST_TYPE,
           :QTY_POST, :PRICE_POST, :POST_NET_VALUE, :POST_GROSS_VALUE, :RATE_POST, :CURR_POST,
           :DATETIME_POST, :USER_NAME, :POST_REASON, :ID_VAT_GROUP, :id_account_post
  do begin
    if ((:INCL_POSTS = 1 and :IS_PRIMARY_POST = 1)
        or (:INCL_CORR = 1 and :IS_PRIMARY_POST = 0)
       ) then suspend;
  end
end
^

/* Alter (ACCOUNT_SELECTION_UNITE$DOC) */
ALTER PROCEDURE ACCOUNT_SELECTION_UNITE$DOC(ID_DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
PROFILE_ACCOUNTS_ONLY SMALLINT = 0)
 RETURNS(SKIP_DOC_SELECTED INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_deposit integer;
  declare variable id_base_doc integer;
  declare variable avail_value double precision ;
  declare variable dbkey char(8);
  declare variable id_account integer;
  declare variable id_profile integer;
  declare variable description varchar(100);
begin
  dbg = null;
  skip_doc_selected = null;
  id_profile = null;
  if (:PROFILE_ACCOUNTS_ONLY = 1) then begin
    select A.ID_PROFILE
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :ID_DEST_ACCOUNT
    into   :ID_PROFILE;
  end

  for
    select AP.ID_ACCOUNT, max(AP.ID_BASE_DOC)
    from   ACCOUNT_POST AP
           join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
    where  AP.DOC_SELECTED = :ID_DOC_SELECTED
           and AP.ID_ACCOUNT is distinct from :ID_DEST_ACCOUNT
           and A.ID_PROFILE = coalesce(:ID_PROFILE, A.ID_PROFILE)
    group by AP.ID_ACCOUNT
    into   :ID_ACCOUNT, :ID_BASE_DOC
  do begin
    if (:ID_BASE_DOC is null) then begin
      /* posting transfer loging is released into next procedure */
      execute procedure ACCOUNT_POSTING_TRANSFER$ACC (:ID_DOC_SELECTED, :ID_DEST_ACCOUNT, :ID_ACCOUNT);
    end else begin
      /* has a document on some postings - skip transfer */
      SKIP_DOC_SELECTED = -:ID_DOC_SELECTED;
      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :SKIP_DOC_SELECTED
      where  AP.DOC_SELECTED = :ID_DOC_SELECTED
             and AP.ID_ACCOUNT = :ID_ACCOUNT;
    end
  end

  for
    select D.ID_ACCOUNT, D.ID_DEPOSIT, D.RDB$DB_KEY
    from   DEPOSIT D
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  D.DOC_SELECTED = :ID_DOC_SELECTED
           and D.ID_ACCOUNT is distinct from :ID_DEST_ACCOUNT
           and A.ID_PROFILE = coalesce(:ID_PROFILE, A.ID_PROFILE)
    order by 1 asc
    into   :ID_ACCOUNT, :ID_DEPOSIT, :DBKEY
  do begin
    if (not exists (select AP.ID_ACCOUNT_POST
                    from   ACCOUNT_POST AP
                    where  AP.ID_ACCOUNT = :ID_ACCOUNT
                           and AP.DOC_SELECTED = -:ID_DOC_SELECTED)) then
    begin
      /* transfer selected item */
      AVAIL_VALUE = null;
      select DA.AVAIL_VALUE, DA.DESCRIPTION
      from   DEPOSIT_AVAILABLE DA
      where  DA.ID_DEPOSIT = :ID_DEPOSIT
      into   :AVAIL_VALUE, :DESCRIPTION;

      if (:AVAIL_VALUE is not null) then begin
        execute procedure DEPOSIT_TRANSFER$ACC (:ID_DEPOSIT, :ID_DEST_ACCOUNT, :AVAIL_VALUE, :DESCRIPTION)
        returning_values  :DBG;
      end
    
      update DEPOSIT D
      set    D.DOC_SELECTED = null
      where  D.RDB$DB_KEY = :DBKEY;
    end else begin
      /* skipped account */
      SKIP_DOC_SELECTED = -:ID_DOC_SELECTED;
      update DEPOSIT D
      set    D.DOC_SELECTED = :SKIP_DOC_SELECTED
      where  D.RDB$DB_KEY = :DBKEY;
    end
  end 

end
^

/* Alter (ACCOUNT_SET_ARCHIVE_STATUS) */
ALTER PROCEDURE ACCOUNT_SET_ARCHIVE_STATUS(ID_ACCOUNT INTEGER,
IS_ARCHIVE SMALLINT)
 AS
declare variable post_sum numeric (15,2);
  declare variable dep_sum numeric (15,2);
  declare variable open_charges integer;
  declare variable old_is_archive integer;
  declare variable id_profile integer;
  declare variable id_hotel integer;
  declare variable p_dbkey char(8);
  declare variable acc_dbkey char(8);
  declare variable archived_date date;
  declare variable is_used integer;
  declare variable action_text varchar(255);
  declare variable account_name varchar(50);
  declare variable id_reserv_detail integer;
  declare variable id_sale_num integer;
begin

  select A.RDB$DB_KEY, A.IS_ARCHIVE, A.ID_PROFILE, A.ID_HOTEL, A.ACCOUNT_NAME,
         a.ID_RESERV_DETAIL, a.ID_SALE_NUM
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :acc_dbkey, :old_is_archive, :id_profile, :id_hotel, :account_name,
         :id_reserv_detail, :id_sale_num;
  /* --------------------------------------- */
  if (:old_is_archive = :IS_ARCHIVE) then exit;
  /* --------------------------------------- */
  if (:IS_ARCHIVE = 0) then begin
    -- unarchive
    update ACCOUNT A
    set    A.IS_ARCHIVE = 0
    where  A.RDB$DB_KEY = :acc_dbkey;

    p_dbkey = null;
    select P.RDB$DB_KEY
    from   PROFILE P
    where  P.ID_PROFILE = :id_profile
           and p.IS_ARCHIVE = 1
    into   :p_dbkey;

    if (:p_dbkey is not null) then begin
      /* restore profile active status */
      execute procedure PROFILE_SET_ARCHIVE$INT (:p_dbkey, 0);
    end

    if (:id_reserv_detail is not null and :id_sale_num is null) then begin
      if (exists (select rd.ID_RESERV_DETAIL
                  from   RESERV_DETAIL rd
                  where  rd.ID_RESERV_DETAIL = :id_reserv_detail
                         and rd.CHECK_STATUS = 0)) then
      begin
        execute procedure ACCOUNT_SALE_NUMBER_SET(:ID_ACCOUNT)
        returning_values (:id_sale_num);

        when any do begin end -- nothing
      end
    end
  end else begin
    execute procedure ACCOUNT_USE_CHECK$INT (:ID_ACCOUNT)
    returning_values (:is_used);

    if (:is_used = 1) then begin
      select AB.POST_VALUE, AB.DEP_VALUE, AB.OPEN_CHARGES
      from   ACCOUNT_BALANCE$INT(:id_account) AB
      into   :post_sum, :dep_sum, :open_charges;
  
      if ((:post_sum <> 0) or (:open_charges = 1)) then
        exception ACCOUNT_EXCEPTION '-44' || f_character(31) || :ID_ACCOUNT;

      if (:dep_sum <> 0) then
        exception ACCOUNT_EXCEPTION '-40' || f_character(31) || :ID_ACCOUNT;
    
      execute procedure SYSTEM_DATE_GET (:id_hotel)
      returning_values (:archived_date);
    end else begin
      archived_date = null;  /* mark account as unused */
    end

    update ACCOUNT A
    set    A.IS_ARCHIVE = 1,
           A.ARCHIVED_DATE = :archived_date
    where  A.RDB$DB_KEY = :acc_dbkey;

    action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'ARCHIVE_ACCOUNT', :action_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_CHECK_CREDIT_STATUS$INT for: ACCOUNT_SET_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_CHECK_CREDIT_STATUS$INT(ID_ACCOUNT /* TYPE OF ID_REF */ INTEGER,
POST_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_SET_CREDIT_STATUS$INT) */
ALTER PROCEDURE ACCOUNT_SET_CREDIT_STATUS$INT(ID_ACCOUNT TYPE OF ID,
IS_CREDIT_ACCOUNT TYPE OF TLOGICAL,
CREDIT_LIMIT TYPE OF TPRICE,
SET_UNCONDITIONAL TYPE OF TLOGICAL = 0)
 AS
declare variable account_name varchar(50);
  declare variable old_is_credit_account smallint;
  declare variable action_code varchar(50);
  declare variable action_text varchar(255);
  declare variable id_profile integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable a_dbkey char(8);
  declare variable old_credit_limit tprice;
begin

  select A.IS_CREDIT_ACCOUNT, a.CREDIT_LIMIT, A.ID_ACCOUNT, A.ACCOUNT_NAME,
         A.ID_PROFILE, A.ID_RESERV_DETAIL, a.RDB$DB_KEY
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :old_is_credit_account, :old_credit_limit, :id_account, :account_name,
         :id_profile, :id_reserv_detail, :a_dbkey;
  /* --------------------------------------- */
  if (:IS_CREDIT_ACCOUNT is not distinct from :old_is_credit_account
      and :CREDIT_LIMIT is not distinct from :old_credit_limit) then exit;
  /* --------------------------------------- */
  if (:is_credit_account > :old_is_credit_account and :set_unconditional = 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('ACC_SET_CREDIT');

  end else if (:is_credit_account < :old_is_credit_account and :id_reserv_detail is not null) then begin
    select RD.CHECK_STATUS
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :id_reserv_detail
    into   :check_status;

    if (:check_status = 1) then exception ACCOUNT_EXCEPTION '-1017';
  end

  update ACCOUNT A
  set    A.IS_CREDIT_ACCOUNT = :is_credit_account,
         A.CREDIT_LIMIT = :credit_limit
  where  A.RDB$DB_KEY = :a_dbkey;

  if (:old_is_credit_account <> :is_credit_account) then begin
    action_code = iif(:is_credit_account = 1, 'SET_CREDIT_ACCOUNT', 'RESET_CREDIT_ACCOUNT');
    action_text = f_character(29) || :id_account || '/' || :account_name;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, :action_code, :action_text);
  end
end
^

/* Alter (ACCOUNT_SET_CURRENCY$INT) */
ALTER PROCEDURE ACCOUNT_SET_CURRENCY$INT(A_DBKEY CHAR(8),
NEW_CURR CHAR(3))
 AS
declare variable id_account integer;
  declare variable old_acc_curr char(3);
  declare variable account_name varchar(50);
  declare variable id_profile integer;
  declare variable is_used integer;
  declare variable action_text varchar(255);
begin
  select A.ID_ACCOUNT, A.ACCOUNT_NAME, A.ACCOUNT_CURR, A.ID_PROFILE
  from   ACCOUNT A
  where  A.RDB$DB_KEY = :a_dbkey
  into   :id_account, :account_name, :old_acc_curr, :id_profile;

  if (:old_acc_curr <> :new_curr) then begin
    execute procedure ACCOUNT_USE_CHECK$INT (:id_account)
    returning_values  :is_used;
    if (:is_used = 1) then exception ACCOUNT_EXCEPTION '-41';
    action_text = f_character(29 ) || :id_account || '/' || :account_name
                  || f_character(28) || :old_acc_curr
                  || f_character(28) || :new_curr;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'EDIT_ACCOUNT_CURR', :action_text);

    update ACCOUNT A
    set    A.ACCOUNT_CURR = :new_curr
    where  A.RDB$DB_KEY = :a_dbkey;
  end

end
^

/* Alter (ACTIVITY_OFFER_CALC_PRICES) */
ALTER PROCEDURE ACTIVITY_OFFER_CALC_PRICES(ID_ACTIVITY_OFFER TYPE OF ID,
WITH_DISCOUNT TYPE OF TBOOLEAN = 1)
 RETURNS(OFFER_PRICE TYPE OF TPRICE,
OFFER_CURRENCY TYPE OF TCURRENCY)
 AS
begin
  for
    select cast(
           coalesce((select sum(coalesce(AE.EVENT_PRICE, 0)
                            + coalesce((select sum(AEE.QTY * AEE.EQUIPMENT_PRICE)
                                        from   ACTIVITY_EVENT_EQUIPMENT AEE
                                        where  AEE.ID_ACTIVITY_EVENT = AE.ID_ACTIVITY_EVENT), 0))
                     from   ACTIVITY_EVENT AE
                     where  AE.ID_ACTIVITY_OFFER = AO.ID_ACTIVITY_OFFER), 0)
           +
           coalesce((select sum(AM.QTY * AM.MENU_ITEM_PRICE)
                     from   ACTIVITY_FB AFB
                            join ACTIVITY_FB_MENU AM on AM.ID_ACTIVITY_FB = AFB.ID_ACTIVITY_FB
                     where  AFB.ID_ACTIVITY_OFFER = AO.ID_ACTIVITY_OFFER), 0)
           +
           coalesce((select sum(AA.ADDITION_PRICE)
                     from   ACTIVITY_ADDITION AA
                     where  AA.ID_ACTIVITY_OFFER = AO.ID_ACTIVITY_OFFER), 0)
           +
           coalesce((select sum(AD.DISCOUNT_PRICE)
                     from   ACTIVITY_DISCOUNT AD
                     where  AD.ID_ACTIVITY_OFFER = AO.ID_ACTIVITY_OFFER
                            and :WITH_DISCOUNT = 1), 0)
           +
           coalesce((select sum(Rp.ROOM_PRICE)
                     from   RESERV_DETAIL RD
                            left outer join RES_GET_PRICE$RPT (RD.ID_RESERV_DETAIL, 'SECURITY') rp on 1=1                   
                     where  RD.ID_GROUP = ao.ID_RESERV_GROUP
                            and rd.is_anul = 0
                            and rp.PRICE_CURRENCY = AO.OFFER_CURRENCY), 0)
           as numeric(15,4)) as offer_price,
           cast(AO.OFFER_CURRENCY as varchar(3)) as offer_currency
    from   ACTIVITY_OFFER AO
    where  AO.ID_ACTIVITY_OFFER = :ID_ACTIVITY_OFFER
    union
    select cast(sum(rp.ROOM_PRICE) as numeric(15,4)), cast(rp.PRICE_CURRENCY as varchar(3))
    from   ACTIVITY_OFFER AO2
           join RESERV_DETAIL RD on RD.ID_GROUP = ao2.ID_RESERV_GROUP and rd.is_anul = 0
           left outer join RES_GET_PRICE$RPT (RD.ID_RESERV_DETAIL, 'SECURITY') rp on 1=1           
    where  AO2.ID_ACTIVITY_OFFER = :ID_ACTIVITY_OFFER
           and not (rp.PRICE_CURRENCY = AO2.OFFER_CURRENCY)
    group by rp.PRICE_CURRENCY
    having sum(rp.ROOM_PRICE) > 0
    into  :OFFER_PRICE, :OFFER_CURRENCY
  do begin
    suspend;
  end
end
^

/* Alter (ACTIVITY_OFFER_COPY) */
ALTER PROCEDURE ACTIVITY_OFFER_COPY(ID_ACTIVITY_OFFER TYPE OF ID)
 RETURNS(NEW_ID_ACTIVITY_OFFER TYPE OF ID)
 AS
declare variable activity_date type of TDATE;
declare variable status type of TENUM_SMALL;
declare variable offer_currency type of TCURRENCY;
declare variable recipient type of TPERSON_NAME;
declare variable recipient_comment type of TDESCRIPTION_LONG;
declare variable person_name type of TPERSON_NAME;
declare variable phone_num type of TPHONE;
declare variable fax type of TPHONE;
declare variable e_mail type of TEMAIL;
declare variable accomodation_note type of TNOTE_BLOB;
declare variable events_note type of TNOTE_BLOB;
declare variable fb_note type of TNOTE_BLOB;
declare variable addition_note type of TNOTE_BLOB;
declare variable extra_note type of TNOTE_BLOB;
declare variable offer_header type of TNOTE_BLOB;
declare variable offer_footer type of TNOTE_BLOB;
declare variable discount_note type of TNOTE_BLOB;
declare variable id_reserv_group type of ID_REF;
declare variable id_hotel type of ID;
declare variable id_agent_profile type of ID_REF;
declare variable id_activity_event type of ID;
declare variable id_activity_fb type of ID;
declare variable no_use type of ID_REF;
declare variable ad_additional_date type of TDATE;
declare variable ad_from_time type of TTIME;
declare variable ad_to_time type of TTIME;
declare variable ad_description type of TOBJECT_TEXT;
declare variable ad_speciality type of TDESCRIPTION_LONG;
declare variable ad_addition_price type of TPRICE;
declare variable ad_note type of TDESCRIPTION_LONG;
declare variable act_description type of TDESCRIPTION_SHORT;
declare variable discount_price type of TPRICE;
declare variable user_attached TUSER_NAME;
begin
  select AO.ACTIVITY_DATE, AO.STATUS, AO.OFFER_CURRENCY, AO.RECIPIENT, AO.RECIPIENT_COMMENT, AO.PERSON_NAME,
         AO.PHONE_NUM, AO.FAX, AO.E_MAIL, AO.ACCOMODATION_NOTE, AO.EVENTS_NOTE, AO.FB_NOTE, AO.ADDITION_NOTE,
         AO.EXTRA_NOTE, AO.OFFER_HEADER, AO.OFFER_FOOTER, AO.DISCOUNT_NOTE, AO.ID_RESERV_GROUP,
         AO.ID_HOTEL, AO.ID_AGENT_PROFILE, USER_ATTACHED
  from   ACTIVITY_OFFER AO
  where  AO.ID_ACTIVITY_OFFER = :id_activity_offer
  into   :activity_date, :status, :offer_currency, :recipient, :recipient_comment, :person_name,
         :phone_num, :fax, :e_mail, :accomodation_note, :events_note, :fb_note, :addition_note,
         :extra_note, :offer_header, :offer_footer, :discount_note, :id_reserv_group,
         :id_hotel, :id_agent_profile, :user_attached;

  execute procedure ACTIVITY_OFFER_MODIFY$RESERV(null, :activity_date, :status, :offer_currency, :recipient, :recipient_comment,
          :person_name, :phone_num, :fax, :e_mail, events_note, :fb_note, :addition_note, :accomodation_note, :offer_header, :offer_footer,
          :extra_note, :discount_note, :id_reserv_group, :id_hotel, :id_agent_profile, :user_attached, 'add')
  returning_values :new_id_activity_offer;

  for
    select AE.ID_ACTIVITY_EVENT
    from   ACTIVITY_EVENT AE
    where  AE.ID_ACTIVITY_OFFER = :id_activity_offer
    into   :id_activity_event
  do begin
    execute procedure ACTIVITY_EVENT_COPY(:id_activity_event, :new_id_activity_offer)
    returning_values  :no_use;
  end

  for
    select AF.ID_ACTIVITY_FB
    from   ACTIVITY_FB AF
    where  AF.ID_ACTIVITY_OFFER = :id_activity_offer
    into   :id_activity_fb
  do begin
    execute procedure ACTIVITY_FB_COPY(:id_activity_fb, :new_id_activity_offer)
    returning_values  :no_use;
  end

  for
    select AD.ADDITION_DATE, AD.FROM_TIME, AD.TO_TIME, AD.DESCRIPTION, AD.SPECIALITY, AD.ADDITION_PRICE,
           AD.NOTE
    from   ACTIVITY_ADDITION AD
    where  AD.ID_ACTIVITY_OFFER = :id_activity_offer
    into   :ad_additional_date, :ad_from_time, :ad_to_time, :ad_description, :ad_speciality, :ad_addition_price,
           :ad_note
  do begin
    execute procedure ACTIVITY_ADDITION_MODIFY$RESERV(null, :new_id_activity_offer, :ad_additional_date, :ad_from_time,
            :ad_to_time, :ad_description, :ad_speciality, :ad_addition_price, :ad_note, 'add')
    returning_values :no_use;
  end

  for
    select ACT.DESCRIPTION, ACT.DISCOUNT_PRICE
    from   ACTIVITY_DISCOUNT ACT
    where  ACT.ID_ACTIVITY_OFFER = :id_activity_offer
    into   :act_description, :discount_price
  do begin
    execute procedure ACTIVITY_DISCOUNT_MODIFY$RESERV(null, :new_id_activity_offer, :act_description, :discount_price, 'add')
    returning_values  :no_use;
  end

  execute procedure SYSTEM_LOG_ADD ('ACTIVITY_OFFER', :id_activity_offer, 'ACTIVITY_OFFER_COPY', f_character(29) || :new_id_activity_offer);
end
^

/* empty dependent procedure body */
/* Clear: SPR_OCC_KONT_AGENT_ROOMTYPE_DAY for: ALLOTMENT_AGENT_GET */
ALTER PROCEDURE SPR_OCC_KONT_AGENT_ROOMTYPE_DAY(FOR_DATE DATE,
ID_AGENT INTEGER,
ID_ROOM_TYPE INTEGER,
KIND SMALLINT,
AGE_KIND SMALLINT,
ALL_KINDS SMALLINT)
 RETURNS(KONTINGENT INTEGER,
DATA INTEGER,
OUT_KIND VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* Alter (ALLOTMENT_AGENT_GET) */
ALTER PROCEDURE ALLOTMENT_AGENT_GET(FROM_DATE DATE,
TO_DATE DATE,
IN_ID_ROOM_TYPE INTEGER,
IN_ID_AGENT INTEGER,
INFO_TYPE VARCHAR(40),
MIND_RELEASE_DATES SMALLINT)
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ROOM_TYPE VARCHAR(50),
CNT_ROOMS INTEGER,
IS_DEFINED INTEGER,
IS_RELEASED INTEGER)
 AS
declare variable id_allotment integer;
  declare variable allotment_options varchar(255);
  declare variable cnt_booked integer;
  declare variable cnt_defined integer;
begin
  /*  Description:
  || INFO_TYPE = 'CONTINGENT_DEFINE', 'CONTINGENT_BOOKED', 'BOOKING_DEFINE', 'BOOKING_BOOKED',
  ||              +EDIT, NONBOOKED
  */
  allotment_options = '';
  id_allotment = null;
  select iif(:info_type starting with 'CONTINGENT', PA.ID_CONTINGENT, PA.ID_BOOKING_POSITION)
  from   PROFILE_AGENT PA
  where  PA.ID_AGENT = :in_id_agent
  into   :id_allotment;

  if (:mind_release_dates = 1) then allotment_options = :allotment_options||',RELEASES';
  if (:info_type like '%BOOKED%') then allotment_options = :allotment_options||',BOOKED';
  if (:info_type like '%EDIT') then allotment_options = :allotment_options||',CONTINGENT_PERIOD,EDIT';
  else if (:info_type like '%RPT') then allotment_options = :allotment_options||',PLAIN_PERIOD';

  for
    select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ROOM_TYPE,
           sum(ACG.CNT_DEFINED), sum(ACG.CNT_BOOKED), sum(ACG.IS_DEFINED), min(ACG.IS_RELEASED)
    from   ALLOTMENT_GET$INT(:id_allotment, :from_date, :to_date, :in_id_room_type, :allotment_options) ACG
    group by 1, 2, 3
    into   :for_date, :id_room_type, :room_type,
           :cnt_defined, :cnt_booked, :is_defined, :is_released
  do begin
    if (:info_type like '%BOOKED%') then begin
      if (:info_type like '%NONBOOKED%') then cnt_rooms = (:cnt_defined - :cnt_booked);
      else cnt_rooms = :cnt_booked;
    end else cnt_rooms = :cnt_defined;                  
    suspend;
  end
end
^

/* Alter (ALLOTMENT_GET) */
ALTER PROCEDURE ALLOTMENT_GET(ID_ALLOTMENT INTEGER,
ID_HOTEL INTEGER)
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ROOM_TYPE VARCHAR(30),
CNT_DEFINED INTEGER,
CNT_BOOKED INTEGER,
ACTIVE_FRAME_BEGIN INTEGER,
IS_DEFINED INTEGER,
IS_RELEASED INTEGER)
 AS
begin
  for
    select a.FOR_DATE, a.ID_ROOM_TYPE, a.ROOM_TYPE, a.CNT_DEFINED, a.CNT_BOOKED,
           a.ACTIVE_FRAME_BEGIN, a.IS_DEFINED, a.IS_RELEASED
    from   ALLOTMENT_GET$INT(:ID_ALLOTMENT, '01.01.2001', '31.12.2099', null, '', :id_hotel) a
    into   :FOR_DATE, :ID_ROOM_TYPE, :ROOM_TYPE, :CNT_DEFINED, :CNT_BOOKED,
           :ACTIVE_FRAME_BEGIN, :IS_DEFINED, :IS_RELEASED
  do suspend;
end
^

/* empty dependent procedure body */
/* Clear: CANCEL_BOOKING$EXC for: APPLY_BOOKING_STATUS$EXC */
ALTER PROCEDURE CANCEL_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20),
STATUS VARCHAR(20))
 RETURNS(BOOKING_ID INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_BOOKING_FINALIZE$EXC for: APPLY_BOOKING_STATUS$EXC */
ALTER PROCEDURE IMPORT_BOOKING_FINALIZE$EXC(BOOKING_ID INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1,
STATUS VARCHAR(50) = null,
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20) = null,
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20) = null)
 RETURNS(RECORD_TIMESTAMP TIMESTAMP,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (APPLY_BOOKING_STATUS$EXC) */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20)
 AS
declare variable err_text varchar(255);
declare variable dummy_int integer;
declare variable anul_reason varchar(30);
declare variable selection_id integer;

declare variable status_code smallint;
declare variable current_anul_code smallint;
declare variable current_status_code smallint;
declare variable current_status_text varchar(50);
declare variable new_status_text varchar(50);
declare variable extra_posts_left integer;
declare variable check_out_kind smallint;
declare variable earlycheckout_date date;
begin
  if (:booking_db_key is null) then begin
    select rd.RDB$DB_KEY, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.ID_RESERV_DETAIL = :BOOKING_ID
    into   :booking_db_key, :current_status_code, :current_anul_code;
  end else begin
    select rd.id_reserv_detail, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.rdb$db_key = :booking_db_key
    into   :booking_id, :current_status_code, :current_anul_code;
  end

  execute procedure IMPORT_BOOKING_STATUS$EXC(:status, -2)
  returning_values :status_code;

  execute procedure EXPORT_BOOKING_STATUS$EXC(:current_status_code, :current_anul_code)
  returning_values :current_status_text;
  execute procedure IMPORT_BOOKING_STATUS$EXC(:current_status_text, :current_status_code)
  returning_values :current_status_code;

  /* nop - exit */
  if (:current_status_code = :status_code) then exit;

  /* validate status transition */
  if (
     /* terminal status values - void booking */
    (:current_status_code in (1004/*no show*/, 1005/*canceled*/))

    /* void over checkin */
    or ((:current_status_code >= 0) and (:status_code in (1004/*no show*/, 1005/*canceled*/)))

    /* positive status downgrade */
    or ((:current_status_code > 0) and (:current_status_code > :status_code))
  )  then begin
    execute procedure PRINT_BOOKING_STATUS$EXC(:current_status_code) returning_values :current_status_text;
    execute procedure PRINT_BOOKING_STATUS$EXC(:status_code) returning_values :new_status_text;

    exception VALIDATE_EXCEPTION '-1022' || f_character(31) || '@{invalid_status_transition} ' || :current_status_text || ' -> ' || :new_status_text;
  end

  anul_reason = null;
  if (1004 = :status_code) then begin
    anul_reason = 'NOSHOW';
  end else if (1005 = :status_code) then begin
    anul_reason = 'CANCELED';
  end

  if (:anul_reason is null) then begin
    if (0 > :status_code) then begin
      execute procedure RES_SAVE_STATUS$INT(:booking_db_key, :status_code, :CONFIRMATION_NUMBER);
    end else begin
      if (:status_code in (0, 1) and 0 > :current_status_code) then begin
        -- checkin
        execute procedure RES_SET_CHECKIN$INT (:booking_db_key)
        returning_values (:dummy_int, :err_text, :dummy_int, :dummy_int);
      end
      if (1 = :status_code and 1 > :current_status_code) then begin
        -- checkout
        selection_id = gen_id(SELECTION_GEN, 1);
        update RESERV_DETAIL
        set    selection_id=:selection_id
        where  rdb$db_key=:booking_db_key
        returning new.CHECK_OUT_KIND, new.EARLYCHECKOUT_DATE
        into   :check_out_kind, :earlycheckout_date;
    
        execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, :check_out_kind, :earlycheckout_date);
      end
    end
  end else begin
    -- void
    execute procedure RES_ANUL_DETAIL$INT(:booking_db_key, :anul_reason, :CANCELATION_NUMBER)
    returning_values  :dummy_int, :extra_posts_left;
    if (:extra_posts_left = 1) then exception BOOKING_EXCEPTION '-1042';

  end
end
^

/* empty dependent procedure body */
/* Clear: AR_OWING_ADD$AR for: AR_OWING_ADD$INT */
ALTER PROCEDURE AR_OWING_ADD$AR(ID_PROFILE /* TYPE OF ID */ INTEGER,
SUM_OWING /* TYPE OF TPRICE */ NUMERIC(15,4),
CURR_OWING /* TYPE OF TCURRENCY */ CHAR(3),
DUE_DATE /* TYPE OF TDATE */ DATE,
SYSTEM_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_AR_TYPE /* TYPE OF ID */ INTEGER,
ID_HOTEL /* TYPE OF ID */ INTEGER)
 RETURNS(NEW_ID_AR_OWING /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: AR_OWING_MODIFY$DOC for: AR_OWING_ADD$INT */
ALTER PROCEDURE AR_OWING_MODIFY$DOC(ID_DOC /* TYPE OF ID */ INTEGER,
ID_PROFILE /* TYPE OF ID */ INTEGER,
OWING_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
OWING_CURR /* TYPE OF TCURRENCY */ CHAR(3),
DUE_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_HOTEL /* TYPE OF ID */ INTEGER,
OPERATION VARCHAR(10))
 AS
 BEGIN EXIT; END
^

/* Alter (AR_OWING_ADD$INT) */
ALTER PROCEDURE AR_OWING_ADD$INT(ID_PROFILE TYPE OF ID,
SUM_OWING TYPE OF TPRICE,
CURR_OWING TYPE OF TCURRENCY,
ID_DOC_HEAD TYPE OF ID_REF,
DUE_DATE TYPE OF TDATE,
SYSTEM_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
ID_AR_TYPE TYPE OF ID,
ID_HOTEL TYPE OF ID)
 RETURNS(NEW_ID_AR_OWING TYPE OF ID)
 AS
declare variable round_to numeric(15,4);
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
begin

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :CURR_OWING
  into   :round_to;

  select P.PROFILE_NAME
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :profile_name;

  new_id_ar_owing = gen_id(GEN_AR_OWING_ID, 1);
  sum_owing = ROUND_F(:sum_owing, :round_to);

  insert into AR_OWING (ID_AR_OWING, ID_PROFILE, SUM_OWING, CURR_OWING,
         USER_CREATED, DATETIME_CREATED, ID_DOC, SYSTEM_DATE,
         ID_AR_OWING_BASE, DESCRIPTION, DUE_DATE, ID_AR_TYPE, ID_HOTEL,
         REST_OWING, OWING_STATUS)
  values (:new_id_ar_owing, :ID_PROFILE, :SUM_OWING, :CURR_OWING,
         user, current_timestamp, :ID_DOC_HEAD, :system_date,
         null, :description, STRIPTIME(:due_date), :ID_AR_TYPE, :ID_HOTEL,
         :SUM_OWING, 11);

  action_text = substring(f_character(29) || :profile_name
                          || f_character(28) || formatfloat(:SUM_OWING, 'F;0.00') || ' ' || :CURR_OWING
                          || f_character(28) || :description from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'OWING_CREATE', :action_text);

end
^

/* empty dependent procedure body */
/* Clear: AR_OWING_ANUL$AR for: AR_OWING_ANUL$INT */
ALTER PROCEDURE AR_OWING_ANUL$AR(ID_AR_OWING /* TYPE OF ID */ INTEGER,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255))
 RETURNS(NEW_ID_AR_OWING /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (AR_OWING_ANUL$INT) */
ALTER PROCEDURE AR_OWING_ANUL$INT(ID_AR_OWING TYPE OF ID,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_MANUAL_ANUL TYPE OF TLOGICAL = 1)
 RETURNS(NEW_ID_AR_OWING TYPE OF ID)
 AS
declare variable system_date type of TDATE;
  declare variable curr_id integer;
  declare variable owing_status smallint;
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable id_doc_head integer;
  declare variable sum_owing numeric(15,4) ;
  declare variable curr_owing char(3);
  declare variable id_profile integer;
begin

    select O.OWING_STATUS, O.ID_DOC, SDG.SYSTEM_DATE, o.SUM_OWING, o.CURR_OWING, o.ID_PROFILE
    from   AR_OWING O
           left outer join SYSTEM_DATE_GET(O.ID_HOTEL) SDG on 1=1
    where  O.ID_AR_OWING = :ID_AR_OWING
    into   :owing_status, :id_doc_head, :system_date, :sum_owing, :curr_owing, :id_profile;

    if (:OWING_STATUS = 22) then
      exception ACCOUNT_RECEIVABLE_EXCEPTION '-606' ;
    if (:IS_MANUAL_ANUL = 1 and :id_doc_head is not null) then
      exception ACCOUNT_RECEIVABLE_EXCEPTION '-609' ;

    update AR_OWING A  -- lock for update
    set    A.ID_AR_OWING = A.ID_AR_OWING,
           A.OWING_STATUS = 22,
           A.REST_OWING = :sum_owing
    where  A.ID_AR_OWING = :ID_AR_OWING;

    new_id_ar_owing = gen_id(GEN_AR_OWING_ID, 1);

    insert into AR_OWING (ID_AR_OWING, ID_PROFILE, SUM_OWING, CURR_OWING,
           USER_CREATED, DATETIME_CREATED, ID_DOC, SYSTEM_DATE,
           ID_AR_OWING_BASE, DESCRIPTION, DUE_DATE, ID_AR_TYPE, ID_HOTEL,
           REST_OWING, OWING_STATUS)
    select :new_id_ar_owing, A.ID_PROFILE, -A.SUM_OWING, A.CURR_OWING,
           user, current_timestamp, A.ID_DOC, :system_date,
           :ID_AR_OWING, :description, A.DUE_DATE, A.ID_AR_TYPE, a.ID_HOTEL,
           -A.SUM_OWING, 22
    from   AR_OWING A
    where  A.ID_AR_OWING = :ID_AR_OWING;

    for
      select A.ID_AR_OWING_PAYMENT_POST
      from   AR_OWING_PAYMENT_POST A
      where  A.ID_AR_OWING = :ID_AR_OWING
             and A.IS_ANUL = 0
      into   :curr_id
    do begin
      execute procedure AR_OWING_PAYMENT_ANUL$AR(:curr_id, :DESCRIPTION);
    end
    -- transaction finalize
    execute procedure AR_POST_FINALIZE(iif(:IS_MANUAL_ANUL = 1, 'anul_owing', 'anul_link'));

    select P.PROFILE_NAME
    from   PROFILE P
    where  P.ID_PROFILE = :id_profile
    into   :profile_name;

    action_text = substring(f_character(29) || :profile_name
                            || f_character(28) || formatfloat(:sum_owing, 'F;0.00') || ' ' || :CURR_OWING
                            || f_character(28) || :description from 1 for 255);
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :id_profile, 'OWING_ANNUL', :action_text);

end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_AR_PAYMENTS_APPLY$INT for: AR_OWING_MODIFY$DOC */
ALTER PROCEDURE DOCUMENT_AR_PAYMENTS_APPLY$INT(DOC_DBKEY CHAR(8),
OPERATION_INFO VARCHAR(100) = null)
 AS
 BEGIN EXIT; END
^

/* Alter (AR_OWING_MODIFY$DOC) */
ALTER PROCEDURE AR_OWING_MODIFY$DOC(ID_DOC TYPE OF ID,
ID_PROFILE TYPE OF ID,
OWING_VALUE TYPE OF TPRICE,
OWING_CURR TYPE OF TCURRENCY,
DUE_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
ID_HOTEL TYPE OF ID,
OPERATION VARCHAR(10))
 AS
declare variable id_ar_owing integer;
  declare variable owing_type integer;
  declare variable system_date date;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add_owing, add_credit, anul');

  execute procedure SYSTEM_DATE_GET(:ID_HOTEL)
  returning_values  (:system_date);

  if (:operation in ('add_owing', 'add_credit')) then begin
    if (:OPERATION = 'add_owing') then begin
      select T.ID_AR_TYPE
      from   AR_TYPE T
      where  T.TYPE_CODE = 'RECEIVABLE'
      into   :owing_type;
    end else if (:OPERATION = 'add_credit') then begin
      select T.ID_AR_TYPE
      from   AR_TYPE T
      where  T.TYPE_CODE = 'CREDIT'
      into   :owing_type;
      OWING_VALUE = -abs(:OWING_VALUE);
    end
    id_ar_owing = null;
    execute procedure AR_OWING_ADD$INT (:ID_PROFILE, :OWING_VALUE, :OWING_CURR,
          :ID_DOC, :DUE_DATE, :SYSTEM_DATE, :DESCRIPTION, :owing_type, :ID_HOTEL)
    returning_values (:id_ar_owing);

  end else if (:operation = 'anul') then begin
    select first 1 A.ID_AR_OWING
    from   AR_OWING A
    where  A.ID_DOC = :ID_DOC
           and a.SUM_OWING = :OWING_VALUE
           and a.OWING_STATUS <> 22
    order by a.ID_AR_OWING desc    -- !!! Very important order  !!!
    into  :ID_AR_OWING;

    if (:ID_AR_OWING is null) then exit;

    execute procedure AR_OWING_ANUL$INT (:id_ar_owing, :DESCRIPTION, 0)
    returning_values (:id_ar_owing);
  end
end
^

/* Alter (AR_OWING_PAYMENT_ADD$AR) */
ALTER PROCEDURE AR_OWING_PAYMENT_ADD$AR(ID_AR_OWING INTEGER,
ID_AR_PAYMENT INTEGER,
SUM_OWING NUMERIC(15,4),
SUM_PAYMENT NUMERIC(15,4),
PAYMENT_RATE_TO_BGN NUMERIC(15,6),
OWING_RATE_TO_BGN NUMERIC(15,6),
DESCRIPTION VARCHAR(255))
 RETURNS(NEW_ID_AR_OWING_PAYMENT_POST INTEGER)
 AS
declare variable curr_payment varchar(3);
  declare variable curr_owing varchar(3);
  declare variable owing_status smallint;
  declare variable payment_status smallint;
  declare variable system_date date;
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable payment_type varchar(20);
  declare variable id_profile integer;
  declare variable id_hotel integer;
  declare variable payment_round_to numeric(15,4);
  declare variable owing_round_to numeric(15,4);
begin
  select A.CURR_PAYMENT, A.PAYMENT_STATUS, pt.PAYMENT_TYPE, c.ROUND_TO
  from   AR_PAYMENT A
         join AR_PAYMENT_TYPE PT on PT.ID_AR_PAYMENT_TYPE = a.ID_AR_PAYMENT_TYPE
         join CURRS c on c.CURR = a.CURR_PAYMENT
  where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT
  into   :curr_payment, :PAYMENT_STATUS, :payment_type, :payment_round_to;

  select A.CURR_OWING, A.OWING_STATUS, P.PROFILE_NAME, p.ID_PROFILE, a.ID_HOTEL, c.ROUND_TO
  from   AR_OWING A
         join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
         join CURRS c on c.CURR = a.CURR_OWING
  where  A.ID_AR_OWING = :id_ar_owing
  into   :curr_owing, :owing_status, :profile_name, :id_profile, :id_hotel, :owing_round_to;

  if ( (:OWING_STATUS = 22) or (:PAYMENT_STATUS = 22) ) then
    exception ACCOUNT_RECEIVABLE_EXCEPTION '-604';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  (:system_date);

  /* lock records for update */
  select P.ID_AR_PAYMENT
  from   AR_PAYMENT P
  where  P.ID_AR_PAYMENT = :ID_AR_PAYMENT
  with lock  -- lock for update
  into   :ID_AR_PAYMENT;

  select O.ID_AR_OWING
  from   AR_OWING O
  where  O.ID_AR_OWING = :ID_AR_OWING
  with lock  -- lock for update
  into   :ID_AR_OWING;

  if (:SUM_OWING = 0.00) then exception ACCOUNT_RECEIVABLE_EXCEPTION '-602';

  SUM_OWING = round_f(:SUM_OWING, :owing_round_to);
  SUM_PAYMENT = round_f(:SUM_PAYMENT, :payment_round_to);

  insert into AR_OWING_PAYMENT_POST(ID_AR_OWING, ID_AR_PAYMENT, ID_PROFILE,
         SUM_OWING, CURR_OWING, SUM_PAYMENT, CURR_PAYMENT, IS_ANUL,
         PAYMENT_RATE_TO_BGN, OWING_RATE_TO_BGN, ID_TRANSACTION, SYSTEM_DATE,
         ID_AR_OWING_PAYMENT_BASE, DESCRIPTION, USER_CREATED, DATETIME_CREATED)
  values (:ID_AR_OWING, :ID_AR_PAYMENT, :id_profile,
         :SUM_OWING, :curr_owing, :SUM_PAYMENT, :curr_payment, 0,
         :payment_rate_to_bgn, :owing_rate_to_bgn, current_transaction, :system_date,
         null, :DESCRIPTION, user, current_timestamp)
  returning ID_AR_OWING_PAYMENT_POST
  into   :new_id_ar_owing_payment_post;

  action_text = substring(f_character(29) || :profile_name
                          || f_character(28) || formatfloat(:SUM_OWING, 'F;0.00') || ' ' || :CURR_OWING
                          || f_character(28) || :payment_type
                          || f_character(28) || formatfloat(:SUM_PAYMENT, 'F;0.00') || ' ' || :CURR_PAYMENT
                          || f_character(28) || :description
                          from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'OWING_PAY', :action_text);

end
^

/* Alter (AR_OWING_PAYMENT_ANUL$AR) */
ALTER PROCEDURE AR_OWING_PAYMENT_ANUL$AR(ID_AR_OWING_PAYMENT_POST INTEGER,
DESCRIPTION VARCHAR(255))
 AS
declare variable curr_payment varchar(3);
  declare variable curr_owing varchar(3);
  declare variable is_anul smallint;
  declare variable system_date date;
  declare variable type_code varchar(10);
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable payment_type varchar(20);
  declare variable id_profile integer;
  declare variable id_hotel integer;
  declare variable sum_owing numeric(15,4);
  declare variable sum_payment numeric(15,4);
  declare variable id_ar_owing integer;
  declare variable id_ar_payment integer;
  declare variable payment_rate_to_bgn numeric(15,6);
  declare variable owing_rate_to_bgn numeric(15,6);
begin
  if (:ID_AR_OWING_PAYMENT_POST is null) then
    exception ACCOUNT_RECEIVABLE_EXCEPTION '-85' || f_character(31) || 'ID_AR_OWING_PAYMENT_POST is null';

  /* lock record for update */
  select p.ID_AR_OWING, p.ID_AR_PAYMENT, p.IS_ANUL
  from   AR_OWING_PAYMENT_POST P
  where  P.ID_AR_OWING_PAYMENT_POST = :id_ar_owing_payment_post
  with lock  -- lock for update
  into   :id_ar_owing, :id_ar_payment, :is_anul;

  if (:is_anul = 1) then exception ACCOUNT_RECEIVABLE_EXCEPTION '-605';

  select A.CURR_PAYMENT, pt.PAYMENT_TYPE
  from   AR_PAYMENT A
         join AR_PAYMENT_TYPE PT on PT.ID_AR_PAYMENT_TYPE = a.ID_AR_PAYMENT_TYPE
  where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT
  into   :curr_payment, :payment_type;

  select A.CURR_OWING, P.PROFILE_NAME, p.ID_PROFILE, t.TYPE_CODE, A.ID_HOTEL
  from   AR_OWING A
         join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
         join AR_TYPE T on a.ID_AR_TYPE = T.ID_AR_TYPE
  where  A.ID_AR_OWING = :id_ar_owing
  into   :curr_owing, :profile_name, :id_profile, :type_code, :id_hotel;

  if (:type_code = 'DEPOSIT') then
    exception ACCOUNT_RECEIVABLE_EXCEPTION 'Operation (type_code=DEPOSIT) is not supported!';

  /* lock records for update */
  select P.ID_AR_PAYMENT
  from   AR_PAYMENT P
  where  P.ID_AR_PAYMENT = :ID_AR_PAYMENT
  with lock  -- lock for update
  into   :ID_AR_PAYMENT;

  select O.ID_AR_OWING
  from   AR_OWING O
  where  O.ID_AR_OWING = :ID_AR_OWING
  with lock  -- lock for update
  into   :ID_AR_OWING;

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  (:system_date);

  update AR_OWING_PAYMENT_POST A
  set    A.IS_ANUL = 1
  where  A.ID_AR_OWING_PAYMENT_POST = :ID_AR_OWING_PAYMENT_POST;

  select -P.SUM_OWING, -P.SUM_PAYMENT, P.ID_AR_OWING, P.ID_AR_PAYMENT, p.ID_PROFILE,
         P.PAYMENT_RATE_TO_BGN, P.OWING_RATE_TO_BGN, P.CURR_OWING, P.CURR_PAYMENT
  from   AR_OWING_PAYMENT_POST P
  where  P.ID_AR_OWING_PAYMENT_POST = :ID_AR_OWING_PAYMENT_POST
  into   :SUM_OWING, :SUM_PAYMENT, :ID_AR_OWING, :ID_AR_PAYMENT, :id_profile,
         :PAYMENT_RATE_TO_BGN, :OWING_RATE_TO_BGN, :CURR_OWING, :CURR_PAYMENT;

  insert into AR_OWING_PAYMENT_POST(ID_AR_OWING, ID_AR_PAYMENT, ID_PROFILE,
         SUM_OWING, CURR_OWING, SUM_PAYMENT, CURR_PAYMENT, IS_ANUL,
         PAYMENT_RATE_TO_BGN, OWING_RATE_TO_BGN, ID_TRANSACTION, SYSTEM_DATE,
         ID_AR_OWING_PAYMENT_BASE, DESCRIPTION, USER_CREATED, DATETIME_CREATED)
  values (:id_ar_owing, :id_ar_payment, :id_profile,
         :sum_owing, :curr_owing, :sum_payment, :curr_payment, 1,
         :payment_rate_to_bgn, :owing_rate_to_bgn, current_transaction, :system_date,
         :id_ar_owing_payment_post, :DESCRIPTION, user, current_timestamp);

  action_text = substring(f_character(29) || :profile_name
                          || f_character(28) || formatfloat(:sum_owing, 'F;0.00') || ' ' || :curr_owing
                          || f_character(28) || :payment_type
                          || f_character(28) || formatfloat(:sum_payment, 'F;0.00') || ' ' || :curr_payment
                          || f_character(28) || :DESCRIPTION
                          from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'OWING_PAY_ANNUL', :action_text);

end
^

/* Alter (AR_PAYMENT_ADD$AR) */
ALTER PROCEDURE AR_PAYMENT_ADD$AR(ID_PROFILE TYPE OF ID,
ID_AR_PAYMENT_TYPE TYPE OF ID_REF,
ACCOUNT_NAME TYPE OF TNAME_SHORT,
SUM_PAYMENT TYPE OF TPRICE,
CURR_PAYMENT TYPE OF TCURRENCY,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
DATE_PAYMENT TYPE OF TDATE)
 RETURNS(NEW_ID_AR_PAYMENT INTEGER)
 AS
declare variable payment_status smallint;
  declare variable round_to numeric(15,6);
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable payment_type varchar(20);
begin
  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :CURR_PAYMENT
  into   :round_to;

  select p.PROFILE_NAME
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :profile_name;

  select P.PAYMENT_TYPE
  from   AR_PAYMENT_TYPE P
  where  P.ID_AR_PAYMENT_TYPE = :ID_AR_PAYMENT_TYPE
  into   :payment_type;

  payment_status = 11;
  SUM_PAYMENT = round_f(:SUM_PAYMENT, :round_to);

  new_id_ar_payment = gen_id(GEN_AR_PAYMENT_ID, 1);
  insert into AR_PAYMENT(ID_AR_PAYMENT, ID_PROFILE, SUM_PAYMENT, CURR_PAYMENT,
         USER_CREATED, DATETIME_CREATED, DESCRIPTION,
         ID_AR_PAYMENT_BASE, ID_AR_PAYMENT_TYPE, ACCOUNT_NAME,
         DATE_PAYMENT, REST_PAYMENT, PAYMENT_STATUS)
  values (:new_id_ar_payment, :ID_PROFILE, :SUM_PAYMENT, :CURR_PAYMENT,
         user, current_timestamp, :DESCRIPTION,
         null, :ID_AR_PAYMENT_TYPE, :ACCOUNT_NAME,
         :DATE_PAYMENT, :SUM_PAYMENT, :PAYMENT_STATUS);

  action_text = substring(f_character(29) || :payment_type
                          || f_character(28) || :profile_name
                          || f_character(28) || formatfloat(:SUM_PAYMENT, 'F;0.00') || ' ' || :CURR_PAYMENT from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'PAYMENT_CREATE', :action_text);

end
^

/* Alter (AR_PAYMENT_ANUL$AR) */
ALTER PROCEDURE AR_PAYMENT_ANUL$AR(ID_AR_PAYMENT INTEGER,
DESCRIPTION VARCHAR(255))
 RETURNS(NEW_ID_AR_PAYMENT INTEGER)
 AS
declare variable curr_id integer;
  declare variable payment_status smallint;
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable payment_type varchar(20);
  declare variable curr_payment char(3);
  declare variable id_profile integer;
  declare variable id_payment_type integer;
  declare variable sum_payment numeric(15,4);
begin
  if (:ID_AR_PAYMENT is null) then exit;

  select p.CURR_PAYMENT, p.ID_PROFILE, p.ID_AR_PAYMENT_TYPE, p.SUM_PAYMENT, p.PAYMENT_STATUS
  from   AR_PAYMENT P
  where  P.ID_AR_PAYMENT = :ID_AR_PAYMENT
  into   :CURR_PAYMENT, :id_profile, :id_payment_type, :sum_payment, :payment_status;

  if (:payment_status = 22) then exception ACCOUNT_RECEIVABLE_EXCEPTION '-606';

  payment_status = 22;

  update AR_PAYMENT A
  set    A.PAYMENT_STATUS = :payment_status
  where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT;

  new_id_ar_payment = gen_id(GEN_AR_PAYMENT_ID, 1);

  insert into AR_PAYMENT(ID_AR_PAYMENT, ID_PROFILE, SUM_PAYMENT, CURR_PAYMENT,
         USER_CREATED, DATETIME_CREATED, DESCRIPTION,
         ID_AR_PAYMENT_BASE, ID_AR_PAYMENT_TYPE, ACCOUNT_NAME,
         DATE_PAYMENT, REST_PAYMENT, PAYMENT_STATUS)
  select :new_id_ar_payment, A.ID_PROFILE, -A.SUM_PAYMENT, A.CURR_PAYMENT,
         user, current_timestamp, :DESCRIPTION,
         :ID_AR_PAYMENT, A.ID_AR_PAYMENT_TYPE, A.ACCOUNT_NAME,
         A.DATE_PAYMENT, -A.SUM_PAYMENT, :payment_status
  from   AR_PAYMENT A
  where  A.ID_AR_PAYMENT = :id_ar_payment;

  -- storno links
  for
    select A.ID_AR_OWING_PAYMENT_POST
    from   AR_OWING_PAYMENT_POST A
    where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT
           and A.IS_ANUL = 0
    into   :curr_id
  do begin
    execute procedure AR_OWING_PAYMENT_ANUL$AR(:curr_id, :DESCRIPTION);
  end
  -- transaction finalize
  execute procedure AR_POST_FINALIZE('anul_pay');

  select p.PROFILE_NAME
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :profile_name;

  select P.PAYMENT_TYPE
  from   AR_PAYMENT_TYPE P
  where  P.ID_AR_PAYMENT_TYPE = :id_payment_type
  into   :payment_type;

  action_text = substring(f_character(29) || :payment_type
                          || f_character(28) || :profile_name
                          || f_character(28) || formatfloat(:SUM_PAYMENT, 'F;0.00') || ' ' || :CURR_PAYMENT from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'PAYMENT_ANNUL', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUP_PREPARE$AVL for: AVAILABILITY_OCCUPANCY$AVL */
ALTER PROCEDURE AVAILABILITY_OCCUP_PREPARE$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS INTEGER,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
 BEGIN EXIT; END
^

/* Alter (AVAILABILITY_OCCUPANCY$AVL) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
begin

  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, :FETCH_TOTALS, 1, 1, 1, 1, 1, 1, :HOTELS);

  ID_OCCUPANCY_SESSION = current_transaction;
end
^

/* empty dependent procedure body */
/* Clear: TEST_RATING for: AVAILABILITY_RATING$AVL */
ALTER PROCEDURE TEST_RATING RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (AVAILABILITY_RATING$AVL) */
ALTER PROCEDURE AVAILABILITY_RATING$AVL(ID_AGENT_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ROOMS_COUNT INTEGER,
ADULTS_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ROOMTYPE_LIST VARCHAR(2000),
RATE_LIST VARCHAR(2000),
BOARD_LIST VARCHAR(2000),
HOTELS VARCHAR(255) = '')
 RETURNS(ID_SESSION INTEGER)
 AS
declare variable id_room_type integer;
  declare variable total_rooms integer;
  declare variable allotment_rooms integer;
  declare variable id_agent integer;
  declare variable min_occ_date date;
  declare variable max_occ_date date;
begin
  /*
   this proc calculate prices and check availabiliti
   data is leaved in table TMP_AVAILABILITY
  */
  roomtype_list = ','||:roomtype_list||',';
  rate_list = ','||:rate_list||',';
  board_list = ','||:board_list||',';

  id_agent = null;
  select PA.ID_AGENT
  from   PROFILE_AGENT PA
  where  PA.ID_PROFILE = :id_agent_profile
  into   :id_agent;

  select min(SOT.FOR_DATE), max(SOT.FOR_DATE)
  from   SMART_OCCUP$TMP SOT
  where  ((:hotels = '') or (','||:hotels||',' containing ','||SOT.ID_HOTEL||','))
  into   :min_occ_date, :max_occ_date;
  if ((:min_occ_date > :arrival_date)
     or (:max_occ_date < :departure_date))
  then begin
    exception WRONG_VALUE 'Wrong input period for calculation! ';
  end

  /*New refactored procedure*/
  ID_SESSION = gen_id(SELECTION_GEN, 1);
  execute procedure AVAILABILITY_RATING_LOOP$INT (:ID_SESSION, :arrival_date, :departure_date,
          :rooms_count, :adults_count, :children_count, :roomtype_list, :rate_list, :board_list, :hotels);

  /*Update Available to output table*/
  for
    select RT.ID_ROOM_TYPE
    from   ROOM_TYPES RT
    where  :roomtype_list containing ','|| RT.ID_ROOM_TYPE ||','
            and ((:hotels = '') or (','||:hotels||',' containing ','||RT.ID_HOTEL||','))
    into   :id_room_type
  do begin
    total_rooms = null;
    execute procedure AVAILABILITY_GET_AVAIL$INT(:id_room_type, :arrival_date, :departure_date, :id_agent)
    returning_values  :total_rooms, :allotment_rooms;

    total_rooms = coalesce(:total_rooms, 0);

    update TMP_AVAILABILITY
    set    TOTAL_ROOMS =  :total_rooms,
           ALLOTMENT_ROOMS =  :allotment_rooms
    where  ID_SESSION  = :ID_SESSION
           and ID_ROOM_TYPE = :id_room_type;
  end

  /**/
  execute procedure AVAILABILITY_RATING_FILL$INT(:ID_SESSION, :roomtype_list, :rate_list,
          :arrival_date, :departure_date, :id_agent);
  --
end
^

/* Alter (BLOCK_ANNUL$BLK) */
ALTER PROCEDURE BLOCK_ANNUL$BLK(ID_BLOCK_ROOM INTEGER,
OPERATION VARCHAR(30))
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable share_err_text varchar(255);
  declare variable system_date date;
  declare variable cancel_date date;
  declare variable from_date date;
  declare variable b_dbkey char(8);
  declare variable new_id_block_room integer;
  declare variable id_room integer;
  declare variable block_grp integer;
  declare variable reason varchar(50);
  declare variable note varchar(255);
  declare variable action_text varchar(255);
  declare variable room_name varchar(10);
  declare variable id_hotel integer;
  declare variable mark_dirty_expired_block integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION (:operation, 'cancel, annul');

  select BR.FROM_DATE, BR.RDB$DB_KEY, R.ID_HOTEL
  from   BLOCK_ROOM BR
         join ROOMS R on R.ID_ROOM = BR.ID_ROOM
  where  BR.ID_BLOCK_ROOM = :id_block_room
  into   :from_date, :b_dbkey, :id_hotel;

  if (:operation = 'annul') then begin
    update BLOCK_ROOM BR
    set    BR.IS_ANNUL = 1
    where  BR.RDB$DB_KEY = :b_dbkey;
  
    execute procedure BLOCK_MODIFY_CONTROL$INT(:b_dbkey, :from_date);
    execute procedure ROOM_MAGIC_CLEAR(:id_block_room);
    action_text = '';
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :id_block_room, 'ANNUL_BLOCK', :action_text);
  end else begin
    select BR.ID_ROOM, BR.BLOCK_GRP, BR.REASON, BR.NOTE, R.ROOM_NAME
    from   BLOCK_ROOM BR
           join ROOMS R on R.ID_ROOM = BR.ID_ROOM
    where  BR.RDB$DB_KEY = :b_dbkey
    into   :id_room, :block_grp, :reason, :note, :room_name;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :system_date;
    cancel_date = :system_date - 1;

    execute procedure BLOCK_MODIFY$INT(:id_block_room, :id_room, :from_date, :cancel_date, :block_grp, :reason,
                      :note, 'mod')
    returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :share_err_text, :warn_code;
    --ignore possible entering into share

    execute procedure SETTING_GET_VALUE('MARK_DIRTY_EXPIRED_BLOCK', :id_hotel)
    returning_values  :mark_dirty_expired_block;
    if (:mark_dirty_expired_block = '1') then begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'BLOCK_STOP', 'set_dirty');
    end

    action_text = f_character(29) || :room_name || f_character(28) || formatdate(:cancel_date, 'D;dd.mm.yyyy');
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :new_id_block_room, 'CANCEL_BLOCK', :action_text);
  end
end
^

/* Alter (BLOCK_CREATE$BLK) */
ALTER PROCEDURE BLOCK_CREATE$BLK(ROOM_NAMES TYPE OF TDESCRIPTION_LONG,
ID_HOTEL TYPE OF ID,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
BLOCK_GRP TYPE OF TRANGE,
REASON TYPE OF TREASON,
NOTE TYPE OF TDESCRIPTION_LONG,
IS_FULL_FROM TYPE OF TRANGE,
IS_FULL_TO TYPE OF TRANGE)
 RETURNS(NEW_ID_BLOCK_ROOM TYPE OF ID,
SHARE_TRANSACTION_ID TYPE OF ID,
SHARE_ERR_CODE TYPE OF ID,
ERR_TEXT VARCHAR(255),
WARN_CODE TYPE OF ID,
NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable room_name varchar(50);
  declare variable id_room integer;
  declare variable action_text varchar(255);
  declare variable block_name varchar(30);
begin
  id_room = null;
  warn_code = null;
  SHARE_ERR_CODE = 0;

  for
    select ITEM
    from   SYSTEM_STRING_PARSER(:room_names, ',')
    into   :room_name
  do begin
    id_room = null;
    select R.ID_ROOM
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ROOM_NAME = :room_name
           and RT.ID_HOTEL = :id_hotel
    into   :id_room;

    if (:id_room is null) then exception BLOCK_EXCEPTION '-5' || f_character(31) || :room_name;

    execute procedure BLOCK_MODIFY$INT(null, :id_room, :from_date, :to_date, :block_grp,
                      :reason, :note, 'add')
    returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :err_text, :warn_code;

    block_name = iif(:block_grp = 18, 'OUT OF ORDER', 'OUT OF INVENTORY');
    action_text = f_character(29) || :room_name
                  || f_character(28) || formatdate(:from_date, 'D;dd.mm.yyyy') || '-' || formatdate(:to_date, 'D;dd.mm.yyyy')
                  || f_character(28) || :block_name;
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :new_id_block_room, 'BLOCK_ROOM', :action_text);

  end

  select cast('31.12.1899' as date) + count(b.ID_BLOCK_ROOM)
  from   BLOCK_ROOM b
  where  b.ID_ROOM is not null
  into   :NEW_FROM_DATE;
end
^

/* empty dependent procedure body */
/* Clear: BLOCK_SET_PERIOD$BLK for: BLOCK_MODIFY$BLK */
ALTER PROCEDURE BLOCK_SET_PERIOD$BLK(ID_BLOCK_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (BLOCK_MODIFY$BLK) */
ALTER PROCEDURE BLOCK_MODIFY$BLK(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
IS_FULL_FROM INTEGER,
IS_FULL_TO INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable new_id_block_room integer;
  declare variable action_text varchar(255);
  declare variable old_from_date date;
  declare variable old_to_date date;
  declare variable old_group integer;
  declare variable room_name varchar(10);
  declare variable block_name varchar(30);
begin
  --  IS_FULL_FROM  - deprecated
  --  IS_FULL_TO  - deprecated

  select BR.FROM_DATE, BR.TO_DATE, BR.BLOCK_GRP, R.ROOM_NAME
  from   BLOCK_ROOM BR
         join ROOMS R on R.ID_ROOM = BR.ID_ROOM
  where  BR.ID_BLOCK_ROOM = :ID_BLOCK_ROOM              
  into   :old_from_date, :old_to_date, :old_group, :room_name;

  execute procedure BLOCK_MODIFY$INT(:id_block_room, :id_room, :from_date, :to_date, :block_grp,
                    :reason, :note, 'mod')
  returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :err_text, :warn_code;

  if ( (:old_from_date <> :FROM_DATE) or (:old_to_date <> :TO_DATE) or (:old_group <> :BLOCK_GRP) ) then begin
    block_name = iif(:block_grp = 18, 'OUT OF ORDER', 'OUT OF INVENTORY');
    action_text = f_character(29) || :room_name
                  || f_character(28) || formatdate(:FROM_DATE, 'D;dd.mm.yyyy') || '-' || formatdate(:TO_DATE, 'D;dd.mm.yyyy')
                  || f_character(28) || :block_name;
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :NEW_ID_BLOCK_ROOM, 'EDIT_BLOCK', :action_text);
  end
end
^

/* Alter (BLOCK_SET_PERIOD$BLK) */
ALTER PROCEDURE BLOCK_SET_PERIOD$BLK(ID_BLOCK_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100),
WARN_CODE INTEGER)
 AS
declare variable id_room integer;
  declare variable block_grp integer;
  declare variable reason varchar(50);
  declare variable note varchar(255);
begin
  share_err_code = 0;
  err_text = '';
  warn_code = null;

  select BR.ID_ROOM, BR.BLOCK_GRP, BR.REASON, BR.NOTE
  from   BLOCK_ROOM BR
  where  BR.ID_BLOCK_ROOM = :id_block_room
  into   :id_room, :block_grp, :reason, :note;

  execute procedure BLOCK_MODIFY$BLK (:id_block_room, :id_room, :from_date, :to_date, :block_grp, :reason, :note, null, null)
  returning_values  :share_transaction_id, :share_err_code, :err_text, :warn_code;
end
^

/* Alter (CACHES_RESOLVE) */
ALTER PROCEDURE CACHES_RESOLVE AS
declare variable id_res_detail integer;
  declare variable id_group integer;
  declare variable cache_cnt integer;
  declare variable id_account integer;
  declare variable no_use varchar(1024);
begin
  /* resolve reservs cache conflicts */
  for
    select first 20 RG.ID_RESERV_DETAIL, rg.ID_GROUP, sum(iif(rg.BOARD_NAMES is null, 2, 1))
    from   RESERV_GUESTDATA_CACHE RG
    group by RG.ID_RESERV_DETAIL, rg.ID_GROUP
    having sum(iif(rg.BOARD_NAMES is null, 2, 1)) > 1
    into   :id_res_detail, :id_group, :cache_cnt
  do begin
    execute procedure RES_GET_GUEST_DATA$INT (iif(:id_res_detail is not null, 'DETAIL', 'GROUP'), coalesce(:id_res_detail, :id_group))
    returning_values  (:no_use, :no_use, :no_use, :no_use);

    when any do begin
      execute procedure sys_dbg('all Cache resolve error for reserv '|| iif(:id_res_detail is not null, 'DETAIL', 'GROUP') || ': ' || coalesce(:id_res_detail, :id_group));
    end
  end 

  /* resolve account balances cache conflicts */
  for
    select first 20 AC.ID_ACCOUNT, sum(iif(AC.ACCOUNT_BALANCE is null, 2, 1))
    from   ACCOUNT_BALANCE_CACHE AC
    group by AC.ID_ACCOUNT
    having sum(iif(AC.ACCOUNT_BALANCE is null, 2, 1)) > 1
    into   :id_account, :cache_cnt
  do begin
    execute procedure ACCOUNT_BALANCE$INT (:id_account, 0)
    returning_values  (:no_use, :no_use, :no_use, :no_use, :no_use, :no_use, :no_use);

    when any do begin
      execute procedure sys_dbg('all Cache resolve error for account: ' || :id_account);
    end
  end 
end
^

/* Alter (CANCEL_BOOKING$EXC) */
ALTER PROCEDURE CANCEL_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20,
STATUS VARCHAR(20))
 RETURNS(BOOKING_ID INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable hotel_id integer;
declare variable cancel_event_log_id integer;
begin
  /* init */
  err_code = 0;
  err_text = '';

  execute procedure import_mark_transaction$exc;

  select first 1 b.id_reserv_detail, b.id_log_event_annul, b.from_date, b.to_date
  from   reserv_detail b
  where  b.number=:number
         and b.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  order by id_log_event_annul nulls first
  into   :booking_id, cancel_event_log_id, :from_date, :to_date;

  if ((:booking_id is null) or (:cancel_event_log_id is not null)) then begin
    /* not found or found but already in void status - ignore and exit */
    exit;
  end

  /* verify hotel */
  execute procedure lookup_hotel$exc(:hotel, 'BOOKING', :booking_id)
  returning_values :hotel_id;

  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  execute procedure APPLY_BOOKING_STATUS$EXC(
    :booking_id, null, :status, :confirmation_number, :cancelation_number
  );
end
^

/* Alter (CLEAR_ORPHAN_GUESTS$EXC) */
ALTER PROCEDURE CLEAR_ORPHAN_GUESTS$EXC(BOOKING_ID INTEGER)
 AS
declare variable guest_id integer;
  declare variable guest_uuid varchar(50);
begin

  for
    select g.id_guest, g.uuid
    from guest g
    where g.id_reserv_detail=:booking_id and g.orphaned_import$exc=1
    into :guest_id, :guest_uuid do
  begin
    execute procedure sys_dbg('exc CLEAR_ORPHAN_GUESTS$EXC - RES_GUEST_DEL$RSV(:guest_id=>' || coalesce(:guest_id, '<null>') || ', :guest_uuid=>' || coalesce(:guest_uuid, '<null>') || ')');

    execute procedure RES_GUEST_DEL$RSV(:guest_id);
  end
end
^

/* empty dependent procedure body */
/* Clear: PMS_REGULAR_POST_CREATE$PMS for: CONTRACT_CALENDAR_MODIFY$PMS */
ALTER PROCEDURE PMS_REGULAR_POST_CREATE$PMS(ID_CONTRACT_CALENDAR_POST INTEGER,
ID_ROOM INTEGER,
ID_OWNER INTEGER,
ID_CURRENCY VARCHAR(3),
ID_SERVICE INTEGER,
POST_VALUE NUMERIC(15,4),
IS_ACC_POST_ITEM SMALLINT,
MANUAL_POST_DATE DATE,
DESCRIPTION VARCHAR(255),
IS_POST_PER_POOL SMALLINT,
ID_RENTAL_POOL INTEGER,
IS_INCOME_POST SMALLINT)
 AS
 BEGIN EXIT; END
^

/* Alter (CONTRACT_CALENDAR_MODIFY$PMS) */
ALTER PROCEDURE CONTRACT_CALENDAR_MODIFY$PMS(ID_CONTRACT_CALENDAR_POST TYPE OF ID,
ID_ROOM_CONTRACT TYPE OF ID,
ID_SERVICE TYPE OF ID,
IS_INCOME TYPE OF TLOGICAL,
SERVICE_PRICE TYPE OF TPRICE,
ID_CURRENCY TYPE OF TCURRENCY,
IS_ACC_POST_ITEM TYPE OF TLOGICAL,
POSTING_DATE_LIST TYPE OF TTEXT_EXTENDED,
POSTING_PERIOD_DURATION TYPE OF TCOUNT,
MONTH_NEXT_DATE TYPE OF TDATE,
IS_FIXED_DATE TYPE OF TLOGICAL,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_CALENDAR_POST TYPE OF ID)
 AS
declare variable post_date date;
  declare variable post_next_date date;
  declare variable service_name varchar(30);
  declare variable old_service_name varchar(30);
  declare variable old_post_next_date date;
  declare variable old_is_income smallint;
  declare variable old_service_price numeric(15,4);
  declare variable old_id_currency varchar(3);
  declare variable old_is_acc_post_item smallint;
  declare variable old_posting_period_duration integer;
  declare variable old_posting_date_list varchar(2000);
  declare variable old_id_service integer;
  declare variable old_is_fixed_date smallint;
  declare variable old_id_room_contract integer;
  declare variable action_text varchar(255);
begin

  /* POSTING_DATE_LIST - list ot dates(dd.mm.yyyy) comma separated;
     POSTING_PERIOD_DURATION must be in months,
     operation in ('add','mod','del') */

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del,mod_next_date');

  post_date = null;
  post_next_date = null;
  if (:OPERATION in ('add','mod')) then begin
    if (:is_fixed_date = 0) then begin
      post_date = :month_next_date;
      if (:posting_period_duration is not null and :post_date is not null) then begin
        post_next_date = addmonth(:post_date, :posting_period_duration);
      end
    end else begin
      select first 1 S.ITEM
      from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') S
      order by cast(S.ITEM as date)
      into :post_date;

      select first 1 SSP.ITEM
      from SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') SSP
      where cast(SSP.ITEM as date) > :post_date
      order by cast(SSP.ITEM as date)
      into :post_next_date;
    end

 --   select first 1 S.ITEM
 --   from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') S
 --   order by S.INTURN
 --   into   :post_date;

 --   if (:posting_period_duration is not null and :post_date is not null) then begin
 --     execute procedure ADD_MONTH(:post_date, :posting_period_duration)
 --     returning_values (:post_next_date);
 --   end else if (:posting_date_list is not null) then begin
 --     select S.ITEM
 --     from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') S
 --     where  S.INTURN = 2
 --     into   :post_next_date;
 --   end
  end

  select SE.SERVICE_NAME
  from SERVICES SE
  where SE.ID_SERVICE = :ID_SERVICE
  into :service_name;

  if (:operation = 'add') then begin
    if (coalesce(:ID_CONTRACT_CALENDAR_POST, -1) > 0) then
      NEW_ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST;
    else
      NEW_ID_CONTRACT_CALENDAR_POST = gen_id(GEN_CONTRACT_CAL_POST$PMS_ID, 1);

    insert into CONTRACT_CALENDAR_POST$PMS (
           ID_CONTRACT_CALENDAR_POST, ID_ROOM_CONTRACT, ID_SERVICE, IS_INCOME,
           SERVICE_PRICE, ID_CURRENCY, IS_ACC_POST_ITEM, POST_DATE, POST_NEXT_DATE, POSTING_PERIOD_DURATION, IS_FIXED_DATE)
    values (:NEW_ID_CONTRACT_CALENDAR_POST, :ID_ROOM_CONTRACT, :ID_SERVICE, :IS_INCOME,
            :SERVICE_PRICE, :ID_CURRENCY, :IS_ACC_POST_ITEM, :POST_DATE, :POST_NEXT_DATE, :POSTING_PERIOD_DURATION, :IS_FIXED_DATE);
    ID_CONTRACT_CALENDAR_POST = :NEW_ID_CONTRACT_CALENDAR_POST;

    if ((:is_fixed_date = 0) and (:month_next_date is not null)) then
      insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
      values (:ID_CONTRACT_CALENDAR_POST, :MONTH_NEXT_DATE);
    else if ((:is_fixed_date = 1) and (:posting_date_list is not null)) then begin
      for
        select SY.ITEM
        from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') SY
        into   :post_date
      do begin
        insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
        values (:ID_CONTRACT_CALENDAR_POST, :POST_DATE);
      end
    end

 --   for
 --     select S.ITEM
 --     from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') S
 --     into   :post_date
 --   do begin
 --     insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
 --     values (:ID_CONTRACT_CALENDAR_POST, :POST_DATE);
 --   end

    action_text = substring(f_character(29) || '@{pms.contract.is_income.' || :is_income || '}' || ', ' || :service_name ||
                  f_character(28) || '@{pms.is_acc_post_item.' || :is_acc_post_item || '}' ||
                  ', ' || formatfloat(:service_price, '0.00') ||
                  ', ' || :id_currency ||
                  ', ' || iif(:is_fixed_date = 0, '@{pms.montly_plannig_scheme}' || ', ' || coalesce(:posting_period_duration, ' ') || ', ' ||
                                                  iif(:month_next_date is not null, formatdate(:month_next_date, 'D;dd.mm.yyyy'), ' '),
                                                             '@{pms.fixed_plannig_scheme}' || ', ' ||coalesce(:posting_date_list, ' ')) from 1 for 255);

    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_CALEN_ADD', :ACTION_TEXT);
  end else begin
    select S.SERVICE_NAME, CCP.IS_INCOME, CCP.SERVICE_PRICE, CCP.ID_CURRENCY, CCP.IS_ACC_POST_ITEM,
           CCP.POSTING_PERIOD_DURATION, CCP.POST_NEXT_DATE, CCP.ID_SERVICE, CCP.IS_FIXED_DATE, CCP.ID_ROOM_CONTRACT
    from CONTRACT_CALENDAR_POST$PMS CCP
      join SERVICES S on S.ID_SERVICE = CCP.ID_SERVICE
    where CCP.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST
    into :old_service_name, old_is_income, :old_service_price, :old_id_currency, :old_is_acc_post_item,
         :old_posting_period_duration, :old_post_next_date, :old_id_service, :old_is_fixed_date, :old_id_room_contract;

    select list(formatdate(CCS.POST_DATE, 'D;dd.mm.yyyy'), ',')
    from CONTRACT_CALENDAR_SCHEME$PMS CCS
    where CCS.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST
    into :old_posting_date_list;

    if (:operation = 'mod') then begin
      if ((:old_is_income <> :is_income) or (:old_id_service <> :id_service)) then begin
        execute procedure CONTRACT_CALENDAR_MODIFY$PMS(:ID_CONTRACT_CALENDAR_POST, :ID_ROOM_CONTRACT, :ID_SERVICE, :IS_INCOME, :SERVICE_PRICE,
                                                       :ID_CURRENCY, :IS_ACC_POST_ITEM, :POSTING_DATE_LIST, :POSTING_PERIOD_DURATION,
                                                       :MONTH_NEXT_DATE, :IS_FIXED_DATE, 'del')
        returning_values :new_id_contract_calendar_post;
        execute procedure CONTRACT_CALENDAR_MODIFY$PMS(:ID_CONTRACT_CALENDAR_POST, :ID_ROOM_CONTRACT, :ID_SERVICE, :IS_INCOME, :SERVICE_PRICE,
                                                       :ID_CURRENCY, :IS_ACC_POST_ITEM, :POSTING_DATE_LIST, :POSTING_PERIOD_DURATION,
                                                       :MONTH_NEXT_DATE, :IS_FIXED_DATE, 'add')
        returning_values :new_id_contract_calendar_post;
      end else begin
        update CONTRACT_CALENDAR_POST$PMS C
        set    C.SERVICE_PRICE = :SERVICE_PRICE,
               C.ID_CURRENCY = :ID_CURRENCY,
               C.IS_ACC_POST_ITEM = :IS_ACC_POST_ITEM,
               C.POST_DATE = :POST_DATE,
               C.POST_NEXT_DATE = :POST_NEXT_DATE,
               C.POSTING_PERIOD_DURATION = :POSTING_PERIOD_DURATION,
               C.IS_FIXED_DATE = :IS_FIXED_DATE
        where C.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST;

        delete from CONTRACT_CALENDAR_SCHEME$PMS
        where (ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST);

        if ((:is_fixed_date = 0) and (:month_next_date is not null)) then
          insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
          values (:ID_CONTRACT_CALENDAR_POST, :MONTH_NEXT_DATE);
        else if ((:is_fixed_date = 1) and (:posting_date_list is not null)) then begin
          for
            select SY.ITEM
            from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') SY
            into   :post_date
          do begin
            insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
            values (:ID_CONTRACT_CALENDAR_POST, :POST_DATE);
          end
        end

 --       for
 --         select S.ITEM
 --         from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') S
 --         into   :post_date
 --       do begin
 --         insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
 --         values (:ID_CONTRACT_CALENDAR_POST, :POST_DATE);
 --       end

        if ((:old_is_acc_post_item <> :is_acc_post_item) or (:old_service_price <> :service_price) or (:old_id_currency <> :id_currency)) then begin
          action_text = substring(f_character(29) || '@{pms.contract.is_income.' || :is_income || '}' ||
                        ', ' || :service_name ||
                        f_character(28) || '@{pms.is_acc_post_item.' || :old_is_acc_post_item || '}' || ', '
                        || formatfloat(:old_service_price, '0.00') || ', ' ||
                        :old_id_currency ||
                        f_character(28) || '@{pms.is_acc_post_item.' || :is_acc_post_item || '}' || ', ' ||
                        formatfloat(:service_price, '0.00') || ', ' || :id_currency from 1 for 255);
          execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_CALEN_MOD', :ACTION_TEXT);
        end

        if ((coalesce(:old_posting_period_duration, 0) <> coalesce(:posting_period_duration, 0)) or
            (coalesce(:old_posting_date_list, ' ') <> coalesce(:posting_date_list, formatdate(:month_next_date, 'D;dd.mm.yyyy')))) then begin
          action_text = substring(f_character(29) || '@{pms.contract.is_income.' || :is_income || '}' ||
                        ', ' || :service_name || ', ' || f_character(28) ||
                        iif(:old_is_fixed_date = 0, '@{pms.montly_plannig_scheme}' || ', ' || coalesce(:old_posting_period_duration, ' ') || ', ' ||
                                                    coalesce(:old_posting_date_list, ' '),
                                                    '@{pms.fixed_plannig_scheme}' || ', ' ||coalesce(:old_posting_date_list, ' ')) ||
                        f_character(28) || iif(:is_fixed_date = 0, '@{pms.montly_plannig_scheme}' || ', ' || coalesce(:posting_period_duration, ' ')
                                                                   || ', ' || /*coalesce(:posting_date_list, ' ')*/iif(:month_next_date is not null, formatdate(:month_next_date, 'D;dd.mm.yyyy'), ' '),
                                                                   '@{pms.fixed_plannig_scheme}' || ', ' || coalesce(:posting_date_list, ' ')) from 1 for 255);
          execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_CALEN_MOD_SCHM', :ACTION_TEXT);
        end
      end
    end
    if (:operation = 'mod_next_date') then begin
      select C.POST_NEXT_DATE, C.POSTING_PERIOD_DURATION, C.IS_FIXED_DATE
      from   CONTRACT_CALENDAR_POST$PMS C
      where  C.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST
      into   :post_date, :posting_period_duration, :is_fixed_date;

      if ((:is_fixed_date = 0) and (:posting_period_duration is not null) and (:post_date is not null)) then begin
        POST_NEXT_DATE = addmonth(:POST_DATE, :POSTING_PERIOD_DURATION);
      end else begin
        select first 1 skip 1 S.POST_DATE
        from   CONTRACT_CALENDAR_SCHEME$PMS S
        where  S.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST
        order by S.POST_DATE
        into   :POST_NEXT_DATE;
      end

      update CONTRACT_CALENDAR_POST$PMS C
      set    C.POST_DATE = :POST_DATE,
             C.POST_NEXT_DATE = :POST_NEXT_DATE
      where  C.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST;
    end
    if (:operation = 'del') then begin
      action_text = f_character(29) || '@{pms.contract.is_income.' || :old_is_income || '}' || f_character(28) || :old_service_name ||
                    f_character(28) || '@{pms.is_acc_post_item.' || :old_is_acc_post_item || '}' ||
                    ', ' || formatfloat(:old_service_price, '0.00') ||
                    ', ' || :old_id_currency ||
                    ', ' || iif(:old_is_fixed_date = 0, '@{pms.montly_plannig_scheme}' || ', ' || coalesce(:old_posting_period_duration, ' ') ||
                                                        ', ' || coalesce(:old_post_next_date, ' '),
                                                        '@{pms.fixed_plannig_scheme}' || ', ' || coalesce(:old_posting_date_list, ' '));
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :OLD_ID_ROOM_CONTRACT, 'ROOM_CONTR_CALEN_DEL', substring(:ACTION_TEXT from 1 for 255));
      delete from CONTRACT_CALENDAR_POST$PMS
      where (ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST);
    end
  end
end
^

/* Alter (CONTRACT_EXPENSE_MODIFY$PMS) */
ALTER PROCEDURE CONTRACT_EXPENSE_MODIFY$PMS(ID_CONTRACT_EXPENSE TYPE OF ID,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
SERVICE_PRICE TYPE OF TPRICE,
CONTRACT_EXPENSE_TYPE VARCHAR(50),
MULTIPLIER_TYPE VARCHAR(50),
ORDER_TAG TYPE OF TCOUNT,
IS_ACC_POST_ITEM TYPE OF TLOGICAL,
ID_AGENT_PROFILE TYPE OF ID_REF,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_EXPENSE TYPE OF ID)
 AS
declare variable is_use smallint;
  declare variable formula varchar(100);
  declare variable service_name varchar(30);
  declare variable id_room_contract integer;
  declare variable old_service_name varchar(30);
  declare variable old_is_acc_post_item smallint;
  declare variable old_multiplier_type varchar(50);
  declare variable old_contract_expense_type varchar(50);
  declare variable old_order_tag integer;
  declare variable old_id_currency char(3);
  declare variable old_service_price numeric(15,4);
  declare variable old_id_service integer;
  declare variable contract_acc varchar(50);
  declare variable action_text varchar(255);
  declare variable id_hotel_contract integer;
  declare variable id_hotel_service integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  if ( :CONTRACT_EXPENSE_TYPE not in ('PERCENT', 'RUNNING_TOTAL_PERCENT', 'CURR_VALUE') ) then
    exception WRONG_PARAM_VALUE;

  if ( :MULTIPLIER_TYPE not in ('RESERVATION', 'STAY', 'GUESTS', 'BED_NIGHTS') ) then
    exception WRONG_PARAM_VALUE;

  if (:ORDER_TAG is null) then ORDER_TAG = 0;
  formula = '';
  is_use = 1;

  select SE.SERVICE_NAME, SE.id_hotel
  from   SERVICES SE
  where  SE.ID_SERVICE = :ID_SERVICE
  into   :service_name, :id_hotel_service;

  select R.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS RP on RP.ID_ROOM_PERIOD = RC.ID_ROOM_PERIOD
         join ROOMS R on R.ID_ROOM = RP.ID_ROOM
  where  RC.ID_ROOM_CONTRACT = :ID_CONTRACT
  into   :id_hotel_contract;

  if (:id_hotel_contract is distinct from :id_hotel_service) then exception PMS_EXCEPTION '-626';

  if (:OPERATION = 'add') then begin
    id_room_contract = :ID_CONTRACT;
    contract_acc = case
                     when :SUB_CONTRACT = 'GUEST_USE' then '@{pms.contract_base_account}'
                     when :SUB_CONTRACT = 'OWNER_USE' then '@{pms.contract_owner_use}'
                     when :SUB_CONTRACT = 'SHADOW_ACC' then '@{pms.contract_shadow_account}'
                     else 'N/A'
                   end;

    NEW_ID_CONTRACT_EXPENSE = gen_id(GEN_CONTRACT_EXPENSE$PMS_ID, 1);
    insert into CONTRACT_EXPENSE$PMS (ID_CONTRACT_EXPENSE, ID_CONTRACT, SUB_CONTRACT, ID_SERVICE, ORDER_TAG,
           FORMULA, ID_CURRENCY, SERVICE_PRICE, CONTRACT_EXPENSE_TYPE, IS_ACC_POST_ITEM, MULTIPLIER_TYPE, ID_AGENT_PROFILE)
    values (:NEW_ID_CONTRACT_EXPENSE, :ID_CONTRACT, :SUB_CONTRACT, :ID_SERVICE, :ORDER_TAG,
           :FORMULA, :ID_CURRENCY, :SERVICE_PRICE, :CONTRACT_EXPENSE_TYPE, :IS_ACC_POST_ITEM, :MULTIPLIER_TYPE, :ID_AGENT_PROFILE);

    action_text = substring(f_character(29) || :contract_acc || f_character(28) || :order_tag || f_character(28) || :service_name ||
                  f_character(28) || '@{pms.is_acc_post_item.' || :is_acc_post_item || '}' ||
                  f_character(28) || '@{pms.multiplier_type.' || :multiplier_type || '}' ||
                  f_character(28) || coalesce(:id_currency, '@{pms.contract_expense_type.' || :contract_expense_type || '}') ||
                  f_character(28) || formatfloat(:service_price, '0.00') from 1 for 255);
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_SERV_ADD', :ACTION_TEXT);
  end else begin
    select S.SERVICE_NAME, CEP.IS_ACC_POST_ITEM, CEP.MULTIPLIER_TYPE, CEP.CONTRACT_EXPENSE_TYPE, CEP.ORDER_TAG,
           CEP.ID_CURRENCY, CEP.SERVICE_PRICE, CEP.ID_SERVICE,
           case
             when CEP.SUB_CONTRACT = 'GUEST_USE' then '@{pms.contract_base_account}'
             when CEP.SUB_CONTRACT = 'OWNER_USE' then '@{pms.contract_owner_use}'
             when CEP.SUB_CONTRACT = 'SHADOW_ACC' then '@{pms.contract_shadow_account}'
             else 'N/A'
           end,
           CEP.ID_CONTRACT
    from   CONTRACT_EXPENSE$PMS CEP
           join SERVICES S on S.ID_SERVICE = CEP.ID_SERVICE
    where  CEP.ID_CONTRACT_EXPENSE = :ID_CONTRACT_EXPENSE
    into   :old_service_name, :old_is_acc_post_item, :old_multiplier_type, :old_contract_expense_type, :old_order_tag,
           :old_id_currency, :old_service_price, :old_id_service, :contract_acc, :id_room_contract;

    if (:OPERATION = 'mod') then begin
      if (:old_id_service <> :id_service) then begin
        execute procedure CONTRACT_EXPENSE_MODIFY$PMS(:ID_CONTRACT_EXPENSE, :ID_CONTRACT, :SUB_CONTRACT, :ID_SERVICE, :ID_CURRENCY, :SERVICE_PRICE,
                                                      :CONTRACT_EXPENSE_TYPE, :MULTIPLIER_TYPE, :ORDER_TAG, :IS_ACC_POST_ITEM, :ID_AGENT_PROFILE, 'del')
        returning_values :new_id_contract_expense;
        execute procedure CONTRACT_EXPENSE_MODIFY$PMS(:ID_CONTRACT_EXPENSE, :ID_CONTRACT, :SUB_CONTRACT, :ID_SERVICE, :ID_CURRENCY, :SERVICE_PRICE,
                                                      :CONTRACT_EXPENSE_TYPE, :MULTIPLIER_TYPE, :ORDER_TAG, :IS_ACC_POST_ITEM, :ID_AGENT_PROFILE, 'add')
        returning_values :new_id_contract_expense;
      end else begin
        update CONTRACT_EXPENSE$PMS
        set    FORMULA = :FORMULA,
               ID_CURRENCY = :ID_CURRENCY,
               SERVICE_PRICE = :SERVICE_PRICE,
               CONTRACT_EXPENSE_TYPE = :CONTRACT_EXPENSE_TYPE,
               IS_ACC_POST_ITEM = :IS_ACC_POST_ITEM,
               MULTIPLIER_TYPE = :MULTIPLIER_TYPE,
               ORDER_TAG = :ORDER_TAG,
               ID_AGENT_PROFILE = :ID_AGENT_PROFILE
        where  ID_CONTRACT_EXPENSE = :ID_CONTRACT_EXPENSE;

        if ((:old_is_acc_post_item <> :is_acc_post_item) or (:old_multiplier_type <> :multiplier_type) or
                   (coalesce(:old_id_currency, :old_contract_expense_type) <> coalesce(:id_currency, :contract_expense_type)) or
                   (:old_service_price <> :service_price)) then begin
          action_text = substring(f_character(29) || :old_service_name || f_character(28) || :contract_acc ||
                        f_character(28) || '@{pms.is_acc_post_item.' || :old_is_acc_post_item || '}' ||
                        f_character(28) || '@{pms.multiplier_type.' || :old_multiplier_type || '}' ||
                        f_character(28) || coalesce(:old_id_currency, '@{pms.contract_expense_type.' || :old_contract_expense_type || '}') ||
                        f_character(28) || formatfloat(:old_service_price, '0.00') ||
                        f_character(28) || '@{pms.is_acc_post_item.' || :is_acc_post_item || '}' ||
                        f_character(28) || '@{pms.multiplier_type.' || :multiplier_type || '}' ||
                        f_character(28) || coalesce(:id_currency, '@{pms.contract_expense_type.' || :contract_expense_type || '}') ||
                        f_character(28) || formatfloat(:service_price, '0.00') from 1 for 255);
          execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_SERV_CHANG', :ACTION_TEXT);
        end
      end
    end else if (:OPERATION = 'del') then begin
      action_text = substring(f_character(29) || :contract_acc || f_character(28) || :old_order_tag || f_character(28) || :old_service_name ||
                      f_character(28) || '@{pms.is_acc_post_item.' || :old_is_acc_post_item || '}' ||
                      f_character(28) || '@{pms.multiplier_type.' || :old_multiplier_type || '}' ||
                      f_character(28) || coalesce(:old_id_currency, '@{pms.contract_expense_type.' || :old_contract_expense_type || '}') ||
                      f_character(28) || formatfloat(:old_service_price, '0.00') from 1 for 255);
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_SERV_DEL', :ACTION_TEXT);

      delete from CONTRACT_EXPENSE$PMS
      where (ID_CONTRACT_EXPENSE = :ID_CONTRACT_EXPENSE);
    end
  end
end
^

/* Alter (CONTRACT_MANAGEMENT_MODIFY$PMS) */
ALTER PROCEDURE CONTRACT_MANAGEMENT_MODIFY$PMS(ID_CONTRACT_MANAGEMENT TYPE OF ID,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_SERVICE TYPE OF ID,
MIN_VALUE TYPE OF TPRICE,
MIN_VALUE_CURR TYPE OF TCURRENCY,
MAX_VALUE TYPE OF TPRICE,
MAX_VALUE_CURR TYPE OF TCURRENCY,
NIGHT_PRICE TYPE OF TPRICE,
NIGHT_PRICE_CURR TYPE OF TCURRENCY,
IS_NETO TYPE OF TLOGICAL,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_MANAGEMENT TYPE OF ID)
 AS
declare variable is_use smallint;
  declare variable formula varchar(100);
  declare variable contract_acc varchar(50);
  declare variable id_room_contract integer;
  declare variable service_name varchar(30);
  declare variable old_id_contract integer;
  declare variable old_service_name varchar(30);
  declare variable old_min_value numeric(15,4);
  declare variable old_min_value_curr varchar(3);
  declare variable old_max_value numeric(15,4);
  declare variable old_max_value_curr varchar(3);
  declare variable old_night_price numeric(15,4);
  declare variable old_night_price_curr varchar(3);
  declare variable is_commision_service smallint;
  declare variable old_is_commision_service smallint;
  declare variable action_text varchar(255);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  formula = '';
  is_use = 1;

  select SE.SERVICE_NAME, iif(se.SERVICE_TYPE = 'COMMISSION', 0, 1) --SE.IS_ACC_POST_ITEM
  from   SERVICES SE
  where  SE.ID_SERVICE = :ID_SERVICE
  into   :service_name, :is_commision_service;

  if (:OPERATION = 'add') then begin
    /*select case
              when :ID_CONTRACT = RCP.ID_CONTRACT_GUEST then '@{pms.contract_base_account}'
              when :ID_CONTRACT = RCP.ID_CONTRACT_OWNER then '@{pms.contract_owner_use}'
              else  '@{pms.contract_shadow_account}'
           end as CONTRACT_ACC,
           RCP.ID_ROOM_CONTRACT
    from   ROOM_CONTRACT$PMS RCP
    where  :ID_CONTRACT in (RCP.ID_CONTRACT_GUEST, RCP.ID_CONTRACT_OWNER, RCP.ID_CONTRACT_SHADOW)
    into   :contract_acc, :id_room_contract; */
    id_room_contract = :ID_CONTRACT;
    contract_acc = case
                     when :SUB_CONTRACT = 'GUEST_USE' then '@{pms.contract_base_account}'
                     when :SUB_CONTRACT = 'OWNER_USE' then '@{pms.contract_owner_use}'
                     when :SUB_CONTRACT = 'SHADOW_ACC' then '@{pms.contract_shadow_account}'
                     else 'N/A'
                   end;

    new_id_contract_management = gen_id(GEN_CONTRACT_MANAGEMENT$PMS_ID, 1);
    insert into CONTRACT_MANAGEMENT$PMS (ID_CONTRACT_MANAGEMENT, ID_CONTRACT, SUB_CONTRACT,
           MIN_VALUE, MIN_VALUE_CURR, MAX_VALUE, MAX_VALUE_CURR,
           NIGHT_PRICE, NIGHT_PRICE_CURR, FORMULA, IS_NETO, IS_USE, ID_SERVICE)
    values (:new_id_contract_management, :ID_CONTRACT, :SUB_CONTRACT,
           :MIN_VALUE, :MIN_VALUE_CURR, :MAX_VALUE, :MAX_VALUE_CURR,
           :NIGHT_PRICE, :NIGHT_PRICE_CURR, :FORMULA, :IS_NETO, :IS_USE, :ID_SERVICE);

    action_text = f_character(29) || :contract_acc || f_character(28) ||
                  iif(:is_commision_service = 0, '@{word.commission}' || ' ' ||'@{word.the_service}' || ' ' || :service_name, :service_name) || f_character(28) ||
                  iif(:min_value is null, '', formatfloat(min_value, '0.00')) ||
                  iif(:max_value is null, '', formatfloat(max_value, '0.00')) ||
                  iif(:night_price is null, '', formatfloat(night_price, '0.00')) || f_character(28) ||
                  coalesce(min_value_curr, '') ||
                  coalesce(max_value_curr, '') || coalesce(night_price_curr, '');
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_KOM_SERV_ADD', :ACTION_TEXT);

  end else begin
    /*select CMP.ID_CONTRACT, CMP.MIN_VALUE, CMP.MIN_VALUE_CURR, CMP.MAX_VALUE, CMP.MAX_VALUE_CURR,
           CMP.NIGHT_PRICE, CMP.NIGHT_PRICE_CURR, SE.SERVICE_NAME, SE.IS_ACC_POST_ITEM,
           case
              when CMP.ID_CONTRACT = RCP.ID_CONTRACT_GUEST then '@{pms.contract_base_account}'
              when CMP.ID_CONTRACT = RCP.ID_CONTRACT_OWNER then '@{pms.contract_owner_use}'
              else  '@{pms.contract_shadow_account}'
           end as CONTRACT_ACC,
           RCP.ID_ROOM_CONTRACT
    from   CONTRACT_MANAGEMENT$PMS CMP
           join SERVICES SE on SE.ID_SERVICE = CMP.ID_SERVICE
           join ROOM_CONTRACT$PMS RCP on CMP.ID_CONTRACT in (RCP.ID_CONTRACT_GUEST, RCP.ID_CONTRACT_OWNER, RCP.ID_CONTRACT_SHADOW)
    where  CMP.ID_CONTRACT_MANAGEMENT = :ID_CONTRACT_MANAGEMENT
    into   :old_id_contract, :old_min_value, :old_min_value_curr, :old_max_value, :old_max_value_curr,
           :old_night_price, :old_night_price_curr, :old_service_name, :old_is_commision_service, :contract_acc, :id_room_contract;*/
    select CMP.ID_CONTRACT, CMP.MIN_VALUE, CMP.MIN_VALUE_CURR, CMP.MAX_VALUE, CMP.MAX_VALUE_CURR,
           CMP.NIGHT_PRICE, CMP.NIGHT_PRICE_CURR, SE.SERVICE_NAME, iif(se.SERVICE_TYPE = 'COMMISSION', 0, 1), --SE.IS_ACC_POST_ITEM,
           case
             when CMP.SUB_CONTRACT = 'GUEST_USE' then '@{pms.contract_base_account}'
             when CMP.SUB_CONTRACT = 'OWNER_USE' then '@{pms.contract_owner_use}'
             when CMP.SUB_CONTRACT = 'SHADOW_ACC' then '@{pms.contract_shadow_account}'
             else 'N/A'
           end as CONTRACT_ACC,
           CMP.ID_CONTRACT
    from   CONTRACT_MANAGEMENT$PMS CMP
           join SERVICES SE on SE.ID_SERVICE = CMP.ID_SERVICE
    where  CMP.ID_CONTRACT_MANAGEMENT = :ID_CONTRACT_MANAGEMENT
    into   :old_id_contract, :old_min_value, :old_min_value_curr, :old_max_value, :old_max_value_curr,
           :old_night_price, :old_night_price_curr, :old_service_name, :old_is_commision_service, :contract_acc, :id_room_contract;

    if (:OPERATION = 'mod') then begin
      update CONTRACT_MANAGEMENT$PMS
      set    -- ID_CONTRACT = :ID_CONTRACT,
             MIN_VALUE = :MIN_VALUE,
             MIN_VALUE_CURR = :MIN_VALUE_CURR,
             MAX_VALUE = :MAX_VALUE,
             MAX_VALUE_CURR = :MAX_VALUE_CURR,
             NIGHT_PRICE = :NIGHT_PRICE,
             NIGHT_PRICE_CURR = :NIGHT_PRICE_CURR,
             FORMULA = :FORMULA,
             IS_NETO = :IS_NETO,
             IS_USE = :IS_USE,
             ID_SERVICE = :ID_SERVICE
      where (ID_CONTRACT_MANAGEMENT = :ID_CONTRACT_MANAGEMENT);

      if ((:old_id_contract <> :id_contract) or (coalesce(:old_min_value, 0) <> coalesce(:min_value, 0)) or
          (coalesce(:old_min_value_curr, ' ') <> coalesce(:min_value_curr, ' ')) or
          (coalesce(:old_max_value, 0) <> coalesce(:max_value, 0)) or
          (coalesce(:old_max_value_curr, ' ') <> coalesce(:max_value_curr, ' ')) or
          (coalesce(:old_night_price, 0) <> coalesce(:night_price, 0)) or
          (coalesce(:old_night_price_curr, ' ') <> coalesce(:night_price_curr, ' ')) or
          (:is_commision_service <> :old_is_commision_service) or
          (coalesce(:service_name, ' ') <> coalesce(:old_service_name, ' '))) then begin
        action_text = f_character(29) || :contract_acc || f_character(28) ||
                      iif(:old_is_commision_service = 0, '@{word.commission}' || ' ' ||'@{word.the_service}' || ' ' || :old_service_name, :old_service_name) || f_character(28) ||
                      iif(:old_min_value is null, '', formatfloat(:old_min_value, '0.00')) ||
                      iif(:old_max_value is null, '', formatfloat(:old_max_value, '0.00')) ||
                      iif(:old_night_price is null, '', formatfloat(:old_night_price, '0.00')) || f_character(28) ||
                      coalesce(old_min_value_curr, '') ||
                      coalesce(old_max_value_curr, '') || coalesce(old_night_price_curr, '') ||
                      f_character(28) ||
                      iif(:is_commision_service = 0, '@{word.commission}' || ' ' ||'@{word.the_service}' || ' ' || :service_name, :service_name) || f_character(28) ||
                      iif(:min_value is null, '', formatfloat(:min_value, '0.00')) ||
                      iif(:max_value is null, '', formatfloat(:max_value, '0.00')) ||
                      iif(:night_price is null, '', formatfloat(:night_price, '0.00')) || f_character(28) || coalesce(min_value_curr, '') ||
                      coalesce(max_value_curr, '') || coalesce(night_price_curr, '');
        execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_KOM_SERV_CHANG', :ACTION_TEXT);
      end
    end else if (:OPERATION = 'del') then begin
      action_text = f_character(29) || coalesce(:contract_acc, '') || f_character(28) ||
                    iif(:old_is_commision_service = 0, '@{word.commission}' || ' ' ||'@{word.the_service}' || ' ' || :old_service_name, :old_service_name) || f_character(28) ||
                    iif(:old_min_value is null, '', formatfloat(:old_min_value, '0.00')) ||
                    iif(:old_max_value is null, '', formatfloat(:old_max_value, '0.00')) ||
                    iif(:old_night_price is null, '', formatfloat(:old_night_price, '0.00')) || f_character(28) || coalesce(old_min_value_curr, '') ||
                    coalesce(old_max_value_curr, '') || coalesce(old_night_price_curr, '');
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_KOM_SERV_DEL', :ACTION_TEXT);

      delete from CONTRACT_MANAGEMENT$PMS
      where (ID_CONTRACT_MANAGEMENT = :ID_CONTRACT_MANAGEMENT);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: CREATE_SESSION_BOOKINGS$WBE for: CREATE_BOOKING$WBE */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (CREATE_BOOKING$WBE) */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
declare variable rate varchar(50);
declare variable room_type varchar(20);
declare variable arrival date;
declare variable departure date;
declare variable adults integer;
declare variable children integer;
declare variable profile_name varchar(100);
declare variable aranger_name varchar(100);
declare variable guest_profile_uuid varchar(40);
declare variable aranger_profile_uuid varchar(40);
declare variable hotel_name varchar(50);
declare variable wbe_session_id bigint;
declare variable main_guest_profile_id integer;
declare variable board varchar(50);
declare variable hotel_id integer;
declare variable guarantee_policy_name varchar(50);
declare variable guarantee_deposit_percent numeric(15,4);
declare variable guarantee_deposit_nights integer;
declare variable guarantee_due_days_bef_arrival integer;
declare variable guarantee_due_days_after_create integer;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable profile_type varchar(20);
declare variable profile_import_time timestamp;
declare variable b_count integer;
declare variable age integer;
declare variable is_child smallint;
declare variable guest_id integer;
declare variable special_treatment varchar(250);
declare variable maintenance varchar(30);
declare variable routing varchar(20);
declare variable arranger_paymeny_type varchar(20);
declare variable market_segment varchar(30);
declare variable market_source varchar(30);
declare variable market_channel varchar(30);
declare variable market_hear_reason varchar(30);
declare variable market_come_reason varchar(30);
declare variable first_food varchar(30);
declare variable bnote varchar(2000);
begin
  -- get wbe product selection
  select  PA.rate_name,PA.room_name, AQ.first_date, AQ.first_date+AQ.day_count,
          PS.adults, PS.children, PS.person_name, H.hotel_name, H.id_hotel,
          WS.id, PA.board_name, GP.name, GP.deposit_totalsum_part, GP.deposit_nights_count, GP.due_days_before_arrival, GP.due_days_after_create,
          PS.bnote
   from   PRODUCT_SELECTION$WBE PS
          join WBE_SESSION$WBE WS on WS.id = PS.wbe_session_id
          join PRODUCT_AVAILABILITY$WBE PA on pa.id = PS.product_availability_id
          join AVAILABILITY_QUERY$WBE AQ on aq.id = WS.product_query_id
          join HOTEL H on H.id_hotel = WS.hotel_id
          join GUARANTEE_POLICY GP on GP.id_guarantee_policy = PS.guarantee_policy_id
   where  PS.id = :product_selection_id
   into   :rate, :room_type, :arrival, :departure,
          :adults,  :children, :profile_name, :hotel_name, :hotel_id,
          :wbe_session_id, :board, :guarantee_policy_name,
          :guarantee_deposit_percent, :guarantee_deposit_nights,
          :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create,
          :bnote;

  select PA.uuid , PA.profile_name, PA.profile_type
  from   PROFILE PA
  where  PA.id_profile = :aranger_profile_id
  into   :aranger_profile_uuid,:aranger_name,  :profile_type;

  if (:aranger_name = :profile_name and :profile_type = 'PERSON') then begin
    -- aranger is main guest
    select count(*)
    from   PRODUCT_SELECTION$WBE PSC
    where  PSC.wbe_session_id = :wbe_session_id
    into   :b_count;
       -- only if single reservation bugfix 2228
    if (1 = :b_count) then begin
     guest_profile_uuid =  aranger_profile_uuid;
     aranger_profile_uuid = null;
    end
  end else begin
    -- create profile for main guest
    execute procedure IMPORT_PERSON_PROFILE$EXC(
      uuid_create(),:profile_name,null,null,null,null,null,null,null,null,null,null, null,
      null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
      null,null,null,null,null, null, null)
    returning_values :main_guest_profile_id, :profile_import_time;

    select P.uuid
    from   PROFILE P
    where  P.id_profile = :main_guest_profile_id
    into   :guest_profile_uuid;
  end

    -- apply default map + forced arranger
    special_treatment = null;
    maintenance = null;
    routing = null;
    arranger_paymeny_type = null;
    market_segment = null;
    market_source = null;
    market_channel = null;
    market_hear_reason = null;
    market_come_reason = null;


  select hc.special_treatment, hk.plan_name, hc.routing,
         pt.payment_type, ms.segment_name, sc.description, cc.description,
         hr.description, cr.description, hc.first_food
  from   HOTEL_PRODUCT_CFG$WBE hc
         left join HK_PLAN hk on hk.id_plan = hc.id_hk_plan
         left join PAYMENT_TYPE pt on pt.id_payment_type = hc.arranger_id_payment_type
         left join NOM_MARKET_SEGMENTS ms on ms.id_nom_market_segment = hc.id_m_segment
         left join NOM_SOURCE_CODES sc on sc.id_nom_source_code = hc.id_m_source
         left join NOM_CHANNEL_CODES cc on cc.id_nom_channel_code = hc.id_m_channel
         left join NOM_HEAR_REASONS hr on hr.id_nom_hear_reason = hc.id_m_hear_reason
         left join NOM_COME_REASONS cr on cr.id_nom_come_reason = hc.id_m_come_reason
  where  hc.hotel_id = :hotel_id
  into   :special_treatment,:maintenance,:routing,:arranger_paymeny_type,
         :market_segment,:market_source,:market_channel,:market_hear_reason,:market_come_reason,:first_food;
  -- create reseravation
  execute procedure IMPORT_BOOKING$EXC(
     :hotel_name, :number, null, null, 0,
     :arrival, null, :departure, null, null, null, null, null, :room_type, :board, null,
     :special_treatment, :maintenance, :routing, :rate, null, null, null, null, :arranger_paymeny_type, null, null, null, null,
     :market_segment, :market_source,:market_channel, :market_hear_reason, :market_come_reason,
     :bnote, null, :first_food, :adults, :children, :aranger_profile_uuid, null, :guest_profile_uuid,
     0, 0, null, :guarantee_policy_name, null, :guarantee_deposit_percent, :guarantee_deposit_nights,
     :guarantee_due_days_bef_arrival,  :guarantee_due_days_after_create, null, null, null, null,  null, null, null, null, null, null, null, null)
  returning_values
     :hotel_id, :booking_id, :err_code, err_text;
  if (0 <> :err_code) then exception WRONG_VALUE ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');

  -- import guests
  for
    select psg.guest_name, psg.is_child, psg.age
    from   PRODUCT_SELECTION_GUESTS$WBE psg
    where  psg.product_selection_id = :product_selection_id
    into   :profile_name,:is_child,:age
  do begin
    execute procedure IMPORT_GUEST$EXC(:booking_id, null, null, :profile_name, :is_child, :age, null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null)
    returning_values :guest_id, :err_code,:err_text;
    if (0 <> :err_code) then exception WRONG_VALUE ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');
  end
  ----------------

  select RD.number_2
  from   RESERV_DETAIL RD
  where  RD.id_reserv_detail = :booking_id
  into   :number_2;

  update PRODUCT_SELECTION$WBE uPS
  set    uPS.booking_id = :booking_id, uPS.selection_id = :number_2
  where  uPS.id = :product_selection_id;
end
^

/* Alter (CREATE_SESSION_BOOKINGS$WBE) */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable product_selection_id bigint;
declare variable next_num integer;
declare variable sel_cnt integer;
declare variable aranger_name varchar(100);
declare variable aranger_email varchar(50);
declare variable aranger_phone varchar(50);
declare variable booking_id integer;
declare variable record_timestamp timestamp;
declare variable new_res_number varchar(62);
declare variable room_types_src varchar(255) = '';
declare variable rates_src varchar(255) = '';
declare variable hotel_id integer;
declare variable profile_id integer;
declare variable from_date date;
declare variable to_date date;
declare variable day_count integer;
declare variable room_type_id integer;
declare variable rate_id integer;
declare variable query_id_tmp integer;
declare variable rooms_required integer;
declare variable rooms_available integer;
declare variable profile_import_time timestamp;
begin
  execute procedure EXPORT_LOG_FORCE$EXC(1);
  /* test overbook (multiuser) */
   for select ws.hotel_id,ws.profile,aq.first_date,(aq.first_date+aq.day_count)-1,pa.room_type_id,pa.rate_id,aq.day_count
    from   PRODUCT_availability$WBE PA
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    join availability_query$wbe aq on aq.id = pa.query_id
   where ws.id = :wbe_session_id and coalesce(pa.room_count,0) > 0
   into  :hotel_id, :profile_id, :from_date, :to_date, :room_type_id, :rate_id , :day_count
   do begin
       room_types_src = :room_types_src||','||cast(:room_type_id as varchar(10));
       rates_src = :rates_src||','||cast(rate_id as varchar(10));
   end

   query_id_tmp = GEN_ID(AVAILABILITY_QUERY$WBE_SEQ,1);
   insert into availability_query$wbe(ID, WBE_SESSION_ID, FIRST_DATE, DAY_COUNT)    -- prevent FK exception
    values (:query_id_tmp,:wbe_session_id,:from_date,:day_count) ;

   execute procedure availability_occup_small$wbe(:from_date,:to_date,:hotel_id,:query_id_tmp,1,:rates_src,:room_types_src) ;

   --  check minimum available rooms for every day
   err_code = null;
   err_text = '';
   for select pa.room_type_id,pa.room_count,
    (select coalesce(min(art.available_rooms),0) from availability_room_type$wbe art
      where art.query_id = :query_id_tmp and art.room_type_id = pa.room_type_id)
    from product_availability$wbe pa
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    where ws.id = :wbe_session_id
    and coalesce(pa.room_count,0) > 0   into :room_type_id,:rooms_required,:rooms_available
   do begin
       if (rooms_required > rooms_available) then
       begin
        err_code = 1;
        ERR_TEXT = coalesce(ERR_TEXT,'')||:room_type_id||';';
       end
   end
   delete from availability_query$wbe aqt where aqt.id = :query_id_tmp;       -- remove temp query
   if (err_code is not null) then exit;

  /* create profile if not exist and reservations > 1*/
  if (aranger_id is NULL) then
  begin
    select WS.person_name,WS.address,WS.phone
    from   WBE_SESSION$WBE WS
    where  WS.id = :wbe_session_id
    into   :aranger_name,:aranger_email,:aranger_phone;

    execute procedure IMPORT_PERSON_PROFILE$EXC(
       uuid_create(),:aranger_name,null,null,null,null,null,null,null,null,null,null,
       null,null,null,null,:aranger_phone,null,:aranger_email,null,null,null,null,null,null,
       STRHASH_LARGE(substring(uuid_create() from 1 for 4)),null,null,null,null,null,null,null,null, null, null)
    returning_values :aranger_id, :profile_import_time;

    update WBE_SESSION$WBE uWS
    set    uWS.profile = :aranger_id
    where  uWS.id = :wbe_session_id;
  end else begin
    -- da podmeni email, phone ako !!
  end
  /* create reservations */
  for
    select PS.id
    from   PRODUCT_SELECTION$WBE PS
    where  PS.wbe_session_id = :wbe_session_id
           and PS.booking_id is null
           and coalesce(PS.is_deleted,0) <> 1
    into   :product_selection_id
  do begin
     if (next_num = 1) then begin      -- increment first reservation number_3
      execute procedure res_number_suffix_gen(:booking_id) returning_values :new_res_number;
      next_num = next_num + 1;
     end
     execute procedure CREATE_BOOKING$WBE(:product_selection_id,:aranger_id,'WBE.'||:selection_id||'.'||:next_num) returning_values :booking_id,:selection_id;
     execute procedure IMPORT_BOOKING_FINALIZE$EXC(:booking_id) returning_values  record_timestamp,:err_code,:err_text;
     insert into SCHEDULER$WBE(booking_id,status,last_action_time,lang_code,guarantee_passed) values (:booking_id, NULL, current_timestamp, :lang_code,0);

     if (next_num is NULL) then begin
      next_num = 1;
     end else begin
      next_num = next_num + 1;
     end
  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_CURRENCY_RATE$EXC for: CURR_RATE_MODIFY */
ALTER PROCEDURE IMPORT_CURRENCY_RATE$EXC(ID_HOTEL INTEGER,
CURRENCY CHAR(3),
ROUND_TO NUMERIC(15,6),
DATETIME TIMESTAMP,
RATE NUMERIC(15,6))
 AS
 BEGIN EXIT; END
^

/* Alter (CURR_RATE_MODIFY) */
ALTER PROCEDURE CURR_RATE_MODIFY(CURR CHAR(3),
ID_HOTEL INTEGER,
RATE NUMERIC(15,6),
FOR_DATE DATE = null)
 AS
declare variable ap_dbkey char(8);
  declare variable guest_posting_rate varchar(20);
  declare variable from_date date;
  declare variable cr_dbkey char(8);
  declare variable old_rate numeric(15,6);
  declare variable id_curr_rate integer;
  declare variable hotel_name varchar(50);
  declare variable action_text varchar(255);
  declare variable nation_curr tcurrency;
begin
  for_date = coalesce(:FOR_DATE, current_date);

  select h.HOTEL_NAME, h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :ID_HOTEL
  into   :hotel_name, :nation_curr;

  if (:nation_curr = :CURR and :RATE <> 1) then exception ASSERT '-35';

  select cr.RDB$DB_KEY, cr.CURR_RATE
  from   CURR_RATES CR
  where  CR.CURR = :CURR
         and cr.ID_HOTEL = :ID_HOTEL
         and cr.DATE_ = :FOR_DATE
  into   :cr_dbkey, :old_rate;

  if (:old_rate is null) then begin
    insert into CURR_RATES (CURR, ID_HOTEL, DATE_, CURR_RATE)
    values (:CURR, :ID_HOTEL, :FOR_DATE, :RATE)
    returning ID_CURR_RATE into :id_curr_rate;

    select first 1 r.CURR_RATE
    from   CURR_RATES r
    where  r.ID_HOTEL = :ID_HOTEL
           and r.CURR = :CURR
           and r.DATE_ < :FOR_DATE
    order by r.DATE_ desc
    into   :old_rate;

  end else if (:old_rate <> :RATE) then begin
    update CURR_RATES r
    set    r.CURR_RATE = :RATE
    where  r.RDB$DB_KEY = :cr_dbkey;
  end else begin
    exit;
  end

  action_text = f_character(29) || :hotel_name || f_character(28)
                || formatdate(:FOR_DATE, 'D;dd.mm.yyyy') || f_character(28)
                || coalesce(:old_rate, 'N/A') || f_character(28)
                || coalesce(:RATE, 'N/A');

  execute procedure SYSTEM_LOG_ADD ('CURRENCY', :id_curr_rate, 'RATE_CHANGED', :action_text, :RATE);

  if (:old_rate is not null) then begin   -- this is not first, initial rate
    /* CHANGE THE CURRENR_RATE OF THE OPEN POSTINGS */
    execute procedure SETTING_GET_VALUE('GUEST_POSTING_RATE', :ID_HOTEL)
    returning_values  :guest_posting_rate;
  
    for
      select AP.rdb$db_key, G.FROM_DATE
      from   ACCOUNT_POST AP
             join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
             left outer join GUEST G on G.ID_GUEST = AP.ID_GUEST
      where  ((AP.CURR_POST = :CURR) or (AP.CURR_ORIG = :CURR))
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null
             and AP.DATE_POST >= current_date
             and A.ID_HOTEL = :ID_HOTEL
      into   :ap_dbkey, :from_date
    do begin
      if (:guest_posting_rate = 'CHECKIN_DATE' and :from_date < current_date) then begin
        /* Do nothing. Theese postings are by guest check_in date rate,
        || which is not changing now
        */
      end else begin
        execute procedure ACCOUNT_POSTING_UPDATE_RATE$INT (:ap_dbkey, :CURR, :RATE);
      end
    end
  end
end
^

/* Alter (DEFAULT_BOOKING_VALUES$EXC) */
ALTER PROCEDURE DEFAULT_BOOKING_VALUES$EXC(BOOKING_DBKEY CHAR(8),
HOTEL_ID INTEGER,
RATE_ID_IN INTEGER,
ROOM_TYPE_ID_IN INTEGER,
BOARD_ID_IN INTEGER,
MAINTANCE_SHEMA_ID_IN INTEGER,
ARRANGER_PAYMENT_TYPE_ID_IN INTEGER,
GUEST_PAYMENT_TYPE_ID_IN INTEGER,
MARKETING1_ID_IN INTEGER,
MARKETING2_ID_IN INTEGER,
MARKETING3_ID_IN INTEGER,
MARKETING4_ID_IN INTEGER,
MARKETING5_ID_IN INTEGER,
ARRANGER_PROFILE_ID_IN INTEGER,
MAIN_GUEST_PROFILE_ID_IN INTEGER,
POSTING_ROUTING_IN VARCHAR(50),
FIRST_FOOD_CODE_IN TFOOD_CODE,
GUARANTEE_POLICY_ID_IN INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_LATE_DEPARTURE_IN INTEGER,
EATING_OBJECT_ID_IN INTEGER)
 RETURNS(RATE_ID INTEGER,
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
MAINTANCE_SHEMA_ID INTEGER,
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
ARRANGER_PROFILE_ID INTEGER,
ARRANGER_ACCOUNT_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
POSTING_ROUTING VARCHAR(50),
FIRST_FOOD_CODE TFOOD_CODE,
GUARANTEE_POLICY_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_LATE_DEPARTURE INTEGER,
EATING_OBJECT_ID INTEGER,
DEFAULT_GUEST_MASK VARCHAR(10))
 AS
declare variable arrival_date_def date;
  declare variable departure_date_def date;
  declare variable adult_count_def integer;
  declare variable child_count_def integer;
  declare variable id_room_def integer;
  declare variable custom_price_def numeric(15,4);
  declare variable custom_currency_def char(3);
  declare variable voucher_num_def varchar(30);
  declare variable voucher_date_def date;
  declare variable voucher_text_def varchar(30);
  declare variable voucher2_num_def varchar(30);
  declare variable voucher2_date_def date;
  declare variable transfer_in_time_def timestamp;
  declare variable transfer_in_note_def varchar(30);
  declare variable transfer_out_time_def timestamp;
  declare variable transfer_out_note_def varchar(30);
  declare variable is_late_departure_def integer;
  declare variable country_code_def varchar(20);
  declare variable check_status_def integer;
  declare variable id_acc_template_person_def integer;
  declare variable arranger_marketing1_id integer;
  declare variable arranger_rate_id integer;
  declare variable arranger_maintance_shema_id integer;
  declare variable deposit_def numeric(15,4);
  declare variable deposit_currency_def char(3);
  declare variable group_name_old varchar(50);
  declare variable group_uuid_old varchar(40);
begin
  if (:booking_dbkey is null) then begin
    execute procedure RES_CREATE_GET$RSV (:hotel_id)
    returning_values
      :arrival_date_def,
      :departure_date_def,
      :arranger_profile_id,
      :main_guest_profile_id,
      :adult_count_def,
      :child_count_def,
      :room_type_id,
      :id_room_def,
      :board_id,
      :rate_id,
      :custom_price_def,
      :custom_currency_def,
      :voucher_num_def,
      :voucher_date_def,
      :voucher_text_def,
      :voucher2_num_def,
      :voucher2_date_def,
      :transfer_in_time_def,
      :transfer_in_note_def,
      :transfer_out_time_def,
      :transfer_out_note_def,
      :is_late_departure_def,
      :first_food_code,
      :country_code_def,
      :marketing1_id,
      :marketing2_id,
      :marketing3_id,
      :marketing4_id,
      :marketing5_id,
      :arranger_account_id,
      :posting_routing,
      :guest_payment_type_id,
      :arranger_payment_type_id,
      :check_status_def,
      :maintance_shema_id,
      :deposit_def,
      :deposit_currency_def,
      :id_acc_template_person_def,
      :guarantee_policy_id,
      :eating_object_id,
      :DEFAULT_GUEST_MASK;
  end else begin
    select RD.id_rate, rd.id_room_type, rd.id_board, rd.id_hk_plan,
      rd.id_agent_payment, rd.id_person_payment, rd.id_nom_market_segment,
      rd.id_nom_source_code, rd.id_nom_channel_code, rd.id_nom_hear_reason,
      rd.id_nom_come_reason, rd.id_agent_profile, rd.id_person_profile,
      rd.acc_routing, rd.id_agent_account_rule, rd.code_first_food,
      rd.id_guarantee_policy, rg.group_name, rg.uuid, (rd.leaving_kind - 1) as is_late_departure
    from   RESERV_DETAIL RD
    left outer join reserv_group rg on rg.id_reserv_group=rd.id_group
    where  RD.RDB$DB_KEY = :booking_dbkey
    into  :rate_id, :room_type_id, :board_id, :maintance_shema_id,
      :arranger_payment_type_id, :guest_payment_type_id, :marketing1_id,
      :marketing2_id, :marketing3_id, :marketing4_id,
      :marketing5_id, :arranger_profile_id, :main_guest_profile_id,
      :posting_routing, :arranger_account_id, :first_food_code,
      :guarantee_policy_id, :group_name_old, :group_uuid_old, :is_late_departure_def;
  end

  /* MERGE ARRANGER PROFILE VALUE  */
  arranger_profile_id = coalesce(:arranger_profile_id_in, :arranger_profile_id);
  posting_routing = coalesce(:posting_routing_in, :posting_routing);

  /* APPLY ARRANGER DEFAULTS TO NEW BOOKINGS */
  if ((:booking_dbkey is null) and (:arranger_profile_id is not null)) then begin
    select p.id_nom_market_segment,
           (select min(id_tariff)
            from profile_hotel_rate aa
            where aa.id_hotel=:hotel_id and aa.id_profile = p.ID_PROFILE
            group by aa.id_profile
            having count(aa.id_profile)=1) as rate_id,
           pbd.ID_HK_PLAN
    from   profile p
    left outer join PROFILE_BOOKING_DEFAULTS pbd on pbd.ID_PROFILE = p.id_profile and pbd.ID_HOTEL = :hotel_id
    where p.id_profile=:arranger_profile_id
    into :arranger_marketing1_id, :arranger_rate_id, :arranger_maintance_shema_id;
    
    marketing1_id = coalesce(:arranger_marketing1_id, :marketing1_id);
    rate_id = coalesce(:arranger_rate_id, :rate_id);
    maintance_shema_id = coalesce(:arranger_maintance_shema_id, :maintance_shema_id);

    if (upper(:posting_routing) in ('AGENT', 'MIXED')) then begin
      select first 1 a.id_account
      from account a
      where
        a.id_profile = :arranger_profile_id
        and a.id_hotel=:hotel_id
        and a.is_credit_account=1
        and a.is_default=1
      into :arranger_account_id;
    end
  end

  /* MERGE THE REST OF THE *_IN VALUES */
  rate_id = coalesce(:rate_id_in, :rate_id);
  room_type_id = coalesce(:room_type_id_in, :room_type_id);
  board_id = coalesce(:board_id_in, :board_id);
  maintance_shema_id = coalesce(:maintance_shema_id_in, :maintance_shema_id);
  arranger_payment_type_id = coalesce(:arranger_payment_type_id_in, :arranger_payment_type_id);
  guest_payment_type_id = coalesce(:guest_payment_type_id_in, :guest_payment_type_id);
  marketing1_id = coalesce(:marketing1_id_in, :marketing1_id);
  marketing2_id = coalesce(:marketing2_id_in, :marketing2_id);
  marketing3_id = coalesce(:marketing3_id_in, :marketing3_id);
  marketing4_id = coalesce(:marketing4_id_in, :marketing4_id);
  marketing5_id = coalesce(:marketing5_id_in, :marketing5_id);
  main_guest_profile_id = coalesce(:main_guest_profile_id_in, :main_guest_profile_id);
  first_food_code = coalesce(:first_food_code_in, :first_food_code);
  guarantee_policy_id = coalesce(:guarantee_policy_id_in, :guarantee_policy_id);
  group_name = coalesce(:group_name, :group_name_old);
  group_uuid = coalesce(:group_uuid, :group_uuid_old);
  is_late_departure = coalesce(:is_late_departure_in, :is_late_departure_def);
  eating_object_id = coalesce(:eating_object_id_in, :eating_object_id);

  execute procedure sys_dbg('exc DEFAULT_BOOKING_VALUES$EXC => IMPORT_GROUP$EXC');
  execute procedure IMPORT_GROUP$EXC(:hotel_id, :group_uuid, :group_name)
  returning_values :reserv_group_id;
end
^

/* empty dependent procedure body */
/* Clear: PAYMENT_DOC_ANUL$DOC for: DEPOSIT_ANUL$DOC */
ALTER PROCEDURE PAYMENT_DOC_ANUL$DOC(ID_PAYMENT_HEAD INTEGER,
ANUL_REASON VARCHAR(100))
 AS
 BEGIN EXIT; END
^

/* Alter (DEPOSIT_ANUL$DOC) */
ALTER PROCEDURE DEPOSIT_ANUL$DOC(ID_DEPOSIT INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_PAYMENT_HEAD INTEGER)
 AS
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_ANUL');

  execute procedure DEPOSIT_ANUL$INT (:ID_DEPOSIT, :DESCRIPTION)
  returning_values :ID_PAYMENT_HEAD;

end
^

/* Alter (DEPOSIT_ANUL$INT) */
ALTER PROCEDURE DEPOSIT_ANUL$INT(ID_DEPOSIT INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_PAYMENT_HEAD INTEGER)
 AS
declare variable id_doc_head integer;
  declare variable id_account integer;
  declare variable deposit_init_amount numeric(15,4);
  declare variable avail_value numeric(15,4);
  declare variable pay_currency varchar(3);
  declare variable payment_date date;
  declare variable dep_current_value numeric(15,4);
  declare variable sys_date date;
  declare variable id_hotel integer;
begin
  select D.ID_PAYMENT_HEAD, D.ID_ACCOUNT, P.PAY_VALUE_A, P.PAYMENT_DATE,
         D.RECEIVED_AMOUNT - d.DEDUCTED_AMOUNT as AVAIL_VALUE, D.ID_DOC_HEAD,
         D.PAY_CURRENCY, D.RECEIVED_AMOUNT
  from   DEPOSITS D
         join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_payment_head, :id_account, :deposit_init_amount, :payment_date,
         :avail_value, :id_doc_head, :pay_currency, :dep_current_value;

  if ((:dep_current_value is null) or (:dep_current_value < :deposit_init_amount)) then
    exception PAYMENT_ANNUL_EXCEPTION '-369';
    --'Part of deposit is refunded or transfered';

  if ((:avail_value is null) or (:avail_value < :deposit_init_amount)) then
    exception PAYMENT_ANNUL_EXCEPTION '-350';
    --'Part of deposit is used into document.';

  if (:id_doc_head is not null) then
    exception PAYMENT_ANNUL_EXCEPTION '-351';
    --'Can not storno deposit, because has invoice for it. First - storno invoice.';

  select A.ID_HOTEL
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :id_hotel;

  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) SD
  into   :SYS_DATE;

  if (:sys_date > :payment_date) then
    exception PAYMENT_ANNUL_EXCEPTION '-349';
    -- Can not void deposit payment for previous date ! May refund it! It's very important for payments control!!!

  execute procedure PAYMENT_ANUL$INT (:ID_PAYMENT_HEAD, :DESCRIPTION);

  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'ANNUL', f_character(29) || formatfloat(:deposit_init_amount, 'F;0.00') || ' ' || :PAY_CURRENCY || f_character(28) || :DESCRIPTION);

end
^

/* Alter (DEPOSIT_NEW$DOC) */
ALTER PROCEDURE DEPOSIT_NEW$DOC(ID_ACCOUNT INTEGER,
ID_DOC_TYPE INTEGER,
PAY_VALUE NUMERIC(15,4),
PAY_CURRENCY VARCHAR(3),
DESCRIPTION VARCHAR(100),
ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_DEPOSIT INTEGER,
ID_PAYMENT_HEAD INTEGER)
 AS
declare variable pay_rate numeric(15,6);
  declare variable payment_date date;
  declare variable is_taxable smallint;
  declare variable id_profile integer;
  declare variable dbkey char(8);
  declare variable acc_curr varchar(3);
  declare variable acc_rate numeric(15,6);
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable id_account_payment integer;
  declare variable is_posting_stopped integer;
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_NEW');

  select r.IS_POSTING_STOPPED
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :is_posting_stopped;

  if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';

  select A.ID_PROFILE, A.ACCOUNT_CURR, A.ID_HOTEL
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :id_profile, :acc_curr, :id_hotel;

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values  (:payment_date);

  execute procedure CURR_RATE_GET (:acc_curr, :payment_date, :id_hotel)
  returning_values  (:acc_rate);

  execute procedure CURR_RATE_GET (:PAY_CURRENCY, :payment_date, :id_hotel)
  returning_values  (:pay_rate);

  execute procedure PAYMENT_CREATE$INT (:ID_DOC_TYPE, :ID_ACCOUNT, :payment_date,
                    :PAY_VALUE, :PAY_CURRENCY, :pay_rate,
                    :acc_curr, :acc_rate, :DESCRIPTION)
  returning_values  :id_payment_head, :id_account_payment, :is_taxable;

  ID_DEPOSIT = gen_id(GEN_DEPOSITS_ID, 1);
  insert into DEPOSIT (ID_DEPOSIT, DESCRIPTION, ID_ACCOUNT, ID_PAYMENT_HEAD, ID_PROFILE, ID_RESERV_DETAIL)
  values (:ID_DEPOSIT, :DESCRIPTION, :ID_ACCOUNT, :ID_PAYMENT_HEAD, :id_profile, :id_reserv_detail);

  select PH.RDB$DB_KEY
  from   PAYMENT_HEAD PH
  where  PH.ID_PAYMENT_HEAD = :id_payment_head
  into   :dbkey;

  update PAYMENT_HEAD P
  set    p.ID_DEPOSIT = :ID_DEPOSIT
  where  p.RDB$DB_KEY = :dbkey;

  update ACCOUNT_PAYMENTS AP
  set    AP.ID_DEPOSIT = :ID_DEPOSIT
  where  ap.ID_ACCOUNT_PAYMENT = :id_account_payment;

  execute procedure PAYMENT_SET_NUMBER$INT(:dbkey);

  action_text = f_character(29) || formatfloat(:PAY_VALUE, 'F;0.00') || ' ' || :PAY_CURRENCY;
  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'CREATE', :action_text);

end
^

/* Alter (DEPOSIT_REFUND_PAY_ANNUL$INT) */
ALTER PROCEDURE DEPOSIT_REFUND_PAY_ANNUL$INT(ID_REFUND_PAYMENT INTEGER,
ANNUL_REASON VARCHAR(255) = '')
 AS
declare variable id_deposit integer;
  declare variable pay_value numeric(15,4);
  declare variable pay_curr varchar(3);
  declare variable id_hotel integer;
  declare variable sys_date date;
  declare variable payment_date date;
begin
  select ap.ID_DEPOSIT, P.PAY_CURRENCY, a.ID_HOTEL, p.PAYMENT_DATE, coalesce(sum(aP.PAY_AMOUNT), 0)
  from   PAYMENT_HEAD P
         join ACCOUNT A on a.ID_ACCOUNT = p.ID_ACCOUNT
         join ACCOUNT_PAYMENTS ap on ap.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
  where  P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT
  group by P.ID_PAYMENT_HEAD, ap.ID_DEPOSIT, P.PAY_CURRENCY, a.ID_HOTEL, p.PAYMENT_DATE
  into   :id_deposit, :pay_curr, :id_hotel, :payment_date, :pay_value;
  /* !!! - check if is real deposit refund */
  if (:id_deposit is null) then EXIT;

  if (:pay_value = 0) then exception PAYMENT_EXCEPTION 'Zero payment amount!';
  /*  */
  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) SD
  into   :sys_date;

  if (:sys_date > :payment_date) then
    exception PAYMENT_ANNUL_EXCEPTION '-349';
    -- Can not void deposit payment for previous date ! May refund it! It's very important for payments control!!!

  execute procedure PAYMENT_ANUL$INT(:ID_REFUND_PAYMENT, :ANNUL_REASON);

  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'REFUND_ANNUL', f_character(29) || formatfloat(:pay_value, 'F;0.00') || ' ' || :pay_curr || f_character(28) || :ANNUL_REASON);

end
^

/* Alter (DEPOSIT_TRANSFER$ACC) */
ALTER PROCEDURE DEPOSIT_TRANSFER$ACC(ID_DEPOSIT INTEGER,
ID_DEST_ACCOUNT INTEGER,
SPLIT_AMOUNT NUMERIC(15,2),
DESCRIPTION VARCHAR(255))
 RETURNS(NEW_ID_DEPOSIT INTEGER)
 AS
begin
  /* Fasade with rights check */
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_TRANSFER');

  execute procedure DEPOSIT_TRANSFER$INT (:ID_DEPOSIT, :ID_DEST_ACCOUNT, :SPLIT_AMOUNT, :DESCRIPTION)
  returning_values (:NEW_ID_DEPOSIT);
end
^

/* Alter (DEPOSIT_TRANSFER$INT) */
ALTER PROCEDURE DEPOSIT_TRANSFER$INT(ID_DEPOSIT TYPE OF ID,
ID_DEST_ACCOUNT TYPE OF ID,
SPLIT_AMOUNT TYPE OF TPRICE,
DEPOSIT_DESCRIPTION TYPE OF TDESCRIPTION_SHORT,
TRANSFER_REASON TYPE OF TREASON = null)
 RETURNS(NEW_ID_DEPOSIT TYPE OF ID)
 AS
declare variable id_source_account integer;
  declare variable id_payment_head integer;
  declare variable doc_selected integer;
  declare variable id_profile integer;
  declare variable orig_descr varchar(100);
  declare variable action_text varchar(255);
  declare variable pay_currency varchar(3);
  declare variable curr_dest varchar(3);
  declare variable curr_src varchar(3);
  declare variable pay_date date;
  declare variable dest_acc_rate numeric(15,6);
  declare variable src_acc_rate numeric(15,6);
  declare variable is_anul integer;
  declare variable sys_date date;
  declare variable id_reserv_detail integer;
  declare variable id_hotel integer;
  declare variable pay_rate numeric(15,6);
  declare variable id_account_payment_src integer;
  declare variable id_account_payment_dest integer;
  declare variable is_posting_stopped integer;
  declare variable id_system_log integer;
  declare variable id_billing_service integer;
begin

  select D.ID_ACCOUNT, D.ID_PAYMENT_HEAD, D.DOC_SELECTED, D.ID_PROFILE, D.DESCRIPTION,
         P.PAY_CURRENCY, P.IS_ANUL, P.PAYMENT_DATE, D.ID_RESERV_DETAIL, A.ID_HOTEL,
         p.PAY_RATE, d.ID_BILLING_SERVICE, a.ACCOUNT_CURR
  from   DEPOSIT D
         join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_source_account, :id_payment_head, :doc_selected, :id_profile, :orig_descr,
         :pay_currency, :is_anul, :pay_date, :id_reserv_detail, :id_hotel,
         :pay_rate, :id_billing_service, :curr_src;

  if (:is_anul = 1) then
    exception PAYMENT_EXCEPTION '-355'; -- payment is annul

  select r.IS_POSTING_STOPPED
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :is_posting_stopped;

  if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';

  if (not exists (select A.ID_ACCOUNT
                  from   ACCOUNT A
                  where  A.ID_ACCOUNT = :ID_DEST_ACCOUNT
                         and A.ID_HOTEL = :id_hotel)) then exception ACCOUNT_EXCEPTION '-376';

  if (coalesce(:DEPOSIT_DESCRIPTION, '') = '') then DEPOSIT_DESCRIPTION = :orig_descr;

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values :sys_date;

  select first 1 ap.ACC_RATE
  from   ACCOUNT_PAYMENTS ap
  where  ap.ID_PAYMENT_HEAD = :id_payment_head
         and ap.ID_ACCOUNT = :id_source_account
  order by ap.ID_ACCOUNT_PAYMENT asc
  into   :src_acc_rate;

  insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
         ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT)
  values (:id_source_account, :id_payment_head, -:SPLIT_AMOUNT, :pay_rate,
         -:SPLIT_AMOUNT * cast(:pay_rate / :src_acc_rate as double precision), :src_acc_rate,
         :sys_date, :ID_DEPOSIT)
  returning id_account_payment into :id_account_payment_src;

  NEW_ID_DEPOSIT = gen_id(GEN_DEPOSITS_ID, 1);
  insert into DEPOSIT (ID_DEPOSIT, DESCRIPTION, ID_ACCOUNT, ID_PAYMENT_HEAD, DOC_SELECTED, ID_PROFILE, ID_RESERV_DETAIL, ID_BILLING_SERVICE)
  values (:NEW_ID_DEPOSIT, :DEPOSIT_DESCRIPTION, :ID_DEST_ACCOUNT, :id_payment_head, :doc_selected, :id_profile, :id_reserv_detail, :id_billing_service);

  select A.ACCOUNT_CURR
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_DEST_ACCOUNT
  into   :curr_dest;
   
  if (:curr_dest is distinct from :curr_src) then begin
    execute procedure CURR_RATE_GET(:curr_dest, :pay_date, :id_hotel)
    returning_values  :dest_acc_rate;
  end else begin
    dest_acc_rate = :src_acc_rate;
  end

  insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
         ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT)
  values (:ID_DEST_ACCOUNT, :id_payment_head, :SPLIT_AMOUNT, :pay_rate,
         :SPLIT_AMOUNT * cast(:pay_rate / :dest_acc_rate as double precision), :dest_acc_rate,
         :sys_date, :NEW_ID_DEPOSIT)
  returning id_account_payment into :id_account_payment_dest;

  action_text = f_character(29) || :id_source_account ||
                f_character(28) || :id_dest_account ||
                f_character(28) || formatfloat(:split_amount, '0.00') || ' ' || :pay_currency ||
                f_character(28) || coalesce(:TRANSFER_REASON, '');
  execute procedure SYSTEM_EVENT_LOG$INT ('DEPOSIT', :ID_DEPOSIT, 'TRANSFER', :ACTION_TEXT)
  returning_values :id_system_log;

  insert into ACCOUNT_PAYMENT_TRANSFER (ID_ACCOUNT_PAYMENT_SOURCE, ID_ACCOUNT_PAYMENT_DEST, ID_SYSTEM_LOG)
  values (:id_account_payment_src, :id_account_payment_dest, :id_system_log);

end
^

/* Alter (DEVICE_READING_ANUL$PMS) */
ALTER PROCEDURE DEVICE_READING_ANUL$PMS(ID_DEVICE_READING TYPE OF ID)
 AS
declare variable id_account_post id_ref;
  declare variable id_account_post$pms id_ref;
  declare variable id_pms_event id_ref;
begin
  for
    select DRP.ID_ACCOUNT_POST, DRP.ID_ACCOUNT_POST$PMS
    from   DEVICE_READING DR
           join DEVICE_READING_EVIDENCE DRQ on DRQ.ID_DEVICE_READING = DR.ID_DEVICE_READING
           join DEVICE_READING_POST DRP on DRP.ID_DEVICE_READING_EVIDENCE = DRQ.ID_DEVICE_READING_EVIDENCE
    where  DR.ID_DEVICE_READING = :id_device_reading
           and DR.STATUS <> 2
    into   :id_account_post, :id_account_post$pms
  do begin
    if (:id_account_post is not null) then begin
      if (exists(select AP.ID_ACCOUNT_POST
                 from   ACCOUNT_POST AP
                 where  AP.ID_ACCOUNT_POST = :id_account_post
                        and ap.is_anul = 0)) then begin
        execute procedure ACCOUNT_POSTING_ANUL(:id_account_post, '');
      end
    end else if (:id_account_post$pms is not null) then begin
      if (exists (select APP.ID_ACCOUNT_POST
                  from   ACCOUNT_POST$PMS APP
                  where  APP.ID_ACCOUNT_POST = :id_account_post$pms
                         and app.line_status <> 22)) then begin
        select APP.ID_PMS_EVENT
        from   ACCOUNT_POST$PMS APP
        where  app.id_account_post = :id_account_post$pms
        into   :id_pms_event;

        execute procedure PMS_EVENT_ANUL$PMS(:id_pms_event);
      end
    end
  end
  update DEVICE_READING DR
  set    DR.STATUS = 2
  where  DR.ID_DEVICE_READING = :ID_DEVICE_READING
         and DR.STATUS <> 2;
end
^

/* Alter (DOC_TYPE_INV_MODIFY$DOC) */
ALTER PROCEDURE DOC_TYPE_INV_MODIFY$DOC(ID_DOC_TYPE INTEGER,
DOC_TYPE_NAME VARCHAR(50),
DEBIT_DOC_NAME VARCHAR(50),
CREDIT_DOC_NAME VARCHAR(50),
ANNUL_PROTOCOL_NAME VARCHAR(50),
EXPORT_TAG VARCHAR(20),
DEBIT_EXPORT_TAG VARCHAR(20),
CREDIT_EXPORT_TAG VARCHAR(20),
ANNUL_EXPORT_TAG VARCHAR(20),
DOC_CURR CHAR(3),
PRINT_ORIGINAL SMALLINT,
RAPORT_NAME VARCHAR(50),
DESCRIPTION VARCHAR(100),
IS_VAT SMALLINT,
PRINT_ANNUL_REPORT_CLASS VARCHAR(50),
IS_ARCHIVE SMALLINT,
REQUIRED_IDENT_NO SMALLINT,
REQUIRED_VAT_NO SMALLINT,
REQUIRED_EGN SMALLINT,
REQUIRED_RECIPIENT_NAME TYPE OF TLOGICAL,
OPERATION VARCHAR(10),
ID_HOTEL TYPE OF ID,
ID_DOC_NUM TYPE OF ID_REF,
ID_ANNUL_DOC_NUM TYPE OF ID_REF,
SECOND_CURRENCY CHAR(3) = null,
CURRENCY_LIST VARCHAR(1000) = null,
PAY_DOC_TYPE_RESTRICT_LIST VARCHAR(1000) = null,
ID_PROFORMA_NUM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_DOC_TYPE INTEGER)
 AS
declare variable is_use integer;
  declare variable old_is_vat integer;
  declare variable old_id_doc_num integer;
  declare variable old_doc_name varchar(50);
  declare variable is_num_used integer;
  declare variable id_pay_doc_type integer;
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  select DT.DOC_TYPE_NAME, DT.IS_VAT, DT.ID_DOC_NUM
  from   DOC_TYPE DT
         join DOC_TYPE_INV I on I.ID_DOC_TYPE = DT.ID_DOC_TYPE
  where  DT.ID_DOC_TYPE = :ID_DOC_TYPE
  into   :old_doc_name, :old_is_vat, :old_id_doc_num;

  if (:operation = 'mod') then begin
    /* doc_type exists */
    if ((:old_doc_name <> :doc_type_name)
        or (:old_is_vat <> :IS_VAT)
        or (:old_id_doc_num is distinct from :ID_DOC_NUM) ) then
    begin
      execute procedure DOC_TYPE_CHECK_USED (:ID_DOC_TYPE)
      returning_values  :is_use;
      if (:is_use = 1) then exception DOC_TYPE_EXCEPTION '-360';
    end
  end

  if (:OPERATION <> 'del') then begin
    select max(DT.ID_DOC_TYPE)
    from   DOC_TYPE DT
           join DOC_TYPE_PAY DTP on DTP.ID_DOC_TYPE = DT.ID_DOC_TYPE
    where  DT.ID_DOC_NUM = :id_doc_num
    into   :is_num_used;
    if (:is_num_used is not null) then exception DOC_TYPE_EXCEPTION '-358';
  end

  execute procedure DOC_TYPE_MODIFY$INT (:id_doc_type, :doc_type_name,
          :doc_curr, :raport_name, :description, :export_tag, :is_vat,
          0, :print_original, :is_archive, :ID_HOTEL,
          :id_doc_num, :id_annul_doc_num, :currency_list, :operation)
  returning_values  :new_id_doc_type;

  if (:OPERATION = 'add') then begin
    insert into DOC_TYPE_INV (ID_DOC_TYPE,
           DEBIT_DOC_NAME, DEBIT_EXPORT_TAG, CREDIT_DOC_NAME, CREDIT_EXPORT_TAG,
           ANNUL_PROTOCOL_NAME, ANNUL_EXPORT_TAG, PRINT_ANNUL_REPORT_CLASS,
           REQUIRED_IDENT_NO, REQUIRED_VAT_NO, REQUIRED_EGN, REQUIRED_RECIPIENT_NAME,
           SECOND_CURRENCY, ID_PROFORMA_NUM)
    values (:new_id_doc_type,
           :debit_doc_name, :debit_export_tag, :credit_doc_name, :credit_export_tag,
           :annul_protocol_name, :annul_export_tag, :print_annul_report_class,
           :required_ident_no, :required_vat_no, :required_egn, :required_recipient_name,
           :second_currency, :id_proforma_num);
  end else if (:OPERATION = 'mod') then begin
    update DOC_TYPE_INV DTI
    set    DTI.DEBIT_DOC_NAME = :debit_doc_name,
           DTI.DEBIT_EXPORT_TAG = :debit_export_tag,
           DTI.CREDIT_DOC_NAME = :credit_doc_name,
           DTI.CREDIT_EXPORT_TAG = :credit_export_tag,
           DTI.ANNUL_PROTOCOL_NAME = :annul_protocol_name,
           DTI.ANNUL_EXPORT_TAG = :annul_export_tag,
           DTI.PRINT_ANNUL_REPORT_CLASS = :print_annul_report_class,
           DTI.REQUIRED_IDENT_NO = :required_ident_no,
           DTI.REQUIRED_VAT_NO = :required_vat_no,
           DTI.REQUIRED_EGN = :required_egn,
           DTI.REQUIRED_RECIPIENT_NAME = :required_recipient_name,
           DTI.SECOND_CURRENCY = :second_currency,
           dti.ID_PROFORMA_NUM = :ID_PROFORMA_NUM
    where  DTI.ID_DOC_TYPE = :ID_DOC_TYPE;
  end

  if (:OPERATION <> 'del') then begin
    delete from DOC_TYPE_PAY_RESTRICT dtp
    where  dtp.ID_DOC_TYPE = :NEW_ID_DOC_TYPE;
    -- PAY_DOC_TYPE_RESTRICTED - comma separated ids
    for
      select sp.ITEM
      from   SYSTEM_STRING_PARSER (:PAY_DOC_TYPE_RESTRICT_LIST) sp
      into   :id_pay_doc_type
    do begin
      insert into DOC_TYPE_PAY_RESTRICT (ID_DOC_TYPE, ID_PAY_DOC_TYPE)
      values (:new_id_doc_type, :id_pay_doc_type);
    end 
  end
end
^

/* Alter (DOCUMENT_ADVANCE_PAYMENT$INT) */
ALTER PROCEDURE DOCUMENT_ADVANCE_PAYMENT$INT(ID_DOC_HEAD INTEGER,
ID_PAYMENT_HEAD INTEGER,
ACC_RATE NUMERIC(15,6))
 AS
declare variable id_deposit integer;
  declare variable dep_curr varchar(3);
  declare variable pay_rate numeric(15,6);
  declare variable id_doc_line integer;
  declare variable doc_value numeric(15,4);
  declare variable init_pay_value numeric(15,4);
  declare variable deducted_value numeric(15,4);
  declare variable pay_round_to numeric(15,4);
  declare variable id_account_payment integer;
  declare variable initial_deposit_id integer;
  declare variable pay_value numeric(15,4);
  declare variable total_pay_value numeric(15,4);
  declare variable total_doc_value numeric(15,4);
  declare variable id_dep_doc integer;
begin
  total_pay_value = 0;
  total_doc_value = 0;
  for
    select D.ID_DEPOSIT, D.PAY_CURRENCY, d.INIT_PAY_AMOUNT, d.DEDUCTED_AMOUNT, d.ID_DOC_HEAD
    from   DEPOSITS D
    where  d.ID_PAYMENT_HEAD = :id_payment_head
    order by d.ID_DEPOSIT asc
    into   :id_deposit, :dep_curr, :init_pay_value, :deducted_value, :id_dep_doc
  do begin
    initial_deposit_id = coalesce(:initial_deposit_id, :id_deposit);
    if (coalesce(:deducted_value, 0) > 0) then
      exception DOCUMENT_EXCEPTION '-350';

    if (:id_dep_doc is not null) then
      exception DOCUMENT_EXCEPTION '-364';

    if (:pay_rate is null) then
      execute procedure DOCUMENT_CURR_RATE_GET$INT (:ID_DOC_HEAD, :dep_curr)
      returning_values  (:pay_rate, :pay_round_to);
    /*
    if (round_f(:dep_value, :pay_round_to) <= 0) then
      exception DOCUMENT_EXCEPTION 'Unavailable payment amount!';
    */
    update ACCOUNT_PAYMENTS AP
    set    AP.ACC_AMOUNT = AP.PAY_AMOUNT * cast(:pay_rate / :acc_rate as double precision),
           Ap.ACC_RATE  = :acc_rate
    where  AP.ID_DEPOSIT = :id_deposit;

    select min(ap.ID_ACCOUNT_PAYMENT), sum(ap.PAY_AMOUNT)
    from   ACCOUNT_PAYMENTS AP
    where  AP.ID_DEPOSIT = :id_deposit
    into   :id_account_payment, :pay_value;
    total_pay_value = :total_pay_value + :pay_value;

    execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:ID_DOC_HEAD, :id_account_payment, :pay_rate, :pay_value)
    returning_values (:doc_value);
    total_doc_value = :total_doc_value + :doc_value;
  end

  if (:total_pay_value <> 0) then begin
    if (round_f(:total_pay_value - :init_pay_value, :pay_round_to) <> 0) then
      exception DOCUMENT_EXCEPTION '-390' || f_character(31)
                || f_character(29) || formatfloat(:total_pay_value, 'F;0.00')
                || f_character(28) || formatfloat(:init_pay_value, 'F;0.00');
  
    execute procedure DOCUMENT_ADD_PAYMENT_LINE$INT (:initial_deposit_id, :ID_DOC_HEAD, :total_doc_value)
    returning_values  (:id_doc_line);

    update PAYMENT_HEAD P
    set    P.ID_DOC_HEAD = :ID_DOC_HEAD
    where  P.ID_PAYMENT_HEAD = :id_payment_head;
  end
end
^

/* Alter (DOCUMENT_AR_PAYMENTS_APPLY$INT) */
ALTER PROCEDURE DOCUMENT_AR_PAYMENTS_APPLY$INT(DOC_DBKEY CHAR(8),
OPERATION_INFO VARCHAR(100) = null)
 AS
declare variable pay_value numeric(15,4);
  declare variable pay_curr varchar(3);
  declare variable due_date date;
  declare variable id_base_doc integer;
  declare variable id_profile integer;
  declare variable id_hotel integer;
  declare variable description varchar(255);
  declare variable operation varchar(10);
begin
  for
    select DP.PAY_AMOUNT, P.PAY_CURRENCY, P.DUE_DATE, A.ID_PROFILE, D.ID_BASE_DOC, A.ID_HOTEL,
           trim(coalesce(:OPERATION_INFO || ': ', '') || D.DOC_TYPE_NAME || ' ' || D.DOC_NUM || '/' || formatdate(D.DOC_DATE, 'D;dd.mm.yyyy')),
           case when D.IS_ANUL = 1 then 'anul'
                when P.IS_STORNO = 1 then 'add_credit'
                else 'add_owing'
           end
    from   DOC_HEAD$INT D
           join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
           join DOC_PAY_USAGE DP on DP.ID_DOC_HEAD = d.ID_DOC_HEAD
           join ACCOUNT_PAYMENTS AP on ap.ID_ACCOUNT_PAYMENT = dp.ID_ACCOUNT_PAYMENT
           join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = AP.ID_PAYMENT_HEAD
                                  and coalesce(p.ID_DOC_HEAD, d.ID_DOC_HEAD) = d.ID_DOC_HEAD
           left join DOC_TYPE_PAY dt on DT.ID_DOC_TYPE = P.ID_DOC_TYPE
    where  D.RDB$DB_KEY = :DOC_DBKEY
           and DT.IS_AR_DEBT = 1
           and DT.DOC_DIRECTION = 0 /* only income docs */
    into   :pay_value, :pay_curr, :due_date, :id_profile, :id_base_doc, :id_hotel,
           :description, :operation
  do begin
    execute procedure AR_OWING_MODIFY$DOC (:id_base_doc, :id_profile,
            :pay_value, :pay_curr, :due_date, :description, :id_hotel, :operation);
  end
end
^

/* Alter (DOCUMENT_ATTACH_AVAIL_PAYS$INT) */
ALTER PROCEDURE DOCUMENT_ATTACH_AVAIL_PAYS$INT(ID_DOC_HEAD INTEGER,
ID_ACCOUNT INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_deposit integer;
  declare variable pay_curr varchar(3);
  declare variable dep_value numeric(15,4);
  declare variable rest_value numeric(15,4);
begin

  for
    select D.ID_DEPOSIT, D.PAY_CURRENCY, D.AVAIL_VALUE
    from   DEPOSIT_AVAILABLE D
    where  D.ID_ACCOUNT = :ID_ACCOUNT
    order by D.DATETIME_CREATED asc
    into   :ID_DEPOSIT, :PAY_CURR, :DEP_VALUE
  do begin

    execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, :PAY_CURR)
    returning_values  (:dbg, :dbg, :dbg, :dbg, :REST_VALUE);

    if (:REST_VALUE > 0) then begin
      DEP_VALUE = iif(:DEP_VALUE > :REST_VALUE, :REST_VALUE, :DEP_VALUE);
      execute procedure DOCUMENT_USE_DEPOSIT$DOC (:ID_DOC_HEAD, :ID_DEPOSIT, :DEP_VALUE);

   end else begin
      exit;
    end

    when exception DOCUMENT_EXCEPTION do post_event 'dummy';
  end

end
^

/* Alter (DOCUMENT_CLEAR_DEPOSITS$DOC) */
ALTER PROCEDURE DOCUMENT_CLEAR_DEPOSITS$DOC(ID_DOC_HEAD INTEGER)
 AS
declare variable is_storno_doc smallint;
begin

  execute procedure DOCUMENT_REUSE_DEPOSITS$INT (:ID_DOC_HEAD, null);

end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_GET_CURR_VALUE$DOC for: DOCUMENT_GET_VALUE$INT */
ALTER PROCEDURE DOCUMENT_GET_CURR_VALUE$DOC(ID_DOC_HEAD INTEGER,
PAY_CURR VARCHAR(3))
 RETURNS(ID_PAY_DOC_DEF INTEGER,
TOTAL_CURR VARCHAR(3),
TOTAL_RATE NUMERIC(15,6),
TOTAL_VALUE NUMERIC(15,4),
REST_VALUE NUMERIC(15,4))
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_GET_VALUE$INT) */
ALTER PROCEDURE DOCUMENT_GET_VALUE$INT(ID_DOC_HEAD INTEGER,
TARGET_CURR VARCHAR(3),
TARGET_RATE NUMERIC(15,6) = null)
 RETURNS(ID_PAY_DOC_DEF INTEGER,
TOTAL_CURR VARCHAR(3),
TOTAL_RATE NUMERIC(15,6),
TOTAL_VALUE NUMERIC(15,4),
PAYABLE_VALUE NUMERIC(15,4))
 AS
declare variable doc_curr varchar(3);
  declare variable doc_round_to numeric(15,4);
  declare variable target_round_to numeric(15,4);
  declare variable doc_rate numeric(15,6);
  declare variable pays_value numeric(15,4);
  declare variable used_dep_value numeric(15,4);
  declare variable ded_dep_value numeric(15,4);
  declare variable discounts numeric(15,4);
  declare variable is_dep_doc integer;
  declare variable id_account integer;
  declare variable doc_sub_type integer;
  declare variable dummy varchar(255);
  declare variable doc_value_a numeric(15,4);
  declare variable total_value_int numeric(15,4);
begin
  select d.DOC_VALUE_ROUNDLESS, d.DOC_VALUE_A,
         D.DOC_CURRENCY, D.DOC_RATE, D.FOR_DEPOSIT, D.ID_ACCOUNT, D.DOC_SUB_TYPE, c.ROUND_TO
  from   DOC_HEAD$INT D
         join DOC_TYPE DT on DT.ID_DOC_TYPE = D.ID_DOC_TYPE
         join CURRS c on C.CURR = d.DOC_CURRENCY
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :total_value_int, :doc_value_a,
         :doc_curr, :doc_rate, :is_dep_doc, :id_account, :doc_sub_type, :doc_round_to;
   
  if (cast(round_f(:total_value_int, :doc_round_to) as numeric(15,4)) <> :doc_value_a) then total_value_int = :doc_value_a;

  select sum(round_f(DD.FOOTER_VALUE, :doc_round_to))
  from   DOC_FOOTER DD
  where  DD.ID_DOC_HEAD = :ID_DOC_HEAD
         and DD.ID_DOC_LINE is null
  into   :discounts;

  select sum(round_f(P.DOC_AMOUNT, :doc_round_to))
  from   DOC_PAY_USAGE P
  where  P.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :pays_value;
  /*  */
  ded_dep_value = 0;  used_dep_value = 0;
  if (:is_dep_doc = 0) then begin
    select sum(round_f(DL.SINGLE_VALUE * DL.QTY_POST, :doc_round_to))
    from   DOC_LINE DL
           join DOC_LINE_DEP_VALUES DV on DV.ID_DOC_LINE = DL.ID_DOC_LINE
    where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
    into   :ded_dep_value;
  end

  PAYABLE_VALUE = :total_value_int
                  - coalesce(:ded_dep_value, 0)
                  - coalesce(:pays_value, 0)
                  - coalesce(:used_dep_value, 0)
                  + coalesce(:discounts, 0);

  if (:TARGET_CURR is null) then begin
    TOTAL_CURR = :doc_curr;
    TARGET_RATE = :doc_rate;
    target_round_to = :doc_round_to;
  end else begin
    TOTAL_CURR = :TARGET_CURR;
    if (:TARGET_RATE is null) then begin
      execute procedure DOC_GET_CURR_RATE$DOC (:ID_DOC_HEAD, :TOTAL_CURR)
      returning_values  (:TARGET_RATE);
    end

    select C.ROUND_TO
    from   CURRS C
    where  C.CURR = :TOTAL_CURR
    into   :target_round_to;
  end

  TOTAL_RATE = :TARGET_RATE;
  if (:TARGET_RATE = :doc_rate) then begin
    TOTAL_VALUE = round_f(:total_value_int, :target_round_to);
  end else begin
    TOTAL_VALUE = round_f(:total_value_int * cast(:doc_rate / :TARGET_RATE as double precision), :target_round_to);
  end

  if ((round_f(:PAYABLE_VALUE, :doc_round_to) = 0) or (cast(abs(:PAYABLE_VALUE) as numeric(15,4)) = :doc_round_to/2)) then begin
    PAYABLE_VALUE = 0;
  end else if (:TARGET_RATE = :doc_rate) then begin
    PAYABLE_VALUE = round_f(:PAYABLE_VALUE, :target_round_to);
  end else begin
    PAYABLE_VALUE = round_f(:PAYABLE_VALUE * cast(:doc_rate / :TARGET_RATE as double precision), :target_round_to);
  end

  if (:doc_sub_type < 2) then begin
    execute procedure PAYMENT_GET_DEFAULT$INT (:id_account)
    returning_values  (:ID_PAY_DOC_DEF, :dummy);
  end

  suspend;
end
^

/* Alter (DOCUMENT_SET_NUMBER$INT) */
ALTER PROCEDURE DOCUMENT_SET_NUMBER$INT(DH_DBKEY TYPE OF TDB_KEY)
 RETURNS(NUM TYPE OF TRANGE,
DOC_NUM VARCHAR(20))
 AS
declare variable id_doc_num integer;
  declare variable id_doc_completed integer;
  declare variable pay_dbkey char(8);
begin

  select D.ID_DOC_NUM, dc.ID_DOC_HEAD
  from   DOC_HEAD$INT D
         left outer join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
  where  D.RDB$DB_KEY = :DH_DBKEY
  into   :id_doc_num, :id_doc_completed;

  if (:id_doc_num is not null) then begin
    if (:id_doc_completed is not null) then begin
      execute procedure SYSTEM_GEN_NUM ('DOCUMENT', :id_doc_num)
      returning_values  (:num, :doc_num);
    end else begin
      execute procedure SYSTEM_GEN_NUM ('PROFORMA', :id_doc_num)
      returning_values  (:num, :doc_num);
    end

    update DOC_HEAD$INT D
    set    D.NUM = :num,
           D.DOC_NUM = :doc_num,
           d.DATETIME_CREATED = current_timestamp -- moves created_at to finalization timestamp
    where  D.RDB$DB_KEY = :DH_DBKEY;
  end

  for
    select PH.RDB$DB_KEY
    from   PAYMENT_HEAD PH
    where  PH.ID_DOC_HEAD = :id_doc_completed
           and PH.NUM is null  /* because of following deposit billing */
    into   :pay_dbkey
  do begin
    execute procedure PAYMENT_SET_NUMBER$INT (:pay_dbkey);
  end
end
^

/* Alter (EAI_AIRCONDITION_SMARTSTART) */
ALTER PROCEDURE EAI_AIRCONDITION_SMARTSTART AS
declare variable id_reserv_detail integer;
begin
  for
    select RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.FROM_DATE = current_date
           and RD.IS_ANUL = 0
           and RD.CHECK_STATUS < 0
           and RD.ID_ROOM > 0
    into   :id_reserv_detail
  do begin
    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'AC.SMARTSTART', '');
  end
end
^

/* Alter (EAI_EVENTQ_ADD) */
ALTER PROCEDURE EAI_EVENTQ_ADD(EAI_IFC VARCHAR(50),
EVENT_CODE VARCHAR(50),
OBJECT_ID INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_first_pushedback integer;
  declare variable m_dbkey char(8);
begin

  execute procedure SYSTEM_LOG_ADD ('EAI_EVENTQ', :object_id, :event_code, :eai_ifc);
end
^

/* Alter (EAI_MAP_SERVICE) */
ALTER PROCEDURE EAI_MAP_SERVICE(SERVICE_TAG VARCHAR(30),
SERVICE_NAME VARCHAR(30),
EXTERNAL_IFC VARCHAR(30),
ID_HOTEL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_MAPPED_SERVICE INTEGER)
 AS
declare variable id_service_group integer;
  declare variable setting_code varchar(30);
  declare variable revenue_group varchar(30);
  declare variable is_base integer;
  declare variable is_deleted integer;
  declare variable hotel_name varchar(50);
begin
  /*  Description:
  ||
  */
  err_code = 0;
  err_text = '';
  id_mapped_service = null;
  select first 1 S.ID_SERVICE, S.IS_BASE, s.IS_DELETED
  from   SERVICES S
  where  S.EXT_CODE = :service_tag
         and s.ID_HOTEL = :id_hotel
  order by s.IS_DELETED asc, s.ID_SERVICE asc
  into   :id_mapped_service, :is_base, :is_deleted;

  if (:is_base = 1) then begin
    ERR_CODE = -63;
    ERR_TEXT= '';
    exit;
  end
  if (:is_deleted = 1) then begin
    ERR_CODE = -64;
    ERR_TEXT= '';
    exit;
  end
  if (:id_mapped_service is not null) then exit;

  if (:external_ifc = 'POS') then revenue_group = 'Food and Beverage';
  else revenue_group = 'Other Operated departments';

  setting_code = 'IFC_'||:external_ifc||'_SRVGRP';
  execute procedure SETTING_GET_VALUE(:setting_code, :ID_HOTEL)
  returning_values  :id_service_group;

  begin
    execute procedure SERVICE_MODIFY(null, :id_service_group, 'EXTRA', :service_name, 0, 1, 0,
                      :revenue_group, null, null, :service_tag, 'BASE', '', 0, 'add', :ID_HOTEL,
                      0, 0, 0, 0, 0, 0, null, null)
    returning_values  :id_mapped_service;
  
    when sqlcode -803 do begin
      -- catch SERVICE_NAME_UNQ_HASH unique index exception
      select h.HOTEL_NAME
      from   HOTEL h
      where  h.ID_HOTEL = :ID_HOTEL
      into   :hotel_name;
  
      err_code = -68;
      err_text = f_character(29) || :SERVICE_NAME || f_character(28) || :hotel_name;
      exit;
    end
  end
end
^

/* Alter (EAI_POS_POSTING_ANUL$P2E) */
ALTER PROCEDURE EAI_POS_POSTING_ANUL$P2E(IN_ID_SMETKA INTEGER,
IN_USER_ANUL VARCHAR(100))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable resource_text varchar(100);
  declare variable id_account_post integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = 0;
  resource_text = 'POS_ID_SMETKA:'||:in_id_smetka ;
  in_user_anul = substring('POS ANULIRANE - '||:in_user_anul from 1 for 49);

  /* PROTECTION AGAINST DA NE SE ANULIRAT WSI4KI POSTOWE */
  if ((:resource_text is null) or (:resource_text = '')) then begin
    err_code = -85;
    err_text = 'Bill number can not be blank';
    exit;
  end
  err_code = 0;
  for
    select AP.ID_ACCOUNT_POST
    from   ACCOUNT_POSTING_DET AD
           join ACCOUNT_POST AP on AD.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
    where  AD.RESOURCE_TEXT = :resource_text
           and AP.IS_ANUL = 0
    into   :id_account_post
  do begin
    /* call ACCOUNT_POSTING_ANUL - to log changes */
    execute procedure ACCOUNT_POSTING_ANUL(:id_account_post, :in_user_anul);

    update ACCOUNT_POST_EXTERNAL ape
    set    ape.EXT_USER_VOIDED = coalesce(:in_user_anul, '')
    where  ape.id_account_post = :id_account_post;
  end
end
^

/* Alter (EAI_RES_CHECK_OUT_FAST) */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
declare variable selection_id integer;
  declare variable is_early_check_out smallint;
  declare variable early_check_out_dep_date date;
  declare variable check_out_date date;
begin
  selection_id = gen_id(selection_gen, 1);

  update RESERV_DETAIL RD
  set RD.SELECTION_ID = :SELECTION_ID
  where RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL;

  execute procedure RES_CHECK_OUT_CHECK$RSV(:selection_id)
  returning_values :is_early_check_out, :early_check_out_dep_date, :check_out_date;

  if (:is_early_check_out = 1) then
    exception BOOKING_EXCEPTION '-1043';

  execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, 0);
end
^

/* Alter (EAI_TELECOUNT_TRANSFER) */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* Alter (END_WORK) */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable system_date date;
  declare variable id_end_work integer;
  declare variable last_closed_date date;
  declare variable lock_id integer;
  declare variable dbkey char(8);
begin
  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date >= :in_next_date) then exception END_WORK_EXCEPTION '-43';
  if (:IN_NEXT_DATE > current_date + 1) then exception END_WORK_EXCEPTION '-60';

  last_closed_date = :in_next_date - 1;

  /* LOCK THE CURRENT FINANCIAL (SYSTEM) DATE  */
  lock_id = null;
  while (:lock_id is null) do begin
    lock_id = strhash_large(:system_date || :id_hotel);
    execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'lock');
  
    when any do begin
      exception END_WORK_EXCEPTION '-337' || f_character(31) || f_character(29) || FormatDate(:system_date, 'D;dd.mm.yyyy');
    end
  end

  /* RIGHT IS REQUIRED TO CHANGE THE FINANCIAL DATE IF THERE ARE GUESTS WITH OVERDUE CHECK OUT */
  if (exists(
    select *
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
    where  G.TO_DATE <= :last_closed_date
           and G.CHECK_STATUS < 1
           and RD.ID_HOTEL = :id_hotel
           and rd.IS_ANUL = 0
  )) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('EW_OVERDUE_CHECKOUT');
  end

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', 'EW');
  -- Suppress eventual right checks into next procedures - all is permitted. Is this needed(?!?)

  for
    select p.RDB$DB_KEY
    from   ACCOUNT_POST p
           join ACCOUNT a on a.ID_ACCOUNT = p.ID_ACCOUNT
    where  p.DATE_POST between :system_date and :last_closed_date
           and p.ID_GUEST > 0
           and a.ID_HOTEL = :ID_HOTEL
    into   :dbkey
  do begin
    update ACCOUNT_POST AP
    set    ap.ROOM_NAME = (select R.ROOM_NAME
                           from   GUEST G
                                  join ROOMS R on R.ID_ROOM = G.ID_ROOM
                           where  G.ID_GUEST = ap.ID_GUEST)
    where  ap.RDB$DB_KEY = :dbkey;
  end

  /* CHANGE SYSTEM DATE */
  execute procedure SYSTEM_DATE_SET(:id_hotel, :system_date, :in_next_date)
  returning_values :id_end_work;

  /* AUTO EXPIRATION OF ROOM NUMBERS, ROOMS AND BOOKING POSITIONS */
  execute procedure RESERVS_EXPIRE$INT(:last_closed_date, :id_hotel);

  execute procedure AGENT_CONTINGENT_EXPIRE(:system_date, :last_closed_date, null, 0, 1, :id_hotel);

  /* DELETE PERSON PROFILES WITH EXPIRATION DATE */
  execute procedure PROFILE_PERSON_EXPIRE (:in_next_date);

  execute procedure HOUSEKEEPING_MARK_ROOMS$EW(:id_end_work);

  /* Summary statistic */
  if (:in_next_date > :system_date) then begin
    execute procedure SUMMARY_FINANCE_STATISTIC$EW(:id_end_work);

    execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:ID_HOTEL, :system_date, :last_closed_date);

    execute procedure SUMMARY_STATISTIC_REBUILD$EW(:ID_HOTEL);

    execute procedure SUMMARY_FORECAST$INT(:ID_HOTEL, :system_date);
  end

  /* Delete pseudo-temporal tables */
  delete from RESERV_ERROR;
  /*  */

--  execute procedure CACHES_RESOLVE;

  execute procedure SYSTEM_LOG_ADD('DAY_END_WORK', :id_end_work, 'DAY_EW', f_character(29) || :system_date || f_character(28) || :IN_NEXT_DATE);

  execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'release');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', null);

  execute procedure SYSTEM_CACHE_APPLY('end_work');
end
^

/* Alter (GUEST_ADDRESSCARD_SET$RSV) */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA TDESCRIPTION_SHORT,
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable gd_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable rd_dbkey char(8);
  declare variable old_is_registred integer;
  declare variable old_guest_name1 varchar(250);
  declare variable old_guest_name2 varchar(250);
  declare variable old_id_pass_type integer;
  declare variable old_pass_num varchar(20);
  declare variable old_pass_date date;
  declare variable old_egn varchar(30);
  declare variable old_country varchar(20);
  declare variable old_id_stay_reason integer;
  declare variable old_kpp integer;
  declare variable old_kpp_date date;
  declare variable old_pass_exp_date date;
  declare variable old_birth_day date;
  declare variable old_pass_place varchar(20);
  declare variable old_city varchar(100);
  declare variable old_address varchar(100);
  declare variable old_visa TDESCRIPTION_SHORT;
  declare variable old_birth_place varchar(30);
  declare variable old_sex char(1);
  declare variable action_text varchar(250);
  declare variable tt_reg_number integer;
  declare variable id_hotel integer;
  declare variable id_tt_numerator integer;
  declare variable domestic_nation varchar(10);
  declare variable no_use varchar(255);
  declare variable is_anul smallint;
  declare variable acc_routing varchar(20);
begin
  err_code = 0;
  err_text = '';

  select G.RDB$DB_KEY, GD.RDB$DB_KEY, PD.RDB$DB_KEY,
         GD.IS_REGISTRED, PD.PERSON_NAME, PD.PERSON_NAME2, PD.ID_PASSPORT_TYPE, PD.PASS_NUM, PD.PASS_DATE,
         PD.EGN, PD.COUNTRY_CODE, GD.ID_STAY_REASON, GD.KPP, GD.KPP_DATE, PD.PASS_EXP_DATE,
         PD.BIRTH_DAY, PD.PASS_PLACE, PD.CITY, PD.ADDRESS, PD.BIRTH_PLACE, PD.SEX, rd.RDB$DB_KEY,
         g.TT_REG_NUMBER, rd.ID_HOTEL, rd.IS_ANUL, rd.ACC_ROUTING, GD.VISA
  from   GUEST G
         join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
         join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :gd_dbkey, :pd_dbkey,
         :old_is_registred, :old_guest_name1, :old_guest_name2, :old_id_pass_type, :old_pass_num, :old_pass_date,
         :old_egn, :old_country, :old_id_stay_reason, :old_kpp, :old_kpp_date, :old_pass_exp_date,
         :old_birth_day, :old_pass_place, :old_city, :old_address, :old_birth_place, :old_sex, :rd_dbkey,
         :tt_reg_number, :id_hotel, :is_anul, :acc_routing, :old_visa;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, :birth_place, :egn, :id_passport_type, :pass_num, :pass_date, :pass_place,
          :pass_exp_date, :city, :address, :sex, :mask);

  update  GUEST_DATA GD
  set     GD.KPP_DATE = :kpp_date,
          GD.KPP = :kpp,
          GD.VISA = :visa,
          GD.ID_STAY_REASON = :id_stay_reason,
          GD.IS_REGISTRED = :is_registred,
          GD.USER_REGISTRED = iif(:IS_REGISTRED = 1, coalesce(GD.USER_REGISTRED, current_user), null),
          GD.CAR = :car,
          GD.RATING_AGE = :RATING_AGE
  where   GD.RDB$DB_KEY = :gd_dbkey;

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name1, :guest_name2, :country,
          :is_child, :age, :birth_day, :TITLE);

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

  /*  */
  if (:IS_REGISTRED = 1 and :tt_reg_number is null and :is_anul = 0 and :acc_routing is distinct from 'OWNER') then begin
    execute procedure SETTING_GET_VALUE ('NATIVE_NATION', :id_hotel)
    returning_values :domestic_nation;

    select iif(:COUNTRY not in (:domestic_nation, '') and h.USE_DIFFERENT_TT_NUMERATORS = 1,
               h.ID_TT_NUMERATOR_2,
               h.ID_TT_NUMERATOR_1)
    from   HOTEL H
    where  h.ID_HOTEL = :id_hotel
    into   :id_tt_numerator;

    if (:id_tt_numerator is not null) then begin
      execute procedure SYSTEM_GEN_NUM('GUEST_NUM', :id_tt_numerator)
      returning_values :tt_reg_number, :no_use;
  
      update GUEST G
      set    g.TT_REG_NUMBER = :tt_reg_number
      where  G.RDB$DB_KEY = :g_dbkey;
    end
  end else if (:IS_REGISTRED is distinct from 1 and :tt_reg_number is not null) then begin
    update GUEST G
    set    g.TT_REG_NUMBER = null
    where  G.RDB$DB_KEY = :g_dbkey;
  end
  /*  */
  if ((:old_is_registred = 0) and (:is_registred = 1)) then begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'REGISTRED', '');
  end

  if ((:old_is_registred = 1) and (:old_guest_name1 <> :guest_name1)) then begin
    action_text = f_character(29)||:old_guest_name1||f_character(28)||:guest_name1;
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'CHANGE_CARD', :action_text);
  end

  if ((:old_IS_REGISTRED = 1)
      and
      ((:old_guest_name1 <> :guest_name1)
        or (:old_guest_name2 <> :guest_name2)
        or (:old_egn <> :egn)
        or (:old_id_pass_type <> :id_passport_type)
        or (:old_pass_num <> :pass_num)
        or (:old_pass_date <> :pass_date)
        or (:old_pass_exp_date <> :pass_exp_date)
        or (:old_pass_place <> :pass_place)
        or (:old_country <> :country)
        or (:old_city <> :city)
        or (:old_address <> :address)
        or (:old_visa <> :visa)
        or (:old_birth_day <> :birth_day)
        or (:old_birth_place <> :birth_place)
        or (:old_sex  <> :sex)
        or (:old_kpp <> :kpp)
        or (coalesce(:old_id_stay_reason,0) <> coalesce(:id_stay_reason,0))
        or (:old_kpp_date <> :kpp_date)
      )) then
  begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'PREREGISTRED', '');
  end

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;

  end

end
^

/* Alter (GUEST_NUMERATOR_MODIFY$INT) */
ALTER PROCEDURE GUEST_NUMERATOR_MODIFY$INT(ID_NUMERATOR INTEGER,
NUM_NAME VARCHAR(50),
NUM_NEXT INTEGER,
OPERATION VARCHAR(20),
ID_HOTEL TYPE OF ID_REF)
 RETURNS(NEW_ID_NUMERATOR INTEGER)
 AS
begin
/*  if (:operation = 'add') then in_use = 0;
  else in_use = 1;
*/
  execute procedure SYSTEM_NUMERATOR_MODIFY$INT(:id_numerator, 'GUEST_NUM',
          :num_name, :num_next - 1, '', 20, :ID_HOTEL, :operation)
  returning_values  :new_id_numerator;
end
^

/* Alter (GUEST_POST_GET_PACK_SERVICE) */
ALTER PROCEDURE GUEST_POST_GET_PACK_SERVICE(IN_ID_SERVICE INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_POST DATE)
 RETURNS(ID_PACK_SERVICE INTEGER)
 AS
declare variable id_type_stay integer;
  declare variable id_room_type integer;
  declare variable id_board integer;
  declare variable id_hotel integer;
begin
  /*  Description:
  ||
  */
  id_pack_service = -1;
  select Sp.ID_TYPE_STAY, Sp.ID_ROOM_TYPE, s.ID_HOTEL
  from   SERVICE_PACKET Sp
         join SERVICES S on s.ID_SERVICE = sp.ID_SERVICE
  where  S.ID_SERVICE = :in_id_service
  into   :id_type_stay, :id_room_type, :id_hotel;

  select GS.ID_BOARD
  from   GUEST_STAY GS
  where  GS.ID_GUEST = :in_id_guest
         and GS.FOR_DATE = :in_date_post
  into   :id_board;

  /*dbg = savedbg('in_id_guest = '||:in_id_guest);
  dbg = savedbg('in_date_post = '||:in_date_post);
  dbg = savedbg('id_board = '||:id_board); */
  execute procedure TAR_GET_BASE_SERVICE$INT(:id_type_stay, :id_room_type, :id_board, :id_hotel)
  returning_values  :id_pack_service;

end
^

/* Alter (GUEST_REROUTE_POSTINGS$INT) */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable ap_dbkey char(8);
  declare variable is_packet_post integer;
  declare variable packet_option varchar(50);
  declare variable id_target_account integer;
  declare variable id_current_account integer;
begin
  update GUEST G
  set    G.ID_BASE_ACCOUNT = :ID_BASE_ACCOUNT,
         G.ID_ACCOUNT = :ID_EXTRA_ACCOUNT
  where  G.ID_GUEST = :ID_GUEST;

  for
    select AP.RDB$DB_KEY, iif(AP.ID_MASTER_ADDINS_ACC_POST > 0, 1, 0), S.VAUCHER_PACKET,
           ap.ID_ACCOUNT
    from   ACCOUNT_POST AP
           join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
    where  AP.ID_GUEST = :ID_GUEST
           and AP.AC = '00'
           and AP.ID_BASE_DOC is null
    into   :ap_dbkey, :is_packet_post, :packet_option, :id_current_account
  do begin
    if ((:is_packet_post = 1) and (:packet_option <> 'NONE')) then id_target_account = :id_base_account;
    else id_target_account = :id_extra_account;

    if (:id_current_account <> :id_target_account) then begin
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:ap_dbkey, :id_target_account, 0);
    end
  end

end
^

/* Alter (GUEST_SET_MANUAL_STAY$INT) */
ALTER PROCEDURE GUEST_SET_MANUAL_STAY$INT(RD_DBKEY CHAR(8),
ID_GUEST INTEGER,
FROM_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable for_date date;
  declare variable id_room_type integer;
  declare variable id_type_stay integer;
  declare variable current_id_type_stay integer;
  declare variable current_id_room_type integer;
  declare variable gs_dbkey char(8);
  declare variable has_manual_stay smallint;
  declare variable id_room integer;
  declare variable room_name varchar(20);
begin
  /*  Description:
  ||
  */
  ERR_CODE = 0;
  ERR_TEXT = '';
  execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MANUAL_STAY');

  has_manual_stay = 0;
  for
    select GS.RDB$DB_KEY, GS.FOR_DATE, gs.ID_TYPE_STAY, gs.ID_ROOM_TYPE, gs.ID_ROOM
    from   GUEST_STAY GS
    where  GS.ID_GUEST = :ID_GUEST
           and GS.FOR_DATE >= :FROM_DATE
    into   :gs_dbkey, :for_date, :current_id_type_stay, :current_id_room_type, :id_room
  do begin
    select gsc.ID_TYPE_STAY, gsc.ID_ROOM_TYPE
    from   GUEST_GET_STAY_CONDITIONS$INT (:id_guest, :for_date) gsc
    into   :id_type_stay, :id_room_type;

    if (coalesce(:id_room_type, 0) < 0) then begin
      err_code = -18;
      err_text = f_character(29) || :ID_GUEST || f_character(28) || :for_date;
      exit;
    end
    if (coalesce(:id_type_stay, -1) < 0) then begin
      if (:id_room > 0) then begin
        select r.ROOM_NAME
        from   ROOMS R
        where  r.ID_ROOM = :id_room
        into   :room_name;
      end else begin
        select rt.TYPE_ROOM
        from   ROOM_TYPES RT
        where  rt.ID_ROOM_TYPE = :id_room_type
        into   :room_name;
      end
      err_code = -17;
      err_text = f_character(29) || :ID_GUEST || f_character(28) || :for_date || f_character(28) || :room_name;
      exit;
    end

    if ((:current_id_room_type <> :id_room_type) or (:current_id_type_stay <> :id_type_stay)) then begin
      update GUEST_STAY GSU
      set    GSU.ID_ROOM_TYPE = :id_room_type,
             GSU.ID_TYPE_STAY = :id_type_stay
      where  GSU.RDB$DB_KEY = :gs_dbkey;
    end
    has_manual_stay = 1;
  end

  if (:has_manual_stay = 1) then
    update RESERV_DETAIL RD
    set    RD.HAS_DIFFERENT_TYPE_STAY = 1,
           RD.HAS_DIFFERENT_ROOM_TYPE = 1
    where  RD.RDB$DB_KEY = :rd_dbkey;

end
^

/* Alter (IMPORT_ACCOUNT$EXC) */
ALTER PROCEDURE IMPORT_ACCOUNT$EXC(ACCOUNT_NAME VARCHAR(50),
ACCOUNT_CURR VARCHAR(3),
IS_CREDIT_ACCOUNT SMALLINT,
CREDIT_LIMIT NUMERIC(15,4),
PAYMENT_TYPE VARCHAR(20),
NOTE VARCHAR(255),
IS_BLOCKED SMALLINT,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE SMALLINT,
IS_EXTRA SMALLINT,
IS_ALOWED_POS_INTERFACE SMALLINT,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
IS_DEFAULT SMALLINT,
HOTEL_NAME VARCHAR(50))
 RETURNS(ID_ACCOUNT INTEGER)
 AS
declare variable id_hotel integer;
declare variable id_payment_type integer;
declare variable id_profile integer;
declare variable id_tax_policy integer;
declare variable id_acc_template integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'ACCOUNT', :ACCOUNT_NAME)
  returning_values :ID_HOTEL;

  execute procedure LOOKUP_PAYMENT_TYPE$EXC(:ID_HOTEL, :ACCOUNT_NAME, 'ACCOUNT', :PAYMENT_TYPE)
  returning_values :ID_PAYMENT_TYPE;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:ACCOUNT_NAME, 'ACCOUNT');

  execute procedure LOOKUP_ACCOUNT$EXC(:ID_HOTEL, :ACCOUNT_NAME)
  returning_values :ID_ACCOUNT;

  select ph.ID_PROFILE
  from   PROFILE_HOUSE ph
  where  ph.HOUSE_TYPE = 'hptComplimentary'
  into   :id_profile;

  select sv.SETTING_VALUE
  from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :ID_HOTEL) sv
  into   :id_acc_template;

  select ac.ID_TAX_POLICY
  from   ACC_TEMPLATE ac
  where  ac.ID_ACC_TEMPLATE = :id_acc_template
  into   :id_tax_policy;

  if (:ID_ACCOUNT is null) then begin
    execute procedure ACCOUNT_MODIFY$INT(null, :ID_PROFILE, :ACCOUNT_CURR, :ACCOUNT_NAME,
      :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT, :ID_PAYMENT_TYPE, :NOTE, :IS_BLOCKED, :BLOCK_TEXT,
      :SECURITY_LEVEL, :IS_BASE, :IS_EXTRA, :IS_ALOWED_POS_INTERFACE, :POS_INTERFACE_NOTE,
      :EXT_CODE, :ID_TAX_POLICY, :IS_DEFAULT, :ID_HOTEL, null, 0, 'add')
    returning_values :ID_ACCOUNT;
  end
end
^

/* empty dependent procedure body */
/* Clear: TEST_BOOKING_IMPORT for: IMPORT_BOOKING$EXC */
ALTER PROCEDURE TEST_BOOKING_IMPORT AS
 BEGIN EXIT; END
^

/* Alter (IMPORT_BOOKING$EXC) */
ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP,
CHECK_OUT_KIND SMALLINT,
EARLYCHECKOUT_DATE DATE)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable current_hotel_id integer;
declare variable booking_update_id integer;
declare variable warn_code integer;
declare variable share_transaction_id integer;
declare variable share_err_code integer;
declare variable arranger_profile_id integer;
declare variable main_guest_profile_id integer;
declare variable rate_id integer;
declare variable room_type_id integer;
declare variable board_id integer;
declare variable maintance_shema_id integer;
declare variable arranger_payment_type_id integer;
declare variable guest_payment_type_id integer;
declare variable marketing_segment_id integer;
declare variable marketing_source_code_id integer;
declare variable marketing_channel_code_id integer;
declare variable marketing_hear_reason_id integer;
declare variable marketing_come_reason_id integer;
declare variable arranger_account_id integer;
declare variable packet_id integer;
declare variable id_guarantee_policy integer;
declare variable first_food_code tfood_code;
declare variable arrival_type_code smallint;
declare variable booking_dbkey char(8);
declare variable reserv_group_id integer;
declare variable id_complimentary_account integer;
declare variable id_eating_object integer;
declare variable default_guest_mask varchar(10);
declare variable id_person_data integer;
begin
  /*execute procedure sys_dbg('exc IMPORT_BOOKING$EXC('
  || 'hotel => ' || coalesce(:hotel, '<null>')
  || ', booking_number => ' || coalesce(:number, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  ||')');
  */
  execute procedure import_mark_transaction$exc;

  /* init */
  err_code = 0;
  err_text = '';
  booking_update_id = null;
  booking_dbkey = null;
  current_hotel_id = null;
  if (:voucher_date is not null) then begin
    voucher_date = striptime(:voucher_date);
  end
  posting_routing = upper(:posting_routing);

  /* detect inser/update mode */
  select b.id_reserv_detail, b.rdb$db_key, b.id_hotel
  from   reserv_detail b
  where  b.number=:number
         and b.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and b.id_log_event_annul is null
  into   :booking_update_id, :booking_dbkey, :current_hotel_id;

  if (:booking_update_id is null) then begin
    booking_id = gen_id (id_reserv_detail_gen, 1);
  end else begin
    booking_id = :booking_update_id;
  end

  /* text to id map */
  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => MAP_BOOKING_RELATIONS$EXC');
  execute procedure MAP_BOOKING_RELATIONS$EXC(
    :booking_id,
    :hotel,
    :room_type,
    :board,
    :maintance_shema,
    :rate,
    :arranger_payment_type,
    :guest_payment_type,
    :marketing_segment,
    :marketing_source_code,
    :marketing_channel_code,
    :marketing_hear_reason,
    :marketing_come_reason,
    :first_food,
    :arranger_profile_uuid,
    :arranger_profile_name,
    :main_guest_profile_uuid,
    :arrival_type,
    :guarantee_policy,
    :eating_object
  ) returning_values
    :arranger_profile_id,
    :main_guest_profile_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :hotel_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :first_food_code,
    :arrival_type_code,
    :id_guarantee_policy,
    :id_eating_object;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* hotel change test */
  if (coalesce(:current_hotel_id, :hotel_id) <> :hotel_id) then begin
    execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', null, :hotel, 'booking hotel changed');
  end

  id_complimentary_account = null;
  if (complimentary_account is not null) then begin
    execute procedure lookup_account$exc(:hotel_id, :complimentary_account, 'booking', :booking_id)
    returning_values :id_complimentary_account;
  end

  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => CREATE_PACK_INSTANCE$EXC');
  packet_id = null;
  /*execute procedure CREATE_PACK_INSTANCE$EXC(
    :hotel_id, :booking_id, :package
  )
  returning_values :packet_id, :err_code, :err_text;
  if (0 <> :err_code) then exit;
  */
  /* merge input and default/persistent database values */
  execute procedure DEFAULT_BOOKING_VALUES$EXC(
    :booking_dbkey, :hotel_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :group_name,
    :group_uuid,
    :is_late_departure,
    :id_eating_object
  ) returning_values
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :arranger_account_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :reserv_group_id,
    :is_late_departure,
    :id_eating_object,
    :default_guest_mask;

  if ('' = :board) then board_id = null; /* preserve "empty board" state and discard default value */

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC DEFAULTED => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* if the booking is complimentary use complimentary account */
  arranger_account_id = coalesce(:id_complimentary_account, :arranger_account_id);

  /* CREATE or UPDATE */
  if (:booking_update_id is not null) then begin
    /* UPDATE booking */
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => UPDATE_BOOKING$EXC');
    execute procedure UPDATE_BOOKING$EXC(
      :booking_id,
      :reserv_group_id,
      :is_vip,
      :arrival,
      :arrival_type_code,
      :departure,
      :is_late_departure,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :room_type_id,
      :board_id,
      :room_preferences,
      :special_treatment,
      :maintance_shema_id,
      :posting_routing,
      :arranger_account_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :deposit_required,
      :deposit_required_currency,
      :arranger_payment_type_id,
      :guest_payment_type_id,
      :voucher,
      :voucher_date,
      :voucher_text,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :note,
      :note_reminders,
      :first_food_code,
      :arranger_profile_id,
      :main_guest_profile_id,
      :is_different_rate,
      :is_different_price,
      :split_on_checkin,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object
    ) returning_values :err_code, :err_text;
    if (0 <> :err_code) then begin
      exit;
    end
  end else begin
    /* CREATE booking */
    if (:default_guest_mask is not null
        and :main_guest_profile_id is not null
        and not exists (select rd.ID_RESERV_DETAIL from reserv_detail rd where rd.ID_PERSON_PROFILE = :main_guest_profile_id)) then
    begin
      -- fill the mask with a default value if its is empty
      select p.id_person_data
      from   PROFILE_PERSON p
      where  p.ID_PROFILE = :main_guest_profile_id
      into   :id_person_data;

      update PERSON_DATA pd
      set    pd.MASK = :default_guest_mask
      where  pd.ID_PERSON_DATA = :id_person_data
             and pd.MASK is null;
    end
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => RES_CREATE_SET$EXC');
    execute procedure RES_CREATE_SET$EXC (
      :booking_id,
      :number,
      :arranger_profile_id,
      :main_guest_profile_id,
      :arrival,
      :departure,
      :adult_count,
      :children_count,
      :room_type_id,
      null,
      :board_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :voucher,
      :voucher_date,
      :voucher_text,
      null,
      null,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :arrival_type_code,
      :is_late_departure,
      :is_vip,
      :first_food_code,
      :special_treatment,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :arranger_account_id,
      :posting_routing,
      :guest_payment_type_id,
      :arranger_payment_type_id,
      null,
      :room_preferences,
      :maintance_shema_id,
      :note,
      :note_reminders,
      :deposit_required,
      :deposit_required_currency,
      :hotel_id,
      :reserv_group_id,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object,
      :create_datetime
      )
    returning_values :err_code, :err_text, :warn_code, :booking_id, :share_transaction_id, :share_err_code;
  end

  update reserv_detail rd
  set    rd.CHECK_OUT_KIND = :CHECK_OUT_KIND,
         rd.EARLYCHECKOUT_DATE = :EARLYCHECKOUT_DATE
  where  rd.ID_RESERV_DETAIL = :BOOKING_ID;

  execute procedure GUEST_STAY_INITIALIZE$INT (:booking_id);
  /* final error check */
  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;

  delete from PENDING_DEPOSIT d
  where  d.ID_RESERV_DETAIL = :BOOKING_ID;
end
^

/* Alter (IMPORT_BOOKING_FINALIZE$EXC) */
ALTER PROCEDURE IMPORT_BOOKING_FINALIZE$EXC(BOOKING_ID INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1,
STATUS VARCHAR(50) = null,
CONFIRMATION_NUMBER NAME_20 = null,
CANCELATION_NUMBER NAME_20 = null)
 RETURNS(RECORD_TIMESTAMP TIMESTAMP,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable booking_db_key char(8);
  declare variable dummy_int integer;
  declare variable dummy_text varchar(255) ;
  declare variable res_id_room integer;
  declare variable id_room integer;
  declare variable id_room_type integer;
  declare variable system_date date;
  declare variable from_date date;
  declare variable to_date date;
  declare variable gs_dbkey char(8);
begin
  ERR_CODE=0;
  ERR_TEXT=null;
  id_room = null;
  force_res_finalize = coalesce(:force_res_finalize, 1);

  execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => CLEAR_ORPHAN_GUESTS$EXC');
  execute procedure CLEAR_ORPHAN_GUESTS$EXC(:booking_id);

  select b.rdb$db_key, b.ID_ROOM, b.ID_ROOM_TYPE, b.FROM_DATE, b.TO_DATE
  from   reserv_detail b
  where  b.id_reserv_detail = :booking_id
  into   :booking_db_key, :res_id_room, :id_room_type, :from_date, :to_date;

  execute procedure RES_GUEST_SAVE_DIFF$INT(:booking_db_key);

  if (:res_id_room < 0) then begin
    --id_room = :res_id_room;
    for
      select lp.OUT_DATE
      from   SYSTEM_LOOP_PERIOD (:from_date, :to_date-1) lp
      into   :system_date
    do begin
      select ro.ID_ROOM, ro.ID_ROOM_TYPE
      from   RES_OCCUPANCY_ROOM$INT (:BOOKING_ID, :system_date, :id_room, :id_room_type) ro
      into   :id_room, :id_room_type;
  
      if (:id_room <> :res_id_room) then begin
        for
          select gs.RDB$DB_KEY
          from   GUEST_STAY GS
                 join GUEST G on g.ID_GUEST = gs.ID_GUEST
          where  g.ID_RESERV_DETAIL = :BOOKING_ID
                 and gs.FOR_DATE = :system_date
                 and gs.ID_ROOM <> :id_room
          into   :gs_dbkey
        do begin
          update GUEST_STAY gsu
          set    gsu.ID_ROOM = :id_room
                 --gsu.ID_ROOM_TYPE = iif (gsu.ID_ROOM_TYPE = -1, :id_room_type, gsu.ID_ROOM_TYPE)
          where  gsu.RDB$DB_KEY = :gs_dbkey;
        end
      end
    end
    update GUEST G
    set    G.ID_ROOM = coalesce(:id_room, :res_id_room)
    where  g.ID_RESERV_DETAIL = :BOOKING_ID;
  end

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null,   --force recalculation
         rd.ID_ROOM = coalesce(:id_room, :res_id_room)
         --rd.HAS_DIFFERENT_ROOM_TYPE = coalesce(:has_different_room_type,  rd.HAS_DIFFERENT_ROOM_TYPE)
  where  rd.RDB$DB_KEY = :booking_db_key;

  if (1 = :force_res_finalize) then begin
    execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => RES_FINALIZE_SHAREOPTION$INT');
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:booking_db_key, 0)
    returning_values  :dummy_int, :dummy_text, :dummy_int, :dummy_int;
  end

  execute procedure APPLY_BOOKING_STATUS$EXC(
    null, :booking_db_key, :status, :confirmation_number, :cancelation_number
  );

  select b.change_time
  from   reserv_detail b
  where  b.rdb$db_key =:booking_db_key
  into   :record_timestamp;
end
^

/* Alter (IMPORT_CURRENCY_RATE$EXC) */
ALTER PROCEDURE IMPORT_CURRENCY_RATE$EXC(ID_HOTEL INTEGER,
CURRENCY CHAR(3),
ROUND_TO NUMERIC(15,6),
DATETIME TIMESTAMP,
RATE NUMERIC(15,6))
 AS
begin
  if (:CURRENCY is null) then exit;

  execute procedure import_mark_transaction$exc;

  if (:ROUND_TO is null) then begin
    ROUND_TO = 0.01;
  end

  if (not exists(select curr from CURRS where curr = :CURRENCY)) then begin
    execute procedure CURR_MODIFY(:CURRENCY, null, :ROUND_TO, '0.00', 'add');
  end

  /*update currs_history
  set rate=:rate
  where id_hotel=:id_hotel and currency = :currency and datetime = :datetime;

  if (0 = row_count) then begin
    execute procedure curr_rate_modify(:currency,  :id_hotel, :rate);
  end*/

  execute procedure CURR_RATE_MODIFY(:currency, :id_hotel, :rate, :DATETIME);
end
^

/* Alter (IMPORT_GUEST$EXC) */
ALTER PROCEDURE IMPORT_GUEST$EXC(BOOKING_ID INTEGER,
PROFILE_UUID VARCHAR(40),
GUEST_UUID VARCHAR(40),
GUEST_NAME VARCHAR(100),
IS_CHILD SMALLINT,
AGE INTEGER,
IS_DIFFERENT_ARRANGER SMALLINT,
ARRIVAL DATE,
DEPARTURE DATE,
VOUCHER VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
RATING_AGE INTEGER,
KPP VARCHAR(50),
KPP_DATE DATE,
STAY_REASON VARCHAR(255),
CAR VARCHAR(30),
IS_REGISTRED SMALLINT,
PERSONAL_NUMBER VARCHAR(30),
TITLE VARCHAR(10),
PT_NAME VARCHAR(100),
PT_EXTCODE VARCHAR(50),
PASS_NUM VARCHAR(20),
PASS_PLACE VARCHAR(20),
PASS_DATE DATE,
PASS_EXP_DATE DATE,
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_DATE DATE,
SEX CHAR,
BIRTH_PLACE VARCHAR(30),
MASK VARCHAR(10),
PACKAGE VARCHAR(255),
VISA TDESCRIPTION_SHORT)
 RETURNS(GUEST_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable warn_code integer;

declare variable birth_date_old date;
declare variable title_old varchar(10);
declare variable id_passport_type_old integer;
declare variable pass_num_old varchar(20);
declare variable pass_date_old date;
declare variable personal_number_old varchar(30);
declare variable id_stay_reason_old integer;
declare variable is_registred_old integer;
declare variable pass_place_old varchar(20);
declare variable city_old varchar(100);
declare variable address_old varchar(100);
declare variable birth_place_old varchar(30);
declare variable sex_old char(1);
declare variable mask_old varchar(10);
declare variable car_old varchar(30);
declare variable kpp_id_old integer;
declare variable kpp_date_old date;
declare variable pass_exp_date_old date;
declare variable rating_age_old integer;
declare variable visa_old tdescription_short;

declare variable guest_name_old varchar(100);
declare variable is_child_old integer;
declare variable arrival_old date;
declare variable departure_old date;
declare variable voucher_old varchar(30);
declare variable voucher_date_old date;
declare variable voucher_text_old varchar(30);
declare variable country_code_old varchar(10);

declare variable id_passport_type integer;
declare variable kpp_id integer;
declare variable id_stay_reason integer;
begin
  execute procedure import_mark_transaction$exc;

  guest_name = substring(:guest_name from 1 for 50);

  execute procedure sys_dbg('exc IMPORT_GUEST$EXC(:guest_uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
  guest_id = null;

  select pd.person_name, --g.is_different_organizer,
         g.id_guest, g.from_date, g.to_date,
         pd.birthday_internal, pd.title, pd.id_passport_type,
         pd.pass_num, pd.pass_date, pd.egn, gd.id_stay_reason,
         gd.is_registred, pd.pass_place, pd.city, pd.address, pd.birth_place,
         pd.sex, pd.mask, g.is_child, gd.car, gd.kpp, gd.kpp_date,
         pd.pass_exp_date, gd.rating_age, g.vaucher_num, g.vaucher_date, g.vaucher_text, pd.country_code,
         gd.id_stay_reason, gd.visa
  from   GUEST g
         join guest_data gd on gd.id_guest=g.id_guest
         join person_data pd on pd.id_person_data=gd.id_person_data
  where  g.uuid=:guest_uuid
         and g.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and g.id_reserv_detail=:booking_id
  into   :guest_name_old, --:is_different_arranger_old,
         :guest_id, :arrival_old, :departure_old, :birth_date_old,
         :title_old, :id_passport_type_old,
         :pass_num_old, :pass_date_old, :personal_number_old, :id_stay_reason_old,
         :is_registred_old, :pass_place_old, :city_old, :address_old, :birth_place_old,
         :sex_old, :mask_old, :is_child_old, :car_old, :kpp_id_old, :kpp_date_old,
         :pass_exp_date_old, :rating_age_old, :voucher_old, :voucher_date_old,
         :voucher_text_old, :country_code_old, :id_stay_reason_old, :visa_old;

  execute procedure import_passport_type$exc(:pt_name, pt_extcode)
  returning_values :id_passport_type;

  execute procedure import_kpp$exc(:kpp, null)
  returning_values :kpp_id;

  execute procedure import_stay_reason$exc(:stay_reason, null)
  returning_values :id_stay_reason;

  guest_name = coalesce(:guest_name, :guest_name_old);
--  DISABLE age/is_child merge (RIU rating cases)
--  is_child = coalesce(:is_child, :is_child_old);
--  is_different_arranger = coalesce(:is_different_arranger, :is_different_arranger_old);
  arrival = coalesce(:arrival, :arrival_old);
  departure = coalesce(:departure, :departure_old);
--  arrival = :arrival_old;
--  departure = :departure_old;
  voucher = coalesce(:voucher, :voucher_old);
  voucher_date = coalesce(:voucher_date, :voucher_date_old);
  voucher_text = coalesce(:voucher_text, :voucher_text_old);
  country_code = coalesce(:country_code, :country_code_old);

--  DISABLE age/is_child merge (RIU rating cases)
--  rating_age = coalesce(:rating_age, :rating_age_old);
  kpp_id = coalesce(:kpp_id, :kpp_id_old);
  kpp_date = coalesce(:kpp_date, :kpp_date_old);
  id_stay_reason = coalesce(:id_stay_reason, :id_stay_reason_old);
  car = coalesce(:car, :car_old);
  is_registred = coalesce(:is_registred, 0);
  if (1 = :is_registred_old) then begin --one way update
    is_registred = 1;
  end
  personal_number = coalesce(:personal_number, :personal_number_old);
  title = coalesce(:title, :title_old);
  id_passport_type = coalesce(:id_passport_type, :id_passport_type_old);
  pass_num = coalesce(:pass_num, :pass_num_old);
  pass_place = coalesce(:pass_place, :pass_place_old);
  pass_date = coalesce(:pass_date, :pass_date_old);
  pass_exp_date = coalesce(:pass_exp_date, :pass_exp_date_old);
  city = coalesce(:city, :city_old);
  address = coalesce(:address, :address_old);
  birth_date = coalesce(:birth_date, :birth_date_old);
  sex = coalesce(:sex, :sex_old);
  birth_place = coalesce(:birth_place, :birth_place_old);
  mask = coalesce(:mask, :mask_old);
  visa = coalesce(:visa, :visa_old);

  if (:guest_id is null) then begin
    execute procedure RES_GUEST_SAVE$RSV(null, :booking_id, :guest_name, null, null, :is_child)
    returning_values :guest_id;

    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - get_next_auto_guest = :guest_id=>' || coalesce(:guest_id, '<null>'));
    if (:guest_id is null) then begin 
      execute procedure sys_dbg('exc IMPORT_GUEST$EXC - exhausted auto guests list - create new guest');
      execute procedure RES_GUEST_ADD$RSV(:booking_id, :is_child)
      returning_values :err_code, :err_text, :warn_code, :guest_id;
      if (0 <> :err_code) then exit;
    end

    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - update_new_guest_uuid(:guest_id=>' || coalesce(:guest_id, '<null>') || ', :uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
    update GUEST
    set    uuid = :guest_uuid
    where  id_guest=:guest_id;

    /* preserve default mask */
    if (:mask is null) then begin
      select pd.mask
      from   guest_data gd
             join person_data pd on pd.id_person_data=gd.id_person_data
      where  gd.id_guest=:guest_id
      into   :mask;
    end          
  end else begin
    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - update_guest(:update_guest_id=>' || coalesce(:guest_id, '<null>') || ')');

--    DISABLE age/is_child merge (RIU rating cases) 
--    if (:age is null) then begin
--      select age from GUEST_AGE_CALC(:guest_id)
--      into :age;
--    end
  end

  /*
  execute procedure sys_dbg('exc IMPORT_GUEST$EXC->GUEST_ADDRESSCARD_SET$RSV('
  || 'update_guest_id => ' || coalesce(:update_guest_id, '<null>')
  || ', guest_name => ' || coalesce(:guest_name, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  || ', :id_passport_type => ' || coalesce(:id_passport_type, '<null>')
  || ', :pass_num => ' || coalesce(:pass_num, '<null>')
  || ', :pass_date => ' || coalesce(:pass_date, '<null>')
  || ', :egn => ' || coalesce(:egn_old, '<null>')
  || ', :country => ' || coalesce(:country_old, '<null>')
  || ', :id_stay_reason => ' || coalesce(:id_stay_reason, '<null>')
  || ', :is_registred => ' || coalesce(:is_registred, '<null>')
  || ', :pass_place => ' || coalesce(:pass_place, '<null>')
  || ', :city => ' || coalesce(:city, '<null>')
  || ', :address => ' || coalesce(:address, '<null>')
  || ', :birth_place => ' || coalesce(:birth_place, '<null>')
  || ', :sex => ' || coalesce(:sex, '<null>')
  || ', :mask => ' || coalesce(:mask, '<null>')
  || ', :is_child => ' || coalesce(:is_child, '<null>')
  || ', :car => ' || coalesce(:car, '<null>')
  || ', :kpp => ' || coalesce(:kpp_old, '<null>')
  || ', :kpp_date => ' || coalesce(:kpp_date, '<null>')
  || ', :pass_exp_date => ' || coalesce(:pass_exp_date, '<null>')
  || ', :age => ' || coalesce(:age, '<null>')
  || ', :birth_date => ' || coalesce(:birth_date, '<null>')
  || ', :rating_age => ' || coalesce(:rating_age, '<null>')
  || ', :title => ' || coalesce(:title, '<null>')
  ||')');
  */
  execute procedure GUEST_ADDRESSCARD_SET$RSV(
    :guest_id,
    :guest_name,
    null,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :personal_number,
    :country_code,
    :id_stay_reason,
    :is_registred,
    :pass_place,
    :city,
    :address,
    :birth_place,
    :sex,
    :mask,
    :is_child,
    :car,
    :kpp_id,
    :kpp_date,
    :pass_exp_date,
    :age,
    :birth_date,
    :visa,
    :rating_age,
    :title,
    0
  )
  returning_values :err_code, :err_text, :warn_code;
  if (0 <> :err_code) then exit;

  --execute procedure RES_GUEST_SAVE_ORGANIZER$RSV(:guest_id, :is_different_arranger);

  if ((:arrival is not null) and (:departure is not null)) then begin
    execute procedure RES_GUEST_SAVE_STAY$RSV(:guest_id, :arrival, :departure)
    returning_values :err_code, :err_text, :warn_code;
    if (0 <> :err_code) then exit;
  end

  if (:voucher is not null) then begin
    execute procedure RES_GUEST_SAVE_VOUCHER$RSV(:guest_id, :voucher,
            :voucher_date, :voucher_text, null, null);
  end

  execute procedure IMPORT_GUEST_PACK$EXC(:guest_id, :package);

  update GUEST
  set    ORPHANED_IMPORT$EXC = null
  where  id_guest=:guest_id;
end
^

/* Alter (IMPORT_PAYMENT_TYPE$EXC) */
ALTER PROCEDURE IMPORT_PAYMENT_TYPE$EXC(UUID VARCHAR(40),
NAME VARCHAR(50),
GROUP_TAG VARCHAR(20),
DESCRIPTION VARCHAR(100),
IS_AR_DEBT SMALLINT,
IS_CASH SMALLINT,
IS_CC SMALLINT,
IS_USE SMALLINT,
FISCAL_CODE VARCHAR(50),
HOTEL_NAME VARCHAR(50))
 RETURNS(PAYMENT_TYPE_ID INTEGER)
 AS
declare variable id_hotel integer;
  declare variable old_name varchar(50);
  declare variable old_group_tag        varchar(20);
  declare variable old_description      varchar(100);
  declare variable old_is_ar_debt       smallint;
  declare variable old_is_cash          smallint;
  declare variable old_is_cc            smallint;
  declare variable old_is_use           smallint;
  declare variable old_fiscal_code      varchar(50);
  declare variable mod_op varchar(10);
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'PAYMENT_TYPE', :NAME)
  returning_values :ID_HOTEL;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:NAME, 'PAYMENT_TYPE');

  select
    id_payment_type,
    payment_type,
    group_tag,
    description,
    is_ar_debt,
    is_cash,
    is_cc,
    is_use,
    fiscal_code
  from payment_type
  where uuid=:uuid and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into
    :payment_type_id,
    :old_name,
    :old_group_tag,
    :old_description,
    :old_is_ar_debt,
    :old_is_cash,
    :old_is_cc,
    :old_is_use,
    :old_fiscal_code;

  name = coalesce(:name, :old_name);
  group_tag = coalesce(:group_tag, :old_group_tag);
  description = coalesce(:description, :old_description);
  is_ar_debt = coalesce(:is_ar_debt, :old_is_ar_debt);
  is_cash = coalesce(:is_cash, :old_is_cash);
  is_cc = coalesce(:is_cc, :old_is_cc);
  is_use = coalesce(:is_use, :old_is_use);
  fiscal_code = coalesce(:fiscal_code, :old_fiscal_code);

  if (:payment_type_id is null) then begin
    mod_op = 'add';
  end else begin
    mod_op = 'mod';
  end

  execute procedure payment_type_modify$cfg(
    :payment_type_id,
    :name,
    :group_tag,
    :description,
    :is_ar_debt,
    :is_cash,
    :is_cc,
    :is_use,
    :fiscal_code,
    :mod_op,
    :id_hotel) returning_values :payment_type_id;

  /* sync uuid field */
  update payment_type
  set uuid=:uuid
  where id_payment_type=:payment_type_id;
end
^

/* Alter (IMPORT_RATE$EXC) */
ALTER PROCEDURE IMPORT_RATE$EXC(TARIFA_NAME VARCHAR(50),
TARIFA_GROUP VARCHAR(30),
HOTEL_NAME VARCHAR(50),
TARIFA_CURR VARCHAR(3),
IS_ACTIVE SMALLINT,
TARIFA_NOTE VARCHAR(500),
PERIOD_DEPEND_ON_CHECKIN SMALLINT,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BOARD_TYPE VARCHAR(10),
SOURCE_BASE_BOARDS_LIST VARCHAR(255),
TMP_DATA BLOB SUB_TYPE 1,
LOCK_KEY VARCHAR(100),
LOCK_STAMP TIMESTAMP,
UUID VARCHAR(40),
RATE_TYPE VARCHAR(20),
IS_SIMPLE SMALLINT,
CHILD_AGE_INCL INTEGER,
IS_PUBLIC TYPE OF TLOGICAL,
EXPLICIT_TAX_POLICY_NAME TDESCRIPTION_SHORT = null,
EXPLICIT_POLICY_NIGHTS_REQUIRED TCOUNT = null)
 RETURNS(ID_TARIFA INTEGER,
ID_TARIFA_GROUP INTEGER,
ID_HOTEL INTEGER,
ID_TAR_SIMPLE INTEGER)
 AS
declare variable BASE_BOARDS_LIST varchar(255);
  declare variable BOARD_NAME varchar(30);
  declare variable ID_BOARD integer;
  declare variable EXPLICIT_TAX_POLICY integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure IMPORT_RATE_COMMON$EXC(:TARIFA_NAME, :TARIFA_GROUP, :HOTEL_NAME, :TARIFA_CURR, 1, :IS_ACTIVE,
    :TARIFA_NOTE, :UUID, :RATE_TYPE, :IS_SIMPLE, :IS_PUBLIC, :CHILD_AGE_INCL)
  returning_values :ID_TARIFA, :ID_TARIFA_GROUP, :ID_HOTEL;

  select ts.ID_TAR_SIMPLE
  from   TAR_SIMPLE ts
  where  ts.ID_TAR_HEAD = :ID_TARIFA
  into   :ID_TAR_SIMPLE;

  BASE_BOARDS_LIST = '';
  for
    select ITEM
    from   SYSTEM_STRING_PARSER(:SOURCE_BASE_BOARDS_LIST, ',')
    into   :BOARD_NAME
  do begin
    execute procedure LOOKUP_BOARD$EXC(:ID_HOTEL, :TARIFA_NAME, :RATE_TYPE, :BOARD_NAME, 0)
    returning_values :ID_BOARD;
    BASE_BOARDS_LIST = BASE_BOARDS_LIST || F_CHARACTER(28) || ID_BOARD;
  end

  if (:EXPLICIT_TAX_POLICY_NAME is not null) then begin
    execute procedure LOOKUP_TAX_POLICY$EXC(:ID_HOTEL, :TARIFA_NAME, :RATE_TYPE, :EXPLICIT_TAX_POLICY_NAME)
    returning_values :EXPLICIT_TAX_POLICY;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:TARIFA_NAME, :RATE_TYPE);

  update TAR_HEAD th
  set    th.PERIOD_DEPEND_ON_CHECKIN = :PERIOD_DEPEND_ON_CHECKIN,
         th.CNT_DAYS_PRICE_BP = :CNT_DAYS_PRICE_BP,
         th.CNT_DAYS_PRICE_BOARD = :CNT_DAYS_PRICE_BOARD,
         th.BASE_BOARDS_LIST = :BASE_BOARDS_LIST,
         th.BOARD_TYPE = :BOARD_TYPE,
         th.TMP_DATA = :TMP_DATA,
         th.LOCK_KEY = :LOCK_KEY,
         th.LOCK_STAMP = :LOCK_STAMP,
         th.EXPLICIT_TAX_POLICY = :EXPLICIT_TAX_POLICY,
         th.EXPLICIT_POLICY_NIGHTS_REQUIRED = :EXPLICIT_POLICY_NIGHTS_REQUIRED
  where  th.ID_TAR_HEAD = :ID_TARIFA;
end
^

/* Alter (IMPORT_RATE_RECORD_RELINK$EXC) */
ALTER PROCEDURE IMPORT_RATE_RECORD_RELINK$EXC(ID_RATE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ID_COLUMN integer;
declare variable ID_NEW_MASTER_RECORD integer;

declare variable PERIOD_DEPEND_ON_CHECKIN INTEGER;
declare variable CNT_DAYS_PRICE_BP INTEGER;
declare variable CNT_DAYS_PRICE_BOARD INTEGER;
declare variable BASE_BOARDS_LIST VARCHAR(255);
declare variable BOARD_TYPE VARCHAR(10);
begin
  execute procedure import_mark_transaction$exc;

  ERR_CODE = 0;
  ERR_TEXT = '';
  for
    select c.ID_TAR_DEFINE_COLUMN, im.ID_NEW
    from   TAR_UI_DEFINE_COLUMNS c
           join IDS_MAP$TMP im on c.ID_DIM2 = im.ID_OLD
    where  c.ID_TAR_HEAD = :ID_RATE
    into   :ID_COLUMN, :ID_NEW_MASTER_RECORD
  do begin
    update TAR_UI_DEFINE_COLUMNS c
    set    c.ID_DIM2 = :ID_NEW_MASTER_RECORD
    where  c.ID_TAR_DEFINE_COLUMN = :ID_COLUMN;
  end

  delete from IDS_MAP$TMP;


  select
        th.PERIOD_DEPEND_ON_CHECKIN,
        th.CNT_DAYS_PRICE_BP,
        th.CNT_DAYS_PRICE_BOARD,
        th.BASE_BOARDS_LIST,
        th.BOARD_TYPE
  from  TAR_HEAD th
  where th.ID_TAR_HEAD = :ID_RATE
  into  :PERIOD_DEPEND_ON_CHECKIN, :CNT_DAYS_PRICE_BP, :CNT_DAYS_PRICE_BOARD, :BASE_BOARDS_LIST, :BOARD_TYPE;

  for
    select ERR_CODE, ERR_TEXT
    from   TAR_SAVE(:ID_RATE, :PERIOD_DEPEND_ON_CHECKIN, :CNT_DAYS_PRICE_BP, :CNT_DAYS_PRICE_BOARD, :BASE_BOARDS_LIST, :BOARD_TYPE)
    into   :err_code, :err_text
  do begin
    if (0 <> :err_code) then begin
      exit;
    end
  end
end
^

/* Alter (IMPORT_RATE_SIMPLE_BOARD$EXC) */
ALTER PROCEDURE IMPORT_RATE_SIMPLE_BOARD$EXC(ID_HOTEL INTEGER,
ID_TAR_SIMPLE_SEASON INTEGER,
RATE_NAME VARCHAR(30),
BOARD_NAME VARCHAR(30),
ADULT_PRICE NUMERIC(15,4),
CHILD_PRICE NUMERIC(15,4))
 RETURNS(ID_TAR_SIMPLE_BOARDS INTEGER)
 AS
declare variable ID_BOARD_TYPE integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_BOARD$EXC(:ID_HOTEL, :RATE_NAME, 'RATE_SIMPLE', :BOARD_NAME, 1)
  returning_values :ID_BOARD_TYPE;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:RATE_NAME, 'ROOM_TYPE');

  execute procedure TAR_SIMPLE_BOARD_MODIFY$CFG(null,
                                                :ID_TAR_SIMPLE_SEASON,
                                                :ID_BOARD_TYPE,
                                                :ADULT_PRICE,
                                                :CHILD_PRICE,
                                                'add')
  returning_values :ID_TAR_SIMPLE_BOARDS;
end
^

/* Alter (IMPORT_RATE_SIMPLE_PRICE$EXC) */
ALTER PROCEDURE IMPORT_RATE_SIMPLE_PRICE$EXC(ID_TAR_SIMPLE_SEASON INTEGER,
RATE_NAME VARCHAR(30),
HOTEL_NAME VARCHAR(50),
ROOM_TYPE VARCHAR(20),
BOARD_NAME VARCHAR(30),
SINGLE_PRICE NUMERIC(15,4),
DOUBLE_PRICE NUMERIC(15,4),
GUEST3_PRICE NUMERIC(15,4),
GUEST4PLUS_PRICE NUMERIC(15,4),
CHILD1_W_ADULT1_PRICE NUMERIC(15,4),
CHILD1_W_ADULT2PLUS_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT1_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT2PLUS_PRICE NUMERIC(15,4),
IS_BASE_DAYS_PRICE SMALLINT)
 AS
declare variable ID_HOTEL integer;
declare variable ID_ROOM_TYPE integer;
declare variable ID_BOARD_TYPE integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'RATE_SIMPLE', :RATE_NAME)
  returning_values :ID_HOTEL;

  execute procedure LOOKUP_ROOM_TYPE$EXC(:ID_HOTEL, :RATE_NAME, 'RATE_SIMPLE', :ROOM_TYPE)
  returning_values :ID_ROOM_TYPE;

  execute procedure LOOKUP_BOARD$EXC(:ID_HOTEL, :RATE_NAME, 'RATE_SIMPLE', :BOARD_NAME, 1)
  returning_values :ID_BOARD_TYPE;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:RATE_NAME, 'RATE_SIMPLE');

  execute procedure TAR_SIMPLE_PRICE_MODIFY$CFG(:ID_TAR_SIMPLE_SEASON,
                                                :ID_ROOM_TYPE,
                                                :ID_BOARD_TYPE,
                                                :SINGLE_PRICE,
                                                :DOUBLE_PRICE,
                                                :GUEST3_PRICE,
                                                :GUEST4PLUS_PRICE,
                                                :CHILD1_W_ADULT1_PRICE,
                                                :CHILD1_W_ADULT2PLUS_PRICE,
                                                :CHILD2PLUS_W_ADULT1_PRICE,
                                                :CHILD2PLUS_W_ADULT2PLUS_PRICE,
                                                :IS_BASE_DAYS_PRICE);
end
^

/* Alter (IMPORT_ROOM_TYPE$EXC) */
ALTER PROCEDURE IMPORT_ROOM_TYPE$EXC(TYPE_ROOM VARCHAR(20),
BEDS INTEGER,
EXT_CODE VARCHAR(30),
UUID VARCHAR(40),
HOTEL_NAME VARCHAR(50))
 RETURNS(ID_ROOM_TYPE INTEGER)
 AS
declare variable id_hotel integer;
declare variable operation varchar(3);
declare variable overrule_need integer;
declare variable overrule_context varchar(255) ;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'ROOM_TYPE', :TYPE_ROOM)
  returning_values :ID_HOTEL;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:TYPE_ROOM, 'ROOM_TYPE');

  ID_ROOM_TYPE = null;
  select rt.ID_ROOM_TYPE
  from   ROOM_TYPES rt
  where  rt.UUID = :UUID and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :ID_ROOM_TYPE;

  if (:ID_ROOM_TYPE is null) then begin
    OPERATION = 'add';
  end else begin
    OPERATION = 'mod';
  end

  execute procedure ROOM_TYPE_MODIFY$CFG(:ID_HOTEL, :ID_ROOM_TYPE, :TYPE_ROOM, :BEDS, :EXT_CODE, :OPERATION)
  returning_values :ID_ROOM_TYPE, :overrule_need, :overrule_context;
  if (:overrule_need <> 0) then exception ASSERT :overrule_need || f_character(31) || coalesce(:overrule_context, '');

  update ROOM_TYPES rt
  set    rt.UUID = :UUID
  where  rt.ID_ROOM_TYPE = :ID_ROOM_TYPE;
end
^

/* Alter (IMPORT_SERVICE$EXC) */
ALTER PROCEDURE IMPORT_SERVICE$EXC(SERVICE_NAME VARCHAR(30),
SERVICE_GROUP VARCHAR(30),
SERVICE_TYPE VARCHAR(50),
IS_DELETED SMALLINT,
IS_MANUAL_PRICE SMALLINT,
IS_DETAILS SMALLINT,
REVENUE_GROUP VARCHAR(50),
REVENUE_ACCOUNT VARCHAR(50),
ACCOUNT_NAME VARCHAR(30),
EXT_CODE VARCHAR(30),
VAUCHER_PACKET VARCHAR(20),
EXTRA_PACKET_NAME VARCHAR(10),
IS_RATE_PRICE SMALLINT,
IS_BREAKFAST SMALLINT,
IS_LUNCH SMALLINT,
IS_DINNER SMALLINT,
IS_EXTRAFOOD1 SMALLINT,
IS_EXTRAFOOD2 SMALLINT,
IS_BOARD SMALLINT,
PRICE NUMERIC(15,4),
PRICE_CURR VARCHAR(3),
HOTEL_NAME VARCHAR(50),
UUID VARCHAR(40))
 RETURNS(ID_SERVICE INTEGER,
ID_SERVICE_GROUP INTEGER)
 AS
declare variable ID_HOTEL integer;
declare variable OPERATION VARCHAR(3);
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'SERVICE', :SERVICE_NAME)
  returning_values :ID_HOTEL;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:SERVICE_NAME, 'SERVICE');

  execute procedure IMPORT_SERVICE_GROUP$EXC(:ID_HOTEL, :SERVICE_GROUP)
  returning_values :ID_SERVICE_GROUP;

  ID_SERVICE = null;
  select s.ID_SERVICE
  from   SERVICES s
  where  s.UUID = :UUID
         and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :ID_SERVICE;

  if (:ID_SERVICE is null) then begin
    OPERATION = 'add';
  end else begin
    OPERATION = 'mod';
  end

  if (:EXTRA_PACKET_NAME is null) then begin
    EXTRA_PACKET_NAME = '';
  end

  execute procedure SERVICE_MODIFY(:ID_SERVICE, :ID_SERVICE_GROUP, :SERVICE_TYPE, :SERVICE_NAME,
    :IS_DELETED, :IS_MANUAL_PRICE, :IS_DETAILS, :REVENUE_GROUP, :REVENUE_ACCOUNT,
    :ACCOUNT_NAME, :EXT_CODE, :VAUCHER_PACKET, :EXTRA_PACKET_NAME, :IS_RATE_PRICE,
    :OPERATION, :ID_HOTEL, :IS_BREAKFAST, :IS_LUNCH, :IS_DINNER, :IS_EXTRAFOOD1, :IS_EXTRAFOOD2,
    :IS_BOARD, :PRICE, :PRICE_CURR)
  returning_values :ID_SERVICE;

  update SERVICES s
  set    s.UUID = :UUID
  where  s.ID_SERVICE = :ID_SERVICE;
end
^

/* Alter (MONITOR_ROOM_GANTT$HM) */
ALTER PROCEDURE MONITOR_ROOM_GANTT$HM(FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ID_ROOM INTEGER,
GFROM_DATE DATE,
IS_MOVED_FROM INTEGER,
GTO_DATE DATE,
IS_MOVED_TO INTEGER,
BUSY_GRP INTEGER,
OCCUPANT_ID INTEGER,
IN_SHARE SMALLINT,
ID_GROUP INTEGER,
ATTENTION_STATUS SMALLINT)
 AS
declare variable contiguous_id_room integer;
begin
  for
    select ID_ROOM, GFROM_DATE, IS_MOVED_FROM, GTO_DATE,
           IS_MOVED_TO, BUSY_GRP, OCCUPANT_ID
    from   MONITOR_ROOM_GANTT$INT(:from_date, :to_date)
    into   :id_room, :gfrom_date, :is_moved_from, :gto_date,
           :is_moved_to, :busy_grp, :occupant_id
  do begin
    if (:gfrom_date = :from_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gfrom_date - 1)
      into   :contiguous_id_room;

      if ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_from = 1;

      select O.FROM_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gfrom_date;
    end

    if (:gto_date = :to_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gto_date + 1)
      into   :contiguous_id_room;

      if ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_to = 1;

      select O.TO_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gto_date;
    end

    if (:busy_grp in (1, 24)) then begin
      select RI.ATTENTION_STATUS, RI.ID_GROUP, RI.IN_SHARE
      from   RES_GET_INFO$RSV(:occupant_id, 0, 1, 0) RI
      into   :attention_status, :id_group, :in_share;
    end else begin
      id_group = null;
      attention_status = null;
      in_share = null;
      if (exists(
        select *
        from   ROOMS_SHARE RS
        where  RS.ID_RESERV_DETAIL = :occupant_id
      )) then in_share = 1;
      else in_share = 0;
    end
    suspend;
  end
end
^

/* Alter (MONITOR_ROOM_GANTT_OCCUPANT$HM) */
ALTER PROCEDURE MONITOR_ROOM_GANTT_OCCUPANT$HM(FROM_DATE DATE,
TO_DATE DATE,
REQUEST_OCCUPANT_ID INTEGER)
 RETURNS(ID_ROOM INTEGER,
GFROM_DATE DATE,
IS_MOVED_FROM INTEGER,
GTO_DATE DATE,
IS_MOVED_TO INTEGER,
BUSY_GRP INTEGER,
OCCUPANT_ID INTEGER,
IN_SHARE SMALLINT,
ID_GROUP INTEGER,
ATTENTION_STATUS SMALLINT)
 AS
declare variable contiguous_id_room integer;
begin
  for
    select ID_ROOM, GFROM_DATE, IS_MOVED_FROM, GTO_DATE,
           IS_MOVED_TO, BUSY_GRP, OCCUPANT_ID
    from   MONITOR_ROOM_GANTT$INT(:from_date, :to_date, :request_occupant_id)
    into   :id_room, :gfrom_date, :is_moved_from, :gto_date,
           :is_moved_to, :busy_grp, :occupant_id
  do begin
    if (:gfrom_date = :from_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gfrom_date - 1)
      into   :contiguous_id_room;

      if     ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_from = 1;

      select O.FROM_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gfrom_date;
    end

    if (:gto_date = :to_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gto_date + 1)
      into   :contiguous_id_room;

      if ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_to = 1;

      select O.TO_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gto_date;
    end

    if (exists(
      select *
      from   ROOMS_SHARE RS
      where  RS.ID_ROOM = :id_room
             and RS.BUSY_DATE between :from_date and :to_date
    )) then in_share = 1;
    else in_share = 0;
  
    if (:busy_grp in (1,24)) then begin
      select RI.ATTENTION_STATUS, RI.ID_GROUP
      from   RES_GET_INFO$RSV(:occupant_id, 0, 0, 0) RI
      into   :attention_status, :id_group;
    end else begin
      id_group = null;
      attention_status = null;
    end
    suspend;
  end
end
^

/* Alter (NUMERATOR_MODIFY$CFG) */
ALTER PROCEDURE NUMERATOR_MODIFY$CFG(ID_NUMERATOR INTEGER,
NUM_NAME VARCHAR(50),
NUM_NEXT INTEGER,
LEADING_PART VARCHAR(20),
NUM_LENGTH INTEGER,
NUM_CLASS TYPE OF TNAME_SHORT,
ID_HOTEL TYPE OF ID_REF,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_NUMERATOR INTEGER)
 AS
begin

  if (:NUM_CLASS = 'BOOKING') then ID_HOTEL = null;

  execute procedure SYSTEM_NUMERATOR_MODIFY$INT(:id_numerator, :num_class, :num_name, :num_next - 1, :leading_part,
                    :num_length, :id_hotel, :operation)
  returning_values  :new_id_numerator;
end
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE_OCCUPANCY$INT for: OCCUPANCY_ACTIVE_FRAME_CHK$INT */
ALTER PROCEDURE RES_FINALIZE_OCCUPANCY$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ERROR_CONTEXT VARCHAR(200),
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (OCCUPANCY_ACTIVE_FRAME_CHK$INT) */
ALTER PROCEDURE OCCUPANCY_ACTIVE_FRAME_CHK$INT(ID_AGENT INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM_TYPE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable active_frame_begin integer;
  declare variable active_frame_end integer;
  declare variable outside_frame_end integer;
  declare variable outside_frame_begin integer;
  declare variable id_hotel integer;
  declare variable system_date date;
begin
  /*  Description:
  ||
  */
  if (:ID_AGENT is null) then exit;
  /*  */
  err_code = 0;
  err_text = '';
  active_frame_begin = 0;
  active_frame_end   = 0;

  select rt.ID_HOTEL
  from   ROOM_TYPES rt
  where  rt.ID_ROOM_TYPE = :ID_ROOM_TYPE
  into   :id_hotel;

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  select first 1
         AR.DAYS_BEFORE, AR.DAYS_AFTER
  from   PROFILE_AGENT PA
         join ALLOTMENT A on A.ID_ALLOTMENT = PA.ID_CONTINGENT
         join ALLOTMENT_RELEASE AR on AR.ID_ALLOTMENT = A.ID_ALLOTMENT
  where  PA.ID_AGENT = :id_agent
         and AR.ID_ROOM_TYPE = :id_room_type
         and AR.FROM_DATE <= :to_date
         and AR.TO_DATE   >= :from_date
  into   :active_frame_begin, :active_frame_end;

  /* CHECK CONTINGENT RIGHTS FOR BOOKING OUTSIDE THE ACTIVE FRAME */
  if (:active_frame_end > 0) then outside_frame_end = (:to_date - :system_date) - :active_frame_end;
  else outside_frame_end = 0;
  if (:active_frame_begin > 0) then outside_frame_begin = (:from_date - :system_date) - :active_frame_begin;
  else outside_frame_begin = 0;

  if ((:outside_frame_begin > 0) or (:outside_frame_end > 0)) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_RELEASE_DATE');

    when exception RIGHT_NOT_GRANTED do begin
      if (:outside_frame_begin > :outside_frame_end) then begin
        err_code = -98;
        err_text = f_character(29)||FormatDate(:from_date, 'D;dd.mm.yyyy')||f_character(28)||:outside_frame_begin;
      end else begin
        err_code = -107;
        err_text = f_character(29)||FormatDate(:to_date, 'D;dd.mm.yyyy')||f_character(28)||:outside_frame_end;
      end
    end
  end
end
^

/* Alter (OCCUPANCY_OVERBOOK_CHECK$INT) */
ALTER PROCEDURE OCCUPANCY_OVERBOOK_CHECK$INT(ID_AGENT INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM_TYPE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable must_check_overbook integer;
  declare variable maxbook_date  date;
  declare variable maxbook_rooms  integer;
  declare variable agent_maxbook_date date;
  declare variable agent_maxbook_rooms integer;
  declare variable id_inventory_allotment integer;
  declare variable id_agent_contingent integer;
  declare variable available_rooms integer;
  declare variable problem_date date;
  declare variable room_type varchar(20);
  declare variable id_hotel integer;
begin
  /* 1. DEALING WITH THE TOTAL OVERBOOK.
  || 2. DEALING WITH THE CONTINGENT OVERBOOK.
  */
  err_code = 0;
  err_text = '';
  warn_code = null;

  /* CHECK THE TOTAL HOTEL AVAILABILITY*/
  select H.ID_INVENTORY_ALLOTMENT, RT.TYPE_ROOM, h.ID_HOTEL
  from   ROOM_TYPES RT
         join HOTEL H on H.ID_HOTEL = RT.ID_HOTEL
  where  RT.ID_ROOM_TYPE = :id_room_type
  into   :id_inventory_allotment, :room_type, :id_hotel;

  execute procedure SETTING_GET_VALUE('CHECK_OVERBOOK', :id_hotel)
  returning_values  :must_check_overbook;

  if (:must_check_overbook = 0) then exit;
  /* ********************************** */
  execute procedure OCCUPANCY_OVERBOOK_MAX$INT(:from_date, :to_date, :id_inventory_allotment, :id_room_type)
  returning_values  :maxbook_date, :maxbook_rooms, :available_rooms;

  if (:available_rooms < 0) then begin
    problem_date = :maxbook_date;
    err_text = substring(f_character(29)||cast(abs(:available_rooms) as integer)||f_character(28)||FormatDate(:problem_date, 'D;dd.mm.yyyy')||f_character(28)||:room_type from 1 for 255);

    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_TOTAL_OVERBOOK');

    execute procedure SYSTEM_WARNING_ADD(-95, :err_text)
    returning_values :warn_code;

    when exception RIGHT_NOT_GRANTED do begin
      err_code = -94;
      exit;
    end
  end

  /* check agent contingent overbooko *****************************************/
  select PA.ID_CONTINGENT
  from   PROFILE_AGENT PA
  where  PA.ID_AGENT = :id_agent
  into   :id_agent_contingent;

  if (:id_agent_contingent is not null) then begin
    /* CHECK THE AGENT CONTINGENT AVAILABILITY*/
    execute procedure OCCUPANCY_OVERBOOK_MAX$INT(:from_date, :to_date, :id_agent_contingent, :id_room_type, :id_agent)
    returning_values  :agent_maxbook_date, :agent_maxbook_rooms, :available_rooms;
  
    if (:available_rooms < 0) then begin
      problem_date = :agent_maxbook_date;
      err_text = f_character(29)||FormatDate(:problem_date, 'D;dd.mm.yyyy')||f_character(28)||:room_type||f_character(28)||cast(abs(:available_rooms) as integer);
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CONT_OVERBOOK');

      execute procedure SYSTEM_WARNING_ADD(-97, :err_text)
      returning_values :warn_code;

      when exception RIGHT_NOT_GRANTED do begin
        err_code = -96;
        exit;
      end
    end
  end
end
^

/* Alter (OCCUPANCY_SUMMARY_REMAKE$SYS) */
ALTER PROCEDURE OCCUPANCY_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
begin
  if (not exists (select h.ID_HOTEL
                  from   HOTEL H
                  where  h.ID_HOTEL = :ID_HOTEL)) then exception WRONG_VALUE 'Non-existing hotel!';

  select mindate(sd.SYSTEM_DATE - 1, :TO_DATE)
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :TO_DATE;

  if (:FROM_DATE > :TO_DATE) then exit;

  execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:id_hotel, :FROM_DATE, :TO_DATE);

  execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'OCCUPANCY_REGENERATE',
                                    f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') || f_character(28) || formatdate(:to_date, 'D;dd/mm/yyyy'));
end
^

/* empty dependent procedure body */
/* Clear: MONITOR_ROOM_GANT$HM for: OCCUPANT_GET_INFO */
ALTER PROCEDURE MONITOR_ROOM_GANT$HM(FROM_DATE DATE,
TO_DATE DATE,
IN_ROOM_NAME VARCHAR(10),
IN_ID_ROOM_TYPE INTEGER,
IN_FLOOR INTEGER,
ID_HOTEL INTEGER)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(20),
GANT_FROM_DATE DATE,
GANT_TO_DATE DATE,
BUSY_GRP INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_SHARE_STATUS$INT for: OCCUPANT_GET_INFO */
ALTER PROCEDURE RES_GET_SHARE_STATUS$INT(ID_RESERV_DETAIL INTEGER,
OPTION_ VARCHAR(100),
FOR_DATE DATE)
 RETURNS(SHARE_STATUS INTEGER,
SHARED_RESERVATIONS VARCHAR(1024),
SHARE_RENDER VARCHAR(1024))
 AS
 BEGIN SUSPEND; END
^

/* Alter (OCCUPANT_GET_INFO) */
ALTER PROCEDURE OCCUPANT_GET_INFO(ID_OCCUPANT INTEGER,
IN_BUSY_GRP INTEGER = null)
 RETURNS(BUSY_GRP INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
INFO VARCHAR(1024))
 AS
declare variable max_day_action integer;
begin
  --busy_grp = :in_busy_grp;

  select max(RM.DAY_ACTION_INT), min(rm.BUSY_GROUP_TYPE)
  from   ROOM_MAGIC RM
  where  RM.ID_RESERV_DETAIL = :ID_OCCUPANT
         --and RM.BUSY_GROUP_TYPE = :busy_grp
  into   :max_day_action, :busy_grp;

  if (:busy_grp in (18, 20) and :max_day_action = 0) then begin
    select BGI.BUSY_GRP, BGI.REASON, BGI.FROM_DATE, BGI.TO_DATE
    from   BLOCK_GET_INFO(:id_occupant) BGI
    into   :busy_grp, :info, :from_date, :to_date;
  end else begin
    -- when :busy_grp in (1, 24) or (:max_day_action > 0) - reservation with block busy group type - owners, as an example
    select RGI.BUSY_GRP, RGI.NUMBER, RGI.ARRIVAL_DATE, RGI.DEPARTURE_DATE
    from   RES_GET_INFO$RSV(:id_occupant, 0, 0, 0) RGI
    into   :busy_grp, :info, :from_date, :to_date;
  end

  suspend;
end
^

/* Alter (PAYMENT_ANUL$INT) */
ALTER PROCEDURE PAYMENT_ANUL$INT(ID_PAYMENT_HEAD INTEGER,
ANUL_REASON VARCHAR(100))
 AS
declare variable p_dbkey char(8);
  declare variable id_ar_payment integer;
  declare variable id_payment_storned integer;
  declare variable payment_amount numeric(15,4);
  declare variable pay_currency varchar(3);
  declare variable system_date date;
  declare variable id_hotel integer;
  declare variable id_system_log integer;
  declare variable id_deposit integer;
  declare variable is_posting_stopped integer;
  declare variable round_to numeric(15,4);
begin 
  execute procedure PAYMENT_VOID_CHECK$INT (:ID_PAYMENT_HEAD, :ANUL_REASON);

  select P.RDB$DB_KEY, p.ID_PAYMENT_STORNED, P.PAY_VALUE_A, P.PAY_CURRENCY,
         P.ID_AR_PAYMENT, a.ID_HOTEL, p.ID_DEPOSIT, c.ROUND_TO
  from   PAYMENT_HEAD P
         join ACCOUNT A on A.ID_ACCOUNT = p.ID_ACCOUNT
         join CURRS c on c.CURR = p.PAY_CURRENCY
  where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  into   :p_dbkey, :id_payment_storned, :payment_amount, :pay_currency,
         :id_ar_payment, :id_hotel, :id_deposit, :round_to;

  if (:id_ar_payment is not null) then
    exception PAYMENT_ANNUL_EXCEPTION '-353';
    --'Payment is created from AR module.';

  if (:id_deposit is not null) then begin
    select r.IS_POSTING_STOPPED
    from   DEPOSIT d
           join RESERV_DETAIL r on r.ID_RESERV_DETAIL = d.ID_RESERV_DETAIL
    where  d.ID_DEPOSIT = :id_deposit
    into   :is_posting_stopped;

    if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';
  end

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :system_date;

  insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
         ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT)
  select AP.ID_ACCOUNT, AP.ID_PAYMENT_HEAD, -sum(AP.PAY_AMOUNT), AP.PAY_RATE,
         -sum(AP.ACC_AMOUNT), AP.ACC_RATE, :system_date, AP.ID_DEPOSIT
  from   ACCOUNT_PAYMENTS AP
  where  AP.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  group by AP.ID_ACCOUNT, AP.ID_PAYMENT_HEAD, AP.PAY_RATE, AP.ACC_RATE, AP.ID_DEPOSIT
  having round_f(sum(AP.PAY_AMOUNT), :round_to) <> 0;
                            
  if (:id_payment_storned is not null) then begin
    update PAYMENT_HEAD SP
    set    sp.IS_STORNED = 0
    where  sp.ID_PAYMENT_HEAD = :id_payment_storned;
  end

  execute procedure SYSTEM_EVENT_LOG$INT ('PAYMENT', :ID_PAYMENT_HEAD, 'ANNUL', f_character(29) || formatfloat(:payment_amount, 'F;0.00') || ' ' || :pay_currency || f_character(28) || :ANUL_REASON)
  returning_values  :id_system_log;

  update PAYMENT_HEAD PA
  set    PA.IS_ANUL = 1,
         pa.ANNUL_DATE = :system_date,
         pa.ID_LOG_EVENT_ANNUL = :id_system_log
  where  PA.RDB$DB_KEY = :p_dbkey;

end
^

/* Alter (PAYMENT_DOC_ANUL$DOC) */
ALTER PROCEDURE PAYMENT_DOC_ANUL$DOC(ID_PAYMENT_HEAD INTEGER,
ANUL_REASON VARCHAR(100))
 AS
declare variable dbg varchar(2000);
  declare variable id_deposit integer;
  declare variable doc_direction integer;
begin
  select DP.DOC_DIRECTION
  from   PAYMENT_HEAD P
         join DOC_TYPE_PAY DP on DP.ID_DOC_TYPE = P.ID_DOC_TYPE
  where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  into   :doc_direction;

  if (:doc_direction = 0) then begin
    /* get all deposits created/splited from this payment */
    for
      select D.ID_DEPOSIT
      from   DEPOSIT D
      where  D.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
      into   :id_deposit
    do begin
      execute procedure DEPOSIT_ANUL$DOC (:id_deposit, :ANUL_REASON)
      returning_values :dbg;
    end
  end else begin
    execute procedure DEPOSIT_REFUND_PAY_ANNUL$INT (:ID_PAYMENT_HEAD, :ANUL_REASON);
  end

end
^

/* empty dependent procedure body */
/* Clear: GUEST_ADDRESSCARD_SET$INT for: PERSON_DATA_SET$INT */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$INT(PD_DBKEY CHAR(8),
G_DBKEY CHAR(8),
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
COUNTRY_CODE VARCHAR(10),
IS_CHILD INTEGER,
AGE INTEGER,
BIRTH_DAY DATE,
TITLE VARCHAR(10))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_PERSON_MODIFY$PROFILE for: PERSON_DATA_SET$INT */
ALTER PROCEDURE PROFILE_PERSON_MODIFY$PROFILE(ID_PROFILE INTEGER,
ID_GUEST_TYPE INTEGER,
PROFILE_NAME VARCHAR(100),
PERSON_NAME2 VARCHAR(100),
SEX CHAR,
BIRTH_DAY DATE,
BIRTH_PLACE VARCHAR(30),
EGN VARCHAR(30),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
COUNTRY_CODE VARCHAR(20),
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
MASK VARCHAR(10),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
IS_ARCHIVE INTEGER,
ID_PHOTO INTEGER,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
TITLE VARCHAR(10) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PERSON_DATA_SET$INT) */
ALTER PROCEDURE PERSON_DATA_SET$INT(P_DBKEY CHAR(8),
PD_DBKEY CHAR(8),
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
COUNTRY VARCHAR(10),
BIRTH_DAY DATE,
BIRTHDAY_INTERNAL DATE,
TITLE VARCHAR(10) = null)
 AS
declare variable id_profile integer;
  declare variable id_guest integer;
  declare variable old_name varchar(100);
  declare variable old_country varchar(10);
  declare variable country_name varchar(50);
  declare variable action_text varchar(255);
  declare variable age integer;
  declare variable old_birthday date;
  declare variable id_person_data integer;
  declare variable old_title varchar(10);
begin

  select coalesce(:country, PD.COUNTRY_CODE), PD.BIRTH_DAY, PD.PERSON_NAME, PD.COUNTRY_CODE,
         pd.ID_PERSON_DATA, pd.TITLE
  from   PERSON_DATA PD
  where  PD.RDB$DB_KEY = :pd_dbkey
  into   :country, :old_birthday, :old_name, :old_country,
         :id_person_data, :old_title;

  update  PERSON_DATA PD
  set     PD.PERSON_NAME = :GUEST_NAME1,
          PD.PERSON_NAME2 = coalesce(:guest_name2, iif(PD.PERSON_NAME = PD.PERSON_NAME2, :guest_name1, PD.PERSON_NAME2)),
          PD.COUNTRY_CODE = :country,
          PD.BIRTH_DAY = coalesce(:birthday_internal, :birth_day), -- this is relative date, calculated by input age or equal to real birth day (if exists)
          PD.BIRTHDAY_INTERNAL = :birthday_internal, -- this is real person birth day (can be null)
          PD.TITLE = :TITLE
  where   PD.RDB$DB_KEY = :pd_dbkey;

  if ((:old_name is distinct from :GUEST_NAME1)
      or (:old_birthday is distinct from :BIRTH_DAY)
      or (:old_title is distinct from :TITLE)
      or (:old_country is distinct from :COUNTRY)) then
  begin
    -- update all related checked in and not checked out guest's cards
    for
      select GD.ID_GUEST
      from   GUEST_DATA GD
             join GUEST G on g.ID_GUEST = gd.ID_GUEST
      where  GD.ID_PERSON_DATA = :id_person_data
             and g.ID_RESERV_DETAIL is not null
             and g.IS_CHECK_IN = 1
             -- and g.IS_CHECK_OUT = 0
      into   :id_guest
    do begin
      select C.COUNTRY_NAME
      from   COUNTRY C
      where  C.COUNTRY_CODE = :COUNTRY
      into   :country_name;
  
      select CA.AGE_INYEARS
      from   SYSTEM_CALC_AGE_INYEARS (:birth_day, current_timestamp) CA
      into   :age;
  
      action_text = f_character(29) || '"' || :guest_name1 || '", ' || coalesce(:age, '') || ', ' || coalesce(:country_name, '');
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'GUEST_IDENT_CHNG', :action_text);

      execute procedure GUEST_REGISTRATION_UPDATE(:id_guest);
    end
  end

  if (ascii_val(nullif(trim(:TITLE), '')) > 64) then  -- starting with letter strings only
    execute procedure LIST_ITEM_MODIFY('person_title', null, :TITLE, 'add');

  if (:p_dbkey is not null) then begin
    update PROFILE P
    set    P.PROFILE_NAME = :guest_name1
    where  P.RDB$DB_KEY = :p_dbkey
    returning new.id_profile
    into   :id_profile;

    -- force reserv changes tracking!
    update RESERV_DETAIL rd
    set    rd.ID_PERSON_PROFILE = :id_profile
    where  rd.ID_PERSON_PROFILE = :id_profile;
  end
end
^

/* Alter (PHONE_LINE_CONVERT_MODIFY$CFG) */
ALTER PROCEDURE PHONE_LINE_CONVERT_MODIFY$CFG(ID INTEGER,
LINE VARCHAR(30),
ROOM_NAME VARCHAR(30),
IS_TAXABLE SMALLINT,
IS_ARCHIVE SMALLINT,
PRICE_INDEX NUMERIC(15,4),
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER,
OPERATION VARCHAR(10))
 RETURNS(NEW_ID INTEGER)
 AS
declare variable action_text varchar(255);
declare variable account_name varchar(50);
declare variable hotel_name varchar(50);
declare variable old_line varchar(30);
declare variable old_room_name varchar(30);
declare variable old_is_taxable smallint;
declare variable old_is_archive smallint;
declare variable old_price_index numeric(15,4);
declare variable old_account_name varchar(50);
declare variable old_hotel_name varchar(50);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:OPERATION = 'add') then ID = null;

  if (:OPERATION in ('add', 'mod')) then begin

    update or insert into PHONE_LINE_CONVERT (ID, LINE, ROOM_NAME, IS_TAXABLE, IS_ARCHIVE, PRICE_INDEX, ID_HOTEL, ID_ACCOUNT)
    values      (:ID, :line, :room_name, :is_taxable, :is_archive, :price_index, :id_hotel, :ID_ACCOUNT)
    matching    (ID)
    returning   ID
    into        :new_id;
  
    select coalesce(ACC.ACCOUNT_NAME, '')
    from   ACCOUNT ACC
    where  ACC.ID_ACCOUNT = :ID_ACCOUNT
    into   :account_name;
  
    select H.HOTEL_NAME
    from   HOTEL H
    where  H.ID_HOTEL = :ID_HOTEL
    into   :hotel_name;
  
    action_text = f_character(29) || :line || f_character(28) || :room_name ||
                  f_character(28) || :is_taxable || f_character(28) || :is_archive ||
                  f_character(28) || formatfloat(:price_index, '0.00') || f_character(28) || :hotel_name ||
                  f_character(28) || coalesce(:account_name, '');
    execute procedure SYSTEM_LOG_ADD ('PHONE_LINES', :NEW_ID, 'PHONE_LINE_MODIFY', :ACTION_TEXT);

  end else if (:operation = 'del') then begin
    select PLC.LINE, PLC.ROOM_NAME, PLC.IS_TAXABLE, PLC.IS_ARCHIVE, PLC.PRICE_INDEX,
           A.ACCOUNT_NAME, HO.HOTEL_NAME
    from   PHONE_LINE_CONVERT PLC
           join HOTEL HO on HO.ID_HOTEL = PLC.ID_HOTEL
           left outer join ACCOUNT A on A.ID_ACCOUNT = PLC.ID_ACCOUNT
    where  PLC.ID = :ID
    into   :old_line, :old_room_name, :old_is_taxable, :old_is_archive, :old_price_index,
           :old_account_name, :old_hotel_name;

    action_text = f_character(29) || :old_line || f_character(28) || :old_room_name ||
                  f_character(28) || :old_is_taxable || f_character(28) || :old_is_archive ||
                  f_character(28) || formatfloat(:old_price_index, '0.00') ||
                  f_character(28) || :old_hotel_name ||
                  f_character(28) || coalesce(:old_account_name, '');
    execute procedure SYSTEM_LOG_ADD ('PHONE_LINES', :ID, 'DELETE', :ACTION_TEXT);

    delete from PHONE_LINE_CONVERT
    where  ID = :id;
  end
end
^

/* Alter (PHONECALL_POST$TC) */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Alter (PHONECALLS_POST_TO_ACCOUNT$TC) */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* empty dependent procedure body */
/* Clear: OWNER_BILL_MODIFY$PMS for: PMS_EVENT_VOID$INT */
ALTER PROCEDURE OWNER_BILL_MODIFY$PMS(ID_OWNER_BILL INTEGER,
ID_OWNER INTEGER,
BILLING_DATE DATE,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_OWNER_BILL INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_EVENT_ANUL$PMS for: PMS_EVENT_VOID$INT */
ALTER PROCEDURE PMS_EVENT_ANUL$PMS(ID_PMS_EVENT INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PMS_IMPORT_ANUL for: PMS_EVENT_VOID$INT */
ALTER PROCEDURE PMS_IMPORT_ANUL(ID_EXPORT_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_EVENT_VOID$INT) */
ALTER PROCEDURE PMS_EVENT_VOID$INT(ID_PMS_EVENT INTEGER)
 AS
declare variable id_post integer;
  declare variable ap_dbkey char(8);
begin
/*  EVENT_TYPE in ('INCOME, MANUAL_INCOME, MANUAL_EXPENSE, POOL_DISTRIBUTION') */

  if ( exists ( select *
                from   ACCOUNT_POST$PMS AP
                where  AP.ID_PMS_EVENT = :id_pms_event
                       and AP.LINE_STATUS = 21 )
       or
       exists ( select *
                from   ACCOUNT_POST AP
                       join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
                where  PP.ID_PMS_EVENT = :id_pms_event
                       and PP.LINE_STATUS = 21 ) ) then
  begin
    exception PMS_EXCEPTION '-620';    --dokumentirani nachisleniq ne mogat da se anulirat!
  end

  update PMS_EVENT$PMS P
  set    P.EVENT_STATUS = 22
  where  P.ID_PMS_EVENT = :ID_PMS_EVENT;

  for
    select P.ID_ACCOUNT_POST
    from   ACCOUNT_POST$PMS P
    where  P.ID_PMS_EVENT = :ID_PMS_EVENT
           and P.LINE_STATUS = 11
    into   :id_post
  do begin
    execute procedure ACCOUNT_POST_PMS_ANUL$INT(:id_pms_event, :id_post);
  end

  for
    select PEP.ID_ACCOUNT_POST, ap.RDB$DB_KEY
    from   PMS_EVENT_POST PEP
           join ACCOUNT_POST AP on PEP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
    where  PEP.ID_PMS_EVENT = :ID_PMS_EVENT
           and AP.IS_ANUL = 0
    into   :id_post, :ap_dbkey
  do begin
    execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_dbkey, 'VOID');

    update PMS_EVENT_POST EP
    set    EP.LINE_STATUS = 22
    where  EP.ID_ACCOUNT_POST = :id_post;
  end

  -- for compatibility with old import logic
  execute procedure PMS_PREV_EVENT_CHECK$INT(:ID_PMS_EVENT);
end
^

/* Alter (PMS_IMPORT_ANUL) */
ALTER PROCEDURE PMS_IMPORT_ANUL(ID_EXPORT_HEAD INTEGER)
 AS
declare variable id_pms_event integer;

  declare variable is_anul smallint;
  declare variable exist_not_anul smallint;
  declare variable to_sys_date date;
  declare variable id_hotel integer;
begin

  select R.IS_ANUL, R.TO_SYS_DATE, R.ID_HOTEL
  from   RESERV_EXPORT$PMS R
  where  R.ID_EXPORT_HEAD = :ID_EXPORT_HEAD
  into   :IS_ANUL, :to_sys_date, :id_hotel;
  if (:IS_ANUL = 1) then exception PMS_EXCEPTION '-621';

  select min(R.IS_ANUL)
  from   RESERV_EXPORT$PMS R
  where  R.from_sys_date > :to_sys_date
         and r.ID_HOTEL = :id_hotel
  into   :exist_not_anul;
  if (:exist_not_anul = 0) then exception PMS_EXCEPTION '-625';

  for
    select E.ID_PMS_EVENT
    from   PMS_EVENT$PMS E
    where  E.ID_EXPORT_HEAD = :ID_EXPORT_HEAD
    into   :id_pms_event
  do begin
    execute procedure PMS_EVENT_VOID$INT(:id_pms_event);

  end
   
  update RESERV_EXPORT$PMS R
  set    R.IS_ANUL = 1,
         R.DT_ANUL = current_timestamp
  where  R.ID_EXPORT_HEAD = :ID_EXPORT_HEAD;

end
^

/* empty dependent procedure body */
/* Clear: CONTRACT_EXPENSE_POST$INT for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_HOTEL INTEGER,
ID_CONTRACT /* TYPE OF ID */ INTEGER,
SUB_CONTRACT /* TYPE OF TSUB_CONTRACT */ VARCHAR(10),
ID_OWNER /* TYPE OF ID */ INTEGER,
OWNERSHIP_PERCENT /* TYPE OF TPERCENT */ NUMERIC(15,4),
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
POST_DATE /* TYPE OF TDATE */ DATE,
STAY /* TYPE OF TCOUNT */ INTEGER,
MAX_GUEST_CNT /* TYPE OF TCOUNT */ INTEGER,
BED_NIGHT_CNT /* TYPE OF TCOUNT */ INTEGER,
RESERVS /* TYPE OF TCOUNT */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PMS_EXPENSE_POSTS_CREATE$INT for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
POST_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
IS_CLIENT_ACC_POST /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_POST_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_POST_PER_POOL /* TYPE OF TLOGICAL */ SMALLINT)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER,
NEW_ID_ACCOUNT_POST$PMS /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_POOL_DISTRIBUTION_SUB for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_POSTING_CREATE$INT) */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_OWNER TYPE OF ID,
POST_DATE TYPE OF TDATE,
CURR_ORIG TYPE OF TCURRENCY,
VALUE_ORIG TYPE OF TPRICE,
POST_ON_PMS_ACCOUNT TYPE OF TLOGICAL,
IS_OWNER_INCOME TYPE OF TLOGICAL,
ID_ROOM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  if (:POST_ON_PMS_ACCOUNT = 1) then begin
    execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account, :id_owner,
            :CURR_ORIG, :VALUE_ORIG, :id_service, :is_owner_income, :POST_DATE)
    returning_values  (:new_id_account_post);
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :ID_SERVICE, 1, 0, 1,
            :VALUE_ORIG, :CURR_ORIG, current_date, current_date,
            '', '', :POST_DATE, 'PMS', :ID_ROOM)
    returning_values  :err_code, :err_text, :new_id_account_post;
    if (:err_code <> 0) then exception PMS_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:ID_PMS_EVENT, :NEW_ID_ACCOUNT_POST, :ID_OWNER, 11);
  end
end
^

/* Alter (PMS_REGULAR_POST_CREATE$PMS) */
ALTER PROCEDURE PMS_REGULAR_POST_CREATE$PMS(ID_CONTRACT_CALENDAR_POST INTEGER,
ID_ROOM INTEGER,
ID_OWNER INTEGER,
ID_CURRENCY VARCHAR(3),
ID_SERVICE INTEGER,
POST_VALUE NUMERIC(15,4),
IS_ACC_POST_ITEM SMALLINT,
MANUAL_POST_DATE DATE,
DESCRIPTION VARCHAR(255),
IS_POST_PER_POOL SMALLINT,
ID_RENTAL_POOL INTEGER,
IS_INCOME_POST SMALLINT)
 AS
declare variable no_use varchar(1000);
begin

  if (:IS_INCOME_POST = 1) then begin
    execute procedure PMS_INCOME_POSTING_CREATE$PMS(:ID_ROOM, :ID_OWNER, :ID_RENTAL_POOL,
            :ID_CURRENCY, :ID_SERVICE, :POST_VALUE, :MANUAL_POST_DATE, :DESCRIPTION, :IS_POST_PER_POOL);
  end else begin
    execute procedure PMS_EXPENSE_POSTING_CREATE$PMS(:ID_ROOM, :ID_OWNER, :ID_RENTAL_POOL,
            :ID_SERVICE, :ID_CURRENCY, :POST_VALUE, :IS_ACC_POST_ITEM, :MANUAL_POST_DATE,
            :DESCRIPTION, :IS_POST_PER_POOL);
  end

  delete from CONTRACT_CALENDAR_SCHEME$PMS S
  where  S.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST
         and S.POST_DATE = :MANUAL_POST_DATE;

  execute procedure CONTRACT_CALENDAR_MODIFY$PMS(:ID_CONTRACT_CALENDAR_POST,
          null, null, null, null, null, null, null, null, null,  null, 'mod_next_date')
  returning_values (:no_use);

end
^

/* Alter (POST_SERVICE_FINALIZE$POST) */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable post_text varchar(100);
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '')
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '')
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set ID_ACCOUNT_POST = :id_acc_post
      where RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_AGENT_PROFILE$EXC for: PROFILE_AGENT_MODIFY$PROFILE */
ALTER PROCEDURE IMPORT_AGENT_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
AGENT_GROUP VARCHAR(50),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
WBE_PASSWORD VARCHAR(20),
IATA_NUMBER VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(2000),
DEF_CONTRAGENT_NAME VARCHAR(100),
THRESHOLD_NOTE VARCHAR(255),
THRESHOLD_AMOUNT NUMERIC(15,4),
THRESHOLD_CURR CHAR(3),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PROFILE_AGENT_MODIFY$PROFILE) */
ALTER PROCEDURE PROFILE_AGENT_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
AGENT_GROUP VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IATA_NUMBER VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null,
THRESHOLD_NOTE VARCHAR(255) = null,
THRESHOLD_AMOUNT NUMERIC(15,4) = null,
THRESHOLD_CURR CHAR(3) = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable id_agent integer;
  declare variable action_text varchar(255);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  AGENT_GROUP = nullif(trim(:AGENT_GROUP), '');

  if (:operation in ('add', 'mod')) then begin
    execute procedure PROFILE_COMMON_MODIFY$INT(:id_profile, 'AGENT', :profile_name,
            :phone, :fax, :email, :contact_city, :contact_address,
            :note, :msg, :is_archive, :id_def_contragent, :id_nom_market_segment,
            :wbe_password, :account_no, :is_exclusive_debt_ownership)
    returning_values (:NEW_ID_PROFILE);

    if (:new_id_profile is distinct from :id_profile) then begin
      id_agent = gen_id(G_AUTO_INC_AGENT,1);
      insert into AGENT (ID_AGENT, AGENT_NAME, IS_USE)
      values (:id_agent, :profile_name, 1-:is_archive);
  
      insert into PROFILE_AGENT(ID_PROFILE, ID_AGENT, AGENT_GROUP, COUNTRY_CODE, IATA_NUMBER, THRESHOLD_NOTE, THRESHOLD_AMOUNT, THRESHOLD_CURR)
      values (:new_id_profile, :id_agent, :agent_group, :country_code, :iata_number, :threshold_note, :threshold_amount, :threshold_curr);
  
      action_text = f_character(29) || :profile_name;
      execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_AGENT_PROFILE', :action_text);
    end else begin
      select PA.ID_AGENT
      from   PROFILE_AGENT PA
      where  PA.ID_PROFILE = :NEW_ID_PROFILE
      into   :id_agent;

      update PROFILE_AGENT PA
      set    PA.IATA_NUMBER = :IATA_NUMBER,
             PA.COUNTRY_CODE = :COUNTRY_CODE,
             PA.AGENT_GROUP = :AGENT_GROUP,
             PA.THRESHOLD_NOTE = :THRESHOLD_NOTE,
             PA.THRESHOLD_AMOUNT = :THRESHOLD_AMOUNT,
             PA.THRESHOLD_CURR = :THRESHOLD_CURR
      where  PA.ID_PROFILE = :NEW_ID_PROFILE;

      update AGENT A
      set    A.AGENT_NAME = :profile_name,
             A.IS_USE = 1 - :is_archive
      where  A.ID_AGENT = :id_agent;
    end
  end else if (:operation = 'del') then  begin
    execute procedure PROFILE_DELETE$INT(:id_profile);

    new_id_profile = null;
  end
end
^

/* Alter (PROFILE_COMMON_MODIFY$INT) */
ALTER PROCEDURE PROFILE_COMMON_MODIFY$INT(ID_PROFILE INTEGER,
PROFILE_TYPE VARCHAR(20),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable action_text varchar(255);
  declare variable old_profile_name varchar(100);
  declare variable old_is_archive integer;
  declare variable p_dbkey char(8);
begin
  p_dbkey = null;
  select P.RDB$DB_KEY, P.PROFILE_NAME, P.IS_ARCHIVE
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :p_dbkey, :old_profile_name, :old_is_archive;
   
  is_exclusive_debt_ownership = coalesce(:is_exclusive_debt_ownership, 0);
  new_id_profile = :id_profile;
  if (:p_dbkey is null) then begin
    execute procedure SYSTEM_CHECK_OPERATION (:PROFILE_TYPE, 'PERSON,AGENT,HOUSE', 'Profile type');

    new_id_profile = gen_id(gen_profile_id, 1);
    insert into PROFILE (ID_PROFILE, PROFILE_NAME, PROFILE_TYPE,
           PHONE, FAX, EMAIL, CITY, ADDRESS, NOTE, MSG,
           ID_DEF_CONTRAGENT, ID_NOM_MARKET_SEGMENT, IS_ARCHIVE, ACCOUNT_NO,
           WBE_PASSWORD, IS_EXCLUSIVE_DEBT_OWNERSHIP)
    values (:new_id_profile, :profile_name, :profile_type,
           :phone, :fax, :email, :contact_city, :contact_address, :note, :msg,
           :id_def_contragent, :id_nom_market_segment, 0, :account_no,
           nullif(:wbe_password, ''), :is_exclusive_debt_ownership)
    returning RDB$DB_KEY into :p_dbkey;
  end else begin
    update PROFILE PU
    set    PU.PROFILE_NAME = :profile_name,
           PU.PHONE = :phone,
           PU.FAX = :fax,
           PU.EMAIL = :email,
           PU.CITY = :contact_city,
           PU.ADDRESS = :contact_address,
           PU.NOTE = :note,
           PU.MSG = :msg,
           PU.ID_DEF_CONTRAGENT = :id_def_contragent,
           PU.ID_NOM_MARKET_SEGMENT = :id_nom_market_segment,
           PU.ACCOUNT_NO = :ACCOUNT_NO,
           PU.WBE_PASSWORD = iif(PU.WBE_PASSWORD is null and :wbe_password = '', null, :wbe_password),
           -- empty ('') new password should not relpace NULLs,
           -- empty password indicate for 'deleted real password'
           PU.IS_EXCLUSIVE_DEBT_OWNERSHIP = :IS_EXCLUSIVE_DEBT_OWNERSHIP
    where  PU.RDB$DB_KEY = :p_dbkey;
  
    if (:old_profile_name <> :profile_name) then begin
      action_text = f_character(29) || :old_profile_name || f_character(28) || :profile_name;
      execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'EDIT_NAME', :action_text);
    end
  
    if (:is_archive is distinct from :old_is_archive) then
      execute procedure PROFILE_SET_ARCHIVE$INT (:P_DBKEY, :IS_ARCHIVE);

  end
end
^

/* Alter (PROFILE_DELETE$INT) */
ALTER PROCEDURE PROFILE_DELETE$INT(ID_PROFILE INTEGER)
 AS
declare variable action_text varchar(255);
declare variable id_agent integer;
begin
  id_agent = null;
  select pa.ID_AGENT
  from   PROFILE_AGENT pa
  where  pa.ID_PROFILE = :ID_PROFILE
  into   :id_agent;

  delete from PROFILE P
  where  P.ID_PROFILE = :id_profile;

  if (:id_agent is not null) then
    delete from AGENT A where a.ID_AGENT = :id_agent;

  action_text = '';
  execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'DELETE', :action_text);

end
^

/* Alter (PROFILE_HOUSE_MODIFY$PROFILE) */
ALTER PROCEDURE PROFILE_HOUSE_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(20),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
HOUSE_TYPE VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable action_text varchar(255);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    execute procedure PROFILE_COMMON_MODIFY$INT(:id_profile, 'HOUSE', :profile_name,
            :phone, :fax, :email, :contact_city, :contact_address,
            :note, :msg, :is_archive, :id_def_contragent, :id_nom_market_segment,
            :wbe_password, :account_no, :is_exclusive_debt_ownership)
    returning_values (:new_id_profile);

    if (:operation = 'add') then begin
      insert into PROFILE_HOUSE(ID_PROFILE, HOUSE_TYPE)
      values (:new_id_profile, :house_type);

      action_text = f_character(29) || :PROFILE_NAME;
      execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_HOUSE_PROFILE', :action_text);
    end
  end else if (:operation = 'del') then  begin
    execute procedure PROFILE_DELETE$INT(:id_profile);

    new_id_profile = null;
  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_PERSON_PROFILE$EXC for: PROFILE_MERGE$PROFILE */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(2000),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PROFILE_MERGE$PROFILE) */
ALTER PROCEDURE PROFILE_MERGE$PROFILE(ID_SOURCE INTEGER,
ID_TARGET INTEGER,
OPERATION VARCHAR(20))
 AS
declare variable source_p_type varchar(30);
  declare variable target_p_type varchar(30);
  declare variable total_points_gained integer;
  declare variable total_points_consumed integer;
  declare variable source_p_name varchar(100);
  declare variable target_p_name varchar(100);
  declare variable id_hotel integer;
  declare variable id_bps integer;
  declare variable target_id_p_data integer;
  declare variable rd_dbkey char(8);
  declare variable gd_dbkey char(8);
  declare variable check_status smallint;
  declare variable id_reserv_detail integer;
  declare variable is_archive integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'merge, notequals');

  if ((:ID_SOURCE is null) or (:ID_TARGET is null)) then exception PROFILE_EXCEPTION '<NULL> profile id is passed!';

  if (:operation = 'notequals') then begin
    insert into PROFILE_DISSIMILAR (ID_PROFILE1, ID_PROFILE2)
    values (iif(:id_source < :id_target, :id_source, :id_target),
            iif(:id_source > :id_target, :id_source, :id_target));

    when any do exit;

  end else if (:operation = 'merge') then begin
    if (exists (select o.ID_OWNER from OWNER$PMS O where O.ID_OWNER in (:ID_SOURCE, :ID_TARGET))) then
      exception PROFILE_EXCEPTION '-1047';

    select p.PROFILE_TYPE, p.PROFILE_NAME
    from   PROFILE P
    where  P.ID_PROFILE = :ID_SOURCE
    into   :source_p_type, :source_p_name;

    select p.PROFILE_TYPE, p.PROFILE_NAME, PP.ID_PERSON_DATA, p.IS_ARCHIVE
    from   PROFILE P
           left outer join PROFILE_PERSON PP on PP.ID_PROFILE = P.ID_PROFILE 
    where  P.ID_PROFILE = :ID_TARGET
    into   :target_p_type, :target_p_name, :target_id_p_data, :is_archive;

    if (:is_archive = 1) then exception PROFILE_EXCEPTION '-1055';
    if (:source_p_type <> :target_p_type) then exception PROFILE_EXCEPTION 'Profile types are incompatible!';

    update RESERV_DETAIL RD
    set    rd.ID_AGENT_PROFILE = :ID_TARGET
    where  rd.ID_AGENT_PROFILE = :ID_SOURCE;

    update ACCOUNT A
    set    a.ID_PROFILE = :ID_TARGET
    where  a.ID_PROFILE = :ID_SOURCE;

    update AR_OWING AO
    set    ao.ID_PROFILE = :ID_TARGET
    where  ao.ID_PROFILE = :ID_SOURCE;

    update AR_PAYMENT ARP
    set    arp.ID_PROFILE = :ID_TARGET
    where  arp.ID_PROFILE = :ID_SOURCE;

    update AR_OWING_PAYMENT_POST AROP
    set    arop.ID_PROFILE = :ID_TARGET
    where  arop.ID_PROFILE = :ID_SOURCE;

    update DEPOSIT D
    set    d.ID_PROFILE = :ID_TARGET
    where  d.ID_PROFILE = :ID_SOURCE;

    update PROFILE_CREDIT_CARD pcc
    set    pcc.ID_PROFILE = :ID_TARGET
    where  pcc.ID_PROFILE = :ID_SOURCE
           and not exists (select spc.CARD_CODE
                           from   PROFILE_CREDIT_CARD spc
                           where  spc.ID_PROFILE = :ID_TARGET
                                  and spc.CARD_CODE = pcc.CARD_CODE);

    update PROFILE_DISCOUNT pd
    set    pd.ID_PROFILE = :ID_TARGET
    where  pd.ID_PROFILE = :ID_SOURCE
           and not exists (select spd.ID_SALE_DISCOUNT
                           from   PROFILE_DISCOUNT spd
                           where  spd.ID_PROFILE = :ID_TARGET
                                  and spd.ID_SALE_DISCOUNT = pd.ID_SALE_DISCOUNT);

    update PROFILE_HOTEL_RATE phr
    set    phr.ID_PROFILE = :ID_TARGET
    where  phr.ID_PROFILE = :ID_SOURCE
           and not exists (select tphr.ID_PROFILE
                           from   PROFILE_HOTEL_RATE tphr
                           where  tphr.ID_PROFILE = :ID_TARGET
                                  and tphr.ID_TARIFF = phr.ID_TARIFF
                                  and tphr.ID_HOTEL = phr.ID_HOTEL);

    update PROFILE_FILE pf
    set    pf.ID_PROFILE = :ID_TARGET
    where  pf.ID_PROFILE = :ID_SOURCE;

    for
      select sbs.ID_HOTEL, sbs.ID_BONUSPOINT_SCHEME
      from   PROFILE_BONUSPOINT_SCHEME sbs
      where  sbs.ID_PROFILE = :ID_SOURCE
      into   :id_hotel, :id_bps
    do begin
      if (not exists (select tbs.ID_BONUSPOINT_SCHEME
                      from   PROFILE_BONUSPOINT_SCHEME tbs
                      where  tbs.ID_PROFILE = :ID_TARGET
                             and tbs.ID_HOTEL = :id_hotel)) then
      begin
        insert into PROFILE_BONUSPOINT_SCHEME (ID_PROFILE, ID_HOTEL, ID_BONUSPOINT_SCHEME)
        values (:ID_TARGET, :id_hotel, :id_bps);
      end

    end

    update PROFILE_WALLET_POINTS pwp
    set    pwp.ID_PROFILE = :ID_TARGET
    where  pwp.ID_PROFILE = :ID_SOURCE;

    select pw.TOTAL_POINTS_GAINED, pw.TOTAL_POINTS_CONSUMED
    from   PROFILE_WALLET pw
    where  pw.ID_PROFILE = :ID_TARGET
    into   :total_points_gained, :total_points_consumed;

    update PROFILE p
    set    p.BONUSPOINT_GAINED = :total_points_gained,
           p.BONUSPOINT_CONSUMED = :total_points_consumed
    where  p.ID_PROFILE = :ID_TARGET;

    if (:source_p_type = 'PERSON') then begin
      for
        select RD.RDB$DB_KEY, GD.RDB$DB_KEY, RD.CHECK_STATUS, RD.ID_RESERV_DETAIL
        from   RESERV_DETAIL RD
               join GUEST_DATA GD on GD.ID_GUEST = RD.ID_TITULAR
        where  rd.ID_PERSON_PROFILE = :id_source
        into   :rd_dbkey, :gd_dbkey, :check_status, :id_reserv_detail
      do begin
        update RESERV_DETAIL RD
        set    RD.ID_PERSON_PROFILE = :id_target
        where  RD.RDB$DB_KEY = :rd_dbkey;

        if (:check_status < 1) then begin
          update GUEST_DATA GD
          set    GD.ID_PERSON_DATA = :target_id_p_data
          where  GD.RDB$DB_KEY = :gd_dbkey;

          execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL,  'TITULAR_CHAN_PROF_MERGE',
                                            f_character(29) || :source_p_name || f_character(28) || :target_p_name);
        end
      end

    end else if (:source_p_type = 'AGENT') then begin
      update SUMMARY_PROFILES$REV spr
      set    spr.ID_PROFILE = :ID_TARGET
      where  spr.ID_PROFILE = :ID_SOURCE;

      update SUMMARY_OCCUPANCY_PROFILE_MRKT sopm
      set    sopm.ID_PROFILE_AGENT = :ID_TARGET
      where  sopm.ID_PROFILE_AGENT = :ID_SOURCE;

      update SUMMARY_OCCUPANCY_OTHER soo
      set    soo.ID_PROFILE_AGENT = :ID_TARGET
      where  soo.ID_PROFILE_AGENT = :ID_SOURCE;
  
      update RES_TEMPLATE rt
      set    rt.ID_AGENT_PROFILE = :ID_TARGET
      where  rt.ID_AGENT_PROFILE = :ID_SOURCE;

      -- PROFILE_HOTEL_ALLOTMENT - keep target's allotments only 
    end

    /* delete or archivate */
    update PROFILE P
    set    p.IS_ARCHIVE = 1,
           p.ID_MERGE_PROFILE = :ID_TARGET
    where  p.ID_PROFILE = :ID_SOURCE;

    -- ficticious update - to force export only
    update PROFILE P
    set    p.UUID = p.UUID
    where  p.ID_PROFILE = :ID_TARGET;
    -- log
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_SOURCE, 'MERGE_TO', f_character(29) || :target_p_name);
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_TARGET, 'CONSOLIDATE_WITH', f_character(29) || :source_p_name);
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_ROOM$INT for: PROFILE_PERSON_CREATEQ$PROFILE */
ALTER PROCEDURE RES_CREATE_ROOM$INT(CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_COUNT INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_AGENT_PROFILE INTEGER,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_PERSON_PROFILE INTEGER,
ACC_ROUTING VARCHAR(50),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ID_GROUP INTEGER = null,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_GUARANTEE_POLICY INTEGER = null,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
RD_DBKEY CHAR(8),
NEW_ID_PERSON_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_PERSON_PROFILE$INT for: PROFILE_PERSON_CREATEQ$PROFILE */
ALTER PROCEDURE RES_GET_PERSON_PROFILE$INT(ID_GUEST INTEGER)
 RETURNS(ID_PERSON_PROFILE INTEGER,
ID_PERSON_DATA INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PROFILE_PERSON_CREATEQ$PROFILE) */
ALTER PROCEDURE PROFILE_PERSON_CREATEQ$PROFILE(PROFILE_NAME TYPE OF TPERSON_NAME,
PHONE TYPE OF TPHONE,
ID_PASSPORT_TYPE TYPE OF ID,
PASS_NUM TYPE OF NAME_20,
EGN TYPE OF TTEXT_SHORT,
COUNTRY_CODE TYPE OF TSHORT_CODE,
CARD_CODE TYPE OF TCARD_CODE,
ID_PERSON_DATA TYPE OF ID_REF = null,
TITLE TYPE OF TSHORT_CODE = null,
ID_HOTEL TYPE OF ID_REF = null)
 RETURNS(NEW_ID_PROFILE TYPE OF ID,
P_DBKEY TYPE OF TDB_KEY,
PD_DBKEY TYPE OF TDB_KEY)
 AS
declare variable action_text varchar(255);
  declare variable mask varchar(10);
  declare variable merge_ident_num tname_unicode;
  declare variable merge_ident_num_alt tname_unicode;
begin
  select trim(ss.UNICODE_STRING) from SYSTEM_STRING_TO_UNICODE(:EGN) ss into :merge_ident_num;
  select trim(ss.UNICODE_STRING) from SYSTEM_STRING_TO_UNICODE(:PASS_NUM) ss into :merge_ident_num_alt;

  new_id_profile = gen_id(gen_profile_id, 1);
  insert into PROFILE (ID_PROFILE, PROFILE_NAME, PROFILE_TYPE, PHONE, IS_ARCHIVE, MERGE_IDENT_NUM, MERGE_IDENT_NUM_ALT)
  values (:new_id_profile, :profile_name, 'PERSON', :phone, 0, :merge_ident_num, :merge_ident_num_alt)
  returning RDB$DB_KEY into :p_dbkey;

  PD_DBKEY = null;
  if (:id_person_data is null) then begin
    id_person_data = gen_id(gen_person_data_id, 1);

    insert into PERSON_DATA(ID_PERSON_DATA)
    values (:id_person_data)
    returning RDB$DB_KEY into :pd_dbkey;
    -- !!! Search sensitive fields must be filled after the profile link creation (below) !!!
  end

  insert into PROFILE_PERSON (ID_PROFILE, ID_PERSON_DATA, CARD_CODE)
  values (:new_id_profile, :id_person_data, :card_code);

  if (:PD_DBKEY is not null) then begin
    if (:ID_HOTEL is not null) then begin
      execute procedure SETTING_GET_VALUE ('DEF_GUEST_MASK', :ID_HOTEL)
      returning_values  :mask;
    end

    execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :profile_name, :profile_name, :country_code,
            null, null, :TITLE);

    execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, null, :EGN, :ID_PASSPORT_TYPE, :PASS_NUM, null, null,
            null, null, null, null, :mask);
  end

  action_text = f_character(29) || :profile_name;
  execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_PERS_PROFILE', :action_text);
end
^

/* Alter (PROFILE_PERSON_MODIFY$PROFILE) */
ALTER PROCEDURE PROFILE_PERSON_MODIFY$PROFILE(ID_PROFILE INTEGER,
ID_GUEST_TYPE INTEGER,
PROFILE_NAME VARCHAR(100),
PERSON_NAME2 VARCHAR(100),
SEX CHAR,
BIRTH_DAY DATE,
BIRTH_PLACE VARCHAR(30),
EGN VARCHAR(30),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
COUNTRY_CODE VARCHAR(20),
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
MASK VARCHAR(10),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
IS_ARCHIVE INTEGER,
ID_PHOTO INTEGER,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
TITLE VARCHAR(10) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable p_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable old_birth_day date;
  declare variable id_picture integer;
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    new_id_profile = :id_profile;

    if (:operation = 'add') then begin
      execute procedure PROFILE_PERSON_CREATEQ$PROFILE(:profile_name, :phone,
              :id_passport_type, :pass_num, :egn, :country_code, :card_code, null, :TITLE, null)
      returning_values  :new_id_profile, :p_dbkey, :pd_dbkey;

      if (:MASK is null) then begin
        -- keep the default mask if input mask is <null> - undefined
        -- empty mask is '' - passed by GUI, but <null> is passed from booking import, etc.
        select PD.MASK
        from   PERSON_DATA PD
        where  PD.RDB$DB_KEY = :pd_dbkey
        into   :mask;
      end
    end

    select P.RDB$DB_KEY, PD.RDB$DB_KEY, pd.BIRTH_DAY
    from   PROFILE P
           join PROFILE_PERSON PP on PP.ID_PROFILE = P.ID_PROFILE
           join PERSON_DATA PD on PD.ID_PERSON_DATA = PP.ID_PERSON_DATA
    where  P.ID_PROFILE = :new_id_profile
    into   :p_dbkey, :pd_dbkey, :old_birth_day;

    execute procedure PROFILE_COMMON_MODIFY$INT(:new_id_profile, 'PERSON', :profile_name,
            :phone, :fax, :email, :contact_city, :contact_address,
            :note, :msg, :is_archive, :id_def_contragent, :id_nom_market_segment,
            :wbe_password, :account_no, :is_exclusive_debt_ownership)
    returning_values (:new_id_profile);

    execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :profile_name, :person_name2, :country_code,
            :old_birth_day, :birth_day, :TITLE);

    execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, :birth_place, :egn, :id_passport_type, :pass_num, :pass_date, :pass_place,
            :pass_exp_date, :pass_city, :pass_address, :sex, :mask);

    update PROFILE_PERSON PP
    set    PP.ID_GUEST_TYPE = :id_guest_type,
           PP.ID_PHOTO = :id_photo,
           PP.CARD_CODE = :card_code
    where  PP.ID_PROFILE = :new_id_profile;

  end else if (:operation = 'del') then begin
    id_picture = null;

    select PP.ID_PHOTO
    from   PROFILE_PERSON PP
    where  PP.ID_PROFILE = :id_profile
    into   :id_picture;

    execute procedure PICTURE_MODIFY (:id_picture, null, null, null, 'del')
    returning_values :id_picture;

    execute procedure PROFILE_DELETE$INT(:id_profile);
    new_id_profile = null;
  end
end
^

/* empty dependent procedure body */
/* Clear: HK_ROOM_STATUS$INT for: REP_ROOM_STATUS$INT */
ALTER PROCEDURE HK_ROOM_STATUS$INT(FOR_DATE DATE,
PRIVATE_STATUS_ADDING SMALLINT = 0)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
SECTOR INTEGER,
ID_ROOM_TYPE INTEGER,
TYPE_ROOM VARCHAR(20),
IS_CLEAN INTEGER,
IS_INSPECTED INTEGER,
CLEAN_TEXT VARCHAR(30),
CLEAN_STATUS VARCHAR(30),
BUSY_DAY SMALLINT,
GUESTS_CNT INTEGER,
LEAVING_GUESTS_CNT INTEGER,
IS_LEAVING SMALLINT,
IS_COMMING SMALLINT,
IS_SHARED SMALLINT,
IS_LEAVING_WORDS VARCHAR(30),
BUSY_GRP INTEGER,
DAYS_THIS_STATUS INTEGER,
DTS_CONTEXT VARCHAR(10),
COMMING_OCCUPANTS VARCHAR(1024),
ID_BLOCK_ROOM INTEGER,
OTHER_OCCUPANTS VARCHAR(1024),
SPECIAL_TREATMENT VARCHAR(1024),
ID_HOTEL INTEGER,
IS_BUSY SMALLINT,
IS_OWNER SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: MONITOR_ROOM_STATUS$HM for: REP_ROOM_STATUS$INT */
ALTER PROCEDURE MONITOR_ROOM_STATUS$HM(FOR_DATE DATE)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
SECTOR INTEGER,
ID_ROOM_TYPE INTEGER,
TYPE_ROOM VARCHAR(20),
IS_CLEAN INTEGER,
IS_INSPECTED INTEGER,
CLEAN_TEXT VARCHAR(30),
IS_LEAVING SMALLINT,
IS_COMMING SMALLINT,
IS_SHARED SMALLINT,
IS_LEAVING_WORDS VARCHAR(30),
BUSY_GRP INTEGER,
DAYS_THIS_STATUS INTEGER,
DTS_CONTEXT VARCHAR(10),
COMMING_OCCUPANTS VARCHAR(1024),
ID_BLOCK_ROOM INTEGER,
OTHER_OCCUPANTS VARCHAR(1024),
ID_HOTEL INTEGER,
HAS_OPENED_POSTINGS SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: REP_ROOM_STATUS_HOTEL$RPT for: REP_ROOM_STATUS$INT */
ALTER PROCEDURE REP_ROOM_STATUS_HOTEL$RPT(ID_HOTEL INTEGER,
FOR_DATE DATE)
 RETURNS(ROOM_STATUS VARCHAR(255),
IS_COMMING INTEGER,
ROOM_FLOOR VARCHAR(20),
ROOM_NAME VARCHAR(255),
ROOM_DATA VARCHAR(255),
IS_BUSY SMALLINT,
IS_CLEAN SMALLINT,
IS_LEAVING SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (REP_ROOM_STATUS$INT) */
ALTER PROCEDURE REP_ROOM_STATUS$INT(FOR_DATE DATE,
STAT_OPTIONS VARCHAR(255),
PRIVATE_STATUS_ADDING SMALLINT = 0)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
SECTOR INTEGER,
ID_ROOM_TYPE INTEGER,
TYPE_ROOM VARCHAR(20),
IS_CLEAN INTEGER,
IS_INSPECTED INTEGER,
CLEAN_TEXT VARCHAR(30),
IS_LEAVING SMALLINT,
IS_COMMING SMALLINT,
IS_SHARED SMALLINT,
IS_LEAVING_WORDS VARCHAR(30),
BUSY_GRP INTEGER,
DAYS_THIS_STATUS INTEGER,
DTS_CONTEXT VARCHAR(10),
COMMING_OCCUPANTS VARCHAR(1024),
ID_BLOCK_ROOM INTEGER,
OTHER_OCCUPANTS VARCHAR(1024),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ID_HOTEL INTEGER,
HAS_OPENED_POSTINGS SMALLINT)
 AS
declare variable dbg varchar(6000);
  declare variable id_room_tmp integer;
  declare variable id_room_magic integer;
  declare variable occupant_id integer;
begin
  for
    select RM.ID_ROOM_MAGIC, RM.ID_ROOM
    from   ROOMS R
           join TMP_SMART_ROOMS TSR on TSR.ID_ROOM = R.ID_ROOM
                and TSR.ID_SESSION = current_connection
           join ROOM_MAGIC RM on RM.ID_ROOM = R.ID_ROOM
    where  RM.BUSY_DATE = :for_date
    into   :id_room_magic, :id_room_tmp
  do begin
    insert into TMP_HM_ROOM_STATUS (ID_ROOMS_MAGIC, ID_SESSION, ID_ROOM)
    values (:id_room_magic, current_transaction, :id_room_tmp);
  end

  for
    select R.ID_ROOM, R.ROOM_NAME, R.FLOOR, R.ID_ROOM_TYPE,
           R.IS_CLEAN, R.CLEAN_TEXT, R.IS_INSPECTED,
           RT.TYPE_ROOM, RT.ID_HOTEL, R.SECTOR
    from   (select distinct P.ID_ROOM
            from   TMP_SMART_ROOMS TSR
                   join ROOM_PERIOD$PMS P on P.ID_ROOM = TSR.ID_ROOM
            where  TSR.ID_SESSION = current_connection
                   and ((P.IS_AVAILABLE = 1) or (:private_status_adding = 1))
                   and P.FROM_DATE <= :for_date
                   and P.TO_DATE >= :for_date) AVR
           join ROOMS R on AVR.ID_ROOM = R.ID_ROOM
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    into   :id_room, :room_name, :floor, :id_room_type,
           :is_clean, :clean_text, :is_inspected,
           :type_room, :id_hotel, :sector
  do begin

    execute procedure REP_ROOM_STATUS_BUILD$INT(:id_room, :for_date, :stat_options)
    returning_values  :is_leaving, :is_comming, :is_shared, :is_leaving_words, :busy_grp,
                      :days_this_status, :dts_context, :comming_occupants, :id_block_room,
                      :other_occupants, :adult_count, :children_count;

    is_comming = iif(:comming_occupants = '', 0, 1);

    HAS_OPENED_POSTINGS = 0;
    for
      select distinct sp.ITEM
      from   SYSTEM_STRING_PARSER (:other_occupants || ',' || :COMMING_OCCUPANTS, ',') SP
      into   :occupant_id
    do begin
      execute procedure RES_GET_BALLANCE$INT (:occupant_id)
      returning_values :dbg, :dbg, :dbg, :HAS_OPENED_POSTINGS, :dbg;
      if (:HAS_OPENED_POSTINGS = 1) then break;
    end

    suspend;

  end

  delete from TMP_HM_ROOM_STATUS HM
  where  HM.ID_SESSION = current_transaction;
end
^

/* Alter (REP_ROOM_STATUS_HOTEL$RPT) */
ALTER PROCEDURE REP_ROOM_STATUS_HOTEL$RPT(ID_HOTEL INTEGER,
FOR_DATE DATE)
 RETURNS(ROOM_STATUS VARCHAR(255),
IS_COMMING INTEGER,
ROOM_FLOOR VARCHAR(20),
ROOM_NAME VARCHAR(255),
ROOM_DATA VARCHAR(255),
IS_BUSY SMALLINT,
IS_CLEAN SMALLINT,
IS_LEAVING SMALLINT)
 AS
--declare variable IS_CLEAN integer;
  declare variable busy_grp integer;
  declare variable days_this_status integer;
  declare variable adult_count integer;
  declare variable children_count integer;
--  declare variable is_leaving integer;
begin
  insert into TMP_SMART_ROOMS (ID_SESSION, ID_ROOM)
  select current_connection, R.ID_ROOM
  from   ROOMS R
         join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
  where  RT.ID_HOTEL = :id_hotel;

  for
    select ROOM_NAME, FLOOR, IS_CLEAN, IS_COMMING, BUSY_GRP,
           DAYS_THIS_STATUS, ADULT_COUNT, CHILDREN_COUNT, IS_LEAVING
    from   REP_ROOM_STATUS$INT(:for_date, 'DAYS_THIS_STATUS, HOUSEKEEPING')
    into   :room_name, :room_floor, :is_clean, :is_comming, :busy_grp,
           :days_this_status, :adult_count, :children_count, :is_leaving
  do begin
    is_busy = 1;
    if (:busy_grp = 0) then begin
      room_status = 'rep.occup.3free' || iif (:is_clean = 1, '.clean', '.dirty');
      room_data = '/'||coalesce(:days_this_status, '~');
      is_busy = 0;
    end else if (:busy_grp in (18, 20) and (not :is_leaving = 1)) then begin
      room_status = 'rep.occup.4block';
      room_data = '/'||coalesce(:days_this_status, '~');
    end else if (:is_leaving = 1) then begin
      room_status = 'rep.occup.2leaving' || iif (:is_clean = 1, '.clean', '.dirty');
      room_data = '/'||coalesce(:days_this_status, '~');
    end else begin
      room_status = 'rep.occup.1stayover';
      room_data = ' '||:adult_count||'+'||:children_count||'/'||coalesce(:days_this_status, '~');
    end

    suspend;
  end

  delete from TMP_SMART_ROOMS
  where  ID_SESSION = current_connection;
end
^

/* Alter (RES_ACCOUNT_CREATE$INT) */
ALTER PROCEDURE RES_ACCOUNT_CREATE$INT(ID_PROFILE INTEGER,
ID_ACC_TEMPLATE INTEGER,
ACC_CURRENCY CHAR(3),
ID_RESERV_DETAIL INTEGER,
IS_BASE_ENABLE SMALLINT = 1,
IS_EXTRA_ENABLE SMALLINT = 1)
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable acc_name varchar(50);
  declare variable id_hotel integer;
  declare variable is_credit_account integer;
  declare variable credit_limit numeric (15,4);
  declare variable sec_level integer;
  declare variable is_pos_allowed integer;
  declare variable id_tax_policy integer;
  declare variable id_sale_num integer;
  declare variable check_status smallint;
begin
  select 'res. ' || substring(RD.NUMBER from 1 for 45), RD.ID_HOTEL, rd.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :acc_name, :id_hotel, :check_status;

  if (:id_acc_template is null) then begin
    select sv.SETTING_VALUE
    from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :id_hotel) sv
    into   :id_acc_template;
  end

  is_credit_account = null;
  select ACT.IS_CREDIT_ACCOUNT, ACT.CREDIT_LIMIT, ACT.SECURITY_LEVEL,
         ACT.IS_ALOWED_POS_INTERFACE, ACT.ID_TAX_POLICY
  from   ACC_TEMPLATE ACT
  where  ACT.ID_ACC_TEMPLATE = :id_acc_template
         and act.ID_HOTEL = :id_hotel
  into   :is_credit_account, :credit_limit, :sec_level,
         :is_pos_allowed, :id_tax_policy;

  if (:is_credit_account is null) then exception ACCOUNT_EXCEPTION '-50';

  execute procedure ACCOUNT_MODIFY$INT (null, :ID_PROFILE, :ACC_CURRENCY, :acc_name, :is_credit_account, :credit_limit,
          null, null, 0, '', :sec_level, :IS_BASE_ENABLE, :IS_EXTRA_ENABLE, :is_pos_allowed, null,
          null, :id_tax_policy, null, :id_hotel, :ID_RESERV_DETAIL, 0, 'add')
  returning_values (:NEW_ID_ACCOUNT);

  if (:check_status = 0) then begin
    execute procedure ACCOUNT_SALE_NUMBER_SET(:NEW_ID_ACCOUNT)
    returning_values (:id_sale_num);
  end
end
^

/* Alter (RES_CHECK_OUT_CHECK$RSV) */
ALTER PROCEDURE RES_CHECK_OUT_CHECK$RSV(SELECTION_ID INTEGER)
 RETURNS(IS_EARLY_CHECK_OUT SMALLINT,
EARLY_CHECK_OUT_DEP_DATE DATE,
CHECK_OUT_DATE DATE)
 AS
declare variable max_to_date date;
  declare variable cnt_early_dates integer;
  declare variable min_check_status integer;
  declare variable max_check_status integer;
  declare variable id_hotel integer;
  declare variable hotels_cnt integer;
  declare variable booking_number varchar(62);
  declare variable safe_name varchar(50);
begin
  is_early_check_out = 0;
  early_check_out_dep_date = null;
  select min(RD.ID_HOTEL), count(distinct RD.ID_HOTEL)
  from   RESERV_DETAIL RD
  where  RD.SELECTION_ID = :SELECTION_ID
  into   :id_hotel, :hotels_cnt;

  if (:hotels_cnt > 1) then exception RESERV_CHECK_OUT_EXCEPTION '-1020';

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values  :check_out_date;

  for
    select max(G.TO_DATE),
           count(distinct case when RD.CHECK_STATUS = 0 and RD.TO_DATE > :check_out_date then RD.TO_DATE else null end),
           min(RD.CHECK_STATUS), max(RD.CHECK_STATUS)
    from   RESERV_DETAIL RD
           left outer join GUEST G on G.ID_RESERV_DETAIL = RD.ID_RESERV_DETAIL
                                      and G.CHECK_STATUS >= 0 /* checked in guests */
    where  RD.SELECTION_ID = :selection_id
    into   :max_to_date, :cnt_early_dates, :min_check_status, :max_check_status
  do begin
    if (:max_check_status > 0) then
        exception RESERV_CHECK_OUT_EXCEPTION '-1013'; --'Reservation is already checked out.';

    if ((:min_check_status is null) or (:min_check_status < 0)) then
        exception RESERV_CHECK_OUT_EXCEPTION '-1006'; --'Can not check out not checked in reservation.';

    if (:max_to_date > :CHECK_OUT_DATE) then begin
      if (:cnt_early_dates > 1) then begin
        exception RESERV_CHECK_OUT_EXCEPTION '-1014'; --'In selection has different departure dates for early check out.';

      end else if (:max_to_date > :CHECK_OUT_DATE) then begin
        execute procedure RIGHTS_CHECK_GRANTED$INT('CHECK_OUT_EARLY');
      
        is_early_check_out = 1;
        early_check_out_dep_date = :max_to_date;
      end
    end
  end 

  for
    select rd.NUMBER, s.SAFE_NAME
    from   RESERV_DETAIL RD
           join RESOURCE_RESERVATION rr on rr.BOOKING_NUMBER = rd.NUMBER
           join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
           join SAFES s on s.ID_CURRENT_OCCUPANCY = rr.ID_RESOURCE_RESERVATION
    where  rd.SELECTION_ID = :SELECTION_ID
           and s.IS_OCCUPIED = 1
    into   :booking_number, :safe_name
  do begin
    execute procedure ERROR_LOG_ADD (-1060, f_character(29) || :booking_number || f_character(28) || :safe_name);
  end 
end
^

/* Alter (RES_CHECKIN$RSV) */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable old_check_status integer;
  declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_anul integer;
  declare variable arrival_date date;
  declare variable system_date date;
  declare variable id_base_account integer;
  declare variable id_extra_account integer;
  declare variable id_sale_num integer;
begin
  /*  Description:
  ||
  */
  select RD.CHECK_STATUS, RD.RDB$DB_KEY, RD.FROM_DATE, RD.ID_HOTEL,
         RD.ID_ROOM, RD.IS_ANUL, rd.ID_BASE_ACCOUNT, rd.ID_EXTRA_ACCOUNT
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_check_status, :rd_dbkey, :arrival_date, :id_hotel,
         :old_id_room, :is_anul, :id_base_account, :id_extra_account;

  if (:is_anul = 1) then exception BOOKING_EXCEPTION '-2';

  if (:old_check_status >= 0) then exception BOOKING_EXCEPTION '-1003';

  if (:old_id_room < 0 and coalesce(:ID_ROOM, 0) <= 0) then exception BOOKING_EXCEPTION '-1018';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date < :arrival_date) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CHECK_IN_FUTURE');
  end
  /*----*/
  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'lock');

  execute procedure sys_dbg('occ RES_CHECKIN$RSV id_room = '||coalesce(:id_room, 'null'));
  execute procedure sys_dbg('occ RES_CHECKIN$RSV old_id_room = '||coalesce(:old_id_room, 'null'));

  if (:id_room is not null) then begin
    if (:old_check_status = -3) then begin
      execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, -2);
    end

    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option)
    returning_values (:WARN_CODE);
  end

  execute procedure ACCOUNT_SALE_NUMBER_SET(:id_base_account)
  returning_values (:id_sale_num);
  execute procedure ACCOUNT_SALE_NUMBER_SET(:id_extra_account)
  returning_values (:id_sale_num);

  execute procedure RES_SET_CHECKIN$INT (:rd_dbkey)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'release');
  /*----*/
  select f_character(29) || R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = coalesce(:ID_ROOM, :old_id_room)
  into   :action_text;
   
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'CHECK_IN', :action_text);

end
^

/* Alter (RES_CREATE_ROOM$INT) */
ALTER PROCEDURE RES_CREATE_ROOM$INT(CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_COUNT INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_AGENT_PROFILE INTEGER,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_PERSON_PROFILE INTEGER,
ACC_ROUTING VARCHAR(50),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ID_GROUP INTEGER = null,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_GUARANTEE_POLICY INTEGER = null,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
RD_DBKEY CHAR(8),
NEW_ID_PERSON_PROFILE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable day_keep_types integer;
  declare variable exp_date date;
  declare variable leaving_kind integer;
  declare variable cnt_processed integer;
begin
  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :ID_HOTEL)
  returning_values  :day_keep_types;
  exp_date = :arrival_date + :day_keep_types;
  leaving_kind = coalesce(:is_late_departure, 0) + 1;
  comming_kind = coalesce(:comming_kind, 1);

  cnt_processed = 0;
  while (:room_count > :cnt_processed) do begin
    if (:res_number is null) then begin
      execute procedure SYSTEM_GEN_NUM('BOOKING', 0)
      returning_values  :dbg, :res_number;
    end
    
    if (:id_person_profile is null) then begin
      execute procedure PROFILE_PERSON_CREATEQ$PROFILE(:res_number, '', null, null, null,
              :country_code, null, null, null, :ID_HOTEL)
      returning_values  :new_id_person_profile, :dbg, :dbg;
      execute procedure sys_dbg('res RES_CREATE_ROOM$INT autocreate id_person_profile = '||coalesce(:id_person_profile, 'null'));
    end else begin
      new_id_person_profile = :id_person_profile;
    end

    execute procedure RES_CREATE_DETAIL$INT(:id_reserv_detail, :id_agent_profile, :res_number, :check_status,
                      :arrival_date, :departure_date, :code_first_food, :exp_date, :comming_kind, :leaving_kind,
                      :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                      0, 0, :note, :i_special_treatment, :id_board, -1, :id_rate,
                      :id_room_type, :country_code, '30.12.1899', null, null, '30.12.1899', null, null, null,
                      :room_features, :id_hk_plan, :new_id_person_profile, :id_hotel, :acc_routing, :id_acc_template_person,
                      :id_group, :id_agent_account, :id_guarantee_policy, :ID_EATING_OBJECT)
    returning_values  :new_id_reserv_detail, :rd_dbkey;
    res_number = null;

    execute procedure RES_GUESTCOUNT_ADD$INT(:rd_dbkey, :adult_count, :child_count, 1);

    cnt_processed = :cnt_processed + 1;
    suspend;
  end
end
^

/* Alter (RES_CREATE_SET$EXC) */
ALTER PROCEDURE RES_CREATE_SET$EXC(ID_RESERV_DETAIL INTEGER,
RES_NUMBER VARCHAR(62),
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER,
CREATE_DATETIME TIMESTAMP)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_RESERV_DETAIL INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  WARN_CODE = 0;
  SHARE_TRANSACTION_ID = 0;
  SHARE_ERR_CODE = 0;

  execute procedure sys_dbg('exc RES_CREATE_SET$EXC => RES_CREATE_SET$INT('
  || 'code_first_food=>' || coalesce(:code_first_food, '<null>')
  || ', id_person_payment=>' || coalesce(:id_person_payment, '<null>')
  || ')');

  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, null, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, '', :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders, :guarantee_deposit,
                    :guarantee_currency, 0, :id_reserv_detail, :res_number, null,  :id_guarantee_policy, :block_cc,
                    :id_eating_object)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :warn_code;

  execute procedure UPDATE_POSTING_TRANSACTION$EXC(:rd_dbkey, :posting_transaction_uuid, 1);

  execute procedure RES_SAVE_GUARANTEE$RSV(:id_reserv_detail, :is_vip, null,
    :id_guarantee_policy, :guarantee_deposit, :guarantee_currency, :block_cc, :guarantee_deposit_percent,
    :guarantee_deposit_nights, :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create
  );

  execute procedure RESERV_DETAIL_EXTERNAL_MOD$RSV(:id_reserv_detail,
    :minibar_rights, :paytv_rights, :video_rights, :nopost_pms, :phone_rights,
    :seminar_cahnnel_rights, null
  );

  if (:create_datetime is not null) then begin
    update reserv_detail set create_datetime = :create_datetime where rdb$db_key = :rd_dbkey;
  end
end
^

/* Alter (RES_EARLY_DEPARTURE_SET$RSV) */
ALTER PROCEDURE RES_EARLY_DEPARTURE_SET$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND INTEGER)
 RETURNS(RECALC_MARKER_LIST VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable sys_date date;
  declare variable stay integer;
  declare variable rd_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable id_hotel integer;
  declare variable hotels_cnt integer;
  declare variable arrival_date date;
  declare variable is_late_departure smallint;
  declare variable comming_kind smallint;
  declare variable dep_date date;
begin
  /* CHECK_OUT_kind =
  || 1 - DO NOT MODIFY GUEST
  || 2 - SHRINK PERIOD AND OCCUPANCY
  || 3 - DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
  */
  execute procedure RIGHTS_CHECK_GRANTED$INT('CHECK_OUT_EARLY');

  select min(RD.ID_HOTEL), count(distinct RD.ID_HOTEL)
  from   RESERV_DETAIL RD
  where  RD.SELECTION_ID = :SELECTION_ID
  into   :id_hotel, :hotels_cnt;

  if (:hotels_cnt > 1) then exception RESERV_CHECK_OUT_EXCEPTION '-1020';

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values  :sys_date;

  RECALC_MARKER_LIST = null;
  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL, rd.FROM_DATE, rd.TO_DATE, RD.LEAVING_KIND - 1, rd.COMMING_KIND
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :rd_dbkey, :id_reserv_detail, :arrival_date, :dep_date, :is_late_departure, :comming_kind
  do begin
    if ((:check_out_kind = 2) and (:dep_date > :sys_date)) then begin
      -- SHRINK PERIOD AND OCCUPANCY
      execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :sys_date, :is_late_departure, :comming_kind);
    
      execute procedure RES_FINALIZE$INT(:rd_dbkey)
      returning_values  :warn_code;
    end else if ((:check_out_kind = 1) and (:dep_date > :sys_date)) then begin
      /* KEEP BOOKING STAY PERIOD AND ROOM OCCUPANCY */
      for
        select G.TO_DATE - :sys_date
        from   GUEST G
        where  G.ID_RESERV_DETAIL = :id_reserv_detail
        into   :stay
      do begin
  --      if (:check_out_kind = 1) then begin
        if (:stay > 1) then begin
            --THE DEPARTURE DATE IS LATER THAN NEXT DATE. STAY SHOULD BE CHANGED MANUALY.;
            exception RESERV_CHECK_OUT_EXCEPTION '-323';
        end
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE_SHAREOPTION$INT for: RES_FINALIZE_OCCUPANCY$INT */
ALTER PROCEDURE RES_FINALIZE_SHAREOPTION$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_FINALIZE_OCCUPANCY$INT) */
ALTER PROCEDURE RES_FINALIZE_OCCUPANCY$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ERROR_CONTEXT VARCHAR(200),
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable busy_group_source integer;
declare variable tmp_warn_code integer;
declare variable id_room_type integer;
declare variable id_agent integer;
declare variable check_status integer;
declare variable from_date date;
declare variable to_date date;
begin
  err_code = 0;
  warn_code = null;
  tmp_warn_code = null;

  select iif(RD.CHECK_STATUS = 1, 24, 1), coalesce(R.ID_ROOM_TYPE, RD.ID_ROOM_TYPE), P.ID_AGENT,
         rd.CHECK_STATUS, rd.FROM_DATE, rd.TO_DATE
  from   RESERV_DETAIL RD
         left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
         left outer join PROFILE_AGENT P on P.ID_PROFILE = RD.ID_AGENT_PROFILE
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :busy_group_source, :id_room_type, :id_agent, :check_status, :from_date, :to_date;

  error_context = 'OCCUPANCY';
  execute procedure OCCUPANCY_RESERV$INT(:rd_dbkey);

  if (:id_agent is not null) then begin
    execute procedure OCCUPANCY_ACTIVE_FRAME_CHK$INT(:id_agent, :from_date, :to_date - 1, :id_room_type)
    returning_values  :err_code, :err_text;
    if (:err_code < 0) then exit;
  end

  if (:check_status > -3) then begin
    execute procedure OCCUPANCY_OVERBOOK_CHECK$INT (:id_agent, :from_date, :to_date - 1, :id_room_type)
    returning_values  :err_code, :err_text, :warn_code;
    if (:err_code < 0) then exit;
  end
  ---------------------------------
  error_context = 'ROOM_VALIDATION';
  execute procedure OCCUPANCY_ROOMS_CHECK$INT(:rd_dbkey, :busy_group_source)
  returning_values  :share_err_code, :share_err_text, :share_transaction_id, :tmp_warn_code;

  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

  /* empty shares helper table*/
  delete from RESERV_STAY$TMP t
  where  t.id_session = RDB$GET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION');

end
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE$INT for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_FINALIZE$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SAVE_ROOM$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
ID_RES_ROOM_TYPE INTEGER,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(255),
SPLIT_ON_CHECKIN SMALLINT,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_CHECKIN$INT for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SET_CHECKIN$INT(RD_DBKEY CHAR(8))
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM$INT for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SET_ROOM$INT(RD_DBKEY CHAR(8),
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_FINALIZE$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RESMULTI_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER,
DISABLE_WARNING SMALLINT)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_FINALIZE_SHAREOPTION$INT) */
ALTER PROCEDURE RES_FINALIZE_SHAREOPTION$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable error_context varchar(200);
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable room_price numeric(15,4);
  declare variable is_anul smallint;
begin
  WARN_CODE = null;

  select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, rd.ROOM_PRICE, rd.IS_ANUL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail, :check_status, :room_price, :is_anul;

  execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));
  execute procedure RES_FINALIZE_OCCUPANCY$INT(:rd_dbkey)
  returning_values  :err_code, :err_text, :error_context, :share_transaction_id, :share_err_code, :share_err_text, :warn_code;

  --execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT share_err_code = '||coalesce(:share_err_code, 'null'));
  --execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT share_err_text = '||coalesce(:share_err_text, 'null'));
  --execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT err_code = '||coalesce(:err_code, 'null'));

  execute procedure RES_FINALIZE_ERRHANDLING$INT(:id_reserv_detail, :err_code, :err_text, :error_context, :SUPPRESS_NON_INSTANT_ERRORS);

  if (((:check_status >= 0) or (:room_price is null) or (:is_anul = 1) ) /*and (:is_anul = 0)*/) then begin
    execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    returning_values  :err_code, :err_text;

    execute procedure RES_FINALIZE_ERRHANDLING$INT(:id_reserv_detail, :err_code, :err_text, 'RECALC', :SUPPRESS_NON_INSTANT_ERRORS);
  end

  execute procedure RES_FINALIZE_CLEAR$INT(:rd_dbkey, :id_reserv_detail);

  warn_code = coalesce(:WARN_CODE, RDB$GET_CONTEXT('USER_TRANSACTION', 'WARN_CODE'));
  RDB$SET_CONTEXT('USER_TRANSACTION', 'WARN_CODE', null);

end
^

/* empty dependent procedure body */
/* Clear: RES_GET_DEPOSIT$WBE for: RES_GET_DEPOSIT$INT */
ALTER PROCEDURE RES_GET_DEPOSIT$WBE(ID_RESERV_DETAIL INTEGER)
 RETURNS(DEPOSIT_VALUE NUMERIC(15,4),
DEPOSIT_CURRENCY CHAR(3))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GET_DEPOSIT$INT) */
ALTER PROCEDURE RES_GET_DEPOSIT$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(DEPOSIT_VALUE NUMERIC(15,4),
DEPOSIT_CURRENCY CHAR(3))
 AS
declare variable rd_dbkey char(8);
declare variable dummy varchar(255);
begin
  select RD.RDB$DB_KEY, RD.GUARANTEE_DEPOSIT, rd.GUARANTEE_CURRENCY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :deposit_value, :deposit_currency;

  if (:DEPOSIT_VALUE is not null) then begin
    EXIT;
  end else begin
    execute procedure RES_GET_PRICE$INT(:rd_dbkey, 'SECURITY, FORCED')
    returning_values  :dummy, :dummy, :dummy, :deposit_value, :deposit_currency;
  end

end
^

/* Alter (RES_GET_DEPOSIT$WBE) */
ALTER PROCEDURE RES_GET_DEPOSIT$WBE(ID_RESERV_DETAIL INTEGER)
 RETURNS(DEPOSIT_VALUE NUMERIC(15,4),
DEPOSIT_CURRENCY CHAR(3))
 AS
begin
  execute procedure RES_GET_DEPOSIT$INT (:ID_RESERV_DETAIL)
  returning_values (:DEPOSIT_VALUE, :DEPOSIT_CURRENCY);
end
^

/* Alter (RES_GET_PERSON_PROFILE$INT) */
ALTER PROCEDURE RES_GET_PERSON_PROFILE$INT(ID_GUEST INTEGER)
 RETURNS(ID_PERSON_PROFILE INTEGER,
ID_PERSON_DATA INTEGER)
 AS
declare variable p_dbkey char(8);
  declare variable profile_name varchar(100);
  declare variable pd_dbkey char(8);
  declare variable id_hotel integer;
  declare variable title varchar(10);
begin
  select PD.ID_PERSON_DATA, PD.PERSON_NAME, PP.ID_PROFILE, rd.ID_HOTEL, pd.TITLE
  from   GUEST G
         join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
         join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
         left outer join PROFILE_PERSON PP on PP.ID_PERSON_DATA = GD.ID_PERSON_DATA
  where  G.ID_GUEST = :id_guest
  into   :id_person_data, :profile_name, :id_person_profile, :id_hotel, :title;

  if (:id_person_profile is null) then begin
    execute procedure PROFILE_PERSON_CREATEQ$PROFILE(:profile_name, '', null, null, null, null, null, :id_person_data, :title, :id_hotel)
    returning_values  :id_person_profile, :p_dbkey, :pd_dbkey;
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_GET_GUESTS$INT for: RES_GET_SHARE_STATUS$INT */
ALTER PROCEDURE TAR_CALC_GET_GUESTS$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_GUEST INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
G_DBKEY CHAR(8),
ID_GUEST_RESERV /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GET_SHARE_STATUS$INT) */
ALTER PROCEDURE RES_GET_SHARE_STATUS$INT(ID_RESERV_DETAIL INTEGER,
OPTION_ VARCHAR(100),
FOR_DATE DATE)
 RETURNS(SHARE_STATUS INTEGER,
SHARED_RESERVATIONS VARCHAR(1024),
SHARE_RENDER VARCHAR(1024))
 AS
declare variable mark_transaction integer;
  declare variable shared_reservation_id integer;
  declare variable occupant_info varchar(2000);
  declare variable is_ex_share integer;
  declare variable check_status integer;
  declare variable split_on_checkin integer;
  declare variable res_from_date date;
  declare variable res_to_date date;
  declare variable related_reservations VARCHAR(1024);
  declare variable busy_group_type integer;
begin
  /*  OPTIONs:
    !!!! DONT mix options !!!.
    ENUM_SHARES - return id's of shared reservations (SHARED_RESERVATIONS) in this save session - usable for calculation and regenerations, but not for renders.
    ENUM_EX_SHARES - return id's of shared reservations just leaved share. As above..
    RENDER - render all reservations in share with current. Usabe for gui previews.
  */
  execute procedure SYSTEM_CHECK_OPERATION (:OPTION_, 'ENUM_SHARES,ENUM_EX_SHARES,RENDER,FOR_RECALC', 'option');

  execute procedure sys_dbg('calc RES_GET_SHARE_STATUS$INT options = '||coalesce(:OPTION_, 'null'));

  shared_reservations = '';
  share_render = '';

  select RD.CHECK_STATUS, RD.SPLIT_ON_CHECKIN, RD.FROM_DATE, RD.TO_DATE
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :check_status, :split_on_checkin, :res_from_date, :res_to_date;

  mark_transaction = RDB$GET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION');

  if (:mark_transaction is null) then begin
    -- THE CALLER IS outside saving/regeneration transaction - NOT FINALIZING BOOKING CHANGES
    select min(RS.IS_EX_SHARE)
    from   ROOMS_SHARE RS
    where  RS.ID_RESERV_DETAIL = :id_reserv_detail
           and ((:for_date is null) or (RS.BUSY_DATE = :for_date))
    into   :is_ex_share;
  end else begin
    -- THIS TRANSACTION IS Saving booking and REGENERATING ROOMS_MAGIC
    select min(RS.IS_EX_SHARE)
    from   ROOMS_SHARE RS
    where  RS.MARK_TRANSACTION = :mark_transaction
           and ((:for_date is null) or (RS.BUSY_DATE = :for_date))
    into   :is_ex_share;
  end

  execute procedure sys_dbg('calc RES_GET_SHARE_STATUS$INT mark_transaction = '||coalesce(:mark_transaction, 'null'));

  if (:is_ex_share = 0) then share_status = 1;
  /*else - null or 1*/
  else share_status = 0;

  execute procedure sys_dbg('calc RES_GET_SHARE_STATUS$INT share_status = '||coalesce(:share_status, 'null'));

  /*option will be changed if we want enum shares ouside modification transaction - for recalculation in example*/
  if ((:OPTION_ = 'ENUM_SHARES') and (:share_status = 1) and (:mark_transaction is null)) then begin
    option_ = 'RENDER';
    execute procedure sys_dbg('calc RES_GET_SHARE_STATUS$INT option was ENUM_SHARES but is changd to RENDER, because :mark_transaction is null' );
  end

  if ((:OPTION_ = 'ENUM_SHARES') and (:share_status = 1)) then begin
    for
      select distinct RS.ID_RESERV_DETAIL
      from   ROOMS_SHARE RS
      where  RS.MARK_TRANSACTION = :mark_transaction
             and RS.BUSY_DATE = coalesce(:for_date, RS.BUSY_DATE)
             and RS.IS_EX_SHARE = 0
      into   :shared_reservation_id
    do begin
      if (:shared_reservation_id <> :id_reserv_detail) then begin
        shared_reservations = :shared_reservations || iif(:shared_reservations = '', '', ',');
        shared_reservations = :shared_reservations || :shared_reservation_id;
      end
    end
  end

  if (:OPTION_ = 'RENDER') then begin
    if (:SHARE_STATUS = 0 ) then begin
      if (:check_status < 0 and :split_on_checkin = 1 and :OPTION_ = 'RENDER') then begin
        share_status = 2;
        exit;
      end
    end else begin
      if (:for_date is not null) then begin
        /*make render only for one date, otherwise for erservation period*/
        res_from_date = :for_date;
        res_to_date = :for_date;
      end

      for
        select distinct RS.ID_RESERV_DETAIL, rs.BUSY_GROUP_TYPE
        from   ROOM_MAGIC rm
               join ROOMS_SHARE RS on rm.id_room = rs.id_room
                                      and rm.busy_date = rs.busy_date
        where  rm.id_reserv_detail = :id_reserv_detail
               and RM.BUSY_DATE between :res_from_date and :res_to_date
               and RS.IS_EX_SHARE = 0
        into   :shared_reservation_id, :busy_group_type
      do begin
        if (:shared_reservation_id <> :id_reserv_detail) then begin
          shared_reservations = :shared_reservations || iif(:shared_reservations = '', '', ',');
          shared_reservations = :shared_reservations || :shared_reservation_id;
          select OGI.INFO
          from   OCCUPANT_GET_INFO(:shared_reservation_id, :busy_group_type) OGI
          into   :occupant_info;
          share_render = :share_render || iif(:share_render = '', '', ',');
          share_render = :share_render || :occupant_info;
        end
      end
    end
  end

  if (:OPTION_ = 'ENUM_EX_SHARES') then begin
    for
      select distinct
             RS.ID_RESERV_DETAIL
      from   ROOMS_SHARE RS
      where  RS.MARK_TRANSACTION = :mark_transaction
             and ((:for_date is null) or (RS.BUSY_DATE = :for_date))
             and RS.IS_EX_SHARE > 0
      into   :shared_reservation_id
    do begin
      if (:shared_reservation_id <> :id_reserv_detail) then begin
        shared_reservations = :shared_reservations || iif(:shared_reservations = '', '', ',');
        shared_reservations = :shared_reservations || :shared_reservation_id;
      end
    end
  end

  if (:OPTION_ = 'FOR_RECALC') then begin
    /*for recalculation is needed all reservations that are connected somehow with this and relaetd to this reservations */
    execute procedure RES_GET_SHARE_ALL_RELATIONS$INT (:ID_RESERV_DETAIL)
    returning_values  :related_reservations;
    /*remove current reservation from list (recursion include curent also)*/
    for
      select SP.ITEM
      from   SYSTEM_STRING_PARSER(:related_reservations, ',') SP
      into   :shared_reservation_id
    do begin
      if (:shared_reservation_id <> :id_reserv_detail) then begin
        shared_reservations = :shared_reservations || iif(:shared_reservations = '', '', ',');
        shared_reservations = :shared_reservations || :shared_reservation_id;
      end
    end
  end

  suspend;
end
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_ADD$RSV for: RES_GUEST_ADD$INT */
ALTER PROCEDURE RES_GUEST_ADD$RSV(ID_RESERV_DETAIL INTEGER,
IS_CHILD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_GUEST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUESTCOUNT_ADD$INT for: RES_GUEST_ADD$INT */
ALTER PROCEDURE RES_GUESTCOUNT_ADD$INT(RD_DBKEY CHAR(8),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
INITIALIZE_BOOKING /* TYPE OF TLOGICAL */ SMALLINT = 0)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_GUEST_ADD$INT) */
ALTER PROCEDURE RES_GUEST_ADD$INT(RD_DBKEY CHAR(8),
IS_CHILD INTEGER,
INITIALIZE_BOOKING TYPE OF TLOGICAL = 0)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable pd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable check_status integer;

  declare variable from_date date;
  declare variable to_date date;
  declare variable id_room integer;
  declare variable id_agent integer;
  declare variable id_tarrif integer;
  declare variable guest_name varchar(100);
  declare variable country_code varchar(10);
  declare variable guest_status varchar(50);
  declare variable default_mask varchar(50);
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable id_titular integer;
  declare variable id_profile_data integer;
  declare variable id_person_data integer;
  declare variable id_base_account integer;
  declare variable id_extra_account integer;
  declare variable id_hotel integer;
  declare variable action_text varchar(255);
begin
  select RD.FROM_DATE, RD.TO_DATE, RD.ID_ROOM, PA.ID_AGENT, RD.ID_RATE,
         RD.ID_RESERV_DETAIL, RD.ID_TITULAR, PP.ID_PERSON_DATA,
         RD.CHECK_STATUS, RD.ADULT_COUNT, RD.CHILD_COUNT, RD.COUNTRY,
         rd.ID_BASE_ACCOUNT, rd.ID_EXTRA_ACCOUNT, rd.ID_HOTEL
  from   RESERV_DETAIL RD
         left outer join PROFILE_PERSON PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join PROFILE_AGENT PA on PA.ID_PROFILE = RD.ID_AGENT_PROFILE
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :from_date, :to_date, :id_room, :id_agent, :id_tarrif,
         :id_reserv_detail, :id_titular, :id_profile_data,
         :check_status, :adult_count, :child_count, :country_code,
         :id_base_account, :id_extra_account, :id_hotel;

  if (:check_status < 0) then begin
    guest_status = '';
    check_status = -2;
  end else if (:check_status = 0) then begin
    guest_status = 'CHECKING_IN';
  end else begin  /* checked out */
    exception BOOKING_EXCEPTION '-1032';
  end


  new_id_guest = gen_id (id_guest_gen, 1);
  insert into GUEST (ID_GUEST, ID_BASE_ACCOUNT, ID_ACCOUNT, FROM_DATE, TO_DATE, ID_ROOM, ID_AGENT, ID_TARIFA,
         ID_RESERV_DETAIL, IS_CHILD, CHECK_STATUS, GUEST_EDIT_STATUS, ID_HOTEL)
  values (:new_id_guest,  :id_base_account, :id_extra_account, :from_date, :to_date, :id_room, :id_agent, :id_tarrif,
         :id_reserv_detail, :is_child, -2, :guest_status, :id_hotel)
  returning RDB$DB_KEY into :g_dbkey;

  execute procedure sys_dbg('res RES_GUEST_ADD$INT new_id_guest = '||coalesce(:new_id_guest, 'null'));

  insert into GUEST_CHANGE_STATUS (ID_GUEST, FROM_DATE_ORIG, TO_DATE_ORIG)
  values (:new_id_guest, :from_date, :to_date);

  if (:is_child = 1) then begin
    child_count = :child_count + 1;
    guest_name = '-';
  end else begin
    adult_count = :adult_count + 1;
    guest_name = '-';
  end

  if (:id_titular is null) then begin
    id_titular = :new_id_guest;
    id_person_data = :id_profile_data;
  end else begin
    execute procedure SETTING_GET_VALUE('DEF_GUEST_MASK', :id_hotel)
    returning_values  :default_mask;

    id_person_data = gen_id(GEN_PERSON_DATA_ID, 1);
    insert into PERSON_DATA (ID_PERSON_DATA, MASK)
    values (:id_person_data, :default_mask)
    returning RDB$DB_KEY into :pd_dbkey;

  end

  insert into GUEST_DATA (ID_GUEST, ID_PERSON_DATA)
  values (:new_id_guest, :id_person_data);

  if (:INITIALIZE_BOOKING is distinct from 1) then begin
    action_text = F_CHARACTER(29) || '"' || :guest_name || '" (' || :NEW_ID_GUEST || ')';
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_GUEST_ADD', :action_text);
  end

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name, :guest_name, coalesce(:country_code, ''),
          :is_child, null, null, null);

  execute procedure RES_GUEST_AUTO$INT(:g_dbkey, :rd_dbkey, 1);

  update RESERV_DETAIL RD
  set    RD.ADULT_COUNT = :adult_count,
         RD.CHILD_COUNT = :child_count,
         RD.ID_TITULAR = :id_titular
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SET_EDIT_STATUS$INT (:RD_DBKEY, 'ADDGUEST', 'add');

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, :check_status);

end
^

/* Alter (RES_GUEST_ADD$RSV) */
ALTER PROCEDURE RES_GUEST_ADD$RSV(ID_RESERV_DETAIL INTEGER,
IS_CHILD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_GUEST INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  warn_code = 0;
  err_code = 0;
  err_text = '';

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey;

  execute procedure RES_GUEST_ADD$INT(:rd_dbkey, :IS_CHILD)
  returning_values  :NEW_ID_GUEST;
end
^

/* empty dependent procedure body */
/* Clear: RES_GUESTLIST_REMOVE$RSV for: RES_GUEST_AUTO$INT */
ALTER PROCEDURE RES_GUESTLIST_REMOVE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GUEST_AUTO$INT) */
ALTER PROCEDURE RES_GUEST_AUTO$INT(G_DBKEY CHAR(8),
RD_DBKEY CHAR(8),
IS_NEW_GUEST SMALLINT)
 AS
declare variable id_guest integer;
  declare variable id_reserv_detail integer;
  declare variable for_date date;
  declare variable id_nom_market_segment integer;
  declare variable id_nom_source_code integer;
  declare variable id_nom_channel_code integer;
  declare variable id_nom_hear_reason integer;
  declare variable id_nom_come_reason integer;
  declare variable from_date date;
  declare variable to_date date;
  declare variable id_room integer;
  declare variable res_id_room integer;
  declare variable id_board integer;
  declare variable id_tarrif integer;
  declare variable voucher_num varchar(30);
  declare variable voucher_date date;
  declare variable voucher_text varchar(30);
  declare variable voucher2_num varchar(30);
  declare variable voucher2_date date;
  declare variable transfer_in_time timestamp;
  declare variable transfer_in_note varchar(255);
  declare variable transfer_out_time timestamp;
  declare variable transfer_out_note varchar(255);
  declare variable code_first_food type of tfood_code;
  declare variable id_hotel integer;
  declare variable id_titular integer;
  declare variable sys_date date;
begin

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -2);

  select G.ID_GUEST
  from   GUEST G
  where  G.RDB$DB_KEY = :g_dbkey
  into   :id_guest;

  select RD.FROM_DATE, RD.TO_DATE, RD.ID_ROOM, RD.ID_BOARD,
         RD.ID_RATE, RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE,
         RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON, RD.ID_NOM_COME_REASON,
         RD.VAUCHER_NUM, RD.VAUCHER_DATE, RD.VAUCHER_TEXT,
         RD.VAUCHER_NUM2, RD.VAUCHER_DATE2, RD.ID_RESERV_DETAIL,
         RD.TRANSFER_IN_TIME, RD.TRANSFER_IN_NOTE, RD.TRANSFER_OUT_TIME, RD.TRANSFER_OUT_NOTE, RD.CODE_FIRST_FOOD,
         RD.ID_HOTEL, rd.ID_TITULAR
  from   RESERV_DETAIL RD
         left outer join PROFILE_PERSON PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join PROFILE_AGENT PA on PA.ID_PROFILE = RD.ID_AGENT_PROFILE
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :from_date, :to_date, :res_id_room, :id_board,
         :id_tarrif, :id_nom_market_segment, :id_nom_source_code,
         :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason,
         :voucher_num, :voucher_date, :voucher_text,
         :voucher2_num, :voucher2_date, :id_reserv_detail,
         :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note, :code_first_food,
         :id_hotel, :id_titular;

  execute procedure RES_GUEST_SAVE_STAY$INT(:g_dbkey, :from_date, :to_date, :id_hotel);

  execute procedure RES_GUEST_SAVE_VOUCHER$INT(:rd_dbkey, :g_dbkey, :voucher_num, :voucher_date,
          :voucher_text, :voucher2_num, :voucher2_date);

  execute procedure RES_GUEST_SAVE_OTHER$INT(:g_dbkey, :transfer_in_time, :transfer_in_note,
          :transfer_out_time, :transfer_out_note, :code_first_food);

  execute procedure RES_GUEST_SAVE_MARKETING$INT(:id_guest, :id_nom_market_segment, :id_nom_source_code,
          :id_nom_channel_code,:id_nom_hear_reason, :id_nom_come_reason);

  if (:IS_NEW_GUEST = 0) then begin
    delete from GUEST_STAY GS
    where  GS.ID_GUEST = :id_guest;

    delete from GUEST_PACKET GP
    where  GP.ID_GUEST = :id_guest;
  end
  --execute procedure sys_dbg('res RES_GUEST_AUTO$INT id_room = '||coalesce(:res_id_room, 'null'));

  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) SD
  into   :sys_date;

  for
    select RLP.OUT_DATE
    from   SYSTEM_LOOP_PERIOD(:from_date, :to_date - 1) RLP
    into   :for_date
  do begin
    id_room = :res_id_room;
    if (:for_date < :sys_date) then begin
      -- get initial room from first checked-in guest for reservation, because may be different from current
      select first 1 GS.ID_ROOM
      from   GUEST G
             join GUEST_STAY GS on GS.ID_GUEST = G.ID_GUEST
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and GS.FOR_DATE = :for_date
      order by g.ID_GUEST asc
      into   :id_room;
    end

    insert into GUEST_STAY (ID_GUEST, FOR_DATE, ID_ROOM_TYPE, ID_BOARD, ID_TYPE_STAY, ID_TARIFF, /*ID_PACKET, */ID_ROOM)
    values (:id_guest, :for_date, -1, :id_board, -1, :id_tarrif, /*:id_packet,*/ :id_room);
  end

  insert into GUEST_PACKET (ID_GUEST, ID_PACKET_ITEM)
  select :id_guest, gp.ID_PACKET_ITEM
  from   GUEST_PACKET GP
  where  GP.ID_GUEST = :id_titular;

  execute procedure RES_GUESTDATA_INVALIDATE$INT(:rd_dbkey);
  --
end
^

/* Alter (RES_GUEST_CHANGE$RSV) */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable check_status integer;
  declare variable id_person_data integer;
  declare variable old_person_profile integer;
  declare variable old_profile_name varchar(100);
  declare variable new_profile_name varchar(100);
begin
  select r.RDB$DB_KEY, r.ID_TITULAR, r.CHECK_STATUS, r.ID_PERSON_PROFILE, p.PROFILE_NAME
  from   RESERV_DETAIL R
         join PROFILE P on P.ID_PROFILE = r.ID_PERSON_PROFILE
  where  R.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :id_guest, :check_status, :old_person_profile, :old_profile_name;

  if (:old_person_profile = :ID_PERSON_PROFILE) then exit; -- NO CHANGES!

  id_person_data = null;
  select pp.ID_PERSON_DATA, p.PROFILE_NAME
  from   PROFILE_PERSON PP
         join PROFILE P on P.ID_PROFILE = pp.ID_PROFILE
  where  pp.ID_PROFILE = :ID_PERSON_PROFILE
  into   :id_person_data, :new_profile_name;

  if (:id_person_data is null) then exception BOOKING_EXCEPTION '-1039';

  update RESERV_DETAIL RD
  set    rd.ID_PERSON_PROFILE = :ID_PERSON_PROFILE
  where  rd.RDB$DB_KEY = :rd_dbkey;

  if (:check_status = 1) then begin
    execute procedure PERSON_DATA_COPY$INT (:id_person_data)
    returning_values (:id_person_data);
  end

  update GUEST_DATA GD
  set    gd.ID_PERSON_DATA = :id_person_data
  where  gd.ID_GUEST = :id_guest;

  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey);

  if (exists (select ap.ID_ACCOUNT_POST
              from   ACCOUNT_POST AP
                     join ACCOUNT A on A.ID_ACCOUNT = ap.ID_ACCOUNT
              where  a.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                     and a.ID_PROFILE = :old_person_profile
                     and ap.IS_ANUL = 0)) then
    exception BOOKING_EXCEPTION '-1038';

  if (exists (select d.ID_DEPOSIT
              from   DEPOSITS D
                     join ACCOUNT A on A.ID_ACCOUNT = d.ID_ACCOUNT
              where  a.ID_PROFILE = :old_person_profile
                     and coalesce(d.ID_RESERV_DETAIL, a.ID_RESERV_DETAIL) = :ID_RESERV_DETAIL
                     and d.RECEIVED_AMOUNT > 0)) then
    exception BOOKING_EXCEPTION '-1040';

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'TITULAR_CHANGED',
          f_character(29) || :old_profile_name || f_character(28) || :new_profile_name, null);

end
^

/* Alter (RES_GUEST_SAVE_OTHER$RSV) */
ALTER PROCEDURE RES_GUEST_SAVE_OTHER$RSV(ID_GUEST INTEGER,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE)
 AS
declare variable g_dbkey char(8);
  declare variable old_code_first_food tfood_code;
  declare variable old_text_first_food varchar(50);
  declare variable text_first_food varchar(50);
  declare variable action_text varchar(255);
begin
  select G.RDB$DB_KEY, G.CODE_FIRST_FOOD
  from   GUEST G
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :old_code_first_food;

  execute procedure RES_GUEST_SAVE_OTHER$INT(:g_dbkey, :transfer_in_time, :transfer_in_note,
          :transfer_out_time, :transfer_out_note, :code_first_food);

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

  if (coalesce(:old_code_first_food, 0) <> coalesce(:code_first_food, 0)) then begin
    old_text_first_food = case
                              when :old_code_first_food = 'breakfast' then 'caption.breakfast'
                              when :old_code_first_food = 'lunch' then 'caption.launch'
                              when :old_code_first_food = 'dinner' then 'caption.dinner'
                              when :old_code_first_food = 'extrafood1' then 'caption.extrafood1'
                              when :old_code_first_food = 'extrafood2' then 'caption.extrafood2'
                              when :old_code_first_food = 'none' then 'caption.no_first_food'
                          end;
    text_first_food = case
                              when :code_first_food = 'breakfast' then 'caption.breakfast'
                              when :code_first_food = 'lunch' then 'caption.launch'
                              when :code_first_food = 'dinner' then 'caption.dinner'
                              when :code_first_food = 'extrafood1' then 'caption.extrafood1'
                              when :code_first_food = 'extrafood2' then 'caption.extrafood2'
                              when :code_first_food = 'none' then 'caption.no_first_food'
                      end;
    action_text = f_character(29) || coalesce('@{' || :old_text_first_food || '}', '') ||
                  f_character(28) || coalesce('@{' || :text_first_food || '}', '');
    execute procedure SYSTEM_LOG_ADD ('GUEST', :ID_GUEST, 'FIRST_FOOD_CHANGED', :ACTION_TEXT);
  end
end
^

/* Alter (RES_GUESTCOUNT_ADD$INT) */
ALTER PROCEDURE RES_GUESTCOUNT_ADD$INT(RD_DBKEY CHAR(8),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
INITIALIZE_BOOKING TYPE OF TLOGICAL = 0)
 AS
declare variable i integer;
  declare variable is_child integer;
  declare variable new_id_guest integer;
begin
  i = 1;
  while (:i <= (coalesce(:adult_count, 0) + coalesce(:child_count, 0))) do begin
    if (:i <= :adult_count) then is_child = 0;
    else is_child = 1;

    execute procedure RES_GUEST_ADD$INT(:rd_dbkey, :is_child, :INITIALIZE_BOOKING)
    returning_values  :new_id_guest;
    i = :i + 1;

  end
end
^

/* Alter (RES_GUESTLIST_REMOVE$RSV) */
ALTER PROCEDURE RES_GUESTLIST_REMOVE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable g_dbkey char(8);
  declare variable rd_dbkey char(8);
begin
  /*  Description:
  ||
  */

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  for
    select G.RDB$DB_KEY
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey
  do begin
    execute procedure RES_GUEST_AUTO$INT(:g_dbkey, :rd_dbkey, 0);
  end

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
  returning_values  :WARN_CODE;

end
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE_RECALC$INT for: RES_RECALC$INT */
ALTER PROCEDURE RES_FINALIZE_RECALC$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_RECALC$INT) */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable num_prefix varchar(20);
  declare variable number_1 varchar(20);
begin
  /* CALLER_KIND = {NORMAL, FORCED} */
  err_code = 0;
  /* 1. GET DATA */
  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, rd.NUMBER_1
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :number_1;

  if (:check_status = 1) then begin
    -- CHECKED OUT
    select sn.LEADING_PART
    from   SYSTEM_NUMERATOR SN
    where  sn.ID_NUMERATOR = 0
    into   :num_prefix;

    if (trim('.' from coalesce(:num_prefix, '')) = coalesce(:number_1, '')) then
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_MINE');
    else
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_ELSE');

    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :id_guest
    do begin
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'MANUAL_EDIT_DATA', '');
    end
  end
  /* 2. FIND DEPENDANT GUESTS AND THEIR TARIFFS */
  --execute procedure sys_dbg('calc RES_RECALC$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

  ID_TAR_CALC = gen_id(gen_id_tar_calc, 1);
  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NONE');

  -- 3. UPDATE ROOM PRICE and REPOST ALL AFFECTED BOOKINGS
  execute procedure RES_TAR_CALC_FINALIZE$INT (:ID_TAR_CALC, :CALLER_KIND, :FORCE_POSTING)
  returning_values (:ERR_CODE, :ERR_TEXT);
end
^

/* Alter (RES_RECALC$RSV) */
ALTER PROCEDURE RES_RECALC$RSV(ID_RESERV_DETAIL INTEGER,
FORCE_POSTING SMALLINT = null)
 AS
declare variable id_tar_calc integer;
declare variable err_text varchar(255);
  declare variable err_code integer;
  declare variable rd_dbkey char(8);
begin
  -- FORCED, user activated recalculation
  execute procedure RIGHTS_CHECK_GRANTED$INT ('GUEST_RECALC_POST');

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_RECALC$INT(:rd_dbkey, 'FORCED', :FORCE_POSTING)
  returning_values  :err_code, :err_text, :id_tar_calc;
  if (:err_code < 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'FORCED_RECALC', null);

end
^

/* Alter (RES_SAVE_GUARANTEE$RSV) */
ALTER PROCEDURE RES_SAVE_GUARANTEE$RSV(ID_RESERV_DETAIL INTEGER,
IS_VIP SMALLINT,
CHECK_STATUS INTEGER,
ID_GUARANTEE_POLICY INTEGER,
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
declare variable old_check_status integer;
declare variable warn_code integer;
declare variable rd_dbkey char(8);
declare variable action_text varchar(255);
begin
  /*  Description:
  ||  GUI facade
  */
  select RD.RDB$DB_KEY, rd.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_check_status;

  update RESERV_DETAIL RDU
  set    RDU.IS_VIP = coalesce(:is_vip, RDU.IS_VIP),
         RDU.ID_GUARANTEE_POLICY = :id_guarantee_policy,
         RDU.GUARANTEE_DEPOSIT = :guarantee_deposit,
         RDU.GUARANTEE_CURRENCY = :guarantee_currency,
         RDU.BLOCK_CC = :BLOCK_CC,
         GUARANTEE_DEPOSIT_PERCENT = :GUARANTEE_DEPOSIT_PERCENT,
         GUARANTEE_DEPOSIT_NIGHTS = :GUARANTEE_DEPOSIT_NIGHTS,
         GUARANTEE_DUE_DAYS_BEF_ARRIVAL = :GUARANTEE_DUE_DAYS_BEF_ARRIVAL,
         GUARANTEE_DUE_DAYS_AFTER_CREATE = :GUARANTEE_DUE_DAYS_AFTER_CREATE
  where  RDU.RDB$DB_KEY = :rd_dbkey;

  action_text = '';
  if (:GUARANTEE_DEPOSIT_PERCENT is not null) then begin
    action_text = f_character(29) || '@{caption.guaranteetype.percent} ' || formatfloat(:GUARANTEE_DEPOSIT_PERCENT, '0.00') || f_character(28)
                  || '[' || coalesce(:GUARANTEE_DUE_DAYS_AFTER_CREATE, ' ') || ']'
                  || f_character(28) || '[' || coalesce(:GUARANTEE_DUE_DAYS_BEF_ARRIVAL, ' ') || ']';
  end
  else if (:GUARANTEE_DEPOSIT_NIGHTS is not null) then begin
    action_text = f_character(29) || '@{caption.guaranteetype.nights} ' || :GUARANTEE_DEPOSIT_NIGHTS || f_character(28)
                  || '[' || coalesce(:GUARANTEE_DUE_DAYS_AFTER_CREATE, ' ') || ']'
                  || f_character(28) || '[' || coalesce(:GUARANTEE_DUE_DAYS_BEF_ARRIVAL, ' ') || ']';
  end
  else if (:GUARANTEE_DEPOSIT is not null) then begin
    action_text = f_character(29) || '@{caption.guaranteetype.fixed} ' || formatfloat(:GUARANTEE_DEPOSIT, '0.00') || ' ' || :GUARANTEE_CURRENCY || f_character(28)
                  || '[' || coalesce(:GUARANTEE_DUE_DAYS_AFTER_CREATE, ' ') || ']'
                  || f_character(28) || '[' || coalesce(:GUARANTEE_DUE_DAYS_BEF_ARRIVAL, ' ') || ']';
  end

  if (:action_text <> '') then begin
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_GUARANTEE_CHANGED', :action_text);
  end

  CHECK_STATUS = coalesce(:CHECK_STATUS, :old_check_status);
  if (:CHECK_STATUS <> :old_check_status) then begin

    if (:CHECK_STATUS >= 0) then exception BOOKING_EXCEPTION 'Can not set status ''CHECKED IN'' or ''CHECKED OUT'' manually!';

    execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, :check_status);

    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;
  end
end
^

/* empty dependent procedure body */
/* Clear: RESMULTI_MARKETING_MODIFY$RSV for: RES_SAVE_MARKETING$RSV */
ALTER PROCEDURE RESMULTI_MARKETING_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SAVE_MARKETING$RSV) */
ALTER PROCEDURE RES_SAVE_MARKETING$RSV(ID_RESERV_DETAIL INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable rd_dbkey char(8);
declare variable old_mrkt_profile varchar(255);
declare variable new_mrkt_profile varchar(255);
begin
  err_code = 0;
  err_text = '';
  rd_dbkey = null;
  select RD.RDB$DB_KEY, MP.MARKETING_PROFILE
  from   RESERV_DETAIL RD
         left outer join MARKETING_PROFILE_GET (RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_COME_REASON,
              RD.ID_NOM_HEAR_REASON, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_MARKET_SEGMENT) MP on 1=1
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_mrkt_profile;

  execute procedure RES_SAVE_MARKETING$INT(:rd_dbkey, :id_nom_market_segment,
          :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason);

  select MP.MARKETING_PROFILE
  from   MARKETING_PROFILE_GET (:ID_NOM_CHANNEL_CODE, :ID_NOM_COME_REASON,
              :ID_NOM_HEAR_REASON, :ID_NOM_SOURCE_CODE, :ID_NOM_MARKET_SEGMENT) MP
  into   :new_mrkt_profile;

  if (:new_mrkt_profile is distinct from :old_mrkt_profile) then begin
    --execute procedure RESERV_TRACK_CHANGES$INT (:rd_dbkey);

    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'MARKETING_CHANGE',
            f_character(29) || :old_mrkt_profile || f_character(28) || :new_mrkt_profile);
  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_BOOKING_CUSTOM_PRICE$EXC for: RES_SAVE_PRICE$RSV */
ALTER PROCEDURE IMPORT_BOOKING_CUSTOM_PRICE$EXC(ID_RESERV_DETAIL INTEGER,
FOR_DATE DATE,
PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3))
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SAVE_PRICE$RSV) */
ALTER PROCEDURE RES_SAVE_PRICE$RSV(ID_RESERV_DETAIL INTEGER,
FOR_DATE DATE,
PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3))
 AS
declare variable old_price numeric(14,4);
  declare variable old_price_currency char(3);
  declare variable action_text varchar(255);
begin
  select cp.PRICE, cp.PRICE_CURRENCY
  from   RESERV_CUSTOM_PRICE cp
  where  cp.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
         and cp.FOR_DATE = :FOR_DATE
  into   :old_price, :old_price_currency;

  if ((:old_price is distinct from :price) or (:old_price_currency is distinct from :price_currency) ) then begin
    execute procedure RES_SAVE_CUSTOM_PRICE$INT(:ID_RESERV_DETAIL, :FOR_DATE, :PRICE, :PRICE_CURRENCY);

    action_text = f_character(29) || formatfloat(:price, 'F;0.00') || ' ' || :price_currency || f_character(28) || formatdate(:for_date, 'D;dd.mm.yyyy') ;
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MANUAL_PRICE', :action_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: RESMULTI_RATE_MODIFY$RSV for: RES_SAVE_RATE$INT */
ALTER PROCEDURE RESMULTI_RATE_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
ID_RATE INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SAVE_RATE$INT) */
ALTER PROCEDURE RES_SAVE_RATE$INT(RD_DBKEY CHAR(8),
ID_RATE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable g_dbkey char(8);
  declare variable id_guest integer;
  declare variable id_old_rate integer;
  declare variable action_text varchar(255);
begin
  select RD.ID_RESERV_DETAIL, rd.ID_RATE
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail, :id_old_rate;

  update RESERV_DETAIL RD
  set    RD.ID_RATE = :id_rate,
         RD.HAS_DIFFERENT_TARIFF = 0
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:ID_RATE is distinct from :id_old_rate) then begin
    select f_character(29) || t.TARIFA_NAME
    from   TARIFA T
    where  t.ID_TARIFA = :id_old_rate
    into   :action_text;

    select :action_text || f_character(28) || t.TARIFA_NAME
    from   TARIFA T
    where  t.ID_TARIFA = :ID_RATE
    into   :action_text;

    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_RATE_CHANGED', :action_text);
  end

  for
    select G.RDB$DB_KEY, G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey, :id_guest
  do begin
    update GUEST GU
    set    GU.ID_TARIFA = :id_rate
    where  GU.RDB$DB_KEY = :g_dbkey;

    update GUEST_STAY GS
    set    GS.ID_TARIFF = :id_rate
    where  GS.ID_GUEST = :id_guest;

    execute procedure RES_GUESTDATA_INVALIDATE$INT(:rd_dbkey);
  end
end
^

/* Alter (RES_SAVE_RATE$RSV) */
ALTER PROCEDURE RES_SAVE_RATE$RSV(ID_RESERV_DETAIL INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
IS_DIFFERENT_TARIFF INTEGER,
IS_DIFFERENT_PRICE INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 AS
declare variable rd_dbkey char(8);
  declare variable old_price numeric(14,4);
  declare variable old_price_currency char(3);
  declare variable old_is_different_price integer;
  declare variable action_text varchar(255);
  declare variable err_code integer;
  declare variable err_text varchar(255) ;
  declare variable id_tar_calc integer;
  declare variable recalc_type varchar(20);
  declare variable old_tariff integer;
begin

  select RD.RDB$DB_KEY, RD.custom_price, rd.custom_currency, rd.HAS_DIFFERENT_PRICE, rd.ID_RATE
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_price, :old_price_currency, :old_is_different_price, :old_tariff;

  if (:is_different_tariff = 0) then begin
    execute procedure RES_SAVE_RATE$INT(:rd_dbkey, :id_tariff);
  end else begin
    execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey);
  end

  if (:IS_DIFFERENT_PRICE = 0) then begin
    delete from RESERV_CUSTOM_PRICE
    where  ID_RESERV_DETAIL  = :ID_RESERV_DETAIL;

    update RESERV_DETAIL RD
    set    RD.CUSTOM_PRICE = :custom_price,
           RD.CUSTOM_CURRENCY = :custom_currency,
           RD.HAS_DIFFERENT_PRICE = :IS_DIFFERENT_PRICE
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end else begin
    if (not exists (select * from RESERV_CUSTOM_PRICE rmp where rmp.id_reserv_detail = :id_reserv_detail)) then IS_DIFFERENT_PRICE = 0;
    update RESERV_DETAIL RD
    set    RD.CUSTOM_PRICE = null,
           RD.CUSTOM_CURRENCY = null,
           RD.HAS_DIFFERENT_PRICE = :IS_DIFFERENT_PRICE
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end


  /*Maintain the flag in RD - HAS_DIFFERENT_PRICE*/
/*  if (exists (select * from RESERV_CUSTOM_PRICE rmp where rmp.id_reserv_detail = :id_reserv_detail)) then
    update RESERV_DETAIL set has_different_price = 1 where id_reserv_detail = :id_reserv_detail;
  else
    update RESERV_DETAIL set has_different_price = 0 where id_reserv_detail = :id_reserv_detail;
*/
  /*Log modifications in custom price if here is diferent values*/
  if ((:old_price is distinct from :custom_price) or (:old_price_currency is distinct from :custom_currency) ) then begin
    action_text = f_character(29) || formatfloat(:custom_price, 'F;0.00') || '' || :custom_currency || f_character(28);
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MANUAL_PRICE', :action_text);
  end

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    if ((:ID_TARIFF is distinct from :old_tariff)
        or (:IS_DIFFERENT_PRICE is distinct from :old_is_different_price)
        or (:CUSTOM_PRICE is distinct from :old_price)
        or (:CUSTOM_CURRENCY is distinct from :old_price_currency) ) then
      recalc_type = 'FORCED';
    else
      recalc_type = 'NORMAL';

    execute procedure RES_RECALC$INT(:rd_dbkey, :recalc_type, 0)
    returning_values  :err_code, :err_text, :id_tar_calc;
    --execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    --returning_values  :err_code, :err_text;
    if (:err_code < 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM$EXC for: RES_SAVE_ROOM$RSV */
ALTER PROCEDURE RES_SAVE_ROOM$EXC(RD_DBKEY CHAR(8),
ID_RES_ROOM_TYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(250),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ROOM$RSV) */
ALTER PROCEDURE RES_SAVE_ROOM$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
ID_RES_ROOM_TYPE INTEGER,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(255),
SPLIT_ON_CHECKIN SMALLINT,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_res_room_type, :TAR_OPTION, :is_auto_staytype)
  returning_values (:WARN_CODE);

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
    returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :tmp_warn_code;
  end
  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

  update RESERV_DETAIL R
  set    r.SPLIT_ON_CHECKIN = :split_on_checkin,
         r.ID_HK_PLAN = :ID_HK_PLAN,
         r.I_SPECIAL_TREATMENT = :I_SPECIAL_TREATMENT,
         r.ROOM_FEATURES = :ROOM_FEATURES
  where  r.ID_RESERV_DETAIL = :id_reserv_detail;
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM$INT for: RES_SAVE_ROOM_LOG$INT */
ALTER PROCEDURE RES_SAVE_ROOM$INT(RD_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
ID_ROOM /* TYPE OF ID */ INTEGER,
ID_RES_ROOM_TYPE /* TYPE OF ID */ INTEGER,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE /* TYPE OF TLOGICAL */ SMALLINT = null)
 RETURNS(WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ROOM_LOG$INT) */
ALTER PROCEDURE RES_SAVE_ROOM_LOG$INT(RD_DBKEY CHAR(8),
OLD_ID_ROOM INTEGER,
OLD_ID_RES_ROOM_TYPE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_res_room_type integer;
  declare variable id_room integer;
  declare variable check_status integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable system_date date;
begin

  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, RD.ID_ROOM_TYPE, RD.ID_ROOM, RD.ID_HOTEL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :id_res_room_type, :id_room, :id_hotel;

  /* LOG SECTION */
  action_text = f_character(29);
  if (:old_ID_RES_ROOM_TYPE is distinct from :ID_RES_ROOM_TYPE) then begin
    select :action_text || '<' || coalesce(rt.TYPE_ROOM, '') || '>'
    from   ROOM_TYPES rt
    where  rt.ID_ROOM_TYPE = :old_id_res_room_type
    into   :action_text;
    action_text = :action_text || f_character(28);
    select :action_text || '<' || coalesce(rt.TYPE_ROOM, '') || '>'
    from   ROOM_TYPES rt
    where  rt.ID_ROOM_TYPE = :ID_RES_ROOM_TYPE
    into   :action_text;
    action_text = :action_text || f_character(28);

    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_ROOM_TYPE_CHANGED', :action_text);
  end

  action_text = f_character(29);
  if (:old_id_room is distinct from :ID_ROOM) then begin
    select :action_text || '<' || coalesce(rt.TYPE_ROOM, '') || ' ' || coalesce (R.ROOM_NAME, '') || '>'
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :old_id_room
    into   :action_text;
    action_text = :action_text || f_character(28);

    select :action_text || '<' || coalesce(rt.TYPE_ROOM, '') || ' ' || coalesce (R.ROOM_NAME, '') || '>'
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :id_room
    into   :action_text;
    action_text = :action_text || f_character(28);

    if (:check_status >= 0) then begin
      execute procedure SYSTEM_DATE_GET (:id_hotel)
      returning_values :system_date;
      action_text = :action_text || f_character(28) || :system_date;
      execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'ROOM_MOVED', :action_text, :old_id_room);
    end else
      execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'ROOM_CHANGED', :action_text);
  end
  /*****/
end
^

/* empty dependent procedure body */
/* Clear: RES_SET_STATUS$RSV for: RES_SAVE_STATUS$INT */
ALTER PROCEDURE RES_SET_STATUS$RSV(SELECTION_ID INTEGER,
CHECK_STATUS SMALLINT)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_STATUS$INT) */
ALTER PROCEDURE RES_SAVE_STATUS$INT(RD_DBKEY CHAR(8),
CHECK_STATUS INTEGER,
CONFIRMATION_NUMBER TYPE OF NAME_20 = null)
 AS
declare variable old_check_status integer;
  declare variable id_reserv_detail integer;
  declare variable action_text varchar(255);
begin

  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_check_status, :id_reserv_detail;

  if (:old_check_status <> :check_status) then begin
    if (:old_check_status >= 0 and :CHECK_STATUS < :old_check_status) then begin
      exception BOOKING_EXCEPTION 'Can not downgrade status for checked in booking!';
    end

    if (:old_check_status < 0 and :CHECK_STATUS = 1) then begin
      exception BOOKING_EXCEPTION '-1006';
    end

    update RESERV_DETAIL RDU
    set    RDU.CHECK_STATUS = :check_status,
           RDU.CONFIRMATION_NUMBER = iif (:CHECK_STATUS = -1, strhash_large(rdu.NUMBER || 'CONFIRMATION'), rdu.CONFIRMATION_NUMBER)
    where  RDU.RDB$DB_KEY = :rd_dbkey;

    update ROOM_MAGIC RM
    set    rm.BUSY_TYPE = case when :CHECK_STATUS = '1' then 'CHECK_OUT'
                               when :CHECK_STATUS = '0' then 'CHECK_IN'
                               when :CHECK_STATUS = '-1' then 'VALUE_CONFIRMED'
                               when :CHECK_STATUS = '-2' then 'VALUE_NOTCONFIRMED'
                               when :CHECK_STATUS = '-3' then 'VALUE_RESERVS'
                               else rm.BUSY_TYPE
                          end
    where  rm.ID_RESERV_DETAIL = :id_reserv_detail;

    update ROOMS_SHARE Rs
    set    rs.BUSY_TYPE = case when :CHECK_STATUS = '1' then 'CHECK_OUT'
                               when :CHECK_STATUS = '0' then 'CHECK_IN'
                               when :CHECK_STATUS = '-1' then 'VALUE_CONFIRMED'
                               when :CHECK_STATUS = '-2' then 'VALUE_NOTCONFIRMED'
                               when :CHECK_STATUS = '-3' then 'VALUE_RESERVS'
                               else rs.BUSY_TYPE
                          end
    where  rs.ID_RESERV_STATISTICS = :id_reserv_detail;

    execute procedure RES_SET_EDIT_STATUS$INT (:rd_dbkey, 'STATUS', 'add');

    if (:CHECK_STATUS < 0) then begin
      action_text = f_character(29) || '@{booking.status.' || :old_check_status || '}'
                    || f_character(28) || '@{booking.status.' || :CHECK_STATUS || '}';
      execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MOD_STATUS', :action_text);
    end
  end

  if (:CHECK_STATUS = -1 and :CONFIRMATION_NUMBER is not null) then begin
    -- override with incoming confirmation number
    update RESERV_DETAIL rd
    set    rd.CONFIRMATION_NUMBER = :CONFIRMATION_NUMBER
    where  rd.RDB$DB_KEY = :RD_DBKEY;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_VOUCHER$RSV for: RES_SAVE_VOUCHER$INT */
ALTER PROCEDURE RES_SAVE_VOUCHER$RSV(ID_RESERV_DETAIL INTEGER,
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_VOUCHER_MODIFY$RSV for: RES_SAVE_VOUCHER$INT */
ALTER PROCEDURE RESMULTI_VOUCHER_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
VOUCHER_NUM VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SAVE_VOUCHER$INT) */
ALTER PROCEDURE RES_SAVE_VOUCHER$INT(RD_DBKEY CHAR(8),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE)
 AS
declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable action_text varchar(255);
begin

  update RESERV_DETAIL RD
  set    RD.VAUCHER_NUM = :voucher_num,
         RD.VAUCHER_DATE = :voucher_date,
         RD.VAUCHER_TEXT = :voucher_text,
         RD.VAUCHER_NUM2 = :voucher2_num,
         RD.VAUCHER_DATE2 = :voucher2_date,
         RD.HAS_DIFFERENT_VOUCHERS = 0
  where  RD.RDB$DB_KEY = :rd_dbkey
         and
         ((RD.VAUCHER_NUM is distinct from :voucher_num)
          or (RD.VAUCHER_DATE is distinct from :voucher_date)
          or (RD.VAUCHER_TEXT is distinct from :voucher_text)
          or (RD.VAUCHER_NUM2 is distinct from :voucher2_num)
          or (RD.VAUCHER_DATE2 is distinct from :voucher2_date)
          or (RD.HAS_DIFFERENT_VOUCHERS is distinct from 0)
         );

  if (row_count > 0) then begin
    select RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.RDB$DB_KEY = :rd_dbkey
    into   :id_reserv_detail;
  
    action_text = f_character(29)
                  || coalesce(:VOUCHER_NUM, '')
                  || iif(:VOUCHER_DATE is not null, '/' || formatdate(:VOUCHER_DATE, 'D;dd.mm.yyyy'), '')
                  || ' (2: ' || coalesce(:VOUCHER2_NUM, '')
                  || iif(:VOUCHER2_DATE is not null, '/' || formatdate(:VOUCHER2_DATE, 'D;dd.mm.yyyy'), '')
                  || ')';
  
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'VOUCHER_SET', :action_text);
  
    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure RES_GUEST_SAVE_VOUCHER$INT(:rd_dbkey, :g_dbkey, :voucher_num, :voucher_date,
              :voucher_text, :voucher2_num, :voucher2_date);
    end
  
    execute procedure RES_GUESTDATA_INVALIDATE$INT(:rd_dbkey);
  end
end
^

/* Alter (RES_SAVE_VOUCHER$RSV) */
ALTER PROCEDURE RES_SAVE_VOUCHER$RSV(ID_RESERV_DETAIL INTEGER,
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_SAVE_VOUCHER$INT(:rd_dbkey, :voucher_num, :voucher_date, :voucher_text, :voucher2_num, :voucher2_date);
end
^

/* Alter (RES_SET_CHECKIN$INT) */
ALTER PROCEDURE RES_SET_CHECKIN$INT(RD_DBKEY CHAR(8))
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
begin
  select r.ID_RESERV_DETAIL
  from   RESERV_DETAIL R
  where  r.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail;

  execute procedure ROOM_MAGIC_CLEAR(:id_reserv_detail);   -- ?!?

  execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, 0);

  for
    select G.RDB$DB_KEY
    from   GUEST G
    where  g.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :g_dbkey
  do begin
    execute procedure GUEST_SET_STATUS$INT(:g_dbkey, 0);
  end

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;
end
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_CO_RENTERS$INT for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_CO_RENTERS$INT(VIRTUAL_ID_ROOM INTEGER,
NEW_ID_ROOM INTEGER,
INIT_ID_RES_DETAIL INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_FAST$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_FAST$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_SHARED$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_SHARED$RSV(SELECTION_ID INTEGER,
ROOM_NAME VARCHAR(10))
 RETURNS(VIRTUAL_ROOM VARCHAR(10),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SET_ROOM$INT) */
ALTER PROCEDURE RES_SET_ROOM$INT(RD_DBKEY CHAR(8),
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option)
  returning_values (:WARN_CODE);

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :SHARE_ERR_TEXT, :share_transaction_id, :tmp_warn_code;

  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
end
^

/* Alter (RES_SET_ROOM_CO_RENTERS$INT) */
ALTER PROCEDURE RES_SET_ROOM_CO_RENTERS$INT(VIRTUAL_ID_ROOM INTEGER,
NEW_ID_ROOM INTEGER,
INIT_ID_RES_DETAIL INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
declare variable shared_rd_dbkey char(8);
declare variable shared_booking_ids varchar(255);
declare variable id_reserv_detail integer;
declare variable tmp_share_err_code integer;
declare variable tmp_share_err_text varchar(255);
begin
  -- distribute the same room to shared bookings

  if (coalesce(:NEW_ID_ROOM, 0) < 0) then exit; -- only for real rooms!1
  SHARE_ERR_CODE = 0;
  shared_booking_ids = ',' || :INIT_ID_RES_DETAIL || ',';
  for
    select vrd.RDB$DB_KEY, vrd.ID_RESERV_DETAIL
    from   RESERV_DETAIL VRD
    where  vrd.ID_ROOM = :VIRTUAL_ID_ROOM
           and vrd.IS_ANUL = 0
           and vrd.ID_RESERV_DETAIL is distinct from :INIT_ID_RES_DETAIL
    into   :shared_rd_dbkey, :id_reserv_detail
  do begin
    shared_booking_ids = :shared_booking_ids || :id_reserv_detail || ',';

    execute procedure RES_SET_ROOM$INT (:shared_rd_dbkey, :NEW_ID_ROOM, :TAR_OPTION)
    returning_values  :WARN_CODE, :share_transaction_id, :tmp_share_err_code, :tmp_share_err_text;

    if (:SHARE_ERR_CODE = 0 and :tmp_share_err_code < 0) then begin
      -- check for share with other bookings
      if (exists (select rs.ID_RESERV_DETAIL
                      from   ROOMS_SHARE rs
                      where  rs.MARK_TRANSACTION = :SHARE_TRANSACTION_ID
                             and :shared_booking_ids not containing ','||rs.ID_RESERV_DETAIL||','
                             and rs.IS_EX_SHARE = 0)) then
      begin
        SHARE_ERR_CODE = :tmp_share_err_code;
        SHARE_ERR_TEXT = :tmp_share_err_text;
      end
    end
  end 
end
^

/* Alter (RES_SET_ROOM_FAST$RSV) */
ALTER PROCEDURE RES_SET_ROOM_FAST$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable old_id_room integer;
  declare variable virtual_room varchar(10);
  declare variable rd_dbkey char(8);
  declare variable tmp_warn_code integer;
  declare variable tmp_share_err_code integer;
  declare variable tmp_share_err_text varchar(255);
begin

  select RD.ID_ROOM, rd.VIRTUAL_ROOM, rd.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_id_room, :virtual_room, :rd_dbkey;

  execute procedure RES_SET_ROOM$INT (:rd_dbkey, :ID_ROOM, :TAR_OPTION)
  returning_values (:warn_code, :share_transaction_id, :share_err_code, :ERR_TEXT);

  if (:virtual_room is not null and :old_id_room < 0) then begin
    execute procedure RES_SET_ROOM_CO_RENTERS$INT (:old_id_room, :ID_ROOM, :ID_RESERV_DETAIL, :TAR_OPTION)
    returning_values (:tmp_warn_code, :share_transaction_id, :tmp_share_err_code, :tmp_share_err_text);
    WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
    SHARE_ERR_CODE = coalesce(:SHARE_ERR_CODE, :tmp_share_err_code);
    ERR_TEXT = coalesce(:ERR_TEXT, :tmp_share_err_text);
  end
end
^

/* Alter (RES_SET_ROOM_MULTI$RSV) */
ALTER PROCEDURE RES_SET_ROOM_MULTI$RSV(OPERATION VARCHAR(20),
FROM_ROOM VARCHAR(20),
SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable cnt_requested integer;
  declare variable cnt_old_room integer;
  declare variable cnt_found integer;
  declare variable is_already_planned integer;
  declare variable is_satisfied integer;
  declare variable new_id_room integer;
  declare variable current_id_room integer;
  declare variable id_res_room_type integer;
  declare variable room_requirements blob sub_type 1 segment size 100;
  declare variable from_date date;
  declare variable to_date date;
  declare variable action_text varchar(255);
  declare variable is_early_arrival smallint;
  declare variable is_late_departure smallint;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable id_reserv_detail integer;
  declare variable tmp_warn_code integer;
  declare variable min_beds integer;
  declare variable virtual_room varchar(10);
  declare variable share_err_text varchar(255);
begin
  /* offer_method :
  ||     0 - NUMBER desc,
  ||     1 - NUMBER asc,
  ||     2 - DAYS FREE(MAX OCCUPANCY),
  ||     3 - FILING FACTOR(EQUAL ROOM USAGE)
  */
  warn_code = null;

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'set_number_asc, set_number_desc, set_max_occupancy, set_max_usage');

  cnt_requested = 0;
  cnt_old_room = 0;
  cnt_found = 0;
  for
    select RD.RDB$DB_KEY, rd.ID_RESERV_DETAIL, rd.ID_ROOM, rd.VIRTUAL_ROOM, RD.ID_ROOM_TYPE, RD.ROOM_FEATURES,
           RD.FROM_DATE, RD.TO_DATE, iif(rd.COMMING_KIND = 0, 1, 0), iif(rd.LEAVING_KIND = 2, 1, 0),
           rd.ADULT_COUNT + rd.CHILD_COUNT
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
           and RD.IS_ANUL = 0
    into   :rd_dbkey, :id_reserv_detail, :current_id_room, :virtual_room, :id_res_room_type, :room_requirements,
           :from_date, :to_date, :is_early_arrival, :is_late_departure, :min_beds
  do begin
    cnt_requested = :cnt_requested + 1;
    new_id_room = null;
    if (:current_id_room < 0) then begin
      if (:virtual_room is not null) then begin
        -- has related bookings with shared virtual room
        -- get cumulative stay for all shared bookings
        select min(vrd.FROM_DATE), min(vrd.FROM_DATE) - min(vrd.FROM_DATE - iif(vrd.COMMING_KIND = 0, 1, 0)),
               max(vrd.TO_DATE), max(vrd.TO_DATE + iif(vrd.LEAVING_KIND = 2, 1, 0)) - max(vrd.TO_DATE),
               sum(vrd.ADULT_COUNT + vrd.CHILD_COUNT)
        from   RESERV_DETAIL VRD
        where  vrd.ID_ROOM = :current_id_room
               and vrd.IS_ANUL = 0
        into   :from_date, :is_early_arrival, :to_date, :is_late_departure, :min_beds;
      end
      -- from_date and to_date are arrival and departure date of reservation,
      -- not first and last accomodation dates !!! this is need to check early arrivals and late departures
      execute procedure ROOM_PICKUP$INT(:id_res_room_type, :from_date, :to_date,
              :is_early_arrival, :is_late_departure,:operation, :from_room, :room_requirements, :min_beds)
      returning_values  :new_id_room;  -- offered room

      if (:new_id_room is not null) then begin
        is_satisfied = 1;
        select R.ROOM_NAME
        from   ROOMS R
        where  r.ID_ROOM = :new_id_room
        into   :action_text;

        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'ROOM_SET_AUTO', :action_text);

        execute procedure RES_SET_ROOM$INT (:rd_dbkey, :new_id_room, 'nrttAsIs')
        returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
        if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
        WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

        if (:virtual_room is not null) then begin
          -- distribute the same room to shared bookings
          execute procedure RES_SET_ROOM_CO_RENTERS$INT (:current_id_room, :new_id_room, :id_reserv_detail, 'nrttAsIs')
          returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
          if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
        end
      end

    end else begin
      is_already_planned = 1;
    end

    cnt_old_room = :cnt_old_room + :is_already_planned;
    cnt_found = :cnt_found + :is_satisfied;

    when exception BOOKING_EXCEPTION do begin
      -- nothing, skip this booking
    end
  end

  if ((:cnt_found + :cnt_old_room) < :cnt_requested) then begin
    execute procedure SYSTEM_WARNING_ADD(-3, f_character(29)||:cnt_found||f_character(28)||:cnt_requested)
    returning_values  :warn_code;
  end
end
^

/* Alter (RES_SET_ROOM_SHARED$RSV) */
ALTER PROCEDURE RES_SET_ROOM_SHARED$RSV(SELECTION_ID INTEGER,
ROOM_NAME VARCHAR(10))
 RETURNS(VIRTUAL_ROOM VARCHAR(10),
WARN_CODE INTEGER)
 AS
declare variable r_dbkey char(8);
  declare variable is_anul integer;
  declare variable shared_id_room integer;
  declare variable current_id_room integer;
  declare variable tmp_warn_code integer;
  declare variable share_trans integer;
  declare variable share_err_code integer;
  declare variable id_hotel integer;
  declare variable cnt_hotels integer;
  declare variable id_room integer;
  declare variable res_counter integer;
  declare variable min_departure date;
  declare variable max_arrival date;
  declare variable share_err_text varchar(255);
begin
  VIRTUAL_ROOM = null;
  select min(r.ID_HOTEL), count(distinct r.ID_HOTEL),
         min(r.TO_DATE), max(r.FROM_DATE)
  from   RESERV_DETAIL R
  where  R.SELECTION_ID = :SELECTION_ID
  into   :id_hotel, :cnt_hotels, :min_departure, :max_arrival;

  if (:cnt_hotels > 1) then exception BOOKING_EXCEPTION '-1035';
  if (:min_departure <= :max_arrival) then exception BOOKING_EXCEPTION '-1037';

  if (:ROOM_NAME is not null) then begin
    execute procedure ROOM_GET_BY_NAME(:ROOM_NAME, :id_hotel)
    returning_values (:id_room);
    shared_id_room = :ID_ROOM;
  end else begin
    id_room = null;
    shared_id_room = gen_id(DETAIL_WITHOUT_ROOMING_LIST, -1);
    VIRTUAL_ROOM = gen_id(GEN_VIRTUAL_ROOM, 1);
  end

  res_counter = 0;
  for
    select r.RDB$DB_KEY, r.IS_ANUL, r.ID_ROOM
    from   RESERV_DETAIL R
    where  R.SELECTION_ID = :SELECTION_ID
    into   :r_dbkey, :is_anul, :current_id_room
  do begin
    res_counter = :res_counter + 1;
    if (:is_anul = 1) then
      exception BOOKING_EXCEPTION '-1036';

    if (:current_id_room > 0 and :ID_ROOM is null) then
      exception BOOKING_EXCEPTION '-1034';

    execute procedure RES_SET_ROOM$INT(:r_dbkey, :shared_id_room, 'nrttAsIs')
    returning_values  :tmp_warn_code, :share_trans, :share_err_code, :share_err_text;
    WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
  end

  if (:VIRTUAL_ROOM is not null and :share_trans is not null) then begin
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = '<'||:VIRTUAL_ROOM||'>'
    where  rd.ID_ROOM = :shared_id_room;
  end
end
^

/* Alter (RES_SET_STATUS$RSV) */
ALTER PROCEDURE RES_SET_STATUS$RSV(SELECTION_ID INTEGER,
CHECK_STATUS SMALLINT)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  if (:CHECK_STATUS >= 0) then exception BOOKING_EXCEPTION 'Can not set status ''CHECKED IN'' or ''CHECKED OUT'' manually!';

  for
    select RD.RDB$DB_KEY
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :rd_dbkey
  do begin
    execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, :check_status);

    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;
  end

end
^

/* Alter (RES_TAR_CALC_FINALIZE$INT) */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(ID_TAR_CALC INTEGER,
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
declare variable old_room_price numeric(15,4);
  declare variable old_room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
  declare variable reserv_posting_disabled smallint;
  declare variable postings_disabled smallint;
  declare variable warn_code integer;
  declare variable action_text varchar(255);
  declare variable id_guest integer;
begin
  --  Razpiswa cenata na staia, kakto i price_detailite.

  execute procedure TAR_CALC_EVAL_ALL$INT(:ID_TAR_CALC)
  returning_values  :ERR_CODE, :ERR_TEXT;

  if (:ERR_CODE = 0) then execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

  select iif(si.INFO_VALUE = '1', 1, null)
  from   SYSTEM_INFO_GET('RESERV_POSTINGS_DISABLED') si
  into   :postings_disabled;

  for
    select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, coalesce(:postings_disabled, rd.IS_POSTING_STOPPED),
           coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
           coalesce(max((select first 1 AP.IS_BASE
                         from   GUEST G
                                join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                         where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (it`s possible)
    from   TAR_CALC_INPUT$TMP TI
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
           join TARIFA t on t.ID_TARIFA = rd.ID_RATE
    where  ti.ID_TAR_CALC = :ID_TAR_CALC
    group by 1, 2, 3, 4, 5, 6
    into   :id_reserv_detail, :check_status, :is_posting_stopped,
           :room_currency, :id_hotel, :is_anul, :has_postings
  do begin
    reserv_posting_disabled = iif(:is_posting_stopped = 1 and :has_postings = 0, 1, 0);

    if (:ERR_CODE <> 0) then begin
      -- price calculation error handling  !!!!!
      if (:reserv_posting_disabled = 1) then begin
        -- set price to null, posting is disabled
        update RESERV_DETAIL RD
        set    RD.ROOM_PRICE = null,
               RD.ROOM_CURRENCY = null,
               RD.ROOM_PRICE_DETAILS = null,
               RD.LAST_ID_TAR_CALC = null
        where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
      end else begin
        -- exit on error in price calculation - cannot make valid posts
        EXIT;
      end
    end else begin
      room_price = 0;
      room_price_details = '';
    
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);
  
      if (:reserv_posting_disabled = 0 and ((coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1))) then begin
        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);
      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;
  
        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end
  
      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc,
             rd.ROOM_PRICE_LAST$INT = null,
             rd.ROOM_CURRENCY_LAST$INT = null
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail
      returning old.ROOM_PRICE_LAST$INT, old.ROOM_CURRENCY_LAST$INT
      into :old_room_price, :old_room_currency;

      if ((:old_room_price is distinct from :room_price)
          or (:old_room_currency is distinct from :room_currency) ) then
      begin
        action_text = f_character(29) || formatfloat(:old_room_price, 'F;0.00') || ' ' || coalesce(:old_room_currency, '') || f_character(28) || formatfloat(:room_price, 'F;0.00') || ' ' || coalesce(:room_currency, '');
        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_PRICE_RECALC', :action_text);

        if (:check_status >= 0) then begin
          for
            select g.ID_GUEST
            from   GUEST G
            where  g.ID_RESERV_DETAIL = :id_reserv_detail
            into   :id_guest
          do begin
            execute procedure GUEST_REGISTRATION_UPDATE(:id_guest);
          end
        end
      end
    end
  end

  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;

  if (:ERR_CODE <> 0) then begin
    execute procedure SYSTEM_WARNING_ADD(:ERR_CODE, :ERR_TEXT)
    returning_values :warn_code;
    ERR_CODE = 0;
    ERR_TEXT='';
  end
end
^

/* Alter (RESERV_DETAIL_EXTERNAL_MOD$RSV) */
ALTER PROCEDURE RESERV_DETAIL_EXTERNAL_MOD$RSV(ID_RESERV_DETAIL INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
LOCATOR VARCHAR(100))
 AS
BEGIN
  update RESERV_DETAIL_EXTERNAL
  set    MINIBAR_RIGHTS = :minibar_rights,
         PAYTV_RIGHTS = :paytv_rights,
         VIDEO_RIGHTS = :video_rights,
         NOPOST_PMS = :nopost_pms,
         PHONE_RIGHTS = :phone_rights,
         SEMINAR_CAHNNEL_RIGHTS = :seminar_cahnnel_rights,
         LOCATOR = :locator
  where  ID_RESERV_DETAIL = :id_reserv_detail;

  if (row_count = 0) then begin
    insert into RESERV_DETAIL_EXTERNAL (
        ID_RESERV_DETAIL,
        MINIBAR_RIGHTS,
        PAYTV_RIGHTS,
        VIDEO_RIGHTS,
        NOPOST_PMS,
        PHONE_RIGHTS,
        SEMINAR_CAHNNEL_RIGHTS,
        LOCATOR)
    values (
        :id_reserv_detail,
        :minibar_rights,
        :paytv_rights,
        :video_rights,
        :nopost_pms,
        :phone_rights,
        :seminar_cahnnel_rights,
        :locator);
  end

  execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RSV_EXT_DETAIL_CHNG', '');

END
^

/* Alter (RESERV_STATISTIC_CANCELED$INT) */
ALTER PROCEDURE RESERV_STATISTIC_CANCELED$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(BUSY_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_PROFILE_AGENT INTEGER,
COUNTRY_CODE VARCHAR(20),
MARKET_SEGMENT_CODE VARCHAR(3),
SOURCE_CODE VARCHAR(3),
CHANNEL_CODE VARCHAR(3),
HEAR_REASON_CODE VARCHAR(3),
COME_REASON_CODE VARCHAR(3),
ROOMS_NOSHOW SMALLINT,
GUESTS_NOSHOW SMALLINT,
ROOMS_CANCELED SMALLINT)
 AS
begin
  -- {NOSHOW, CANCELED, USERERROR}
  for
    select P.OUT_DATE, RD.ID_ROOM_TYPE, S.ID_PROFILE_AGENT, coalesce(RD.COUNTRY, ''),
           S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE,
           count(distinct iif(RD.REASON_OF_ANUL = 'NOSHOW', RD.ID_ROOM, null)),
           sum(iif(RD.REASON_OF_ANUL = 'NOSHOW', RD.ADULT_COUNT + RD.CHILD_COUNT, 0)),
           count(distinct iif(RD.REASON_OF_ANUL = 'CANCELED', RD.ID_ROOM, null))
    from   RESERV_DETAIL RD
           left outer join RESERV_STATISTIC_SLICE$INT(RD.ID_RESERV_DETAIL) S on 0=0
           left outer join SYSTEM_LOOP_PERIOD(maxdate(:from_date, RD.FROM_DATE), mindate(:to_date, RD.TO_DATE-1)) P on 0=0
    where  RD.ID_HOTEL = :id_hotel
           and RD.FROM_DATE <= :to_date
           and RD.TO_DATE > :from_date
           and RD.IS_ANUL = 1
           and RD.REASON_OF_ANUL in ('NOSHOW', 'CANCELED')
    group by 1, 2, 3, 4, 5, 6, 7, 8, 9
    into   :busy_date, :id_room_type, :id_profile_agent, :country_code,
           :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
           :rooms_noshow,
           :guests_noshow,
           :rooms_canceled
  do begin
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_EATING_OBJECT$RSV for: RESGRP_SAVE_OTHER$INT */
ALTER PROCEDURE RES_SAVE_EATING_OBJECT$RSV(ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_OTHER$RSV for: RESGRP_SAVE_OTHER$INT */
ALTER PROCEDURE RES_SAVE_OTHER$RSV(ID_RESERV_DETAIL INTEGER,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_FIRSTFOOD_MODIFY$RSV for: RESGRP_SAVE_OTHER$INT */
ALTER PROCEDURE RESMULTI_FIRSTFOOD_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_TRANSFER_MODIFY$RSV for: RESGRP_SAVE_OTHER$INT */
ALTER PROCEDURE RESMULTI_TRANSFER_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* Alter (RESGRP_SAVE_OTHER$INT) */
ALTER PROCEDURE RESGRP_SAVE_OTHER$INT(RD_DBKEY CHAR(8),
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
ID_EATING_OBJECT TYPE OF ID_REF)
 AS
declare variable id_reserv_detail integer;
  declare variable g_dbkey char(8);
  declare variable old_code_first_food type of tfood_code;
  declare variable old_text_first_food varchar(50);
  declare variable text_first_food varchar(50);
  declare variable action_text varchar(255);
begin
  select RD.ID_RESERV_DETAIL, RD.CODE_FIRST_FOOD
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail, :old_code_first_food;

  update RESERV_DETAIL RD
  set    RD.HAS_DIFFERENT_OTHER = 0,
         RD.TRANSFER_IN_TIME = :transfer_in_time,
         RD.TRANSFER_IN_NOTE = :transfer_in_note,
         RD.TRANSFER_OUT_TIME = :transfer_out_time,
         RD.TRANSFER_OUT_NOTE = :transfer_out_note,
         RD.CODE_FIRST_FOOD = :code_first_food,
         rd.ID_EATING_OBJECT = :ID_EATING_OBJECT
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_code_first_food is distinct from :code_first_food) then begin
    old_text_first_food = cast(case
                              when :old_code_first_food = 'breakfast' then 'caption.breakfast'
                              when :old_code_first_food = 'lunch' then 'caption.launch'
                              when :old_code_first_food = 'dinner' then 'caption.dinner'
                              when :old_code_first_food = 'extrafood1' then 'caption.extrafood1'
                              when :old_code_first_food = 'extrafood2' then 'caption.extrafood2'
                              when :old_code_first_food = 'none' then 'caption.no_first_food'
                          end as varchar(50));
    text_first_food = cast(case
                              when :code_first_food = 'breakfast' then 'caption.breakfast'
                              when :code_first_food = 'lunch' then 'caption.launch'
                              when :code_first_food = 'dinner' then 'caption.dinner'
                              when :code_first_food = 'extrafood1' then 'caption.extrafood1'
                              when :code_first_food = 'extrafood2' then 'caption.extrafood2'
                              when :code_first_food = 'none' then 'caption.no_first_food'
                           end as varchar(50));
    action_text = f_character(29) || coalesce('@{' || :old_text_first_food || '}', '') ||
                  f_character(28) || coalesce('@{' || :text_first_food || '}', '');
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'FIRST_FOOD_CHANGED', :ACTION_TEXT);
  end

  for
    select G.RDB$DB_KEY
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey
  do begin
    execute procedure RES_GUEST_SAVE_OTHER$INT(:g_dbkey, :transfer_in_time, :transfer_in_note,
            :transfer_out_time, :transfer_out_note, :code_first_food);
  end
end
^

/* Alter (RESMULTI_FINALIZE$RSV) */
ALTER PROCEDURE RESMULTI_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER,
DISABLE_WARNING SMALLINT)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  if (:disable_warning = 1) then warn_code = 0;
end
^

/* Alter (RESMULTI_FIRSTFOOD_MODIFY$RSV) */
ALTER PROCEDURE RESMULTI_FIRSTFOOD_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE)
 AS
declare variable transfer_in_time time;
  declare variable transfer_in_note varchar(255);
  declare variable transfer_out_time time;
  declare variable transfer_out_note varchar(255);
  declare variable rd_dbkey char(8);
  declare variable id_eating_object type of id_ref;
begin
  select RD.RDB$DB_KEY, RD.TRANSFER_IN_TIME, RD.TRANSFER_IN_NOTE,
         RD.TRANSFER_OUT_TIME, RD.TRANSFER_OUT_NOTE, rd.ID_EATING_OBJECT
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :transfer_in_time, :transfer_in_note,
         :transfer_out_time, :transfer_out_note, :id_eating_object;

  execute procedure RESGRP_SAVE_OTHER$INT(:rd_dbkey, :transfer_in_time, :transfer_in_note,
          :transfer_out_time, :transfer_out_note, :code_first_food, :id_eating_object);
  --
end
^

/* Alter (RESMULTI_MARKETING_MODIFY$RSV) */
ALTER PROCEDURE RESMULTI_MARKETING_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  execute procedure RES_SAVE_MARKETING$RSV(:id_reserv_detail, :id_nom_market_segment, :id_nom_source_code,
                    :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
end
^

/* Alter (RESMULTI_RATE_MODIFY$RSV) */
ALTER PROCEDURE RESMULTI_RATE_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
ID_RATE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_SAVE_RATE$INT(:rd_dbkey, :id_rate);
end
^

/* Alter (RESMULTI_TRANSFER_MODIFY$RSV) */
ALTER PROCEDURE RESMULTI_TRANSFER_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30))
 AS
declare variable code_first_food tfood_code;
  declare variable rd_dbkey char(8);
  declare variable id_eating_object type of id_ref;
begin
  select RD.RDB$DB_KEY, RD.CODE_FIRST_FOOD, rd.ID_EATING_OBJECT 
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :code_first_food, :id_eating_object;

  execute procedure RESGRP_SAVE_OTHER$INT(:rd_dbkey, :transfer_in_time, :transfer_in_note,
          :transfer_out_time, :transfer_out_note, :code_first_food, :id_eating_object);
  --
end
^

/* Alter (RESMULTI_VOUCHER_MODIFY$RSV) */
ALTER PROCEDURE RESMULTI_VOUCHER_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
VOUCHER_NUM VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30))
 AS
declare variable voucher2_num varchar(30);
  declare variable voucher2_date date;
  declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY, RD.VAUCHER_NUM2, RD.VAUCHER_DATE2
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :voucher2_num, :voucher2_date;

  execute procedure RES_SAVE_VOUCHER$INT(:rd_dbkey, :voucher_num, :voucher_date, :voucher_text, :voucher2_num, :voucher2_date);
end
^

/* Alter (REVENUE_SUMMARY_REMAKE$SYS) */
ALTER PROCEDURE REVENUE_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
STATISTIC_ONLY SMALLINT)
 AS
declare variable id_end_work integer;
declare variable ad_dbkey char(8);
declare variable id_service integer;
declare variable id_guest integer;
declare variable id_account integer;
declare variable revenue_group varchar(50);
declare variable revenue_account varchar(50);
declare variable revenue_sub_account varchar(50);
begin
  if (not exists (select h.ID_HOTEL
                  from   HOTEL H
                  where  h.ID_HOTEL = :ID_HOTEL)) then exception WRONG_VALUE 'Non-existing hotel!';

  if (:STATISTIC_ONLY = 1) then begin

    execute procedure REVENUE_STATISTIC_REMAKE$SYS (:ID_HOTEL, :FROM_DATE, :TO_DATE);

    execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'REV_REGEN_PART',
                                      f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') ||
                                      f_character(28) || formatdate(:to_date, 'D;dd/mm/yyyy'));
  end else begin
    for
      select ad.RDB$DB_KEY, ad.ID_SERVICE, ad.ID_GUEST, ad.ID_ACCOUNT
      from   ACCOUNT_DEBT AD
      where  AD.ID_HOTEL = :id_hotel
             and ad.DEBT_DATE between :FROM_DATE and :TO_DATE
      order by ad.DEBT_DATE asc, ad.ID_ACCOUNT_POST asc
      into   :ad_dbkey, :id_service, :id_guest, :id_account
    do begin
      select  S.REVENUE_GROUP, RA.REVENUE_ACCOUNT, RA.REVENUE_SUB_ACCOUNT
      from    ACCOUNT A
              left outer join SERVICES S on s.ID_SERVICE = :id_service
              left outer join GUEST G on G.ID_GUEST = :id_guest
              left outer join PROFILE_HOUSE PH on PH.ID_PROFILE = A.ID_PROFILE
              left outer join REVENUE_ACCOUNT_PARSE$INT (S.REVENUE_ACCOUNT, coalesce(G.ID_RESERV_DETAIL, A.ID_RESERV_DETAIL)) RA on 1=1
      where   a.ID_ACCOUNT = :id_account
              and PH.HOUSE_TYPE is distinct from 'hptComplimentary'
      into    :revenue_group, :revenue_account, :revenue_sub_account;
  
      update ACCOUNT_DEBT d
      set    d.REVENUE_GROUP = :revenue_group,
             d.REVENUE_ACCOUNT = :revenue_account,
             d.REVENUE_SUB_ACCOUNT = :revenue_sub_account
             -- TODO - revenue deduction tax recalc ???
      where  d.RDB$DB_KEY = :ad_dbkey;
    end
  
  
    for
      select se.ID_END_WORK
      from   SUMMARY_END_WORK SE
      where  se.ID_HOTEL = :ID_HOTEL
             and se.SUMMARY_DATE between :FROM_DATE and :TO_DATE
      order by se.ID_END_WORK
      into   :id_end_work
    do begin
  
      update SUMMARY_END_WORK s
      set    s.REVENUE_AMOUNT = 0,
             s.CORRECTION_AMOUNT = 0,
             s.VAT_AMOUNT = 0
      where  s.ID_END_WORK = :id_end_work;
  
      execute procedure REVENUE_EW_SUMMARIZE$INT (:id_end_work, 'full');
    end

    execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'REV_REGEN_FULL',
                                      f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') || f_character(28) ||
                                      formatdate(:to_date, 'D;dd/mm/yyyy'));
  end
end
^

/* Alter (RIGHTS_GROUP_MODIFY) */
ALTER PROCEDURE RIGHTS_GROUP_MODIFY(ID_RIGHT_GROUP INTEGER,
GROUP_NAME VARCHAR(20),
GROUP_DESCRIPTION VARCHAR(100),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_RIGHT_GROUP INTEGER)
 AS
declare variable old_name varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation = 'add') then begin
    if ((:id_right_group is null) or (:id_right_group <= -1))  then
      new_id_right_group = gen_id(ID_RIGHT_GROUP_GEN, 1);
    else new_id_right_group = :id_right_group;

    insert into RIGHTS_GROUPS (ID_RIGHT_GROUP, GROUP_NAME, GROUP_DESCRIPTION)
    values (:new_id_right_group, :group_name , :group_description);
  end else if (:operation = 'mod') then begin
    select G.GROUP_NAME
    from   RIGHTS_GROUPS G
    where  G.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
    into   :old_name;

    update RIGHTS_GROUPS UG
    set    UG.GROUP_NAME  = :group_name,
           UG.GROUP_DESCRIPTION = :group_description
    where  UG.ID_RIGHT_GROUP = :id_right_group;

    if (:old_name <> :GROUP_NAME) then begin
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'GROUP_EDIT',
              f_character(29) || :old_name || f_character(28) || :GROUP_NAME);
    end
  end else if (:operation = 'del') then begin
    delete from RIGHTS_GROUPS
    where ID_RIGHT_GROUP = :id_right_group;
    delete from RIGHTS_USER_GROUPS
    where ID_RIGHT_GROUP = :id_right_group;
  end
end
^

/* Alter (RIGHTS_GROUP_REPORTS_MODIFY) */
ALTER PROCEDURE RIGHTS_GROUP_REPORTS_MODIFY(ID_RIGHT_GROUP INTEGER,
REPORT_NAME VARCHAR(200),
OPERATION VARCHAR(20))
 AS
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'grant, revoke');

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS rg
  where  rg.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'grant') then begin
    if (not exists (
      select *
      from   RIGHTS_GROUPS_REPORTS RGR
      where  RGR.ID_RIGHT_GROUP = :id_right_group
             and RGR.REPORT_NAME = :report_name)
    ) then begin
      insert into RIGHTS_GROUPS_REPORTS (ID_RIGHT_GROUP, REPORT_NAME)
      values (:id_right_group, :report_name);

      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'RIGHT_GRANT',
              f_character(29) || :REPORT_NAME || f_character(28) || :right_group);

    end
  end else if (:operation = 'revoke') then begin
    delete from RIGHTS_GROUPS_REPORTS RGR
    where  RGR.ID_RIGHT_GROUP = :id_right_group
           and  RGR.REPORT_NAME = :report_name;

    if (row_count = 1) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'RIGHT_REVOKE',
              f_character(29) || :REPORT_NAME || f_character(28) || :right_group);
  end
end
^

/* Alter (RIGHTS_GROUP_RIGHTS_MODIFY) */
ALTER PROCEDURE RIGHTS_GROUP_RIGHTS_MODIFY(ID_RIGHT_GROUP INTEGER,
RIGHT_CODE VARCHAR(30),
VALUE_CODE INTEGER,
OPERATION VARCHAR(20))
 AS
declare variable right_descr varchar(255);
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'grant, revoke');

  right_descr = '@{right.name.' || :right_code || '}';

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS RG
  where  RG.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'grant') then begin
    --if (:value_code <> 0) then exception WRONG_VALUE 'rightType is rtPlain but value_code <> 0';

    if (not exists (select *
                    from   RIGHTS_GROUPS_LINES RGL
                    where  RGL.ID_RIGHT_GROUP = :id_right_group
                           and RGL.RIGHT_CODE = :right_code)) then
    begin
      insert into RIGHTS_GROUPS_LINES (ID_RIGHT_GROUP, RIGHT_CODE)
      values (:id_right_group, :right_code);

      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'RIGHT_GRANT',
              f_character(29) || :right_descr || f_character(28) || :right_group);
    end

  end else if (:operation = 'revoke') then begin
    delete from RIGHTS_GROUPS_LINES RGL
    where  RGL.ID_RIGHT_GROUP = :id_right_group
           and RGL.RIGHT_CODE = :right_code;

    if (row_count > 0) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'RIGHT_REVOKE',
              f_character(29) || :right_descr || f_character(28) || :right_group);
  end
end
^

/* Alter (RIGHTS_GROUP_USER_MODIFY) */
ALTER PROCEDURE RIGHTS_GROUP_USER_MODIFY(USER_NAME VARCHAR(30),
ID_RIGHT_GROUP INTEGER,
OPERATION VARCHAR(50))
 AS
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add,del');

  if (:USER_NAME = 'SYSDBA') then exit;

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS RG
  where  RG.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'add') then begin
    update or insert into RIGHTS_USER_GROUPS (USER_NAME, ID_RIGHT_GROUP)
    values (:user_name, :id_right_group)
    matching (USER_NAME, ID_RIGHT_GROUP);

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_ADDED',
            f_character(29) || :USER_NAME  || f_character(28) || :right_group);

  end else begin
    delete from RIGHTS_USER_GROUPS
    where USER_NAME = :user_name
          and ID_RIGHT_GROUP = :id_right_group;

    if (row_count > 0) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_REMOVED',
              f_character(29) || :USER_NAME || f_character(28) || :right_group);

  end

  when sqlcode -803 do begin
    /* ERR_TEXT = '       ! ' ;*/
    exit;
  end
end
^

/* Alter (RIGHTS_REGRANT) */
ALTER PROCEDURE RIGHTS_REGRANT AS
declare variable relation_name char(31);
  declare variable ui_role_name char(31);
  declare variable ena_role_name char(31);
  declare variable auditor_role_name char(31);
begin
  ui_role_name = 'CLOCKBS_ROLE';
  ena_role_name = 'HTTPDBA_ROLE';
  auditor_role_name = 'AUDITOR_ROLE';

  /* PRIVILEGES GIVEN DIRECTLY TO SOME DB USER MUST BE PRESERVED.
  || AUTOGRANTS ARE MADE ONLY TO THE 'UI' and 'ENA' ROLES AND 'PUBLIC' USER.
  */
  delete from RDB$USER_PRIVILEGES UP
  where  (UP.RDB$USER_TYPE not in (8 /* user*/, 13 /* role */));

  delete from RDB$USER_PRIVILEGES UP
  where  (UP.RDB$USER = :ui_role_name)
         or (UP.RDB$USER = :ena_role_name)
         or (UP.RDB$USER = 'PUBLIC');

  /* THE 'UI' ROLE MUST HAVE ALL PRIVILIGES LIKE THE USER 'SYSDBA'.
  || ONLY NATIVE CLOCKBS APPLICATIONS ARE USING THIS ROLE.
  */
  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION,
         RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select :ui_role_name, 'SYSDBA', U.RDB$PRIVILEGE, 0,
         U.RDB$RELATION_NAME, U.RDB$FIELD_NAME, 13, U.RDB$OBJECT_TYPE
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = 'SYSDBA'
         and (not exists (select u2.RDB$PRIVILEGE
                          from   RDB$USER_PRIVILEGES u2
                          where  u2.RDB$USER = :ui_role_name
                                 and u2.RDB$PRIVILEGE = U.RDB$PRIVILEGE 
                                 and u2.RDB$RELATION_NAME = u.RDB$RELATION_NAME))
         and U.RDB$PRIVILEGE <> 'M' /* MEMBERSHIP */;

  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION,
         RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select :ena_role_name, 'SYSDBA', U.RDB$PRIVILEGE, 0,
         U.RDB$RELATION_NAME, U.RDB$FIELD_NAME, 13, U.RDB$OBJECT_TYPE
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = 'SYSDBA'
         and u.RDB$RELATION_NAME starting with 'ENA_'
         and (not exists (select u2.RDB$PRIVILEGE
                          from   RDB$USER_PRIVILEGES u2
                          where  u2.RDB$USER = :ena_role_name
                                 and u2.RDB$PRIVILEGE = U.RDB$PRIVILEGE 
                                 and u2.RDB$RELATION_NAME = u.RDB$RELATION_NAME))
         and U.RDB$PRIVILEGE in ('S') /* Select (and Reference ??) */;

  /* grant READ access to AUDITOR_ROLE  */
  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION, RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select :auditor_role_name , 'SYSDBA' , U.RDB$PRIVILEGE, 0 , U.RDB$RELATION_NAME, U.RDB$FIELD_NAME, 13, U.RDB$OBJECT_TYPE
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = :ui_role_name
         and not exists
           (select *
            from RDB$USER_PRIVILEGES U2
            where U2.RDB$USER = 'AUDITOR_ROLE'
                  and U2.RDB$PRIVILEGE = U.RDB$PRIVILEGE 
                  and U2.RDB$RELATION_NAME = U.RDB$RELATION_NAME);           

  delete
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = :auditor_role_name
         and u.RDB$PRIVILEGE in ('I', 'U', 'D')
         and u.RDB$RELATION_NAME like '%$PMS%';

  delete
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = :auditor_role_name
         and u.RDB$PRIVILEGE in ('I', 'U', 'D')
         and ( (u.RDB$RELATION_NAME starting with 'SUMMARY_')
              or (u.RDB$RELATION_NAME starting with 'RIGHTS_')
              or (u.RDB$RELATION_NAME starting with 'PROFILE_')
              or (u.RDB$RELATION_NAME starting with 'AGENT_')
              or (u.RDB$RELATION_NAME starting with 'RESOURCE_')
              or (u.RDB$RELATION_NAME starting with 'ACTIVITY_')
              or (u.RDB$RELATION_NAME starting with 'NOM_')
              or (u.RDB$RELATION_NAME starting with 'AR_')
              or (u.RDB$RELATION_NAME starting with 'HK_')
              or (u.RDB$RELATION_NAME starting with 'ALLOTMENT_')
              or (u.RDB$RELATION_NAME starting with 'SERVICE_')
              or (u.RDB$RELATION_NAME starting with 'TARIFA_')
              or (u.RDB$RELATION_NAME starting with 'TAR_BO_')
              or (u.RDB$RELATION_NAME starting with 'REPORT_')
              or (u.RDB$RELATION_NAME starting with 'CHANNEL')
              or (u.RDB$RELATION_NAME starting with 'TAR_UI_')
              or (u.RDB$RELATION_NAME starting with 'TAR_SIMPLE_')
              or (u.RDB$RELATION_NAME starting with 'DEVICE')
              or (u.RDB$RELATION_NAME starting with 'DOC_')
              or (u.RDB$RELATION_NAME starting with 'GUEST_')
              or (u.RDB$RELATION_NAME starting with 'SALE_')
              or (u.RDB$RELATION_NAME starting with 'WORKING_')
             ) ;
  delete
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = :auditor_role_name
         and u.RDB$PRIVILEGE in ('I', 'U', 'D')
         and u.RDB$RELATION_NAME in ('SERVICES', 'DOC_TYPE', 'DOC_TYPE_INV', 'DOC_TYPE_PAY', 'DOC_HEAD$INT',
             'PAYMENT_TYPE', 'CREDIT_CARD_TYPE', 'CURRS', 'CURR_RATES', 'PROFILE', 'AGENT',
             'ACCOUNT', 'ACCOUNT_POST_EXTERNAL',
             'ACC_TEMPLATE', 'CONTRAGENTS', 'HOTEL', 'SETTING_HOTEL_VALUE', 'GUARANTEE_POLICY',
             'RESOURCE$INT', 'RESOURCE_TYPE$INT', 'SAFE', 'SAFE_TYPE', 
             'ROOMS', 'ROOM_TYPES', 'ROOM_CLEAN_LOG',
             'TAX_POLICY',
             'TAR_HEAD', 'TRAIFA_GROUP', 'TAR_SIMPLE',
             'COUNTRY', 'KPPS', 'STAY_REASON', 'PASSPORT_TYPE', 'PHONE_LINE_CONVERT', 'LISTS_ITEMS',
             'RES_TEMPLATE', 'INFOMATIC_ACCOUNT', 'INFOMATIC_CHANNEL', 'ALLOTMENT',
             'PHONECALLS', 'BLOCK_ROOM', 'TASK', 'TASK_FILE', 'TASK_RESERVATION', 'TASK_RESPONSIBLE',
             'REPORT', 'PACKET_ITEM', 'BONUSPOINT_SCHEME', 'BONUSPOINT_SERVICE_GROUP',
             'EATING_OBJECT', 'END_WORKS', 'TASK');

  delete
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = :auditor_role_name
         and u.RDB$PRIVILEGE in ('X')
         and ((u.RDB$RELATION_NAME like '%$CFG%')
              or (u.RDB$RELATION_NAME like '%_MODIFY%')
              or (u.RDB$RELATION_NAME like '%$POST%')
              or (u.RDB$RELATION_NAME in ('RES_SET_STATUS$RSV', 'RES_SAVE_VOUCHER$RSV', 'RES_SAVE_OTHER$RSV',
                  'RES_SAVE_FINALIZE$RSV', 'RES_GUEST_ADD$RSV', 'RES_GUEST_DEL $RSV',
                  'RES_SAVE_NOTE$RSV', 'RESERV_DETAIL_EXTERNAL_MOD$RSV', 'RES_ANUL_DETAIL$RSV',
                  'RES_DELETE$RSV', 'POST_TELECOUNT_TRANSFER$TC', 'PROFILE_MERGE$PROFILE'))) ;
  /* GRANT REFERENCE RIGHT TO 'PUBLIC' FOR ALL TABLES THAT ARE REFERENCED WITH
  || FOREIGN KEYS.
  */
  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION,
         RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select distinct
         'PUBLIC', 'SYSDBA', 'R', 0, RC2.RDB$RELATION_NAME, null, 8, 0
  from   RDB$RELATION_CONSTRAINTS RC
         join RDB$REF_CONSTRAINTS C on C.RDB$CONSTRAINT_NAME = RC.RDB$CONSTRAINT_NAME
         join RDB$RELATION_CONSTRAINTS RC2 on RC2.RDB$CONSTRAINT_NAME = C.RDB$CONST_NAME_UQ
  where  RC.RDB$CONSTRAINT_TYPE = 'FOREIGN KEY';

  /* ALL EXTERNAL INTERFACES FROM OTHER VENDORS ARE NOT USING ROLES, SO
  || THEY WILL TAKE THE PRIVILEDGES OF THE 'PUBLIC' USER. THEY MUST HAVE
  || ACCESS ONLY TO THEIR SPECIFIC PROCEDURES OR OTHER METADATA OBJECTS WICH
  || MUST BE ENUMERATED HERE.
  */
  for
    select R.RDB$RELATION_NAME
    from   RDB$RELATIONS R
    where  (R.RDB$RELATION_NAME starting with 'EAI_')
           or (R.RDB$RELATION_NAME in ('SYSTEM_INFO_MODULE','PHONECALLS','SYSTEM_SESSION'))
           or (R.RDB$RELATION_NAME containing '$TMP')
           or (R.RDB$RELATION_NAME containing '_CACHE')
    union

    select R.RDB$PROCEDURE_NAME
    from   RDB$PROCEDURES R
    where  (R.RDB$PROCEDURE_NAME starting with 'EAI_')
           or (R.RDB$PROCEDURE_NAME in ('SYSTEM_INFO_GET', 'RDB$F_SP'))
    into   :relation_name
  do begin
    execute procedure RIGHTS_REGRANT_SUB('PUBLIC', :relation_name, 8);
  end
end
^

/* Alter (ROOM_CONTRACT_MODIFY$PMS) */
ALTER PROCEDURE ROOM_CONTRACT_MODIFY$PMS(ID_ROOM_CONTRACT INTEGER,
ID_ROOM_PERIOD INTEGER,
CONTRACT_TYPE VARCHAR(50),
PMS_MARKERS BLOB SUB_TYPE 1 SEGMENT SIZE 100,
IMPORT_INCOME_WITH_VAT SMALLINT,
ID_RENTAL_POOL INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_CONTRACT INTEGER)
 AS
declare variable permissible_value_list varchar(255);
  declare variable from_date date;
  declare variable rental_pool_unit_name varchar(100);
  declare variable room_name varchar(10);
  declare variable old_contract_type varchar(50);
  declare variable old_import_income_with_vat smallint;
  declare variable old_from_date date;
  declare variable old_rental_pool_unit_name varchar(100);
  declare variable old_room_name varchar(10);
  declare variable old_id_room_period integer;
  declare variable id_room integer;
  declare variable action_text varchar(255);
  declare variable no_use varchar(255);
begin

  permissible_value_list = '';
  select list(trim(S.KEY_))
  from   SYSTEM_ENUM S
  where  S.GROUP_ = 'pms.contract_type'
  into   :permissible_value_list;

  if (:operation in ('add', 'mod')) then begin
    execute procedure SYSTEM_CHECK_OPERATION(:contract_type, :permissible_value_list, 'contract type');

    select PRO.PROFILE_NAME
    from   PROFILE PRO
    where  PRO.ID_PROFILE = :ID_RENTAL_POOL
    into   :rental_pool_unit_name;

    select ROO.ROOM_NAME, RPP.FROM_DATE
    from   ROOM_PERIOD$PMS RPP
           join ROOMS ROO on ROO.ID_ROOM = RPP.ID_ROOM
    where  RPP.ID_ROOM_PERIOD = :ID_ROOM_PERIOD
    into   :room_name, :from_date;
  end

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  NEW_ID_ROOM_CONTRACT = :id_room_contract;

  if (:operation = 'add') then begin
    if (coalesce(:ID_ROOM_CONTRACT, -1) < 0) then begin
      NEW_ID_ROOM_CONTRACT = gen_id(GEN_ROOM_CONTRACT$PMS_ID, 1);
      ID_ROOM_CONTRACT = :NEW_ID_ROOM_CONTRACT;
    end
    else
      NEW_ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT;

    insert into ROOM_CONTRACT$PMS (ID_ROOM_CONTRACT, ID_ROOM_PERIOD,
           CONTRACT_TYPE, PMS_MARKERS, IMPORT_INCOME_WITH_VAT, ID_RENTAL_POOL)
    values (:NEW_ID_ROOM_CONTRACT, :ID_ROOM_PERIOD,
           :CONTRACT_TYPE, :PMS_MARKERS, :IMPORT_INCOME_WITH_VAT, :ID_RENTAL_POOL);

    action_text = substring(f_character(29) || '@{pms.contract_type.' || :contract_type || '}' || f_character(28) ||
                  formatdate(:from_date, 'D;dd.mm.yyyy') ||
                  f_character(28) || :room_name || f_character(28) || coalesce(:rental_pool_unit_name, ' ') || f_character(28)
                  || coalesce(:import_income_with_vat, 0) from 1 for 255);
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_ADDED', :ACTION_TEXT);

  end else begin
    select RC.CONTRACT_TYPE, RC.IMPORT_INCOME_WITH_VAT,
           RO.ROOM_NAME, PR.PROFILE_NAME, RP.FROM_DATE, RC.ID_ROOM_PERIOD, RP.ID_ROOM
    from   ROOM_CONTRACT$PMS RC
           join ROOM_PERIOD$PMS RP on RP.ID_ROOM_PERIOD = RC.ID_ROOM_PERIOD
           join ROOMS RO on RO.ID_ROOM = RP.ID_ROOM
           left outer join PROFILE PR on PR.ID_PROFILE = RC.ID_RENTAL_POOL
    where  RC.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
    into   :old_contract_type, :old_import_income_with_vat,
           :old_room_name, :old_rental_pool_unit_name, :old_from_date, :old_id_room_period, :id_room;

    if (:operation = 'mod') then begin
      update ROOM_CONTRACT$PMS
      set    CONTRACT_TYPE = :CONTRACT_TYPE,
             PMS_MARKERS = :PMS_MARKERS,
             IMPORT_INCOME_WITH_VAT = :IMPORT_INCOME_WITH_VAT,
             ID_RENTAL_POOL = :ID_RENTAL_POOL
      where (ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT);

      if ((:contract_type <> :old_contract_type) or (:import_income_with_vat <> :old_import_income_with_vat) or
         (coalesce(:rental_pool_unit_name, ' ') <> coalesce(:old_rental_pool_unit_name, ' ')) or
         (:from_date <> :old_from_date) or (:room_name <> :old_room_name)) then begin
        action_text = substring(f_character(29) || '@{pms.contract_type.' || :old_contract_type || '}' || f_character(28) ||
                      formatdate(:old_from_date, 'D;dd.mm.yyyy') ||
                      f_character(28) || :old_room_name ||
                      f_character(28) || coalesce(:old_rental_pool_unit_name, ' ') || f_character(28) || coalesce(:old_import_income_with_vat, 0) ||
                      f_character(28) || '@{pms.contract_type.' || :contract_type || '}' || f_character(28) || formatdate(:from_date, 'D;dd.mm.yyyy') ||
                      f_character(28) || :room_name || f_character(28) || coalesce(:rental_pool_unit_name, ' ') || f_character(28)
                      || coalesce(:import_income_with_vat, 0) from 1 for 255);
        execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_CHANGED', :ACTION_TEXT);
      end

    end

    if (:operation = 'del') then begin
      action_text = substring(f_character(29) || '@{pms.contract_type.' || :old_contract_type || '}' || f_character(28) ||
                    formatdate(:old_from_date, 'D;dd.mm.yyyy') ||
                    f_character(28) || :old_room_name || f_character(28) || coalesce(:old_rental_pool_unit_name, ' ') || f_character(28)
                    || coalesce(:old_import_income_with_vat, 0) from 1 for 255);
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_REMOVED', :ACTION_TEXT);

      delete from ROOM_CONTRACT$PMS where (ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT);

      execute procedure ROOM_PERIOD_MODIFY$PMS (:OLD_ID_ROOM_PERIOD, :id_room,  :old_from_date,
              iif(:contract_type in ('PRIVATE_USE'), 'PRIVATE', 'CONTRACT'),  'del')
      returning_values :no_use;
    end
  end
end
^

/* Alter (ROOM_MODIFY$PMS) */
ALTER PROCEDURE ROOM_MODIFY$PMS(ID_ROOM INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
BEDS INTEGER,
EXTRA_BEDS INTEGER,
SECTOR INTEGER,
SORT_ORDER INTEGER,
FEATURES BLOB SUB_TYPE 1 SEGMENT SIZE 100,
EXTERNAL_NAME VARCHAR(20),
ID_EATING_OBJECT TYPE OF ID_REF,
OPERATION VARCHAR(20),
ACCOMODATION_PLACE_UIN TYPE OF TDESCRIPTION_LONG = null)
 RETURNS(OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255),
NEW_ID_ROOM INTEGER)
 AS
declare variable old_id_room_type integer;
  declare variable old_room_name varchar(10);
  declare variable rebuild_id_hotel integer;
  declare variable rebuild_id_room_type integer;
  declare variable no_use varchar(20);
  declare variable old_capacity integer;
  declare variable sys_date date;
  declare variable action_text varchar(255);
  declare variable old_floor integer;
  declare variable old_sector integer;
  declare variable old_extra_beds integer;
  declare variable id_hotel integer;
begin
  overrule_need = 0;
  overrule_context = '';
  new_id_room = null;
  --if OVERRULE_NEED = 1 then OVERRULE_CONTEXT = ERR_TEXT like ERR_CODE = -9
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    if (coalesce(:room_name, '') = '') then
      exception ASSERT '-119';

    if ((:room_name containing '<') or (:room_name containing '>') or (:room_name starting with 'i')) then
      exception ASSERT '-120';
  end

  room_name = upper(:room_name);

  if (:operation='mod') then begin
    select R.ROOM_NAME, R.ID_ROOM_TYPE, R.BEDS+R.EXTRA_BEDS, r.floor, r.sector, r.extra_beds
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :id_room
    into   :old_room_name, :old_id_room_type, :old_capacity, :old_floor, :old_sector, :old_extra_beds;

    if (:id_room_type <> :old_id_room_type) then begin
      exception OCCUPANCY_EXCEPTION '-65';
    end

    new_id_room = :id_room;
    execute procedure ROOM_CAPACITY_CHECK$INT(:NEW_ID_ROOM, :ROOM_NAME, :old_capacity, :BEDS + :EXTRA_BEDS)
    returning_values (:OVERRULE_NEED, :OVERRULE_CONTEXT);

    update ROOMS RU
    set    RU.ID_ROOM_TYPE = :id_room_type,
           RU.ROOM_NAME = :room_name,
           RU.FLOOR = :floor,
           RU.BEDS = :beds,
           RU.EXTRA_BEDS = :extra_beds,
           RU.SECTOR = :sector,
           RU.FEATURES = :features,
           RU.SORT_ORDER = :sort_order,
           RU.EXTERNAL_NAME = :external_name,
           RU.ID_EATING_OBJECT = :ID_EATING_OBJECT,
           ru.ACCOMODATION_PLACE_UIN = :ACCOMODATION_PLACE_UIN
    where  RU.ID_ROOM = :id_room;

    if ((:room_name <> :old_room_name)
        or (:floor <> :old_floor)
        or (:sector <> :old_sector)
        or (:extra_beds <> :old_extra_beds)) then
    begin
      action_text = f_character(29) || '(' || :old_room_name || '/' || :old_floor || '/' || :old_sector || '/'
                    || :old_extra_beds || ')' || f_character(28) || '(' || :room_name || '/' || :floor || '/'
                    || :sector || '/' || :extra_beds || ')';
      execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_PARAMS_CHANGED', :action_text);
    end

    if (:room_name <> :old_room_name) then begin
      update ACCOUNT_POST AP
      set    AP.ROOM_NAME = :room_name
      where  AP.ROOM_NAME = :old_room_name
             and ap.ID_ROOM = :ID_ROOM
             and ap.ac = '00';
    end

  end else if (:operation = 'add') then begin
    select rt.ID_HOTEL
    from   ROOM_TYPES RT
    where  rt.ID_ROOM_TYPE = :ID_ROOM_TYPE
    into   :id_hotel;

    insert into ROOMS (
      ID_ROOM, ID_ROOM_TYPE, ROOM_NAME, FLOOR, BEDS, EXTRA_BEDS, SECTOR,
      FEATURES, SORT_ORDER, ID_HOTEL, EXTERNAL_NAME, ID_EATING_OBJECT, ACCOMODATION_PLACE_UIN)
    values (gen_id(ID_ROOM_GEN, 1), :id_room_type, :room_name, :floor, :beds, :extra_beds, :sector,
      :features, :sort_order, :id_hotel, :external_name, :ID_EATING_OBJECT, :ACCOMODATION_PLACE_UIN)
    returning ID_ROOM into :NEW_ID_ROOM;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :sys_date;

    execute procedure ROOM_PERIOD_MODIFY$PMS(null, :new_id_room, :sys_date, 'HOTEL', 'add')
    returning_values  :no_use;

    insert into ROOMS_ADD (ID_ROOM, PMS_MARKERS, ADDRESS)
    values (:new_id_room, null, null);
  end else if (:operation = 'del') then begin
    -- Booked rooms are preserved with FK constraint on room_magic
    execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'DELETE', '');

    select RT.ID_ROOM_TYPE, RT.ID_HOTEL
    from   ROOM_TYPES RT
    where  RT.ID_ROOM_TYPE = :id_room_type
    into   :rebuild_id_room_type, :rebuild_id_hotel;

    delete from ROOMS where ID_ROOM = :id_room;

    execute procedure ALLOTMENT_PHYS_REBUILD$INT(:rebuild_id_hotel, :rebuild_id_room_type);

    when sqlcode -530 do begin
      -- Violation of FOREIGN KEY constraint "%s" on table "%s"
      exception ASSERT '-34';
    end
  end
end
^

/* Alter (ROOM_OWNER_MODIFY$PMS) */
ALTER PROCEDURE ROOM_OWNER_MODIFY$PMS(ID_ROOM_OWNER INTEGER,
ID_ROOM_CONTRACT INTEGER,
ID_OWNER INTEGER,
OWNERSHIP_PERCENT NUMERIC(15,4),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_OWNER INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_hotel integer;
  declare variable id_acc_template_pms integer;
  declare variable id_currency varchar(3);
  declare variable owner_name varchar(100);
  declare variable old_owner_name varchar(100);
  declare variable old_ownership_percent NUMERIC(15,4);
  declare variable old_id_room_contract integer;
  declare variable action_text varchar(255);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  new_id_room_owner = :id_room_owner;

  if ( (:operation in ('add', 'mod')) and (not exists ( select * from OWNER$PMS P where P.ID_OWNER = :ID_OWNER ) )) then begin
    exception PMS_EXCEPTION '-610';
    exit;
  end

  select RT.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS RP on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
         join ROOMS R on RP.ID_ROOM = R.ID_ROOM
         join ROOM_TYPES RT on R.ID_ROOM_TYPE = RT.ID_ROOM_TYPE
  where  RC.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
  into   :id_hotel;

  if (:operation not in ('add')) then begin
    select coalesce(PR.PROFILE_NAME, ' '), RO.OWNERSHIP_PERCENT, RO.ID_ROOM_CONTRACT
    from ROOM_OWNER$PMS RO
      left outer join PROFILE PR ON PR.ID_PROFILE = RO.ID_OWNER
    where RO.ID_ROOM_OWNER = :ID_ROOM_OWNER
    into :old_owner_name, :old_ownership_percent, :old_id_room_contract;
  end

  select PRO.PROFILE_NAME
  from PROFILE PRO
    where PRO.ID_PROFILE = :ID_OWNER
  into :owner_name;

  if (:operation in ('add', 'mod')) then begin
    if (coalesce(:OWNERSHIP_PERCENT, 0) <= 0) then begin
      exception PMS_EXCEPTION '-611';
      exit;
    end
  end

  if (:operation = 'add') then begin
    if (coalesce(:ID_ROOM_OWNER, -1) < 0) then
         NEW_ID_ROOM_OWNER = gen_id(GEN_ROOM_OWNER$PMS_ID, 1);
    else NEW_ID_ROOM_OWNER = :ID_ROOM_OWNER;

    insert into ROOM_OWNER$PMS (ID_ROOM_OWNER, ID_ROOM_CONTRACT, ID_OWNER, OWNERSHIP_PERCENT)
    values (:NEW_ID_ROOM_OWNER, :ID_ROOM_CONTRACT, :ID_OWNER, :OWNERSHIP_PERCENT);

    action_text = f_character(29) || :owner_name || f_character(28) || formatfloat(:ownership_percent, '0.00');
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_OWNER_ADDED', :ACTION_TEXT);

    if (not exists ( select *
                     from   ACCOUNT A
                     where  A.IS_PMS_ACCOUNT = 1
                            and A.ID_HOTEL = :id_hotel
                            and A.ID_PROFILE = :ID_OWNER ))
    then begin
      select O.ID_ACC_TEMPLATE_PMS, O.ID_CURRENCY
      from   OWNER$PMS O
      where  O.ID_OWNER = :ID_OWNER
      into   :id_acc_template_pms, :id_currency;

      execute procedure ACCOUNT_CREATE_PMS$PMS(:ID_OWNER, :ID_ACC_TEMPLATE_PMS,
              :ID_CURRENCY, :ID_HOTEL)
      returning_values (:dbg);
    end

    when sqlcode -803 do begin
      exception PMS_EXCEPTION '-1057';
      exit;
    end

  end else if (:operation = 'mod') then begin
    if (not exists ( select *
                     from   ROOM_OWNER$PMS R
                     where  R.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
                            and R.ID_OWNER = :ID_OWNER ))
    then begin /* smenen e sobstwenik */
      if (not exists ( select *
                       from   ACCOUNT A
                       where  A.IS_PMS_ACCOUNT = 1
                              and A.ID_HOTEL = :id_hotel
                              and A.ID_PROFILE = :ID_OWNER ))
      then begin
        select O.ID_ACC_TEMPLATE_PMS, O.ID_CURRENCY
        from   OWNER$PMS O
        where  O.ID_OWNER = :ID_OWNER
        into   :id_acc_template_pms, :id_currency;
  
        execute procedure ACCOUNT_CREATE_PMS$PMS(:ID_OWNER, :ID_ACC_TEMPLATE_PMS,
                :ID_CURRENCY, :ID_HOTEL)
        returning_values (:dbg);
      end
    end

    update ROOM_OWNER$PMS
    set ID_OWNER = :ID_OWNER,
        OWNERSHIP_PERCENT = :OWNERSHIP_PERCENT
    where (ID_ROOM_OWNER = :ID_ROOM_OWNER);

    if ((:old_owner_name <> :owner_name) or (:old_ownership_percent <> :ownership_percent)) then begin
      action_text = f_character(29) || :old_owner_name || f_character(28) || formatfloat(:old_ownership_percent, '0.00') ||
                    f_character(28) || :owner_name || f_character(28) || formatfloat(:ownership_percent, '0.00');
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_OWNER_CHANGED', :ACTION_TEXT);
    end
  end else if (:operation = 'del') then begin
    action_text = f_character(29) || :old_owner_name || f_character(28) || formatfloat(:old_ownership_percent, '0.00');
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :OLD_ID_ROOM_CONTRACT, 'ROOM_OWNER_REMOVED', :ACTION_TEXT);

    delete from ROOM_OWNER$PMS
    where (ID_ROOM_OWNER = :ID_ROOM_OWNER);
  end
end
^

/* empty dependent procedure body */
/* Clear: ROOM_PERIOD_MODIFY$PMS for: ROOM_PERIOD_ADD$INT */
ALTER PROCEDURE ROOM_PERIOD_MODIFY$PMS(ID_ROOM_PERIOD INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
STATUS VARCHAR(30),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_PERIOD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ROOM_PERIOD_ADD$INT) */
ALTER PROCEDURE ROOM_PERIOD_ADD$INT(ID_ROOM_PERIOD INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
STATUS VARCHAR(30))
 RETURNS(NEW_ID_ROOM_PERIOD INTEGER)
 AS
declare variable action_text varchar(255);
  declare variable to_date date;
  declare variable prev_period_status varchar(30);
begin
  new_id_room_period = :id_room_period;

  if (exists (select *
              from   ROOM_PERIOD$PMS R
              where  R.ID_ROOM = :ID_ROOM
                     and R.FROM_DATE = :FROM_DATE)) then exception PMS_EXCEPTION '-612';

  if (coalesce(:id_room_period, 0) <= 0) then new_id_room_period = gen_id(GEN_ROOM_PERIOD$PMS_ID,1);
  else new_id_room_period = :id_room_period;

  select first 1 rpm.status, rpm.TO_DATE
  from   ROOM_PERIOD$PMS rpm
  where  rpm.id_room = :id_room
         and rpm.from_date < :from_date
  order by rpm.from_date desc
  into   :prev_period_status, :to_date;

  execute procedure ROOM_STATUS_CHECK$INT (:ID_ROOM, :FROM_DATE, :to_date, :prev_period_status, :status);

  insert into ROOM_PERIOD$PMS (ID_ROOM_PERIOD, ID_ROOM, FROM_DATE, STATUS)
  values (:new_id_room_period, :id_room, :from_date, :status);

  execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

  action_text = f_character(29) || '@{period_room_status.'||:status||'}' || f_character(28) || formatdate(:from_date, 'dd.mm.yyyy')
                || f_character(28) || iif(extract(year from :to_date) = 2500, '~', formatdate(:to_date, 'dd.mm.yyyy'));
  execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_STATUS_ADDED', :action_text);

end
^

/* Alter (ROOM_PERIOD_DEL$INT) */
ALTER PROCEDURE ROOM_PERIOD_DEL$INT(ID_ROOM_PERIOD INTEGER)
 AS
declare variable id_room integer;
  declare variable status varchar(30);
  declare variable from_date date;
  declare variable id_account_post integer;
  declare variable id_pms_event integer;
  declare variable action_text varchar(255);
  declare variable to_date date;
  declare variable prev_period_status varchar(30);
begin
  select R.STATUS, R.FROM_DATE, R.ID_ROOM, R.TO_DATE
  from   ROOM_PERIOD$PMS R
  where  R.ID_ROOM_PERIOD = :id_room_period
  into   :status, :from_date, :id_room, :to_date;

  if (singular (select *
                from   ROOM_PERIOD$PMS R
                where  R.ID_ROOM = :id_room)) then exception PMS_EXCEPTION '-622';

  select first 1 rpm.status
  from   ROOM_PERIOD$PMS rpm
  where  rpm.id_room = :id_room
         and rpm.from_date < :from_date
  order by rpm.from_date desc
  into   :prev_period_status;

  execute procedure ROOM_STATUS_CHECK$INT (:ID_ROOM, :from_date, :to_date, :status, :prev_period_status);

  for
    select AP1.ID_ACCOUNT_POST, AP1.ID_PMS_EVENT
    from   ACCOUNT_POST$PMS AP1
           join ACCOUNT$PMS A1 on A1.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS
           join PMS_EVENT$PMS E1 on E1.ID_PMS_EVENT = AP1.ID_PMS_EVENT
    where  AP1.DATE_POST between :from_date and :to_date
           and E1.ID_ROOM = :id_room
           and A1.IS_SHADOW = 1
           and AP1.LINE_STATUS = 11 /*  anulirat se samo aktiwnite nachisleniq. Ako ima dokumentirani?! ili anulirani, ne se pipat  */
    into   :id_account_post, :id_pms_event
  do begin
    execute procedure ACCOUNT_POST_PMS_ANUL$INT(:id_pms_event, :id_account_post);
  end

  delete from ROOM_PERIOD$PMS
  where  ID_ROOM_PERIOD = :id_room_period;

  execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

  action_text = f_character(29) || '@{period_room_status.'||:status||'}'
              || f_character(28) || iif(extract(year from :from_date) = 2500, '~', formatdate(:from_date, 'dd.mm.yyyy'))
              || f_character(28) || iif(extract(year from :to_date) = 2500, '~', formatdate(:to_date, 'dd.mm.yyyy'))
              || f_character(28) || '@{period_room_status.'||:prev_period_status||'}' ;
  execute procedure SYSTEM_LOG_ADD ('ROOM', :id_room, 'ROOM_STATUS_DELETED', :action_text);
end
^

/* Alter (ROOM_PERIOD_MODIFY$INT) */
ALTER PROCEDURE ROOM_PERIOD_MODIFY$INT(ID_ROOM_PERIOD INTEGER,
FROM_DATE DATE,
STATUS VARCHAR(30))
 AS
declare variable id_room integer;
  declare variable old_status varchar(30);
  declare variable old_from_date date;
  declare variable id_account_post integer;
  declare variable id_pms_event integer;
  declare variable action_text varchar(255);
  declare variable to_date date;
  declare variable prev_period_status varchar(30);
  declare variable old_id_room_contract integer;
begin
  select R.STATUS, R.FROM_DATE, r.TO_DATE, r.ID_ROOM
  from   ROOM_PERIOD$PMS R
  where  R.ID_ROOM_PERIOD = :id_room_period
  into   :old_status, :old_from_date, :to_date, :id_room;

  select first 1 rpm.status
  from   ROOM_PERIOD$PMS rpm
  where  rpm.id_room = :id_room
         and rpm.from_date < :old_from_date
  order by rpm.from_date desc
  into   :prev_period_status;

  if (:STATUS <> :old_status) then begin
    execute procedure ROOM_STATUS_CHECK$INT (:ID_ROOM, :from_date, :to_date, :old_status, :STATUS);
  end

  if (:old_from_date < :FROM_DATE) then begin
    execute procedure ROOM_STATUS_CHECK$INT (:ID_ROOM, :old_from_date, :from_date, :old_status, :prev_period_status);
  end else if (:old_from_date > :FROM_DATE) then begin
    execute procedure ROOM_STATUS_CHECK$INT (:ID_ROOM, :from_date, :old_from_date, :prev_period_status, :STATUS);
  end

  if ((:old_from_date <> :FROM_DATE) or (:STATUS <> :old_status)) then begin
    for
      select AP1.ID_ACCOUNT_POST, AP1.ID_PMS_EVENT
      from   ACCOUNT_POST$PMS AP1
             join ACCOUNT$PMS A1 on A1.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS
             join PMS_EVENT$PMS E1 on E1.ID_PMS_EVENT = AP1.ID_PMS_EVENT
      where  AP1.DATE_POST between :old_from_date and :to_date
             and E1.ID_ROOM = :id_room
             and A1.IS_SHADOW = 1
             and AP1.LINE_STATUS = 11 /*  anulirat se samo aktiwnite nachisleniq. Ako ima dokumentirani?! ili anulirani, ne se pipat  */
      into   :id_account_post, :id_pms_event
    do begin
      execute procedure ACCOUNT_POST_PMS_ANUL$INT(:id_pms_event, :id_account_post);
    end
  end
  
  update ROOM_PERIOD$PMS p
  set    p.FROM_DATE = :from_date,
         p.STATUS = :status
  where  p.ID_ROOM_PERIOD = :id_room_period;

  execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

  action_text = f_character(29) || '@{period_room_status.'||:old_status||'}'
                || f_character(28) || iif(extract(year from :old_from_date) = 2500, '~', formatdate(:old_from_date, 'dd.mm.yyyy'))
                || f_character(28) || iif(extract(year from :to_date) = 2500, '~', formatdate(:to_date, 'dd.mm.yyyy'))
                || f_character(28) || '@{period_room_status.'||:status||'}'
                || f_character(28) || iif(extract(year from :from_date) = 2500, '~', formatdate(:from_date, 'dd.mm.yyyy'))
                || f_character(28) || iif(extract(year from :to_date) = 2500, '~', formatdate(:to_date, 'dd.mm.yyyy'));

  execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_STATUS_CHANGED', :action_text);

  if((:status in ('PRIVATE', 'CONTRACT')) and (:from_date <> :old_from_date)) then begin
    select first 1 rcp.id_room_contract
    from   ROOM_CONTRACT$PMS rcp
    where  rcp.id_room_period = :id_room_period
    into   :old_id_room_contract;

    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :OLD_ID_ROOM_CONTRACT, 'ROOM_STATUS_CHANGED', :action_text);
  end

end
^

/* Alter (ROOM_PERIOD_MODIFY$PMS) */
ALTER PROCEDURE ROOM_PERIOD_MODIFY$PMS(ID_ROOM_PERIOD INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
STATUS VARCHAR(30),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_PERIOD INTEGER)
 AS
declare variable id_hotel integer;
  declare variable old_status varchar(30);
  declare variable old_from_date date;
  declare variable id_room_type integer;
  declare variable to_date date;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  execute procedure SYSTEM_CHECK_OPERATION(:status, 'HOTEL, PRIVATE, CONTRACT, INACTIVE', 'Status');

  if (:operation = 'add') then begin
     execute procedure ROOM_PERIOD_ADD$INT (:ID_ROOM_PERIOD, :ID_ROOM, :FROM_DATE, :STATUS)
     returning_values (:NEW_ID_ROOM_PERIOD);

  end else if (:operation = 'mod') then begin
    if (exists (select *
                from   ROOM_PERIOD$PMS R
                where  R.ID_ROOM = :ID_ROOM
                       and R.FROM_DATE = :FROM_DATE
                       and r.ID_ROOM_PERIOD <> :ID_ROOM_PERIOD)) then exception PMS_EXCEPTION '-612';
  
    select R.STATUS, R.FROM_DATE, r.TO_DATE
    from   ROOM_PERIOD$PMS R
    where  R.ID_ROOM_PERIOD = :id_room_period
    into   :old_status, :old_from_date, :to_date;

    if ((:FROM_DATE > :to_date)
        or exists (select pp.ID_ROOM_PERIOD
                   from   ROOM_PERIOD$PMS pp
                   where  pp.ID_ROOM = :id_room
                          and pp.FROM_DATE < :old_from_date
                          and pp.FROM_DATE > :FROM_DATE) ) then
    begin
      -- spring over neighbour period (from date)
      execute procedure ROOM_PERIOD_DEL$INT (:ID_ROOM_PERIOD);

      execute procedure ROOM_PERIOD_ADD$INT (:ID_ROOM_PERIOD, :ID_ROOM, :FROM_DATE, :STATUS)
      returning_values (:NEW_ID_ROOM_PERIOD);
    end else if ((:old_status <> :status) or (:old_from_date <> :from_date)) then begin
      execute procedure ROOM_PERIOD_MODIFY$INT (:ID_ROOM_PERIOD, :FROM_DATE, :STATUS);
      NEW_ID_ROOM_PERIOD = :ID_ROOM_PERIOD;
    end

  end else if (:operation = 'del') then begin
    execute procedure ROOM_PERIOD_DEL$INT (:ID_ROOM_PERIOD);
    NEW_ID_ROOM_PERIOD = null;

  end

  /* rebuild physical allotment */
  if ( (:operation in ('add', 'del'))
       or
       ((:operation = 'mod') and ((:old_status <> :status) or (:old_from_date <> :from_date)))) then
  begin
    select RT.ID_HOTEL, R.ID_ROOM_TYPE
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :id_room
    into   :id_hotel, :id_room_type;

    execute procedure ALLOTMENT_PHYS_REBUILD$INT(:id_hotel, :id_room_type);
  end

end
^

/* Alter (ROOM_SMART_LIST$RSV) */
ALTER PROCEDURE ROOM_SMART_LIST$RSV(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(50))
 RETURNS(ROOM_NAME VARCHAR(50),
FREE_BEDS_BASE INTEGER,
FREE_BEDS_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
FEATURES BLOB,
BUSY_GROUP_TYPE INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
DATA1 VARCHAR(255),
DATA2 VARCHAR(255))
 AS
declare variable report_leaving varchar(20);
declare variable suppress_private integer;
begin
  if (:from_date >= :to_date) then exit;
  execute procedure SYSTEM_CHECK_OPERATION(:report_type, 'FREE_ONLY,FREE_AND_LEAVING,BLOCKED,POTENTIAL_SHARE,PRIVATE_USE,ALL');

  suppress_private = iif(:REPORT_TYPE = 'ALL', 0, 1);
  if (:report_type in ('FREE_ONLY','FREE_AND_LEAVING')) then begin
    if (:report_type = 'FREE_AND_LEAVING') then report_leaving = 'AS_FREE';
    else report_leaving = 'AS_LEAVING';
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DBEFORE, SRLF.DAFTER, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_FREE$INT(:from_date, :to_date, :report_leaving, :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end else if (:report_type in ('BLOCKED','POTENTIAL_SHARE')) then begin
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DESCRIPTION, SRLF.PERIOD, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_SHARE$INT(:from_date, :to_date, :report_type, :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end else if (:report_type in ('ALL')) then begin
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DBEFORE, SRLF.DAFTER, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_FREE$INT(:from_date, :to_date, 'FREE_AND_LEAVING', :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;

    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DESCRIPTION, SRLF.PERIOD, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_SHARE$INT(:from_date, :to_date, 'POTENTIAL_SHARE', :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end
end
^

/* Alter (SAFE_CHECK_OUT) */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE TYPE OF ID)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
WARN_CODE TYPE OF ID_REF)
 AS
declare variable to_dt timestamp;
  declare variable is_occupied integer;
  declare variable expire_tollerance integer;
  declare variable occupant_name varchar(100);
  declare variable id_resource_reservation integer;
  declare variable check_out_datetime timestamp;
begin
  DOC_SELECTED = null;
  select s.IS_OCCUPIED, od.TO_DATETIME,
         st.EXPIRE_TOLLERANCE, rr.OCCUPANT_NAME, rr.ID_RESOURCE_RESERVATION
  from   SAFE s
         join RESOURCE$INT r on r.ID_RESOURCE = s.ID_SAFE
         join SAFE_TYPES st on st.ID_SAFE_TYPE = r.ID_RESOURCE_TYPE
         join RESOURCE_RESERVATION rr on rr.ID_RESOURCE_RESERVATION = s.ID_CURRENT_OCCUPANCY
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join RESOURCE_OCCUPANCY ro on ro.ID_RESOURCE_OCCUPANCY_DATA = od.ID_RESOURCE_OCCUPANCY_DATA
  where  s.ID_SAFE = :ID_SAFE
  into   :is_occupied, :to_dt, :expire_tollerance, :occupant_name, :id_resource_reservation;

  if (:is_occupied = 0) then exit;

  expire_tollerance = coalesce(:expire_tollerance, 0);
  check_out_datetime = current_timestamp;

  execute procedure SAFE_OCCUPANCY_MODIFY (:id_safe, current_timestamp, :occupant_name)
  returning_values  :DOC_SELECTED;

  if (:check_out_datetime > (:to_dt + cast(:expire_tollerance as double precision) / 60 / 24)) then begin
    execute procedure SYSTEM_WARNING_ADD (-1066, f_character(29) || :expire_tollerance || f_character(28) || formatdate(:to_dt + cast(:expire_tollerance as double precision) / 60 / 24, 'D;dd/mm/yyyy HH:MM'))
    returning_values (:WARN_CODE);
  end

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = null
  where  s.ID_SAFE = :ID_SAFE;

  update RESOURCE_RESERVATION rr
  set    rr.STATUS = 'CHECKED_OUT'
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_CHECKED_OUT', :occupant_name);
end
^

/* Alter (SAFE_OCCUPANCY_ANNUL) */
ALTER PROCEDURE SAFE_OCCUPANCY_ANNUL(ID_SAFE TYPE OF ID,
REASON TYPE OF TREASON)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_resource_reservation integer;
  declare variable from_datetime timestamp;
  declare variable to_datetime timestamp;
  declare variable action_text varchar(255);
  declare variable id_account_post integer;
begin
  select s.ID_CURRENT_OCCUPANCY, od.FROM_DATETIME, od.TO_DATETIME, rp.ID_ACCOUNNT_POST
  from   SAFE S
         join RESOURCE_RESERVATION rr on rr.ID_RESOURCE_RESERVATION = s.ID_CURRENT_OCCUPANCY
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESOURCE_RESERV_POST rp on rp.ID_RESOURCE_RESERVATION = rr.ID_RESOURCE_RESERVATION
  where  s.ID_SAFE = :ID_SAFE
  into   :id_resource_reservation, :from_datetime, :to_datetime, :id_account_post;

  execute procedure RESOURCE_RESERVATION_CANCEL (:id_resource_reservation, :REASON);

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = null
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:REASON, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_ANNUL', :action_text);

  execute procedure ACCOUNT_POSTING_ANUL (:id_account_post, :REASON);

  DOC_SELECTED = null;
  update ACCOUNT_POST AP
  set    ap.DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1)
  where  ap.ID_ACCOUNT_POST = :id_account_post
         and ap.ac = '00'
  returning new.doc_selected
  into   :DOC_SELECTED;

end
^

/* Alter (SAFE_OCCUPANCY_MODIFY) */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail)
  returning_values (:DOC_SELECTED);

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Alter (SAFE_OCCUPANCY_NEW) */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* Alter (SALE_TAX_MODIFY$CFG) */
ALTER PROCEDURE SALE_TAX_MODIFY$CFG(ID_SALE_TAX INTEGER,
TAX_NAME VARCHAR(50),
TAX_PERCENT NUMERIC(15,4),
TAXABLE_BASE_PERCENT NUMERIC(15,4),
TAX_VALUE NUMERIC(15,4),
REVENUE_DEDUCTION_TAX SMALLINT,
REPORT_IN_DOCUMENT SMALLINT,
FISCAL_CODE VARCHAR(30),
ACCOUNT_NAME VARCHAR(50),
OPERATION VARCHAR(10),
ID_HOTEL TYPE OF ID,
TAXATION_REASON TYPE OF TDESCRIPTION_LONG)
 RETURNS(NEW_ID_SALE_TAX INTEGER)
 AS
declare variable id_sale_taxation integer;
declare variable old_tax_percent numeric(15,4);
declare variable old_taxable_base_percent numeric(15,4);
declare variable taxation_name varchar(50);
declare variable old_tax_name varchar(50);
declare variable old_fiscal_code varchar(30);
declare variable old_is_percent smallint;
declare variable new_is_percent smallint;
declare variable old_rev_deduction_tax integer;
declare variable old_tax_value tprice;
declare variable old_taxation_reason type of TDESCRIPTION_LONG;
begin
  execute procedure SYSTEM_CHECK_OPERATION (:OPERATION, 'add, mod, del');

  if (:TAX_VALUE is not null and :TAX_PERCENT is not null) then exception ASSERT '-701';

  fiscal_code = nullif(trim(:FISCAL_CODE), '');
  if (:OPERATION = 'add') then begin
    insert into SALE_TAXES (ID_SALE_TAX, TAX_NAME, TAX_PERCENT, TAXABLE_BASE_PERCENT,
           FISCAL_CODE, ACCOUNT_NAME, ID_HOTEL, TAX_VALUE, REVENUE_DEDUCTION_TAX, REPORT_IN_DOCUMENT, TAXATION_REASON)
    values (nullif(:ID_SALE_TAX, -1), :TAX_NAME, :TAX_PERCENT, coalesce(:TAXABLE_BASE_PERCENT, 100),
           :FISCAL_CODE, :ACCOUNT_NAME, :id_hotel, :TAX_VALUE, :REVENUE_DEDUCTION_TAX, :REPORT_IN_DOCUMENT, :TAXATION_REASON)
    returning ID_SALE_TAX
    into   :NEW_ID_SALE_TAX;

  end else if (:OPERATION = 'mod') then begin
    select st.TAX_PERCENT, st.TAXABLE_BASE_PERCENT, st.tax_name, st.fiscal_code, st.IS_PERCENT_TAX,
           st.REVENUE_DEDUCTION_TAX, st.TAX_VALUE, ST.TAXATION_REASON
    from   SALE_TAXES st
    where  st.ID_SALE_TAX = :ID_SALE_TAX
    into   :old_tax_percent, :old_taxable_base_percent, :old_tax_name, :old_fiscal_code, :old_is_percent,
           :old_rev_deduction_tax, :old_tax_value, :old_taxation_reason;

    if (coalesce(:old_rev_deduction_tax, 0) <> coalesce(:REVENUE_DEDUCTION_TAX, 0)) then
      exception SALE_TAX_EXCEPTION '-702';

    if ((:TAX_PERCENT is distinct from :old_tax_percent)
        or (:TAXABLE_BASE_PERCENT is distinct from :old_taxable_base_percent)
        or (:TAX_VALUE is distinct from :old_tax_value)) then begin
      for
        select distinct stt.ID_SALE_TAXATION, t.NAME
        from   SALE_TAXATION_TAX STT
               join SALE_TAXATION t on t.ID_SALE_TAXATION = stt.ID_SALE_TAXATION
        where  stt.ID_SALE_TAX = :ID_SALE_TAX
        into   :id_sale_taxation, :taxation_name
      do begin

        /* check if sale tax is used in postings */
        delete from SALE_TAXATION STT where stt.ID_SALE_TAXATION = :id_sale_taxation;
  
        insert into SALE_TAXATION (ID_SALE_TAXATION, NAME, ID_HOTEL)
        values (:id_sale_taxation, :taxation_name, :id_hotel);
  
        when sqlcode -530 do begin
          exception SALE_TAX_EXCEPTION '-338';
        end
      end 

      execute procedure SYSTEM_LOG_ADD('SALE_TAX', :ID_SALE_TAX, 'TAX_CHANGED',
              f_character(29) || :old_tax_percent  || '%'  || f_character(28) || :old_taxable_base_percent || '%'
              || f_character(28) || :TAX_PERCENT  || '%'  || f_character(28) || :TAXABLE_BASE_PERCENT || '%');
    end

    update SALE_TAXES T
    set    t.TAX_PERCENT = :TAX_PERCENT,
           t.TAXABLE_BASE_PERCENT = :TAXABLE_BASE_PERCENT,
           T.TAX_NAME = :TAX_NAME,
           t.FISCAL_CODE = :FISCAL_CODE,
           t.ACCOUNT_NAME = :ACCOUNT_NAME,
           t.TAX_VALUE = :TAX_VALUE,
           --t.REVENUE_DEDUCTION_TAX = :REVENUE_DEDUCTION_TAX,
           t.REPORT_IN_DOCUMENT = :REPORT_IN_DOCUMENT,
           T.TAXATION_REASON = :TAXATION_REASON
    where  T.ID_SALE_TAX = :ID_SALE_TAX
    returning new.IS_PERCENT_TAX
    into   :new_is_percent;
    NEW_ID_SALE_TAX = :ID_SALE_TAX;

    if (:new_is_percent <> :old_is_percent) then exception ASSERT '-703';

    if ((:old_tax_name <> :tax_name) or (:old_fiscal_code <> :fiscal_code)) then begin
      execute procedure SYSTEM_LOG_ADD('SALE_TAX', :ID_SALE_TAX, 'TAX_NAME_CHANGED',
              f_character(29) || :old_tax_name || f_character(28) || :old_fiscal_code ||
              f_character(28) || :tax_name || f_character(28) || :fiscal_code);
    end

    if (:old_taxation_reason is distinct from :taxation_reason) then begin
      execute procedure SYSTEM_LOG_ADD('SALE_TAX', :ID_SALE_TAX, 'TAX_REASON_CHANGED',
              f_character(29) || :old_taxation_reason || f_character(28) || :taxation_reason);
    end

  end else if (:OPERATION = 'del') then begin
    execute procedure SYSTEM_LOG_ADD ('SALE_TAX', :ID_SALE_TAX, 'DELETE', '');

    delete from SALE_TAXES ST
    where  ST.ID_SALE_TAX = :ID_SALE_TAX;

    NEW_ID_SALE_TAX = null;

    when sqlcode -530 do begin
      exception REF_INTEGRITY_DELETE;
    end
  end
end
^

/* Alter (SALE_TAXATION_MODIFY$CFG) */
ALTER PROCEDURE SALE_TAXATION_MODIFY$CFG(ID_SALE_TAXATION TYPE OF ID,
NAME TYPE OF TOBJECT_NAME,
TAXES VARCHAR(250),
ACCOUNT_NAME TYPE OF TOBJECT_NAME,
OPERATION VARCHAR(10),
ID_HOTEL TYPE OF ID)
 RETURNS(NEW_ID_SALE_TAXATION INTEGER)
 AS
declare variable id_sale_tax integer;
  declare variable old_taxes varchar(250);
  declare variable no_use varchar(255);
begin
  execute procedure SYSTEM_CHECK_OPERATION (:OPERATION, 'add, mod, del');

  if (:OPERATION = 'add') then begin
    insert into SALE_TAXATION (NAME, ACCOUNT_NAME, ID_HOTEL)
    values (:NAME, :ACCOUNT_NAME, :ID_HOTEL)
    returning ID_SALE_TAXATION
    into      :NEW_ID_SALE_TAXATION;

    for
      select T.ITEM
      from   SYSTEM_STRING_PARSER (:TAXES, ',') T
      into   :id_sale_tax
    do begin
      if (not exists (select stt.ID_SALE_TAX
                      from   SALE_TAXATION_TAX STT
                      where  stt.ID_SALE_TAXATION = :NEW_ID_SALE_TAXATION
                             and stt.ID_SALE_TAX = :id_sale_tax)) then
      begin
        insert into SALE_TAXATION_TAX (ID_SALE_TAXATION, ID_SALE_TAX)
        values (:NEW_ID_SALE_TAXATION, :id_sale_tax);

        execute procedure SYSTEM_EVENT_LOG$INT ('SALE_TAX', :id_sale_tax, 'SALE_TAX_ADDED', f_character(29) || :NAME)
        returning_values (:no_use);
      end
    end
  end else if (:OPERATION = 'mod') then begin
    select coalesce(list(distinct(cast(t.ITEM as integer))), '')   -- select new taxes, ordered by ID asc
    from   SYSTEM_STRING_PARSER (:TAXES, ',') T
    into   :TAXES;

    select coalesce(list(distinct(stt.ID_SALE_TAX)), '')           -- select old taxes, ordered by ID asc
    from   SALE_TAXATION_TAX STT
    where  stt.ID_SALE_TAXATION = :ID_SALE_TAXATION
    into   :old_taxes;

    if (:taxes = :old_taxes) then begin
      -- tax contents is not changed
      update SALE_TAXATION ST
      set    ST.NAME = :NAME,
             st.ACCOUNT_NAME = :ACCOUNT_NAME
      where  ST.ID_SALE_TAXATION = :id_sale_taxation;
      NEW_ID_SALE_TAXATION = :ID_SALE_TAXATION;
    end else begin
      -- create new taxation package
      update SALE_TAXATION st
      set    st.NAME = '$$$' || st.NAME || '$$$'
      where  st.ID_SALE_TAXATION = :ID_SALE_TAXATION;

      execute procedure SALE_TAXATION_MODIFY$CFG (null, :name, :taxes, :ACCOUNT_NAME, 'add', :id_hotel)
      returning_values (:NEW_ID_SALE_TAXATION);

      update SERVICE_TAXATION pt
      set    pt.ID_SALE_TAXATION = :NEW_ID_SALE_TAXATION
      where  pt.ID_SALE_TAXATION = :ID_SALE_TAXATION;

      update SETTING_HOTEL_VALUE s
      set    s.SETTING_VALUE = :NEW_ID_SALE_TAXATION
      where  s.SETTING_CODE = 'DEF_SERVICE_TAXATION'
             and s.SETTING_VALUE = :ID_SALE_TAXATION
             and s.ID_HOTEL = :ID_HOTEL;

      -- and delete old, if possible ... else BOOOM! - unallowable changes !
      execute procedure SALE_TAXATION_MODIFY$CFG (:ID_SALE_TAXATION, :name, :taxes, :ACCOUNT_NAME, 'del', :id_hotel)
      returning_values (:ID_SALE_TAXATION);

      when any do begin
        exception SALE_TAX_EXCEPTION '-704';
      end
    end

  end else if (:OPERATION = 'del') then begin
    delete from SALE_TAXATION
    where  ID_SALE_TAXATION = :id_sale_taxation;

    delete from SALE_TAXATION_TAX STT
    where  stt.ID_SALE_TAXATION = :ID_SALE_TAXATION;

    new_id_sale_taxation = null;
  end

  execute procedure SYSTEM_CACHE_APPLY('SALE_TAXATION');
end
^

/* Alter (SERVICE_TAXATION_MODIFY$CFG) */
ALTER PROCEDURE SERVICE_TAXATION_MODIFY$CFG(ID_TAX_POLICY TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_SALE_TAXATION TYPE OF ID)
 AS
declare variable dbkey char(8);
  declare variable nat_round_to numeric(15,4);
  declare variable action_text varchar(255);
  declare variable old_sale_taxation_name varchar(50);
  declare variable service_name varchar(30);
  declare variable id_rate integer;
  declare variable passed_nights integer;
  declare variable id_posting_sale_taxation integer;
begin
  if (:ID_SALE_TAXATION is null) then begin
    delete from SERVICE_TAXATION T
    where  t.ID_TAX_POLICY = :ID_TAX_POLICY
           and t.ID_SERVICE = :ID_SERVICE;

    select f_character(29) || se.service_name
    from   SERVICES se
    where  se.id_service = :id_service
    into   :action_text;
    execute procedure SYSTEM_LOG_ADD ('TAX_POLICY', :id_tax_policy, 'TAX_POLICY_SERVICE_DELETED', :action_text);
  end else begin
    select sta.name
    from   SERVICE_TAXATION TPT
           join SALE_TAXATION sta on sta.id_sale_taxation = tpt.id_sale_taxation
    where  TPT.ID_TAX_POLICY = :ID_TAX_POLICY
           and TPT.ID_SERVICE = :ID_SERVICE
    into   :old_sale_taxation_name;

    select s.SERVICE_NAME, c.ROUND_TO
    from   SERVICES s
           join HOTEL h on h.ID_HOTEL = s.ID_HOTEL
           join CURRS c on c.CURR = h.NATION_CURR
    where  s.ID_SERVICE = :ID_SERVICE
    into   :service_name, :nat_round_to;

    update SERVICE_TAXATION T
    set    T.ID_SALE_TAXATION = :ID_SALE_TAXATION
    where  T.ID_TAX_POLICY = :ID_TAX_POLICY
           and T.ID_SERVICE = :ID_SERVICE;

    if (row_count > 0) then begin
      select st.name
      from   SALE_TAXATION st
      where  st.id_sale_taxation = :id_sale_taxation
      into   :action_text;
      action_text = f_character(29) || :service_name || f_character(28) || coalesce(:old_sale_taxation_name, '') || f_character(28) || :action_text;
      execute procedure SYSTEM_LOG_ADD ('TAX_POLICY', :id_tax_policy, 'TAX_POLICY_SERVICE_UPDATED', :action_text);
    end else begin
      insert into SERVICE_TAXATION (ID_TAX_POLICY, ID_SERVICE, ID_SALE_TAXATION)
      values (:ID_TAX_POLICY, :ID_SERVICE, :ID_SALE_TAXATION);
    end
  
    for
      select AP.RDB$DB_KEY, ap.ID_TARIFF, ap.DATE_POST - ap.FROM_DATE
      from   ACCOUNT A
             join ACCOUNT_POST AP on AP.ID_ACCOUNT = A.ID_ACCOUNT
      where  A.ID_TAX_POLICY = :ID_TAX_POLICY
             and A.IS_ARCHIVE = 0
             and AP.ID_SERVICE = :ID_SERVICE
             and AP.ID_BASE_DOC is null
             and AP.ID_SALE_TAXATION is distinct from :ID_SALE_TAXATION
             and ap.IS_ANUL = 0
      into   :dbkey, :id_rate, :passed_nights
    do begin
      execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :ID_TAX_POLICY, :id_rate, :passed_nights)
      returning_values (:id_posting_sale_taxation);

      if (:id_posting_sale_taxation = :ID_SALE_TAXATION) then begin
        execute procedure ACCOUNT_POSTING_UPDATE_TAX$INT (:dbkey, :ID_SALE_TAXATION, :nat_round_to, 'SERVICE VAT CHANGED');
      end

    end
  end
end
^

/* Alter (SETTINGS_MODIFY_VALUE) */
ALTER PROCEDURE SETTINGS_MODIFY_VALUE(SETTING_CODE TYPE OF TSEARCH_CODE,
SETTING_VALUE TYPE OF TOBJECT_TEXT,
ID_HOTEL TYPE OF ID)
 AS
declare variable old_setting_value varchar(100);
declare variable tmp_setting_value varchar(100);
  declare variable action_text varchar(255);
  declare variable setting_name varchar(255);
  declare variable id_setting_grp integer;
  declare variable settingClass varchar(20);
  declare variable dbkey char(8);
begin
  dbkey = null;
  select SV.SETTING_VALUE, S.ID_SETTING_GRP, S.CONTROL_CLASS, sv.RDB$DB_KEY
  from   SETTING s
         join SETTING_HOTEL_VALUE SV on sv.SETTING_CODE = s.SETTING_CODE
  where  SV.SETTING_CODE = :setting_code
         and sv.ID_HOTEL = :ID_HOTEL
  into   :old_setting_value, :id_setting_grp, :settingClass, :dbkey;

  if (:dbkey is not null) then begin
    update SETTING_HOTEL_VALUE SV
    set    SV.SETTING_VALUE = :setting_value
    where  SV.RDB$DB_KEY = :dbkey;
  end else begin
    insert into SETTING_HOTEL_VALUE (SETTING_CODE, ID_HOTEL, SETTING_VALUE)
    values (:SETTING_CODE, :ID_HOTEL, :SETTING_VALUE);
  end

  RDB$SET_CONTEXT('USER_SESSION', 'setting.'||:setting_code||'.'||:id_hotel, :setting_value);

  if ((:id_setting_grp is not null) and (:setting_value is distinct from :old_setting_value)) then begin
    /* FOR THE FEATURE THIS KIND OF LOGING MUST BE BASED
    || ON MACROS WICH ARE EXECUTED AT DISPLAY TIME.
    || FOR NOW WE ARE HARDCODED TO THE BASE LANG.
    */
    setting_name = '@{set_name.'||:setting_code||'}';
    action_text = f_character(29)||:setting_name;

    if (:settingClass = 'COMBO') then begin
      old_setting_value = '@{set_item.'||:setting_code||'.'||:old_setting_value||'}';
      tmp_setting_value = '@{set_item.'||:setting_code||'.'||:setting_value||'}';
    end else begin
      tmp_setting_value = :setting_value;
    end

    action_text = :action_text
                  || f_character(28) || coalesce(:old_setting_value, '')
                  || f_character(28) || :tmp_setting_value;
    execute procedure SYSTEM_LOG_ADD ('SYSTEM', 0, 'SETTING_CHANGED', :action_text);
  end

  execute procedure SYSTEM_CACHE_APPLY('HOTEL');
end
^

/* empty dependent procedure body */
/* Clear: SPR_OCC_KONT_AGENT for: SPR_OCC_KONT_AGENT_ROOMTYPE_DAY */
ALTER PROCEDURE SPR_OCC_KONT_AGENT(FROM_DATE DATE,
TO_DATE DATE,
ID_AGENT INTEGER,
KIND SMALLINT,
AGE_KIND SMALLINT,
ALL_KINDS SMALLINT,
ID_HOTEL INTEGER)
 RETURNS(TYPE_ROOM VARCHAR(20),
TYPE_ROOM2 VARCHAR(20),
FOR_DATE DATE,
KONTINGENT INTEGER,
DATA INTEGER,
OUT_KIND VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* Alter (SPR_OCC_KONT_AGENT_ROOMTYPE_DAY) */
ALTER PROCEDURE SPR_OCC_KONT_AGENT_ROOMTYPE_DAY(FOR_DATE DATE,
ID_AGENT INTEGER,
ID_ROOM_TYPE INTEGER,
KIND SMALLINT,
AGE_KIND SMALLINT,
ALL_KINDS SMALLINT)
 RETURNS(KONTINGENT INTEGER,
DATA INTEGER,
OUT_KIND VARCHAR(20))
 AS
declare variable kont_rooms integer;
  declare variable kont_beds integer;
  declare variable kont_adds integer;
  declare variable data_rooms integer;
  declare variable data_adult_beds integer;
  declare variable data_children_beds integer;
  declare variable data_adult_adds integer;
  declare variable data_children_adds integer;
begin
  /* KIND:  1 - ROOMS
            2 - BEDS
            3 - ADD BEDS
            else - BEDS + ADD BEDS
     AGE_KIND:  1 - ADULTS
                2 - CHILDREN
                else - ALL*/
  kontingent = 0;
  data = 0;

  for
    select ACR.CNT_ROOMS
    from   ALLOTMENT_AGENT_GET(:for_date, :for_date, :id_room_type, :id_agent, 'CONTINGENT_DEFINE', 0) ACR
    into   :kont_rooms
  do if ((:all_kinds = 1) or (:kind > 2)) then begin
    select max(:kont_rooms * RT.BEDS),
           round_f(max(RM.EXTRA_BEDS)/max(AD.CNT_ROOMS) * :kont_rooms, 1)
    from   (select max(r.ID_HOTEL) as id_hotel, sum(R.EXTRA_BEDS) as EXTRA_BEDS
            from   ROOMS R
            where  r.ID_ROOM_TYPE = :ID_ROOM_TYPE) RM
           join HOTEL H on H.ID_HOTEL = RM.ID_HOTEL
           join ALLOTMENT_DETAIL AD on AD.ID_ALLOTMENT = H.ID_INVENTORY_ALLOTMENT
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = ad.ID_ROOM_TYPE
    where  AD.ID_ROOM_TYPE = :id_room_type
           and AD.FROM_DATE <= :for_date
           and AD.TO_DATE >= :for_date
    into   :kont_beds, :kont_adds;
  end

  select count(distinct RM.ID_ROOM),
         sum(RM.GST_AD_IN + RM.GST_AD_STAY),
         sum(RM.GST_CH_IN + RM.GST_CH_STAY)
  from   ROOM_MAGIC RM
  where  RM.ID_ROOM_TYPE = :id_room_type
         and RM.BUSY_DATE = :for_date
         and RM.BUSY_GROUP_TYPE in (1,24)
         and upper(RM.BUSY_TYPE) is distinct from 'VALUE_RESERVS'
         and RM.DAY_ACTION not containing 'CHECK_OUT'
         and RM.ID_AGENT = :id_agent
  into   :data_rooms, :data_adult_beds, :data_children_beds;

  if (not ((:kind = 1) and (:all_kinds = 0))) then begin
    /*select sum(RM.GST_AD_IN + RM.GST_AD_STAY),
           sum(RM.GST_CH_IN + RM.GST_CH_STAY)
    from   ROOM_MAGIC RM
           join GUEST G on G.ID_RESERV_DETAIL = RM.ID_RESERV_DETAIL
           join ACCOUNT_POST AP on AP.ID_GUEST = G.ID_GUEST
                and AP.DATE_POST = RM.BUSY_DATE
                and AP.IS_BASE = 1 and AP.IS_ANUL = 0
           join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
           join TYPE_STAY TS on TS.ID_TYPE_STAY = S.ID_TYPE_STAY and TS.TYPE_STAY_CODE = 'EXTRA_BED'
    where  RM.ID_ROOM_TYPE = :id_room_type
           and RM.BUSY_DATE = :for_date
           and RM.BUSY_GROUP_TYPE = 24
           and RM.ID_AGENT = :id_agent
    into   :data_adult_adds, :data_children_adds;*/

    select count(iif(g.IS_CHILD = 0, gs.ID_GUEST, null)),
           count(iif(g.IS_CHILD = 1, gs.ID_GUEST, null))
    from   GUEST_STAY GS     
           join ROOMS R on R.ID_ROOM = gs.ID_ROOM
           join TYPE_STAY TS on TS.ID_TYPE_STAY = GS.ID_TYPE_STAY
           left join GUEST G on G.ID_GUEST = gs.ID_GUEST
           left join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  gs.FOR_DATE = :for_date
           and r.ID_ROOM_TYPE = :id_room_type
           and rd.CHECK_STATUS >= -1
           and upper(rd.res_status) is distinct from 'WAITING'
           and rd.IS_ANUL = 0
           and g.ID_AGENT = :id_agent
           and TS.TYPE_STAY_CODE = 'EXTRA_BED'
    into   :data_adult_adds, :data_children_adds;
  end

  kont_adds = coalesce(:kont_adds, 0);
  kont_beds = coalesce(:kont_beds, 0);
  kont_rooms = coalesce(:kont_rooms, 0);
  data_rooms = coalesce(:data_rooms, 0);
  data_adult_beds = coalesce(:data_adult_beds, 0);
  data_children_beds = coalesce(:data_children_beds, 0);
  data_adult_adds = coalesce(:data_adult_adds, 0);
  data_children_adds = coalesce(:data_children_adds, 0);

  data_adult_beds = :data_adult_beds - :data_adult_adds;
  data_children_beds = :data_children_beds - :data_children_adds;
  if (:ALL_KINDS <> 1) then begin
    if (:KIND = 1) then KONTINGENT = :kont_rooms;
    else if (:KIND = 2) then KONTINGENT = :kont_beds;
    else if (:KIND = 3) then KONTINGENT = :kont_adds;
    else KONTINGENT = :kont_beds + :kont_adds;

    if (:KIND = 1) then
      DATA = :data_rooms;
    else if (:KIND = 2) then
      if (:AGE_KIND = 1) then DATA = :data_adult_beds;
      else if (:AGE_KIND = 2) then DATA = :data_children_beds;
      else DATA = :data_adult_beds + :data_children_beds;
    else if (:KIND = 3) then
      if (:AGE_KIND = 1) then DATA = :data_adult_adds;
      else if (:AGE_KIND = 2) then DATA = :data_children_adds;
      else DATA = :data_adult_adds + :data_children_adds;
    else
      if (:AGE_KIND = 1) then DATA = :data_adult_adds + :data_adult_beds;
      else if (:AGE_KIND = 2) then DATA = :data_children_adds + :data_children_beds;
      else DATA = :data_adult_adds + :data_children_adds + :data_adult_beds + :data_children_beds;

    if (:DATA is null) then DATA = 0;
    if (:KONTINGENT is null) then KONTINGENT = 0;
    OUT_KIND = 'DEFINED;DEFINED';
    suspend;
  end else begin
  /* KIND:  1 - ROOMS
            2 - BEDS
            3 - ADD BEDS
            else - BEDS + ADD BEDS
     AGE_KIND:  1 - ADULTS
                2 - CHILDREN
                else - ALL*/
    OUT_KIND = 'ADDS;ADULTS';
    KONTINGENT = :kont_adds;
    DATA = :data_adult_adds;
    suspend;
    OUT_KIND = 'ADDS;CHILDREN';
    KONTINGENT = :kont_adds;
    DATA = :data_children_adds;
    suspend;
    OUT_KIND = 'ADDS;ALL';
    KONTINGENT = :kont_adds;
    DATA = :data_children_adds + :data_adult_adds;
    suspend;
    OUT_KIND = 'ALL_BEDS;ADULTS';
    KONTINGENT = :kont_adds + :kont_beds;
    DATA = :data_adult_adds + :data_adult_beds;
    suspend;
    OUT_KIND = 'ALL_BEDS;CHILDREN';
    KONTINGENT = :kont_adds + :kont_beds;
    DATA = :data_children_adds + :data_children_beds;
    suspend;
    OUT_KIND = 'ALL_BEDS;ALL';
    KONTINGENT = :kont_adds + :kont_beds;
    DATA = :data_children_adds + :data_adult_adds + :data_children_beds + :data_adult_beds;
    suspend;
    OUT_KIND = 'BEDS;ADULTS';
    KONTINGENT = :kont_beds;
    DATA = :data_adult_beds;
    suspend;
    OUT_KIND = 'BEDS;CHILDREN';
    KONTINGENT = :kont_beds;
    DATA = :data_children_beds;
    suspend;
    OUT_KIND = 'BEDS;ALL';
    KONTINGENT = :kont_beds;
    DATA = :data_children_beds + :data_adult_beds;
    suspend;
    OUT_KIND = 'ROOMS;ALL';
    KONTINGENT = :kont_rooms;
    DATA = :data_rooms;
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: PRODUCT_RATING$INT for: TAR_CALC_EVAL_ALL$INT */
ALTER PROCEDURE PRODUCT_RATING$INT(ID_HOTEL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
ADULT_AGES VARCHAR(100) = null,
CHILD_AGES VARCHAR(100) = null,
ID_TAR_CALC_COMMON INTEGER = null)
 RETURNS(ROOM_PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_TEST$TAR for: TAR_CALC_EVAL_ALL$INT */
ALTER PROCEDURE TAR_TEST$TAR(NUMBER VARCHAR(62),
ID_TAR_HEAD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_EVAL_ALL$INT) */
ALTER PROCEDURE TAR_CALC_EVAL_ALL$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_status varchar(20);
  declare variable from_date date;
  declare variable to_date date;
  declare variable idate date;
  declare variable is_static integer;
  declare variable id_tar_input integer;
  declare variable id_type_stay integer;
  declare variable separate_board integer;
  declare variable id_board_include integer;
  declare variable id_tar_head integer;
  declare variable is_manual_type_stay smallint;
  declare variable seasson_name varchar(50);
begin
  err_code = 0;

  delete from TAR_CALC_OUTPUT$TMP TCO where TCO.ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP TCV where TCV.ID_TAR_CALC = :id_tar_calc;

  execute procedure TAR_CALC_INIT_VARS$INT(:id_tar_calc);

  for
    select TCI.ROOM_STATUS, min(TCI.FROM_DATE_CALC), max(TCI.TO_DATE_CALC), min(TCI.IS_STATIC)
    from   TAR_CALC_INPUT$TMP TCI
    where  TCI.ID_TAR_CALC = :id_tar_calc
    group by TCI.ROOM_STATUS
    into   :room_status, :from_date, :to_date, :is_static
  do begin
    for
      select RLP.OUT_DATE
      from   SYSTEM_LOOP_PERIOD(:from_date, :to_date) RLP
      into   :idate
    do begin
      if ((:is_static = 1) and (:idate > :from_date)) then begin
        insert into TAR_CALC_OUTPUT$TMP (ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
               FOR_DATE, PRICE, CURRENCY, PRICE_TARIFF, CURRENCY_TARIFF, PRICE_NOTE, QTY_POST,
               PTEXT, DISC_TAG, ID_DISCOUNT_SERVICE, REQUIRED_ID_PACKET_ITEM)
        select tco.ID_TAR_INPUT, tco.ID_TAR_CALC, tco.ID_SERVICE, tco.SERVICE_TYPE,
               :idate, PRICE, tco.CURRENCY, tco.PRICE_TARIFF, tco.CURRENCY_TARIFF, tco.PRICE_NOTE, tco.QTY_POST,
               tco.PTEXT, tco.DISC_TAG, tco.ID_DISCOUNT_SERVICE, tco.REQUIRED_ID_PACKET_ITEM
        from   TAR_CALC_OUTPUT$TMP TCO
        where  TCO.FOR_DATE = :from_date
               and TCO.ID_TAR_CALC = :id_tar_calc;
        for
          select TCID.ID_TAR_INPUT, TCID.ID_TYPE_STAY, TCID.SEPARATE_BOARD, TCID.ID_BOARD_INCLUDE,
                 TCID.IS_MANUAL_TYPE_STAY, TCID.ID_TAR_HEAD
          from   TAR_CALC_INPUT_DETAIL$TMP TCID
                 join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
          where  TCID.FOR_DATE = :from_date
                 and TCI.ID_TAR_CALC = :id_tar_calc
          into   :id_tar_input, :id_type_stay, :separate_board, :id_board_include,
                 :is_manual_type_stay, :id_tar_head
        do begin
          seasson_name = null;
          select tp.SEASON_NAME
          from   TARIFA_GET_PERIOD_FOR_DATE (:id_tar_head, :idate) tp
          into   :seasson_name;
          if (:seasson_name is null) then begin
            ERR_CODE = -231;
            ERR_TEXT = '';
            exit;
          end

          update TAR_CALC_INPUT_DETAIL$TMP TCID
          set    TCID.ID_TYPE_STAY = :id_type_stay,
                 TCID.IS_MANUAL_TYPE_STAY = :is_manual_type_stay,
                 TCID.SEPARATE_BOARD = :separate_board,
                 TCID.ID_BOARD_INCLUDE = :id_board_include
          where  TCID.ID_TAR_INPUT = :id_tar_input;
        end
      end else begin
        execute procedure TAR_CALC_EVAL_DATE$INT(:id_tar_calc, :room_status, :idate)
        returning_values  :err_code, :err_text;
        if (:err_code < 0) then exit;
      end
    end
  end

  execute procedure TAR_CALC_EVAL_ZERO$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  if (:err_code is null) then begin
    err_code = -230; /*WRONG INPUT PARAMS - MISSING GUESTS*/
    err_text = 'Missing input data for calculation';
    exit;
  end

  execute procedure TAR_CALC_EVAL_PERIOD$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  execute procedure TAR_CALC_CHECK_PACKETS$INT (:ID_TAR_CALC)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_INPUT_RESERV$INT for: TAR_CALC_GET_GUESTS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_RESERV$INT(ID_RESERV_DETAIL INTEGER,
ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
ID_RATE_OVERRULE INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* Alter (TAR_CALC_GET_GUESTS$INT) */
ALTER PROCEDURE TAR_CALC_GET_GUESTS$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_GUEST INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
G_DBKEY CHAR(8),
ID_GUEST_RESERV TYPE OF ID)
 AS
declare variable dbg varchar(2000);
declare variable share_status integer;
declare variable shared_reservations varchar(1024);
declare variable id_shared_detail integer;
declare variable unshared_reservations varchar(1024);
declare variable id_unshared_detail integer;
declare variable incremental_guest_list varchar(2000);
begin
  incremental_guest_list = ','; /*using for not suspend dublicated guests - otherwise calculations are wrong*/
  for
    select G.ID_GUEST, G.FROM_DATE, G.TO_DATE, G.RDB$DB_KEY, rd.ID_RESERV_DETAIL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  Rd.ID_RESERV_DETAIL = :id_reserv_detail
           and rd.IS_ANUL = 0
    into   :ID_GUEST, :FROM_DATE, :TO_DATE, :G_DBKEY, :ID_GUEST_RESERV
  do begin
    suspend;
    incremental_guest_list = :incremental_guest_list || :id_guest ||',';
  end

/*  execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'ENUM_SHARES', null)*/
  execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'FOR_RECALC', null)
  returning_values  :share_status, :shared_reservations, :dbg;
  execute procedure sys_dbg('calc TAR_CALC_GET_GUESTS$INT shared_reservations = '||coalesce(:shared_reservations, 'null'));

  if (:share_status = 1) then begin
    for
      select SP.ITEM
      from   SYSTEM_STRING_PARSER(:shared_reservations, ',') SP
      into   :id_shared_detail
    do begin
      for
        select G.ID_GUEST, G.FROM_DATE, G.TO_DATE, G.RDB$DB_KEY, G.ID_RESERV_DETAIL
        from   GUEST G
        where  G.ID_RESERV_DETAIL = :id_shared_detail
        into   :ID_GUEST, :FROM_DATE, :TO_DATE, :G_DBKEY, :ID_GUEST_RESERV
      do begin
        if (:incremental_guest_list not containing ','||:id_guest||',' ) then begin
          suspend;
          incremental_guest_list = :incremental_guest_list || :id_guest ||',';
        end
      end
    end
  end

  execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'ENUM_EX_SHARES', null)
  returning_values  :share_status, :unshared_reservations, :dbg;

  execute procedure sys_dbg('calc TAR_CALC_GET_GUESTS$INT unshared_reservations = '||coalesce(:unshared_reservations, 'null'));
  execute procedure sys_dbg('calc TAR_CALC_GET_GUESTS$INT incremental_guest_list = '||coalesce(:incremental_guest_list, 'null'));

  if (:unshared_reservations <> '') then begin
    for
      select SP.ITEM
      from   SYSTEM_STRING_PARSER(:unshared_reservations, ',') SP
      into   :id_unshared_detail
    do begin
      for
        select G.ID_GUEST, G.FROM_DATE, G.TO_DATE, G.RDB$DB_KEY, g.ID_RESERV_DETAIL
        from   GUEST G
        where  G.ID_RESERV_DETAIL = :id_unshared_detail
        into   :ID_GUEST, :FROM_DATE, :TO_DATE, :G_DBKEY, :ID_GUEST_RESERV
      do begin
        if (:incremental_guest_list not containing ','||:id_guest||',' ) then begin
          suspend;
          incremental_guest_list = :incremental_guest_list || :id_guest ||',';
        end
        execute procedure sys_dbg('calc TAR_CALC_GET_GUESTS$INT incremental_guest_list2 = '||coalesce(:incremental_guest_list, 'null'));
      end
    end
  end
end
^

/* Alter (TAR_CALC_INPUT_RESERV$INT) */
ALTER PROCEDURE TAR_CALC_INPUT_RESERV$INT(ID_RESERV_DETAIL INTEGER,
ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
ID_RATE_OVERRULE INTEGER = null)
 AS
declare variable id_guest integer;
  declare variable g_dbkey char(8);
  declare variable from_date date;
  declare variable to_date  date;
  declare variable id_tariff_calc integer;
  declare variable err_code integer;
  declare variable err_text varchar(25);
  declare variable id_guest_reserv integer;
begin
  for
    select G.ID_GUEST, G.FROM_DATE, G.TO_DATE, G.G_DBKEY, g.ID_GUEST_RESERV
    from   TAR_CALC_GET_GUESTS$INT(:id_reserv_detail) G
    into   :id_guest, :from_date, :to_date, :g_dbkey, :id_guest_reserv
  do begin
    execute procedure sys_dbg('calc RES_RECALC$INT input guest_id '|| :id_guest || ', from:' || :from_date || ', to:' ||  :to_date);

    id_tariff_calc = null;
    if (:id_guest_reserv = :ID_RESERV_DETAIL and :ID_RATE_OVERRULE is not null) then id_tariff_calc = :ID_RATE_OVERRULE;
    -- skip ID_RATE_OVERRULE for shared bookings
    execute procedure TAR_CALC_INPUT_GUEST$INT(:id_tar_calc, :room_status, :g_dbkey, :id_tariff_calc, 1);
  end

  -- RECALCULATING DEPENDING ON THE TARIFF KIND
  execute procedure TAR_CALC_INPUT_DETAILS$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exception RATING_PREPARE_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_INPUT_PARAMS$INT for: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_PARAMS$INT) */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* Alter (TAR_CALC_POST_PREPARE$INT) */
ALTER PROCEDURE TAR_CALC_POST_PREPARE$INT(ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
  declare variable id_service integer;
  declare variable id_tariff integer;
  declare variable date_post date;
  declare variable qty_post integer;
  declare variable price_orig numeric(15,4);
  declare variable round_to numeric(15,4);
  declare variable curr_orig char(3);
  declare variable id_room integer;
  declare variable short_code varchar(255);
  declare variable id_reserv integer;
begin

  delete
  from   TAR_CALC_POST$TMP TCP
  where  TCP.ID_TAR_CALC = :id_tar_calc;

  -- update all packets with posting_service_id && source_type
  update  TAR_CALC_OUTPUT$TMP TCO
  set     tco.ID_POSTING_SERVICE = tco.ID_SERVICE,
          tco.SOURCE_TYPE = iif(tco.price_note = 'DISC_STAY', tco.PRICE_NOTE, tco.SERVICE_TYPE)
  where   TCO.id_tar_calc = :id_tar_calc
          and tco.SERVICE_TYPE = 'PACKETS';

  -- transform all 'discounts with service' as packets, with specific source_type
  -- update order is URGENT - 'real' packets must be updated above !!!
  update  TAR_CALC_OUTPUT$TMP TCO
  set     tco.service_type = 'PACKETS',
          tco.ID_POSTING_SERVICE = tco.ID_DISCOUNT_SERVICE,
          tco.SOURCE_TYPE = 'DISC'
  where   TCO.id_tar_calc = :id_tar_calc
          and tco.price_note = 'DISC'
          and tco.id_discount_service > 0;

  -- all packet`s updates must be applied before TAR_OUTPUT_BASE !!!!!!
  for
    select TOB.ID_GUEST, TOB.ID_RESERV, TOB.ID_SERVICE, TOB.ID_TARIFF, TOB.DATE_POST, TOB.QTY_POST,
           round_f(TOB.PRICE_ORIG, c.ROUND_TO), TOB.CURR_ORIG, TOB.ID_ROOM, TOB.SHORT_CODE, c.ROUND_TO
    from   TAR_OUTPUT_BASE(:id_tar_calc) TOB
           left outer join CURRS c on c.CURR = tob.CURR_ORIG
    into   :id_guest, :id_reserv, :id_service, :id_tariff, :date_post, :qty_post,
           :price_orig, :curr_orig, :id_room, :short_code, :round_to
  do begin
    insert into TAR_CALC_POST$TMP(ID_GUEST, ID_RESERV, ID_SERVICE, ID_TARIFF, DATE_POST, QTY_POST,
           PRICE_ORIG, CURR_ORIG, ID_ROOM, IS_BASE, ID_TAR_CALC, SHORT_CODE)
    values(:id_guest, :id_reserv, :id_service, :id_tariff, :date_post, :qty_post,
           :price_orig, :curr_orig, :id_room, 1, :id_tar_calc, :short_code);

    for
        select   TCO.ID_POSTING_SERVICE, coalesce(TCO.SOURCE_TYPE, ''),
                 max(TCO.QTY_POST), round_f(sum(TCO.PRICE_TARIFF), :round_to)
        from     TAR_CALC_OUTPUT$TMP TCO
                 join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCO.ID_TAR_INPUT
        where    TCO.ID_TAR_CALC = :id_tar_calc
                 and TCO.SERVICE_TYPE = 'PACKETS'
                 and TCI.ID_GUEST = :id_guest
                 and TCO.FOR_DATE = :date_post
        group by 1, 2
        into     :id_service, :short_code, :qty_post, :price_orig
    do begin
      if (:short_code not in ('BASE_BOARD', 'EXTRA_BOARD')) then short_code = 'PACK';

      insert into TAR_CALC_POST$TMP(ID_GUEST, ID_RESERV, ID_SERVICE, ID_TARIFF, DATE_POST,
             QTY_POST, PRICE_ORIG, CURR_ORIG, ID_ROOM, IS_BASE, ID_TAR_CALC, SHORT_CODE)
      values(:id_guest, :id_reserv, :id_service, :id_tariff, :date_post, :qty_post,
             :price_orig, :curr_orig, :id_room, 0, :id_tar_calc, :short_code);
    end
  end
end
^

/* Alter (TAR_TEST$TAR) */
ALTER PROCEDURE TAR_TEST$TAR(NUMBER VARCHAR(62),
ID_TAR_HEAD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_reserv_detail integer;
begin
  id_tar_calc = -1 * :id_tar_head;
  delete from TAR_CALC_OUTPUT$TMP where id_tar_calc = :id_tar_calc;
  delete from TAR_CALC_INPUT$TMP  where id_tar_calc = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP  where id_tar_calc = :id_tar_calc;

  err_code = 0;

  id_reserv_detail = null;
  select RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.NUMBER = :number
         and rd.IS_ANUL = 0
  into   :id_reserv_detail;

  if (:id_reserv_detail is null) then begin
    select first 1 RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.NUMBER_2 = :number
           and rd.IS_ANUL = 0
    into   :id_reserv_detail;
  end

  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NEW_ROOM', :ID_TAR_HEAD);

  execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;
end
^

/* Alter (TEST_BOOKING_IMPORT) */
ALTER PROCEDURE TEST_BOOKING_IMPORT AS
declare variable dbg varchar(255);
  declare variable booking_id integer;
begin
  dbg = null;
  EXECUTE PROCEDURE IMPORT_BOOKING$EXC ('SOL NESSEBAR BAY', 'EXP.3', null, null, 0,
  cast('17.11.2008' as date), null, cast('19.11.2008' as date),
  null, null, null, null, null, 'LARGE_ROOM', 'BB', null, null, '????????', 'MIXED', 'EXPEDIA-BAY',
  null, null, null, null, '?????? ??????', null, null, null, null, 'Business - Corporate',
  'Companies (FIR)', 'E-Mail (EMA)', 'Advert (ANZ)', 'Activities (ANI)', 'A room with a view.(4)',
  null, null, 2, 2, 'e43a4cc0-7d73-47cc-bd07-a98c18c714a3', null, '0D074F966A187B2A9912B5F0E213FEB4',
  0, 0, 0, null, null, null, null, null, null, null, null, null, null,  null, null, null, null, null, null, null, null)
  returning_values (:dbg, :booking_id, :dbg, :dbg);
  dbg = null;
end
^

/* Alter (TEST_RATING) */
ALTER PROCEDURE TEST_RATING RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
declare variable from_date date;
 declare variable to_date date;
 declare variable hotels varchar(255);
begin
  from_date = '01.01.2010';
  to_date = '08.01.2010';
  hotels = '2';

  execute procedure AVAILABILITY_OCCUP_PREPARE$AVL (:from_date, :from_date + 30, 1, 0, 0, 1, 1, 0, 0, 0, :hotels);

  execute procedure AVAILABILITY_RATING$AVL (null, :from_date, :to_date, 2,
          2, 0, '33,31,55,30,32,54,62,59,71,72', '2301,2210,2347,1633,2300,2342,2353,2362', '6,0,8,7,22,21,23', :hotels)
  returning_values (:ID_OCCUPANCY_SESSION);

end
^

/* Restore proc. body: ACCOUNT_CHECK_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_CHECK_CREDIT_STATUS$INT(ID_ACCOUNT TYPE OF ID_REF,
POST_VALUE TYPE OF TPRICE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_credit_account integer;
  declare variable id_reserv_detail integer;
  declare variable credit_limit tprice;
  declare variable b_post_sum tprice;
  declare variable b_pay_sum tprice;
  declare variable difference_value tprice;
  declare variable no_use varchar(255);
  declare variable account_currency tcurrency;
  declare variable round_to numeric(15,4);
begin
  if (:POST_VALUE = 0) then exit;

  select a.IS_CREDIT_ACCOUNT, a.CREDIT_LIMIT, a.ID_RESERV_DETAIL
  from   ACCOUNT A
  where  a.ID_ACCOUNT = :ID_ACCOUNT
  into   :is_credit_account, :credit_limit, :id_reserv_detail;

  if (:is_credit_account = 0
      and exists (select rd.ID_RESERV_DETAIL
                  from   RESERV_DETAIL rd
                  where  rd.ID_RESERV_DETAIL = :id_reserv_detail
                         and rd.CHECK_STATUS = 1)) then
  begin
    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, :credit_limit, 1);
  end

  if (coalesce(:credit_limit, 0) > 0) then begin
    /* FIND BALANCE OF ACCOUNT */
    execute procedure ACCOUNT_BALANCE$INT(:id_account)
    returning_values  :account_currency, :round_to, :no_use, :b_post_sum, :b_pay_sum, :no_use, :no_use;
    b_post_sum = coalesce(:b_post_sum, 0);
    b_pay_sum  = coalesce(:b_pay_sum, 0);

    /* IS THIS POST IS IN LIMIT */
    if ((:b_post_sum + :POST_VALUE) > :credit_limit) then begin
      err_code = -13; /*  */
      difference_value = :b_post_sum + :POST_VALUE - :credit_limit;
      err_text = f_character(29)||FormatFloat(:credit_limit, :round_to)||' '||:account_currency||
                 f_character(28)||FormatFloat(:difference_value, :round_to);
    end
  end
end
^

/* Restore proc. body: ACCOUNT_CREATE_PMS$PMS */
ALTER PROCEDURE ACCOUNT_CREATE_PMS$PMS(ID_OWNER INTEGER,
ID_ACC_TEMPLATE INTEGER,
ID_CURRENCY CHAR(3),
ID_HOTEL INTEGER)
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable hotel_name varchar(50);
  declare variable account_name varchar(50);
  declare variable is_owner_pool smallint;
  declare variable is_credit_account integer;
  declare variable credit_limit numeric (15,4);
  declare variable sec_level integer;
  declare variable is_pos_allowed integer;
  declare variable id_tax_policy integer;
begin
  -- klientska smetka za pool ne triabwa da se syzdawa!
  select iif(O.ID_RENTAL_POOL_UNIT is null, 0, 1)
  from   OWNER$PMS O
  where  O.ID_OWNER = :ID_OWNER
  into   :is_owner_pool;
  if (:is_owner_pool = 1) then exit;

  select H.HOTEL_NAME
  from   HOTEL H
  where  H.ID_HOTEL = :ID_HOTEL
  into   :hotel_name;
  account_name = substring('Owner account - '||:hotel_name from 1 for 50);

  if (:ID_ACC_TEMPLATE is null) then begin
    select sv.SETTING_VALUE
    from   SETTING_GET_VALUE ('DEF_OWNER_ACC_TEMPLATE', :ID_HOTEL) sv
    into   :id_acc_template;

    if (not exists (select t.ID_ACC_TEMPLATE
                    from   ACC_TEMPLATE t
                    where  t.ID_ACC_TEMPLATE = :ID_ACC_TEMPLATE
                           and t.ID_HOTEL = :ID_HOTEL)) then
    begin
      select sv.SETTING_VALUE
      from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :id_hotel) sv
      into   :id_acc_template;
    end
  end

  is_credit_account = null;
  select ACT.IS_CREDIT_ACCOUNT, ACT.CREDIT_LIMIT, ACT.SECURITY_LEVEL,
         ACT.IS_ALOWED_POS_INTERFACE, ACT.ID_TAX_POLICY
  from   ACC_TEMPLATE ACT
  where  ACT.ID_ACC_TEMPLATE = :id_acc_template
         and act.ID_HOTEL = :id_hotel
  into   :is_credit_account, :credit_limit, :sec_level,
         :is_pos_allowed, :id_tax_policy;

  if (:is_credit_account is null) then exception ACCOUNT_EXCEPTION '-50';

  execute procedure ACCOUNT_MODIFY$INT (null, :ID_OWNER, :ID_CURRENCY, :account_name, 1, :credit_limit,
          null, null, 0, null, :sec_level, 1, 1, :is_pos_allowed, null,
          null, :id_tax_policy, null, :ID_HOTEL, null, 1, 'add')
  returning_values (:NEW_ID_ACCOUNT);
end
^

/* Restore proc. body: ACCOUNT_JOIN_IN_ONE_BY_STRING */
ALTER PROCEDURE ACCOUNT_JOIN_IN_ONE_BY_STRING(IN_TARGET_ID_ACCOUNT INTEGER,
IN_SOURCE_STRING VARCHAR(1000))
 AS
declare variable source_id_account integer;
  declare variable id_deposit integer;
  declare variable avail_value numeric(15,4);
  declare variable dbg varchar(1000);
  declare variable description varchar(100);
  declare variable doc_selected integer;
begin

  for
    select cast(ITEM as integer)
    from   SYSTEM_STRING_PARSER(:IN_SOURCE_STRING, 'x')
    into   :source_id_account
  do begin
    if (:source_id_account <> :in_target_id_account) then begin
      doc_selected = gen_id(DOC_SELECTED_GEN, 1);
      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :doc_selected
      where  AP.ID_ACCOUNT =  :source_id_account
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null;

      /* call next procedure because of logging */
      execute procedure ACCOUNT_POSTING_TRANSFER$ACC(:doc_selected, :in_target_id_account, :source_id_account);

      for
        select DA.ID_DEPOSIT, DA.AVAIL_VALUE, DA.DESCRIPTION
        from   DEPOSIT_AVAILABLE DA
        where  DA.ID_ACCOUNT = :source_id_account
        into   :id_deposit, :avail_value, :description
      do begin
        execute procedure DEPOSIT_TRANSFER$ACC (:id_deposit, :in_target_id_account, :avail_value, :description)
        returning_values  :dbg;
      end 
    end
  end
end
^

/* Restore proc. body: ACCOUNT_POST_MODIFY$PMS */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
declare variable id_account integer;
  declare variable id_service integer;
  declare variable date_post date;
  declare variable is_owner_income smallint;
  declare variable is_account_post_item smallint;
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable no_use_id_acc_post integer;
  declare variable ap_dbkey char(8);
begin
  -- da se wika samo ot GUI
  if ( (:ID_ACCOUNT_POST is null) and (:ID_ACCOUNT_POST_PMS is null) ) then begin
    exception WRONG_PARAM_VALUE;
    exit;
  end

  is_account_post_item = iif(:id_account_post is not null, 1, 0);

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'mod, anul');

  if (:operation in ('mod', 'anul')) then begin
    -- prowerka: ot GUI-to mogat da se anulirat samo nedokumentirani i neanulirani nachisleniq
    if (:is_account_post_item = 1) then begin
      if ( (:ID_PMS_EVENT > 0) and
           not exists ( select *
                        from   PMS_EVENT_POST PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      select ap.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  ap.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
      into   :ap_dbkey;

      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_dbkey, 'PMS GUI VOID');

      update PMS_EVENT_POST PP
      set    PP.LINE_STATUS = 22
      where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST;

    end else if (:ID_ACCOUNT_POST_PMS is not null) then begin
      if ( not exists ( select *
                        from   ACCOUNT_POST$PMS PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      execute procedure ACCOUNT_POST_PMS_ANUL$INT(:ID_PMS_EVENT, :ID_ACCOUNT_POST_PMS);
    end

    if (:operation = 'mod') then begin
      id_account = null;
      if (:is_account_post_item = 1) then begin
        select AP.ID_ACCOUNT, AP.ID_SERVICE, AP.DATE_POST, PP.ID_OWNER, 0, ap.id_room
        from   ACCOUNT_POST AP
               join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and PP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :id_owner, :is_owner_income, :id_room;
      end else begin
        select AP.ID_ACCOUNT_PMS, AP.ID_SERVICE, AP.DATE_POST, AP.IS_OWNER_INCOME, AP.ID_OWNER
        from   ACCOUNT_POST$PMS AP
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
               and AP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :is_owner_income, :id_owner;
      end
      if (:id_account is null) then exit;

      execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_account, :id_service, :id_owner, :date_post,
              :in_curr_orig, :in_value_orig, 1 - :is_account_post_item, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Restore proc. body: AR_OWING_ADD$AR */
ALTER PROCEDURE AR_OWING_ADD$AR(ID_PROFILE TYPE OF ID,
SUM_OWING TYPE OF TPRICE,
CURR_OWING TYPE OF TCURRENCY,
DUE_DATE TYPE OF TDATE,
SYSTEM_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
ID_AR_TYPE TYPE OF ID,
ID_HOTEL TYPE OF ID)
 RETURNS(NEW_ID_AR_OWING TYPE OF ID)
 AS
begin

  execute procedure AR_OWING_ADD$INT (:ID_PROFILE,
          :SUM_OWING, :CURR_OWING, null, :DUE_DATE,
          :SYSTEM_DATE, :DESCRIPTION, :ID_AR_TYPE, :ID_HOTEL)
  returning_values  (:NEW_ID_AR_OWING);

end
^

/* Restore proc. body: AR_OWING_ANUL$AR */
ALTER PROCEDURE AR_OWING_ANUL$AR(ID_AR_OWING TYPE OF ID,
DESCRIPTION TYPE OF TDESCRIPTION_LONG)
 RETURNS(NEW_ID_AR_OWING TYPE OF ID)
 AS
begin

  execute procedure AR_OWING_ANUL$INT (:ID_AR_OWING, :DESCRIPTION, 1)
  returning_values  (:NEW_ID_AR_OWING);

end
^

/* Restore proc. body: AVAILABILITY_OCCUP_PREPARE$AVL */
ALTER PROCEDURE AVAILABILITY_OCCUP_PREPARE$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS INTEGER,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
declare variable occupancy_session integer;
begin

  execute procedure AVAILABILITY_OCCUPANCY$AVL (:FROM_DATE, :TO_DATE, :FETCH_TOTALS, :HOTELS)
  returning_values :occupancy_session;
   
  execute procedure AVAILABILITY_OCCUPANCY_OPT$AVL (:occupancy_session, :RELEASE_DATES, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT);

end
^

/* Restore proc. body: CONTRACT_EXPENSE_POST$INT */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT TYPE OF ID,
ID_HOTEL INTEGER,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_OWNER TYPE OF ID,
OWNERSHIP_PERCENT TYPE OF TPERCENT,
ID_RENTAL_POOL TYPE OF ID_REF,
VALUE_ORIG TYPE OF TPRICE,
CURR_ORIG TYPE OF TCURRENCY,
POST_DATE TYPE OF TDATE,
STAY TYPE OF TCOUNT,
MAX_GUEST_CNT TYPE OF TCOUNT,
BED_NIGHT_CNT TYPE OF TCOUNT,
RESERVS TYPE OF TCOUNT)
 AS
declare variable service_price numeric(15,4);
  declare variable id_currency varchar(3);
  declare variable contract_expense_type varchar(50);
  declare variable id_account integer;
  declare variable post_value numeric(15,4);
  declare variable post_currency varchar(3);
  declare variable id_service integer;
  declare variable is_owner_income smallint;
  declare variable is_client_acc_post smallint;
  declare variable multiplier_type varchar(50);
  declare variable multiplier integer;
  declare variable id_room integer;
  declare variable use_shadow_account integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
  declare variable id_agent_profile integer;
begin
  is_owner_income = 0;
  use_shadow_account = iif(:SUB_CONTRACT = 'SHADOW_ACC', 1, 0);

  select r.ID_HOTEL, rd.ID_AGENT_PROFILE
  from   PMS_EVENT$PMS p
         join ROOMS R on r.ID_ROOM = p.ID_ROOM
         left outer join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = p.ID_RESERV_DETAIL
  where  p.ID_PMS_EVENT = :ID_PMS_EVENT
  into   :id_hotel, :id_agent_profile;
-- CONTRACT_EXPENSE_TYPE in ( 'PERCENT', 'RUNNING_TOTAL_PERCENT', 'CURR_VALUE' )
-- MULTIPLIER_TYPE in ('RESERVATION', 'STAY', 'GUESTS', 'BED_NIGHTS')
  for
    select C.SERVICE_PRICE, C.ID_CURRENCY, C.CONTRACT_EXPENSE_TYPE, C.IS_ACC_POST_ITEM,
           C.ID_SERVICE, C.MULTIPLIER_TYPE
    from   CONTRACT_EXPENSE$PMS C
    where  C.ID_CONTRACT = :id_contract
           and c.SUB_CONTRACT = :SUB_CONTRACT
           and ((c.id_agent_profile is null) or (c.ID_AGENT_PROFILE = :id_agent_profile))
    order by C.ORDER_TAG asc
    into   :service_price, :id_currency, :contract_expense_type, :is_client_acc_post,
           :ID_SERVICE, :multiplier_type
  do begin

    execute procedure OWNER_ACCOUNT_GET$INT (coalesce(:ID_RENTAL_POOL,:ID_OWNER),
            :id_hotel, :use_shadow_account, :is_client_acc_post)
    returning_values (:id_account, :is_account$pms);

    multiplier = case
                   when :multiplier_type = 'RESERVATION' then iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'STAY' then :STAY
                   when :multiplier_type = 'GUESTS' then :MAX_GUEST_CNT * iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'BED_NIGHTS' then :BED_NIGHT_CNT
                   else null
                 end;

    if (:multiplier is not null) then begin
      if (:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE') then begin
        post_value = cast(:service_price as double precision) * :ownership_percent / 100 * :multiplier;
        post_currency = :id_currency;
      end else if (:CONTRACT_EXPENSE_TYPE = 'PERCENT') then begin
        post_value = :VALUE_ORIG * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end else if (:CONTRACT_EXPENSE_TYPE = 'RUNNING_TOTAL_PERCENT') then begin
        execute procedure PMS_RUNNING_TOTAL_GET(:ID_PMS_EVENT, coalesce(:ID_RENTAL_POOL,:ID_OWNER), :ID_HOTEL,
                iif(:is_account$pms = 0, :id_account, null), iif(:is_account$pms = 1, :id_account, null), :POST_DATE, :CURR_ORIG)
        returning_values :post_value;
        if (:post_value < 0) then post_value = 0;
    
        post_value = :post_value * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end

      select pe.ID_ROOM
      from   PMS_EVENT$PMS PE
      where  pe.ID_PMS_EVENT = :ID_PMS_EVENT
      into   :id_room;

      select c.ROUND_TO
      from   CURRS C
      where  c.CURR = :post_currency
      into   :round_to;

      execute procedure PMS_POSTING_CREATE$INT(:ID_PMS_EVENT, :id_account, :id_service, :ID_OWNER,
              :POST_DATE, :post_currency, round_f(:post_value, :round_to), :is_account$pms, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Restore proc. body: DOCUMENT_GET_CURR_VALUE$DOC */
ALTER PROCEDURE DOCUMENT_GET_CURR_VALUE$DOC(ID_DOC_HEAD INTEGER,
PAY_CURR VARCHAR(3))
 RETURNS(ID_PAY_DOC_DEF INTEGER,
TOTAL_CURR VARCHAR(3),
TOTAL_RATE NUMERIC(15,6),
TOTAL_VALUE NUMERIC(15,4),
REST_VALUE NUMERIC(15,4))
 AS
begin

  execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, :PAY_CURR)
  returning_values :ID_PAY_DOC_DEF, :TOTAL_CURR, :TOTAL_RATE, :TOTAL_VALUE, :REST_VALUE;

  suspend;
end
^

/* Restore proc. body: GUEST_ADDRESSCARD_SET$INT */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$INT(PD_DBKEY CHAR(8),
G_DBKEY CHAR(8),
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
COUNTRY_CODE VARCHAR(10),
IS_CHILD INTEGER,
AGE INTEGER,
BIRTH_DAY DATE,
TITLE VARCHAR(10))
 AS
declare variable rd_dbkey char(8);
  declare variable old_is_child integer;
  declare variable old_birthday date;
  declare variable p_dbkey char(8);
  declare variable old_country_code varchar(10);
  declare variable from_date date;
  declare variable birthday_internal date;
begin

  select G.IS_CHILD, coalesce(:is_child, G.IS_CHILD), RD.RDB$DB_KEY, G.FROM_DATE
  from   GUEST G
         left join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
  where  G.RDB$DB_KEY = :g_dbkey
  into   :old_is_child, :is_child, :rd_dbkey, :from_date;

  select PD.COUNTRY_CODE, PD.BIRTH_DAY, P.RDB$DB_KEY
  from   PERSON_DATA PD
         left outer join PROFILE_PERSON PP on PP.ID_PERSON_DATA = PD.ID_PERSON_DATA
         left outer join PROFILE P on P.ID_PROFILE = PP.ID_PROFILE
  where  PD.RDB$DB_KEY = :pd_dbkey
  into   :old_country_code, :old_birthday, :p_dbkey;

  country_code = coalesce(:country_code, '');

  execute procedure sys_dbg('res GUEST_ADDRESSCARD_SET$INT birth_day = '||coalesce(:birth_day, 'null'));
  execute procedure sys_dbg('res GUEST_ADDRESSCARD_SET$INT old_birthday = '||coalesce(:old_birthday, 'null'));
  execute procedure sys_dbg('res GUEST_ADDRESSCARD_SET$INT age = '||coalesce(:age, 'null'));

  execute procedure GUEST_BIRTHDAY$INT(:birth_day, :age, :old_birthday, :from_date)
  returning_values  :birthday_internal, :birth_day;

  execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :guest_name1, :guest_name2,
          :country_code, :birth_day, :birthday_internal, :TITLE);

  if (:old_is_child <> :is_child) then begin
    update RESERV_DETAIL RD
    set    RD.ADULT_COUNT = RD.ADULT_COUNT + (2*:old_is_child - 1),
           RD.CHILD_COUNT = RD.CHILD_COUNT - (2*:old_is_child - 1)
    where  RD.RDB$DB_KEY = :rd_dbkey;

    update GUEST G
    set    G.IS_CHILD = :is_child
    where  G.RDB$DB_KEY = :g_dbkey;
  end

  if (:old_country_code is distinct from :country_code) then begin
    update RESERV_DETAIL RD
    set    RD.COUNTRY = :country_code
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end
end
^

/* Restore proc. body: HK_ROOM_STATUS$INT */
ALTER PROCEDURE HK_ROOM_STATUS$INT(FOR_DATE DATE,
PRIVATE_STATUS_ADDING SMALLINT = 0)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
SECTOR INTEGER,
ID_ROOM_TYPE INTEGER,
TYPE_ROOM VARCHAR(20),
IS_CLEAN INTEGER,
IS_INSPECTED INTEGER,
CLEAN_TEXT VARCHAR(30),
CLEAN_STATUS VARCHAR(30),
BUSY_DAY SMALLINT,
GUESTS_CNT INTEGER,
LEAVING_GUESTS_CNT INTEGER,
IS_LEAVING SMALLINT,
IS_COMMING SMALLINT,
IS_SHARED SMALLINT,
IS_LEAVING_WORDS VARCHAR(30),
BUSY_GRP INTEGER,
DAYS_THIS_STATUS INTEGER,
DTS_CONTEXT VARCHAR(10),
COMMING_OCCUPANTS VARCHAR(1024),
ID_BLOCK_ROOM INTEGER,
OTHER_OCCUPANTS VARCHAR(1024),
SPECIAL_TREATMENT VARCHAR(1024),
ID_HOTEL INTEGER,
IS_BUSY SMALLINT,
IS_OWNER SMALLINT)
 AS
declare variable from_date date;
declare variable is_expected_leaving integer;
declare variable is_expected_comming integer;
begin
  for
    select ID_ROOM, ROOM_NAME, FLOOR, ID_ROOM_TYPE, TYPE_ROOM, IS_CLEAN, CLEAN_TEXT,
           IS_LEAVING, IS_COMMING, IS_SHARED, IS_LEAVING_WORDS, BUSY_GRP, DAYS_THIS_STATUS,
           DTS_CONTEXT, ID_BLOCK_ROOM, OTHER_OCCUPANTS, ID_HOTEL, SECTOR, IS_INSPECTED,
           COMMING_OCCUPANTS, iif(BUSY_GRP = 0, 0, 1)
    from   REP_ROOM_STATUS$INT(:for_date, '', :private_status_adding) RI
    into   :id_room, :room_name, :floor, :id_room_type, :type_room, :is_clean, :clean_text,
           :is_leaving, :is_comming, :is_shared, :is_leaving_words, :busy_grp, :days_this_status,
           :dts_context, :id_block_room, :other_occupants, :id_hotel, :sector, :is_inspected,
           :comming_occupants, :is_busy
  do begin
    select min(RD.FROM_DATE), sum(RM.ADULT_COUNT + RM.CHILDREN_COUNT),
           sum(RM.GST_AD_OUT + RM.GST_CH_OUT), min(RD.I_SPECIAL_TREATMENT),
           max(iif(RD.ACC_ROUTING = 'OWNER', 1, 0)),
           max(iif(rm.DAY_ACTION containing 'CHECK_IN' and rd.CHECK_STATUS < 0, 1, 0)) as is_expected_comming,
           max(iif(rm.DAY_ACTION containing 'CHECK_OUT' and rd.CHECK_STATUS = 0, 1, 0)) as is_expected_leaving
    from   SYSTEM_STRING_PARSER (:comming_occupants || ',' || :other_occupants, ',') SP
           left outer join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = SP.ITEM
           left outer join ROOM_MAGIC RM on RM.ID_RESERV_DETAIL = RD.ID_RESERV_DETAIL and RM.BUSY_DATE = :for_date
    into   :from_date, :guests_cnt, :leaving_guests_cnt, :special_treatment,
           :is_owner, :is_expected_comming, :is_expected_leaving;
    busy_day = :for_date - :from_date + 1;

    clean_status = '';
    --if (:is_leaving = 1) then clean_status = :clean_status || 'Due/';

    if ((:busy_grp = 0) and (:is_leaving = 0)) then clean_status = :clean_status || 'V/';
    else if (:busy_grp = 1) then begin
      clean_status = :clean_status || 'R/';
      /*if (:is_leaving = 1 and :is_comming <> 1) then begin
        clean_status = :clean_status||'Due/';
      end */
    end else if (:busy_grp in (18, 20)) then clean_status = :clean_status||'B/';
    else clean_status = :clean_status || 'O/';

    if (:is_expected_leaving = 1) then clean_status = :clean_status || 'Due/';
    if (:is_expected_comming = 1) then clean_status = :clean_status || 'Arr/';

    if (:is_clean = 1) then clean_status = :clean_status||'C/';
    else clean_status = :clean_status||'D/';
    suspend;
  end
end
^

/* Restore proc. body: IMPORT_AGENT_PROFILE$EXC */
ALTER PROCEDURE IMPORT_AGENT_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
AGENT_GROUP VARCHAR(50),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
WBE_PASSWORD VARCHAR(20),
IATA_NUMBER VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(2000),
DEF_CONTRAGENT_NAME VARCHAR(100),
THRESHOLD_NOTE VARCHAR(255),
THRESHOLD_AMOUNT NUMERIC(15,4),
THRESHOLD_CURR CHAR(3),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
declare variable op varchar(10);
  declare variable market_segment_id integer;
  declare variable agent_group_old varchar(50);
  declare variable id_bonuspoint_scheme integer;
  declare variable id_def_contragent integer;
  declare variable is_exclusive_debt_ownership smallint;
  declare variable country_code_old varchar(10);
  declare variable profile_receiver_id integer;
  declare variable discount_id integer;
begin
  profile_id = null;
  import_time = null;

  execute procedure import_mark_transaction$exc;

  execute procedure sys_dbg('exc IMPORT_AGENT_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, cast('<null>' as varchar(40)) ) || ')');
  profile_id = null;
  if (:PROFILE_UUID is null) then begin
    execute procedure sys_dbg('exc IMPORT_AGENT_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end

  select p.profile_id, p.profile_name, p.phone, p.fax, p.email, p.city,
         p.address, p.market_segment, p.note, p.is_archive, p.id_bonuspoint_scheme,
         p.id_def_contragent, pa.agent_group, p.wbe_password,
         p.msg, p.account_no, p.is_exclusive_debt_ownership, pa.country_code
  from   IMPORT_COMMON_PROFILE$EXC(:PROFILE_UUID, 1, :PROFILE_NAME,
         :PHONE, :FAX, :EMAIL, :CITY, :ADDRESS, :MARKET_SEGMENT, :NOTE, :IS_ARCHIVE, :WBE_PASSWORD, :ACCOUNT_NO, :MSG,  'AGENT_PROFILE', :HOTEL_UUID_LIST) p
         left outer join PROFILE_AGENT pa on pa.id_profile = p.profile_id
  into   :profile_id, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :id_bonuspoint_scheme,
         :id_def_contragent, :agent_group_old, :wbe_password,
         :msg, :account_no, :is_exclusive_debt_ownership, :country_code_old;

  if (:profile_id is null) then begin
    op = 'add';
  end else if (:hotel_uuid_list is null) then begin
    profile_id = null;
    exit;
  end else begin
    op = 'mod';
    if (:hotel_uuid_list is not null) then begin
      for
        select d.id_sale_discount
        from   SALE_DISCOUNT d
               join HOTEL h on h.id_hotel = d.id_hotel
        where  :hotel_uuid_list containing h.uuid
        into   :discount_id
      do begin
        delete from PROFILE_DISCOUNT pd
        where  pd.ID_PROFILE = :profile_id
               and pd.id_sale_discount = :discount_id;
      end
    end

    delete from PROFILE_BONUSPOINT_SCHEME bs
    where  bs.ID_PROFILE = :profile_id;
  end

  AGENT_GROUP=coalesce(:AGENT_GROUP, :AGENT_GROUP_OLD);
  country_code=coalesce(:country_code, :country_code_old);

  execute procedure LOOKUP_MARKET_SEGMENT$EXC(:profile_name, 'AGENT_PROFILE', :market_segment)
  returning_values :market_segment_id;

  if ((def_contragent_name is not null) and (def_contragent_name <> '')) then begin
    execute procedure LOOKUP_CONTRAGENT$EXC(:profile_name, 'AGENT_PROFILE', :def_contragent_name)
    returning_values :id_def_contragent;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:profile_name, 'AGENT_PROFILE');

  execute procedure sys_dbg('exc IMPORT_AGENT_PROFILE$EXC - profile_agent_modify$profile(:profile_uuid=>' || coalesce(:profile_uuid,cast('<null>' as varchar(40)))
    || ', :operation=>' || coalesce(:op, cast('<null>' as varchar(10)) )
    || ', :market_segment_id=>' || coalesce(cast(:market_segment_id as varchar(10)) , cast('<null>' as varchar(10)) )
    || ')');

  if (:hotel_uuid_list is null) then begin
    -- in "non authoritive" mode (i.e. embeded mode transfer only profile key fields )
    --profile_name = null;
    phone = null;
    fax = null;
    email = null;
    country_code = null;
    city = null;
    address = null;
    note = null;
    msg = null;
    --is_archive = null;
    agent_group = null;
    id_def_contragent = null;
    market_segment_id = null;
    id_bonuspoint_scheme = null;
    wbe_password = null;
    account_no = null;
    --iata_number = null;
    is_exclusive_debt_ownership = null;
  end

  execute procedure profile_agent_modify$profile(
    :profile_id, :profile_name, :phone, :fax, :email,
    :country_code, :city, :address, :note, :msg, :is_archive, :agent_group, :id_def_contragent, :market_segment_id,
    :wbe_password, :op, :account_no, :iata_number, :is_exclusive_debt_ownership,
    :threshold_note, :threshold_amount, :threshold_curr)
  returning_values :profile_id;

  /*assign UUID to the new profiles*/
  if ('add' = :op) then begin
    update profile
    set    uuid = :profile_uuid
    where  id_profile = :profile_id;
  end

  select record_timestamp
  from   profile
  where  id_profile = :profile_id
  into   :import_time;

  if (:MERGE_TARGET_UUID is not null) then begin
    select p.ID_PROFILE
    from   PROFILE P
    where  P.UUID = :MERGE_TARGET_UUID
    into   :profile_receiver_id;

    execute procedure PROFILE_MERGE$PROFILE (:PROFILE_ID, :profile_receiver_id, 'merge');

  end
end
^

/* Restore proc. body: IMPORT_BOOKING_CUSTOM_PRICE$EXC */
ALTER PROCEDURE IMPORT_BOOKING_CUSTOM_PRICE$EXC(ID_RESERV_DETAIL INTEGER,
FOR_DATE DATE,
PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3))
 AS
begin
  execute procedure RES_SAVE_PRICE$RSV(:ID_RESERV_DETAIL, :FOR_DATE, :PRICE, :PRICE_CURRENCY);

  /*Maintain the flag in RD - HAS_DIFFERENT_PRICE*/
  if (exists (select * from RESERV_CUSTOM_PRICE rmp where rmp.id_reserv_detail = :id_reserv_detail)) then
    update RESERV_DETAIL set has_different_price = 1 where id_reserv_detail = :id_reserv_detail;
  else
    update RESERV_DETAIL set has_different_price = 0 where id_reserv_detail = :id_reserv_detail;

end
^

/* Restore proc. body: IMPORT_PERSON_PROFILE$EXC */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(2000),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
declare variable op varchar(10);
  declare variable market_segment_id integer;
  declare variable sex_old char(1);
  declare variable birth_date_old date;
  declare variable birth_place_old varchar(30);
  declare variable personal_number_old varchar(30);
  declare variable pass_num_old varchar(20);
  declare variable pass_date_old date;
  declare variable pass_place_old varchar(20);
  declare variable pass_exp_date_old date;
  declare variable pass_city_old varchar(100);
  declare variable pass_address_old varchar(100);
  declare variable country_old varchar(10);
  declare variable mask_old varchar(10);
  declare variable title_old varchar(10);
  declare variable id_photo integer;
  declare variable id_def_contragent integer;
  declare variable id_passport_type integer;
  declare variable account_no_old varchar(20);
  declare variable msg_old varchar(2000);
  declare variable id_guest_type integer;
  declare variable id_guest_type_old integer;
  declare variable card_code_old varchar(50);
  declare variable is_exclusive_debt_ownership smallint;
  declare variable profile_receiver_id integer;
begin
  profile_id = null;
  import_time = null;

  execute procedure import_mark_transaction$exc;

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, '<null>')
                          || ', email=>' || coalesce(:email, '<null>') || ')');

  profile_id = null;
  if (profile_uuid is null) then begin
    execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end

  select p.profile_id, p.profile_name, p.phone, p.fax, p.email, p.city,
         p.address, p.market_segment, p.note, p.is_archive, pp.card_code,
         pd.sex, pd.birthday_internal, pd.birth_place, pd.egn, pd.pass_num,
         pd.pass_date, pd.pass_place, pd.pass_exp_date, pd.city, pd.address, pd.country_code,
         pd.mask, p.id_def_contragent, p.wbe_password,
         pd.title, p.account_no, p.msg, pp.id_guest_type, pp.id_photo, pd.id_passport_type,
         p.is_exclusive_debt_ownership
  from   import_common_profile$exc(:profile_uuid, 0, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :wbe_password, :ACCOUNT_NO, :MSG, 'PERSON_PROFILE', :HOTEL_UUID_LIST) p
         left outer join profile_person pp on pp.id_profile = p.profile_id
         left outer join person_data pd on pd.id_person_data=pp.id_person_data
  into   :profile_id, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :card_code_old,
         :sex_old, :birth_date_old, :birth_place_old, :personal_number_old, :pass_num_old,
         :pass_date_old, :pass_place_old, :pass_exp_date_old, :pass_city_old, :pass_address_old, :country_old,
         :mask_old, :id_def_contragent, :wbe_password, :title_old,
         :account_no_old, :msg_old, :id_guest_type_old, :id_photo, :id_passport_type, :is_exclusive_debt_ownership;

  if (:profile_id is null) then begin
    op = 'add';
  end else if (:hotel_uuid_list is null) then begin
    profile_id = null;
    exit;
  end else begin
    op = 'mod';
    delete from PROFILE_BONUSPOINT_SCHEME bs
      where bs.ID_PROFILE = :profile_id;
  end

  sex=coalesce(:sex, :sex_old);
  birth_date=coalesce(:birth_date, :birth_date_old);
  birth_place=coalesce(:birth_place, :birth_place_old);
  personal_number=coalesce(:personal_number, :personal_number_old);
  pass_num=coalesce(:pass_num, :pass_num_old);
  pass_date=coalesce(:pass_date, :pass_date_old);
  pass_place=coalesce(:pass_place, :pass_place_old);
  pass_exp_date=coalesce(:pass_exp_date, :pass_exp_date_old);
  pass_city=coalesce(:pass_city, :pass_city_old);
  pass_address=coalesce(:pass_address, :pass_address_old);
  country=upper(coalesce(:country, :country_old));
  mask=coalesce(:mask, :mask_old);
  title=coalesce(:title, :title_old);
  account_no=coalesce(:account_no, :account_no_old);
  msg=coalesce(:msg, :msg_old);
  card_code=coalesce(:card_code, :card_code_old);

  execute procedure IMPORT_PASSPORT_TYPE$EXC(:pass_type_name, :pass_type_external_code)
  returning_values :id_passport_type;

  execute procedure lookup_market_segment$exc(:profile_name, 'PERSON_PROFILE', :market_segment)
  returning_values :market_segment_id;

  if (guest_type_name is not null) then begin
    execute procedure lookup_guest_type$exc(:profile_name, 'PERSON_PROFILE', :guest_type_name)
    returning_values :id_guest_type;
  end

  if ((def_contragent_name is not null) and (def_contragent_name <> '')) then begin
    execute procedure LOOKUP_CONTRAGENT$EXC(:profile_name, 'PERSON_PROFILE', :def_contragent_name)
    returning_values :id_def_contragent;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:profile_name, 'PERSON_PROFILE');

  id_guest_type=coalesce(:id_guest_type, :id_guest_type_old);

  if (id_photo is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, null, null, null, 'del')
    returning_values :id_photo;
  end
  id_photo = null;
  if (picture is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, :picture, :picture_type, :picture_layout, 'add')
    returning_values :id_photo;
  end

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC - profile_person_modify$profile(:profile_uuid=>'
    || coalesce(:profile_uuid, '<null>')
    || ', :operation=>' || coalesce(:op, '<null>')
    || ', :email=>' || coalesce(:email, '<null>')
    || ', :birth_date=>' || coalesce(:birth_date, '<null>')
  || ')');
  execute procedure profile_person_modify$profile(
    :profile_id,
    :id_guest_type,
    :profile_name,
    null,
    :sex,
    :birth_date,
    :birth_place,
    :personal_number,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :pass_place,
    :pass_exp_date,
    :country,
    :pass_city,
    :pass_address,
    :mask,
    :phone,
    :fax,
    :email,
    :city,
    :address,
    :note,
    :msg,
    :id_def_contragent,
    :market_segment_id,
    :is_archive,
    :id_photo,
    :card_code,
    :wbe_password,
    :op,
    :account_no,
    :title,
    :is_exclusive_debt_ownership
  ) returning_values
    :profile_id;

  /*assign uuid to the new profiles*/
  if ('add' = :op) then begin
    update profile set uuid=:profile_uuid where id_profile=:profile_id;
  end

  select record_timestamp from profile where id_profile=:profile_id
  into :import_time;

  if (:MERGE_TARGET_UUID is not null) then begin
    select p.ID_PROFILE
    from   PROFILE P
    where  P.UUID = :MERGE_TARGET_UUID
    into   :profile_receiver_id;

    execute procedure PROFILE_MERGE$PROFILE (:PROFILE_ID, :profile_receiver_id, 'merge');

  end

end
^

/* Restore proc. body: MONITOR_ROOM_GANT$HM */
ALTER PROCEDURE MONITOR_ROOM_GANT$HM(FROM_DATE DATE,
TO_DATE DATE,
IN_ROOM_NAME VARCHAR(10),
IN_ID_ROOM_TYPE INTEGER,
IN_FLOOR INTEGER,
ID_HOTEL INTEGER)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(20),
GANT_FROM_DATE DATE,
GANT_TO_DATE DATE,
BUSY_GRP INTEGER)
 AS
declare variable id_occupant integer;
begin
  for
    select R.ID_ROOM, R.ROOM_NAME
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  RT.ID_HOTEL = :id_hotel
           and ((R.ID_ROOM_TYPE = :in_id_room_type) or (:in_id_room_type = -1))
           and ((:in_room_name = '') or (r.room_name like :in_room_name))
           and ((:in_floor = -1) or (R.FLOOR = :in_floor))
    order by R.ROOM_NAME
    into :id_room, :room_name
  do begin
    gant_from_date = null;
    gant_to_date = null;
    busy_grp = null;
    suspend;

    for
      select distinct
             RM.ID_RESERV_DETAIL, RM.BUSY_GROUP_TYPE
      from   ROOM_MAGIC RM
      where  RM.BUSY_DATE between :from_date and :to_date
             and RM.ID_ROOM = :id_room
      into   :id_occupant, :busy_grp
    do begin
      select O.FROM_DATE, O.TO_DATE
      from   OCCUPANT_GET_INFO(:id_occupant, :busy_grp) O
      into   :gant_from_date, :gant_to_date;

      suspend;
    end
  end
end
^

/* Restore proc. body: MONITOR_ROOM_STATUS$HM */
ALTER PROCEDURE MONITOR_ROOM_STATUS$HM(FOR_DATE DATE)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
SECTOR INTEGER,
ID_ROOM_TYPE INTEGER,
TYPE_ROOM VARCHAR(20),
IS_CLEAN INTEGER,
IS_INSPECTED INTEGER,
CLEAN_TEXT VARCHAR(30),
IS_LEAVING SMALLINT,
IS_COMMING SMALLINT,
IS_SHARED SMALLINT,
IS_LEAVING_WORDS VARCHAR(30),
BUSY_GRP INTEGER,
DAYS_THIS_STATUS INTEGER,
DTS_CONTEXT VARCHAR(10),
COMMING_OCCUPANTS VARCHAR(1024),
ID_BLOCK_ROOM INTEGER,
OTHER_OCCUPANTS VARCHAR(1024),
ID_HOTEL INTEGER,
HAS_OPENED_POSTINGS SMALLINT)
 AS
begin

  for
    select ID_ROOM, ROOM_NAME, FLOOR, SECTOR, ID_ROOM_TYPE, TYPE_ROOM, IS_CLEAN, IS_INSPECTED, CLEAN_TEXT,
           IS_LEAVING, IS_COMMING, IS_SHARED, IS_LEAVING_WORDS, BUSY_GRP, DAYS_THIS_STATUS, DTS_CONTEXT,
           COMMING_OCCUPANTS, ID_BLOCK_ROOM, OTHER_OCCUPANTS, ID_HOTEL, HAS_OPENED_POSTINGS
    from   REP_ROOM_STATUS$INT(:for_date, 'DAYS_THIS_STATUS')
    into   :id_room, :room_name, :floor, :sector, :id_room_type, :type_room, :is_clean, :is_inspected, :clean_text,
           :is_leaving, :is_comming, :is_shared, :is_leaving_words, :busy_grp, :days_this_status, :dts_context,
           :comming_occupants, :id_block_room, :other_occupants, :id_hotel, :has_opened_postings
  do begin
    suspend;
  end
end
^

/* Restore proc. body: OWNER_BILL_MODIFY$PMS */
ALTER PROCEDURE OWNER_BILL_MODIFY$PMS(ID_OWNER_BILL INTEGER,
ID_OWNER INTEGER,
BILLING_DATE DATE,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_OWNER_BILL INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_anul smallint;
  declare variable bill_num integer;
  declare variable id_account_post_pms integer;
  declare variable id_account_post integer;
  declare variable prev_id_owner_bill integer;
  declare variable prev_billing_date date;

  declare variable id_account integer;
  declare variable id_account_pms integer;
  declare variable value_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable value_post numeric(15,4);
  declare variable curr_post varchar(3);
  declare variable is_owner_income smallint;
  declare variable id_service integer;
  declare variable id_room integer;
  declare variable date_post date;
  declare variable id_reserv_detail integer;
  declare variable doc_description varchar(255);
  declare variable id_doc_head integer;
  declare variable description varchar(255);
  declare variable id_pms_event integer;
  declare variable is_client_account_post smallint;
begin
  err_code = 0;
  err_text = '';
  is_client_account_post = null;
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'create, anul');

  if ( exists ( select *
                from   OWNER$PMS O
                where  O.ID_OWNER = :ID_OWNER
                       and O.ID_RENTAL_POOL_UNIT is not null ) ) then
  begin
    exception PMS_EXCEPTION 'selected owner is pool!';
  end

  if (:operation = 'create') then begin
    is_anul = 0;

    if ( (:ID_OWNER_BILL is null) or (:ID_OWNER_BILL <= 0) )  then
      NEW_ID_OWNER_BILL = gen_id(GEN_OWNER_BILL$PMS_ID, 1);
    else
      NEW_ID_OWNER_BILL = :ID_OWNER_BILL;

    BILL_NUM = :NEW_ID_OWNER_BILL;
    insert into OWNER_BILL$PMS (ID_OWNER_BILL, ID_OWNER, BILL_DATE, IS_ANUL, BILL_NUM,
           IS_EXPORTED_TO_INTRANET, IS_POOL_DISTRIBUTION_STATEMENT)
    values (:NEW_ID_OWNER_BILL, :ID_OWNER, :BILLING_DATE, :IS_ANUL, :BILL_NUM, 0, 0);

    update OWNER$PMS O
    set    O.LAST_BILLING_DATE = :billing_date,
           O.ID_OWNER_BILL = :NEW_ID_OWNER_BILL
    where  O.ID_OWNER = :ID_OWNER;

    for
    /*  select ID_ACCOUNT_POST, ID_ACCOUNT_POST_PMS
      from   PMS_ACC_POST_TO_BILL_GET$INT(:ID_OWNER, null, '01.01.1500', :BILLING_DATE, 1)
      into   :ID_ACCOUNT_POST, :ID_ACCOUNT_POST_PMS */
      select   OP.ID_ACCOUNT_POST, OP.ID_ACCOUNT_POST$PMS
      from     OWNER_POST OP
      where    OP.ID_OWNER = :id_owner
               and OP.POST_DATE between cast('01.01.1500' as date) and :billing_date
               and OP.IS_ANUL = 0
      order by OP.ID_ACCOUNT_POST$PMS nulls last
      into     :ID_ACCOUNT_POST, :ID_ACCOUNT_POST_PMS
    do begin
      if (:id_account_post_pms is not null) then begin

        update ACCOUNT_POST$PMS A
        set    A.LINE_STATUS = 21
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS;

        id_account = null;
        select ACC.ID_SERVICE, ACC.VALUE_ORIG, ACC.CURR_ORIG, ACC.VALUE_POST, ACC.CURR_POST,
               ACC.IS_OWNER_INCOME, ACC.DATE_POST, ACC.ID_ACCOUNT_PMS, E.ID_ROOM,
               E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION, A.IS_CLIENT_POOL_ACCOUNT
        from   ACCOUNT_POST$PMS ACC
               join ACCOUNT$PMS A on A.ID_ACCOUNT = ACC.ID_ACCOUNT_PMS
               join PMS_EVENT$PMS E on E.ID_PMS_EVENT = ACC.ID_PMS_EVENT
        where  ACC.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
        into   :ID_SERVICE, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
               :IS_OWNER_INCOME, :DATE_POST, :ID_ACCOUNT_PMS, :ID_ROOM,
               :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION, :is_client_account_post;
      end

      if (:id_account_post is not null) then begin
        exception PMS_EXCEPTION '-613';
          
        is_client_account_post = 1;
        update PMS_EVENT_POST A
        set    A.LINE_STATUS = 21
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST;

        id_account_pms = null;
        select ACC.ID_SERVICE, ACC.PRICE_ORIG, ACC.CURR_ORIG, ACC.PRICE_POST, ACC.CURR_POST,
               0, ACC.DATE_POST, ACC.ID_ACCOUNT, E.ID_ROOM,
               E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION
        from   ACCOUNT_POST ACC
               join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = ACC.ID_ACCOUNT_POST
               join PMS_EVENT$PMS E on E.ID_PMS_EVENT = PP.ID_PMS_EVENT
        where  ACC.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
        into   :ID_SERVICE, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
               :IS_OWNER_INCOME, :DATE_POST, :ID_ACCOUNT, :ID_ROOM,
               :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION;
      end

      insert into OWNER_BILL_ROW$PMS (ID_OWNER_BILL, ID_ACCOUNT_POST,
             ID_ACCOUNT, ID_ACCOUNT_POST_PMS, ID_ACCOUNT_PMS, ID_SERVICE, VALUE_ORIG,
             CURR_ORIG, VALUE_POST, CURR_POST, IS_OWNER_INCOME, ID_ROOM, DATE_POST,
             ID_RESERV_DETAIL, DOC_DESCRIPTION, ID_DOC_HEAD, DESCRIPTION, IS_CLIENT_ACCOUNT_POST)
      values (:new_id_owner_bill, :ID_ACCOUNT_POST, :ID_ACCOUNT,
             :ID_ACCOUNT_POST_PMS, :ID_ACCOUNT_PMS, :ID_SERVICE, :VALUE_ORIG,
             :CURR_ORIG, :VALUE_POST, :CURR_POST, :IS_OWNER_INCOME, :ID_ROOM, :DATE_POST,
             :ID_RESERV_DETAIL, :DOC_DESCRIPTION, :ID_DOC_HEAD, :DESCRIPTION, :is_client_account_post);
    end
  end
  if (:operation = 'anul') then begin
    select O.ID_OWNER, O.IS_ANUL
    from   OWNER_BILL$PMS O
    where  O.ID_OWNER_BILL = :ID_OWNER_BILL
    into   :id_owner, :is_anul;
    if (:is_anul = 1) then exit;

    select first 1 B.ID_OWNER_BILL
    from   OWNER_BILL$PMS B
    where  B.ID_OWNER = :id_owner
           and B.IS_ANUL = 0
    order by B.BILL_DATE desc
    into   :prev_id_owner_bill;
    if (:prev_id_owner_bill <> :id_owner_bill) then exception PMS_EXCEPTION '-619';

    select first 1 O.ID_OWNER_BILL, O.BILL_DATE
    from   OWNER_BILL$PMS O
    where  O.ID_OWNER = :ID_OWNER
           and o.IS_ANUL = 0
           and O.ID_OWNER_BILL <> :ID_OWNER_BILL
    order by O.BILL_DATE desc
    into   :prev_id_owner_bill, :prev_billing_date;

    update OWNER$PMS O
    set    O.LAST_BILLING_DATE = :prev_billing_date,
           O.ID_OWNER_BILL = :prev_id_owner_bill
    where  O.ID_OWNER = :ID_OWNER;

    update OWNER_BILL$PMS B
    set    B.IS_EXPORTED_TO_INTRANET = 0,
           B.IS_ANUL = 1
    where  B.ID_OWNER_BILL = :ID_OWNER_BILL;

    for
      select O.ID_ACCOUNT_POST, O.ID_ACCOUNT_POST_PMS
      from   OWNER_BILL_ROW$PMS O
      where  O.ID_OWNER_BILL = :ID_OWNER_BILL
      into   :id_account_post, :id_account_post_pms
    do begin
      if (:id_account_post_pms is not null) then begin
        update ACCOUNT_POST$PMS A
        set    A.LINE_STATUS = 11
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
               and A.LINE_STATUS = 21;
      end

      if (:id_account_post is not null) then begin
        update PMS_EVENT_POST A
        set    A.LINE_STATUS = 11
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and A.LINE_STATUS = 21;
      end
    end

    for
      select distinct AP.ID_PMS_EVENT
      from   OWNER_BILL_ROW$PMS R
             join OWNER_BILL$PMS B on B.ID_OWNER_BILL = R.ID_OWNER_BILL
             join ACCOUNT_POST$PMS AP on AP.ID_ACCOUNT_POST = R.ID_ACCOUNT_POST_PMS
             join PMS_EVENT$PMS E on E.ID_PMS_EVENT = AP.ID_PMS_EVENT
      where  R.ID_OWNER_BILL = :ID_OWNER_BILL
             and E.EVENT_TYPE = 'POOL_DISTRIBUTION'
             and B.IS_POOL_DISTRIBUTION_STATEMENT = 1
      into   :id_pms_event
    do begin
      execute procedure PMS_EVENT_VOID$INT(:id_pms_event);
    end
  end
end
^

/* Restore proc. body: PMS_EVENT_ANUL$PMS */
ALTER PROCEDURE PMS_EVENT_ANUL$PMS(ID_PMS_EVENT INTEGER)
 AS
begin
  execute procedure PMS_EVENT_VOID$INT(:id_pms_event);
end
^

/* Restore proc. body: PMS_EXPENSE_POSTS_CREATE$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM TYPE OF ID,
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
POST_VALUE TYPE OF TPRICE,
IS_CLIENT_ACC_POST TYPE OF TLOGICAL,
MANUAL_POST_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_POST_PER_POOL TYPE OF TLOGICAL)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF,
NEW_ID_ACCOUNT_POST$PMS ID_REF)
 AS
declare variable event_type varchar(30);
  declare variable id_room_contract integer;
  declare variable new_id_pms_event integer;
  declare variable round_to_orig numeric(15,6);
  declare variable ownership_percent numeric(15,4);
  declare variable curr_contract_owner integer;
  declare variable curr_total_ownership numeric(15,4);
  declare variable curr_total_value numeric(15,4);
  declare variable percent_value numeric(15,4);
  declare variable id_account integer;
  declare variable id_hotel integer;
  declare variable is_account$pms integer;
  declare variable id_acc_post integer;
BEGIN
  event_type = 'MANUAL_EXPENSE';
  curr_total_value = 0;
  curr_total_ownership = 0;

  select RC.ID_ROOM_CONTRACT, r.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS P on RC.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
         join ROOMS R on R.ID_ROOM = p.ID_ROOM
  where  :MANUAL_POST_DATE between P.FROM_DATE and P.TO_DATE
         and P.ID_ROOM = :ID_ROOM
         and P.STATUS in ('PRIVATE','CONTRACT')
  into   :id_room_contract, :id_hotel;

  if (:ID_ROOM_CONTRACT is null) then exception PMS_EXCEPTION '-615';

  execute procedure PMS_EVENT_CREATE$INT(:EVENT_TYPE, :ID_ROOM, :ID_OWNER, :DESCRIPTION,
          :MANUAL_POST_DATE, null, null, null, null, :POST_VALUE, :POST_VALUE, :ID_CURRENCY, null, :id_room_contract)
  returning_values :new_id_pms_event;

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :ID_CURRENCY
  into   :round_to_orig;

  for
    select iif(:ID_OWNER is null, O.OWNERSHIP_PERCENT, 100), O.ID_OWNER
    from   ROOM_CONTRACT$PMS RC
           join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = RC.ID_ROOM_CONTRACT
    where  RC.ID_ROOM_CONTRACT = :id_room_contract
           and ((:ID_OWNER is null) or (O.ID_OWNER = :ID_OWNER))
    into   :ownership_percent, :curr_contract_owner
  do begin
    curr_total_ownership = :curr_total_ownership + :ownership_percent;
    if (:curr_total_ownership = 100) then begin
      percent_value = :post_value - :curr_total_value;
    end else
      percent_value = round_f(:post_value * :ownership_percent / 100, :round_to_orig);

    curr_total_value = :curr_total_value + :percent_value;

    execute procedure OWNER_ACCOUNT_GET$INT (iif(:is_post_per_pool = 1, :id_rental_pool, :curr_contract_owner),
            :id_hotel, 0, :IS_CLIENT_ACC_POST)
    returning_values (:id_account, :is_account$pms);

    execute procedure PMS_POSTING_CREATE$INT(:new_id_pms_event, :ID_ACCOUNT, :ID_SERVICE,
            :curr_contract_owner, :MANUAL_POST_DATE, :ID_CURRENCY, :PERCENT_VALUE, :is_account$pms, 0, :ID_ROOM)
    returning_values :id_acc_post;

    new_id_account_post = null;
    new_id_account_post$pms = null;

    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 1)) then new_id_account_post$pms = :id_acc_post;
    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 0)) then new_id_account_post = :id_acc_post;
    suspend;
  end

  execute procedure PMS_EVENT_SET_ACTIVE$INT(:new_id_pms_event);
END
^

/* Restore proc. body: PMS_POOL_DISTRIBUTION_SUB */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
declare variable cnt_room smallint;
  declare variable curr_total_posted numeric(15,4);
  declare variable cnt integer;
  declare variable value_to_post numeric(15,4);
  declare variable value_to_post_per_owner numeric(15,4);
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable id_room_contract integer;
  declare variable id_owner_account integer;
  declare variable id_pms_event integer;
  declare variable id_hotel integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  select c.ROUND_TO
  from   CURRS c
  where  c.CURR = :CURR
  into   :round_to;

  cnt_room = 0;
  select count(distinct RP.ID_ROOM)
  from   ROOM_PERIOD$PMS RP
         join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
  where  RC.ID_RENTAL_POOL = :id_rental_pool
         and RP.STATUS in ('PRIVATE','CONTRACT')
         and RP.FROM_DATE <= :FOR_DATE
         and RP.TO_DATE >= :FOR_DATE
  into   :cnt_room;

  if (:cnt_room = 0) then exception PMS_EXCEPTION 'The pool has not assigned room contracts for selected date (' || :FOR_DATE || ') !';

  if (:is_room_pool = 1) then begin
    curr_total_posted = 0;
    cnt = 0;
    id_pms_event = null;
    id_hotel = null;
    for
      select distinct RP.ID_ROOM, RC.ID_ROOM_CONTRACT, R.ID_HOTEL
      from   ROOM_PERIOD$PMS RP
             join ROOMS R on R.ID_ROOM = RP.ID_ROOM
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.FROM_DATE <= :FOR_DATE
             and RP.TO_DATE >= :FOR_DATE
      into   :id_room, :id_room_contract, :id_hotel
    do begin
      id_pms_event = null;

      select E.ID_PMS_EVENT
      from   PMS_EVENT$PMS E
      where  E.ID_ROOM = :id_room
             and E.ID_SESSION = current_transaction
      into   :ID_PMS_EVENT;

      if (:ID_PMS_EVENT is null) then begin
        execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, :id_room_contract)
        returning_values :id_pms_event;
        -- FIXME nakraq da se update total_event_value
      end
      if (:cnt_room - :cnt = 1) then begin
        value_to_post = :TOTAL_VALUE_PER_SERVICE - :curr_total_posted;
      end else begin
        value_to_post = round_f(:TOTAL_VALUE_PER_SERVICE / :cnt_room, :round_to);
      end

      curr_total_posted = :curr_total_posted + :value_to_post;
      cnt = :cnt + 1;

      /* ...i se razpredelq mejdu sobstwenicite na staqta */
      value_to_post = abs(:value_to_post);
      for
        select R.ID_OWNER, R.OUT_VALUE
        from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
        into   :id_owner, :value_to_post_per_owner
      do begin
        /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_pool_account,
                :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                1, :IS_OWNER_INCOME, :id_room)
        returning_values :no_use_id_acc_post;
        /* ... i se nachislqwa po sobswtenik */
        execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
        returning_values (:id_owner_account, :is_account$pms);

        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                :is_account$pms, :is_owner_income, :id_room)
        returning_values :no_use_id_acc_post;
      end
    end
  end else begin
    /* distribution by room_param */
    insert into TMP_SELECT$PMS(ID_SESSION, ID_ROOM, ID_OWNER)
    select distinct current_transaction, RP.ID_ROOM, null
    from   ROOM_PERIOD$PMS RP
           join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
    where  RC.ID_RENTAL_POOL = :ID_RENTAL_POOL
           and RP.STATUS in ('PRIVATE','CONTRACT')
           and RP.FROM_DATE <= :FOR_DATE
           and RP.TO_DATE >= :FOR_DATE;

    id_hotel = null;
    for
      select P.OUT_VALUE, P.OUT_ID_ROOM, R.ID_HOTEL
      from   PMS_CALC_VALUE_BY_PARAM(:ID_ROOM_PARAM, :TOTAL_VALUE_PER_SERVICE, :round_to) P
             join ROOMS R on R.ID_ROOM = P.OUT_ID_ROOM
      into   :value_to_post, :id_room, :id_hotel
    do begin
      id_pms_event = null;
      id_room_contract = null;
      -- room contract must be only one for this period
      select RC.ID_ROOM_CONTRACT
      from   ROOM_PERIOD$PMS RP
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.ID_ROOM = :id_room
             and :for_date between RP.FROM_DATE and RP.TO_DATE
      into   :id_room_contract;

      if (:id_room_contract is not null) then begin
        select E.ID_PMS_EVENT
        from   PMS_EVENT$PMS E
        where  E.ID_ROOM = :id_room
               and E.ID_SESSION = current_transaction
        into   :ID_PMS_EVENT;
  
        if (:ID_PMS_EVENT is null) then begin
          execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                  'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, id_room_contract)
          returning_values :id_pms_event;
          -- FIXME nakraq da se update total_event_value
        end
  
        /* ...i se razpredelq mejdu sobstwenicite na staqta */
        for
          select R.ID_OWNER, R.OUT_VALUE
          from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
          into   :id_owner, :value_to_post_per_owner
        do begin
          /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :ID_POOL_ACCOUNT,
                  :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                  1, :IS_OWNER_INCOME, :id_room)
          returning_values :no_use_id_acc_post;
  
          /* ... i se nachislqwa po sobswtenik */
          execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
          returning_values (:id_owner_account, :is_account$pms);

          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                  :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                  :is_account$pms, :is_owner_income, :id_room)
          returning_values :no_use_id_acc_post;
        end
      end
    end

    delete from TMP_SELECT$PMS T
    where  T.ID_SESSION = current_transaction;
  end
end
^

/* Restore proc. body: PRODUCT_RATING$INT */
ALTER PROCEDURE PRODUCT_RATING$INT(ID_HOTEL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
ADULT_AGES VARCHAR(100) = null,
CHILD_AGES VARCHAR(100) = null,
ID_TAR_CALC_COMMON INTEGER = null)
 RETURNS(ROOM_PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100))
 AS
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable id_reserv integer;
declare variable id_tar_calc integer;
declare variable rate_currency char(3);
begin
  id_tar_calc = null;
  select T.CURR
  from   TARIFA T
  where  t.ID_TARIFA = :ID_RATE
  into   :rate_currency;

  execute procedure TAR_CALC_INPUT_PLAIN$INT (:adult_count, :children_count,
          :id_room_type, :id_board, :arrival_date, :departure_date,
          '', '', null, '', null, null, :id_rate, :adult_ages, :child_ages, :ID_TAR_CALC_COMMON)
  returning_values (:id_tar_calc, :id_reserv, :err_code, :err_text);
  --if (:err_code < 0) then exit;

  if (:err_code = 0) then begin
    execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
    returning_values  :err_code, :err_text;
    /*savedbg('-----------------------------');
    savedbg('id_rate: ' || :id_rate);
    savedbg('id_board: ' || :id_board);
    savedbg('id_room_type: ' || :id_room_type);
    savedbg('id_tar_calc: ' || :id_tar_calc);
    savedbg('err_code: ' || :ERR_CODE);
    savedbg('err_text: ' || :ERR_TEXT);
    */
    if (:err_code = 0) then begin
      execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

      price_currency = :rate_currency;
      execute procedure TAR_CALC_GET_PRICE$INT (:id_tar_calc, :id_hotel, :id_reserv, :price_currency)
      returning_values  :room_price, :room_price_details;
    end
  end
end
^

/* Restore proc. body: RES_FINALIZE$INT */
ALTER PROCEDURE RES_FINALIZE$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable err_text varchar(255);
begin
  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, :SUPPRESS_NON_INSTANT_ERRORS)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;
  if (:share_err_code < 0) then exception BOOKING_EXCEPTION :share_err_code || f_character(31) || :ERR_TEXT;
end
^

/* Restore proc. body: RES_FINALIZE_RECALC$INT */
ALTER PROCEDURE RES_FINALIZE_RECALC$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_calc integer;
begin
  -- NORMAL recalculation processing
  execute procedure RES_RECALC$INT(:rd_dbkey, 'NORMAL', 0)
  returning_values  :err_code, :err_text, :id_tar_calc;
  if (:err_code < 0) then exit;

end
^

/* Restore proc. body: RES_SAVE_EATING_OBJECT$RSV */
ALTER PROCEDURE RES_SAVE_EATING_OBJECT$RSV(ID_RESERV_DETAIL TYPE OF ID,
ID_EATING_OBJECT TYPE OF ID_REF)
 AS
declare variable transfer_in_time time;
  declare variable transfer_in_note varchar(255);
  declare variable transfer_out_time time;
  declare variable transfer_out_note varchar(255);
  declare variable rd_dbkey char(8);
  declare variable code_first_food type of tfood_code;
begin
  select RD.RDB$DB_KEY, RD.TRANSFER_IN_TIME, RD.TRANSFER_IN_NOTE,
         RD.TRANSFER_OUT_TIME, RD.TRANSFER_OUT_NOTE, rd.CODE_FIRST_FOOD
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :transfer_in_time, :transfer_in_note,
         :transfer_out_time, :transfer_out_note, :code_first_food;

  execute procedure RESGRP_SAVE_OTHER$INT(:rd_dbkey, :transfer_in_time, :transfer_in_note,
          :transfer_out_time, :transfer_out_note, :code_first_food, :id_eating_object);
  --
end
^

/* Restore proc. body: RES_SAVE_OTHER$RSV */
ALTER PROCEDURE RES_SAVE_OTHER$RSV(ID_RESERV_DETAIL INTEGER,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE)
 AS
declare variable rd_dbkey char(8);
declare variable id_eating_object integer;
begin

  select RD.RDB$DB_KEY, rd.ID_EATING_OBJECT
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :id_eating_object;
  
  execute procedure RESGRP_SAVE_OTHER$INT(:rd_dbkey, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note, :code_first_food, :id_eating_object);
end
^

/* Restore proc. body: RES_SAVE_ROOM$EXC */
ALTER PROCEDURE RES_SAVE_ROOM$EXC(RD_DBKEY CHAR(8),
ID_RES_ROOM_TYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(250),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_room integer;
begin
  select RD.ID_ROOM, RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_room, :id_reserv_detail;

  execute procedure RES_SAVE_ROOM$RSV(
    :id_reserv_detail,
    :old_id_room,
    :id_res_room_type,
    'nrttAsIs',
    1,
    :id_hk_plan,
    :room_features,
    :i_special_treatment,
    :split_on_checkin,
    0
  ) returning_values :share_err_code, :err_text, :share_transaction_id, :warn_code;
end
^

/* Restore proc. body: RES_SAVE_ROOM$INT */
ALTER PROCEDURE RES_SAVE_ROOM$INT(RD_DBKEY TYPE OF TDB_KEY,
ID_ROOM TYPE OF ID,
ID_RES_ROOM_TYPE TYPE OF ID,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE TYPE OF TLOGICAL = null)
 RETURNS(WARN_CODE TYPE OF TRANGE)
 AS
declare variable id_reserv_detail integer;
  declare variable id_tar_room_type integer;
  declare variable old_id_room_type integer;
  declare variable old_id_room integer;
  declare variable departure_date date;
  declare variable arrival_date date;
  declare variable id_guest integer;
  declare variable g_dbkey char(8);
  declare variable system_date date;
  declare variable system_date_for_room date;
  declare variable check_status integer;
  declare variable cleaning_restriction varchar(50);
  declare variable guest_status varchar(50) default '';
  declare variable id_hotel integer;
  declare variable has_different_room_type integer;
  declare variable acc_routing varchar(30);
  declare variable res_number varchar(62);
  declare variable is_check_in smallint;
begin
  select RD.ID_ROOM_TYPE, RD.CHECK_STATUS, RD.ID_ROOM, rd.FROM_DATE, RD.TO_DATE, RD.ID_RESERV_DETAIL, RD.ID_HOTEL, rd.ACC_ROUTING, rd.NUMBER
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_room_type, :check_status, :old_id_room, :arrival_date, :departure_date, :id_reserv_detail, :id_hotel, :acc_routing, :res_number;

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date_for_room;
  /**/
  system_date = null;
  /*  */
  if (:check_status >= 0 and :old_id_room > 0 and coalesce(:id_room, 0) <= 0) then
    exception BOOKING_EXCEPTION '-111';

  if ((:old_id_room > 0) and (:id_room is distinct from :old_id_room)) then begin
    guest_status = 'ROOM_CHANGED';
    if ((:old_id_room > 0) and (:id_room > 0)) then begin
      execute procedure SYSTEM_DATE_GET(:id_hotel)
      returning_values  :system_date;
      execute procedure sys_dbg('res RES_SAVE_ROOM$INT old_id_room = '||coalesce(:old_id_room, 'null'));
      execute procedure sys_dbg('res RES_SAVE_ROOM$INT check_status = '||coalesce(:check_status, 'null'));

      if ((:departure_date <= :system_date) and (:check_status >= 0)) then exception BOOKING_EXCEPTION '-51';
    end
  end

  if (:id_room is null and :old_id_room < 0) then id_room = :old_id_room; -- preserve old fictious ID, because of mapped rooms

  if (coalesce(:id_room, 0) <= 0) then begin
    delete from ROOM_MAP$EXC m
    where  m.id_room = :id_room
           and m.ID_SRC_ROOM < 0;  -- delete wrong mappings (bug 2827)

    select ro.ID_ROOM
    from   RES_OCCUPANCY_ROOM$INT (:id_reserv_detail, :system_date_for_room, :id_room, :ID_RES_ROOM_TYPE) RO
    into   :id_room;

  end else begin
    -- real room is
    id_res_room_type = :old_id_room_type;
    if (:acc_routing <> 'OWNER'
        and :id_room is distinct from :old_id_room
        and exists (select rp.ID_ROOM_PERIOD
                    from   ROOM_PERIOD$PMS rp
                    where  rp.ID_ROOM = :ID_ROOM
                           and rp.FROM_DATE <= maxdate(:system_date_for_room, :arrival_date)
                           and rp.TO_DATE >= maxdate(:system_date_for_room, :arrival_date)
                           and rp.STATUS = 'PRIVATE')) then
    begin
      execute procedure SYSTEM_WARNING_ADD (-61, f_character(29) || :res_number)
      returning_values  :WARN_CODE;
    end
  end
  id_res_room_type = coalesce(:id_res_room_type, :old_id_room_type);
  -- null is permissible for id_res_room_type, treat of "keep the same"

  /* tar_option : nrttAsIs, nrttRoom, nrttReserv */
  id_tar_room_type = null;
  has_different_room_type = null;
  if (:tar_option = 'nrttAsIs') then begin
    id_tar_room_type = null;
    has_different_room_type = null;
  end else if (:tar_option = 'nrttRoom') then begin
    --id_tar_room_type = iif(coalesce(:id_room, 0) <= 0 and :room_id_room_type <> :ID_RES_ROOM_TYPE, :room_id_room_type, -1);
    id_tar_room_type = iif (:ID_ROOM > 0, -1, null); -- if not room - like a AsIs
    has_different_room_type = iif(:id_tar_room_type = -1, 0, null);
    -- preserve tar_room_type from mapped(unexisted) room
  end else begin /* nrttReserv */
    id_tar_room_type = :id_res_room_type;
    has_different_room_type = 1;
  end

  update RESERV_DETAIL RD
  set    RD.ID_ROOM = :id_room,
         rd.ROOM_PRICE = case
                           when rd.CHECK_STATUS >= 0 then null
                           -- 'checked in' bookings - force recalculation always
                           when rd.CHECK_STATUS < 0
                                and ((rd.ID_ROOM_TYPE <> :id_res_room_type) or (:id_room is distinct from :old_id_room)) then null
                           -- not 'checked in', but room/room type changed - force too
                           else rd.ROOM_PRICE
                         end,   -- <null> room_price will be force booking recalculation !!!
         RD.ID_ROOM_TYPE = :id_res_room_type,  -- this field update must be after room_price update
         rd.HAS_DIFFERENT_ROOM_TYPE = coalesce(:has_different_room_type, rd.HAS_DIFFERENT_ROOM_TYPE) --iif(coalesce(:id_tar_room_type, 0) > 0, 1, rd.HAS_DIFFERENT_ROOM_TYPE)
  where  RD.RDB$DB_KEY = :rd_dbkey;

  for
    select G.RDB$DB_KEY, G.ID_GUEST, g.IS_CHECK_IN
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey, :id_guest, :is_check_in
  do begin
    update GUEST GU
    set    GU.OLD_ID_ROOM = GU.ID_ROOM,
           GU.ID_ROOM = :id_room
    where  GU.RDB$DB_KEY = :g_dbkey;

    execute procedure GUEST_SET_EDIT_STATUS$INT (:g_dbkey, :guest_status, 'add');
   
    /*Old code if (:system_date is null) update room_type and type stay*/
    update GUEST_STAY GS
    set    GS.ID_ROOM_TYPE = iif(:id_tar_room_type is null, GS.ID_ROOM_TYPE, :id_tar_room_type),
           GS.ID_TYPE_STAY = iif(:is_auto_staytype = 1, -1, GS.ID_TYPE_STAY)
    where  GS.ID_GUEST = :id_guest
           and ((:system_date is null) or (GS.FOR_DATE >= :system_date));

    /*New part - Room number never be updated in past - important for shares and calulations*/
    /* will be updated in pass only if there was no room assigned*/
    update GUEST_STAY GS
    set    GS.ID_ROOM = :id_room
    where  GS.ID_GUEST = :id_guest
           and ((GS.FOR_DATE >= :system_date_for_room)
                 or (:check_status < 0) -- new - always change id_room from begining, for non checked in reservs
               ) ;

    if (:is_check_in = 1 and :ID_ROOM is distinct from :old_id_room) then begin
      execute procedure GUEST_REGISTRATION_UPDATE(:id_guest);
    end
  end

  if ((:check_status = 0) and (:guest_status = 'ROOM_CHANGED') and (:old_id_room > 0)) then begin
    /* IF THE CLEANING RESTRICTION IS ACTIVATED AND THE OLD
    || GUEST'S ROOM IS VACANT THEN IT MUST BE MARKED DIRTY.
    */
    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :cleaning_restriction;
    if ((:cleaning_restriction <> '0') and (not exists (
      select *
      from   GUEST G
             join GUEST_STAY GS on GS.ID_GUEST = G.ID_GUEST
      where  GS.FOR_DATE >= :system_date
             and G.CHECK_STATUS = 0
             and GS.ID_ROOM = :old_id_room
             and G.ID_RESERV_DETAIL <> :id_reserv_detail
    ))) then begin
      execute procedure ROOM_HOUSEKEEPING(:old_id_room, 'GST_MOVED', 'set_dirty');
    end
  end

  execute procedure RES_SAVE_ROOM_LOG$INT(:RD_DBKEY, :old_id_room, :old_id_room_type);

end
^

/* Restore proc. body: SPR_OCC_KONT_AGENT */
ALTER PROCEDURE SPR_OCC_KONT_AGENT(FROM_DATE DATE,
TO_DATE DATE,
ID_AGENT INTEGER,
KIND SMALLINT,
AGE_KIND SMALLINT,
ALL_KINDS SMALLINT,
ID_HOTEL INTEGER)
 RETURNS(TYPE_ROOM VARCHAR(20),
TYPE_ROOM2 VARCHAR(20),
FOR_DATE DATE,
KONTINGENT INTEGER,
DATA INTEGER,
OUT_KIND VARCHAR(20))
 AS
declare variable id_room_type integer;
begin
  /* KIND:  1 - ROOMS
            2 - BEDS
            3 - ADD BEDS
            else - BEDS + ADD BEDS
     AGE_KIND:  1 - ADULTS
                2 - CHILDREN
                else - ALL*/
  kontingent = 0;
  data = 0;
  for
    select distinct AD.ID_ROOM_TYPE
    from   PROFILE_AGENT PA
           join ALLOTMENT_DETAIL AD on AD.ID_ALLOTMENT = PA.ID_CONTINGENT
    where  PA.ID_AGENT = :id_agent
           and AD.FROM_DATE <= :to_date
           and AD.TO_DATE >= :from_date
    into   :id_room_type
  do begin
    select RT.TYPE_ROOM, RT.TYPE_ROOM
    from   ROOM_TYPES RT
    where  RT.ID_ROOM_TYPE = :id_room_type
           and RT.ID_HOTEL = :id_hotel
    into   :type_room, :type_room2;

    for
      select SLP.OUT_DATE
      from   SYSTEM_LOOP_PERIOD(:from_date, :to_date) SLP
      into   :for_date
    do begin
      for
        select KONTINGENT, DATA, OUT_KIND
        from   SPR_OCC_KONT_AGENT_ROOMTYPE_DAY(:for_date,:id_agent,:id_room_type,:kind,:age_kind, :all_kinds)
        into   :kontingent, :data, :out_kind
      do suspend;
    end
  end
end
^

/* Restore proc. body: TAR_CALC_INPUT_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_input integer;
  declare variable id_guest integer;
  declare variable for_date date;
  declare variable id_calc_tariff integer;
  declare variable td_dbkey char(8);
  declare variable date_independent_param_values varchar(2000);
  declare variable date_dep_param_values varchar(2000);
  declare variable prev_id_guest integer;
  declare variable prev_id_tariff integer;
begin
  prev_id_guest = null;
  prev_id_tariff = null;
  for
    select Td.RDB$DB_KEY, TI.ID_TAR_INPUT, ti.ID_GUEST, td.FOR_DATE, td.ID_TAR_HEAD
    from   TAR_CALC_INPUT$TMP TI
           join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
    where  TI.ID_TAR_CALC = :id_tar_calc
    order by ti.ID_GUEST asc, td.FOR_DATE asc
    into   :td_dbkey, :id_tar_input, :id_guest, :for_date, :id_calc_tariff
  do begin
    if ((:id_guest is distinct from :prev_id_guest)
        or (:id_calc_tariff is distinct from :prev_id_tariff)) then
    begin
      /* get date independent params */
      execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, null, null)
      returning_values (:ERR_CODE, :date_independent_param_values);
      if (:ERR_CODE < 0) then exit;
      prev_id_guest = :id_guest;
      prev_id_tariff = :id_calc_tariff;
    end

    execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, :for_date, null)
    returning_values (:ERR_CODE, :date_dep_param_values);
    if (:ERR_CODE < 0) then exit;

    update TAR_CALC_INPUT_DETAIL$TMP d
    set    d.PARAM_VALUES = coalesce(:date_independent_param_values, '') || ';'
                            || coalesce(:date_dep_param_values, '')
    where  d.RDB$DB_KEY = :td_dbkey;
  end
end
^

SET TERM ; ^

ALTER TABLE ACC_TEMPLATE ALTER COLUMN ID_ACC_TEMPLATE POSITION 1;

ALTER TABLE ACC_TEMPLATE ALTER COLUMN TEMPLATE_NAME POSITION 2;

ALTER TABLE ACC_TEMPLATE ALTER COLUMN ID_HOTEL POSITION 3;

ALTER TABLE ACC_TEMPLATE ALTER COLUMN ID_TAX_POLICY POSITION 4;

ALTER TABLE ACC_TEMPLATE ALTER COLUMN SECURITY_LEVEL POSITION 5;

ALTER TABLE ACC_TEMPLATE ALTER COLUMN IS_CREDIT_ACCOUNT POSITION 6;

ALTER TABLE ACC_TEMPLATE ALTER COLUMN CREDIT_LIMIT POSITION 7;

ALTER TABLE ACC_TEMPLATE ALTER COLUMN IS_ALOWED_POS_INTERFACE POSITION 8;

ALTER TABLE ACC_TEMPLATE ALTER COLUMN IS_ARCHIVE POSITION 9;

ALTER TABLE ACC_TEMPLATE ALTER COLUMN SUBSCRIBER_ID POSITION 10;

ALTER TABLE ACCOUNT ALTER COLUMN ID_ACCOUNT POSITION 1;

ALTER TABLE ACCOUNT ALTER COLUMN ACCOUNT_NAME POSITION 2;

ALTER TABLE ACCOUNT ALTER COLUMN ACCOUNT_CURR POSITION 3;

ALTER TABLE ACCOUNT ALTER COLUMN ID_TAX_POLICY POSITION 4;

ALTER TABLE ACCOUNT ALTER COLUMN ID_TYPE_PAYMENT POSITION 5;

ALTER TABLE ACCOUNT ALTER COLUMN ID_PROFILE POSITION 6;

ALTER TABLE ACCOUNT ALTER COLUMN ID_RESERV_DETAIL POSITION 7;

ALTER TABLE ACCOUNT ALTER COLUMN ID_HOTEL POSITION 8;

ALTER TABLE ACCOUNT ALTER COLUMN SECURITY_LEVEL POSITION 9;

ALTER TABLE ACCOUNT ALTER COLUMN IS_CREDIT_ACCOUNT POSITION 10;

ALTER TABLE ACCOUNT ALTER COLUMN CREDIT_LIMIT POSITION 11;

ALTER TABLE ACCOUNT ALTER COLUMN IS_BASE POSITION 12;

ALTER TABLE ACCOUNT ALTER COLUMN IS_EXTRA POSITION 13;

ALTER TABLE ACCOUNT ALTER COLUMN IS_BLOCKED POSITION 14;

ALTER TABLE ACCOUNT ALTER COLUMN BLOCK_TEXT POSITION 15;

ALTER TABLE ACCOUNT ALTER COLUMN IS_ALOWED_POS_INTERFACE POSITION 16;

ALTER TABLE ACCOUNT ALTER COLUMN POS_INTERFACE_NOTE POSITION 17;

ALTER TABLE ACCOUNT ALTER COLUMN IS_DEFAULT POSITION 18;

ALTER TABLE ACCOUNT ALTER COLUMN IS_PMS_ACCOUNT POSITION 19;

ALTER TABLE ACCOUNT ALTER COLUMN IS_ARCHIVE POSITION 20;

ALTER TABLE ACCOUNT ALTER COLUMN ARCHIVED_DATE POSITION 21;

ALTER TABLE ACCOUNT ALTER COLUMN MASK POSITION 22;

ALTER TABLE ACCOUNT ALTER COLUMN NOTE POSITION 23;

ALTER TABLE ACCOUNT ALTER COLUMN EXT_CODE POSITION 24;

ALTER TABLE ACCOUNT ALTER COLUMN ID_CONTRAGENT POSITION 25;

ALTER TABLE ACCOUNT ALTER COLUMN ID_SALE_NUM POSITION 26;

ALTER TABLE BONUSPOINT_SCHEME ALTER COLUMN ID_BONUSPOINT_SCHEME POSITION 1;

ALTER TABLE BONUSPOINT_SCHEME ALTER COLUMN NAME POSITION 2;

ALTER TABLE BONUSPOINT_SCHEME ALTER COLUMN ID_HOTEL POSITION 3;

ALTER TABLE BONUSPOINT_SCHEME ALTER COLUMN NIGHTS_ROOM_TYPE POSITION 4;

ALTER TABLE BONUSPOINT_SCHEME ALTER COLUMN NIGHTS_KIND POSITION 5;

ALTER TABLE BONUSPOINT_SCHEME ALTER COLUMN NIGHTS_POINTS POSITION 6;

ALTER TABLE BONUSPOINT_SCHEME ALTER COLUMN NIGHTS_COUNT POSITION 7;

ALTER TABLE BONUSPOINT_SCHEME ALTER COLUMN TURNOVER_KIND POSITION 8;

ALTER TABLE BONUSPOINT_SCHEME ALTER COLUMN TURNOVER_POINTS POSITION 9;

ALTER TABLE BONUSPOINT_SCHEME ALTER COLUMN TURNOVER_AMOUNT POSITION 10;

ALTER TABLE BONUSPOINT_SCHEME ALTER COLUMN MIN_AVAIL_POINTS_CONSUME POSITION 11;

ALTER TABLE BONUSPOINT_SCHEME ALTER COLUMN CONSUME_POINT_PRICE POSITION 12;

ALTER TABLE BONUSPOINT_SCHEME ALTER COLUMN CONSUME_POINT_CURR POSITION 13;

ALTER TABLE BONUSPOINT_SCHEME ALTER COLUMN CONSUME_DISCOUNT_TXT POSITION 14;

ALTER TABLE BONUSPOINT_SCHEME ALTER COLUMN CONSUME_POINT_NOMINAL POSITION 15;

ALTER TABLE CONTRACT_AGENT_COMMISSION$PMS ALTER COLUMN ID_CONTRACT_AGENT_COMMISSION POSITION 1;

ALTER TABLE CONTRACT_AGENT_COMMISSION$PMS ALTER COLUMN ID_CONTRACT POSITION 2;

ALTER TABLE CONTRACT_AGENT_COMMISSION$PMS ALTER COLUMN SUB_CONTRACT POSITION 3;

ALTER TABLE CONTRACT_AGENT_COMMISSION$PMS ALTER COLUMN FORMULA POSITION 4;

ALTER TABLE CONTRACT_AGENT_COMMISSION$PMS ALTER COLUMN IS_USE POSITION 5;

ALTER TABLE CONTRACT_AGENT_COMMISSION$PMS ALTER COLUMN AGENT_COMMISSION_PERCENT POSITION 6;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN ID_CONTRACT_EXPENSE POSITION 1;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN ID_CONTRACT POSITION 2;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN SUB_CONTRACT POSITION 3;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN ID_SERVICE POSITION 4;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN ID_CURRENCY POSITION 5;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN FORMULA POSITION 6;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN SERVICE_PRICE POSITION 7;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN IS_ACC_POST_ITEM POSITION 8;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN CONTRACT_EXPENSE_TYPE POSITION 9;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN MULTIPLIER_TYPE POSITION 10;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN ID_AGENT_PROFILE POSITION 11;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN ORDER_TAG POSITION 12;

ALTER TABLE CONTRACT_MANAGEMENT$PMS ALTER COLUMN ID_CONTRACT_MANAGEMENT POSITION 1;

ALTER TABLE CONTRACT_MANAGEMENT$PMS ALTER COLUMN ID_CONTRACT POSITION 2;

ALTER TABLE CONTRACT_MANAGEMENT$PMS ALTER COLUMN SUB_CONTRACT POSITION 3;

ALTER TABLE CONTRACT_MANAGEMENT$PMS ALTER COLUMN MIN_VALUE POSITION 4;

ALTER TABLE CONTRACT_MANAGEMENT$PMS ALTER COLUMN MIN_VALUE_CURR POSITION 5;

ALTER TABLE CONTRACT_MANAGEMENT$PMS ALTER COLUMN MAX_VALUE POSITION 6;

ALTER TABLE CONTRACT_MANAGEMENT$PMS ALTER COLUMN MAX_VALUE_CURR POSITION 7;

ALTER TABLE CONTRACT_MANAGEMENT$PMS ALTER COLUMN NIGHT_PRICE POSITION 8;

ALTER TABLE CONTRACT_MANAGEMENT$PMS ALTER COLUMN NIGHT_PRICE_CURR POSITION 9;

ALTER TABLE CONTRACT_MANAGEMENT$PMS ALTER COLUMN FORMULA POSITION 10;

ALTER TABLE CONTRACT_MANAGEMENT$PMS ALTER COLUMN IS_NETO POSITION 11;

ALTER TABLE CONTRACT_MANAGEMENT$PMS ALTER COLUMN IS_USE POSITION 12;

ALTER TABLE CONTRACT_MANAGEMENT$PMS ALTER COLUMN ID_SERVICE POSITION 13;

ALTER TABLE DOC_COMPLETION ALTER COLUMN ID_DOC_HEAD POSITION 1;

ALTER TABLE DOC_COMPLETION ALTER COLUMN FISC_STATUS POSITION 2;

ALTER TABLE DOC_COMPLETION ALTER COLUMN IS_EFAKTURA_EXPORTED POSITION 3;

ALTER TABLE DOC_COMPLETION ALTER COLUMN TAX_EVENT_DATE POSITION 4;

ALTER TABLE DOC_COMPLETION ALTER COLUMN ID_DOC_PROFORMA POSITION 5;

ALTER TABLE DOC_COMPLETION ALTER COLUMN DATETIME_FISCALIZED POSITION 6;

ALTER TABLE DOC_COMPLETION ALTER COLUMN ID_SALE_NUM POSITION 7;

ALTER TABLE DOC_SUPPLIER ALTER COLUMN ID_DOC_SUPPLIER POSITION 1;

ALTER TABLE DOC_SUPPLIER ALTER COLUMN COMPANY_NAME POSITION 2;

ALTER TABLE DOC_SUPPLIER ALTER COLUMN COMPANY_ADDRESS POSITION 3;

ALTER TABLE DOC_SUPPLIER ALTER COLUMN COMPANY_IDENT_NUM POSITION 4;

ALTER TABLE DOC_SUPPLIER ALTER COLUMN COMPANY_VAT_REG_NUM POSITION 5;

ALTER TABLE DOC_SUPPLIER ALTER COLUMN COMPANY_MOL POSITION 6;

ALTER TABLE DOC_SUPPLIER ALTER COLUMN SEND_NAME POSITION 7;

ALTER TABLE DOC_SUPPLIER ALTER COLUMN FIRM_DATA POSITION 8;

ALTER TABLE DOC_TYPE ALTER COLUMN ID_DOC_TYPE POSITION 1;

ALTER TABLE DOC_TYPE ALTER COLUMN DOC_SUB_TYPE POSITION 2;

ALTER TABLE DOC_TYPE ALTER COLUMN DOC_TYPE_NAME POSITION 3;

ALTER TABLE DOC_TYPE ALTER COLUMN ID_HOTEL POSITION 4;

ALTER TABLE DOC_TYPE ALTER COLUMN ID_DOC_NUM POSITION 5;

ALTER TABLE DOC_TYPE ALTER COLUMN ID_ANNUL_DOC_NUM POSITION 6;

ALTER TABLE DOC_TYPE ALTER COLUMN DOC_CURR POSITION 7;

ALTER TABLE DOC_TYPE ALTER COLUMN CURRENCY_LIST POSITION 8;

ALTER TABLE DOC_TYPE ALTER COLUMN IS_VAT POSITION 9;

ALTER TABLE DOC_TYPE ALTER COLUMN IS_TAXED POSITION 10;

ALTER TABLE DOC_TYPE ALTER COLUMN IS_ARCHIVE POSITION 11;

ALTER TABLE DOC_TYPE ALTER COLUMN EXPORT_TAG POSITION 12;

ALTER TABLE DOC_TYPE ALTER COLUMN RAPORT_NAME POSITION 13;

ALTER TABLE DOC_TYPE ALTER COLUMN PRINT_COPYIES POSITION 14;

ALTER TABLE DOC_TYPE ALTER COLUMN PRINT_ORIGINAL POSITION 15;

ALTER TABLE DOC_TYPE ALTER COLUMN DESCRIPTION POSITION 16;

ALTER TABLE DOC_TYPE ALTER COLUMN SUBSCRIBER_ID POSITION 17;

ALTER TABLE DOC_TYPE ALTER COLUMN CREATED_AT POSITION 18;

ALTER TABLE DOC_TYPE ALTER COLUMN UPDATED_AT POSITION 19;

ALTER TABLE DOC_TYPE ALTER COLUMN ARCHIVED_AT POSITION 20;

ALTER TABLE GUARANTEE_POLICY ALTER COLUMN ID_GUARANTEE_POLICY POSITION 1;

ALTER TABLE GUARANTEE_POLICY ALTER COLUMN NAME POSITION 2;

ALTER TABLE GUARANTEE_POLICY ALTER COLUMN ID_HOTEL POSITION 3;

ALTER TABLE GUARANTEE_POLICY ALTER COLUMN DESCRIPTION POSITION 4;

ALTER TABLE GUARANTEE_POLICY ALTER COLUMN WBE_DESCRIPTION POSITION 5;

ALTER TABLE GUARANTEE_POLICY ALTER COLUMN WBE_DESCRIPTION_FULL POSITION 6;

ALTER TABLE GUARANTEE_POLICY ALTER COLUMN CHECK_STATUS POSITION 7;

ALTER TABLE GUARANTEE_POLICY ALTER COLUMN DEPOSIT_TOTALSUM_PART POSITION 8;

ALTER TABLE GUARANTEE_POLICY ALTER COLUMN DEPOSIT_NIGHTS_COUNT POSITION 9;

ALTER TABLE GUARANTEE_POLICY ALTER COLUMN DUE_DAYS_BEFORE_ARRIVAL POSITION 10;

ALTER TABLE GUARANTEE_POLICY ALTER COLUMN DUE_DAYS_AFTER_CREATE POSITION 11;

ALTER TABLE GUARANTEE_POLICY ALTER COLUMN IS_ACTIVE POSITION 12;

ALTER TABLE GUARANTEE_POLICY ALTER COLUMN UUID POSITION 13;

ALTER TABLE GUARANTEE_POLICY ALTER COLUMN SUBSCRIBER_ID POSITION 14;

ALTER TABLE GUARANTEE_POLICY ALTER COLUMN WBE_PUBLIC POSITION 15;

ALTER TABLE GUEST_STAY ALTER COLUMN FOR_DATE POSITION 1;

ALTER TABLE GUEST_STAY ALTER COLUMN ID_GUEST POSITION 2;

ALTER TABLE GUEST_STAY ALTER COLUMN ID_TARIFF POSITION 3;

ALTER TABLE GUEST_STAY ALTER COLUMN ID_BOARD POSITION 4;

ALTER TABLE GUEST_STAY ALTER COLUMN ID_ROOM POSITION 5;

ALTER TABLE GUEST_STAY ALTER COLUMN ID_ROOM_TYPE POSITION 6;

ALTER TABLE GUEST_STAY ALTER COLUMN ID_TYPE_STAY POSITION 7;

ALTER TABLE HOTEL ALTER COLUMN ID_HOTEL POSITION 1;

ALTER TABLE HOTEL ALTER COLUMN HOTEL_NAME POSITION 2;

ALTER TABLE HOTEL ALTER COLUMN CODE POSITION 3;

ALTER TABLE HOTEL ALTER COLUMN SYSTEM_DATE POSITION 4;

ALTER TABLE HOTEL ALTER COLUMN FIRM_DATA POSITION 5;

ALTER TABLE HOTEL ALTER COLUMN ID_LOGO POSITION 6;

ALTER TABLE HOTEL ALTER COLUMN HOTEL_ADDRESS POSITION 7;

ALTER TABLE HOTEL ALTER COLUMN ID_OVERBOOK_ALLOTMENT POSITION 8;

ALTER TABLE HOTEL ALTER COLUMN ID_PHYSICAL_ALLOTMENT POSITION 9;

ALTER TABLE HOTEL ALTER COLUMN ID_INVENTORY_ALLOTMENT POSITION 10;

ALTER TABLE HOTEL ALTER COLUMN ID_EXTERNAL_OCCUPANCY_ALLOTMENT POSITION 11;

ALTER TABLE HOTEL ALTER COLUMN ID_EXTRA_RATE POSITION 12;

ALTER TABLE HOTEL ALTER COLUMN LETTER_HEADER POSITION 13;

ALTER TABLE HOTEL ALTER COLUMN LETTER_FOOTER POSITION 14;

ALTER TABLE HOTEL ALTER COLUMN RES_CONFIRM_TEXT POSITION 15;

ALTER TABLE HOTEL ALTER COLUMN DOC_PACK_SRV_TEXT POSITION 16;

ALTER TABLE HOTEL ALTER COLUMN DOC_ONE_LINE_TEXT POSITION 17;

ALTER TABLE HOTEL ALTER COLUMN MONITOR_MAP POSITION 18;

ALTER TABLE HOTEL ALTER COLUMN ORDER_TAG POSITION 19;

ALTER TABLE HOTEL ALTER COLUMN IS_USE POSITION 20;

ALTER TABLE HOTEL ALTER COLUMN UUID POSITION 21;

ALTER TABLE HOTEL ALTER COLUMN SUBSCRIBER_ID POSITION 22;

ALTER TABLE HOTEL ALTER COLUMN EXTERNAL_TYPE POSITION 23;

ALTER TABLE HOTEL ALTER COLUMN WBE_ENABLED POSITION 24;

ALTER TABLE HOTEL ALTER COLUMN ID_GUEST_NUMERATOR POSITION 25;

ALTER TABLE HOTEL ALTER COLUMN ID_TT_NUMERATOR_1 POSITION 26;

ALTER TABLE HOTEL ALTER COLUMN ID_TT_NUMERATOR_2 POSITION 27;

ALTER TABLE HOTEL ALTER COLUMN USE_DIFFERENT_TT_NUMERATORS POSITION 28;

ALTER TABLE HOTEL ALTER COLUMN NATION_CURR POSITION 29;

ALTER TABLE HOTEL ALTER COLUMN REG_CARD_TEXT POSITION 30;

ALTER TABLE HOTEL ALTER COLUMN LAST_KNOWN_UUID POSITION 31;

ALTER TABLE HOTEL ALTER COLUMN CREATED_AT POSITION 32;

ALTER TABLE HOTEL ALTER COLUMN UPDATED_AT POSITION 33;

ALTER TABLE HOTEL ALTER COLUMN ARCHIVED_AT POSITION 34;

ALTER TABLE HOTEL ALTER COLUMN COMPANY_NAME POSITION 35;

ALTER TABLE HOTEL ALTER COLUMN COMPANY_ADDRESS POSITION 36;

ALTER TABLE HOTEL ALTER COLUMN COMPANY_IDENT_NUM POSITION 37;

ALTER TABLE HOTEL ALTER COLUMN COMPANY_VAT_REG_NUM POSITION 38;

ALTER TABLE HOTEL ALTER COLUMN COMPANY_MOL POSITION 39;

ALTER TABLE HOTEL ALTER COLUMN ACCOMODATION_PLACE_UIN POSITION 40;

ALTER TABLE PAYMENT_TAX ALTER COLUMN ID_PAYMENT_TAX POSITION 1;

ALTER TABLE PAYMENT_TAX ALTER COLUMN ID_PAY_DOC_TYPE POSITION 2;

ALTER TABLE PAYMENT_TAX ALTER COLUMN TAX_PERCENT POSITION 3;

ALTER TABLE PAYMENT_TAX ALTER COLUMN ID_SERVICE POSITION 4;

ALTER TABLE PAYMENT_TAX ALTER COLUMN IS_ARCHIVE POSITION 5;

ALTER TABLE PAYMENT_TYPE ALTER COLUMN ID_PAYMENT_TYPE POSITION 1;

ALTER TABLE PAYMENT_TYPE ALTER COLUMN PAYMENT_TYPE POSITION 2;

ALTER TABLE PAYMENT_TYPE ALTER COLUMN ID_HOTEL POSITION 3;

ALTER TABLE PAYMENT_TYPE ALTER COLUMN GROUP_TAG POSITION 4;

ALTER TABLE PAYMENT_TYPE ALTER COLUMN DESCRIPTION POSITION 5;

ALTER TABLE PAYMENT_TYPE ALTER COLUMN IS_AR_DEBT POSITION 6;

ALTER TABLE PAYMENT_TYPE ALTER COLUMN IS_CASH POSITION 7;

ALTER TABLE PAYMENT_TYPE ALTER COLUMN IS_CC POSITION 8;

ALTER TABLE PAYMENT_TYPE ALTER COLUMN IS_USE POSITION 9;

ALTER TABLE PAYMENT_TYPE ALTER COLUMN FISCAL_CODE POSITION 10;

ALTER TABLE PAYMENT_TYPE ALTER COLUMN SUBSCRIBER_ID POSITION 11;

ALTER TABLE PAYMENT_TYPE ALTER COLUMN UUID POSITION 12;

ALTER TABLE PAYMENT_TYPE ALTER COLUMN CREATED_AT POSITION 13;

ALTER TABLE PAYMENT_TYPE ALTER COLUMN UPDATED_AT POSITION 14;

ALTER TABLE PAYMENT_TYPE ALTER COLUMN ARCHIVED_AT POSITION 15;

ALTER TABLE PROFILE ALTER COLUMN ID_PROFILE POSITION 1;

ALTER TABLE PROFILE ALTER COLUMN PROFILE_NAME POSITION 2;

ALTER TABLE PROFILE ALTER COLUMN PROFILE_TYPE POSITION 3;

ALTER TABLE PROFILE ALTER COLUMN IS_ARCHIVE POSITION 4;

ALTER TABLE PROFILE ALTER COLUMN PHONE POSITION 5;

ALTER TABLE PROFILE ALTER COLUMN FAX POSITION 6;

ALTER TABLE PROFILE ALTER COLUMN EMAIL POSITION 7;

ALTER TABLE PROFILE ALTER COLUMN CITY POSITION 8;

ALTER TABLE PROFILE ALTER COLUMN ADDRESS POSITION 9;

ALTER TABLE PROFILE ALTER COLUMN NOTE POSITION 10;

ALTER TABLE PROFILE ALTER COLUMN MSG POSITION 11;

ALTER TABLE PROFILE ALTER COLUMN ACCOUNT_NO POSITION 12;

ALTER TABLE PROFILE ALTER COLUMN ID_NOM_MARKET_SEGMENT POSITION 13;

ALTER TABLE PROFILE ALTER COLUMN ID_DEF_CONTRAGENT POSITION 14;

ALTER TABLE PROFILE ALTER COLUMN DEFAULT_CREDIT_CARD POSITION 15;

ALTER TABLE PROFILE ALTER COLUMN UUID POSITION 16;

ALTER TABLE PROFILE ALTER COLUMN SUBSCRIBER_ID POSITION 17;

ALTER TABLE PROFILE ALTER COLUMN WBE_PASSWORD POSITION 18;

ALTER TABLE PROFILE ALTER COLUMN IS_EXCLUSIVE_DEBT_OWNERSHIP POSITION 19;

ALTER TABLE PROFILE ALTER COLUMN RECORD_TIMESTAMP POSITION 20;

ALTER TABLE PROFILE ALTER COLUMN BONUSPOINT_GAINED POSITION 21;

ALTER TABLE PROFILE ALTER COLUMN BONUSPOINT_CONSUMED POSITION 22;

ALTER TABLE PROFILE ALTER COLUMN ID_MERGE_PROFILE POSITION 23;

ALTER TABLE PROFILE ALTER COLUMN MERGE_NAME POSITION 24;

ALTER TABLE PROFILE ALTER COLUMN MERGE_IDENT_NUM POSITION 25;

ALTER TABLE PROFILE ALTER COLUMN MERGE_IDENT_NUM_ALT POSITION 26;

ALTER TABLE PROFILE ALTER COLUMN CREATED_AT POSITION 27;

ALTER TABLE PROFILE ALTER COLUMN UPDATED_AT POSITION 28;

ALTER TABLE PROFILE ALTER COLUMN ARCHIVED_AT POSITION 29;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_RESERV_DETAIL POSITION 1;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_HOTEL POSITION 2;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_ROOM_TYPE POSITION 3;

ALTER TABLE RESERV_DETAIL ALTER COLUMN FROM_DATE POSITION 4;

ALTER TABLE RESERV_DETAIL ALTER COLUMN TO_DATE POSITION 5;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ADULT_COUNT POSITION 6;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CHILD_COUNT POSITION 7;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CHECK_STATUS POSITION 8;

ALTER TABLE RESERV_DETAIL ALTER COLUMN IS_ANUL POSITION 9;

ALTER TABLE RESERV_DETAIL ALTER COLUMN REASON_OF_ANUL POSITION 10;

ALTER TABLE RESERV_DETAIL ALTER COLUMN RES_STATUS POSITION 11;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_ROOM POSITION 12;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ROOM_FEATURES POSITION 13;

ALTER TABLE RESERV_DETAIL ALTER COLUMN VIRTUAL_ROOM POSITION 14;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_BOARD POSITION 15;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CODE_FIRST_FOOD POSITION 16;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_GROUP POSITION 17;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_AGENT_PROFILE POSITION 18;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_AGENT_PAYMENT POSITION 19;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_AGENT_ACCOUNT_RULE POSITION 20;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ACC_ROUTING POSITION 21;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_BASE_ACCOUNT POSITION 22;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_EXTRA_ACCOUNT POSITION 23;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_AGENT_ACCOUNT POSITION 24;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_PERSON_PROFILE POSITION 25;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_ACC_TEMPLATE_PERSON POSITION 26;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_PERSON_PAYMENT POSITION 27;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_TITULAR POSITION 28;

ALTER TABLE RESERV_DETAIL ALTER COLUMN COUNTRY POSITION 29;

ALTER TABLE RESERV_DETAIL ALTER COLUMN VAUCHER_NUM POSITION 30;

ALTER TABLE RESERV_DETAIL ALTER COLUMN VAUCHER_DATE POSITION 31;

ALTER TABLE RESERV_DETAIL ALTER COLUMN VAUCHER_NUM2 POSITION 32;

ALTER TABLE RESERV_DETAIL ALTER COLUMN VAUCHER_DATE2 POSITION 33;

ALTER TABLE RESERV_DETAIL ALTER COLUMN VAUCHER_TEXT POSITION 34;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_RATE POSITION 35;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ROOM_PRICE POSITION 36;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ROOM_CURRENCY POSITION 37;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ROOM_PRICE_DETAILS POSITION 38;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CUSTOM_PRICE POSITION 39;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CUSTOM_CURRENCY POSITION 40;

ALTER TABLE RESERV_DETAIL ALTER COLUMN HAS_DIFFERENT_VOUCHERS POSITION 41;

ALTER TABLE RESERV_DETAIL ALTER COLUMN HAS_DIFFERENT_ROOM_TYPE POSITION 42;

ALTER TABLE RESERV_DETAIL ALTER COLUMN HAS_DIFFERENT_BOARD POSITION 43;

ALTER TABLE RESERV_DETAIL ALTER COLUMN HAS_DIFFERENT_TYPE_STAY POSITION 44;

ALTER TABLE RESERV_DETAIL ALTER COLUMN HAS_DIFFERENT_TARIFF POSITION 45;

ALTER TABLE RESERV_DETAIL ALTER COLUMN HAS_DIFFERENT_OTHER POSITION 46;

ALTER TABLE RESERV_DETAIL ALTER COLUMN HAS_DIFFERENT_PRICE POSITION 47;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_HK_PLAN POSITION 48;

ALTER TABLE RESERV_DETAIL ALTER COLUMN IS_VIP POSITION 49;

ALTER TABLE RESERV_DETAIL ALTER COLUMN I_SPECIAL_TREATMENT POSITION 50;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_NOM_MARKET_SEGMENT POSITION 51;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_NOM_SOURCE_CODE POSITION 52;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_NOM_CHANNEL_CODE POSITION 53;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_NOM_HEAR_REASON POSITION 54;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_NOM_COME_REASON POSITION 55;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CREATE_DATETIME POSITION 56;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CHANGE_TIME POSITION 57;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_LOG_EVENT_CREATE POSITION 58;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_LOG_EVENT_ANNUL POSITION 59;

ALTER TABLE RESERV_DETAIL ALTER COLUMN RES_EDIT_STATUS POSITION 60;

ALTER TABLE RESERV_DETAIL ALTER COLUMN NOTE POSITION 61;

ALTER TABLE RESERV_DETAIL ALTER COLUMN NOTE_REMINDERS POSITION 62;

ALTER TABLE RESERV_DETAIL ALTER COLUMN SPLIT_ON_CHECKIN POSITION 63;

ALTER TABLE RESERV_DETAIL ALTER COLUMN EXP_DATE POSITION 64;

ALTER TABLE RESERV_DETAIL ALTER COLUMN COMMING_KIND POSITION 65;

ALTER TABLE RESERV_DETAIL ALTER COLUMN LEAVING_KIND POSITION 66;

ALTER TABLE RESERV_DETAIL ALTER COLUMN TRANSFER_IN_TIME POSITION 67;

ALTER TABLE RESERV_DETAIL ALTER COLUMN TRANSFER_IN_NOTE POSITION 68;

ALTER TABLE RESERV_DETAIL ALTER COLUMN TRANSFER_OUT_TIME POSITION 69;

ALTER TABLE RESERV_DETAIL ALTER COLUMN TRANSFER_OUT_NOTE POSITION 70;

ALTER TABLE RESERV_DETAIL ALTER COLUMN SELECTION_ID POSITION 71;

ALTER TABLE RESERV_DETAIL ALTER COLUMN SUBSCRIBER_ID POSITION 72;

ALTER TABLE RESERV_DETAIL ALTER COLUMN NUMBER_1 POSITION 73;

ALTER TABLE RESERV_DETAIL ALTER COLUMN NUMBER_2 POSITION 74;

ALTER TABLE RESERV_DETAIL ALTER COLUMN NUMBER_3 POSITION 75;

ALTER TABLE RESERV_DETAIL ALTER COLUMN NUMBER POSITION 76;

ALTER TABLE RESERV_DETAIL ALTER COLUMN BLOCK_CC POSITION 77;

ALTER TABLE RESERV_DETAIL ALTER COLUMN GUARANTEE_DEPOSIT POSITION 78;

ALTER TABLE RESERV_DETAIL ALTER COLUMN GUARANTEE_CURRENCY POSITION 79;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_GUARANTEE_POLICY POSITION 80;

ALTER TABLE RESERV_DETAIL ALTER COLUMN GUARANTEE_DEPOSIT_PERCENT POSITION 81;

ALTER TABLE RESERV_DETAIL ALTER COLUMN GUARANTEE_DEPOSIT_NIGHTS POSITION 82;

ALTER TABLE RESERV_DETAIL ALTER COLUMN GUARANTEE_DUE_DAYS_BEF_ARRIVAL POSITION 83;

ALTER TABLE RESERV_DETAIL ALTER COLUMN GUARANTEE_DUE_DAYS_AFTER_CREATE POSITION 84;

ALTER TABLE RESERV_DETAIL ALTER COLUMN GUARANTEE_EXPIRE_DATE POSITION 85;

ALTER TABLE RESERV_DETAIL ALTER COLUMN IS_POSTING_STOPPED POSITION 86;

ALTER TABLE RESERV_DETAIL ALTER COLUMN POSTING_TRANSACTION_UUID POSITION 87;

ALTER TABLE RESERV_DETAIL ALTER COLUMN EXC_LOCAL_VERSION POSITION 88;

ALTER TABLE RESERV_DETAIL ALTER COLUMN EXC_REMOTE_VERSION POSITION 89;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CONFIRMATION_NUMBER POSITION 90;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CANCELATION_NUMBER POSITION 91;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_EATING_OBJECT POSITION 92;

ALTER TABLE RESERV_DETAIL ALTER COLUMN LAST_ID_TAR_CALC POSITION 93;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CHECK_OUT_KIND POSITION 94;

ALTER TABLE RESERV_DETAIL ALTER COLUMN EARLYCHECKOUT_DATE POSITION 95;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ROOM_PRICE_LAST$INT POSITION 96;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ROOM_CURRENCY_LAST$INT POSITION 97;

ALTER TABLE RIGHTS_GROUPS ALTER COLUMN ID_RIGHT_GROUP POSITION 1;

ALTER TABLE RIGHTS_GROUPS ALTER COLUMN GROUP_NAME POSITION 2;

ALTER TABLE RIGHTS_GROUPS ALTER COLUMN GROUP_DESCRIPTION POSITION 3;

ALTER TABLE RIGHTS_GROUPS ALTER COLUMN CREATED_AT POSITION 4;

ALTER TABLE RIGHTS_GROUPS ALTER COLUMN UPDATED_AT POSITION 5;

ALTER TABLE RIGHTS_GROUPS ALTER COLUMN ARCHIVED_AT POSITION 6;

ALTER TABLE RIGHTS_GROUPS_LINES ALTER COLUMN ID_GROUP_LINES POSITION 1;

ALTER TABLE RIGHTS_GROUPS_LINES ALTER COLUMN ID_RIGHT_GROUP POSITION 2;

ALTER TABLE RIGHTS_GROUPS_LINES ALTER COLUMN RIGHT_CODE POSITION 3;

ALTER TABLE RIGHTS_GROUPS_LINES ALTER COLUMN GRANTED_AT POSITION 4;

ALTER TABLE RIGHTS_GROUPS_REPORTS ALTER COLUMN ID_RIGHTS_G_REPORT POSITION 1;

ALTER TABLE RIGHTS_GROUPS_REPORTS ALTER COLUMN ID_RIGHT_GROUP POSITION 2;

ALTER TABLE RIGHTS_GROUPS_REPORTS ALTER COLUMN REPORT_NAME POSITION 3;

ALTER TABLE RIGHTS_GROUPS_REPORTS ALTER COLUMN EXTRA_COL POSITION 4;

ALTER TABLE RIGHTS_GROUPS_REPORTS ALTER COLUMN GRANTED_AT POSITION 5;

ALTER TABLE RIGHTS_USERS ALTER COLUMN USER_NAME POSITION 1;

ALTER TABLE RIGHTS_USERS ALTER COLUMN USER_NAME_LONG POSITION 2;

ALTER TABLE RIGHTS_USERS ALTER COLUMN USER_PASSWORD POSITION 3;

ALTER TABLE RIGHTS_USERS ALTER COLUMN USER_POSITION POSITION 4;

ALTER TABLE RIGHTS_USERS ALTER COLUMN FISCAL_ID POSITION 5;

ALTER TABLE RIGHTS_USERS ALTER COLUMN LANG_UI POSITION 6;

ALTER TABLE RIGHTS_USERS ALTER COLUMN IS_ACTIVE POSITION 7;

ALTER TABLE RIGHTS_USERS ALTER COLUMN CODE POSITION 8;

ALTER TABLE RIGHTS_USERS ALTER COLUMN CREATED_AT POSITION 9;

ALTER TABLE RIGHTS_USERS ALTER COLUMN UPDATED_AT POSITION 10;

ALTER TABLE RIGHTS_USERS ALTER COLUMN ARCHIVED_AT POSITION 11;

ALTER TABLE ROOMS ALTER COLUMN ID_ROOM POSITION 1;

ALTER TABLE ROOMS ALTER COLUMN ID_ROOM_TYPE POSITION 2;

ALTER TABLE ROOMS ALTER COLUMN ROOM_NAME POSITION 3;

ALTER TABLE ROOMS ALTER COLUMN FLOOR POSITION 4;

ALTER TABLE ROOMS ALTER COLUMN BEDS POSITION 5;

ALTER TABLE ROOMS ALTER COLUMN EXTRA_BEDS POSITION 6;

ALTER TABLE ROOMS ALTER COLUMN SECTOR POSITION 7;

ALTER TABLE ROOMS ALTER COLUMN IS_CLEAN POSITION 8;

ALTER TABLE ROOMS ALTER COLUMN IS_INSPECTED POSITION 9;

ALTER TABLE ROOMS ALTER COLUMN SORT_ORDER POSITION 10;

ALTER TABLE ROOMS ALTER COLUMN CLEAN_TEXT POSITION 11;

ALTER TABLE ROOMS ALTER COLUMN FEATURES POSITION 12;

ALTER TABLE ROOMS ALTER COLUMN ID_HOTEL POSITION 13;

ALTER TABLE ROOMS ALTER COLUMN EXTERNAL_NAME POSITION 14;

ALTER TABLE ROOMS ALTER COLUMN ID_EATING_OBJECT POSITION 15;

ALTER TABLE ROOMS ALTER COLUMN ACCOMODATION_PLACE_UIN POSITION 16;

ALTER TABLE SALE_DISCOUNT ALTER COLUMN ID_SALE_DISCOUNT POSITION 1;

ALTER TABLE SALE_DISCOUNT ALTER COLUMN DISCOUNT_NAME POSITION 2;

ALTER TABLE SALE_DISCOUNT ALTER COLUMN DISCOUNTED_VALUE_TYPE POSITION 3;

ALTER TABLE SALE_DISCOUNT ALTER COLUMN DISCOUNT_VALUE POSITION 4;

ALTER TABLE SALE_DISCOUNT ALTER COLUMN DISCOUNT_CALC_METHOD POSITION 5;

ALTER TABLE SALE_DISCOUNT ALTER COLUMN ID_SERVICE POSITION 6;

ALTER TABLE SALE_DISCOUNT ALTER COLUMN SERVICE_DEPENDENCE_TYPE POSITION 7;

ALTER TABLE SALE_DISCOUNT ALTER COLUMN IS_ARCHIVE POSITION 8;

ALTER TABLE SALE_DISCOUNT ALTER COLUMN FIXED_DISCOUNT_CURRENCY POSITION 9;

ALTER TABLE SALE_DISCOUNT ALTER COLUMN ID_HOTEL POSITION 10;

ALTER TABLE SALE_DISCOUNT ALTER COLUMN SUBSCRIBER_ID POSITION 11;

ALTER TABLE SALE_DISCOUNT ALTER COLUMN UUID POSITION 12;

ALTER TABLE SALE_NUM ALTER COLUMN ID_SALE_NUM POSITION 1;

ALTER TABLE SALE_NUM ALTER COLUMN UNIQUE_SALES_NUMBER POSITION 2;

ALTER TABLE SALE_NUM ALTER COLUMN CREATED_AT POSITION 3;

ALTER TABLE SALE_NUM ALTER COLUMN USER_CREATED POSITION 4;

ALTER TABLE SALE_NUM ALTER COLUMN SALE_DATE POSITION 5;

ALTER TABLE SALE_TAXATION ALTER COLUMN ID_SALE_TAXATION POSITION 1;

ALTER TABLE SALE_TAXATION ALTER COLUMN NAME POSITION 2;

ALTER TABLE SALE_TAXATION ALTER COLUMN ID_HOTEL POSITION 3;

ALTER TABLE SALE_TAXATION ALTER COLUMN ACCOUNT_NAME POSITION 4;

ALTER TABLE SALE_TAXES ALTER COLUMN ID_SALE_TAX POSITION 1;

ALTER TABLE SALE_TAXES ALTER COLUMN ID_HOTEL POSITION 2;

ALTER TABLE SALE_TAXES ALTER COLUMN TAX_NAME POSITION 3;

ALTER TABLE SALE_TAXES ALTER COLUMN TAX_PERCENT POSITION 4;

ALTER TABLE SALE_TAXES ALTER COLUMN TAXABLE_BASE_PERCENT POSITION 5;

ALTER TABLE SALE_TAXES ALTER COLUMN FISCAL_CODE POSITION 6;

ALTER TABLE SALE_TAXES ALTER COLUMN TAX_VALUE POSITION 7;

ALTER TABLE SALE_TAXES ALTER COLUMN REVENUE_DEDUCTION_TAX POSITION 8;

ALTER TABLE SALE_TAXES ALTER COLUMN REPORT_IN_DOCUMENT POSITION 9;

ALTER TABLE SALE_TAXES ALTER COLUMN ACCOUNT_NAME POSITION 10;

ALTER TABLE SALE_TAXES ALTER COLUMN SUBSCRIBER_ID POSITION 11;

ALTER TABLE SALE_TAXES ALTER COLUMN IS_PERCENT_TAX POSITION 12;

ALTER TABLE SALE_TAXES ALTER COLUMN TAXATION_REASON POSITION 13;

ALTER TABLE SERVICE_GROUPS ALTER COLUMN ID_SERVICE_GROUP POSITION 1;

ALTER TABLE SERVICE_GROUPS ALTER COLUMN GROUP_NAME POSITION 2;

ALTER TABLE SERVICE_GROUPS ALTER COLUMN ID_HOTEL POSITION 3;

ALTER TABLE SERVICE_GROUPS ALTER COLUMN SUBSCRIBER_ID POSITION 4;

ALTER TABLE SERVICES ALTER COLUMN ID_SERVICE POSITION 1;

ALTER TABLE SERVICES ALTER COLUMN ID_HOTEL POSITION 2;

ALTER TABLE SERVICES ALTER COLUMN ID_SERVICE_GROUP POSITION 3;

ALTER TABLE SERVICES ALTER COLUMN ID_SERVICE_PACKET POSITION 4;

ALTER TABLE SERVICES ALTER COLUMN SERVICE_NAME POSITION 5;

ALTER TABLE SERVICES ALTER COLUMN SERVICE_TYPE POSITION 6;

ALTER TABLE SERVICES ALTER COLUMN IS_BASE POSITION 7;

ALTER TABLE SERVICES ALTER COLUMN IS_MANUAL_PRICE POSITION 8;

ALTER TABLE SERVICES ALTER COLUMN IS_RATE_PRICE POSITION 9;

ALTER TABLE SERVICES ALTER COLUMN IS_DETAILS POSITION 10;

ALTER TABLE SERVICES ALTER COLUMN IS_DELETED POSITION 11;

ALTER TABLE SERVICES ALTER COLUMN REVENUE_GROUP POSITION 12;

ALTER TABLE SERVICES ALTER COLUMN REVENUE_ACCOUNT POSITION 13;

ALTER TABLE SERVICES ALTER COLUMN ACCOUNT_NAME POSITION 14;

ALTER TABLE SERVICES ALTER COLUMN VAUCHER_PACKET POSITION 15;

ALTER TABLE SERVICES ALTER COLUMN EXTRA_PACKET_NAME POSITION 16;

ALTER TABLE SERVICES ALTER COLUMN PRICE POSITION 17;

ALTER TABLE SERVICES ALTER COLUMN PRICE_CURR POSITION 18;

ALTER TABLE SERVICES ALTER COLUMN EXT_CODE POSITION 19;

ALTER TABLE SERVICES ALTER COLUMN UUID POSITION 20;

ALTER TABLE SERVICES ALTER COLUMN SUBSCRIBER_ID POSITION 21;

ALTER TABLE SERVICES ALTER COLUMN SERVICE_NAME_UNQ_HASH POSITION 22;

ALTER TABLE SERVICES ALTER COLUMN CREATED_AT POSITION 23;

ALTER TABLE SERVICES ALTER COLUMN UPDATED_AT POSITION 24;

ALTER TABLE SERVICES ALTER COLUMN ARCHIVED_AT POSITION 25;

ALTER TABLE TAR_BO_BASE_POSITION ALTER COLUMN ID_TAR_BP POSITION 1;

ALTER TABLE TAR_BO_BASE_POSITION ALTER COLUMN ID_TAR_HEAD POSITION 2;

ALTER TABLE TAR_BO_BASE_POSITION ALTER COLUMN POSITION_NUMBER POSITION 3;

ALTER TABLE TAR_BO_BASE_POSITION ALTER COLUMN ID_ROOM_TYPE POSITION 4;

ALTER TABLE TAR_BO_BASE_POSITION ALTER COLUMN MAX_PERSONS POSITION 5;

ALTER TABLE TAR_BO_BASE_POSITION ALTER COLUMN ID_BOARD_INCLUDE POSITION 6;

ALTER TABLE TAR_BO_BASE_POSITION ALTER COLUMN BOARD_WEIGHT POSITION 7;

ALTER TABLE TAR_BO_BASE_POSITION ALTER COLUMN IS_PRICE_FOR_ROOM POSITION 8;

ALTER TABLE TAR_BO_BASE_POSITION ALTER COLUMN PTEXT POSITION 9;

ALTER TABLE TAR_BO_BASE_POSITION ALTER COLUMN PACKET_ITEM POSITION 10;

ALTER TABLE TAR_BO_BASE_POSITION ALTER COLUMN DISC_TAG POSITION 11;

ALTER TABLE TAR_BO_BASE_POSITION ALTER COLUMN SET_VAR POSITION 12;

ALTER TABLE TAR_BO_BASE_POSITION ALTER COLUMN RND_METHOD POSITION 13;

ALTER TABLE TAR_BO_BOARD ALTER COLUMN ID_TAR_BOARD POSITION 1;

ALTER TABLE TAR_BO_BOARD ALTER COLUMN ID_TAR_HEAD POSITION 2;

ALTER TABLE TAR_BO_BOARD ALTER COLUMN ID_SERVICE POSITION 3;

ALTER TABLE TAR_BO_BOARD ALTER COLUMN ID_BOARD POSITION 4;

ALTER TABLE TAR_BO_BOARD ALTER COLUMN PTEXT POSITION 5;

ALTER TABLE TAR_BO_BOARD ALTER COLUMN SEPARATE_BOARD POSITION 6;

ALTER TABLE TAR_BO_BOARD ALTER COLUMN PACKET_ITEM POSITION 7;

ALTER TABLE TAR_BO_BOARD ALTER COLUMN DISC_TAG POSITION 8;

ALTER TABLE TAR_BO_BOARD ALTER COLUMN SET_VAR POSITION 9;

ALTER TABLE TAR_BO_BOARD ALTER COLUMN RND_METHOD POSITION 10;

ALTER TABLE TAR_BO_DISCOUNT ALTER COLUMN ID_TAR_DISCOUNT POSITION 1;

ALTER TABLE TAR_BO_DISCOUNT ALTER COLUMN ID_TAR_HEAD POSITION 2;

ALTER TABLE TAR_BO_DISCOUNT ALTER COLUMN PRIORITET POSITION 3;

ALTER TABLE TAR_BO_DISCOUNT ALTER COLUMN DAY_SCHEME POSITION 4;

ALTER TABLE TAR_BO_DISCOUNT ALTER COLUMN DAY_SCHEME_NUM POSITION 5;

ALTER TABLE TAR_BO_DISCOUNT ALTER COLUMN CALC_LIST POSITION 6;

ALTER TABLE TAR_BO_DISCOUNT ALTER COLUMN ID_SERVICE POSITION 7;

ALTER TABLE TAR_BO_DISCOUNT ALTER COLUMN PTEXT POSITION 8;

ALTER TABLE TAR_BO_DISCOUNT ALTER COLUMN PACKET_ITEM POSITION 9;

ALTER TABLE TAR_BO_DISCOUNT ALTER COLUMN DISC_TAG POSITION 10;

ALTER TABLE TAR_BO_DISCOUNT ALTER COLUMN SET_VAR POSITION 11;

ALTER TABLE TAR_BO_DISCOUNT ALTER COLUMN RND_METHOD POSITION 12;

ALTER TABLE TAR_BO_DISCOUNT_STAY ALTER COLUMN ID_TAR_DISCOUNT_STAY POSITION 1;

ALTER TABLE TAR_BO_DISCOUNT_STAY ALTER COLUMN ID_TAR_HEAD POSITION 2;

ALTER TABLE TAR_BO_DISCOUNT_STAY ALTER COLUMN PRIORITET POSITION 3;

ALTER TABLE TAR_BO_DISCOUNT_STAY ALTER COLUMN CALC_POSITION POSITION 4;

ALTER TABLE TAR_BO_DISCOUNT_STAY ALTER COLUMN CALC_LIST POSITION 5;

ALTER TABLE TAR_BO_DISCOUNT_STAY ALTER COLUMN ID_SERVICE POSITION 6;

ALTER TABLE TAR_BO_DISCOUNT_STAY ALTER COLUMN PTEXT POSITION 7;

ALTER TABLE TAR_BO_DISCOUNT_STAY ALTER COLUMN DISC_TAG POSITION 8;

ALTER TABLE TAR_BO_DISCOUNT_STAY ALTER COLUMN SET_VAR POSITION 9;

ALTER TABLE TAR_BO_DISCOUNT_STAY ALTER COLUMN RND_METHOD POSITION 10;

ALTER TABLE TAR_BO_PACK ALTER COLUMN ID_TAR_PACK POSITION 1;

ALTER TABLE TAR_BO_PACK ALTER COLUMN ID_TAR_HEAD POSITION 2;

ALTER TABLE TAR_BO_PACK ALTER COLUMN ID_SERVICE POSITION 3;

ALTER TABLE TAR_BO_PACK ALTER COLUMN PRICE_CURRENCY POSITION 4;

ALTER TABLE TAR_BO_PACK ALTER COLUMN IS_IN_BASE_PRICE POSITION 5;

ALTER TABLE TAR_BO_PACK ALTER COLUMN CNT_POST POSITION 6;

ALTER TABLE TAR_BO_PACK ALTER COLUMN DAY_SCHEME POSITION 7;

ALTER TABLE TAR_BO_PACK ALTER COLUMN DAY_SCHEME_NUM POSITION 8;

ALTER TABLE TAR_BO_PACK ALTER COLUMN GRP_IN_REPORTS POSITION 9;

ALTER TABLE TAR_BO_PACK ALTER COLUMN GRP_IN_DOCUMENTS POSITION 10;

ALTER TABLE TAR_BO_PACK ALTER COLUMN PTEXT POSITION 11;

ALTER TABLE TAR_BO_PACK ALTER COLUMN PACKET_ITEM POSITION 12;

ALTER TABLE TAR_BO_PACK ALTER COLUMN DISC_TAG POSITION 13;

ALTER TABLE TAR_BO_PACK ALTER COLUMN SET_VAR POSITION 14;

ALTER TABLE TAR_BO_PACK ALTER COLUMN RND_METHOD POSITION 15;

ALTER TABLE TAR_SIMPLE_BOARDS ALTER COLUMN ID_TAR_SIMPLE_BOARDS POSITION 1;

ALTER TABLE TAR_SIMPLE_BOARDS ALTER COLUMN ID_TAR_SIMPLE_SEASON POSITION 2;

ALTER TABLE TAR_SIMPLE_BOARDS ALTER COLUMN ID_BOARD POSITION 3;

ALTER TABLE TAR_SIMPLE_BOARDS ALTER COLUMN ADULT_PRICE POSITION 4;

ALTER TABLE TAR_SIMPLE_BOARDS ALTER COLUMN CHILD_PRICE POSITION 5;

ALTER TABLE TAR_SIMPLE_PRICE ALTER COLUMN ID_TAR_SIMPLE_SEASON POSITION 1;

ALTER TABLE TAR_SIMPLE_PRICE ALTER COLUMN ID_ROOM_TYPE POSITION 2;

ALTER TABLE TAR_SIMPLE_PRICE ALTER COLUMN ID_BOARD POSITION 3;

ALTER TABLE TAR_SIMPLE_PRICE ALTER COLUMN IS_BASE_DAYS_PRICE POSITION 4;

ALTER TABLE TAR_SIMPLE_PRICE ALTER COLUMN SINGLE_PRICE POSITION 5;

ALTER TABLE TAR_SIMPLE_PRICE ALTER COLUMN DOUBLE_PRICE POSITION 6;

ALTER TABLE TAR_SIMPLE_PRICE ALTER COLUMN GUEST3_PRICE POSITION 7;

ALTER TABLE TAR_SIMPLE_PRICE ALTER COLUMN GUEST4PLUS_PRICE POSITION 8;

ALTER TABLE TAR_SIMPLE_PRICE ALTER COLUMN CHILD1_W_ADULT1_PRICE POSITION 9;

ALTER TABLE TAR_SIMPLE_PRICE ALTER COLUMN CHILD1_W_ADULT2PLUS_PRICE POSITION 10;

ALTER TABLE TAR_SIMPLE_PRICE ALTER COLUMN CHILD2PLUS_W_ADULT1_PRICE POSITION 11;

ALTER TABLE TAR_SIMPLE_PRICE ALTER COLUMN CHILD2PLUS_W_ADULT2PLUS_PRICE POSITION 12;

ALTER TABLE TAX_POLICY ALTER COLUMN ID_TAX_POLICY POSITION 1;

ALTER TABLE TAX_POLICY ALTER COLUMN POLICY_NAME POSITION 2;

ALTER TABLE TAX_POLICY ALTER COLUMN IS_ARCHIVE POSITION 3;

ALTER TABLE TAX_POLICY ALTER COLUMN SUBSCRIBER_ID POSITION 4;

ALTER TABLE TAX_POLICY ALTER COLUMN TAXATION_REASON POSITION 5;

ALTER TABLE TAX_POLICY ALTER COLUMN ID_HOTEL POSITION 6;

/* Creating roles */
CREATE ROLE AUDITOR_ROLE;


