/* Server version: WI-V6.3.7.18553 Firebird 2.1 
   SQLDialect: 3. ODS: 11.1. Forced writes: On. Sweep inteval: 20000.
   Page size: 8192. Cache pages: 75 (600 Kb). Read-only: False. */
SET NAMES NONE;

SET SQL DIALECT 3;

ALTER TABLE DOC_FISCAL_DATA DROP CONSTRAINT PK_DOC_FISCAL_DATA;

/* Alter Procedure (Before Drop)... */
SET TERM ^ ;

ALTER PROCEDURE DOC_DISCOUNTABLE_ACCUMULATE$INT(ID_DOC_HEAD INTEGER,
ID_SERVICE_GROUP INTEGER,
NET_VALUE DOUBLE PRECISION,
GROSS_VALUE DOUBLE PRECISION)
 RETURNS(ID_DOC_DISCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DOC_SERVICE_DISCOUNTS$INT(ID_DOC_HEAD INTEGER,
ID_SERVICE_GROUP INTEGER)
 RETURNS(DISCOUNT_CALC_DBKEY CHAR(8),
ID_DOC_DISCOUNT INTEGER,
DISCOUNT_ORDER SMALLINT,
DISCOUNT_VALUE NUMERIC(15,4),
DISCOUNT_CALC_METHOD VARCHAR(50),
DISCOUNTED_VALUE_TYPE VARCHAR(50))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DOCUMENT_DISCOUNTS_APPLICABLE(ID_ACCOUNT INTEGER)
 RETURNS(ID_SALE_DISCOUNT INTEGER,
DISCOUNTED_VALUE_TYPE VARCHAR(50),
DISCOUNT_ORDER INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DOCUMENT_DISCOUNTS_SET$INT(ID_DOC_HEAD INTEGER)
 RETURNS(DISCOUNT_CNT INTEGER)
 AS
 BEGIN SUSPEND; END
^


/* Drop Procedure... */
ALTER PROCEDURE DOCUMENT_CALC_DISCOUNTS$INT(ID_DOC_HEAD INTEGER,
DOC_CURRENCY VARCHAR(3),
SECOND_CURRENCY VARCHAR(3))
 AS
 BEGIN EXIT; END
^

SET TERM ; ^

DROP PROCEDURE DOC_DISCOUNTABLE_ACCUMULATE$INT;

DROP PROCEDURE DOC_SERVICE_DISCOUNTS$INT;

DROP PROCEDURE DOCUMENT_DISCOUNTS_APPLICABLE;

DROP PROCEDURE DOCUMENT_DISCOUNTS_SET$INT;


/* Create Table... */
CREATE GLOBAL TEMPORARY TABLE DOC_FISCAL_LINES$TMP(ID_DOC_HEAD ID,
FISC_GRP TSHORT_CODE,
FISC_TEXT TDESCRIPTION_SHORT,
FISC_PRICE TPRICE,
FISC_QTY TQTY,
LINE_TYPE TENUM_STRING)
 ON COMMIT DELETE ROWS;



ALTER TABLE DOC_FISCAL_DATA ADD ID_FISCAL_DATA ID_REF NOT NULL;

ALTER TABLE DOC_FISCAL_DATA ADD FISCAL_AMOUNT TPRICE;

ALTER TABLE DOC_FISCAL_DATA ADD FISCAL_DISCOUNTS TNOTE_BLOB;

ALTER TABLE DOC_FISCAL_DATA ADD FISCAL_GROUP_LIST TENUM_STRING;

ALTER TABLE SALE_DISCOUNT_CALC$TMP ADD ID_SALE_TAXATION ID_REF;

ALTER TABLE SALE_DISCOUNT_CALC$TMP ADD TAXES_IDS TDESCRIPTION_SHORT;

/* Create Procedure... */
SET TERM ^ ;

CREATE PROCEDURE DISCOUNT_TAXATION_GET$INT(TAXES_IDS TYPE OF TDESCRIPTION_SHORT)
 RETURNS(ID_SALE_TAXATION TYPE OF ID)
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE DISCOUNTABLE_VALUE_CALC$INT(ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

CREATE PROCEDURE DOC_LINES_TO_DISCOUNT(ID_DOC_HEAD TYPE OF ID,
ID_SALE_DISCOUNT TYPE OF ID)
 RETURNS(ID_DOC_LINE TYPE OF ID,
TAXES_IDS TYPE OF TDESCRIPTION_SHORT)
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE DOCUMENT_DELETE$DOC(ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

CREATE PROCEDURE DOCUMENT_DISCOUNTS_INIT$INT(ID_DOC_HEAD INTEGER)
 RETURNS(DISCOUNT_CNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE DOCUMENT_PRENUMERATE$DOC(SELECTION_ID INTEGER)
 AS
 BEGIN EXIT; END
^

CREATE PROCEDURE FISCALIZE_DISCOUNT$FISC(ID_FISCAL_DATA INTEGER)
 RETURNS(FISC_SUM NUMERIC(15,4),
FISC_TEXT VARCHAR(100))
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE PAYMENT_DOC_DELETE$DOC(ID_PAYMENT_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

CREATE PROCEDURE SALE_DISCOUNTS_APPLICABLE(ID_DOC_HEAD INTEGER)
 RETURNS(ID_SALE_DISCOUNT INTEGER,
DISCOUNTED_VALUE_TYPE VARCHAR(50),
DISCOUNT_CALC_METHOD VARCHAR(50),
DISCOUNT_ORDER INTEGER,
ID_SERVICE INTEGER,
ID_TAX_POLICY INTEGER)
 AS
 BEGIN SUSPEND; END
^


/* Create Views... */
/* Create view: DOC_FISCAL_BONS */
SET TERM ; ^

CREATE VIEW DOC_FISCAL_BONS(
ID_FISCAL_DATA,
ID_DOC_HEAD,
IS_STORNO_BON,
UNIQUE_SALES_NUMBER,
FISCAL_DEVICE_ID,
FISCALIZATION_DETAILS,
FISCAL_AMOUNT,
FISCAL_LINES,
FISCAL_DISCOUNTS,
FISCAL_PAYMENTS,
FISCAL_GROUP_LIST)
 AS 
select f.ID_FISCAL_DATA,
       f.ID_DOC_HEAD,
       vr.tag as is_storno_bon,
       f.UNIQUE_SALES_NUMBER,
       iif(vr.tag = 0, f.FISCAL_DEVICE_ID, f.STORNO_FISCAL_DEVICE_ID) as FISCAL_DEVICE_ID,
       iif(vr.tag = 0, f.FISCALIZATION_DETAILS, f.STORNO_FISCALIZATION_DETAILS) as FISCALIZATION_DETAILS,
       f.FISCAL_AMOUNT,
       f.FISCAL_LINES,
       f.FISCAL_DISCOUNTS,
       f.FISCAL_PAYMENTS,
       f.FISCAL_GROUP_LIST
from   DOC_FISCAL_DATA f
       join DOC_HEAD d on d.ID_DOC = f.ID_DOC_HEAD
       left join RECORD_MULTIPLIER vr on (
         (d.DOC_SUB_TYPE < 2 and ((vr.TAG = 0) or (vr.TAG = 1 and d.IS_ANUL = 1 and f.FISCAL_DEVICE_ID is not null)))
          or (d.DOC_SUB_TYPE = 2 and vr.tag = 1) -- credit docs with own bons
       )
;

/* Create view: SALE_TAXATION_WITH_TAX */
CREATE VIEW SALE_TAXATION_WITH_TAX(
ID_SALE_TAXATION,
NAME,
ID_HOTEL,
ACCOUNT_NAME,
TAXES_IDS,
INCLUDE_NON_VAT)
 AS 
select st.ID_SALE_TAXATION,
       st.NAME,
       st.ID_HOTEL,
       st.ACCOUNT_NAME,
       cast(list(distinct(iif(t.REVENUE_DEDUCTION_TAX is not distinct from 1, null, t.ID_SALE_TAX))) as varchar(100)) as taxes_ids,
       max(iif(t.REVENUE_DEDUCTION_TAX is not distinct from 1, 1, 0))
from   SALE_TAXATION st
       join SALE_TAXATION_TAX stt on stt.ID_SALE_TAXATION = st.ID_SALE_TAXATION
       join SALE_TAXES t on t.ID_SALE_TAX = stt.ID_SALE_TAX
group by 1, 2, 3, 4
;


/* Create generator... */
CREATE GENERATOR GEN_DOC_FISCAL_DATA_ID;

/* Create Foreign Key... */
RECONNECT;

ALTER TABLE DOC_FISCAL_DATA ADD CONSTRAINT FK_DFD_DOC_HEAD FOREIGN KEY (ID_DOC_HEAD) REFERENCES DOC_HEAD$INT (ID_DOC_HEAD) ON UPDATE CASCADE ON DELETE CASCADE;

/*  Empty FISCALIZE_PREPARE$FISC for FISCALIZE_PREPARE_DATA$INT(param list change)  */
SET TERM ^ ;

ALTER PROCEDURE FISCALIZE_PREPARE$FISC(ID_DOC_HEAD /* TYPE OF ID */ INTEGER)
 RETURNS(UNIQUE_SALES_NUMBER /* TYPE OF TENUM_STRING */ VARCHAR(50),
FISCALIZATION_DETAILS /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
VOID_REASON /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
IS_VOID /* TYPE OF TLOGICAL */ SMALLINT,
DOC_DESCRIPTION /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100))
 AS
 BEGIN SUSPEND; END
^

/*  Empty FISCALIZE_VOID_PREPARE$FISC for FISCALIZE_PREPARE_DATA$INT(param list change)  */
ALTER PROCEDURE FISCALIZE_VOID_PREPARE$FISC(ID_DOC_HEAD /* TYPE OF ID */ INTEGER)
 RETURNS(UNIQUE_SALES_NUMBER /* TYPE OF TENUM_STRING */ VARCHAR(50),
FISCALIZATION_DETAILS /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
VOID_REASON /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
DOC_DESCRIPTION /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100))
 AS
 BEGIN SUSPEND; END
^

/*  Empty FISCALIZE_PREPARE_DATA$INT for FISCALIZE_PREPARE_LINES$INT(param list change)  */
ALTER PROCEDURE FISCALIZE_PREPARE_DATA$INT(ID_DOC_HEAD /* TYPE OF ID */ INTEGER,
UNIQUE_SALES_NUMBER /* TYPE OF TENUM_STRING */ VARCHAR(50),
SUMMARY_FISCALIZATION /* TYPE OF TLOGICAL */ SMALLINT = 0)
 AS
 BEGIN EXIT; END
^

/* Alter empty procedure FISCALIZE_PREPARE_DATA$INT with new param-list */
ALTER PROCEDURE FISCALIZE_PREPARE_DATA$INT(ID_DOC_HEAD TYPE OF ID,
UNIQUE_SALES_NUMBER TYPE OF TENUM_STRING,
SUMMARY_FISCALIZATION TYPE OF TLOGICAL = 0)
 RETURNS(FISCAL_AMOUNT TYPE OF TPRICE)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure FISCALIZE_PREPARE_LINES$INT with new param-list */
ALTER PROCEDURE FISCALIZE_PREPARE_LINES$INT(ID_DOC_HEAD TYPE OF ID,
TARGET_FISCAL_VALUE TYPE OF TPRICE,
FISC_VALUE_COEF TYPE OF TCOEF,
DOC_RATE TYPE OF TRATE,
STORNO_COEF TYPE OF TCOEF,
ROUND_TO TYPE OF TPRICE,
IS_ADVANCE TYPE OF TLOGICAL,
SUMMARY_FISCALISATION TYPE OF TLOGICAL = 0)
 RETURNS(FISC_PRICE TYPE OF TPRICE,
FISC_QTY TYPE OF TPRICE,
FISC_TEXT TYPE OF TDESCRIPTION_SHORT,
FISC_GRP TYPE OF TSHORT_CODE,
TRANSACTION_VALUE TYPE OF TPRICE,
LINE_TYPE TYPE OF TENUM_STRING)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure FISCALIZE_VOID_PREPARE$FISC with new param-list */
ALTER PROCEDURE FISCALIZE_VOID_PREPARE$FISC(ID_DOC_HEAD TYPE OF ID)
 RETURNS(VOID_REASON TYPE OF TDESCRIPTION_SHORT,
DOC_DESCRIPTION TYPE OF TDESCRIPTION_SHORT)
 AS
 BEGIN SUSPEND; END
^

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_ADD$INT for: ACCOUNT_CHECK_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_GUEST /* TYPE OF ID_REF */ INTEGER,
ID_SECQUENCE /* TYPE OF ID_REF */ INTEGER,
DATE_POST /* TYPE OF TDATE */ DATE,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
IS_BASE /* TYPE OF TLOGICAL */ SMALLINT,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
ORIG_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
CHANGED_TEXT /* TYPE OF TTEXT_SHORT */ VARCHAR(30),
ID_MASTER_ADDINS_ACC_POST /* TYPE OF ID_REF */ INTEGER,
DESCRIPTION /* TYPE OF TSERVICE_DESCRIPTION */ VARCHAR(67) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
NEW_ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE$INT for: ACCOUNT_CHECK_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
ID_SERVICE /* TYPE OF ID_REF */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
QTY_FREE /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TVALUE */ DOUBLE PRECISION,
CURR /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
CHANGED_TEXT VARCHAR(40),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
IS_CONSEQUENTIAL_UPDATE /* TYPE OF TBOOLEAN */ SMALLINT = 0,
RE_ROUTE_ACCOUNT /* TYPE OF ID_REF */ INTEGER = null,
DESCRIPTION /* TYPE OF TSERVICE_DESCRIPTION */ VARCHAR(67) = null)
 RETURNS(OUT_QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
OUT_PRICE_POST /* TYPE OF TVALUE */ DOUBLE PRECISION,
OUT_AC VARCHAR(2))
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_CHECK_CREDIT_STATUS$INT) */
ALTER PROCEDURE ACCOUNT_CHECK_CREDIT_STATUS$INT(ID_ACCOUNT TYPE OF ID_REF,
POST_VALUE TYPE OF TPRICE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_credit_account integer;
  declare variable id_reserv_detail integer;
  declare variable credit_limit tprice;
  declare variable b_post_sum tprice;
  declare variable b_pay_sum tprice;
  declare variable difference_value tprice;
  declare variable no_use varchar(255);
  declare variable account_currency tcurrency;
  declare variable round_to numeric(15,4);
begin
  if (:POST_VALUE = 0) then exit;

  select a.IS_CREDIT_ACCOUNT, a.CREDIT_LIMIT, a.ID_RESERV_DETAIL
  from   ACCOUNT A
  where  a.ID_ACCOUNT = :ID_ACCOUNT
  into   :is_credit_account, :credit_limit, :id_reserv_detail;

  if (:is_credit_account = 0
      and exists (select rd.ID_RESERV_DETAIL
                  from   RESERV_DETAIL rd
                  where  rd.ID_RESERV_DETAIL = :id_reserv_detail
                         and rd.CHECK_STATUS = 1)) then
  begin
    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, :credit_limit, 1);
  end

  if (coalesce(:credit_limit, 0) > 0) then begin
    /* FIND BALANCE OF ACCOUNT */
    execute procedure ACCOUNT_BALANCE$INT(:id_account)
    returning_values  :account_currency, :round_to, :no_use, :b_post_sum, :b_pay_sum, :no_use, :no_use;
    b_post_sum = coalesce(:b_post_sum, 0);
    b_pay_sum  = coalesce(:b_pay_sum, 0);

    /* IS THIS POST IS IN LIMIT */
    if ((:b_post_sum + :POST_VALUE) > :credit_limit) then begin
      err_code = -13; /*  */
      difference_value = :b_post_sum + :POST_VALUE - :credit_limit;
      err_text = f_character(29)||FormatFloat(:credit_limit, :round_to)||' '||:account_currency||
                 f_character(28)||FormatFloat(:difference_value, :round_to);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ACCOUNT$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
QTY /* TYPE OF TQTY */ NUMERIC(15,2),
ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
DATE_POST /* TYPE OF TDATE */ DATE,
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ROOM /* TYPE OF ID */ INTEGER = null,
POST_DESCRIPTION /* TYPE OF TSERVICE_DESCRIPTION */ VARCHAR(67) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_GUEST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ACCOUNT_ROUTING /* TYPE OF TSHORT_CODE */ VARCHAR(10),
DESCRIPTION /* TYPE OF TSERVICE_DESCRIPTION */ VARCHAR(67) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_REPOST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC /* TYPE OF ID_REF */ INTEGER,
ID_RESERV_DETAIL /* TYPE OF ID_REF */ INTEGER,
RECALC_MARKER VARCHAR(40))
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_ADD$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT TYPE OF ID,
ID_GUEST TYPE OF ID_REF,
ID_SECQUENCE TYPE OF ID_REF,
DATE_POST TYPE OF TDATE,
ID_SERVICE TYPE OF ID,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
IS_BASE TYPE OF TLOGICAL,
QTY_POST TYPE OF TQTY,
PRICE TYPE OF TPRICE,
ORIG_CURRENCY TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
CHANGED_TEXT TYPE OF TTEXT_SHORT,
ID_MASTER_ADDINS_ACC_POST TYPE OF ID_REF,
DESCRIPTION TYPE OF TSERVICE_DESCRIPTION = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
NEW_ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable price_post double precision;
  declare variable post_rate numeric (15, 6);
  declare variable curr_post char(3);
  declare variable account_currency char(3);
  declare variable id_pack_service integer;
  declare variable id_room_type integer;
  declare variable room_name varchar(30);
  declare variable is_archive integer;
  declare variable id_tax_policy integer;
  declare variable id_sale_taxation integer;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable check_option varchar(255);
  declare variable id_hotel integer;
  declare variable id_srv_hotel integer;
  declare variable service_name varchar(30);
  declare variable account_name varchar(50);
  declare variable id_sale_num integer;
begin
  ID_GUEST = nullif(:ID_GUEST, -1);

  execute procedure POST_PRICE_CHECK$INT (:QTY_POST, :PRICE, :ORIG_CURRENCY);

  if ( (:IS_BASE = 1) or (:ID_MASTER_ADDINS_ACC_POST > 0) ) then
    check_option = 'IS_BASE;ALLOW_POSTING;UNIQUE_SALES_NUMBER';
  else
    check_option = 'IS_EXTRA;ALLOW_POSTING;UNIQUE_SALES_NUMBER';

  execute procedure ACCOUNT_VALIDATE$INT(:id_account, :check_option)
  returning_values  (:err_code, :err_text, :account_currency, :id_tax_policy, :id_hotel,
                     :account_name, :id_sale_num);
  if (:err_code < 0) then EXIT; --  exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;

  if (:id_sale_num is null) then begin
    execute procedure ACCOUNT_SALE_NUMBER_SET(:ID_ACCOUNT)
    returning_values (:id_sale_num);
  end

  select s.ID_HOTEL, s.SERVICE_NAME, coalesce(:DESCRIPTION, s.DESCRIPTION)
  from   SERVICES S
  where  s.ID_SERVICE = :ID_SERVICE
  into   :id_srv_hotel, :service_name, :DESCRIPTION;

  if (:id_srv_hotel is distinct from :id_hotel) then
    exception POSTING_EXCEPTION '-1056' || f_character(31) || f_character(29) || :service_name || f_character(28) || :account_name;

  if (:rate is null) then begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :orig_currency, :date_post, :id_guest)
    returning_values  :rate;
  end

  curr_post  = :account_currency;
  if (:orig_currency = :account_currency) then begin
    post_rate  = :rate;
  end else begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :account_currency, :date_post, :id_guest)
    returning_values  :post_rate;
  end

  execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :DATE_POST - :FROM_DATE)
  returning_values (:id_sale_taxation);

  execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                    :RATE, :post_rate, :id_sale_taxation)
  returning_values  :price_post, :post_net_value, :post_gross_value;

  execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:ID_ACCOUNT, :price_post * :QTY_POST)
  returning_values (:ERR_CODE, :ERR_TEXT);
  if (:ERR_CODE <> 0) then exit;

  --
  new_id_account_post = gen_id (id_account_post_gen, 1);

  if (:post_text starting with 'PACK') then begin
    id_pack_service = substring(:post_text from 6 for 20);
    post_text = '';
  end else begin
    id_pack_service = -1;
  end
  if (:is_base = 1) then id_master_addins_acc_post = :new_id_account_post;

  select R.ROOM_NAME, R.ID_ROOM_TYPE
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name, :id_room_type;

  if (:id_guest is null) then begin
    is_archive = 1;
  end else begin
    select iif(G.CHECK_STATUS = 1, 1, 0)
    from   GUEST G
    where  G.ID_GUEST = :id_guest
    into   :is_archive;
  end

  insert into ACCOUNT_POST (
    ID_ACCOUNT_POST, ID_ACCOUNT, ID_GUEST, ID_SERVICE, ID_TARIFF, ID_ROOM,
    IS_BASE, DATE_POST, QTY_POST, QTY_FREE, PRICE_POST, POST_NET_VALUE, POST_GROSS_VALUE, CURR_POST, RATE_POST,
    PRICE_ORIG, CURR_ORIG, RATE_ORIG, IS_LOCKED_FOR_UPDATE, TO_DATE, FROM_DATE, ID_SEQUENCE,
    SHORT_CODE, CHANGED_TEXT, ID_MASTER_ADDINS_ACC_POST, ID_PACK_SERVICE, ROOM_NAME, ID_ROOM_TYPE,
    ID_SALE_TAXATION, AC, IS_ARCHIVE, IN_DOC_QTY, IN_DOC_VALUE, DESCRIPTION)
  values (
    :new_id_account_post, :id_account, :id_guest, :id_service, :id_tariff, coalesce(:id_room, -1),
    :is_base, :date_post, :qty_post, 0, :price_post, :post_net_value, :post_gross_value, :curr_post, :post_rate,
    :price, :orig_currency, :rate, 0, :TO_DATE, :FROM_DATE, :id_secquence,
    :short_code, :changed_text, :id_master_addins_acc_post, :id_pack_service, :room_name, :id_room_type,
    :id_sale_taxation, '00', :is_archive, 0, 0, :DESCRIPTION);

  if ((coalesce(:post_text, '') <> '') or (coalesce(:resource_text, '') <> '')) then begin
    insert into ACCOUNT_POSTING_DET (ID_ACCOUNT_POST, POST_TEXT, QTY, FROM_DATETIME, TO_DATETIME, RESOURCE_TEXT)
    values (:new_id_account_post, :post_text, :qty_post, :FROM_DATE, :TO_DATE, :resource_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER,
IS_MANUAL_TRANSFER /* TYPE OF TLOGICAL */ SMALLINT = 1)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_ID_TARIFF /* TYPE OF ID */ INTEGER,
IN_ID_ROOM /* TYPE OF ID */ INTEGER,
IN_QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
IN_QTY_FREE /* TYPE OF TQTY */ NUMERIC(15,2),
IN_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
IN_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_RATE /* TYPE OF TRATE */ NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IN_DESCRIPTION /* TYPE OF TSERVICE_DESCRIPTION */ VARCHAR(67) = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE_PERC for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_POSTING$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
PRICE_DESCRIPTION /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(DOC_SELECTED /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_POSTING_UPDATE$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY TYPE OF TDB_KEY,
ID_SERVICE TYPE OF ID_REF,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
QTY_POST TYPE OF TQTY,
QTY_FREE TYPE OF TQTY,
PRICE TYPE OF TVALUE,
CURR TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
CHANGED_TEXT VARCHAR(40),
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
IS_CONSEQUENTIAL_UPDATE TYPE OF TBOOLEAN = 0,
RE_ROUTE_ACCOUNT TYPE OF ID_REF = null,
DESCRIPTION TYPE OF TSERVICE_DESCRIPTION = null)
 RETURNS(OUT_QTY_POST TYPE OF TQTY,
OUT_PRICE_POST TYPE OF TVALUE,
OUT_AC VARCHAR(2))
 AS
declare variable date_post date;
  declare variable orig_is_base integer;
  declare variable orig_id_service integer;
  declare variable orig_id_room integer;
  declare variable orig_short_code varchar(255);
  declare variable orig_qty_post integer;
  declare variable orig_ac varchar(2);
  declare variable is_locked_for_update integer;
  declare variable orig_locked_for_update integer;
  declare variable orig_id_tariff integer;
  declare variable orig_id_guest integer;
  declare variable id_type_stay integer;
  declare variable id_room_type integer;
  declare variable id_board integer;
  declare variable id_pack_service integer;
  declare variable new_id_pack_service integer;
  declare variable post_currency char(3);
  declare variable room_name varchar(30);
  declare variable original_post varchar(30);
  declare variable new_ac varchar(2);
  declare variable orig_in_doc_qty numeric(15,2);
  declare variable orig_in_doc_value double precision;
  declare variable rate_post numeric(15,6);
  declare variable id_base_doc integer;
  declare variable id_tax_policy integer;
  declare variable price_post double precision;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable id_sale_taxation integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable orig_price_post tprice;
  declare variable round_to numeric(15,4);
  declare variable account_name tobject_name;
  declare variable err_code integer;
  declare variable err_text varchar(100);
  declare variable id_account integer;
  declare variable orig_id_master_addins_acc_post integer;
  declare variable check_options varchar(255);
  declare variable id_sale_num integer;
  declare variable orig_description type of TSERVICE_DESCRIPTION;
begin
  /* GET DATA */
  original_post = '';
  new_id_pack_service = null;

  select AP.DATE_POST, AP.IS_BASE, AP.ID_SERVICE, AP.ID_BASE_DOC,
         AP.SHORT_CODE, AP.QTY_POST, ap.PRICE_POST, AP.IS_LOCKED_FOR_UPDATE,
         AP.AC, AP.ID_TARIFF, AP.ID_GUEST, AP.ID_ROOM,
         AP.ID_PACK_SERVICE, AP.ID_ROOM_TYPE,
         AP.IN_DOC_QTY, AP.IN_DOC_VALUE, AP.RATE_POST, ap.ID_SALE_TAXATION,
         ap.ID_ACCOUNT, ap.ID_ACCOUNT_POST, ap.ID_MASTER_ADDINS_ACC_POST, ap.DESCRIPTION
  from   ACCOUNT_POST AP
  where  AP.rdb$db_key = :AP_DBKEY
  into   :date_post, :orig_is_base, :orig_id_service, :id_base_doc,
         :orig_short_code, :orig_qty_post, :orig_price_post, :orig_locked_for_update,
         :orig_ac, :orig_id_tariff, :orig_id_guest, :orig_id_room,
         :id_pack_service, :id_room_type,
         :orig_in_doc_qty, :orig_in_doc_value, :rate_post, :id_sale_taxation,
         :id_account, :id_account_post, :orig_id_master_addins_acc_post, :orig_description;

  check_options = 'ALLOW_POSTING;';
  if (:RE_ROUTE_ACCOUNT is not null and :id_base_doc is null and :id_account <> :RE_ROUTE_ACCOUNT) then begin
    -- IMPORTANT !!! Re-routing is possible only in this case!
    id_account = :RE_ROUTE_ACCOUNT;
    if ( (:orig_is_base = 1) or (:orig_id_master_addins_acc_post > 0) ) then
      check_options = :check_options || 'IS_BASE;';
    else
      check_options = :check_options || 'IS_EXTRA;';
  end
  is_locked_for_update = :orig_locked_for_update; /* to initialize and preserve from null */
  if (:ID_SERVICE <> :orig_id_service and :DESCRIPTION is null) then begin
    select s.DESCRIPTION
    from   SERVICES s
    where  s.ID_SERVICE = :ID_SERVICE
    into   :DESCRIPTION;
  end else begin
    DESCRIPTION = coalesce(:DESCRIPTION, :orig_description);
  end

  if (:IS_CONSEQUENTIAL_UPDATE is distinct from 1) then begin
    -- direct post update - manual edition restrictions check
    if (:QTY_POST = -1) then QTY_POST = :orig_qty_post;   -- preserve current qty

    if (:QTY_POST <> :orig_qty_post) then exception POSTING_EXCEPTION '-379';

    if ((:orig_is_base = 1) and ((:QTY_POST <> 1) or (:ID_SERVICE <> :orig_id_service))) then
      exception POSTING_EXCEPTION '-223';

    if (:orig_ac = '01') then execute procedure RIGHTS_CHECK_GRANTED$INT('BALANCES_EDIT_CLOSED');

    short_code = :orig_short_code;
    id_tariff  = :orig_id_tariff;
    id_room    = :orig_id_room;
    is_locked_for_update = 1;  /* manual corrections must lock the postings  */
  end else begin
    /* post changes is a result from some user operation, indirect update ('NORMAL', 'FORCED', safes recalc, etc....) */
    is_locked_for_update = iif(:CHANGED_TEXT = 'TRANSFER_POSTING', :orig_locked_for_update, 0);

    if (:orig_is_base = 1) then begin
      /* PREPARING THE PACKET SERVICE */
      select Sp.ID_TYPE_STAY, Sp.ID_ROOM_TYPE, s.ID_HOTEL
      from   SERVICE_PACKET Sp
             join SERVICES s on s.ID_SERVICE = sp.ID_SERVICE
      where  s.ID_SERVICE = :id_service
      into   :id_type_stay, :id_room_type, :id_hotel;

      select GS.ID_BOARD
      from   GUEST_STAY GS
      where  GS.ID_GUEST = :orig_id_guest
             and GS.FOR_DATE = :date_post
      into   :id_board;

      execute procedure TAR_GET_BASE_SERVICE$INT(:id_type_stay, :id_room_type, :id_board, :id_hotel)
      returning_values  :id_pack_service;
      /* detecting change of STAY_TYPE or ROOM_TYPE */
      if (exists(
        select *
        from   SERVICE_PACKET S
        where  S.ID_SERVICE = :orig_id_service
               and ((S.ID_TYPE_STAY is distinct from :id_type_stay) or (S.ID_ROOM_TYPE is distinct from :id_room_type))
      )) then original_post = 'CHANGED';
    end
  end

  select R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name;

  if (:orig_locked_for_update = 1
      and :changed_text starting with 'NORMALRECALC'
      and :id_service = :orig_id_service
      --and :orig_is_anul = 0
      and :id_tariff = :orig_id_tariff) then
  begin
    -- price is locked for update
    update ACCOUNT_POST AP
    set    AP.ID_ROOM      = :ID_ROOM,
           AP.ROOM_NAME    = :room_name,
           Ap.FROM_DATE    = :FROM_DATE,
           Ap.TO_DATE      = :TO_DATE,
           AP.ID_PACK_SERVICE  = :id_pack_service,
           AP.CHANGED_TEXT     = :CHANGED_TEXT,
           AP.USER_CHANGED     = current_user,
           AP.DATETIME_CHANGED = current_timestamp,
           AP.SHORT_CODE       = :SHORT_CODE
    where  AP.rdb$db_key   = :AP_DBKEY;
    OUT_QTY_POST = :orig_qty_post;
    OUT_PRICE_POST = :orig_price_post;
    OUT_AC = :orig_ac;
  end else begin
    -- fully update
    execute procedure ACCOUNT_VALIDATE$INT(:id_account, :check_options)
    returning_values  (:err_code, :err_text, :post_currency, :id_tax_policy, :id_hotel,
                      :account_name, :id_sale_num);
    if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;
  
    if (:id_sale_num is null) then begin
      execute procedure ACCOUNT_SALE_NUMBER_SET(:ID_ACCOUNT)
      returning_values (:id_sale_num);
    end

    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :curr, :date_post, :orig_id_guest)
    returning_values  :rate;
  
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :post_currency, :date_post, :orig_id_guest)
    returning_values  :rate_post;
  
    if (:id_base_doc is null) then begin
      execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :date_post - :from_date)
      returning_values (:id_sale_taxation);
    end

    execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                      :RATE, :rate_post, :id_sale_taxation)
    returning_values  :price_post, :post_net_value, :post_gross_value;

    select c.ROUND_TO
    from   CURRS c
    where  c.CURR = :post_currency
    into   :round_to;

    if ( (:id_base_doc is not null)
         and (:qty_post = :orig_in_doc_qty)
         and (round_f(:price_post * :qty_post - :orig_in_doc_value * :orig_in_doc_qty, :round_to) = 0))
    then new_ac = '01';
    else new_ac = '00';                   
  
    if (:new_ac = '00') then begin
      execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:id_account, :price_post * :QTY_POST - :orig_price_post * :orig_qty_post)
      returning_values (:err_code, :err_text);
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;
    end

    update ACCOUNT_POST AP
    set    AP.ID_ACCOUNT           = :id_account,
           AP.ID_SERVICE           = :id_service,
  
           AP.QTY_POST             = :qty_post,
           AP.QTY_FREE             = :qty_free,
           AP.PRICE_POST           = :price_post,
           AP.CURR_POST            = :post_currency,
           AP.RATE_POST            = :rate_post,
           AP.RATE_ORIG            = :rate,
           AP.PRICE_ORIG           = :price,
           AP.CURR_ORIG            = :curr,
           AP.POST_NET_VALUE       = :post_net_value,
           AP.POST_GROSS_VALUE     = :post_gross_value,
  
           AP.AC                   = :new_ac,
           AP.IS_ANUL              = 0,
           AP.ANUL_REASON          = '',
           AP.IS_LOCKED_FOR_UPDATE = :is_locked_for_update,
           AP.ID_TARIFF            = :id_tariff,
           AP.ID_PACK_SERVICE      = :id_pack_service,
           AP.ID_ROOM              = :id_room,
           AP.ID_ROOM_TYPE         = :id_room_type,
           AP.ROOM_NAME            = :room_name,
           AP.ID_SALE_TAXATION     = :id_sale_taxation,
           AP.ORIGINAL_POST        = :original_post,
           AP.SHORT_CODE           = :short_code,
           AP.CHANGED_TEXT         = :changed_text,
           AP.USER_CHANGED         = current_user,
           AP.DATETIME_CHANGED     = current_timestamp,
           Ap.FROM_DATE            = :from_date,
           Ap.TO_DATE              = :to_date,
           AP.DESCRIPTION          = :DESCRIPTION
    where  AP.rdb$db_key = :AP_DBKEY
    returning new.id_account_post, new.id_pack_service
    into   :id_account_post, :new_id_pack_service;
  
    if (:new_ac = '01') then begin
      update ACCOUNT_POST_CORRECTION APC
      set    APC.IS_OPEN = 0
      where  APC.ID_ACCOUNT_POST = :id_account_post
             and APC.IS_OPEN = 1;
    end

    if (:orig_is_base = 1 and :new_id_pack_service <> :id_pack_service) then begin
      -- update add_inses with new pack service
      update ACCOUNT_POST AP
      set    ap.ID_PACK_SERVICE = :new_id_pack_service
      where  ap.ID_MASTER_ADDINS_ACC_POST = :id_account_post
             and ap.IS_BASE = 0;
    end

    OUT_QTY_POST = :qty_post;
    OUT_PRICE_POST = :price_post;
    OUT_AC = :new_ac;
  end
end
^

/* Alter (ACCOUNT_POSTING_UPDATE_PERC) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
declare variable id_account_post integer;
  declare variable ap_dbkey char(8);
  declare variable id_service integer;
  declare variable id_tariff integer;
  declare variable id_room integer;
  declare variable id_account integer;
  declare variable qty_post numeric (15,4);
  declare variable qty_free numeric (15,4);
  declare variable short_code varchar(255);
  declare variable curr_post char(3);
  declare variable price_post numeric (15,4);
  declare variable new_qty_post numeric (15,4);
  declare variable new_price_post numeric (15,4);
  declare variable orig_currency char(3);
  declare variable orig_rate numeric (15,4);
  declare variable orig_price numeric (15,4);
  declare variable new_orig_price double precision;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
  declare variable date_post date;
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
begin
  for
    select item
    from   SYSTEM_STRING_PARSER(:in_id_account_post, ',')
    into   :id_account_post
  do begin
    select AP.rdb$db_key, AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, ap.ID_ACCOUNT,
           AP.QTY_POST, ap.PRICE_POST, ap.CURR_POST, ap.DATE_POST,
           AP.QTY_FREE, AP.SHORT_CODE, AP.CURR_ORIG, AP.RATE_ORIG, AP.PRICE_ORIG,
           ap.FROM_DATE, ap.TO_DATE
    from   ACCOUNT_POST AP
    where  AP.ID_ACCOUNT_POST = :id_account_post
    into   :ap_dbkey, :id_service, :id_tariff, :id_room, :id_account,
           :qty_post, :price_post, :curr_post,:date_post,
           :qty_free, :short_code, :orig_currency, :orig_rate, :orig_price,
           :from_date, :to_date;

    new_orig_price = :orig_price + :orig_price * :in_perc;

    execute procedure ACCOUNT_POSTING_UPDATE$INT(:ap_dbkey,
            :id_service, :id_tariff, :id_room,
            :qty_post, :qty_free, :new_orig_price, :orig_currency, :orig_rate,
            :in_changed_text, :short_code, :from_date, :to_date)
    returning_values  :new_qty_post, :new_price_post, :no_use;

    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :id_service
    into   :action_text;

    log_old_value = formatfloat(:qty_post * :price_post, 'F;0.00') || ' ' || :curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :curr_post;
    action_text = f_character(29) || :action_text
                  || f_character(28) || formatfloat(:IN_PERC*100, 'F;0.0') || '%'
                  || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                  || f_character(28) || :log_old_value
                  || f_character(28) || :log_new_value
                  || f_character(28) || replace(:IN_CHANGED_TEXT, 'MANUAL', '');
    execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_PERC_UPDATE', :action_text);
  end
end
^

/* Alter (AR_PAYMENT_TYPE_MODIFY$AR) */
ALTER PROCEDURE AR_PAYMENT_TYPE_MODIFY$AR(ID_AR_PAYMENT_TYPE INTEGER,
PAYMENT_TYPE VARCHAR(30),
IS_USE SMALLINT,
OPERATION VARCHAR(3))
 RETURNS(NEW_ID_AR_PAYMENT_TYPE INTEGER)
 AS
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  NEW_ID_AR_PAYMENT_TYPE = ID_AR_PAYMENT_TYPE;
  if (:OPERATION = 'add') then begin
    NEW_ID_AR_PAYMENT_TYPE = gen_id(G_AUTO_INC_PAYMENT_TYPE, 1);
    insert into AR_PAYMENT_TYPE (ID_AR_PAYMENT_TYPE, PAYMENT_TYPE, IS_USE)
    values (:NEW_ID_AR_PAYMENT_TYPE, :PAYMENT_TYPE, :IS_USE);
  end if (:OPERATION = 'mod') then begin
    update AR_PAYMENT_TYPE pt
    set pt.PAYMENT_TYPE = :PAYMENT_TYPE,
        pt.IS_USE = :IS_USE
    where pt.ID_AR_PAYMENT_TYPE = :ID_AR_PAYMENT_TYPE;
  end if (:OPERATION = 'del') then begin
    delete from AR_PAYMENT_TYPE pt
    where pt.ID_AR_PAYMENT_TYPE = :ID_AR_PAYMENT_TYPE;
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_CREATE$INT for: DOCUMENT_ADD_DISCOUNTS$INT */
ALTER PROCEDURE DOCUMENT_CREATE$INT(DOC_SELECTED INTEGER,
ID_ACCOUNT INTEGER,
ID_DOC_TYPE INTEGER,
DOC_TYPE_NAME /* TYPE OF TOBJECT_NAME */ VARCHAR(50),
DOC_DATE DATE,
DOC_CURR VARCHAR(3),
ID_BASE_DOC INTEGER,
TAX_EVENT_DATE DATE,
IS_PROFORMA /* TLOGICAL */ SMALLINT,
ID_ADVANCE_PAYMENT /* ID_REF */ INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER,
DOC_SUB_TYPE SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_ADD_DISCOUNTS$INT) */
ALTER PROCEDURE DOCUMENT_ADD_DISCOUNTS$INT(ID_DOC_HEAD TYPE OF ID,
ID_ACCOUNT TYPE OF ID)
 AS
declare variable sys_date date;
  declare variable doc_round_to numeric(15,4);
  declare variable nat_curr_round_to numeric(15,4);
  declare variable sec_curr_round_to numeric(15,4);
  declare variable id_doc_line integer;
  declare variable id_service integer;
  declare variable service_name varchar(50);
  declare variable single_value numeric(15,4);
  declare variable nat_gross_value numeric(15,4);
  declare variable sec_curr_gross_value numeric(15,4);
  declare variable id_hotel integer;
  declare variable df_dbkey char(8);
  declare variable discount_calc_method varchar(50);
  declare variable footer_value double precision;
  declare variable id_sale_taxation integer;
  declare variable discount_value numeric(15,4);
  declare variable doc_curr varchar(3);
  declare variable sec_curr varchar(3);
  declare variable doc_curr_rate numeric(15,6);
  declare variable no_use varchar(255);
  declare variable taxes_ids varchar(100);
  declare variable discount_cnt integer;
begin
  /* GET SOME SETTINGS VALUES *************************************************/
  select A.ID_HOTEL
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :id_hotel;

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values :sys_date;

  execute procedure DOCUMENT_CURRS_GET$INT (:ID_DOC_HEAD)
  returning_values (:doc_curr, :doc_curr_rate, :doc_round_to, :no_use, :nat_curr_round_to,
                    :sec_curr, :no_use, :sec_curr_round_to);
  /* CALC DOCUMENT DISCOUNTS ******************************************************/
  execute procedure DOCUMENT_DISCOUNTS_INIT$INT (:ID_DOC_HEAD)
  returning_values :discount_cnt;
  if (:discount_cnt = 0) then EXIT;

  execute procedure DISCOUNTABLE_VALUE_CALC$INT(:ID_DOC_HEAD);

  execute procedure DOCUMENT_CALC_DISCOUNTS$INT (:ID_DOC_HEAD, :doc_curr, :sec_curr);

  for
    select df.RDB$DB_KEY, df.FOOTER_VALUE, sd.DISCOUNT_CALC_METHOD, t.ID_SALE_TAXATION, t.TAXES_IDS,
           sd.ID_SERVICE, s.SERVICE_NAME, sd.DISCOUNT_VALUE, df.SECOND_CURR_DISCOUNT_VALUE
    from   DOC_FOOTER DF
           join SALE_DISCOUNT SD on sd.ID_SALE_DISCOUNT = df.ID_TAX
           join SERVICES s on s.ID_SERVICE = sd.ID_SERVICE
           left join SALE_DISCOUNT_CALC$TMP t on t.ID_DOC_HEAD = df.ID_DOC_HEAD and t.ID_DOC_DISCOUNT = df.ID
    where  DF.ID_DOC_HEAD = :ID_DOC_HEAD
           and sd.DISCOUNTED_VALUE_TYPE = 'taxableValue'
    into   :df_dbkey, :footer_value, :discount_calc_method, :id_sale_taxation, :taxes_ids,
           :id_service, :service_name, :discount_value, :sec_curr_gross_value
  do begin
    single_value = round_f(:footer_value, :doc_round_to);
    id_doc_line = null;

    nat_gross_value = round_f(:footer_value * :doc_curr_rate, :nat_curr_round_to);
    sec_curr_gross_value = round_f(:sec_curr_gross_value, :sec_curr_round_to);

    if (:id_sale_taxation is null) then begin
      execute procedure DISCOUNT_TAXATION_GET$INT(:taxes_ids)
      returning_values (:id_sale_taxation);
    end

    execute procedure DOCUMENT_LINE_ADD$INT (
            :ID_DOC_HEAD, :id_service, :id_sale_taxation,
            :service_name || ' ' || iif(:discount_calc_method = 'fixedValue', '', ' ' || formatfloat(:discount_value, '0.00') ||' %'),
            -1, :sys_date, :sys_date, :sys_date, null,
            1, :footer_value, :single_value, :doc_round_to, :nat_gross_value, :nat_curr_round_to,
            :sec_curr, :sec_curr_gross_value, :sec_curr_round_to, iif(:single_value >= 0, 2, 3),
            0, null)
    returning_values (:id_doc_line, :no_use, :no_use, :no_use);

    update DOC_FOOTER df
    set    df.ID_DOC_LINE = :id_doc_line
    where  df.RDB$DB_KEY = :df_dbkey;
  end 

end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_RESET_TYPE$DOC for: DOCUMENT_BONUSPOINTS_SPEND */
ALTER PROCEDURE DOCUMENT_RESET_TYPE$DOC(ID_DOC_HEAD INTEGER,
ID_DOC_TYPE INTEGER,
DOC_CURRENCY VARCHAR(3),
PROFORMA_NAME_PREFIX VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* Alter (DOCUMENT_BONUSPOINTS_SPEND) */
ALTER PROCEDURE DOCUMENT_BONUSPOINTS_SPEND(ID_DOC_HEAD INTEGER,
BONUSPOINT_CNT INTEGER)
 RETURNS(DOC_REST_AMOUNT NUMERIC(15,4))
 AS
declare variable bonuspoints_avail integer;
  declare variable id_bonuspoint_scheme integer;
  declare variable consume_discount_txt varchar(100) ;
  declare variable consume_point_price numeric(15,4);
  declare variable consume_point_curr varchar(3);
  declare variable doc_curr varchar(3);
  declare variable second_curr varchar(3);
  declare variable discount_value numeric(15,4);
  declare variable doc_discount_value numeric(15,4);
  declare variable sec_curr_discount_value numeric(15,4);
  declare variable round_to numeric(15,4);
  declare variable doc_rate numeric(15,6);
  declare variable second_curr_rate numeric(15,6);
  declare variable bp_price_rate numeric(15,6);
  declare variable no_use varchar(255);
  declare variable consume_point_nominal integer;
begin
  delete from DOC_FOOTER DF
  where  DF.ID_DOC_HEAD = :ID_DOC_HEAD
         and df.ID_TAX is null;

  if (:BONUSPOINT_CNT <= 0) then exit;

  select D.DOC_CURRENCY, D.DOC_RATE, PB.ID_BONUSPOINT_SCHEME, c.ROUND_TO, d.SECOND_CURRENCY, d.SECOND_CURR_RATE,
         cast(coalesce(P.BONUSPOINT_GAINED, 0) - coalesce(p.BONUSPOINT_CONSUMED, 0) as integer)
  from   DOC_HEAD D
         join ACCOUNT A on A.ID_ACCOUNT = d.ID_ACCOUNT
         join PROFILE P on P.ID_PROFILE = a.ID_PROFILE
         join PROFILE_BONUSPOINT_SCHEME PB on PB.ID_PROFILE = P.ID_PROFILE and PB.ID_HOTEL = a.ID_HOTEL
         join CURRS c on c.CURR = d.DOC_CURRENCY
  where  D.ID_DOC = :ID_DOC_HEAD
  into   :doc_curr, :doc_rate, :id_bonuspoint_scheme, :round_to, :second_curr, :second_curr_rate,
         :bonuspoints_avail;

  if (:BONUSPOINT_CNT > :bonuspoints_avail) then exception DOCUMENT_EXCEPTION 'Insufficient bonus points !';

  select BS.CONSUME_DISCOUNT_TXT, BS.CONSUME_POINT_PRICE, BS.CONSUME_POINT_CURR, BS.CONSUME_POINT_NOMINAL
  from   BONUSPOINT_SCHEME BS
  where  BS.ID_BONUSPOINT_SCHEME = :id_bonuspoint_scheme
  into   :consume_discount_txt, :consume_point_price, :consume_point_curr, :consume_point_nominal;

  discount_value = -round_f(:BONUSPOINT_CNT * iif(:consume_point_nominal = 0, 0, cast(:consume_point_price / :consume_point_nominal as double precision)), :round_to);

  if (:doc_curr <> :consume_point_curr) then begin
    -- convert to document currency
    execute procedure DOCUMENT_CURR_RATE_GET$INT (:ID_DOC_HEAD, :consume_point_curr)
    returning_values (:bp_price_rate, :no_use);

    doc_discount_value = round_f(:discount_value * cast(:bp_price_rate / :doc_rate as double precision), :round_to);
  end else begin
    doc_discount_value = :discount_value;
  end
  if (:second_curr = :doc_curr) then begin
    sec_curr_discount_value = :doc_discount_value;
  end else if (:second_curr = :consume_point_curr) then begin
    sec_curr_discount_value = :discount_value;
  end else if (:second_curr is not null) then begin
    execute procedure DOCUMENT_CURR_RATE_GET$INT (:ID_DOC_HEAD, :consume_point_curr)
    returning_values (:bp_price_rate, :no_use);

    sec_curr_discount_value = round_f(:discount_value * cast(:bp_price_rate / :second_curr_rate as double precision), :round_to);
  end

  insert into DOC_FOOTER (ID_DOC_HEAD, ID_TAX, TAX_ORDER, TAXABLE_VALUE,
         ID_DOC_LINE, FOOTER_VALUE, DESCRIPTION, SECOND_CURR_DISCOUNTABLE_VALUE, SECOND_CURR_DISCOUNT_VALUE)
  values (:ID_DOC_HEAD, null, 0, :BONUSPOINT_CNT,
         null, :doc_discount_value, substring(:consume_discount_txt from 1 for 50), :BONUSPOINT_CNT, :sec_curr_discount_value);

  execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, null)
  returning_values (:no_use, :no_use, :no_use, :no_use, :DOC_REST_AMOUNT);

  if (:DOC_REST_AMOUNT < 0) then exception DOCUMENT_EXCEPTION '-380';
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ADD_DISCOUNTS$INT for: DOCUMENT_CALC_DISCOUNTS$INT */
ALTER PROCEDURE DOCUMENT_ADD_DISCOUNTS$INT(ID_DOC_HEAD /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (DOCUMENT_CALC_DISCOUNTS$INT) */
ALTER PROCEDURE DOCUMENT_CALC_DISCOUNTS$INT(ID_DOC_HEAD INTEGER,
DOC_CURRENCY VARCHAR(3),
SECOND_CURRENCY VARCHAR(3))
 AS
declare variable df_dbkey char(8);
  declare variable discountable_value numeric(15,4) ;
  declare variable doc_discount_value numeric(15,4) ;
  declare variable discount_value numeric(15,4) ;
  declare variable sec_curr_discount_value numeric(15,4) ;
  declare variable sec_curr_discountable_value numeric(15,4) ;
  declare variable discount_name varchar(50);
  declare variable discount_calc_method varchar(50);
  declare variable discount_currency varchar(3);
  declare variable cross_rate double precision;
  declare variable round_to numeric(15,4);
  declare variable sec_round_to numeric(15,4);
begin
  select c.ROUND_TO
  from   CURRS C
  where  c.CURR = :DOC_CURRENCY
  into   :round_to;

  select c.ROUND_TO
  from   CURRS C
  where  c.CURR = :SECOND_CURRENCY
  into   :sec_round_to;

  for
    select df.RDB$DB_KEY, T.DISCOUNTABLE_VALUE, sd.FIXED_DISCOUNT_CURRENCY,
           Sd.DISCOUNT_VALUE, sd.DISCOUNT_NAME, sd.DISCOUNT_CALC_METHOD
    from   SALE_DISCOUNT_CALC$TMP T
           join DOC_FOOTER DF on DF.ID = t.ID_DOC_DISCOUNT
           join SALE_DISCOUNT sd on sd.ID_SALE_DISCOUNT = df.ID_TAX
    where  T.ID_DOC_HEAD = :ID_DOC_HEAD
    into   :df_dbkey, :discountable_value, :discount_currency,
           :discount_value, :discount_name, :discount_calc_method
  do begin
    doc_discount_value = null;
    sec_curr_discount_value = null;
    sec_curr_discountable_value = null;

    if (:discount_calc_method = 'fixedValue') then begin
      /* permanent value  */
      if (:DOC_CURRENCY <> :discount_currency) then begin
        select cast((select ddr.curr_rate
                     from   DOC_GET_CURR_RATE$DOC(:ID_DOC_HEAD, :discount_currency) ddr)
                    / DR.CURR_RATE as double precision)
        from   DOC_GET_CURR_RATE$DOC(:ID_DOC_HEAD, :DOC_CURRENCY) DR
        into   :cross_rate;
      end else begin
        cross_rate = 1;
      end
      doc_discount_value = round_f(:discount_value * :cross_rate, :round_to);
      discountable_value = 0;

      if (:SECOND_CURRENCY is not null) then begin
        select cast((select ddr.curr_rate
                     from   DOC_GET_CURR_RATE$DOC(:ID_DOC_HEAD, :discount_currency) ddr)
                    / DR.CURR_RATE as double precision)
        from   DOC_GET_CURR_RATE$DOC(:ID_DOC_HEAD, :SECOND_CURRENCY) DR
        into   :cross_rate;
        sec_curr_discount_value = round_f(:discount_value * :cross_rate, :sec_round_to);
        sec_curr_discountable_value = 0;
      end

    end else begin
      --discountable_value = iif(:discounted_value_type = 'taxableValue', :discountable_wot_vat, :discountable_value);
      doc_discount_value = round_f(:discountable_value * cast(:discount_value/100 as double precision), :round_to);
      if (:SECOND_CURRENCY is not null) then begin
        select cast(d.DOC_RATE / D.SECOND_CURR_RATE as double precision)
        from   DOC_HEAD$INT d
        where  d.ID_DOC_HEAD = :ID_DOC_HEAD
        into   :cross_rate;
        sec_curr_discountable_value = round_f(:discountable_value * :cross_rate, :sec_round_to);
        sec_curr_discount_value = round_f(:doc_discount_value * :cross_rate, :sec_round_to);
      end
    end

    if (round_f(:discountable_value, :round_to) = 0 and :doc_discount_value = 0) then begin
      delete from DOC_FOOTER DF
      where  df.RDB$DB_KEY = :df_dbkey;

    end else begin
      update DOC_FOOTER f
      set    f.FOOTER_VALUE = -:doc_discount_value,
             f.TAXABLE_VALUE = :discountable_value,
             f.SECOND_CURR_DISCOUNT_VALUE = -:sec_curr_discount_value,
             f.SECOND_CURR_DISCOUNTABLE_VALUE = :sec_curr_discountable_value,
             f.DESCRIPTION = :discount_name
      where  f.rdb$db_key = :df_dbkey;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_INITIALIZE$DOC for: DOCUMENT_CREATE$INT */
ALTER PROCEDURE DOCUMENT_INITIALIZE$DOC(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
DOC_SELECTED /* TYPE OF ID */ INTEGER,
PROFORMA_NAME_PREFIX VARCHAR(30) = null)
 RETURNS(ID_DOC_HEAD INTEGER,
ID_HOTEL INTEGER,
WARN_CODE INTEGER,
REQUIRE_ARCHIVE_CONFIRMATION /* TYPE OF TLOGICAL */ SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_CREATE$INT) */
ALTER PROCEDURE DOCUMENT_CREATE$INT(DOC_SELECTED INTEGER,
ID_ACCOUNT INTEGER,
ID_DOC_TYPE INTEGER,
DOC_TYPE_NAME TYPE OF TOBJECT_NAME,
DOC_DATE DATE,
DOC_CURR VARCHAR(3),
ID_BASE_DOC INTEGER,
TAX_EVENT_DATE DATE,
IS_PROFORMA TLOGICAL,
ID_ADVANCE_PAYMENT ID_REF)
 RETURNS(ID_DOC_HEAD INTEGER,
DOC_SUB_TYPE SMALLINT)
 AS
declare variable no_use varchar(255);
  declare variable acc_currency char(3);
  declare variable second_currency char(3);
  declare variable acc_curr_rate numeric(15,6);
  declare variable doc_curr_rate numeric(15,6);
  declare variable sec_curr_rate numeric(15,6);
  declare variable id_doc_num integer;
  declare variable id_hotel integer;
  declare variable currency_list varchar(1000);
  declare variable id_sale_num integer;
begin
  /* FIND THE ACCOUNT CURRENCY ************************************************/
  select A.ACCOUNT_CURR, A.ID_HOTEL, a.ID_SALE_NUM
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :acc_currency, :id_hotel, :id_sale_num;

  if (:id_sale_num is null) then begin
    execute procedure ACCOUNT_SALE_NUMBER_SET(:ID_ACCOUNT)
    returning_values (:id_sale_num);
  end
  /* FIND THE DOCUMENT LOOKUPS FROM THE DOCUMENT TYPE *************************/
  select iif(:IS_PROFORMA = 1, dti.ID_PROFORMA_NUM, DT.ID_DOC_NUM), dti.SECOND_CURRENCY, dt.CURRENCY_LIST
  from   DOC_TYPE DT
         join DOC_TYPE_INV DTI on DTI.ID_DOC_TYPE = DT.ID_DOC_TYPE
  where  DT.ID_DOC_TYPE = :id_doc_type
         and DT.ID_HOTEL = :id_hotel
  into   :id_doc_num, :second_currency, :currency_list;

  if (:IS_PROFORMA = 1 and :ID_ADVANCE_PAYMENT is not null) then
     exception DOCUMENT_EXCEPTION '-392';
  if (:IS_PROFORMA = 1 and :id_doc_num is null) then
     exception DOCUMENT_EXCEPTION '-393';
  if (:id_doc_num is null) then
    exception DOCUMENT_EXCEPTION '-92' || f_character(31) || f_character(29) || :doc_type_name;
  /* CHECK DOC_TYPE CURRENCY RESTRICTIONS *************************************/
  if (:currency_list not containing :DOC_CURR) then
    exception CURRENCY_IS_NOT_SUPPORTED f_character (29) || :DOC_CURR || f_character (28) || :doc_type_name;
  /* GET ACTUAL CURRENCY RATES ************************************************/
  execute procedure DOCUMENT_CURR_RATE_GET$INT (:DOC_SELECTED, :acc_currency)
  returning_values  (:acc_curr_rate, :no_use);

  execute procedure DOCUMENT_CURR_RATE_GET$INT (:DOC_SELECTED, :DOC_CURR)
  returning_values  (:doc_curr_rate, :no_use);

  if (:second_currency is not null) then
    execute procedure DOCUMENT_CURR_RATE_GET$INT (:DOC_SELECTED, :second_currency)
    returning_values  (:sec_curr_rate, :no_use);
  /*****------------------------------------------------------------------*****/
  /*****                 CREATING THE NEW DOCUMENT                        *****/
  /*****              CREATING NEW RECORD IN DOC_HEAD                     *****/
  /*****                    AND NEW DOC LINES                             *****/
  /*****------------------------------------------------------------------*****/
  ID_DOC_HEAD = :DOC_SELECTED;
  ID_BASE_DOC = coalesce(:ID_BASE_DOC, :ID_DOC_HEAD);

  insert into DOC_HEAD$INT(ID_DOC_HEAD, ID_DOC_TYPE, DOC_SUB_TYPE, ID_ACCOUNT, DOC_DATE,
         DOC_CURRENCY, DOC_RATE, DOC_ACC_RATE, DOC_TYPE_NAME,
         DOC_VALUE, DOC_VALUE_A, DOC_NET_VALUE, DOC_VALUE_ROUNDLESS, ID_BASE_DOC, FOR_DEPOSIT,
         IS_STORNO, IS_STORNED, IS_ANUL,SECOND_CURRENCY, SECOND_CURR_RATE, SECOND_CURR_NET_VALUE, SECOND_CURR_GROSS_VALUE, ID_DOC_NUM)
  values (:id_doc_head, :id_doc_type, 0, :id_account, :DOC_DATE,
         :DOC_CURR, :doc_curr_rate, cast(:doc_curr_rate/:acc_curr_rate as double precision), :DOC_TYPE_NAME,
         0, 0, 0, 0, :id_base_doc, iif(:ID_ADVANCE_PAYMENT is null,  0, 1),
         0, 0, 0, :second_currency, :sec_curr_rate, iif(:second_currency is null, null, 0), iif(:second_currency is null, null, 0), :id_doc_num);

  if (:IS_PROFORMA is distinct from 1) then begin
    id_sale_num = null;
    if (:ID_BASE_DOC <> :ID_DOC_HEAD) then begin
      select d.ID_SALE_NUM
      from   DOC_HEAD d
      where  d.ID_DOC = :ID_BASE_DOC
      into   :id_sale_num;
    end
    execute procedure DOCUMENT_COMPLETE$INT (:ID_DOC_HEAD, :DOC_DATE, :TAX_EVENT_DATE, null, :id_sale_num);
  end

  if (:ID_ADVANCE_PAYMENT is null) then begin
    execute procedure DOCUMENT_ADD_SERVICES$INT (:ID_DOC_HEAD, :ID_ACCOUNT);

    execute procedure DOCUMENT_ADD_DISCOUNTS$INT(:ID_DOC_HEAD, :ID_ACCOUNT);

  end else begin
    execute procedure DOCUMENT_ADVANCE_PAYMENT$INT (:ID_DOC_HEAD, :ID_ADVANCE_PAYMENT, :acc_curr_rate);
  end

  execute procedure DOCUMENT_SAVE_TOTAL$INT (:ID_DOC_HEAD)
  returning_values :DOC_SUB_TYPE;

end
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_DOCUMENT_INITIALIZE$DOC for: DOCUMENT_INITIALIZE$DOC */
ALTER PROCEDURE DEPOSIT_DOCUMENT_INITIALIZE$DOC(ID_PAYMENT_HEAD /* TYPE OF ID */ INTEGER,
ID_BILLING_SERVICE /* TYPE OF ID */ INTEGER)
 RETURNS(ID_DOC_HEAD /* TYPE OF ID */ INTEGER,
ID_HOTEL /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TEST_DOC for: DOCUMENT_INITIALIZE$DOC */
ALTER PROCEDURE TEST_DOC(ID_ACCOUNT INTEGER,
DOC_SELECTED INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_INITIALIZE$DOC) */
ALTER PROCEDURE DOCUMENT_INITIALIZE$DOC(ID_ACCOUNT TYPE OF ID,
DOC_SELECTED TYPE OF ID,
PROFORMA_NAME_PREFIX VARCHAR(30) = null)
 RETURNS(ID_DOC_HEAD INTEGER,
ID_HOTEL INTEGER,
WARN_CODE INTEGER,
REQUIRE_ARCHIVE_CONFIRMATION TYPE OF TLOGICAL)
 AS
declare variable id_doc_type integer;
  declare variable id_base_doc integer;
  declare variable doc_date date;
  declare variable doc_curr varchar(3);
  declare variable id_doc_contragent integer;
  declare variable doc_sub_type integer;
  declare variable id_advance_payment integer;
  declare variable is_proforma tlogical;
  declare variable is_archive tlogical;
  declare variable doc_type_name varchar(50);
  declare variable hp_type varchar(50);
  declare variable is_credit_account smallint;
  declare variable closing_whole_account smallint;
  declare variable chk_out_date date;
begin
  chk_out_date = null;
  REQUIRE_ARCHIVE_CONFIRMATION = -1;

  is_proforma = iif(:PROFORMA_NAME_PREFIX is null, 0, 1);

  if (:IS_PROFORMA is distinct from 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_NOPAY_CREATE');
  end else begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('PROFORMA_CREATE');
  end

  select A.ID_HOTEL, p.HOUSE_TYPE, a.IS_CREDIT_ACCOUNT, RD.TO_DATE
  from   ACCOUNT A
         left outer join PROFILE_HOUSE p on p.ID_PROFILE = a.ID_PROFILE
         left outer join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = a.ID_RESERV_DETAIL
  where  A.ID_ACCOUNT = :id_account
  into   :id_hotel, :hp_type, :is_credit_account, :chk_out_date;

  if (coalesce(:hp_type, '') in ('hptExternalRevenue', 'hptComplimentary')) then
    exception DOCUMENT_EXCEPTION '-601';

  id_advance_payment = null;
  execute procedure DOCUMENT_CHECK_SELECTION$INT (:DOC_SELECTED, :ID_ACCOUNT)
  returning_values  (:id_doc_type, :id_base_doc, :doc_curr, :id_doc_contragent,
                     :id_advance_payment, :closing_whole_account);

  if (:is_proforma = 1 and :id_base_doc is not null) then
    exception DOCUMENT_EXCEPTION '-1062';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :doc_date;

  if (:id_doc_type is null) then begin
    execute procedure DOC_TYPE_GET$INT (:id_hotel, :IS_PROFORMA, :id_advance_payment)
    returning_values (:id_doc_type);
  end

  execute procedure CURR_RATES_PREPARE$INT (:DOC_SELECTED, :ID_ACCOUNT, :doc_date);

  select coalesce(:doc_curr, DT.DOC_CURR),
         iif (:is_proforma = 1, substring(trim(:PROFORMA_NAME_PREFIX) || ' ' || dt.doc_type_name from 1 for 50), dt.DOC_TYPE_NAME),
         dt.IS_ARCHIVE
  from   DOC_TYPE DT
  where  DT.ID_DOC_TYPE = :id_doc_type
  into   :doc_curr, :DOC_TYPE_NAME, :is_archive;

  if (:is_archive = 1) then begin
    execute procedure SYSTEM_WARNING_ADD(-312, '')
    returning_values :WARN_CODE;
  end

  execute procedure DOCUMENT_CREATE$INT (:DOC_SELECTED, :ID_ACCOUNT, :id_doc_type, :doc_type_name, :doc_date, :doc_curr, :id_base_doc, :doc_date, :is_proforma, :id_advance_payment)
  returning_values  (:ID_DOC_HEAD, :doc_sub_type);

  if (:ID_ADVANCE_PAYMENT is null and :IS_PROFORMA is distinct from 1 and :doc_sub_type < 2) then begin
    execute procedure DOCUMENT_ATTACH_AVAIL_PAYS$INT (:ID_DOC_HEAD, :ID_ACCOUNT);
  end

  if (:id_doc_contragent is not null) then begin
    execute procedure DOC_CONTRAGENT_INITIALIZE$DOC (:ID_DOC_HEAD, null, :id_doc_contragent);
  end else begin
    execute procedure DOC_CONTRAGENT_INITIALIZE$INT (:ID_DOC_HEAD, :ID_ACCOUNT);
  end

  execute procedure DOC_SUPPLIER_SET$DOC (:ID_DOC_HEAD);

  if (:is_proforma = 0 and :closing_whole_account = 1 and :is_credit_account is distinct from 1) then begin
    if ((:chk_out_date is null) or (:doc_date >= :chk_out_date)) then
      REQUIRE_ARCHIVE_CONFIRMATION = 1;
    else
      REQUIRE_ARCHIVE_CONFIRMATION = 0;
  end

  when exception DOC_ON_EMPTY_SELECTION do begin
    ID_DOC_HEAD = null;
  end
end
^

/* Alter (DOCUMENT_RESET_TYPE$DOC) */
ALTER PROCEDURE DOCUMENT_RESET_TYPE$DOC(ID_DOC_HEAD INTEGER,
ID_DOC_TYPE INTEGER,
DOC_CURRENCY VARCHAR(3),
PROFORMA_NAME_PREFIX VARCHAR(30))
 AS
declare variable id_account integer;
  declare variable old_id_doc_type integer;
  declare variable id_doc_contragent integer;
  declare variable id_doc_supplier integer;
  declare variable is_deposit integer;
  declare variable old_doc_curr varchar(3);
  declare variable doc_date date;
  declare variable tax_event_date date;
  declare variable id_base_doc integer;
  declare variable dbg varchar(1000);
  declare variable d_dbkey char(8);
  declare variable bonuspoints integer;
  declare variable id_advance_payment integer;
  declare variable id_payment_head integer;
  declare variable id_hotel integer;
  declare variable is_proforma tlogical;
  declare variable doc_type_name varchar(50);
  declare variable doc_sub_type smallint;
begin
  is_proforma = iif(:PROFORMA_NAME_PREFIX is null, 0, 1);

  select D.ID_ACCOUNT, D.ID_DOC_TYPE, D.ID_DOC_CONTRAGENT, D.ID_DOC_SUPPLIER,
         D.FOR_DEPOSIT, D.DOC_CURRENCY, D.DOC_DATE, DC.TAX_EVENT_DATE,
         D.ID_BASE_DOC, D.RDB$DB_KEY, a.ID_HOTEL, d.DOC_SUB_TYPE
  from   DOC_HEAD$INT D
         join ACCOUNT A on a.ID_ACCOUNT = d.ID_ACCOUNT
         left outer join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :id_account, :old_id_doc_type, :id_doc_contragent, :id_doc_supplier,
         :is_deposit, :old_doc_curr, :doc_date, :tax_event_date,
         :id_base_doc, :d_dbkey, :id_hotel, :doc_sub_type;
  /***************/
  if (:doc_sub_type > 0) then exit; -- can't change type for credit or debit document
  /***************/
  if ((:old_id_doc_type <> :ID_DOC_TYPE) or (:old_doc_curr <> :DOC_CURRENCY)) then begin
    for
      select p.ID_PAYMENT_HEAD
      from   PAYMENT_HEAD p
      where  p.ID_DOC_HEAD = :ID_DOC_HEAD
      into   :id_payment_head
    do begin
      execute procedure DOC_TYPE_EVALUATE$INT (:ID_DOC_TYPE, :id_hotel, :is_proforma, :id_payment_head);
    end

    id_advance_payment = null;
    if (:is_deposit = 1) then begin
      select first 1 p.ID_PAYMENT_HEAD
      from   PAYMENT_HEAD p
      where  p.ID_DOC_HEAD = :ID_DOC_HEAD
      into   :id_advance_payment;

      update PAYMENT_HEAD DP
      set    DP.ID_DOC_HEAD = null
      where  DP.ID_DOC_HEAD = :ID_DOC_HEAD;
    end
    /* update old document with reverse ID, to be deleted on the end */
    update DOC_HEAD$INT OD
    set    OD.ID_DOC_HEAD = -OD.ID_DOC_HEAD
    where  OD.RDB$DB_KEY = :d_dbkey;
    /* recreate document */
    select iif (:is_proforma = 1, substring(trim(:PROFORMA_NAME_PREFIX) || ' ' || dt.doc_type_name from 1 for 50), dt.DOC_TYPE_NAME)
    from   DOC_TYPE dt
    where  dt.ID_DOC_TYPE = :ID_DOC_TYPE
    into   :doc_type_name;

    execute procedure DOCUMENT_CREATE$INT (:ID_DOC_HEAD, :id_account, :ID_DOC_TYPE,
            :doc_type_name, :doc_date, :DOC_CURRENCY, :id_base_doc, :tax_event_date, :is_proforma, :id_advance_payment)
    returning_values  (:dbg, :dbg);
    /* reuse bonuspoints discounts */
    for
      select DF.TAXABLE_VALUE
      from   DOC_FOOTER DF
      where  DF.ID_DOC_HEAD = -:ID_DOC_HEAD
             and DF.ID_TAX is null
      into   :bonuspoints
    do begin
      execute procedure DOCUMENT_BONUSPOINTS_SPEND (:ID_DOC_HEAD, :bonuspoints)
      returning_values (:dbg);
    end 
    /* reuse deposits and payments */
    if (:is_deposit = 0) then begin
      execute procedure DOCUMENT_REUSE_DEPOSITS$INT (-:ID_DOC_HEAD, :ID_DOC_HEAD);

      execute procedure DOCUMENT_REUSE_PAYMENTS$INT (-:ID_DOC_HEAD, :ID_DOC_HEAD);
    end
    /* get client and sipplier data */
    update DOC_HEAD$INT D
    set    D.ID_DOC_CONTRAGENT = :id_doc_contragent,
           D.ID_DOC_SUPPLIER = :id_doc_supplier
    where  D.ID_DOC_HEAD = :ID_DOC_HEAD;
    /* delete old document */
    delete from DOC_HEAD$INT D
    where  D.ID_DOC_HEAD = -:ID_DOC_HEAD;
    /*  */
  end
end
^

/* Alter (EAI_POS_GET_GUESTS$P2E) */
ALTER PROCEDURE EAI_POS_GET_GUESTS$P2E(IN_ROOM_NAME VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(OUT_ID_GUEST INTEGER,
OUT_GUEST_NAME VARCHAR(100),
OUT_FROM_DATE DATE,
OUT_TO_DATE DATE,
OUT_OK_FOR_POST INTEGER,
OUT_COUNTRY VARCHAR(30),
OUT_TEXT VARCHAR(100),
OUT_BOARD_NAME VARCHAR(30),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100))
 AS
declare variable id_room integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  OUT_GUEST_NAME = null;

  /*FIND ROOM*/
  select R.ID_ROOM
  from   ROOMS R
         join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
  where  R.ROOM_NAME = :IN_ROOM_NAME
         and RT.ID_HOTEL = :ID_HOTEL
  into   :ID_ROOM;
  if ((:ID_ROOM is null) or (:ID_ROOM <= 0) ) then begin
    ERR_CODE = -5;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Room number not found!    ! ';
    suspend;
    exit;
  end

  /*FIND GUESTS*/
  for
    select G.ID_GUEST, GC.GUEST_NAME1, G.FROM_DATE, G.TO_DATE, C.COUNTRY_NAME,
           (select m.NAME
            from   GUEST_STAY gs
                   join MEALS M on m.ID_BOARD = gs.ID_BOARD
            where  gs.ID_GUEST = g.ID_GUEST
                   and gs.FOR_DATE = iif(current_date = g.to_date, current_date - 1, current_date))
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
           left outer join GUEST_CARD GC on G.ID_GUEST = GC.ID_GUEST
           left outer join COUNTRY C on C.COUNTRY_CODE = GC.COUNTRY
    where  G.ID_ROOM = :ID_ROOM
           and G.CHECK_STATUS = 0
           and rd.IS_ANUL = 0
    into   :OUT_ID_GUEST, :OUT_GUEST_NAME, :OUT_FROM_DATE,  :OUT_TO_DATE, :OUT_COUNTRY, :OUT_BOARD_NAME
  do begin
    OUT_OK_FOR_POST = iif(:OUT_TO_DATE < current_date, 0, 1) ;
    suspend;
  end

  if (:OUT_GUEST_NAME is null) then begin
    ERR_CODE = -1;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Guests not found!     !';
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ANUL$DOC for: FISCAL_DEVICE_STATUS_CHECK */
ALTER PROCEDURE DOCUMENT_ANUL$DOC(ID_DOC_HEAD INTEGER,
ANUL_REASON VARCHAR(100),
MAKE_ANNUL_REPORT SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_VALIDATE$DOC for: FISCAL_DEVICE_STATUS_CHECK */
ALTER PROCEDURE DOCUMENT_VALIDATE$DOC(ID_DOC_HEAD /* TYPE OF ID_REF */ INTEGER,
ARCHIVE_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT = 0)
 RETURNS(FIRM_DATA /* TYPE OF TNOTE_BLOB */ BLOB SUB_TYPE 1,
WARN_CODE /* TYPE OF TRANGE */ INTEGER,
NEW_DOC_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: UNIQUE_SALES_NUMBER_GEN for: FISCAL_DEVICE_STATUS_CHECK */
ALTER PROCEDURE UNIQUE_SALES_NUMBER_GEN(ID_HOTEL /* TYPE OF ID */ INTEGER)
 RETURNS(UNIQUE_SALES_NUMBER /* TYPE OF TENUM_STRING */ VARCHAR(50))
 AS
 BEGIN SUSPEND; END
^

/* Alter (FISCAL_DEVICE_STATUS_CHECK) */
ALTER PROCEDURE FISCAL_DEVICE_STATUS_CHECK(ID_HOTEL TYPE OF ID,
FISCALIZATION_CONTEXT TYPE OF TLOGICAL = 0)
 RETURNS(FISCAL_DEVICE_ID TYPE OF TSHORT_CODE)
 AS
declare variable machine_name varchar(50);
  declare variable map_fiscal_device_id varchar(50);
  declare variable session_fiscal_device_id varchar(50);
  declare variable default_fiscal_device_id varchar(8);
begin
  default_fiscal_device_id = 'OO000000';

  execute procedure SYSTEM_SESSION_GET('MACHINE_NAME')
  returning_values  :machine_name;

  select m.FISCAL_DEVICE_ID
  from   FISCAL_DEVICE_USAGE_MAP m
         join FISCAL_DEVICE fd on fd.FISCAL_DEVICE_ID = m.FISCAL_DEVICE_ID
  where  m.ID_HOTEL = :ID_HOTEL
         and m.MACHINE_NAME = :machine_name
         and fd.LAST_SUCCESS_DT >= ADDMINUTE(current_timestamp, -5)
  into   :map_fiscal_device_id;

  select fs.FISCAL_DEVICE_ID
  from   FISCAL_SESSION fS
  where  fS.ID_FISCAL_SESSION = current_connection
  into   :session_fiscal_device_id;

  FISCAL_DEVICE_ID = coalesce(:map_fiscal_device_id, :session_fiscal_device_id, :default_fiscal_device_id);
end
^

/* Alter (FISCALIZE_LINE$FISC) */
ALTER procedure FISCALIZE_LINE$FISC (
    ID_FISCAL_DATA integer)
returns (
    FISC_PRICE numeric(15,4),
    FISC_QTY numeric(15,4),
    FISC_TEXT varchar(100),
    FISC_GRP varchar(10),
    FISC_DISCOUNT_VALUE numeric(15,4),
    FISC_DISCOUNT_TEXT varchar(50),
    IS_ADVANCE type of TLOGICAL)
AS
declare variable fld_sep varchar(10);
  declare variable line_sep varchar(10);
  declare variable line varchar(255);
  declare variable end_pos integer;
  declare variable lines_data blob sub_type 1 segment size 100;
  declare variable i integer;
  declare variable last_value numeric(15,4);
begin
  FISC_DISCOUNT_TEXT = null;
  FISC_DISCOUNT_VALUE = null;

  select f.FISCAL_LINES
  from   DOC_FISCAL_DATA f
         join DOC_HEAD h on h.ID_DOC = f.ID_DOC_HEAD
  where  f.ID_FISCAL_DATA = :ID_FISCAL_DATA
  into   :lines_data;

  i = 0;
  fld_sep = f_character(28);
  line_sep = f_character(29);
  while (trim(:lines_data) <> '') do begin
    end_pos = position(:line_sep, :lines_data);
    line = substring(:lines_data from 1 for end_pos);
    lines_data = substring(:lines_data from end_pos + 1);
    if (:line <> '') then begin
      FISC_PRICE = substring(:line from 1 for position(:fld_sep, :line)-1);
      line = substring(:line from position(:fld_sep, :line)+1);
      FISC_QTY = substring(:line from 1 for position(:fld_sep, :line)-1);
      line = substring(:line from position(:fld_sep, :line)+1);
      FISC_TEXT = substring(:line from 1 for position(:fld_sep, :line)-1);
      line = substring(:line from position(:fld_sep, :line)+1);
      FISC_GRP = substring(:line from 1 for position(:fld_sep, :line)-1);
      line = substring(:line from position(:fld_sep, :line)+1);
      last_value = substring(:line from 1 for position(:line_sep, :line)-1);
      IS_ADVANCE = iif(:last_value = 1, 1, 0);
      suspend;
    end
    i= :i + 1;
    if (:i = 4096) then exit; -- Too many cycles, recursion prevents.
  end
end
^

/* Alter (FISCALIZE_MARK_DOC$FISC) */
ALTER PROCEDURE FISCALIZE_MARK_DOC$FISC(ID_FISCAL_DATA INTEGER,
IS_MANUAL INTEGER,
FISCAL_DEVICE_ID VARCHAR(10))
 AS
declare variable fisc_status integer;
declare variable is_anul integer;
declare variable doc_sub_type integer;
declare variable id_doc_head integer;
declare variable non_fiscal_data integer;
declare variable current_fiscal_device_id varchar(10);
declare variable current_storno_fiscal_device_id varchar(10);
begin
  select DH.FISC_STATUS, dh.IS_ANUL, dh.DOC_SUB_TYPE, dh.ID_DOC,
         fd.FISCAL_DEVICE_ID, fd.STORNO_FISCAL_DEVICE_ID
  from   DOC_FISCAL_DATA fd
         join DOC_HEAD DH on dh.ID_DOC = fd.ID_DOC_HEAD
  where  fd.ID_FISCAL_DATA = :ID_FISCAL_DATA
  into   :fisc_status, :is_anul, :doc_sub_type, :id_doc_head,
         :current_fiscal_device_id, :current_storno_fiscal_device_id;

  /* preliminary checks **********************/
  if (:id_doc_head is null) then
    exception FISCALIZE_EXCEPTION 'The fiscal data does not exists! id='||:ID_FISCAL_DATA;

  if (:fisc_status = 0) then
    exception FISCALIZE_EXCEPTION 'The document is not subject to fiscalization! id='||:id_doc_head;

  if (:fisc_status = 2 and :is_anul = 0) then
    exception FISCALIZE_EXCEPTION '-708';
  /******************************************/

  if (:is_anul = 0 and :doc_sub_type < 2) then begin
    if (:current_fiscal_device_id is not null) then
      exception FISCALIZE_EXCEPTION 'The fiscal data is already marked as fiscalized! id='||:ID_FISCAL_DATA;

    update DOC_FISCAL_DATA FD
    set    FD.FISCAL_DEVICE_ID = :FISCAL_DEVICE_ID
    where  fd.ID_FISCAL_DATA = :ID_FISCAL_DATA;

    select count(fd.ID_FISCAL_DATA)
    from   DOC_FISCAL_DATA fd
    where  fd.ID_DOC_HEAD = :id_doc_head
           and fd.FISCAL_DEVICE_ID is null
    into   :non_fiscal_data;
  end else begin
    if (:current_storno_fiscal_device_id is not null) then
      exception FISCALIZE_EXCEPTION 'The fiscal data is already marked as voided! id='||:ID_FISCAL_DATA;

    update DOC_FISCAL_DATA FD
    set    FD.STORNO_FISCAL_DEVICE_ID = :FISCAL_DEVICE_ID
    where  fd.ID_FISCAL_DATA = :ID_FISCAL_DATA;

    select count(fd.ID_FISCAL_DATA)
    from   DOC_FISCAL_DATA fd
    where  fd.ID_DOC_HEAD = :id_doc_head
           and fd.STORNO_FISCAL_DEVICE_ID is null
    into   :non_fiscal_data;
  end

  if (:non_fiscal_data = 0) then begin
    update DOC_COMPLETION Dc
    set    Dc.FISC_STATUS = 2,
           dc.DATETIME_FISCALIZED = current_timestamp
    where  Dc.ID_DOC_HEAD = :id_doc_head;

    if (:IS_MANUAL is not distinct from 1) then
      execute procedure SYSTEM_LOG_ADD('DOCUMENT', :ID_DOC_HEAD, 'RE-FISCALIZE', '');
    else
      execute procedure SYSTEM_LOG_ADD('DOCUMENT', :ID_DOC_HEAD, 'FISCALIZE', '');
  end
end
^

/* Alter (FISCALIZE_PAYMENT$FISC) */
ALTER PROCEDURE FISCALIZE_PAYMENT$FISC(ID_FISCAL_DATA INTEGER)
 RETURNS(FISC_SUM NUMERIC(15,4),
FISC_TEXT VARCHAR(100),
FISC_GRP VARCHAR(10))
 AS
declare variable fld_sep varchar(10);
  declare variable line_sep varchar(10);
  declare variable line varchar(255);
  declare variable end_pos integer;
  declare variable payments_data blob sub_type 1 segment size 100;
  declare variable i integer;
begin
  select f.FISCAL_PAYMENTS
  from   DOC_FISCAL_DATA f
         join DOC_HEAD h on h.ID_DOC = f.ID_DOC_HEAD
  where  f.ID_FISCAL_DATA = :ID_FISCAL_DATA
  into   :payments_data;

  i = 0;
  fld_sep = f_character(28);
  line_sep = f_character(29);
  while (trim(:payments_data) <> '') do begin
    end_pos = position(:line_sep, :payments_data);
    line = substring(:payments_data from 1 for :end_pos);
    payments_data = substring(:payments_data from :end_pos + 1);
    if (:line <> '') then begin
      FISC_SUM = substring(:line from 1 for position(:fld_sep, :line)-1);
      line = substring(:line from position(:fld_sep, :line)+1);
      FISC_TEXT = substring(:line from 1 for position(:fld_sep, :line)-1);
      line = substring(:line from position(:fld_sep, :line)+1);
      FISC_GRP = substring(:line from 1 for position(:line_sep, :line)-1);
      suspend;
    end
    i= :i + 1;
    if (:i = 1000) then exit; -- Too many cycles, recursion prevents.
  end
end
^

ALTER PROCEDURE FISCALIZE_PREPARE_DATA$INT(ID_DOC_HEAD TYPE OF ID,
UNIQUE_SALES_NUMBER TYPE OF TENUM_STRING,
SUMMARY_FISCALIZATION TYPE OF TLOGICAL = 0)
 RETURNS(FISCAL_AMOUNT TYPE OF TPRICE)
 AS
declare variable fld_sep type of TSHORT_CODE;
  declare variable line_sep type of TSHORT_CODE;
  declare variable lines_data type of TNOTE_BLOB;
  declare variable discounts_data type of TNOTE_BLOB;
  declare variable payments_data type of TNOTE_BLOB;
  declare variable fisc_price type of tprice;
  declare variable fisc_qty type of tprice;
  declare variable fisc_text type of tdescription_short;
  declare variable fisc_grp type of tshort_code;
  declare variable line_type type of tenum_string;
  declare variable fisc_grp_list varchar(100);
  declare variable payment_cnt type of TCOUNT;
  declare variable fisc_value_coef type of TCOEF;
  declare variable target_fiscal_value type of TPRICE;
  declare variable bon_fiscal_amount type of TPRICE;
  declare variable storno_coef type of TRANGE;
  declare variable doc_rate type of TRATE;
  declare variable round_to type of TPRICE;
  declare variable doc_sub_type type of TRANGE;
  declare variable is_advance type of TLOGICAL;
  declare variable current_payment integer;
  declare variable no_use varchar(255);
  declare variable remaining_pay_amount type of TPRICE;
begin
  if (exists (select fd.ID_DOC_HEAD
              from   DOC_FISCAL_DATA fd
              where  fd.ID_DOC_HEAD = :ID_DOC_HEAD)) then exit;

  execute procedure FISCAL_VALUE_GET$INT (:ID_DOC_HEAD)
  returning_values  :target_fiscal_value, :payment_cnt, :no_use, :fisc_value_coef;

  if (:payment_cnt = 0) then exit; --no fiscal payments

  select dh.DOC_RATE, dh.DOC_SUB_TYPE, c.ROUND_TO, dh.FOR_DEPOSIT
  from   DOC_HEAD DH
         join ACCOUNT A on A.ID_ACCOUNT = dh.ID_ACCOUNT
         join HOTEL H on h.ID_HOTEL = a.ID_HOTEL
         join CURRS c on c.CURR = h.NATION_CURR
  where  DH.ID_DOC = :ID_DOC_HEAD
  into   :doc_rate, :doc_sub_type, :round_to, :is_advance;

  if (:doc_sub_type = 2) then storno_coef = -1; else storno_coef = 1;

  insert into DOC_FISCAL_LINES$TMP (ID_DOC_HEAD, FISC_GRP, FISC_TEXT, FISC_PRICE, FISC_QTY, LINE_TYPE)
  select :ID_DOC_HEAD, l.FISC_GRP, l.FISC_TEXT, l.FISC_PRICE, l.FISC_QTY, l.LINE_TYPE
  from   FISCALIZE_PREPARE_LINES$INT (:ID_DOC_HEAD, :target_fiscal_value, :fisc_value_coef,
         :doc_rate, :storno_coef, :round_to, :is_advance, :SUMMARY_FISCALIZATION) l;

  fld_sep = f_character(28);
  line_sep = f_character(29);
  FISCAL_AMOUNT = 0;
  for
    -- fiscal lines grouping for bons - discountable/non-discountable sales by vats
    select iif(tg.disc_exists = 0, 'no-disc', 'disc-'||tg.FISC_GRP),
           list(distinct(tg.FISC_GRP)),
           sum(tg.fisc_value)
    from   (select t.FISC_GRP, max(iif(t.LINE_TYPE = 'discount', 1, 0)) as disc_exists,
            sum(t.FISC_QTY * t.FISC_PRICE) as fisc_value
            from   DOC_FISCAL_LINES$TMP t
            where  t.ID_DOC_HEAD = :ID_DOC_HEAD
            group by t.FISC_GRP) tg
    group by 1
    into   :no_use, :fisc_grp_list, :bon_fiscal_amount  --fiscal amount per bon!!!
  do begin
    fisc_value_coef = :bon_fiscal_amount / :target_fiscal_value;  --bon reduction coef
    lines_data = '';
    discounts_data = '';
    for
      select coalesce(l.FISC_PRICE, 0),
             coalesce(l.FISC_QTY, 0),
             coalesce(l.FISC_TEXT, ''),
             coalesce(l.FISC_GRP, ''),
             l.line_type
      from   DOC_FISCAL_LINES$TMP l
      where  l.ID_DOC_HEAD = :ID_DOC_HEAD
             and ',' || :fisc_grp_list || ',' containing ',' || l.FISC_GRP || ','
      into   :fisc_price, :fisc_qty, :fisc_text, :fisc_grp, :line_type
    do begin
      if (:line_type = 'discount') then begin
        discounts_data = :discounts_data
                         || :fisc_price || :fld_sep
                         || :fisc_text || :line_sep;
      end else begin
        lines_data = :lines_data
                     || :fisc_price || :fld_sep
                     || :fisc_qty || :fld_sep
                     || :fisc_text || :fld_sep
                     || :fisc_grp || :fld_sep
                     || iif(:line_type = 'advance', '1', '0') || :line_sep;
      end
    end
    ------------------ payments
    payments_data = '';
    current_payment = 0;
    remaining_pay_amount = :bon_fiscal_amount;
    for
      select p.FISC_GRP, p.FISC_TEXT, p.FISC_SUM
      from   FISCALIZE_PREPARE_PAYMENT$INT(:ID_DOC_HEAD) p
      into   :fisc_grp, :fisc_text, :fisc_price
    do begin
      current_payment = :current_payment + 1;
      fisc_price = round_f(:fisc_price * :fisc_value_coef, :round_to);
      remaining_pay_amount = :remaining_pay_amount - :fisc_price; --calc remaining amount
      if (:current_payment = :payment_cnt and :bon_fiscal_amount <> 0) then
        -- the last payment accummulates remaining amount
        fisc_price = round_f(:fisc_price + :remaining_pay_amount, round_to);

      payments_data = :payments_data
                    || coalesce(fisc_price, 0) || :fld_sep
                    || coalesce(fisc_text, '') || :fld_sep
                    || coalesce(fisc_grp, '') || :line_sep ;
    end
  
    insert into DOC_FISCAL_DATA(ID_DOC_HEAD, UNIQUE_SALES_NUMBER, FISCAL_LINES,
           FISCAL_DISCOUNTS, FISCAL_PAYMENTS, SUMMARY_FISCALIZATION, FISCAL_AMOUNT, FISCAL_GROUP_LIST)
    values (:ID_DOC_HEAD, :UNIQUE_SALES_NUMBER, :lines_data,
           :discounts_data, :payments_data, :SUMMARY_FISCALIZATION, :bon_fiscal_amount, :fisc_grp_list);

    FISCAL_AMOUNT = :FISCAL_AMOUNT + :bon_fiscal_amount;
  end
end
^

ALTER PROCEDURE FISCALIZE_VOID_PREPARE$FISC(ID_DOC_HEAD TYPE OF ID)
 RETURNS(VOID_REASON TYPE OF TDESCRIPTION_SHORT,
DOC_DESCRIPTION TYPE OF TDESCRIPTION_SHORT)
 AS
declare variable is_anul type of TLOGICAL;
  declare variable fisc_status type of TRANGE;
  declare variable doc_sub_type type of TRANGE;
  declare variable system_usn type of TENUM_STRING;
  declare variable summary_fiscalization type of TLOGICAL;
  declare variable storno_description type of TDESCRIPTION_SHORT;
  declare variable field_sep varchar(10);
  declare variable unique_sales_number type of TENUM_STRING;
  declare variable id_base_doc integer;
  declare variable id_fiscal_data integer;
  declare variable fiscalization_details type of TDESCRIPTION_LONG;
  declare variable fiscal_amount type of TPRICE;
  declare variable storno_fiscal_amount type of TPRICE;
  declare variable fiscal_group_list type of TENUM_STRING;
begin
  system_usn = 'OO000000-0000-0000000';
  field_sep = f_character(30);

  select h.is_anul, h.FISC_STATUS, h.DOC_SUB_TYPE, h.ID_BASE_DOC,
         sn.UNIQUE_SALES_NUMBER, dt.SUMMARY_FISCALISATION, h.DESCRIPTION,
         iif(dt.SUMMARY_FISCALISATION is not distinct from 1,
             substring(h.DOC_TYPE_NAME || :field_sep || h.DOC_NUM || '/'|| formatdate(h.DOC_DATE, 'D;dd.mm.yyyy') from 1 for 100),
             null)
  from   DOC_HEAD h
         join DOC_TYPE_INV dt on dt.ID_DOC_TYPE = h.ID_DOC_TYPE
         left outer join SALE_NUM sn on sn.ID_SALE_NUM = h.ID_SALE_NUM
  where  h.ID_DOC = :ID_DOC_HEAD
  into   :is_anul, :fisc_status, :doc_sub_type, :id_base_doc,
         :unique_sales_number, :summary_fiscalization, :storno_description,
         :DOC_DESCRIPTION;

  if (:is_anul = 1) then begin
    if (:doc_sub_type = 2) then exit; -- voided credit docs - nothing to void
    if (:fisc_status < 2) then exit;  -- Only voided docs with fisc_status = 2 allows to continue with VOID preparation !!!

    if (:unique_sales_number = :system_usn) then begin
      -- Old documents without FISCAL_DATA
      execute procedure FISCALIZE_PREPARE_DATA$INT(:ID_DOC_HEAD, :unique_sales_number, :summary_fiscalization)
      returning_values :storno_fiscal_amount;
    end
  
    if (not exists (select f.ID_DOC_HEAD from DOC_FISCAL_DATA f where f.ID_DOC_HEAD = :ID_DOC_HEAD)) then
       exception FISCALIZE_EXCEPTION '-710';

    select sum(fb.FISCAL_AMOUNT)
    from   DOC_FISCAL_BONS fb
    where  fb.ID_DOC_HEAD = :ID_DOC_HEAD
           and fb.IS_STORNO_BON = 1
           and fb.FISCAL_DEVICE_ID is null
    into   :storno_fiscal_amount;

    select coalesce(sum(fb.FISCAL_AMOUNT * iif(fb.IS_STORNO_BON = 0, 1, -1)), 0)
    from   DOC_HEAD d
           join DOC_FISCAL_BONS fb on fb.ID_DOC_HEAD = d.ID_DOC and fb.FISCAL_DEVICE_ID is not null
    where  d.ID_BASE_DOC = :id_base_doc
    into   :fiscal_amount;

    if (:fiscal_amount < :storno_fiscal_amount) then exception FISCALIZE_EXCEPTION '-714';

    select substring(l.ACTION_TEXT from 2 for 100)
    from   DOC_ANNULMENT d
           left outer join SYSTEM_LOG_EVENT l on l.ID_SYSTEM_LOG = d.ID_LOG_EVENT
    where  d.ID_DOC_HEAD = :ID_DOC_HEAD
    into   :VOID_REASON;
  
  end else begin
    if ( :doc_sub_type in (0, 1) ) then exception FISCALIZE_EXCEPTION '-711';
    if ( :fisc_status <> 1 ) then exit;
    -- !!! Only credit docs with fisc_status = 1 allows to continue with VOID preparation !!!
    VOID_REASON = :storno_description;
    execute procedure FISCALIZE_PREPARE_DATA$INT(:ID_DOC_HEAD, :unique_sales_number, :summary_fiscalization)
    returning_values :storno_fiscal_amount;

    for
      select fb.FISCALIZATION_DETAILS, fb.FISCAL_GROUP_LIST
      from   DOC_HEAD d
             join DOC_FISCAL_DATA fb on fb.ID_DOC_HEAD = d.ID_DOC
                                        and fb.FISCAL_DEVICE_ID is not null    -- fiscalized
                                        and fb.STORNO_FISCAL_DEVICE_ID is null -- not storned
      where  d.ID_BASE_DOC = :id_base_doc
             and d.ID_DOC <> :ID_DOC_HEAD
      order by fb.FISCAL_AMOUNT desc
      into   :fiscalization_details, :fiscal_group_list
    do begin
      -- matching storno to storned bons (FISCALIZATION_DETAILS) - by vat groups, bigger amount - first
      select first 1 sfd.ID_FISCAL_DATA
      from   DOC_FISCAL_DATA sfd
      where  sfd.ID_DOC_HEAD = :ID_DOC_HEAD
             and coalesce(sfd.FISCAL_GROUP_LIST, :fiscal_group_list) = :fiscal_group_list
             and sfd.FISCALIZATION_DETAILS is null
      order by sfd.FISCAL_AMOUNT desc
      into   :id_fiscal_data;

      update DOC_FISCAL_DATA fd
      set    fd.FISCALIZATION_DETAILS = :fiscalization_details
      where  fd.ID_FISCAL_DATA = :id_fiscal_data;
    end

    select coalesce(sum(fb.FISCAL_AMOUNT * iif(fb.IS_STORNO_BON = 0, 1, -1)), 0)
    from   DOC_HEAD d
           join DOC_FISCAL_BONS fb on fb.ID_DOC_HEAD = d.ID_DOC and fb.FISCAL_DEVICE_ID is not null
    where  d.ID_BASE_DOC = :id_base_doc
    into   :fiscal_amount;

    if (:fiscal_amount < :storno_fiscal_amount) then exception FISCALIZE_EXCEPTION '-713';
  end
end
^

/* Alter (FISCALIZE_PREPARE$FISC) */
ALTER PROCEDURE FISCALIZE_PREPARE$FISC(ID_DOC_HEAD TYPE OF ID)
 RETURNS(VOID_REASON TYPE OF TDESCRIPTION_SHORT,
IS_VOID TYPE OF TLOGICAL,
DOC_DESCRIPTION TYPE OF TDESCRIPTION_SHORT)
 AS
declare variable fisc_status type of TRANGE;
  declare variable void_status type of TRANGE;
  declare variable doc_sub_type type of TRANGE;
  declare variable summary_fiscalization type of TLOGICAL;
  declare variable field_sep varchar(10);
  declare variable unique_sales_number type of tenum_string;
  declare variable fiscal_amount type of TPRICE;
begin
  VOID_REASON = null;
  IS_VOID = 0;
  field_sep = f_character(30);

  select sn.UNIQUE_SALES_NUMBER, h.FISC_STATUS, h.IS_ANUL + h.IS_STORNED,
         h.DOC_SUB_TYPE, dt.SUMMARY_FISCALISATION,
         iif(dt.SUMMARY_FISCALISATION is not distinct from 1,
             substring(h.DOC_TYPE_NAME || :field_sep || h.DOC_NUM || '/'|| formatdate(h.DOC_DATE, 'D;dd.mm.yyyy') from 1 for 100),
             null)
  from   DOC_HEAD h
         join SALE_NUM sn on sn.ID_SALE_NUM = h.ID_SALE_NUM
         join DOC_TYPE_INV dt on dt.ID_DOC_TYPE = h.ID_DOC_TYPE
  where  h.ID_DOC = :ID_DOC_HEAD
  into   :unique_sales_number, :fisc_status, :void_status,
         :doc_sub_type, :summary_fiscalization, :DOC_DESCRIPTION;

  if (:void_status > 0) then exception FISCALIZE_EXCEPTION '-711';

  if (:fisc_status = 0) then exit;  -- Nothing to fiscalize
  else if (:fisc_status = 2) then exit;  -- Payments are marked as fiscalized already
  -- !!! Only fisc_status=1 allows to continue with data preparation !!!

  if (:doc_sub_type in (0, 1)) then begin
    execute procedure FISCALIZE_PREPARE_DATA$INT(:ID_DOC_HEAD, :unique_sales_number, :summary_fiscalization)
    returning_values :fiscal_amount;

  end else begin
    -- credit docs
    execute procedure FISCALIZE_VOID_PREPARE$FISC(:ID_DOC_HEAD)
    returning_values (:VOID_REASON, :DOC_DESCRIPTION);
    IS_VOID = 1;
  end
end
^

/* Alter (FISCALIZE_PREPARE_LINES$INT) */
ALTER PROCEDURE FISCALIZE_PREPARE_LINES$INT(ID_DOC_HEAD TYPE OF ID,
TARGET_FISCAL_VALUE TYPE OF TPRICE,
FISC_VALUE_COEF TYPE OF TCOEF,
DOC_RATE TYPE OF TRATE,
STORNO_COEF TYPE OF TCOEF,
ROUND_TO TYPE OF TPRICE,
IS_ADVANCE TYPE OF TLOGICAL,
SUMMARY_FISCALISATION TYPE OF TLOGICAL = 0)
 RETURNS(FISC_PRICE TYPE OF TPRICE,
FISC_QTY TYPE OF TPRICE,
FISC_TEXT TYPE OF TDESCRIPTION_SHORT,
FISC_GRP TYPE OF TSHORT_CODE,
TRANSACTION_VALUE TYPE OF TPRICE,
LINE_TYPE TYPE OF TENUM_STRING)
 AS
declare variable fiscalized_value type of TPRICE;
  declare variable total_lines type of TCOUNT;
  declare variable lines_cnt type of TCOUNT;
  declare variable tmp_cnt type of TCOUNT;
  declare variable summary_text TDESCRIPTION_SHORT;
begin
  -- line_types: 'sale', 'discount', 'advance'
  FISC_PRICE = null;
  FISC_TEXT = null;
  FISC_GRP = null;
  TRANSACTION_VALUE = null;
  FISC_QTY = 1;
  fiscalized_value = 0;
  lines_cnt = 0;

  select count(dl.ID_DOC_LINE)
  from   DOC_LINE DL
  where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :total_lines;

  if (:SUMMARY_FISCALISATION is distinct from 1) then begin
    for
      select dl.LINE_NAME,
             (select cast(substring(list(trim(coalesce(st.FISCAL_CODE, '')), '') from 1 for 10) as varchar(10)) as fisc_codes
              from   SALE_TAXATION_TAX stt
                     join SALE_TAXES st on st.ID_SALE_TAX = stt.ID_SALE_TAX and st.REVENUE_DEDUCTION_TAX is distinct from 1
              where  stt.ID_SALE_TAXATION = dl.ID_SALE_TAXATION) as fisc_codes,
             DL.SINGLE_VALUE,
             abs(sum(dl.QTY_POST)) as line_qty,
             round_f(sum(DL.SINGLE_VALUE * DL.QTY_POST * :doc_rate) * :fisc_value_coef * :storno_coef, 0.01),
             iif(:is_advance = 1, 'advance', iif(coalesce(df.ID, dv.ID_DEPOSIT) is not null, 'discount', 'sale')),
             count(DL.ID_DOC_LINE)
      from   DOC_LINE DL
             join SERVICES S on S.ID_SERVICE = DL.ID_SERVICE
             left outer join DOC_LINE_DEP_VALUES dv on dv.ID_DOC_LINE = dl.ID_DOC_LINE
             left outer join DOC_FOOTER df on df.ID_DOC_LINE = dl.ID_DOC_LINE and df.ID_DOC_HEAD = dl.ID_DOC_HEAD
      where  dl.ID_DOC_HEAD = :ID_DOC_HEAD
      group by 1, 2, 3, 6, ID_SALE_TAXATION, dv.ID_DEPOSIT, df.TAX_ORDER
      having round_f(sum(DL.SINGLE_VALUE * DL.QTY_POST * :doc_rate) * :fisc_value_coef * :storno_coef, 0.01) <> 0
      order by df.TAX_ORDER asc nulls first,
               dv.ID_DEPOSIT asc nulls first,
               iif(sum(DL.SINGLE_VALUE * DL.QTY_POST) * :storno_coef > 0, 0, 1),
               2,
               1,
               3
      into   :FISC_TEXT, :FISC_GRP, :FISC_PRICE, :FISC_QTY, :TRANSACTION_VALUE, :LINE_TYPE, :tmp_cnt
    do begin
      lines_cnt = :lines_cnt + :tmp_cnt;
      if (:lines_cnt = :total_lines) then begin
        TRANSACTION_VALUE = round_f(:target_fiscal_value, :round_to) - :fiscalized_value;
        -- to fiscalize rest value - in case of mixed fiscal/nonfiscal payments
      end
      for
        select p.QTY, p.SINGLE_PRICE
        from   AMOUNT_APPORTION_TO_PRICE$FISC (:TRANSACTION_VALUE, :FISC_QTY, :round_to) p
        into   :FISC_QTY, :FISC_PRICE
      do begin
        if (:FISC_PRICE <> 0) then suspend;
      end
      fiscalized_value = :fiscalized_value + :TRANSACTION_VALUE;
    end
  end else begin
    -- summary fiscalization
    select substring(se.DEFAULT_CAPTION from 1 for 100)
    from   SYSTEM_ENUM se
    where  se.GROUP_ = 'fiscal'
           and se.KEY_ = 'summary_text'
    into   :summary_text;

    for
      select lines.fisc_codes,
             iif(:is_advance = 1, 'advance', iif(coalesce(df.ID, dv.ID_DEPOSIT) is not null, 'discount', 'sale')),
             iif((:is_advance = 1) or (coalesce(df.ID, dv.ID_DEPOSIT) is null), :summary_text, lines.LINE_NAME),
             round_f(sum(DL.SINGLE_VALUE * DL.QTY_POST * :doc_rate) * :fisc_value_coef * :storno_coef, 0.01),
             count(DL.ID_DOC_LINE)
      from   (select l.ID_DOC_LINE,
                     l.LINE_NAME,
                     cast(substring(list(trim(coalesce(st.FISCAL_CODE, '')), '') from 1 for 10) as varchar(10)) as fisc_codes
              from   DOC_LINE l
                     join SALE_TAXATION_TAX stt on stt.ID_SALE_TAXATION = l.ID_SALE_TAXATION
                     join SALE_TAXES st on st.ID_SALE_TAX = stt.ID_SALE_TAX
                                           and st.REVENUE_DEDUCTION_TAX is distinct from 1
              where  l.ID_DOC_HEAD = :ID_DOC_HEAD
              group by l.ID_DOC_LINE, l.LINE_NAME) lines
             join DOC_LINE DL on dl.ID_DOC_LINE = lines.ID_DOC_LINE
             join SERVICES S on S.ID_SERVICE = DL.ID_SERVICE
             left outer join DOC_LINE_DEP_VALUES dv on dv.ID_DOC_LINE = dl.ID_DOC_LINE
             left outer join DOC_FOOTER df on df.ID_DOC_LINE = dl.ID_DOC_LINE and df.ID_DOC_HEAD = dl.ID_DOC_HEAD
      group by 1, 2, 3, dv.ID_DEPOSIT, df.TAX_ORDER
      order by df.TAX_ORDER asc nulls first,
               dv.ID_DEPOSIT asc nulls first
      into   :FISC_GRP, :LINE_TYPE, :FISC_TEXT, :FISC_PRICE, :tmp_cnt
    do begin
      lines_cnt = :lines_cnt + :tmp_cnt;
      if (:lines_cnt = :total_lines) then begin
        FISC_PRICE = round_f(:target_fiscal_value, :round_to) - :fiscalized_value;
        -- to fiscalize rest value - in case of mixed fiscal/nonfiscal payments
      end
      TRANSACTION_VALUE = :FISC_PRICE;
      if (:FISC_PRICE <> 0) then suspend;
      fiscalized_value = :fiscalized_value + :FISC_PRICE;
    end
  end
end
^

/* Alter (FISCALIZE_SET_DETAILS$FISC) */
ALTER PROCEDURE FISCALIZE_SET_DETAILS$FISC(ID_FISCAL_DATA INTEGER,
FISCALIZATION_DETAILS VARCHAR(255))
 AS
declare variable curr_fiscal_details varchar(255);
  declare variable curr_storno_fiscal_details varchar(255);
  declare variable is_anul integer;
  declare variable doc_sub_type integer;
begin
  select fd.FISCALIZATION_DETAILS, fd.STORNO_FISCALIZATION_DETAILS, h.IS_ANUL, h.DOC_SUB_TYPE
  from   DOC_FISCAL_DATA fd
         join DOC_HEAD h on h.ID_DOC = fd.ID_DOC_HEAD
  where  fd.ID_FISCAL_DATA = :ID_FISCAL_DATA
  into   :curr_fiscal_details, :curr_storno_fiscal_details, :is_anul, :doc_sub_type;

  if (:is_anul = 0 and :doc_sub_type < 2) then begin
    -- Fiscalization mark
    if (:curr_fiscal_details is not null) then
      exception FISCALIZE_EXCEPTION '-308';

    update DOC_FISCAL_DATA FD
    set    FD.FISCALIZATION_DETAILS = :FISCALIZATION_DETAILS
    where  fd.ID_FISCAL_DATA = :ID_FISCAL_DATA;

  end else begin
    -- Storno fiscalization mark
    if (:curr_storno_fiscal_details is not null) then
      exception FISCALIZE_EXCEPTION '-309';

    update DOC_FISCAL_DATA FD
    set    FD.STORNO_FISCALIZATION_DETAILS = :FISCALIZATION_DETAILS
    where  fd.ID_FISCAL_DATA = :ID_FISCAL_DATA;
  end
end
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ADD$P2E for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30),
UNIQUE_SALES_NUMBER VARCHAR(30) = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_DET_ADD$P2E for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE EAI_POS_POSTING_DET_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_AMOUNT NUMERIC(15,2),
IN_QTY NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30),
IN_SERVICE_DESCRIPTION VARCHAR(50),
UNIQUE_SALES_NUMBER VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_POSTING_CREATE$INT for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
POST_DATE /* TYPE OF TDATE */ DATE,
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
POST_ON_PMS_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
IS_OWNER_INCOME /* TYPE OF TLOGICAL */ SMALLINT,
ID_ROOM /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_FINALIZE$POST for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_CALL$INT for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_ACCOUNT$INT) */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
QTY TYPE OF TQTY,
ID_SECQUENCE TYPE OF ID,
IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
DATE_POST TYPE OF TDATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ID_ROOM TYPE OF ID = null,
POST_DESCRIPTION TYPE OF TSERVICE_DESCRIPTION = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable action_text varchar(255);
begin
  if (:date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :date_post;
  end

  post_currency = :manual_curr ;
  post_price = :manual_price ;
  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, -1, :id_secquence, :date_post, :id_service, -1, :id_room, 0, :qty, :post_price,
    :post_currency, null, :short_code, :from_date, :to_date, :post_text, :resource_text, '', -1, :POST_DESCRIPTION)
  returning_values :err_code, :err_text, :id_account_post;
  if (:err_code <> 0) then exit;

  select S.SERVICE_NAME
  from   SERVICES S
  where  S.ID_SERVICE = :ID_SERVICE
  into   :action_text;
   
  action_text = f_character(29) || coalesce(:action_text, '')
                || f_character(28) || formatdate(:DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || coalesce(:post_currency, '');
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_RESERVATION$INT for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ROOM for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255))
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_GUEST /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_GUEST$INT) */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TDESCRIPTION_SHORT,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ACCOUNT_ROUTING TYPE OF TSHORT_CODE,
DESCRIPTION TYPE OF TSERVICE_DESCRIPTION = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable id_room integer;
  declare variable no_use varchar(255);
  declare variable action_text varchar(255);
  declare variable is_guest_check_in smallint;
  declare variable service_name varchar(50);
  declare variable service_description type of TSERVICE_DESCRIPTION;
begin
  err_code = 0;
  err_text = '';

  select g.check_status
  from   guest g
  where  g.id_guest = :in_id_guest
  into   :is_guest_check_in;

  if (:is_guest_check_in < 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
  end

  execute procedure GUEST_GET_POSTING_ACCOUNT$INT (:in_id_guest, :account_routing)
  returning_values  :id_account, :id_room;

  if (:in_date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :in_date_post;
  end

  if (:in_is_manual_price = 0) then begin
    execute procedure SERVICE_GET_POSTING_DETAILS(:in_id_service, :IN_DATE_POST)
    returning_values  :no_use, :no_use, :service_name, :post_price, :post_currency, :service_description;
  end else begin
    /* MANUAL PRICE */
    post_currency = :manual_curr;
    post_price = :manual_price;
    select s.SERVICE_NAME
    from   SERVICES s
    where  s.ID_SERVICE = :IN_ID_SERVICE
    into   :service_name;
  end

  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, :in_id_guest, :in_id_secquence, :in_date_post, :in_id_service, -1, :id_room, 0, :in_qty,
    :post_price, :post_currency, null, :in_short_code, :in_from_datetime, :in_to_datetime, :in_post_text,
    :in_resource_text, '', -1, coalesce(:DESCRIPTION, :service_description))
  returning_values  :err_code, :err_text, :id_account_post;

  action_text = f_character(29) || coalesce(:service_name, '')
                || f_character(28) || formatdate(:IN_DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:IN_QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || coalesce(:post_currency, '');
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: RESOURCE_RESERVATION_CHECK_IN for: POST_SERVICE_ON_RESERVATION$INT */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_RESERVATION$INT) */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TDESCRIPTION_SHORT,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable id_guest integer;
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select RD.ID_TITULAR
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :id_guest;

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence,
                    :in_is_manual_price, :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime,
                    :in_post_text, :in_resource_text, :in_date_post, :in_short_code, '', :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_POST_TO_MH_FRONT_ONLINE for: POST_SERVICE_ON_ROOM */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_SERVICE_POST for: POST_SERVICE_ON_ROOM */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_ROOM) */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TDESCRIPTION_SHORT,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_GUEST TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select first 1 G.ID_GUEST
  from   GUEST G
  where  G.ID_ROOM = :in_id_room
         and G.CHECK_STATUS = 0
  order by G.FROM_DATE desc, G.ID_GUEST asc
        /************************************************/
        /* DESCENDANT ORDER IS VERY IMPORTANT!!         */
        /* IF TWO GUESTS HAVE:                          */
        /* TO_DATE OF THE 1'ST = FROM_DATE OF THE 2'ND, */
        /* THEN PHONACALLS SHOULD GO TO THE 2'ND        */         
        /************************************************/
  into   :id_guest;

  if (:id_guest is null) then begin
    err_code = -24;   /* NO GUESTS ARE CHECKED_IN INTO THE REQUESTED ROOM! */
    exit;
  end

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence, :in_is_manual_price,
    :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime, :in_post_text, :in_resource_text,
    :in_date_post, :in_short_code, '', substring(:IN_POST_TEXT from 1 for 67))
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* empty dependent procedure body */
/* Clear: EAI_TELECOUNT_TRANSFER for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALL_POST$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL /* ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALLS_POST_TO_ACCOUNT$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_TRANSFER$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_TELECOUNT_CALL$INT) */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ext_ifc_name varchar(20);
  declare variable room_name varchar(30);
  declare variable datetime_call timestamp;
  declare variable price numeric(15,2);
  declare variable dial_number varchar(50);
  declare variable units integer;
  declare variable pc_id_service integer;
  declare variable def_manual_curr char(3);
  declare variable post_text varchar(100);
  declare variable id_account_post integer;
  declare variable is_archive integer;
  declare variable new_id_account_post integer;
  declare variable pc_tag varchar(30);
  declare variable number_zone varchar(50);
  declare variable id_hotel integer;
  declare variable id_phonecall integer;
  declare variable no_use varchar(255);
  declare variable description type of TSERVICE_DESCRIPTION;
begin
  /* Description:
  || POST_TO_TYPE = 0 - ACCOUNT, 1 - GUEST, 2 - RESERV_DETAIL, 3 - JUST PREPARE, FOR EXTERNAL CLIENT
  */
  err_code = 0;
  err_text = '';
  ext_ifc_name = 'TELECOUNT';

  select PC.ID_PHONECALL, PC.ROOM_NAME, PC.DATETIME_CALL, PC.PRICE, PC.DIAL_NUMBER, PC.UNITS,
         PC.ID_ACCOUNT_POST, PC.IS_ARCHIVE, PC.TAG, substring(PC.NUMBER_ZONE from 1 for 30), pc.ID_HOTEL
  from   PHONECALLS PC 
  where  PC.rdb$db_key = :ph_dbkey
  into   :id_phonecall, :room_name, :datetime_call, :price, :dial_number, :units,
         :id_account_post, :is_archive, :pc_tag, :number_zone, :id_hotel;

  if ((:is_archive = 1) or (coalesce(:id_account_post, 0) > 0)) then exit;

  if ((:pc_tag is null) or (:pc_tag = '')) then pc_tag = 'TELECOUNT_DEFAULT';
  else pc_tag = 'TELECOUNT_' || :pc_tag;

  execute procedure EAI_MAP_SERVICE(:pc_tag, :number_zone, :ext_ifc_name, :id_hotel)
  returning_values  :err_code, :err_text, :pc_id_service;
  if (:err_code < 0) then exit;

  post_text = substring(:dial_number || ', impulses ' || :units from 1 for 100);

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :def_manual_curr;

  new_id_account_post = null;
  description = substring(:dial_number || ' | ' || formatdate(:datetime_call, 'D;dd.mm.yyyy hh:mm:') from 1 for 67);

  if (:post_to_type = 0) then begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:POST_TO_ID, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null,
      :ext_ifc_name, null, :description)
    returning_values :err_code, :err_text, :new_id_account_post;

  end else if (:post_to_type = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:POST_TO_ID, :pc_id_service, 1, -1, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null,
      :ext_ifc_name, '', :description)
    returning_values :err_code, :err_text, :no_use, :new_id_account_post;

  end else if (:post_to_type = 2) then begin
    execute procedure POST_SERVICE_ON_RESERVATION$INT(:POST_TO_ID, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null,
      :ext_ifc_name, :description)
    returning_values :err_code, :err_text, :no_use, :new_id_account_post;

  end else if (:post_to_type = 3) then begin
    execute procedure POST_PREPARE$INT (:POST_TO_ID, null, :pc_id_service,
      1, :ID_SEQUENCE, :price, :def_manual_curr, :description, null, null, :post_text, :ID_PHONECALL)
    returning_values :no_use;
  end
  if (:err_code < 0) then exit;

  if (:new_id_account_post is not null) then begin
    update PHONECALLS PC
    set    PC.ID_ACCOUNT_POST = :new_id_account_post,
           pc.POSTING_ERROR = null
    where  PC.rdb$db_key = :ph_dbkey;

    insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
    values (:new_id_account_post, :ext_ifc_name, null, :datetime_call);
  end

end
^

/* Alter (POST_TELECOUNT_TRANSFER$TC) */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ph_dbkey char(8);
  declare variable id_account_post integer;
  declare variable account_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  for
    select PC.RDB$DB_KEY, PC.ID_ACCOUNT_POST
    from   PHONECALLS PC
    where  PC.SELECTION_ID = :selection_id
    into   :ph_dbkey, :id_account_post
  do begin
    if ((:id_account_post is not null) and (:id_account_post <> -1)) then begin
      err_code = -117;
      select A.ACCOUNT_NAME
      from   ACCOUNT_POST AP
             join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
      where  AP.ID_ACCOUNT_POST = :id_account_post
      into   :account_name;
      err_text = f_character(29) || :account_name;
      exit;
    end

    execute procedure POST_TELECOUNT_CALL$INT(2, :id_reserv_detail, :ph_dbkey, 0)
    returning_values :err_code, :err_text;
    if (:err_code < 0) then exit;
  end
end
^

/* Alter (RATE_GET_AVAILABILITY$CHM) */
ALTER PROCEDURE RATE_GET_AVAILABILITY$CHM(ID_RATE INTEGER,
FOR_DATE DATE)
 RETURNS(ACTIVE_STATUS INTEGER,
MIN_LOS INTEGER,
MAX_LOS INTEGER)
 AS
declare variable date_from date;
  declare variable date_to date;
  declare variable RATE_capacity integer;
  declare variable to_sell integer;
begin
  --ACTIVE_STATUS 0 - closed
  --ACTIVE_STATUS 1 - closed fro arrival
  --ACTIVE_STATUS 2 - opened
  --opala ID_HOTEL
--  date_from = null;
--  ACTIVE_STATUS -  autoclose, t.e. AUTO_PERCENT






/*  select min(FOR_DATE), max(FOR_DATE)
  from RATE_ALLOTMENT
  where ID_RATE = :id_RATE
  into :date_from, :date_to;
  if (date_from is null) then exit;

  for select distinct ID_ROOM_TYPE
      from RATE_ALLOTMENT
      where ID_RATE = :id_RATE
        and FOR_DATE between :date_from and :date_to
      into :id_room_type
  do begin
    for select RTR.FOR_DATE,
               CA.STATUS,
               CA.AUTO_FREE_ROOMS, CA.ROOM_COUNT, RTR.AVAILABLE as FREE_ROOMS
        from ROOM_TYPE_GET_FREE$CHM(:date_from, :date_to, :id_room_type) RTR
             join RATE_ALLOTMENT CA on CA.ID_ROOM_TYPE = :id_room_type
                                      and CA.ID_RATE = :id_RATE
                                      and CA.FOR_DATE = RTR.FOR_DATE
    into :for_date, :status,
         :auto_free_rooms, :RATE_capacity, :free_rooms
    do begin
      if (:auto_free_rooms is not null) then
        if (coalesce(:free_rooms,0) >= :auto_free_rooms) then
          is_active = 1;
        else is_active = 0;
      else if (:status = 0) then
             is_active = 1;
           else is_active = 0;

      to_sell = coalesce(:free_rooms,0) - coalesce(:auto_free_rooms,0);
      if (to_sell < 0) then to_sell = 0;

      room_count = :to_sell;
      if (:RATE_capacity is not null) then
        if (RATE_capacity < room_count) then
          room_count = :RATE_capacity;

      suspend;
    end
  end*/
end
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_FINALIZE$INT for: RES_TAR_CALC_REPOST$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(ID_TAR_CALC INTEGER,
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_TAR_CALC_REPOST$INT) */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC TYPE OF ID_REF,
ID_RESERV_DETAIL TYPE OF ID_REF,
RECALC_MARKER VARCHAR(40))
 AS
declare variable id_guest type of id_ref;
  declare variable id_service type of id_ref;
  declare variable id_tariff type of id_ref;
  declare variable date_post type of tdate;
  declare variable qty_post type of tqty;
  declare variable price_orig type of tprice;
  declare variable curr_orig type of tcurrency;
  declare variable id_room type of id_ref;
  declare variable is_base type of tlogical;
  declare variable short_code type of tdescription_long;
  declare variable id_account type of id_ref;
  declare variable gfrom_date type of tdate;
  declare variable gto_date type of tdate;
  declare variable ap_db_key char(8);
  declare variable id_pack_service type of id_ref;
  declare variable err_code type of id_ref;
  declare variable err_text type of tdescription_long;
  declare variable id_master_account_post type of id_ref;
  declare variable id_acc_post type of id_ref;
  declare variable is_base_account type of id_ref;
  declare variable id_extra_account type of id_ref;
  declare variable no_use varchar(255);
begin
  for
    select   TCP.ID_GUEST, TCP.ID_SERVICE, TCP.ID_TARIFF, TCP.DATE_POST, TCP.QTY_POST,
             round_f(TCP.PRICE_ORIG, c.ROUND_TO), TCP.CURR_ORIG, TCP.ID_ROOM, TCP.IS_BASE,
             TCP.SHORT_CODE, iif(coalesce(AGP.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'NONE', 0, 1),
             G.ID_BASE_ACCOUNT, G.FROM_DATE, G.TO_DATE, G.ID_ACCOUNT
    from     TAR_CALC_POST$TMP TCP
             join GUEST G on G.ID_GUEST = TCP.ID_GUEST
             join SERVICES S on S.ID_SERVICE = TCP.ID_SERVICE
             join CURRS c on c.CURR = tcp.CURR_ORIG
             left outer join AGENT_PACKET AGP on AGP.ID_SERVICE = S.ID_SERVICE and AGP.ID_AGENT = G.ID_AGENT
    where    TCP.ID_TAR_CALC = :id_tar_calc
             and tcp.ID_RESERV = :ID_RESERV_DETAIL
                  --or (coalesce(RD.IS_POSTING_STOPPED, 0) = 0 and RD.POSTING_TRANSACTION_UUID is not null))
    order by TCP.ID_GUEST asc, TCP.DATE_POST asc, TCP.IS_BASE desc
    into     :id_guest, :id_service, :id_tariff, :date_post, :qty_post,
             :price_orig, :curr_orig, :id_room, :is_base, :short_code, :is_base_account,
             :id_account, :gfrom_date, :gto_date, :id_extra_account
  do begin
    ap_db_key = null;
    if (:is_base = 1) then begin
      select AP.RDB$DB_KEY, AP.ID_MASTER_ADDINS_ACC_POST, AP.ID_PACK_SERVICE
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.DATE_POST = :date_post
             and AP.IS_BASE = 1
      into   :ap_db_key, :id_master_account_post, :id_pack_service;

      --execute procedure sys_dbg('tar TAR_CALC_REPOST$INT price_orig = '||coalesce(:price_orig, 'null'));
      --execute procedure sys_dbg('tar TAR_CALC_REPOST$INT ap_db_key = '||coalesce(:ap_db_key, 'null'));

      if (:ap_db_key is null) then begin
        id_master_account_post = -1;
        execute procedure GUEST_POST_GET_PACK_SERVICE(:id_service, :id_guest, :date_post)
        returning_values  :id_pack_service;
      end

    end else begin
      -- short_code = '';
      select first 1 APU.rdb$db_key
      from   ACCOUNT_POST APU
      where  APU.ID_MASTER_ADDINS_ACC_POST = :id_master_account_post
             and APU.ID_SERVICE = :id_service
             and APU.CHANGED_TEXT is distinct from :recalc_marker
      order by apu.IS_ANUL asc, apu.ID_ACCOUNT_POST asc
      into   :ap_db_key;

      if ((:is_base_account <> 1)) then id_account = :id_extra_account;
    end

    if (:ap_db_key is null) then begin
      execute procedure ACCOUNT_POSTING_ADD$INT(
        :id_account, :id_guest, -1, :date_post, :id_service, :id_tariff, :id_room, :is_base, :qty_post,
        :price_orig, :curr_orig, null, :short_code, :gfrom_date, :gto_date, 'PACK='||:id_pack_service, '',
        :recalc_marker, :id_master_account_post)
      returning_values  :err_code, :err_text, :id_acc_post;
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

      if (:is_base = 1) then id_master_account_post = :id_acc_post;

    end else begin
      execute procedure ACCOUNT_POSTING_UPDATE$INT(
        :ap_db_key, :id_service, :id_tariff, :id_room, :qty_post, 0, :price_orig, :curr_orig, null,
        :recalc_marker, :short_code, :gfrom_date, :gto_date, 1, :id_account)
      returning_values  :no_use, :no_use, :no_use;
    end

  end

  ap_db_key = null;
  id_guest = null;
  for
    select distinct TCP.ID_GUEST
    from   TAR_CALC_POST$TMP TCP
    where  tcp.ID_TAR_CALC = :ID_TAR_CALC
           and tcp.ID_RESERV = :ID_RESERV_DETAIL
    into   :id_guest
  do begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.CHANGED_TEXT is distinct from :recalc_marker
             and AP.ID_MASTER_ADDINS_ACC_POST > 0
             and AP.IS_ANUL = 0
      into   :ap_db_key
    do begin
      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_db_key, :recalc_marker);
    end
  end

  delete from RESERV_PREPOST RP where RP.ID_RESERV_DETAIL = :id_reserv_detail;
  execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:ID_RESERV_DETAIL);
end
^

/* Alter (RESOURCE_RESERVATION_CHECK_IN) */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
declare variable old_status varchar(20);
  declare variable new_status varchar(20);
  declare variable dbkey char(8);
  declare variable id_service id_ref;
  declare variable price_post tprice;
  declare variable curr_post TCURRENCY;
  declare variable is_manual_price TLOGICAL;
  declare variable is_details tlogical;
  declare variable post_description tobject_text;
  declare variable id_reserv_detail integer;
  declare variable post_date tdate;
  declare variable from_datetime tdatetime;
  declare variable to_datetime tdatetime;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  new_status = 'CHECKED_IN';

  select r.RDB$DB_KEY, R.STATUS, rd.ID_RESERV_DETAIL
  from   RESOURCE_RESERVATION R
         left outer join RESERV_DETAIL rd on rd.NUMBER = r.BOOKING_NUMBER
                                             and rd.IS_ANUL = 0
                                             and rd.SUBSCRIBER_ID is not distinct from r.SUBSCRIBER_ID
  where  R.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
  into   :dbkey, :old_status, :id_reserv_detail;

  if (:old_status = :NEW_STATUS) then exit;
 
  if (:old_status is distinct from 'RESERVED') then exception ASSERT '-511';

  if (exists (select RP.ID_RESOURCE_RESERVATION
              from   RESOURCE_RESERV_POST RP
                     join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = RP.ID_ACCOUNNT_POST
              where  RP.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION)) then
  begin
    exception ASSERT '-505';
  end

  if (:id_reserv_detail is not null) then begin
    execute procedure RESOURCE_RESERV_SERVICE_GET (:ID_RESOURCE_RESERVATION)
    returning_values (:id_service, :price_post, :curr_post, :is_manual_price, :is_details, :post_description,
                     :post_date, :from_datetime, :to_datetime);
  
    if (:is_manual_price = 1) then begin
      price_post = :SERVICE_PRICE;
      curr_post = :SERVICE_CURR;
    end

    if (:price_post is null) then exception ASSERT 'Unspecified service price!';
    if (:curr_post is null) then exception ASSERT 'Unspecified price currency!';
  
    execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
            1, :price_post, :curr_post, :from_datetime, :to_datetime,
            '', '', :post_date, 'RESOURCE', :post_description)
    returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT, :OUT_ID_ACCOUNT_POST);
    if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
  
    insert into RESOURCE_RESERV_POST(ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:ID_RESOURCE_RESERVATION, :OUT_ID_ACCOUNT_POST);
  end

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = :NEW_STATUS
  where  RR.RDB$DB_KEY = :dbkey;

end
^

/* empty dependent procedure body */
/* Clear: RIGHTS_MODIFY_AUDIT_USER for: RIGHTS_GROUP_USER_MODIFY */
ALTER PROCEDURE RIGHTS_MODIFY_AUDIT_USER(USER_PASSWORD VARCHAR(50),
OPERATION VARCHAR(10))
 RETURNS(USER_NAME VARCHAR(30))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RIGHTS_GROUP_USER_MODIFY) */
ALTER PROCEDURE RIGHTS_GROUP_USER_MODIFY(USER_NAME VARCHAR(30),
ID_RIGHT_GROUP INTEGER,
OPERATION VARCHAR(50))
 AS
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add,del');

  if (:USER_NAME = 'SYSDBA') then exit;

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS RG
  where  RG.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'add') then begin
    update or insert into RIGHTS_USER_GROUPS (USER_NAME, ID_RIGHT_GROUP)
    values (:user_name, :id_right_group)
    matching (USER_NAME, ID_RIGHT_GROUP);

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_ADDED',
            f_character(29) || :USER_NAME  || f_character(28) || :right_group);

  end else begin
    delete from RIGHTS_USER_GROUPS
    where USER_NAME = :user_name
          and ID_RIGHT_GROUP = :id_right_group;

    if (row_count > 0) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_REMOVED',
              f_character(29) || :USER_NAME || f_character(28) || :right_group);

  end

  when sqlcode -803 do begin
    /* ERR_TEXT = '       ! ' ;*/
    exit;
  end
end
^

/* Alter (RIGHTS_MODIFY_AUDIT_USER) */
ALTER PROCEDURE RIGHTS_MODIFY_AUDIT_USER(USER_PASSWORD VARCHAR(50),
OPERATION VARCHAR(10))
 RETURNS(USER_NAME VARCHAR(30))
 AS
declare variable is_active smallint;
  declare variable lang_code varchar(10);
  declare variable user_operation varchar(10);
  declare variable user_name_long varchar(50);
  declare variable group_name varchar(30);
  declare variable id_right_group integer;
  declare variable auditor_rights varchar(4000);
begin
  exception ASSERT 'User "_AUDITOR_" could not be activated!';

  execute procedure RIGHTS_CHECK_GRANTED$INT('RIGHTS_AUDIT_MANAGE');

  USER_NAME = '_AUDITOR_';
  user_name_long = 'Clock audit system user';
  lang_code = 'bg';
  is_active = iif(:OPERATION = 'activate', 1, 0);

  if (:OPERATION = 'activate' and not exists (select * from RIGHTS_USERS u where u.USER_NAME = :USER_NAME)) then
    user_operation = 'add';
  else
    user_operation = 'mod';

  execute procedure RIGHTS_MODIFY_USER(:user_name, :user_name_long, :USER_PASSWORD,
          :lang_code, 1, :is_active, :user_operation, '', '');

  GROUP_NAME = '_AUDITORS_';
  select g.ID_RIGHT_GROUP
  from   RIGHTS_GROUPS g
  where  g.GROUP_NAME = :group_name
  into   :id_right_group;

  if (:id_right_group is null) then begin
    insert into RIGHTS_GROUPS (GROUP_NAME, GROUP_DESCRIPTION)
    values ('_AUDITORS_', 'AUDITORS GROUP')
    returning ID_RIGHT_GROUP into :id_right_group;
    
    auditor_rights = 'DOC_PAY_GROUP_1,DOC_PAY_GROUP_2,DOCS_FIND,ACC_BALANCES,BALANCES_PRINT,OPEN_BOOKING_INBOX,AR_PREVIEW,CURR,USERSEDIT,CHECKEDOUT_RESERV_PREVIEW,WAITING_RESERV_PREVIEW,RESERV_LIST,ACC_FIND_ARCHIVE,ACC_SET_CREDIT,ACCSECURLEVEL1,ANALIZ_AGENT,RPT.*,RPT.EXPORT,SYSTEM_LOG,PERSON_PROFILE_STATISTIC,MASK_DIFF_FROM_DEF,ARCHIVE_PHONE_LINES,FIND_PHONECALLS,MONITOR_TCREPS,PMS_OWNERS,RIGHTSEDIT,TARIFIEDIT,MONITOR_PAGE4,MONITOR_PAGE3,MONITOR_PAGE7,MONITOR_PAGE1,REPORT_HOTEL_REGISTER,ROOMS,OTHER_NOM,PROFILE_GUEST_EDIT,SERVICES,DOC_PAY_TYPES,PROFILE_AGENT_EDIT,EXPORT';

    insert into RIGHTS_GROUPS_LINES(ID_RIGHT_GROUP, RIGHT_CODE)
    select g.ID_RIGHT_GROUP, sp.ITEM
    from   RIGHTS_GROUPS g
           left outer join SYSTEM_STRING_PARSER(:auditor_rights) sp on 1=1
    where  g.ID_RIGHT_GROUP = :id_right_group;
  end

  execute procedure RIGHTS_GROUP_USER_MODIFY(:USER_NAME, :id_right_group, 'add');

end
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_MODIFY for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE /* TYPE OF ID */ INTEGER,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100))
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_NEW for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE /* TYPE OF ID */ INTEGER,
FROM_DATETIME /* TDATETIME */ TIMESTAMP,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100),
BOOKING_NUMBER /* TYPE OF TRES_NUMBER */ VARCHAR(92),
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
ID_RESOURCE_RESERVATION /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SAFE_OCCUPANCY_POSTING$INT) */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION TYPE OF ID,
ID_SERVICE TYPE OF ID,
PRICE TYPE OF TPRICE,
CURRENCY TYPE OF TCURRENCY,
PRICE_DESCRIPTION TYPE OF TDESCRIPTION_SHORT,
ID_RESERV_DETAIL TYPE OF ID,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF = null)
 RETURNS(DOC_SELECTED TYPE OF TRANGE)
 AS
declare variable from_datetime timestamp;
  declare variable to_datetime timestamp;
  declare variable ap_dbkey TDB_KEY;
  declare variable id_account_post integer;
  declare variable safe_name TOBJECT_NAME;
  declare variable no_use varchar(255);
  declare variable new_ac varchar(2);
  declare variable err_code integer;
  declare variable err_text varchar(255) ;
  declare variable occupant_name tperson_name;
  declare variable id_room integer;
  declare variable id_tariff integer;
  declare variable post_text varchar(100);
  declare variable id_account integer;
begin
  DOC_SELECTED = null;
  select od.FROM_DATETIME, od.TO_DATETIME, ap.RDB$DB_KEY, ap.ID_ACCOUNT_POST,
         s.SAFE_NAME, rr.OCCUPANT_NAME, ap.ID_ROOM, ap.ID_TARIFF, ap.ID_ACCOUNT
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join SAFES s on s.ID_SAFE = od.ID_RESOURCE
         left outer join RESOURCE_RESERV_POST rrp on rrp.ID_RESOURCE_RESERVATION = rr.ID_RESOURCE_RESERVATION
         left outer join ACCOUNT_POST ap on ap.ID_ACCOUNT_POST = rrp.ID_ACCOUNNT_POST
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :from_datetime, :to_datetime, :ap_dbkey, :id_account_post,
         :safe_name, :occupant_name, :id_room, :id_tariff, :id_account;

  new_ac = null;
  if (:id_account_post is not null) then begin
    execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 0);

    execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
            :id_tariff, :id_room, 1, 0, :price, :currency, null, null, 'RESOURCE', :from_datetime, :TO_DATETIME, 1)
    returning_values :no_use, :no_use, :new_ac;
  end else begin
    post_text = substring(:safe_name || ' / '
                || formatdate(:from_datetime, 'D;dd.mm.yy(hh:mm)') || ' - '
                || formatdate(:to_datetime, 'D;dd.mm.yy(hh:mm)') || ' / '
                || replace(:price_description, F_CRLF(), ';') from 1 for 100);

    if (:id_reserv_detail is not null) then begin
      execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
              1, :price, :currency, :from_datetime, :to_datetime,
              :post_text, :safe_name, cast(:from_datetime as date), 'RESOURCE', :safe_name)
      returning_values (:ERR_CODE, :ERR_TEXT, :no_use, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end else if (:ID_EXTERNAL_CLIENT_ACCCOUNT is not null) then begin
      execute procedure POST_SERVICE_ON_ACCOUNT$INT (:ID_EXTERNAL_CLIENT_ACCCOUNT, :id_service,
              1, 0, 1, :price, :currency, :from_datetime, :TO_DATETIME,
              :post_text, :safe_name, cast(:from_datetime as date), 'RESOURCE', null, :safe_name)
      returning_values (:err_code, :err_text, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end
  end

  if (:new_ac is null) then
    exception ASSERT '-1067' || f_character(31) || f_character(29) || :safe_name || f_character(28) || :occupant_name;

  if (:new_ac = '00') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);
    update ACCOUNT_POST AP
    set    ap.DOC_SELECTED = :DOC_SELECTED
    where  ap.ID_ACCOUNT_POST = :id_account_post;
  end

  if (not exists (select rp.ID_ACCOUNNT_POST
                  from   RESOURCE_RESERV_POST rp
                  where  rp.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
                         and rp.ID_ACCOUNNT_POST = :id_account_post)) then
  begin
    insert into RESOURCE_RESERV_POST (ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:id_resource_reservation, :id_account_post);
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_PARAMS$INT for: TARIFA_GET_PARAM */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TARIFA_GET_PARAM) */
ALTER PROCEDURE TARIFA_GET_PARAM(ID_PARAM INTEGER,
FOR_DATE DATE,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER)
 RETURNS(OUT_VALUE VARCHAR(255))
 AS
declare variable is_interface integer;
  declare variable param_code varchar(30);
  declare variable is_value integer;
  declare variable int1 integer;
  declare variable data_type varchar(10);
  declare variable pvalue varchar(20);
  declare variable from_ date;
  declare variable to_ date;
begin
  select TP.IS_INTERFACE, TP.PARAM_CODE, TP.IS_VALUE, TP.DATA_TYPE, TP.PVALUE
  from   TARIFA_PARAMS TP
  where  ID_TARIFA_PARAM = :ID_PARAM 
  into   :is_interface, :param_code, :is_value, :data_type, :pvalue;
  /*get interface params*/
  if (:PARAM_CODE = 'NATION2') then
    PARAM_CODE = 'NATION'; /* !!!!!!!!!! */

  /*get value params*/
  if (:IS_VALUE = 1) then
    OUT_VALUE = :pvalue;

  /*get internal params*/
  OUT_VALUE = null;
  if (:IS_INTERFACE = 0) then begin
    if (:PARAM_CODE = 'TODAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'D;dd/mm/yyyy');

    end else if (:PARAM_CODE = 'WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'DW;MON');

    end else if (:PARAM_CODE = 'NEXT_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE + 1, 'DW;MON');

    end else if (:PARAM_CODE = 'PREV_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE - 1, 'DW;MON');

    end else if (:PARAM_CODE = 'REQUIRED_WEEK_DAYS') then begin
      select ti.FROM_DATE, ti.TO_DATE - 1
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :from_, :to_;
      
      select list(formatdate(RLP.OUT_DATE, 'DW;MON'))
      from   SYSTEM_LOOP_PERIOD(:from_, :to_) RLP
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'ARRIVAL_WEEK_DAYS') then begin
      select formatdate(ti.FROM_DATE, 'DW;MON')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PRESTOI') then begin
      select cast(ti.TO_DATE - ti.FROM_DATE as integer)
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'FROM_DATE') then begin
      select formatdate(ti.FROM_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TO_DATE') then begin
      select formatdate(ti.TO_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'FIRST_NIGHT') then begin
      select formatdate(ti.FROM_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'LAST_NIGHT') then begin
      select formatdate(ti.TO_DATE - 1, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_PASSED') then begin
       /* 01  03 -  01-1, 02-2   (        )*/   
       select cast((:FOR_DATE - G.FROM_DATE + 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_TO_STAY') then begin
       /* 01  03 -  01-2, 02-1    (  )*/
       select cast((G.TO_DATE - :FOR_DATE - 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_CHILDREN') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD = 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_ADULTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD is distinct from 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS_BY_ACCOUNT') then begin
      select (select count(*)
              from   GUEST G
                     join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
              where  G.ID_BASE_ACCOUNT = ti.ID_BASE_ACCOUNT
                     and G.FROM_DATE <= :FOR_DATE
                     and G.TO_DATE > :FOR_DATE
                     and RD.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP ti
      where  ti.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_ROOM') then begin
      select trim(rt.TYPE_ROOM)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = tid.ID_ROOM_TYPE
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;
      /* TO PRESEVE COMPATIBILITY WITH OLD TARIFF VERSIONS */
      /* WE HAVE TO RETURN THE NAME NOT THE ID !           */

    end else if (:PARAM_CODE = 'TYPE_STAY') then begin
      select trim(ts.TYPE_STAY)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join TYPE_STAY TS on ts.ID_TYPE_STAY = tid.ID_TYPE_STAY
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_HRANA') then  begin
      select trim(m.NAME)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join MEALS m on m.ID_BOARD = tid.ID_BOARD
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = trim(coalesce(:OUT_VALUE, ''));

    end else if (:PARAM_CODE = 'PACK_ITEMS') then begin
      OUT_VALUE = null;
      select TID.PACKET_ITEMS
      from   TAR_CALC_INPUT$TMP TID
      where  TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = coalesce(:OUT_VALUE, '~~');
      -- strfloateval('POS("~2~", :PACK_ITEMS)>0', ';:PACK_ITEMS,STRING,~2~3~D~')

    end else if (:PARAM_CODE = 'AGE') then begin
      select ti.GUEST_AGE
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_SEX') then begin
      select G.GUEST_SEX
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE ;
      if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then OUT_VALUE = '-' ;

    end else if (:PARAM_CODE = 'NATION') then begin
      select tid.COUNTRY_CODE
      from   TAR_CALC_INPUT$TMP TID
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_DATE') then begin
      select cast(iif(G.FROM_DATE = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LAST_DATE') then begin
      select cast(iif(G.TO_DATE -1 = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LATE_CHECKOUT') then begin
      select g.IS_LATE_CHECKOUT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_GUEST_IN_ROOM') then begin
      select (select count(ti.ID_TAR_INPUT)
              from   TAR_CALC_INPUT$TMP ti
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and ti.ID_GUEST < t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :int1;

      if (:int1 = 0) then OUT_VALUE = 1; else OUT_VALUE = 0;
      
    end else if (:PARAM_CODE = 'IS_DIFER_NATIONS') then begin
      select (select cast(iif(count(distinct ti.COUNTRY_CODE) > 1, 1, 0) as integer)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_GROUP') then begin
      select cast(iif(g.ID_GROUP is not null, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_NIGHTS_BY_ACCOUNT') then begin
      /*          . */
      select (select cast(sum (G_IN_R.TO_DATE - G_IN_R.FROM_DATE) as integer)
              from   GUEST G_IN_R
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_R.ID_RESERV_DETAIL
              where  G_IN_R.ID_BASE_ACCOUNT = G.ID_BASE_ACCOUNT
                     and G_IN_R.CHECK_STATUS = 0
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYACCOUNT') then begin
      select (select cast(count(G.ID_GUEST) as integer)
              from   GUEST G
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  G.ID_BASE_ACCOUNT = t.ID_BASE_ACCOUNT
                     and G.ID_GUEST <= t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PAX_PRICE_WO_ADDINS') then begin
      /*             */
      /* PRICE_ORIG          */
      -- ?????    ???
      /*select  max(AP.PRICE_ORIG)
      from    ACCOUNT_POST AP 
      where   AP.ID_GUEST = :ID_GUEST
              and AP.DATE_POST = :FOR_DATE
              and AP.IS_BASE = 1
      plan    (AP index (ACCOUNT_POST_IDX6))
      into    :OUT_VALUE;
      */
      OUT_VALUE = null;

    end else if (:PARAM_CODE = 'ROOM_FEATURES') then begin
      select substring(R.FEATURES from 1 for 255)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join ROOMS R on r.ID_ROOM = tid.ID_ROOM
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_NIGHTS') then begin
      select (select cast(sum (G_IN_V.TO_DATE - G_IN_V.FROM_DATE) as integer)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE ;

    end else if (:PARAM_CODE = 'VAUCHER_GUESTS') then begin
      select (select count (G_IN_V.ID_GUEST)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_DATE') then begin
      select formatdate(G.VOUCHER_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_TEXT') then begin
      select G.VOUCHER_TEXT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYROOM') then begin
      select (select count(*) + 1
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ((t.IS_CHILD = 0 and ti.IS_CHILD = 0 and td.CHECKIN_ORDER < tid.CHECKIN_ORDER)
                          or (t.IS_CHILD = 1 and ((ti.IS_CHILD = 0) or (ti.GUEST_AGE > t.GUEST_AGE) or (ti.GUEST_AGE = t.GUEST_AGE and td.CHECKIN_ORDER < tid.CHECKIN_ORDER) )))
              )
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'ADULT_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*) + 1
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and td.CHECKIN_ORDER < tid.CHECKIN_ORDER
                     and ti.IS_CHILD = 0)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 0
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'CHILD_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*) + 1
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ( (ti.GUEST_AGE > t.GUEST_AGE) or (ti.GUEST_AGE = t.GUEST_AGE and td.CHECKIN_ORDER < tid.CHECKIN_ORDER) )
                     and ti.IS_CHILD = 1)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 1
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_TYPE') then begin
      select G.ID_GUEST_TYPE
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TO_AGENT') then begin
      select G.ID_AGENT_PROFILE
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else begin
      exception RATING_EXCEPTION 'Unsupported param - '||:PARAM_CODE;
    end

  end /*PART OF INTERNAL PARAMS*/


  /**********************************************/
  begin
    /* the source of the next check is gone with the wind
    /* but we must distinguish different data types */
    if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then begin
      /*not allow nulls*/
      if (:DATA_TYPE = 'DATE') then OUT_VALUE = '01/01/1899';
      else OUT_VALUE = '-1';  -- Unspecified
    end else if (:DATA_TYPE = 'INTEGER') then begin
      OUT_VALUE = cast(:OUT_VALUE as integer);
      /* to prevent errors like OUT_VALUE = '00001' */
    end

    when any do exception RATING_EXCEPTION 'Unsupported param value: ' || :param_code || ' = "' || coalesce(:OUT_VALUE, '<null>') || '"';
  end
  /**********************************************/
end
^

/* Alter (TEST_DOC) */
ALTER PROCEDURE TEST_DOC(ID_ACCOUNT INTEGER,
DOC_SELECTED INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER)
 AS
declare variable is_dep_doc integer;
  declare variable id_hotel integer;
  declare variable dummy varchar(255);
begin
  is_dep_doc = 0;

  execute procedure DOCUMENT_INITIALIZE$DOC (:id_account, :doc_selected, null)
  returning_values (:id_doc_head, :id_hotel, :dummy, :dummy);

  execute procedure DOCUMENT_ADD_DEF_PAYMENT$DOC (:id_doc_head, null);

  execute procedure DOCUMENT_VALIDATE$DOC (:id_doc_head)
  returning_values :dummy, :dummy, :dummy;
  suspend;
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_SALE_NUMBER_SET for: UNIQUE_SALES_NUMBER_GEN */
ALTER PROCEDURE ACCOUNT_SALE_NUMBER_SET(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
OVERRIDE_EXISTING /* TYPE OF TLOGICAL */ SMALLINT = 0)
 RETURNS(ID_SALE_NUM /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_SALE_NUMBER_SET for: UNIQUE_SALES_NUMBER_GEN */
ALTER PROCEDURE DOCUMENT_SALE_NUMBER_SET(ID_DOC_HEAD /* TYPE OF ID */ INTEGER,
CREATED_AT /* TYPE OF TDATETIME */ TIMESTAMP = current_timestamp)
 RETURNS(ID_SALE_NUM /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (UNIQUE_SALES_NUMBER_GEN) */
ALTER PROCEDURE UNIQUE_SALES_NUMBER_GEN(ID_HOTEL TYPE OF ID)
 RETURNS(UNIQUE_SALES_NUMBER TYPE OF TENUM_STRING)
 AS
declare variable num_class type of TNAME_SHORT;
  declare variable fiscal_device_id type of TSHORT_CODE;
  declare variable number type of TRANGE;
  declare variable user_code type of TENUM_STRING;
  declare variable num_object type of TRANGE;
begin
  execute procedure FISCAL_DEVICE_STATUS_CHECK(:ID_HOTEL, 0)
  returning_values (:fiscal_device_id);

  select u.CODE
  from   RIGHTS_USERS u
  where  u.USER_NAME = current_user
  into   :user_code;

  if (coalesce(:user_code, '') = '') then exception ASSERT '-706';

  NUM_CLASS = 'FISCAL_DEVICE';
  select n.NUM_OBJECT
  from   SYSTEM_NUMERATOR n
  where  n.NUM_CLASS = :num_class
         and n.NUM_NAME = :FISCAL_DEVICE_ID
         and n.ID_HOTEL is null
  into   :num_object;
  if (:num_object is null) then begin
    execute procedure NUMERATOR_MODIFY$CFG(null, :fiscal_device_id,
            1, '', 10, :num_class, null, 'add')
    returning_values (:num_object);
  end

  execute procedure SYSTEM_GEN_NUM(:num_class, :num_object)
  returning_values (:number, :number);

  if (:number is null) then exception ASSERT 'Sales number is empty!';

  UNIQUE_SALES_NUMBER = :FISCAL_DEVICE_ID || '-' || lpad(:user_code, 4, '0') || '-' || lpad(:number, 7, '0');
end
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER,
IS_MANUAL_TRANSFER TYPE OF TLOGICAL = 1)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date,
                    iif(:IS_MANUAL_TRANSFER is distinct from 1, 1, 0), :id_target_account)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Restore proc. body: ACCOUNT_POSTING_UPDATE */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_ID_TARIFF TYPE OF ID,
IN_ID_ROOM TYPE OF ID,
IN_QTY_POST TYPE OF TQTY,
IN_QTY_FREE TYPE OF TQTY,
IN_PRICE TYPE OF TPRICE,
IN_CURR TYPE OF TCURRENCY,
IN_RATE TYPE OF TRATE,
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
IN_DESCRIPTION TYPE OF TSERVICE_DESCRIPTION = null)
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date, 0, null, :IN_DESCRIPTION)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    action_text = f_character(29) || :action_text
                  || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                  || f_character(28) || :log_old_value
                  || f_character(28) || :log_new_value
                  || f_character(28) || replace(:IN_CHANGED_TEXT, 'MANUAL', '');
    execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
  end

end
^

/* Restore proc. body: ACCOUNT_SALE_NUMBER_SET */
ALTER PROCEDURE ACCOUNT_SALE_NUMBER_SET(ID_ACCOUNT TYPE OF ID,
OVERRIDE_EXISTING TYPE OF TLOGICAL = 0)
 RETURNS(ID_SALE_NUM TYPE OF ID)
 AS
declare variable dbkey char(8);
  declare variable unique_sales_number varchar(50);
  declare variable hp_type varchar(50);
  declare variable is_archive integer;
  declare variable id_hotel integer;
begin
  select a.RDB$DB_KEY, a.ID_SALE_NUM, p.HOUSE_TYPE, a.IS_ARCHIVE, a.ID_HOTEL
  from   ACCOUNT A
         left outer join PROFILE_HOUSE p on p.ID_PROFILE = a.ID_PROFILE
  where  a.ID_ACCOUNT = :ID_ACCOUNT
  into   :dbkey, :id_sale_num, :hp_type, :is_archive, :id_hotel;

  if (:dbkey is null) then exit;  -- inexistent

  if ((:id_sale_num is null) or (:OVERRIDE_EXISTING is not distinct from 1)) then begin
    if (:is_archive = 1) then
      exception ACCOUNT_EXCEPTION '-712';

    if (coalesce(:hp_type, '') in ('hptExternalRevenue', 'hptComplimentary')) then begin
      unique_sales_number = '_' || :hp_type || :ID_ACCOUNT;
    end else begin
      execute procedure UNIQUE_SALES_NUMBER_GEN(:id_hotel)
      returning_values (:unique_sales_number);
    end

    insert into SALE_NUM (UNIQUE_SALES_NUMBER)
    values (:unique_sales_number)
    returning id_sale_num into :id_sale_num;
  
    update ACCOUNT A
    set    a.ID_SALE_NUM = :id_sale_num
    where  a.RDB$DB_KEY = :dbkey;
  end
end
^

/* Restore proc. body: DEPOSIT_DOCUMENT_INITIALIZE$DOC */
ALTER PROCEDURE DEPOSIT_DOCUMENT_INITIALIZE$DOC(ID_PAYMENT_HEAD TYPE OF ID,
ID_BILLING_SERVICE TYPE OF ID)
 RETURNS(ID_DOC_HEAD TYPE OF ID,
ID_HOTEL TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable id_dep_doc integer;
  declare variable doc_selected integer;
  declare variable payment_date date;
  declare variable system_date date;
  declare variable require_archive_confirmation smallint;
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_BILLING');

  id_dep_doc = null;

  select p.ID_DOC_HEAD, p.ID_ACCOUNT, p.PAYMENT_DATE, a.ID_HOTEL
  from   PAYMENT_HEAD P
         join DEPOSIT d on d.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
         join ACCOUNT a on a.ID_ACCOUNT = p.ID_ACCOUNT
  where  p.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
         and p.IS_ANUL = 0
  into   :id_dep_doc, :id_account, :payment_date, :id_hotel;

  if (:id_account is null) then
    exception DOCUMENT_EXCEPTION '-355';

  if (:id_dep_doc is not null) then
    exception DOCUMENT_EXCEPTION '-364';

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :system_date;

  if (:payment_date < :system_date) then
    exception DOCUMENT_EXCEPTION '-399';

  doc_selected = gen_id(DOC_SELECTED_GEN, 1);

  update DEPOSIT P
  set    p.DOC_SELECTED = :doc_selected,
         p.ID_BILLING_SERVICE = :ID_BILLING_SERVICE
  where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;

  execute procedure DOCUMENT_INITIALIZE$DOC (:ID_ACCOUNT, :doc_selected)
  returning_values  (:ID_DOC_HEAD, :ID_HOTEL, :WARN_CODE, :REQUIRE_ARCHIVE_CONFIRMATION);
end
^

/* Restore proc. body: DISCOUNT_TAXATION_GET$INT */
ALTER PROCEDURE DISCOUNT_TAXATION_GET$INT(TAXES_IDS TYPE OF TDESCRIPTION_SHORT)
 RETURNS(ID_SALE_TAXATION TYPE OF ID)
 AS
declare variable new_sale_taxation_name varchar(50);
  declare variable id_hotel integer;
begin
  if (coalesce(:TAXES_IDS, '') = '') then
    exception ASSERT 'Unknown taxes for document discount!';

  -- find propper taxation
  select first 1 stt.ID_SALE_TAXATION
  from   SALE_TAXATION_WITH_TAX stt
  where  stt.TAXES_IDS = :TAXES_IDS
         and stt.INCLUDE_NON_VAT = 0
  into   :ID_SALE_TAXATION;

  if (:ID_SALE_TAXATION is null) then begin
    select substring(list(t.TAX_NAME, '+') from 1 for 49) || '*', min(t.ID_HOTEL)
    from   SYSTEM_STRING_PARSER(:TAXES_IDS) sp
           left join SALE_TAXES t on t.ID_SALE_TAX = sp.ITEM
    into   :new_sale_taxation_name, :id_hotel;

    insert into SALE_TAXATION (NAME, ID_HOTEL, ACCOUNT_NAME)
    values (:new_sale_taxation_name, :id_hotel, null)
    returning ID_SALE_TAXATION into :ID_SALE_TAXATION;

    insert into SALE_TAXATION_TAX (ID_SALE_TAXATION, ID_SALE_TAX)
    select :id_sale_taxation, sp.ITEM
    from   SYSTEM_STRING_PARSER(:taxes_ids) sp;
  end
end
^

/* Restore proc. body: DISCOUNTABLE_VALUE_CALC$INT */
ALTER PROCEDURE DISCOUNTABLE_VALUE_CALC$INT(ID_DOC_HEAD INTEGER)
 AS
declare variable discount_calc_method varchar(50) ;
  declare variable accum_discountable_gross_value double precision;
  declare variable accum_discountable_net_value double precision;
  declare variable lines_gross_value numeric(15,4);
  declare variable lines_net_value numeric(15,4);
  declare variable discountable_gross_value numeric(15,4);
  declare variable discountable_net_value numeric(15,4);
  declare variable discount_value double precision;
  declare variable discounted_value_type varchar(50);
  declare variable id_doc_discount integer;
  declare variable id_service_group integer;
  declare variable prev_id_srv_group integer;
  declare variable disc_order integer;
  declare variable taxes_ids varchar(50);
  declare variable prev_taxes_ids varchar(50);
begin
  accum_discountable_gross_value = 0;
  accum_discountable_net_value = 0;
  prev_id_srv_group = null;
  prev_taxes_ids = null;
  /* accumulate taxable values for each existed document taxes  */
  for
    select t.TAXES_IDS, s.ID_SERVICE_GROUP, df.TAX_ORDER, Df.ID,
           sd.DISCOUNT_CALC_METHOD, sd.DISCOUNT_VALUE, sd.DISCOUNTED_VALUE_TYPE,
           sum(dl.WOT_VAT), sum(dl.QTY_POST * dl.SINGLE_VALUE)
    from   DOC_LINE dl
           join SERVICES s on s.ID_SERVICE = dl.ID_SERVICE
           join DOC_LINE_DISCOUNTED dld on dld.ID_DOC_LINE = dl.ID_DOC_LINE
           join DOC_FOOTER df on df.ID = dld.ID_DOC_DISCOUNT
           join SALE_DISCOUNT_CALC$TMP t on t.ID_DOC_DISCOUNT = df.ID
           join SALE_DISCOUNT sd on sd.ID_SALE_DISCOUNT = df.ID_TAX
    where  dl.ID_DOC_HEAD = :ID_DOC_HEAD
    group by 1, 2, 3, 4, 5, 6, 7
    into   :taxes_ids, :id_service_group, :disc_order, :id_doc_discount,
           :discount_calc_method, :discount_value, :discounted_value_type,
           :lines_net_value, :lines_gross_value
  do begin
    if ( (:id_service_group is distinct from :prev_id_srv_group)
         or (:taxes_ids is distinct from :prev_taxes_ids) ) then begin
      accum_discountable_gross_value = :lines_gross_value;
      accum_discountable_net_value = :lines_net_value;
    end

    discountable_gross_value = 0;
    discountable_net_value = 0;
    if ((:discount_calc_method = 'runningTotal') or (:discounted_value_type = 'payableValue')) then begin
      /* this is a specific case :                         */
      /* discountable_value is service_value decreased with PREVIOUS discounts OVER TAXABLE VALUE */
      discountable_gross_value = :accum_discountable_gross_value;
      discountable_net_value = :accum_discountable_net_value;
    end else begin
      discountable_gross_value = :lines_gross_value;
      discountable_net_value = :lines_net_value;
    end

    update SALE_DISCOUNT_CALC$TMP T
    set    t.DISCOUNTABLE_VALUE = coalesce(t.DISCOUNTABLE_VALUE, 0) + :discountable_gross_value,
           t.DISCOUNTABLE_WOT_VAT = coalesce(t.DISCOUNTABLE_WOT_VAT, 0) + :discountable_net_value
    where  t.ID_DOC_DISCOUNT = :id_doc_discount;

    if (:discounted_value_type = 'taxableValue') then begin
      /* calculate service_value increased/decreased with current affected discount */
      /* accum_discounted_value is used by next discount with discount_calc_method = 'runningTotal' */
      accum_discountable_gross_value = :accum_discountable_gross_value
                                 - iif(:discount_calc_method = 'totalValue', :lines_gross_value, :accum_discountable_gross_value) * cast(:discount_value/100 as double precision);
      accum_discountable_net_value = :accum_discountable_net_value
                                   - iif(:discount_calc_method = 'totalValue', :lines_net_value, :accum_discountable_net_value) * cast(:discount_value/100 as double precision);
    end

    prev_id_srv_group = :id_service_group;
    prev_taxes_ids = :taxes_ids;
  end  /* for select...  */
end
^

/* Restore proc. body: DOC_LINES_TO_DISCOUNT */
ALTER PROCEDURE DOC_LINES_TO_DISCOUNT(ID_DOC_HEAD TYPE OF ID,
ID_SALE_DISCOUNT TYPE OF ID)
 RETURNS(ID_DOC_LINE TYPE OF ID,
TAXES_IDS TYPE OF TDESCRIPTION_SHORT)
 AS
declare variable service_dependence_type varchar(50);
  declare variable id_service_group integer;
  declare variable discounted_value_type varchar(50);
begin
  select sd.SERVICE_DEPENDENCE_TYPE, sd.DISCOUNTED_VALUE_TYPE
  from   SALE_DISCOUNT sd
  where  sd.ID_SALE_DISCOUNT = :ID_SALE_DISCOUNT
         and sd.DISCOUNT_CALC_METHOD <> 'fixedValue'
  into   :service_dependence_type, :discounted_value_type;

  if (:service_dependence_type is null) then exit;

  for
    select dl.ID_DOC_LINE, s.ID_SERVICE_GROUP,
           coalesce(stt.TAXES_IDS, '')  -- discounts on the payableValue should not respect taxes
    from   DOC_LINE dl
           join SERVICES s on s.ID_SERVICE = dl.ID_SERVICE
           left outer join SALE_TAXATION_WITH_TAX stt on stt.ID_SALE_TAXATION = dl.ID_SALE_TAXATION
                                                      and :discounted_value_type = 'taxableValue'
    where  dl.ID_DOC_HEAD = :ID_DOC_HEAD
           and dl.TAX_STATUS < 2
    into   :ID_DOC_LINE, :id_service_group, :TAXES_IDS
  do begin
    if (:service_dependence_type = 'none') then begin
      /* calc discount over ALL service groups */
      suspend;
    end else if (:service_dependence_type = 'include'
                 and exists (select *
                             from   SALE_DISCOUNT_SERVICES sds
                             where  Sds.ID_SALE_DISCOUNT = :ID_SALE_DISCOUNT
                                    and Sds.ID_SERVICE_GROUP = :ID_SERVICE_GROUP)) then
    begin
      /* calc discount over ennumerated service groups */
      suspend;
    end else if (:service_dependence_type = 'exclude'
                 and not exists (select *
                                 from   SALE_DISCOUNT_SERVICES sds
                                 where  Sds.ID_SALE_DISCOUNT = :ID_SALE_DISCOUNT
                                        and Sds.ID_SERVICE_GROUP = :ID_SERVICE_GROUP)) then
    begin
      suspend;
    end
  end
end
^

/* Restore proc. body: DOCUMENT_ADD_DISCOUNTS$INT */
ALTER PROCEDURE DOCUMENT_ADD_DISCOUNTS$INT(ID_DOC_HEAD TYPE OF ID,
ID_ACCOUNT TYPE OF ID)
 AS
declare variable sys_date date;
  declare variable doc_round_to numeric(15,4);
  declare variable nat_curr_round_to numeric(15,4);
  declare variable sec_curr_round_to numeric(15,4);
  declare variable id_doc_line integer;
  declare variable id_service integer;
  declare variable service_name varchar(50);
  declare variable single_value numeric(15,4);
  declare variable nat_gross_value numeric(15,4);
  declare variable sec_curr_gross_value numeric(15,4);
  declare variable id_hotel integer;
  declare variable df_dbkey char(8);
  declare variable discount_calc_method varchar(50);
  declare variable footer_value double precision;
  declare variable id_sale_taxation integer;
  declare variable discount_value numeric(15,4);
  declare variable doc_curr varchar(3);
  declare variable sec_curr varchar(3);
  declare variable doc_curr_rate numeric(15,6);
  declare variable no_use varchar(255);
  declare variable taxes_ids varchar(100);
  declare variable discount_cnt integer;
begin
  /* GET SOME SETTINGS VALUES *************************************************/
  select A.ID_HOTEL
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :id_hotel;

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values :sys_date;

  execute procedure DOCUMENT_CURRS_GET$INT (:ID_DOC_HEAD)
  returning_values (:doc_curr, :doc_curr_rate, :doc_round_to, :no_use, :nat_curr_round_to,
                    :sec_curr, :no_use, :sec_curr_round_to);
  /* CALC DOCUMENT DISCOUNTS ******************************************************/
  execute procedure DOCUMENT_DISCOUNTS_INIT$INT (:ID_DOC_HEAD)
  returning_values :discount_cnt;
  if (:discount_cnt = 0) then EXIT;

  execute procedure DISCOUNTABLE_VALUE_CALC$INT(:ID_DOC_HEAD);

  execute procedure DOCUMENT_CALC_DISCOUNTS$INT (:ID_DOC_HEAD, :doc_curr, :sec_curr);

  for
    select df.RDB$DB_KEY, df.FOOTER_VALUE, sd.DISCOUNT_CALC_METHOD, t.ID_SALE_TAXATION, t.TAXES_IDS,
           sd.ID_SERVICE, s.SERVICE_NAME, sd.DISCOUNT_VALUE, df.SECOND_CURR_DISCOUNT_VALUE
    from   DOC_FOOTER DF
           join SALE_DISCOUNT SD on sd.ID_SALE_DISCOUNT = df.ID_TAX
           join SERVICES s on s.ID_SERVICE = sd.ID_SERVICE
           left join SALE_DISCOUNT_CALC$TMP t on t.ID_DOC_HEAD = df.ID_DOC_HEAD and t.ID_DOC_DISCOUNT = df.ID
    where  DF.ID_DOC_HEAD = :ID_DOC_HEAD
           and sd.DISCOUNTED_VALUE_TYPE = 'taxableValue'
    into   :df_dbkey, :footer_value, :discount_calc_method, :id_sale_taxation, :taxes_ids,
           :id_service, :service_name, :discount_value, :sec_curr_gross_value
  do begin
    single_value = round_f(:footer_value, :doc_round_to);
    id_doc_line = null;

    nat_gross_value = round_f(:footer_value * :doc_curr_rate, :nat_curr_round_to);
    sec_curr_gross_value = round_f(:sec_curr_gross_value, :sec_curr_round_to);

    if (:id_sale_taxation is null) then begin
      execute procedure DISCOUNT_TAXATION_GET$INT(:taxes_ids)
      returning_values (:id_sale_taxation);
    end

    execute procedure DOCUMENT_LINE_ADD$INT (
            :ID_DOC_HEAD, :id_service, :id_sale_taxation,
            :service_name || ' ' || iif(:discount_calc_method = 'fixedValue', '', ' ' || formatfloat(:discount_value, '0.00') ||' %'),
            -1, :sys_date, :sys_date, :sys_date, null,
            1, :footer_value, :single_value, :doc_round_to, :nat_gross_value, :nat_curr_round_to,
            :sec_curr, :sec_curr_gross_value, :sec_curr_round_to, iif(:single_value >= 0, 2, 3),
            0, null)
    returning_values (:id_doc_line, :no_use, :no_use, :no_use);

    update DOC_FOOTER df
    set    df.ID_DOC_LINE = :id_doc_line
    where  df.RDB$DB_KEY = :df_dbkey;
  end 

end
^

/* Restore proc. body: DOCUMENT_ANUL$DOC */
ALTER PROCEDURE DOCUMENT_ANUL$DOC(ID_DOC_HEAD INTEGER,
ANUL_REASON VARCHAR(100),
MAKE_ANNUL_REPORT SMALLINT)
 AS
/**/
  declare variable id_account  integer;
  declare variable id_payment_head integer;
  declare variable for_deposit integer;
  declare variable id_base_doc integer;
  declare variable is_anul integer;
  declare variable dh_dbkey char(8);
  declare variable id_annul_protocol_num integer;
  declare variable num integer;
  declare variable doc_num varchar(20);
  declare variable system_date date;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable doc_date date;
  declare variable id_system_log integer;
  declare variable id_hotel integer;
  declare variable is_storno_doc integer;
  declare variable no_use varchar(255);
  declare variable doc_sub_type integer;
  declare variable fisc_status smallint;
begin
  select H.RDB$DB_KEY, H.ID_ACCOUNT, H.FOR_DEPOSIT, H.ID_BASE_DOC, H.IS_ANUL, A.ID_HOTEL,
         A.ID_RESERV_DETAIL, T.ID_ANNUL_DOC_NUM, h.DOC_DATE, H.IS_STORNO, h.DOC_SUB_TYPE, dc.FISC_STATUS
  from   DOC_HEAD$INT H
         join DOC_COMPLETION dc on dc.ID_DOC_HEAD = h.ID_DOC_HEAD
         join DOC_TYPE T on H.ID_DOC_TYPE = T.ID_DOC_TYPE
         join DOC_TYPE_INV DTI on DTI.ID_DOC_TYPE = T.ID_DOC_TYPE
         join ACCOUNT A on A.ID_ACCOUNT = H.ID_ACCOUNT
  where  H.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dh_dbkey, :id_account, :for_deposit, :id_base_doc, :is_anul, :id_hotel,
         :id_reserv_detail, :id_annul_protocol_num, :doc_date, :is_storno_doc, :doc_sub_type, :fisc_status;

  if (:is_anul = 1) then
    exception DOCUMENT_ANNUL_EXCEPTION '-352'; --'Document is already annul';

  if (exists (select D.ID_DOC
              from   DOC_HEAD D
              where  D.ID_BASE_DOC = :ID_BASE_DOC
                     and D.ID_DOC > :ID_DOC_HEAD
                     and D.IS_ANUL = 0))
  then exception DOCUMENT_ANNUL_EXCEPTION '-314';

  if (exists (select D.ID_DEPOSIT
              from   DEPOSIT_DEDUCT DD
                     join DEPOSITS d on d.ID_DEPOSIT = dd.ID_DEPOSIT
              where  DD.ID_DOC_USED = :ID_DOC_HEAD
                     and D.RECEIVED_AMOUNT = 0))
  then exception DOCUMENT_ANNUL_EXCEPTION '-315';

  execute procedure SYSTEM_DATE_GET(:ID_HOTEL)
  returning_values  :system_date;

  if (:DOC_DATE < :SYSTEM_DATE) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_PREV_DATE');
  end
  if (:doc_sub_type > 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_CORR_DOC');
  end
  /* unarchive account and set as credit account, for shecked out bookings only */
  execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:ID_ACCOUNT, 0);

  if (:ID_RESERV_DETAIL is not null) then begin
    select RD.CHECK_STATUS
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :check_status;

    if (:check_status = 1) then begin
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, null, 1);
    end
  end
  /* MARK THE DOCUMENT AS ANUL - before posting and payment updates */
  update DOC_HEAD$INT DH
  set    DH.IS_ANUL = 1
  where  DH.RDB$DB_KEY = :dh_dbkey;

  update DOC_COMPLETION Dc
  set    Dc.IS_EFAKTURA_EXPORTED = 0
  where  Dc.ID_DOC_HEAD = :ID_DOC_HEAD;


  if (:is_storno_doc = 1) then begin
    /* annul storno doc */
    update DOC_HEAD$INT BD
    set    BD.IS_STORNED = 0
    where  BD.ID_BASE_DOC = :id_base_doc
           and BD.IS_STORNED = 1;
  end
  /* RELEASE ACCOUNT_POSTS */
  if (:for_deposit = 0) then
    execute procedure ACCOUNT_POSTING_DOC_UPDATE$INT (:DH_DBKEY)
    returning_values (:no_use);

  /* PAYMENTS REFLECTION */
  for
    select PH.ID_PAYMENT_HEAD
    from   PAYMENT_HEAD PH
           join DOC_TYPE_PAY dt on dt.ID_DOC_TYPE = ph.ID_DOC_TYPE
    where  PH.ID_DOC_HEAD = :ID_DOC_HEAD
           and PH.IS_STORNED = 0
    into   :ID_PAYMENT_HEAD
  do begin

    execute procedure PAYMENT_ANUL$INT (:ID_PAYMENT_HEAD, :ANUL_REASON);
  end

  /* ANNUL_PROTOCOL creating section */
  NUM = null;
  DOC_NUM = null;
  if (:MAKE_ANNUL_REPORT = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_WITH_PROT');

    if (:ID_ANNUL_PROTOCOL_NUM is null) then exception DOCUMENT_ANNUL_EXCEPTION '-345';

    execute procedure SYSTEM_GEN_NUM ('ANNUL_PROT', :ID_ANNUL_PROTOCOL_NUM)
    returning_values  (:num, :doc_num);
  end
  /* log annul event */
  execute procedure SYSTEM_EVENT_LOG$INT ('DOCUMENT', :ID_DOC_HEAD, 'ANNUL', f_character(29)||:ANUL_REASON)
  returning_values  :id_system_log;

  insert into DOC_ANNULMENT (ID_DOC_HEAD, ANNULMENT_DATE, ID_PROT_DOC_NUM, PROT_NUM, PROT_DOC_NUM, ID_LOG_EVENT)
  values (:ID_DOC_HEAD, :SYSTEM_DATE, :ID_ANNUL_PROTOCOL_NUM, :NUM, :DOC_NUM, :ID_SYSTEM_LOG);
  /* reflect annul date on doc release dates */
  if (:DOC_DATE < :SYSTEM_DATE) then begin
    insert into DOC_RELEASE_DATE (ID_DOC_HEAD, RELEASE_DATE, VALUE_CORR_INDEX)
    values (:ID_DOC_HEAD, :SYSTEM_DATE, -1);
  end else begin
    update DOC_RELEASE_DATE RD
    set    RD.VALUE_CORR_INDEX = 0
    where  RD.ID_DOC_HEAD = :ID_DOC_HEAD
           and RD.RELEASE_DATE = :DOC_DATE;
  end
  /* reflect on AR module */
  execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT (:DH_DBKEY, :ANUL_REASON);
  /* reflect on client loyalty module */
  execute procedure DOCUMENT_BONUSPOINTS_VOID$CL (:ID_DOC_HEAD);

  execute procedure FISCAL_DEVICE_STATUS_CHECK(:id_hotel, iif(:fisc_status = 2, 1, 0))
  returning_values (:no_use);
end
^

/* Restore proc. body: DOCUMENT_DELETE$DOC */
ALTER PROCEDURE DOCUMENT_DELETE$DOC(ID_DOC_HEAD INTEGER)
 AS
declare variable id_account_post integer;
  declare variable id_doc integer;
  declare variable doc_num varchar(20);
  declare variable doc_type_name varchar(50);
  declare variable doc_date date;
  declare variable action_text varchar(255);
  declare variable id_base_doc integer;
  declare variable id_doc_num integer;
  declare variable num_dbkey char(8);
  declare variable doc_dbkey char(8);
  declare variable last_num integer;
  declare variable num integer;
  declare variable id_doc_line integer;
  declare variable for_deposit smallint;
  declare variable is_anul smallint;
  declare variable id_account integer;
begin

  select DH.ID_BASE_DOC, dh.IS_ANUL, dh.ID_ACCOUNT
  from   DOC_HEAD$INT DH
  where  DH.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :id_base_doc, :is_anul, :id_account;

  if (:id_base_doc is distinct from :ID_DOC_HEAD and :is_anul = 0) then
    exception DOCUMENT_EXCEPTION '-342'; /* base doc is not selected to delete */

  execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 0);

  for
    select D.ID_DOC_NUM, D.ID_DOC_HEAD, D.DOC_NUM, D.NUM, D.DOC_TYPE_NAME, D.DOC_DATE, d.FOR_DEPOSIT, D.RDB$DB_KEY
    from   DOC_HEAD$INT D
    where  (D.ID_BASE_DOC = :ID_DOC_HEAD and :is_anul = 0)
           or (d.ID_DOC_HEAD = :ID_DOC_HEAD and :is_anul = 1)
    order by D.ID_DOC_NUM asc, D.ID_DOC_HEAD desc
    into   :id_doc_num, :id_doc, :doc_num, :num, :doc_type_name, :doc_date, :for_deposit, :doc_dbkey
  do begin
    if (:is_anul = 0) then begin
      for
        select PV.ID_ACCOUNT_POST
        from   DOC_LINE dl
               join DOC_LINE_POST_VALUES pv on PV.ID_DOC_LINE = dl.ID_DOC_LINE
        where  DL.ID_DOC_HEAD = :id_doc
        order by Dl.ID_DOC_LINE desc
        into   :id_account_post
      do begin
        update ACCOUNT_POST AP
        set    AP.IN_DOC_QTY = 0,
               AP.IN_DOC_VALUE = 0,
               AP.AC = iif(AP.QTY_POST = 0, '10', '00'),
               AP.IS_ANUL = iif(AP.QTY_POST = 0, 1, 0),
               AP.ID_BASE_DOC = null
        where  AP.ID_ACCOUNT_POST = :id_account_post
               and AP.ID_BASE_DOC = :ID_DOC_HEAD;
      end
    end
    /*   */
    action_text = f_character(29) || :doc_type_name || ' ' || :doc_num || '/' || formatdate(:doc_date, 'D;dd.mm.yyyy');
    execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :id_doc, 'DELETE', :action_text);

    if (:is_anul = 0 and exists (select p.ID_PAYMENT_HEAD
                                 from   PAYMENT_HEAD P
                                        join PAYMENT_TYPE pt on pt.ID_PAYMENT_TYPE = p.ID_PAYMENT_TYPE and pt.IS_AR_DEBT = 1
                                 where  p.ID_DOC_HEAD = :id_doc)) then begin
      /* Account recievables check*/
      update DOC_HEAD$INT DH
      set    dh.IS_ANUL = 1
      where  DH.RDB$DB_KEY = :doc_dbkey;
  
      execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT(:doc_dbkey);
    end

    if (:for_deposit = 1) then begin
      for
        select dl.ID_DOC_LINE
        from   DOC_LINE dl
        where  dl.ID_DOC_HEAD = :id_doc
        into   :id_doc_line
      do begin
        delete from DOC_LINE_DEP_VALUES dv
        where  dv.ID_DOC_LINE = :id_doc_line;
      end 
    end

    delete from PAYMENT_HEAD P
    where  P.ID_DOC_HEAD = :id_doc;

    delete from DOC_HEAD$INT dh
    where  dh.ID_DOC_HEAD = :id_doc;

    -- reset numerator if deleted document is the last
    select coalesce(max(d.NUM), 0)
    from   DOC_HEAD$INT D
    where  D.ID_DOC_NUM = :id_doc_num
    into   :last_num;

    if (:last_num < :num) then begin
      select SN.RDB$DB_KEY
      from   SYSTEM_NUMERATOR SN
      where  SN.ID_NUMERATOR = :id_doc_num
      into   :num_dbkey;
  
      execute procedure SYSTEM_GEN_NUM$INT (:num_dbkey, :last_num)
      returning_values  (:last_num);
    end

  end
end
^

/* Restore proc. body: DOCUMENT_DISCOUNTS_INIT$INT */
ALTER PROCEDURE DOCUMENT_DISCOUNTS_INIT$INT(ID_DOC_HEAD INTEGER)
 RETURNS(DISCOUNT_CNT INTEGER)
 AS
declare variable id_sale_discount integer;
declare variable discount_order integer;
declare variable id_doc_footer integer;
declare variable is_payable_value_disc integer;
declare variable discount_calc_method varchar(50);
declare variable id_doc_line  integer;
declare variable id_sale_taxation integer;
declare variable id_service integer;
declare variable id_tax_policy integer;
declare variable taxes_ids varchar(100);
declare variable prev_taxes_ids varchar(100);
begin
  DISCOUNT_CNT = 0;
  discount_order = 0;
  for
    select iif(d.DISCOUNTED_VALUE_TYPE = 'taxableValue', 0, 1),
           D.ID_SALE_DISCOUNT, d.DISCOUNT_CALC_METHOD, d.ID_SERVICE, d.ID_TAX_POLICY
    from   SALE_DISCOUNTS_APPLICABLE(:ID_DOC_HEAD) D
    order by 1 asc, d.DISCOUNT_ORDER asc  -- mandatory !!! first calc discounts over taxable value.
    into   :is_payable_value_disc, :id_sale_discount, :discount_calc_method, :id_service, :id_tax_policy
  do begin
    discount_order = :discount_order + 1;
    id_sale_taxation = null;

    if (:discount_calc_method = 'fixedValue') then begin
      insert into DOC_FOOTER (ID_DOC_HEAD, ID_TAX, TAX_ORDER,
             TAXABLE_VALUE, ID_DOC_LINE, FOOTER_VALUE, DESCRIPTION)
      values (:ID_DOC_HEAD, :id_sale_discount, :discount_order,
             0, null, 0, '')
      returning ID into :id_doc_footer;
  
      if (:is_payable_value_disc = 0) then begin
        select st.ID_SALE_TAXATION
        from   SERVICE_TAXATION st
        where  st.ID_SERVICE = :ID_SERVICE
               and st.ID_TAX_POLICY = :id_tax_policy
        into   :id_sale_taxation;
      end
      insert into SALE_DISCOUNT_CALC$TMP (ID_DOC_HEAD, ID_DOC_DISCOUNT, ID_SALE_TAXATION, DISCOUNTABLE_VALUE, DISCOUNTABLE_WOT_VAT)
      values (:ID_DOC_HEAD, :id_doc_footer, :id_sale_taxation, 0, 0);

      DISCOUNT_CNT = :DISCOUNT_CNT + 1;
    end else begin
      prev_taxes_ids = null;
      for
        select  ltd.id_doc_line, ltd.TAXES_IDS
        from    DOC_LINES_TO_DISCOUNT(:id_doc_head, :id_sale_discount) ltd
        order by 2 -- mandatory for doc_footer creating!
        into    :id_doc_line, :taxes_ids
      do begin
        if (:prev_taxes_ids is distinct from :taxes_ids) then begin
          insert into DOC_FOOTER (ID_DOC_HEAD, ID_TAX, TAX_ORDER,
                 TAXABLE_VALUE, ID_DOC_LINE, FOOTER_VALUE, DESCRIPTION)
          values (:ID_DOC_HEAD, :id_sale_discount, :discount_order,
                 0, null, 0, '')
          returning ID into :id_doc_footer;

          insert into SALE_DISCOUNT_CALC$TMP (ID_DOC_HEAD, ID_DOC_DISCOUNT, TAXES_IDS, DISCOUNTABLE_VALUE, DISCOUNTABLE_WOT_VAT)
          values (:ID_DOC_HEAD, :id_doc_footer, :taxes_ids, 0, 0);
    
          DISCOUNT_CNT = :DISCOUNT_CNT + 1;
        end

        insert into DOC_LINE_DISCOUNTED (id_doc_line, id_doc_discount)
        values (:id_doc_line, :id_doc_footer);

        prev_taxes_ids = :taxes_ids;
      end
    end
  end
end
^

/* Restore proc. body: DOCUMENT_PRENUMERATE$DOC */
ALTER PROCEDURE DOCUMENT_PRENUMERATE$DOC(SELECTION_ID INTEGER)
 AS
declare variable id_doc_num integer;
  declare variable last_num integer;
  declare variable old_doc_num varchar(20);
  declare variable doc_num varchar(20);
  declare variable tmp_id_doc integer;
  declare variable action_text varchar(255);
  declare variable num_dbkey char(8);
begin
  for
    select SN.ID_NUMERATOR, SN.RDB$DB_KEY, min(DH.NUM)
    from   DOC_HEAD DH
           join SYSTEM_NUMERATOR SN on SN.ID_NUMERATOR = DH.ID_DOC_NUM
    where  DH.SELECTION_ID = :SELECTION_ID
    group by SN.ID_NUMERATOR, SN.RDB$DB_KEY
    into   :id_doc_num, :num_dbkey, :last_num
  do begin
    execute procedure SYSTEM_GEN_NUM$INT (:num_dbkey, :last_num)
    returning_values  (:last_num);
    if (:last_num is null) then exception NUMERATOR_EXCEPTION 'Numerator is locked!';

    for
      select DH.DOC_NUM, DH.ID_DOC
      from   DOC_HEAD DH
      where  dh.ID_DOC_NUM = :id_doc_num
             and dh.NUM > :last_num
      order by DH.NUM asc
      into   :old_doc_num, :tmp_id_doc
    do begin
      execute procedure SYSTEM_GEN_NUM ('DOCUMENT', :id_doc_num)
      returning_values  (:last_num, :doc_num);

      update DOC_HEAD$INT D
      set    D.NUM = :last_num,
             D.DOC_NUM = :doc_num
      where  D.ID_DOC_HEAD = :tmp_id_doc;

      action_text = f_character(29)||:old_doc_num||f_character(28)||:doc_num;
      execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :tmp_id_doc, 'DOC_NUM_REGEN', :action_text);
    end
  end
end
^

/* Restore proc. body: DOCUMENT_SALE_NUMBER_SET */
ALTER PROCEDURE DOCUMENT_SALE_NUMBER_SET(ID_DOC_HEAD TYPE OF ID,
CREATED_AT TYPE OF TDATETIME = current_timestamp)
 RETURNS(ID_SALE_NUM TYPE OF ID)
 AS
declare variable unique_sales_number varchar(50);
declare variable id_hotel integer;
begin
  select d.ID_SALE_NUM, a.ID_HOTEL
  from   DOC_HEAD D
         join ACCOUNT a on a.ID_ACCOUNT = d.ID_ACCOUNT
  where  d.ID_DOC = :ID_DOC_HEAD
  into   :id_sale_num, :id_hotel;

  if (:id_sale_num is null) then begin
    execute procedure UNIQUE_SALES_NUMBER_GEN(:id_hotel)
    returning_values (:UNIQUE_SALES_NUMBER);

    insert into SALE_NUM (UNIQUE_SALES_NUMBER, CREATED_AT)
    values (:UNIQUE_SALES_NUMBER, :CREATED_AT)
    returning id_sale_num into :id_sale_num;
  
    update DOC_COMPLETION dc
    set    dc.ID_SALE_NUM = :id_sale_num
    where  dc.ID_DOC_HEAD = :ID_DOC_HEAD;
  end
end
^

/* Restore proc. body: DOCUMENT_VALIDATE$DOC */
ALTER PROCEDURE DOCUMENT_VALIDATE$DOC(ID_DOC_HEAD TYPE OF ID_REF,
ARCHIVE_ACCOUNT TYPE OF TLOGICAL = 0)
 RETURNS(FIRM_DATA TYPE OF TNOTE_BLOB,
WARN_CODE TYPE OF TRANGE,
NEW_DOC_DATE TYPE OF TDATE)
 AS
declare variable no_use varchar(255);
  declare variable doc_value numeric(15,4);
  declare variable rest_value numeric(15,4);
  declare variable lines_value numeric(15,4);
  declare variable lines_wot_vat numeric(15,4);
  declare variable tax_value numeric(15,4);
  declare variable taxable_value numeric(15,4);
  declare variable round_to numeric(15,4);
  declare variable id_doc_contragent integer;
  declare variable id_doc_supplier integer;
  declare variable for_deposit integer;
  declare variable id_profile integer;
  declare variable dbkey char(8);
  declare variable id_contragent integer;
  declare variable ident_no varchar(30) ;
  declare variable action_text varchar(255);
  declare variable doc_currency varchar(3);
  declare variable is_juridical_person smallint;
  declare variable vat_ident_no varchar(30);
  declare variable id_doc_type integer;
  declare variable doc_sub_type integer;
  declare variable required_ident_no smallint;
  declare variable required_vat_no smallint;
  declare variable required_egn smallint;
  declare variable required_recipient_name smallint;
  declare variable lines_count integer;
  declare variable recipient_name varchar(100);
  declare variable id_doc_completed integer;
  declare variable action_code varchar(50);
  declare variable id_sale_num integer;
  declare variable id_acc_sale_num integer;
  declare variable id_account integer;
  declare variable fiscal_device_id varchar(10);
  declare variable created_at timestamp;
  declare variable id_hotel integer;
  declare variable fisc_status integer;
begin

  select D.RDB$DB_KEY, D.DOC_VALUE_A, C.ROUND_TO, a.ID_HOTEL,
         D.ID_DOC_CONTRAGENT, D.ID_DOC_SUPPLIER, D.FOR_DEPOSIT,
         A.ID_PROFILE, D.DOC_CURRENCY, D.TAXABLE_VALUE, d.ID_DOC_TYPE, d.DOC_SUB_TYPE,
         dc.ID_DOC_HEAD, coalesce(ds."__FIRM_DATA", ds.COMPANY_IDENT_NUM), dc.ID_SALE_NUM, a.ID_SALE_NUM, d.DATETIME_CREATED, a.ID_ACCOUNT
  from   DOC_HEAD$INT D
         join CURRS C on C.CURR = D.DOC_CURRENCY
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         left outer join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
         left outer join DOC_SUPPLIER ds on ds.ID_DOC_SUPPLIER = d.ID_DOC_SUPPLIER
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dbkey, :doc_value, :round_to, :id_hotel,
         :id_doc_contragent, :id_doc_supplier, :for_deposit,
         :id_profile, :doc_currency, :taxable_value, :id_doc_type, :doc_sub_type,
         :id_doc_completed, :FIRM_DATA, :id_sale_num, :id_acc_sale_num, :created_at, :id_account;

  if (:id_doc_contragent is null) then
    exception DOCUMENT_EXCEPTION '-356'; --'Contragent is not set!';

  if (:id_doc_supplier is null) then
    exception DOCUMENT_EXCEPTION '-357'; --'Supplier is not set!';

  select sum(DT.TAX_VALUE)
  from   DOC_TAXES DT
  where  DT.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :tax_value;

  /*if (round_f(:doc_value - :total_value, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Total value is not correct!';
  */
  select round_f(sum(DL.SINGLE_VALUE * DL.QTY_POST), :round_to),
         round_f(sum(DL.WOT_VAT), :round_to),
         count(*)
  from   DOC_LINE DL
  where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :lines_value, :lines_wot_vat, :lines_count;
 
  if (:lines_count = 0) then
    exception INTERNAL_DOC_EXCEPTION 'Document is empty! Not exists sale lines!';

  if (round_f(:doc_value - :lines_value, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines total value is not correct!' || :doc_value ||  ' / ' || :lines_value || ' ; '|| (:doc_value - :tax_value) ||  ' / ' || :lines_wot_vat;

  if (round_f(:doc_value - :tax_value - :lines_wot_vat, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines wot tax value is not correct!';

  if (round_f(abs(:lines_wot_vat) - abs(:taxable_value), :round_to) < 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines wot tax value is less than total taxable value!';

  if (:id_doc_completed is not null) then begin
    select DV.PAYABLE_VALUE
    from   DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, null) DV
    into   :rest_value;
  
    if (round_f(:rest_value, :round_to) <> 0) then
      exception DOCUMENT_EXCEPTION '-371'; --'Insufficient amount of payments !';
  end

  /* Validate contragent data */
  select dt.REQUIRED_IDENT_NO, dt.REQUIRED_VAT_NO, dt.REQUIRED_EGN, dt.REQUIRED_RECIPIENT_NAME
  from   DOC_TYPE_INV DT
  where  dt.ID_DOC_TYPE = :id_doc_type
  into   :required_ident_no, :required_vat_no, :required_egn, :required_recipient_name;

  select dc.ID_CONTRAGENT, dc.IS_JURIDICAL_PERSON,
         trim(coalesce(dc.IDENT_NO, '')), trim(coalesce(dc.VAT_REG_NUM, '')),
         trim(coalesce(dc.RECIPIENT_NAME, ''))
  from   DOC_CONTRAGENT dc
  where  dc.ID_DOC_CONTRAGENT = :id_doc_contragent
  into   :id_contragent, :is_juridical_person, :ident_no, :vat_ident_no, :recipient_name;

  if (:doc_sub_type = 0 and :required_ident_no = 1 and :is_juridical_person = 1 and :ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-324'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_egn = 1 and :is_juridical_person = 0 and :ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-324'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_vat_no = 1 and :is_juridical_person = 1 and :vat_ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-326'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_recipient_name = 1 and :recipient_name = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-327'; --'Recipient_name is empty.';
  /*if (:post_address = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-325'; --'Contragent address is empty.';
  /* save contragent link for profile */
  if (:id_contragent is not null) then begin
    update PROFILE P
    set    P.ID_DEF_CONTRAGENT = :id_contragent
    where  P.ID_PROFILE = :id_profile
           and P.ID_DEF_CONTRAGENT is null;
  end
  /*  */
  execute procedure DOCUMENT_SET_NUMBER$INT (:dbkey)
  returning_values (:no_use, :no_use);
  /*  */
  if (:id_doc_completed is not null) then begin
    execute procedure DOC_INIT_FISCAL_STATUS$INT(:ID_DOC_HEAD)
    returning_values :fisc_status;
    /*  */
    execute procedure FISCAL_DEVICE_STATUS_CHECK(:id_hotel, :fisc_status)
    returning_values (:fiscal_device_id);

    if (:for_deposit = 0) then begin
      /* update account posts */
      execute procedure ACCOUNT_POSTING_DOC_UPDATE$INT (:dbkey)
      returning_values :WARN_CODE;
    end

    execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT (:dbkey);
    /* ... */
    execute procedure DOCUMENT_BONUSPOINTS_APPLY$CL (:ID_DOC_HEAD);
    /* ... */
  end

  if (:id_doc_completed is not null and :id_sale_num is null) then begin
    if (not exists (select ap.ID_ACCOUNT_POST
                    from   ACCOUNT_POST Ap
                    where  ap.ID_ACCOUNT = :id_account
                           and ap.ac in ('00', '10'))) then
    begin
      update DOC_COMPLETION c
      set    c.ID_SALE_NUM = :id_acc_sale_num
      where  c.ID_DOC_HEAD = :ID_DOC_HEAD;

      update ACCOUNT a
      set    a.ID_SALE_NUM = null
      where  a.ID_ACCOUNT = :id_account;
      id_acc_sale_num = null;
    end else begin
      execute procedure DOCUMENT_SALE_NUMBER_SET(:ID_DOC_HEAD, :created_at)
      returning_values (:id_sale_num);
    end
  end

  execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, coalesce(:ARCHIVE_ACCOUNT, 0));

  if (:ARCHIVE_ACCOUNT is distinct from 1 and :id_acc_sale_num is null) then begin
    execute procedure ACCOUNT_SALE_NUMBER_SET(:id_account)
    returning_values (:id_acc_sale_num);
  end
  /*  */
  action_text = f_character(29) || formatfloat(:doc_value, 'F;0.00') || ' ' || :doc_currency;
  action_code = iif(:id_doc_completed is null,  'PROFORMA_CREATE', 'CREATE');
  execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :ID_DOC_HEAD, :action_code, :action_text);

  select cast('31.12.1899' as date) + count(d.ID_DOC_HEAD)
  from   DOC_HEAD$INT d
  where  d.DOC_DATE is not null
  into   :NEW_DOC_DATE;
end
^

/* Restore proc. body: EAI_EXT_POST_TO_MH_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:ID_ACCOUNT_POST, :SERVICE_CODE, null, null);

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Restore proc. body: EAI_EXT_SERVICE_POST */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:ID_ACCOUNT_POST, :SERVICE_EXT_CODE, null, null);

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Restore proc. body: EAI_POS_POSTING_ADD$P2E */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30),
UNIQUE_SALES_NUMBER VARCHAR(30) = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable my_post_text varchar(255);
  declare variable my_resource_text varchar(255);
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
  declare variable id_account_post integer;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  my_post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  my_resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  my_post_text = substring(:my_post_text from 1 for 100);
  my_resource_text = substring(:my_resource_text from 1 for 49);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code, '')
    returning_values  :err_code, :err_text, :out_id_account, :id_account_post;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code)
    returning_values  :err_code, :err_text, :id_account_post;
    out_id_account = :in_id_account;
  end

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:id_account_post, :post_short_code, :IN_POS_USER, :IN_DATETIME);

  if (:UNIQUE_SALES_NUMBER is null and :IN_ID_SMETKA = 'END_WORK') then
    UNIQUE_SALES_NUMBER = 'END_WORK';

  insert into ACCOUNT_POST_POS_TRANSFER (ID_ACCOUNT_POST, UNIQUE_SALES_NUMBER, POS_ID_SMETKA, POS_SMETKA_NUM,
         POS_SMETKA_DATE, POS_OBJECT_NAME, TAG_VALUE, TAG_NAME, TRANSFER_VALUE)
  values (:id_account_post, :UNIQUE_SALES_NUMBER, nullif(:IN_ID_SMETKA, 'END_WORK'), :IN_SMETKA_NUM,
         :IN_DATE_SMETKA, :IN_OBJ_NAME, :IN_SERVICE_TAG, :IN_SERVICE_NAME, :IN_PRICE);
end
^

/* Restore proc. body: EAI_POS_POSTING_DET_ADD$P2E */
ALTER PROCEDURE EAI_POS_POSTING_DET_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_AMOUNT NUMERIC(15,2),
IN_QTY NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30),
IN_SERVICE_DESCRIPTION VARCHAR(50),
UNIQUE_SALES_NUMBER VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable post_text varchar(255);
  declare variable resource_text varchar(255);
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
  declare variable id_account_post integer;
  declare variable price type of TPRICE;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  post_text = substring(:post_text from 1 for 100);
  resource_text = substring(:resource_text from 1 for 49);

  IN_QTY = coalesce(nullif(:IN_QTY, 0), 1);
  price = cast(:IN_AMOUNT/:IN_QTY as type of TPRICE);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, :in_qty, 0, 1, :price, :nation_curr,
      current_timestamp, current_timestamp, :post_text, :resource_text, null, :post_short_code, '', :IN_SERVICE_DESCRIPTION)
    returning_values  :err_code, :err_text, :out_id_account, :id_account_post;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, :IN_QTY, 0, 1, :price, :nation_curr,
      current_timestamp, current_timestamp, :post_text, :resource_text, null, :post_short_code, null, :IN_SERVICE_DESCRIPTION)
    returning_values  :err_code, :err_text, :id_account_post;
    out_id_account = :in_id_account;
  end

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:id_account_post, :post_short_code, :IN_POS_USER, :IN_DATETIME);

  if (:UNIQUE_SALES_NUMBER is null and :IN_ID_SMETKA = 'END_WORK') then
    UNIQUE_SALES_NUMBER = 'END_WORK';

  insert into ACCOUNT_POST_POS_TRANSFER (ID_ACCOUNT_POST, UNIQUE_SALES_NUMBER, POS_ID_SMETKA, POS_SMETKA_NUM,
         POS_SMETKA_DATE, POS_OBJECT_NAME, TAG_VALUE, TAG_NAME, TRANSFER_VALUE)
  values (:id_account_post, :UNIQUE_SALES_NUMBER, nullif(:IN_ID_SMETKA, 'END_WORK'), :IN_SMETKA_NUM,
         :IN_DATE_SMETKA, :IN_OBJ_NAME, :IN_SERVICE_TAG, :IN_SERVICE_NAME, :IN_AMOUNT);
 
end
^

/* Restore proc. body: EAI_TELECOUNT_TRANSFER */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* Restore proc. body: FISCALIZE_DISCOUNT$FISC */
ALTER PROCEDURE FISCALIZE_DISCOUNT$FISC(ID_FISCAL_DATA INTEGER)
 RETURNS(FISC_SUM NUMERIC(15,4),
FISC_TEXT VARCHAR(100))
 AS
declare variable fld_sep varchar(10);
  declare variable line_sep varchar(10);
  declare variable line varchar(255);
  declare variable end_pos integer;
  declare variable discounts_data blob sub_type 1 segment size 100;
  declare variable i integer;
begin
  select f.FISCAL_DISCOUNTS
  from   DOC_FISCAL_DATA f
  where  f.ID_FISCAL_DATA = :ID_FISCAL_DATA
  into   :discounts_data;

  i = 0;
  fld_sep = f_character(28);
  line_sep = f_character(29);
  while (trim(:discounts_data) <> '') do begin
    end_pos = position(:line_sep, :discounts_data);
    line = substring(:discounts_data from 1 for end_pos);
    discounts_data = substring(:discounts_data from end_pos + 1);
    if (:line <> '') then begin
      FISC_SUM = substring(:line from 1 for position(:fld_sep, :line)-1);
      line = substring(:line from position(:fld_sep, :line)+1);
      FISC_TEXT = substring(:line from 1 for position(:line_sep, :line)-1);
      suspend;
    end
    i= :i + 1;
    if (:i = 4096) then exit; -- Too many cycles, recursion prevents.
  end
end
^

/* Restore proc. body: PAYMENT_DOC_DELETE$DOC */
ALTER PROCEDURE PAYMENT_DOC_DELETE$DOC(ID_PAYMENT_HEAD INTEGER)
 AS
declare variable id_deposit integer;
  declare variable is_dep_payment integer;
  declare variable no_use varchar(255);
  declare variable is_anul integer;
begin
  is_dep_payment = 0;

  for
    select D.ID_DEPOSIT, d.IS_ANUL
    from   DEPOSITS D
    where  D.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
    into   :id_deposit, :is_anul
  do begin
    if (:is_anul = 0) then begin
      execute procedure DEPOSIT_ANUL$INT (:id_deposit, null)
      returning_values :no_use;
    end

    delete from DEPOSIT D
    where  D.ID_DEPOSIT = :id_deposit;

    is_dep_payment = 1;
  end

  if (:is_dep_payment = 0) then
    execute procedure DEPOSIT_REFUND_PAY_ANNUL$INT (:ID_PAYMENT_HEAD);

  delete from PAYMENT_HEAD PH
  where  PH.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;

end
^

/* Restore proc. body: PHONECALL_POST$TC */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Restore proc. body: PHONECALLS_POST_TO_ACCOUNT$TC */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* Restore proc. body: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_OWNER TYPE OF ID,
POST_DATE TYPE OF TDATE,
CURR_ORIG TYPE OF TCURRENCY,
VALUE_ORIG TYPE OF TPRICE,
POST_ON_PMS_ACCOUNT TYPE OF TLOGICAL,
IS_OWNER_INCOME TYPE OF TLOGICAL,
ID_ROOM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  if (:POST_ON_PMS_ACCOUNT = 1) then begin
    execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account, :id_owner,
            :CURR_ORIG, :VALUE_ORIG, :id_service, :is_owner_income, :POST_DATE)
    returning_values  (:new_id_account_post);
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :ID_SERVICE, 1, 0, 1,
            :VALUE_ORIG, :CURR_ORIG, current_date, current_date,
            '', '', :POST_DATE, 'PMS', :ID_ROOM)
    returning_values  :err_code, :err_text, :new_id_account_post;
    if (:err_code <> 0) then exception PMS_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:ID_PMS_EVENT, :NEW_ID_ACCOUNT_POST, :ID_OWNER, 11);
  end
end
^

/* Restore proc. body: POST_SERVICE_FINALIZE$POST */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable description type of TSERVICE_DESCRIPTION;
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
  declare variable post_text varchar(100);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.DESCRIPTION, ts.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :description, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '', :description)
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '', null, :description)
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set    ID_ACCOUNT_POST = :id_acc_post
      where  RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* Restore proc. body: RES_TAR_CALC_FINALIZE$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(ID_TAR_CALC INTEGER,
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
declare variable old_room_price numeric(15,4);
  declare variable old_room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
  declare variable reserv_posting_disabled smallint;
  declare variable postings_disabled smallint;
  declare variable warn_code integer;
  declare variable action_text varchar(255);
  declare variable id_guest integer;
begin
  --  Razpiswa cenata na staia, kakto i price_detailite.

  execute procedure TAR_CALC_EVAL_ALL$INT(:ID_TAR_CALC)
  returning_values  :ERR_CODE, :ERR_TEXT;

  if (:ERR_CODE = 0) then execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

  select iif(si.INFO_VALUE = '1', 1, null)
  from   SYSTEM_INFO_GET('RESERV_POSTINGS_DISABLED') si
  into   :postings_disabled;

  for
    select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, coalesce(:postings_disabled, rd.IS_POSTING_STOPPED),
           coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
           coalesce(max((select first 1 AP.IS_BASE
                         from   GUEST G
                                join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                         where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (it`s possible)
    from   TAR_CALC_INPUT$TMP TI
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
           join TARIFA t on t.ID_TARIFA = rd.ID_RATE
    where  ti.ID_TAR_CALC = :ID_TAR_CALC
    group by 1, 2, 3, 4, 5, 6
    into   :id_reserv_detail, :check_status, :is_posting_stopped,
           :room_currency, :id_hotel, :is_anul, :has_postings
  do begin
    reserv_posting_disabled = iif(:is_posting_stopped = 1 and :has_postings = 0, 1, 0);

    if (:ERR_CODE <> 0) then begin
      -- price calculation error handling  !!!!!
      if (:reserv_posting_disabled = 1) then begin
        -- set price to null, posting is disabled
        update RESERV_DETAIL RD
        set    RD.ROOM_PRICE = null,
               RD.ROOM_CURRENCY = null,
               RD.ROOM_PRICE_DETAILS = null,
               RD.LAST_ID_TAR_CALC = null
        where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
      end else begin
        -- exit on error in price calculation - cannot make valid posts
        EXIT;
      end
    end else begin
      room_price = 0;
      room_price_details = '';
    
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);
  
      if (:reserv_posting_disabled = 0 and ((coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1))) then begin
        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);
      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;
  
        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end
  
      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc,
             rd.ROOM_PRICE_LAST$INT = null,
             rd.ROOM_CURRENCY_LAST$INT = null
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail
      returning old.ROOM_PRICE_LAST$INT, old.ROOM_CURRENCY_LAST$INT
      into :old_room_price, :old_room_currency;

      if ((:old_room_price is distinct from :room_price)
          or (:old_room_currency is distinct from :room_currency) ) then
      begin
        action_text = f_character(29) || formatfloat(:old_room_price, 'F;0.00') || ' ' || coalesce(:old_room_currency, '') || f_character(28) || formatfloat(:room_price, 'F;0.00') || ' ' || coalesce(:room_currency, '');
        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_PRICE_RECALC', :action_text);

        if (:check_status >= 0) then begin
          for
            select g.ID_GUEST
            from   GUEST G
            where  g.ID_RESERV_DETAIL = :id_reserv_detail
            into   :id_guest
          do begin
            execute procedure GUEST_REGISTRATION_UPDATE(:id_guest);
          end
        end
      end
    end
  end

  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;

  if (:ERR_CODE <> 0) then begin
    execute procedure SYSTEM_WARNING_ADD(:ERR_CODE, :ERR_TEXT)
    returning_values :warn_code;
    ERR_CODE = 0;
    ERR_TEXT='';
  end
end
^

/* Restore proc. body: SAFE_OCCUPANCY_MODIFY */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable old_rate_price tprice;
  declare variable old_rate_curr tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';
  DOC_SELECTED = null;

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation
  returning old.rate_price, old.rate_curr
  into :old_rate_price, :old_rate_curr;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  if ((:old_rate_curr <> :currency) or (:old_rate_price <> :price)) then begin
    execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
            :price_description, :id_reserv_detail)
    returning_values (:DOC_SELECTED);
  end

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Restore proc. body: SAFE_OCCUPANCY_NEW */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* Restore proc. body: SALE_DISCOUNTS_APPLICABLE */
ALTER PROCEDURE SALE_DISCOUNTS_APPLICABLE(ID_DOC_HEAD INTEGER)
 RETURNS(ID_SALE_DISCOUNT INTEGER,
DISCOUNTED_VALUE_TYPE VARCHAR(50),
DISCOUNT_CALC_METHOD VARCHAR(50),
DISCOUNT_ORDER INTEGER,
ID_SERVICE INTEGER,
ID_TAX_POLICY INTEGER)
 AS
declare variable id_profile integer;
  declare variable id_hotel integer;
  declare variable id_account integer;
  declare variable discounts_exists smallint;
begin
  discounts_exists = 0;
  select a.ID_ACCOUNT, a.ID_PROFILE, a.ID_HOTEL, a.ID_TAX_POLICY
  from   DOC_HEAD$INT d
         join ACCOUNT A on a.ID_ACCOUNT = d.ID_ACCOUNT
  where  d.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :id_account, :id_profile, :id_hotel, :ID_TAX_POLICY;

  for
    select ad.ID_SALE_DISCOUNT, sd.DISCOUNTED_VALUE_TYPE, sd.DISCOUNT_CALC_METHOD, ad.DISCOUNT_ORDER, sd.ID_SERVICE
    from   ACCOUNT_DISCOUNT ad
           join SALE_DISCOUNT sd on sd.ID_SALE_DISCOUNT = ad.ID_SALE_DISCOUNT and sd.IS_ARCHIVE = 0
    where  ad.ID_ACCOUNT = :id_account
    into   :ID_SALE_DISCOUNT, :DISCOUNTED_VALUE_TYPE, :DISCOUNT_CALC_METHOD, :DISCOUNT_ORDER, :ID_SERVICE
  do begin
    suspend;
    discounts_exists = 1;
  end 

  if (:discounts_exists = 0) then begin
    for
      select pd.ID_SALE_DISCOUNT, sd.DISCOUNTED_VALUE_TYPE, sd.DISCOUNT_CALC_METHOD, pd.DISCOUNT_ORDER, sd.ID_SERVICE
      from   PROFILE_DISCOUNT pd
             join SALE_DISCOUNT sd on sd.ID_SALE_DISCOUNT = pd.ID_SALE_DISCOUNT
      where  pd.ID_PROFILE = :id_profile
             and sd.ID_HOTEL = :id_hotel
             and sd.IS_ARCHIVE = 0
      into   :ID_SALE_DISCOUNT, :DISCOUNTED_VALUE_TYPE, :DISCOUNT_CALC_METHOD, :DISCOUNT_ORDER, :ID_SERVICE
    do begin
      suspend;
    end
  end
end
^

/* Restore proc. body: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* Creating trigger... */
CREATE TRIGGER DOC_FISCAL_DATA_BI FOR DOC_FISCAL_DATA
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.ID_FISCAL_DATA is null) then
    new.ID_FISCAL_DATA = gen_id(GEN_DOC_FISCAL_DATA_ID,1);
end
^


/* Create Views... */

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$ACC for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: GUEST_REROUTE_POSTINGS$INT for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_TRANSFER$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER,
IS_MANUAL_TRANSFER TYPE OF TLOGICAL = 1)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date,
                    iif(:IS_MANUAL_TRANSFER is distinct from 1, 1, 0), :id_target_account)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Alter (ACCOUNT_POSTING_UPDATE) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_ID_TARIFF TYPE OF ID,
IN_ID_ROOM TYPE OF ID,
IN_QTY_POST TYPE OF TQTY,
IN_QTY_FREE TYPE OF TQTY,
IN_PRICE TYPE OF TPRICE,
IN_CURR TYPE OF TCURRENCY,
IN_RATE TYPE OF TRATE,
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
IN_DESCRIPTION TYPE OF TSERVICE_DESCRIPTION = null)
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date, 0, null, :IN_DESCRIPTION)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    action_text = f_character(29) || :action_text
                  || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                  || f_character(28) || :log_old_value
                  || f_character(28) || :log_new_value
                  || f_character(28) || replace(:IN_CHANGED_TEXT, 'MANUAL', '');
    execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
  end

end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_MODIFY$PROFILE for: ACCOUNT_SALE_NUMBER_SET */
ALTER PROCEDURE ACCOUNT_MODIFY$PROFILE(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_CONTRAGENT INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_DOC_UPDATE$INT for: ACCOUNT_SALE_NUMBER_SET */
ALTER PROCEDURE ACCOUNT_POSTING_DOC_UPDATE$INT(DH_DBKEY /* TYPE OF TDB_KEY */ CHAR(8))
 RETURNS(WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_SET_ARCHIVE_STATUS for: ACCOUNT_SALE_NUMBER_SET */
ALTER PROCEDURE ACCOUNT_SET_ARCHIVE_STATUS(ID_ACCOUNT INTEGER,
IS_ARCHIVE SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_ACCOUNT_CREATE$INT for: ACCOUNT_SALE_NUMBER_SET */
ALTER PROCEDURE RES_ACCOUNT_CREATE$INT(ID_PROFILE INTEGER,
ID_ACC_TEMPLATE INTEGER,
ACC_CURRENCY CHAR(3),
ID_RESERV_DETAIL INTEGER,
IS_BASE_ENABLE SMALLINT = 1,
IS_EXTRA_ENABLE SMALLINT = 1)
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN$RSV for: ACCOUNT_SALE_NUMBER_SET */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTS$INT for: ACCOUNT_SALE_NUMBER_SET */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_SALE_NUMBER_SET) */
ALTER PROCEDURE ACCOUNT_SALE_NUMBER_SET(ID_ACCOUNT TYPE OF ID,
OVERRIDE_EXISTING TYPE OF TLOGICAL = 0)
 RETURNS(ID_SALE_NUM TYPE OF ID)
 AS
declare variable dbkey char(8);
  declare variable unique_sales_number varchar(50);
  declare variable hp_type varchar(50);
  declare variable is_archive integer;
  declare variable id_hotel integer;
begin
  select a.RDB$DB_KEY, a.ID_SALE_NUM, p.HOUSE_TYPE, a.IS_ARCHIVE, a.ID_HOTEL
  from   ACCOUNT A
         left outer join PROFILE_HOUSE p on p.ID_PROFILE = a.ID_PROFILE
  where  a.ID_ACCOUNT = :ID_ACCOUNT
  into   :dbkey, :id_sale_num, :hp_type, :is_archive, :id_hotel;

  if (:dbkey is null) then exit;  -- inexistent

  if ((:id_sale_num is null) or (:OVERRIDE_EXISTING is not distinct from 1)) then begin
    if (:is_archive = 1) then
      exception ACCOUNT_EXCEPTION '-712';

    if (coalesce(:hp_type, '') in ('hptExternalRevenue', 'hptComplimentary')) then begin
      unique_sales_number = '_' || :hp_type || :ID_ACCOUNT;
    end else begin
      execute procedure UNIQUE_SALES_NUMBER_GEN(:id_hotel)
      returning_values (:unique_sales_number);
    end

    insert into SALE_NUM (UNIQUE_SALES_NUMBER)
    values (:unique_sales_number)
    returning id_sale_num into :id_sale_num;
  
    update ACCOUNT A
    set    a.ID_SALE_NUM = :id_sale_num
    where  a.RDB$DB_KEY = :dbkey;
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_MODIFY$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE ACCOUNT_MODIFY$INT(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL /* TYPE OF ID_REF */ INTEGER,
IS_PMS_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PAYMENT_STORNO$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE PAYMENT_STORNO$INT(ID_PAYMENT_HEAD INTEGER,
ID_ACCOUNT INTEGER,
NEW_ID_DOC_HEAD INTEGER,
STORNO_AMOUNT NUMERIC(15,4),
DESCRIPTION VARCHAR(100),
TARGET_DOC_AMOUNT NUMERIC(15,4))
 RETURNS(ID_STORNO_PAYMENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_GET_ACCOUNT$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE PROFILE_GET_ACCOUNT$INT(ID_PROFILE INTEGER,
ID_RESERV_DETAIL INTEGER,
ACCOUNT_CURR VARCHAR(3),
ID_ACC_TEMPLATE INTEGER,
IS_BASE_ENABLE SMALLINT = 1,
IS_EXTRA_ENABLE SMALLINT = 1)
 RETURNS(ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_SET_ARCHIVE$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE PROFILE_SET_ARCHIVE$INT(P_DBKEY CHAR(8),
ARCHIVE_STATUS SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_ACCOUNTS_RECIEVE$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE RES_ACCOUNTS_RECIEVE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
ID_AGENT_ACCOUNT_RULE INTEGER,
ID_BASE_ACCOUNT_PROFILE INTEGER,
ID_EXTRA_ACCOUNT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ID_ACC_TEMPLATE_PERSON INTEGER,
IS_SEPARATE_ACCOUNTS SMALLINT)
 RETURNS(NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_ARCHIVATE_ACCOUNTS$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE RES_ARCHIVATE_ACCOUNTS$INT(ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACC_ARCHIVE$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE RES_SAVE_ACC_ARCHIVE$INT(ACCOUNTS_FOR_ARCHIVE VARCHAR(2000),
ID_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTS_FINALIZE$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE RES_SAVE_ACCOUNTS_FINALIZE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_SET_ARCHIVE_STATUS) */
ALTER PROCEDURE ACCOUNT_SET_ARCHIVE_STATUS(ID_ACCOUNT INTEGER,
IS_ARCHIVE SMALLINT)
 AS
declare variable post_sum numeric (15,2);
  declare variable dep_sum numeric (15,2);
  declare variable open_charges integer;
  declare variable old_is_archive integer;
  declare variable id_profile integer;
  declare variable id_hotel integer;
  declare variable p_dbkey char(8);
  declare variable acc_dbkey char(8);
  declare variable archived_date date;
  declare variable is_used integer;
  declare variable action_text varchar(255);
  declare variable account_name varchar(50);
  declare variable id_reserv_detail integer;
  declare variable id_sale_num integer;
begin

  select A.RDB$DB_KEY, A.IS_ARCHIVE, A.ID_PROFILE, A.ID_HOTEL, A.ACCOUNT_NAME,
         a.ID_RESERV_DETAIL, a.ID_SALE_NUM
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :acc_dbkey, :old_is_archive, :id_profile, :id_hotel, :account_name,
         :id_reserv_detail, :id_sale_num;
  /* --------------------------------------- */
  if (:old_is_archive = :IS_ARCHIVE) then exit;
  /* --------------------------------------- */
  if (:IS_ARCHIVE = 0) then begin
    -- unarchive
    update ACCOUNT A
    set    A.IS_ARCHIVE = 0
    where  A.RDB$DB_KEY = :acc_dbkey;

    p_dbkey = null;
    select P.RDB$DB_KEY
    from   PROFILE P
    where  P.ID_PROFILE = :id_profile
           and p.IS_ARCHIVE = 1
    into   :p_dbkey;

    if (:p_dbkey is not null) then begin
      /* restore profile active status */
      execute procedure PROFILE_SET_ARCHIVE$INT (:p_dbkey, 0);
    end

    if (:id_reserv_detail is not null and :id_sale_num is null) then begin
      if (exists (select rd.ID_RESERV_DETAIL
                  from   RESERV_DETAIL rd
                  where  rd.ID_RESERV_DETAIL = :id_reserv_detail
                         and rd.CHECK_STATUS = 0)) then
      begin
        execute procedure ACCOUNT_SALE_NUMBER_SET(:ID_ACCOUNT)
        returning_values (:id_sale_num);

        when any do begin end -- nothing
      end
    end
  end else begin
    execute procedure ACCOUNT_USE_CHECK$INT (:ID_ACCOUNT)
    returning_values (:is_used);

    if (:is_used = 1) then begin
      select AB.POST_VALUE, AB.DEP_VALUE, AB.OPEN_CHARGES
      from   ACCOUNT_BALANCE$INT(:id_account) AB
      into   :post_sum, :dep_sum, :open_charges;
  
      if ((:post_sum <> 0) or (:open_charges = 1)) then
        exception ACCOUNT_EXCEPTION '-44' || f_character(31) || :ID_ACCOUNT;

      if (:dep_sum <> 0) then
        exception ACCOUNT_EXCEPTION '-40' || f_character(31) || :ID_ACCOUNT;
    
      execute procedure SYSTEM_DATE_GET (:id_hotel)
      returning_values (:archived_date);
    end else begin
      archived_date = null;  /* mark account as unused */
    end

    update ACCOUNT A
    set    A.IS_ARCHIVE = 1,
           A.ARCHIVED_DATE = :archived_date
    where  A.RDB$DB_KEY = :acc_dbkey;

    action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'ARCHIVE_ACCOUNT', :action_text);
  end
end
^

/* Alter (DEPOSIT_DOCUMENT_INITIALIZE$DOC) */
ALTER PROCEDURE DEPOSIT_DOCUMENT_INITIALIZE$DOC(ID_PAYMENT_HEAD TYPE OF ID,
ID_BILLING_SERVICE TYPE OF ID)
 RETURNS(ID_DOC_HEAD TYPE OF ID,
ID_HOTEL TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable id_dep_doc integer;
  declare variable doc_selected integer;
  declare variable payment_date date;
  declare variable system_date date;
  declare variable require_archive_confirmation smallint;
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_BILLING');

  id_dep_doc = null;

  select p.ID_DOC_HEAD, p.ID_ACCOUNT, p.PAYMENT_DATE, a.ID_HOTEL
  from   PAYMENT_HEAD P
         join DEPOSIT d on d.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
         join ACCOUNT a on a.ID_ACCOUNT = p.ID_ACCOUNT
  where  p.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
         and p.IS_ANUL = 0
  into   :id_dep_doc, :id_account, :payment_date, :id_hotel;

  if (:id_account is null) then
    exception DOCUMENT_EXCEPTION '-355';

  if (:id_dep_doc is not null) then
    exception DOCUMENT_EXCEPTION '-364';

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :system_date;

  if (:payment_date < :system_date) then
    exception DOCUMENT_EXCEPTION '-399';

  doc_selected = gen_id(DOC_SELECTED_GEN, 1);

  update DEPOSIT P
  set    p.DOC_SELECTED = :doc_selected,
         p.ID_BILLING_SERVICE = :ID_BILLING_SERVICE
  where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;

  execute procedure DOCUMENT_INITIALIZE$DOC (:ID_ACCOUNT, :doc_selected)
  returning_values  (:ID_DOC_HEAD, :ID_HOTEL, :WARN_CODE, :REQUIRE_ARCHIVE_CONFIRMATION);
end
^

/* Alter (DOCUMENT_ADD_DISCOUNTS$INT) */
ALTER PROCEDURE DOCUMENT_ADD_DISCOUNTS$INT(ID_DOC_HEAD TYPE OF ID,
ID_ACCOUNT TYPE OF ID)
 AS
declare variable sys_date date;
  declare variable doc_round_to numeric(15,4);
  declare variable nat_curr_round_to numeric(15,4);
  declare variable sec_curr_round_to numeric(15,4);
  declare variable id_doc_line integer;
  declare variable id_service integer;
  declare variable service_name varchar(50);
  declare variable single_value numeric(15,4);
  declare variable nat_gross_value numeric(15,4);
  declare variable sec_curr_gross_value numeric(15,4);
  declare variable id_hotel integer;
  declare variable df_dbkey char(8);
  declare variable discount_calc_method varchar(50);
  declare variable footer_value double precision;
  declare variable id_sale_taxation integer;
  declare variable discount_value numeric(15,4);
  declare variable doc_curr varchar(3);
  declare variable sec_curr varchar(3);
  declare variable doc_curr_rate numeric(15,6);
  declare variable no_use varchar(255);
  declare variable taxes_ids varchar(100);
  declare variable discount_cnt integer;
begin
  /* GET SOME SETTINGS VALUES *************************************************/
  select A.ID_HOTEL
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :id_hotel;

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values :sys_date;

  execute procedure DOCUMENT_CURRS_GET$INT (:ID_DOC_HEAD)
  returning_values (:doc_curr, :doc_curr_rate, :doc_round_to, :no_use, :nat_curr_round_to,
                    :sec_curr, :no_use, :sec_curr_round_to);
  /* CALC DOCUMENT DISCOUNTS ******************************************************/
  execute procedure DOCUMENT_DISCOUNTS_INIT$INT (:ID_DOC_HEAD)
  returning_values :discount_cnt;
  if (:discount_cnt = 0) then EXIT;

  execute procedure DISCOUNTABLE_VALUE_CALC$INT(:ID_DOC_HEAD);

  execute procedure DOCUMENT_CALC_DISCOUNTS$INT (:ID_DOC_HEAD, :doc_curr, :sec_curr);

  for
    select df.RDB$DB_KEY, df.FOOTER_VALUE, sd.DISCOUNT_CALC_METHOD, t.ID_SALE_TAXATION, t.TAXES_IDS,
           sd.ID_SERVICE, s.SERVICE_NAME, sd.DISCOUNT_VALUE, df.SECOND_CURR_DISCOUNT_VALUE
    from   DOC_FOOTER DF
           join SALE_DISCOUNT SD on sd.ID_SALE_DISCOUNT = df.ID_TAX
           join SERVICES s on s.ID_SERVICE = sd.ID_SERVICE
           left join SALE_DISCOUNT_CALC$TMP t on t.ID_DOC_HEAD = df.ID_DOC_HEAD and t.ID_DOC_DISCOUNT = df.ID
    where  DF.ID_DOC_HEAD = :ID_DOC_HEAD
           and sd.DISCOUNTED_VALUE_TYPE = 'taxableValue'
    into   :df_dbkey, :footer_value, :discount_calc_method, :id_sale_taxation, :taxes_ids,
           :id_service, :service_name, :discount_value, :sec_curr_gross_value
  do begin
    single_value = round_f(:footer_value, :doc_round_to);
    id_doc_line = null;

    nat_gross_value = round_f(:footer_value * :doc_curr_rate, :nat_curr_round_to);
    sec_curr_gross_value = round_f(:sec_curr_gross_value, :sec_curr_round_to);

    if (:id_sale_taxation is null) then begin
      execute procedure DISCOUNT_TAXATION_GET$INT(:taxes_ids)
      returning_values (:id_sale_taxation);
    end

    execute procedure DOCUMENT_LINE_ADD$INT (
            :ID_DOC_HEAD, :id_service, :id_sale_taxation,
            :service_name || ' ' || iif(:discount_calc_method = 'fixedValue', '', ' ' || formatfloat(:discount_value, '0.00') ||' %'),
            -1, :sys_date, :sys_date, :sys_date, null,
            1, :footer_value, :single_value, :doc_round_to, :nat_gross_value, :nat_curr_round_to,
            :sec_curr, :sec_curr_gross_value, :sec_curr_round_to, iif(:single_value >= 0, 2, 3),
            0, null)
    returning_values (:id_doc_line, :no_use, :no_use, :no_use);

    update DOC_FOOTER df
    set    df.ID_DOC_LINE = :id_doc_line
    where  df.RDB$DB_KEY = :df_dbkey;
  end 

end
^

/* Alter (DOCUMENT_ANUL$DOC) */
ALTER PROCEDURE DOCUMENT_ANUL$DOC(ID_DOC_HEAD INTEGER,
ANUL_REASON VARCHAR(100),
MAKE_ANNUL_REPORT SMALLINT)
 AS
/**/
  declare variable id_account  integer;
  declare variable id_payment_head integer;
  declare variable for_deposit integer;
  declare variable id_base_doc integer;
  declare variable is_anul integer;
  declare variable dh_dbkey char(8);
  declare variable id_annul_protocol_num integer;
  declare variable num integer;
  declare variable doc_num varchar(20);
  declare variable system_date date;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable doc_date date;
  declare variable id_system_log integer;
  declare variable id_hotel integer;
  declare variable is_storno_doc integer;
  declare variable no_use varchar(255);
  declare variable doc_sub_type integer;
  declare variable fisc_status smallint;
begin
  select H.RDB$DB_KEY, H.ID_ACCOUNT, H.FOR_DEPOSIT, H.ID_BASE_DOC, H.IS_ANUL, A.ID_HOTEL,
         A.ID_RESERV_DETAIL, T.ID_ANNUL_DOC_NUM, h.DOC_DATE, H.IS_STORNO, h.DOC_SUB_TYPE, dc.FISC_STATUS
  from   DOC_HEAD$INT H
         join DOC_COMPLETION dc on dc.ID_DOC_HEAD = h.ID_DOC_HEAD
         join DOC_TYPE T on H.ID_DOC_TYPE = T.ID_DOC_TYPE
         join DOC_TYPE_INV DTI on DTI.ID_DOC_TYPE = T.ID_DOC_TYPE
         join ACCOUNT A on A.ID_ACCOUNT = H.ID_ACCOUNT
  where  H.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dh_dbkey, :id_account, :for_deposit, :id_base_doc, :is_anul, :id_hotel,
         :id_reserv_detail, :id_annul_protocol_num, :doc_date, :is_storno_doc, :doc_sub_type, :fisc_status;

  if (:is_anul = 1) then
    exception DOCUMENT_ANNUL_EXCEPTION '-352'; --'Document is already annul';

  if (exists (select D.ID_DOC
              from   DOC_HEAD D
              where  D.ID_BASE_DOC = :ID_BASE_DOC
                     and D.ID_DOC > :ID_DOC_HEAD
                     and D.IS_ANUL = 0))
  then exception DOCUMENT_ANNUL_EXCEPTION '-314';

  if (exists (select D.ID_DEPOSIT
              from   DEPOSIT_DEDUCT DD
                     join DEPOSITS d on d.ID_DEPOSIT = dd.ID_DEPOSIT
              where  DD.ID_DOC_USED = :ID_DOC_HEAD
                     and D.RECEIVED_AMOUNT = 0))
  then exception DOCUMENT_ANNUL_EXCEPTION '-315';

  execute procedure SYSTEM_DATE_GET(:ID_HOTEL)
  returning_values  :system_date;

  if (:DOC_DATE < :SYSTEM_DATE) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_PREV_DATE');
  end
  if (:doc_sub_type > 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_CORR_DOC');
  end
  /* unarchive account and set as credit account, for shecked out bookings only */
  execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:ID_ACCOUNT, 0);

  if (:ID_RESERV_DETAIL is not null) then begin
    select RD.CHECK_STATUS
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :check_status;

    if (:check_status = 1) then begin
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, null, 1);
    end
  end
  /* MARK THE DOCUMENT AS ANUL - before posting and payment updates */
  update DOC_HEAD$INT DH
  set    DH.IS_ANUL = 1
  where  DH.RDB$DB_KEY = :dh_dbkey;

  update DOC_COMPLETION Dc
  set    Dc.IS_EFAKTURA_EXPORTED = 0
  where  Dc.ID_DOC_HEAD = :ID_DOC_HEAD;


  if (:is_storno_doc = 1) then begin
    /* annul storno doc */
    update DOC_HEAD$INT BD
    set    BD.IS_STORNED = 0
    where  BD.ID_BASE_DOC = :id_base_doc
           and BD.IS_STORNED = 1;
  end
  /* RELEASE ACCOUNT_POSTS */
  if (:for_deposit = 0) then
    execute procedure ACCOUNT_POSTING_DOC_UPDATE$INT (:DH_DBKEY)
    returning_values (:no_use);

  /* PAYMENTS REFLECTION */
  for
    select PH.ID_PAYMENT_HEAD
    from   PAYMENT_HEAD PH
           join DOC_TYPE_PAY dt on dt.ID_DOC_TYPE = ph.ID_DOC_TYPE
    where  PH.ID_DOC_HEAD = :ID_DOC_HEAD
           and PH.IS_STORNED = 0
    into   :ID_PAYMENT_HEAD
  do begin

    execute procedure PAYMENT_ANUL$INT (:ID_PAYMENT_HEAD, :ANUL_REASON);
  end

  /* ANNUL_PROTOCOL creating section */
  NUM = null;
  DOC_NUM = null;
  if (:MAKE_ANNUL_REPORT = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_WITH_PROT');

    if (:ID_ANNUL_PROTOCOL_NUM is null) then exception DOCUMENT_ANNUL_EXCEPTION '-345';

    execute procedure SYSTEM_GEN_NUM ('ANNUL_PROT', :ID_ANNUL_PROTOCOL_NUM)
    returning_values  (:num, :doc_num);
  end
  /* log annul event */
  execute procedure SYSTEM_EVENT_LOG$INT ('DOCUMENT', :ID_DOC_HEAD, 'ANNUL', f_character(29)||:ANUL_REASON)
  returning_values  :id_system_log;

  insert into DOC_ANNULMENT (ID_DOC_HEAD, ANNULMENT_DATE, ID_PROT_DOC_NUM, PROT_NUM, PROT_DOC_NUM, ID_LOG_EVENT)
  values (:ID_DOC_HEAD, :SYSTEM_DATE, :ID_ANNUL_PROTOCOL_NUM, :NUM, :DOC_NUM, :ID_SYSTEM_LOG);
  /* reflect annul date on doc release dates */
  if (:DOC_DATE < :SYSTEM_DATE) then begin
    insert into DOC_RELEASE_DATE (ID_DOC_HEAD, RELEASE_DATE, VALUE_CORR_INDEX)
    values (:ID_DOC_HEAD, :SYSTEM_DATE, -1);
  end else begin
    update DOC_RELEASE_DATE RD
    set    RD.VALUE_CORR_INDEX = 0
    where  RD.ID_DOC_HEAD = :ID_DOC_HEAD
           and RD.RELEASE_DATE = :DOC_DATE;
  end
  /* reflect on AR module */
  execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT (:DH_DBKEY, :ANUL_REASON);
  /* reflect on client loyalty module */
  execute procedure DOCUMENT_BONUSPOINTS_VOID$CL (:ID_DOC_HEAD);

  execute procedure FISCAL_DEVICE_STATUS_CHECK(:id_hotel, iif(:fisc_status = 2, 1, 0))
  returning_values (:no_use);
end
^

/* Alter (DOCUMENT_SALE_NUMBER_SET) */
ALTER PROCEDURE DOCUMENT_SALE_NUMBER_SET(ID_DOC_HEAD TYPE OF ID,
CREATED_AT TYPE OF TDATETIME = current_timestamp)
 RETURNS(ID_SALE_NUM TYPE OF ID)
 AS
declare variable unique_sales_number varchar(50);
declare variable id_hotel integer;
begin
  select d.ID_SALE_NUM, a.ID_HOTEL
  from   DOC_HEAD D
         join ACCOUNT a on a.ID_ACCOUNT = d.ID_ACCOUNT
  where  d.ID_DOC = :ID_DOC_HEAD
  into   :id_sale_num, :id_hotel;

  if (:id_sale_num is null) then begin
    execute procedure UNIQUE_SALES_NUMBER_GEN(:id_hotel)
    returning_values (:UNIQUE_SALES_NUMBER);

    insert into SALE_NUM (UNIQUE_SALES_NUMBER, CREATED_AT)
    values (:UNIQUE_SALES_NUMBER, :CREATED_AT)
    returning id_sale_num into :id_sale_num;
  
    update DOC_COMPLETION dc
    set    dc.ID_SALE_NUM = :id_sale_num
    where  dc.ID_DOC_HEAD = :ID_DOC_HEAD;
  end
end
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_REFUND$DOC for: DOCUMENT_VALIDATE$DOC */
ALTER PROCEDURE DEPOSIT_REFUND$DOC(ID_DEPOSIT INTEGER,
REFUND_AMOUNT NUMERIC(15,4),
REFUND_CURRENCY VARCHAR(3),
ID_PAY_DOC_TYPE INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_REFUND_PAYMENT INTEGER,
ID_STORNO_DOC INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_VALIDATE$DOC) */
ALTER PROCEDURE DOCUMENT_VALIDATE$DOC(ID_DOC_HEAD TYPE OF ID_REF,
ARCHIVE_ACCOUNT TYPE OF TLOGICAL = 0)
 RETURNS(FIRM_DATA TYPE OF TNOTE_BLOB,
WARN_CODE TYPE OF TRANGE,
NEW_DOC_DATE TYPE OF TDATE)
 AS
declare variable no_use varchar(255);
  declare variable doc_value numeric(15,4);
  declare variable rest_value numeric(15,4);
  declare variable lines_value numeric(15,4);
  declare variable lines_wot_vat numeric(15,4);
  declare variable tax_value numeric(15,4);
  declare variable taxable_value numeric(15,4);
  declare variable round_to numeric(15,4);
  declare variable id_doc_contragent integer;
  declare variable id_doc_supplier integer;
  declare variable for_deposit integer;
  declare variable id_profile integer;
  declare variable dbkey char(8);
  declare variable id_contragent integer;
  declare variable ident_no varchar(30) ;
  declare variable action_text varchar(255);
  declare variable doc_currency varchar(3);
  declare variable is_juridical_person smallint;
  declare variable vat_ident_no varchar(30);
  declare variable id_doc_type integer;
  declare variable doc_sub_type integer;
  declare variable required_ident_no smallint;
  declare variable required_vat_no smallint;
  declare variable required_egn smallint;
  declare variable required_recipient_name smallint;
  declare variable lines_count integer;
  declare variable recipient_name varchar(100);
  declare variable id_doc_completed integer;
  declare variable action_code varchar(50);
  declare variable id_sale_num integer;
  declare variable id_acc_sale_num integer;
  declare variable id_account integer;
  declare variable fiscal_device_id varchar(10);
  declare variable created_at timestamp;
  declare variable id_hotel integer;
  declare variable fisc_status integer;
begin

  select D.RDB$DB_KEY, D.DOC_VALUE_A, C.ROUND_TO, a.ID_HOTEL,
         D.ID_DOC_CONTRAGENT, D.ID_DOC_SUPPLIER, D.FOR_DEPOSIT,
         A.ID_PROFILE, D.DOC_CURRENCY, D.TAXABLE_VALUE, d.ID_DOC_TYPE, d.DOC_SUB_TYPE,
         dc.ID_DOC_HEAD, coalesce(ds."__FIRM_DATA", ds.COMPANY_IDENT_NUM), dc.ID_SALE_NUM, a.ID_SALE_NUM, d.DATETIME_CREATED, a.ID_ACCOUNT
  from   DOC_HEAD$INT D
         join CURRS C on C.CURR = D.DOC_CURRENCY
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         left outer join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
         left outer join DOC_SUPPLIER ds on ds.ID_DOC_SUPPLIER = d.ID_DOC_SUPPLIER
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dbkey, :doc_value, :round_to, :id_hotel,
         :id_doc_contragent, :id_doc_supplier, :for_deposit,
         :id_profile, :doc_currency, :taxable_value, :id_doc_type, :doc_sub_type,
         :id_doc_completed, :FIRM_DATA, :id_sale_num, :id_acc_sale_num, :created_at, :id_account;

  if (:id_doc_contragent is null) then
    exception DOCUMENT_EXCEPTION '-356'; --'Contragent is not set!';

  if (:id_doc_supplier is null) then
    exception DOCUMENT_EXCEPTION '-357'; --'Supplier is not set!';

  select sum(DT.TAX_VALUE)
  from   DOC_TAXES DT
  where  DT.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :tax_value;

  /*if (round_f(:doc_value - :total_value, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Total value is not correct!';
  */
  select round_f(sum(DL.SINGLE_VALUE * DL.QTY_POST), :round_to),
         round_f(sum(DL.WOT_VAT), :round_to),
         count(*)
  from   DOC_LINE DL
  where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :lines_value, :lines_wot_vat, :lines_count;
 
  if (:lines_count = 0) then
    exception INTERNAL_DOC_EXCEPTION 'Document is empty! Not exists sale lines!';

  if (round_f(:doc_value - :lines_value, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines total value is not correct!' || :doc_value ||  ' / ' || :lines_value || ' ; '|| (:doc_value - :tax_value) ||  ' / ' || :lines_wot_vat;

  if (round_f(:doc_value - :tax_value - :lines_wot_vat, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines wot tax value is not correct!';

  if (round_f(abs(:lines_wot_vat) - abs(:taxable_value), :round_to) < 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines wot tax value is less than total taxable value!';

  if (:id_doc_completed is not null) then begin
    select DV.PAYABLE_VALUE
    from   DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, null) DV
    into   :rest_value;
  
    if (round_f(:rest_value, :round_to) <> 0) then
      exception DOCUMENT_EXCEPTION '-371'; --'Insufficient amount of payments !';
  end

  /* Validate contragent data */
  select dt.REQUIRED_IDENT_NO, dt.REQUIRED_VAT_NO, dt.REQUIRED_EGN, dt.REQUIRED_RECIPIENT_NAME
  from   DOC_TYPE_INV DT
  where  dt.ID_DOC_TYPE = :id_doc_type
  into   :required_ident_no, :required_vat_no, :required_egn, :required_recipient_name;

  select dc.ID_CONTRAGENT, dc.IS_JURIDICAL_PERSON,
         trim(coalesce(dc.IDENT_NO, '')), trim(coalesce(dc.VAT_REG_NUM, '')),
         trim(coalesce(dc.RECIPIENT_NAME, ''))
  from   DOC_CONTRAGENT dc
  where  dc.ID_DOC_CONTRAGENT = :id_doc_contragent
  into   :id_contragent, :is_juridical_person, :ident_no, :vat_ident_no, :recipient_name;

  if (:doc_sub_type = 0 and :required_ident_no = 1 and :is_juridical_person = 1 and :ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-324'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_egn = 1 and :is_juridical_person = 0 and :ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-324'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_vat_no = 1 and :is_juridical_person = 1 and :vat_ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-326'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_recipient_name = 1 and :recipient_name = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-327'; --'Recipient_name is empty.';
  /*if (:post_address = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-325'; --'Contragent address is empty.';
  /* save contragent link for profile */
  if (:id_contragent is not null) then begin
    update PROFILE P
    set    P.ID_DEF_CONTRAGENT = :id_contragent
    where  P.ID_PROFILE = :id_profile
           and P.ID_DEF_CONTRAGENT is null;
  end
  /*  */
  execute procedure DOCUMENT_SET_NUMBER$INT (:dbkey)
  returning_values (:no_use, :no_use);
  /*  */
  if (:id_doc_completed is not null) then begin
    execute procedure DOC_INIT_FISCAL_STATUS$INT(:ID_DOC_HEAD)
    returning_values :fisc_status;
    /*  */
    execute procedure FISCAL_DEVICE_STATUS_CHECK(:id_hotel, :fisc_status)
    returning_values (:fiscal_device_id);

    if (:for_deposit = 0) then begin
      /* update account posts */
      execute procedure ACCOUNT_POSTING_DOC_UPDATE$INT (:dbkey)
      returning_values :WARN_CODE;
    end

    execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT (:dbkey);
    /* ... */
    execute procedure DOCUMENT_BONUSPOINTS_APPLY$CL (:ID_DOC_HEAD);
    /* ... */
  end

  if (:id_doc_completed is not null and :id_sale_num is null) then begin
    if (not exists (select ap.ID_ACCOUNT_POST
                    from   ACCOUNT_POST Ap
                    where  ap.ID_ACCOUNT = :id_account
                           and ap.ac in ('00', '10'))) then
    begin
      update DOC_COMPLETION c
      set    c.ID_SALE_NUM = :id_acc_sale_num
      where  c.ID_DOC_HEAD = :ID_DOC_HEAD;

      update ACCOUNT a
      set    a.ID_SALE_NUM = null
      where  a.ID_ACCOUNT = :id_account;
      id_acc_sale_num = null;
    end else begin
      execute procedure DOCUMENT_SALE_NUMBER_SET(:ID_DOC_HEAD, :created_at)
      returning_values (:id_sale_num);
    end
  end

  execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, coalesce(:ARCHIVE_ACCOUNT, 0));

  if (:ARCHIVE_ACCOUNT is distinct from 1 and :id_acc_sale_num is null) then begin
    execute procedure ACCOUNT_SALE_NUMBER_SET(:id_account)
    returning_values (:id_acc_sale_num);
  end
  /*  */
  action_text = f_character(29) || formatfloat(:doc_value, 'F;0.00') || ' ' || :doc_currency;
  action_code = iif(:id_doc_completed is null,  'PROFORMA_CREATE', 'CREATE');
  execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :ID_DOC_HEAD, :action_code, :action_text);

  select cast('31.12.1899' as date) + count(d.ID_DOC_HEAD)
  from   DOC_HEAD$INT d
  where  d.DOC_DATE is not null
  into   :NEW_DOC_DATE;
end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_POST_TO_FRONT_ONLINE for: EAI_EXT_POST_TO_MH_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_EXT_POST_TO_MH_FRONT_ONLINE) */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:ID_ACCOUNT_POST, :SERVICE_CODE, null, null);

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Alter (EAI_EXT_SERVICE_POST) */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:ID_ACCOUNT_POST, :SERVICE_EXT_CODE, null, null);

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ADD for: EAI_POS_POSTING_ADD$P2E */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_POS_POSTING_ADD$P2E) */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30),
UNIQUE_SALES_NUMBER VARCHAR(30) = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable my_post_text varchar(255);
  declare variable my_resource_text varchar(255);
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
  declare variable id_account_post integer;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  my_post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  my_resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  my_post_text = substring(:my_post_text from 1 for 100);
  my_resource_text = substring(:my_resource_text from 1 for 49);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code, '')
    returning_values  :err_code, :err_text, :out_id_account, :id_account_post;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code)
    returning_values  :err_code, :err_text, :id_account_post;
    out_id_account = :in_id_account;
  end

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:id_account_post, :post_short_code, :IN_POS_USER, :IN_DATETIME);

  if (:UNIQUE_SALES_NUMBER is null and :IN_ID_SMETKA = 'END_WORK') then
    UNIQUE_SALES_NUMBER = 'END_WORK';

  insert into ACCOUNT_POST_POS_TRANSFER (ID_ACCOUNT_POST, UNIQUE_SALES_NUMBER, POS_ID_SMETKA, POS_SMETKA_NUM,
         POS_SMETKA_DATE, POS_OBJECT_NAME, TAG_VALUE, TAG_NAME, TRANSFER_VALUE)
  values (:id_account_post, :UNIQUE_SALES_NUMBER, nullif(:IN_ID_SMETKA, 'END_WORK'), :IN_SMETKA_NUM,
         :IN_DATE_SMETKA, :IN_OBJ_NAME, :IN_SERVICE_TAG, :IN_SERVICE_NAME, :IN_PRICE);
end
^

/* Alter (EAI_POS_POSTING_DET_ADD$P2E) */
ALTER PROCEDURE EAI_POS_POSTING_DET_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_AMOUNT NUMERIC(15,2),
IN_QTY NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30),
IN_SERVICE_DESCRIPTION VARCHAR(50),
UNIQUE_SALES_NUMBER VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable post_text varchar(255);
  declare variable resource_text varchar(255);
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
  declare variable id_account_post integer;
  declare variable price type of TPRICE;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  post_text = substring(:post_text from 1 for 100);
  resource_text = substring(:resource_text from 1 for 49);

  IN_QTY = coalesce(nullif(:IN_QTY, 0), 1);
  price = cast(:IN_AMOUNT/:IN_QTY as type of TPRICE);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, :in_qty, 0, 1, :price, :nation_curr,
      current_timestamp, current_timestamp, :post_text, :resource_text, null, :post_short_code, '', :IN_SERVICE_DESCRIPTION)
    returning_values  :err_code, :err_text, :out_id_account, :id_account_post;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, :IN_QTY, 0, 1, :price, :nation_curr,
      current_timestamp, current_timestamp, :post_text, :resource_text, null, :post_short_code, null, :IN_SERVICE_DESCRIPTION)
    returning_values  :err_code, :err_text, :id_account_post;
    out_id_account = :in_id_account;
  end

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:id_account_post, :post_short_code, :IN_POS_USER, :IN_DATETIME);

  if (:UNIQUE_SALES_NUMBER is null and :IN_ID_SMETKA = 'END_WORK') then
    UNIQUE_SALES_NUMBER = 'END_WORK';

  insert into ACCOUNT_POST_POS_TRANSFER (ID_ACCOUNT_POST, UNIQUE_SALES_NUMBER, POS_ID_SMETKA, POS_SMETKA_NUM,
         POS_SMETKA_DATE, POS_OBJECT_NAME, TAG_VALUE, TAG_NAME, TRANSFER_VALUE)
  values (:id_account_post, :UNIQUE_SALES_NUMBER, nullif(:IN_ID_SMETKA, 'END_WORK'), :IN_SMETKA_NUM,
         :IN_DATE_SMETKA, :IN_OBJ_NAME, :IN_SERVICE_TAG, :IN_SERVICE_NAME, :IN_AMOUNT);
 
end
^

/* Alter (EAI_TELECOUNT_TRANSFER) */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* Alter (GUEST_REROUTE_POSTINGS$INT) */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable ap_dbkey char(8);
  declare variable is_packet_post integer;
  declare variable packet_option varchar(50);
  declare variable id_target_account integer;
  declare variable id_current_account integer;
begin
  update GUEST G
  set    G.ID_BASE_ACCOUNT = :ID_BASE_ACCOUNT,
         G.ID_ACCOUNT = :ID_EXTRA_ACCOUNT
  where  G.ID_GUEST = :ID_GUEST;

  for
    select AP.RDB$DB_KEY, iif(AP.ID_MASTER_ADDINS_ACC_POST > 0, 1, 0), S.VAUCHER_PACKET,
           ap.ID_ACCOUNT
    from   ACCOUNT_POST AP
           join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
    where  AP.ID_GUEST = :ID_GUEST
           and AP.AC = '00'
           and AP.ID_BASE_DOC is null
    into   :ap_dbkey, :is_packet_post, :packet_option, :id_current_account
  do begin
    if ((:is_packet_post = 1) and (:packet_option <> 'NONE')) then id_target_account = :id_base_account;
    else id_target_account = :id_extra_account;

    if (:id_current_account <> :id_target_account) then begin
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:ap_dbkey, :id_target_account, 0);
    end
  end

end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ADD_DEF_PAYMENT$DOC for: PAYMENT_STORNO$INT */
ALTER PROCEDURE DOCUMENT_ADD_DEF_PAYMENT$DOC(ID_DOC_HEAD INTEGER,
ID_PAY_DOC_TYPE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_STORNO_PAYS_SET$DOC for: PAYMENT_STORNO$INT */
ALTER PROCEDURE DOCUMENT_STORNO_PAYS_SET$DOC(ID_STORNO_DOC INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (PAYMENT_STORNO$INT) */
ALTER PROCEDURE PAYMENT_STORNO$INT(ID_PAYMENT_HEAD INTEGER,
ID_ACCOUNT INTEGER,
NEW_ID_DOC_HEAD INTEGER,
STORNO_AMOUNT NUMERIC(15,4),
DESCRIPTION VARCHAR(100),
TARGET_DOC_AMOUNT NUMERIC(15,4))
 RETURNS(ID_STORNO_PAYMENT INTEGER)
 AS
declare variable payment_date date;
  declare variable acc_currency varchar(3);
  declare variable id_doc_type integer;
  declare variable doc_type_name varchar(50);
  declare variable id_doc_num integer;
  declare variable is_storno integer;
  declare variable round_to numeric(15,4);
  declare variable pay_rate numeric(15,6);
  declare variable pay_curr varchar(3);
  declare variable doc_value numeric(15,4);
  declare variable acc_value numeric(15,4);
  declare variable acc_rate numeric(15,6);
  declare variable doc_rate numeric(15,6);
  declare variable doc_curr varchar(3);
  declare variable id_doc_contragent integer;
  declare variable id_storned_doc_head integer;
  declare variable id_payment_type integer;
  declare variable id_hotel integer;
  declare variable due_date date;
  declare variable equal_pay_doc_rate double precision;
  declare variable is_partial_storno numeric(15,4);
  declare variable id_account_payment integer;
  declare variable id_deposit integer;
  declare variable avail_pay_amount numeric(15,4);
begin
  execute procedure PAYMENT_VOID_CHECK$INT (:ID_PAYMENT_HEAD, substring(:DESCRIPTION from 1 for 50));

  select PH.ID_DOC_TYPE, DTP.STORNO_DOC_NAME, PH.ID_DOC_NUM, PH.ID_PAYMENT_TYPE, PH.DUE_DATE,
         ph.IS_STORNO, PH.PAY_CURRENCY, PH.PAY_RATE, PH.ID_DOC_HEAD,
         A.ID_HOTEL, c.ROUND_TO
  from   PAYMENT_HEAD PH
         join DOC_TYPE DP on DP.ID_DOC_TYPE = PH.ID_DOC_TYPE
         join DOC_TYPE_PAY dtp on dtp.ID_DOC_TYPE = dp.ID_DOC_TYPE
         join ACCOUNT A on A.ID_ACCOUNT = PH.ID_ACCOUNT
         join CURRS c on c.CURR = ph.PAY_CURRENCY
  where  PH.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  into   :id_doc_type, :doc_type_name, :id_doc_num, :id_payment_type, :due_date,
         :is_storno, :pay_curr, :pay_rate, :id_storned_doc_head,
         :id_hotel, :round_to;

  if (:is_storno = 1) then
    exception PAYMENT_EXCEPTION 'Storno payment cannot be voided !';

  select sum(AP.PAY_AMOUNT)
  from   ACCOUNT_PAYMENTS AP
  where  AP.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  into   :avail_pay_amount;

  if ((:STORNO_AMOUNT is null) or (round_f(:STORNO_AMOUNT - :avail_pay_amount, :round_to) = 0) ) then begin
    /* storn whole available payment */
    is_partial_storno = 0;
    STORNO_AMOUNT = :avail_pay_amount;
  end else begin
    is_partial_storno =1;
  end

  if (:STORNO_AMOUNT = 0 ) then
    exception PAYMENT_EXCEPTION '-340' || f_character(31) || '' || f_character(29) || :storno_amount;
    --'Payment value iz zero.' ;

  execute procedure SYSTEM_DATE_GET (:ID_HOTEL)
  returning_values  (:payment_date);
   
  /* CHECK FOR VALID ACCOUNT */
  select A.ACCOUNT_CURR
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :acc_currency;

  execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:ID_ACCOUNT, 0);
  /*-------------------- PAYMENT HEADER ---------------------*/
  select D.DOC_CURRENCY, D.ID_DOC_CONTRAGENT, D.DOC_RATE
  from   DOC_HEAD D
  where  D.ID_DOC = :NEW_ID_DOC_HEAD
  into   :doc_curr, :id_doc_contragent, :doc_rate;

  ID_STORNO_PAYMENT = gen_id(G_ID_PAYMENT_HEAD, 1);
  insert into PAYMENT_HEAD
         (ID_PAYMENT_HEAD, ID_ACCOUNT, ID_DOC_TYPE, ID_DOC_NUM,
         ID_PAYMENT_TYPE, DOC_TYPE_NAME, PAYMENT_DATE, DUE_DATE,
         PAY_VALUE, PAY_VALUE_A, PAY_CURRENCY, PAY_RATE, IS_STORNO, ID_DOC_HEAD,
         DESCRIPTION, ID_DOC_CONTRAGENT, ID_PAYMENT_STORNED)
  values (:ID_STORNO_PAYMENT, :ID_ACCOUNT, :id_doc_type, :id_doc_num,
         :id_payment_type, :doc_type_name, :payment_date, :due_date,
         -:STORNO_AMOUNT, -:STORNO_AMOUNT, :pay_curr, :pay_rate, 1, :NEW_ID_DOC_HEAD,
         :DESCRIPTION, :id_doc_contragent, :ID_PAYMENT_HEAD);
  /*-------------------- ACCOUNT_PAYMENT ---------------------*/
  execute procedure CURR_RATE_GET (:acc_currency, :payment_date, :id_hotel)
  returning_values  (:acc_rate);

  if (:is_partial_storno = 1 /*and :TARGET_DOC_AMOUNT is not null */) then begin
    if (:pay_curr = :doc_curr) then pay_rate = :doc_rate;
    execute procedure PAYMENT_EQUIVALENCE_CALC$INT (:pay_rate, -:STORNO_AMOUNT, :round_to, :doc_rate, :round_to, :TARGET_DOC_AMOUNT)
    returning_values  (:doc_value, :equal_pay_doc_rate);
    --doc_rate = :pay_rate / :equal_pay_doc_rate;
     
    if (:acc_currency = :doc_curr) then begin
      acc_value = :doc_value;
      acc_rate = :pay_rate / :equal_pay_doc_rate; --:doc_rate;
    end else begin
      acc_value = (-:storno_amount) * cast(:pay_rate/:acc_rate as double precision);
    end

    insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
           ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT, IS_INITIAL_PAYMENT)
    values (:ID_ACCOUNT, :ID_STORNO_PAYMENT, -:STORNO_AMOUNT , :pay_rate,
           :acc_value, :acc_rate, :payment_date, null, 1)
    returning id_account_payment into :id_account_payment;
  
    if (:NEW_ID_DOC_HEAD is not null) then begin
      insert into DOC_PAY_USAGE (ID_DOC_HEAD, ID_ACCOUNT_PAYMENT, PAY_AMOUNT, PAY_RATE,
             DOC_AMOUNT, /*DOC_RATE,*/ EQUAL_PAY_DOC_RATE)
      values (:NEW_ID_DOC_HEAD, :id_account_payment, -:storno_amount, :pay_rate,
             :doc_value, /*:doc_rate,*/ :equal_pay_doc_rate);
    end
  end else begin
    /* whole paymnent is storned */
    select dp.EQUAL_PAY_DOC_RATE
    from   DOC_PAY_USAGE DP
           join ACCOUNT_PAYMENTS AP on AP.ID_ACCOUNT_PAYMENT = dp.ID_ACCOUNT_PAYMENT
    where  DP.ID_DOC_HEAD = :id_storned_doc_head
           and AP.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
    into   :equal_pay_doc_rate;

    for
      select ap.ID_DEPOSIT, ap.id_account, ap.PAY_RATE, ap.ACC_RATE,
             sum(ap.PAY_AMOUNT), sum(ap.ACC_AMOUNT)
      from   ACCOUNT_PAYMENTS AP
      where  AP.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
      group by 1, 2, 3, 4
      having round_f(sum(AP.PAY_AMOUNT), :round_to) <> 0
      into   :id_deposit, :ID_ACCOUNT, :pay_rate, :acc_rate,
             :STORNO_AMOUNT, :acc_value
    do begin
      insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
             ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT, IS_INITIAL_PAYMENT)
      values (:ID_ACCOUNT, :ID_STORNO_PAYMENT, -:STORNO_AMOUNT, :pay_rate,
             -:acc_value, :acc_rate, :payment_date, :id_deposit, 1)
      returning id_account_payment into :id_account_payment;

      if (:NEW_ID_DOC_HEAD is not null) then begin
        doc_value = :storno_amount * :equal_pay_doc_rate;
        --doc_rate = :pay_rate / :equal_pay_doc_rate;
        insert into DOC_PAY_USAGE (ID_DOC_HEAD, ID_ACCOUNT_PAYMENT, PAY_AMOUNT, PAY_RATE,
               DOC_AMOUNT, /*DOC_RATE, */EQUAL_PAY_DOC_RATE)
        values (:NEW_ID_DOC_HEAD, :id_account_payment, -:storno_amount, :pay_rate,
               -:doc_value, /*:doc_rate, */:equal_pay_doc_rate);
      end
    end

  end

  insert into PAYMENT_CREDIT_CARD (ID_PAYMENT_HEAD, CARD_CODE, ID_CC_TYPE,
         HOLDER_NAME, HOLDER_ADDRESS, VALIDITY_YEAR, VALIDITY_MONTH, VERIFICTION_CODE, CARD_CODE_PREVIEW)
  select :ID_STORNO_PAYMENT, CARD_CODE, ID_CC_TYPE,
         HOLDER_NAME, HOLDER_ADDRESS, VALIDITY_YEAR, VALIDITY_MONTH, VERIFICTION_CODE, CARD_CODE_PREVIEW
  from   PAYMENT_CREDIT_CARD pcc
  where  pcc.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;

  /* Mark storned pay doc and account payments for it as storned */
  if (:is_partial_storno = 0) then begin
    update PAYMENT_HEAD P
    set    P.IS_STORNED = 1
    where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;
  end
end
^

/* Alter (PHONECALL_POST$TC) */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Alter (PHONECALLS_POST_TO_ACCOUNT$TC) */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POST_MODIFY$PMS for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: CONTRACT_EXPENSE_POST$INT for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_HOTEL INTEGER,
ID_CONTRACT /* TYPE OF ID */ INTEGER,
SUB_CONTRACT /* TYPE OF TSUB_CONTRACT */ VARCHAR(10),
ID_OWNER /* TYPE OF ID */ INTEGER,
OWNERSHIP_PERCENT /* TYPE OF TPERCENT */ NUMERIC(15,4),
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
POST_DATE /* TYPE OF TDATE */ DATE,
STAY /* TYPE OF TCOUNT */ INTEGER,
MAX_GUEST_CNT /* TYPE OF TCOUNT */ INTEGER,
BED_NIGHT_CNT /* TYPE OF TCOUNT */ INTEGER,
RESERVS /* TYPE OF TCOUNT */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PMS_EXPENSE_POSTS_CREATE$INT for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
POST_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
IS_CLIENT_ACC_POST /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_POST_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_POST_PER_POOL /* TYPE OF TLOGICAL */ SMALLINT)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER,
NEW_ID_ACCOUNT_POST$PMS /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_POOL_DISTRIBUTION_SUB for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_POSTING_CREATE$INT) */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_OWNER TYPE OF ID,
POST_DATE TYPE OF TDATE,
CURR_ORIG TYPE OF TCURRENCY,
VALUE_ORIG TYPE OF TPRICE,
POST_ON_PMS_ACCOUNT TYPE OF TLOGICAL,
IS_OWNER_INCOME TYPE OF TLOGICAL,
ID_ROOM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  if (:POST_ON_PMS_ACCOUNT = 1) then begin
    execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account, :id_owner,
            :CURR_ORIG, :VALUE_ORIG, :id_service, :is_owner_income, :POST_DATE)
    returning_values  (:new_id_account_post);
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :ID_SERVICE, 1, 0, 1,
            :VALUE_ORIG, :CURR_ORIG, current_date, current_date,
            '', '', :POST_DATE, 'PMS', :ID_ROOM)
    returning_values  :err_code, :err_text, :new_id_account_post;
    if (:err_code <> 0) then exception PMS_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:ID_PMS_EVENT, :NEW_ID_ACCOUNT_POST, :ID_OWNER, 11);
  end
end
^

/* Alter (POST_SERVICE_FINALIZE$POST) */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable description type of TSERVICE_DESCRIPTION;
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
  declare variable post_text varchar(100);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.DESCRIPTION, ts.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :description, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '', :description)
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '', null, :description)
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set    ID_ACCOUNT_POST = :id_acc_post
      where  RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* Alter (PROFILE_GET_ACCOUNT$INT) */
ALTER PROCEDURE PROFILE_GET_ACCOUNT$INT(ID_PROFILE INTEGER,
ID_RESERV_DETAIL INTEGER,
ACCOUNT_CURR VARCHAR(3),
ID_ACC_TEMPLATE INTEGER,
IS_BASE_ENABLE SMALLINT = 1,
IS_EXTRA_ENABLE SMALLINT = 1)
 RETURNS(ID_ACCOUNT INTEGER)
 AS
declare variable is_archive integer;
declare variable id_hotel integer;
begin
  id_account = null;

  select first 1 A.ID_ACCOUNT, a.IS_ARCHIVE
  from   ACCOUNT A
  where  A.ID_PROFILE = :id_profile
         and A.ACCOUNT_CURR = :account_curr
         and A.ID_RESERV_DETAIL is not distinct from :id_reserv_detail
         and A.IS_BASE >= :IS_BASE_ENABLE
         and A.IS_EXTRA >= :IS_EXTRA_ENABLE
  order by A.IS_ARCHIVE asc, A.ID_ACCOUNT asc
  into   :id_account, :is_archive;

  if (:id_account is null) then begin
    if (:id_acc_template is null) then begin
      select rd.ID_HOTEL
      from   RESERV_DETAIL RD
      where  rd.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
      into   :id_hotel;

      select P.ID_ACCOUNT_TEMPLATE
      from   PROFILE_BOOKING_DEFAULTS P
      where  P.ID_PROFILE = :id_profile
             and P.ID_HOTEL = :id_hotel
      into   :id_acc_template;
    end

    execute procedure RES_ACCOUNT_CREATE$INT(:id_profile, :id_acc_template, :account_curr,
            :id_reserv_detail, :IS_BASE_ENABLE, :IS_EXTRA_ENABLE)
    returning_values  :id_account;

  end else if (:is_archive = 1) then begin
    execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 0);
  end
end
^

/* empty dependent procedure body */
/* Clear: PROFILE_COMMON_MODIFY$INT for: PROFILE_SET_ARCHIVE$INT */
ALTER PROCEDURE PROFILE_COMMON_MODIFY$INT(ID_PROFILE INTEGER,
PROFILE_TYPE VARCHAR(20),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL /* TYPE OF TEMAIL */ VARCHAR(100),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PROFILE_SET_ARCHIVE$INT) */
ALTER PROCEDURE PROFILE_SET_ARCHIVE$INT(P_DBKEY CHAR(8),
ARCHIVE_STATUS SMALLINT)
 AS
declare variable old_is_archive smallint;
  declare variable id_profile integer;
  declare variable id_account integer;
  declare variable id_merge_profile integer;
begin
  select P.IS_ARCHIVE, P.ID_PROFILE, p.ID_MERGE_PROFILE
  from   PROFILE P
  where  P.RDB$DB_KEY = :P_DBKEY
  into   :old_is_archive, :id_profile, :id_merge_profile;
   
  if (:ARCHIVE_STATUS > :old_is_archive) then begin
    /* archive */
    if (exists (select app.ID_ACCOUNT_POST
                from   ACCOUNT_POST$PMS APP
                where  app.ID_OWNER = :id_profile
                       and app.LINE_STATUS = 11)) then
      exception PROFILE_EXCEPTION '-1050';

    for
      select A.ID_ACCOUNT
      from   ACCOUNT A
      where  A.ID_PROFILE = :id_profile
             and a.IS_ARCHIVE is distinct from 1
      into   :id_account
    do begin
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS (:id_account, 1);
    end 

  end else if (:ARCHIVE_STATUS < :old_is_archive) then begin
    /* unarchive */
    if (:id_merge_profile is not null) then exception PROFILE_EXCEPTION '-1045';

    for
      select A.ID_ACCOUNT
      from   ACCOUNT A
      where  A.ID_PROFILE = :id_profile
             and a.IS_PMS_ACCOUNT = 1
             and a.IS_ARCHIVE = 1
      into   :id_account
    do begin
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS (:id_account, 0);
    end 

  end

  update PROFILE P
  set    P.IS_ARCHIVE = :ARCHIVE_STATUS
  where  P.RDB$DB_KEY = :P_DBKEY;
   
end
^

/* Alter (RES_ACCOUNT_CREATE$INT) */
ALTER PROCEDURE RES_ACCOUNT_CREATE$INT(ID_PROFILE INTEGER,
ID_ACC_TEMPLATE INTEGER,
ACC_CURRENCY CHAR(3),
ID_RESERV_DETAIL INTEGER,
IS_BASE_ENABLE SMALLINT = 1,
IS_EXTRA_ENABLE SMALLINT = 1)
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable acc_name varchar(50);
  declare variable id_hotel integer;
  declare variable is_credit_account integer;
  declare variable credit_limit numeric (15,4);
  declare variable sec_level integer;
  declare variable is_pos_allowed integer;
  declare variable id_tax_policy integer;
  declare variable id_sale_num integer;
  declare variable check_status smallint;
begin
  select 'res. ' || substring(RD.NUMBER from 1 for 45), RD.ID_HOTEL, rd.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :acc_name, :id_hotel, :check_status;

  if (:id_acc_template is null) then begin
    select sv.SETTING_VALUE
    from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :id_hotel) sv
    into   :id_acc_template;
  end

  is_credit_account = null;
  select ACT.IS_CREDIT_ACCOUNT, ACT.CREDIT_LIMIT, ACT.SECURITY_LEVEL,
         ACT.IS_ALOWED_POS_INTERFACE, ACT.ID_TAX_POLICY
  from   ACC_TEMPLATE ACT
  where  ACT.ID_ACC_TEMPLATE = :id_acc_template
         and act.ID_HOTEL = :id_hotel
  into   :is_credit_account, :credit_limit, :sec_level,
         :is_pos_allowed, :id_tax_policy;

  if (:is_credit_account is null) then exception ACCOUNT_EXCEPTION '-50';

  execute procedure ACCOUNT_MODIFY$INT (null, :ID_PROFILE, :ACC_CURRENCY, :acc_name, :is_credit_account, :credit_limit,
          null, null, 0, '', :sec_level, :IS_BASE_ENABLE, :IS_EXTRA_ENABLE, :is_pos_allowed, null,
          null, :id_tax_policy, null, :id_hotel, :ID_RESERV_DETAIL, 0, 'add')
  returning_values (:NEW_ID_ACCOUNT);

  if (:check_status = 0) then begin
    execute procedure ACCOUNT_SALE_NUMBER_SET(:NEW_ID_ACCOUNT)
    returning_values (:id_sale_num);
  end
end
^

/* Alter (RES_ACCOUNTS_RECIEVE$INT) */
ALTER PROCEDURE RES_ACCOUNTS_RECIEVE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
ID_AGENT_ACCOUNT_RULE INTEGER,
ID_BASE_ACCOUNT_PROFILE INTEGER,
ID_EXTRA_ACCOUNT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ID_ACC_TEMPLATE_PERSON INTEGER,
IS_SEPARATE_ACCOUNTS SMALLINT)
 RETURNS(NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable id_acc_profile integer;
  declare variable base_account_curr varchar(3);
  declare variable base_tariff_currency char(3);
  declare variable extra_tariff_currency char(3);
  declare variable id_hotel integer;
  declare variable id_base_acc_reserv integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
begin
  id_acc_profile = null;
  select A.ID_PROFILE, A.ACCOUNT_CURR, A.ID_RESERV_DETAIL
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :old_id_base_account
  into   :id_acc_profile, :base_account_curr, :id_base_acc_reserv;

  select first 1 T.CURR, T.ID_HOTEL
  from   GUEST G
         join GUEST_STAY GS on gs.ID_GUEST = g.ID_GUEST
         join TARIFA T on T.ID_TARIFA = GS.ID_TARIFF
  where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  order by GS.FOR_DATE asc
  into   :base_tariff_currency, :id_hotel;

  if (:base_tariff_currency is null) then EXIT;

  select first 1 T.CURR
  from   TARIFA T
  where  T.IS_EXTRA = 1
         and T.ID_HOTEL = :id_hotel
  into   :extra_tariff_currency;

  if (coalesce(:id_agent_account_rule, 0) > 0) then begin
    /* get specified account */
    new_id_base_account = :id_agent_account_rule;
    execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:NEW_ID_BASE_ACCOUNT, 0);
  end else if (:id_acc_profile = :id_base_account_profile
               and :base_account_curr = :base_tariff_currency
               and :id_base_acc_reserv is not distinct from :ID_RESERV_DETAIL) then
  begin
    /* preserve old base personal account */
    new_id_base_account = :old_id_base_account;
  end else begin
    /* get new personal account */
    execute procedure PROFILE_GET_ACCOUNT$INT (:id_base_account_profile, :id_reserv_detail, 
            :base_tariff_currency, iif(:id_base_account_profile = :id_person_profile, :id_acc_template_person, null),
            1, iif(:IS_SEPARATE_ACCOUNTS = 0, 1, 0))
    returning_values (:new_id_base_account);
  end

  select ba.ACCOUNT_CURR
  from   ACCOUNT BA
  where  ba.ID_ACCOUNT = :NEW_ID_BASE_ACCOUNT
  into   :base_account_curr;

  if (:IS_SEPARATE_ACCOUNTS = 1
      and :base_account_curr = :extra_tariff_currency
      and :ID_BASE_ACCOUNT_PROFILE = :ID_EXTRA_ACCOUNT_PROFILE)
  then IS_SEPARATE_ACCOUNTS = 0;


  if (:IS_SEPARATE_ACCOUNTS = 0) then begin
    new_id_extra_account = :new_id_base_account;
    update ACCOUNT A
    set    a.IS_EXTRA = 1
    where  a.ID_ACCOUNT = :NEW_ID_EXTRA_ACCOUNT
           and a.IS_EXTRA is distinct from 1;
  end else begin
    id_acc_profile = null;
    select A.ID_PROFILE/*, A.ACCOUNT_CURR*/
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :old_id_extra_account
    into   :id_acc_profile/*, :account_curr*/;

    if (:id_acc_profile = :id_extra_account_profile /*and :account_curr = :extra_tariff_currency*/ and :old_id_extra_account is not null) then begin
      -- CHANGED after p27 -> condition {:account_curr = :extra_tariff_currency} is removed;
      -- if exists extra account by this profile, it must be preserve, independent of currency,
      -- because of unnecessary posting transfer and archiving of unused accounts (by the same profile);
      -- this can be forced with ACC_ROUTING changing (MIXED -> AGENT -> MIXED)
      new_id_extra_account = :old_id_extra_account;
    end else begin
      execute procedure PROFILE_GET_ACCOUNT$INT (:id_extra_account_profile, :id_reserv_detail,
              :extra_tariff_currency, iif(:id_extra_account_profile = :id_person_profile, :id_acc_template_person, null),
              1, 1)
      returning_values (:new_id_extra_account);
    end
  end
  /*  */
  if (:NEW_ID_BASE_ACCOUNT is distinct from :OLD_ID_BASE_ACCOUNT) then begin
    execute procedure ACCOUNT_VALIDATE$INT(:NEW_ID_BASE_ACCOUNT, 'IS_BASE')
    returning_values  :err_code, :err_text, :no_use, :no_use, :no_use, :no_use, :no_use;
    if (:err_code < 0) then exception ACCOUNT_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end
  if (:NEW_ID_EXTRA_ACCOUNT is distinct from :OLD_ID_EXTRA_ACCOUNT) then begin
    execute procedure ACCOUNT_VALIDATE$INT(:NEW_ID_EXTRA_ACCOUNT, 'IS_EXTRA')
    returning_values  :err_code, :err_text, :no_use, :no_use, :no_use, :no_use, :no_use;
    if (:err_code < 0) then exception ACCOUNT_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end

end
^

/* empty dependent procedure body */
/* Clear: RES_ANUL_DETAIL$INT for: RES_ARCHIVATE_ACCOUNTS$INT */
ALTER PROCEDURE RES_ANUL_DETAIL$INT(RD_DBKEY CHAR(8),
REASON VARCHAR(50),
CANCELATION_NUMBER /* TYPE OF NAME_20 */ VARCHAR(20) = null)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_CHECK_OUT_GUESTS$RSV for: RES_ARCHIVATE_ACCOUNTS$INT */
ALTER PROCEDURE RES_CHECK_OUT_GUESTS$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND SMALLINT = 0,
EARLYCHECKOUT_DATE DATE = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_DELETE$INT for: RES_ARCHIVATE_ACCOUNTS$INT */
ALTER PROCEDURE RES_DELETE$INT(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_ARCHIVATE_ACCOUNTS$INT) */
ALTER PROCEDURE RES_ARCHIVATE_ACCOUNTS$INT(ID_RESERV_DETAIL INTEGER)
 AS
declare variable id_account integer;
begin
  for
    select RA.ID_ACCOUNT
    from   RES_GET_ACCOUNTS(:id_reserv_detail, 'BALANCE') RA
    into   :id_account
  do begin
    execute procedure ACCOUNT_BALANCE_INVALIDATE$INT (:id_account);

    execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 1);
  end

end
^

/* empty dependent procedure body */
/* Clear: APPLY_BOOKING_STATUS$EXC for: RES_CHECK_OUT_GUESTS$RSV */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: EAI_RES_CHECK_OUT_FAST for: RES_CHECK_OUT_GUESTS$RSV */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_CHECK_OUT_GUESTS$RSV) */
ALTER PROCEDURE RES_CHECK_OUT_GUESTS$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND SMALLINT = 0,
EARLYCHECKOUT_DATE DATE = null)
 AS
declare variable action_code varchar(100);
  declare variable cleaning_restriction varchar(10);
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable id_reserv_detail integer;
  declare variable id_guest integer;
  declare variable id_room integer;
  declare variable rd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable checkout_status integer;
  declare variable sys_date date;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
begin
  checkout_status = 1;
  action_code = case when :check_out_kind = 0 then 'CHECK_OUT'
                     when :check_out_kind = 1 then 'CHECK_OUT_EARLY1'
                     when :check_out_kind = 2 then 'CHECK_OUT_EARLY2'
                     when :check_out_kind = 3 then 'CHECK_OUT_EARLY3'
                end;

  for
    select RD.ID_RESERV_DETAIL, RD.ID_ROOM, RD.RDB$DB_KEY, rd.ID_HOTEL,
           (select sd.SYSTEM_DATE
            from   SYSTEM_DATE_GET (rd.ID_HOTEL) sd)
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_room, :rd_dbkey, :id_hotel, :sys_date
  do begin

    for
      select G.ID_GUEST, G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.CHECK_STATUS = 0 /* checked in */
      into   :id_guest, :g_dbkey
    do begin
      if (:CHECK_OUT_KIND = 3) then begin
        -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
        update GUEST G
        set    G.EARLYCHECKOUT_DATE = coalesce(:EARLYCHECKOUT_DATE, :sys_date)
        where  g.RDB$DB_KEY = :g_dbkey;

        execute procedure GUEST_SET_MANUAL_STAY$INT(:rd_dbkey, :id_guest, coalesce(:EARLYCHECKOUT_DATE, :sys_date))
        returning_values  :err_code, :err_text;
        if (:err_code < 0) then exception RESERV_CHECK_OUT_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
      end

      update ACCOUNT_POST AP
      set    AP.IS_ARCHIVE = 1
      where  AP.ID_GUEST = :id_guest;
    
      execute procedure GUEST_SET_STATUS$INT (:g_dbkey, :checkout_status);

      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, :action_code, '');
    end

    if (:CHECK_OUT_KIND = 3) then begin
      -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
      execute procedure OCCUPANCY_RESERV$INT(:rd_dbkey);

      execute procedure OCCUPANCY_SHARES_COMPLETE$INT (:id_reserv_detail)
      returning_values (:no_use, :no_use);
    end

    execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :cleaning_restriction;
  
    if (:cleaning_restriction <> '0' and :id_room > 0) then begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'CHECK_OUT', 'set_dirty');
    end

    execute procedure RES_SAVE_STATUS$INT (:rd_dbkey, :checkout_status);

    update RESERV_DETAIL rd
    set    rd.CHECK_OUT_KIND = :CHECK_OUT_KIND,
           rd.EARLYCHECKOUT_DATE = iif(:check_out_kind > 0, coalesce(:EARLYCHECKOUT_DATE, :sys_date), null)
    where  rd.RDB$DB_KEY = :rd_dbkey;

    execute procedure RES_BONUSPOINTS_APPLY$CL (:id_reserv_detail);
  end

end
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN_MULTI$RSV for: RES_CHECKIN$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_CHECKIN$RSV) */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable old_check_status integer;
  declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_anul integer;
  declare variable arrival_date date;
  declare variable system_date date;
  declare variable id_base_account integer;
  declare variable id_extra_account integer;
  declare variable id_sale_num integer;
begin
  /*  Description:
  ||
  */
  select RD.CHECK_STATUS, RD.RDB$DB_KEY, RD.FROM_DATE, RD.ID_HOTEL,
         RD.ID_ROOM, RD.IS_ANUL, rd.ID_BASE_ACCOUNT, rd.ID_EXTRA_ACCOUNT
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_check_status, :rd_dbkey, :arrival_date, :id_hotel,
         :old_id_room, :is_anul, :id_base_account, :id_extra_account;

  if (:is_anul = 1) then exception BOOKING_EXCEPTION '-2';

  if (:old_check_status >= 0) then exception BOOKING_EXCEPTION '-1003';

  if (:old_id_room < 0 and coalesce(:ID_ROOM, 0) <= 0) then exception BOOKING_EXCEPTION '-1018';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date < :arrival_date) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CHECK_IN_FUTURE');
  end
  /*----*/
  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'lock');

  execute procedure sys_dbg('occ RES_CHECKIN$RSV id_room = '||coalesce(:id_room, 'null'));
  execute procedure sys_dbg('occ RES_CHECKIN$RSV old_id_room = '||coalesce(:old_id_room, 'null'));

  if (:id_room is not null) then begin
    if (:old_check_status = -3) then begin
      execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, -2);
    end

    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option)
    returning_values (:WARN_CODE);
  end

  execute procedure ACCOUNT_SALE_NUMBER_SET(:id_base_account)
  returning_values (:id_sale_num);
  execute procedure ACCOUNT_SALE_NUMBER_SET(:id_extra_account)
  returning_values (:id_sale_num);

  execute procedure RES_SET_CHECKIN$INT (:rd_dbkey)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'release');
  /*----*/
  select f_character(29) || R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = coalesce(:ID_ROOM, :old_id_room)
  into   :action_text;
   
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'CHECK_IN', :action_text);

end
^

/* Alter (RES_CHECKIN_MULTI$RSV) */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable checkin_count integer;
  declare variable split_on_checkin integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
  declare variable tmp_warn_code integer;
begin
  checkin_count = 0;
  warn_code = null;
  for
    select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, RD.SPLIT_ON_CHECKIN, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :SELECTION_ID
    into   :id_reserv_detail, :check_status, :split_on_checkin, :id_titular
  do begin
    if (:check_status >= 0) then begin
      checkin_count = :checkin_count + 1;
    end else begin
      if (:split_on_checkin = 1) then begin
        for
          select G.ID_GUEST
          from   GUEST G
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and G.ID_GUEST <> :id_titular
          into   :id_guest
        do begin
          execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
          returning_values  :id_splited_reservation;

          execute procedure RES_CHECKIN$RSV (:id_splited_reservation)
          returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

          update RESERV_DETAIL RD
          set    RD.SELECTION_ID = :selection_id
          where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
        end
      end

      execute procedure RES_CHECKIN$RSV (:id_reserv_detail)
      returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
      WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end

  if (:checkin_count > 0) then begin
    execute procedure SYSTEM_WARNING_ADD(-1011, f_character(29)||:checkin_count)
    returning_values  :warn_code;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_DELETE$RSV for: RES_DELETE$INT */
ALTER PROCEDURE RES_DELETE$RSV(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESGRP_DELETE$RSV for: RES_DELETE$INT */
ALTER PROCEDURE RESGRP_DELETE$RSV(ID_GROUP INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_DELETE$INT) */
ALTER PROCEDURE RES_DELETE$INT(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable action_text varchar(255);
  declare variable from_date date;
  declare variable to_date date;
  declare variable room_type varchar(20);
  declare variable number type of TRES_NUMBER;
  declare variable tmp_extra_posts_left integer;
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_DELETE');

  if (exists (select ap.ID_ACCOUNT_POST
              from   GUEST G
                     join ACCOUNT_POST ap on ap.ID_GUEST = g.ID_GUEST
              where  g.ID_RESERV_DETAIL = :ID_RESERV_DETAIL)) then
    exception BOOKING_EXCEPTION '-1004';

  select RD.RDB$DB_KEY, RD.FROM_DATE, rd.TO_DATE, RT.TYPE_ROOM, rd.NUMBER
  from   RESERV_DETAIL RD
         left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = RD.ID_ROOM_TYPE
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :from_date, :to_date, :room_type, :number;

  update RESERV_DETAIL R
  set    r.ID_TITULAR = null
  where  r.RDB$DB_KEY = :rd_dbkey;

  EXTRA_POSTS_LEFT = 0;
  for
    select G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest
  do begin
    execute procedure RES_GUEST_DEL$INT(:id_guest, :id_reserv_detail, :REASON)
    returning_values  :tmp_extra_posts_left;
    EXTRA_POSTS_LEFT = iif(:EXTRA_POSTS_LEFT = 1, 1, :tmp_extra_posts_left);
  end

  execute procedure RES_FINALIZE$INT (:RD_DBKEY, 1)
  returning_values (:warn_code);


  execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

  action_text = f_character(29) || coalesce(:number, '')
                || f_character(28) || coalesce(:room_type, '')
                || f_character(28) || :from_date
                || f_character(28) || :to_date
                || f_character(28) || :reason;
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'DELETE', :action_text);

  delete from RESERV_DETAIL RDD
  where  RDD.RDB$DB_KEY = :rd_dbkey;

  delete from XML_MESSAGE$EXC xml
  where  xml.OBJECT_TYPE = 'BOOKING'
         and xml.OBJECT_ID = :number;

end
^

/* Alter (RES_DELETE$RSV) */
ALTER PROCEDURE RES_DELETE$RSV(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT,
NEW_FROM_DATE TYPE OF TDATE)
 AS
begin

  execute procedure RES_DELETE$INT(:ID_RESERV_DETAIL, :REASON)
  returning_values :WARN_CODE, :EXTRA_POSTS_LEFT;

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;
end
^

/* Alter (RES_SAVE_ACC_ARCHIVE$INT) */
ALTER PROCEDURE RES_SAVE_ACC_ARCHIVE$INT(ACCOUNTS_FOR_ARCHIVE VARCHAR(2000),
ID_PROFILE INTEGER)
 AS
declare variable id_account integer;
  declare variable old_id_profile integer;
  declare variable is_used integer;
  declare variable errtxt_acc_name varchar(50);
  declare variable errtxt_prof_name varchar(100);
  declare variable id_sale_num integer;
begin
  /*  Description:
  ||
  */
  for
    select ITEM
    from   SYSTEM_STRING_PARSER(:accounts_for_archive, ',')
    into   :id_account                                 
  do begin
    select A.ID_PROFILE, a.ID_SALE_NUM
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :old_id_profile, :id_sale_num;

    execute procedure sys_dbg('acc RES_SAVE_ACC_ARCHIVE$INT old_id_profile = '||coalesce(:old_id_profile, 'null'));
    execute procedure sys_dbg('acc RES_SAVE_ACC_ARCHIVE$INT id_profile = '||coalesce(:id_profile, 'null'));

    execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 1);
    execute procedure sys_dbg('acc RES_SAVE_ACC_ARCHIVE$INT id_account = '||coalesce(:id_account, 'null'));

    if (:old_id_profile is distinct from :id_profile) then begin
      execute procedure ACCOUNT_USE_CHECK$INT(:id_account)
      returning_values  :is_used;
      if (:id_sale_num is null and :is_used = 0) then
        delete from ACCOUNT A
        where  A.ID_ACCOUNT = :id_account;
    end

    when exception ACCOUNT_EXCEPTION do begin
      -- catch the exception raised from archivate procedure (err_code = -44)
      select A.ACCOUNT_NAME
      from   ACCOUNT A
      where  A.ID_ACCOUNT = :id_account
      into   :errtxt_acc_name;
  
      select P.PROFILE_NAME
      from   PROFILE P
      where  P.ID_PROFILE = :old_id_profile
      into   :errtxt_prof_name;
      -- override error code with most concrete
      exception ACCOUNT_EXCEPTION '-1009' || f_character(31) || '' || f_character(29)||:errtxt_acc_name||f_character(28)||:errtxt_prof_name;
    end

  end
end
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_CHANGE$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTING$INT for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUESTCOUNT$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ACCOUNTS$INT) */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_base_account integer;
  declare variable old_id_extra_account integer;
  declare variable new_id_base_account integer;
  declare variable new_id_extra_account integer;
  declare variable acc_routing varchar(30);
  declare variable is_sep_accounts integer;
  declare variable id_base_account_profile integer;
  declare variable id_extra_account_profile integer;
  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable id_agent_account_rule integer;
  declare variable id_acc_template_person integer;
  declare variable id_guest integer;
  declare variable id_hotel integer;
  declare variable check_status integer;
  declare variable id_sale_num integer;
begin

  select RD.ID_RESERV_DETAIL, RD.ID_PERSON_PROFILE, RD.ID_ACC_TEMPLATE_PERSON,
         RD.ACC_ROUTING, RD.ID_BASE_ACCOUNT, RD.ID_EXTRA_ACCOUNT,
         RD.ID_AGENT_PROFILE, RD.ID_AGENT_ACCOUNT_RULE, rd.id_hotel
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :RD_DBKEY
  into   :id_reserv_detail, :id_person_profile, :id_acc_template_person,
         :acc_routing, :old_id_base_account, :old_id_extra_account,
         :id_agent_profile, :id_agent_account_rule, :id_hotel;

  id_agent_account_rule = nullif(:id_agent_account_rule, -1);
  /* --- new */
  execute procedure SETTING_GET_VALUE ('SEPARATE_ACCOUNTS_PER_PAYER', :id_hotel)
  returning_values (:IS_SEP_ACCOUNTS);

  NEW_ID_BASE_ACCOUNT = null; --:old_id_base_account;
  NEW_ID_EXTRA_ACCOUNT = null; --:old_id_extra_account;

  /* identify profiles for base and extra account */
  if (:ACC_ROUTING in ('MIXED')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else if (:ACC_ROUTING in ('AGENT')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
  end else if (:ACC_ROUTING in ('FULL_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = null;
    IS_SEP_ACCOUNTS = 0;  -- never
  end else if (:ACC_ROUTING in ('PART_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else begin -- if (:acc_routing in ('GUEST', 'OWNER'))
    ID_BASE_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_AGENT_ACCOUNT_RULE = null;
  end

  execute procedure RES_ACCOUNTS_RECIEVE$INT (:ID_RESERV_DETAIL, :old_id_base_account, :old_id_extra_account,
          :id_agent_account_rule, :id_base_account_profile, :id_extra_account_profile, :id_person_profile,
          :id_acc_template_person, :is_sep_accounts)
  returning_values (:new_id_base_account, :new_id_extra_account);

--  if (:new_id_base_account is null) then exception WRONG_VALUE 'Invalid base account!';
--  if (:new_id_extra_account is null) then exception WRONG_VALUE 'Invalid extra account!';
  if ((:old_id_base_account is distinct from :new_id_base_account)
       or (:old_id_extra_account is distinct from :new_id_extra_account)) then
  begin
    update RESERV_DETAIL RD
    set    RD.ID_BASE_ACCOUNT = :new_id_base_account,
           RD.ID_EXTRA_ACCOUNT = :new_id_extra_account
    where  RD.RDB$DB_KEY = :RD_DBKEY
    returning CHECK_STATUS into :check_status;
    /* end --- */
    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
             --and G.CHECK_STATUS < 1
      into   :id_guest
    do begin
      execute procedure GUEST_REROUTE_POSTINGS$INT(:id_guest, :new_id_base_account, :new_id_extra_account);
    end

    if (:check_status = 0) then begin
      execute procedure ACCOUNT_SALE_NUMBER_SET(:new_id_base_account)
      returning_values (:id_sale_num);
      execute procedure ACCOUNT_SALE_NUMBER_SET(:new_id_extra_account)
      returning_values (:id_sale_num);
    end
    -- Log account changes
    execute procedure RES_SAVE_ACCOUNTS_FINALIZE$INT(:id_reserv_detail, :old_id_base_account, :old_id_extra_account,
            :new_id_base_account, :new_id_extra_account);
  end

end
^

/* Alter (RES_SAVE_ACCOUNTS_FINALIZE$INT) */
ALTER PROCEDURE RES_SAVE_ACCOUNTS_FINALIZE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable id_old_account integer;
  declare variable action_text varchar(255);
  declare variable acc_name varchar(50);
  declare variable is_used integer;
  declare variable id_sale_num integer;
begin
  if (:NEW_ID_BASE_ACCOUNT is distinct from :OLD_ID_BASE_ACCOUNT) then begin
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OLD_ID_BASE_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = F_CHARACTER(29) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:OLD_ID_BASE_ACCOUNT, '')  || ')';
    ACC_NAME = null;
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :NEW_ID_BASE_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = :ACTION_TEXT || F_CHARACTER(28) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:NEW_ID_BASE_ACCOUNT, '')  || ')';

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_MOD_BASE_ACCOUNT', :ACTION_TEXT);
  end

  ACTION_TEXT = '';
  ACC_NAME = null;
  if (:NEW_ID_EXTRA_ACCOUNT is distinct from :OLD_ID_EXTRA_ACCOUNT) then begin
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OLD_ID_EXTRA_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = F_CHARACTER(29) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:OLD_ID_EXTRA_ACCOUNT, '')  || ')';
    ACC_NAME = null;
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :NEW_ID_EXTRA_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = :ACTION_TEXT || F_CHARACTER(28) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:NEW_ID_EXTRA_ACCOUNT, '')  || ')';

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_MOD_EXTRA_ACCOUNT', :ACTION_TEXT);
  end

  -- Archivate old unused accounts
  for
    select A.ID_ACCOUNT, a.ID_SALE_NUM
    from   ACCOUNT_S A
    where  A.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
           and A.IS_ARCHIVE = 0
           and A.ID_ACCOUNT <> :NEW_ID_BASE_ACCOUNT
           and A.ID_ACCOUNT <> :NEW_ID_EXTRA_ACCOUNT
           and A.IS_CREDIT_ACCOUNT = 0
           and not exists(select G.ID_GUEST
                          from   GUEST G
                          where  (G.ID_BASE_ACCOUNT = A.ID_ACCOUNT)
                                 or (G.ID_ACCOUNT = A.ID_ACCOUNT))
    into   :ID_OLD_ACCOUNT, :id_sale_num
  do begin
    select auc.is_used
    from   ACCOUNT_USE_CHECK$INT(:id_old_account) auc
    into   :is_used;

    if (:id_sale_num is null and :is_used = 0) then begin
      delete from ACCOUNT A
      where  a.ID_ACCOUNT = :id_old_account;
    end else if (not exists(select ap.ID_ACCOUNT_POST from account_post ap where ap.ID_ACCOUNT = :id_old_account and ap.IS_ANUL = 0)) then  begin
      -- archive only used accounts without valid postings
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS (:ID_OLD_ACCOUNT, 1);
  
      when exception ACCOUNT_EXCEPTION do post_event 'dummy';
    end
  end 
end
^

/* Alter (RES_SAVE_GUESTCOUNT$RSV) */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select rd.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  rd.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SAVE_GUESTCOUNT$INT(:rd_dbkey, :adult_count, :child_count);

  execute procedure RES_SAVE_ACCOUNTS$INT (:rd_dbkey);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :warn_code;

end
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SPLIT$RSV) */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
declare variable rd_dbkey_old char(8);
  declare variable rd_dbkey_new char(8);
  declare variable id_guest integer;
  declare variable warn_code integer;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;

  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable check_status integer;
  declare variable arrival_date date;
  declare variable departure_date date;
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable id_room_type integer;
  declare variable id_room integer;
  declare variable id_board integer;
  declare variable id_tariff integer;
  declare variable custom_price numeric(15,4);
  declare variable custom_currency char(3);
  declare variable voucher_num varchar(30);
  declare variable voucher_date date;
  declare variable voucher_text varchar(30);
  declare variable voucher2_num varchar(30);
  declare variable voucher2_date date;
  declare variable transfer_in_time time;
  declare variable transfer_in_note varchar(255);
  declare variable transfer_out_time time;
  declare variable transfer_out_note varchar(255);
  declare variable comming_kind integer;
  declare variable is_late_departure integer;
  declare variable is_vip integer;
  declare variable country_code varchar(20);
  declare variable code_first_food tfood_code;
  declare variable i_special_treatment varchar(255);
  declare variable id_nom_market_segment integer;
  declare variable id_nom_source_code integer;
  declare variable id_nom_channel_code integer;
  declare variable id_nom_hear_reason integer;
  declare variable id_nom_come_reason integer;
  declare variable id_agent_account integer;
  declare variable acc_routing varchar(50);
  declare variable id_person_payment integer;
  declare variable id_agent_payment integer;
  declare variable room_features blob sub_type 1 segment size 80;
  declare variable id_hk_plan integer;
  declare variable id_group integer;
  declare variable id_hotel integer;
  declare variable note varchar(2000);
  declare variable note_reminders varchar(50);
  declare variable guarantee_deposit numeric(15,4);
  declare variable guarantee_currency char(3);
  declare variable id_titular integer;
  declare variable id_profile_data integer;
  declare variable id_acc_template_person integer;
  declare variable number_1 varchar(20);
  declare variable number_2 varchar(20);
  declare variable new_res_number type of TRES_NUMBER;
  declare variable g_dbkey char(8);
  declare variable is_child integer;
  declare variable id_guarantee_policy integer;
  declare variable block_cc varchar(255);
  declare variable virtual_room varchar(10);
  declare variable err_text varchar(255);
  declare variable is_posting_stopped integer;
  declare variable id_eating_object integer;
begin
  select RD.RDB$DB_KEY, RD.ID_AGENT_PROFILE, RD.CHECK_STATUS, RD.FROM_DATE, RD.TO_DATE,
         RD.ADULT_COUNT, RD.CHILD_COUNT, RD.ID_ROOM_TYPE, RD.ID_ROOM, RD.ID_BOARD, RD.ID_RATE,
         RD.CUSTOM_PRICE, RD.CUSTOM_CURRENCY, RD.VAUCHER_NUM, RD.VAUCHER_DATE, RD.VAUCHER_TEXT, RD.VAUCHER_NUM2,
         RD.VAUCHER_DATE2, RD.TRANSFER_IN_TIME, RD.TRANSFER_IN_NOTE, RD.TRANSFER_OUT_TIME, RD.TRANSFER_OUT_NOTE,
         RD.COMMING_KIND, RD.LEAVING_KIND - 1, RD.IS_VIP, RD.COUNTRY, RD.CODE_FIRST_FOOD, RD.I_SPECIAL_TREATMENT,
         RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON,
         RD.ID_NOM_COME_REASON, RD.ID_AGENT_ACCOUNT_RULE, RD.ACC_ROUTING, RD.ID_PERSON_PAYMENT, RD.ID_AGENT_PAYMENT,
         RD.ROOM_FEATURES, RD.ID_HK_PLAN, RD.ID_GROUP, RD.ID_HOTEL, RD.NOTE, RD.NOTE_REMINDERS,
         RD.GUARANTEE_DEPOSIT, RD.GUARANTEE_CURRENCY, RD.ID_ACC_TEMPLATE_PERSON,
         RD.NUMBER_1, rd.NUMBER_2, rd.ID_GUARANTEE_POLICY, rd.BLOCK_CC, rd.IS_POSTING_STOPPED, rd.ID_EATING_OBJECT
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail_source
  into   :rd_dbkey_old, :id_agent_profile, :check_status, :arrival_date, :departure_date,
         :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff,
         :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
         :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
         :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
         :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
         :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
         :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
         :guarantee_deposit, :guarantee_currency, :id_acc_template_person,
         :number_1, :number_2,:id_guarantee_policy, :block_cc, :is_posting_stopped, :id_eating_object;

  select first 1 sp.ITEM
  from   SYSTEM_STRING_PARSER(:guest_ids, ',') sp
  into   :id_titular;

  select min(g.FROM_DATE), max(g.TO_DATE)
  from   GUEST G
  where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL_SOURCE
         and ','||:GUEST_IDS||',' containing ','||g.ID_GUEST||','
  into   :arrival_date, :departure_date;

  if (exists (select *
              from   RESERV_DETAIL RD
              where  RD.ID_TITULAR = :id_titular
                     and RD.ID_RESERV_DETAIL = :id_reserv_detail_source))
  then exception BOOKING_EXCEPTION 'Titular can not be splited in new reservation';

  execute procedure RES_GET_PERSON_PROFILE$INT(:id_titular)
  returning_values  :id_person_profile, :id_profile_data;

  new_res_number = iif(coalesce(:number_1,'')='','.',:number_1||'.')
                   || coalesce(:number_2, '')
                   || '.0';  -- fictive suffix, needed for unique constraint limitation, that will be replaced with real one


  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    0, 0, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, 0, null, :new_res_number, :id_acc_template_person,
                    :id_guarantee_policy, :block_cc, :id_eating_object)
  returning_values  :rd_dbkey_new, :new_id_reserv_detail, :warn_code;

  execute procedure RES_NUMBER_SUFFIX_GEN (:NEW_ID_RESERV_DETAIL)
  returning_values  (:new_res_number);  -- add suffix to new (splited) booking number (empty on create)

  update RESERV_DETAIL NR
  set    nr.IS_POSTING_STOPPED = :is_posting_stopped
  where  nr.RDB$DB_KEY = :rd_dbkey_new;

  -- there is no need guests deleting, because new splited reservation is created with 0 guests
  adult_count = 0; child_count = 0;
  for
    select G.ID_GUEST, G.RDB$DB_KEY, G.IS_CHILD
    from   SYSTEM_STRING_PARSER(:guest_ids, ',') SP
           join GUEST G on G.ID_GUEST = SP.ITEM
    into   :id_guest, :g_dbkey, :is_child
  do begin
    execute procedure GUEST_SET_EDIT_STATUS$INT (:g_dbkey, 'REBUILD', 'add');

    update GUEST G
    set    G.ID_RESERV_DETAIL = :new_id_reserv_detail
    where  G.ID_GUEST = :id_guest;

    adult_count = :adult_count + (1-:is_child);
    child_count = :child_count + :is_child;

    if (:id_guest = :id_titular) then begin
      update RESERV_DETAIL RD
      set    RD.ID_TITULAR = :id_titular
      where  RD.RDB$DB_KEY = :rd_dbkey_new;

      update GUEST_DATA GD
      set    GD.ID_PERSON_DATA = :id_profile_data
      where  GD.ID_GUEST = :id_titular;
    end
  end

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL_SOURCE, 'RES_SPLIT',
          f_character(29) || :new_res_number || f_character(28) || :adult_count || ' + ' || :child_count);

  -- calling RES_SAVE_PROFILING$INT is unnecessary, it is called into RES_CREATE_SET$INT with same params
  -- here is needed to set reserv accounts per splited guests and reroute posting only (accomplished in next procedure)
  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey_new);

  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_old);
  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_new);

  update RESERV_DETAIL ORD
  set    ord.ROOM_PRICE = null
  where  ord.RDB$DB_KEY = :rd_dbkey_old;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_old, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_new, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  if (:id_room < 0) then begin
    virtual_room = gen_id(GEN_VIRTUAL_ROOM, 1);
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = '<'||:virtual_room||'>'
    where  rd.ID_ROOM = :id_room;
  end
end
^

/* Alter (RES_SPLIT_MULTI$RSV) */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
begin
  for
    select RD.ID_RESERV_DETAIL, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_titular
  do begin
    for
      select G.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.ID_GUEST <> :id_titular
      into   :id_guest
    do begin
      execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
      returning_values  :id_splited_reservation;

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_RECALC$INT for: RES_TAR_CALC_FINALIZE$INT */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_TAR_CALC_FINALIZE$INT) */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(ID_TAR_CALC INTEGER,
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
declare variable old_room_price numeric(15,4);
  declare variable old_room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
  declare variable reserv_posting_disabled smallint;
  declare variable postings_disabled smallint;
  declare variable warn_code integer;
  declare variable action_text varchar(255);
  declare variable id_guest integer;
begin
  --  Razpiswa cenata na staia, kakto i price_detailite.

  execute procedure TAR_CALC_EVAL_ALL$INT(:ID_TAR_CALC)
  returning_values  :ERR_CODE, :ERR_TEXT;

  if (:ERR_CODE = 0) then execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

  select iif(si.INFO_VALUE = '1', 1, null)
  from   SYSTEM_INFO_GET('RESERV_POSTINGS_DISABLED') si
  into   :postings_disabled;

  for
    select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, coalesce(:postings_disabled, rd.IS_POSTING_STOPPED),
           coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
           coalesce(max((select first 1 AP.IS_BASE
                         from   GUEST G
                                join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                         where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (it`s possible)
    from   TAR_CALC_INPUT$TMP TI
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
           join TARIFA t on t.ID_TARIFA = rd.ID_RATE
    where  ti.ID_TAR_CALC = :ID_TAR_CALC
    group by 1, 2, 3, 4, 5, 6
    into   :id_reserv_detail, :check_status, :is_posting_stopped,
           :room_currency, :id_hotel, :is_anul, :has_postings
  do begin
    reserv_posting_disabled = iif(:is_posting_stopped = 1 and :has_postings = 0, 1, 0);

    if (:ERR_CODE <> 0) then begin
      -- price calculation error handling  !!!!!
      if (:reserv_posting_disabled = 1) then begin
        -- set price to null, posting is disabled
        update RESERV_DETAIL RD
        set    RD.ROOM_PRICE = null,
               RD.ROOM_CURRENCY = null,
               RD.ROOM_PRICE_DETAILS = null,
               RD.LAST_ID_TAR_CALC = null
        where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
      end else begin
        -- exit on error in price calculation - cannot make valid posts
        EXIT;
      end
    end else begin
      room_price = 0;
      room_price_details = '';
    
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);
  
      if (:reserv_posting_disabled = 0 and ((coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1))) then begin
        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);
      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;
  
        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end
  
      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc,
             rd.ROOM_PRICE_LAST$INT = null,
             rd.ROOM_CURRENCY_LAST$INT = null
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail
      returning old.ROOM_PRICE_LAST$INT, old.ROOM_CURRENCY_LAST$INT
      into :old_room_price, :old_room_currency;

      if ((:old_room_price is distinct from :room_price)
          or (:old_room_currency is distinct from :room_currency) ) then
      begin
        action_text = f_character(29) || formatfloat(:old_room_price, 'F;0.00') || ' ' || coalesce(:old_room_currency, '') || f_character(28) || formatfloat(:room_price, 'F;0.00') || ' ' || coalesce(:room_currency, '');
        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_PRICE_RECALC', :action_text);

        if (:check_status >= 0) then begin
          for
            select g.ID_GUEST
            from   GUEST G
            where  g.ID_RESERV_DETAIL = :id_reserv_detail
            into   :id_guest
          do begin
            execute procedure GUEST_REGISTRATION_UPDATE(:id_guest);
          end
        end
      end
    end
  end

  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;

  if (:ERR_CODE <> 0) then begin
    execute procedure SYSTEM_WARNING_ADD(:ERR_CODE, :ERR_TEXT)
    returning_values :warn_code;
    ERR_CODE = 0;
    ERR_TEXT='';
  end
end
^

/* Alter (RESGRP_DELETE$RSV) */
ALTER PROCEDURE RESGRP_DELETE$RSV(ID_GROUP INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable id_reserv_detail integer;
  declare variable tmp_warn_code integer;
begin

  for
    select RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
           left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = rd.ID_ROOM_TYPE
    where  RD.ID_GROUP = :id_group
    into   :id_reserv_detail
  do begin
    execute procedure RES_DELETE$INT(:id_reserv_detail, :REASON)
    returning_values :tmp_warn_code, :extra_posts_left;
    if (:warn_code is null) then WARN_CODE = :tmp_warn_code;
  end
end
^

/* empty dependent procedure body */
/* Clear: SAFE_CHECK_OUT for: SAFE_OCCUPANCY_MODIFY */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE /* TYPE OF ID */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
WARN_CODE /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SAFE_OCCUPANCY_MODIFY) */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable old_rate_price tprice;
  declare variable old_rate_curr tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';
  DOC_SELECTED = null;

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation
  returning old.rate_price, old.rate_curr
  into :old_rate_price, :old_rate_curr;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  if ((:old_rate_curr <> :currency) or (:old_rate_price <> :price)) then begin
    execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
            :price_description, :id_reserv_detail)
    returning_values (:DOC_SELECTED);
  end

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Alter (SAFE_OCCUPANCY_NEW) */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_INPUT_PARAMS$INT for: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_PARAMS$INT) */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* Restore proc. body: ACCOUNT_MODIFY$INT */
ALTER PROCEDURE ACCOUNT_MODIFY$INT(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL TYPE OF ID_REF,
IS_PMS_ACCOUNT TYPE OF TLOGICAL,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable a_dbkey char(8);
  declare variable old_sec_level integer;
  declare variable action_text varchar(255);
  declare variable old_acc_name varchar(50);
  declare variable old_acc_curr varchar(3);
  declare variable old_tax_policy integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, archive');

  new_id_account = :id_account;
  if (:operation = 'add') then begin
    if ((:new_id_account is null) or (:new_id_account <= 0)) then new_id_account = gen_id(ID_ACCOUNT_GEN, 1);

    insert into ACCOUNT(ID_ACCOUNT, ACCOUNT_CURR, ACCOUNT_NAME, IS_CREDIT_ACCOUNT, CREDIT_LIMIT,
           ID_TYPE_PAYMENT, NOTE, IS_BLOCKED, BLOCK_TEXT, SECURITY_LEVEL, IS_BASE, IS_EXTRA,
           IS_ALOWED_POS_INTERFACE, POS_INTERFACE_NOTE, EXT_CODE, ID_TAX_POLICY, ID_PROFILE,
           ID_HOTEL, IS_DEFAULT, IS_PMS_ACCOUNT, ID_RESERV_DETAIL)
    values (:new_id_account, :account_curr, :account_name, 0, null,
           :id_type_payment, :note, :is_blocked, :block_text, :security_level, :is_base, :is_extra,
           :is_alowed_pos_interface, :pos_interface_note, :ext_code, :id_tax_policy, :id_profile,
           :id_hotel, :is_default, coalesce(:IS_PMS_ACCOUNT, 0), :ID_RESERV_DETAIL)
    returning RDB$DB_KEY
    into   :a_dbkey;

    action_text = f_character(29) || :new_id_account || '/' || :account_name;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'ADD_ACCOUNT', :action_text);

    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:NEW_ID_ACCOUNT, :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT);
    -- check special right and log event

  end else begin
    ID_RESERV_DETAIL = null;
    select A.RDB$DB_KEY, A.ID_RESERV_DETAIL, A.SECURITY_LEVEL,
           A.ACCOUNT_NAME, A.ACCOUNT_CURR, A.ID_TAX_POLICY
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :a_dbkey, :id_reserv_detail, :old_sec_level,
           :old_acc_name, :old_acc_curr, :old_tax_policy;
    if (:operation = 'mod') then begin
  
      update ACCOUNT A
      set    A.ACCOUNT_NAME = :account_name,
             A.ID_TYPE_PAYMENT = :id_type_payment,
             A.NOTE = :note,
             A.IS_BLOCKED = :is_blocked,
             A.BLOCK_TEXT = :block_text,
             A.SECURITY_LEVEL = :security_level,
             A.IS_BASE = :is_base,
             A.IS_EXTRA = :is_extra,
             A.IS_ALOWED_POS_INTERFACE = :is_alowed_pos_interface,
             A.POS_INTERFACE_NOTE = :pos_interface_note,
             A.EXT_CODE = :ext_code,
             A.ID_TAX_POLICY = :id_tax_policy,
             A.IS_DEFAULT = :is_default
      where  A.RDB$DB_KEY = :a_dbkey;
  
      execute procedure ACCOUNT_SET_CURRENCY$INT (:a_dbkey, :account_curr);
  
      if (:old_acc_name <> :account_name) then begin
        action_text = f_character(29 ) || :ID_ACCOUNT || '/' || :old_acc_name || ', ' || :old_acc_curr
                      || f_character(28) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME || ', ' || :ACCOUNT_CURR;
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'EDIT_ACCOUNT', :action_text);
      end
  
      if (:old_sec_level <> :SECURITY_LEVEL) then begin
        action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME
                      || f_character(28) || :SECURITY_LEVEL;
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'SET_ACC_SEC_LEVEL', :action_text);
      end
  
      if (:old_tax_policy <> :id_tax_policy) then begin
        execute procedure ACCOUNT_TAXATION_RECALC$INT (:ID_ACCOUNT, :ID_TAX_POLICY);
  
        action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME;                        
  
        select :action_text || f_character(28) || OTP.POLICY_NAME
        from   TAX_POLICY OTP
        where  OTP.ID_TAX_POLICY = :old_tax_policy
        into   :action_text;
        select :action_text || f_character(28) || NTP.POLICY_NAME
        from   TAX_POLICY NTP
        where  NTP.ID_TAX_POLICY = :ID_TAX_POLICY
        into   :action_text;
         
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'VAT_POLICY_CHNG', :action_text);
      end
  
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:ID_ACCOUNT, :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT); -- check special right and log event
  
    end else if (:operation = 'archive') then begin
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 1);

    end
  end

  if ((:id_reserv_detail is null) and (:IS_CREDIT_ACCOUNT = 0)) then begin
    exception ACCOUNT_EXCEPTION '-1010';
    -- The account must have active credit status
    exit;
  end

  if (:is_default = 1) then begin
    update ACCOUNT A
    set    A.IS_DEFAULT = 0
    where  A.ID_HOTEL = :id_hotel
           and A.ID_PROFILE = :id_profile
           and A.ID_ACCOUNT <> :new_id_account;
  end
end
^

/* Restore proc. body: ACCOUNT_MODIFY$PROFILE */
ALTER PROCEDURE ACCOUNT_MODIFY$PROFILE(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_CONTRAGENT INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable is_pms_account tlogical;
  declare variable id_sale_num integer;
begin

  select a.ID_RESERV_DETAIL, a.IS_PMS_ACCOUNT
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :id_reserv_detail, :is_pms_account;

  execute procedure ACCOUNT_MODIFY$INT (:ID_ACCOUNT, :ID_PROFILE, :ACCOUNT_CURR, :ACCOUNT_NAME,
          :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT, :ID_TYPE_PAYMENT, :NOTE, :IS_BLOCKED, :BLOCK_TEXT,
          :SECURITY_LEVEL, :IS_BASE, :IS_EXTRA, :IS_ALOWED_POS_INTERFACE, :POS_INTERFACE_NOTE,
          :EXT_CODE, :ID_TAX_POLICY, :IS_DEFAULT, :ID_HOTEL, :ID_RESERV_DETAIL, :IS_PMS_ACCOUNT, :OPERATION)
  returning_values (:NEW_ID_ACCOUNT);

  update ACCOUNT a
  set    a.ID_CONTRAGENT = :ID_CONTRAGENT
  where  a.ID_ACCOUNT = :NEW_ID_ACCOUNT;

  if (:OPERATION = 'add' and exists (select p.ID_PROFILE
                                     from   PROFILE_HOUSE p
                                     where  p.ID_PROFILE = :ID_PROFILE
                                            and p.HOUSE_TYPE in ('hptExternalRevenue', 'hptComplimentary'))) then
  begin
    execute procedure ACCOUNT_SALE_NUMBER_SET(:NEW_ID_ACCOUNT)
    returning_values (:id_sale_num);
  end
end
^

/* Restore proc. body: ACCOUNT_POST_MODIFY$PMS */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
declare variable id_account integer;
  declare variable id_service integer;
  declare variable date_post date;
  declare variable is_owner_income smallint;
  declare variable is_account_post_item smallint;
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable no_use_id_acc_post integer;
  declare variable ap_dbkey char(8);
begin
  -- da se wika samo ot GUI
  if ( (:ID_ACCOUNT_POST is null) and (:ID_ACCOUNT_POST_PMS is null) ) then begin
    exception WRONG_PARAM_VALUE;
    exit;
  end

  is_account_post_item = iif(:id_account_post is not null, 1, 0);

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'mod, anul');

  if (:operation in ('mod', 'anul')) then begin
    -- prowerka: ot GUI-to mogat da se anulirat samo nedokumentirani i neanulirani nachisleniq
    if (:is_account_post_item = 1) then begin
      if ( (:ID_PMS_EVENT > 0) and
           not exists ( select *
                        from   PMS_EVENT_POST PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      select ap.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  ap.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
      into   :ap_dbkey;

      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_dbkey, 'PMS GUI VOID');

      update PMS_EVENT_POST PP
      set    PP.LINE_STATUS = 22
      where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST;

    end else if (:ID_ACCOUNT_POST_PMS is not null) then begin
      if ( not exists ( select *
                        from   ACCOUNT_POST$PMS PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      execute procedure ACCOUNT_POST_PMS_ANUL$INT(:ID_PMS_EVENT, :ID_ACCOUNT_POST_PMS);
    end

    if (:operation = 'mod') then begin
      id_account = null;
      if (:is_account_post_item = 1) then begin
        select AP.ID_ACCOUNT, AP.ID_SERVICE, AP.DATE_POST, PP.ID_OWNER, 0, ap.id_room
        from   ACCOUNT_POST AP
               join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and PP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :id_owner, :is_owner_income, :id_room;
      end else begin
        select AP.ID_ACCOUNT_PMS, AP.ID_SERVICE, AP.DATE_POST, AP.IS_OWNER_INCOME, AP.ID_OWNER
        from   ACCOUNT_POST$PMS AP
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
               and AP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :is_owner_income, :id_owner;
      end
      if (:id_account is null) then exit;

      execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_account, :id_service, :id_owner, :date_post,
              :in_curr_orig, :in_value_orig, 1 - :is_account_post_item, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Restore proc. body: ACCOUNT_POSTING_DOC_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_DOC_UPDATE$INT(DH_DBKEY TYPE OF TDB_KEY)
 RETURNS(WARN_CODE TYPE OF TRANGE)
 AS
declare variable date_post date;
  declare variable old_date_post date;
  declare variable curr_post varchar(3);
  declare variable old_curr_post varchar(3);
  declare variable rate_post numeric(15,6);
  declare variable curr_orig varchar(3);
  declare variable old_curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable dbkey char(8);
  declare variable id_account_post integer;
  declare variable doc_date date;
  declare variable doc_release_ap integer;
  declare variable qty_post numeric(15,2);
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable price_orig numeric(15,4);
  declare variable price_post double precision;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable id_sale_taxation integer;
  declare variable id_base_doc integer;
  declare variable doc_operation varchar(10);
  declare variable is_anul_doc integer;
  declare variable is_storno integer;
  declare variable id_doc_head integer;
  declare variable posts_value double precision;
  declare variable line_value double precision ;
  declare variable action_text varchar(255);
  declare variable action_code varchar(30);
  declare variable account_curr varchar(3);
  declare variable id_ap_base_doc integer;
  declare variable new_is_anul integer;
  declare variable new_is_closed integer;
  declare variable doc_qty numeric(15,2);
  declare variable doc_price double precision;
  declare variable id_hotel integer;
  declare variable round_to numeric(15,4);
  declare variable proforma_dt_created timestamp;
  declare variable new_ac varchar(2);
  declare variable id_tax_policy integer;
  declare variable id_service integer;
  declare variable nat_round_to numeric(15,4);
  declare variable id_sale_num integer;
begin

  select D.ID_DOC_HEAD, iif(D.IS_ANUL = 0, D.DOC_DATE, DA.ANNULMENT_DATE),
         D.ID_BASE_DOC, D.IS_ANUL, D.IS_STORNO, a.ID_TAX_POLICY, c.ROUND_TO,
         A.ID_ACCOUNT, A.ACCOUNT_CURR, a.id_hotel, pd.DATETIME_CREATED
  from   DOC_HEAD$INT D
         join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join HOTEL h on h.ID_HOTEL = a.ID_HOTEL
         join CURRS c on c.CURR = h.NATION_CURR
         left outer join DOC_ANNULMENT DA on DA.ID_DOC_HEAD = D.ID_DOC_HEAD
         left outer join DOC_HEAD$INT pd on pd.ID_DOC_HEAD = dc.ID_DOC_PROFORMA
  where  D.RDB$DB_KEY = :DH_DBKEY
  into   :id_doc_head, :doc_date, :id_base_doc, :is_anul_doc, :is_storno, :id_tax_policy, :nat_round_to,
         :id_account, :account_curr, :id_hotel, :proforma_dt_created;

  if (:id_doc_head is null) then exit;

  doc_operation = case when :is_anul_doc = 1 then 'anul'
                       when :is_storno   = 1 then 'storno'
                       else 'new'
                  end;

  doc_release_ap = -gen_id(DOC_SELECTED_GEN, 1);
  /*   */
  posts_value = 0;
  if (:doc_operation = 'new') then begin
    for
      select AP.RDB$DB_KEY, AP.ID_ACCOUNT_POST, DL.QTY_POST, PV.ACCOUNT_PRICE,
             ap.QTY_POST, ap.PRICE_POST, c.ROUND_TO
      from   ACCOUNT_POST AP
             join DOC_LINE_POST_VALUES PV on PV.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
             join DOC_LINE DL on DL.ID_DOC_LINE = PV.ID_DOC_LINE
             join CURRS C on c.CURR = ap.CURR_POST
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
      into   :dbkey, :id_account_post, :doc_qty, :doc_price,
             :qty_post, :price_post, :round_to
    do begin
      posts_value = :posts_value + :doc_price * :doc_qty;  -- logable value accumulation
      /*  if (:is_anul = 1) - annul corrective document, else - new valid document */
      /* annulment/storno of base document is in other case - operation "anul"  */
      if (:proforma_dt_created is not null) then begin
        new_is_anul = 0;
        new_is_closed = iif(cast(round_f(:qty_post - :doc_qty, :round_to) as numeric(15,2)) = 0
                            and cast(round_f(:price_post - :doc_price, :round_to) as numeric(15,2)) = 0,
                            1,
                            0);
      end else begin
        new_is_anul = 0;
        new_is_closed = 1;
        doc_qty = :qty_post;
        doc_price = :price_post;
      end

      update ACCOUNT_POST AP
      set    AP.ID_BASE_DOC   = :id_base_doc,
             AP.IN_DOC_QTY    = :doc_qty,
             AP.IN_DOC_VALUE  = :doc_price,
             AP.IS_ANUL       = :new_is_anul,
             AP.AC            = :new_is_anul || :new_is_closed,
             AP.DOC_SELECTED  = :doc_release_ap,
             AP.DATETIME_CHANGED = current_timestamp
      where  AP.RDB$DB_KEY = :DBKEY
      returning ap.ac into :new_ac;
      if (:new_ac = '00') then begin
        execute procedure SYSTEM_WARNING_ADD (-1061, '')
        returning_values (:warn_code);
      end

      update ACCOUNT_POST_CORRECTION APCU
      set    APCU.ID_DOC_HEAD  = iif(apcu.DATETIME_CREATED < coalesce(:proforma_dt_created, current_timestamp), :ID_DOC_HEAD, -1),
             APCU.IS_OPEN      = iif(apcu.DATETIME_CREATED < coalesce(:proforma_dt_created, current_timestamp), 0, 1)
      where  APCU.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
             and coalesce(APCU.ID_DOC_HEAD, -1) = -1;
    end

    action_text = f_character(29) || formatfloat(abs(:posts_value), 'F;0.00') || ' ' || :account_curr;
    action_code = 'CLOSE_POSTINGS';
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, :action_code, :action_text);

  end else if (:doc_operation in ('anul', 'storno')) then begin
    /* annulment/storno of base document - release all postings */
    /*   */
    old_date_post = '01.01.1900';
    old_curr_post = '';
    old_curr_orig = '';
    posts_value = 0;
    /*   */
    for
      select distinct AP.RDB$DB_KEY, AP.ID_ACCOUNT, AP.ID_GUEST, AP.ID_SALE_TAXATION, AP.ID_BASE_DOC,
             AP.QTY_POST, AP.PRICE_POST, AP.DATE_POST, AP.CURR_POST, AP.CURR_ORIG, AP.PRICE_ORIG,
             AP.ID_ACCOUNT_POST, AP.POST_NET_VALUE, AP.POST_GROSS_VALUE, AP.RATE_POST, AP.RATE_ORIG,
             PV.ACCOUNT_PRICE * DL.QTY_POST, c.ROUND_TO, ap.ID_SERVICE
      from   ACCOUNT_POST AP
             join DOC_LINE_POST_VALUES PV on PV.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
             join DOC_LINE DL on DL.ID_DOC_LINE = PV.ID_DOC_LINE
             join CURRS C on c.CURR = ap.CURR_POST
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
      order by AP.DATE_POST, AP.CURR_POST, AP.CURR_ORIG
      into   :dbkey, :id_account, :id_guest, :id_sale_taxation, :id_ap_base_doc,
             :qty_post, :price_post, :date_post, :curr_post, :curr_orig, :price_orig,
             :id_account_post, :post_net_value, :post_gross_value, :rate_post, :rate_orig,
             :line_value, :round_to, :id_service
    do begin
      if (:id_ap_base_doc is not null and :id_ap_base_doc is distinct from :id_base_doc) then
        exception DOCUMENT_EXCEPTION '-365';

      doc_qty = null;
      doc_price = 0;
      if (:DOC_OPERATION = 'anul') then begin
        select sum(DL.QTY_POST * (1 - DL.IS_CORRECT)) as DOC_QTY,
               sum(DLP.ACCOUNT_PRICE * DL.QTY_POST) /* / sum(DL.QTY_POST * (1 - DL.IS_CORRECT))*/ as DOC_VALUE
        from   DOC_HEAD DH
               join DOC_LINE DL on DL.ID_DOC_HEAD = DH.ID_DOC
               join DOC_LINE_POST_VALUES DLP on dlp.ID_DOC_LINE = dl.ID_DOC_LINE
        where  DH.IS_ANUL = 0
               and DLP.ID_ACCOUNT_POST = :id_account_post
               and DH.ID_BASE_DOC = :id_base_doc
        into   :doc_qty, :doc_price;
        if (:doc_qty = 0) then doc_price = 0;
        else doc_price = :doc_price / :doc_qty;
      end

      if (:doc_qty is null) then begin
        -- update prices only for released posting
        select tp.ID_SALE_TAXATION
        from   SERVICE_TAXATION tp
        where  tp.ID_TAX_POLICY = :id_tax_policy
               and tp.ID_SERVICE = :id_service
        into   :id_sale_taxation;  -- get actual taxation

        if (:date_post >= :doc_date) then begin
          /* update rates for prepaid postings (date_post >= doc_date) if base doc is annul */
          if ((:old_date_post <> :date_post) or (:old_curr_post <> :curr_post) ) then begin
            execute procedure ACCOUNT_POSTING_RATE_GET (:id_hotel, :curr_post, :date_post, :id_guest)
            returning_values  :RATE_POST;
          end
    
          if ((:OLD_DATE_POST <> :DATE_POST) or (:OLD_CURR_ORIG <> :CURR_ORIG) ) then begin
            execute procedure ACCOUNT_POSTING_RATE_GET (:id_hotel, :curr_orig, :date_post, :id_guest)
            returning_values  :rate_orig;
          end
  
          execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:qty_post, :price_orig,
                            :rate_orig, :rate_post, :id_sale_taxation)
          returning_values  :price_post, :post_net_value, :post_gross_value;
        end else begin
          -- recalc only nat net value with actual taxation
          select tv.VALUE_WOT_TAX
          from   TAX_VALUE_DEDUCT (:qty_post * :price_post * :rate_post, :nat_round_to, :id_sale_taxation) tv
          into   :post_net_value;
        end
      end

      new_is_anul = iif(:qty_post = 0 and :doc_qty is null, 1, 0);
      new_is_closed = iif(:doc_qty is not null
                          and cast(round_f(:qty_post - :doc_qty, :round_to) as numeric(15,2)) = 0
                          and cast(round_f(:price_post - :doc_price, :round_to)  as numeric(15,2)) = 0,
                          1,
                          0);

      update ACCOUNT_POST AP
      set    AP.IN_DOC_VALUE  = iif(:doc_qty is null, 0, :doc_price),
             AP.IN_DOC_QTY    = iif(:doc_qty is null, 0, :doc_qty),
             AP.RATE_ORIG     = :rate_orig,
             AP.RATE_POST     = :rate_post,
             AP.PRICE_POST    = :price_post,
             AP.POST_NET_VALUE = :post_net_value,
             AP.POST_GROSS_VALUE = :post_gross_value,
             AP.ID_SALE_TAXATION  = :id_sale_taxation,
             AP.ID_BASE_DOC   = iif(:doc_qty is null, null, :ID_BASE_DOC),
             AP.IS_ANUL       = :new_is_anul,
             AP.AC            = :new_is_anul || :new_is_closed,
             AP.ANUL_DATETIME = iif(:new_is_anul = 1, current_timestamp, ap.anul_datetime),
             AP.DATETIME_CHANGED = current_timestamp
      where  AP.RDB$DB_KEY = :DBKEY;

      if (:doc_operation = 'anul') then begin
        update ACCOUNT_POST_CORRECTION APCU
        set    APCU.ID_DOC_HEAD  = -1,
               APCU.IS_OPEN      = iif(:DOC_QTY is not null, 1, apcu.IS_OPEN)
        where  APCU.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and APCU.ID_DOC_HEAD = :ID_DOC_HEAD;
      end else begin  -- 'storno'
        update ACCOUNT_POST_CORRECTION APCU
        set    APCU.ID_DOC_HEAD  = -1,
               APCU.IS_OPEN      = iif(:DOC_QTY is not null, 1, apcu.IS_OPEN)
        where  APCU.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and APCU.ID_DOC_HEAD in (select d.ID_DOC from DOC_HEAD d where d.ID_BASE_DOC = :id_base_doc);
      end

      old_curr_post = :curr_post;
      old_curr_orig = :curr_orig;

      posts_value = :posts_value + :line_value;
    end  /* for select ... do begin  */

    execute procedure ACCOUNT_SALE_NUMBER_SET(:id_account)
    returning_values (:id_sale_num);

    action_text = f_character(29) || formatfloat(abs(:posts_value), 'F;0.00') || ' ' || :account_curr;
    action_code = 'OPEN_POSTINGS';
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, :action_code, :action_text);
  end  /* call type in (STORNO, ANUL)  */
end
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$ACC */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
declare variable ap_dbkey char(8);
  declare variable transfer_value double precision;
  declare variable post_value double precision;
  declare variable id_account integer;
  declare variable tmp_id_account integer;
  declare variable curr_post varchar(3);
  declare variable acc_name varchar(50);
  declare variable action_text varchar(255);
  declare variable is_pms_account integer;
  declare variable dest_acc_name varchar(50);
begin

  id_account = null;
  transfer_value = 0;

  select ACC.ACCOUNT_NAME, acc.IS_PMS_ACCOUNT
  from   ACCOUNT ACC
  where  ACC.ID_ACCOUNT = :ID_DEST_ACCOUNT
  into   :dest_acc_name, is_pms_account;

  if (:is_pms_account = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('PMS_TRANSFER_POSTINGS');
  end

  for
    select AP.RDB$DB_KEY, AP.ID_ACCOUNT, ap.PRICE_POST * ap.QTY_POST
    from   ACCOUNT_POST AP
    where  AP.DOC_SELECTED = :DOC_SELECTED
           and AP.ID_ACCOUNT = coalesce(:ID_SRC_ACCOUNT, AP.ID_ACCOUNT)
           and AP.ID_ACCOUNT is distinct from :ID_DEST_ACCOUNT
    order by AP.ID_ACCOUNT asc
    into   :ap_dbkey, :tmp_id_account, :post_value
  do begin
    execute procedure ACCOUNT_POSTING_TRANSFER$INT (:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:id_account is null) then id_account = :tmp_id_account;

    /* update from/to pms account */
    execute procedure ACCOUNT_POST_EVENT_REROUTE$INT(:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:tmp_id_account is distinct from :id_account) then begin
      select A.ACCOUNT_NAME, A.ACCOUNT_CURR
      from   ACCOUNT A
      where  A.ID_ACCOUNT = :id_account
      into   :acc_name, :curr_post;

      action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                    f_character(28) || :id_account || '/' || :acc_name ||
                    f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
      execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
      id_account = :tmp_id_account;
      transfer_value = 0;
    end
    transfer_value = :transfer_value + :post_value;
  end

  if (:id_account is not null) then begin
    select A.ACCOUNT_NAME, A.ACCOUNT_CURR
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :acc_name, :curr_post;
  
    action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                  f_character(28) || :id_account || '/' || :acc_name ||
                  f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
  end
end
^

/* Restore proc. body: APPLY_BOOKING_STATUS$EXC */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20)
 AS
declare variable err_text varchar(255);
declare variable dummy_int integer;
declare variable anul_reason varchar(30);
declare variable selection_id integer;

declare variable status_code smallint;
declare variable current_anul_code smallint;
declare variable current_status_code smallint;
declare variable current_status_text varchar(50);
declare variable new_status_text varchar(50);
declare variable extra_posts_left integer;
declare variable check_out_kind smallint;
declare variable earlycheckout_date date;
begin
  if (:booking_db_key is null) then begin
    select rd.RDB$DB_KEY, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.ID_RESERV_DETAIL = :BOOKING_ID
    into   :booking_db_key, :current_status_code, :current_anul_code;
  end else begin
    select rd.id_reserv_detail, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.rdb$db_key = :booking_db_key
    into   :booking_id, :current_status_code, :current_anul_code;
  end

  execute procedure IMPORT_BOOKING_STATUS$EXC(:status, -2)
  returning_values :status_code;

  execute procedure EXPORT_BOOKING_STATUS$EXC(:current_status_code, :current_anul_code)
  returning_values :current_status_text;
  execute procedure IMPORT_BOOKING_STATUS$EXC(:current_status_text, :current_status_code)
  returning_values :current_status_code;

  /* nop - exit */
  if (:current_status_code = :status_code) then exit;

  /* validate status transition */
  if (
     /* terminal status values - void booking */
    (:current_status_code in (1004/*no show*/, 1005/*canceled*/))

    /* void over checkin */
    or ((:current_status_code >= 0) and (:status_code in (1004/*no show*/, 1005/*canceled*/)))

    /* positive status downgrade */
    or ((:current_status_code > 0) and (:current_status_code > :status_code))
  )  then begin
    execute procedure PRINT_BOOKING_STATUS$EXC(:current_status_code) returning_values :current_status_text;
    execute procedure PRINT_BOOKING_STATUS$EXC(:status_code) returning_values :new_status_text;

    exception VALIDATE_EXCEPTION '-1022' || f_character(31) || '@{invalid_status_transition} ' || :current_status_text || ' -> ' || :new_status_text;
  end

  anul_reason = null;
  if (1004 = :status_code) then begin
    anul_reason = 'NOSHOW';
  end else if (1005 = :status_code) then begin
    anul_reason = 'CANCELED';
  end

  if (:anul_reason is null) then begin
    if (0 > :status_code) then begin
      execute procedure RES_SAVE_STATUS$INT(:booking_db_key, :status_code, :CONFIRMATION_NUMBER);
    end else begin
      if (:status_code in (0, 1) and 0 > :current_status_code) then begin
        -- checkin
        execute procedure RES_SET_CHECKIN$INT (:booking_db_key)
        returning_values (:dummy_int, :err_text, :dummy_int, :dummy_int);
      end
      if (1 = :status_code and 1 > :current_status_code) then begin
        -- checkout
        selection_id = gen_id(SELECTION_GEN, 1);
        update RESERV_DETAIL
        set    selection_id=:selection_id
        where  rdb$db_key=:booking_db_key
        returning new.CHECK_OUT_KIND, new.EARLYCHECKOUT_DATE
        into   :check_out_kind, :earlycheckout_date;
    
        execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, :check_out_kind, :earlycheckout_date);
      end
    end
  end else begin
    -- void
    execute procedure RES_ANUL_DETAIL$INT(:booking_db_key, :anul_reason, :CANCELATION_NUMBER)
    returning_values  :dummy_int, :extra_posts_left;
    if (:extra_posts_left = 1) then exception BOOKING_EXCEPTION '-1042';

  end
end
^

/* Restore proc. body: CONTRACT_EXPENSE_POST$INT */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT TYPE OF ID,
ID_HOTEL INTEGER,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_OWNER TYPE OF ID,
OWNERSHIP_PERCENT TYPE OF TPERCENT,
ID_RENTAL_POOL TYPE OF ID_REF,
VALUE_ORIG TYPE OF TPRICE,
CURR_ORIG TYPE OF TCURRENCY,
POST_DATE TYPE OF TDATE,
STAY TYPE OF TCOUNT,
MAX_GUEST_CNT TYPE OF TCOUNT,
BED_NIGHT_CNT TYPE OF TCOUNT,
RESERVS TYPE OF TCOUNT)
 AS
declare variable service_price numeric(15,4);
  declare variable id_currency varchar(3);
  declare variable contract_expense_type varchar(50);
  declare variable id_account integer;
  declare variable post_value numeric(15,4);
  declare variable post_currency varchar(3);
  declare variable id_service integer;
  declare variable is_owner_income smallint;
  declare variable is_client_acc_post smallint;
  declare variable multiplier_type varchar(50);
  declare variable multiplier integer;
  declare variable id_room integer;
  declare variable use_shadow_account integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
  declare variable event_price numeric(15,4);
  declare variable id_agent_profile integer;
begin
  is_owner_income = 0;
  use_shadow_account = iif(:SUB_CONTRACT = 'SHADOW_ACC', 1, 0);

  select r.ID_HOTEL, rd.ID_AGENT_PROFILE, p.PRICE_WITH_VAT
  from   PMS_EVENT$PMS p
         join ROOMS R on r.ID_ROOM = p.ID_ROOM
         left outer join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = p.ID_RESERV_DETAIL
  where  p.ID_PMS_EVENT = :ID_PMS_EVENT
  into   :id_hotel, :id_agent_profile, :event_price;
-- CONTRACT_EXPENSE_TYPE in ( 'PERCENT', 'RUNNING_TOTAL_PERCENT', 'CURR_VALUE' )
-- MULTIPLIER_TYPE in ('RESERVATION', 'STAY', 'GUESTS', 'BED_NIGHTS')
  for
    select C.SERVICE_PRICE, C.ID_CURRENCY, C.CONTRACT_EXPENSE_TYPE, C.IS_ACC_POST_ITEM,
           C.ID_SERVICE, C.MULTIPLIER_TYPE
    from   CONTRACT_EXPENSE$PMS C
    where  C.ID_CONTRACT = :id_contract
           and c.SUB_CONTRACT = :SUB_CONTRACT
           and ((c.id_agent_profile is null) or (c.ID_AGENT_PROFILE = :id_agent_profile))
    order by C.ORDER_TAG asc
    into   :service_price, :id_currency, :contract_expense_type, :is_client_acc_post,
           :ID_SERVICE, :multiplier_type
  do begin

    execute procedure OWNER_ACCOUNT_GET$INT (coalesce(:ID_RENTAL_POOL,:ID_OWNER),
            :id_hotel, :use_shadow_account, :is_client_acc_post)
    returning_values (:id_account, :is_account$pms);

    multiplier = case
                   when :multiplier_type = 'RESERVATION' then iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'STAY' then :STAY
                   when :multiplier_type = 'GUESTS' then :MAX_GUEST_CNT * iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'BED_NIGHTS' then :BED_NIGHT_CNT
                   else null
                 end;

    if (:multiplier is not null) then begin
      if (:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE') then begin
        post_value = cast(:service_price as double precision) * :ownership_percent / 100 * :multiplier;
        post_currency = :id_currency;
      end else if (:CONTRACT_EXPENSE_TYPE = 'PERCENT') then begin
        post_value = :VALUE_ORIG * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end else if (:CONTRACT_EXPENSE_TYPE = 'RUNNING_TOTAL_PERCENT') then begin
        execute procedure PMS_RUNNING_TOTAL_GET(:ID_PMS_EVENT, coalesce(:ID_RENTAL_POOL,:ID_OWNER), :ID_HOTEL,
                iif(:is_account$pms = 0, :id_account, null), iif(:is_account$pms = 1, :id_account, null), :POST_DATE, :CURR_ORIG)
        returning_values :post_value;
        if ( (:event_price > 0 and :post_value < 0)
             or (:event_price < 0 and :post_value > 0) ) then post_value = 0;
    
        post_value = :post_value * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end

      select pe.ID_ROOM
      from   PMS_EVENT$PMS PE
      where  pe.ID_PMS_EVENT = :ID_PMS_EVENT
      into   :id_room;

      select c.ROUND_TO
      from   CURRS C
      where  c.CURR = :post_currency
      into   :round_to;

      execute procedure PMS_POSTING_CREATE$INT(:ID_PMS_EVENT, :id_account, :id_service, :ID_OWNER,
              :POST_DATE, :post_currency, round_f(:post_value, :round_to), :is_account$pms, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Restore proc. body: DEPOSIT_REFUND$DOC */
ALTER PROCEDURE DEPOSIT_REFUND$DOC(ID_DEPOSIT INTEGER,
REFUND_AMOUNT NUMERIC(15,4),
REFUND_CURRENCY VARCHAR(3),
ID_PAY_DOC_TYPE INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_REFUND_PAYMENT INTEGER,
ID_STORNO_DOC INTEGER,
WARN_CODE INTEGER)
 AS
declare variable no_use varchar(2000);
  declare variable id_account integer;
  declare variable avail_value numeric(15,4);
  declare variable id_doc_head integer;
  declare variable pay_currency varchar(3);
  declare variable pay_rate numeric(15,6);
  declare variable sys_date date;
  declare variable round_to numeric(15,4);
  declare variable p_dbkey char(8);
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable id_account_payment integer;
  declare variable id_doc_type integer;
  declare variable account_curr varchar(3);
  declare variable account_rate numeric(15,6);
  declare variable id_reserv_detail integer;
  declare variable is_posting_stopped integer;
begin
  WARN_CODE = null;
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_REFUND');

  select D.ID_ACCOUNT, DH.ID_DOC, dh.ID_DOC_TYPE, c.ROUND_TO, d.ID_RESERV_DETAIL,
         D.AVAIL_VALUE, D.PAY_CURRENCY, D.PAY_RATE, A.ID_HOTEL, A.ACCOUNT_CURR
  from   DEPOSIT_AVAILABLE D
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join CURRS C on c.CURR = d.PAY_CURRENCY
         left outer join DOC_HEAD DH on DH.ID_DOC = D.ID_DOC_HEAD
                                        and DH.IS_STORNED = 0
                                        and DH.IS_ANUL = 0
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_account, :id_doc_head, :id_doc_type, :round_to, :id_reserv_detail,
         :avail_value, :pay_currency, :pay_rate, :id_hotel, :account_curr;

  if (:pay_currency is distinct from :refund_currency) then exception PAYMENT_EXCEPTION 'Currency mismatch!';

  if (round_f(:avail_value - :REFUND_AMOUNT, :round_to) < 0) then exception PAYMENT_EXCEPTION '-305';
  --'Issued value is more than available deposit amount.';

  select r.IS_POSTING_STOPPED
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :is_posting_stopped;

  if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';

  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET(:id_hotel) SD
  into   :sys_date;

  select first 1 ap.ACC_RATE
  from   ACCOUNT_PAYMENTS ap
  where  ap.ID_DEPOSIT = :ID_DEPOSIT
  order by ap.ID_ACCOUNT_PAYMENT asc
  into   :account_rate;

  execute procedure PAYMENT_CREATE$INT (:ID_PAY_DOC_TYPE, :ID_ACCOUNT, :SYS_DATE,
          -:REFUND_AMOUNT, :PAY_CURRENCY, :PAY_RATE, :account_curr, :account_rate, :DESCRIPTION)
  returning_values  (:id_refund_payment, :id_account_payment, :no_use);

  insert into DEPOSIT_REFUND (ID_DEPOSIT, ID_PAYMENT_HEAD, DESCRIPTION)
  values (:ID_DEPOSIT, :ID_REFUND_PAYMENT, :DESCRIPTION);

  update ACCOUNT_PAYMENTS AP
  set    AP.ID_DEPOSIT = :ID_DEPOSIT
  where  ap.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

  if (:ID_DOC_HEAD is not null) then begin
    execute procedure DOC_TYPE_EVALUATE$INT (:id_doc_type, :id_hotel, 0, :ID_REFUND_PAYMENT);

    execute procedure DOCUMENT_ADVANCE_STORNO$INT (:ID_DEPOSIT, :REFUND_AMOUNT, :DESCRIPTION)
    returning_values  (:ID_STORNO_DOC, :WARN_CODE);

    execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:ID_STORNO_DOC, :id_account_payment, :pay_rate, null)
    returning_values :no_use;
     
    update  PAYMENT_HEAD P
    set     P.ID_DOC_HEAD = :ID_STORNO_DOC
    where   P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

    execute procedure DOCUMENT_VALIDATE$DOC (:ID_STORNO_DOC)
    returning_values (:no_use, :no_use, :no_use);
  end else begin
    select P.RDB$DB_KEY
    from   PAYMENT_HEAD P
    where  P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT
    into   :P_DBKEY;
     
    execute procedure PAYMENT_SET_NUMBER$INT (:P_DBKEY);
  end

  action_text = F_CHARACTER(29) || :REFUND_AMOUNT || ' ' || :PAY_CURRENCY;
  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'REFUND', :ACTION_TEXT);
end
^

/* Restore proc. body: DOCUMENT_ADD_DEF_PAYMENT$DOC */
ALTER PROCEDURE DOCUMENT_ADD_DEF_PAYMENT$DOC(ID_DOC_HEAD INTEGER,
ID_PAY_DOC_TYPE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable pay_curr varchar(3);
  declare variable doc_curr varchar(3);
  declare variable id_account integer;
  declare variable doc_sub_type integer;
  declare variable id_base_doc integer;
  declare variable paydocs_cnt integer;
  declare variable id_payment_head integer;
  declare variable storno_amount numeric(15,4);
  declare variable rest_value numeric(15,4);
  declare variable doc_rnd_to numeric(15,4);
  declare variable doc_value numeric(15,4);
  declare variable pay_rate numeric(15,6);
  declare variable doc_rate numeric(15,6);
  declare variable extra_info_needed smallint;
  declare variable id_doc_type integer;
begin                         /* create payment */
  PAY_CURR = null;
  select D.ID_ACCOUNT, D.DOC_SUB_TYPE, D.ID_BASE_DOC,
         D.DOC_CURRENCY, D.DOC_VALUE_A, d.DOC_RATE, d.ID_DOC_TYPE
  from   DOC_HEAD D
         join DOC_TYPE DT on dt.ID_DOC_TYPE = d.ID_DOC_TYPE
  where  D.ID_DOC = :ID_DOC_HEAD
  into   :id_account, :doc_sub_type, :id_base_doc,
         :doc_curr, :doc_value, :doc_rate, :id_doc_type;

  if (:doc_sub_type < 2) then begin
    if (:ID_PAY_DOC_TYPE is null) then begin
      /* = case */
      execute procedure PAYMENT_GET_DEFAULT$INT (:ID_ACCOUNT)
      returning_values  (:ID_PAY_DOC_TYPE, :pay_curr);

      if (:pay_curr <> :doc_curr) then begin
        execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, null)
        returning_values  (:dbg, :dbg, :dbg, :dbg, :rest_value);

        select C.ROUND_TO
        from   CURRS C
        where  C.CURR = :DOC_CURR
        into   :doc_rnd_to;
         
        if (:REST_VALUE = :DOC_RND_TO) then begin
          select iif(pdt.CURRENCY_LIST containing :doc_curr, :doc_curr, null)
          from   DOC_TYPE pdt
          where  pdt.ID_DOC_TYPE = :ID_DOC_TYPE
          into   :pay_curr;
        end
      end
    end else begin
      select  PDT.DEF_CURRENCY
      from    PAY_DOC_TYPE_S PDT
      where   PDT.ID_DOC_TYPE = :ID_PAY_DOC_TYPE
              and PDT.IS_ARCHIVE = 0
              and PDT.DOC_DIRECTION = 1
      into    :PAY_CURR;
    end

    if (:ID_PAY_DOC_TYPE is not null and :PAY_CURR is not null) then begin
      select coalesce(dtp.IS_CC, 0) + coalesce(dtp.IS_AR_DEBT, 0)
      from   DOC_TYPE_PAY DTp
      where  DTP.ID_DOC_TYPE = :ID_PAY_DOC_TYPE
      into   :extra_info_needed;

      if (:extra_info_needed = 0) then begin
        execute procedure DOCUMENT_ADD_PAYMENT$DOC (:ID_DOC_HEAD, :ID_PAY_DOC_TYPE, null, :PAY_CURR, '')
        returning_values :DBG;
      end
    end
  end else begin
    select count(P.ID_PAYMENT_HEAD)
    from   PAYMENT_HEAD P
    where  P.ID_DOC_HEAD = :ID_BASE_DOC
    into   :PAYDOCS_CNT;

    if (:PAYDOCS_CNT = 1) then begin
      select P.ID_PAYMENT_HEAD, P.PAY_CURRENCY, P.PAY_RATE
      from   PAYMENT_HEAD P
      where  P.ID_DOC_HEAD = :ID_BASE_DOC
      into   :id_payment_head, :pay_curr, :pay_rate;

      if (:pay_curr = :doc_curr) then pay_rate = :doc_rate;
      execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, :pay_curr, :pay_rate)
      returning_values  (:dbg, :dbg, :dbg, :dbg, :rest_value);

      STORNO_AMOUNT = -:REST_VALUE;

      execute procedure PAYMENT_STORNO$INT (:ID_PAYMENT_HEAD, :ID_ACCOUNT, :ID_DOC_HEAD, :STORNO_AMOUNT, '', :DOC_VALUE)
      returning_values  :DBG;

      when any do exit;
       
    end
  end
end
^

/* Restore proc. body: DOCUMENT_STORNO_PAYS_SET$DOC */
ALTER PROCEDURE DOCUMENT_STORNO_PAYS_SET$DOC(ID_STORNO_DOC INTEGER)
 AS
declare variable id_account integer;
  declare variable id_payment_head integer;
  declare variable id_storned_doc integer;
  declare variable description varchar(100);
  declare variable id_storno_payment integer;
  declare variable storno_amount numeric(15,4);
  declare variable doc_amount numeric(15,4);
begin
  execute procedure DOCUMENT_PAYMENTS_CLEAR$DOC (:ID_STORNO_DOC);

  select D.ID_BASE_DOC, D.DESCRIPTION
  from   DOC_HEAD D
  where  D.ID_DOC = :ID_STORNO_DOC
  into   :id_storned_doc, :description;
   
  for
    select P.ID_PAYMENT_HEAD, BD.ID_ACCOUNT, sum(dp.PAY_AMOUNT), sum(dp.DOC_AMOUNT)
    from   DOC_HEAD BD
           join PAYMENT_HEAD P on P.ID_DOC_HEAD = BD.ID_DOC
           join ACCOUNT_PAYMENTS AP on AP.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
           join DOC_PAY_USAGE DP on dp.ID_ACCOUNT_PAYMENT = ap.ID_ACCOUNT_PAYMENT
                                   and dp.ID_DOC_HEAD = bd.ID_DOC
    where  BD.ID_BASE_DOC = :id_storned_doc
           and P.IS_STORNED = 0
           and P.IS_STORNO = 0
           and P.IS_ANUL = 0
    group by 1, 2
    into   :id_payment_head, :id_account, :storno_amount, :doc_amount
  do begin
    select :storno_amount + coalesce(sum(sdp.PAY_AMOUNT), 0),
           :doc_amount + coalesce(sum(sdp.DOC_AMOUNT), 0)
    from   PAYMENT_HEAD SP
           join ACCOUNT_PAYMENTS sap on sap.ID_PAYMENT_HEAD = sp.ID_PAYMENT_HEAD
           join DOC_PAY_USAGE sdp on sdp.ID_ACCOUNT_PAYMENT = sap.ID_ACCOUNT_PAYMENT
    where  sp.ID_PAYMENT_STORNED = :id_payment_head
           and sp.IS_ANUL = 0
    into   :storno_amount, :doc_amount;

    execute procedure PAYMENT_STORNO$INT (:id_payment_head, :id_account, :ID_STORNO_DOC, :storno_amount, :DESCRIPTION, :doc_amount)
    returning_values  (:id_storno_payment);

  end
end
^

/* Restore proc. body: EAI_EXT_POST_TO_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable ID_HOTEL integer;
begin
  if (singular(select HS.ID_HOTEL
               from HOTEL_S HS
               where HS.IS_USE = 1)) then
    select H.ID_HOTEL
    from   HOTEL_S H
    where H.IS_USE = 1
    into   :id_hotel;
  else begin
    err_code = -1044;
    exit;
  end

  execute procedure EAI_EXT_POST_TO_MH_FRONT_ONLINE(:ID_HOTEL, :ROOM_NAME,
    :SERVICE_CODE, :CODE_TYPE, :QTY_POST, :PRICE_POST, :CURR_POST, :POST_TEXT)
  returning_values (:ERR_CODE, :ERR_TEXT, :ID_ROOM, :ID_GUEST, :GUEST_NAME1,
    :ID_ACCOUNT, :ID_ACCOUNT_POST, :ID_SERVICE);

end
^

/* Restore proc. body: EAI_POS_POSTING_ADD */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
begin
  -- used external inteface - for compatability with Front 2008
  execute procedure EAI_POS_POSTING_ADD$P2E (:IN_ON_GUEST, :IN_ID_ACCOUNT, :IN_ID_GUEST, :IN_DATE_SMETKA,
          :IN_PRICE, :IN_DATETIME, :IN_OBJ_NAME, :IN_TABLE, :IN_SITE, :IN_SMETKA_NUM, :IN_POS_USER,
          :IN_ID_SMETKA, :IN_SERVICE_TAG, :IN_SERVICE_NAME)
  returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT);

end
^

/* Restore proc. body: EAI_RES_CHECK_OUT_FAST */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
declare variable selection_id integer;
  declare variable is_early_check_out smallint;
  declare variable early_check_out_dep_date date;
  declare variable check_out_date date;
begin
  selection_id = gen_id(selection_gen, 1);

  update RESERV_DETAIL RD
  set RD.SELECTION_ID = :SELECTION_ID
  where RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL;

  execute procedure RES_CHECK_OUT_CHECK$RSV(:selection_id)
  returning_values :is_early_check_out, :early_check_out_dep_date, :check_out_date;

  if (:is_early_check_out = 1) then
    exception BOOKING_EXCEPTION '-1043';

  execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, 0);
end
^

/* Restore proc. body: PMS_EXPENSE_POSTS_CREATE$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM TYPE OF ID,
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
POST_VALUE TYPE OF TPRICE,
IS_CLIENT_ACC_POST TYPE OF TLOGICAL,
MANUAL_POST_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_POST_PER_POOL TYPE OF TLOGICAL)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF,
NEW_ID_ACCOUNT_POST$PMS ID_REF)
 AS
declare variable event_type varchar(30);
  declare variable id_room_contract integer;
  declare variable new_id_pms_event integer;
  declare variable round_to_orig numeric(15,6);
  declare variable ownership_percent numeric(15,4);
  declare variable curr_contract_owner integer;
  declare variable curr_total_ownership numeric(15,4);
  declare variable curr_total_value numeric(15,4);
  declare variable percent_value numeric(15,4);
  declare variable id_account integer;
  declare variable id_hotel integer;
  declare variable is_account$pms integer;
  declare variable id_acc_post integer;
BEGIN
  event_type = 'MANUAL_EXPENSE';
  curr_total_value = 0;
  curr_total_ownership = 0;

  select RC.ID_ROOM_CONTRACT, r.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS P on RC.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
         join ROOMS R on R.ID_ROOM = p.ID_ROOM
  where  :MANUAL_POST_DATE between P.FROM_DATE and P.TO_DATE
         and P.ID_ROOM = :ID_ROOM
         and P.STATUS in ('PRIVATE','CONTRACT')
  into   :id_room_contract, :id_hotel;

  if (:ID_ROOM_CONTRACT is null) then exception PMS_EXCEPTION '-615';

  execute procedure PMS_EVENT_CREATE$INT(:EVENT_TYPE, :ID_ROOM, :ID_OWNER, :DESCRIPTION,
          :MANUAL_POST_DATE, null, null, null, null, :POST_VALUE, :POST_VALUE, :ID_CURRENCY, null, :id_room_contract)
  returning_values :new_id_pms_event;

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :ID_CURRENCY
  into   :round_to_orig;

  for
    select iif(:ID_OWNER is null, O.OWNERSHIP_PERCENT, 100), O.ID_OWNER
    from   ROOM_CONTRACT$PMS RC
           join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = RC.ID_ROOM_CONTRACT
    where  RC.ID_ROOM_CONTRACT = :id_room_contract
           and ((:ID_OWNER is null) or (O.ID_OWNER = :ID_OWNER))
    into   :ownership_percent, :curr_contract_owner
  do begin
    curr_total_ownership = :curr_total_ownership + :ownership_percent;
    if (:curr_total_ownership = 100) then begin
      percent_value = :post_value - :curr_total_value;
    end else
      percent_value = round_f(:post_value * :ownership_percent / 100, :round_to_orig);

    curr_total_value = :curr_total_value + :percent_value;

    execute procedure OWNER_ACCOUNT_GET$INT (iif(:is_post_per_pool = 1, :id_rental_pool, :curr_contract_owner),
            :id_hotel, 0, :IS_CLIENT_ACC_POST)
    returning_values (:id_account, :is_account$pms);

    execute procedure PMS_POSTING_CREATE$INT(:new_id_pms_event, :ID_ACCOUNT, :ID_SERVICE,
            :curr_contract_owner, :MANUAL_POST_DATE, :ID_CURRENCY, :PERCENT_VALUE, :is_account$pms, 0, :ID_ROOM)
    returning_values :id_acc_post;

    new_id_account_post = null;
    new_id_account_post$pms = null;

    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 1)) then new_id_account_post$pms = :id_acc_post;
    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 0)) then new_id_account_post = :id_acc_post;
    suspend;
  end

  execute procedure PMS_EVENT_SET_ACTIVE$INT(:new_id_pms_event);
END
^

/* Restore proc. body: PMS_POOL_DISTRIBUTION_SUB */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
declare variable cnt_room smallint;
  declare variable curr_total_posted numeric(15,4);
  declare variable cnt integer;
  declare variable value_to_post numeric(15,4);
  declare variable value_to_post_per_owner numeric(15,4);
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable id_room_contract integer;
  declare variable id_owner_account integer;
  declare variable id_pms_event integer;
  declare variable id_hotel integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  select c.ROUND_TO
  from   CURRS c
  where  c.CURR = :CURR
  into   :round_to;

  cnt_room = 0;
  select count(distinct RP.ID_ROOM)
  from   ROOM_PERIOD$PMS RP
         join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
  where  RC.ID_RENTAL_POOL = :id_rental_pool
         and RP.STATUS in ('PRIVATE','CONTRACT')
         and RP.FROM_DATE <= :FOR_DATE
         and RP.TO_DATE >= :FOR_DATE
  into   :cnt_room;

  if (:cnt_room = 0) then exception PMS_EXCEPTION 'The pool has not assigned room contracts for selected date (' || :FOR_DATE || ') !';

  if (:is_room_pool = 1) then begin
    curr_total_posted = 0;
    cnt = 0;
    id_pms_event = null;
    id_hotel = null;
    for
      select distinct RP.ID_ROOM, RC.ID_ROOM_CONTRACT, R.ID_HOTEL
      from   ROOM_PERIOD$PMS RP
             join ROOMS R on R.ID_ROOM = RP.ID_ROOM
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.FROM_DATE <= :FOR_DATE
             and RP.TO_DATE >= :FOR_DATE
      into   :id_room, :id_room_contract, :id_hotel
    do begin
      id_pms_event = null;

      select E.ID_PMS_EVENT
      from   PMS_EVENT$PMS E
      where  E.ID_ROOM = :id_room
             and E.ID_SESSION = current_transaction
      into   :ID_PMS_EVENT;

      if (:ID_PMS_EVENT is null) then begin
        execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, :id_room_contract)
        returning_values :id_pms_event;
        -- FIXME nakraq da se update total_event_value
      end
      if (:cnt_room - :cnt = 1) then begin
        value_to_post = :TOTAL_VALUE_PER_SERVICE - :curr_total_posted;
      end else begin
        value_to_post = round_f(:TOTAL_VALUE_PER_SERVICE / :cnt_room, :round_to);
      end

      curr_total_posted = :curr_total_posted + :value_to_post;
      cnt = :cnt + 1;

      /* ...i se razpredelq mejdu sobstwenicite na staqta */
      value_to_post = abs(:value_to_post);
      for
        select R.ID_OWNER, R.OUT_VALUE
        from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
        into   :id_owner, :value_to_post_per_owner
      do begin
        /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_pool_account,
                :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                1, :IS_OWNER_INCOME, :id_room)
        returning_values :no_use_id_acc_post;
        /* ... i se nachislqwa po sobswtenik */
        execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
        returning_values (:id_owner_account, :is_account$pms);

        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                :is_account$pms, :is_owner_income, :id_room)
        returning_values :no_use_id_acc_post;
      end
    end
  end else begin
    /* distribution by room_param */
    insert into TMP_SELECT$PMS(ID_SESSION, ID_ROOM, ID_OWNER)
    select distinct current_transaction, RP.ID_ROOM, null
    from   ROOM_PERIOD$PMS RP
           join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
    where  RC.ID_RENTAL_POOL = :ID_RENTAL_POOL
           and RP.STATUS in ('PRIVATE','CONTRACT')
           and RP.FROM_DATE <= :FOR_DATE
           and RP.TO_DATE >= :FOR_DATE;

    id_hotel = null;
    for
      select P.OUT_VALUE, P.OUT_ID_ROOM, R.ID_HOTEL
      from   PMS_CALC_VALUE_BY_PARAM(:ID_ROOM_PARAM, :TOTAL_VALUE_PER_SERVICE, :round_to) P
             join ROOMS R on R.ID_ROOM = P.OUT_ID_ROOM
      into   :value_to_post, :id_room, :id_hotel
    do begin
      id_pms_event = null;
      id_room_contract = null;
      -- room contract must be only one for this period
      select RC.ID_ROOM_CONTRACT
      from   ROOM_PERIOD$PMS RP
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.ID_ROOM = :id_room
             and :for_date between RP.FROM_DATE and RP.TO_DATE
      into   :id_room_contract;

      if (:id_room_contract is not null) then begin
        select E.ID_PMS_EVENT
        from   PMS_EVENT$PMS E
        where  E.ID_ROOM = :id_room
               and E.ID_SESSION = current_transaction
        into   :ID_PMS_EVENT;
  
        if (:ID_PMS_EVENT is null) then begin
          execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                  'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, id_room_contract)
          returning_values :id_pms_event;
          -- FIXME nakraq da se update total_event_value
        end
  
        /* ...i se razpredelq mejdu sobstwenicite na staqta */
        for
          select R.ID_OWNER, R.OUT_VALUE
          from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
          into   :id_owner, :value_to_post_per_owner
        do begin
          /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :ID_POOL_ACCOUNT,
                  :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                  1, :IS_OWNER_INCOME, :id_room)
          returning_values :no_use_id_acc_post;
  
          /* ... i se nachislqwa po sobswtenik */
          execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
          returning_values (:id_owner_account, :is_account$pms);

          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                  :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                  :is_account$pms, :is_owner_income, :id_room)
          returning_values :no_use_id_acc_post;
        end
      end
    end

    delete from TMP_SELECT$PMS T
    where  T.ID_SESSION = current_transaction;
  end
end
^

/* Restore proc. body: PROFILE_COMMON_MODIFY$INT */
ALTER PROCEDURE PROFILE_COMMON_MODIFY$INT(ID_PROFILE INTEGER,
PROFILE_TYPE VARCHAR(20),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL TYPE OF TEMAIL,
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable action_text varchar(255);
  declare variable old_profile_name varchar(100);
  declare variable old_is_archive integer;
  declare variable p_dbkey char(8);
begin
  p_dbkey = null;
  select P.RDB$DB_KEY, P.PROFILE_NAME, P.IS_ARCHIVE
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :p_dbkey, :old_profile_name, :old_is_archive;
   
  is_exclusive_debt_ownership = coalesce(:is_exclusive_debt_ownership, 0);
  new_id_profile = :id_profile;
  if (:p_dbkey is null) then begin
    execute procedure SYSTEM_CHECK_OPERATION (:PROFILE_TYPE, 'PERSON,AGENT,HOUSE', 'Profile type');

    new_id_profile = gen_id(gen_profile_id, 1);
    insert into PROFILE (ID_PROFILE, PROFILE_NAME, PROFILE_TYPE,
           PHONE, FAX, EMAIL, CITY, ADDRESS, NOTE, MSG,
           ID_DEF_CONTRAGENT, ID_NOM_MARKET_SEGMENT, IS_ARCHIVE, ACCOUNT_NO,
           WBE_PASSWORD, IS_EXCLUSIVE_DEBT_OWNERSHIP)
    values (:new_id_profile, :profile_name, :profile_type,
           :phone, :fax, :email, :contact_city, :contact_address, :note, :msg,
           :id_def_contragent, :id_nom_market_segment, 0, :account_no,
           nullif(:wbe_password, ''), :is_exclusive_debt_ownership)
    returning RDB$DB_KEY into :p_dbkey;
  end else begin
    update PROFILE PU
    set    PU.PROFILE_NAME = :profile_name,
           PU.PHONE = :phone,
           PU.FAX = :fax,
           PU.EMAIL = :email,
           PU.CITY = :contact_city,
           PU.ADDRESS = :contact_address,
           PU.NOTE = :note,
           PU.MSG = :msg,
           PU.ID_DEF_CONTRAGENT = :id_def_contragent,
           PU.ID_NOM_MARKET_SEGMENT = :id_nom_market_segment,
           PU.ACCOUNT_NO = :ACCOUNT_NO,
           PU.WBE_PASSWORD = iif(PU.WBE_PASSWORD is null and :wbe_password = '', null, :wbe_password),
           -- empty ('') new password should not relpace NULLs,
           -- empty password indicate for 'deleted real password'
           PU.IS_EXCLUSIVE_DEBT_OWNERSHIP = :IS_EXCLUSIVE_DEBT_OWNERSHIP
    where  PU.RDB$DB_KEY = :p_dbkey;
  
    if (:old_profile_name <> :profile_name) then begin
      action_text = f_character(29) || :old_profile_name || f_character(28) || :profile_name;
      execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'EDIT_NAME', :action_text);
    end
  
    if (:is_archive is distinct from :old_is_archive) then
      execute procedure PROFILE_SET_ARCHIVE$INT (:P_DBKEY, :IS_ARCHIVE);

  end
end
^

/* Restore proc. body: RES_ANUL_DETAIL$INT */
ALTER PROCEDURE RES_ANUL_DETAIL$INT(RD_DBKEY CHAR(8),
REASON VARCHAR(50),
CANCELATION_NUMBER TYPE OF NAME_20 = null)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable id_reserv_detail integer;
  declare variable is_anul integer;
  declare variable id_log_event integer;
  declare variable id_guest integer;
  declare variable id_group integer;
  declare variable g_dbkey char(8);
  declare variable no_use varchar(255);
  declare variable tmp_extra_posts_left smallint;
  declare variable is_check_in smallint;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:reason, 'NOSHOW, CANCELED, USERERROR, TRANSFER', 'Annul reason');

  select RD.IS_ANUL, RD.ID_RESERV_DETAIL, rd.ID_GROUP
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :is_anul, :id_reserv_detail, :id_group;

  if (:is_anul = 1) then begin
    exception BOOKING_EXCEPTION '-1021';
    -- Reservation is already annuled or checkedin !
  end

  if (:reason = 'NOSHOW') then begin
    execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    returning_values  :no_use, :no_use;
  end

  execute procedure SYSTEM_EVENT_LOG$INT ('RES_DETAIL', :id_reserv_detail, 'RES_ANUL', f_character(29) || :reason)
  returning_values :id_log_event;

  update RESERV_DETAIL RDU
  set    RDU.IS_ANUL = 1,
         RDU.REASON_OF_ANUL = :reason,
         RDU.ID_LOG_EVENT_ANNUL = :id_log_event,
         RDU.CANCELATION_NUMBER = coalesce(:CANCELATION_NUMBER, strhash_large(rdu.NUMBER || 'CANCELATION')),
         RDU.CANCELATION_DATE = current_date
  where  RDU.RDB$DB_KEY = :rd_dbkey;

  EXTRA_POSTS_LEFT = 0;
  for
    select g.ID_GUEST, G.RDB$DB_KEY, g.IS_CHECK_IN
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest, :g_dbkey, :is_check_in
  do begin
    execute procedure GUEST_ANUL_POSTINGS$INT(:id_guest)
    returning_values  :tmp_extra_posts_left;
    EXTRA_POSTS_LEFT = iif(:EXTRA_POSTS_LEFT = 1, 1, :tmp_extra_posts_left);

    update GUEST G
    set    G.UUID = null
    where  g.RDB$DB_KEY = :g_dbkey;

    if (:is_check_in = 1) then begin
      execute procedure GUEST_REGISTRATION_UPDATE(:id_guest);
    end
  end

  execute procedure RES_FINALIZE$INT (:RD_DBKEY, 0)
  returning_values (:warn_code);

  execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

  if (:id_group is not null) then
    execute procedure RESGRP_GUESTDATA_INVALIDATE$INT(:id_group);

end
^

/* Restore proc. body: RES_GUEST_CHANGE$RSV */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable check_status integer;
  declare variable id_person_data integer;
  declare variable old_person_profile integer;
  declare variable old_profile_name varchar(100);
  declare variable new_profile_name varchar(100);
begin
  select r.RDB$DB_KEY, r.ID_TITULAR, r.CHECK_STATUS, r.ID_PERSON_PROFILE, p.PROFILE_NAME
  from   RESERV_DETAIL R
         join PROFILE P on P.ID_PROFILE = r.ID_PERSON_PROFILE
  where  R.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :id_guest, :check_status, :old_person_profile, :old_profile_name;

  if (:old_person_profile = :ID_PERSON_PROFILE) then exit; -- NO CHANGES!

  id_person_data = null;
  select pp.ID_PERSON_DATA, p.PROFILE_NAME
  from   PROFILE_PERSON PP
         join PROFILE P on P.ID_PROFILE = pp.ID_PROFILE
  where  pp.ID_PROFILE = :ID_PERSON_PROFILE
  into   :id_person_data, :new_profile_name;

  if (:id_person_data is null) then exception BOOKING_EXCEPTION '-1039';

  update RESERV_DETAIL RD
  set    rd.ID_PERSON_PROFILE = :ID_PERSON_PROFILE
  where  rd.RDB$DB_KEY = :rd_dbkey;

  if (:check_status = 1) then begin
    execute procedure PERSON_DATA_COPY$INT (:id_person_data)
    returning_values (:id_person_data);
  end

  update GUEST_DATA GD
  set    gd.ID_PERSON_DATA = :id_person_data
  where  gd.ID_GUEST = :id_guest;

  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey);

  if (exists (select ap.ID_ACCOUNT_POST
              from   ACCOUNT_POST AP
                     join ACCOUNT A on A.ID_ACCOUNT = ap.ID_ACCOUNT
              where  a.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                     and a.ID_PROFILE = :old_person_profile
                     and ap.IS_ANUL = 0)) then
    exception BOOKING_EXCEPTION '-1038';

  if (exists (select d.ID_DEPOSIT
              from   DEPOSITS D
                     join ACCOUNT A on A.ID_ACCOUNT = d.ID_ACCOUNT
              where  a.ID_PROFILE = :old_person_profile
                     and coalesce(d.ID_RESERV_DETAIL, a.ID_RESERV_DETAIL) = :ID_RESERV_DETAIL
                     and d.RECEIVED_AMOUNT > 0)) then
    exception BOOKING_EXCEPTION '-1040';

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'TITULAR_CHANGED',
          f_character(29) || :old_profile_name || f_character(28) || :new_profile_name, null);

end
^

/* Restore proc. body: RES_RECALC$INT */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable num_prefix varchar(20);
  declare variable number_1 varchar(20);
begin
  /* CALLER_KIND = {NORMAL, FORCED} */
  err_code = 0;
  /* 1. GET DATA */
  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, rd.NUMBER_1
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :number_1;

  if (:check_status = 1) then begin
    -- CHECKED OUT
    select sn.LEADING_PART
    from   SYSTEM_NUMERATOR SN
    where  sn.ID_NUMERATOR = 0
    into   :num_prefix;

    if (trim('.' from coalesce(:num_prefix, '')) = coalesce(:number_1, '')) then
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_MINE');
    else
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_ELSE');

    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :id_guest
    do begin
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'MANUAL_EDIT_DATA', '');
    end
  end
  /* 2. FIND DEPENDANT GUESTS AND THEIR TARIFFS */
  --execute procedure sys_dbg('calc RES_RECALC$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

  ID_TAR_CALC = gen_id(gen_id_tar_calc, 1);
  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NONE');

  -- 3. UPDATE ROOM PRICE and REPOST ALL AFFECTED BOOKINGS
  execute procedure RES_TAR_CALC_FINALIZE$INT (:ID_TAR_CALC, :CALLER_KIND, :FORCE_POSTING)
  returning_values (:ERR_CODE, :ERR_TEXT);
end
^

/* Restore proc. body: RES_SAVE_ACCOUNTING$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
declare variable old_id_agent_profile integer;
  declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable action_text varchar(255);
  declare variable old_account_routing varchar(30);
  declare variable id_acc_profile integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:acc_routing, 'GUEST, AGENT, MIXED, OWNER, FULL_COMPLIMENTARY, PART_COMPLIMENTARY', 'Account routing');

  if (exists (select *
              from   PROFILE_HOUSE PH
              where  PH.ID_PROFILE = :id_agent_profile)) then
  begin
    exception BOOKING_EXCEPTION '-1016';
  end

  --execute procedure RESERV_TRACK_CHANGES$INT(:rd_dbkey);

  select RD.ID_AGENT_PROFILE, RD.ID_RESERV_DETAIL, RD.ACC_ROUTING
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_agent_profile, :id_reserv_detail, :old_account_routing;

  if (:ACC_ROUTING in ('AGENT','MIXED') and :ID_AGENT_ACCOUNT is not null) then begin
    select A.ID_PROFILE
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :ID_AGENT_ACCOUNT
    into   :id_acc_profile;
    -- check up agent account ownership
    if (:id_acc_profile is distinct from :ID_AGENT_PROFILE) then ID_AGENT_ACCOUNT = null;
  end

  update RESERV_DETAIL RD
  set    RD.ID_AGENT_ACCOUNT_RULE = :ID_AGENT_ACCOUNT,
         RD.ACC_ROUTING = :ACC_ROUTING,
         RD.ID_AGENT_PROFILE = :ID_AGENT_PROFILE,
         RD.ID_AGENT_PAYMENT = :ID_AGENT_PAYMENT,
         RD.ID_PERSON_PAYMENT = coalesce(:ID_PERSON_PAYMENT, RD.ID_PERSON_PAYMENT),
         RD.ID_GROUP = :ID_GROUP
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_id_agent_profile is distinct from :id_agent_profile) then begin
    execute procedure RES_SET_EDIT_STATUS$INT(:RD_DBKEY, 'AGENT', 'add');

    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure GUEST_AGENT_SET$INT(:g_dbkey, :id_agent_profile);
    end

    select f_character(29)||coalesce(old_A.PROFILE_NAME, '')||f_character(28)||coalesce(new_A.PROFILE_NAME, '')
    from   PROFILE old_A, PROFILE new_A
    where  old_A.ID_PROFILE = :old_id_agent_profile
           and new_A.ID_PROFILE = :ID_AGENT_PROFILE
    into   :action_text;

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_AGENT', :action_text);
  end

  if (:ACC_ROUTING <> :old_account_routing) then begin
    action_text = f_character(29) || coalesce(:old_account_routing, '')
                  || f_character(28) || coalesce(:acc_routing, '');

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_ACC_ROUTING', :action_text);
  end

  execute procedure RES_SAVE_ACCOUNTS$INT (:RD_DBKEY);
end
^

/* Restore proc. body: SAFE_CHECK_OUT */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE TYPE OF ID)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
WARN_CODE TYPE OF ID_REF)
 AS
declare variable to_dt timestamp;
  declare variable is_occupied integer;
  declare variable expire_tollerance integer;
  declare variable occupant_name varchar(100);
  declare variable id_resource_reservation integer;
  declare variable check_out_datetime timestamp;
begin
  DOC_SELECTED = null;
  select s.IS_OCCUPIED, od.TO_DATETIME,
         st.EXPIRE_TOLLERANCE, rr.OCCUPANT_NAME, rr.ID_RESOURCE_RESERVATION
  from   SAFE s
         join RESOURCE$INT r on r.ID_RESOURCE = s.ID_SAFE
         join SAFE_TYPES st on st.ID_SAFE_TYPE = r.ID_RESOURCE_TYPE
         join RESOURCE_RESERVATION rr on rr.ID_RESOURCE_RESERVATION = s.ID_CURRENT_OCCUPANCY
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join RESOURCE_OCCUPANCY ro on ro.ID_RESOURCE_OCCUPANCY_DATA = od.ID_RESOURCE_OCCUPANCY_DATA
  where  s.ID_SAFE = :ID_SAFE
  into   :is_occupied, :to_dt, :expire_tollerance, :occupant_name, :id_resource_reservation;

  if (:is_occupied = 0) then exit;

  expire_tollerance = coalesce(:expire_tollerance, 0);
  check_out_datetime = current_timestamp;

  execute procedure SAFE_OCCUPANCY_MODIFY (:id_safe, current_timestamp, :occupant_name)
  returning_values  :DOC_SELECTED;

  if (:check_out_datetime > (:to_dt + cast(:expire_tollerance as double precision) / 60 / 24)) then begin
    execute procedure SYSTEM_WARNING_ADD (-1066, f_character(29) || :expire_tollerance || f_character(28) || formatdate(:to_dt + cast(:expire_tollerance as double precision) / 60 / 24, 'D;dd/mm/yyyy HH:MM'))
    returning_values (:WARN_CODE);
  end

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = null
  where  s.ID_SAFE = :ID_SAFE;

  update RESOURCE_RESERVATION rr
  set    rr.STATUS = 'CHECKED_OUT'
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_CHECKED_OUT', :occupant_name);
end
^

/* Restore proc. body: TAR_CALC_INPUT_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_input integer;
  declare variable id_guest integer;
  declare variable for_date date;
  declare variable id_calc_tariff integer;
  declare variable td_dbkey char(8);
  declare variable date_independent_param_values varchar(2000);
  declare variable date_dep_param_values varchar(2000);
  declare variable prev_id_guest integer;
  declare variable prev_id_tariff integer;
begin
  prev_id_guest = null;
  prev_id_tariff = null;
  for
    select Td.RDB$DB_KEY, TI.ID_TAR_INPUT, ti.ID_GUEST, td.FOR_DATE, td.ID_TAR_HEAD
    from   TAR_CALC_INPUT$TMP TI
           join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
    where  TI.ID_TAR_CALC = :id_tar_calc
    order by ti.ID_GUEST asc, td.FOR_DATE asc
    into   :td_dbkey, :id_tar_input, :id_guest, :for_date, :id_calc_tariff
  do begin
    if ((:id_guest is distinct from :prev_id_guest)
        or (:id_calc_tariff is distinct from :prev_id_tariff)) then
    begin
      /* get date independent params */
      execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, null, null)
      returning_values (:ERR_CODE, :date_independent_param_values);
      if (:ERR_CODE < 0) then exit;
      prev_id_guest = :id_guest;
      prev_id_tariff = :id_calc_tariff;
    end

    execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, :for_date, null)
    returning_values (:ERR_CODE, :date_dep_param_values);
    if (:ERR_CODE < 0) then exit;

    update TAR_CALC_INPUT_DETAIL$TMP d
    set    d.PARAM_VALUES = coalesce(:date_independent_param_values, '') || ';'
                            || coalesce(:date_dep_param_values, '')
    where  d.RDB$DB_KEY = :td_dbkey;
  end
end
^

SET TERM ; ^

ALTER TABLE DOC_FISCAL_DATA ALTER COLUMN ID_FISCAL_DATA POSITION 1;

ALTER TABLE DOC_FISCAL_DATA ALTER COLUMN ID_DOC_HEAD POSITION 2;

ALTER TABLE DOC_FISCAL_DATA ALTER COLUMN UNIQUE_SALES_NUMBER POSITION 3;

ALTER TABLE DOC_FISCAL_DATA ALTER COLUMN FISCAL_AMOUNT POSITION 4;

ALTER TABLE DOC_FISCAL_DATA ALTER COLUMN FISCAL_LINES POSITION 5;

ALTER TABLE DOC_FISCAL_DATA ALTER COLUMN FISCAL_DISCOUNTS POSITION 6;

ALTER TABLE DOC_FISCAL_DATA ALTER COLUMN FISCAL_PAYMENTS POSITION 7;

ALTER TABLE DOC_FISCAL_DATA ALTER COLUMN FISCAL_GROUP_LIST POSITION 8;

ALTER TABLE DOC_FISCAL_DATA ALTER COLUMN FISCAL_DEVICE_ID POSITION 9;

ALTER TABLE DOC_FISCAL_DATA ALTER COLUMN FISCALIZATION_DETAILS POSITION 10;

ALTER TABLE DOC_FISCAL_DATA ALTER COLUMN STORNO_FISCAL_DEVICE_ID POSITION 11;

ALTER TABLE DOC_FISCAL_DATA ALTER COLUMN STORNO_FISCALIZATION_DETAILS POSITION 12;

ALTER TABLE DOC_FISCAL_DATA ALTER COLUMN SUMMARY_FISCALIZATION POSITION 13;

ALTER TABLE SALE_DISCOUNT_CALC$TMP ALTER COLUMN ID_DOC_HEAD POSITION 1;

ALTER TABLE SALE_DISCOUNT_CALC$TMP ALTER COLUMN ID_DOC_DISCOUNT POSITION 2;

ALTER TABLE SALE_DISCOUNT_CALC$TMP ALTER COLUMN ID_SALE_TAXATION POSITION 3;

ALTER TABLE SALE_DISCOUNT_CALC$TMP ALTER COLUMN TAXES_IDS POSITION 4;

ALTER TABLE SALE_DISCOUNT_CALC$TMP ALTER COLUMN DISCOUNTABLE_VALUE POSITION 5;

ALTER TABLE SALE_DISCOUNT_CALC$TMP ALTER COLUMN DISCOUNTABLE_WOT_VAT POSITION 6;

